/**
 * AppliedMicro X-Gene Ethernet Common Header
 *
 * Copyright (c) 2013 Applied Micro Circuits Corporation.
 * All rights reserved. Ravi Patel <rapatel@apm.com>
 *                      Iyappan Subramanian <isubramanian@apm.com>
 *                      Fushen Chen <fchen@apm.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * @file apm_enet_csr.h
 *
 * This file implements X-Gene Ethernet Common Header
 *
 * WARNING !!!
 * This is an auto-generated C header file for register definitions 
 * PLEASE DON'T MANUALLY MODIFY IN THIS FILE AS CHANGES WILL BE LOST
 */
#ifndef _APM_ENET_CSR_H__
#define _APM_ENET_CSR_H__

/*	Global Base Address	*/
#define ENET_MACIP_IND_CSR_BASE_ADDR			0x01f210000ULL

/*    Address ENET_MACIP_IND_CSR  Registers */
#define MAC_IND_ADDR_0_ADDR                                          0x00000000
#define MAC_IND_ADDR_0_DEFAULT                                       0x00000000
#define MAC_IND_COMMAND_0_ADDR                                       0x00000004
#define MAC_IND_COMMAND_0_DEFAULT                                    0x00000000
#define MAC_IND_WDATA_0_ADDR                                         0x00000008
#define MAC_IND_WDATA_0_DEFAULT                                      0x00000000
#define MAC_IND_RDATA_0_ADDR                                         0x0000000c
#define MAC_IND_RDATA_0_DEFAULT                                      0x00000000
#define MAC_IND_COMMAND_DONE_0_ADDR                                  0x00000010
#define MAC_IND_COMMAND_DONE_0_DEFAULT                               0x00000000
#define STAT_IND_ADDR_0_ADDR                                         0x00000014
#define STAT_IND_ADDR_0_DEFAULT                                      0x00000000
#define STAT_IND_COMMAND_0_ADDR                                      0x00000018
#define STAT_IND_COMMAND_0_DEFAULT                                   0x00000000
#define STAT_IND_WDATA_0_ADDR                                        0x0000001c
#define STAT_IND_WDATA_0_DEFAULT                                     0x00000000
#define STAT_IND_RDATA_0_ADDR                                        0x00000020
#define STAT_IND_RDATA_0_DEFAULT                                     0x00000000
#define STAT_IND_COMMAND_DONE_0_ADDR                                 0x00000024
#define STAT_IND_COMMAND_DONE_0_DEFAULT                              0x00000000
#define DEVICEIDENTREG_ADDR                                          0x00000028
#define DEVICEIDENTREG_DEFAULT                                       0x41000000
#define MAC_IND_ADDR_1_ADDR                                          0x00000030
#define MAC_IND_ADDR_1_DEFAULT                                       0x00000000
#define MAC_IND_COMMAND_1_ADDR                                       0x00000034
#define MAC_IND_COMMAND_1_DEFAULT                                    0x00000000
#define MAC_IND_WDATA_1_ADDR                                         0x00000038
#define MAC_IND_WDATA_1_DEFAULT                                      0x00000000
#define MAC_IND_RDATA_1_ADDR                                         0x0000003c
#define MAC_IND_RDATA_1_DEFAULT                                      0x00000000
#define MAC_IND_COMMAND_DONE_1_ADDR                                  0x00000040
#define MAC_IND_COMMAND_DONE_1_DEFAULT                               0x00000000
#define STAT_IND_ADDR_1_ADDR                                         0x00000044
#define STAT_IND_ADDR_1_DEFAULT                                      0x00000000
#define STAT_IND_COMMAND_1_ADDR                                      0x00000048
#define STAT_IND_COMMAND_1_DEFAULT                                   0x00000000
#define STAT_IND_WDATA_1_ADDR                                        0x0000004c
#define STAT_IND_WDATA_1_DEFAULT                                     0x00000000
#define STAT_IND_RDATA_1_ADDR                                        0x00000050
#define STAT_IND_RDATA_1_DEFAULT                                     0x00000000
#define STAT_IND_COMMAND_DONE_1_ADDR                                 0x00000054
#define STAT_IND_COMMAND_DONE_1_DEFAULT                              0x00000000

/*	Register MAC_Ind_Addr_0	*/ 
/*	 Fields addr	 */
#define ENET_ADDR0_WIDTH                                                  32
#define ENET_ADDR0_SHIFT                                                   0
#define ENET_ADDR0_MASK                                           0xffffffff
#define ENET_ADDR0_RD(src)                            (((src) & 0xffffffff))
#define ENET_ADDR0_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_ADDR0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register MAC_Ind_Command_0	*/ 
/*	 Fields write	 */
#define ENET_WRITE0_WIDTH                                                  1
#define ENET_WRITE0_SHIFT                                                 31
#define ENET_WRITE0_MASK                                          0x80000000
#define ENET_WRITE0_RD(src)                       (((src) & 0x80000000)>>31)
#define ENET_WRITE0_WR(src)                  (((u32)(src)<<31) & 0x80000000)
#define ENET_WRITE0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields read	 */
#define ENET_READ0_WIDTH                                                   1
#define ENET_READ0_SHIFT                                                  30
#define ENET_READ0_MASK                                           0x40000000
#define ENET_READ0_RD(src)                        (((src) & 0x40000000)>>30)
#define ENET_READ0_WR(src)                   (((u32)(src)<<30) & 0x40000000)
#define ENET_READ0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))

/*	Register MAC_Ind_WData_0	*/ 
/*	 Fields wrData	 */
#define WRDATA0_WIDTH                                                        32
#define WRDATA0_SHIFT                                                         0
#define WRDATA0_MASK                                                 0xffffffff
#define WRDATA0_RD(src)                                  (((src) & 0xffffffff))
#define WRDATA0_WR(src)                             (((u32)(src)) & 0xffffffff)
#define WRDATA0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register MAC_Ind_RData_0	*/ 
/*	 Fields readData	 */
#define READDATA0_WIDTH                                                      32
#define READDATA0_SHIFT                                                       0
#define READDATA0_MASK                                               0xffffffff
#define READDATA0_RD(src)                                (((src) & 0xffffffff))
#define READDATA0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register MAC_Ind_Command_Done_0	*/ 
/*	 Fields command_done	 */
#define COMMAND_DONE0_WIDTH                                                   1
#define COMMAND_DONE0_SHIFT                                                   0
#define COMMAND_DONE0_MASK                                           0x00000001
#define COMMAND_DONE0_RD(src)                            (((src) & 0x00000001))
#define COMMAND_DONE0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register Stat_Ind_Addr_0	*/ 
/*	 Fields addr	 */
#define ENET_ADDR0_F1_WIDTH                                               32
#define ENET_ADDR0_F1_SHIFT                                                0
#define ENET_ADDR0_F1_MASK                                        0xffffffff
#define ENET_ADDR0_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_ADDR0_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_ADDR0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Stat_Ind_Command_0	*/ 
/*	 Fields write	 */
#define ENET_WRITE0_F1_WIDTH                                               1
#define ENET_WRITE0_F1_SHIFT                                              31
#define ENET_WRITE0_F1_MASK                                       0x80000000
#define ENET_WRITE0_F1_RD(src)                    (((src) & 0x80000000)>>31)
#define ENET_WRITE0_F1_WR(src)               (((u32)(src)<<31) & 0x80000000)
#define ENET_WRITE0_F1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields read	 */
#define ENET_READ0_F1_WIDTH                                                1
#define ENET_READ0_F1_SHIFT                                               30
#define ENET_READ0_F1_MASK                                        0x40000000
#define ENET_READ0_F1_RD(src)                     (((src) & 0x40000000)>>30)
#define ENET_READ0_F1_WR(src)                (((u32)(src)<<30) & 0x40000000)
#define ENET_READ0_F1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))

/*	Register Stat_Ind_WData_0	*/ 
/*	 Fields wrData	 */
#define WRDATA0_F1_WIDTH                                                     32
#define WRDATA0_F1_SHIFT                                                      0
#define WRDATA0_F1_MASK                                              0xffffffff
#define WRDATA0_F1_RD(src)                               (((src) & 0xffffffff))
#define WRDATA0_F1_WR(src)                          (((u32)(src)) & 0xffffffff)
#define WRDATA0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Stat_Ind_RData_0	*/ 
/*	 Fields readData	 */
#define READDATA0_F1_WIDTH                                                   32
#define READDATA0_F1_SHIFT                                                    0
#define READDATA0_F1_MASK                                            0xffffffff
#define READDATA0_F1_RD(src)                             (((src) & 0xffffffff))
#define READDATA0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Stat_Ind_Command_Done_0	*/ 
/*	 Fields command_done	 */
#define COMMAND_DONE0_F1_WIDTH                                                1
#define COMMAND_DONE0_F1_SHIFT                                                0
#define COMMAND_DONE0_F1_MASK                                        0x00000001
#define COMMAND_DONE0_F1_RD(src)                         (((src) & 0x00000001))
#define COMMAND_DONE0_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register DeviceIdentReg	*/ 
/*	 Fields DeviceId	 */
#define ENET_DEVICEID_WIDTH                                                8
#define ENET_DEVICEID_SHIFT                                               24
#define ENET_DEVICEID_MASK                                        0xff000000
#define ENET_DEVICEID_RD(src)                     (((src) & 0xff000000)>>24)
#define ENET_DEVICEID_WR(src)                (((u32)(src)<<24) & 0xff000000)
#define ENET_DEVICEID_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields MajorRev	 */
#define MAJORREV_WIDTH                                                        8
#define MAJORREV_SHIFT                                                        8
#define MAJORREV_MASK                                                0x0000ff00
#define MAJORREV_RD(src)                              (((src) & 0x0000ff00)>>8)
#define MAJORREV_WR(src)                         (((u32)(src)<<8) & 0x0000ff00)
#define MAJORREV_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields MinorRev	 */
#define MINORREV_WIDTH                                                        8
#define MINORREV_SHIFT                                                        0
#define MINORREV_MASK                                                0x000000ff
#define MINORREV_RD(src)                                 (((src) & 0x000000ff))
#define MINORREV_WR(src)                            (((u32)(src)) & 0x000000ff)
#define MINORREV_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register MAC_Ind_Addr_1	*/ 
/*	 Fields addr	 */
#define ENET_ADDR1_WIDTH                                                  32
#define ENET_ADDR1_SHIFT                                                   0
#define ENET_ADDR1_MASK                                           0xffffffff
#define ENET_ADDR1_RD(src)                            (((src) & 0xffffffff))
#define ENET_ADDR1_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_ADDR1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register MAC_Ind_Command_1	*/ 
/*	 Fields write	 */
#define ENET_WRITE1_WIDTH                                                  1
#define ENET_WRITE1_SHIFT                                                 31
#define ENET_WRITE1_MASK                                          0x80000000
#define ENET_WRITE1_RD(src)                       (((src) & 0x80000000)>>31)
#define ENET_WRITE1_WR(src)                  (((u32)(src)<<31) & 0x80000000)
#define ENET_WRITE1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields read	 */
#define ENET_READ1_WIDTH                                                   1
#define ENET_READ1_SHIFT                                                  30
#define ENET_READ1_MASK                                           0x40000000
#define ENET_READ1_RD(src)                        (((src) & 0x40000000)>>30)
#define ENET_READ1_WR(src)                   (((u32)(src)<<30) & 0x40000000)
#define ENET_READ1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))

/*	Register MAC_Ind_WData_1	*/ 
/*	 Fields wrData	 */
#define WRDATA1_WIDTH                                                        32
#define WRDATA1_SHIFT                                                         0
#define WRDATA1_MASK                                                 0xffffffff
#define WRDATA1_RD(src)                                  (((src) & 0xffffffff))
#define WRDATA1_WR(src)                             (((u32)(src)) & 0xffffffff)
#define WRDATA1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register MAC_Ind_RData_1	*/ 
/*	 Fields readData	 */
#define READDATA1_WIDTH                                                      32
#define READDATA1_SHIFT                                                       0
#define READDATA1_MASK                                               0xffffffff
#define READDATA1_RD(src)                                (((src) & 0xffffffff))
#define READDATA1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register MAC_Ind_Command_Done_1	*/ 
/*	 Fields command_done	 */
#define COMMAND_DONE1_WIDTH                                                   1
#define COMMAND_DONE1_SHIFT                                                   0
#define COMMAND_DONE1_MASK                                           0x00000001
#define COMMAND_DONE1_RD(src)                            (((src) & 0x00000001))
#define COMMAND_DONE1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register Stat_Ind_Addr_1	*/ 
/*	 Fields addr	 */
#define ENET_ADDR1_F1_WIDTH                                               32
#define ENET_ADDR1_F1_SHIFT                                                0
#define ENET_ADDR1_F1_MASK                                        0xffffffff
#define ENET_ADDR1_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_ADDR1_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_ADDR1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Stat_Ind_Command_1	*/ 
/*	 Fields write	 */
#define ENET_WRITE1_F1_WIDTH                                               1
#define ENET_WRITE1_F1_SHIFT                                              31
#define ENET_WRITE1_F1_MASK                                       0x80000000
#define ENET_WRITE1_F1_RD(src)                    (((src) & 0x80000000)>>31)
#define ENET_WRITE1_F1_WR(src)               (((u32)(src)<<31) & 0x80000000)
#define ENET_WRITE1_F1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields read	 */
#define ENET_READ1_F1_WIDTH                                                1
#define ENET_READ1_F1_SHIFT                                               30
#define ENET_READ1_F1_MASK                                        0x40000000
#define ENET_READ1_F1_RD(src)                     (((src) & 0x40000000)>>30)
#define ENET_READ1_F1_WR(src)                (((u32)(src)<<30) & 0x40000000)
#define ENET_READ1_F1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))

/*	Register Stat_Ind_WData_1	*/ 
/*	 Fields wrData	 */
#define WRDATA1_F1_WIDTH                                                     32
#define WRDATA1_F1_SHIFT                                                      0
#define WRDATA1_F1_MASK                                              0xffffffff
#define WRDATA1_F1_RD(src)                               (((src) & 0xffffffff))
#define WRDATA1_F1_WR(src)                          (((u32)(src)) & 0xffffffff)
#define WRDATA1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Stat_Ind_RData_1	*/ 
/*	 Fields readData	 */
#define READDATA1_F1_WIDTH                                                   32
#define READDATA1_F1_SHIFT                                                    0
#define READDATA1_F1_MASK                                            0xffffffff
#define READDATA1_F1_RD(src)                             (((src) & 0xffffffff))
#define READDATA1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Stat_Ind_Command_Done_1	*/ 
/*	 Fields command_done	 */
#define COMMAND_DONE1_F1_WIDTH                                                1
#define COMMAND_DONE1_F1_SHIFT                                                0
#define COMMAND_DONE1_F1_MASK                                        0x00000001
#define COMMAND_DONE1_F1_RD(src)                         (((src) & 0x00000001))
#define COMMAND_DONE1_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_CSR_BASE_ADDR			0x01f212000ULL

/*    Address ENET_CSR  Registers */
#define ENET_BID_ADDR                                                0x00000000
#define ENET_BID_DEFAULT                                             0x00000063
#define ENET_FPGA_ADDR                                               0x00000004
#define ENET_FPGA_DEFAULT                                            0x00000000
#define PCKWD_REG0_ADDR                                              0x00000008
#define PCKWD_REG0_DEFAULT                                           0x0000870c
#define RSIF_CONFIG_REG_ADDR                                         0x00000010
#define RSIF_CONFIG_REG_DEFAULT                                      0x7f010044
#define RSIF_POLICER_REG0_ADDR                                       0x00000014
#define RSIF_POLICER_REG0_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG1_ADDR                                       0x00000018
#define RSIF_POLICER_REG1_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG2_ADDR                                       0x0000001c
#define RSIF_POLICER_REG2_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG3_ADDR                                       0x00000020
#define RSIF_POLICER_REG3_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG4_ADDR                                       0x00000024
#define RSIF_POLICER_REG4_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG5_ADDR                                       0x00000028
#define RSIF_POLICER_REG5_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG6_ADDR                                       0x0000002c
#define RSIF_POLICER_REG6_DEFAULT                                    0x00000000
#define RSIF_POLICER_REG7_ADDR                                       0x00000030
#define RSIF_POLICER_REG7_DEFAULT                                    0x02000f0f
#define RSIF_POLICER_REG8_ADDR                                       0x00000034
#define RSIF_POLICER_REG8_DEFAULT                                    0x00000000
#define RSIF_POLICER_HDREXT_SHIFT_ADDR                               0x00000038
#define RSIF_POLICER_HDREXT_SHIFT_DEFAULT                            0x00000040
#define RSIF_POLICER_STSREG0_ADDR                                    0x00000040
#define RSIF_POLICER_STSREG0_DEFAULT                                 0x00000000
#define RSIF_POLICER_STSREG1_ADDR                                    0x00000044
#define RSIF_POLICER_STSREG1_DEFAULT                                 0x00000000
#define RSIF_RAM_DBG_REG0_ADDR                                       0x00000048
#define RSIF_RAM_DBG_REG0_DEFAULT                                    0x02100000
#define RSIF_WOL_MODE0_ADDR                                          0x0000004c
#define RSIF_WOL_MODE0_DEFAULT                                       0x00000000
#define RSIF_FIFO_EMPTYSTS0_ADDR                                     0x00000050
#define RSIF_FIFO_EMPTYSTS0_DEFAULT                                  0x70ff00ff
#define RSIF_INT_REG0_ADDR                                           0x00000054
#define RSIF_INT_REG0_DEFAULT                                        0x00000000
#define RSIF_INT_REG0MASK_ADDR                                       0x00000058
#define RSIF_FINT_REG0_ADDR                                          0x0000005c
#define RSIF_FINT_REG0_DEFAULT                                       0x00000000
#define RSIF_FINT_REG0MASK_ADDR                                      0x00000060
#define RSIF_STS_REG0_ADDR                                           0x00000064
#define RSIF_STS_REG0_DEFAULT                                        0x00000000
#define RSIF_H0_0_ADDR                                               0x00000068
#define RSIF_H0_0_DEFAULT                                            0x00000000
#define RSIF_H0_1_ADDR                                               0x0000006c
#define RSIF_H0_1_DEFAULT                                            0x00000010
#define RSIF_H1_0_ADDR                                               0x00000070
#define RSIF_H1_0_DEFAULT                                            0x00000000
#define RSIF_H1_1_ADDR                                               0x00000074
#define RSIF_H1_1_DEFAULT                                            0x00000300
#define RSIF_FPBUFF_TIMEOUT_STSREG0_ADDR                             0x00000078
#define RSIF_FPBUFF_TIMEOUT_STSREG0_DEFAULT                          0x00000000
#define RSIF_FPBUFF_TIMEOUT_PARTIALDROP_STSREG0_ADDR                 0x0000007c
#define RSIF_FPBUFF_TIMEOUT_PARTIALDROP_STSREG0_DEFAULT              0x00000000
#define RSIF_FPBUFF_MIRROR_TIMEOUT_STSREG0_ADDR                      0x00000080
#define RSIF_FPBUFF_MIRROR_TIMEOUT_STSREG0_DEFAULT                   0x00000000
#define RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIALDROP_STSREG0_ADDR          0x00000084
#define RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIALDROP_STSREG0_DEFAULT       0x00000000
#define RSIF_MIRROR_ERR_STSREG0_ADDR                                 0x00000088
#define RSIF_MIRROR_ERR_STSREG0_DEFAULT                              0x00000000
#define RSIF_STS_CNTR_REG0_ADDR                                      0x0000008c
#define RSIF_STS_CNTR_REG0_DEFAULT                                   0x00000000
#define RSIF_STS_CNTR_REG1_ADDR                                      0x00000090
#define RSIF_STS_CNTR_REG1_DEFAULT                                   0x00000000
#define RSIF_STS_CLE_DROP_CNTR_REG0_ADDR                             0x00000094
#define RSIF_STS_CLE_DROP_CNTR_REG0_DEFAULT                          0x00000000
#define RSIF_LERR_MASK_ADDR                                          0x00000098
#define RSIF_LERR_MASK_DEFAULT                                       0x0000001f
#define RSIF_INT_REG1_ADDR                                           0x0000009c
#define RSIF_INT_REG1_DEFAULT                                        0x00000000
#define RSIF_INT_REG1MASK_ADDR                                       0x000000a0
#define RSIF_FINT_REG1_ADDR                                          0x000000a4
#define RSIF_FINT_REG1_DEFAULT                                       0x00000000
#define RSIF_FINT_REG1MASK_ADDR                                      0x000000a8
#define PCKWD_STSSOFCTRLWD0_0_ADDR                                   0x000000b0
#define PCKWD_STSSOFCTRLWD0_0_DEFAULT                                0x00000000
#define PCKWD_STSSOFCTRLWD1_0_ADDR                                   0x000000b4
#define PCKWD_STSSOFCTRLWD1_0_DEFAULT                                0x00000000
#define PCKWD_STSSOFCTRLWD2_0_ADDR                                   0x000000b8
#define PCKWD_STSSOFCTRLWD2_0_DEFAULT                                0x00000000
#define PCKWD_STSSOFCTRLWD3_0_ADDR                                   0x000000bc
#define PCKWD_STSSOFCTRLWD3_0_DEFAULT                                0x00000000
#define PCKWD_STSEOFCTRLWD_0_ADDR                                    0x000000c0
#define PCKWD_STSEOFCTRLWD_0_DEFAULT                                 0x00000000
#define PCKWD_STSSOFCTRLWD0_1_ADDR                                   0x000000c4
#define PCKWD_STSSOFCTRLWD0_1_DEFAULT                                0x00000000
#define PCKWD_STSSOFCTRLWD1_1_ADDR                                   0x000000c8
#define PCKWD_STSSOFCTRLWD1_1_DEFAULT                                0x00000000
#define PCKWD_STSSOFCTRLWD2_1_ADDR                                   0x000000cc
#define PCKWD_STSSOFCTRLWD2_1_DEFAULT                                0x00000000
#define PCKWD_STSSOFCTRLWD3_1_ADDR                                   0x000000d0
#define PCKWD_STSSOFCTRLWD3_1_DEFAULT                                0x00000000
#define PCKWD_STSEOFCTRLWD_1_ADDR                                    0x000000d4
#define PCKWD_STSEOFCTRLWD_1_DEFAULT                                 0x00000000
#define LCLRXBUF_CONFIG_THRESH_REG_0_ADDR                            0x000000e0
#define LCLRXBUF_CONFIG_THRESH_REG_0_DEFAULT                         0x00440041
#define LCLRXBUF_CONFIG_PORT_DEPTH_REG_0_ADDR                        0x000000e4
#define LCLRXBUF_CONFIG_PORT_DEPTH_REG_0_DEFAULT                     0x00000044
#define LCLRXBUF_CONFIG_THRESH_REG_1_ADDR                            0x000000e8
#define LCLRXBUF_CONFIG_THRESH_REG_1_DEFAULT                         0x00440041
#define LCLRXBUF_CONFIG_PORT_DEPTH_REG_1_ADDR                        0x000000ec
#define LCLRXBUF_CONFIG_PORT_DEPTH_REG_1_DEFAULT                     0x00000044
#define RSIF_POLICER_COLORENC0_ADDR                                  0x000000f0
#define RSIF_POLICER_COLORENC0_DEFAULT                               0x32100000
#define RSIF_POLICER_COLORENC1_ADDR                                  0x000000f4
#define RSIF_POLICER_COLORENC1_DEFAULT                               0x32103210
#define RSIF_POLICER_COLORENC2_ADDR                                  0x000000f8
#define RSIF_POLICER_COLORENC2_DEFAULT                               0x00003210
#define RSIF_POLICER_COLORENC3_ADDR                                  0x000000fc
#define RSIF_POLICER_COLORENC3_DEFAULT                               0x00000000
#define TSIF_CONFIG_REG_0_ADDR                                       0x00000100
#define TSIF_CONFIG_REG_0_DEFAULT                                    0x00004c88
#define TSIF_CONFIG_REG_1_ADDR                                       0x00000104
#define TSIF_CONFIG_REG_1_DEFAULT                                    0x00004c88
#define TSIF_MSS_REG0_0_ADDR                                         0x00000108
#define TSIF_MSS_REG0_0_DEFAULT                                      0x01000040
#define TSIF_MSS_REG0_1_ADDR                                         0x0000010c
#define TSIF_MSS_REG0_1_DEFAULT                                      0x01000040
#define TSIF_MSS_REG1_0_ADDR                                         0x00000110
#define TSIF_MSS_REG1_0_DEFAULT                                      0x05ee0400
#define TSIF_MSS_REG1_1_ADDR                                         0x00000114
#define TSIF_MSS_REG1_1_DEFAULT                                      0x05ee0400
#define TSIF_FIFO_EMPTYSTS0_ADDR                                     0x00000118
#define TSIF_FIFO_EMPTYSTS0_DEFAULT                                  0x00070007
#define TSIF_INT_REG0_ADDR                                           0x0000012c
#define TSIF_INT_REG0_DEFAULT                                        0x00000000
#define TSIF_INT_REG0MASK_ADDR                                       0x00000130
#define TSIF_FINT_REG0_ADDR                                          0x00000134
#define TSIF_FINT_REG0_DEFAULT                                       0x00000000
#define TSIF_FINT_REG0MASK_ADDR                                      0x00000138
#define TSIF_STS_REG0_ADDR                                           0x0000013c
#define TSIF_STS_REG0_DEFAULT                                        0x00000000
#define TSIF_STS_REG1_ADDR                                           0x00000140
#define TSIF_STS_REG1_DEFAULT                                        0x00000000
#define TSIF_STS_REG2_ADDR                                           0x00000144
#define TSIF_STS_REG2_DEFAULT                                        0x00000000
#define TSIF_STS_REG3_ADDR                                           0x00000148
#define TSIF_STS_REG3_DEFAULT                                        0x00000000
#define CFG_CAPTURE_ECM_CTRLWD_0_ADDR                                0x00000150
#define CFG_CAPTURE_ECM_CTRLWD_0_DEFAULT                             0x00000000
#define STS_ECM_SOF0_CNTRL_WORD_0_ADDR                               0x00000154
#define STS_ECM_SOF0_CNTRL_WORD_0_DEFAULT                            0x00000000
#define STS_ECM_SOF1_CNTRL_WORD_0_ADDR                               0x00000158
#define STS_ECM_SOF1_CNTRL_WORD_0_DEFAULT                            0x00000000
#define STS_ECM_SOF2_CNTRL_WORD_0_ADDR                               0x0000015c
#define STS_ECM_SOF2_CNTRL_WORD_0_DEFAULT                            0x00000000
#define STS_ECM_SOF3_CNTRL_WORD_0_ADDR                               0x00000160
#define STS_ECM_SOF3_CNTRL_WORD_0_DEFAULT                            0x00000000
#define STS_ECM_EOF1_CNTRL_WORD_0_ADDR                               0x00000164
#define STS_ECM_EOF1_CNTRL_WORD_0_DEFAULT                            0x00000000
#define CFG_CAPTURE_ECM_CTRLWD_1_ADDR                                0x00000170
#define CFG_CAPTURE_ECM_CTRLWD_1_DEFAULT                             0x00000000
#define STS_ECM_SOF0_CNTRL_WORD_1_ADDR                               0x00000174
#define STS_ECM_SOF0_CNTRL_WORD_1_DEFAULT                            0x00000000
#define STS_ECM_SOF1_CNTRL_WORD_1_ADDR                               0x00000178
#define STS_ECM_SOF1_CNTRL_WORD_1_DEFAULT                            0x00000000
#define STS_ECM_SOF2_CNTRL_WORD_1_ADDR                               0x0000017c
#define STS_ECM_SOF2_CNTRL_WORD_1_DEFAULT                            0x00000000
#define STS_ECM_SOF3_CNTRL_WORD_1_ADDR                               0x00000180
#define STS_ECM_SOF3_CNTRL_WORD_1_DEFAULT                            0x00000000
#define STS_ECM_EOF1_CNTRL_WORD_1_ADDR                               0x00000184
#define STS_ECM_EOF1_CNTRL_WORD_1_DEFAULT                            0x00000000
#define ENET_SPARE_CFG_REG_1_ADDR                                    0x00000190
#define ENET_SPARE_CFG_REG_1_DEFAULT                                 0x00000000
#define ENET_SPARE_STATUS_REG_1_ADDR                                 0x00000194
#define ENET_SPARE_STATUS_REG_1_DEFAULT                              0x00000000
#define AVB_CLASSA_CREDIT_REFILL_0_ADDR                              0x00000200
#define AVB_CLASSA_CREDIT_REFILL_0_DEFAULT                           0x00000000
#define AVB_CLASSA_CREDIT_REFILL_1_ADDR                              0x00000204
#define AVB_CLASSA_CREDIT_REFILL_1_DEFAULT                           0x00000000
#define AVB_CLASSB_CREDIT_REFILL_0_ADDR                              0x00000208
#define AVB_CLASSB_CREDIT_REFILL_0_DEFAULT                           0x00000000
#define AVB_CLASSB_CREDIT_REFILL_1_ADDR                              0x0000020c
#define AVB_CLASSB_CREDIT_REFILL_1_DEFAULT                           0x00000000
#define AVB_COMMON_CONFIG1_0_ADDR                                    0x00000210
#define AVB_COMMON_CONFIG1_0_DEFAULT                                 0x00000000
#define AVB_COMMON_CONFIG1_1_ADDR                                    0x00000214
#define AVB_COMMON_CONFIG1_1_DEFAULT                                 0x00000000
#define AVB_COMMON_CONFIG2_0_ADDR                                    0x00000218
#define AVB_COMMON_CONFIG2_0_DEFAULT                                 0x20010000
#define AVB_COMMON_CONFIG2_1_ADDR                                    0x0000021c
#define AVB_COMMON_CONFIG2_1_DEFAULT                                 0x20010000
#define AVB_PER_Q_CONFIG1_0_ADDR                                     0x00000220
#define AVB_PER_Q_CONFIG1_0_DEFAULT                                  0x10efaaaa
#define AVB_PER_Q_CONFIG1_1_ADDR                                     0x00000224
#define AVB_PER_Q_CONFIG1_1_DEFAULT                                  0x10efaaaa
#define AVB_PER_Q_HI_CREDIT_0_ADDR                                   0x00000228
#define AVB_PER_Q_HI_CREDIT_0_DEFAULT                                0x00000000
#define AVB_PER_Q_HI_CREDIT_1_ADDR                                   0x0000022c
#define AVB_PER_Q_HI_CREDIT_1_DEFAULT                                0x00000000
#define AVB_PER_Q_IDLE_SLOPE0_0_ADDR                                 0x00000230
#define AVB_PER_Q_IDLE_SLOPE0_0_DEFAULT                              0x07ffffff
#define AVB_PER_Q_IDLE_SLOPE0_1_ADDR                                 0x00000234
#define AVB_PER_Q_IDLE_SLOPE0_1_DEFAULT                              0x07ffffff
#define AVB_PER_Q_IDLE_SLOPE1_0_ADDR                                 0x00000238
#define AVB_PER_Q_IDLE_SLOPE1_0_DEFAULT                              0x07ffffff
#define AVB_PER_Q_IDLE_SLOPE1_1_ADDR                                 0x0000023c
#define AVB_PER_Q_IDLE_SLOPE1_1_DEFAULT                              0x07ffffff
#define AVB_PER_Q_IDLE_SLOPE2_0_ADDR                                 0x00000240
#define AVB_PER_Q_IDLE_SLOPE2_0_DEFAULT                              0x0003ffff
#define AVB_PER_Q_IDLE_SLOPE2_1_ADDR                                 0x00000244
#define AVB_PER_Q_IDLE_SLOPE2_1_DEFAULT                              0x0003ffff
#define AVB_PER_Q_BYTE_NUM_Q0_0_ADDR                                 0x00000248
#define AVB_PER_Q_BYTE_NUM_Q0_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q0_1_ADDR                                 0x0000024c
#define AVB_PER_Q_BYTE_NUM_Q0_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q1_0_ADDR                                 0x00000250
#define AVB_PER_Q_BYTE_NUM_Q1_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q1_1_ADDR                                 0x00000254
#define AVB_PER_Q_BYTE_NUM_Q1_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q2_0_ADDR                                 0x00000258
#define AVB_PER_Q_BYTE_NUM_Q2_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q2_1_ADDR                                 0x0000025c
#define AVB_PER_Q_BYTE_NUM_Q2_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q3_0_ADDR                                 0x00000260
#define AVB_PER_Q_BYTE_NUM_Q3_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q3_1_ADDR                                 0x00000264
#define AVB_PER_Q_BYTE_NUM_Q3_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q4_0_ADDR                                 0x00000268
#define AVB_PER_Q_BYTE_NUM_Q4_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q4_1_ADDR                                 0x0000026c
#define AVB_PER_Q_BYTE_NUM_Q4_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q5_0_ADDR                                 0x00000270
#define AVB_PER_Q_BYTE_NUM_Q5_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q5_1_ADDR                                 0x00000274
#define AVB_PER_Q_BYTE_NUM_Q5_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q6_0_ADDR                                 0x00000278
#define AVB_PER_Q_BYTE_NUM_Q6_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q6_1_ADDR                                 0x0000027c
#define AVB_PER_Q_BYTE_NUM_Q6_1_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q7_0_ADDR                                 0x00000280
#define AVB_PER_Q_BYTE_NUM_Q7_0_DEFAULT                              0x00000000
#define AVB_PER_Q_BYTE_NUM_Q7_1_ADDR                                 0x00000284
#define AVB_PER_Q_BYTE_NUM_Q7_1_DEFAULT                              0x00000000
#define AVB_CFG_PRSNTN_TIME_0_ADDR                                   0x00000288
#define AVB_CFG_PRSNTN_TIME_0_DEFAULT                                0x00000000
#define AVB_CFG_PRSNTN_TIME_1_ADDR                                   0x0000028c
#define AVB_CFG_PRSNTN_TIME_1_DEFAULT                                0x00000000
#define CFG_LINK_AGGR_ADDR                                           0x00000290
#define CFG_LINK_AGGR_DEFAULT                                        0x00000000
#define CFG_BYPASS_ADDR                                              0x00000294
#define CFG_BYPASS_DEFAULT                                           0x00000000
#define CFG_LINK_STS_SEL_ADDR                                        0x00000298
#define CFG_LINK_STS_SEL_DEFAULT                                     0x00000000
#define CFG_FORCE_LINK_STATUS_EN_ADDR                                0x0000029c
#define CFG_FORCE_LINK_STATUS_EN_DEFAULT                             0x00000000
#define FORCE_LINK_STATUS_ADDR                                       0x000002a0
#define FORCE_LINK_STATUS_DEFAULT                                    0x00000000
#define CFG_PHYID_0_ADDR                                             0x000002a4
#define CFG_PHYID_0_DEFAULT                                          0x04030201
#define CFG_PHYID_1_ADDR                                             0x000002a8
#define CFG_PHYID_1_DEFAULT                                          0x25070605
#define CFG_MDIO_ADDR                                                0x000002ac
#define CFG_MDIO_DEFAULT                                             0x00000009
#define AUTOPOLL_LINK_STS_INTR_ADDR                                  0x000002b0
#define AUTOPOLL_LINK_STS_INTR_DEFAULT                               0x00000000
#define AUTOPOLL_LINK_STS_INTRMASK_ADDR                              0x000002b4
#define AUTOPOLL_LINK_STATUS_ADDR                                    0x000002b8
#define AUTOPOLL_LINK_STATUS_DEFAULT                                 0x00000000
#define MH_FIFO_FULL_THRESH_0_ADDR                                   0x00000300
#define MH_FIFO_FULL_THRESH_0_DEFAULT                                0x88888888
#define MH_FIFO_FULL_THRESH_1_ADDR                                   0x00000304
#define MH_FIFO_FULL_THRESH_1_DEFAULT                                0x88888888
#define DEALLOC_FIFO_FULL_THRESH_0_ADDR                              0x00000308
#define DEALLOC_FIFO_FULL_THRESH_0_DEFAULT                           0x00000007
#define DEALLOC_FIFO_FULL_THRESH_1_ADDR                              0x0000030c
#define DEALLOC_FIFO_FULL_THRESH_1_DEFAULT                           0x00000007
#define TSO_FIFO_STATUS_ADDR                                         0x00000310
#define TSO_FIFO_STATUS_DEFAULT                                      0x00000000
#define TSO_CFG_0_ADDR                                               0x00000314
#define TSO_CFG_0_DEFAULT                                            0x00000040
#define TSO_CFG_1_ADDR                                               0x00000318
#define TSO_CFG_1_DEFAULT                                            0x00000040
#define TSO_CFG_INSERT_VLAN_0_ADDR                                   0x0000031c
#define TSO_CFG_INSERT_VLAN_0_DEFAULT                                0x00000000
#define TSO_CFG_INSERT_VLAN_1_ADDR                                   0x00000320
#define TSO_CFG_INSERT_VLAN_1_DEFAULT                                0x00000000
#define TSO_INT_REG0_ADDR                                            0x00000324
#define TSO_INT_REG0_DEFAULT                                         0x00000000
#define TSO_INT_REG0MASK_ADDR                                        0x00000328
#define TTF_FIFO_FULL_THRESH_0_ADDR                                  0x0000032c
#define TTF_FIFO_FULL_THRESH_0_DEFAULT                               0x00000005
#define TTF_FIFO_FULL_THRESH_1_ADDR                                  0x00000330
#define TTF_FIFO_FULL_THRESH_1_DEFAULT                               0x00000005
#define TSO_CFG_FLAGS_ADDR                                           0x00000334
#define TSO_CFG_FLAGS_DEFAULT                                        0x000030a6
#define SPI2SAP_ADDSPI_REG_ADDR                                      0x00000400
#define SPI2SAP_ADDSPI_REG_DEFAULT                                   0x00000000
#define SPI2SAP_ADDSPIEN_REG_ADDR                                    0x00000404
#define SPI2SAP_ADDSPIEN_REG_DEFAULT                                 0x00000000
#define SPI2SAP_DELSPI_REG_ADDR                                      0x00000408
#define SPI2SAP_DELSPI_REG_DEFAULT                                   0x00000000
#define SPI2SAP_DELSPIEN_REG_ADDR                                    0x0000040c
#define SPI2SAP_DELSPIEN_REG_DEFAULT                                 0x00000000
#define SPI2SAP_SEARCHSPI_REG_ADDR                                   0x00000410
#define SPI2SAP_SEARCHSPI_REG_DEFAULT                                0x00000000
#define SPI2SAP_SEARCHSPIEN_REG_ADDR                                 0x00000414
#define SPI2SAP_SEARCHSPIEN_REG_DEFAULT                              0x00000000
#define SPI2SAP_CFG0_REG_ADDR                                        0x00000418
#define SPI2SAP_CFG0_REG_DEFAULT                                     0x000fff7f
#define SPI2SAP_DBG0_REG_ADDR                                        0x0000041c
#define SPI2SAP_DBG0_REG_DEFAULT                                     0x00000000
#define SPI2SAP_DBG1_REG_ADDR                                        0x00000420
#define SPI2SAP_DBG1_REG_DEFAULT                                     0x00000000
#define SPI2SAP_DBG2_REG_ADDR                                        0x00000424
#define SPI2SAP_DBG2_REG_DEFAULT                                     0x00000000
#define SPI2SAP_INTREG_ADDR                                          0x00000428
#define SPI2SAP_INTREG_DEFAULT                                       0x00000000
#define SPI2SAP_INTREGMASK_ADDR                                      0x0000042c
#define SPI2SAP_STSREG0_ADDR                                         0x00000430
#define SPI2SAP_STSREG0_DEFAULT                                      0x00000000
#define SPI2SAP_STSREG1_ADDR                                         0x00000434
#define SPI2SAP_STSREG1_DEFAULT                                      0x00000000
#define SPI2SAP_STSREG2_ADDR                                         0x00000438
#define SPI2SAP_STSREG2_DEFAULT                                      0x00000000
#define SPI2SAP_STSREG3_ADDR                                         0x00000440
#define SPI2SAP_STSREG3_DEFAULT                                      0x000000ff
#define SPI2SAP_FIFO_EMPTYSTS0_ADDR                                  0x00000444
#define SPI2SAP_FIFO_EMPTYSTS0_DEFAULT                               0x00000003
#define SPI2SAP_INT_REG0_ADDR                                        0x00000448
#define SPI2SAP_INT_REG0_DEFAULT                                     0x00000000
#define SPI2SAP_INT_REG0MASK_ADDR                                    0x0000044c
#define ENET_SAD_ADDRCMD_REG_ADDR                                    0x00000460
#define ENET_SAD_ADDRCMD_REG_DEFAULT                                 0x00000000
#define ENET_SAD_WDATA0_REG_ADDR                                     0x00000464
#define ENET_SAD_WDATA0_REG_DEFAULT                                  0x00000000
#define ENET_SAD_WDATA1_REG_ADDR                                     0x00000468
#define ENET_SAD_WDATA1_REG_DEFAULT                                  0x00000000
#define ENET_SAD_WDATA2_REG_ADDR                                     0x0000046c
#define ENET_SAD_WDATA2_REG_DEFAULT                                  0x00000000
#define ENET_SAD_WDATA3_REG_ADDR                                     0x00000470
#define ENET_SAD_WDATA3_REG_DEFAULT                                  0x00000000
#define ENET_SAD_RDATA0_REG_ADDR                                     0x00000474
#define ENET_SAD_RDATA0_REG_DEFAULT                                  0x00000000
#define ENET_SAD_RDATA1_REG_ADDR                                     0x00000478
#define ENET_SAD_RDATA1_REG_DEFAULT                                  0x00000000
#define ENET_SAD_RDATA2_REG_ADDR                                     0x0000047c
#define ENET_SAD_RDATA2_REG_DEFAULT                                  0x00000000
#define ENET_SAD_RDATA3_REG_ADDR                                     0x00000480
#define ENET_SAD_RDATA3_REG_DEFAULT                                  0x00000000
#define ENET_SAD_CMDDONE_REG_ADDR                                    0x00000484
#define ENET_SAD_CMDDONE_REG_DEFAULT                                 0x00000000
#define CLE_BYPASS_REG0_0_ADDR                                       0x00000490
#define CLE_BYPASS_REG0_0_DEFAULT                                    0x2000050e
#define CLE_BYPASS_REG1_0_ADDR                                       0x00000494
#define CLE_BYPASS_REG1_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG2_0_ADDR                                       0x00000498
#define CLE_BYPASS_REG2_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG3_0_ADDR                                       0x0000049c
#define CLE_BYPASS_REG3_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG4_0_ADDR                                       0x000004a0
#define CLE_BYPASS_REG4_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG5_0_ADDR                                       0x000004a4
#define CLE_BYPASS_REG5_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG6_0_ADDR                                       0x000004a8
#define CLE_BYPASS_REG6_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG7_0_ADDR                                       0x000004ac
#define CLE_BYPASS_REG7_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG8_0_ADDR                                       0x000004b0
#define CLE_BYPASS_REG8_0_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG0_1_ADDR                                       0x000004c0
#define CLE_BYPASS_REG0_1_DEFAULT                                    0x2000050e
#define CLE_BYPASS_REG1_1_ADDR                                       0x000004c4
#define CLE_BYPASS_REG1_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG2_1_ADDR                                       0x000004c8
#define CLE_BYPASS_REG2_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG3_1_ADDR                                       0x000004cc
#define CLE_BYPASS_REG3_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG4_1_ADDR                                       0x000004d0
#define CLE_BYPASS_REG4_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG5_1_ADDR                                       0x000004d4
#define CLE_BYPASS_REG5_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG6_1_ADDR                                       0x000004d8
#define CLE_BYPASS_REG6_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG7_1_ADDR                                       0x000004dc
#define CLE_BYPASS_REG7_1_DEFAULT                                    0x00000000
#define CLE_BYPASS_REG8_1_ADDR                                       0x000004e0
#define CLE_BYPASS_REG8_1_DEFAULT                                    0x00000000
#define RXBUF_CONFIG_THRESH_REG_ADDR                                 0x00000500
#define RXBUF_CONFIG_THRESH_REG_DEFAULT                              0x01f40000
#define RXBUF_CONFIG_PORT_DEPTH_REG_ADDR                             0x00000504
#define RXBUF_CONFIG_PORT_DEPTH_REG_DEFAULT                          0x02000200
#define RXBUF_CONFIG_START_ADDR_REG_ADDR                             0x00000508
#define RXBUF_CONFIG_START_ADDR_REG_DEFAULT                          0x00000000
#define RXBUF_CONFIG_BUFFER_REG_ADDR                                 0x0000050c
#define RXBUF_CONFIG_BUFFER_REG_DEFAULT                              0x00000000
#define TXBUF_CONFIG_THRESH_REG_ADDR                                 0x00000510
#define TXBUF_CONFIG_THRESH_REG_DEFAULT                              0x0c000000
#define TXBUF_CONFIG_PORT_DEPTH_REG_ADDR                             0x00000514
#define TXBUF_CONFIG_PORT_DEPTH_REG_DEFAULT                          0x0c000c00
#define TXBUF_CONFIG_START_ADDR_REG_ADDR                             0x00000518
#define TXBUF_CONFIG_START_ADDR_REG_DEFAULT                          0x00000c00
#define TXBUF_CONFIG_BUFFER_REG_ADDR                                 0x0000051c
#define TXBUF_CONFIG_BUFFER_REG_DEFAULT                              0x0000000a
#define TIMER_CONFIG1_REG_ADDR                                       0x00000520
#define TIMER_CONFIG1_REG_DEFAULT                                    0x001fa3e8
#define TIMER_CONFIG2_REG_ADDR                                       0x00000524
#define TIMER_CONFIG2_REG_DEFAULT                                    0x00180101
#define RX_TX_BUF_STS_REG0_ADDR                                      0x00000528
#define RX_TX_BUF_STS_REG0_DEFAULT                                   0x00030003
#define RX_TX_BUF_CHKSM_INT_REG0_ADDR                                0x0000052c
#define RX_TX_BUF_CHKSM_INT_REG0_DEFAULT                             0x00000000
#define RX_TX_BUF_CHKSM_INT_REG0MASK_ADDR                            0x00000530
#define RXBUF_CONFIG_PAUSE_THRESH_REG_ADDR                           0x00000534
#define RXBUF_CONFIG_PAUSE_THRESH_REG_DEFAULT                        0x01f401f4
#define CHECKSUM_CONFIG_REG_ADDR                                     0x00000538
#define CHECKSUM_CONFIG_REG_DEFAULT                                  0x0000000f
#define RXBUF_CONFIG_PAUSE_OFF_THRESH_REG_ADDR                       0x00000540
#define RXBUF_CONFIG_PAUSE_OFF_THRESH_REG_DEFAULT                    0x01e401e4
#define MEMORY_CONFIG1_REG_ADDR                                      0x00000600
#define MEMORY_CONFIG1_REG_DEFAULT                                   0x00000000
#define MEMORY_CONFIG2_REG_ADDR                                      0x00000604
#define MEMORY_CONFIG2_REG_DEFAULT                                   0x00000000
#define PTP_TMSTMP_CFG_ADDR                                          0x0000064c
#define PTP_TMSTMP_CFG_DEFAULT                                       0x000c0100
#define PTP_CONFIG_ADDR                                              0x00000650
#define PTP_CONFIG_DEFAULT                                           0x00012090
#define PTP_RX_TMSTMP_PRT0_ADDR                                      0x00000654
#define PTP_RX_TMSTMP_PRT0_DEFAULT                                   0x00000000
#define PTP_TX_TMSTMP0_PRT0_ADDR                                     0x00000658
#define PTP_TX_TMSTMP0_PRT0_DEFAULT                                  0x00000000
#define PTP_TX_TMSTMP1_PRT0_ADDR                                     0x0000065c
#define PTP_TX_TMSTMP1_PRT0_DEFAULT                                  0x00000000
#define PTP_TX_CORRECTION_PRT0_ADDR                                  0x00000660
#define PTP_TX_CORRECTION_PRT0_DEFAULT                               0x00000000
#define PTP_RX_TMSTMP_PRT1_ADDR                                      0x00000664
#define PTP_RX_TMSTMP_PRT1_DEFAULT                                   0x00000000
#define PTP_TX_TMSTMP0_PRT1_ADDR                                     0x00000668
#define PTP_TX_TMSTMP0_PRT1_DEFAULT                                  0x00000000
#define PTP_TX_TMSTMP1_PRT1_ADDR                                     0x0000066c
#define PTP_TX_TMSTMP1_PRT1_DEFAULT                                  0x00000000
#define PTP_TX_CORRECTION_PRT1_ADDR                                  0x00000670
#define PTP_TX_CORRECTION_PRT1_DEFAULT                               0x00000000
#define PTP_TSTMP_OFFSET_ADDR                                        0x00000674
#define PTP_TSTMP_OFFSET_DEFAULT                                     0x00060822
#define DEBUG_REG1_ADDR                                              0x000006fc
#define DEBUG_REG1_DEFAULT                                           0x00000000
#define DEBUG_REG_ADDR                                               0x00000700
#define DEBUG_REG_DEFAULT                                            0x003e03e8
#define MPIC_DEBUG_REG_ADDR                                          0x00000704
#define MPIC_DEBUG_REG_DEFAULT                                       0x00000000
#define TSO_ENET_STAT_REG_PORT0_ADDR                                 0x00000708
#define TSO_ENET_STAT_REG_PORT0_DEFAULT                              0x00000000
#define TXB_ENET_STAT_REG_PORT0_ADDR                                 0x0000070c
#define TXB_ENET_STAT_REG_PORT0_DEFAULT                              0x00000000
#define MACIN_ENET_STAT_REG_PORT0_ADDR                               0x00000710
#define MACIN_ENET_STAT_REG_PORT0_DEFAULT                            0x00000000
#define MACOUT_ENET_STAT_REG_PORT0_ADDR                              0x00000714
#define MACOUT_ENET_STAT_REG_PORT0_DEFAULT                           0x00000000
#define RXBIN_ENET_STAT_REG_PORT0_ADDR                               0x00000718
#define RXBIN_ENET_STAT_REG_PORT0_DEFAULT                            0x00000000
#define RSIF_ENET_STAT_REG_PORT0_ADDR                                0x0000071c
#define RSIF_ENET_STAT_REG_PORT0_DEFAULT                             0x00000000
#define TSO_ENET_STAT_REG_PORT1_ADDR                                 0x00000720
#define TSO_ENET_STAT_REG_PORT1_DEFAULT                              0x00000000
#define TXB_ENET_STAT_REG_PORT1_ADDR                                 0x00000724
#define TXB_ENET_STAT_REG_PORT1_DEFAULT                              0x00000000
#define MACIN_ENET_STAT_REG_PORT1_ADDR                               0x00000728
#define MACIN_ENET_STAT_REG_PORT1_DEFAULT                            0x00000000
#define MACOUT_ENET_STAT_REG_PORT1_ADDR                              0x0000072c
#define MACOUT_ENET_STAT_REG_PORT1_DEFAULT                           0x00000000
#define RXBIN_ENET_STAT_REG_PORT1_ADDR                               0x00000730
#define RXBIN_ENET_STAT_REG_PORT1_DEFAULT                            0x00000000
#define RSIF_ENET_STAT_REG_PORT1_ADDR                                0x00000734
#define RSIF_ENET_STAT_REG_PORT1_DEFAULT                             0x00000000
#define ENET_SPARE_CFG_REG_ADDR                                      0x00000750
#define ENET_SPARE_CFG_REG_DEFAULT                                   0x22406040
#define ENET_SPARE_STATUS_REG_ADDR                                   0x00000754
#define ENET_SPARE_STATUS_REG_DEFAULT                                0x22407203
#define SAI2SAP_ADDSAI_HI_REG_ADDR                                   0x00000758
#define SAI2SAP_ADDSAI_HI_REG_DEFAULT                                0x00000000
#define SAI2SAP_ADDSAI_LO_REG_ADDR                                   0x0000075c
#define SAI2SAP_ADDSAI_LO_REG_DEFAULT                                0x00000000
#define SAI2SAP_ADDSAIEN_REG_ADDR                                    0x00000760
#define SAI2SAP_ADDSAIEN_REG_DEFAULT                                 0x00000000
#define SAI2SAP_DELSAI_HI_REG_ADDR                                   0x00000764
#define SAI2SAP_DELSAI_HI_REG_DEFAULT                                0x00000000
#define SAI2SAP_DELSAI_LO_REG_ADDR                                   0x00000768
#define SAI2SAP_DELSAI_LO_REG_DEFAULT                                0x00000000
#define SAI2SAP_DELSAIEN_REG_ADDR                                    0x0000076c
#define SAI2SAP_DELSAIEN_REG_DEFAULT                                 0x00000000
#define SAI2SAP_SEARCHSAI_HI_REG_ADDR                                0x00000770
#define SAI2SAP_SEARCHSAI_HI_REG_DEFAULT                             0x00000000
#define SAI2SAP_SEARCHSAI_LO_REG_ADDR                                0x00000774
#define SAI2SAP_SEARCHSAI_LO_REG_DEFAULT                             0x00000000
#define SAI2SAP_SEARCHSAIEN_REG_ADDR                                 0x00000778
#define SAI2SAP_SEARCHSAIEN_REG_DEFAULT                              0x00000000
#define SAI2SAP_CFG0_REG_ADDR                                        0x0000077c
#define SAI2SAP_CFG0_REG_DEFAULT                                     0x000fff08
#define SAI2SAP_DBG0_REG_ADDR                                        0x00000780
#define SAI2SAP_DBG0_REG_DEFAULT                                     0x00000000
#define SAI2SAP_DBG1_REG_ADDR                                        0x00000784
#define SAI2SAP_DBG1_REG_DEFAULT                                     0x00000000
#define SAI2SAP_DBG2_REG_ADDR                                        0x00000788
#define SAI2SAP_DBG2_REG_DEFAULT                                     0x00000000
#define SAI2SAP_DBG3_REG_ADDR                                        0x0000078c
#define SAI2SAP_DBG3_REG_DEFAULT                                     0x00000000
#define SAI2SAP_INTREG_ADDR                                          0x00000790
#define SAI2SAP_INTREG_DEFAULT                                       0x00000000
#define SAI2SAP_INTREGMASK_ADDR                                      0x00000794
#define SAI2SAP_STSREG0_ADDR                                         0x00000798
#define SAI2SAP_STSREG0_DEFAULT                                      0x00000000
#define SAI2SAP_STSREG1_ADDR                                         0x0000079c
#define SAI2SAP_STSREG1_DEFAULT                                      0x00000000
#define SAI2SAP_STSREG2_ADDR                                         0x000007a0
#define SAI2SAP_STSREG2_DEFAULT                                      0x00000000
#define SAI2SAP_STSREG3_ADDR                                         0x000007a4
#define SAI2SAP_STSREG3_DEFAULT                                      0x00000000
#define SAI2SAP_STSREG4_ADDR                                         0x000007a8
#define SAI2SAP_STSREG4_DEFAULT                                      0x000000ff
#define SAI2SAP_FIFO_EMPTYSTS0_ADDR                                  0x000007ac
#define SAI2SAP_FIFO_EMPTYSTS0_DEFAULT                               0x00000003
#define SAI2SAP_INT_REG0_ADDR                                        0x000007b0
#define SAI2SAP_INT_REG0_DEFAULT                                     0x00000000
#define SAI2SAP_INT_REG0MASK_ADDR                                    0x000007b4
#define LINK_STS_INTR_ADDR                                           0x000007bc
#define LINK_STS_INTR_DEFAULT                                        0x00000000
#define LINK_STS_INTRMASK_ADDR                                       0x000007c0
#define LINK_STATUS_ADDR                                             0x000007c4
#define LINK_STATUS_DEFAULT                                          0x00070000
#define CFG_LINK_AGGR_RESUME_0_ADDR                                  0x000007c8
#define CFG_LINK_AGGR_RESUME_0_DEFAULT                               0x00000000
#define CFG_LINK_AGGR_RESUME_1_ADDR                                  0x000007cc
#define CFG_LINK_AGGR_RESUME_1_DEFAULT                               0x00000000
#define CFG_LPBK_GATE_TX_ADDR                                        0x000007d0
#define CFG_LPBK_GATE_TX_DEFAULT                                     0x00000003
#define CFG_FORCE_SDET_0_ADDR                                        0x000007d4
#define CFG_FORCE_SDET_0_DEFAULT                                     0x00000000
#define CFG_FORCE_SDET_1_ADDR                                        0x000007d8
#define CFG_FORCE_SDET_1_DEFAULT                                     0x00000000
#define RGMII_REG_0_ADDR                                             0x000007e0
#define RGMII_REG_0_DEFAULT                                          0x01000000
#define RGMII_REG_1_ADDR                                             0x000007e4
#define RGMII_REG_1_DEFAULT                                          0x01000000
#define SGMII_REG0_ADDR                                              0x000007e8
#define SGMII_REG0_DEFAULT                                           0x00000000
#define SGMII_REG1_ADDR                                              0x000007ec
#define SGMII_REG1_DEFAULT                                           0x00000000
#define RGMII_SGMII_REG_ADDR                                         0x000007f0
#define RGMII_SGMII_REG_DEFAULT                                      0x000c3500

/*	Register enet_bid	*/ 
/*	 Fields revno	 */
#define ENET_REVNO_WIDTH                                                   2
#define ENET_REVNO_SHIFT                                                   8
#define ENET_REVNO_MASK                                           0x00000300
#define ENET_REVNO_RD(src)                         (((src) & 0x00000300)>>8)
#define ENET_REVNO_SET(dst,src) \
                       (((dst) & ~0x00000300) | (((u32)(src)<<8) & 0x00000300))
/*	 Fields bulsid	 */
#define BULSID_WIDTH                                                          3
#define BULSID_SHIFT                                                          5
#define BULSID_MASK                                                  0x000000e0
#define BULSID_RD(src)                                (((src) & 0x000000e0)>>5)
#define BULSID_SET(dst,src) \
                       (((dst) & ~0x000000e0) | (((u32)(src)<<5) & 0x000000e0))
/*	 Fields deviceid	 */
#define ENET_DEVICEID_F2_WIDTH                                             5
#define ENET_DEVICEID_F2_SHIFT                                             0
#define ENET_DEVICEID_F2_MASK                                     0x0000001f
#define ENET_DEVICEID_F2_RD(src)                      (((src) & 0x0000001f))
#define ENET_DEVICEID_F2_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register enet_fpga	*/ 
/*	 Fields date	 */
#define DATE_WIDTH                                                            8
#define DATE_SHIFT                                                           24
#define DATE_MASK                                                    0xff000000
#define DATE_RD(src)                                 (((src) & 0xff000000)>>24)
#define DATE_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields month	 */
#define MONTH_WIDTH                                                           8
#define MONTH_SHIFT                                                          16
#define MONTH_MASK                                                   0x00ff0000
#define MONTH_RD(src)                                (((src) & 0x00ff0000)>>16)
#define MONTH_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields year	 */
#define YEAR_WIDTH                                                            8
#define YEAR_SHIFT                                                            8
#define YEAR_MASK                                                    0x0000ff00
#define YEAR_RD(src)                                  (((src) & 0x0000ff00)>>8)
#define YEAR_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields version_no	 */
#define VERSION_NO_WIDTH                                                      8
#define VERSION_NO_SHIFT                                                      0
#define VERSION_NO_MASK                                              0x000000ff
#define VERSION_NO_RD(src)                               (((src) & 0x000000ff))
#define VERSION_NO_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register Pckwd_Reg0	*/ 
/*	 Fields cfg_pckwd_cle_data_big_endian_port1	 */
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT10_WIDTH                            1
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT10_SHIFT                           21
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT10_MASK                    0x00200000
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT10_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT10_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_pckwd_cle_data_big_endian_port0	 */
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT00_WIDTH                            1
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT00_SHIFT                           20
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT00_MASK                    0x00100000
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT00_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT00_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define CFG_PCKWD_CLE_DATA_BIG_ENDIAN_PORT00_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_pckwd_capture_rx_ctrwd_en_port1	 */
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT10_WIDTH                            1
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT10_SHIFT                           17
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT10_MASK                    0x00020000
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT10_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT10_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_pckwd_capture_rx_ctrwd_en_port0	 */
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT00_WIDTH                            1
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT00_SHIFT                           16
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT00_MASK                    0x00010000
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT00_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT00_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define CFG_PCKWD_CAPTURE_RX_CTRWD_EN_PORT00_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_pckwd_cle_pktram_wdcnt_port1	 */
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT10_WIDTH                               7
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT10_SHIFT                               9
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT10_MASK                       0x0000fe00
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT10_RD(src)     (((src) & 0x0000fe00)>>9)
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT10_WR(src) \
                                                 (((u32)(src)<<9) & 0x0000fe00)
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT10_SET(dst,src) \
                       (((dst) & ~0x0000fe00) | (((u32)(src)<<9) & 0x0000fe00))
/*	 Fields cfg_pckwd_cle_pktram_wdcnt_port0	 */
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT00_WIDTH                               7
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT00_SHIFT                               2
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT00_MASK                       0x000001fc
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT00_RD(src)     (((src) & 0x000001fc)>>2)
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT00_WR(src) \
                                                 (((u32)(src)<<2) & 0x000001fc)
#define CFG_PCKWD_CLE_PKTRAM_WDCNT_PORT00_SET(dst,src) \
                       (((dst) & ~0x000001fc) | (((u32)(src)<<2) & 0x000001fc))
/*	 Fields cfg_pckwd_cts_drop_en_port1	 */
#define CFG_PCKWD_CTS_DROP_EN_PORT10_WIDTH                                    1
#define CFG_PCKWD_CTS_DROP_EN_PORT10_SHIFT                                    1
#define CFG_PCKWD_CTS_DROP_EN_PORT10_MASK                            0x00000002
#define CFG_PCKWD_CTS_DROP_EN_PORT10_RD(src)          (((src) & 0x00000002)>>1)
#define CFG_PCKWD_CTS_DROP_EN_PORT10_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define CFG_PCKWD_CTS_DROP_EN_PORT10_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_pckwd_cts_drop_en_port0	 */
#define CFG_PCKWD_CTS_DROP_EN_PORT00_WIDTH                                    1
#define CFG_PCKWD_CTS_DROP_EN_PORT00_SHIFT                                    0
#define CFG_PCKWD_CTS_DROP_EN_PORT00_MASK                            0x00000001
#define CFG_PCKWD_CTS_DROP_EN_PORT00_RD(src)             (((src) & 0x00000001))
#define CFG_PCKWD_CTS_DROP_EN_PORT00_WR(src)        (((u32)(src)) & 0x00000001)
#define CFG_PCKWD_CTS_DROP_EN_PORT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_Config_Reg	*/ 
/*	 Fields cfg_rsif_fpbuff_timeout_en	 */
#define CFG_RSIF_FPBUFF_TIMEOUT_EN_WIDTH                                      1
#define CFG_RSIF_FPBUFF_TIMEOUT_EN_SHIFT                                     31
#define CFG_RSIF_FPBUFF_TIMEOUT_EN_MASK                              0x80000000
#define CFG_RSIF_FPBUFF_TIMEOUT_EN_RD(src)           (((src) & 0x80000000)>>31)
#define CFG_RSIF_FPBUFF_TIMEOUT_EN_WR(src)      (((u32)(src)<<31) & 0x80000000)
#define CFG_RSIF_FPBUFF_TIMEOUT_EN_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_rsif_fpbuff_timeout	 */
#define CFG_RSIF_FPBUFF_TIMEOUT_WIDTH                                         7
#define CFG_RSIF_FPBUFF_TIMEOUT_SHIFT                                        24
#define CFG_RSIF_FPBUFF_TIMEOUT_MASK                                 0x7f000000
#define CFG_RSIF_FPBUFF_TIMEOUT_RD(src)              (((src) & 0x7f000000)>>24)
#define CFG_RSIF_FPBUFF_TIMEOUT_WR(src)         (((u32)(src)<<24) & 0x7f000000)
#define CFG_RSIF_FPBUFF_TIMEOUT_SET(dst,src) \
                      (((dst) & ~0x7f000000) | (((u32)(src)<<24) & 0x7f000000))
/*	 Fields cfg_rsif_short_ptp_timestamp_en	 */
#define CFG_RSIF_SHORT_PTP_TIMESTAMP_EN_WIDTH                                 1
#define CFG_RSIF_SHORT_PTP_TIMESTAMP_EN_SHIFT                                22
#define CFG_RSIF_SHORT_PTP_TIMESTAMP_EN_MASK                         0x00400000
#define CFG_RSIF_SHORT_PTP_TIMESTAMP_EN_RD(src)      (((src) & 0x00400000)>>22)
#define CFG_RSIF_SHORT_PTP_TIMESTAMP_EN_WR(src) \
                                                (((u32)(src)<<22) & 0x00400000)
#define CFG_RSIF_SHORT_PTP_TIMESTAMP_EN_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields cfg_rsif_wrrsp_disable	 */
#define CFG_RSIF_WRRSP_DISABLE_WIDTH                                          1
#define CFG_RSIF_WRRSP_DISABLE_SHIFT                                         21
#define CFG_RSIF_WRRSP_DISABLE_MASK                                  0x00200000
#define CFG_RSIF_WRRSP_DISABLE_RD(src)               (((src) & 0x00200000)>>21)
#define CFG_RSIF_WRRSP_DISABLE_WR(src)          (((u32)(src)<<21) & 0x00200000)
#define CFG_RSIF_WRRSP_DISABLE_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_rsif_big_endian	 */
#define CFG_RSIF_BIG_ENDIAN_WIDTH                                             1
#define CFG_RSIF_BIG_ENDIAN_SHIFT                                            20
#define CFG_RSIF_BIG_ENDIAN_MASK                                     0x00100000
#define CFG_RSIF_BIG_ENDIAN_RD(src)                  (((src) & 0x00100000)>>20)
#define CFG_RSIF_BIG_ENDIAN_WR(src)             (((u32)(src)<<20) & 0x00100000)
#define CFG_RSIF_BIG_ENDIAN_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_rsif_vc	 */
#define CFG_RSIF_VC_WIDTH                                                     2
#define CFG_RSIF_VC_SHIFT                                                    18
#define CFG_RSIF_VC_MASK                                             0x000c0000
#define CFG_RSIF_VC_RD(src)                          (((src) & 0x000c0000)>>18)
#define CFG_RSIF_VC_WR(src)                     (((u32)(src)<<18) & 0x000c0000)
#define CFG_RSIF_VC_SET(dst,src) \
                      (((dst) & ~0x000c0000) | (((u32)(src)<<18) & 0x000c0000))
/*	 Fields cfg_rsif_buff_threshold	 */
#define CFG_RSIF_BUFF_THRESHOLD_WIDTH                                         5
#define CFG_RSIF_BUFF_THRESHOLD_SHIFT                                        12
#define CFG_RSIF_BUFF_THRESHOLD_MASK                                 0x0001f000
#define CFG_RSIF_BUFF_THRESHOLD_RD(src)              (((src) & 0x0001f000)>>12)
#define CFG_RSIF_BUFF_THRESHOLD_WR(src)         (((u32)(src)<<12) & 0x0001f000)
#define CFG_RSIF_BUFF_THRESHOLD_SET(dst,src) \
                      (((dst) & ~0x0001f000) | (((u32)(src)<<12) & 0x0001f000))
/*	 Fields cfg_rsif_ctrlbuff_threshold	 */
#define CFG_RSIF_CTRLBUFF_THRESHOLD_WIDTH                                     5
#define CFG_RSIF_CTRLBUFF_THRESHOLD_SHIFT                                     4
#define CFG_RSIF_CTRLBUFF_THRESHOLD_MASK                             0x000001f0
#define CFG_RSIF_CTRLBUFF_THRESHOLD_RD(src)           (((src) & 0x000001f0)>>4)
#define CFG_RSIF_CTRLBUFF_THRESHOLD_WR(src)      (((u32)(src)<<4) & 0x000001f0)
#define CFG_RSIF_CTRLBUFF_THRESHOLD_SET(dst,src) \
                       (((dst) & ~0x000001f0) | (((u32)(src)<<4) & 0x000001f0))
/*	 Fields cfg_rsif_cle_buff_threshold	 */
#define CFG_RSIF_CLE_BUFF_THRESHOLD_WIDTH                                     3
#define CFG_RSIF_CLE_BUFF_THRESHOLD_SHIFT                                     0
#define CFG_RSIF_CLE_BUFF_THRESHOLD_MASK                             0x00000007
#define CFG_RSIF_CLE_BUFF_THRESHOLD_RD(src)              (((src) & 0x00000007))
#define CFG_RSIF_CLE_BUFF_THRESHOLD_WR(src)         (((u32)(src)) & 0x00000007)
#define CFG_RSIF_CLE_BUFF_THRESHOLD_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register RSIF_Policer_Reg0	*/ 
/*	 Fields cfg_rsif_plc_rd_en	 */
#define CFG_RSIF_PLC_RD_EN0_WIDTH                                             1
#define CFG_RSIF_PLC_RD_EN0_SHIFT                                            31
#define CFG_RSIF_PLC_RD_EN0_MASK                                     0x80000000
#define CFG_RSIF_PLC_RD_EN0_RD(src)                  (((src) & 0x80000000)>>31)
#define CFG_RSIF_PLC_RD_EN0_WR(src)             (((u32)(src)<<31) & 0x80000000)
#define CFG_RSIF_PLC_RD_EN0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_rsif_plc_wr_en	 */
#define CFG_RSIF_PLC_WR_EN0_WIDTH                                             1
#define CFG_RSIF_PLC_WR_EN0_SHIFT                                            30
#define CFG_RSIF_PLC_WR_EN0_MASK                                     0x40000000
#define CFG_RSIF_PLC_WR_EN0_RD(src)                  (((src) & 0x40000000)>>30)
#define CFG_RSIF_PLC_WR_EN0_WR(src)             (((u32)(src)<<30) & 0x40000000)
#define CFG_RSIF_PLC_WR_EN0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_rsif_plc_addr	 */
#define CFG_RSIF_PLC_ADDR0_WIDTH                                             10
#define CFG_RSIF_PLC_ADDR0_SHIFT                                              0
#define CFG_RSIF_PLC_ADDR0_MASK                                      0x000003ff
#define CFG_RSIF_PLC_ADDR0_RD(src)                       (((src) & 0x000003ff))
#define CFG_RSIF_PLC_ADDR0_WR(src)                  (((u32)(src)) & 0x000003ff)
#define CFG_RSIF_PLC_ADDR0_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register RSIF_Policer_Reg1	*/ 
/*	 Fields cfg_rsif_plc_CBS	 */
#define CFG_RSIF_PLC_CBS1_WIDTH                                              31
#define CFG_RSIF_PLC_CBS1_SHIFT                                               0
#define CFG_RSIF_PLC_CBS1_MASK                                       0x7fffffff
#define CFG_RSIF_PLC_CBS1_RD(src)                        (((src) & 0x7fffffff))
#define CFG_RSIF_PLC_CBS1_WR(src)                   (((u32)(src)) & 0x7fffffff)
#define CFG_RSIF_PLC_CBS1_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RSIF_Policer_Reg2	*/ 
/*	 Fields cfg_rsif_plc_CIR	 */
#define CFG_RSIF_PLC_CIR2_WIDTH                                              24
#define CFG_RSIF_PLC_CIR2_SHIFT                                               0
#define CFG_RSIF_PLC_CIR2_MASK                                       0x00ffffff
#define CFG_RSIF_PLC_CIR2_RD(src)                        (((src) & 0x00ffffff))
#define CFG_RSIF_PLC_CIR2_WR(src)                   (((u32)(src)) & 0x00ffffff)
#define CFG_RSIF_PLC_CIR2_SET(dst,src) \
                          (((dst) & ~0x00ffffff) | (((u32)(src)) & 0x00ffffff))

/*	Register RSIF_Policer_Reg3	*/ 
/*	 Fields cfg_rsif_plc_CCA	 */
#define CFG_RSIF_PLC_CCA3_WIDTH                                              32
#define CFG_RSIF_PLC_CCA3_SHIFT                                               0
#define CFG_RSIF_PLC_CCA3_MASK                                       0xffffffff
#define CFG_RSIF_PLC_CCA3_RD(src)                        (((src) & 0xffffffff))
#define CFG_RSIF_PLC_CCA3_WR(src)                   (((u32)(src)) & 0xffffffff)
#define CFG_RSIF_PLC_CCA3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_Reg4	*/ 
/*	 Fields cfg_rsif_plc_EBS	 */
#define CFG_RSIF_PLC_EBS4_WIDTH                                              31
#define CFG_RSIF_PLC_EBS4_SHIFT                                               0
#define CFG_RSIF_PLC_EBS4_MASK                                       0x7fffffff
#define CFG_RSIF_PLC_EBS4_RD(src)                        (((src) & 0x7fffffff))
#define CFG_RSIF_PLC_EBS4_WR(src)                   (((u32)(src)) & 0x7fffffff)
#define CFG_RSIF_PLC_EBS4_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RSIF_Policer_Reg5	*/ 
/*	 Fields cfg_rsif_plc_CM	 */
#define CFG_RSIF_PLC_CM5_WIDTH                                                1
#define CFG_RSIF_PLC_CM5_SHIFT                                               31
#define CFG_RSIF_PLC_CM5_MASK                                        0x80000000
#define CFG_RSIF_PLC_CM5_RD(src)                     (((src) & 0x80000000)>>31)
#define CFG_RSIF_PLC_CM5_WR(src)                (((u32)(src)<<31) & 0x80000000)
#define CFG_RSIF_PLC_CM5_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_rsif_plc_CF	 */
#define CFG_RSIF_PLC_CF5_WIDTH                                                1
#define CFG_RSIF_PLC_CF5_SHIFT                                               30
#define CFG_RSIF_PLC_CF5_MASK                                        0x40000000
#define CFG_RSIF_PLC_CF5_RD(src)                     (((src) & 0x40000000)>>30)
#define CFG_RSIF_PLC_CF5_WR(src)                (((u32)(src)<<30) & 0x40000000)
#define CFG_RSIF_PLC_CF5_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_rsif_plc_EIR	 */
#define CFG_RSIF_PLC_EIR5_WIDTH                                              24
#define CFG_RSIF_PLC_EIR5_SHIFT                                               0
#define CFG_RSIF_PLC_EIR5_MASK                                       0x00ffffff
#define CFG_RSIF_PLC_EIR5_RD(src)                        (((src) & 0x00ffffff))
#define CFG_RSIF_PLC_EIR5_WR(src)                   (((u32)(src)) & 0x00ffffff)
#define CFG_RSIF_PLC_EIR5_SET(dst,src) \
                          (((dst) & ~0x00ffffff) | (((u32)(src)) & 0x00ffffff))

/*	Register RSIF_Policer_Reg6	*/ 
/*	 Fields cfg_rsif_plc_ECA	 */
#define CFG_RSIF_PLC_ECA6_WIDTH                                              32
#define CFG_RSIF_PLC_ECA6_SHIFT                                               0
#define CFG_RSIF_PLC_ECA6_MASK                                       0xffffffff
#define CFG_RSIF_PLC_ECA6_RD(src)                        (((src) & 0xffffffff))
#define CFG_RSIF_PLC_ECA6_WR(src)                   (((u32)(src)) & 0xffffffff)
#define CFG_RSIF_PLC_ECA6_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_Reg7	*/ 
/*	 Fields cfg_rsif_plc_dual_bucket_mode	 */
#define ENET_CFG_RSIF_PLC_DUAL_BUCKET_MODE7_WIDTH                          1
#define ENET_CFG_RSIF_PLC_DUAL_BUCKET_MODE7_SHIFT                         31
#define ENET_CFG_RSIF_PLC_DUAL_BUCKET_MODE7_MASK                  0x80000000
#define ENET_CFG_RSIF_PLC_DUAL_BUCKET_MODE7_RD(src) \
                                                    (((src) & 0x80000000)>>31)
#define ENET_CFG_RSIF_PLC_DUAL_BUCKET_MODE7_WR(src) \
                                                (((u32)(src)<<31) & 0x80000000)
#define ENET_CFG_RSIF_PLC_DUAL_BUCKET_MODE7_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_rsif_plc0_en	 */
#define ENET_CFG_RSIF_PLC0_EN7_WIDTH                                       1
#define ENET_CFG_RSIF_PLC0_EN7_SHIFT                                      30
#define ENET_CFG_RSIF_PLC0_EN7_MASK                               0x40000000
#define ENET_CFG_RSIF_PLC0_EN7_RD(src)            (((src) & 0x40000000)>>30)
#define ENET_CFG_RSIF_PLC0_EN7_WR(src)       (((u32)(src)<<30) & 0x40000000)
#define ENET_CFG_RSIF_PLC0_EN7_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_rsif_plc1_en	 */
#define ENET_CFG_RSIF_PLC1_EN7_WIDTH                                       1
#define ENET_CFG_RSIF_PLC1_EN7_SHIFT                                      29
#define ENET_CFG_RSIF_PLC1_EN7_MASK                               0x20000000
#define ENET_CFG_RSIF_PLC1_EN7_RD(src)            (((src) & 0x20000000)>>29)
#define ENET_CFG_RSIF_PLC1_EN7_WR(src)       (((u32)(src)<<29) & 0x20000000)
#define ENET_CFG_RSIF_PLC1_EN7_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields cfg_rsif_plc2_en	 */
#define CFG_RSIF_PLC2_EN7_WIDTH                                               1
#define CFG_RSIF_PLC2_EN7_SHIFT                                              28
#define CFG_RSIF_PLC2_EN7_MASK                                       0x10000000
#define CFG_RSIF_PLC2_EN7_RD(src)                    (((src) & 0x10000000)>>28)
#define CFG_RSIF_PLC2_EN7_WR(src)               (((u32)(src)<<28) & 0x10000000)
#define CFG_RSIF_PLC2_EN7_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields cfg_rsif_plc_pkt_color_default	 */
#define CFG_RSIF_PLC_PKT_COLOR_DEFAULT7_WIDTH                                 2
#define CFG_RSIF_PLC_PKT_COLOR_DEFAULT7_SHIFT                                25
#define CFG_RSIF_PLC_PKT_COLOR_DEFAULT7_MASK                         0x06000000
#define CFG_RSIF_PLC_PKT_COLOR_DEFAULT7_RD(src)      (((src) & 0x06000000)>>25)
#define CFG_RSIF_PLC_PKT_COLOR_DEFAULT7_WR(src) \
                                                (((u32)(src)<<25) & 0x06000000)
#define CFG_RSIF_PLC_PKT_COLOR_DEFAULT7_SET(dst,src) \
                      (((dst) & ~0x06000000) | (((u32)(src)<<25) & 0x06000000))
/*	 Fields cfg_rsif_plc_short_credit_update_time	 */
#define CFG_RSIF_PLC_SHORT_CREDIT_UPDATE_TIME7_WIDTH                          1
#define CFG_RSIF_PLC_SHORT_CREDIT_UPDATE_TIME7_SHIFT                         24
#define CFG_RSIF_PLC_SHORT_CREDIT_UPDATE_TIME7_MASK                  0x01000000
#define CFG_RSIF_PLC_SHORT_CREDIT_UPDATE_TIME7_RD(src) \
                                                    (((src) & 0x01000000)>>24)
#define CFG_RSIF_PLC_SHORT_CREDIT_UPDATE_TIME7_WR(src) \
                                                (((u32)(src)<<24) & 0x01000000)
#define CFG_RSIF_PLC_SHORT_CREDIT_UPDATE_TIME7_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_rsif_plc_total_threshold_toggle	 */
#define CFG_RSIF_PLC_TOTAL_THRESHOLD_TOGGLE7_WIDTH                            1
#define CFG_RSIF_PLC_TOTAL_THRESHOLD_TOGGLE7_SHIFT                           13
#define CFG_RSIF_PLC_TOTAL_THRESHOLD_TOGGLE7_MASK                    0x00002000
#define CFG_RSIF_PLC_TOTAL_THRESHOLD_TOGGLE7_RD(src) \
                                                    (((src) & 0x00002000)>>13)
#define CFG_RSIF_PLC_TOTAL_THRESHOLD_TOGGLE7_WR(src) \
                                                (((u32)(src)<<13) & 0x00002000)
#define CFG_RSIF_PLC_TOTAL_THRESHOLD_TOGGLE7_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields cfg_rsif_plc_total_threshold	 */
#define CFG_RSIF_PLC_TOTAL_THRESHOLD7_WIDTH                                   5
#define CFG_RSIF_PLC_TOTAL_THRESHOLD7_SHIFT                                   8
#define CFG_RSIF_PLC_TOTAL_THRESHOLD7_MASK                           0x00001f00
#define CFG_RSIF_PLC_TOTAL_THRESHOLD7_RD(src)         (((src) & 0x00001f00)>>8)
#define CFG_RSIF_PLC_TOTAL_THRESHOLD7_WR(src)    (((u32)(src)<<8) & 0x00001f00)
#define CFG_RSIF_PLC_TOTAL_THRESHOLD7_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields cfg_rsif_plc_threshold_toggle	 */
#define CFG_RSIF_PLC_THRESHOLD_TOGGLE7_WIDTH                                  1
#define CFG_RSIF_PLC_THRESHOLD_TOGGLE7_SHIFT                                  5
#define CFG_RSIF_PLC_THRESHOLD_TOGGLE7_MASK                          0x00000020
#define CFG_RSIF_PLC_THRESHOLD_TOGGLE7_RD(src)        (((src) & 0x00000020)>>5)
#define CFG_RSIF_PLC_THRESHOLD_TOGGLE7_WR(src)   (((u32)(src)<<5) & 0x00000020)
#define CFG_RSIF_PLC_THRESHOLD_TOGGLE7_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields cfg_rsif_plc_threshold	 */
#define CFG_RSIF_PLC_THRESHOLD7_WIDTH                                         5
#define CFG_RSIF_PLC_THRESHOLD7_SHIFT                                         0
#define CFG_RSIF_PLC_THRESHOLD7_MASK                                 0x0000001f
#define CFG_RSIF_PLC_THRESHOLD7_RD(src)                  (((src) & 0x0000001f))
#define CFG_RSIF_PLC_THRESHOLD7_WR(src)             (((u32)(src)) & 0x0000001f)
#define CFG_RSIF_PLC_THRESHOLD7_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register RSIF_Policer_Reg8	*/ 
/*	 Fields sts_rsif_plc_drop_cnt	 */
#define STS_RSIF_PLC_DROP_CNT8_WIDTH                                         32
#define STS_RSIF_PLC_DROP_CNT8_SHIFT                                          0
#define STS_RSIF_PLC_DROP_CNT8_MASK                                  0xffffffff
#define STS_RSIF_PLC_DROP_CNT8_RD(src)                   (((src) & 0xffffffff))
#define STS_RSIF_PLC_DROP_CNT8_WR(src)              (((u32)(src)) & 0xffffffff)
#define STS_RSIF_PLC_DROP_CNT8_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_HdrExt_shift	*/ 
/*	 Fields cfg_rsif_plc_nonip_shift	 */
#define CFG_RSIF_PLC_NONIP_SHIFT_WIDTH                                        4
#define CFG_RSIF_PLC_NONIP_SHIFT_SHIFT                                        8
#define CFG_RSIF_PLC_NONIP_SHIFT_MASK                                0x00000f00
#define CFG_RSIF_PLC_NONIP_SHIFT_RD(src)              (((src) & 0x00000f00)>>8)
#define CFG_RSIF_PLC_NONIP_SHIFT_WR(src)         (((u32)(src)<<8) & 0x00000f00)
#define CFG_RSIF_PLC_NONIP_SHIFT_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields cfg_rsif_plc_ipv6_shift	 */
#define CFG_RSIF_PLC_IPV6_SHIFT_WIDTH                                         4
#define CFG_RSIF_PLC_IPV6_SHIFT_SHIFT                                         4
#define CFG_RSIF_PLC_IPV6_SHIFT_MASK                                 0x000000f0
#define CFG_RSIF_PLC_IPV6_SHIFT_RD(src)               (((src) & 0x000000f0)>>4)
#define CFG_RSIF_PLC_IPV6_SHIFT_WR(src)          (((u32)(src)<<4) & 0x000000f0)
#define CFG_RSIF_PLC_IPV6_SHIFT_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_rsif_plc_ipv4_shift	 */
#define CFG_RSIF_PLC_IPV4_SHIFT_WIDTH                                         4
#define CFG_RSIF_PLC_IPV4_SHIFT_SHIFT                                         0
#define CFG_RSIF_PLC_IPV4_SHIFT_MASK                                 0x0000000f
#define CFG_RSIF_PLC_IPV4_SHIFT_RD(src)                  (((src) & 0x0000000f))
#define CFG_RSIF_PLC_IPV4_SHIFT_WR(src)             (((u32)(src)) & 0x0000000f)
#define CFG_RSIF_PLC_IPV4_SHIFT_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register RSIF_Policer_StsReg0	*/ 
/*	 Fields sts_rsif_plc_total_dropcnt	 */
#define STS_RSIF_PLC_TOTAL_DROPCNT0_WIDTH                                    32
#define STS_RSIF_PLC_TOTAL_DROPCNT0_SHIFT                                     0
#define STS_RSIF_PLC_TOTAL_DROPCNT0_MASK                             0xffffffff
#define STS_RSIF_PLC_TOTAL_DROPCNT0_RD(src)              (((src) & 0xffffffff))
#define STS_RSIF_PLC_TOTAL_DROPCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_StsReg1	*/ 
/*	 Fields sts_rsif_plc_total_dropcnt	 */
#define STS_RSIF_PLC_TOTAL_DROPCNT1_WIDTH                                    32
#define STS_RSIF_PLC_TOTAL_DROPCNT1_SHIFT                                     0
#define STS_RSIF_PLC_TOTAL_DROPCNT1_MASK                             0xffffffff
#define STS_RSIF_PLC_TOTAL_DROPCNT1_RD(src)              (((src) & 0xffffffff))
#define STS_RSIF_PLC_TOTAL_DROPCNT1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_RAM_Dbg_Reg0	*/ 
/*	 Fields cfg_rsif_rtype	 */
#define CFG_RSIF_RTYPE0_WIDTH                                                10
#define CFG_RSIF_RTYPE0_SHIFT                                                16
#define CFG_RSIF_RTYPE0_MASK                                         0x03ff0000
#define CFG_RSIF_RTYPE0_RD(src)                      (((src) & 0x03ff0000)>>16)
#define CFG_RSIF_RTYPE0_WR(src)                 (((u32)(src)<<16) & 0x03ff0000)
#define CFG_RSIF_RTYPE0_SET(dst,src) \
                      (((dst) & ~0x03ff0000) | (((u32)(src)<<16) & 0x03ff0000))
/*	 Fields cfg_rsif_plcram_TEST1B	 */
#define CFG_RSIF_PLCRAM_TEST1B0_WIDTH                                         1
#define CFG_RSIF_PLCRAM_TEST1B0_SHIFT                                        11
#define CFG_RSIF_PLCRAM_TEST1B0_MASK                                 0x00000800
#define CFG_RSIF_PLCRAM_TEST1B0_RD(src)              (((src) & 0x00000800)>>11)
#define CFG_RSIF_PLCRAM_TEST1B0_WR(src)         (((u32)(src)<<11) & 0x00000800)
#define CFG_RSIF_PLCRAM_TEST1B0_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_rsif_plcram_TEST1A	 */
#define CFG_RSIF_PLCRAM_TEST1A0_WIDTH                                         1
#define CFG_RSIF_PLCRAM_TEST1A0_SHIFT                                        10
#define CFG_RSIF_PLCRAM_TEST1A0_MASK                                 0x00000400
#define CFG_RSIF_PLCRAM_TEST1A0_RD(src)              (((src) & 0x00000400)>>10)
#define CFG_RSIF_PLCRAM_TEST1A0_WR(src)         (((u32)(src)<<10) & 0x00000400)
#define CFG_RSIF_PLCRAM_TEST1A0_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_rsif_plcram_RMEB	 */
#define CFG_RSIF_PLCRAM_RMEB0_WIDTH                                           1
#define CFG_RSIF_PLCRAM_RMEB0_SHIFT                                           9
#define CFG_RSIF_PLCRAM_RMEB0_MASK                                   0x00000200
#define CFG_RSIF_PLCRAM_RMEB0_RD(src)                 (((src) & 0x00000200)>>9)
#define CFG_RSIF_PLCRAM_RMEB0_WR(src)            (((u32)(src)<<9) & 0x00000200)
#define CFG_RSIF_PLCRAM_RMEB0_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_rsif_plcram_RMEA	 */
#define CFG_RSIF_PLCRAM_RMEA0_WIDTH                                           1
#define CFG_RSIF_PLCRAM_RMEA0_SHIFT                                           8
#define CFG_RSIF_PLCRAM_RMEA0_MASK                                   0x00000100
#define CFG_RSIF_PLCRAM_RMEA0_RD(src)                 (((src) & 0x00000100)>>8)
#define CFG_RSIF_PLCRAM_RMEA0_WR(src)            (((u32)(src)<<8) & 0x00000100)
#define CFG_RSIF_PLCRAM_RMEA0_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_rsif_plcram_RMB	 */
#define CFG_RSIF_PLCRAM_RMB0_WIDTH                                            4
#define CFG_RSIF_PLCRAM_RMB0_SHIFT                                            4
#define CFG_RSIF_PLCRAM_RMB0_MASK                                    0x000000f0
#define CFG_RSIF_PLCRAM_RMB0_RD(src)                  (((src) & 0x000000f0)>>4)
#define CFG_RSIF_PLCRAM_RMB0_WR(src)             (((u32)(src)<<4) & 0x000000f0)
#define CFG_RSIF_PLCRAM_RMB0_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_rsif_plcram_RMA	 */
#define CFG_RSIF_PLCRAM_RMA0_WIDTH                                            4
#define CFG_RSIF_PLCRAM_RMA0_SHIFT                                            0
#define CFG_RSIF_PLCRAM_RMA0_MASK                                    0x0000000f
#define CFG_RSIF_PLCRAM_RMA0_RD(src)                     (((src) & 0x0000000f))
#define CFG_RSIF_PLCRAM_RMA0_WR(src)                (((u32)(src)) & 0x0000000f)
#define CFG_RSIF_PLCRAM_RMA0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register RSIF_Wol_Mode0	*/ 
/*	 Fields cfg_fpga_wol_mode_testen_port1	 */
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT10_WIDTH                         1
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT10_SHIFT                        29
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT10_MASK                 0x20000000
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT10_RD(src) \
                                                    (((src) & 0x20000000)>>29)
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT10_WR(src) \
                                                (((u32)(src)<<29) & 0x20000000)
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT10_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields cfg_fpga_wol_mode_testen_port0	 */
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT00_WIDTH                         1
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT00_SHIFT                        28
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT00_MASK                 0x10000000
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT00_RD(src) \
                                                    (((src) & 0x10000000)>>28)
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT00_WR(src) \
                                                (((u32)(src)<<28) & 0x10000000)
#define ENET_CFG_FPGA_WOL_MODE_TESTEN_PORT00_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields cfg_mpa_enet_tx_wakeup_qmsel_port1	 */
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT10_WIDTH                             1
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT10_SHIFT                            18
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT10_MASK                     0x00040000
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT10_RD(src)  (((src) & 0x00040000)>>18)
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT10_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields cfg_mpa_enet_wake_up_port1	 */
#define CFG_MPA_ENET_WAKE_UP_PORT10_WIDTH                                     1
#define CFG_MPA_ENET_WAKE_UP_PORT10_SHIFT                                    17
#define CFG_MPA_ENET_WAKE_UP_PORT10_MASK                             0x00020000
#define CFG_MPA_ENET_WAKE_UP_PORT10_RD(src)          (((src) & 0x00020000)>>17)
#define CFG_MPA_ENET_WAKE_UP_PORT10_WR(src)     (((u32)(src)<<17) & 0x00020000)
#define CFG_MPA_ENET_WAKE_UP_PORT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_mpa_enet_release_halt_port1	 */
#define CFG_MPA_ENET_RELEASE_HALT_PORT10_WIDTH                                1
#define CFG_MPA_ENET_RELEASE_HALT_PORT10_SHIFT                               16
#define CFG_MPA_ENET_RELEASE_HALT_PORT10_MASK                        0x00010000
#define CFG_MPA_ENET_RELEASE_HALT_PORT10_RD(src)     (((src) & 0x00010000)>>16)
#define CFG_MPA_ENET_RELEASE_HALT_PORT10_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define CFG_MPA_ENET_RELEASE_HALT_PORT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_mpa_enet_tx_wakeup_qmsel_port0	 */
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT00_WIDTH                             1
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT00_SHIFT                             2
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT00_MASK                     0x00000004
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT00_RD(src)   (((src) & 0x00000004)>>2)
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT00_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define CFG_MPA_ENET_TX_WAKEUP_QMSEL_PORT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_mpa_enet_wake_up_port0	 */
#define CFG_MPA_ENET_WAKE_UP_PORT00_WIDTH                                     1
#define CFG_MPA_ENET_WAKE_UP_PORT00_SHIFT                                     1
#define CFG_MPA_ENET_WAKE_UP_PORT00_MASK                             0x00000002
#define CFG_MPA_ENET_WAKE_UP_PORT00_RD(src)           (((src) & 0x00000002)>>1)
#define CFG_MPA_ENET_WAKE_UP_PORT00_WR(src)      (((u32)(src)<<1) & 0x00000002)
#define CFG_MPA_ENET_WAKE_UP_PORT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_mpa_enet_release_halt_port0	 */
#define CFG_MPA_ENET_RELEASE_HALT_PORT00_WIDTH                                1
#define CFG_MPA_ENET_RELEASE_HALT_PORT00_SHIFT                                0
#define CFG_MPA_ENET_RELEASE_HALT_PORT00_MASK                        0x00000001
#define CFG_MPA_ENET_RELEASE_HALT_PORT00_RD(src)         (((src) & 0x00000001))
#define CFG_MPA_ENET_RELEASE_HALT_PORT00_WR(src)    (((u32)(src)) & 0x00000001)
#define CFG_MPA_ENET_RELEASE_HALT_PORT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_FIFO_EmptySts0	*/ 
/*	 Fields rsif_plc_eof_fifo_empty	 */
#define RSIF_PLC_EOF_FIFO_EMPTY0_WIDTH                                        1
#define RSIF_PLC_EOF_FIFO_EMPTY0_SHIFT                                       30
#define RSIF_PLC_EOF_FIFO_EMPTY0_MASK                                0x40000000
#define RSIF_PLC_EOF_FIFO_EMPTY0_RD(src)             (((src) & 0x40000000)>>30)
#define RSIF_PLC_EOF_FIFO_EMPTY0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields enet_fifo_empty	 */
#define ENET_FIFO_EMPTY0_WIDTH                                                1
#define ENET_FIFO_EMPTY0_SHIFT                                               29
#define ENET_FIFO_EMPTY0_MASK                                        0x20000000
#define ENET_FIFO_EMPTY0_RD(src)                     (((src) & 0x20000000)>>29)
#define ENET_FIFO_EMPTY0_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields rsif_plc_clebuff_fifo_empty	 */
#define ENET_RSIF_PLC_CLEBUFF_FIFO_EMPTY0_WIDTH                            1
#define ENET_RSIF_PLC_CLEBUFF_FIFO_EMPTY0_SHIFT                           28
#define ENET_RSIF_PLC_CLEBUFF_FIFO_EMPTY0_MASK                    0x10000000
#define ENET_RSIF_PLC_CLEBUFF_FIFO_EMPTY0_RD(src) \
                                                    (((src) & 0x10000000)>>28)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_EMPTY0_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields rsif_chksum_cledata_fifo_empty_rxprt1	 */
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT10_WIDTH                          1
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT10_SHIFT                         23
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT10_MASK                  0x00800000
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT10_RD(src) \
                                                    (((src) & 0x00800000)>>23)
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields rsif_lcl_rxbuf_fifo_empty_rxprt1	 */
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT10_WIDTH                               1
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT10_SHIFT                              22
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT10_MASK                       0x00400000
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT10_RD(src)    (((src) & 0x00400000)>>22)
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields rsif_chksum_buff_fifo_empty_rxprt1	 */
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT10_WIDTH                             1
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT10_SHIFT                            21
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT10_MASK                     0x00200000
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT10_RD(src)  (((src) & 0x00200000)>>21)
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields rsif_timestamp_buff_fifo_empty_rxprt1	 */
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT10_WIDTH                          1
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT10_SHIFT                         20
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT10_MASK                  0x00100000
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT10_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields rsif_err_buff_fifo_empty_rxprt1	 */
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT10_WIDTH                                1
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT10_SHIFT                               19
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT10_MASK                        0x00080000
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT10_RD(src)     (((src) & 0x00080000)>>19)
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields rsif_clebuff_fifo_empty_rxprt1	 */
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT10_WIDTH                                 1
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT10_SHIFT                                18
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT10_MASK                         0x00040000
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT10_RD(src)      (((src) & 0x00040000)>>18)
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields rsif_ctrlbuff_fifo_empty_rxprt1	 */
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT10_WIDTH                                1
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT10_SHIFT                               17
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT10_MASK                        0x00020000
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT10_RD(src)     (((src) & 0x00020000)>>17)
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields rsif_buf_fifo_empty_rxprt1	 */
#define RSIF_BUF_FIFO_EMPTY_RXPRT10_WIDTH                                     1
#define RSIF_BUF_FIFO_EMPTY_RXPRT10_SHIFT                                    16
#define RSIF_BUF_FIFO_EMPTY_RXPRT10_MASK                             0x00010000
#define RSIF_BUF_FIFO_EMPTY_RXPRT10_RD(src)          (((src) & 0x00010000)>>16)
#define RSIF_BUF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields rsif_chksum_cledata_fifo_empty_rxprt0	 */
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT00_WIDTH                          1
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT00_SHIFT                          7
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT00_MASK                  0x00000080
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT00_RD(src) \
                                                     (((src) & 0x00000080)>>7)
#define RSIF_CHKSUM_CLEDATA_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields rsif_lcl_rxbuf_fifo_empty_rxprt0	 */
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT00_WIDTH                               1
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT00_SHIFT                               6
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT00_MASK                       0x00000040
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT00_RD(src)     (((src) & 0x00000040)>>6)
#define RSIF_LCL_RXBUF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields rsif_chksum_buff_fifo_empty_rxprt0	 */
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT00_WIDTH                             1
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT00_SHIFT                             5
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT00_MASK                     0x00000020
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT00_RD(src)   (((src) & 0x00000020)>>5)
#define RSIF_CHKSUM_BUFF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields rsif_timestamp_buff_fifo_empty_rxprt0	 */
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT00_WIDTH                          1
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT00_SHIFT                          4
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT00_MASK                  0x00000010
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT00_RD(src) \
                                                     (((src) & 0x00000010)>>4)
#define RSIF_TIMESTAMP_BUFF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields rsif_err_buff_fifo_empty_rxprt0	 */
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT00_WIDTH                                1
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT00_SHIFT                                3
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT00_MASK                        0x00000008
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT00_RD(src)      (((src) & 0x00000008)>>3)
#define RSIF_ERR_BUFF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields rsif_clebuff_fifo_empty_rxprt0	 */
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT00_WIDTH                                 1
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT00_SHIFT                                 2
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT00_MASK                         0x00000004
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT00_RD(src)       (((src) & 0x00000004)>>2)
#define RSIF_CLEBUFF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rsif_ctrlbuff_fifo_empty_rxprt0	 */
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT00_WIDTH                                1
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT00_SHIFT                                1
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT00_MASK                        0x00000002
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT00_RD(src)      (((src) & 0x00000002)>>1)
#define RSIF_CTRLBUFF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields rsif_buf_fifo_empty_rxprt0	 */
#define RSIF_BUF_FIFO_EMPTY_RXPRT00_WIDTH                                     1
#define RSIF_BUF_FIFO_EMPTY_RXPRT00_SHIFT                                     0
#define RSIF_BUF_FIFO_EMPTY_RXPRT00_MASK                             0x00000001
#define RSIF_BUF_FIFO_EMPTY_RXPRT00_RD(src)              (((src) & 0x00000001))
#define RSIF_BUF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_Int_Reg0	*/ 
/*	 Fields rsif_plc_eof_fifo_overfl_intr	 */
#define RSIF_PLC_EOF_FIFO_OVERFL_INTR0_WIDTH                                  1
#define RSIF_PLC_EOF_FIFO_OVERFL_INTR0_SHIFT                                 31
#define RSIF_PLC_EOF_FIFO_OVERFL_INTR0_MASK                          0x80000000
#define RSIF_PLC_EOF_FIFO_OVERFL_INTR0_RD(src)       (((src) & 0x80000000)>>31)
#define RSIF_PLC_EOF_FIFO_OVERFL_INTR0_WR(src)  (((u32)(src)<<31) & 0x80000000)
#define RSIF_PLC_EOF_FIFO_OVERFL_INTR0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields rsif_plc_eof_fifo_underfl_intr	 */
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTR0_WIDTH                                 1
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTR0_SHIFT                                30
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTR0_MASK                         0x40000000
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTR0_RD(src)      (((src) & 0x40000000)>>30)
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTR0_WR(src) \
                                                (((u32)(src)<<30) & 0x40000000)
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTR0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields rsif_lcl_rxbuf_fifo_overfl_intr_rxprt1	 */
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                         1
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                        29
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT10_MASK                 0x20000000
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x20000000)>>29)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<29) & 0x20000000)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields rsif_lcl_rxbuf_fifo_underfl_intr_rxprt1	 */
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                        1
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                       28
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT10_MASK                0x10000000
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x10000000)>>28)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<28) & 0x10000000)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields rsif_chksum_buff_fifo_overfl_intr_rxprt1	 */
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                       1
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                      27
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT10_MASK               0x08000000
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x08000000)>>27)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<27) & 0x08000000)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields rsif_chksum_buff_fifo_underfl_intr_rxprt1	 */
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                      1
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                     26
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT10_MASK              0x04000000
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x04000000)>>26)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<26) & 0x04000000)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields rsif_timestamp_buff_fifo_overfl_intr_rxprt1	 */
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                    1
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                   25
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT10_MASK            0x02000000
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x02000000)>>25)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<25) & 0x02000000)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields rsif_timestamp_buff_fifo_underfl_intr_rxprt1	 */
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                   1
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                  24
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT10_MASK           0x01000000
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x01000000)>>24)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<24) & 0x01000000)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields rsif_err_buff_fifo_overfl_intr_rxprt1	 */
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                          1
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                         23
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT10_MASK                  0x00800000
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00800000)>>23)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<23) & 0x00800000)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields rsif_err_buff_fifo_underfl_intr_rxprt1	 */
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                         1
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                        22
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT10_MASK                 0x00400000
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00400000)>>22)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<22) & 0x00400000)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields rsif_clebuff_fifo_overfl_intr_rxprt1	 */
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                           1
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                          21
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT10_MASK                   0x00200000
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields rsif_clebuff_fifo_underfl_intr_rxprt1	 */
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                          1
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                         20
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT10_MASK                  0x00100000
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields rsif_ctrlbuff_fifo_overfl_intr_rxprt1	 */
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                          1
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                         19
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT10_MASK                  0x00080000
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00080000)>>19)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields rsif_ctrlbuff_fifo_underfl_intr_rxprt1	 */
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                         1
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                        18
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT10_MASK                 0x00040000
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00040000)>>18)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields rsif_buf_fifo_overfl_intr_rxprt1	 */
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                               1
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                              17
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT10_MASK                       0x00020000
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT10_RD(src)    (((src) & 0x00020000)>>17)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields rsif_buf_fifo_underfl_intr_rxprt1	 */
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                              1
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                             16
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT10_MASK                      0x00010000
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT10_RD(src)   (((src) & 0x00010000)>>16)
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields rsif_plc_clebuff_fifo_overfl_intr	 */
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTR0_WIDTH                      1
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTR0_SHIFT                     15
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTR0_MASK              0x00008000
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTR0_RD(src) \
                                                    (((src) & 0x00008000)>>15)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTR0_WR(src) \
                                                (((u32)(src)<<15) & 0x00008000)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTR0_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields rsif_plc_clebuff_fifo_underfl_intr	 */
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTR0_WIDTH                     1
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTR0_SHIFT                    14
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTR0_MASK             0x00004000
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTR0_RD(src) \
                                                    (((src) & 0x00004000)>>14)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTR0_WR(src) \
                                                (((u32)(src)<<14) & 0x00004000)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTR0_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields rsif_lcl_rxbuf_fifo_overfl_intr_rxprt0	 */
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                         1
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                        13
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT00_MASK                 0x00002000
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT00_RD(src) \
                                                    (((src) & 0x00002000)>>13)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                (((u32)(src)<<13) & 0x00002000)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields rsif_lcl_rxbuf_fifo_underfl_intr_rxprt0	 */
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                        1
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                       12
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT00_MASK                0x00001000
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT00_RD(src) \
                                                    (((src) & 0x00001000)>>12)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT00_WR(src) \
                                                (((u32)(src)<<12) & 0x00001000)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields rsif_chksum_buff_fifo_overfl_intr_rxprt0	 */
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                       1
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                      11
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT00_MASK               0x00000800
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT00_RD(src) \
                                                    (((src) & 0x00000800)>>11)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                (((u32)(src)<<11) & 0x00000800)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields rsif_chksum_buff_fifo_underfl_intr_rxprt0	 */
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                      1
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                     10
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT00_MASK              0x00000400
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT00_RD(src) \
                                                    (((src) & 0x00000400)>>10)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT00_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields rsif_timestamp_buff_fifo_overfl_intr_rxprt0	 */
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                    1
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                    9
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT00_MASK            0x00000200
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000200)>>9)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields rsif_timestamp_buff_fifo_underfl_intr_rxprt0	 */
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                   1
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                   8
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT00_MASK           0x00000100
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000100)>>8)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<8) & 0x00000100)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields rsif_err_buff_fifo_overfl_intr_rxprt0	 */
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                          1
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                          7
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT00_MASK                  0x00000080
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000080)>>7)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<7) & 0x00000080)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields rsif_err_buff_fifo_underfl_intr_rxprt0	 */
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                         1
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                         6
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT00_MASK                 0x00000040
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000040)>>6)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields rsif_clebuff_fifo_overfl_intr_rxprt0	 */
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                           1
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                           5
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT00_MASK                   0x00000020
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000020)>>5)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields rsif_clebuff_fifo_underfl_intr_rxprt0	 */
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                          1
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                          4
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT00_MASK                  0x00000010
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000010)>>4)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields rsif_ctrlbuff_fifo_overfl_intr_rxprt0	 */
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                          1
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                          3
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT00_MASK                  0x00000008
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000008)>>3)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields rsif_ctrlbuff_fifo_underfl_intr_rxprt0	 */
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                         1
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                         2
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT00_MASK                 0x00000004
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000004)>>2)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rsif_buf_fifo_overfl_intr_rxprt0	 */
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                               1
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                               1
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT00_MASK                       0x00000002
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT00_RD(src)     (((src) & 0x00000002)>>1)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields rsif_buf_fifo_underfl_intr_rxprt0	 */
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                              1
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                              0
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT00_MASK                      0x00000001
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT00_RD(src)       (((src) & 0x00000001))
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT00_WR(src)  (((u32)(src)) & 0x00000001)
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_Int_Reg0Mask	*/
/*    Mask Register Fields rsif_plc_eof_fifo_overfl_intrMask    */
#define RSIF_PLC_EOF_FIFO_OVERFL_INTRMASK_WIDTH                               1
#define RSIF_PLC_EOF_FIFO_OVERFL_INTRMASK_SHIFT                              31
#define RSIF_PLC_EOF_FIFO_OVERFL_INTRMASK_MASK                       0x80000000
#define RSIF_PLC_EOF_FIFO_OVERFL_INTRMASK_RD(src)    (((src) & 0x80000000)>>31)
#define RSIF_PLC_EOF_FIFO_OVERFL_INTRMASK_WR(src) \
                                                (((u32)(src)<<31) & 0x80000000)
#define RSIF_PLC_EOF_FIFO_OVERFL_INTRMASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields rsif_plc_eof_fifo_underfl_intrMask    */
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTRMASK_WIDTH                              1
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTRMASK_SHIFT                             30
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTRMASK_MASK                      0x40000000
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTRMASK_RD(src)   (((src) & 0x40000000)>>30)
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTRMASK_WR(src) \
                                                (((u32)(src)<<30) & 0x40000000)
#define RSIF_PLC_EOF_FIFO_UNDERFL_INTRMASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields rsif_lcl_rxbuf_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                      1
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                     29
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK              0x20000000
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x20000000)>>29)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<29) & 0x20000000)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields rsif_lcl_rxbuf_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                     1
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                    28
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK             0x10000000
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x10000000)>>28)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<28) & 0x10000000)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields rsif_chksum_buff_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                    1
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                   27
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK            0x08000000
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x08000000)>>27)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<27) & 0x08000000)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields rsif_chksum_buff_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                   1
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                  26
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK           0x04000000
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x04000000)>>26)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<26) & 0x04000000)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields rsif_timestamp_buff_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                 1
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                25
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK         0x02000000
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x02000000)>>25)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<25) & 0x02000000)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields rsif_timestamp_buff_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                1
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT               24
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK        0x01000000
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x01000000)>>24)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<24) & 0x01000000)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields rsif_err_buff_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                       1
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                      23
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK               0x00800000
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00800000)>>23)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<23) & 0x00800000)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields rsif_err_buff_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                      1
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                     22
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK              0x00400000
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00400000)>>22)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<22) & 0x00400000)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields rsif_clebuff_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                        1
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                       21
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK                0x00200000
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields rsif_clebuff_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                       1
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                      20
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK               0x00100000
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields rsif_ctrlbuff_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                       1
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                      19
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK               0x00080000
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00080000)>>19)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields rsif_ctrlbuff_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                      1
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                     18
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK              0x00040000
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00040000)>>18)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields rsif_buf_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                            1
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                           17
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK                    0x00020000
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields rsif_buf_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                           1
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                          16
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK                   0x00010000
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields rsif_plc_clebuff_fifo_overfl_intrMask    */
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTRMASK_WIDTH                   1
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTRMASK_SHIFT                  15
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTRMASK_MASK           0x00008000
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTRMASK_RD(src) \
                                                    (((src) & 0x00008000)>>15)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTRMASK_WR(src) \
                                                (((u32)(src)<<15) & 0x00008000)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_OVERFL_INTRMASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields rsif_plc_clebuff_fifo_underfl_intrMask    */
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTRMASK_WIDTH                  1
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTRMASK_SHIFT                 14
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTRMASK_MASK          0x00004000
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTRMASK_RD(src) \
                                                    (((src) & 0x00004000)>>14)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTRMASK_WR(src) \
                                                (((u32)(src)<<14) & 0x00004000)
#define ENET_RSIF_PLC_CLEBUFF_FIFO_UNDERFL_INTRMASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields rsif_lcl_rxbuf_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                      1
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                     13
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK              0x00002000
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                    (((src) & 0x00002000)>>13)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                (((u32)(src)<<13) & 0x00002000)
#define RSIF_LCL_RXBUF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields rsif_lcl_rxbuf_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                     1
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                    12
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK             0x00001000
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                    (((src) & 0x00001000)>>12)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                (((u32)(src)<<12) & 0x00001000)
#define RSIF_LCL_RXBUF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields rsif_chksum_buff_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                    1
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                   11
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK            0x00000800
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                    (((src) & 0x00000800)>>11)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                (((u32)(src)<<11) & 0x00000800)
#define RSIF_CHKSUM_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields rsif_chksum_buff_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                   1
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                  10
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK           0x00000400
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                    (((src) & 0x00000400)>>10)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define RSIF_CHKSUM_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields rsif_timestamp_buff_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                 1
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                 9
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK         0x00000200
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000200)>>9)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define RSIF_TIMESTAMP_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields rsif_timestamp_buff_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                1
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                8
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK        0x00000100
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000100)>>8)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<8) & 0x00000100)
#define RSIF_TIMESTAMP_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields rsif_err_buff_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                       1
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                       7
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK               0x00000080
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000080)>>7)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<7) & 0x00000080)
#define RSIF_ERR_BUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields rsif_err_buff_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                      1
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                      6
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK              0x00000040
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000040)>>6)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define RSIF_ERR_BUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields rsif_clebuff_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                        1
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                        5
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK                0x00000020
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000020)>>5)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define RSIF_CLEBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields rsif_clebuff_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                       1
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                       4
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK               0x00000010
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000010)>>4)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define RSIF_CLEBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields rsif_ctrlbuff_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                       1
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                       3
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK               0x00000008
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000008)>>3)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define RSIF_CTRLBUFF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields rsif_ctrlbuff_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                      1
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                      2
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK              0x00000004
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000004)>>2)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define RSIF_CTRLBUFF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields rsif_buf_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                            1
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                            1
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK                    0x00000002
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src)  (((src) & 0x00000002)>>1)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define RSIF_BUF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields rsif_buf_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                           1
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                           0
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK                   0x00000001
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src)    (((src) & 0x00000001))
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define RSIF_BUF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_FInt_Reg0	*/ 
/*	 Fields rsif_ss_lllength_gt_256_intr_rxprt1	 */
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT10_WIDTH                            1
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT10_SHIFT                           21
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT10_MASK                    0x00200000
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields rsif_ss_fpbuff_invld_enc_intr_rxprt1	 */
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT10_WIDTH                           1
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT10_SHIFT                          20
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT10_MASK                   0x00100000
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT10_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields rsif_ss_mirrorerr_intr_rxprt1	 */
#define RSIF_SS_MIRRORERR_INTR_RXPRT10_WIDTH                                  1
#define RSIF_SS_MIRRORERR_INTR_RXPRT10_SHIFT                                 19
#define RSIF_SS_MIRRORERR_INTR_RXPRT10_MASK                          0x00080000
#define RSIF_SS_MIRRORERR_INTR_RXPRT10_RD(src)       (((src) & 0x00080000)>>19)
#define RSIF_SS_MIRRORERR_INTR_RXPRT10_WR(src)  (((u32)(src)<<19) & 0x00080000)
#define RSIF_SS_MIRRORERR_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields rsif_ss_split_boundary_intr_rxprt1	 */
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT10_WIDTH                             1
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT10_SHIFT                            18
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT10_MASK                     0x00040000
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT10_RD(src)  (((src) & 0x00040000)>>18)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields rsif_ss_fpbuff_timeout_intr_rxprt1	 */
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT10_WIDTH                             1
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT10_SHIFT                            17
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT10_MASK                     0x00020000
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT10_RD(src)  (((src) & 0x00020000)>>17)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields rsif_ss_axi_wrerr_intr_rxprt1	 */
#define RSIF_SS_AXI_WRERR_INTR_RXPRT10_WIDTH                                  1
#define RSIF_SS_AXI_WRERR_INTR_RXPRT10_SHIFT                                 16
#define RSIF_SS_AXI_WRERR_INTR_RXPRT10_MASK                          0x00010000
#define RSIF_SS_AXI_WRERR_INTR_RXPRT10_RD(src)       (((src) & 0x00010000)>>16)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT10_WR(src)  (((u32)(src)<<16) & 0x00010000)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields rsif_ss_lllength_gt_256_intr_rxprt0	 */
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT00_WIDTH                            1
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT00_SHIFT                            6
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT00_MASK                    0x00000040
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT00_RD(src)  (((src) & 0x00000040)>>6)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields rsif_ss_fpbuff_invld_enc_intr_rxprt0	 */
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT00_WIDTH                           1
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT00_SHIFT                           5
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT00_MASK                   0x00000020
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT00_RD(src) \
                                                     (((src) & 0x00000020)>>5)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields rsif_ss_mirrorerr_intr_rxprt0	 */
#define RSIF_SS_MIRRORERR_INTR_RXPRT00_WIDTH                                  1
#define RSIF_SS_MIRRORERR_INTR_RXPRT00_SHIFT                                  4
#define RSIF_SS_MIRRORERR_INTR_RXPRT00_MASK                          0x00000010
#define RSIF_SS_MIRRORERR_INTR_RXPRT00_RD(src)        (((src) & 0x00000010)>>4)
#define RSIF_SS_MIRRORERR_INTR_RXPRT00_WR(src)   (((u32)(src)<<4) & 0x00000010)
#define RSIF_SS_MIRRORERR_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields rsif_ss_split_boundary_intr_rxprt0	 */
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT00_WIDTH                             1
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT00_SHIFT                             3
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT00_MASK                     0x00000008
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT00_RD(src)   (((src) & 0x00000008)>>3)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields rsif_ss_fpbuff_timeout_intr_rxprt0	 */
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT00_WIDTH                             1
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT00_SHIFT                             2
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT00_MASK                     0x00000004
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT00_RD(src)   (((src) & 0x00000004)>>2)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT00_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rsif_ss_axi_wrerr_intr_rxprt0	 */
#define RSIF_SS_AXI_WRERR_INTR_RXPRT00_WIDTH                                  1
#define RSIF_SS_AXI_WRERR_INTR_RXPRT00_SHIFT                                  1
#define RSIF_SS_AXI_WRERR_INTR_RXPRT00_MASK                          0x00000002
#define RSIF_SS_AXI_WRERR_INTR_RXPRT00_RD(src)        (((src) & 0x00000002)>>1)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT00_WR(src)   (((u32)(src)<<1) & 0x00000002)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields sts_rsif_plc_drop	 */
#define STS_RSIF_PLC_DROP0_WIDTH                                              1
#define STS_RSIF_PLC_DROP0_SHIFT                                              0
#define STS_RSIF_PLC_DROP0_MASK                                      0x00000001
#define STS_RSIF_PLC_DROP0_RD(src)                       (((src) & 0x00000001))
#define STS_RSIF_PLC_DROP0_WR(src)                  (((u32)(src)) & 0x00000001)
#define STS_RSIF_PLC_DROP0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_FInt_Reg0Mask	*/
/*    Mask Register Fields rsif_ss_lllength_gt_256_intr_rxprt1Mask    */
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT1MASK_WIDTH                         1
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT1MASK_SHIFT                        21
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT1MASK_MASK                 0x00200000
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields rsif_ss_fpbuff_invld_enc_intr_rxprt1Mask    */
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT1MASK_WIDTH                        1
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT1MASK_SHIFT                       20
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT1MASK_MASK                0x00100000
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields rsif_ss_mirrorerr_intr_rxprt1Mask    */
#define RSIF_SS_MIRRORERR_INTR_RXPRT1MASK_WIDTH                               1
#define RSIF_SS_MIRRORERR_INTR_RXPRT1MASK_SHIFT                              19
#define RSIF_SS_MIRRORERR_INTR_RXPRT1MASK_MASK                       0x00080000
#define RSIF_SS_MIRRORERR_INTR_RXPRT1MASK_RD(src)    (((src) & 0x00080000)>>19)
#define RSIF_SS_MIRRORERR_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define RSIF_SS_MIRRORERR_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields rsif_ss_split_boundary_intr_rxprt1Mask    */
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT1MASK_WIDTH                          1
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT1MASK_SHIFT                         18
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT1MASK_MASK                  0x00040000
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00040000)>>18)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields rsif_ss_fpbuff_timeout_intr_rxprt1Mask    */
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT1MASK_WIDTH                          1
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT1MASK_SHIFT                         17
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT1MASK_MASK                  0x00020000
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields rsif_ss_axi_wrerr_intr_rxprt1Mask    */
#define RSIF_SS_AXI_WRERR_INTR_RXPRT1MASK_WIDTH                               1
#define RSIF_SS_AXI_WRERR_INTR_RXPRT1MASK_SHIFT                              16
#define RSIF_SS_AXI_WRERR_INTR_RXPRT1MASK_MASK                       0x00010000
#define RSIF_SS_AXI_WRERR_INTR_RXPRT1MASK_RD(src)    (((src) & 0x00010000)>>16)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields rsif_ss_lllength_gt_256_intr_rxprt0Mask    */
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT0MASK_WIDTH                         1
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT0MASK_SHIFT                         6
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT0MASK_MASK                 0x00000040
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000040)>>6)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define RSIF_SS_LLLENGTH_GT_256_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields rsif_ss_fpbuff_invld_enc_intr_rxprt0Mask    */
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT0MASK_WIDTH                        1
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT0MASK_SHIFT                        5
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT0MASK_MASK                0x00000020
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000020)>>5)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define RSIF_SS_FPBUFF_INVLD_ENC_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields rsif_ss_mirrorerr_intr_rxprt0Mask    */
#define RSIF_SS_MIRRORERR_INTR_RXPRT0MASK_WIDTH                               1
#define RSIF_SS_MIRRORERR_INTR_RXPRT0MASK_SHIFT                               4
#define RSIF_SS_MIRRORERR_INTR_RXPRT0MASK_MASK                       0x00000010
#define RSIF_SS_MIRRORERR_INTR_RXPRT0MASK_RD(src)     (((src) & 0x00000010)>>4)
#define RSIF_SS_MIRRORERR_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define RSIF_SS_MIRRORERR_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields rsif_ss_split_boundary_intr_rxprt0Mask    */
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT0MASK_WIDTH                          1
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT0MASK_SHIFT                          3
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT0MASK_MASK                  0x00000008
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000008)>>3)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define RSIF_SS_SPLIT_BOUNDARY_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields rsif_ss_fpbuff_timeout_intr_rxprt0Mask    */
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT0MASK_WIDTH                          1
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT0MASK_SHIFT                          2
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT0MASK_MASK                  0x00000004
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000004)>>2)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define RSIF_SS_FPBUFF_TIMEOUT_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields rsif_ss_axi_wrerr_intr_rxprt0Mask    */
#define RSIF_SS_AXI_WRERR_INTR_RXPRT0MASK_WIDTH                               1
#define RSIF_SS_AXI_WRERR_INTR_RXPRT0MASK_SHIFT                               1
#define RSIF_SS_AXI_WRERR_INTR_RXPRT0MASK_MASK                       0x00000002
#define RSIF_SS_AXI_WRERR_INTR_RXPRT0MASK_RD(src)     (((src) & 0x00000002)>>1)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define RSIF_SS_AXI_WRERR_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields sts_rsif_plc_dropMask    */
#define STS_RSIF_PLC_DROPMASK_WIDTH                                           1
#define STS_RSIF_PLC_DROPMASK_SHIFT                                           0
#define STS_RSIF_PLC_DROPMASK_MASK                                   0x00000001
#define STS_RSIF_PLC_DROPMASK_RD(src)                    (((src) & 0x00000001))
#define STS_RSIF_PLC_DROPMASK_WR(src)               (((u32)(src)) & 0x00000001)
#define STS_RSIF_PLC_DROPMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_Sts_Reg0	*/ 
/*	 Fields rsif_ss_axi_wrerr_bresp_rxprt1	 */
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT10_WIDTH                                 2
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT10_SHIFT                                16
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT10_MASK                         0x00030000
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT10_RD(src)      (((src) & 0x00030000)>>16)
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00030000) | (((u32)(src)<<16) & 0x00030000))
/*	 Fields rsif_ss_axi_wrerr_bresp_rxprt0	 */
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT00_WIDTH                                 2
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT00_SHIFT                                 0
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT00_MASK                         0x00000003
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT00_RD(src)          (((src) & 0x00000003))
#define RSIF_SS_AXI_WRERR_BRESP_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register RSIF_H0_0	*/ 
/*	 Fields info	 */
#define INFO0_WIDTH                                                          32
#define INFO0_SHIFT                                                           0
#define INFO0_MASK                                                   0xffffffff
#define INFO0_RD(src)                                    (((src) & 0xffffffff))
#define INFO0_WR(src)                               (((u32)(src)) & 0xffffffff)
#define INFO0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_H0_1	*/ 
/*	 Fields info	 */
#define INFO1_WIDTH                                                          10
#define INFO1_SHIFT                                                           0
#define INFO1_MASK                                                   0x000003ff
#define INFO1_RD(src)                                    (((src) & 0x000003ff))
#define INFO1_WR(src)                               (((u32)(src)) & 0x000003ff)
#define INFO1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register RSIF_H1_0	*/ 
/*	 Fields info	 */
#define INFO0_F1_WIDTH                                                       32
#define INFO0_F1_SHIFT                                                        0
#define INFO0_F1_MASK                                                0xffffffff
#define INFO0_F1_RD(src)                                 (((src) & 0xffffffff))
#define INFO0_F1_WR(src)                            (((u32)(src)) & 0xffffffff)
#define INFO0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_H1_1	*/ 
/*	 Fields enable	 */
#define ENET_ENABLE1_WIDTH                                                 1
#define ENET_ENABLE1_SHIFT                                                16
#define ENET_ENABLE1_MASK                                         0x00010000
#define ENET_ENABLE1_RD(src)                      (((src) & 0x00010000)>>16)
#define ENET_ENABLE1_WR(src)                 (((u32)(src)<<16) & 0x00010000)
#define ENET_ENABLE1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields info	 */
#define INFO1_F1_WIDTH                                                       10
#define INFO1_F1_SHIFT                                                        0
#define INFO1_F1_MASK                                                0x000003ff
#define INFO1_F1_RD(src)                                 (((src) & 0x000003ff))
#define INFO1_F1_WR(src)                            (((u32)(src)) & 0x000003ff)
#define INFO1_F1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register RSIF_FPbuff_Timeout_StsReg0	*/ 
/*	 Fields sts_rsif_fpbuff_timeout_dropcnt	 */
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_DROPCNT0_WIDTH                       32
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_DROPCNT0_SHIFT                        0
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_DROPCNT0_MASK                0xffffffff
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_DROPCNT0_RD(src) \
                                                        (((src) & 0xffffffff))
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_DROPCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_FPbuff_Timeout_PartialDrop_StsReg0	*/ 
/*	 Fields sts_rsif_fpbuff_timeout_partial_dropcnt	 */
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_PARTIAL_DROPCNT0_WIDTH               32
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_PARTIAL_DROPCNT0_SHIFT                0
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_PARTIAL_DROPCNT0_MASK        0xffffffff
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_PARTIAL_DROPCNT0_RD(src) \
                                                        (((src) & 0xffffffff))
#define ENET_STS_RSIF_FPBUFF_TIMEOUT_PARTIAL_DROPCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_FPbuff_Mirror_Timeout_StsReg0	*/ 
/*	 Fields sts_rsif_fpbuff_mirror_timeout_dropcnt	 */
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_DROPCNT0_WIDTH                32
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_DROPCNT0_SHIFT                 0
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_DROPCNT0_MASK         0xffffffff
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_DROPCNT0_RD(src) \
                                                        (((src) & 0xffffffff))
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_DROPCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_FPbuff_Mirror_Timeout_PartialDrop_StsReg0	*/ 
/*	 Fields sts_rsif_fpbuff_mirror_timeout_partial_dropcnt	 */
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIAL_DROPCNT0_WIDTH        32
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIAL_DROPCNT0_SHIFT                                                                       0
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIAL_DROPCNT0_MASK 0xffffffff
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIAL_DROPCNT0_RD(src) \
                                                        (((src) & 0xffffffff))
#define ENET_STS_RSIF_FPBUFF_MIRROR_TIMEOUT_PARTIAL_DROPCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Mirror_Err_StsReg0	*/ 
/*	 Fields sts_rsif_mirrorerr_dropcnt	 */
#define ENET_STS_RSIF_MIRRORERR_DROPCNT0_WIDTH                            32
#define ENET_STS_RSIF_MIRRORERR_DROPCNT0_SHIFT                             0
#define ENET_STS_RSIF_MIRRORERR_DROPCNT0_MASK                     0xffffffff
#define ENET_STS_RSIF_MIRRORERR_DROPCNT0_RD(src)      (((src) & 0xffffffff))
#define ENET_STS_RSIF_MIRRORERR_DROPCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Sts_Cntr_Reg0	*/ 
/*	 Fields sts_rsif_mirror_pkt_cntr_prt0	 */
#define STS_RSIF_MIRROR_PKT_CNTR_PRT00_WIDTH                                 16
#define STS_RSIF_MIRROR_PKT_CNTR_PRT00_SHIFT                                 16
#define STS_RSIF_MIRROR_PKT_CNTR_PRT00_MASK                          0xffff0000
#define STS_RSIF_MIRROR_PKT_CNTR_PRT00_RD(src)       (((src) & 0xffff0000)>>16)
#define STS_RSIF_MIRROR_PKT_CNTR_PRT00_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields sts_rsif_pkt_cntr_prt0	 */
#define STS_RSIF_PKT_CNTR_PRT00_WIDTH                                        16
#define STS_RSIF_PKT_CNTR_PRT00_SHIFT                                         0
#define STS_RSIF_PKT_CNTR_PRT00_MASK                                 0x0000ffff
#define STS_RSIF_PKT_CNTR_PRT00_RD(src)                  (((src) & 0x0000ffff))
#define STS_RSIF_PKT_CNTR_PRT00_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RSIF_Sts_Cntr_Reg1	*/ 
/*	 Fields sts_rsif_mirror_pkt_cntr_prt1	 */
#define STS_RSIF_MIRROR_PKT_CNTR_PRT11_WIDTH                                 16
#define STS_RSIF_MIRROR_PKT_CNTR_PRT11_SHIFT                                 16
#define STS_RSIF_MIRROR_PKT_CNTR_PRT11_MASK                          0xffff0000
#define STS_RSIF_MIRROR_PKT_CNTR_PRT11_RD(src)       (((src) & 0xffff0000)>>16)
#define STS_RSIF_MIRROR_PKT_CNTR_PRT11_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields sts_rsif_pkt_cntr_prt1	 */
#define STS_RSIF_PKT_CNTR_PRT11_WIDTH                                        16
#define STS_RSIF_PKT_CNTR_PRT11_SHIFT                                         0
#define STS_RSIF_PKT_CNTR_PRT11_MASK                                 0x0000ffff
#define STS_RSIF_PKT_CNTR_PRT11_RD(src)                  (((src) & 0x0000ffff))
#define STS_RSIF_PKT_CNTR_PRT11_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RSIF_Sts_Cle_Drop_Cntr_Reg0	*/ 
/*	 Fields sts_rsif_cle_dropcnt_rxprt1	 */
#define STS_RSIF_CLE_DROPCNT_RXPRT10_WIDTH                                   16
#define STS_RSIF_CLE_DROPCNT_RXPRT10_SHIFT                                   16
#define STS_RSIF_CLE_DROPCNT_RXPRT10_MASK                            0xffff0000
#define STS_RSIF_CLE_DROPCNT_RXPRT10_RD(src)         (((src) & 0xffff0000)>>16)
#define STS_RSIF_CLE_DROPCNT_RXPRT10_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields sts_rsif_cle_dropcnt_rxprt0	 */
#define STS_RSIF_CLE_DROPCNT_RXPRT00_WIDTH                                   16
#define STS_RSIF_CLE_DROPCNT_RXPRT00_SHIFT                                    0
#define STS_RSIF_CLE_DROPCNT_RXPRT00_MASK                            0x0000ffff
#define STS_RSIF_CLE_DROPCNT_RXPRT00_RD(src)             (((src) & 0x0000ffff))
#define STS_RSIF_CLE_DROPCNT_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RSIF_LERR_Mask	*/ 
/*	 Fields cfg_rsif_lerr_mask	 */
#define CFG_RSIF_LERR_MASK_WIDTH                                              5
#define CFG_RSIF_LERR_MASK_SHIFT                                              0
#define CFG_RSIF_LERR_MASK_MASK                                      0x0000001f
#define CFG_RSIF_LERR_MASK_RD(src)                       (((src) & 0x0000001f))
#define CFG_RSIF_LERR_MASK_WR(src)                  (((u32)(src)) & 0x0000001f)
#define CFG_RSIF_LERR_MASK_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register RSIF_Int_Reg1	*/ 
/*	 Fields rsif_chksum_cledata_fifo_overfl_intr_rxprt1	 */
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT11_WIDTH                    1
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT11_SHIFT                   17
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT11_MASK            0x00020000
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT11_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT11_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT11_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields rsif_chksum_cledata_fifo_underfl_intr_rxprt1	 */
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT11_WIDTH                   1
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT11_SHIFT                  16
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT11_MASK           0x00010000
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT11_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT11_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT11_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields rsif_chksum_cledata_fifo_overfl_intr_rxprt0	 */
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT01_WIDTH                    1
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT01_SHIFT                    1
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT01_MASK            0x00000002
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT01_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT01_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT01_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields rsif_chksum_cledata_fifo_underfl_intr_rxprt0	 */
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT01_WIDTH                   1
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT01_SHIFT                   0
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT01_MASK           0x00000001
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT01_RD(src) \
                                                        (((src) & 0x00000001))
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT01_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT01_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_Int_Reg1Mask	*/
/*    Mask Register Fields rsif_chksum_cledata_fifo_overfl_intr_rxprt1Mask    */
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                 1
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                17
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT1MASK_MASK         0x00020000
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields rsif_chksum_cledata_fifo_underfl_intr_rxprt1Mask    */
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                1
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT               16
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK        0x00010000
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields rsif_chksum_cledata_fifo_overfl_intr_rxprt0Mask    */
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                 1
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                 1
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT0MASK_MASK         0x00000002
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define RSIF_CHKSUM_CLEDATA_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields rsif_chksum_cledata_fifo_underfl_intr_rxprt0Mask    */
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                1
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                0
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK        0x00000001
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src) \
                                                        (((src) & 0x00000001))
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define RSIF_CHKSUM_CLEDATA_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_FInt_Reg1	*/ 
/*	 Fields plc_dropcnt_gt_threshold_intr	 */
#define PLC_DROPCNT_GT_THRESHOLD_INTR1_WIDTH                                  1
#define PLC_DROPCNT_GT_THRESHOLD_INTR1_SHIFT                                  2
#define PLC_DROPCNT_GT_THRESHOLD_INTR1_MASK                          0x00000004
#define PLC_DROPCNT_GT_THRESHOLD_INTR1_RD(src)        (((src) & 0x00000004)>>2)
#define PLC_DROPCNT_GT_THRESHOLD_INTR1_WR(src)   (((u32)(src)<<2) & 0x00000004)
#define PLC_DROPCNT_GT_THRESHOLD_INTR1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields plc_total_dropcnt_gt_threshold_intr_port1	 */
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT11_WIDTH                      1
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT11_SHIFT                      1
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT11_MASK              0x00000002
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT11_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT11_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT11_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields plc_total_dropcnt_gt_threshold_intr_port0	 */
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT01_WIDTH                      1
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT01_SHIFT                      0
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT01_MASK              0x00000001
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT01_RD(src) \
                                                        (((src) & 0x00000001))
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT01_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT01_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RSIF_FInt_Reg1Mask	*/
/*    Mask Register Fields plc_dropcnt_gt_threshold_intrMask    */
#define PLC_DROPCNT_GT_THRESHOLD_INTRMASK_WIDTH                               1
#define PLC_DROPCNT_GT_THRESHOLD_INTRMASK_SHIFT                               2
#define PLC_DROPCNT_GT_THRESHOLD_INTRMASK_MASK                       0x00000004
#define PLC_DROPCNT_GT_THRESHOLD_INTRMASK_RD(src)     (((src) & 0x00000004)>>2)
#define PLC_DROPCNT_GT_THRESHOLD_INTRMASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define PLC_DROPCNT_GT_THRESHOLD_INTRMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields plc_total_dropcnt_gt_threshold_intr_port1Mask    */
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT1MASK_WIDTH                   1
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT1MASK_SHIFT                   1
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT1MASK_MASK           0x00000002
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT1MASK_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT1MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT1MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields plc_total_dropcnt_gt_threshold_intr_port0Mask    */
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT0MASK_WIDTH                   1
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT0MASK_SHIFT                   0
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT0MASK_MASK           0x00000001
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT0MASK_RD(src) \
                                                        (((src) & 0x00000001))
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT0MASK_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define PLC_TOTAL_DROPCNT_GT_THRESHOLD_INTR_PORT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register Pckwd_StsSofCtrlWd0_0	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA0_WIDTH                                                   32
#define CTRLWD_DATA0_SHIFT                                                    0
#define CTRLWD_DATA0_MASK                                            0xffffffff
#define CTRLWD_DATA0_RD(src)                             (((src) & 0xffffffff))
#define CTRLWD_DATA0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd1_0	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA0_F1_WIDTH                                                32
#define CTRLWD_DATA0_F1_SHIFT                                                 0
#define CTRLWD_DATA0_F1_MASK                                         0xffffffff
#define CTRLWD_DATA0_F1_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd2_0	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA0_F2_WIDTH                                                32
#define CTRLWD_DATA0_F2_SHIFT                                                 0
#define CTRLWD_DATA0_F2_MASK                                         0xffffffff
#define CTRLWD_DATA0_F2_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA0_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd3_0	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA0_F3_WIDTH                                                32
#define CTRLWD_DATA0_F3_SHIFT                                                 0
#define CTRLWD_DATA0_F3_MASK                                         0xffffffff
#define CTRLWD_DATA0_F3_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA0_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsEofCtrlWd_0	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA0_F4_WIDTH                                                32
#define CTRLWD_DATA0_F4_SHIFT                                                 0
#define CTRLWD_DATA0_F4_MASK                                         0xffffffff
#define CTRLWD_DATA0_F4_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA0_F4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd0_1	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA1_WIDTH                                                   32
#define CTRLWD_DATA1_SHIFT                                                    0
#define CTRLWD_DATA1_MASK                                            0xffffffff
#define CTRLWD_DATA1_RD(src)                             (((src) & 0xffffffff))
#define CTRLWD_DATA1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd1_1	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA1_F1_WIDTH                                                32
#define CTRLWD_DATA1_F1_SHIFT                                                 0
#define CTRLWD_DATA1_F1_MASK                                         0xffffffff
#define CTRLWD_DATA1_F1_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd2_1	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA1_F2_WIDTH                                                32
#define CTRLWD_DATA1_F2_SHIFT                                                 0
#define CTRLWD_DATA1_F2_MASK                                         0xffffffff
#define CTRLWD_DATA1_F2_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA1_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsSofCtrlWd3_1	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA1_F3_WIDTH                                                32
#define CTRLWD_DATA1_F3_SHIFT                                                 0
#define CTRLWD_DATA1_F3_MASK                                         0xffffffff
#define CTRLWD_DATA1_F3_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA1_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register Pckwd_StsEofCtrlWd_1	*/ 
/*	 Fields ctrlwd_data	 */
#define CTRLWD_DATA1_F4_WIDTH                                                32
#define CTRLWD_DATA1_F4_SHIFT                                                 0
#define CTRLWD_DATA1_F4_MASK                                         0xffffffff
#define CTRLWD_DATA1_F4_RD(src)                          (((src) & 0xffffffff))
#define CTRLWD_DATA1_F4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register LCLRxBuf_Config_Thresh_Reg_0	*/ 
/*	 Fields cfg_lclrxbuf_full_thresh	 */
#define CFG_LCLRXBUF_FULL_THRESH0_WIDTH                                       8
#define CFG_LCLRXBUF_FULL_THRESH0_SHIFT                                      16
#define CFG_LCLRXBUF_FULL_THRESH0_MASK                               0x00ff0000
#define CFG_LCLRXBUF_FULL_THRESH0_RD(src)            (((src) & 0x00ff0000)>>16)
#define CFG_LCLRXBUF_FULL_THRESH0_WR(src)       (((u32)(src)<<16) & 0x00ff0000)
#define CFG_LCLRXBUF_FULL_THRESH0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_lclrxbuf_rlevelcnt_full_thresh	 */
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH0_WIDTH                             8
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH0_SHIFT                             0
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH0_MASK                     0x000000ff
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH0_RD(src)      (((src) & 0x000000ff))
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH0_WR(src) \
                                                    (((u32)(src)) & 0x000000ff)
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register LCLRxBuf_Config_Port_Depth_Reg_0	*/ 
/*	 Fields cfg_lclrxbuf_ramdepth	 */
#define CFG_LCLRXBUF_RAMDEPTH0_WIDTH                                          8
#define CFG_LCLRXBUF_RAMDEPTH0_SHIFT                                          0
#define CFG_LCLRXBUF_RAMDEPTH0_MASK                                  0x000000ff
#define CFG_LCLRXBUF_RAMDEPTH0_RD(src)                   (((src) & 0x000000ff))
#define CFG_LCLRXBUF_RAMDEPTH0_WR(src)              (((u32)(src)) & 0x000000ff)
#define CFG_LCLRXBUF_RAMDEPTH0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register LCLRxBuf_Config_Thresh_Reg_1	*/ 
/*	 Fields cfg_lclrxbuf_full_thresh	 */
#define CFG_LCLRXBUF_FULL_THRESH1_WIDTH                                       8
#define CFG_LCLRXBUF_FULL_THRESH1_SHIFT                                      16
#define CFG_LCLRXBUF_FULL_THRESH1_MASK                               0x00ff0000
#define CFG_LCLRXBUF_FULL_THRESH1_RD(src)            (((src) & 0x00ff0000)>>16)
#define CFG_LCLRXBUF_FULL_THRESH1_WR(src)       (((u32)(src)<<16) & 0x00ff0000)
#define CFG_LCLRXBUF_FULL_THRESH1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_lclrxbuf_rlevelcnt_full_thresh	 */
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH1_WIDTH                             8
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH1_SHIFT                             0
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH1_MASK                     0x000000ff
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH1_RD(src)      (((src) & 0x000000ff))
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH1_WR(src) \
                                                    (((u32)(src)) & 0x000000ff)
#define CFG_LCLRXBUF_RLEVELCNT_FULL_THRESH1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register LCLRxBuf_Config_Port_Depth_Reg_1	*/ 
/*	 Fields cfg_lclrxbuf_ramdepth	 */
#define CFG_LCLRXBUF_RAMDEPTH1_WIDTH                                          8
#define CFG_LCLRXBUF_RAMDEPTH1_SHIFT                                          0
#define CFG_LCLRXBUF_RAMDEPTH1_MASK                                  0x000000ff
#define CFG_LCLRXBUF_RAMDEPTH1_RD(src)                   (((src) & 0x000000ff))
#define CFG_LCLRXBUF_RAMDEPTH1_WR(src)              (((u32)(src)) & 0x000000ff)
#define CFG_LCLRXBUF_RAMDEPTH1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register RSIF_Policer_ColorEnc0	*/ 
/*	 Fields cfg_rsif_plc_pkt_color_enc0	 */
#define CFG_RSIF_PLC_PKT_COLOR_ENC00_WIDTH                                   32
#define CFG_RSIF_PLC_PKT_COLOR_ENC00_SHIFT                                    0
#define CFG_RSIF_PLC_PKT_COLOR_ENC00_MASK                            0xffffffff
#define CFG_RSIF_PLC_PKT_COLOR_ENC00_RD(src)             (((src) & 0xffffffff))
#define CFG_RSIF_PLC_PKT_COLOR_ENC00_WR(src)        (((u32)(src)) & 0xffffffff)
#define CFG_RSIF_PLC_PKT_COLOR_ENC00_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_ColorEnc1	*/ 
/*	 Fields cfg_rsif_plc_pkt_color_enc1	 */
#define CFG_RSIF_PLC_PKT_COLOR_ENC11_WIDTH                                   32
#define CFG_RSIF_PLC_PKT_COLOR_ENC11_SHIFT                                    0
#define CFG_RSIF_PLC_PKT_COLOR_ENC11_MASK                            0xffffffff
#define CFG_RSIF_PLC_PKT_COLOR_ENC11_RD(src)             (((src) & 0xffffffff))
#define CFG_RSIF_PLC_PKT_COLOR_ENC11_WR(src)        (((u32)(src)) & 0xffffffff)
#define CFG_RSIF_PLC_PKT_COLOR_ENC11_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_ColorEnc2	*/ 
/*	 Fields cfg_rsif_plc_pkt_color_enc2	 */
#define CFG_RSIF_PLC_PKT_COLOR_ENC22_WIDTH                                   32
#define CFG_RSIF_PLC_PKT_COLOR_ENC22_SHIFT                                    0
#define CFG_RSIF_PLC_PKT_COLOR_ENC22_MASK                            0xffffffff
#define CFG_RSIF_PLC_PKT_COLOR_ENC22_RD(src)             (((src) & 0xffffffff))
#define CFG_RSIF_PLC_PKT_COLOR_ENC22_WR(src)        (((u32)(src)) & 0xffffffff)
#define CFG_RSIF_PLC_PKT_COLOR_ENC22_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RSIF_Policer_ColorEnc3	*/ 
/*	 Fields cfg_rsif_plc_pkt_color_enc3	 */
#define CFG_RSIF_PLC_PKT_COLOR_ENC33_WIDTH                                   32
#define CFG_RSIF_PLC_PKT_COLOR_ENC33_SHIFT                                    0
#define CFG_RSIF_PLC_PKT_COLOR_ENC33_MASK                            0xffffffff
#define CFG_RSIF_PLC_PKT_COLOR_ENC33_RD(src)             (((src) & 0xffffffff))
#define CFG_RSIF_PLC_PKT_COLOR_ENC33_WR(src)        (((u32)(src)) & 0xffffffff)
#define CFG_RSIF_PLC_PKT_COLOR_ENC33_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register TSIF_Config_Reg_0	*/ 
/*	 Fields cfg_tsif_vc	 */
#define CFG_TSIF_VC0_WIDTH                                                    2
#define CFG_TSIF_VC0_SHIFT                                                   18
#define CFG_TSIF_VC0_MASK                                            0x000c0000
#define CFG_TSIF_VC0_RD(src)                         (((src) & 0x000c0000)>>18)
#define CFG_TSIF_VC0_WR(src)                    (((u32)(src)<<18) & 0x000c0000)
#define CFG_TSIF_VC0_SET(dst,src) \
                      (((dst) & ~0x000c0000) | (((u32)(src)<<18) & 0x000c0000))
/*	 Fields cfg_tsif_insert_error_pattern	 */
#define CFG_TSIF_INSERT_ERROR_PATTERN0_WIDTH                                  1
#define CFG_TSIF_INSERT_ERROR_PATTERN0_SHIFT                                 17
#define CFG_TSIF_INSERT_ERROR_PATTERN0_MASK                          0x00020000
#define CFG_TSIF_INSERT_ERROR_PATTERN0_RD(src)       (((src) & 0x00020000)>>17)
#define CFG_TSIF_INSERT_ERROR_PATTERN0_WR(src)  (((u32)(src)<<17) & 0x00020000)
#define CFG_TSIF_INSERT_ERROR_PATTERN0_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_tsif_insert_error	 */
#define CFG_TSIF_INSERT_ERROR0_WIDTH                                          1
#define CFG_TSIF_INSERT_ERROR0_SHIFT                                         16
#define CFG_TSIF_INSERT_ERROR0_MASK                                  0x00010000
#define CFG_TSIF_INSERT_ERROR0_RD(src)               (((src) & 0x00010000)>>16)
#define CFG_TSIF_INSERT_ERROR0_WR(src)          (((u32)(src)<<16) & 0x00010000)
#define CFG_TSIF_INSERT_ERROR0_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_tsif_cle_insert_domainid	 */
#define CFG_TSIF_CLE_INSERT_DOMAINID0_WIDTH                                   1
#define CFG_TSIF_CLE_INSERT_DOMAINID0_SHIFT                                  15
#define CFG_TSIF_CLE_INSERT_DOMAINID0_MASK                           0x00008000
#define CFG_TSIF_CLE_INSERT_DOMAINID0_RD(src)        (((src) & 0x00008000)>>15)
#define CFG_TSIF_CLE_INSERT_DOMAINID0_WR(src)   (((u32)(src)<<15) & 0x00008000)
#define CFG_TSIF_CLE_INSERT_DOMAINID0_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields cfg_tsif_enet	 */
#define CFG_TSIF_ENET0_WIDTH                                                  1
#define CFG_TSIF_ENET0_SHIFT                                                 14
#define CFG_TSIF_ENET0_MASK                                          0x00004000
#define CFG_TSIF_ENET0_RD(src)                       (((src) & 0x00004000)>>14)
#define CFG_TSIF_ENET0_WR(src)                  (((u32)(src)<<14) & 0x00004000)
#define CFG_TSIF_ENET0_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields cfg_tsif_cle	 */
#define CFG_TSIF_CLE0_WIDTH                                                   1
#define CFG_TSIF_CLE0_SHIFT                                                  13
#define CFG_TSIF_CLE0_MASK                                           0x00002000
#define CFG_TSIF_CLE0_RD(src)                        (((src) & 0x00002000)>>13)
#define CFG_TSIF_CLE0_WR(src)                   (((u32)(src)<<13) & 0x00002000)
#define CFG_TSIF_CLE0_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields cfg_tsif_ctm	 */
#define CFG_TSIF_CTM0_WIDTH                                                   1
#define CFG_TSIF_CTM0_SHIFT                                                  12
#define CFG_TSIF_CTM0_MASK                                           0x00001000
#define CFG_TSIF_CTM0_RD(src)                        (((src) & 0x00001000)>>12)
#define CFG_TSIF_CTM0_WR(src)                   (((u32)(src)<<12) & 0x00001000)
#define CFG_TSIF_CTM0_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields cfg_tsif_dealloc_wmsg	 */
#define CFG_TSIF_DEALLOC_WMSG0_WIDTH                                          1
#define CFG_TSIF_DEALLOC_WMSG0_SHIFT                                         11
#define CFG_TSIF_DEALLOC_WMSG0_MASK                                  0x00000800
#define CFG_TSIF_DEALLOC_WMSG0_RD(src)               (((src) & 0x00000800)>>11)
#define CFG_TSIF_DEALLOC_WMSG0_WR(src)          (((u32)(src)<<11) & 0x00000800)
#define CFG_TSIF_DEALLOC_WMSG0_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_tsif_cmsg_wmsg	 */
#define CFG_TSIF_CMSG_WMSG0_WIDTH                                             1
#define CFG_TSIF_CMSG_WMSG0_SHIFT                                            10
#define CFG_TSIF_CMSG_WMSG0_MASK                                     0x00000400
#define CFG_TSIF_CMSG_WMSG0_RD(src)                  (((src) & 0x00000400)>>10)
#define CFG_TSIF_CMSG_WMSG0_WR(src)             (((u32)(src)<<10) & 0x00000400)
#define CFG_TSIF_CMSG_WMSG0_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_tsif_big_endian	 */
#define CFG_TSIF_BIG_ENDIAN0_WIDTH                                            1
#define CFG_TSIF_BIG_ENDIAN0_SHIFT                                            9
#define CFG_TSIF_BIG_ENDIAN0_MASK                                    0x00000200
#define CFG_TSIF_BIG_ENDIAN0_RD(src)                  (((src) & 0x00000200)>>9)
#define CFG_TSIF_BIG_ENDIAN0_WR(src)             (((u32)(src)<<9) & 0x00000200)
#define CFG_TSIF_BIG_ENDIAN0_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_tsif_wmsg_swap	 */
#define CFG_TSIF_WMSG_SWAP0_WIDTH                                             1
#define CFG_TSIF_WMSG_SWAP0_SHIFT                                             8
#define CFG_TSIF_WMSG_SWAP0_MASK                                     0x00000100
#define CFG_TSIF_WMSG_SWAP0_RD(src)                   (((src) & 0x00000100)>>8)
#define CFG_TSIF_WMSG_SWAP0_WR(src)              (((u32)(src)<<8) & 0x00000100)
#define CFG_TSIF_WMSG_SWAP0_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_tsif_rrm_threshold	 */
#define CFG_TSIF_RRM_THRESHOLD0_WIDTH                                         4
#define CFG_TSIF_RRM_THRESHOLD0_SHIFT                                         4
#define CFG_TSIF_RRM_THRESHOLD0_MASK                                 0x000000f0
#define CFG_TSIF_RRM_THRESHOLD0_RD(src)               (((src) & 0x000000f0)>>4)
#define CFG_TSIF_RRM_THRESHOLD0_WR(src)          (((u32)(src)<<4) & 0x000000f0)
#define CFG_TSIF_RRM_THRESHOLD0_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_tsif_rdm_threshold	 */
#define CFG_TSIF_RDM_THRESHOLD0_WIDTH                                         4
#define CFG_TSIF_RDM_THRESHOLD0_SHIFT                                         0
#define CFG_TSIF_RDM_THRESHOLD0_MASK                                 0x0000000f
#define CFG_TSIF_RDM_THRESHOLD0_RD(src)                  (((src) & 0x0000000f))
#define CFG_TSIF_RDM_THRESHOLD0_WR(src)             (((u32)(src)) & 0x0000000f)
#define CFG_TSIF_RDM_THRESHOLD0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register TSIF_Config_Reg_1	*/ 
/*	 Fields cfg_tsif_vc	 */
#define CFG_TSIF_VC1_WIDTH                                                    2
#define CFG_TSIF_VC1_SHIFT                                                   18
#define CFG_TSIF_VC1_MASK                                            0x000c0000
#define CFG_TSIF_VC1_RD(src)                         (((src) & 0x000c0000)>>18)
#define CFG_TSIF_VC1_WR(src)                    (((u32)(src)<<18) & 0x000c0000)
#define CFG_TSIF_VC1_SET(dst,src) \
                      (((dst) & ~0x000c0000) | (((u32)(src)<<18) & 0x000c0000))
/*	 Fields cfg_tsif_insert_error_pattern	 */
#define CFG_TSIF_INSERT_ERROR_PATTERN1_WIDTH                                  1
#define CFG_TSIF_INSERT_ERROR_PATTERN1_SHIFT                                 17
#define CFG_TSIF_INSERT_ERROR_PATTERN1_MASK                          0x00020000
#define CFG_TSIF_INSERT_ERROR_PATTERN1_RD(src)       (((src) & 0x00020000)>>17)
#define CFG_TSIF_INSERT_ERROR_PATTERN1_WR(src)  (((u32)(src)<<17) & 0x00020000)
#define CFG_TSIF_INSERT_ERROR_PATTERN1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_tsif_insert_error	 */
#define CFG_TSIF_INSERT_ERROR1_WIDTH                                          1
#define CFG_TSIF_INSERT_ERROR1_SHIFT                                         16
#define CFG_TSIF_INSERT_ERROR1_MASK                                  0x00010000
#define CFG_TSIF_INSERT_ERROR1_RD(src)               (((src) & 0x00010000)>>16)
#define CFG_TSIF_INSERT_ERROR1_WR(src)          (((u32)(src)<<16) & 0x00010000)
#define CFG_TSIF_INSERT_ERROR1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_tsif_cle_insert_domainid	 */
#define CFG_TSIF_CLE_INSERT_DOMAINID1_WIDTH                                   1
#define CFG_TSIF_CLE_INSERT_DOMAINID1_SHIFT                                  15
#define CFG_TSIF_CLE_INSERT_DOMAINID1_MASK                           0x00008000
#define CFG_TSIF_CLE_INSERT_DOMAINID1_RD(src)        (((src) & 0x00008000)>>15)
#define CFG_TSIF_CLE_INSERT_DOMAINID1_WR(src)   (((u32)(src)<<15) & 0x00008000)
#define CFG_TSIF_CLE_INSERT_DOMAINID1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields cfg_tsif_enet	 */
#define CFG_TSIF_ENET1_WIDTH                                                  1
#define CFG_TSIF_ENET1_SHIFT                                                 14
#define CFG_TSIF_ENET1_MASK                                          0x00004000
#define CFG_TSIF_ENET1_RD(src)                       (((src) & 0x00004000)>>14)
#define CFG_TSIF_ENET1_WR(src)                  (((u32)(src)<<14) & 0x00004000)
#define CFG_TSIF_ENET1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields cfg_tsif_cle	 */
#define CFG_TSIF_CLE1_WIDTH                                                   1
#define CFG_TSIF_CLE1_SHIFT                                                  13
#define CFG_TSIF_CLE1_MASK                                           0x00002000
#define CFG_TSIF_CLE1_RD(src)                        (((src) & 0x00002000)>>13)
#define CFG_TSIF_CLE1_WR(src)                   (((u32)(src)<<13) & 0x00002000)
#define CFG_TSIF_CLE1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields cfg_tsif_ctm	 */
#define CFG_TSIF_CTM1_WIDTH                                                   1
#define CFG_TSIF_CTM1_SHIFT                                                  12
#define CFG_TSIF_CTM1_MASK                                           0x00001000
#define CFG_TSIF_CTM1_RD(src)                        (((src) & 0x00001000)>>12)
#define CFG_TSIF_CTM1_WR(src)                   (((u32)(src)<<12) & 0x00001000)
#define CFG_TSIF_CTM1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields cfg_tsif_dealloc_wmsg	 */
#define CFG_TSIF_DEALLOC_WMSG1_WIDTH                                          1
#define CFG_TSIF_DEALLOC_WMSG1_SHIFT                                         11
#define CFG_TSIF_DEALLOC_WMSG1_MASK                                  0x00000800
#define CFG_TSIF_DEALLOC_WMSG1_RD(src)               (((src) & 0x00000800)>>11)
#define CFG_TSIF_DEALLOC_WMSG1_WR(src)          (((u32)(src)<<11) & 0x00000800)
#define CFG_TSIF_DEALLOC_WMSG1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_tsif_cmsg_wmsg	 */
#define CFG_TSIF_CMSG_WMSG1_WIDTH                                             1
#define CFG_TSIF_CMSG_WMSG1_SHIFT                                            10
#define CFG_TSIF_CMSG_WMSG1_MASK                                     0x00000400
#define CFG_TSIF_CMSG_WMSG1_RD(src)                  (((src) & 0x00000400)>>10)
#define CFG_TSIF_CMSG_WMSG1_WR(src)             (((u32)(src)<<10) & 0x00000400)
#define CFG_TSIF_CMSG_WMSG1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_tsif_big_endian	 */
#define CFG_TSIF_BIG_ENDIAN1_WIDTH                                            1
#define CFG_TSIF_BIG_ENDIAN1_SHIFT                                            9
#define CFG_TSIF_BIG_ENDIAN1_MASK                                    0x00000200
#define CFG_TSIF_BIG_ENDIAN1_RD(src)                  (((src) & 0x00000200)>>9)
#define CFG_TSIF_BIG_ENDIAN1_WR(src)             (((u32)(src)<<9) & 0x00000200)
#define CFG_TSIF_BIG_ENDIAN1_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_tsif_wmsg_swap	 */
#define CFG_TSIF_WMSG_SWAP1_WIDTH                                             1
#define CFG_TSIF_WMSG_SWAP1_SHIFT                                             8
#define CFG_TSIF_WMSG_SWAP1_MASK                                     0x00000100
#define CFG_TSIF_WMSG_SWAP1_RD(src)                   (((src) & 0x00000100)>>8)
#define CFG_TSIF_WMSG_SWAP1_WR(src)              (((u32)(src)<<8) & 0x00000100)
#define CFG_TSIF_WMSG_SWAP1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_tsif_rrm_threshold	 */
#define CFG_TSIF_RRM_THRESHOLD1_WIDTH                                         4
#define CFG_TSIF_RRM_THRESHOLD1_SHIFT                                         4
#define CFG_TSIF_RRM_THRESHOLD1_MASK                                 0x000000f0
#define CFG_TSIF_RRM_THRESHOLD1_RD(src)               (((src) & 0x000000f0)>>4)
#define CFG_TSIF_RRM_THRESHOLD1_WR(src)          (((u32)(src)<<4) & 0x000000f0)
#define CFG_TSIF_RRM_THRESHOLD1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_tsif_rdm_threshold	 */
#define CFG_TSIF_RDM_THRESHOLD1_WIDTH                                         4
#define CFG_TSIF_RDM_THRESHOLD1_SHIFT                                         0
#define CFG_TSIF_RDM_THRESHOLD1_MASK                                 0x0000000f
#define CFG_TSIF_RDM_THRESHOLD1_RD(src)                  (((src) & 0x0000000f))
#define CFG_TSIF_RDM_THRESHOLD1_WR(src)             (((u32)(src)) & 0x0000000f)
#define CFG_TSIF_RDM_THRESHOLD1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register TSIF_MSS_Reg0_0	*/ 
/*	 Fields cfg_tsif_mss_sz1	 */
#define CFG_TSIF_MSS_SZ10_WIDTH                                              14
#define CFG_TSIF_MSS_SZ10_SHIFT                                              16
#define CFG_TSIF_MSS_SZ10_MASK                                       0x3fff0000
#define CFG_TSIF_MSS_SZ10_RD(src)                    (((src) & 0x3fff0000)>>16)
#define CFG_TSIF_MSS_SZ10_WR(src)               (((u32)(src)<<16) & 0x3fff0000)
#define CFG_TSIF_MSS_SZ10_SET(dst,src) \
                      (((dst) & ~0x3fff0000) | (((u32)(src)<<16) & 0x3fff0000))
/*	 Fields cfg_tsif_mss_sz0	 */
#define CFG_TSIF_MSS_SZ00_WIDTH                                              14
#define CFG_TSIF_MSS_SZ00_SHIFT                                               0
#define CFG_TSIF_MSS_SZ00_MASK                                       0x00003fff
#define CFG_TSIF_MSS_SZ00_RD(src)                        (((src) & 0x00003fff))
#define CFG_TSIF_MSS_SZ00_WR(src)                   (((u32)(src)) & 0x00003fff)
#define CFG_TSIF_MSS_SZ00_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register TSIF_MSS_Reg0_1	*/ 
/*	 Fields cfg_tsif_mss_sz1	 */
#define CFG_TSIF_MSS_SZ11_WIDTH                                              14
#define CFG_TSIF_MSS_SZ11_SHIFT                                              16
#define CFG_TSIF_MSS_SZ11_MASK                                       0x3fff0000
#define CFG_TSIF_MSS_SZ11_RD(src)                    (((src) & 0x3fff0000)>>16)
#define CFG_TSIF_MSS_SZ11_WR(src)               (((u32)(src)<<16) & 0x3fff0000)
#define CFG_TSIF_MSS_SZ11_SET(dst,src) \
                      (((dst) & ~0x3fff0000) | (((u32)(src)<<16) & 0x3fff0000))
/*	 Fields cfg_tsif_mss_sz0	 */
#define CFG_TSIF_MSS_SZ01_WIDTH                                              14
#define CFG_TSIF_MSS_SZ01_SHIFT                                               0
#define CFG_TSIF_MSS_SZ01_MASK                                       0x00003fff
#define CFG_TSIF_MSS_SZ01_RD(src)                        (((src) & 0x00003fff))
#define CFG_TSIF_MSS_SZ01_WR(src)                   (((u32)(src)) & 0x00003fff)
#define CFG_TSIF_MSS_SZ01_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register TSIF_MSS_Reg1_0	*/ 
/*	 Fields cfg_tsif_mss_sz3	 */
#define CFG_TSIF_MSS_SZ30_WIDTH                                              14
#define CFG_TSIF_MSS_SZ30_SHIFT                                              16
#define CFG_TSIF_MSS_SZ30_MASK                                       0x3fff0000
#define CFG_TSIF_MSS_SZ30_RD(src)                    (((src) & 0x3fff0000)>>16)
#define CFG_TSIF_MSS_SZ30_WR(src)               (((u32)(src)<<16) & 0x3fff0000)
#define CFG_TSIF_MSS_SZ30_SET(dst,src) \
                      (((dst) & ~0x3fff0000) | (((u32)(src)<<16) & 0x3fff0000))
/*	 Fields cfg_tsif_mss_sz2	 */
#define CFG_TSIF_MSS_SZ20_WIDTH                                              14
#define CFG_TSIF_MSS_SZ20_SHIFT                                               0
#define CFG_TSIF_MSS_SZ20_MASK                                       0x00003fff
#define CFG_TSIF_MSS_SZ20_RD(src)                        (((src) & 0x00003fff))
#define CFG_TSIF_MSS_SZ20_WR(src)                   (((u32)(src)) & 0x00003fff)
#define CFG_TSIF_MSS_SZ20_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register TSIF_MSS_Reg1_1	*/ 
/*	 Fields cfg_tsif_mss_sz3	 */
#define CFG_TSIF_MSS_SZ31_WIDTH                                              14
#define CFG_TSIF_MSS_SZ31_SHIFT                                              16
#define CFG_TSIF_MSS_SZ31_MASK                                       0x3fff0000
#define CFG_TSIF_MSS_SZ31_RD(src)                    (((src) & 0x3fff0000)>>16)
#define CFG_TSIF_MSS_SZ31_WR(src)               (((u32)(src)<<16) & 0x3fff0000)
#define CFG_TSIF_MSS_SZ31_SET(dst,src) \
                      (((dst) & ~0x3fff0000) | (((u32)(src)<<16) & 0x3fff0000))
/*	 Fields cfg_tsif_mss_sz2	 */
#define CFG_TSIF_MSS_SZ21_WIDTH                                              14
#define CFG_TSIF_MSS_SZ21_SHIFT                                               0
#define CFG_TSIF_MSS_SZ21_MASK                                       0x00003fff
#define CFG_TSIF_MSS_SZ21_RD(src)                        (((src) & 0x00003fff))
#define CFG_TSIF_MSS_SZ21_WR(src)                   (((u32)(src)) & 0x00003fff)
#define CFG_TSIF_MSS_SZ21_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register TSIF_FIFO_EmptySts0	*/ 
/*	 Fields tsif_rdmbuff_fifo_empty_prt1	 */
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT10_WIDTH                                   1
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT10_SHIFT                                  18
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT10_MASK                           0x00040000
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT10_RD(src)        (((src) & 0x00040000)>>18)
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields tsif_rrm_fifo_empty_prt1	 */
#define TSIF_RRM_FIFO_EMPTY_PRT10_WIDTH                                       1
#define TSIF_RRM_FIFO_EMPTY_PRT10_SHIFT                                      17
#define TSIF_RRM_FIFO_EMPTY_PRT10_MASK                               0x00020000
#define TSIF_RRM_FIFO_EMPTY_PRT10_RD(src)            (((src) & 0x00020000)>>17)
#define TSIF_RRM_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields tsif_amabuf_fifo_empty_prt1	 */
#define TSIF_AMABUF_FIFO_EMPTY_PRT10_WIDTH                                    1
#define TSIF_AMABUF_FIFO_EMPTY_PRT10_SHIFT                                   16
#define TSIF_AMABUF_FIFO_EMPTY_PRT10_MASK                            0x00010000
#define TSIF_AMABUF_FIFO_EMPTY_PRT10_RD(src)         (((src) & 0x00010000)>>16)
#define TSIF_AMABUF_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields tsif_rdmbuff_fifo_empty_prt0	 */
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT00_WIDTH                                   1
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT00_SHIFT                                   2
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT00_MASK                           0x00000004
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT00_RD(src)         (((src) & 0x00000004)>>2)
#define TSIF_RDMBUFF_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields tsif_rrm_fifo_empty_prt0	 */
#define TSIF_RRM_FIFO_EMPTY_PRT00_WIDTH                                       1
#define TSIF_RRM_FIFO_EMPTY_PRT00_SHIFT                                       1
#define TSIF_RRM_FIFO_EMPTY_PRT00_MASK                               0x00000002
#define TSIF_RRM_FIFO_EMPTY_PRT00_RD(src)             (((src) & 0x00000002)>>1)
#define TSIF_RRM_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields tsif_amabuf_fifo_empty_prt0	 */
#define TSIF_AMABUF_FIFO_EMPTY_PRT00_WIDTH                                    1
#define TSIF_AMABUF_FIFO_EMPTY_PRT00_SHIFT                                    0
#define TSIF_AMABUF_FIFO_EMPTY_PRT00_MASK                            0x00000001
#define TSIF_AMABUF_FIFO_EMPTY_PRT00_RD(src)             (((src) & 0x00000001))
#define TSIF_AMABUF_FIFO_EMPTY_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TSIF_Int_Reg0	*/ 
/*	 Fields tsif_rdmbuff_fifo_overfl_intr_prt1	 */
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT10_WIDTH                             1
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT10_SHIFT                            21
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT10_MASK                     0x00200000
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT10_RD(src)  (((src) & 0x00200000)>>21)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields tsif_rdmbuff_fifo_underfl_intr_prt1	 */
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT10_WIDTH                            1
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT10_SHIFT                           20
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT10_MASK                    0x00100000
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT10_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields tsif_rrm_fifo_overfl_intr_prt1	 */
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT10_WIDTH                                 1
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT10_SHIFT                                19
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT10_MASK                         0x00080000
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT10_RD(src)      (((src) & 0x00080000)>>19)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields tsif_rrm_fifo_underfl_intr_prt1	 */
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT10_WIDTH                                1
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT10_SHIFT                               18
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT10_MASK                        0x00040000
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT10_RD(src)     (((src) & 0x00040000)>>18)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields tsif_amabuf_fifo_overfl_intr_prt1	 */
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT10_WIDTH                              1
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT10_SHIFT                             17
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT10_MASK                      0x00020000
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT10_RD(src)   (((src) & 0x00020000)>>17)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields tsif_amabuf_fifo_underfl_intr_prt1	 */
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT10_WIDTH                             1
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT10_SHIFT                            16
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT10_MASK                     0x00010000
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT10_RD(src)  (((src) & 0x00010000)>>16)
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields tsif_rdmbuff_fifo_overfl_intr_prt0	 */
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT00_WIDTH                             1
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT00_SHIFT                             5
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT00_MASK                     0x00000020
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT00_RD(src)   (((src) & 0x00000020)>>5)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields tsif_rdmbuff_fifo_underfl_intr_prt0	 */
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT00_WIDTH                            1
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT00_SHIFT                            4
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT00_MASK                    0x00000010
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT00_RD(src)  (((src) & 0x00000010)>>4)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields tsif_rrm_fifo_overfl_intr_prt0	 */
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT00_WIDTH                                 1
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT00_SHIFT                                 3
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT00_MASK                         0x00000008
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT00_RD(src)       (((src) & 0x00000008)>>3)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT00_WR(src)  (((u32)(src)<<3) & 0x00000008)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields tsif_rrm_fifo_underfl_intr_prt0	 */
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT00_WIDTH                                1
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT00_SHIFT                                2
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT00_MASK                        0x00000004
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT00_RD(src)      (((src) & 0x00000004)>>2)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields tsif_amabuf_fifo_overfl_intr_prt0	 */
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT00_WIDTH                              1
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT00_SHIFT                              1
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT00_MASK                      0x00000002
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT00_RD(src)    (((src) & 0x00000002)>>1)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields tsif_amabuf_fifo_underfl_intr_prt0	 */
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT00_WIDTH                             1
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT00_SHIFT                             0
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT00_MASK                     0x00000001
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT00_RD(src)      (((src) & 0x00000001))
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TSIF_Int_Reg0Mask	*/
/*    Mask Register Fields tsif_rdmbuff_fifo_overfl_intr_prt1Mask    */
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                          1
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                         21
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT1MASK_MASK                  0x00200000
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields tsif_rdmbuff_fifo_underfl_intr_prt1Mask    */
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                         1
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                        20
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT1MASK_MASK                 0x00100000
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00100000)>>20)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields tsif_rrm_fifo_overfl_intr_prt1Mask    */
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                              1
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                             19
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT1MASK_MASK                      0x00080000
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT1MASK_RD(src)   (((src) & 0x00080000)>>19)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields tsif_rrm_fifo_underfl_intr_prt1Mask    */
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                             1
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                            18
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT1MASK_MASK                     0x00040000
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)  (((src) & 0x00040000)>>18)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields tsif_amabuf_fifo_overfl_intr_prt1Mask    */
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                           1
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                          17
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT1MASK_MASK                   0x00020000
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields tsif_amabuf_fifo_underfl_intr_prt1Mask    */
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                          1
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                         16
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT1MASK_MASK                  0x00010000
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields tsif_rdmbuff_fifo_overfl_intr_prt0Mask    */
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                          1
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                          5
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT0MASK_MASK                  0x00000020
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT0MASK_RD(src) \
                                                     (((src) & 0x00000020)>>5)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define TSIF_RDMBUFF_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields tsif_rdmbuff_fifo_underfl_intr_prt0Mask    */
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                         1
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                         4
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT0MASK_MASK                 0x00000010
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT0MASK_RD(src) \
                                                     (((src) & 0x00000010)>>4)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define TSIF_RDMBUFF_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields tsif_rrm_fifo_overfl_intr_prt0Mask    */
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                              1
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                              3
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT0MASK_MASK                      0x00000008
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT0MASK_RD(src)    (((src) & 0x00000008)>>3)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define TSIF_RRM_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields tsif_rrm_fifo_underfl_intr_prt0Mask    */
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                             1
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                             2
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT0MASK_MASK                     0x00000004
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)   (((src) & 0x00000004)>>2)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define TSIF_RRM_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields tsif_amabuf_fifo_overfl_intr_prt0Mask    */
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                           1
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                           1
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT0MASK_MASK                   0x00000002
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT0MASK_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define TSIF_AMABUF_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields tsif_amabuf_fifo_underfl_intr_prt0Mask    */
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                          1
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                          0
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT0MASK_MASK                  0x00000001
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)   (((src) & 0x00000001))
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define TSIF_AMABUF_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TSIF_FInt_Reg0	*/ 
/*	 Fields tsif_ss_tso_hdr_notinline_intr_prt1	 */
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT10_WIDTH                            1
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT10_SHIFT                           21
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT10_MASK                    0x00200000
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT10_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields tsif_ss_msg_ll_invld_intr_prt1	 */
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT10_WIDTH                                 1
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT10_SHIFT                                20
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT10_MASK                         0x00100000
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT10_RD(src)      (((src) & 0x00100000)>>20)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields tsif_ss_tso_hdrlenerr_intr_prt1	 */
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT10_WIDTH                                1
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT10_SHIFT                               19
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT10_MASK                        0x00080000
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT10_RD(src)     (((src) & 0x00080000)>>19)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields tsif_ss_axi_llrderr_intr_prt1	 */
#define TSIF_SS_AXI_LLRDERR_INTR_PRT10_WIDTH                                  1
#define TSIF_SS_AXI_LLRDERR_INTR_PRT10_SHIFT                                 18
#define TSIF_SS_AXI_LLRDERR_INTR_PRT10_MASK                          0x00040000
#define TSIF_SS_AXI_LLRDERR_INTR_PRT10_RD(src)       (((src) & 0x00040000)>>18)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT10_WR(src)  (((u32)(src)<<18) & 0x00040000)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields tsif_ss_axi_rderr_intr_prt1	 */
#define TSIF_SS_AXI_RDERR_INTR_PRT10_WIDTH                                    1
#define TSIF_SS_AXI_RDERR_INTR_PRT10_SHIFT                                   17
#define TSIF_SS_AXI_RDERR_INTR_PRT10_MASK                            0x00020000
#define TSIF_SS_AXI_RDERR_INTR_PRT10_RD(src)         (((src) & 0x00020000)>>17)
#define TSIF_SS_AXI_RDERR_INTR_PRT10_WR(src)    (((u32)(src)<<17) & 0x00020000)
#define TSIF_SS_AXI_RDERR_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields tsif_ss_bad_msg_intr_prt1	 */
#define TSIF_SS_BAD_MSG_INTR_PRT10_WIDTH                                      1
#define TSIF_SS_BAD_MSG_INTR_PRT10_SHIFT                                     16
#define TSIF_SS_BAD_MSG_INTR_PRT10_MASK                              0x00010000
#define TSIF_SS_BAD_MSG_INTR_PRT10_RD(src)           (((src) & 0x00010000)>>16)
#define TSIF_SS_BAD_MSG_INTR_PRT10_WR(src)      (((u32)(src)<<16) & 0x00010000)
#define TSIF_SS_BAD_MSG_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields tsif_ss_tso_hdr_notinline_intr_prt0	 */
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT00_WIDTH                            1
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT00_SHIFT                            5
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT00_MASK                    0x00000020
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT00_RD(src)  (((src) & 0x00000020)>>5)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields tsif_ss_msg_ll_invld_intr_prt0	 */
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT00_WIDTH                                 1
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT00_SHIFT                                 4
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT00_MASK                         0x00000010
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT00_RD(src)       (((src) & 0x00000010)>>4)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT00_WR(src)  (((u32)(src)<<4) & 0x00000010)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields tsif_ss_tso_hdrlenerr_intr_prt0	 */
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT00_WIDTH                                1
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT00_SHIFT                                3
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT00_MASK                        0x00000008
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT00_RD(src)      (((src) & 0x00000008)>>3)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields tsif_ss_axi_llrderr_intr_prt0	 */
#define TSIF_SS_AXI_LLRDERR_INTR_PRT00_WIDTH                                  1
#define TSIF_SS_AXI_LLRDERR_INTR_PRT00_SHIFT                                  2
#define TSIF_SS_AXI_LLRDERR_INTR_PRT00_MASK                          0x00000004
#define TSIF_SS_AXI_LLRDERR_INTR_PRT00_RD(src)        (((src) & 0x00000004)>>2)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT00_WR(src)   (((u32)(src)<<2) & 0x00000004)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields tsif_ss_axi_rderr_intr_prt0	 */
#define TSIF_SS_AXI_RDERR_INTR_PRT00_WIDTH                                    1
#define TSIF_SS_AXI_RDERR_INTR_PRT00_SHIFT                                    1
#define TSIF_SS_AXI_RDERR_INTR_PRT00_MASK                            0x00000002
#define TSIF_SS_AXI_RDERR_INTR_PRT00_RD(src)          (((src) & 0x00000002)>>1)
#define TSIF_SS_AXI_RDERR_INTR_PRT00_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define TSIF_SS_AXI_RDERR_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields tsif_ss_bad_msg_intr_prt0	 */
#define TSIF_SS_BAD_MSG_INTR_PRT00_WIDTH                                      1
#define TSIF_SS_BAD_MSG_INTR_PRT00_SHIFT                                      0
#define TSIF_SS_BAD_MSG_INTR_PRT00_MASK                              0x00000001
#define TSIF_SS_BAD_MSG_INTR_PRT00_RD(src)               (((src) & 0x00000001))
#define TSIF_SS_BAD_MSG_INTR_PRT00_WR(src)          (((u32)(src)) & 0x00000001)
#define TSIF_SS_BAD_MSG_INTR_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TSIF_FInt_Reg0Mask	*/
/*    Mask Register Fields tsif_ss_tso_hdr_notinline_intr_prt1Mask    */
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT1MASK_WIDTH                         1
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT1MASK_SHIFT                        21
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT1MASK_MASK                 0x00200000
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00200000)>>21)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields tsif_ss_msg_ll_invld_intr_prt1Mask    */
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT1MASK_WIDTH                              1
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT1MASK_SHIFT                             20
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT1MASK_MASK                      0x00100000
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT1MASK_RD(src)   (((src) & 0x00100000)>>20)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields tsif_ss_tso_hdrlenerr_intr_prt1Mask    */
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT1MASK_WIDTH                             1
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT1MASK_SHIFT                            19
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT1MASK_MASK                     0x00080000
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT1MASK_RD(src)  (((src) & 0x00080000)>>19)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields tsif_ss_axi_llrderr_intr_prt1Mask    */
#define TSIF_SS_AXI_LLRDERR_INTR_PRT1MASK_WIDTH                               1
#define TSIF_SS_AXI_LLRDERR_INTR_PRT1MASK_SHIFT                              18
#define TSIF_SS_AXI_LLRDERR_INTR_PRT1MASK_MASK                       0x00040000
#define TSIF_SS_AXI_LLRDERR_INTR_PRT1MASK_RD(src)    (((src) & 0x00040000)>>18)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields tsif_ss_axi_rderr_intr_prt1Mask    */
#define TSIF_SS_AXI_RDERR_INTR_PRT1MASK_WIDTH                                 1
#define TSIF_SS_AXI_RDERR_INTR_PRT1MASK_SHIFT                                17
#define TSIF_SS_AXI_RDERR_INTR_PRT1MASK_MASK                         0x00020000
#define TSIF_SS_AXI_RDERR_INTR_PRT1MASK_RD(src)      (((src) & 0x00020000)>>17)
#define TSIF_SS_AXI_RDERR_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define TSIF_SS_AXI_RDERR_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields tsif_ss_bad_msg_intr_prt1Mask    */
#define TSIF_SS_BAD_MSG_INTR_PRT1MASK_WIDTH                                   1
#define TSIF_SS_BAD_MSG_INTR_PRT1MASK_SHIFT                                  16
#define TSIF_SS_BAD_MSG_INTR_PRT1MASK_MASK                           0x00010000
#define TSIF_SS_BAD_MSG_INTR_PRT1MASK_RD(src)        (((src) & 0x00010000)>>16)
#define TSIF_SS_BAD_MSG_INTR_PRT1MASK_WR(src)   (((u32)(src)<<16) & 0x00010000)
#define TSIF_SS_BAD_MSG_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields tsif_ss_tso_hdr_notinline_intr_prt0Mask    */
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT0MASK_WIDTH                         1
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT0MASK_SHIFT                         5
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT0MASK_MASK                 0x00000020
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT0MASK_RD(src) \
                                                     (((src) & 0x00000020)>>5)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define TSIF_SS_TSO_HDR_NOTINLINE_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields tsif_ss_msg_ll_invld_intr_prt0Mask    */
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT0MASK_WIDTH                              1
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT0MASK_SHIFT                              4
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT0MASK_MASK                      0x00000010
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT0MASK_RD(src)    (((src) & 0x00000010)>>4)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define TSIF_SS_MSG_LL_INVLD_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields tsif_ss_tso_hdrlenerr_intr_prt0Mask    */
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT0MASK_WIDTH                             1
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT0MASK_SHIFT                             3
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT0MASK_MASK                     0x00000008
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT0MASK_RD(src)   (((src) & 0x00000008)>>3)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define TSIF_SS_TSO_HDRLENERR_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields tsif_ss_axi_llrderr_intr_prt0Mask    */
#define TSIF_SS_AXI_LLRDERR_INTR_PRT0MASK_WIDTH                               1
#define TSIF_SS_AXI_LLRDERR_INTR_PRT0MASK_SHIFT                               2
#define TSIF_SS_AXI_LLRDERR_INTR_PRT0MASK_MASK                       0x00000004
#define TSIF_SS_AXI_LLRDERR_INTR_PRT0MASK_RD(src)     (((src) & 0x00000004)>>2)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define TSIF_SS_AXI_LLRDERR_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields tsif_ss_axi_rderr_intr_prt0Mask    */
#define TSIF_SS_AXI_RDERR_INTR_PRT0MASK_WIDTH                                 1
#define TSIF_SS_AXI_RDERR_INTR_PRT0MASK_SHIFT                                 1
#define TSIF_SS_AXI_RDERR_INTR_PRT0MASK_MASK                         0x00000002
#define TSIF_SS_AXI_RDERR_INTR_PRT0MASK_RD(src)       (((src) & 0x00000002)>>1)
#define TSIF_SS_AXI_RDERR_INTR_PRT0MASK_WR(src)  (((u32)(src)<<1) & 0x00000002)
#define TSIF_SS_AXI_RDERR_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields tsif_ss_bad_msg_intr_prt0Mask    */
#define TSIF_SS_BAD_MSG_INTR_PRT0MASK_WIDTH                                   1
#define TSIF_SS_BAD_MSG_INTR_PRT0MASK_SHIFT                                   0
#define TSIF_SS_BAD_MSG_INTR_PRT0MASK_MASK                           0x00000001
#define TSIF_SS_BAD_MSG_INTR_PRT0MASK_RD(src)            (((src) & 0x00000001))
#define TSIF_SS_BAD_MSG_INTR_PRT0MASK_WR(src)       (((u32)(src)) & 0x00000001)
#define TSIF_SS_BAD_MSG_INTR_PRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TSIF_Sts_Reg0	*/ 
/*	 Fields tsif_ss_axi_llrderr_rresp_prt1	 */
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT10_WIDTH                                 2
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT10_SHIFT                                18
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT10_MASK                         0x000c0000
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT10_RD(src)      (((src) & 0x000c0000)>>18)
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT10_SET(dst,src) \
                      (((dst) & ~0x000c0000) | (((u32)(src)<<18) & 0x000c0000))
/*	 Fields tsif_ss_axi_rderr_rresp_prt1	 */
#define TSIF_SS_AXI_RDERR_RRESP_PRT10_WIDTH                                   2
#define TSIF_SS_AXI_RDERR_RRESP_PRT10_SHIFT                                  16
#define TSIF_SS_AXI_RDERR_RRESP_PRT10_MASK                           0x00030000
#define TSIF_SS_AXI_RDERR_RRESP_PRT10_RD(src)        (((src) & 0x00030000)>>16)
#define TSIF_SS_AXI_RDERR_RRESP_PRT10_SET(dst,src) \
                      (((dst) & ~0x00030000) | (((u32)(src)<<16) & 0x00030000))
/*	 Fields tsif_ss_axi_llrderr_rresp_prt0	 */
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT00_WIDTH                                 2
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT00_SHIFT                                 2
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT00_MASK                         0x0000000c
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT00_RD(src)       (((src) & 0x0000000c)>>2)
#define TSIF_SS_AXI_LLRDERR_RRESP_PRT00_SET(dst,src) \
                       (((dst) & ~0x0000000c) | (((u32)(src)<<2) & 0x0000000c))
/*	 Fields tsif_ss_axi_rderr_rresp_prt0	 */
#define TSIF_SS_AXI_RDERR_RRESP_PRT00_WIDTH                                   2
#define TSIF_SS_AXI_RDERR_RRESP_PRT00_SHIFT                                   0
#define TSIF_SS_AXI_RDERR_RRESP_PRT00_MASK                           0x00000003
#define TSIF_SS_AXI_RDERR_RRESP_PRT00_RD(src)            (((src) & 0x00000003))
#define TSIF_SS_AXI_RDERR_RRESP_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register TSIF_Sts_Reg1	*/ 
/*	 Fields sts_tsif_wmsg_cntr_prt1	 */
#define STS_TSIF_WMSG_CNTR_PRT11_WIDTH                                       16
#define STS_TSIF_WMSG_CNTR_PRT11_SHIFT                                       16
#define STS_TSIF_WMSG_CNTR_PRT11_MASK                                0xffff0000
#define STS_TSIF_WMSG_CNTR_PRT11_RD(src)             (((src) & 0xffff0000)>>16)
#define STS_TSIF_WMSG_CNTR_PRT11_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields sts_tsif_wmsg_cntr_prt0	 */
#define STS_TSIF_WMSG_CNTR_PRT01_WIDTH                                       16
#define STS_TSIF_WMSG_CNTR_PRT01_SHIFT                                        0
#define STS_TSIF_WMSG_CNTR_PRT01_MASK                                0x0000ffff
#define STS_TSIF_WMSG_CNTR_PRT01_RD(src)                 (((src) & 0x0000ffff))
#define STS_TSIF_WMSG_CNTR_PRT01_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TSIF_Sts_Reg2	*/ 
/*	 Fields sts_tsif_da_wmsg_cntr_prt1	 */
#define STS_TSIF_DA_WMSG_CNTR_PRT12_WIDTH                                    16
#define STS_TSIF_DA_WMSG_CNTR_PRT12_SHIFT                                    16
#define STS_TSIF_DA_WMSG_CNTR_PRT12_MASK                             0xffff0000
#define STS_TSIF_DA_WMSG_CNTR_PRT12_RD(src)          (((src) & 0xffff0000)>>16)
#define STS_TSIF_DA_WMSG_CNTR_PRT12_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields sts_tsif_da_wmsg_cntr_prt0	 */
#define STS_TSIF_DA_WMSG_CNTR_PRT02_WIDTH                                    16
#define STS_TSIF_DA_WMSG_CNTR_PRT02_SHIFT                                     0
#define STS_TSIF_DA_WMSG_CNTR_PRT02_MASK                             0x0000ffff
#define STS_TSIF_DA_WMSG_CNTR_PRT02_RD(src)              (((src) & 0x0000ffff))
#define STS_TSIF_DA_WMSG_CNTR_PRT02_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TSIF_Sts_Reg3	*/ 
/*	 Fields sts_tsif_bad_wmsg_cntr_prt1	 */
#define STS_TSIF_BAD_WMSG_CNTR_PRT13_WIDTH                                   16
#define STS_TSIF_BAD_WMSG_CNTR_PRT13_SHIFT                                   16
#define STS_TSIF_BAD_WMSG_CNTR_PRT13_MASK                            0xffff0000
#define STS_TSIF_BAD_WMSG_CNTR_PRT13_RD(src)         (((src) & 0xffff0000)>>16)
#define STS_TSIF_BAD_WMSG_CNTR_PRT13_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields sts_tsif_bad_wmsg_cntr_prt0	 */
#define STS_TSIF_BAD_WMSG_CNTR_PRT03_WIDTH                                   16
#define STS_TSIF_BAD_WMSG_CNTR_PRT03_SHIFT                                    0
#define STS_TSIF_BAD_WMSG_CNTR_PRT03_MASK                            0x0000ffff
#define STS_TSIF_BAD_WMSG_CNTR_PRT03_RD(src)             (((src) & 0x0000ffff))
#define STS_TSIF_BAD_WMSG_CNTR_PRT03_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register cfg_capture_ECM_ctrlwd_0	*/ 
/*	 Fields en	 */
#define EN0_WIDTH                                                             1
#define EN0_SHIFT                                                             0
#define EN0_MASK                                                     0x00000001
#define EN0_RD(src)                                      (((src) & 0x00000001))
#define EN0_WR(src)                                 (((u32)(src)) & 0x00000001)
#define EN0_SET(dst,src) (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register STS_ECM_SOF0_Cntrl_word_0	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD0_WIDTH                                                     32
#define CTRL_WORD0_SHIFT                                                      0
#define CTRL_WORD0_MASK                                              0xffffffff
#define CTRL_WORD0_RD(src)                               (((src) & 0xffffffff))
#define CTRL_WORD0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_SOF1_Cntrl_word_0	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD0_F1_WIDTH                                                  32
#define CTRL_WORD0_F1_SHIFT                                                   0
#define CTRL_WORD0_F1_MASK                                           0xffffffff
#define CTRL_WORD0_F1_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_SOF2_Cntrl_word_0	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD0_F2_WIDTH                                                  32
#define CTRL_WORD0_F2_SHIFT                                                   0
#define CTRL_WORD0_F2_MASK                                           0xffffffff
#define CTRL_WORD0_F2_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD0_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_SOF3_Cntrl_word_0	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD0_F3_WIDTH                                                  32
#define CTRL_WORD0_F3_SHIFT                                                   0
#define CTRL_WORD0_F3_MASK                                           0xffffffff
#define CTRL_WORD0_F3_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD0_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_EOF1_Cntrl_word_0	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD0_F4_WIDTH                                                  32
#define CTRL_WORD0_F4_SHIFT                                                   0
#define CTRL_WORD0_F4_MASK                                           0xffffffff
#define CTRL_WORD0_F4_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD0_F4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register cfg_capture_ECM_ctrlwd_1	*/ 
/*	 Fields en	 */
#define EN1_WIDTH                                                             1
#define EN1_SHIFT                                                             0
#define EN1_MASK                                                     0x00000001
#define EN1_RD(src)                                      (((src) & 0x00000001))
#define EN1_WR(src)                                 (((u32)(src)) & 0x00000001)
#define EN1_SET(dst,src) (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register STS_ECM_SOF0_Cntrl_word_1	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD1_WIDTH                                                     32
#define CTRL_WORD1_SHIFT                                                      0
#define CTRL_WORD1_MASK                                              0xffffffff
#define CTRL_WORD1_RD(src)                               (((src) & 0xffffffff))
#define CTRL_WORD1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_SOF1_Cntrl_word_1	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD1_F1_WIDTH                                                  32
#define CTRL_WORD1_F1_SHIFT                                                   0
#define CTRL_WORD1_F1_MASK                                           0xffffffff
#define CTRL_WORD1_F1_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_SOF2_Cntrl_word_1	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD1_F2_WIDTH                                                  32
#define CTRL_WORD1_F2_SHIFT                                                   0
#define CTRL_WORD1_F2_MASK                                           0xffffffff
#define CTRL_WORD1_F2_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD1_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_SOF3_Cntrl_word_1	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD1_F3_WIDTH                                                  32
#define CTRL_WORD1_F3_SHIFT                                                   0
#define CTRL_WORD1_F3_MASK                                           0xffffffff
#define CTRL_WORD1_F3_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD1_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_ECM_EOF1_Cntrl_word_1	*/ 
/*	 Fields ctrl_word	 */
#define CTRL_WORD1_F4_WIDTH                                                  32
#define CTRL_WORD1_F4_SHIFT                                                   0
#define CTRL_WORD1_F4_MASK                                           0xffffffff
#define CTRL_WORD1_F4_RD(src)                            (((src) & 0xffffffff))
#define CTRL_WORD1_F4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register enet_spare_cfg_reg_1	*/ 
/*	 Fields spare_cfg	 */
#define SPARE_CFG1_WIDTH                                                     32
#define SPARE_CFG1_SHIFT                                                      0
#define SPARE_CFG1_MASK                                              0xffffffff
#define SPARE_CFG1_RD(src)                               (((src) & 0xffffffff))
#define SPARE_CFG1_WR(src)                          (((u32)(src)) & 0xffffffff)
#define SPARE_CFG1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register enet_spare_status_reg_1	*/ 
/*	 Fields spare_cfg	 */
#define SPARE_CFG1_F1_WIDTH                                                  32
#define SPARE_CFG1_F1_SHIFT                                                   0
#define SPARE_CFG1_F1_MASK                                           0xffffffff
#define SPARE_CFG1_F1_RD(src)                            (((src) & 0xffffffff))
#define SPARE_CFG1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_classA_credit_refill_0	*/ 
/*	 Fields cfg_avb_classA_credit_refill	 */
#define CFG_AVB_CLASSA_CREDIT_REFILL0_WIDTH                                  27
#define CFG_AVB_CLASSA_CREDIT_REFILL0_SHIFT                                   0
#define CFG_AVB_CLASSA_CREDIT_REFILL0_MASK                           0x07ffffff
#define CFG_AVB_CLASSA_CREDIT_REFILL0_RD(src)            (((src) & 0x07ffffff))
#define CFG_AVB_CLASSA_CREDIT_REFILL0_WR(src)       (((u32)(src)) & 0x07ffffff)
#define CFG_AVB_CLASSA_CREDIT_REFILL0_SET(dst,src) \
                          (((dst) & ~0x07ffffff) | (((u32)(src)) & 0x07ffffff))

/*	Register AVB_classA_credit_refill_1	*/ 
/*	 Fields cfg_avb_classA_credit_refill	 */
#define CFG_AVB_CLASSA_CREDIT_REFILL1_WIDTH                                  27
#define CFG_AVB_CLASSA_CREDIT_REFILL1_SHIFT                                   0
#define CFG_AVB_CLASSA_CREDIT_REFILL1_MASK                           0x07ffffff
#define CFG_AVB_CLASSA_CREDIT_REFILL1_RD(src)            (((src) & 0x07ffffff))
#define CFG_AVB_CLASSA_CREDIT_REFILL1_WR(src)       (((u32)(src)) & 0x07ffffff)
#define CFG_AVB_CLASSA_CREDIT_REFILL1_SET(dst,src) \
                          (((dst) & ~0x07ffffff) | (((u32)(src)) & 0x07ffffff))

/*	Register AVB_classB_credit_refill_0	*/ 
/*	 Fields cfg_avb_classB_credit_refill	 */
#define CFG_AVB_CLASSB_CREDIT_REFILL0_WIDTH                                  27
#define CFG_AVB_CLASSB_CREDIT_REFILL0_SHIFT                                   0
#define CFG_AVB_CLASSB_CREDIT_REFILL0_MASK                           0x07ffffff
#define CFG_AVB_CLASSB_CREDIT_REFILL0_RD(src)            (((src) & 0x07ffffff))
#define CFG_AVB_CLASSB_CREDIT_REFILL0_WR(src)       (((u32)(src)) & 0x07ffffff)
#define CFG_AVB_CLASSB_CREDIT_REFILL0_SET(dst,src) \
                          (((dst) & ~0x07ffffff) | (((u32)(src)) & 0x07ffffff))

/*	Register AVB_classB_credit_refill_1	*/ 
/*	 Fields cfg_avb_classB_credit_refill	 */
#define CFG_AVB_CLASSB_CREDIT_REFILL1_WIDTH                                  27
#define CFG_AVB_CLASSB_CREDIT_REFILL1_SHIFT                                   0
#define CFG_AVB_CLASSB_CREDIT_REFILL1_MASK                           0x07ffffff
#define CFG_AVB_CLASSB_CREDIT_REFILL1_RD(src)            (((src) & 0x07ffffff))
#define CFG_AVB_CLASSB_CREDIT_REFILL1_WR(src)       (((u32)(src)) & 0x07ffffff)
#define CFG_AVB_CLASSB_CREDIT_REFILL1_SET(dst,src) \
                          (((dst) & ~0x07ffffff) | (((u32)(src)) & 0x07ffffff))

/*	Register AVB_common_config1_0	*/ 
/*	 Fields cfg_avb_ptp_timer_en	 */
#define CFG_AVB_PTP_TIMER_EN0_WIDTH                                           1
#define CFG_AVB_PTP_TIMER_EN0_SHIFT                                          31
#define CFG_AVB_PTP_TIMER_EN0_MASK                                   0x80000000
#define CFG_AVB_PTP_TIMER_EN0_RD(src)                (((src) & 0x80000000)>>31)
#define CFG_AVB_PTP_TIMER_EN0_WR(src)           (((u32)(src)<<31) & 0x80000000)
#define CFG_AVB_PTP_TIMER_EN0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_avb_credit_carry	 */
#define CFG_AVB_CREDIT_CARRY0_WIDTH                                           1
#define CFG_AVB_CREDIT_CARRY0_SHIFT                                          30
#define CFG_AVB_CREDIT_CARRY0_MASK                                   0x40000000
#define CFG_AVB_CREDIT_CARRY0_RD(src)                (((src) & 0x40000000)>>30)
#define CFG_AVB_CREDIT_CARRY0_WR(src)           (((u32)(src)<<30) & 0x40000000)
#define CFG_AVB_CREDIT_CARRY0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_avb_credit_hold	 */
#define CFG_AVB_CREDIT_HOLD0_WIDTH                                            1
#define CFG_AVB_CREDIT_HOLD0_SHIFT                                           29
#define CFG_AVB_CREDIT_HOLD0_MASK                                    0x20000000
#define CFG_AVB_CREDIT_HOLD0_RD(src)                 (((src) & 0x20000000)>>29)
#define CFG_AVB_CREDIT_HOLD0_WR(src)            (((u32)(src)<<29) & 0x20000000)
#define CFG_AVB_CREDIT_HOLD0_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields mac_speed	 */
#define MAC_SPEED0_WIDTH                                                      2
#define MAC_SPEED0_SHIFT                                                     27
#define MAC_SPEED0_MASK                                              0x18000000
#define MAC_SPEED0_RD(src)                           (((src) & 0x18000000)>>27)
#define MAC_SPEED0_WR(src)                      (((u32)(src)<<27) & 0x18000000)
#define MAC_SPEED0_SET(dst,src) \
                      (((dst) & ~0x18000000) | (((u32)(src)<<27) & 0x18000000))
/*	 Fields cfg_avb_add_overhead	 */
#define CFG_AVB_ADD_OVERHEAD0_WIDTH                                           1
#define CFG_AVB_ADD_OVERHEAD0_SHIFT                                          26
#define CFG_AVB_ADD_OVERHEAD0_MASK                                   0x04000000
#define CFG_AVB_ADD_OVERHEAD0_RD(src)                (((src) & 0x04000000)>>26)
#define CFG_AVB_ADD_OVERHEAD0_WR(src)           (((u32)(src)<<26) & 0x04000000)
#define CFG_AVB_ADD_OVERHEAD0_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields cfg_avb_overhead	 */
#define CFG_AVB_OVERHEAD0_WIDTH                                               7
#define CFG_AVB_OVERHEAD0_SHIFT                                              19
#define CFG_AVB_OVERHEAD0_MASK                                       0x03f80000
#define CFG_AVB_OVERHEAD0_RD(src)                    (((src) & 0x03f80000)>>19)
#define CFG_AVB_OVERHEAD0_WR(src)               (((u32)(src)<<19) & 0x03f80000)
#define CFG_AVB_OVERHEAD0_SET(dst,src) \
                      (((dst) & ~0x03f80000) | (((u32)(src)<<19) & 0x03f80000))
/*	 Fields cfg_avb_credit_inc	 */
#define CFG_AVB_CREDIT_INC0_WIDTH                                             1
#define CFG_AVB_CREDIT_INC0_SHIFT                                            18
#define CFG_AVB_CREDIT_INC0_MASK                                     0x00040000
#define CFG_AVB_CREDIT_INC0_RD(src)                  (((src) & 0x00040000)>>18)
#define CFG_AVB_CREDIT_INC0_WR(src)             (((u32)(src)<<18) & 0x00040000)
#define CFG_AVB_CREDIT_INC0_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields cfg_avb_credit_refill_en	 */
#define CFG_AVB_CREDIT_REFILL_EN0_WIDTH                                       1
#define CFG_AVB_CREDIT_REFILL_EN0_SHIFT                                      17
#define CFG_AVB_CREDIT_REFILL_EN0_MASK                               0x00020000
#define CFG_AVB_CREDIT_REFILL_EN0_RD(src)            (((src) & 0x00020000)>>17)
#define CFG_AVB_CREDIT_REFILL_EN0_WR(src)       (((u32)(src)<<17) & 0x00020000)
#define CFG_AVB_CREDIT_REFILL_EN0_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_avb_ptp_sync_drain_en	 */
#define CFG_AVB_PTP_SYNC_DRAIN_EN0_WIDTH                                      1
#define CFG_AVB_PTP_SYNC_DRAIN_EN0_SHIFT                                     16
#define CFG_AVB_PTP_SYNC_DRAIN_EN0_MASK                              0x00010000
#define CFG_AVB_PTP_SYNC_DRAIN_EN0_RD(src)           (((src) & 0x00010000)>>16)
#define CFG_AVB_PTP_SYNC_DRAIN_EN0_WR(src)      (((u32)(src)<<16) & 0x00010000)
#define CFG_AVB_PTP_SYNC_DRAIN_EN0_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_avb_ptp_sync_en_classA_cnt	 */
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT0_WIDTH                                 8
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT0_SHIFT                                 8
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT0_MASK                         0x0000ff00
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT0_RD(src)       (((src) & 0x0000ff00)>>8)
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT0_WR(src)  (((u32)(src)<<8) & 0x0000ff00)
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT0_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_avb_ptp_sync_en_classB_cnt	 */
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT0_WIDTH                                 8
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT0_SHIFT                                 0
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT0_MASK                         0x000000ff
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT0_RD(src)          (((src) & 0x000000ff))
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT0_WR(src)     (((u32)(src)) & 0x000000ff)
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register AVB_common_config1_1	*/ 
/*	 Fields cfg_avb_ptp_timer_en	 */
#define CFG_AVB_PTP_TIMER_EN1_WIDTH                                           1
#define CFG_AVB_PTP_TIMER_EN1_SHIFT                                          31
#define CFG_AVB_PTP_TIMER_EN1_MASK                                   0x80000000
#define CFG_AVB_PTP_TIMER_EN1_RD(src)                (((src) & 0x80000000)>>31)
#define CFG_AVB_PTP_TIMER_EN1_WR(src)           (((u32)(src)<<31) & 0x80000000)
#define CFG_AVB_PTP_TIMER_EN1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_avb_credit_carry	 */
#define CFG_AVB_CREDIT_CARRY1_WIDTH                                           1
#define CFG_AVB_CREDIT_CARRY1_SHIFT                                          30
#define CFG_AVB_CREDIT_CARRY1_MASK                                   0x40000000
#define CFG_AVB_CREDIT_CARRY1_RD(src)                (((src) & 0x40000000)>>30)
#define CFG_AVB_CREDIT_CARRY1_WR(src)           (((u32)(src)<<30) & 0x40000000)
#define CFG_AVB_CREDIT_CARRY1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_avb_credit_hold	 */
#define CFG_AVB_CREDIT_HOLD1_WIDTH                                            1
#define CFG_AVB_CREDIT_HOLD1_SHIFT                                           29
#define CFG_AVB_CREDIT_HOLD1_MASK                                    0x20000000
#define CFG_AVB_CREDIT_HOLD1_RD(src)                 (((src) & 0x20000000)>>29)
#define CFG_AVB_CREDIT_HOLD1_WR(src)            (((u32)(src)<<29) & 0x20000000)
#define CFG_AVB_CREDIT_HOLD1_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields mac_speed	 */
#define MAC_SPEED1_WIDTH                                                      2
#define MAC_SPEED1_SHIFT                                                     27
#define MAC_SPEED1_MASK                                              0x18000000
#define MAC_SPEED1_RD(src)                           (((src) & 0x18000000)>>27)
#define MAC_SPEED1_WR(src)                      (((u32)(src)<<27) & 0x18000000)
#define MAC_SPEED1_SET(dst,src) \
                      (((dst) & ~0x18000000) | (((u32)(src)<<27) & 0x18000000))
/*	 Fields cfg_avb_add_overhead	 */
#define CFG_AVB_ADD_OVERHEAD1_WIDTH                                           1
#define CFG_AVB_ADD_OVERHEAD1_SHIFT                                          26
#define CFG_AVB_ADD_OVERHEAD1_MASK                                   0x04000000
#define CFG_AVB_ADD_OVERHEAD1_RD(src)                (((src) & 0x04000000)>>26)
#define CFG_AVB_ADD_OVERHEAD1_WR(src)           (((u32)(src)<<26) & 0x04000000)
#define CFG_AVB_ADD_OVERHEAD1_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields cfg_avb_overhead	 */
#define CFG_AVB_OVERHEAD1_WIDTH                                               7
#define CFG_AVB_OVERHEAD1_SHIFT                                              19
#define CFG_AVB_OVERHEAD1_MASK                                       0x03f80000
#define CFG_AVB_OVERHEAD1_RD(src)                    (((src) & 0x03f80000)>>19)
#define CFG_AVB_OVERHEAD1_WR(src)               (((u32)(src)<<19) & 0x03f80000)
#define CFG_AVB_OVERHEAD1_SET(dst,src) \
                      (((dst) & ~0x03f80000) | (((u32)(src)<<19) & 0x03f80000))
/*	 Fields cfg_avb_credit_inc	 */
#define CFG_AVB_CREDIT_INC1_WIDTH                                             1
#define CFG_AVB_CREDIT_INC1_SHIFT                                            18
#define CFG_AVB_CREDIT_INC1_MASK                                     0x00040000
#define CFG_AVB_CREDIT_INC1_RD(src)                  (((src) & 0x00040000)>>18)
#define CFG_AVB_CREDIT_INC1_WR(src)             (((u32)(src)<<18) & 0x00040000)
#define CFG_AVB_CREDIT_INC1_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields cfg_avb_credit_refill_en	 */
#define CFG_AVB_CREDIT_REFILL_EN1_WIDTH                                       1
#define CFG_AVB_CREDIT_REFILL_EN1_SHIFT                                      17
#define CFG_AVB_CREDIT_REFILL_EN1_MASK                               0x00020000
#define CFG_AVB_CREDIT_REFILL_EN1_RD(src)            (((src) & 0x00020000)>>17)
#define CFG_AVB_CREDIT_REFILL_EN1_WR(src)       (((u32)(src)<<17) & 0x00020000)
#define CFG_AVB_CREDIT_REFILL_EN1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_avb_ptp_sync_drain_en	 */
#define CFG_AVB_PTP_SYNC_DRAIN_EN1_WIDTH                                      1
#define CFG_AVB_PTP_SYNC_DRAIN_EN1_SHIFT                                     16
#define CFG_AVB_PTP_SYNC_DRAIN_EN1_MASK                              0x00010000
#define CFG_AVB_PTP_SYNC_DRAIN_EN1_RD(src)           (((src) & 0x00010000)>>16)
#define CFG_AVB_PTP_SYNC_DRAIN_EN1_WR(src)      (((u32)(src)<<16) & 0x00010000)
#define CFG_AVB_PTP_SYNC_DRAIN_EN1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_avb_ptp_sync_en_classA_cnt	 */
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT1_WIDTH                                 8
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT1_SHIFT                                 8
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT1_MASK                         0x0000ff00
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT1_RD(src)       (((src) & 0x0000ff00)>>8)
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT1_WR(src)  (((u32)(src)<<8) & 0x0000ff00)
#define CFG_AVB_PTP_SYNC_EN_CLASSA_CNT1_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_avb_ptp_sync_en_classB_cnt	 */
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT1_WIDTH                                 8
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT1_SHIFT                                 0
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT1_MASK                         0x000000ff
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT1_RD(src)          (((src) & 0x000000ff))
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT1_WR(src)     (((u32)(src)) & 0x000000ff)
#define CFG_AVB_PTP_SYNC_EN_CLASSB_CNT1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register AVB_common_config2_0	*/ 
/*	 Fields cfg_wrr_credit_reset_en	 */
#define CFG_WRR_CREDIT_RESET_EN0_WIDTH                                        1
#define CFG_WRR_CREDIT_RESET_EN0_SHIFT                                       29
#define CFG_WRR_CREDIT_RESET_EN0_MASK                                0x20000000
#define CFG_WRR_CREDIT_RESET_EN0_RD(src)             (((src) & 0x20000000)>>29)
#define CFG_WRR_CREDIT_RESET_EN0_WR(src)        (((u32)(src)<<29) & 0x20000000)
#define CFG_WRR_CREDIT_RESET_EN0_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields cfg_avb_ipsec_expansion	 */
#define CFG_AVB_IPSEC_EXPANSION0_WIDTH                                        6
#define CFG_AVB_IPSEC_EXPANSION0_SHIFT                                       23
#define CFG_AVB_IPSEC_EXPANSION0_MASK                                0x1f800000
#define CFG_AVB_IPSEC_EXPANSION0_RD(src)             (((src) & 0x1f800000)>>23)
#define CFG_AVB_IPSEC_EXPANSION0_WR(src)        (((u32)(src)<<23) & 0x1f800000)
#define CFG_AVB_IPSEC_EXPANSION0_SET(dst,src) \
                      (((dst) & ~0x1f800000) | (((u32)(src)<<23) & 0x1f800000))
/*	 Fields cfg_avb_macsec_expansion	 */
#define CFG_AVB_MACSEC_EXPANSION0_WIDTH                                       6
#define CFG_AVB_MACSEC_EXPANSION0_SHIFT                                      17
#define CFG_AVB_MACSEC_EXPANSION0_MASK                               0x007e0000
#define CFG_AVB_MACSEC_EXPANSION0_RD(src)            (((src) & 0x007e0000)>>17)
#define CFG_AVB_MACSEC_EXPANSION0_WR(src)       (((u32)(src)<<17) & 0x007e0000)
#define CFG_AVB_MACSEC_EXPANSION0_SET(dst,src) \
                      (((dst) & ~0x007e0000) | (((u32)(src)<<17) & 0x007e0000))
/*	 Fields cfg_avb_calc_int_HundredNsec_cnt	 */
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT0_WIDTH                              17
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT0_SHIFT                               0
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT0_MASK                       0x0001ffff
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT0_RD(src)        (((src) & 0x0001ffff))
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT0_WR(src)   (((u32)(src)) & 0x0001ffff)
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT0_SET(dst,src) \
                          (((dst) & ~0x0001ffff) | (((u32)(src)) & 0x0001ffff))

/*	Register AVB_common_config2_1	*/ 
/*	 Fields cfg_wrr_credit_reset_en	 */
#define CFG_WRR_CREDIT_RESET_EN1_WIDTH                                        1
#define CFG_WRR_CREDIT_RESET_EN1_SHIFT                                       29
#define CFG_WRR_CREDIT_RESET_EN1_MASK                                0x20000000
#define CFG_WRR_CREDIT_RESET_EN1_RD(src)             (((src) & 0x20000000)>>29)
#define CFG_WRR_CREDIT_RESET_EN1_WR(src)        (((u32)(src)<<29) & 0x20000000)
#define CFG_WRR_CREDIT_RESET_EN1_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields cfg_avb_ipsec_expansion	 */
#define CFG_AVB_IPSEC_EXPANSION1_WIDTH                                        6
#define CFG_AVB_IPSEC_EXPANSION1_SHIFT                                       23
#define CFG_AVB_IPSEC_EXPANSION1_MASK                                0x1f800000
#define CFG_AVB_IPSEC_EXPANSION1_RD(src)             (((src) & 0x1f800000)>>23)
#define CFG_AVB_IPSEC_EXPANSION1_WR(src)        (((u32)(src)<<23) & 0x1f800000)
#define CFG_AVB_IPSEC_EXPANSION1_SET(dst,src) \
                      (((dst) & ~0x1f800000) | (((u32)(src)<<23) & 0x1f800000))
/*	 Fields cfg_avb_macsec_expansion	 */
#define CFG_AVB_MACSEC_EXPANSION1_WIDTH                                       6
#define CFG_AVB_MACSEC_EXPANSION1_SHIFT                                      17
#define CFG_AVB_MACSEC_EXPANSION1_MASK                               0x007e0000
#define CFG_AVB_MACSEC_EXPANSION1_RD(src)            (((src) & 0x007e0000)>>17)
#define CFG_AVB_MACSEC_EXPANSION1_WR(src)       (((u32)(src)<<17) & 0x007e0000)
#define CFG_AVB_MACSEC_EXPANSION1_SET(dst,src) \
                      (((dst) & ~0x007e0000) | (((u32)(src)<<17) & 0x007e0000))
/*	 Fields cfg_avb_calc_int_HundredNsec_cnt	 */
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT1_WIDTH                              17
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT1_SHIFT                               0
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT1_MASK                       0x0001ffff
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT1_RD(src)        (((src) & 0x0001ffff))
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT1_WR(src)   (((u32)(src)) & 0x0001ffff)
#define CFG_AVB_CALC_INT_HUNDREDNSEC_CNT1_SET(dst,src) \
                          (((dst) & ~0x0001ffff) | (((u32)(src)) & 0x0001ffff))

/*	Register AVB_per_q_config1_0	*/ 
/*	 Fields cfg_avb_classA	 */
#define CFG_AVB_CLASSA0_WIDTH                                                 8
#define CFG_AVB_CLASSA0_SHIFT                                                24
#define CFG_AVB_CLASSA0_MASK                                         0xff000000
#define CFG_AVB_CLASSA0_RD(src)                      (((src) & 0xff000000)>>24)
#define CFG_AVB_CLASSA0_WR(src)                 (((u32)(src)<<24) & 0xff000000)
#define CFG_AVB_CLASSA0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_avb_classB	 */
#define CFG_AVB_CLASSB0_WIDTH                                                 8
#define CFG_AVB_CLASSB0_SHIFT                                                16
#define CFG_AVB_CLASSB0_MASK                                         0x00ff0000
#define CFG_AVB_CLASSB0_RD(src)                      (((src) & 0x00ff0000)>>16)
#define CFG_AVB_CLASSB0_WR(src)                 (((u32)(src)<<16) & 0x00ff0000)
#define CFG_AVB_CLASSB0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_eth_q_arb_type	 */
#define CFG_ETH_Q_ARB_TYPE0_WIDTH                                            16
#define CFG_ETH_Q_ARB_TYPE0_SHIFT                                             0
#define CFG_ETH_Q_ARB_TYPE0_MASK                                     0x0000ffff
#define CFG_ETH_Q_ARB_TYPE0_RD(src)                      (((src) & 0x0000ffff))
#define CFG_ETH_Q_ARB_TYPE0_WR(src)                 (((u32)(src)) & 0x0000ffff)
#define CFG_ETH_Q_ARB_TYPE0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register AVB_per_q_config1_1	*/ 
/*	 Fields cfg_avb_classA	 */
#define CFG_AVB_CLASSA1_WIDTH                                                 8
#define CFG_AVB_CLASSA1_SHIFT                                                24
#define CFG_AVB_CLASSA1_MASK                                         0xff000000
#define CFG_AVB_CLASSA1_RD(src)                      (((src) & 0xff000000)>>24)
#define CFG_AVB_CLASSA1_WR(src)                 (((u32)(src)<<24) & 0xff000000)
#define CFG_AVB_CLASSA1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_avb_classB	 */
#define CFG_AVB_CLASSB1_WIDTH                                                 8
#define CFG_AVB_CLASSB1_SHIFT                                                16
#define CFG_AVB_CLASSB1_MASK                                         0x00ff0000
#define CFG_AVB_CLASSB1_RD(src)                      (((src) & 0x00ff0000)>>16)
#define CFG_AVB_CLASSB1_WR(src)                 (((u32)(src)<<16) & 0x00ff0000)
#define CFG_AVB_CLASSB1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_eth_q_arb_type	 */
#define CFG_ETH_Q_ARB_TYPE1_WIDTH                                            16
#define CFG_ETH_Q_ARB_TYPE1_SHIFT                                             0
#define CFG_ETH_Q_ARB_TYPE1_MASK                                     0x0000ffff
#define CFG_ETH_Q_ARB_TYPE1_RD(src)                      (((src) & 0x0000ffff))
#define CFG_ETH_Q_ARB_TYPE1_WR(src)                 (((u32)(src)) & 0x0000ffff)
#define CFG_ETH_Q_ARB_TYPE1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register AVB_per_q_hi_credit_0	*/ 
/*	 Fields cfg_hi_credit	 */
#define CFG_HI_CREDIT0_WIDTH                                                 32
#define CFG_HI_CREDIT0_SHIFT                                                  0
#define CFG_HI_CREDIT0_MASK                                          0xffffffff
#define CFG_HI_CREDIT0_RD(src)                           (((src) & 0xffffffff))
#define CFG_HI_CREDIT0_WR(src)                      (((u32)(src)) & 0xffffffff)
#define CFG_HI_CREDIT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_hi_credit_1	*/ 
/*	 Fields cfg_hi_credit	 */
#define CFG_HI_CREDIT1_WIDTH                                                 32
#define CFG_HI_CREDIT1_SHIFT                                                  0
#define CFG_HI_CREDIT1_MASK                                          0xffffffff
#define CFG_HI_CREDIT1_RD(src)                           (((src) & 0xffffffff))
#define CFG_HI_CREDIT1_WR(src)                      (((u32)(src)) & 0xffffffff)
#define CFG_HI_CREDIT1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_idle_slope0_0	*/ 
/*	 Fields cfg_idle_slope_wrr_weights_q2	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q20_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q20_SHIFT                                 18
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q20_MASK                          0x07fc0000
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q20_RD(src)       (((src) & 0x07fc0000)>>18)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q20_WR(src)  (((u32)(src)<<18) & 0x07fc0000)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q20_SET(dst,src) \
                      (((dst) & ~0x07fc0000) | (((u32)(src)<<18) & 0x07fc0000))
/*	 Fields cfg_idle_slope_wrr_weights_q1	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q10_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q10_SHIFT                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q10_MASK                          0x0003fe00
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q10_RD(src)        (((src) & 0x0003fe00)>>9)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q10_WR(src)   (((u32)(src)<<9) & 0x0003fe00)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q10_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_idle_slope_wrr_weights_q0	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q00_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q00_SHIFT                                  0
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q00_MASK                          0x000001ff
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q00_RD(src)           (((src) & 0x000001ff))
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q00_WR(src)      (((u32)(src)) & 0x000001ff)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q00_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register AVB_per_q_idle_slope0_1	*/ 
/*	 Fields cfg_idle_slope_wrr_weights_q2	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q21_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q21_SHIFT                                 18
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q21_MASK                          0x07fc0000
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q21_RD(src)       (((src) & 0x07fc0000)>>18)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q21_WR(src)  (((u32)(src)<<18) & 0x07fc0000)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q21_SET(dst,src) \
                      (((dst) & ~0x07fc0000) | (((u32)(src)<<18) & 0x07fc0000))
/*	 Fields cfg_idle_slope_wrr_weights_q1	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q11_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q11_SHIFT                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q11_MASK                          0x0003fe00
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q11_RD(src)        (((src) & 0x0003fe00)>>9)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q11_WR(src)   (((u32)(src)<<9) & 0x0003fe00)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q11_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_idle_slope_wrr_weights_q0	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q01_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q01_SHIFT                                  0
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q01_MASK                          0x000001ff
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q01_RD(src)           (((src) & 0x000001ff))
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q01_WR(src)      (((u32)(src)) & 0x000001ff)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q01_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register AVB_per_q_idle_slope1_0	*/ 
/*	 Fields cfg_idle_slope_wrr_weights_q5	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q50_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q50_SHIFT                                 18
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q50_MASK                          0x07fc0000
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q50_RD(src)       (((src) & 0x07fc0000)>>18)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q50_WR(src)  (((u32)(src)<<18) & 0x07fc0000)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q50_SET(dst,src) \
                      (((dst) & ~0x07fc0000) | (((u32)(src)<<18) & 0x07fc0000))
/*	 Fields cfg_idle_slope_wrr_weights_q4	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q40_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q40_SHIFT                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q40_MASK                          0x0003fe00
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q40_RD(src)        (((src) & 0x0003fe00)>>9)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q40_WR(src)   (((u32)(src)<<9) & 0x0003fe00)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q40_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_idle_slope_wrr_weights_q3	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q30_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q30_SHIFT                                  0
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q30_MASK                          0x000001ff
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q30_RD(src)           (((src) & 0x000001ff))
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q30_WR(src)      (((u32)(src)) & 0x000001ff)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q30_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register AVB_per_q_idle_slope1_1	*/ 
/*	 Fields cfg_idle_slope_wrr_weights_q5	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q51_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q51_SHIFT                                 18
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q51_MASK                          0x07fc0000
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q51_RD(src)       (((src) & 0x07fc0000)>>18)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q51_WR(src)  (((u32)(src)<<18) & 0x07fc0000)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q51_SET(dst,src) \
                      (((dst) & ~0x07fc0000) | (((u32)(src)<<18) & 0x07fc0000))
/*	 Fields cfg_idle_slope_wrr_weights_q4	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q41_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q41_SHIFT                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q41_MASK                          0x0003fe00
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q41_RD(src)        (((src) & 0x0003fe00)>>9)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q41_WR(src)   (((u32)(src)<<9) & 0x0003fe00)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q41_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_idle_slope_wrr_weights_q3	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q31_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q31_SHIFT                                  0
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q31_MASK                          0x000001ff
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q31_RD(src)           (((src) & 0x000001ff))
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q31_WR(src)      (((u32)(src)) & 0x000001ff)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q31_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register AVB_per_q_idle_slope2_0	*/ 
/*	 Fields cfg_idle_slope_wrr_weights_q7	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q70_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q70_SHIFT                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q70_MASK                          0x0003fe00
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q70_RD(src)        (((src) & 0x0003fe00)>>9)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q70_WR(src)   (((u32)(src)<<9) & 0x0003fe00)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q70_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_idle_slope_wrr_weights_q6	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q60_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q60_SHIFT                                  0
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q60_MASK                          0x000001ff
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q60_RD(src)           (((src) & 0x000001ff))
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q60_WR(src)      (((u32)(src)) & 0x000001ff)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q60_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register AVB_per_q_idle_slope2_1	*/ 
/*	 Fields cfg_idle_slope_wrr_weights_q7	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q71_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q71_SHIFT                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q71_MASK                          0x0003fe00
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q71_RD(src)        (((src) & 0x0003fe00)>>9)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q71_WR(src)   (((u32)(src)<<9) & 0x0003fe00)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q71_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_idle_slope_wrr_weights_q6	 */
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q61_WIDTH                                  9
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q61_SHIFT                                  0
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q61_MASK                          0x000001ff
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q61_RD(src)           (((src) & 0x000001ff))
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q61_WR(src)      (((u32)(src)) & 0x000001ff)
#define CFG_IDLE_SLOPE_WRR_WEIGHTS_Q61_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register AVB_per_q_byte_num_q0_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_WIDTH                                            32
#define CFG_AVB_Q_BYTE_NUM0_SHIFT                                             0
#define CFG_AVB_Q_BYTE_NUM0_MASK                                     0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_RD(src)                      (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_WR(src)                 (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q0_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_WIDTH                                            32
#define CFG_AVB_Q_BYTE_NUM1_SHIFT                                             0
#define CFG_AVB_Q_BYTE_NUM1_MASK                                     0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_RD(src)                      (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_WR(src)                 (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q1_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F1_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F1_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F1_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F1_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q1_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F1_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F1_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F1_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F1_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q2_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F2_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F2_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F2_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F2_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F2_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q2_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F2_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F2_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F2_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F2_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F2_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q3_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F3_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F3_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F3_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F3_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F3_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q3_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F3_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F3_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F3_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F3_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F3_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q4_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F4_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F4_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F4_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F4_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F4_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q4_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F4_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F4_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F4_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F4_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F4_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q5_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F5_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F5_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F5_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F5_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F5_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F5_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q5_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F5_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F5_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F5_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F5_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F5_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F5_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q6_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F6_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F6_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F6_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F6_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F6_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F6_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q6_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F6_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F6_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F6_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F6_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F6_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F6_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q7_0	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM0_F7_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM0_F7_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM0_F7_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM0_F7_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM0_F7_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM0_F7_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_per_q_byte_num_q7_1	*/ 
/*	 Fields cfg_avb_q_byte_num	 */
#define CFG_AVB_Q_BYTE_NUM1_F7_WIDTH                                         32
#define CFG_AVB_Q_BYTE_NUM1_F7_SHIFT                                          0
#define CFG_AVB_Q_BYTE_NUM1_F7_MASK                                  0xffffffff
#define CFG_AVB_Q_BYTE_NUM1_F7_RD(src)                   (((src) & 0xffffffff))
#define CFG_AVB_Q_BYTE_NUM1_F7_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_AVB_Q_BYTE_NUM1_F7_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_cfg_prsntn_time_0	*/ 
/*	 Fields offset	 */
#define OFFSET0_WIDTH                                                        32
#define OFFSET0_SHIFT                                                         0
#define OFFSET0_MASK                                                 0xffffffff
#define OFFSET0_RD(src)                                  (((src) & 0xffffffff))
#define OFFSET0_WR(src)                             (((u32)(src)) & 0xffffffff)
#define OFFSET0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register AVB_cfg_prsntn_time_1	*/ 
/*	 Fields offset	 */
#define OFFSET1_WIDTH                                                        32
#define OFFSET1_SHIFT                                                         0
#define OFFSET1_MASK                                                 0xffffffff
#define OFFSET1_RD(src)                                  (((src) & 0xffffffff))
#define OFFSET1_WR(src)                             (((u32)(src)) & 0xffffffff)
#define OFFSET1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register cfg_link_aggr	*/ 
/*	 Fields arb_sel	 */
#define ARB_SEL_WIDTH                                                         1
#define ARB_SEL_SHIFT                                                         2
#define ARB_SEL_MASK                                                 0x00000004
#define ARB_SEL_RD(src)                               (((src) & 0x00000004)>>2)
#define ARB_SEL_WR(src)                          (((u32)(src)<<2) & 0x00000004)
#define ARB_SEL_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields en	 */
#define EN_WIDTH                                                              1
#define EN_SHIFT                                                              1
#define EN_MASK                                                      0x00000002
#define EN_RD(src)                                    (((src) & 0x00000002)>>1)
#define EN_WR(src)                               (((u32)(src)<<1) & 0x00000002)
#define EN_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))

/*	Register cfg_bypass	*/ 
/*	 Fields resume_tx	 */
#define RESUME_TX_WIDTH                                                       1
#define RESUME_TX_SHIFT                                                       0
#define RESUME_TX_MASK                                               0x00000001
#define RESUME_TX_RD(src)                                (((src) & 0x00000001))
#define RESUME_TX_WR(src)                           (((u32)(src)) & 0x00000001)
#define RESUME_TX_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_link_sts_sel	*/ 
/*	 Fields port1	 */
#define PORT1_WIDTH                                                           1
#define PORT1_SHIFT                                                           1
#define PORT1_MASK                                                   0x00000002
#define PORT1_RD(src)                                 (((src) & 0x00000002)>>1)
#define PORT1_WR(src)                            (((u32)(src)<<1) & 0x00000002)
#define PORT1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_WIDTH                                                           1
#define PORT0_SHIFT                                                           0
#define PORT0_MASK                                                   0x00000001
#define PORT0_RD(src)                                    (((src) & 0x00000001))
#define PORT0_WR(src)                               (((u32)(src)) & 0x00000001)
#define PORT0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_force_link_status_en	*/ 
/*	 Fields port1	 */
#define PORT1_F1_WIDTH                                                        1
#define PORT1_F1_SHIFT                                                        1
#define PORT1_F1_MASK                                                0x00000002
#define PORT1_F1_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F1_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define PORT1_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F1_WIDTH                                                        1
#define PORT0_F1_SHIFT                                                        0
#define PORT0_F1_MASK                                                0x00000001
#define PORT0_F1_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F1_WR(src)                            (((u32)(src)) & 0x00000001)
#define PORT0_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register force_link_status	*/ 
/*	 Fields port1	 */
#define PORT1_F2_WIDTH                                                        1
#define PORT1_F2_SHIFT                                                        1
#define PORT1_F2_MASK                                                0x00000002
#define PORT1_F2_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F2_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define PORT1_F2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F2_WIDTH                                                        1
#define PORT0_F2_SHIFT                                                        0
#define PORT0_F2_MASK                                                0x00000001
#define PORT0_F2_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F2_WR(src)                            (((u32)(src)) & 0x00000001)
#define PORT0_F2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_phyid_0	*/ 
/*	 Fields port3	 */
#define PORT30_WIDTH                                                          5
#define PORT30_SHIFT                                                         24
#define PORT30_MASK                                                  0x1f000000
#define PORT30_RD(src)                               (((src) & 0x1f000000)>>24)
#define PORT30_WR(src)                          (((u32)(src)<<24) & 0x1f000000)
#define PORT30_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields port2	 */
#define PORT20_WIDTH                                                          5
#define PORT20_SHIFT                                                         16
#define PORT20_MASK                                                  0x001f0000
#define PORT20_RD(src)                               (((src) & 0x001f0000)>>16)
#define PORT20_WR(src)                          (((u32)(src)<<16) & 0x001f0000)
#define PORT20_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields port1	 */
#define PORT10_WIDTH                                                          5
#define PORT10_SHIFT                                                          8
#define PORT10_MASK                                                  0x00001f00
#define PORT10_RD(src)                                (((src) & 0x00001f00)>>8)
#define PORT10_WR(src)                           (((u32)(src)<<8) & 0x00001f00)
#define PORT10_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields port0	 */
#define PORT00_WIDTH                                                          5
#define PORT00_SHIFT                                                          0
#define PORT00_MASK                                                  0x0000001f
#define PORT00_RD(src)                                   (((src) & 0x0000001f))
#define PORT00_WR(src)                              (((u32)(src)) & 0x0000001f)
#define PORT00_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register cfg_phyid_1	*/ 
/*	 Fields port8	 */
#define PORT81_WIDTH                                                          5
#define PORT81_SHIFT                                                         26
#define PORT81_MASK                                                  0x7c000000
#define PORT81_RD(src)                               (((src) & 0x7c000000)>>26)
#define PORT81_WR(src)                          (((u32)(src)<<26) & 0x7c000000)
#define PORT81_SET(dst,src) \
                      (((dst) & ~0x7c000000) | (((u32)(src)<<26) & 0x7c000000))
/*	 Fields port7	 */
#define PORT71_WIDTH                                                          5
#define PORT71_SHIFT                                                         21
#define PORT71_MASK                                                  0x03e00000
#define PORT71_RD(src)                               (((src) & 0x03e00000)>>21)
#define PORT71_WR(src)                          (((u32)(src)<<21) & 0x03e00000)
#define PORT71_SET(dst,src) \
                      (((dst) & ~0x03e00000) | (((u32)(src)<<21) & 0x03e00000))
/*	 Fields port6	 */
#define PORT61_WIDTH                                                          5
#define PORT61_SHIFT                                                         16
#define PORT61_MASK                                                  0x001f0000
#define PORT61_RD(src)                               (((src) & 0x001f0000)>>16)
#define PORT61_WR(src)                          (((u32)(src)<<16) & 0x001f0000)
#define PORT61_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields port5	 */
#define PORT51_WIDTH                                                          5
#define PORT51_SHIFT                                                          8
#define PORT51_MASK                                                  0x00001f00
#define PORT51_RD(src)                                (((src) & 0x00001f00)>>8)
#define PORT51_WR(src)                           (((u32)(src)<<8) & 0x00001f00)
#define PORT51_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields port4	 */
#define PORT41_WIDTH                                                          5
#define PORT41_SHIFT                                                          0
#define PORT41_MASK                                                  0x0000001f
#define PORT41_RD(src)                                   (((src) & 0x0000001f))
#define PORT41_WR(src)                              (((u32)(src)) & 0x0000001f)
#define PORT41_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register cfg_mdio	*/ 
/*	 Fields port_sel	 */
#define PORT_SEL_WIDTH                                                        1
#define PORT_SEL_SHIFT                                                        8
#define PORT_SEL_MASK                                                0x00000100
#define PORT_SEL_RD(src)                              (((src) & 0x00000100)>>8)
#define PORT_SEL_WR(src)                         (((u32)(src)<<8) & 0x00000100)
#define PORT_SEL_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields last_phyid	 */
#define LAST_PHYID_WIDTH                                                      5
#define LAST_PHYID_SHIFT                                                      0
#define LAST_PHYID_MASK                                              0x0000001f
#define LAST_PHYID_RD(src)                               (((src) & 0x0000001f))
#define LAST_PHYID_WR(src)                          (((u32)(src)) & 0x0000001f)
#define LAST_PHYID_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register autopoll_link_sts_intr	*/ 
/*	 Fields port8	 */
#define PORT8_WIDTH                                                           1
#define PORT8_SHIFT                                                           8
#define PORT8_MASK                                                   0x00000100
#define PORT8_RD(src)                                 (((src) & 0x00000100)>>8)
#define PORT8_WR(src)                            (((u32)(src)<<8) & 0x00000100)
#define PORT8_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields port7	 */
#define PORT7_WIDTH                                                           1
#define PORT7_SHIFT                                                           7
#define PORT7_MASK                                                   0x00000080
#define PORT7_RD(src)                                 (((src) & 0x00000080)>>7)
#define PORT7_WR(src)                            (((u32)(src)<<7) & 0x00000080)
#define PORT7_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields port6	 */
#define PORT6_WIDTH                                                           1
#define PORT6_SHIFT                                                           6
#define PORT6_MASK                                                   0x00000040
#define PORT6_RD(src)                                 (((src) & 0x00000040)>>6)
#define PORT6_WR(src)                            (((u32)(src)<<6) & 0x00000040)
#define PORT6_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields port5	 */
#define PORT5_WIDTH                                                           1
#define PORT5_SHIFT                                                           5
#define PORT5_MASK                                                   0x00000020
#define PORT5_RD(src)                                 (((src) & 0x00000020)>>5)
#define PORT5_WR(src)                            (((u32)(src)<<5) & 0x00000020)
#define PORT5_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields port4	 */
#define PORT4_WIDTH                                                           1
#define PORT4_SHIFT                                                           4
#define PORT4_MASK                                                   0x00000010
#define PORT4_RD(src)                                 (((src) & 0x00000010)>>4)
#define PORT4_WR(src)                            (((u32)(src)<<4) & 0x00000010)
#define PORT4_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields port3	 */
#define PORT3_WIDTH                                                           1
#define PORT3_SHIFT                                                           3
#define PORT3_MASK                                                   0x00000008
#define PORT3_RD(src)                                 (((src) & 0x00000008)>>3)
#define PORT3_WR(src)                            (((u32)(src)<<3) & 0x00000008)
#define PORT3_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields port2	 */
#define PORT2_WIDTH                                                           1
#define PORT2_SHIFT                                                           2
#define PORT2_MASK                                                   0x00000004
#define PORT2_RD(src)                                 (((src) & 0x00000004)>>2)
#define PORT2_WR(src)                            (((u32)(src)<<2) & 0x00000004)
#define PORT2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields port1	 */
#define PORT1_F3_WIDTH                                                        1
#define PORT1_F3_SHIFT                                                        1
#define PORT1_F3_MASK                                                0x00000002
#define PORT1_F3_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F3_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define PORT1_F3_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F3_WIDTH                                                        1
#define PORT0_F3_SHIFT                                                        0
#define PORT0_F3_MASK                                                0x00000001
#define PORT0_F3_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F3_WR(src)                            (((u32)(src)) & 0x00000001)
#define PORT0_F3_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register autopoll_link_sts_intrMask	*/
/*    Mask Register Fields port8Mask    */
#define PORT8MASK_WIDTH                                                       1
#define PORT8MASK_SHIFT                                                       8
#define PORT8MASK_MASK                                               0x00000100
#define PORT8MASK_RD(src)                             (((src) & 0x00000100)>>8)
#define PORT8MASK_WR(src)                        (((u32)(src)<<8) & 0x00000100)
#define PORT8MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields port7Mask    */
#define PORT7MASK_WIDTH                                                       1
#define PORT7MASK_SHIFT                                                       7
#define PORT7MASK_MASK                                               0x00000080
#define PORT7MASK_RD(src)                             (((src) & 0x00000080)>>7)
#define PORT7MASK_WR(src)                        (((u32)(src)<<7) & 0x00000080)
#define PORT7MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields port6Mask    */
#define PORT6MASK_WIDTH                                                       1
#define PORT6MASK_SHIFT                                                       6
#define PORT6MASK_MASK                                               0x00000040
#define PORT6MASK_RD(src)                             (((src) & 0x00000040)>>6)
#define PORT6MASK_WR(src)                        (((u32)(src)<<6) & 0x00000040)
#define PORT6MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields port5Mask    */
#define PORT5MASK_WIDTH                                                       1
#define PORT5MASK_SHIFT                                                       5
#define PORT5MASK_MASK                                               0x00000020
#define PORT5MASK_RD(src)                             (((src) & 0x00000020)>>5)
#define PORT5MASK_WR(src)                        (((u32)(src)<<5) & 0x00000020)
#define PORT5MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields port4Mask    */
#define PORT4MASK_WIDTH                                                       1
#define PORT4MASK_SHIFT                                                       4
#define PORT4MASK_MASK                                               0x00000010
#define PORT4MASK_RD(src)                             (((src) & 0x00000010)>>4)
#define PORT4MASK_WR(src)                        (((u32)(src)<<4) & 0x00000010)
#define PORT4MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields port3Mask    */
#define PORT3MASK_WIDTH                                                       1
#define PORT3MASK_SHIFT                                                       3
#define PORT3MASK_MASK                                               0x00000008
#define PORT3MASK_RD(src)                             (((src) & 0x00000008)>>3)
#define PORT3MASK_WR(src)                        (((u32)(src)<<3) & 0x00000008)
#define PORT3MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields port2Mask    */
#define PORT2MASK_WIDTH                                                       1
#define PORT2MASK_SHIFT                                                       2
#define PORT2MASK_MASK                                               0x00000004
#define PORT2MASK_RD(src)                             (((src) & 0x00000004)>>2)
#define PORT2MASK_WR(src)                        (((u32)(src)<<2) & 0x00000004)
#define PORT2MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields port1Mask    */
#define PORT1MASK_WIDTH                                                       1
#define PORT1MASK_SHIFT                                                       1
#define PORT1MASK_MASK                                               0x00000002
#define PORT1MASK_RD(src)                             (((src) & 0x00000002)>>1)
#define PORT1MASK_WR(src)                        (((u32)(src)<<1) & 0x00000002)
#define PORT1MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields port0Mask    */
#define PORT0MASK_WIDTH                                                       1
#define PORT0MASK_SHIFT                                                       0
#define PORT0MASK_MASK                                               0x00000001
#define PORT0MASK_RD(src)                                (((src) & 0x00000001))
#define PORT0MASK_WR(src)                           (((u32)(src)) & 0x00000001)
#define PORT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register autopoll_link_status	*/ 
/*	 Fields port8	 */
#define PORT8_F1_WIDTH                                                        1
#define PORT8_F1_SHIFT                                                        8
#define PORT8_F1_MASK                                                0x00000100
#define PORT8_F1_RD(src)                              (((src) & 0x00000100)>>8)
#define PORT8_F1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields port7	 */
#define PORT7_F1_WIDTH                                                        1
#define PORT7_F1_SHIFT                                                        7
#define PORT7_F1_MASK                                                0x00000080
#define PORT7_F1_RD(src)                              (((src) & 0x00000080)>>7)
#define PORT7_F1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields port6	 */
#define PORT6_F1_WIDTH                                                        1
#define PORT6_F1_SHIFT                                                        6
#define PORT6_F1_MASK                                                0x00000040
#define PORT6_F1_RD(src)                              (((src) & 0x00000040)>>6)
#define PORT6_F1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields port5	 */
#define PORT5_F1_WIDTH                                                        1
#define PORT5_F1_SHIFT                                                        5
#define PORT5_F1_MASK                                                0x00000020
#define PORT5_F1_RD(src)                              (((src) & 0x00000020)>>5)
#define PORT5_F1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields port4	 */
#define PORT4_F1_WIDTH                                                        1
#define PORT4_F1_SHIFT                                                        4
#define PORT4_F1_MASK                                                0x00000010
#define PORT4_F1_RD(src)                              (((src) & 0x00000010)>>4)
#define PORT4_F1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields port3	 */
#define PORT3_F1_WIDTH                                                        1
#define PORT3_F1_SHIFT                                                        3
#define PORT3_F1_MASK                                                0x00000008
#define PORT3_F1_RD(src)                              (((src) & 0x00000008)>>3)
#define PORT3_F1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields port2	 */
#define PORT2_F1_WIDTH                                                        1
#define PORT2_F1_SHIFT                                                        2
#define PORT2_F1_MASK                                                0x00000004
#define PORT2_F1_RD(src)                              (((src) & 0x00000004)>>2)
#define PORT2_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields port1	 */
#define PORT1_F4_WIDTH                                                        1
#define PORT1_F4_SHIFT                                                        1
#define PORT1_F4_MASK                                                0x00000002
#define PORT1_F4_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F4_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F4_WIDTH                                                        1
#define PORT0_F4_SHIFT                                                        0
#define PORT0_F4_MASK                                                0x00000001
#define PORT0_F4_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F4_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register MH_FIFO_full_thresh_0	*/ 
/*	 Fields cfg_prio7_ffull_thresh	 */
#define CFG_PRIO7_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO7_FFULL_THRESH0_SHIFT                                        28
#define CFG_PRIO7_FFULL_THRESH0_MASK                                 0xf0000000
#define CFG_PRIO7_FFULL_THRESH0_RD(src)              (((src) & 0xf0000000)>>28)
#define CFG_PRIO7_FFULL_THRESH0_WR(src)         (((u32)(src)<<28) & 0xf0000000)
#define CFG_PRIO7_FFULL_THRESH0_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields cfg_prio6_ffull_thresh	 */
#define CFG_PRIO6_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO6_FFULL_THRESH0_SHIFT                                        24
#define CFG_PRIO6_FFULL_THRESH0_MASK                                 0x0f000000
#define CFG_PRIO6_FFULL_THRESH0_RD(src)              (((src) & 0x0f000000)>>24)
#define CFG_PRIO6_FFULL_THRESH0_WR(src)         (((u32)(src)<<24) & 0x0f000000)
#define CFG_PRIO6_FFULL_THRESH0_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields cfg_prio5_ffull_thresh	 */
#define CFG_PRIO5_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO5_FFULL_THRESH0_SHIFT                                        20
#define CFG_PRIO5_FFULL_THRESH0_MASK                                 0x00f00000
#define CFG_PRIO5_FFULL_THRESH0_RD(src)              (((src) & 0x00f00000)>>20)
#define CFG_PRIO5_FFULL_THRESH0_WR(src)         (((u32)(src)<<20) & 0x00f00000)
#define CFG_PRIO5_FFULL_THRESH0_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_prio4_ffull_thresh	 */
#define CFG_PRIO4_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO4_FFULL_THRESH0_SHIFT                                        16
#define CFG_PRIO4_FFULL_THRESH0_MASK                                 0x000f0000
#define CFG_PRIO4_FFULL_THRESH0_RD(src)              (((src) & 0x000f0000)>>16)
#define CFG_PRIO4_FFULL_THRESH0_WR(src)         (((u32)(src)<<16) & 0x000f0000)
#define CFG_PRIO4_FFULL_THRESH0_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_prio3_ffull_thresh	 */
#define CFG_PRIO3_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO3_FFULL_THRESH0_SHIFT                                        12
#define CFG_PRIO3_FFULL_THRESH0_MASK                                 0x0000f000
#define CFG_PRIO3_FFULL_THRESH0_RD(src)              (((src) & 0x0000f000)>>12)
#define CFG_PRIO3_FFULL_THRESH0_WR(src)         (((u32)(src)<<12) & 0x0000f000)
#define CFG_PRIO3_FFULL_THRESH0_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields cfg_prio2_ffull_thresh	 */
#define CFG_PRIO2_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO2_FFULL_THRESH0_SHIFT                                         8
#define CFG_PRIO2_FFULL_THRESH0_MASK                                 0x00000f00
#define CFG_PRIO2_FFULL_THRESH0_RD(src)               (((src) & 0x00000f00)>>8)
#define CFG_PRIO2_FFULL_THRESH0_WR(src)          (((u32)(src)<<8) & 0x00000f00)
#define CFG_PRIO2_FFULL_THRESH0_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields cfg_prio1_ffull_thresh	 */
#define CFG_PRIO1_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO1_FFULL_THRESH0_SHIFT                                         4
#define CFG_PRIO1_FFULL_THRESH0_MASK                                 0x000000f0
#define CFG_PRIO1_FFULL_THRESH0_RD(src)               (((src) & 0x000000f0)>>4)
#define CFG_PRIO1_FFULL_THRESH0_WR(src)          (((u32)(src)<<4) & 0x000000f0)
#define CFG_PRIO1_FFULL_THRESH0_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_prio0_ffull_thresh	 */
#define CFG_PRIO0_FFULL_THRESH0_WIDTH                                         4
#define CFG_PRIO0_FFULL_THRESH0_SHIFT                                         0
#define CFG_PRIO0_FFULL_THRESH0_MASK                                 0x0000000f
#define CFG_PRIO0_FFULL_THRESH0_RD(src)                  (((src) & 0x0000000f))
#define CFG_PRIO0_FFULL_THRESH0_WR(src)             (((u32)(src)) & 0x0000000f)
#define CFG_PRIO0_FFULL_THRESH0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register MH_FIFO_full_thresh_1	*/ 
/*	 Fields cfg_prio7_ffull_thresh	 */
#define CFG_PRIO7_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO7_FFULL_THRESH1_SHIFT                                        28
#define CFG_PRIO7_FFULL_THRESH1_MASK                                 0xf0000000
#define CFG_PRIO7_FFULL_THRESH1_RD(src)              (((src) & 0xf0000000)>>28)
#define CFG_PRIO7_FFULL_THRESH1_WR(src)         (((u32)(src)<<28) & 0xf0000000)
#define CFG_PRIO7_FFULL_THRESH1_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields cfg_prio6_ffull_thresh	 */
#define CFG_PRIO6_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO6_FFULL_THRESH1_SHIFT                                        24
#define CFG_PRIO6_FFULL_THRESH1_MASK                                 0x0f000000
#define CFG_PRIO6_FFULL_THRESH1_RD(src)              (((src) & 0x0f000000)>>24)
#define CFG_PRIO6_FFULL_THRESH1_WR(src)         (((u32)(src)<<24) & 0x0f000000)
#define CFG_PRIO6_FFULL_THRESH1_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields cfg_prio5_ffull_thresh	 */
#define CFG_PRIO5_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO5_FFULL_THRESH1_SHIFT                                        20
#define CFG_PRIO5_FFULL_THRESH1_MASK                                 0x00f00000
#define CFG_PRIO5_FFULL_THRESH1_RD(src)              (((src) & 0x00f00000)>>20)
#define CFG_PRIO5_FFULL_THRESH1_WR(src)         (((u32)(src)<<20) & 0x00f00000)
#define CFG_PRIO5_FFULL_THRESH1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_prio4_ffull_thresh	 */
#define CFG_PRIO4_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO4_FFULL_THRESH1_SHIFT                                        16
#define CFG_PRIO4_FFULL_THRESH1_MASK                                 0x000f0000
#define CFG_PRIO4_FFULL_THRESH1_RD(src)              (((src) & 0x000f0000)>>16)
#define CFG_PRIO4_FFULL_THRESH1_WR(src)         (((u32)(src)<<16) & 0x000f0000)
#define CFG_PRIO4_FFULL_THRESH1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_prio3_ffull_thresh	 */
#define CFG_PRIO3_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO3_FFULL_THRESH1_SHIFT                                        12
#define CFG_PRIO3_FFULL_THRESH1_MASK                                 0x0000f000
#define CFG_PRIO3_FFULL_THRESH1_RD(src)              (((src) & 0x0000f000)>>12)
#define CFG_PRIO3_FFULL_THRESH1_WR(src)         (((u32)(src)<<12) & 0x0000f000)
#define CFG_PRIO3_FFULL_THRESH1_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields cfg_prio2_ffull_thresh	 */
#define CFG_PRIO2_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO2_FFULL_THRESH1_SHIFT                                         8
#define CFG_PRIO2_FFULL_THRESH1_MASK                                 0x00000f00
#define CFG_PRIO2_FFULL_THRESH1_RD(src)               (((src) & 0x00000f00)>>8)
#define CFG_PRIO2_FFULL_THRESH1_WR(src)          (((u32)(src)<<8) & 0x00000f00)
#define CFG_PRIO2_FFULL_THRESH1_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields cfg_prio1_ffull_thresh	 */
#define CFG_PRIO1_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO1_FFULL_THRESH1_SHIFT                                         4
#define CFG_PRIO1_FFULL_THRESH1_MASK                                 0x000000f0
#define CFG_PRIO1_FFULL_THRESH1_RD(src)               (((src) & 0x000000f0)>>4)
#define CFG_PRIO1_FFULL_THRESH1_WR(src)          (((u32)(src)<<4) & 0x000000f0)
#define CFG_PRIO1_FFULL_THRESH1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_prio0_ffull_thresh	 */
#define CFG_PRIO0_FFULL_THRESH1_WIDTH                                         4
#define CFG_PRIO0_FFULL_THRESH1_SHIFT                                         0
#define CFG_PRIO0_FFULL_THRESH1_MASK                                 0x0000000f
#define CFG_PRIO0_FFULL_THRESH1_RD(src)                  (((src) & 0x0000000f))
#define CFG_PRIO0_FFULL_THRESH1_WR(src)             (((u32)(src)) & 0x0000000f)
#define CFG_PRIO0_FFULL_THRESH1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register DEALLOC_FIFO_full_thresh_0	*/ 
/*	 Fields cfg_dealloc_ffull_thresh	 */
#define CFG_DEALLOC_FFULL_THRESH0_WIDTH                                       4
#define CFG_DEALLOC_FFULL_THRESH0_SHIFT                                       0
#define CFG_DEALLOC_FFULL_THRESH0_MASK                               0x0000000f
#define CFG_DEALLOC_FFULL_THRESH0_RD(src)                (((src) & 0x0000000f))
#define CFG_DEALLOC_FFULL_THRESH0_WR(src)           (((u32)(src)) & 0x0000000f)
#define CFG_DEALLOC_FFULL_THRESH0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register DEALLOC_FIFO_full_thresh_1	*/ 
/*	 Fields cfg_dealloc_ffull_thresh	 */
#define CFG_DEALLOC_FFULL_THRESH1_WIDTH                                       4
#define CFG_DEALLOC_FFULL_THRESH1_SHIFT                                       0
#define CFG_DEALLOC_FFULL_THRESH1_MASK                               0x0000000f
#define CFG_DEALLOC_FFULL_THRESH1_RD(src)                (((src) & 0x0000000f))
#define CFG_DEALLOC_FFULL_THRESH1_WR(src)           (((u32)(src)) & 0x0000000f)
#define CFG_DEALLOC_FFULL_THRESH1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register TSO_FIFO_Status	*/ 
/*	 Fields prio0_fifo_rlevelcnt_prt1	 */
#define PRIO0_FIFO_RLEVELCNT_PRT1_WIDTH                                       4
#define PRIO0_FIFO_RLEVELCNT_PRT1_SHIFT                                      24
#define PRIO0_FIFO_RLEVELCNT_PRT1_MASK                               0x0f000000
#define PRIO0_FIFO_RLEVELCNT_PRT1_RD(src)            (((src) & 0x0f000000)>>24)
#define PRIO0_FIFO_RLEVELCNT_PRT1_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields mh_dealloc_RLevelCnt_prt1	 */
#define MH_DEALLOC_RLEVELCNT_PRT1_WIDTH                                       4
#define MH_DEALLOC_RLEVELCNT_PRT1_SHIFT                                      20
#define MH_DEALLOC_RLEVELCNT_PRT1_MASK                               0x00f00000
#define MH_DEALLOC_RLEVELCNT_PRT1_RD(src)            (((src) & 0x00f00000)>>20)
#define MH_DEALLOC_RLEVELCNT_PRT1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields mb_ttf_rlevelcnt_prt1	 */
#define MB_TTF_RLEVELCNT_PRT1_WIDTH                                           4
#define MB_TTF_RLEVELCNT_PRT1_SHIFT                                          16
#define MB_TTF_RLEVELCNT_PRT1_MASK                                   0x000f0000
#define MB_TTF_RLEVELCNT_PRT1_RD(src)                (((src) & 0x000f0000)>>16)
#define MB_TTF_RLEVELCNT_PRT1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields prio0_fifo_rlevelcnt_prt0	 */
#define PRIO0_FIFO_RLEVELCNT_PRT0_WIDTH                                       4
#define PRIO0_FIFO_RLEVELCNT_PRT0_SHIFT                                       8
#define PRIO0_FIFO_RLEVELCNT_PRT0_MASK                               0x00000f00
#define PRIO0_FIFO_RLEVELCNT_PRT0_RD(src)             (((src) & 0x00000f00)>>8)
#define PRIO0_FIFO_RLEVELCNT_PRT0_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields mh_dealloc_RLevelCnt_prt0	 */
#define MH_DEALLOC_RLEVELCNT_PRT0_WIDTH                                       4
#define MH_DEALLOC_RLEVELCNT_PRT0_SHIFT                                       4
#define MH_DEALLOC_RLEVELCNT_PRT0_MASK                               0x000000f0
#define MH_DEALLOC_RLEVELCNT_PRT0_RD(src)             (((src) & 0x000000f0)>>4)
#define MH_DEALLOC_RLEVELCNT_PRT0_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields mb_ttf_rlevelcnt_prt0	 */
#define MB_TTF_RLEVELCNT_PRT0_WIDTH                                           4
#define MB_TTF_RLEVELCNT_PRT0_SHIFT                                           0
#define MB_TTF_RLEVELCNT_PRT0_MASK                                   0x0000000f
#define MB_TTF_RLEVELCNT_PRT0_RD(src)                    (((src) & 0x0000000f))
#define MB_TTF_RLEVELCNT_PRT0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register TSO_cfg_0	*/ 
/*	 Fields tcp_flag_position	 */
#define TCP_FLAG_POSITION0_WIDTH                                              2
#define TCP_FLAG_POSITION0_SHIFT                                              6
#define TCP_FLAG_POSITION0_MASK                                      0x000000c0
#define TCP_FLAG_POSITION0_RD(src)                    (((src) & 0x000000c0)>>6)
#define TCP_FLAG_POSITION0_WR(src)               (((u32)(src)<<6) & 0x000000c0)
#define TCP_FLAG_POSITION0_SET(dst,src) \
                       (((dst) & ~0x000000c0) | (((u32)(src)<<6) & 0x000000c0))
/*	 Fields mac_prop_hdr_len	 */
#define MAC_PROP_HDR_LEN0_WIDTH                                               6
#define MAC_PROP_HDR_LEN0_SHIFT                                               0
#define MAC_PROP_HDR_LEN0_MASK                                       0x0000003f
#define MAC_PROP_HDR_LEN0_RD(src)                        (((src) & 0x0000003f))
#define MAC_PROP_HDR_LEN0_WR(src)                   (((u32)(src)) & 0x0000003f)
#define MAC_PROP_HDR_LEN0_SET(dst,src) \
                          (((dst) & ~0x0000003f) | (((u32)(src)) & 0x0000003f))

/*	Register TSO_cfg_1	*/ 
/*	 Fields tcp_flag_position	 */
#define TCP_FLAG_POSITION1_WIDTH                                              2
#define TCP_FLAG_POSITION1_SHIFT                                              6
#define TCP_FLAG_POSITION1_MASK                                      0x000000c0
#define TCP_FLAG_POSITION1_RD(src)                    (((src) & 0x000000c0)>>6)
#define TCP_FLAG_POSITION1_WR(src)               (((u32)(src)<<6) & 0x000000c0)
#define TCP_FLAG_POSITION1_SET(dst,src) \
                       (((dst) & ~0x000000c0) | (((u32)(src)<<6) & 0x000000c0))
/*	 Fields mac_prop_hdr_len	 */
#define MAC_PROP_HDR_LEN1_WIDTH                                               6
#define MAC_PROP_HDR_LEN1_SHIFT                                               0
#define MAC_PROP_HDR_LEN1_MASK                                       0x0000003f
#define MAC_PROP_HDR_LEN1_RD(src)                        (((src) & 0x0000003f))
#define MAC_PROP_HDR_LEN1_WR(src)                   (((u32)(src)) & 0x0000003f)
#define MAC_PROP_HDR_LEN1_SET(dst,src) \
                          (((dst) & ~0x0000003f) | (((u32)(src)) & 0x0000003f))

/*	Register TSO_cfg_insert_vlan_0	*/ 
/*	 Fields id_tag	 */
#define ID_TAG0_WIDTH                                                        32
#define ID_TAG0_SHIFT                                                         0
#define ID_TAG0_MASK                                                 0xffffffff
#define ID_TAG0_RD(src)                                  (((src) & 0xffffffff))
#define ID_TAG0_WR(src)                             (((u32)(src)) & 0xffffffff)
#define ID_TAG0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register TSO_cfg_insert_vlan_1	*/ 
/*	 Fields id_tag	 */
#define ID_TAG1_WIDTH                                                        32
#define ID_TAG1_SHIFT                                                         0
#define ID_TAG1_MASK                                                 0xffffffff
#define ID_TAG1_RD(src)                                  (((src) & 0xffffffff))
#define ID_TAG1_WR(src)                             (((u32)(src)) & 0xffffffff)
#define ID_TAG1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register TSO_Int_Reg0	*/ 
/*	 Fields mb_ttf_fifo_overfl_intr_prt1	 */
#define MB_TTF_FIFO_OVERFL_INTR_PRT10_WIDTH                                   1
#define MB_TTF_FIFO_OVERFL_INTR_PRT10_SHIFT                                  21
#define MB_TTF_FIFO_OVERFL_INTR_PRT10_MASK                           0x00200000
#define MB_TTF_FIFO_OVERFL_INTR_PRT10_RD(src)        (((src) & 0x00200000)>>21)
#define MB_TTF_FIFO_OVERFL_INTR_PRT10_WR(src)   (((u32)(src)<<21) & 0x00200000)
#define MB_TTF_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields mb_ttf_fifo_underfl_intr_prt1	 */
#define MB_TTF_FIFO_UNDERFL_INTR_PRT10_WIDTH                                  1
#define MB_TTF_FIFO_UNDERFL_INTR_PRT10_SHIFT                                 20
#define MB_TTF_FIFO_UNDERFL_INTR_PRT10_MASK                          0x00100000
#define MB_TTF_FIFO_UNDERFL_INTR_PRT10_RD(src)       (((src) & 0x00100000)>>20)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT10_WR(src)  (((u32)(src)<<20) & 0x00100000)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields mh_dealloc_fifo_overfl_intr_prt1	 */
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT10_WIDTH                               1
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT10_SHIFT                              19
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT10_MASK                       0x00080000
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT10_RD(src)    (((src) & 0x00080000)>>19)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields mh_dealloc_fifo_underfl_intr_prt1	 */
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT10_WIDTH                              1
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT10_SHIFT                             18
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT10_MASK                      0x00040000
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT10_RD(src)   (((src) & 0x00040000)>>18)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields mh_fifo_overfl_intr_prt1	 */
#define MH_FIFO_OVERFL_INTR_PRT10_WIDTH                                       1
#define MH_FIFO_OVERFL_INTR_PRT10_SHIFT                                      17
#define MH_FIFO_OVERFL_INTR_PRT10_MASK                               0x00020000
#define MH_FIFO_OVERFL_INTR_PRT10_RD(src)            (((src) & 0x00020000)>>17)
#define MH_FIFO_OVERFL_INTR_PRT10_WR(src)       (((u32)(src)<<17) & 0x00020000)
#define MH_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields mh_fifo_underfl_intr_prt1	 */
#define MH_FIFO_UNDERFL_INTR_PRT10_WIDTH                                      1
#define MH_FIFO_UNDERFL_INTR_PRT10_SHIFT                                     16
#define MH_FIFO_UNDERFL_INTR_PRT10_MASK                              0x00010000
#define MH_FIFO_UNDERFL_INTR_PRT10_RD(src)           (((src) & 0x00010000)>>16)
#define MH_FIFO_UNDERFL_INTR_PRT10_WR(src)      (((u32)(src)<<16) & 0x00010000)
#define MH_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields mb_ttf_fifo_overfl_intr_prt0	 */
#define MB_TTF_FIFO_OVERFL_INTR_PRT00_WIDTH                                   1
#define MB_TTF_FIFO_OVERFL_INTR_PRT00_SHIFT                                   5
#define MB_TTF_FIFO_OVERFL_INTR_PRT00_MASK                           0x00000020
#define MB_TTF_FIFO_OVERFL_INTR_PRT00_RD(src)         (((src) & 0x00000020)>>5)
#define MB_TTF_FIFO_OVERFL_INTR_PRT00_WR(src)    (((u32)(src)<<5) & 0x00000020)
#define MB_TTF_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields mb_ttf_fifo_underfl_intr_prt0	 */
#define MB_TTF_FIFO_UNDERFL_INTR_PRT00_WIDTH                                  1
#define MB_TTF_FIFO_UNDERFL_INTR_PRT00_SHIFT                                  4
#define MB_TTF_FIFO_UNDERFL_INTR_PRT00_MASK                          0x00000010
#define MB_TTF_FIFO_UNDERFL_INTR_PRT00_RD(src)        (((src) & 0x00000010)>>4)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT00_WR(src)   (((u32)(src)<<4) & 0x00000010)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields mh_dealloc_fifo_overfl_intr_prt0	 */
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT00_WIDTH                               1
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT00_SHIFT                               3
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT00_MASK                       0x00000008
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT00_RD(src)     (((src) & 0x00000008)>>3)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields mh_dealloc_fifo_underfl_intr_prt0	 */
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT00_WIDTH                              1
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT00_SHIFT                              2
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT00_MASK                      0x00000004
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT00_RD(src)    (((src) & 0x00000004)>>2)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields mh_fifo_overfl_intr_prt0	 */
#define MH_FIFO_OVERFL_INTR_PRT00_WIDTH                                       1
#define MH_FIFO_OVERFL_INTR_PRT00_SHIFT                                       1
#define MH_FIFO_OVERFL_INTR_PRT00_MASK                               0x00000002
#define MH_FIFO_OVERFL_INTR_PRT00_RD(src)             (((src) & 0x00000002)>>1)
#define MH_FIFO_OVERFL_INTR_PRT00_WR(src)        (((u32)(src)<<1) & 0x00000002)
#define MH_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields mh_fifo_underfl_intr_prt0	 */
#define MH_FIFO_UNDERFL_INTR_PRT00_WIDTH                                      1
#define MH_FIFO_UNDERFL_INTR_PRT00_SHIFT                                      0
#define MH_FIFO_UNDERFL_INTR_PRT00_MASK                              0x00000001
#define MH_FIFO_UNDERFL_INTR_PRT00_RD(src)               (((src) & 0x00000001))
#define MH_FIFO_UNDERFL_INTR_PRT00_WR(src)          (((u32)(src)) & 0x00000001)
#define MH_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TSO_Int_Reg0Mask	*/
/*    Mask Register Fields mb_ttf_fifo_overfl_intr_prt1Mask    */
#define MB_TTF_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                                1
#define MB_TTF_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                               21
#define MB_TTF_FIFO_OVERFL_INTR_PRT1MASK_MASK                        0x00200000
#define MB_TTF_FIFO_OVERFL_INTR_PRT1MASK_RD(src)     (((src) & 0x00200000)>>21)
#define MB_TTF_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define MB_TTF_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields mb_ttf_fifo_underfl_intr_prt1Mask    */
#define MB_TTF_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                               1
#define MB_TTF_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                              20
#define MB_TTF_FIFO_UNDERFL_INTR_PRT1MASK_MASK                       0x00100000
#define MB_TTF_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)    (((src) & 0x00100000)>>20)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields mh_dealloc_fifo_overfl_intr_prt1Mask    */
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                            1
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                           19
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT1MASK_MASK                    0x00080000
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00080000)>>19)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields mh_dealloc_fifo_underfl_intr_prt1Mask    */
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                           1
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                          18
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT1MASK_MASK                   0x00040000
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x00040000)>>18)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields mh_fifo_overfl_intr_prt1Mask    */
#define MH_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                                    1
#define MH_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                                   17
#define MH_FIFO_OVERFL_INTR_PRT1MASK_MASK                            0x00020000
#define MH_FIFO_OVERFL_INTR_PRT1MASK_RD(src)         (((src) & 0x00020000)>>17)
#define MH_FIFO_OVERFL_INTR_PRT1MASK_WR(src)    (((u32)(src)<<17) & 0x00020000)
#define MH_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields mh_fifo_underfl_intr_prt1Mask    */
#define MH_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                                   1
#define MH_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                                  16
#define MH_FIFO_UNDERFL_INTR_PRT1MASK_MASK                           0x00010000
#define MH_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)        (((src) & 0x00010000)>>16)
#define MH_FIFO_UNDERFL_INTR_PRT1MASK_WR(src)   (((u32)(src)<<16) & 0x00010000)
#define MH_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields mb_ttf_fifo_overfl_intr_prt0Mask    */
#define MB_TTF_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                                1
#define MB_TTF_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                                5
#define MB_TTF_FIFO_OVERFL_INTR_PRT0MASK_MASK                        0x00000020
#define MB_TTF_FIFO_OVERFL_INTR_PRT0MASK_RD(src)      (((src) & 0x00000020)>>5)
#define MB_TTF_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define MB_TTF_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields mb_ttf_fifo_underfl_intr_prt0Mask    */
#define MB_TTF_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                               1
#define MB_TTF_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                               4
#define MB_TTF_FIFO_UNDERFL_INTR_PRT0MASK_MASK                       0x00000010
#define MB_TTF_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)     (((src) & 0x00000010)>>4)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define MB_TTF_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields mh_dealloc_fifo_overfl_intr_prt0Mask    */
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                            1
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                            3
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT0MASK_MASK                    0x00000008
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT0MASK_RD(src)  (((src) & 0x00000008)>>3)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define MH_DEALLOC_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields mh_dealloc_fifo_underfl_intr_prt0Mask    */
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                           1
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                           2
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT0MASK_MASK                   0x00000004
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT0MASK_RD(src) \
                                                     (((src) & 0x00000004)>>2)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define MH_DEALLOC_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields mh_fifo_overfl_intr_prt0Mask    */
#define MH_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                                    1
#define MH_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                                    1
#define MH_FIFO_OVERFL_INTR_PRT0MASK_MASK                            0x00000002
#define MH_FIFO_OVERFL_INTR_PRT0MASK_RD(src)          (((src) & 0x00000002)>>1)
#define MH_FIFO_OVERFL_INTR_PRT0MASK_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define MH_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields mh_fifo_underfl_intr_prt0Mask    */
#define MH_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                                   1
#define MH_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                                   0
#define MH_FIFO_UNDERFL_INTR_PRT0MASK_MASK                           0x00000001
#define MH_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)            (((src) & 0x00000001))
#define MH_FIFO_UNDERFL_INTR_PRT0MASK_WR(src)       (((u32)(src)) & 0x00000001)
#define MH_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register TTF_FIFO_full_thresh_0	*/ 
/*	 Fields cfg_ttf_ffull_thresh	 */
#define CFG_TTF_FFULL_THRESH0_WIDTH                                           4
#define CFG_TTF_FFULL_THRESH0_SHIFT                                           0
#define CFG_TTF_FFULL_THRESH0_MASK                                   0x0000000f
#define CFG_TTF_FFULL_THRESH0_RD(src)                    (((src) & 0x0000000f))
#define CFG_TTF_FFULL_THRESH0_WR(src)               (((u32)(src)) & 0x0000000f)
#define CFG_TTF_FFULL_THRESH0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register TTF_FIFO_full_thresh_1	*/ 
/*	 Fields cfg_ttf_ffull_thresh	 */
#define CFG_TTF_FFULL_THRESH1_WIDTH                                           4
#define CFG_TTF_FFULL_THRESH1_SHIFT                                           0
#define CFG_TTF_FFULL_THRESH1_MASK                                   0x0000000f
#define CFG_TTF_FFULL_THRESH1_RD(src)                    (((src) & 0x0000000f))
#define CFG_TTF_FFULL_THRESH1_WR(src)               (((u32)(src)) & 0x0000000f)
#define CFG_TTF_FFULL_THRESH1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register TSO_cfg_flags	*/ 
/*	 Fields cfg_reset_ack_num	 */
#define CFG_RESET_ACK_NUM_WIDTH                                               1
#define CFG_RESET_ACK_NUM_SHIFT                                              13
#define CFG_RESET_ACK_NUM_MASK                                       0x00002000
#define CFG_RESET_ACK_NUM_RD(src)                    (((src) & 0x00002000)>>13)
#define CFG_RESET_ACK_NUM_WR(src)               (((u32)(src)<<13) & 0x00002000)
#define CFG_RESET_ACK_NUM_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields cfg_reset_urg_ptr	 */
#define CFG_RESET_URG_PTR_WIDTH                                               1
#define CFG_RESET_URG_PTR_SHIFT                                              12
#define CFG_RESET_URG_PTR_MASK                                       0x00001000
#define CFG_RESET_URG_PTR_RD(src)                    (((src) & 0x00001000)>>12)
#define CFG_RESET_URG_PTR_WR(src)               (((u32)(src)<<12) & 0x00001000)
#define CFG_RESET_URG_PTR_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields cfg_set_urg_flag	 */
#define CFG_SET_URG_FLAG_WIDTH                                                2
#define CFG_SET_URG_FLAG_SHIFT                                               10
#define CFG_SET_URG_FLAG_MASK                                        0x00000c00
#define CFG_SET_URG_FLAG_RD(src)                     (((src) & 0x00000c00)>>10)
#define CFG_SET_URG_FLAG_WR(src)                (((u32)(src)<<10) & 0x00000c00)
#define CFG_SET_URG_FLAG_SET(dst,src) \
                      (((dst) & ~0x00000c00) | (((u32)(src)<<10) & 0x00000c00))
/*	 Fields cfg_set_ack_flag	 */
#define CFG_SET_ACK_FLAG_WIDTH                                                2
#define CFG_SET_ACK_FLAG_SHIFT                                                8
#define CFG_SET_ACK_FLAG_MASK                                        0x00000300
#define CFG_SET_ACK_FLAG_RD(src)                      (((src) & 0x00000300)>>8)
#define CFG_SET_ACK_FLAG_WR(src)                 (((u32)(src)<<8) & 0x00000300)
#define CFG_SET_ACK_FLAG_SET(dst,src) \
                       (((dst) & ~0x00000300) | (((u32)(src)<<8) & 0x00000300))
/*	 Fields cfg_set_psh_flag	 */
#define CFG_SET_PSH_FLAG_WIDTH                                                2
#define CFG_SET_PSH_FLAG_SHIFT                                                6
#define CFG_SET_PSH_FLAG_MASK                                        0x000000c0
#define CFG_SET_PSH_FLAG_RD(src)                      (((src) & 0x000000c0)>>6)
#define CFG_SET_PSH_FLAG_WR(src)                 (((u32)(src)<<6) & 0x000000c0)
#define CFG_SET_PSH_FLAG_SET(dst,src) \
                       (((dst) & ~0x000000c0) | (((u32)(src)<<6) & 0x000000c0))
/*	 Fields cfg_set_rst_flag	 */
#define CFG_SET_RST_FLAG_WIDTH                                                2
#define CFG_SET_RST_FLAG_SHIFT                                                4
#define CFG_SET_RST_FLAG_MASK                                        0x00000030
#define CFG_SET_RST_FLAG_RD(src)                      (((src) & 0x00000030)>>4)
#define CFG_SET_RST_FLAG_WR(src)                 (((u32)(src)<<4) & 0x00000030)
#define CFG_SET_RST_FLAG_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_set_syn_flag	 */
#define CFG_SET_SYN_FLAG_WIDTH                                                2
#define CFG_SET_SYN_FLAG_SHIFT                                                2
#define CFG_SET_SYN_FLAG_MASK                                        0x0000000c
#define CFG_SET_SYN_FLAG_RD(src)                      (((src) & 0x0000000c)>>2)
#define CFG_SET_SYN_FLAG_WR(src)                 (((u32)(src)<<2) & 0x0000000c)
#define CFG_SET_SYN_FLAG_SET(dst,src) \
                       (((dst) & ~0x0000000c) | (((u32)(src)<<2) & 0x0000000c))
/*	 Fields cfg_set_fin_flag	 */
#define CFG_SET_FIN_FLAG_WIDTH                                                2
#define CFG_SET_FIN_FLAG_SHIFT                                                0
#define CFG_SET_FIN_FLAG_MASK                                        0x00000003
#define CFG_SET_FIN_FLAG_RD(src)                         (((src) & 0x00000003))
#define CFG_SET_FIN_FLAG_WR(src)                    (((u32)(src)) & 0x00000003)
#define CFG_SET_FIN_FLAG_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register SPI2SAP_AddSPI_Reg	*/ 
/*	 Fields cfg_spi2sap_add_rid	 */
#define CFG_SPI2SAP_ADD_RID_WIDTH                                            32
#define CFG_SPI2SAP_ADD_RID_SHIFT                                             0
#define CFG_SPI2SAP_ADD_RID_MASK                                     0xffffffff
#define CFG_SPI2SAP_ADD_RID_RD(src)                      (((src) & 0xffffffff))
#define CFG_SPI2SAP_ADD_RID_WR(src)                 (((u32)(src)) & 0xffffffff)
#define CFG_SPI2SAP_ADD_RID_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SPI2SAP_AddSPIEn_Reg	*/ 
/*	 Fields cfg_spi2sap_add_rid_port	 */
#define CFG_SPI2SAP_ADD_RID_PORT_WIDTH                                        1
#define CFG_SPI2SAP_ADD_RID_PORT_SHIFT                                        2
#define CFG_SPI2SAP_ADD_RID_PORT_MASK                                0x00000004
#define CFG_SPI2SAP_ADD_RID_PORT_RD(src)              (((src) & 0x00000004)>>2)
#define CFG_SPI2SAP_ADD_RID_PORT_WR(src)         (((u32)(src)<<2) & 0x00000004)
#define CFG_SPI2SAP_ADD_RID_PORT_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_spi2sap_add_rid_dir	 */
#define CFG_SPI2SAP_ADD_RID_DIR_WIDTH                                         1
#define CFG_SPI2SAP_ADD_RID_DIR_SHIFT                                         1
#define CFG_SPI2SAP_ADD_RID_DIR_MASK                                 0x00000002
#define CFG_SPI2SAP_ADD_RID_DIR_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_SPI2SAP_ADD_RID_DIR_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_SPI2SAP_ADD_RID_DIR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_spi2sap_add_rid_en	 */
#define CFG_SPI2SAP_ADD_RID_EN_WIDTH                                          1
#define CFG_SPI2SAP_ADD_RID_EN_SHIFT                                          0
#define CFG_SPI2SAP_ADD_RID_EN_MASK                                  0x00000001
#define CFG_SPI2SAP_ADD_RID_EN_RD(src)                   (((src) & 0x00000001))
#define CFG_SPI2SAP_ADD_RID_EN_WR(src)              (((u32)(src)) & 0x00000001)
#define CFG_SPI2SAP_ADD_RID_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_DelSPI_Reg	*/ 
/*	 Fields cfg_spi2sap_del_rid	 */
#define CFG_SPI2SAP_DEL_RID_WIDTH                                            32
#define CFG_SPI2SAP_DEL_RID_SHIFT                                             0
#define CFG_SPI2SAP_DEL_RID_MASK                                     0xffffffff
#define CFG_SPI2SAP_DEL_RID_RD(src)                      (((src) & 0xffffffff))
#define CFG_SPI2SAP_DEL_RID_WR(src)                 (((u32)(src)) & 0xffffffff)
#define CFG_SPI2SAP_DEL_RID_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SPI2SAP_DelSPIEn_Reg	*/ 
/*	 Fields cfg_spi2sap_del_rid_port	 */
#define CFG_SPI2SAP_DEL_RID_PORT_WIDTH                                        1
#define CFG_SPI2SAP_DEL_RID_PORT_SHIFT                                        2
#define CFG_SPI2SAP_DEL_RID_PORT_MASK                                0x00000004
#define CFG_SPI2SAP_DEL_RID_PORT_RD(src)              (((src) & 0x00000004)>>2)
#define CFG_SPI2SAP_DEL_RID_PORT_WR(src)         (((u32)(src)<<2) & 0x00000004)
#define CFG_SPI2SAP_DEL_RID_PORT_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_spi2sap_del_rid_dir	 */
#define CFG_SPI2SAP_DEL_RID_DIR_WIDTH                                         1
#define CFG_SPI2SAP_DEL_RID_DIR_SHIFT                                         1
#define CFG_SPI2SAP_DEL_RID_DIR_MASK                                 0x00000002
#define CFG_SPI2SAP_DEL_RID_DIR_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_SPI2SAP_DEL_RID_DIR_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_SPI2SAP_DEL_RID_DIR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_spi2sap_del_rid_en	 */
#define CFG_SPI2SAP_DEL_RID_EN_WIDTH                                          1
#define CFG_SPI2SAP_DEL_RID_EN_SHIFT                                          0
#define CFG_SPI2SAP_DEL_RID_EN_MASK                                  0x00000001
#define CFG_SPI2SAP_DEL_RID_EN_RD(src)                   (((src) & 0x00000001))
#define CFG_SPI2SAP_DEL_RID_EN_WR(src)              (((u32)(src)) & 0x00000001)
#define CFG_SPI2SAP_DEL_RID_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_SearchSPI_Reg	*/ 
/*	 Fields cfg_spi2sap_srch_rid	 */
#define CFG_SPI2SAP_SRCH_RID_WIDTH                                           32
#define CFG_SPI2SAP_SRCH_RID_SHIFT                                            0
#define CFG_SPI2SAP_SRCH_RID_MASK                                    0xffffffff
#define CFG_SPI2SAP_SRCH_RID_RD(src)                     (((src) & 0xffffffff))
#define CFG_SPI2SAP_SRCH_RID_WR(src)                (((u32)(src)) & 0xffffffff)
#define CFG_SPI2SAP_SRCH_RID_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SPI2SAP_SearchSPIEn_Reg	*/ 
/*	 Fields cfg_spi2sap_srch_rid_port	 */
#define CFG_SPI2SAP_SRCH_RID_PORT_WIDTH                                       1
#define CFG_SPI2SAP_SRCH_RID_PORT_SHIFT                                       2
#define CFG_SPI2SAP_SRCH_RID_PORT_MASK                               0x00000004
#define CFG_SPI2SAP_SRCH_RID_PORT_RD(src)             (((src) & 0x00000004)>>2)
#define CFG_SPI2SAP_SRCH_RID_PORT_WR(src)        (((u32)(src)<<2) & 0x00000004)
#define CFG_SPI2SAP_SRCH_RID_PORT_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_spi2sap_srch_rid_dir	 */
#define CFG_SPI2SAP_SRCH_RID_DIR_WIDTH                                        1
#define CFG_SPI2SAP_SRCH_RID_DIR_SHIFT                                        1
#define CFG_SPI2SAP_SRCH_RID_DIR_MASK                                0x00000002
#define CFG_SPI2SAP_SRCH_RID_DIR_RD(src)              (((src) & 0x00000002)>>1)
#define CFG_SPI2SAP_SRCH_RID_DIR_WR(src)         (((u32)(src)<<1) & 0x00000002)
#define CFG_SPI2SAP_SRCH_RID_DIR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_spi2sap_srch_rid_en	 */
#define CFG_SPI2SAP_SRCH_RID_EN_WIDTH                                         1
#define CFG_SPI2SAP_SRCH_RID_EN_SHIFT                                         0
#define CFG_SPI2SAP_SRCH_RID_EN_MASK                                 0x00000001
#define CFG_SPI2SAP_SRCH_RID_EN_RD(src)                  (((src) & 0x00000001))
#define CFG_SPI2SAP_SRCH_RID_EN_WR(src)             (((u32)(src)) & 0x00000001)
#define CFG_SPI2SAP_SRCH_RID_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_Cfg0_Reg	*/ 
/*	 Fields cfg_avlmgr_maxsteps_thresh	 */
#define CFG_AVLMGR_MAXSTEPS_THRESH_WIDTH                                     12
#define CFG_AVLMGR_MAXSTEPS_THRESH_SHIFT                                      8
#define CFG_AVLMGR_MAXSTEPS_THRESH_MASK                              0x000fff00
#define CFG_AVLMGR_MAXSTEPS_THRESH_RD(src)            (((src) & 0x000fff00)>>8)
#define CFG_AVLMGR_MAXSTEPS_THRESH_WR(src)       (((u32)(src)<<8) & 0x000fff00)
#define CFG_AVLMGR_MAXSTEPS_THRESH_SET(dst,src) \
                       (((dst) & ~0x000fff00) | (((u32)(src)<<8) & 0x000fff00))
/*	 Fields cfg_avlmgr_srchdb_depth	 */
#define CFG_AVLMGR_SRCHDB_DEPTH_WIDTH                                         8
#define CFG_AVLMGR_SRCHDB_DEPTH_SHIFT                                         0
#define CFG_AVLMGR_SRCHDB_DEPTH_MASK                                 0x000000ff
#define CFG_AVLMGR_SRCHDB_DEPTH_RD(src)                  (((src) & 0x000000ff))
#define CFG_AVLMGR_SRCHDB_DEPTH_WR(src)             (((u32)(src)) & 0x000000ff)
#define CFG_AVLMGR_SRCHDB_DEPTH_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register SPI2SAP_Dbg0_Reg	*/ 
/*	 Fields cfg_avlmgr_dbg_srchdb_wr_en	 */
#define CFG_AVLMGR_DBG_SRCHDB_WR_EN_WIDTH                                     1
#define CFG_AVLMGR_DBG_SRCHDB_WR_EN_SHIFT                                     9
#define CFG_AVLMGR_DBG_SRCHDB_WR_EN_MASK                             0x00000200
#define CFG_AVLMGR_DBG_SRCHDB_WR_EN_RD(src)           (((src) & 0x00000200)>>9)
#define CFG_AVLMGR_DBG_SRCHDB_WR_EN_WR(src)      (((u32)(src)<<9) & 0x00000200)
#define CFG_AVLMGR_DBG_SRCHDB_WR_EN_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_avlmgr_dbg_en	 */
#define CFG_AVLMGR_DBG_EN_WIDTH                                               1
#define CFG_AVLMGR_DBG_EN_SHIFT                                               8
#define CFG_AVLMGR_DBG_EN_MASK                                       0x00000100
#define CFG_AVLMGR_DBG_EN_RD(src)                     (((src) & 0x00000100)>>8)
#define CFG_AVLMGR_DBG_EN_WR(src)                (((u32)(src)<<8) & 0x00000100)
#define CFG_AVLMGR_DBG_EN_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_avlmgr_dbg_srchdb_addr	 */
#define CFG_AVLMGR_DBG_SRCHDB_ADDR_WIDTH                                      7
#define CFG_AVLMGR_DBG_SRCHDB_ADDR_SHIFT                                      0
#define CFG_AVLMGR_DBG_SRCHDB_ADDR_MASK                              0x0000007f
#define CFG_AVLMGR_DBG_SRCHDB_ADDR_RD(src)               (((src) & 0x0000007f))
#define CFG_AVLMGR_DBG_SRCHDB_ADDR_WR(src)          (((u32)(src)) & 0x0000007f)
#define CFG_AVLMGR_DBG_SRCHDB_ADDR_SET(dst,src) \
                          (((dst) & ~0x0000007f) | (((u32)(src)) & 0x0000007f))

/*	Register SPI2SAP_Dbg1_Reg	*/ 
/*	 Fields cfg_avlmgr_dbg_srchdb_wdata_l	 */
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_L_WIDTH                                  19
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_L_SHIFT                                   0
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_L_MASK                           0x0007ffff
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_L_RD(src)            (((src) & 0x0007ffff))
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_L_WR(src)       (((u32)(src)) & 0x0007ffff)
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_L_SET(dst,src) \
                          (((dst) & ~0x0007ffff) | (((u32)(src)) & 0x0007ffff))

/*	Register SPI2SAP_Dbg2_Reg	*/ 
/*	 Fields cfg_avlmgr_dbg_srchdb_wdata_h	 */
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_H_WIDTH                                  32
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_H_SHIFT                                   0
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_H_MASK                           0xffffffff
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_H_RD(src)            (((src) & 0xffffffff))
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_H_WR(src)       (((u32)(src)) & 0xffffffff)
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_H_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SPI2SAP_IntReg	*/ 
/*	 Fields sts_avlmgr_fatal_wrselfpointerr	 */
#define STS_AVLMGR_FATAL_WRSELFPOINTERR_WIDTH                                 1
#define STS_AVLMGR_FATAL_WRSELFPOINTERR_SHIFT                                10
#define STS_AVLMGR_FATAL_WRSELFPOINTERR_MASK                         0x00000400
#define STS_AVLMGR_FATAL_WRSELFPOINTERR_RD(src)      (((src) & 0x00000400)>>10)
#define STS_AVLMGR_FATAL_WRSELFPOINTERR_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define STS_AVLMGR_FATAL_WRSELFPOINTERR_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields sts_avlmgr_fatal_rdselfpointerr	 */
#define STS_AVLMGR_FATAL_RDSELFPOINTERR_WIDTH                                 1
#define STS_AVLMGR_FATAL_RDSELFPOINTERR_SHIFT                                 9
#define STS_AVLMGR_FATAL_RDSELFPOINTERR_MASK                         0x00000200
#define STS_AVLMGR_FATAL_RDSELFPOINTERR_RD(src)       (((src) & 0x00000200)>>9)
#define STS_AVLMGR_FATAL_RDSELFPOINTERR_WR(src)  (((u32)(src)<<9) & 0x00000200)
#define STS_AVLMGR_FATAL_RDSELFPOINTERR_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields sts_avlmgr_fatal_wrbalerr	 */
#define STS_AVLMGR_FATAL_WRBALERR_WIDTH                                       1
#define STS_AVLMGR_FATAL_WRBALERR_SHIFT                                       8
#define STS_AVLMGR_FATAL_WRBALERR_MASK                               0x00000100
#define STS_AVLMGR_FATAL_WRBALERR_RD(src)             (((src) & 0x00000100)>>8)
#define STS_AVLMGR_FATAL_WRBALERR_WR(src)        (((u32)(src)<<8) & 0x00000100)
#define STS_AVLMGR_FATAL_WRBALERR_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields sts_avlmgr_fatal_rdbalerr	 */
#define STS_AVLMGR_FATAL_RDBALERR_WIDTH                                       1
#define STS_AVLMGR_FATAL_RDBALERR_SHIFT                                       7
#define STS_AVLMGR_FATAL_RDBALERR_MASK                               0x00000080
#define STS_AVLMGR_FATAL_RDBALERR_RD(src)             (((src) & 0x00000080)>>7)
#define STS_AVLMGR_FATAL_RDBALERR_WR(src)        (((u32)(src)<<7) & 0x00000080)
#define STS_AVLMGR_FATAL_RDBALERR_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields sts_avlmgr_fatal_maxstepserr	 */
#define STS_AVLMGR_FATAL_MAXSTEPSERR_WIDTH                                    1
#define STS_AVLMGR_FATAL_MAXSTEPSERR_SHIFT                                    6
#define STS_AVLMGR_FATAL_MAXSTEPSERR_MASK                            0x00000040
#define STS_AVLMGR_FATAL_MAXSTEPSERR_RD(src)          (((src) & 0x00000040)>>6)
#define STS_AVLMGR_FATAL_MAXSTEPSERR_WR(src)     (((u32)(src)<<6) & 0x00000040)
#define STS_AVLMGR_FATAL_MAXSTEPSERR_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields sts_avlmgr_fatal_rderr_ram	 */
#define STS_AVLMGR_FATAL_RDERR_RAM_WIDTH                                      1
#define STS_AVLMGR_FATAL_RDERR_RAM_SHIFT                                      5
#define STS_AVLMGR_FATAL_RDERR_RAM_MASK                              0x00000020
#define STS_AVLMGR_FATAL_RDERR_RAM_RD(src)            (((src) & 0x00000020)>>5)
#define STS_AVLMGR_FATAL_RDERR_RAM_WR(src)       (((u32)(src)<<5) & 0x00000020)
#define STS_AVLMGR_FATAL_RDERR_RAM_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields sts_avlmgr_rderr_ram	 */
#define STS_AVLMGR_RDERR_RAM_WIDTH                                            1
#define STS_AVLMGR_RDERR_RAM_SHIFT                                            4
#define STS_AVLMGR_RDERR_RAM_MASK                                    0x00000010
#define STS_AVLMGR_RDERR_RAM_RD(src)                  (((src) & 0x00000010)>>4)
#define STS_AVLMGR_RDERR_RAM_WR(src)             (((u32)(src)<<4) & 0x00000010)
#define STS_AVLMGR_RDERR_RAM_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields sts_avlmgr_adderr_srchdb_full	 */
#define STS_AVLMGR_ADDERR_SRCHDB_FULL_WIDTH                                   1
#define STS_AVLMGR_ADDERR_SRCHDB_FULL_SHIFT                                   3
#define STS_AVLMGR_ADDERR_SRCHDB_FULL_MASK                           0x00000008
#define STS_AVLMGR_ADDERR_SRCHDB_FULL_RD(src)         (((src) & 0x00000008)>>3)
#define STS_AVLMGR_ADDERR_SRCHDB_FULL_WR(src)    (((u32)(src)<<3) & 0x00000008)
#define STS_AVLMGR_ADDERR_SRCHDB_FULL_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields sts_avlmgr_adderr_ridduplicate	 */
#define STS_AVLMGR_ADDERR_RIDDUPLICATE_WIDTH                                  1
#define STS_AVLMGR_ADDERR_RIDDUPLICATE_SHIFT                                  2
#define STS_AVLMGR_ADDERR_RIDDUPLICATE_MASK                          0x00000004
#define STS_AVLMGR_ADDERR_RIDDUPLICATE_RD(src)        (((src) & 0x00000004)>>2)
#define STS_AVLMGR_ADDERR_RIDDUPLICATE_WR(src)   (((u32)(src)<<2) & 0x00000004)
#define STS_AVLMGR_ADDERR_RIDDUPLICATE_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields sts_avlmgr_delerr_srchdb_empty	 */
#define STS_AVLMGR_DELERR_SRCHDB_EMPTY_WIDTH                                  1
#define STS_AVLMGR_DELERR_SRCHDB_EMPTY_SHIFT                                  1
#define STS_AVLMGR_DELERR_SRCHDB_EMPTY_MASK                          0x00000002
#define STS_AVLMGR_DELERR_SRCHDB_EMPTY_RD(src)        (((src) & 0x00000002)>>1)
#define STS_AVLMGR_DELERR_SRCHDB_EMPTY_WR(src)   (((u32)(src)<<1) & 0x00000002)
#define STS_AVLMGR_DELERR_SRCHDB_EMPTY_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields sts_avlmgr_delerr_ridnotfound	 */
#define STS_AVLMGR_DELERR_RIDNOTFOUND_WIDTH                                   1
#define STS_AVLMGR_DELERR_RIDNOTFOUND_SHIFT                                   0
#define STS_AVLMGR_DELERR_RIDNOTFOUND_MASK                           0x00000001
#define STS_AVLMGR_DELERR_RIDNOTFOUND_RD(src)            (((src) & 0x00000001))
#define STS_AVLMGR_DELERR_RIDNOTFOUND_WR(src)       (((u32)(src)) & 0x00000001)
#define STS_AVLMGR_DELERR_RIDNOTFOUND_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_IntRegMask	*/
/*    Mask Register Fields sts_avlmgr_fatal_wrselfpointerrMask    */
#define STS_AVLMGR_FATAL_WRSELFPOINTERRMASK_WIDTH                             1
#define STS_AVLMGR_FATAL_WRSELFPOINTERRMASK_SHIFT                            10
#define STS_AVLMGR_FATAL_WRSELFPOINTERRMASK_MASK                     0x00000400
#define STS_AVLMGR_FATAL_WRSELFPOINTERRMASK_RD(src)  (((src) & 0x00000400)>>10)
#define STS_AVLMGR_FATAL_WRSELFPOINTERRMASK_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define STS_AVLMGR_FATAL_WRSELFPOINTERRMASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields sts_avlmgr_fatal_rdselfpointerrMask    */
#define STS_AVLMGR_FATAL_RDSELFPOINTERRMASK_WIDTH                             1
#define STS_AVLMGR_FATAL_RDSELFPOINTERRMASK_SHIFT                             9
#define STS_AVLMGR_FATAL_RDSELFPOINTERRMASK_MASK                     0x00000200
#define STS_AVLMGR_FATAL_RDSELFPOINTERRMASK_RD(src)   (((src) & 0x00000200)>>9)
#define STS_AVLMGR_FATAL_RDSELFPOINTERRMASK_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define STS_AVLMGR_FATAL_RDSELFPOINTERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields sts_avlmgr_fatal_wrbalerrMask    */
#define STS_AVLMGR_FATAL_WRBALERRMASK_WIDTH                                   1
#define STS_AVLMGR_FATAL_WRBALERRMASK_SHIFT                                   8
#define STS_AVLMGR_FATAL_WRBALERRMASK_MASK                           0x00000100
#define STS_AVLMGR_FATAL_WRBALERRMASK_RD(src)         (((src) & 0x00000100)>>8)
#define STS_AVLMGR_FATAL_WRBALERRMASK_WR(src)    (((u32)(src)<<8) & 0x00000100)
#define STS_AVLMGR_FATAL_WRBALERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields sts_avlmgr_fatal_rdbalerrMask    */
#define STS_AVLMGR_FATAL_RDBALERRMASK_WIDTH                                   1
#define STS_AVLMGR_FATAL_RDBALERRMASK_SHIFT                                   7
#define STS_AVLMGR_FATAL_RDBALERRMASK_MASK                           0x00000080
#define STS_AVLMGR_FATAL_RDBALERRMASK_RD(src)         (((src) & 0x00000080)>>7)
#define STS_AVLMGR_FATAL_RDBALERRMASK_WR(src)    (((u32)(src)<<7) & 0x00000080)
#define STS_AVLMGR_FATAL_RDBALERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields sts_avlmgr_fatal_maxstepserrMask    */
#define STS_AVLMGR_FATAL_MAXSTEPSERRMASK_WIDTH                                1
#define STS_AVLMGR_FATAL_MAXSTEPSERRMASK_SHIFT                                6
#define STS_AVLMGR_FATAL_MAXSTEPSERRMASK_MASK                        0x00000040
#define STS_AVLMGR_FATAL_MAXSTEPSERRMASK_RD(src)      (((src) & 0x00000040)>>6)
#define STS_AVLMGR_FATAL_MAXSTEPSERRMASK_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define STS_AVLMGR_FATAL_MAXSTEPSERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields sts_avlmgr_fatal_rderr_ramMask    */
#define STS_AVLMGR_FATAL_RDERR_RAMMASK_WIDTH                                  1
#define STS_AVLMGR_FATAL_RDERR_RAMMASK_SHIFT                                  5
#define STS_AVLMGR_FATAL_RDERR_RAMMASK_MASK                          0x00000020
#define STS_AVLMGR_FATAL_RDERR_RAMMASK_RD(src)        (((src) & 0x00000020)>>5)
#define STS_AVLMGR_FATAL_RDERR_RAMMASK_WR(src)   (((u32)(src)<<5) & 0x00000020)
#define STS_AVLMGR_FATAL_RDERR_RAMMASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields sts_avlmgr_rderr_ramMask    */
#define STS_AVLMGR_RDERR_RAMMASK_WIDTH                                        1
#define STS_AVLMGR_RDERR_RAMMASK_SHIFT                                        4
#define STS_AVLMGR_RDERR_RAMMASK_MASK                                0x00000010
#define STS_AVLMGR_RDERR_RAMMASK_RD(src)              (((src) & 0x00000010)>>4)
#define STS_AVLMGR_RDERR_RAMMASK_WR(src)         (((u32)(src)<<4) & 0x00000010)
#define STS_AVLMGR_RDERR_RAMMASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields sts_avlmgr_adderr_srchdb_fullMask    */
#define STS_AVLMGR_ADDERR_SRCHDB_FULLMASK_WIDTH                               1
#define STS_AVLMGR_ADDERR_SRCHDB_FULLMASK_SHIFT                               3
#define STS_AVLMGR_ADDERR_SRCHDB_FULLMASK_MASK                       0x00000008
#define STS_AVLMGR_ADDERR_SRCHDB_FULLMASK_RD(src)     (((src) & 0x00000008)>>3)
#define STS_AVLMGR_ADDERR_SRCHDB_FULLMASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define STS_AVLMGR_ADDERR_SRCHDB_FULLMASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields sts_avlmgr_adderr_ridduplicateMask    */
#define STS_AVLMGR_ADDERR_RIDDUPLICATEMASK_WIDTH                              1
#define STS_AVLMGR_ADDERR_RIDDUPLICATEMASK_SHIFT                              2
#define STS_AVLMGR_ADDERR_RIDDUPLICATEMASK_MASK                      0x00000004
#define STS_AVLMGR_ADDERR_RIDDUPLICATEMASK_RD(src)    (((src) & 0x00000004)>>2)
#define STS_AVLMGR_ADDERR_RIDDUPLICATEMASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define STS_AVLMGR_ADDERR_RIDDUPLICATEMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields sts_avlmgr_delerr_srchdb_emptyMask    */
#define STS_AVLMGR_DELERR_SRCHDB_EMPTYMASK_WIDTH                              1
#define STS_AVLMGR_DELERR_SRCHDB_EMPTYMASK_SHIFT                              1
#define STS_AVLMGR_DELERR_SRCHDB_EMPTYMASK_MASK                      0x00000002
#define STS_AVLMGR_DELERR_SRCHDB_EMPTYMASK_RD(src)    (((src) & 0x00000002)>>1)
#define STS_AVLMGR_DELERR_SRCHDB_EMPTYMASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define STS_AVLMGR_DELERR_SRCHDB_EMPTYMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields sts_avlmgr_delerr_ridnotfoundMask    */
#define STS_AVLMGR_DELERR_RIDNOTFOUNDMASK_WIDTH                               1
#define STS_AVLMGR_DELERR_RIDNOTFOUNDMASK_SHIFT                               0
#define STS_AVLMGR_DELERR_RIDNOTFOUNDMASK_MASK                       0x00000001
#define STS_AVLMGR_DELERR_RIDNOTFOUNDMASK_RD(src)        (((src) & 0x00000001))
#define STS_AVLMGR_DELERR_RIDNOTFOUNDMASK_WR(src)   (((u32)(src)) & 0x00000001)
#define STS_AVLMGR_DELERR_RIDNOTFOUNDMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_StsReg0	*/ 
/*	 Fields sts_avlmgr_rootaddr	 */
#define STS_AVLMGR_ROOTADDR0_WIDTH                                            7
#define STS_AVLMGR_ROOTADDR0_SHIFT                                            8
#define STS_AVLMGR_ROOTADDR0_MASK                                    0x00007f00
#define STS_AVLMGR_ROOTADDR0_RD(src)                  (((src) & 0x00007f00)>>8)
#define STS_AVLMGR_ROOTADDR0_SET(dst,src) \
                       (((dst) & ~0x00007f00) | (((u32)(src)<<8) & 0x00007f00))
/*	 Fields sts_avlmgr_rid_cnt	 */
#define STS_AVLMGR_RID_CNT0_WIDTH                                             8
#define STS_AVLMGR_RID_CNT0_SHIFT                                             0
#define STS_AVLMGR_RID_CNT0_MASK                                     0x000000ff
#define STS_AVLMGR_RID_CNT0_RD(src)                      (((src) & 0x000000ff))
#define STS_AVLMGR_RID_CNT0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register SPI2SAP_StsReg1	*/ 
/*	 Fields sts_avlmgr_dbg_srchdb_rdata_l	 */
#define STS_AVLMGR_DBG_SRCHDB_RDATA_L1_WIDTH                                 19
#define STS_AVLMGR_DBG_SRCHDB_RDATA_L1_SHIFT                                  0
#define STS_AVLMGR_DBG_SRCHDB_RDATA_L1_MASK                          0x0007ffff
#define STS_AVLMGR_DBG_SRCHDB_RDATA_L1_RD(src)           (((src) & 0x0007ffff))
#define STS_AVLMGR_DBG_SRCHDB_RDATA_L1_SET(dst,src) \
                          (((dst) & ~0x0007ffff) | (((u32)(src)) & 0x0007ffff))

/*	Register SPI2SAP_StsReg2	*/ 
/*	 Fields sts_avlmgr_dbg_srchdb_rdata_h	 */
#define STS_AVLMGR_DBG_SRCHDB_RDATA_H2_WIDTH                                 32
#define STS_AVLMGR_DBG_SRCHDB_RDATA_H2_SHIFT                                  0
#define STS_AVLMGR_DBG_SRCHDB_RDATA_H2_MASK                          0xffffffff
#define STS_AVLMGR_DBG_SRCHDB_RDATA_H2_RD(src)           (((src) & 0xffffffff))
#define STS_AVLMGR_DBG_SRCHDB_RDATA_H2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SPI2SAP_StsReg3	*/ 
/*	 Fields sts_avlmgr_deladdr	 */
#define STS_AVLMGR_DELADDR3_WIDTH                                             7
#define STS_AVLMGR_DELADDR3_SHIFT                                            16
#define STS_AVLMGR_DELADDR3_MASK                                     0x007f0000
#define STS_AVLMGR_DELADDR3_RD(src)                  (((src) & 0x007f0000)>>16)
#define STS_AVLMGR_DELADDR3_SET(dst,src) \
                      (((dst) & ~0x007f0000) | (((u32)(src)<<16) & 0x007f0000))
/*	 Fields sts_avlmgr_addaddr	 */
#define STS_AVLMGR_ADDADDR3_WIDTH                                             7
#define STS_AVLMGR_ADDADDR3_SHIFT                                             8
#define STS_AVLMGR_ADDADDR3_MASK                                     0x00007f00
#define STS_AVLMGR_ADDADDR3_RD(src)                   (((src) & 0x00007f00)>>8)
#define STS_AVLMGR_ADDADDR3_SET(dst,src) \
                       (((dst) & ~0x00007f00) | (((u32)(src)<<8) & 0x00007f00))
/*	 Fields sts_avlmgr_srchaddr	 */
#define STS_AVLMGR_SRCHADDR3_WIDTH                                            8
#define STS_AVLMGR_SRCHADDR3_SHIFT                                            0
#define STS_AVLMGR_SRCHADDR3_MASK                                    0x000000ff
#define STS_AVLMGR_SRCHADDR3_RD(src)                     (((src) & 0x000000ff))
#define STS_AVLMGR_SRCHADDR3_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register SPI2SAP_FIFO_EmptySts0	*/ 
/*	 Fields macif_fifo_empty_rxprt1	 */
#define MACIF_FIFO_EMPTY_RXPRT10_WIDTH                                        1
#define MACIF_FIFO_EMPTY_RXPRT10_SHIFT                                        1
#define MACIF_FIFO_EMPTY_RXPRT10_MASK                                0x00000002
#define MACIF_FIFO_EMPTY_RXPRT10_RD(src)              (((src) & 0x00000002)>>1)
#define MACIF_FIFO_EMPTY_RXPRT10_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields macif_fifo_empty_rxprt0	 */
#define MACIF_FIFO_EMPTY_RXPRT00_WIDTH                                        1
#define MACIF_FIFO_EMPTY_RXPRT00_SHIFT                                        0
#define MACIF_FIFO_EMPTY_RXPRT00_MASK                                0x00000001
#define MACIF_FIFO_EMPTY_RXPRT00_RD(src)                 (((src) & 0x00000001))
#define MACIF_FIFO_EMPTY_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_Int_Reg0	*/ 
/*	 Fields macif_fifo_overfl_intr_rxprt1	 */
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_WIDTH                                  1
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_SHIFT                                 17
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_MASK                          0x00020000
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_RD(src)       (((src) & 0x00020000)>>17)
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_WR(src)  (((u32)(src)<<17) & 0x00020000)
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields macif_fifo_underfl_intr_rxprt1	 */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_WIDTH                                 1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_SHIFT                                16
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_MASK                         0x00010000
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_RD(src)      (((src) & 0x00010000)>>16)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields macif_fifo_overfl_intr_rxprt0	 */
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_WIDTH                                  1
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_SHIFT                                  1
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_MASK                          0x00000002
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_RD(src)        (((src) & 0x00000002)>>1)
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_WR(src)   (((u32)(src)<<1) & 0x00000002)
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields macif_fifo_underfl_intr_rxprt0	 */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_WIDTH                                 1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_SHIFT                                 0
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_MASK                         0x00000001
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_RD(src)          (((src) & 0x00000001))
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_WR(src)     (((u32)(src)) & 0x00000001)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SPI2SAP_Int_Reg0Mask	*/
/*    Mask Register Fields macif_fifo_overfl_intr_rxprt1Mask    */
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_WIDTH                               1
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_SHIFT                              17
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_MASK                       0x00020000
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_RD(src)    (((src) & 0x00020000)>>17)
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields macif_fifo_underfl_intr_rxprt1Mask    */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_WIDTH                              1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_SHIFT                             16
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_MASK                      0x00010000
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_RD(src)   (((src) & 0x00010000)>>16)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields macif_fifo_overfl_intr_rxprt0Mask    */
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_WIDTH                               1
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_SHIFT                               1
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_MASK                       0x00000002
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_RD(src)     (((src) & 0x00000002)>>1)
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields macif_fifo_underfl_intr_rxprt0Mask    */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_WIDTH                              1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_SHIFT                              0
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_MASK                      0x00000001
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_RD(src)       (((src) & 0x00000001))
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_WR(src)  (((u32)(src)) & 0x00000001)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ENET_SAD_AddrCmd_Reg	*/ 
/*	 Fields cfg_enet_csr_sad_req	 */
#define CFG_ENET_CSR_SAD_REQ_WIDTH                                            1
#define CFG_ENET_CSR_SAD_REQ_SHIFT                                           17
#define CFG_ENET_CSR_SAD_REQ_MASK                                    0x00020000
#define CFG_ENET_CSR_SAD_REQ_RD(src)                 (((src) & 0x00020000)>>17)
#define CFG_ENET_CSR_SAD_REQ_WR(src)            (((u32)(src)<<17) & 0x00020000)
#define CFG_ENET_CSR_SAD_REQ_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_enet_csr_sad_rdwr	 */
#define CFG_ENET_CSR_SAD_RDWR_WIDTH                                           1
#define CFG_ENET_CSR_SAD_RDWR_SHIFT                                          16
#define CFG_ENET_CSR_SAD_RDWR_MASK                                   0x00010000
#define CFG_ENET_CSR_SAD_RDWR_RD(src)                (((src) & 0x00010000)>>16)
#define CFG_ENET_CSR_SAD_RDWR_WR(src)           (((u32)(src)<<16) & 0x00010000)
#define CFG_ENET_CSR_SAD_RDWR_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_enet_csr_sad_addr	 */
#define CFG_ENET_CSR_SAD_ADDR_WIDTH                                          16
#define CFG_ENET_CSR_SAD_ADDR_SHIFT                                           0
#define CFG_ENET_CSR_SAD_ADDR_MASK                                   0x0000ffff
#define CFG_ENET_CSR_SAD_ADDR_RD(src)                    (((src) & 0x0000ffff))
#define CFG_ENET_CSR_SAD_ADDR_WR(src)               (((u32)(src)) & 0x0000ffff)
#define CFG_ENET_CSR_SAD_ADDR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register ENET_SAD_Wdata0_Reg	*/ 
/*	 Fields cfg_enet_csr_sad_wdata0	 */
#define CFG_ENET_CSR_SAD_WDATA0_WIDTH                                        32
#define CFG_ENET_CSR_SAD_WDATA0_SHIFT                                         0
#define CFG_ENET_CSR_SAD_WDATA0_MASK                                 0xffffffff
#define CFG_ENET_CSR_SAD_WDATA0_RD(src)                  (((src) & 0xffffffff))
#define CFG_ENET_CSR_SAD_WDATA0_WR(src)             (((u32)(src)) & 0xffffffff)
#define CFG_ENET_CSR_SAD_WDATA0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Wdata1_Reg	*/ 
/*	 Fields cfg_enet_csr_sad_wdata1	 */
#define CFG_ENET_CSR_SAD_WDATA1_WIDTH                                        32
#define CFG_ENET_CSR_SAD_WDATA1_SHIFT                                         0
#define CFG_ENET_CSR_SAD_WDATA1_MASK                                 0xffffffff
#define CFG_ENET_CSR_SAD_WDATA1_RD(src)                  (((src) & 0xffffffff))
#define CFG_ENET_CSR_SAD_WDATA1_WR(src)             (((u32)(src)) & 0xffffffff)
#define CFG_ENET_CSR_SAD_WDATA1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Wdata2_Reg	*/ 
/*	 Fields cfg_enet_csr_sad_wdata2	 */
#define CFG_ENET_CSR_SAD_WDATA2_WIDTH                                        32
#define CFG_ENET_CSR_SAD_WDATA2_SHIFT                                         0
#define CFG_ENET_CSR_SAD_WDATA2_MASK                                 0xffffffff
#define CFG_ENET_CSR_SAD_WDATA2_RD(src)                  (((src) & 0xffffffff))
#define CFG_ENET_CSR_SAD_WDATA2_WR(src)             (((u32)(src)) & 0xffffffff)
#define CFG_ENET_CSR_SAD_WDATA2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Wdata3_Reg	*/ 
/*	 Fields cfg_enet_csr_sad_wdata3	 */
#define CFG_ENET_CSR_SAD_WDATA3_WIDTH                                        32
#define CFG_ENET_CSR_SAD_WDATA3_SHIFT                                         0
#define CFG_ENET_CSR_SAD_WDATA3_MASK                                 0xffffffff
#define CFG_ENET_CSR_SAD_WDATA3_RD(src)                  (((src) & 0xffffffff))
#define CFG_ENET_CSR_SAD_WDATA3_WR(src)             (((u32)(src)) & 0xffffffff)
#define CFG_ENET_CSR_SAD_WDATA3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Rdata0_Reg	*/ 
/*	 Fields sts_enet_csr_sad_rdata0	 */
#define STS_ENET_CSR_SAD_RDATA0_WIDTH                                        32
#define STS_ENET_CSR_SAD_RDATA0_SHIFT                                         0
#define STS_ENET_CSR_SAD_RDATA0_MASK                                 0xffffffff
#define STS_ENET_CSR_SAD_RDATA0_RD(src)                  (((src) & 0xffffffff))
#define STS_ENET_CSR_SAD_RDATA0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Rdata1_Reg	*/ 
/*	 Fields sts_enet_csr_sad_rdata1	 */
#define STS_ENET_CSR_SAD_RDATA1_WIDTH                                        32
#define STS_ENET_CSR_SAD_RDATA1_SHIFT                                         0
#define STS_ENET_CSR_SAD_RDATA1_MASK                                 0xffffffff
#define STS_ENET_CSR_SAD_RDATA1_RD(src)                  (((src) & 0xffffffff))
#define STS_ENET_CSR_SAD_RDATA1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Rdata2_Reg	*/ 
/*	 Fields sts_enet_csr_sad_rdata2	 */
#define STS_ENET_CSR_SAD_RDATA2_WIDTH                                        32
#define STS_ENET_CSR_SAD_RDATA2_SHIFT                                         0
#define STS_ENET_CSR_SAD_RDATA2_MASK                                 0xffffffff
#define STS_ENET_CSR_SAD_RDATA2_RD(src)                  (((src) & 0xffffffff))
#define STS_ENET_CSR_SAD_RDATA2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_Rdata3_Reg	*/ 
/*	 Fields sts_enet_csr_sad_rdata3	 */
#define STS_ENET_CSR_SAD_RDATA3_WIDTH                                        32
#define STS_ENET_CSR_SAD_RDATA3_SHIFT                                         0
#define STS_ENET_CSR_SAD_RDATA3_MASK                                 0xffffffff
#define STS_ENET_CSR_SAD_RDATA3_RD(src)                  (((src) & 0xffffffff))
#define STS_ENET_CSR_SAD_RDATA3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ENET_SAD_CmdDone_Reg	*/ 
/*	 Fields cfg_enet_csr_sad_done	 */
#define CFG_ENET_CSR_SAD_DONE_WIDTH                                           1
#define CFG_ENET_CSR_SAD_DONE_SHIFT                                           0
#define CFG_ENET_CSR_SAD_DONE_MASK                                   0x00000001
#define CFG_ENET_CSR_SAD_DONE_RD(src)                    (((src) & 0x00000001))
#define CFG_ENET_CSR_SAD_DONE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CLE_Bypass_Reg0_0	*/ 
/*	 Fields cfg_cle_bypass_en	 */
#define CFG_CLE_BYPASS_EN0_WIDTH                                              1
#define CFG_CLE_BYPASS_EN0_SHIFT                                             31
#define CFG_CLE_BYPASS_EN0_MASK                                      0x80000000
#define CFG_CLE_BYPASS_EN0_RD(src)                   (((src) & 0x80000000)>>31)
#define CFG_CLE_BYPASS_EN0_WR(src)              (((u32)(src)<<31) & 0x80000000)
#define CFG_CLE_BYPASS_EN0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_cle_result_dlycntr	 */
#define CFG_CLE_RESULT_DLYCNTR0_WIDTH                                         7
#define CFG_CLE_RESULT_DLYCNTR0_SHIFT                                        24
#define CFG_CLE_RESULT_DLYCNTR0_MASK                                 0x7f000000
#define CFG_CLE_RESULT_DLYCNTR0_RD(src)              (((src) & 0x7f000000)>>24)
#define CFG_CLE_RESULT_DLYCNTR0_WR(src)         (((u32)(src)<<24) & 0x7f000000)
#define CFG_CLE_RESULT_DLYCNTR0_SET(dst,src) \
                      (((dst) & ~0x7f000000) | (((u32)(src)<<24) & 0x7f000000))
/*	 Fields cfg_cle_ip_fragment	 */
#define CFG_CLE_IP_FRAGMENT0_WIDTH                                            1
#define CFG_CLE_IP_FRAGMENT0_SHIFT                                           21
#define CFG_CLE_IP_FRAGMENT0_MASK                                    0x00200000
#define CFG_CLE_IP_FRAGMENT0_RD(src)                 (((src) & 0x00200000)>>21)
#define CFG_CLE_IP_FRAGMENT0_WR(src)            (((u32)(src)<<21) & 0x00200000)
#define CFG_CLE_IP_FRAGMENT0_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_cle_ip_version	 */
#define CFG_CLE_IP_VERSION0_WIDTH                                             1
#define CFG_CLE_IP_VERSION0_SHIFT                                            20
#define CFG_CLE_IP_VERSION0_MASK                                     0x00100000
#define CFG_CLE_IP_VERSION0_RD(src)                  (((src) & 0x00100000)>>20)
#define CFG_CLE_IP_VERSION0_WR(src)             (((u32)(src)<<20) & 0x00100000)
#define CFG_CLE_IP_VERSION0_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_cle_ip_protocol	 */
#define CFG_CLE_IP_PROTOCOL0_WIDTH                                            2
#define CFG_CLE_IP_PROTOCOL0_SHIFT                                           16
#define CFG_CLE_IP_PROTOCOL0_MASK                                    0x00030000
#define CFG_CLE_IP_PROTOCOL0_RD(src)                 (((src) & 0x00030000)>>16)
#define CFG_CLE_IP_PROTOCOL0_WR(src)            (((u32)(src)<<16) & 0x00030000)
#define CFG_CLE_IP_PROTOCOL0_SET(dst,src) \
                      (((dst) & ~0x00030000) | (((u32)(src)<<16) & 0x00030000))
/*	 Fields cfg_cle_ip_hdr_len	 */
#define CFG_CLE_IP_HDR_LEN0_WIDTH                                             5
#define CFG_CLE_IP_HDR_LEN0_SHIFT                                             8
#define CFG_CLE_IP_HDR_LEN0_MASK                                     0x00001f00
#define CFG_CLE_IP_HDR_LEN0_RD(src)                   (((src) & 0x00001f00)>>8)
#define CFG_CLE_IP_HDR_LEN0_WR(src)              (((u32)(src)<<8) & 0x00001f00)
#define CFG_CLE_IP_HDR_LEN0_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields cfg_cle_eth_hdr_len	 */
#define CFG_CLE_ETH_HDR_LEN0_WIDTH                                            7
#define CFG_CLE_ETH_HDR_LEN0_SHIFT                                            0
#define CFG_CLE_ETH_HDR_LEN0_MASK                                    0x0000007f
#define CFG_CLE_ETH_HDR_LEN0_RD(src)                     (((src) & 0x0000007f))
#define CFG_CLE_ETH_HDR_LEN0_WR(src)                (((u32)(src)) & 0x0000007f)
#define CFG_CLE_ETH_HDR_LEN0_SET(dst,src) \
                          (((dst) & ~0x0000007f) | (((u32)(src)) & 0x0000007f))

/*	Register CLE_Bypass_Reg1_0	*/ 
/*	 Fields cfg_cle_nxtfpsel	 */
#define CFG_CLE_NXTFPSEL0_WIDTH                                               4
#define CFG_CLE_NXTFPSEL0_SHIFT                                              20
#define CFG_CLE_NXTFPSEL0_MASK                                       0x00f00000
#define CFG_CLE_NXTFPSEL0_RD(src)                    (((src) & 0x00f00000)>>20)
#define CFG_CLE_NXTFPSEL0_WR(src)               (((u32)(src)<<20) & 0x00f00000)
#define CFG_CLE_NXTFPSEL0_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_cle_fpsel	 */
#define CFG_CLE_FPSEL0_WIDTH                                                  4
#define CFG_CLE_FPSEL0_SHIFT                                                 16
#define CFG_CLE_FPSEL0_MASK                                          0x000f0000
#define CFG_CLE_FPSEL0_RD(src)                       (((src) & 0x000f0000)>>16)
#define CFG_CLE_FPSEL0_WR(src)                  (((u32)(src)<<16) & 0x000f0000)
#define CFG_CLE_FPSEL0_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_cle_dstqid	 */
#define CFG_CLE_DSTQID0_WIDTH                                                12
#define CFG_CLE_DSTQID0_SHIFT                                                 0
#define CFG_CLE_DSTQID0_MASK                                         0x00000fff
#define CFG_CLE_DSTQID0_RD(src)                          (((src) & 0x00000fff))
#define CFG_CLE_DSTQID0_WR(src)                     (((u32)(src)) & 0x00000fff)
#define CFG_CLE_DSTQID0_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CLE_Bypass_Reg2_0	*/ 
/*	 Fields cfg_cle_mirror_nxtfpsel	 */
#define CFG_CLE_MIRROR_NXTFPSEL0_WIDTH                                        4
#define CFG_CLE_MIRROR_NXTFPSEL0_SHIFT                                       20
#define CFG_CLE_MIRROR_NXTFPSEL0_MASK                                0x00f00000
#define CFG_CLE_MIRROR_NXTFPSEL0_RD(src)             (((src) & 0x00f00000)>>20)
#define CFG_CLE_MIRROR_NXTFPSEL0_WR(src)        (((u32)(src)<<20) & 0x00f00000)
#define CFG_CLE_MIRROR_NXTFPSEL0_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_cle_mirror_fpsel	 */
#define CFG_CLE_MIRROR_FPSEL0_WIDTH                                           4
#define CFG_CLE_MIRROR_FPSEL0_SHIFT                                          16
#define CFG_CLE_MIRROR_FPSEL0_MASK                                   0x000f0000
#define CFG_CLE_MIRROR_FPSEL0_RD(src)                (((src) & 0x000f0000)>>16)
#define CFG_CLE_MIRROR_FPSEL0_WR(src)           (((u32)(src)<<16) & 0x000f0000)
#define CFG_CLE_MIRROR_FPSEL0_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_cle_mirror_dstqid	 */
#define CFG_CLE_MIRROR_DSTQID0_WIDTH                                         12
#define CFG_CLE_MIRROR_DSTQID0_SHIFT                                          0
#define CFG_CLE_MIRROR_DSTQID0_MASK                                  0x00000fff
#define CFG_CLE_MIRROR_DSTQID0_RD(src)                   (((src) & 0x00000fff))
#define CFG_CLE_MIRROR_DSTQID0_WR(src)              (((u32)(src)) & 0x00000fff)
#define CFG_CLE_MIRROR_DSTQID0_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CLE_Bypass_Reg3_0	*/ 
/*	 Fields cfg_cle_dbpolicer_en	 */
#define CFG_CLE_DBPOLICER_EN0_WIDTH                                           1
#define CFG_CLE_DBPOLICER_EN0_SHIFT                                          28
#define CFG_CLE_DBPOLICER_EN0_MASK                                   0x10000000
#define CFG_CLE_DBPOLICER_EN0_RD(src)                (((src) & 0x10000000)>>28)
#define CFG_CLE_DBPOLICER_EN0_WR(src)           (((u32)(src)<<28) & 0x10000000)
#define CFG_CLE_DBPOLICER_EN0_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields cfg_cle_dbpolicerid	 */
#define CFG_CLE_DBPOLICERID0_WIDTH                                            9
#define CFG_CLE_DBPOLICERID0_SHIFT                                           16
#define CFG_CLE_DBPOLICERID0_MASK                                    0x01ff0000
#define CFG_CLE_DBPOLICERID0_RD(src)                 (((src) & 0x01ff0000)>>16)
#define CFG_CLE_DBPOLICERID0_WR(src)            (((u32)(src)<<16) & 0x01ff0000)
#define CFG_CLE_DBPOLICERID0_SET(dst,src) \
                      (((dst) & ~0x01ff0000) | (((u32)(src)<<16) & 0x01ff0000))
/*	 Fields cfg_cle_perflow	 */
#define CFG_CLE_PERFLOW0_WIDTH                                                6
#define CFG_CLE_PERFLOW0_SHIFT                                                8
#define CFG_CLE_PERFLOW0_MASK                                        0x00003f00
#define CFG_CLE_PERFLOW0_RD(src)                      (((src) & 0x00003f00)>>8)
#define CFG_CLE_PERFLOW0_WR(src)                 (((u32)(src)<<8) & 0x00003f00)
#define CFG_CLE_PERFLOW0_SET(dst,src) \
                       (((dst) & ~0x00003f00) | (((u32)(src)<<8) & 0x00003f00))
/*	 Fields cfg_cle_flowgroup	 */
#define CFG_CLE_FLOWGROUP0_WIDTH                                              4
#define CFG_CLE_FLOWGROUP0_SHIFT                                              4
#define CFG_CLE_FLOWGROUP0_MASK                                      0x000000f0
#define CFG_CLE_FLOWGROUP0_RD(src)                    (((src) & 0x000000f0)>>4)
#define CFG_CLE_FLOWGROUP0_WR(src)               (((u32)(src)<<4) & 0x000000f0)
#define CFG_CLE_FLOWGROUP0_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_cle_priority	 */
#define CFG_CLE_PRIORITY0_WIDTH                                               3
#define CFG_CLE_PRIORITY0_SHIFT                                               0
#define CFG_CLE_PRIORITY0_MASK                                       0x00000007
#define CFG_CLE_PRIORITY0_RD(src)                        (((src) & 0x00000007))
#define CFG_CLE_PRIORITY0_WR(src)                   (((u32)(src)) & 0x00000007)
#define CFG_CLE_PRIORITY0_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register CLE_Bypass_Reg4_0	*/ 
/*	 Fields cfg_cle_split_boundary	 */
#define CFG_CLE_SPLIT_BOUNDARY0_WIDTH                                         8
#define CFG_CLE_SPLIT_BOUNDARY0_SHIFT                                        24
#define CFG_CLE_SPLIT_BOUNDARY0_MASK                                 0xff000000
#define CFG_CLE_SPLIT_BOUNDARY0_RD(src)              (((src) & 0xff000000)>>24)
#define CFG_CLE_SPLIT_BOUNDARY0_WR(src)         (((u32)(src)<<24) & 0xff000000)
#define CFG_CLE_SPLIT_BOUNDARY0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_cle_insert_timestamp	 */
#define CFG_CLE_INSERT_TIMESTAMP0_WIDTH                                       1
#define CFG_CLE_INSERT_TIMESTAMP0_SHIFT                                       7
#define CFG_CLE_INSERT_TIMESTAMP0_MASK                               0x00000080
#define CFG_CLE_INSERT_TIMESTAMP0_RD(src)             (((src) & 0x00000080)>>7)
#define CFG_CLE_INSERT_TIMESTAMP0_WR(src)        (((u32)(src)<<7) & 0x00000080)
#define CFG_CLE_INSERT_TIMESTAMP0_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields cfg_cle_mirror	 */
#define CFG_CLE_MIRROR0_WIDTH                                                 1
#define CFG_CLE_MIRROR0_SHIFT                                                 6
#define CFG_CLE_MIRROR0_MASK                                         0x00000040
#define CFG_CLE_MIRROR0_RD(src)                       (((src) & 0x00000040)>>6)
#define CFG_CLE_MIRROR0_WR(src)                  (((u32)(src)<<6) & 0x00000040)
#define CFG_CLE_MIRROR0_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_cle_stash	 */
#define CFG_CLE_STASH0_WIDTH                                                  2
#define CFG_CLE_STASH0_SHIFT                                                  4
#define CFG_CLE_STASH0_MASK                                          0x00000030
#define CFG_CLE_STASH0_RD(src)                        (((src) & 0x00000030)>>4)
#define CFG_CLE_STASH0_WR(src)                   (((u32)(src)<<4) & 0x00000030)
#define CFG_CLE_STASH0_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_cle_in	 */
#define CFG_CLE_IN0_WIDTH                                                     1
#define CFG_CLE_IN0_SHIFT                                                     3
#define CFG_CLE_IN0_MASK                                             0x00000008
#define CFG_CLE_IN0_RD(src)                           (((src) & 0x00000008)>>3)
#define CFG_CLE_IN0_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define CFG_CLE_IN0_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_cle_wol_mode	 */
#define ENET_CFG_CLE_WOL_MODE0_WIDTH                                       1
#define ENET_CFG_CLE_WOL_MODE0_SHIFT                                       2
#define ENET_CFG_CLE_WOL_MODE0_MASK                               0x00000004
#define ENET_CFG_CLE_WOL_MODE0_RD(src)             (((src) & 0x00000004)>>2)
#define ENET_CFG_CLE_WOL_MODE0_WR(src)        (((u32)(src)<<2) & 0x00000004)
#define ENET_CFG_CLE_WOL_MODE0_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_cle_hdr_data_split	 */
#define CFG_CLE_HDR_DATA_SPLIT0_WIDTH                                         1
#define CFG_CLE_HDR_DATA_SPLIT0_SHIFT                                         1
#define CFG_CLE_HDR_DATA_SPLIT0_MASK                                 0x00000002
#define CFG_CLE_HDR_DATA_SPLIT0_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_CLE_HDR_DATA_SPLIT0_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_CLE_HDR_DATA_SPLIT0_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_cle_drop	 */
#define CFG_CLE_DROP0_WIDTH                                                   1
#define CFG_CLE_DROP0_SHIFT                                                   0
#define CFG_CLE_DROP0_MASK                                           0x00000001
#define CFG_CLE_DROP0_RD(src)                            (((src) & 0x00000001))
#define CFG_CLE_DROP0_WR(src)                       (((u32)(src)) & 0x00000001)
#define CFG_CLE_DROP0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CLE_Bypass_Reg5_0	*/ 
/*	 Fields cfg_cle_hopinfolsbs_lsbs	 */
#define CFG_CLE_HOPINFOLSBS_LSBS0_WIDTH                                      32
#define CFG_CLE_HOPINFOLSBS_LSBS0_SHIFT                                       0
#define CFG_CLE_HOPINFOLSBS_LSBS0_MASK                               0xffffffff
#define CFG_CLE_HOPINFOLSBS_LSBS0_RD(src)                (((src) & 0xffffffff))
#define CFG_CLE_HOPINFOLSBS_LSBS0_WR(src)           (((u32)(src)) & 0xffffffff)
#define CFG_CLE_HOPINFOLSBS_LSBS0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CLE_Bypass_Reg6_0	*/ 
/*	 Fields cfg_cle_dr	 */
#define CFG_CLE_DR0_WIDTH                                                     1
#define CFG_CLE_DR0_SHIFT                                                    21
#define CFG_CLE_DR0_MASK                                             0x00200000
#define CFG_CLE_DR0_RD(src)                          (((src) & 0x00200000)>>21)
#define CFG_CLE_DR0_WR(src)                     (((u32)(src)<<21) & 0x00200000)
#define CFG_CLE_DR0_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_cle_hr	 */
#define CFG_CLE_HR0_WIDTH                                                     1
#define CFG_CLE_HR0_SHIFT                                                    20
#define CFG_CLE_HR0_MASK                                             0x00100000
#define CFG_CLE_HR0_RD(src)                          (((src) & 0x00100000)>>20)
#define CFG_CLE_HR0_WR(src)                     (((u32)(src)<<20) & 0x00100000)
#define CFG_CLE_HR0_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_cle_hfpsel	 */
#define CFG_CLE_HFPSEL0_WIDTH                                                 4
#define CFG_CLE_HFPSEL0_SHIFT                                                16
#define CFG_CLE_HFPSEL0_MASK                                         0x000f0000
#define CFG_CLE_HFPSEL0_RD(src)                      (((src) & 0x000f0000)>>16)
#define CFG_CLE_HFPSEL0_WR(src)                 (((u32)(src)<<16) & 0x000f0000)
#define CFG_CLE_HFPSEL0_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_cle_hopinfolsbs_msbs	 */
#define CFG_CLE_HOPINFOLSBS_MSBS0_WIDTH                                      16
#define CFG_CLE_HOPINFOLSBS_MSBS0_SHIFT                                       0
#define CFG_CLE_HOPINFOLSBS_MSBS0_MASK                               0x0000ffff
#define CFG_CLE_HOPINFOLSBS_MSBS0_RD(src)                (((src) & 0x0000ffff))
#define CFG_CLE_HOPINFOLSBS_MSBS0_WR(src)           (((u32)(src)) & 0x0000ffff)
#define CFG_CLE_HOPINFOLSBS_MSBS0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CLE_Bypass_Reg7_0	*/ 
/*	 Fields cfg_cle_hopinfomsbs_lsbs	 */
#define CFG_CLE_HOPINFOMSBS_LSBS0_WIDTH                                      32
#define CFG_CLE_HOPINFOMSBS_LSBS0_SHIFT                                       0
#define CFG_CLE_HOPINFOMSBS_LSBS0_MASK                               0xffffffff
#define CFG_CLE_HOPINFOMSBS_LSBS0_RD(src)                (((src) & 0xffffffff))
#define CFG_CLE_HOPINFOMSBS_LSBS0_WR(src)           (((u32)(src)) & 0xffffffff)
#define CFG_CLE_HOPINFOMSBS_LSBS0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CLE_Bypass_Reg8_0	*/ 
/*	 Fields cfg_cle_henqnum	 */
#define CFG_CLE_HENQNUM0_WIDTH                                               12
#define CFG_CLE_HENQNUM0_SHIFT                                               16
#define CFG_CLE_HENQNUM0_MASK                                        0x0fff0000
#define CFG_CLE_HENQNUM0_RD(src)                     (((src) & 0x0fff0000)>>16)
#define CFG_CLE_HENQNUM0_WR(src)                (((u32)(src)<<16) & 0x0fff0000)
#define CFG_CLE_HENQNUM0_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields cfg_cle_hopinfomsbs_msbs	 */
#define CFG_CLE_HOPINFOMSBS_MSBS0_WIDTH                                      16
#define CFG_CLE_HOPINFOMSBS_MSBS0_SHIFT                                       0
#define CFG_CLE_HOPINFOMSBS_MSBS0_MASK                               0x0000ffff
#define CFG_CLE_HOPINFOMSBS_MSBS0_RD(src)                (((src) & 0x0000ffff))
#define CFG_CLE_HOPINFOMSBS_MSBS0_WR(src)           (((u32)(src)) & 0x0000ffff)
#define CFG_CLE_HOPINFOMSBS_MSBS0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CLE_Bypass_Reg0_1	*/ 
/*	 Fields cfg_cle_bypass_en	 */
#define CFG_CLE_BYPASS_EN1_WIDTH                                              1
#define CFG_CLE_BYPASS_EN1_SHIFT                                             31
#define CFG_CLE_BYPASS_EN1_MASK                                      0x80000000
#define CFG_CLE_BYPASS_EN1_RD(src)                   (((src) & 0x80000000)>>31)
#define CFG_CLE_BYPASS_EN1_WR(src)              (((u32)(src)<<31) & 0x80000000)
#define CFG_CLE_BYPASS_EN1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_cle_result_dlycntr	 */
#define CFG_CLE_RESULT_DLYCNTR1_WIDTH                                         7
#define CFG_CLE_RESULT_DLYCNTR1_SHIFT                                        24
#define CFG_CLE_RESULT_DLYCNTR1_MASK                                 0x7f000000
#define CFG_CLE_RESULT_DLYCNTR1_RD(src)              (((src) & 0x7f000000)>>24)
#define CFG_CLE_RESULT_DLYCNTR1_WR(src)         (((u32)(src)<<24) & 0x7f000000)
#define CFG_CLE_RESULT_DLYCNTR1_SET(dst,src) \
                      (((dst) & ~0x7f000000) | (((u32)(src)<<24) & 0x7f000000))
/*	 Fields cfg_cle_ip_fragment	 */
#define CFG_CLE_IP_FRAGMENT1_WIDTH                                            1
#define CFG_CLE_IP_FRAGMENT1_SHIFT                                           21
#define CFG_CLE_IP_FRAGMENT1_MASK                                    0x00200000
#define CFG_CLE_IP_FRAGMENT1_RD(src)                 (((src) & 0x00200000)>>21)
#define CFG_CLE_IP_FRAGMENT1_WR(src)            (((u32)(src)<<21) & 0x00200000)
#define CFG_CLE_IP_FRAGMENT1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_cle_ip_version	 */
#define CFG_CLE_IP_VERSION1_WIDTH                                             1
#define CFG_CLE_IP_VERSION1_SHIFT                                            20
#define CFG_CLE_IP_VERSION1_MASK                                     0x00100000
#define CFG_CLE_IP_VERSION1_RD(src)                  (((src) & 0x00100000)>>20)
#define CFG_CLE_IP_VERSION1_WR(src)             (((u32)(src)<<20) & 0x00100000)
#define CFG_CLE_IP_VERSION1_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_cle_ip_protocol	 */
#define CFG_CLE_IP_PROTOCOL1_WIDTH                                            2
#define CFG_CLE_IP_PROTOCOL1_SHIFT                                           16
#define CFG_CLE_IP_PROTOCOL1_MASK                                    0x00030000
#define CFG_CLE_IP_PROTOCOL1_RD(src)                 (((src) & 0x00030000)>>16)
#define CFG_CLE_IP_PROTOCOL1_WR(src)            (((u32)(src)<<16) & 0x00030000)
#define CFG_CLE_IP_PROTOCOL1_SET(dst,src) \
                      (((dst) & ~0x00030000) | (((u32)(src)<<16) & 0x00030000))
/*	 Fields cfg_cle_ip_hdr_len	 */
#define CFG_CLE_IP_HDR_LEN1_WIDTH                                             5
#define CFG_CLE_IP_HDR_LEN1_SHIFT                                             8
#define CFG_CLE_IP_HDR_LEN1_MASK                                     0x00001f00
#define CFG_CLE_IP_HDR_LEN1_RD(src)                   (((src) & 0x00001f00)>>8)
#define CFG_CLE_IP_HDR_LEN1_WR(src)              (((u32)(src)<<8) & 0x00001f00)
#define CFG_CLE_IP_HDR_LEN1_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields cfg_cle_eth_hdr_len	 */
#define CFG_CLE_ETH_HDR_LEN1_WIDTH                                            7
#define CFG_CLE_ETH_HDR_LEN1_SHIFT                                            0
#define CFG_CLE_ETH_HDR_LEN1_MASK                                    0x0000007f
#define CFG_CLE_ETH_HDR_LEN1_RD(src)                     (((src) & 0x0000007f))
#define CFG_CLE_ETH_HDR_LEN1_WR(src)                (((u32)(src)) & 0x0000007f)
#define CFG_CLE_ETH_HDR_LEN1_SET(dst,src) \
                          (((dst) & ~0x0000007f) | (((u32)(src)) & 0x0000007f))

/*	Register CLE_Bypass_Reg1_1	*/ 
/*	 Fields cfg_cle_nxtfpsel	 */
#define CFG_CLE_NXTFPSEL1_WIDTH                                               4
#define CFG_CLE_NXTFPSEL1_SHIFT                                              20
#define CFG_CLE_NXTFPSEL1_MASK                                       0x00f00000
#define CFG_CLE_NXTFPSEL1_RD(src)                    (((src) & 0x00f00000)>>20)
#define CFG_CLE_NXTFPSEL1_WR(src)               (((u32)(src)<<20) & 0x00f00000)
#define CFG_CLE_NXTFPSEL1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_cle_fpsel	 */
#define CFG_CLE_FPSEL1_WIDTH                                                  4
#define CFG_CLE_FPSEL1_SHIFT                                                 16
#define CFG_CLE_FPSEL1_MASK                                          0x000f0000
#define CFG_CLE_FPSEL1_RD(src)                       (((src) & 0x000f0000)>>16)
#define CFG_CLE_FPSEL1_WR(src)                  (((u32)(src)<<16) & 0x000f0000)
#define CFG_CLE_FPSEL1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_cle_dstqid	 */
#define CFG_CLE_DSTQID1_WIDTH                                                12
#define CFG_CLE_DSTQID1_SHIFT                                                 0
#define CFG_CLE_DSTQID1_MASK                                         0x00000fff
#define CFG_CLE_DSTQID1_RD(src)                          (((src) & 0x00000fff))
#define CFG_CLE_DSTQID1_WR(src)                     (((u32)(src)) & 0x00000fff)
#define CFG_CLE_DSTQID1_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CLE_Bypass_Reg2_1	*/ 
/*	 Fields cfg_cle_mirror_nxtfpsel	 */
#define CFG_CLE_MIRROR_NXTFPSEL1_WIDTH                                        4
#define CFG_CLE_MIRROR_NXTFPSEL1_SHIFT                                       20
#define CFG_CLE_MIRROR_NXTFPSEL1_MASK                                0x00f00000
#define CFG_CLE_MIRROR_NXTFPSEL1_RD(src)             (((src) & 0x00f00000)>>20)
#define CFG_CLE_MIRROR_NXTFPSEL1_WR(src)        (((u32)(src)<<20) & 0x00f00000)
#define CFG_CLE_MIRROR_NXTFPSEL1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_cle_mirror_fpsel	 */
#define CFG_CLE_MIRROR_FPSEL1_WIDTH                                           4
#define CFG_CLE_MIRROR_FPSEL1_SHIFT                                          16
#define CFG_CLE_MIRROR_FPSEL1_MASK                                   0x000f0000
#define CFG_CLE_MIRROR_FPSEL1_RD(src)                (((src) & 0x000f0000)>>16)
#define CFG_CLE_MIRROR_FPSEL1_WR(src)           (((u32)(src)<<16) & 0x000f0000)
#define CFG_CLE_MIRROR_FPSEL1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_cle_mirror_dstqid	 */
#define CFG_CLE_MIRROR_DSTQID1_WIDTH                                         12
#define CFG_CLE_MIRROR_DSTQID1_SHIFT                                          0
#define CFG_CLE_MIRROR_DSTQID1_MASK                                  0x00000fff
#define CFG_CLE_MIRROR_DSTQID1_RD(src)                   (((src) & 0x00000fff))
#define CFG_CLE_MIRROR_DSTQID1_WR(src)              (((u32)(src)) & 0x00000fff)
#define CFG_CLE_MIRROR_DSTQID1_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CLE_Bypass_Reg3_1	*/ 
/*	 Fields cfg_cle_dbpolicer_en	 */
#define CFG_CLE_DBPOLICER_EN1_WIDTH                                           1
#define CFG_CLE_DBPOLICER_EN1_SHIFT                                          28
#define CFG_CLE_DBPOLICER_EN1_MASK                                   0x10000000
#define CFG_CLE_DBPOLICER_EN1_RD(src)                (((src) & 0x10000000)>>28)
#define CFG_CLE_DBPOLICER_EN1_WR(src)           (((u32)(src)<<28) & 0x10000000)
#define CFG_CLE_DBPOLICER_EN1_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields cfg_cle_dbpolicerid	 */
#define CFG_CLE_DBPOLICERID1_WIDTH                                            9
#define CFG_CLE_DBPOLICERID1_SHIFT                                           16
#define CFG_CLE_DBPOLICERID1_MASK                                    0x01ff0000
#define CFG_CLE_DBPOLICERID1_RD(src)                 (((src) & 0x01ff0000)>>16)
#define CFG_CLE_DBPOLICERID1_WR(src)            (((u32)(src)<<16) & 0x01ff0000)
#define CFG_CLE_DBPOLICERID1_SET(dst,src) \
                      (((dst) & ~0x01ff0000) | (((u32)(src)<<16) & 0x01ff0000))
/*	 Fields cfg_cle_perflow	 */
#define CFG_CLE_PERFLOW1_WIDTH                                                6
#define CFG_CLE_PERFLOW1_SHIFT                                                8
#define CFG_CLE_PERFLOW1_MASK                                        0x00003f00
#define CFG_CLE_PERFLOW1_RD(src)                      (((src) & 0x00003f00)>>8)
#define CFG_CLE_PERFLOW1_WR(src)                 (((u32)(src)<<8) & 0x00003f00)
#define CFG_CLE_PERFLOW1_SET(dst,src) \
                       (((dst) & ~0x00003f00) | (((u32)(src)<<8) & 0x00003f00))
/*	 Fields cfg_cle_flowgroup	 */
#define CFG_CLE_FLOWGROUP1_WIDTH                                              4
#define CFG_CLE_FLOWGROUP1_SHIFT                                              4
#define CFG_CLE_FLOWGROUP1_MASK                                      0x000000f0
#define CFG_CLE_FLOWGROUP1_RD(src)                    (((src) & 0x000000f0)>>4)
#define CFG_CLE_FLOWGROUP1_WR(src)               (((u32)(src)<<4) & 0x000000f0)
#define CFG_CLE_FLOWGROUP1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_cle_priority	 */
#define CFG_CLE_PRIORITY1_WIDTH                                               3
#define CFG_CLE_PRIORITY1_SHIFT                                               0
#define CFG_CLE_PRIORITY1_MASK                                       0x00000007
#define CFG_CLE_PRIORITY1_RD(src)                        (((src) & 0x00000007))
#define CFG_CLE_PRIORITY1_WR(src)                   (((u32)(src)) & 0x00000007)
#define CFG_CLE_PRIORITY1_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register CLE_Bypass_Reg4_1	*/ 
/*	 Fields cfg_cle_split_boundary	 */
#define CFG_CLE_SPLIT_BOUNDARY1_WIDTH                                         8
#define CFG_CLE_SPLIT_BOUNDARY1_SHIFT                                        24
#define CFG_CLE_SPLIT_BOUNDARY1_MASK                                 0xff000000
#define CFG_CLE_SPLIT_BOUNDARY1_RD(src)              (((src) & 0xff000000)>>24)
#define CFG_CLE_SPLIT_BOUNDARY1_WR(src)         (((u32)(src)<<24) & 0xff000000)
#define CFG_CLE_SPLIT_BOUNDARY1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_cle_insert_timestamp	 */
#define CFG_CLE_INSERT_TIMESTAMP1_WIDTH                                       1
#define CFG_CLE_INSERT_TIMESTAMP1_SHIFT                                       7
#define CFG_CLE_INSERT_TIMESTAMP1_MASK                               0x00000080
#define CFG_CLE_INSERT_TIMESTAMP1_RD(src)             (((src) & 0x00000080)>>7)
#define CFG_CLE_INSERT_TIMESTAMP1_WR(src)        (((u32)(src)<<7) & 0x00000080)
#define CFG_CLE_INSERT_TIMESTAMP1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields cfg_cle_mirror	 */
#define CFG_CLE_MIRROR1_WIDTH                                                 1
#define CFG_CLE_MIRROR1_SHIFT                                                 6
#define CFG_CLE_MIRROR1_MASK                                         0x00000040
#define CFG_CLE_MIRROR1_RD(src)                       (((src) & 0x00000040)>>6)
#define CFG_CLE_MIRROR1_WR(src)                  (((u32)(src)<<6) & 0x00000040)
#define CFG_CLE_MIRROR1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_cle_stash	 */
#define CFG_CLE_STASH1_WIDTH                                                  2
#define CFG_CLE_STASH1_SHIFT                                                  4
#define CFG_CLE_STASH1_MASK                                          0x00000030
#define CFG_CLE_STASH1_RD(src)                        (((src) & 0x00000030)>>4)
#define CFG_CLE_STASH1_WR(src)                   (((u32)(src)<<4) & 0x00000030)
#define CFG_CLE_STASH1_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_cle_in	 */
#define CFG_CLE_IN1_WIDTH                                                     1
#define CFG_CLE_IN1_SHIFT                                                     3
#define CFG_CLE_IN1_MASK                                             0x00000008
#define CFG_CLE_IN1_RD(src)                           (((src) & 0x00000008)>>3)
#define CFG_CLE_IN1_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define CFG_CLE_IN1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_cle_wol_mode	 */
#define ENET_CFG_CLE_WOL_MODE1_WIDTH                                       1
#define ENET_CFG_CLE_WOL_MODE1_SHIFT                                       2
#define ENET_CFG_CLE_WOL_MODE1_MASK                               0x00000004
#define ENET_CFG_CLE_WOL_MODE1_RD(src)             (((src) & 0x00000004)>>2)
#define ENET_CFG_CLE_WOL_MODE1_WR(src)        (((u32)(src)<<2) & 0x00000004)
#define ENET_CFG_CLE_WOL_MODE1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_cle_hdr_data_split	 */
#define CFG_CLE_HDR_DATA_SPLIT1_WIDTH                                         1
#define CFG_CLE_HDR_DATA_SPLIT1_SHIFT                                         1
#define CFG_CLE_HDR_DATA_SPLIT1_MASK                                 0x00000002
#define CFG_CLE_HDR_DATA_SPLIT1_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_CLE_HDR_DATA_SPLIT1_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_CLE_HDR_DATA_SPLIT1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_cle_drop	 */
#define CFG_CLE_DROP1_WIDTH                                                   1
#define CFG_CLE_DROP1_SHIFT                                                   0
#define CFG_CLE_DROP1_MASK                                           0x00000001
#define CFG_CLE_DROP1_RD(src)                            (((src) & 0x00000001))
#define CFG_CLE_DROP1_WR(src)                       (((u32)(src)) & 0x00000001)
#define CFG_CLE_DROP1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CLE_Bypass_Reg5_1	*/ 
/*	 Fields cfg_cle_hopinfolsbs_lsbs	 */
#define CFG_CLE_HOPINFOLSBS_LSBS1_WIDTH                                      32
#define CFG_CLE_HOPINFOLSBS_LSBS1_SHIFT                                       0
#define CFG_CLE_HOPINFOLSBS_LSBS1_MASK                               0xffffffff
#define CFG_CLE_HOPINFOLSBS_LSBS1_RD(src)                (((src) & 0xffffffff))
#define CFG_CLE_HOPINFOLSBS_LSBS1_WR(src)           (((u32)(src)) & 0xffffffff)
#define CFG_CLE_HOPINFOLSBS_LSBS1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CLE_Bypass_Reg6_1	*/ 
/*	 Fields cfg_cle_dr	 */
#define CFG_CLE_DR1_WIDTH                                                     1
#define CFG_CLE_DR1_SHIFT                                                    21
#define CFG_CLE_DR1_MASK                                             0x00200000
#define CFG_CLE_DR1_RD(src)                          (((src) & 0x00200000)>>21)
#define CFG_CLE_DR1_WR(src)                     (((u32)(src)<<21) & 0x00200000)
#define CFG_CLE_DR1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_cle_hr	 */
#define CFG_CLE_HR1_WIDTH                                                     1
#define CFG_CLE_HR1_SHIFT                                                    20
#define CFG_CLE_HR1_MASK                                             0x00100000
#define CFG_CLE_HR1_RD(src)                          (((src) & 0x00100000)>>20)
#define CFG_CLE_HR1_WR(src)                     (((u32)(src)<<20) & 0x00100000)
#define CFG_CLE_HR1_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_cle_hfpsel	 */
#define CFG_CLE_HFPSEL1_WIDTH                                                 4
#define CFG_CLE_HFPSEL1_SHIFT                                                16
#define CFG_CLE_HFPSEL1_MASK                                         0x000f0000
#define CFG_CLE_HFPSEL1_RD(src)                      (((src) & 0x000f0000)>>16)
#define CFG_CLE_HFPSEL1_WR(src)                 (((u32)(src)<<16) & 0x000f0000)
#define CFG_CLE_HFPSEL1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_cle_hopinfolsbs_msbs	 */
#define CFG_CLE_HOPINFOLSBS_MSBS1_WIDTH                                      16
#define CFG_CLE_HOPINFOLSBS_MSBS1_SHIFT                                       0
#define CFG_CLE_HOPINFOLSBS_MSBS1_MASK                               0x0000ffff
#define CFG_CLE_HOPINFOLSBS_MSBS1_RD(src)                (((src) & 0x0000ffff))
#define CFG_CLE_HOPINFOLSBS_MSBS1_WR(src)           (((u32)(src)) & 0x0000ffff)
#define CFG_CLE_HOPINFOLSBS_MSBS1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CLE_Bypass_Reg7_1	*/ 
/*	 Fields cfg_cle_hopinfomsbs_lsbs	 */
#define CFG_CLE_HOPINFOMSBS_LSBS1_WIDTH                                      32
#define CFG_CLE_HOPINFOMSBS_LSBS1_SHIFT                                       0
#define CFG_CLE_HOPINFOMSBS_LSBS1_MASK                               0xffffffff
#define CFG_CLE_HOPINFOMSBS_LSBS1_RD(src)                (((src) & 0xffffffff))
#define CFG_CLE_HOPINFOMSBS_LSBS1_WR(src)           (((u32)(src)) & 0xffffffff)
#define CFG_CLE_HOPINFOMSBS_LSBS1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CLE_Bypass_Reg8_1	*/ 
/*	 Fields cfg_cle_henqnum	 */
#define CFG_CLE_HENQNUM1_WIDTH                                               12
#define CFG_CLE_HENQNUM1_SHIFT                                               16
#define CFG_CLE_HENQNUM1_MASK                                        0x0fff0000
#define CFG_CLE_HENQNUM1_RD(src)                     (((src) & 0x0fff0000)>>16)
#define CFG_CLE_HENQNUM1_WR(src)                (((u32)(src)<<16) & 0x0fff0000)
#define CFG_CLE_HENQNUM1_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields cfg_cle_hopinfomsbs_msbs	 */
#define CFG_CLE_HOPINFOMSBS_MSBS1_WIDTH                                      16
#define CFG_CLE_HOPINFOMSBS_MSBS1_SHIFT                                       0
#define CFG_CLE_HOPINFOMSBS_MSBS1_MASK                               0x0000ffff
#define CFG_CLE_HOPINFOMSBS_MSBS1_RD(src)                (((src) & 0x0000ffff))
#define CFG_CLE_HOPINFOMSBS_MSBS1_WR(src)           (((u32)(src)) & 0x0000ffff)
#define CFG_CLE_HOPINFOMSBS_MSBS1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RxBuf_Config_Thresh_Reg	*/ 
/*	 Fields cfg_rxbuf_full_thresh	 */
#define CFG_RXBUF_FULL_THRESH_WIDTH                                          16
#define CFG_RXBUF_FULL_THRESH_SHIFT                                          16
#define CFG_RXBUF_FULL_THRESH_MASK                                   0xffff0000
#define CFG_RXBUF_FULL_THRESH_RD(src)                (((src) & 0xffff0000)>>16)
#define CFG_RXBUF_FULL_THRESH_WR(src)           (((u32)(src)<<16) & 0xffff0000)
#define CFG_RXBUF_FULL_THRESH_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_rxbuf_empty_thresh	 */
#define CFG_RXBUF_EMPTY_THRESH_WIDTH                                         16
#define CFG_RXBUF_EMPTY_THRESH_SHIFT                                          0
#define CFG_RXBUF_EMPTY_THRESH_MASK                                  0x0000ffff
#define CFG_RXBUF_EMPTY_THRESH_RD(src)                   (((src) & 0x0000ffff))
#define CFG_RXBUF_EMPTY_THRESH_WR(src)              (((u32)(src)) & 0x0000ffff)
#define CFG_RXBUF_EMPTY_THRESH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RxBuf_Config_Port_Depth_Reg	*/ 
/*	 Fields cfg_rxbuf_port0_depth	 */
#define CFG_RXBUF_PORT0_DEPTH_WIDTH                                          16
#define CFG_RXBUF_PORT0_DEPTH_SHIFT                                          16
#define CFG_RXBUF_PORT0_DEPTH_MASK                                   0xffff0000
#define CFG_RXBUF_PORT0_DEPTH_RD(src)                (((src) & 0xffff0000)>>16)
#define CFG_RXBUF_PORT0_DEPTH_WR(src)           (((u32)(src)<<16) & 0xffff0000)
#define CFG_RXBUF_PORT0_DEPTH_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_rxbuf_port1_depth	 */
#define CFG_RXBUF_PORT1_DEPTH_WIDTH                                          16
#define CFG_RXBUF_PORT1_DEPTH_SHIFT                                           0
#define CFG_RXBUF_PORT1_DEPTH_MASK                                   0x0000ffff
#define CFG_RXBUF_PORT1_DEPTH_RD(src)                    (((src) & 0x0000ffff))
#define CFG_RXBUF_PORT1_DEPTH_WR(src)               (((u32)(src)) & 0x0000ffff)
#define CFG_RXBUF_PORT1_DEPTH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RxBuf_Config_Start_Addr_Reg	*/ 
/*	 Fields cfg_rxbuf_port0_startaddr	 */
#define CFG_RXBUF_PORT0_STARTADDR_WIDTH                                      16
#define CFG_RXBUF_PORT0_STARTADDR_SHIFT                                      16
#define CFG_RXBUF_PORT0_STARTADDR_MASK                               0xffff0000
#define CFG_RXBUF_PORT0_STARTADDR_RD(src)            (((src) & 0xffff0000)>>16)
#define CFG_RXBUF_PORT0_STARTADDR_WR(src)       (((u32)(src)<<16) & 0xffff0000)
#define CFG_RXBUF_PORT0_STARTADDR_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_rxbuf_port1_startaddr	 */
#define CFG_RXBUF_PORT1_STARTADDR_WIDTH                                      16
#define CFG_RXBUF_PORT1_STARTADDR_SHIFT                                       0
#define CFG_RXBUF_PORT1_STARTADDR_MASK                               0x0000ffff
#define CFG_RXBUF_PORT1_STARTADDR_RD(src)                (((src) & 0x0000ffff))
#define CFG_RXBUF_PORT1_STARTADDR_WR(src)           (((u32)(src)) & 0x0000ffff)
#define CFG_RXBUF_PORT1_STARTADDR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RxBuf_Config_Buffer_Reg	*/ 
/*	 Fields cfg_rxbuf_store_fwd_mode	 */
#define ENET_CFG_RXBUF_STORE_FWD_MODE_WIDTH                                1
#define ENET_CFG_RXBUF_STORE_FWD_MODE_SHIFT                               16
#define ENET_CFG_RXBUF_STORE_FWD_MODE_MASK                        0x00010000
#define ENET_CFG_RXBUF_STORE_FWD_MODE_RD(src)     (((src) & 0x00010000)>>16)
#define ENET_CFG_RXBUF_STORE_FWD_MODE_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define ENET_CFG_RXBUF_STORE_FWD_MODE_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_rxbuf_read_thresh	 */
#define CFG_RXBUF_READ_THRESH_WIDTH                                          16
#define CFG_RXBUF_READ_THRESH_SHIFT                                           0
#define CFG_RXBUF_READ_THRESH_MASK                                   0x0000ffff
#define CFG_RXBUF_READ_THRESH_RD(src)                    (((src) & 0x0000ffff))
#define CFG_RXBUF_READ_THRESH_WR(src)               (((u32)(src)) & 0x0000ffff)
#define CFG_RXBUF_READ_THRESH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TxBuf_Config_Thresh_Reg	*/ 
/*	 Fields cfg_txbuf_full_thresh	 */
#define CFG_TXBUF_FULL_THRESH_WIDTH                                          16
#define CFG_TXBUF_FULL_THRESH_SHIFT                                          16
#define CFG_TXBUF_FULL_THRESH_MASK                                   0xffff0000
#define CFG_TXBUF_FULL_THRESH_RD(src)                (((src) & 0xffff0000)>>16)
#define CFG_TXBUF_FULL_THRESH_WR(src)           (((u32)(src)<<16) & 0xffff0000)
#define CFG_TXBUF_FULL_THRESH_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_txbuf_empty_thresh	 */
#define CFG_TXBUF_EMPTY_THRESH_WIDTH                                         16
#define CFG_TXBUF_EMPTY_THRESH_SHIFT                                          0
#define CFG_TXBUF_EMPTY_THRESH_MASK                                  0x0000ffff
#define CFG_TXBUF_EMPTY_THRESH_RD(src)                   (((src) & 0x0000ffff))
#define CFG_TXBUF_EMPTY_THRESH_WR(src)              (((u32)(src)) & 0x0000ffff)
#define CFG_TXBUF_EMPTY_THRESH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TxBuf_Config_Port_Depth_Reg	*/ 
/*	 Fields cfg_txbuf_port0_depth	 */
#define CFG_TXBUF_PORT0_DEPTH_WIDTH                                          16
#define CFG_TXBUF_PORT0_DEPTH_SHIFT                                          16
#define CFG_TXBUF_PORT0_DEPTH_MASK                                   0xffff0000
#define CFG_TXBUF_PORT0_DEPTH_RD(src)                (((src) & 0xffff0000)>>16)
#define CFG_TXBUF_PORT0_DEPTH_WR(src)           (((u32)(src)<<16) & 0xffff0000)
#define CFG_TXBUF_PORT0_DEPTH_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_txbuf_port1_depth	 */
#define CFG_TXBUF_PORT1_DEPTH_WIDTH                                          16
#define CFG_TXBUF_PORT1_DEPTH_SHIFT                                           0
#define CFG_TXBUF_PORT1_DEPTH_MASK                                   0x0000ffff
#define CFG_TXBUF_PORT1_DEPTH_RD(src)                    (((src) & 0x0000ffff))
#define CFG_TXBUF_PORT1_DEPTH_WR(src)               (((u32)(src)) & 0x0000ffff)
#define CFG_TXBUF_PORT1_DEPTH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TxBuf_Config_Start_Addr_Reg	*/ 
/*	 Fields cfg_txbuf_port0_startaddr	 */
#define CFG_TXBUF_PORT0_STARTADDR_WIDTH                                      16
#define CFG_TXBUF_PORT0_STARTADDR_SHIFT                                      16
#define CFG_TXBUF_PORT0_STARTADDR_MASK                               0xffff0000
#define CFG_TXBUF_PORT0_STARTADDR_RD(src)            (((src) & 0xffff0000)>>16)
#define CFG_TXBUF_PORT0_STARTADDR_WR(src)       (((u32)(src)<<16) & 0xffff0000)
#define CFG_TXBUF_PORT0_STARTADDR_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_txbuf_port1_startaddr	 */
#define CFG_TXBUF_PORT1_STARTADDR_WIDTH                                      16
#define CFG_TXBUF_PORT1_STARTADDR_SHIFT                                       0
#define CFG_TXBUF_PORT1_STARTADDR_MASK                               0x0000ffff
#define CFG_TXBUF_PORT1_STARTADDR_RD(src)                (((src) & 0x0000ffff))
#define CFG_TXBUF_PORT1_STARTADDR_WR(src)           (((u32)(src)) & 0x0000ffff)
#define CFG_TXBUF_PORT1_STARTADDR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TxBuf_Config_Buffer_Reg	*/ 
/*	 Fields cfg_txbuf_arb_mode	 */
#define ENET_CFG_TXBUF_ARB_MODE_WIDTH                                      1
#define ENET_CFG_TXBUF_ARB_MODE_SHIFT                                     20
#define ENET_CFG_TXBUF_ARB_MODE_MASK                              0x00100000
#define ENET_CFG_TXBUF_ARB_MODE_RD(src)           (((src) & 0x00100000)>>20)
#define ENET_CFG_TXBUF_ARB_MODE_WR(src)      (((u32)(src)<<20) & 0x00100000)
#define ENET_CFG_TXBUF_ARB_MODE_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_txbuf_store_fwd_mode	 */
#define ENET_CFG_TXBUF_STORE_FWD_MODE_WIDTH                                1
#define ENET_CFG_TXBUF_STORE_FWD_MODE_SHIFT                               16
#define ENET_CFG_TXBUF_STORE_FWD_MODE_MASK                        0x00010000
#define ENET_CFG_TXBUF_STORE_FWD_MODE_RD(src)     (((src) & 0x00010000)>>16)
#define ENET_CFG_TXBUF_STORE_FWD_MODE_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define ENET_CFG_TXBUF_STORE_FWD_MODE_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_txbuf_read_thresh	 */
#define CFG_TXBUF_READ_THRESH_WIDTH                                          16
#define CFG_TXBUF_READ_THRESH_SHIFT                                           0
#define CFG_TXBUF_READ_THRESH_MASK                                   0x0000ffff
#define CFG_TXBUF_READ_THRESH_RD(src)                    (((src) & 0x0000ffff))
#define CFG_TXBUF_READ_THRESH_WR(src)               (((u32)(src)) & 0x0000ffff)
#define CFG_TXBUF_READ_THRESH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register Timer_Config1_Reg	*/ 
/*	 Fields CfgMicroSecInc	 */
#define CFGMICROSECINC_WIDTH                                                 10
#define CFGMICROSECINC_SHIFT                                                 20
#define CFGMICROSECINC_MASK                                          0x3ff00000
#define CFGMICROSECINC_RD(src)                       (((src) & 0x3ff00000)>>20)
#define CFGMICROSECINC_WR(src)                  (((u32)(src)<<20) & 0x3ff00000)
#define CFGMICROSECINC_SET(dst,src) \
                      (((dst) & ~0x3ff00000) | (((u32)(src)<<20) & 0x3ff00000))
/*	 Fields CfgMicroSecLimit	 */
#define CFGMICROSECLIMIT_WIDTH                                               10
#define CFGMICROSECLIMIT_SHIFT                                               10
#define CFGMICROSECLIMIT_MASK                                        0x000ffc00
#define CFGMICROSECLIMIT_RD(src)                     (((src) & 0x000ffc00)>>10)
#define CFGMICROSECLIMIT_WR(src)                (((u32)(src)<<10) & 0x000ffc00)
#define CFGMICROSECLIMIT_SET(dst,src) \
                      (((dst) & ~0x000ffc00) | (((u32)(src)<<10) & 0x000ffc00))
/*	 Fields CfgMilliSecLimit	 */
#define CFGMILLISECLIMIT_WIDTH                                               10
#define CFGMILLISECLIMIT_SHIFT                                                0
#define CFGMILLISECLIMIT_MASK                                        0x000003ff
#define CFGMILLISECLIMIT_RD(src)                         (((src) & 0x000003ff))
#define CFGMILLISECLIMIT_WR(src)                    (((u32)(src)) & 0x000003ff)
#define CFGMILLISECLIMIT_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register Timer_Config2_Reg	*/ 
/*	 Fields Cfg100NSecCntLimit	 */
#define CFG100NSECCNTLIMIT_WIDTH                                              8
#define CFG100NSECCNTLIMIT_SHIFT                                             16
#define CFG100NSECCNTLIMIT_MASK                                      0x00ff0000
#define CFG100NSECCNTLIMIT_RD(src)                   (((src) & 0x00ff0000)>>16)
#define CFG100NSECCNTLIMIT_WR(src)              (((u32)(src)<<16) & 0x00ff0000)
#define CFG100NSECCNTLIMIT_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields CfgMCnt	 */
#define CFGMCNT_WIDTH                                                         8
#define CFGMCNT_SHIFT                                                         8
#define CFGMCNT_MASK                                                 0x0000ff00
#define CFGMCNT_RD(src)                               (((src) & 0x0000ff00)>>8)
#define CFGMCNT_WR(src)                          (((u32)(src)<<8) & 0x0000ff00)
#define CFGMCNT_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields CfgNCnt	 */
#define CFGNCNT_WIDTH                                                         8
#define CFGNCNT_SHIFT                                                         0
#define CFGNCNT_MASK                                                 0x000000ff
#define CFGNCNT_RD(src)                                  (((src) & 0x000000ff))
#define CFGNCNT_WR(src)                             (((u32)(src)) & 0x000000ff)
#define CFGNCNT_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register Rx_Tx_Buf_Sts_Reg0	*/ 
/*	 Fields txbuf_fifo_empty_prt1	 */
#define TXBUF_FIFO_EMPTY_PRT10_WIDTH                                          1
#define TXBUF_FIFO_EMPTY_PRT10_SHIFT                                         17
#define TXBUF_FIFO_EMPTY_PRT10_MASK                                  0x00020000
#define TXBUF_FIFO_EMPTY_PRT10_RD(src)               (((src) & 0x00020000)>>17)
#define TXBUF_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields rxbuf_fifo_empty_prt1	 */
#define RXBUF_FIFO_EMPTY_PRT10_WIDTH                                          1
#define RXBUF_FIFO_EMPTY_PRT10_SHIFT                                         16
#define RXBUF_FIFO_EMPTY_PRT10_MASK                                  0x00010000
#define RXBUF_FIFO_EMPTY_PRT10_RD(src)               (((src) & 0x00010000)>>16)
#define RXBUF_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields txbuf_fifo_empty_prt0	 */
#define TXBUF_FIFO_EMPTY_PRT00_WIDTH                                          1
#define TXBUF_FIFO_EMPTY_PRT00_SHIFT                                          1
#define TXBUF_FIFO_EMPTY_PRT00_MASK                                  0x00000002
#define TXBUF_FIFO_EMPTY_PRT00_RD(src)                (((src) & 0x00000002)>>1)
#define TXBUF_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields rxbuf_fifo_empty_prt0	 */
#define RXBUF_FIFO_EMPTY_PRT00_WIDTH                                          1
#define RXBUF_FIFO_EMPTY_PRT00_SHIFT                                          0
#define RXBUF_FIFO_EMPTY_PRT00_MASK                                  0x00000001
#define RXBUF_FIFO_EMPTY_PRT00_RD(src)                   (((src) & 0x00000001))
#define RXBUF_FIFO_EMPTY_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register Rx_Tx_buf_chksm_Int_Reg0	*/ 
/*	 Fields rxbuf_pause_intr_port1	 */
#define RXBUF_PAUSE_INTR_PORT10_WIDTH                                         1
#define RXBUF_PAUSE_INTR_PORT10_SHIFT                                        22
#define RXBUF_PAUSE_INTR_PORT10_MASK                                 0x00400000
#define RXBUF_PAUSE_INTR_PORT10_RD(src)              (((src) & 0x00400000)>>22)
#define RXBUF_PAUSE_INTR_PORT10_WR(src)         (((u32)(src)<<22) & 0x00400000)
#define RXBUF_PAUSE_INTR_PORT10_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields rx_chksum_intr_port1	 */
#define RX_CHKSUM_INTR_PORT10_WIDTH                                           1
#define RX_CHKSUM_INTR_PORT10_SHIFT                                          21
#define RX_CHKSUM_INTR_PORT10_MASK                                   0x00200000
#define RX_CHKSUM_INTR_PORT10_RD(src)                (((src) & 0x00200000)>>21)
#define RX_CHKSUM_INTR_PORT10_WR(src)           (((u32)(src)<<21) & 0x00200000)
#define RX_CHKSUM_INTR_PORT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields tx_chksum_intr_port1	 */
#define TX_CHKSUM_INTR_PORT10_WIDTH                                           1
#define TX_CHKSUM_INTR_PORT10_SHIFT                                          20
#define TX_CHKSUM_INTR_PORT10_MASK                                   0x00100000
#define TX_CHKSUM_INTR_PORT10_RD(src)                (((src) & 0x00100000)>>20)
#define TX_CHKSUM_INTR_PORT10_WR(src)           (((u32)(src)<<20) & 0x00100000)
#define TX_CHKSUM_INTR_PORT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields rxbuf_fifo_overfl_intr_prt1	 */
#define RXBUF_FIFO_OVERFL_INTR_PRT10_WIDTH                                    1
#define RXBUF_FIFO_OVERFL_INTR_PRT10_SHIFT                                   19
#define RXBUF_FIFO_OVERFL_INTR_PRT10_MASK                            0x00080000
#define RXBUF_FIFO_OVERFL_INTR_PRT10_RD(src)         (((src) & 0x00080000)>>19)
#define RXBUF_FIFO_OVERFL_INTR_PRT10_WR(src)    (((u32)(src)<<19) & 0x00080000)
#define RXBUF_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields rxbuf_fifo_underfl_intr_prt1	 */
#define RXBUF_FIFO_UNDERFL_INTR_PRT10_WIDTH                                   1
#define RXBUF_FIFO_UNDERFL_INTR_PRT10_SHIFT                                  18
#define RXBUF_FIFO_UNDERFL_INTR_PRT10_MASK                           0x00040000
#define RXBUF_FIFO_UNDERFL_INTR_PRT10_RD(src)        (((src) & 0x00040000)>>18)
#define RXBUF_FIFO_UNDERFL_INTR_PRT10_WR(src)   (((u32)(src)<<18) & 0x00040000)
#define RXBUF_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields txbuf_fifo_overfl_intr_prt1	 */
#define TXBUF_FIFO_OVERFL_INTR_PRT10_WIDTH                                    1
#define TXBUF_FIFO_OVERFL_INTR_PRT10_SHIFT                                   17
#define TXBUF_FIFO_OVERFL_INTR_PRT10_MASK                            0x00020000
#define TXBUF_FIFO_OVERFL_INTR_PRT10_RD(src)         (((src) & 0x00020000)>>17)
#define TXBUF_FIFO_OVERFL_INTR_PRT10_WR(src)    (((u32)(src)<<17) & 0x00020000)
#define TXBUF_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields txbuf_fifo_underfl_intr_prt1	 */
#define TXBUF_FIFO_UNDERFL_INTR_PRT10_WIDTH                                   1
#define TXBUF_FIFO_UNDERFL_INTR_PRT10_SHIFT                                  16
#define TXBUF_FIFO_UNDERFL_INTR_PRT10_MASK                           0x00010000
#define TXBUF_FIFO_UNDERFL_INTR_PRT10_RD(src)        (((src) & 0x00010000)>>16)
#define TXBUF_FIFO_UNDERFL_INTR_PRT10_WR(src)   (((u32)(src)<<16) & 0x00010000)
#define TXBUF_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields rxbuf_pause_intr_port0	 */
#define RXBUF_PAUSE_INTR_PORT00_WIDTH                                         1
#define RXBUF_PAUSE_INTR_PORT00_SHIFT                                         6
#define RXBUF_PAUSE_INTR_PORT00_MASK                                 0x00000040
#define RXBUF_PAUSE_INTR_PORT00_RD(src)               (((src) & 0x00000040)>>6)
#define RXBUF_PAUSE_INTR_PORT00_WR(src)          (((u32)(src)<<6) & 0x00000040)
#define RXBUF_PAUSE_INTR_PORT00_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields rx_chksum_intr_port0	 */
#define RX_CHKSUM_INTR_PORT00_WIDTH                                           1
#define RX_CHKSUM_INTR_PORT00_SHIFT                                           5
#define RX_CHKSUM_INTR_PORT00_MASK                                   0x00000020
#define RX_CHKSUM_INTR_PORT00_RD(src)                 (((src) & 0x00000020)>>5)
#define RX_CHKSUM_INTR_PORT00_WR(src)            (((u32)(src)<<5) & 0x00000020)
#define RX_CHKSUM_INTR_PORT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields tx_chksum_intr_port0	 */
#define TX_CHKSUM_INTR_PORT00_WIDTH                                           1
#define TX_CHKSUM_INTR_PORT00_SHIFT                                           4
#define TX_CHKSUM_INTR_PORT00_MASK                                   0x00000010
#define TX_CHKSUM_INTR_PORT00_RD(src)                 (((src) & 0x00000010)>>4)
#define TX_CHKSUM_INTR_PORT00_WR(src)            (((u32)(src)<<4) & 0x00000010)
#define TX_CHKSUM_INTR_PORT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields rxbuf_fifo_overfl_intr_prt0	 */
#define RXBUF_FIFO_OVERFL_INTR_PRT00_WIDTH                                    1
#define RXBUF_FIFO_OVERFL_INTR_PRT00_SHIFT                                    3
#define RXBUF_FIFO_OVERFL_INTR_PRT00_MASK                            0x00000008
#define RXBUF_FIFO_OVERFL_INTR_PRT00_RD(src)          (((src) & 0x00000008)>>3)
#define RXBUF_FIFO_OVERFL_INTR_PRT00_WR(src)     (((u32)(src)<<3) & 0x00000008)
#define RXBUF_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields rxbuf_fifo_underfl_intr_prt0	 */
#define RXBUF_FIFO_UNDERFL_INTR_PRT00_WIDTH                                   1
#define RXBUF_FIFO_UNDERFL_INTR_PRT00_SHIFT                                   2
#define RXBUF_FIFO_UNDERFL_INTR_PRT00_MASK                           0x00000004
#define RXBUF_FIFO_UNDERFL_INTR_PRT00_RD(src)         (((src) & 0x00000004)>>2)
#define RXBUF_FIFO_UNDERFL_INTR_PRT00_WR(src)    (((u32)(src)<<2) & 0x00000004)
#define RXBUF_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields txbuf_fifo_overfl_intr_prt0	 */
#define TXBUF_FIFO_OVERFL_INTR_PRT00_WIDTH                                    1
#define TXBUF_FIFO_OVERFL_INTR_PRT00_SHIFT                                    1
#define TXBUF_FIFO_OVERFL_INTR_PRT00_MASK                            0x00000002
#define TXBUF_FIFO_OVERFL_INTR_PRT00_RD(src)          (((src) & 0x00000002)>>1)
#define TXBUF_FIFO_OVERFL_INTR_PRT00_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define TXBUF_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields txbuf_fifo_underfl_intr_prt0	 */
#define TXBUF_FIFO_UNDERFL_INTR_PRT00_WIDTH                                   1
#define TXBUF_FIFO_UNDERFL_INTR_PRT00_SHIFT                                   0
#define TXBUF_FIFO_UNDERFL_INTR_PRT00_MASK                           0x00000001
#define TXBUF_FIFO_UNDERFL_INTR_PRT00_RD(src)            (((src) & 0x00000001))
#define TXBUF_FIFO_UNDERFL_INTR_PRT00_WR(src)       (((u32)(src)) & 0x00000001)
#define TXBUF_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register Rx_Tx_buf_chksm_Int_Reg0Mask	*/
/*    Mask Register Fields rxbuf_pause_intr_port1Mask    */
#define RXBUF_PAUSE_INTR_PORT1MASK_WIDTH                                      1
#define RXBUF_PAUSE_INTR_PORT1MASK_SHIFT                                     22
#define RXBUF_PAUSE_INTR_PORT1MASK_MASK                              0x00400000
#define RXBUF_PAUSE_INTR_PORT1MASK_RD(src)           (((src) & 0x00400000)>>22)
#define RXBUF_PAUSE_INTR_PORT1MASK_WR(src)      (((u32)(src)<<22) & 0x00400000)
#define RXBUF_PAUSE_INTR_PORT1MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields rx_chksum_intr_port1Mask    */
#define RX_CHKSUM_INTR_PORT1MASK_WIDTH                                        1
#define RX_CHKSUM_INTR_PORT1MASK_SHIFT                                       21
#define RX_CHKSUM_INTR_PORT1MASK_MASK                                0x00200000
#define RX_CHKSUM_INTR_PORT1MASK_RD(src)             (((src) & 0x00200000)>>21)
#define RX_CHKSUM_INTR_PORT1MASK_WR(src)        (((u32)(src)<<21) & 0x00200000)
#define RX_CHKSUM_INTR_PORT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields tx_chksum_intr_port1Mask    */
#define TX_CHKSUM_INTR_PORT1MASK_WIDTH                                        1
#define TX_CHKSUM_INTR_PORT1MASK_SHIFT                                       20
#define TX_CHKSUM_INTR_PORT1MASK_MASK                                0x00100000
#define TX_CHKSUM_INTR_PORT1MASK_RD(src)             (((src) & 0x00100000)>>20)
#define TX_CHKSUM_INTR_PORT1MASK_WR(src)        (((u32)(src)<<20) & 0x00100000)
#define TX_CHKSUM_INTR_PORT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields rxbuf_fifo_overfl_intr_prt1Mask    */
#define RXBUF_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                                 1
#define RXBUF_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                                19
#define RXBUF_FIFO_OVERFL_INTR_PRT1MASK_MASK                         0x00080000
#define RXBUF_FIFO_OVERFL_INTR_PRT1MASK_RD(src)      (((src) & 0x00080000)>>19)
#define RXBUF_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define RXBUF_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields rxbuf_fifo_underfl_intr_prt1Mask    */
#define RXBUF_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                                1
#define RXBUF_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                               18
#define RXBUF_FIFO_UNDERFL_INTR_PRT1MASK_MASK                        0x00040000
#define RXBUF_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)     (((src) & 0x00040000)>>18)
#define RXBUF_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define RXBUF_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields txbuf_fifo_overfl_intr_prt1Mask    */
#define TXBUF_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                                 1
#define TXBUF_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                                17
#define TXBUF_FIFO_OVERFL_INTR_PRT1MASK_MASK                         0x00020000
#define TXBUF_FIFO_OVERFL_INTR_PRT1MASK_RD(src)      (((src) & 0x00020000)>>17)
#define TXBUF_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define TXBUF_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields txbuf_fifo_underfl_intr_prt1Mask    */
#define TXBUF_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                                1
#define TXBUF_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                               16
#define TXBUF_FIFO_UNDERFL_INTR_PRT1MASK_MASK                        0x00010000
#define TXBUF_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)     (((src) & 0x00010000)>>16)
#define TXBUF_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define TXBUF_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields rxbuf_pause_intr_port0Mask    */
#define RXBUF_PAUSE_INTR_PORT0MASK_WIDTH                                      1
#define RXBUF_PAUSE_INTR_PORT0MASK_SHIFT                                      6
#define RXBUF_PAUSE_INTR_PORT0MASK_MASK                              0x00000040
#define RXBUF_PAUSE_INTR_PORT0MASK_RD(src)            (((src) & 0x00000040)>>6)
#define RXBUF_PAUSE_INTR_PORT0MASK_WR(src)       (((u32)(src)<<6) & 0x00000040)
#define RXBUF_PAUSE_INTR_PORT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields rx_chksum_intr_port0Mask    */
#define RX_CHKSUM_INTR_PORT0MASK_WIDTH                                        1
#define RX_CHKSUM_INTR_PORT0MASK_SHIFT                                        5
#define RX_CHKSUM_INTR_PORT0MASK_MASK                                0x00000020
#define RX_CHKSUM_INTR_PORT0MASK_RD(src)              (((src) & 0x00000020)>>5)
#define RX_CHKSUM_INTR_PORT0MASK_WR(src)         (((u32)(src)<<5) & 0x00000020)
#define RX_CHKSUM_INTR_PORT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields tx_chksum_intr_port0Mask    */
#define TX_CHKSUM_INTR_PORT0MASK_WIDTH                                        1
#define TX_CHKSUM_INTR_PORT0MASK_SHIFT                                        4
#define TX_CHKSUM_INTR_PORT0MASK_MASK                                0x00000010
#define TX_CHKSUM_INTR_PORT0MASK_RD(src)              (((src) & 0x00000010)>>4)
#define TX_CHKSUM_INTR_PORT0MASK_WR(src)         (((u32)(src)<<4) & 0x00000010)
#define TX_CHKSUM_INTR_PORT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields rxbuf_fifo_overfl_intr_prt0Mask    */
#define RXBUF_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                                 1
#define RXBUF_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                                 3
#define RXBUF_FIFO_OVERFL_INTR_PRT0MASK_MASK                         0x00000008
#define RXBUF_FIFO_OVERFL_INTR_PRT0MASK_RD(src)       (((src) & 0x00000008)>>3)
#define RXBUF_FIFO_OVERFL_INTR_PRT0MASK_WR(src)  (((u32)(src)<<3) & 0x00000008)
#define RXBUF_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields rxbuf_fifo_underfl_intr_prt0Mask    */
#define RXBUF_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                                1
#define RXBUF_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                                2
#define RXBUF_FIFO_UNDERFL_INTR_PRT0MASK_MASK                        0x00000004
#define RXBUF_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)      (((src) & 0x00000004)>>2)
#define RXBUF_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define RXBUF_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields txbuf_fifo_overfl_intr_prt0Mask    */
#define TXBUF_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                                 1
#define TXBUF_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                                 1
#define TXBUF_FIFO_OVERFL_INTR_PRT0MASK_MASK                         0x00000002
#define TXBUF_FIFO_OVERFL_INTR_PRT0MASK_RD(src)       (((src) & 0x00000002)>>1)
#define TXBUF_FIFO_OVERFL_INTR_PRT0MASK_WR(src)  (((u32)(src)<<1) & 0x00000002)
#define TXBUF_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields txbuf_fifo_underfl_intr_prt0Mask    */
#define TXBUF_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                                1
#define TXBUF_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                                0
#define TXBUF_FIFO_UNDERFL_INTR_PRT0MASK_MASK                        0x00000001
#define TXBUF_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)         (((src) & 0x00000001))
#define TXBUF_FIFO_UNDERFL_INTR_PRT0MASK_WR(src)    (((u32)(src)) & 0x00000001)
#define TXBUF_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RxBuf_Config_Pause_Thresh_Reg	*/ 
/*	 Fields cfg_rxbuf1_pause_thresh	 */
#define CFG_RXBUF1_PAUSE_THRESH_WIDTH                                        16
#define CFG_RXBUF1_PAUSE_THRESH_SHIFT                                        16
#define CFG_RXBUF1_PAUSE_THRESH_MASK                                 0xffff0000
#define CFG_RXBUF1_PAUSE_THRESH_RD(src)              (((src) & 0xffff0000)>>16)
#define CFG_RXBUF1_PAUSE_THRESH_WR(src)         (((u32)(src)<<16) & 0xffff0000)
#define CFG_RXBUF1_PAUSE_THRESH_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_rxbuf0_pause_thresh	 */
#define CFG_RXBUF0_PAUSE_THRESH_WIDTH                                        16
#define CFG_RXBUF0_PAUSE_THRESH_SHIFT                                         0
#define CFG_RXBUF0_PAUSE_THRESH_MASK                                 0x0000ffff
#define CFG_RXBUF0_PAUSE_THRESH_RD(src)                  (((src) & 0x0000ffff))
#define CFG_RXBUF0_PAUSE_THRESH_WR(src)             (((u32)(src)) & 0x0000ffff)
#define CFG_RXBUF0_PAUSE_THRESH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register Checksum_Config_Reg	*/ 
/*	 Fields cfg_rxchksum_en_port0	 */
#define CFG_RXCHKSUM_EN_PORT0_WIDTH                                           1
#define CFG_RXCHKSUM_EN_PORT0_SHIFT                                           3
#define CFG_RXCHKSUM_EN_PORT0_MASK                                   0x00000008
#define CFG_RXCHKSUM_EN_PORT0_RD(src)                 (((src) & 0x00000008)>>3)
#define CFG_RXCHKSUM_EN_PORT0_WR(src)            (((u32)(src)<<3) & 0x00000008)
#define CFG_RXCHKSUM_EN_PORT0_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_rxchksum_en_port1	 */
#define CFG_RXCHKSUM_EN_PORT1_WIDTH                                           1
#define CFG_RXCHKSUM_EN_PORT1_SHIFT                                           2
#define CFG_RXCHKSUM_EN_PORT1_MASK                                   0x00000004
#define CFG_RXCHKSUM_EN_PORT1_RD(src)                 (((src) & 0x00000004)>>2)
#define CFG_RXCHKSUM_EN_PORT1_WR(src)            (((u32)(src)<<2) & 0x00000004)
#define CFG_RXCHKSUM_EN_PORT1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_txchksum_en_port0	 */
#define CFG_TXCHKSUM_EN_PORT0_WIDTH                                           1
#define CFG_TXCHKSUM_EN_PORT0_SHIFT                                           1
#define CFG_TXCHKSUM_EN_PORT0_MASK                                   0x00000002
#define CFG_TXCHKSUM_EN_PORT0_RD(src)                 (((src) & 0x00000002)>>1)
#define CFG_TXCHKSUM_EN_PORT0_WR(src)            (((u32)(src)<<1) & 0x00000002)
#define CFG_TXCHKSUM_EN_PORT0_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_txchksum_en_port1	 */
#define CFG_TXCHKSUM_EN_PORT1_WIDTH                                           1
#define CFG_TXCHKSUM_EN_PORT1_SHIFT                                           0
#define CFG_TXCHKSUM_EN_PORT1_MASK                                   0x00000001
#define CFG_TXCHKSUM_EN_PORT1_RD(src)                    (((src) & 0x00000001))
#define CFG_TXCHKSUM_EN_PORT1_WR(src)               (((u32)(src)) & 0x00000001)
#define CFG_TXCHKSUM_EN_PORT1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RxBuf_Config_Pause_Off_Thresh_Reg	*/ 
/*	 Fields cfg_rxbuf1_pause_off_thresh	 */
#define CFG_RXBUF1_PAUSE_OFF_THRESH_WIDTH                                    16
#define CFG_RXBUF1_PAUSE_OFF_THRESH_SHIFT                                    16
#define CFG_RXBUF1_PAUSE_OFF_THRESH_MASK                             0xffff0000
#define CFG_RXBUF1_PAUSE_OFF_THRESH_RD(src)          (((src) & 0xffff0000)>>16)
#define CFG_RXBUF1_PAUSE_OFF_THRESH_WR(src)     (((u32)(src)<<16) & 0xffff0000)
#define CFG_RXBUF1_PAUSE_OFF_THRESH_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_rxbuf0_pause_off_thresh	 */
#define CFG_RXBUF0_PAUSE_OFF_THRESH_WIDTH                                    16
#define CFG_RXBUF0_PAUSE_OFF_THRESH_SHIFT                                     0
#define CFG_RXBUF0_PAUSE_OFF_THRESH_MASK                             0x0000ffff
#define CFG_RXBUF0_PAUSE_OFF_THRESH_RD(src)              (((src) & 0x0000ffff))
#define CFG_RXBUF0_PAUSE_OFF_THRESH_WR(src)         (((u32)(src)) & 0x0000ffff)
#define CFG_RXBUF0_PAUSE_OFF_THRESH_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register Memory_Config1_Reg	*/ 
/*	 Fields cfg_txbuf_TEST1	 */
#define CFG_TXBUF_TEST1_WIDTH                                                 1
#define CFG_TXBUF_TEST1_SHIFT                                                31
#define CFG_TXBUF_TEST1_MASK                                         0x80000000
#define CFG_TXBUF_TEST1_RD(src)                      (((src) & 0x80000000)>>31)
#define CFG_TXBUF_TEST1_WR(src)                 (((u32)(src)<<31) & 0x80000000)
#define CFG_TXBUF_TEST1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_txbuf_RME	 */
#define CFG_TXBUF_RME_WIDTH                                                   1
#define CFG_TXBUF_RME_SHIFT                                                  30
#define CFG_TXBUF_RME_MASK                                           0x40000000
#define CFG_TXBUF_RME_RD(src)                        (((src) & 0x40000000)>>30)
#define CFG_TXBUF_RME_WR(src)                   (((u32)(src)<<30) & 0x40000000)
#define CFG_TXBUF_RME_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_txbuf_RM	 */
#define CFG_TXBUF_RM_WIDTH                                                    4
#define CFG_TXBUF_RM_SHIFT                                                   26
#define CFG_TXBUF_RM_MASK                                            0x3c000000
#define CFG_TXBUF_RM_RD(src)                         (((src) & 0x3c000000)>>26)
#define CFG_TXBUF_RM_WR(src)                    (((u32)(src)<<26) & 0x3c000000)
#define CFG_TXBUF_RM_SET(dst,src) \
                      (((dst) & ~0x3c000000) | (((u32)(src)<<26) & 0x3c000000))
/*	 Fields cfg_rxbuf_TEST1B_prt1	 */
#define CFG_RXBUF_TEST1B_PRT1_WIDTH                                           1
#define CFG_RXBUF_TEST1B_PRT1_SHIFT                                          24
#define CFG_RXBUF_TEST1B_PRT1_MASK                                   0x01000000
#define CFG_RXBUF_TEST1B_PRT1_RD(src)                (((src) & 0x01000000)>>24)
#define CFG_RXBUF_TEST1B_PRT1_WR(src)           (((u32)(src)<<24) & 0x01000000)
#define CFG_RXBUF_TEST1B_PRT1_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_rxbuf_TEST1A_prt1	 */
#define CFG_RXBUF_TEST1A_PRT1_WIDTH                                           1
#define CFG_RXBUF_TEST1A_PRT1_SHIFT                                          23
#define CFG_RXBUF_TEST1A_PRT1_MASK                                   0x00800000
#define CFG_RXBUF_TEST1A_PRT1_RD(src)                (((src) & 0x00800000)>>23)
#define CFG_RXBUF_TEST1A_PRT1_WR(src)           (((u32)(src)<<23) & 0x00800000)
#define CFG_RXBUF_TEST1A_PRT1_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields cfg_rxbuf_RMEB_prt1	 */
#define CFG_RXBUF_RMEB_PRT1_WIDTH                                             1
#define CFG_RXBUF_RMEB_PRT1_SHIFT                                            22
#define CFG_RXBUF_RMEB_PRT1_MASK                                     0x00400000
#define CFG_RXBUF_RMEB_PRT1_RD(src)                  (((src) & 0x00400000)>>22)
#define CFG_RXBUF_RMEB_PRT1_WR(src)             (((u32)(src)<<22) & 0x00400000)
#define CFG_RXBUF_RMEB_PRT1_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields cfg_rxbuf_RMEA_prt1	 */
#define CFG_RXBUF_RMEA_PRT1_WIDTH                                             1
#define CFG_RXBUF_RMEA_PRT1_SHIFT                                            21
#define CFG_RXBUF_RMEA_PRT1_MASK                                     0x00200000
#define CFG_RXBUF_RMEA_PRT1_RD(src)                  (((src) & 0x00200000)>>21)
#define CFG_RXBUF_RMEA_PRT1_WR(src)             (((u32)(src)<<21) & 0x00200000)
#define CFG_RXBUF_RMEA_PRT1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_rxbuf_RMB_prt1	 */
#define CFG_RXBUF_RMB_PRT1_WIDTH                                              4
#define CFG_RXBUF_RMB_PRT1_SHIFT                                             17
#define CFG_RXBUF_RMB_PRT1_MASK                                      0x001e0000
#define CFG_RXBUF_RMB_PRT1_RD(src)                   (((src) & 0x001e0000)>>17)
#define CFG_RXBUF_RMB_PRT1_WR(src)              (((u32)(src)<<17) & 0x001e0000)
#define CFG_RXBUF_RMB_PRT1_SET(dst,src) \
                      (((dst) & ~0x001e0000) | (((u32)(src)<<17) & 0x001e0000))
/*	 Fields cfg_rxbuf_RMA_prt1	 */
#define CFG_RXBUF_RMA_PRT1_WIDTH                                              4
#define CFG_RXBUF_RMA_PRT1_SHIFT                                             13
#define CFG_RXBUF_RMA_PRT1_MASK                                      0x0001e000
#define CFG_RXBUF_RMA_PRT1_RD(src)                   (((src) & 0x0001e000)>>13)
#define CFG_RXBUF_RMA_PRT1_WR(src)              (((u32)(src)<<13) & 0x0001e000)
#define CFG_RXBUF_RMA_PRT1_SET(dst,src) \
                      (((dst) & ~0x0001e000) | (((u32)(src)<<13) & 0x0001e000))
/*	 Fields cfg_rxbuf_TEST1B_prt0	 */
#define CFG_RXBUF_TEST1B_PRT0_WIDTH                                           1
#define CFG_RXBUF_TEST1B_PRT0_SHIFT                                          11
#define CFG_RXBUF_TEST1B_PRT0_MASK                                   0x00000800
#define CFG_RXBUF_TEST1B_PRT0_RD(src)                (((src) & 0x00000800)>>11)
#define CFG_RXBUF_TEST1B_PRT0_WR(src)           (((u32)(src)<<11) & 0x00000800)
#define CFG_RXBUF_TEST1B_PRT0_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_rxbuf_TEST1A_prt0	 */
#define CFG_RXBUF_TEST1A_PRT0_WIDTH                                           1
#define CFG_RXBUF_TEST1A_PRT0_SHIFT                                          10
#define CFG_RXBUF_TEST1A_PRT0_MASK                                   0x00000400
#define CFG_RXBUF_TEST1A_PRT0_RD(src)                (((src) & 0x00000400)>>10)
#define CFG_RXBUF_TEST1A_PRT0_WR(src)           (((u32)(src)<<10) & 0x00000400)
#define CFG_RXBUF_TEST1A_PRT0_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_rxbuf_RMEB_prt0	 */
#define CFG_RXBUF_RMEB_PRT0_WIDTH                                             1
#define CFG_RXBUF_RMEB_PRT0_SHIFT                                             9
#define CFG_RXBUF_RMEB_PRT0_MASK                                     0x00000200
#define CFG_RXBUF_RMEB_PRT0_RD(src)                   (((src) & 0x00000200)>>9)
#define CFG_RXBUF_RMEB_PRT0_WR(src)              (((u32)(src)<<9) & 0x00000200)
#define CFG_RXBUF_RMEB_PRT0_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_rxbuf_RMEA_prt0	 */
#define CFG_RXBUF_RMEA_PRT0_WIDTH                                             1
#define CFG_RXBUF_RMEA_PRT0_SHIFT                                             8
#define CFG_RXBUF_RMEA_PRT0_MASK                                     0x00000100
#define CFG_RXBUF_RMEA_PRT0_RD(src)                   (((src) & 0x00000100)>>8)
#define CFG_RXBUF_RMEA_PRT0_WR(src)              (((u32)(src)<<8) & 0x00000100)
#define CFG_RXBUF_RMEA_PRT0_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_rxbuf_RMB_prt0	 */
#define CFG_RXBUF_RMB_PRT0_WIDTH                                              4
#define CFG_RXBUF_RMB_PRT0_SHIFT                                              4
#define CFG_RXBUF_RMB_PRT0_MASK                                      0x000000f0
#define CFG_RXBUF_RMB_PRT0_RD(src)                    (((src) & 0x000000f0)>>4)
#define CFG_RXBUF_RMB_PRT0_WR(src)               (((u32)(src)<<4) & 0x000000f0)
#define CFG_RXBUF_RMB_PRT0_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields cfg_rxbuf_RMA_prt0	 */
#define CFG_RXBUF_RMA_PRT0_WIDTH                                              4
#define CFG_RXBUF_RMA_PRT0_SHIFT                                              0
#define CFG_RXBUF_RMA_PRT0_MASK                                      0x0000000f
#define CFG_RXBUF_RMA_PRT0_RD(src)                       (((src) & 0x0000000f))
#define CFG_RXBUF_RMA_PRT0_WR(src)                  (((u32)(src)) & 0x0000000f)
#define CFG_RXBUF_RMA_PRT0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register Memory_Config2_Reg	*/ 
/*	 Fields cfg_smibctr_TEST1	 */
#define CFG_SMIBCTR_TEST1_WIDTH                                               1
#define CFG_SMIBCTR_TEST1_SHIFT                                              19
#define CFG_SMIBCTR_TEST1_MASK                                       0x00080000
#define CFG_SMIBCTR_TEST1_RD(src)                    (((src) & 0x00080000)>>19)
#define CFG_SMIBCTR_TEST1_WR(src)               (((u32)(src)<<19) & 0x00080000)
#define CFG_SMIBCTR_TEST1_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields cfg_smibctr_RME	 */
#define CFG_SMIBCTR_RME_WIDTH                                                 1
#define CFG_SMIBCTR_RME_SHIFT                                                18
#define CFG_SMIBCTR_RME_MASK                                         0x00040000
#define CFG_SMIBCTR_RME_RD(src)                      (((src) & 0x00040000)>>18)
#define CFG_SMIBCTR_RME_WR(src)                 (((u32)(src)<<18) & 0x00040000)
#define CFG_SMIBCTR_RME_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields cfg_smibctr_RM	 */
#define CFG_SMIBCTR_RM_WIDTH                                                  2
#define CFG_SMIBCTR_RM_SHIFT                                                 16
#define CFG_SMIBCTR_RM_MASK                                          0x00030000
#define CFG_SMIBCTR_RM_RD(src)                       (((src) & 0x00030000)>>16)
#define CFG_SMIBCTR_RM_WR(src)                  (((u32)(src)<<16) & 0x00030000)
#define CFG_SMIBCTR_RM_SET(dst,src) \
                      (((dst) & ~0x00030000) | (((u32)(src)<<16) & 0x00030000))
/*	 Fields cfg_sad_mem_TEST1	 */
#define CFG_SAD_MEM_TEST1_WIDTH                                               1
#define CFG_SAD_MEM_TEST1_SHIFT                                              13
#define CFG_SAD_MEM_TEST1_MASK                                       0x00002000
#define CFG_SAD_MEM_TEST1_RD(src)                    (((src) & 0x00002000)>>13)
#define CFG_SAD_MEM_TEST1_WR(src)               (((u32)(src)<<13) & 0x00002000)
#define CFG_SAD_MEM_TEST1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields cfg_sad_mem_RME	 */
#define CFG_SAD_MEM_RME_WIDTH                                                 1
#define CFG_SAD_MEM_RME_SHIFT                                                12
#define CFG_SAD_MEM_RME_MASK                                         0x00001000
#define CFG_SAD_MEM_RME_RD(src)                      (((src) & 0x00001000)>>12)
#define CFG_SAD_MEM_RME_WR(src)                 (((u32)(src)<<12) & 0x00001000)
#define CFG_SAD_MEM_RME_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields cfg_sad_mem_RM	 */
#define CFG_SAD_MEM_RM_WIDTH                                                  4
#define CFG_SAD_MEM_RM_SHIFT                                                  8
#define CFG_SAD_MEM_RM_MASK                                          0x00000f00
#define CFG_SAD_MEM_RM_RD(src)                        (((src) & 0x00000f00)>>8)
#define CFG_SAD_MEM_RM_WR(src)                   (((u32)(src)<<8) & 0x00000f00)
#define CFG_SAD_MEM_RM_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields cfg_avl_ram_TEST1	 */
#define CFG_AVL_RAM_TEST1_WIDTH                                               1
#define CFG_AVL_RAM_TEST1_SHIFT                                               5
#define CFG_AVL_RAM_TEST1_MASK                                       0x00000020
#define CFG_AVL_RAM_TEST1_RD(src)                     (((src) & 0x00000020)>>5)
#define CFG_AVL_RAM_TEST1_WR(src)                (((u32)(src)<<5) & 0x00000020)
#define CFG_AVL_RAM_TEST1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields cfg_avl_ram_RME	 */
#define CFG_AVL_RAM_RME_WIDTH                                                 1
#define CFG_AVL_RAM_RME_SHIFT                                                 4
#define CFG_AVL_RAM_RME_MASK                                         0x00000010
#define CFG_AVL_RAM_RME_RD(src)                       (((src) & 0x00000010)>>4)
#define CFG_AVL_RAM_RME_WR(src)                  (((u32)(src)<<4) & 0x00000010)
#define CFG_AVL_RAM_RME_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields cfg_avl_ram_RM	 */
#define CFG_AVL_RAM_RM_WIDTH                                                  4
#define CFG_AVL_RAM_RM_SHIFT                                                  0
#define CFG_AVL_RAM_RM_MASK                                          0x0000000f
#define CFG_AVL_RAM_RM_RD(src)                           (((src) & 0x0000000f))
#define CFG_AVL_RAM_RM_WR(src)                      (((u32)(src)) & 0x0000000f)
#define CFG_AVL_RAM_RM_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register PTP_tmstmp_cfg	*/ 
/*	 Fields single_pkt	 */
#define SINGLE_PKT_WIDTH                                                      1
#define SINGLE_PKT_SHIFT                                                     31
#define SINGLE_PKT_MASK                                              0x80000000
#define SINGLE_PKT_RD(src)                           (((src) & 0x80000000)>>31)
#define SINGLE_PKT_WR(src)                      (((u32)(src)<<31) & 0x80000000)
#define SINGLE_PKT_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields max_unsisec_lat_ns	 */
#define MAX_UNSISEC_LAT_NS_WIDTH                                             12
#define MAX_UNSISEC_LAT_NS_SHIFT                                             19
#define MAX_UNSISEC_LAT_NS_MASK                                      0x7ff80000
#define MAX_UNSISEC_LAT_NS_RD(src)                   (((src) & 0x7ff80000)>>19)
#define MAX_UNSISEC_LAT_NS_WR(src)              (((u32)(src)<<19) & 0x7ff80000)
#define MAX_UNSISEC_LAT_NS_SET(dst,src) \
                      (((dst) & ~0x7ff80000) | (((u32)(src)<<19) & 0x7ff80000))
/*	 Fields max_unsisec_lat_cc	 */
#define MAX_UNSISEC_LAT_CC_WIDTH                                             10
#define MAX_UNSISEC_LAT_CC_SHIFT                                              9
#define MAX_UNSISEC_LAT_CC_MASK                                      0x0007fe00
#define MAX_UNSISEC_LAT_CC_RD(src)                    (((src) & 0x0007fe00)>>9)
#define MAX_UNSISEC_LAT_CC_WR(src)               (((u32)(src)<<9) & 0x0007fe00)
#define MAX_UNSISEC_LAT_CC_SET(dst,src) \
                       (((dst) & ~0x0007fe00) | (((u32)(src)<<9) & 0x0007fe00))
/*	 Fields extra_lat	 */
#define EXTRA_LAT_WIDTH                                                       9
#define EXTRA_LAT_SHIFT                                                       0
#define EXTRA_LAT_MASK                                               0x000001ff
#define EXTRA_LAT_RD(src)                                (((src) & 0x000001ff))
#define EXTRA_LAT_WR(src)                           (((u32)(src)) & 0x000001ff)
#define EXTRA_LAT_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register PTP_Config	*/ 
/*	 Fields ptp_clk_sel1	 */
#define PTP_CLK_SEL1_WIDTH                                                    1
#define PTP_CLK_SEL1_SHIFT                                                   21
#define PTP_CLK_SEL1_MASK                                            0x00200000
#define PTP_CLK_SEL1_RD(src)                         (((src) & 0x00200000)>>21)
#define PTP_CLK_SEL1_WR(src)                    (((u32)(src)<<21) & 0x00200000)
#define PTP_CLK_SEL1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields ffdiv_vco_clk_sel	 */
#define FFDIV_VCO_CLK_SEL_WIDTH                                               1
#define FFDIV_VCO_CLK_SEL_SHIFT                                              20
#define FFDIV_VCO_CLK_SEL_MASK                                       0x00100000
#define FFDIV_VCO_CLK_SEL_RD(src)                    (((src) & 0x00100000)>>20)
#define FFDIV_VCO_CLK_SEL_WR(src)               (((u32)(src)<<20) & 0x00100000)
#define FFDIV_VCO_CLK_SEL_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields tstmp_fifo_emptythresh_prt1	 */
#define TSTMP_FIFO_EMPTYTHRESH_PRT1_WIDTH                                     3
#define TSTMP_FIFO_EMPTYTHRESH_PRT1_SHIFT                                    17
#define TSTMP_FIFO_EMPTYTHRESH_PRT1_MASK                             0x000e0000
#define TSTMP_FIFO_EMPTYTHRESH_PRT1_RD(src)          (((src) & 0x000e0000)>>17)
#define TSTMP_FIFO_EMPTYTHRESH_PRT1_WR(src)     (((u32)(src)<<17) & 0x000e0000)
#define TSTMP_FIFO_EMPTYTHRESH_PRT1_SET(dst,src) \
                      (((dst) & ~0x000e0000) | (((u32)(src)<<17) & 0x000e0000))
/*	 Fields tstmp_fifo_fullthresh_prt1	 */
#define TSTMP_FIFO_FULLTHRESH_PRT1_WIDTH                                      3
#define TSTMP_FIFO_FULLTHRESH_PRT1_SHIFT                                     14
#define TSTMP_FIFO_FULLTHRESH_PRT1_MASK                              0x0001c000
#define TSTMP_FIFO_FULLTHRESH_PRT1_RD(src)           (((src) & 0x0001c000)>>14)
#define TSTMP_FIFO_FULLTHRESH_PRT1_WR(src)      (((u32)(src)<<14) & 0x0001c000)
#define TSTMP_FIFO_FULLTHRESH_PRT1_SET(dst,src) \
                      (((dst) & ~0x0001c000) | (((u32)(src)<<14) & 0x0001c000))
/*	 Fields tstmp_fifo_ramdepth_prt1	 */
#define TSTMP_FIFO_RAMDEPTH_PRT1_WIDTH                                        3
#define TSTMP_FIFO_RAMDEPTH_PRT1_SHIFT                                       11
#define TSTMP_FIFO_RAMDEPTH_PRT1_MASK                                0x00003800
#define TSTMP_FIFO_RAMDEPTH_PRT1_RD(src)             (((src) & 0x00003800)>>11)
#define TSTMP_FIFO_RAMDEPTH_PRT1_WR(src)        (((u32)(src)<<11) & 0x00003800)
#define TSTMP_FIFO_RAMDEPTH_PRT1_SET(dst,src) \
                      (((dst) & ~0x00003800) | (((u32)(src)<<11) & 0x00003800))
/*	 Fields tstmp_fifo_emptythresh_prt0	 */
#define TSTMP_FIFO_EMPTYTHRESH_PRT0_WIDTH                                     3
#define TSTMP_FIFO_EMPTYTHRESH_PRT0_SHIFT                                     8
#define TSTMP_FIFO_EMPTYTHRESH_PRT0_MASK                             0x00000700
#define TSTMP_FIFO_EMPTYTHRESH_PRT0_RD(src)           (((src) & 0x00000700)>>8)
#define TSTMP_FIFO_EMPTYTHRESH_PRT0_WR(src)      (((u32)(src)<<8) & 0x00000700)
#define TSTMP_FIFO_EMPTYTHRESH_PRT0_SET(dst,src) \
                       (((dst) & ~0x00000700) | (((u32)(src)<<8) & 0x00000700))
/*	 Fields tstmp_fifo_fullthresh_prt0	 */
#define TSTMP_FIFO_FULLTHRESH_PRT0_WIDTH                                      3
#define TSTMP_FIFO_FULLTHRESH_PRT0_SHIFT                                      5
#define TSTMP_FIFO_FULLTHRESH_PRT0_MASK                              0x000000e0
#define TSTMP_FIFO_FULLTHRESH_PRT0_RD(src)            (((src) & 0x000000e0)>>5)
#define TSTMP_FIFO_FULLTHRESH_PRT0_WR(src)       (((u32)(src)<<5) & 0x000000e0)
#define TSTMP_FIFO_FULLTHRESH_PRT0_SET(dst,src) \
                       (((dst) & ~0x000000e0) | (((u32)(src)<<5) & 0x000000e0))
/*	 Fields tstmp_fifo_ramdepth_prt0	 */
#define TSTMP_FIFO_RAMDEPTH_PRT0_WIDTH                                        3
#define TSTMP_FIFO_RAMDEPTH_PRT0_SHIFT                                        2
#define TSTMP_FIFO_RAMDEPTH_PRT0_MASK                                0x0000001c
#define TSTMP_FIFO_RAMDEPTH_PRT0_RD(src)              (((src) & 0x0000001c)>>2)
#define TSTMP_FIFO_RAMDEPTH_PRT0_WR(src)         (((u32)(src)<<2) & 0x0000001c)
#define TSTMP_FIFO_RAMDEPTH_PRT0_SET(dst,src) \
                       (((dst) & ~0x0000001c) | (((u32)(src)<<2) & 0x0000001c))
/*	 Fields ffdiv_clk_sel	 */
#define FFDIV_CLK_SEL_WIDTH                                                   1
#define FFDIV_CLK_SEL_SHIFT                                                   1
#define FFDIV_CLK_SEL_MASK                                           0x00000002
#define FFDIV_CLK_SEL_RD(src)                         (((src) & 0x00000002)>>1)
#define FFDIV_CLK_SEL_WR(src)                    (((u32)(src)<<1) & 0x00000002)
#define FFDIV_CLK_SEL_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields ptp_clk_sel	 */
#define PTP_CLK_SEL_WIDTH                                                     1
#define PTP_CLK_SEL_SHIFT                                                     0
#define PTP_CLK_SEL_MASK                                             0x00000001
#define PTP_CLK_SEL_RD(src)                              (((src) & 0x00000001))
#define PTP_CLK_SEL_WR(src)                         (((u32)(src)) & 0x00000001)
#define PTP_CLK_SEL_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register PTP_Rx_tmstmp_prt0	*/ 
/*	 Fields ptp_curr_sample_num	 */
#define PTP_CURR_SAMPLE_NUM0_WIDTH                                            2
#define PTP_CURR_SAMPLE_NUM0_SHIFT                                           30
#define PTP_CURR_SAMPLE_NUM0_MASK                                    0xc0000000
#define PTP_CURR_SAMPLE_NUM0_RD(src)                 (((src) & 0xc0000000)>>30)
#define PTP_CURR_SAMPLE_NUM0_SET(dst,src) \
                      (((dst) & ~0xc0000000) | (((u32)(src)<<30) & 0xc0000000))
/*	 Fields ptp_last_tstmp	 */
#define PTP_LAST_TSTMP0_WIDTH                                                30
#define PTP_LAST_TSTMP0_SHIFT                                                 0
#define PTP_LAST_TSTMP0_MASK                                         0x3fffffff
#define PTP_LAST_TSTMP0_RD(src)                          (((src) & 0x3fffffff))
#define PTP_LAST_TSTMP0_SET(dst,src) \
                          (((dst) & ~0x3fffffff) | (((u32)(src)) & 0x3fffffff))

/*	Register PTP_Tx_tmstmp0_prt0	*/ 
/*	 Fields ptp_ins_tstmp	 */
#define PTP_INS_TSTMP0_WIDTH                                                 32
#define PTP_INS_TSTMP0_SHIFT                                                  0
#define PTP_INS_TSTMP0_MASK                                          0xffffffff
#define PTP_INS_TSTMP0_RD(src)                           (((src) & 0xffffffff))
#define PTP_INS_TSTMP0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PTP_Tx_tmstmp1_prt0	*/ 
/*	 Fields ptp_ins_tstmp	 */
#define PTP_INS_TSTMP0_F1_WIDTH                                              32
#define PTP_INS_TSTMP0_F1_SHIFT                                               0
#define PTP_INS_TSTMP0_F1_MASK                                       0xffffffff
#define PTP_INS_TSTMP0_F1_RD(src)                        (((src) & 0xffffffff))
#define PTP_INS_TSTMP0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PTP_Tx_correction_prt0	*/ 
/*	 Fields value	 */
#define VALUE0_WIDTH                                                         32
#define VALUE0_SHIFT                                                          0
#define VALUE0_MASK                                                  0xffffffff
#define VALUE0_RD(src)                                   (((src) & 0xffffffff))
#define VALUE0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PTP_Rx_tmstmp_prt1	*/ 
/*	 Fields ptp_curr_sample_num	 */
#define PTP_CURR_SAMPLE_NUM1_WIDTH                                            2
#define PTP_CURR_SAMPLE_NUM1_SHIFT                                           30
#define PTP_CURR_SAMPLE_NUM1_MASK                                    0xc0000000
#define PTP_CURR_SAMPLE_NUM1_RD(src)                 (((src) & 0xc0000000)>>30)
#define PTP_CURR_SAMPLE_NUM1_SET(dst,src) \
                      (((dst) & ~0xc0000000) | (((u32)(src)<<30) & 0xc0000000))
/*	 Fields ptp_last_tstmp	 */
#define PTP_LAST_TSTMP1_WIDTH                                                30
#define PTP_LAST_TSTMP1_SHIFT                                                 0
#define PTP_LAST_TSTMP1_MASK                                         0x3fffffff
#define PTP_LAST_TSTMP1_RD(src)                          (((src) & 0x3fffffff))
#define PTP_LAST_TSTMP1_SET(dst,src) \
                          (((dst) & ~0x3fffffff) | (((u32)(src)) & 0x3fffffff))

/*	Register PTP_Tx_tmstmp0_prt1	*/ 
/*	 Fields ptp_ins_tstmp	 */
#define PTP_INS_TSTMP1_WIDTH                                                 32
#define PTP_INS_TSTMP1_SHIFT                                                  0
#define PTP_INS_TSTMP1_MASK                                          0xffffffff
#define PTP_INS_TSTMP1_RD(src)                           (((src) & 0xffffffff))
#define PTP_INS_TSTMP1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PTP_Tx_tmstmp1_prt1	*/ 
/*	 Fields ptp_ins_tstmp	 */
#define PTP_INS_TSTMP1_F1_WIDTH                                              32
#define PTP_INS_TSTMP1_F1_SHIFT                                               0
#define PTP_INS_TSTMP1_F1_MASK                                       0xffffffff
#define PTP_INS_TSTMP1_F1_RD(src)                        (((src) & 0xffffffff))
#define PTP_INS_TSTMP1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PTP_Tx_correction_prt1	*/ 
/*	 Fields value	 */
#define VALUE1_WIDTH                                                         32
#define VALUE1_SHIFT                                                          0
#define VALUE1_MASK                                                  0xffffffff
#define VALUE1_RD(src)                                   (((src) & 0xffffffff))
#define VALUE1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PTP_tstmp_offset	*/ 
/*	 Fields avb_prstime_field_offset	 */
#define AVB_PRSTIME_FIELD_OFFSET_WIDTH                                        8
#define AVB_PRSTIME_FIELD_OFFSET_SHIFT                                       16
#define AVB_PRSTIME_FIELD_OFFSET_MASK                                0x00ff0000
#define AVB_PRSTIME_FIELD_OFFSET_RD(src)             (((src) & 0x00ff0000)>>16)
#define AVB_PRSTIME_FIELD_OFFSET_WR(src)        (((u32)(src)<<16) & 0x00ff0000)
#define AVB_PRSTIME_FIELD_OFFSET_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields corr_field_offset	 */
#define CORR_FIELD_OFFSET_WIDTH                                               8
#define CORR_FIELD_OFFSET_SHIFT                                               8
#define CORR_FIELD_OFFSET_MASK                                       0x0000ff00
#define CORR_FIELD_OFFSET_RD(src)                     (((src) & 0x0000ff00)>>8)
#define CORR_FIELD_OFFSET_WR(src)                (((u32)(src)<<8) & 0x0000ff00)
#define CORR_FIELD_OFFSET_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields orig_tstmp_offset	 */
#define ORIG_TSTMP_OFFSET_WIDTH                                               8
#define ORIG_TSTMP_OFFSET_SHIFT                                               0
#define ORIG_TSTMP_OFFSET_MASK                                       0x000000ff
#define ORIG_TSTMP_OFFSET_RD(src)                        (((src) & 0x000000ff))
#define ORIG_TSTMP_OFFSET_WR(src)                   (((u32)(src)) & 0x000000ff)
#define ORIG_TSTMP_OFFSET_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register Debug_Reg1	*/ 
/*	 Fields cfg_rx2tx_sgmii_lp	 */
#define CFG_RX2TX_SGMII_LP1_WIDTH                                             2
#define CFG_RX2TX_SGMII_LP1_SHIFT                                             3
#define CFG_RX2TX_SGMII_LP1_MASK                                     0x00000018
#define CFG_RX2TX_SGMII_LP1_RD(src)                   (((src) & 0x00000018)>>3)
#define CFG_RX2TX_SGMII_LP1_WR(src)              (((u32)(src)<<3) & 0x00000018)
#define CFG_RX2TX_SGMII_LP1_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields cfg_rx_port1_duplicate	 */
#define CFG_RX_PORT1_DUPLICATE1_WIDTH                                         1
#define CFG_RX_PORT1_DUPLICATE1_SHIFT                                         2
#define CFG_RX_PORT1_DUPLICATE1_MASK                                 0x00000004
#define CFG_RX_PORT1_DUPLICATE1_RD(src)               (((src) & 0x00000004)>>2)
#define CFG_RX_PORT1_DUPLICATE1_WR(src)          (((u32)(src)<<2) & 0x00000004)
#define CFG_RX_PORT1_DUPLICATE1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields CfgRx2TxClkLoopBackEn	 */
#define CFGRX2TXCLKLOOPBACKEN1_WIDTH                                          2
#define CFGRX2TXCLKLOOPBACKEN1_SHIFT                                          0
#define CFGRX2TXCLKLOOPBACKEN1_MASK                                  0x00000003
#define CFGRX2TXCLKLOOPBACKEN1_RD(src)                   (((src) & 0x00000003))
#define CFGRX2TXCLKLOOPBACKEN1_WR(src)              (((u32)(src)) & 0x00000003)
#define CFGRX2TXCLKLOOPBACKEN1_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register Debug_Reg	*/ 
/*	 Fields cfg_diag_bus_gray_ungray_sel	 */
#define CFG_DIAG_BUS_GRAY_UNGRAY_SEL_WIDTH                                    1
#define CFG_DIAG_BUS_GRAY_UNGRAY_SEL_SHIFT                                   31
#define CFG_DIAG_BUS_GRAY_UNGRAY_SEL_MASK                            0x80000000
#define CFG_DIAG_BUS_GRAY_UNGRAY_SEL_RD(src)         (((src) & 0x80000000)>>31)
#define CFG_DIAG_BUS_GRAY_UNGRAY_SEL_WR(src)    (((u32)(src)<<31) & 0x80000000)
#define CFG_DIAG_BUS_GRAY_UNGRAY_SEL_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_debug_txbuf_igr_rd_gnt_lmt	 */
#define CFG_DEBUG_TXBUF_IGR_RD_GNT_LMT_WIDTH                                  1
#define CFG_DEBUG_TXBUF_IGR_RD_GNT_LMT_SHIFT                                 30
#define CFG_DEBUG_TXBUF_IGR_RD_GNT_LMT_MASK                          0x40000000
#define CFG_DEBUG_TXBUF_IGR_RD_GNT_LMT_RD(src)       (((src) & 0x40000000)>>30)
#define CFG_DEBUG_TXBUF_IGR_RD_GNT_LMT_WR(src)  (((u32)(src)<<30) & 0x40000000)
#define CFG_DEBUG_TXBUF_IGR_RD_GNT_LMT_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_debug_txbuf_igr_wr_gnt_lmt	 */
#define CFG_DEBUG_TXBUF_IGR_WR_GNT_LMT_WIDTH                                  1
#define CFG_DEBUG_TXBUF_IGR_WR_GNT_LMT_SHIFT                                 29
#define CFG_DEBUG_TXBUF_IGR_WR_GNT_LMT_MASK                          0x20000000
#define CFG_DEBUG_TXBUF_IGR_WR_GNT_LMT_RD(src)       (((src) & 0x20000000)>>29)
#define CFG_DEBUG_TXBUF_IGR_WR_GNT_LMT_WR(src)  (((u32)(src)<<29) & 0x20000000)
#define CFG_DEBUG_TXBUF_IGR_WR_GNT_LMT_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields cfg_debug_txbuf_rd_grant_limit	 */
#define CFG_DEBUG_TXBUF_RD_GRANT_LIMIT_WIDTH                                 12
#define CFG_DEBUG_TXBUF_RD_GRANT_LIMIT_SHIFT                                 17
#define CFG_DEBUG_TXBUF_RD_GRANT_LIMIT_MASK                          0x1ffe0000
#define CFG_DEBUG_TXBUF_RD_GRANT_LIMIT_RD(src)       (((src) & 0x1ffe0000)>>17)
#define CFG_DEBUG_TXBUF_RD_GRANT_LIMIT_WR(src)  (((u32)(src)<<17) & 0x1ffe0000)
#define CFG_DEBUG_TXBUF_RD_GRANT_LIMIT_SET(dst,src) \
                      (((dst) & ~0x1ffe0000) | (((u32)(src)<<17) & 0x1ffe0000))
/*	 Fields cfg_debug_txbuf_wr_grant_limit	 */
#define CFG_DEBUG_TXBUF_WR_GRANT_LIMIT_WIDTH                                 12
#define CFG_DEBUG_TXBUF_WR_GRANT_LIMIT_SHIFT                                  5
#define CFG_DEBUG_TXBUF_WR_GRANT_LIMIT_MASK                          0x0001ffe0
#define CFG_DEBUG_TXBUF_WR_GRANT_LIMIT_RD(src)        (((src) & 0x0001ffe0)>>5)
#define CFG_DEBUG_TXBUF_WR_GRANT_LIMIT_WR(src)   (((u32)(src)<<5) & 0x0001ffe0)
#define CFG_DEBUG_TXBUF_WR_GRANT_LIMIT_SET(dst,src) \
                       (((dst) & ~0x0001ffe0) | (((u32)(src)<<5) & 0x0001ffe0))
/*	 Fields cfg_debug_rxtsotxbuf_loopback	 */
#define CFG_DEBUG_RXTSOTXBUF_LOOPBACK_WIDTH                                   1
#define CFG_DEBUG_RXTSOTXBUF_LOOPBACK_SHIFT                                   4
#define CFG_DEBUG_RXTSOTXBUF_LOOPBACK_MASK                           0x00000010
#define CFG_DEBUG_RXTSOTXBUF_LOOPBACK_RD(src)         (((src) & 0x00000010)>>4)
#define CFG_DEBUG_RXTSOTXBUF_LOOPBACK_WR(src)    (((u32)(src)<<4) & 0x00000010)
#define CFG_DEBUG_RXTSOTXBUF_LOOPBACK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields cfg_bypass_timestamp_ins	 */
#define CFG_BYPASS_TIMESTAMP_INS_WIDTH                                        1
#define CFG_BYPASS_TIMESTAMP_INS_SHIFT                                        3
#define CFG_BYPASS_TIMESTAMP_INS_MASK                                0x00000008
#define CFG_BYPASS_TIMESTAMP_INS_RD(src)              (((src) & 0x00000008)>>3)
#define CFG_BYPASS_TIMESTAMP_INS_WR(src)         (((u32)(src)<<3) & 0x00000008)
#define CFG_BYPASS_TIMESTAMP_INS_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_bypass_unisec_tx	 */
#define CFG_BYPASS_UNISEC_TX_WIDTH                                            1
#define CFG_BYPASS_UNISEC_TX_SHIFT                                            2
#define CFG_BYPASS_UNISEC_TX_MASK                                    0x00000004
#define CFG_BYPASS_UNISEC_TX_RD(src)                  (((src) & 0x00000004)>>2)
#define CFG_BYPASS_UNISEC_TX_WR(src)             (((u32)(src)<<2) & 0x00000004)
#define CFG_BYPASS_UNISEC_TX_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_bypass_unisec_rx	 */
#define CFG_BYPASS_UNISEC_RX_WIDTH                                            1
#define CFG_BYPASS_UNISEC_RX_SHIFT                                            1
#define CFG_BYPASS_UNISEC_RX_MASK                                    0x00000002
#define CFG_BYPASS_UNISEC_RX_RD(src)                  (((src) & 0x00000002)>>1)
#define CFG_BYPASS_UNISEC_RX_WR(src)             (((u32)(src)<<1) & 0x00000002)
#define CFG_BYPASS_UNISEC_RX_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_debug_rxtxbuf_loopback	 */
#define CFG_DEBUG_RXTXBUF_LOOPBACK_WIDTH                                      1
#define CFG_DEBUG_RXTXBUF_LOOPBACK_SHIFT                                      0
#define CFG_DEBUG_RXTXBUF_LOOPBACK_MASK                              0x00000001
#define CFG_DEBUG_RXTXBUF_LOOPBACK_RD(src)               (((src) & 0x00000001))
#define CFG_DEBUG_RXTXBUF_LOOPBACK_WR(src)          (((u32)(src)) & 0x00000001)
#define CFG_DEBUG_RXTXBUF_LOOPBACK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register mpic_debug_reg	*/ 
/*	 Fields sw_intr_debug	 */
#define SW_INTR_DEBUG_WIDTH                                                   5
#define SW_INTR_DEBUG_SHIFT                                                   0
#define SW_INTR_DEBUG_MASK                                           0x0000001f
#define SW_INTR_DEBUG_RD(src)                            (((src) & 0x0000001f))
#define SW_INTR_DEBUG_WR(src)                       (((u32)(src)) & 0x0000001f)
#define SW_INTR_DEBUG_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register tso_enet_stat_reg_port0	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT0_WIDTH                                                      16
#define BYTE_CNT0_SHIFT                                                      16
#define BYTE_CNT0_MASK                                               0xffff0000
#define BYTE_CNT0_RD(src)                            (((src) & 0xffff0000)>>16)
#define BYTE_CNT0_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT0_WIDTH                                                       16
#define PKT_CNT0_SHIFT                                                        0
#define PKT_CNT0_MASK                                                0x0000ffff
#define PKT_CNT0_RD(src)                                 (((src) & 0x0000ffff))
#define PKT_CNT0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register txb_enet_stat_reg_port0	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT0_F1_WIDTH                                                   16
#define BYTE_CNT0_F1_SHIFT                                                   16
#define BYTE_CNT0_F1_MASK                                            0xffff0000
#define BYTE_CNT0_F1_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT0_F1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT0_F1_WIDTH                                                    16
#define PKT_CNT0_F1_SHIFT                                                     0
#define PKT_CNT0_F1_MASK                                             0x0000ffff
#define PKT_CNT0_F1_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT0_F1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register macin_enet_stat_reg_port0	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT0_F2_WIDTH                                                   16
#define BYTE_CNT0_F2_SHIFT                                                   16
#define BYTE_CNT0_F2_MASK                                            0xffff0000
#define BYTE_CNT0_F2_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT0_F2_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT0_F2_WIDTH                                                    16
#define PKT_CNT0_F2_SHIFT                                                     0
#define PKT_CNT0_F2_MASK                                             0x0000ffff
#define PKT_CNT0_F2_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT0_F2_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register macout_enet_stat_reg_port0	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT0_F3_WIDTH                                                   16
#define BYTE_CNT0_F3_SHIFT                                                   16
#define BYTE_CNT0_F3_MASK                                            0xffff0000
#define BYTE_CNT0_F3_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT0_F3_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT0_F3_WIDTH                                                    16
#define PKT_CNT0_F3_SHIFT                                                     0
#define PKT_CNT0_F3_MASK                                             0x0000ffff
#define PKT_CNT0_F3_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT0_F3_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register rxbin_enet_stat_reg_port0	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT0_F4_WIDTH                                                   16
#define BYTE_CNT0_F4_SHIFT                                                   16
#define BYTE_CNT0_F4_MASK                                            0xffff0000
#define BYTE_CNT0_F4_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT0_F4_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT0_F4_WIDTH                                                    16
#define PKT_CNT0_F4_SHIFT                                                     0
#define PKT_CNT0_F4_MASK                                             0x0000ffff
#define PKT_CNT0_F4_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT0_F4_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register rsif_enet_stat_reg_port0	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT0_F5_WIDTH                                                   16
#define BYTE_CNT0_F5_SHIFT                                                   16
#define BYTE_CNT0_F5_MASK                                            0xffff0000
#define BYTE_CNT0_F5_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT0_F5_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT0_F5_WIDTH                                                    16
#define PKT_CNT0_F5_SHIFT                                                     0
#define PKT_CNT0_F5_MASK                                             0x0000ffff
#define PKT_CNT0_F5_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT0_F5_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register tso_enet_stat_reg_port1	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT1_WIDTH                                                      16
#define BYTE_CNT1_SHIFT                                                      16
#define BYTE_CNT1_MASK                                               0xffff0000
#define BYTE_CNT1_RD(src)                            (((src) & 0xffff0000)>>16)
#define BYTE_CNT1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT1_WIDTH                                                       16
#define PKT_CNT1_SHIFT                                                        0
#define PKT_CNT1_MASK                                                0x0000ffff
#define PKT_CNT1_RD(src)                                 (((src) & 0x0000ffff))
#define PKT_CNT1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register txb_enet_stat_reg_port1	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT1_F1_WIDTH                                                   16
#define BYTE_CNT1_F1_SHIFT                                                   16
#define BYTE_CNT1_F1_MASK                                            0xffff0000
#define BYTE_CNT1_F1_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT1_F1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT1_F1_WIDTH                                                    16
#define PKT_CNT1_F1_SHIFT                                                     0
#define PKT_CNT1_F1_MASK                                             0x0000ffff
#define PKT_CNT1_F1_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT1_F1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register macin_enet_stat_reg_port1	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT1_F2_WIDTH                                                   16
#define BYTE_CNT1_F2_SHIFT                                                   16
#define BYTE_CNT1_F2_MASK                                            0xffff0000
#define BYTE_CNT1_F2_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT1_F2_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT1_F2_WIDTH                                                    16
#define PKT_CNT1_F2_SHIFT                                                     0
#define PKT_CNT1_F2_MASK                                             0x0000ffff
#define PKT_CNT1_F2_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT1_F2_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register macout_enet_stat_reg_port1	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT1_F3_WIDTH                                                   16
#define BYTE_CNT1_F3_SHIFT                                                   16
#define BYTE_CNT1_F3_MASK                                            0xffff0000
#define BYTE_CNT1_F3_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT1_F3_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT1_F3_WIDTH                                                    16
#define PKT_CNT1_F3_SHIFT                                                     0
#define PKT_CNT1_F3_MASK                                             0x0000ffff
#define PKT_CNT1_F3_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT1_F3_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register rxbin_enet_stat_reg_port1	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT1_F4_WIDTH                                                   16
#define BYTE_CNT1_F4_SHIFT                                                   16
#define BYTE_CNT1_F4_MASK                                            0xffff0000
#define BYTE_CNT1_F4_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT1_F4_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT1_F4_WIDTH                                                    16
#define PKT_CNT1_F4_SHIFT                                                     0
#define PKT_CNT1_F4_MASK                                             0x0000ffff
#define PKT_CNT1_F4_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT1_F4_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register rsif_enet_stat_reg_port1	*/ 
/*	 Fields byte_cnt	 */
#define BYTE_CNT1_F5_WIDTH                                                   16
#define BYTE_CNT1_F5_SHIFT                                                   16
#define BYTE_CNT1_F5_MASK                                            0xffff0000
#define BYTE_CNT1_F5_RD(src)                         (((src) & 0xffff0000)>>16)
#define BYTE_CNT1_F5_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields pkt_cnt	 */
#define PKT_CNT1_F5_WIDTH                                                    16
#define PKT_CNT1_F5_SHIFT                                                     0
#define PKT_CNT1_F5_MASK                                             0x0000ffff
#define PKT_CNT1_F5_RD(src)                              (((src) & 0x0000ffff))
#define PKT_CNT1_F5_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register enet_spare_cfg_reg	*/ 
/*	 Fields spare_cfg	 */
#define SPARE_CFG_WIDTH                                                      19
#define SPARE_CFG_SHIFT                                                      13
#define SPARE_CFG_MASK                                               0xffffe000
#define SPARE_CFG_RD(src)                            (((src) & 0xffffe000)>>13)
#define SPARE_CFG_WR(src)                       (((u32)(src)<<13) & 0xffffe000)
#define SPARE_CFG_SET(dst,src) \
                      (((dst) & ~0xffffe000) | (((u32)(src)<<13) & 0xffffe000))
/*	 Fields enet_mpa_idle_with_qmi_empty	 */
#define ENET_MPA_IDLE_WITH_QMI_EMPTY_WIDTH                                    1
#define ENET_MPA_IDLE_WITH_QMI_EMPTY_SHIFT                                   12
#define ENET_MPA_IDLE_WITH_QMI_EMPTY_MASK                            0x00001000
#define ENET_MPA_IDLE_WITH_QMI_EMPTY_RD(src)         (((src) & 0x00001000)>>12)
#define ENET_MPA_IDLE_WITH_QMI_EMPTY_WR(src)    (((u32)(src)<<12) & 0x00001000)
#define ENET_MPA_IDLE_WITH_QMI_EMPTY_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields enet_idle_timer	 */
#define ENET_IDLE_TIMER_WIDTH                                                10
#define ENET_IDLE_TIMER_SHIFT                                                 0
#define ENET_IDLE_TIMER_MASK                                         0x000003ff
#define ENET_IDLE_TIMER_RD(src)                          (((src) & 0x000003ff))
#define ENET_IDLE_TIMER_WR(src)                     (((u32)(src)) & 0x000003ff)
#define ENET_IDLE_TIMER_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register enet_spare_status_reg	*/ 
/*	 Fields spare_cfg	 */
#define SPARE_CFG_F1_WIDTH                                                   32
#define SPARE_CFG_F1_SHIFT                                                    0
#define SPARE_CFG_F1_MASK                                            0xffffffff
#define SPARE_CFG_F1_RD(src)                             (((src) & 0xffffffff))
#define SPARE_CFG_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_AddSAI_HI_Reg	*/ 
/*	 Fields cfg_sai2sap_add_rid_hi	 */
#define CFG_SAI2SAP_ADD_RID_HI_WIDTH                                         32
#define CFG_SAI2SAP_ADD_RID_HI_SHIFT                                          0
#define CFG_SAI2SAP_ADD_RID_HI_MASK                                  0xffffffff
#define CFG_SAI2SAP_ADD_RID_HI_RD(src)                   (((src) & 0xffffffff))
#define CFG_SAI2SAP_ADD_RID_HI_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_SAI2SAP_ADD_RID_HI_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_AddSAI_LO_Reg	*/ 
/*	 Fields cfg_sai2sap_add_rid_lo	 */
#define CFG_SAI2SAP_ADD_RID_LO_WIDTH                                         32
#define CFG_SAI2SAP_ADD_RID_LO_SHIFT                                          0
#define CFG_SAI2SAP_ADD_RID_LO_MASK                                  0xffffffff
#define CFG_SAI2SAP_ADD_RID_LO_RD(src)                   (((src) & 0xffffffff))
#define CFG_SAI2SAP_ADD_RID_LO_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_SAI2SAP_ADD_RID_LO_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_AddSAIEn_Reg	*/ 
/*	 Fields cfg_sai2sap_add_rid_lsbs	 */
#define CFG_SAI2SAP_ADD_RID_LSBS_WIDTH                                        2
#define CFG_SAI2SAP_ADD_RID_LSBS_SHIFT                                        3
#define CFG_SAI2SAP_ADD_RID_LSBS_MASK                                0x00000018
#define CFG_SAI2SAP_ADD_RID_LSBS_RD(src)              (((src) & 0x00000018)>>3)
#define CFG_SAI2SAP_ADD_RID_LSBS_WR(src)         (((u32)(src)<<3) & 0x00000018)
#define CFG_SAI2SAP_ADD_RID_LSBS_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields cfg_sai2sap_add_rid_port	 */
#define CFG_SAI2SAP_ADD_RID_PORT_WIDTH                                        1
#define CFG_SAI2SAP_ADD_RID_PORT_SHIFT                                        2
#define CFG_SAI2SAP_ADD_RID_PORT_MASK                                0x00000004
#define CFG_SAI2SAP_ADD_RID_PORT_RD(src)              (((src) & 0x00000004)>>2)
#define CFG_SAI2SAP_ADD_RID_PORT_WR(src)         (((u32)(src)<<2) & 0x00000004)
#define CFG_SAI2SAP_ADD_RID_PORT_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_sai2sap_add_rid_dir	 */
#define CFG_SAI2SAP_ADD_RID_DIR_WIDTH                                         1
#define CFG_SAI2SAP_ADD_RID_DIR_SHIFT                                         1
#define CFG_SAI2SAP_ADD_RID_DIR_MASK                                 0x00000002
#define CFG_SAI2SAP_ADD_RID_DIR_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_SAI2SAP_ADD_RID_DIR_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_SAI2SAP_ADD_RID_DIR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_sai2sap_add_rid_en	 */
#define CFG_SAI2SAP_ADD_RID_EN_WIDTH                                          1
#define CFG_SAI2SAP_ADD_RID_EN_SHIFT                                          0
#define CFG_SAI2SAP_ADD_RID_EN_MASK                                  0x00000001
#define CFG_SAI2SAP_ADD_RID_EN_RD(src)                   (((src) & 0x00000001))
#define CFG_SAI2SAP_ADD_RID_EN_WR(src)              (((u32)(src)) & 0x00000001)
#define CFG_SAI2SAP_ADD_RID_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_DelSAI_HI_Reg	*/ 
/*	 Fields cfg_sai2sap_del_rid_hi	 */
#define CFG_SAI2SAP_DEL_RID_HI_WIDTH                                         32
#define CFG_SAI2SAP_DEL_RID_HI_SHIFT                                          0
#define CFG_SAI2SAP_DEL_RID_HI_MASK                                  0xffffffff
#define CFG_SAI2SAP_DEL_RID_HI_RD(src)                   (((src) & 0xffffffff))
#define CFG_SAI2SAP_DEL_RID_HI_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_SAI2SAP_DEL_RID_HI_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_DelSAI_LO_Reg	*/ 
/*	 Fields cfg_sai2sap_del_rid_lo	 */
#define CFG_SAI2SAP_DEL_RID_LO_WIDTH                                         32
#define CFG_SAI2SAP_DEL_RID_LO_SHIFT                                          0
#define CFG_SAI2SAP_DEL_RID_LO_MASK                                  0xffffffff
#define CFG_SAI2SAP_DEL_RID_LO_RD(src)                   (((src) & 0xffffffff))
#define CFG_SAI2SAP_DEL_RID_LO_WR(src)              (((u32)(src)) & 0xffffffff)
#define CFG_SAI2SAP_DEL_RID_LO_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_DelSAIEn_Reg	*/ 
/*	 Fields cfg_sai2sap_del_rid_lsbs	 */
#define CFG_SAI2SAP_DEL_RID_LSBS_WIDTH                                        2
#define CFG_SAI2SAP_DEL_RID_LSBS_SHIFT                                        3
#define CFG_SAI2SAP_DEL_RID_LSBS_MASK                                0x00000018
#define CFG_SAI2SAP_DEL_RID_LSBS_RD(src)              (((src) & 0x00000018)>>3)
#define CFG_SAI2SAP_DEL_RID_LSBS_WR(src)         (((u32)(src)<<3) & 0x00000018)
#define CFG_SAI2SAP_DEL_RID_LSBS_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields cfg_sai2sap_del_rid_port	 */
#define CFG_SAI2SAP_DEL_RID_PORT_WIDTH                                        1
#define CFG_SAI2SAP_DEL_RID_PORT_SHIFT                                        2
#define CFG_SAI2SAP_DEL_RID_PORT_MASK                                0x00000004
#define CFG_SAI2SAP_DEL_RID_PORT_RD(src)              (((src) & 0x00000004)>>2)
#define CFG_SAI2SAP_DEL_RID_PORT_WR(src)         (((u32)(src)<<2) & 0x00000004)
#define CFG_SAI2SAP_DEL_RID_PORT_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_sai2sap_del_rid_dir	 */
#define CFG_SAI2SAP_DEL_RID_DIR_WIDTH                                         1
#define CFG_SAI2SAP_DEL_RID_DIR_SHIFT                                         1
#define CFG_SAI2SAP_DEL_RID_DIR_MASK                                 0x00000002
#define CFG_SAI2SAP_DEL_RID_DIR_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_SAI2SAP_DEL_RID_DIR_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_SAI2SAP_DEL_RID_DIR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_sai2sap_del_rid_en	 */
#define CFG_SAI2SAP_DEL_RID_EN_WIDTH                                          1
#define CFG_SAI2SAP_DEL_RID_EN_SHIFT                                          0
#define CFG_SAI2SAP_DEL_RID_EN_MASK                                  0x00000001
#define CFG_SAI2SAP_DEL_RID_EN_RD(src)                   (((src) & 0x00000001))
#define CFG_SAI2SAP_DEL_RID_EN_WR(src)              (((u32)(src)) & 0x00000001)
#define CFG_SAI2SAP_DEL_RID_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_SearchSAI_HI_Reg	*/ 
/*	 Fields cfg_sai2sap_srch_rid_hi	 */
#define CFG_SAI2SAP_SRCH_RID_HI_WIDTH                                        32
#define CFG_SAI2SAP_SRCH_RID_HI_SHIFT                                         0
#define CFG_SAI2SAP_SRCH_RID_HI_MASK                                 0xffffffff
#define CFG_SAI2SAP_SRCH_RID_HI_RD(src)                  (((src) & 0xffffffff))
#define CFG_SAI2SAP_SRCH_RID_HI_WR(src)             (((u32)(src)) & 0xffffffff)
#define CFG_SAI2SAP_SRCH_RID_HI_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_SearchSAI_LO_Reg	*/ 
/*	 Fields cfg_sai2sap_srch_rid_lo	 */
#define CFG_SAI2SAP_SRCH_RID_LO_WIDTH                                        32
#define CFG_SAI2SAP_SRCH_RID_LO_SHIFT                                         0
#define CFG_SAI2SAP_SRCH_RID_LO_MASK                                 0xffffffff
#define CFG_SAI2SAP_SRCH_RID_LO_RD(src)                  (((src) & 0xffffffff))
#define CFG_SAI2SAP_SRCH_RID_LO_WR(src)             (((u32)(src)) & 0xffffffff)
#define CFG_SAI2SAP_SRCH_RID_LO_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_SearchSAIEn_Reg	*/ 
/*	 Fields cfg_sai2sap_srch_rid_lsbs	 */
#define CFG_SAI2SAP_SRCH_RID_LSBS_WIDTH                                       2
#define CFG_SAI2SAP_SRCH_RID_LSBS_SHIFT                                       3
#define CFG_SAI2SAP_SRCH_RID_LSBS_MASK                               0x00000018
#define CFG_SAI2SAP_SRCH_RID_LSBS_RD(src)             (((src) & 0x00000018)>>3)
#define CFG_SAI2SAP_SRCH_RID_LSBS_WR(src)        (((u32)(src)<<3) & 0x00000018)
#define CFG_SAI2SAP_SRCH_RID_LSBS_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields cfg_sai2sap_srch_rid_port	 */
#define CFG_SAI2SAP_SRCH_RID_PORT_WIDTH                                       1
#define CFG_SAI2SAP_SRCH_RID_PORT_SHIFT                                       2
#define CFG_SAI2SAP_SRCH_RID_PORT_MASK                               0x00000004
#define CFG_SAI2SAP_SRCH_RID_PORT_RD(src)             (((src) & 0x00000004)>>2)
#define CFG_SAI2SAP_SRCH_RID_PORT_WR(src)        (((u32)(src)<<2) & 0x00000004)
#define CFG_SAI2SAP_SRCH_RID_PORT_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_sai2sap_srch_rid_dir	 */
#define CFG_SAI2SAP_SRCH_RID_DIR_WIDTH                                        1
#define CFG_SAI2SAP_SRCH_RID_DIR_SHIFT                                        1
#define CFG_SAI2SAP_SRCH_RID_DIR_MASK                                0x00000002
#define CFG_SAI2SAP_SRCH_RID_DIR_RD(src)              (((src) & 0x00000002)>>1)
#define CFG_SAI2SAP_SRCH_RID_DIR_WR(src)         (((u32)(src)<<1) & 0x00000002)
#define CFG_SAI2SAP_SRCH_RID_DIR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_sai2sap_srch_rid_en	 */
#define CFG_SAI2SAP_SRCH_RID_EN_WIDTH                                         1
#define CFG_SAI2SAP_SRCH_RID_EN_SHIFT                                         0
#define CFG_SAI2SAP_SRCH_RID_EN_MASK                                 0x00000001
#define CFG_SAI2SAP_SRCH_RID_EN_RD(src)                  (((src) & 0x00000001))
#define CFG_SAI2SAP_SRCH_RID_EN_WR(src)             (((u32)(src)) & 0x00000001)
#define CFG_SAI2SAP_SRCH_RID_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_Cfg0_Reg	*/ 
/*	 Fields cfg_sai_avlmgr_maxsteps_thresh	 */
#define CFG_SAI_AVLMGR_MAXSTEPS_THRESH_WIDTH                                 12
#define CFG_SAI_AVLMGR_MAXSTEPS_THRESH_SHIFT                                  8
#define CFG_SAI_AVLMGR_MAXSTEPS_THRESH_MASK                          0x000fff00
#define CFG_SAI_AVLMGR_MAXSTEPS_THRESH_RD(src)        (((src) & 0x000fff00)>>8)
#define CFG_SAI_AVLMGR_MAXSTEPS_THRESH_WR(src)   (((u32)(src)<<8) & 0x000fff00)
#define CFG_SAI_AVLMGR_MAXSTEPS_THRESH_SET(dst,src) \
                       (((dst) & ~0x000fff00) | (((u32)(src)<<8) & 0x000fff00))
/*	 Fields cfg_sai_avlmgr_srchdb_depth	 */
#define CFG_SAI_AVLMGR_SRCHDB_DEPTH_WIDTH                                     8
#define CFG_SAI_AVLMGR_SRCHDB_DEPTH_SHIFT                                     0
#define CFG_SAI_AVLMGR_SRCHDB_DEPTH_MASK                             0x000000ff
#define CFG_SAI_AVLMGR_SRCHDB_DEPTH_RD(src)              (((src) & 0x000000ff))
#define CFG_SAI_AVLMGR_SRCHDB_DEPTH_WR(src)         (((u32)(src)) & 0x000000ff)
#define CFG_SAI_AVLMGR_SRCHDB_DEPTH_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register SAI2SAP_Dbg0_Reg	*/ 
/*	 Fields cfg_sai_avlmgr_dbg_srchdb_wr_en	 */
#define CFG_SAI_AVLMGR_DBG_SRCHDB_WR_EN_WIDTH                                 1
#define CFG_SAI_AVLMGR_DBG_SRCHDB_WR_EN_SHIFT                                 9
#define CFG_SAI_AVLMGR_DBG_SRCHDB_WR_EN_MASK                         0x00000200
#define CFG_SAI_AVLMGR_DBG_SRCHDB_WR_EN_RD(src)       (((src) & 0x00000200)>>9)
#define CFG_SAI_AVLMGR_DBG_SRCHDB_WR_EN_WR(src)  (((u32)(src)<<9) & 0x00000200)
#define CFG_SAI_AVLMGR_DBG_SRCHDB_WR_EN_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_sai_avlmgr_dbg_en	 */
#define CFG_SAI_AVLMGR_DBG_EN_WIDTH                                           1
#define CFG_SAI_AVLMGR_DBG_EN_SHIFT                                           8
#define CFG_SAI_AVLMGR_DBG_EN_MASK                                   0x00000100
#define CFG_SAI_AVLMGR_DBG_EN_RD(src)                 (((src) & 0x00000100)>>8)
#define CFG_SAI_AVLMGR_DBG_EN_WR(src)            (((u32)(src)<<8) & 0x00000100)
#define CFG_SAI_AVLMGR_DBG_EN_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_sai_avlmgr_dbg_srchdb_addr	 */
#define CFG_SAI_AVLMGR_DBG_SRCHDB_ADDR_WIDTH                                  7
#define CFG_SAI_AVLMGR_DBG_SRCHDB_ADDR_SHIFT                                  0
#define CFG_SAI_AVLMGR_DBG_SRCHDB_ADDR_MASK                          0x0000007f
#define CFG_SAI_AVLMGR_DBG_SRCHDB_ADDR_RD(src)           (((src) & 0x0000007f))
#define CFG_SAI_AVLMGR_DBG_SRCHDB_ADDR_WR(src)      (((u32)(src)) & 0x0000007f)
#define CFG_SAI_AVLMGR_DBG_SRCHDB_ADDR_SET(dst,src) \
                          (((dst) & ~0x0000007f) | (((u32)(src)) & 0x0000007f))

/*	Register SAI2SAP_Dbg1_Reg	*/ 
/*	 Fields cfg_avlmgr_dbg_srchdb_wdata_lsb	 */
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LSB_WIDTH                                17
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LSB_SHIFT                                 0
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LSB_MASK                         0x0001ffff
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LSB_RD(src)          (((src) & 0x0001ffff))
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LSB_WR(src)     (((u32)(src)) & 0x0001ffff)
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LSB_SET(dst,src) \
                          (((dst) & ~0x0001ffff) | (((u32)(src)) & 0x0001ffff))

/*	Register SAI2SAP_Dbg2_Reg	*/ 
/*	 Fields cfg_avlmgr_dbg_srchdb_wdata_lo	 */
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LO_WIDTH                                 32
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LO_SHIFT                                  0
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LO_MASK                          0xffffffff
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LO_RD(src)           (((src) & 0xffffffff))
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LO_WR(src)      (((u32)(src)) & 0xffffffff)
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_LO_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_Dbg3_Reg	*/ 
/*	 Fields cfg_avlmgr_dbg_srchdb_wdata_hi	 */
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_HI_WIDTH                                 32
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_HI_SHIFT                                  0
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_HI_MASK                          0xffffffff
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_HI_RD(src)           (((src) & 0xffffffff))
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_HI_WR(src)      (((u32)(src)) & 0xffffffff)
#define CFG_AVLMGR_DBG_SRCHDB_WDATA_HI_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_IntReg	*/ 
/*	 Fields sts_sai_avlmgr_fatal_wrselfpointerr	 */
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERR_WIDTH                             1
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERR_SHIFT                            10
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERR_MASK                     0x00000400
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERR_RD(src)  (((src) & 0x00000400)>>10)
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERR_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERR_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields sts_sai_avlmgr_fatal_rdselfpointerr	 */
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERR_WIDTH                             1
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERR_SHIFT                             9
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERR_MASK                     0x00000200
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERR_RD(src)   (((src) & 0x00000200)>>9)
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERR_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERR_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields sts_sai_avlmgr_fatal_wrbalerr	 */
#define STS_SAI_AVLMGR_FATAL_WRBALERR_WIDTH                                   1
#define STS_SAI_AVLMGR_FATAL_WRBALERR_SHIFT                                   8
#define STS_SAI_AVLMGR_FATAL_WRBALERR_MASK                           0x00000100
#define STS_SAI_AVLMGR_FATAL_WRBALERR_RD(src)         (((src) & 0x00000100)>>8)
#define STS_SAI_AVLMGR_FATAL_WRBALERR_WR(src)    (((u32)(src)<<8) & 0x00000100)
#define STS_SAI_AVLMGR_FATAL_WRBALERR_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields sts_sai_avlmgr_fatal_rdbalerr	 */
#define STS_SAI_AVLMGR_FATAL_RDBALERR_WIDTH                                   1
#define STS_SAI_AVLMGR_FATAL_RDBALERR_SHIFT                                   7
#define STS_SAI_AVLMGR_FATAL_RDBALERR_MASK                           0x00000080
#define STS_SAI_AVLMGR_FATAL_RDBALERR_RD(src)         (((src) & 0x00000080)>>7)
#define STS_SAI_AVLMGR_FATAL_RDBALERR_WR(src)    (((u32)(src)<<7) & 0x00000080)
#define STS_SAI_AVLMGR_FATAL_RDBALERR_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields sts_sai_avlmgr_fatal_maxstepserr	 */
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERR_WIDTH                                1
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERR_SHIFT                                6
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERR_MASK                        0x00000040
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERR_RD(src)      (((src) & 0x00000040)>>6)
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERR_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERR_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields sts_sai_avlmgr_fatal_rderr_ram	 */
#define STS_SAI_AVLMGR_FATAL_RDERR_RAM_WIDTH                                  1
#define STS_SAI_AVLMGR_FATAL_RDERR_RAM_SHIFT                                  5
#define STS_SAI_AVLMGR_FATAL_RDERR_RAM_MASK                          0x00000020
#define STS_SAI_AVLMGR_FATAL_RDERR_RAM_RD(src)        (((src) & 0x00000020)>>5)
#define STS_SAI_AVLMGR_FATAL_RDERR_RAM_WR(src)   (((u32)(src)<<5) & 0x00000020)
#define STS_SAI_AVLMGR_FATAL_RDERR_RAM_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields sts_sai_avlmgr_rderr_ram	 */
#define STS_SAI_AVLMGR_RDERR_RAM_WIDTH                                        1
#define STS_SAI_AVLMGR_RDERR_RAM_SHIFT                                        4
#define STS_SAI_AVLMGR_RDERR_RAM_MASK                                0x00000010
#define STS_SAI_AVLMGR_RDERR_RAM_RD(src)              (((src) & 0x00000010)>>4)
#define STS_SAI_AVLMGR_RDERR_RAM_WR(src)         (((u32)(src)<<4) & 0x00000010)
#define STS_SAI_AVLMGR_RDERR_RAM_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields sts_sai_avlmgr_adderr_srchdb_full	 */
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULL_WIDTH                               1
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULL_SHIFT                               3
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULL_MASK                       0x00000008
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULL_RD(src)     (((src) & 0x00000008)>>3)
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULL_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULL_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields sts_sai_avlmgr_adderr_ridduplicate	 */
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATE_WIDTH                              1
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATE_SHIFT                              2
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATE_MASK                      0x00000004
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATE_RD(src)    (((src) & 0x00000004)>>2)
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATE_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATE_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields sts_sai_avlmgr_delerr_srchdb_empty	 */
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTY_WIDTH                              1
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTY_SHIFT                              1
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTY_MASK                      0x00000002
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTY_RD(src)    (((src) & 0x00000002)>>1)
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTY_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTY_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields sts_sai_avlmgr_delerr_ridnotfound	 */
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUND_WIDTH                               1
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUND_SHIFT                               0
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUND_MASK                       0x00000001
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUND_RD(src)        (((src) & 0x00000001))
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUND_WR(src)   (((u32)(src)) & 0x00000001)
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUND_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_IntRegMask	*/
/*    Mask Register Fields sts_sai_avlmgr_fatal_wrselfpointerrMask    */
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERRMASK_WIDTH                         1
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERRMASK_SHIFT                        10
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERRMASK_MASK                 0x00000400
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERRMASK_RD(src) \
                                                    (((src) & 0x00000400)>>10)
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERRMASK_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define STS_SAI_AVLMGR_FATAL_WRSELFPOINTERRMASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields sts_sai_avlmgr_fatal_rdselfpointerrMask    */
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERRMASK_WIDTH                         1
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERRMASK_SHIFT                         9
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERRMASK_MASK                 0x00000200
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERRMASK_RD(src) \
                                                     (((src) & 0x00000200)>>9)
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERRMASK_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define STS_SAI_AVLMGR_FATAL_RDSELFPOINTERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields sts_sai_avlmgr_fatal_wrbalerrMask    */
#define STS_SAI_AVLMGR_FATAL_WRBALERRMASK_WIDTH                               1
#define STS_SAI_AVLMGR_FATAL_WRBALERRMASK_SHIFT                               8
#define STS_SAI_AVLMGR_FATAL_WRBALERRMASK_MASK                       0x00000100
#define STS_SAI_AVLMGR_FATAL_WRBALERRMASK_RD(src)     (((src) & 0x00000100)>>8)
#define STS_SAI_AVLMGR_FATAL_WRBALERRMASK_WR(src) \
                                                 (((u32)(src)<<8) & 0x00000100)
#define STS_SAI_AVLMGR_FATAL_WRBALERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields sts_sai_avlmgr_fatal_rdbalerrMask    */
#define STS_SAI_AVLMGR_FATAL_RDBALERRMASK_WIDTH                               1
#define STS_SAI_AVLMGR_FATAL_RDBALERRMASK_SHIFT                               7
#define STS_SAI_AVLMGR_FATAL_RDBALERRMASK_MASK                       0x00000080
#define STS_SAI_AVLMGR_FATAL_RDBALERRMASK_RD(src)     (((src) & 0x00000080)>>7)
#define STS_SAI_AVLMGR_FATAL_RDBALERRMASK_WR(src) \
                                                 (((u32)(src)<<7) & 0x00000080)
#define STS_SAI_AVLMGR_FATAL_RDBALERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields sts_sai_avlmgr_fatal_maxstepserrMask    */
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERRMASK_WIDTH                            1
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERRMASK_SHIFT                            6
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERRMASK_MASK                    0x00000040
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERRMASK_RD(src)  (((src) & 0x00000040)>>6)
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERRMASK_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define STS_SAI_AVLMGR_FATAL_MAXSTEPSERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields sts_sai_avlmgr_fatal_rderr_ramMask    */
#define STS_SAI_AVLMGR_FATAL_RDERR_RAMMASK_WIDTH                              1
#define STS_SAI_AVLMGR_FATAL_RDERR_RAMMASK_SHIFT                              5
#define STS_SAI_AVLMGR_FATAL_RDERR_RAMMASK_MASK                      0x00000020
#define STS_SAI_AVLMGR_FATAL_RDERR_RAMMASK_RD(src)    (((src) & 0x00000020)>>5)
#define STS_SAI_AVLMGR_FATAL_RDERR_RAMMASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define STS_SAI_AVLMGR_FATAL_RDERR_RAMMASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields sts_sai_avlmgr_rderr_ramMask    */
#define STS_SAI_AVLMGR_RDERR_RAMMASK_WIDTH                                    1
#define STS_SAI_AVLMGR_RDERR_RAMMASK_SHIFT                                    4
#define STS_SAI_AVLMGR_RDERR_RAMMASK_MASK                            0x00000010
#define STS_SAI_AVLMGR_RDERR_RAMMASK_RD(src)          (((src) & 0x00000010)>>4)
#define STS_SAI_AVLMGR_RDERR_RAMMASK_WR(src)     (((u32)(src)<<4) & 0x00000010)
#define STS_SAI_AVLMGR_RDERR_RAMMASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields sts_sai_avlmgr_adderr_srchdb_fullMask    */
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULLMASK_WIDTH                           1
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULLMASK_SHIFT                           3
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULLMASK_MASK                   0x00000008
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULLMASK_RD(src) \
                                                     (((src) & 0x00000008)>>3)
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULLMASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define STS_SAI_AVLMGR_ADDERR_SRCHDB_FULLMASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields sts_sai_avlmgr_adderr_ridduplicateMask    */
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATEMASK_WIDTH                          1
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATEMASK_SHIFT                          2
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATEMASK_MASK                  0x00000004
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATEMASK_RD(src) \
                                                     (((src) & 0x00000004)>>2)
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATEMASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define STS_SAI_AVLMGR_ADDERR_RIDDUPLICATEMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields sts_sai_avlmgr_delerr_srchdb_emptyMask    */
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTYMASK_WIDTH                          1
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTYMASK_SHIFT                          1
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTYMASK_MASK                  0x00000002
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTYMASK_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTYMASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define STS_SAI_AVLMGR_DELERR_SRCHDB_EMPTYMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields sts_sai_avlmgr_delerr_ridnotfoundMask    */
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUNDMASK_WIDTH                           1
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUNDMASK_SHIFT                           0
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUNDMASK_MASK                   0x00000001
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUNDMASK_RD(src)    (((src) & 0x00000001))
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUNDMASK_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define STS_SAI_AVLMGR_DELERR_RIDNOTFOUNDMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_StsReg0	*/ 
/*	 Fields sts_sai_avlmgr_rootaddr	 */
#define STS_SAI_AVLMGR_ROOTADDR0_WIDTH                                        7
#define STS_SAI_AVLMGR_ROOTADDR0_SHIFT                                        8
#define STS_SAI_AVLMGR_ROOTADDR0_MASK                                0x00007f00
#define STS_SAI_AVLMGR_ROOTADDR0_RD(src)              (((src) & 0x00007f00)>>8)
#define STS_SAI_AVLMGR_ROOTADDR0_SET(dst,src) \
                       (((dst) & ~0x00007f00) | (((u32)(src)<<8) & 0x00007f00))
/*	 Fields sts_sai_avlmgr_rid_cnt	 */
#define STS_SAI_AVLMGR_RID_CNT0_WIDTH                                         8
#define STS_SAI_AVLMGR_RID_CNT0_SHIFT                                         0
#define STS_SAI_AVLMGR_RID_CNT0_MASK                                 0x000000ff
#define STS_SAI_AVLMGR_RID_CNT0_RD(src)                  (((src) & 0x000000ff))
#define STS_SAI_AVLMGR_RID_CNT0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register SAI2SAP_StsReg1	*/ 
/*	 Fields sts_avlmgr_dbg_srchdb_rdata_lsb	 */
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LSB1_WIDTH                               17
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LSB1_SHIFT                                0
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LSB1_MASK                        0x0001ffff
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LSB1_RD(src)         (((src) & 0x0001ffff))
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LSB1_SET(dst,src) \
                          (((dst) & ~0x0001ffff) | (((u32)(src)) & 0x0001ffff))

/*	Register SAI2SAP_StsReg2	*/ 
/*	 Fields sts_avlmgr_dbg_srchdb_rdata_lo	 */
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LO2_WIDTH                                32
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LO2_SHIFT                                 0
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LO2_MASK                         0xffffffff
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LO2_RD(src)          (((src) & 0xffffffff))
#define STS_AVLMGR_DBG_SRCHDB_RDATA_LO2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_StsReg3	*/ 
/*	 Fields sts_avlmgr_dbg_srchdb_rdata_hi	 */
#define STS_AVLMGR_DBG_SRCHDB_RDATA_HI3_WIDTH                                32
#define STS_AVLMGR_DBG_SRCHDB_RDATA_HI3_SHIFT                                 0
#define STS_AVLMGR_DBG_SRCHDB_RDATA_HI3_MASK                         0xffffffff
#define STS_AVLMGR_DBG_SRCHDB_RDATA_HI3_RD(src)          (((src) & 0xffffffff))
#define STS_AVLMGR_DBG_SRCHDB_RDATA_HI3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SAI2SAP_StsReg4	*/ 
/*	 Fields sts_sai_avlmgr_deladdr	 */
#define STS_SAI_AVLMGR_DELADDR4_WIDTH                                         8
#define STS_SAI_AVLMGR_DELADDR4_SHIFT                                        16
#define STS_SAI_AVLMGR_DELADDR4_MASK                                 0x00ff0000
#define STS_SAI_AVLMGR_DELADDR4_RD(src)              (((src) & 0x00ff0000)>>16)
#define STS_SAI_AVLMGR_DELADDR4_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields sts_sai_avlmgr_addaddr	 */
#define STS_SAI_AVLMGR_ADDADDR4_WIDTH                                         8
#define STS_SAI_AVLMGR_ADDADDR4_SHIFT                                         8
#define STS_SAI_AVLMGR_ADDADDR4_MASK                                 0x0000ff00
#define STS_SAI_AVLMGR_ADDADDR4_RD(src)               (((src) & 0x0000ff00)>>8)
#define STS_SAI_AVLMGR_ADDADDR4_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields sts_sai_avlmgr_srchaddr	 */
#define STS_SAI_AVLMGR_SRCHADDR4_WIDTH                                        8
#define STS_SAI_AVLMGR_SRCHADDR4_SHIFT                                        0
#define STS_SAI_AVLMGR_SRCHADDR4_MASK                                0x000000ff
#define STS_SAI_AVLMGR_SRCHADDR4_RD(src)                 (((src) & 0x000000ff))
#define STS_SAI_AVLMGR_SRCHADDR4_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register SAI2SAP_FIFO_EmptySts0	*/ 
/*	 Fields macif_fifo_empty_sai_rxprt1	 */
#define MACIF_FIFO_EMPTY_SAI_RXPRT10_WIDTH                                    1
#define MACIF_FIFO_EMPTY_SAI_RXPRT10_SHIFT                                    1
#define MACIF_FIFO_EMPTY_SAI_RXPRT10_MASK                            0x00000002
#define MACIF_FIFO_EMPTY_SAI_RXPRT10_RD(src)          (((src) & 0x00000002)>>1)
#define MACIF_FIFO_EMPTY_SAI_RXPRT10_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields macif_fifo_empty_sai_rxprt0	 */
#define MACIF_FIFO_EMPTY_SAI_RXPRT00_WIDTH                                    1
#define MACIF_FIFO_EMPTY_SAI_RXPRT00_SHIFT                                    0
#define MACIF_FIFO_EMPTY_SAI_RXPRT00_MASK                            0x00000001
#define MACIF_FIFO_EMPTY_SAI_RXPRT00_RD(src)             (((src) & 0x00000001))
#define MACIF_FIFO_EMPTY_SAI_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_Int_Reg0	*/ 
/*	 Fields macif_fifo_overfl_intr_sai_rxprt1	 */
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT10_WIDTH                              1
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT10_SHIFT                             17
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT10_MASK                      0x00020000
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT10_RD(src)   (((src) & 0x00020000)>>17)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT10_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields macif_fifo_underfl_intr_sai_rxprt1	 */
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT10_WIDTH                             1
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT10_SHIFT                            16
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT10_MASK                     0x00010000
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT10_RD(src)  (((src) & 0x00010000)>>16)
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT10_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT10_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields macif_fifo_overfl_intr_sai_rxprt0	 */
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT00_WIDTH                              1
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT00_SHIFT                              1
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT00_MASK                      0x00000002
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT00_RD(src)    (((src) & 0x00000002)>>1)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT00_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields macif_fifo_underfl_intr_sai_rxprt0	 */
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT00_WIDTH                             1
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT00_SHIFT                             0
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT00_MASK                     0x00000001
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT00_RD(src)      (((src) & 0x00000001))
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT00_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT00_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SAI2SAP_Int_Reg0Mask	*/
/*    Mask Register Fields macif_fifo_overfl_intr_sai_rxprt1Mask    */
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT1MASK_WIDTH                           1
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT1MASK_SHIFT                          17
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT1MASK_MASK                   0x00020000
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields macif_fifo_underfl_intr_sai_rxprt1Mask    */
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT1MASK_WIDTH                          1
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT1MASK_SHIFT                         16
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT1MASK_MASK                  0x00010000
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT1MASK_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT1MASK_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields macif_fifo_overfl_intr_sai_rxprt0Mask    */
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT0MASK_WIDTH                           1
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT0MASK_SHIFT                           1
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT0MASK_MASK                   0x00000002
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT0MASK_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT0MASK_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define MACIF_FIFO_OVERFL_INTR_SAI_RXPRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields macif_fifo_underfl_intr_sai_rxprt0Mask    */
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT0MASK_WIDTH                          1
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT0MASK_SHIFT                          0
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT0MASK_MASK                  0x00000001
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT0MASK_RD(src)   (((src) & 0x00000001))
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT0MASK_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define MACIF_FIFO_UNDERFL_INTR_SAI_RXPRT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register link_sts_intr	*/ 
/*	 Fields port1	 */
#define PORT1_F5_WIDTH                                                        1
#define PORT1_F5_SHIFT                                                        1
#define PORT1_F5_MASK                                                0x00000002
#define PORT1_F5_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F5_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define PORT1_F5_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F5_WIDTH                                                        1
#define PORT0_F5_SHIFT                                                        0
#define PORT0_F5_MASK                                                0x00000001
#define PORT0_F5_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F5_WR(src)                            (((u32)(src)) & 0x00000001)
#define PORT0_F5_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register link_sts_intrMask	*/
/*    Mask Register Fields port1Mask    */
#define PORT1MASK_F1_WIDTH                                                    1
#define PORT1MASK_F1_SHIFT                                                    1
#define PORT1MASK_F1_MASK                                            0x00000002
#define PORT1MASK_F1_RD(src)                          (((src) & 0x00000002)>>1)
#define PORT1MASK_F1_WR(src)                     (((u32)(src)<<1) & 0x00000002)
#define PORT1MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields port0Mask    */
#define PORT0MASK_F1_WIDTH                                                    1
#define PORT0MASK_F1_SHIFT                                                    0
#define PORT0MASK_F1_MASK                                            0x00000001
#define PORT0MASK_F1_RD(src)                             (((src) & 0x00000001))
#define PORT0MASK_F1_WR(src)                        (((u32)(src)) & 0x00000001)
#define PORT0MASK_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register link_status	*/ 
/*	 Fields qmi_wq_avlbl	 */
#define QMI_WQ_AVLBL_WIDTH                                                    1
#define QMI_WQ_AVLBL_SHIFT                                                   19
#define QMI_WQ_AVLBL_MASK                                            0x00080000
#define QMI_WQ_AVLBL_RD(src)                         (((src) & 0x00080000)>>19)
#define QMI_WQ_AVLBL_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields mpa_enet_idle	 */
#define MPA_ENET_IDLE_WIDTH                                                   1
#define MPA_ENET_IDLE_SHIFT                                                  18
#define MPA_ENET_IDLE_MASK                                           0x00040000
#define MPA_ENET_IDLE_RD(src)                        (((src) & 0x00040000)>>18)
#define MPA_ENET_IDLE_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields tx_idle_port1	 */
#define TX_IDLE_PORT1_WIDTH                                                   1
#define TX_IDLE_PORT1_SHIFT                                                  17
#define TX_IDLE_PORT1_MASK                                           0x00020000
#define TX_IDLE_PORT1_RD(src)                        (((src) & 0x00020000)>>17)
#define TX_IDLE_PORT1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields tx_idle_port0	 */
#define TX_IDLE_PORT0_WIDTH                                                   1
#define TX_IDLE_PORT0_SHIFT                                                  16
#define TX_IDLE_PORT0_MASK                                           0x00010000
#define TX_IDLE_PORT0_RD(src)                        (((src) & 0x00010000)>>16)
#define TX_IDLE_PORT0_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields port1	 */
#define PORT1_F6_WIDTH                                                        1
#define PORT1_F6_SHIFT                                                        1
#define PORT1_F6_MASK                                                0x00000002
#define PORT1_F6_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F6_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F6_WIDTH                                                        1
#define PORT0_F6_SHIFT                                                        0
#define PORT0_F6_MASK                                                0x00000001
#define PORT0_F6_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F6_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_link_aggr_resume_0	*/ 
/*	 Fields tx_port	 */
#define TX_PORT0_WIDTH                                                        1
#define TX_PORT0_SHIFT                                                        0
#define TX_PORT0_MASK                                                0x00000001
#define TX_PORT0_RD(src)                                 (((src) & 0x00000001))
#define TX_PORT0_WR(src)                            (((u32)(src)) & 0x00000001)
#define TX_PORT0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_link_aggr_resume_1	*/ 
/*	 Fields tx_port	 */
#define TX_PORT1_WIDTH                                                        1
#define TX_PORT1_SHIFT                                                        0
#define TX_PORT1_MASK                                                0x00000001
#define TX_PORT1_RD(src)                                 (((src) & 0x00000001))
#define TX_PORT1_WR(src)                            (((u32)(src)) & 0x00000001)
#define TX_PORT1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_lpbk_gate_tx	*/ 
/*	 Fields port1	 */
#define PORT1_F7_WIDTH                                                        1
#define PORT1_F7_SHIFT                                                        1
#define PORT1_F7_MASK                                                0x00000002
#define PORT1_F7_RD(src)                              (((src) & 0x00000002)>>1)
#define PORT1_F7_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define PORT1_F7_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields port0	 */
#define PORT0_F7_WIDTH                                                        1
#define PORT0_F7_SHIFT                                                        0
#define PORT0_F7_MASK                                                0x00000001
#define PORT0_F7_RD(src)                                 (((src) & 0x00000001))
#define PORT0_F7_WR(src)                            (((u32)(src)) & 0x00000001)
#define PORT0_F7_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_force_sdet_0	*/ 
/*	 Fields en	 */
#define EN0_F1_WIDTH                                                          1
#define EN0_F1_SHIFT                                                          1
#define EN0_F1_MASK                                                  0x00000002
#define EN0_F1_RD(src)                                (((src) & 0x00000002)>>1)
#define EN0_F1_WR(src)                           (((u32)(src)<<1) & 0x00000002)
#define EN0_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields val	 */
#define VAL0_WIDTH                                                            1
#define VAL0_SHIFT                                                            0
#define VAL0_MASK                                                    0x00000001
#define VAL0_RD(src)                                     (((src) & 0x00000001))
#define VAL0_WR(src)                                (((u32)(src)) & 0x00000001)
#define VAL0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_force_sdet_1	*/ 
/*	 Fields en	 */
#define EN1_F1_WIDTH                                                          1
#define EN1_F1_SHIFT                                                          1
#define EN1_F1_MASK                                                  0x00000002
#define EN1_F1_RD(src)                                (((src) & 0x00000002)>>1)
#define EN1_F1_WR(src)                           (((u32)(src)<<1) & 0x00000002)
#define EN1_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields val	 */
#define VAL1_WIDTH                                                            1
#define VAL1_SHIFT                                                            0
#define VAL1_MASK                                                    0x00000001
#define VAL1_RD(src)                                     (((src) & 0x00000001))
#define VAL1_WR(src)                                (((u32)(src)) & 0x00000001)
#define VAL1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RGMII_Reg_0	*/ 
/*	 Fields cfg_txclk_muxsel	 */
#define CFG_TXCLK_MUXSEL0_WIDTH                                               3
#define CFG_TXCLK_MUXSEL0_SHIFT                                              29
#define CFG_TXCLK_MUXSEL0_MASK                                       0xe0000000
#define CFG_TXCLK_MUXSEL0_RD(src)                    (((src) & 0xe0000000)>>29)
#define CFG_TXCLK_MUXSEL0_WR(src)               (((u32)(src)<<29) & 0xe0000000)
#define CFG_TXCLK_MUXSEL0_SET(dst,src) \
                      (((dst) & ~0xe0000000) | (((u32)(src)<<29) & 0xe0000000))
/*	 Fields cfg_rxclk_muxsel	 */
#define CFG_RXCLK_MUXSEL0_WIDTH                                               3
#define CFG_RXCLK_MUXSEL0_SHIFT                                              26
#define CFG_RXCLK_MUXSEL0_MASK                                       0x1c000000
#define CFG_RXCLK_MUXSEL0_RD(src)                    (((src) & 0x1c000000)>>26)
#define CFG_RXCLK_MUXSEL0_WR(src)               (((u32)(src)<<26) & 0x1c000000)
#define CFG_RXCLK_MUXSEL0_SET(dst,src) \
                      (((dst) & ~0x1c000000) | (((u32)(src)<<26) & 0x1c000000))
/*	 Fields cfg_loopback_tx2rx	 */
#define CFG_LOOPBACK_TX2RX0_WIDTH                                             1
#define CFG_LOOPBACK_TX2RX0_SHIFT                                            25
#define CFG_LOOPBACK_TX2RX0_MASK                                     0x02000000
#define CFG_LOOPBACK_TX2RX0_RD(src)                  (((src) & 0x02000000)>>25)
#define CFG_LOOPBACK_TX2RX0_WR(src)             (((u32)(src)<<25) & 0x02000000)
#define CFG_LOOPBACK_TX2RX0_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields cfg_speed_125	 */
#define CFG_SPEED_1250_WIDTH                                                  1
#define CFG_SPEED_1250_SHIFT                                                 24
#define CFG_SPEED_1250_MASK                                          0x01000000
#define CFG_SPEED_1250_RD(src)                       (((src) & 0x01000000)>>24)
#define CFG_SPEED_1250_WR(src)                  (((u32)(src)<<24) & 0x01000000)
#define CFG_SPEED_1250_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_flip_nibble_tx	 */
#define CFG_FLIP_NIBBLE_TX0_WIDTH                                             1
#define CFG_FLIP_NIBBLE_TX0_SHIFT                                            23
#define CFG_FLIP_NIBBLE_TX0_MASK                                     0x00800000
#define CFG_FLIP_NIBBLE_TX0_RD(src)                  (((src) & 0x00800000)>>23)
#define CFG_FLIP_NIBBLE_TX0_WR(src)             (((u32)(src)<<23) & 0x00800000)
#define CFG_FLIP_NIBBLE_TX0_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields cfg_flip_nibble_rx	 */
#define CFG_FLIP_NIBBLE_RX0_WIDTH                                             1
#define CFG_FLIP_NIBBLE_RX0_SHIFT                                            22
#define CFG_FLIP_NIBBLE_RX0_MASK                                     0x00400000
#define CFG_FLIP_NIBBLE_RX0_RD(src)                  (((src) & 0x00400000)>>22)
#define CFG_FLIP_NIBBLE_RX0_WR(src)             (((u32)(src)<<22) & 0x00400000)
#define CFG_FLIP_NIBBLE_RX0_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields cfg_txclk_invert	 */
#define CFG_TXCLK_INVERT0_WIDTH                                               1
#define CFG_TXCLK_INVERT0_SHIFT                                              21
#define CFG_TXCLK_INVERT0_MASK                                       0x00200000
#define CFG_TXCLK_INVERT0_RD(src)                    (((src) & 0x00200000)>>21)
#define CFG_TXCLK_INVERT0_WR(src)               (((u32)(src)<<21) & 0x00200000)
#define CFG_TXCLK_INVERT0_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_rxclk_invert	 */
#define CFG_RXCLK_INVERT0_WIDTH                                               1
#define CFG_RXCLK_INVERT0_SHIFT                                              20
#define CFG_RXCLK_INVERT0_MASK                                       0x00100000
#define CFG_RXCLK_INVERT0_RD(src)                    (((src) & 0x00100000)>>20)
#define CFG_RXCLK_INVERT0_WR(src)               (((u32)(src)<<20) & 0x00100000)
#define CFG_RXCLK_INVERT0_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))

/*	Register RGMII_Reg_1	*/ 
/*	 Fields cfg_txclk_muxsel	 */
#define CFG_TXCLK_MUXSEL1_WIDTH                                               3
#define CFG_TXCLK_MUXSEL1_SHIFT                                              29
#define CFG_TXCLK_MUXSEL1_MASK                                       0xe0000000
#define CFG_TXCLK_MUXSEL1_RD(src)                    (((src) & 0xe0000000)>>29)
#define CFG_TXCLK_MUXSEL1_WR(src)               (((u32)(src)<<29) & 0xe0000000)
#define CFG_TXCLK_MUXSEL1_SET(dst,src) \
                      (((dst) & ~0xe0000000) | (((u32)(src)<<29) & 0xe0000000))
/*	 Fields cfg_rxclk_muxsel	 */
#define CFG_RXCLK_MUXSEL1_WIDTH                                               3
#define CFG_RXCLK_MUXSEL1_SHIFT                                              26
#define CFG_RXCLK_MUXSEL1_MASK                                       0x1c000000
#define CFG_RXCLK_MUXSEL1_RD(src)                    (((src) & 0x1c000000)>>26)
#define CFG_RXCLK_MUXSEL1_WR(src)               (((u32)(src)<<26) & 0x1c000000)
#define CFG_RXCLK_MUXSEL1_SET(dst,src) \
                      (((dst) & ~0x1c000000) | (((u32)(src)<<26) & 0x1c000000))
/*	 Fields cfg_loopback_tx2rx	 */
#define CFG_LOOPBACK_TX2RX1_WIDTH                                             1
#define CFG_LOOPBACK_TX2RX1_SHIFT                                            25
#define CFG_LOOPBACK_TX2RX1_MASK                                     0x02000000
#define CFG_LOOPBACK_TX2RX1_RD(src)                  (((src) & 0x02000000)>>25)
#define CFG_LOOPBACK_TX2RX1_WR(src)             (((u32)(src)<<25) & 0x02000000)
#define CFG_LOOPBACK_TX2RX1_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields cfg_speed_125	 */
#define CFG_SPEED_1251_WIDTH                                                  1
#define CFG_SPEED_1251_SHIFT                                                 24
#define CFG_SPEED_1251_MASK                                          0x01000000
#define CFG_SPEED_1251_RD(src)                       (((src) & 0x01000000)>>24)
#define CFG_SPEED_1251_WR(src)                  (((u32)(src)<<24) & 0x01000000)
#define CFG_SPEED_1251_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_flip_nibble_tx	 */
#define CFG_FLIP_NIBBLE_TX1_WIDTH                                             1
#define CFG_FLIP_NIBBLE_TX1_SHIFT                                            23
#define CFG_FLIP_NIBBLE_TX1_MASK                                     0x00800000
#define CFG_FLIP_NIBBLE_TX1_RD(src)                  (((src) & 0x00800000)>>23)
#define CFG_FLIP_NIBBLE_TX1_WR(src)             (((u32)(src)<<23) & 0x00800000)
#define CFG_FLIP_NIBBLE_TX1_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields cfg_flip_nibble_rx	 */
#define CFG_FLIP_NIBBLE_RX1_WIDTH                                             1
#define CFG_FLIP_NIBBLE_RX1_SHIFT                                            22
#define CFG_FLIP_NIBBLE_RX1_MASK                                     0x00400000
#define CFG_FLIP_NIBBLE_RX1_RD(src)                  (((src) & 0x00400000)>>22)
#define CFG_FLIP_NIBBLE_RX1_WR(src)             (((u32)(src)<<22) & 0x00400000)
#define CFG_FLIP_NIBBLE_RX1_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields cfg_txclk_invert	 */
#define CFG_TXCLK_INVERT1_WIDTH                                               1
#define CFG_TXCLK_INVERT1_SHIFT                                              21
#define CFG_TXCLK_INVERT1_MASK                                       0x00200000
#define CFG_TXCLK_INVERT1_RD(src)                    (((src) & 0x00200000)>>21)
#define CFG_TXCLK_INVERT1_WR(src)               (((u32)(src)<<21) & 0x00200000)
#define CFG_TXCLK_INVERT1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_rxclk_invert	 */
#define CFG_RXCLK_INVERT1_WIDTH                                               1
#define CFG_RXCLK_INVERT1_SHIFT                                              20
#define CFG_RXCLK_INVERT1_MASK                                       0x00100000
#define CFG_RXCLK_INVERT1_RD(src)                    (((src) & 0x00100000)>>20)
#define CFG_RXCLK_INVERT1_WR(src)               (((u32)(src)<<20) & 0x00100000)
#define CFG_RXCLK_INVERT1_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))

/*	Register SGMII_Reg0	*/ 
/*	 Fields cfg_sgmii_bypass_posedge_rxdv	 */
#define CFG_SGMII_BYPASS_POSEDGE_RXDV0_WIDTH                                  1
#define CFG_SGMII_BYPASS_POSEDGE_RXDV0_SHIFT                                  6
#define CFG_SGMII_BYPASS_POSEDGE_RXDV0_MASK                          0x00000040
#define CFG_SGMII_BYPASS_POSEDGE_RXDV0_RD(src)        (((src) & 0x00000040)>>6)
#define CFG_SGMII_BYPASS_POSEDGE_RXDV0_WR(src)   (((u32)(src)<<6) & 0x00000040)
#define CFG_SGMII_BYPASS_POSEDGE_RXDV0_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_sgmii_store_en	 */
#define CFG_SGMII_STORE_EN0_WIDTH                                             2
#define CFG_SGMII_STORE_EN0_SHIFT                                             4
#define CFG_SGMII_STORE_EN0_MASK                                     0x00000030
#define CFG_SGMII_STORE_EN0_RD(src)                   (((src) & 0x00000030)>>4)
#define CFG_SGMII_STORE_EN0_WR(src)              (((u32)(src)<<4) & 0x00000030)
#define CFG_SGMII_STORE_EN0_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_dis_preamble_fix	 */
#define CFG_DIS_PREAMBLE_FIX0_WIDTH                                           1
#define CFG_DIS_PREAMBLE_FIX0_SHIFT                                           3
#define CFG_DIS_PREAMBLE_FIX0_MASK                                   0x00000008
#define CFG_DIS_PREAMBLE_FIX0_RD(src)                 (((src) & 0x00000008)>>3)
#define CFG_DIS_PREAMBLE_FIX0_WR(src)            (((u32)(src)<<3) & 0x00000008)
#define CFG_DIS_PREAMBLE_FIX0_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_sgmii_rxclk_invert	 */
#define CFG_SGMII_RXCLK_INVERT0_WIDTH                                         1
#define CFG_SGMII_RXCLK_INVERT0_SHIFT                                         2
#define CFG_SGMII_RXCLK_INVERT0_MASK                                 0x00000004
#define CFG_SGMII_RXCLK_INVERT0_RD(src)               (((src) & 0x00000004)>>2)
#define CFG_SGMII_RXCLK_INVERT0_WR(src)          (((u32)(src)<<2) & 0x00000004)
#define CFG_SGMII_RXCLK_INVERT0_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_sgmii_txclk_invert	 */
#define CFG_SGMII_TXCLK_INVERT0_WIDTH                                         1
#define CFG_SGMII_TXCLK_INVERT0_SHIFT                                         1
#define CFG_SGMII_TXCLK_INVERT0_MASK                                 0x00000002
#define CFG_SGMII_TXCLK_INVERT0_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_SGMII_TXCLK_INVERT0_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_SGMII_TXCLK_INVERT0_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_dis_commaalign_fix	 */
#define CFG_DIS_COMMAALIGN_FIX0_WIDTH                                         1
#define CFG_DIS_COMMAALIGN_FIX0_SHIFT                                         0
#define CFG_DIS_COMMAALIGN_FIX0_MASK                                 0x00000001
#define CFG_DIS_COMMAALIGN_FIX0_RD(src)                  (((src) & 0x00000001))
#define CFG_DIS_COMMAALIGN_FIX0_WR(src)             (((u32)(src)) & 0x00000001)
#define CFG_DIS_COMMAALIGN_FIX0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SGMII_Reg1	*/ 
/*	 Fields cfg_sgmii_bypass_posedge_rxdv	 */
#define CFG_SGMII_BYPASS_POSEDGE_RXDV1_WIDTH                                  1
#define CFG_SGMII_BYPASS_POSEDGE_RXDV1_SHIFT                                  6
#define CFG_SGMII_BYPASS_POSEDGE_RXDV1_MASK                          0x00000040
#define CFG_SGMII_BYPASS_POSEDGE_RXDV1_RD(src)        (((src) & 0x00000040)>>6)
#define CFG_SGMII_BYPASS_POSEDGE_RXDV1_WR(src)   (((u32)(src)<<6) & 0x00000040)
#define CFG_SGMII_BYPASS_POSEDGE_RXDV1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_sgmii_store_en	 */
#define CFG_SGMII_STORE_EN1_WIDTH                                             2
#define CFG_SGMII_STORE_EN1_SHIFT                                             4
#define CFG_SGMII_STORE_EN1_MASK                                     0x00000030
#define CFG_SGMII_STORE_EN1_RD(src)                   (((src) & 0x00000030)>>4)
#define CFG_SGMII_STORE_EN1_WR(src)              (((u32)(src)<<4) & 0x00000030)
#define CFG_SGMII_STORE_EN1_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_dis_preamble_fix	 */
#define CFG_DIS_PREAMBLE_FIX1_WIDTH                                           1
#define CFG_DIS_PREAMBLE_FIX1_SHIFT                                           3
#define CFG_DIS_PREAMBLE_FIX1_MASK                                   0x00000008
#define CFG_DIS_PREAMBLE_FIX1_RD(src)                 (((src) & 0x00000008)>>3)
#define CFG_DIS_PREAMBLE_FIX1_WR(src)            (((u32)(src)<<3) & 0x00000008)
#define CFG_DIS_PREAMBLE_FIX1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_sgmii_rxclk_invert	 */
#define CFG_SGMII_RXCLK_INVERT1_WIDTH                                         1
#define CFG_SGMII_RXCLK_INVERT1_SHIFT                                         2
#define CFG_SGMII_RXCLK_INVERT1_MASK                                 0x00000004
#define CFG_SGMII_RXCLK_INVERT1_RD(src)               (((src) & 0x00000004)>>2)
#define CFG_SGMII_RXCLK_INVERT1_WR(src)          (((u32)(src)<<2) & 0x00000004)
#define CFG_SGMII_RXCLK_INVERT1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_sgmii_txclk_invert	 */
#define CFG_SGMII_TXCLK_INVERT1_WIDTH                                         1
#define CFG_SGMII_TXCLK_INVERT1_SHIFT                                         1
#define CFG_SGMII_TXCLK_INVERT1_MASK                                 0x00000002
#define CFG_SGMII_TXCLK_INVERT1_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_SGMII_TXCLK_INVERT1_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_SGMII_TXCLK_INVERT1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_dis_commaalign_fix	 */
#define CFG_DIS_COMMAALIGN_FIX1_WIDTH                                         1
#define CFG_DIS_COMMAALIGN_FIX1_SHIFT                                         0
#define CFG_DIS_COMMAALIGN_FIX1_MASK                                 0x00000001
#define CFG_DIS_COMMAALIGN_FIX1_RD(src)                  (((src) & 0x00000001))
#define CFG_DIS_COMMAALIGN_FIX1_WR(src)             (((u32)(src)) & 0x00000001)
#define CFG_DIS_COMMAALIGN_FIX1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RGMII_SGMII_Reg	*/ 
/*	 Fields cfg_lktmr	 */
#define CFG_LKTMR_WIDTH                                                      21
#define CFG_LKTMR_SHIFT                                                       2
#define CFG_LKTMR_MASK                                               0x007ffffc
#define CFG_LKTMR_RD(src)                             (((src) & 0x007ffffc)>>2)
#define CFG_LKTMR_WR(src)                        (((u32)(src)<<2) & 0x007ffffc)
#define CFG_LKTMR_SET(dst,src) \
                       (((dst) & ~0x007ffffc) | (((u32)(src)<<2) & 0x007ffffc))
/*	 Fields cfg_dis_petfn_fix_port1	 */
#define CFG_DIS_PETFN_FIX_PORT1_WIDTH                                         1
#define CFG_DIS_PETFN_FIX_PORT1_SHIFT                                         1
#define CFG_DIS_PETFN_FIX_PORT1_MASK                                 0x00000002
#define CFG_DIS_PETFN_FIX_PORT1_RD(src)               (((src) & 0x00000002)>>1)
#define CFG_DIS_PETFN_FIX_PORT1_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define CFG_DIS_PETFN_FIX_PORT1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_dis_petfn_fix_port0	 */
#define CFG_DIS_PETFN_FIX_PORT0_WIDTH                                         1
#define CFG_DIS_PETFN_FIX_PORT0_SHIFT                                         0
#define CFG_DIS_PETFN_FIX_PORT0_MASK                                 0x00000001
#define CFG_DIS_PETFN_FIX_PORT0_RD(src)                  (((src) & 0x00000001))
#define CFG_DIS_PETFN_FIX_PORT0_WR(src)             (((u32)(src)) & 0x00000001)
#define CFG_DIS_PETFN_FIX_PORT0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_MAC_CSR_BASE_ADDR			0x01f212800ULL

/*    Address ENET_MAC_CSR  Registers */
#define CFG_MAC_IPG_MONITOR_0_ADDR                                   0x00000020
#define CFG_MAC_IPG_MONITOR_0_DEFAULT                                0x0c0c0001
#define CFG_MAC_IPG_MONITOR_1_ADDR                                   0x00000024
#define CFG_MAC_IPG_MONITOR_1_DEFAULT                                0x0c0c0001
#define EEE_RX_TIMER0_0_ADDR                                         0x00000030
#define EEE_RX_TIMER0_0_DEFAULT                                      0x0007270e
#define EEE_RX_TIMER1_0_ADDR                                         0x00000034
#define EEE_RX_TIMER1_0_DEFAULT                                      0x00000705
#define EEE_RX_TIMER2_0_ADDR                                         0x00000038
#define EEE_RX_TIMER2_0_DEFAULT                                      0x0017d784
#define EEE_RX_TIMER0_1_ADDR                                         0x00000040
#define EEE_RX_TIMER0_1_DEFAULT                                      0x0007270e
#define EEE_RX_TIMER1_1_ADDR                                         0x00000044
#define EEE_RX_TIMER1_1_DEFAULT                                      0x00000705
#define EEE_RX_TIMER2_1_ADDR                                         0x00000048
#define EEE_RX_TIMER2_1_DEFAULT                                      0x0017d784
#define EEE_REG_0_ADDR                                               0x00000080
#define EEE_REG_0_DEFAULT                                            0x08000010
#define EEE_TW_TIMER_0_ADDR                                          0x00000084
#define EEE_TW_TIMER_0_DEFAULT                                       0x00001000
#define EEE_LPI_WAIT_PATTERNS_0_ADDR                                 0x00000088
#define EEE_LPI_WAIT_PATTERNS_0_DEFAULT                              0x00000201
#define EEE_REG_1_ADDR                                               0x00000090
#define EEE_REG_1_DEFAULT                                            0x08000010
#define EEE_TW_TIMER_1_ADDR                                          0x00000094
#define EEE_TW_TIMER_1_DEFAULT                                       0x00001000
#define EEE_LPI_WAIT_PATTERNS_1_ADDR                                 0x00000098
#define EEE_LPI_WAIT_PATTERNS_1_DEFAULT                              0x00000201
#define EEE_RX_LPI_DETECT_0_ADDR                                     0x00000100
#define EEE_RX_LPI_DETECT_0_DEFAULT                                  0x00000201
#define EEE_RX_LPI_DETECT_1_ADDR                                     0x00000104
#define EEE_RX_LPI_DETECT_1_DEFAULT                                  0x00000201
#define EEE_RX_LPI_DETECT_INTR_0_ADDR                                0x000001f0
#define EEE_RX_LPI_DETECT_INTR_0_DEFAULT                             0x00000000
#define EEE_RX_LPI_DETECT_INTR_0MASK_ADDR                            0x000001f4
#define EEE_RX_LPI_DETECT_INTR_1_ADDR                                0x000001f8
#define EEE_RX_LPI_DETECT_INTR_1_DEFAULT                             0x00000000
#define EEE_RX_LPI_DETECT_INTR_1MASK_ADDR                            0x000001fc
#define CSR_ECM_CFG_0_ADDR                                           0x00000220
#define CSR_ECM_CFG_0_DEFAULT                                        0x00000005
#define CSR_ECM_CFG_1_ADDR                                           0x00000224
#define CSR_ECM_CFG_1_DEFAULT                                        0x00000005
#define CSR_ECM_SWPF_0_ADDR                                          0x00000228
#define CSR_ECM_SWPF_0_DEFAULT                                       0x00010000
#define CSR_ECM_SWPF_1_ADDR                                          0x0000022c
#define CSR_ECM_SWPF_1_DEFAULT                                       0x00010000
#define CSR_MULTI_DPF_0_ADDR                                         0x00000230
#define CSR_MULTI_DPF_0_DEFAULT                                      0x00010000
#define CSR_MULTI_DPF_1_ADDR                                         0x00000234
#define CSR_MULTI_DPF_1_DEFAULT                                      0x00010000
#define CSR_ECM_RSH_0_ADDR                                           0x00000238
#define CSR_ECM_RSH_0_DEFAULT                                        0x00000000
#define CSR_ECM_RSH_1_ADDR                                           0x0000023c
#define CSR_ECM_RSH_1_DEFAULT                                        0x00000000
#define PFC_CONFIG0_REG_0_ADDR                                       0x00000300
#define PFC_CONFIG0_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG1_REG_0_ADDR                                       0x00000304
#define PFC_CONFIG1_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG2_REG_0_ADDR                                       0x00000308
#define PFC_CONFIG2_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG3_REG_0_ADDR                                       0x0000030c
#define PFC_CONFIG3_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG4_REG_0_ADDR                                       0x00000310
#define PFC_CONFIG4_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG5_REG_0_ADDR                                       0x00000314
#define PFC_CONFIG5_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG6_REG_0_ADDR                                       0x00000318
#define PFC_CONFIG6_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG7_REG_0_ADDR                                       0x0000031c
#define PFC_CONFIG7_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG8_REG_0_ADDR                                       0x00000320
#define PFC_CONFIG8_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG9_REG_0_ADDR                                       0x00000324
#define PFC_CONFIG9_REG_0_DEFAULT                                    0x00000000
#define PFC_CONFIG10_REG_0_ADDR                                      0x00000328
#define PFC_CONFIG10_REG_0_DEFAULT                                   0x00000000
#define PFC_CONFIG0_REG_1_ADDR                                       0x00000350
#define PFC_CONFIG0_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG1_REG_1_ADDR                                       0x00000354
#define PFC_CONFIG1_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG2_REG_1_ADDR                                       0x00000358
#define PFC_CONFIG2_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG3_REG_1_ADDR                                       0x0000035c
#define PFC_CONFIG3_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG4_REG_1_ADDR                                       0x00000360
#define PFC_CONFIG4_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG5_REG_1_ADDR                                       0x00000364
#define PFC_CONFIG5_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG6_REG_1_ADDR                                       0x00000368
#define PFC_CONFIG6_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG7_REG_1_ADDR                                       0x0000036c
#define PFC_CONFIG7_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG8_REG_1_ADDR                                       0x00000370
#define PFC_CONFIG8_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG9_REG_1_ADDR                                       0x00000374
#define PFC_CONFIG9_REG_1_DEFAULT                                    0x00000000
#define PFC_CONFIG10_REG_1_ADDR                                      0x00000378
#define PFC_CONFIG10_REG_1_DEFAULT                                   0x00000000
#define ICM_CONFIG0_REG_0_ADDR                                       0x00000400
#define ICM_CONFIG0_REG_0_DEFAULT                                    0x0008503f
#define ICM_CONFIG1_REG_0_ADDR                                       0x00000404
#define ICM_CONFIG1_REG_0_DEFAULT                                    0x02103200
#define ICM_CONFIG0_REG_1_ADDR                                       0x00000408
#define ICM_CONFIG0_REG_1_DEFAULT                                    0x0008503f
#define ICM_CONFIG1_REG_1_ADDR                                       0x0000040c
#define ICM_CONFIG1_REG_1_DEFAULT                                    0x02103200
#define ICM_CONFIG2_REG_0_ADDR                                       0x00000410
#define ICM_CONFIG2_REG_0_DEFAULT                                    0x0001000f
#define ICM_CONFIG2_REG_1_ADDR                                       0x00000414
#define ICM_CONFIG2_REG_1_DEFAULT                                    0x0001000f
#define ICM_CONFIG3_REG_0_ADDR                                       0x00000418
#define ICM_CONFIG3_REG_0_DEFAULT                                    0x00000000
#define ICM_CONFIG3_REG_1_ADDR                                       0x0000041c
#define ICM_CONFIG3_REG_1_DEFAULT                                    0x00000000
#define ECM_CONFIG0_REG_0_ADDR                                       0x00000500
#define ECM_CONFIG0_REG_0_DEFAULT                                    0x0200003f
#define ECM_CONFIG0_REG_1_ADDR                                       0x00000504
#define ECM_CONFIG0_REG_1_DEFAULT                                    0x0200003f
#define ICM_ECM_DROP_COUNT_REG_0_ADDR                                0x00000508
#define ICM_ECM_DROP_COUNT_REG_0_DEFAULT                             0x00000000
#define ICM_ECM_DROP_COUNT_REG_1_ADDR                                0x0000050c
#define ICM_ECM_DROP_COUNT_REG_1_DEFAULT                             0x00000000
#define MAC_FIFO_STS_REG0_ADDR                                       0x00000510
#define MAC_FIFO_STS_REG0_DEFAULT                                    0x003f003f
#define MAC_INT_REG0_ADDR                                            0x00000514
#define MAC_INT_REG0_DEFAULT                                         0x00000000
#define MAC_INT_REG0MASK_ADDR                                        0x00000518
#define MAC_INT_REG1_ADDR                                            0x0000051c
#define MAC_INT_REG1_DEFAULT                                         0x00000000
#define MAC_INT_REG1MASK_ADDR                                        0x00000520
#define ICM_ECM_INT_REG_ADDR                                         0x00000524
#define ICM_ECM_INT_REG_DEFAULT                                      0x00000000
#define ICM_ECM_INT_REGMASK_ADDR                                     0x00000528
#define ECM_BAD_PKT_COUNT_REG_0_ADDR                                 0x0000052c
#define ECM_BAD_PKT_COUNT_REG_0_DEFAULT                              0x00000000
#define ECM_BAD_PKT_COUNT_REG_1_ADDR                                 0x00000530
#define ECM_BAD_PKT_COUNT_REG_1_DEFAULT                              0x00000000
#define RX_DV_GATE_REG_0_ADDR                                        0x000005fc
#define RX_DV_GATE_REG_0_DEFAULT                                     0x00000006
#define RX_DV_GATE_REG_1_ADDR                                        0x00000600
#define RX_DV_GATE_REG_1_DEFAULT                                     0x00000006

/*	Register cfg_mac_ipg_monitor_0	*/ 
/*	 Fields cfg_tx_ipg_monitor_cntr	 */
#define CFG_TX_IPG_MONITOR_CNTR0_WIDTH                                        8
#define CFG_TX_IPG_MONITOR_CNTR0_SHIFT                                       24
#define CFG_TX_IPG_MONITOR_CNTR0_MASK                                0xff000000
#define CFG_TX_IPG_MONITOR_CNTR0_RD(src)             (((src) & 0xff000000)>>24)
#define CFG_TX_IPG_MONITOR_CNTR0_WR(src)        (((u32)(src)<<24) & 0xff000000)
#define CFG_TX_IPG_MONITOR_CNTR0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_rx_ipg_monitor_cntr	 */
#define CFG_RX_IPG_MONITOR_CNTR0_WIDTH                                        8
#define CFG_RX_IPG_MONITOR_CNTR0_SHIFT                                       16
#define CFG_RX_IPG_MONITOR_CNTR0_MASK                                0x00ff0000
#define CFG_RX_IPG_MONITOR_CNTR0_RD(src)             (((src) & 0x00ff0000)>>16)
#define CFG_RX_IPG_MONITOR_CNTR0_WR(src)        (((u32)(src)<<16) & 0x00ff0000)
#define CFG_RX_IPG_MONITOR_CNTR0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_ipg_monitor_cmd	 */
#define CFG_IPG_MONITOR_CMD0_WIDTH                                            2
#define CFG_IPG_MONITOR_CMD0_SHIFT                                            1
#define CFG_IPG_MONITOR_CMD0_MASK                                    0x00000006
#define CFG_IPG_MONITOR_CMD0_RD(src)                  (((src) & 0x00000006)>>1)
#define CFG_IPG_MONITOR_CMD0_WR(src)             (((u32)(src)<<1) & 0x00000006)
#define CFG_IPG_MONITOR_CMD0_SET(dst,src) \
                       (((dst) & ~0x00000006) | (((u32)(src)<<1) & 0x00000006))
/*	 Fields cfg_ipg_monitor_en	 */
#define CFG_IPG_MONITOR_EN0_WIDTH                                             1
#define CFG_IPG_MONITOR_EN0_SHIFT                                             0
#define CFG_IPG_MONITOR_EN0_MASK                                     0x00000001
#define CFG_IPG_MONITOR_EN0_RD(src)                      (((src) & 0x00000001))
#define CFG_IPG_MONITOR_EN0_WR(src)                 (((u32)(src)) & 0x00000001)
#define CFG_IPG_MONITOR_EN0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cfg_mac_ipg_monitor_1	*/ 
/*	 Fields cfg_tx_ipg_monitor_cntr	 */
#define CFG_TX_IPG_MONITOR_CNTR1_WIDTH                                        8
#define CFG_TX_IPG_MONITOR_CNTR1_SHIFT                                       24
#define CFG_TX_IPG_MONITOR_CNTR1_MASK                                0xff000000
#define CFG_TX_IPG_MONITOR_CNTR1_RD(src)             (((src) & 0xff000000)>>24)
#define CFG_TX_IPG_MONITOR_CNTR1_WR(src)        (((u32)(src)<<24) & 0xff000000)
#define CFG_TX_IPG_MONITOR_CNTR1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_rx_ipg_monitor_cntr	 */
#define CFG_RX_IPG_MONITOR_CNTR1_WIDTH                                        8
#define CFG_RX_IPG_MONITOR_CNTR1_SHIFT                                       16
#define CFG_RX_IPG_MONITOR_CNTR1_MASK                                0x00ff0000
#define CFG_RX_IPG_MONITOR_CNTR1_RD(src)             (((src) & 0x00ff0000)>>16)
#define CFG_RX_IPG_MONITOR_CNTR1_WR(src)        (((u32)(src)<<16) & 0x00ff0000)
#define CFG_RX_IPG_MONITOR_CNTR1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_ipg_monitor_cmd	 */
#define CFG_IPG_MONITOR_CMD1_WIDTH                                            2
#define CFG_IPG_MONITOR_CMD1_SHIFT                                            1
#define CFG_IPG_MONITOR_CMD1_MASK                                    0x00000006
#define CFG_IPG_MONITOR_CMD1_RD(src)                  (((src) & 0x00000006)>>1)
#define CFG_IPG_MONITOR_CMD1_WR(src)             (((u32)(src)<<1) & 0x00000006)
#define CFG_IPG_MONITOR_CMD1_SET(dst,src) \
                       (((dst) & ~0x00000006) | (((u32)(src)<<1) & 0x00000006))
/*	 Fields cfg_ipg_monitor_en	 */
#define CFG_IPG_MONITOR_EN1_WIDTH                                             1
#define CFG_IPG_MONITOR_EN1_SHIFT                                             0
#define CFG_IPG_MONITOR_EN1_MASK                                     0x00000001
#define CFG_IPG_MONITOR_EN1_RD(src)                      (((src) & 0x00000001))
#define CFG_IPG_MONITOR_EN1_WR(src)                 (((u32)(src)) & 0x00000001)
#define CFG_IPG_MONITOR_EN1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register EEE_RX_Timer0_0	*/ 
/*	 Fields cfg_eee_rx_tq_timer	 */
#define CFG_EEE_RX_TQ_TIMER0_WIDTH                                           19
#define CFG_EEE_RX_TQ_TIMER0_SHIFT                                            0
#define CFG_EEE_RX_TQ_TIMER0_MASK                                    0x0007ffff
#define CFG_EEE_RX_TQ_TIMER0_RD(src)                     (((src) & 0x0007ffff))
#define CFG_EEE_RX_TQ_TIMER0_WR(src)                (((u32)(src)) & 0x0007ffff)
#define CFG_EEE_RX_TQ_TIMER0_SET(dst,src) \
                          (((dst) & ~0x0007ffff) | (((u32)(src)) & 0x0007ffff))

/*	Register EEE_RX_Timer1_0	*/ 
/*	 Fields cfg_eee_rx_tw_timer	 */
#define CFG_EEE_RX_TW_TIMER0_WIDTH                                           16
#define CFG_EEE_RX_TW_TIMER0_SHIFT                                            0
#define CFG_EEE_RX_TW_TIMER0_MASK                                    0x0000ffff
#define CFG_EEE_RX_TW_TIMER0_RD(src)                     (((src) & 0x0000ffff))
#define CFG_EEE_RX_TW_TIMER0_WR(src)                (((u32)(src)) & 0x0000ffff)
#define CFG_EEE_RX_TW_TIMER0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register EEE_RX_Timer2_0	*/ 
/*	 Fields cfg_eee_rx_wf_timer	 */
#define CFG_EEE_RX_WF_TIMER0_WIDTH                                           21
#define CFG_EEE_RX_WF_TIMER0_SHIFT                                            0
#define CFG_EEE_RX_WF_TIMER0_MASK                                    0x001fffff
#define CFG_EEE_RX_WF_TIMER0_RD(src)                     (((src) & 0x001fffff))
#define CFG_EEE_RX_WF_TIMER0_WR(src)                (((u32)(src)) & 0x001fffff)
#define CFG_EEE_RX_WF_TIMER0_SET(dst,src) \
                          (((dst) & ~0x001fffff) | (((u32)(src)) & 0x001fffff))

/*	Register EEE_RX_Timer0_1	*/ 
/*	 Fields cfg_eee_rx_tq_timer	 */
#define CFG_EEE_RX_TQ_TIMER1_WIDTH                                           19
#define CFG_EEE_RX_TQ_TIMER1_SHIFT                                            0
#define CFG_EEE_RX_TQ_TIMER1_MASK                                    0x0007ffff
#define CFG_EEE_RX_TQ_TIMER1_RD(src)                     (((src) & 0x0007ffff))
#define CFG_EEE_RX_TQ_TIMER1_WR(src)                (((u32)(src)) & 0x0007ffff)
#define CFG_EEE_RX_TQ_TIMER1_SET(dst,src) \
                          (((dst) & ~0x0007ffff) | (((u32)(src)) & 0x0007ffff))

/*	Register EEE_RX_Timer1_1	*/ 
/*	 Fields cfg_eee_rx_tw_timer	 */
#define CFG_EEE_RX_TW_TIMER1_WIDTH                                           16
#define CFG_EEE_RX_TW_TIMER1_SHIFT                                            0
#define CFG_EEE_RX_TW_TIMER1_MASK                                    0x0000ffff
#define CFG_EEE_RX_TW_TIMER1_RD(src)                     (((src) & 0x0000ffff))
#define CFG_EEE_RX_TW_TIMER1_WR(src)                (((u32)(src)) & 0x0000ffff)
#define CFG_EEE_RX_TW_TIMER1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register EEE_RX_Timer2_1	*/ 
/*	 Fields cfg_eee_rx_wf_timer	 */
#define CFG_EEE_RX_WF_TIMER1_WIDTH                                           21
#define CFG_EEE_RX_WF_TIMER1_SHIFT                                            0
#define CFG_EEE_RX_WF_TIMER1_MASK                                    0x001fffff
#define CFG_EEE_RX_WF_TIMER1_RD(src)                     (((src) & 0x001fffff))
#define CFG_EEE_RX_WF_TIMER1_WR(src)                (((u32)(src)) & 0x001fffff)
#define CFG_EEE_RX_WF_TIMER1_SET(dst,src) \
                          (((dst) & ~0x001fffff) | (((u32)(src)) & 0x001fffff))

/*	Register EEE_Reg_0	*/ 
/*	 Fields cfg_lpi_mode	 */
#define ENET_CFG_LPI_MODE0_WIDTH                                           1
#define ENET_CFG_LPI_MODE0_SHIFT                                          31
#define ENET_CFG_LPI_MODE0_MASK                                   0x80000000
#define ENET_CFG_LPI_MODE0_RD(src)                (((src) & 0x80000000)>>31)
#define ENET_CFG_LPI_MODE0_WR(src)           (((u32)(src)<<31) & 0x80000000)
#define ENET_CFG_LPI_MODE0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_lpi_clk_stoppable	 */
#define CFG_LPI_CLK_STOPPABLE0_WIDTH                                          1
#define CFG_LPI_CLK_STOPPABLE0_SHIFT                                         30
#define CFG_LPI_CLK_STOPPABLE0_MASK                                  0x40000000
#define CFG_LPI_CLK_STOPPABLE0_RD(src)               (((src) & 0x40000000)>>30)
#define CFG_LPI_CLK_STOPPABLE0_WR(src)          (((u32)(src)<<30) & 0x40000000)
#define CFG_LPI_CLK_STOPPABLE0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_sgmii_eee_en	 */
#define CFG_SGMII_EEE_EN0_WIDTH                                               1
#define CFG_SGMII_EEE_EN0_SHIFT                                              27
#define CFG_SGMII_EEE_EN0_MASK                                       0x08000000
#define CFG_SGMII_EEE_EN0_RD(src)                    (((src) & 0x08000000)>>27)
#define CFG_SGMII_EEE_EN0_WR(src)               (((u32)(src)<<27) & 0x08000000)
#define CFG_SGMII_EEE_EN0_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields cfg_lpi_clk_stop_after_ncycles	 */
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES0_WIDTH                                16
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES0_SHIFT                                 0
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES0_MASK                         0x0000ffff
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES0_RD(src)          (((src) & 0x0000ffff))
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES0_WR(src)     (((u32)(src)) & 0x0000ffff)
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register EEE_tw_timer_0	*/ 
/*	 Fields cfg_lpi_tw_timer	 */
#define CFG_LPI_TW_TIMER0_WIDTH                                              32
#define CFG_LPI_TW_TIMER0_SHIFT                                               0
#define CFG_LPI_TW_TIMER0_MASK                                       0xffffffff
#define CFG_LPI_TW_TIMER0_RD(src)                        (((src) & 0xffffffff))
#define CFG_LPI_TW_TIMER0_WR(src)                   (((u32)(src)) & 0xffffffff)
#define CFG_LPI_TW_TIMER0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register EEE_lpi_wait_patterns_0	*/ 
/*	 Fields cfg_lpi_wait_pattern	 */
#define CFG_LPI_WAIT_PATTERN0_WIDTH                                          10
#define CFG_LPI_WAIT_PATTERN0_SHIFT                                          10
#define CFG_LPI_WAIT_PATTERN0_MASK                                   0x000ffc00
#define CFG_LPI_WAIT_PATTERN0_RD(src)                (((src) & 0x000ffc00)>>10)
#define CFG_LPI_WAIT_PATTERN0_WR(src)           (((u32)(src)<<10) & 0x000ffc00)
#define CFG_LPI_WAIT_PATTERN0_SET(dst,src) \
                      (((dst) & ~0x000ffc00) | (((u32)(src)<<10) & 0x000ffc00))
/*	 Fields cfg_lpi_pattern	 */
#define CFG_LPI_PATTERN0_WIDTH                                               10
#define CFG_LPI_PATTERN0_SHIFT                                                0
#define CFG_LPI_PATTERN0_MASK                                        0x000003ff
#define CFG_LPI_PATTERN0_RD(src)                         (((src) & 0x000003ff))
#define CFG_LPI_PATTERN0_WR(src)                    (((u32)(src)) & 0x000003ff)
#define CFG_LPI_PATTERN0_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register EEE_Reg_1	*/ 
/*	 Fields cfg_lpi_mode	 */
#define ENET_CFG_LPI_MODE1_WIDTH                                           1
#define ENET_CFG_LPI_MODE1_SHIFT                                          31
#define ENET_CFG_LPI_MODE1_MASK                                   0x80000000
#define ENET_CFG_LPI_MODE1_RD(src)                (((src) & 0x80000000)>>31)
#define ENET_CFG_LPI_MODE1_WR(src)           (((u32)(src)<<31) & 0x80000000)
#define ENET_CFG_LPI_MODE1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cfg_lpi_clk_stoppable	 */
#define CFG_LPI_CLK_STOPPABLE1_WIDTH                                          1
#define CFG_LPI_CLK_STOPPABLE1_SHIFT                                         30
#define CFG_LPI_CLK_STOPPABLE1_MASK                                  0x40000000
#define CFG_LPI_CLK_STOPPABLE1_RD(src)               (((src) & 0x40000000)>>30)
#define CFG_LPI_CLK_STOPPABLE1_WR(src)          (((u32)(src)<<30) & 0x40000000)
#define CFG_LPI_CLK_STOPPABLE1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields cfg_sgmii_eee_en	 */
#define CFG_SGMII_EEE_EN1_WIDTH                                               1
#define CFG_SGMII_EEE_EN1_SHIFT                                              27
#define CFG_SGMII_EEE_EN1_MASK                                       0x08000000
#define CFG_SGMII_EEE_EN1_RD(src)                    (((src) & 0x08000000)>>27)
#define CFG_SGMII_EEE_EN1_WR(src)               (((u32)(src)<<27) & 0x08000000)
#define CFG_SGMII_EEE_EN1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields cfg_lpi_clk_stop_after_ncycles	 */
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES1_WIDTH                                16
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES1_SHIFT                                 0
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES1_MASK                         0x0000ffff
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES1_RD(src)          (((src) & 0x0000ffff))
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES1_WR(src)     (((u32)(src)) & 0x0000ffff)
#define CFG_LPI_CLK_STOP_AFTER_NCYCLES1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register EEE_tw_timer_1	*/ 
/*	 Fields cfg_lpi_tw_timer	 */
#define CFG_LPI_TW_TIMER1_WIDTH                                              32
#define CFG_LPI_TW_TIMER1_SHIFT                                               0
#define CFG_LPI_TW_TIMER1_MASK                                       0xffffffff
#define CFG_LPI_TW_TIMER1_RD(src)                        (((src) & 0xffffffff))
#define CFG_LPI_TW_TIMER1_WR(src)                   (((u32)(src)) & 0xffffffff)
#define CFG_LPI_TW_TIMER1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register EEE_lpi_wait_patterns_1	*/ 
/*	 Fields cfg_lpi_wait_pattern	 */
#define CFG_LPI_WAIT_PATTERN1_WIDTH                                          10
#define CFG_LPI_WAIT_PATTERN1_SHIFT                                          10
#define CFG_LPI_WAIT_PATTERN1_MASK                                   0x000ffc00
#define CFG_LPI_WAIT_PATTERN1_RD(src)                (((src) & 0x000ffc00)>>10)
#define CFG_LPI_WAIT_PATTERN1_WR(src)           (((u32)(src)<<10) & 0x000ffc00)
#define CFG_LPI_WAIT_PATTERN1_SET(dst,src) \
                      (((dst) & ~0x000ffc00) | (((u32)(src)<<10) & 0x000ffc00))
/*	 Fields cfg_lpi_pattern	 */
#define CFG_LPI_PATTERN1_WIDTH                                               10
#define CFG_LPI_PATTERN1_SHIFT                                                0
#define CFG_LPI_PATTERN1_MASK                                        0x000003ff
#define CFG_LPI_PATTERN1_RD(src)                         (((src) & 0x000003ff))
#define CFG_LPI_PATTERN1_WR(src)                    (((u32)(src)) & 0x000003ff)
#define CFG_LPI_PATTERN1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register EEE_Rx_lpi_detect_0	*/ 
/*	 Fields cfg_lpirx_debug	 */
#define CFG_LPIRX_DEBUG0_WIDTH                                                1
#define CFG_LPIRX_DEBUG0_SHIFT                                               10
#define CFG_LPIRX_DEBUG0_MASK                                        0x00000400
#define CFG_LPIRX_DEBUG0_RD(src)                     (((src) & 0x00000400)>>10)
#define CFG_LPIRX_DEBUG0_WR(src)                (((u32)(src)<<10) & 0x00000400)
#define CFG_LPIRX_DEBUG0_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_lpirx_detect_pattern	 */
#define CFG_LPIRX_DETECT_PATTERN0_WIDTH                                      10
#define CFG_LPIRX_DETECT_PATTERN0_SHIFT                                       0
#define CFG_LPIRX_DETECT_PATTERN0_MASK                               0x000003ff
#define CFG_LPIRX_DETECT_PATTERN0_RD(src)                (((src) & 0x000003ff))
#define CFG_LPIRX_DETECT_PATTERN0_WR(src)           (((u32)(src)) & 0x000003ff)
#define CFG_LPIRX_DETECT_PATTERN0_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register EEE_Rx_lpi_detect_1	*/ 
/*	 Fields cfg_lpirx_debug	 */
#define CFG_LPIRX_DEBUG1_WIDTH                                                1
#define CFG_LPIRX_DEBUG1_SHIFT                                               10
#define CFG_LPIRX_DEBUG1_MASK                                        0x00000400
#define CFG_LPIRX_DEBUG1_RD(src)                     (((src) & 0x00000400)>>10)
#define CFG_LPIRX_DEBUG1_WR(src)                (((u32)(src)<<10) & 0x00000400)
#define CFG_LPIRX_DEBUG1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_lpirx_detect_pattern	 */
#define CFG_LPIRX_DETECT_PATTERN1_WIDTH                                      10
#define CFG_LPIRX_DETECT_PATTERN1_SHIFT                                       0
#define CFG_LPIRX_DETECT_PATTERN1_MASK                               0x000003ff
#define CFG_LPIRX_DETECT_PATTERN1_RD(src)                (((src) & 0x000003ff))
#define CFG_LPIRX_DETECT_PATTERN1_WR(src)           (((u32)(src)) & 0x000003ff)
#define CFG_LPIRX_DETECT_PATTERN1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register EEE_Rx_lpi_detect_Intr_0	*/ 
/*	 Fields lpi_detect	 */
#define LPI_DETECT0_WIDTH                                                     1
#define LPI_DETECT0_SHIFT                                                     0
#define LPI_DETECT0_MASK                                             0x00000001
#define LPI_DETECT0_RD(src)                              (((src) & 0x00000001))
#define LPI_DETECT0_WR(src)                         (((u32)(src)) & 0x00000001)
#define LPI_DETECT0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register EEE_Rx_lpi_detect_Intr_0Mask	*/
/*    Mask Register Fields lpi_detectMask    */
#define LPI_DETECTMASK_WIDTH                                                  1
#define LPI_DETECTMASK_SHIFT                                                  0
#define LPI_DETECTMASK_MASK                                          0x00000001
#define LPI_DETECTMASK_RD(src)                           (((src) & 0x00000001))
#define LPI_DETECTMASK_WR(src)                      (((u32)(src)) & 0x00000001)
#define LPI_DETECTMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register EEE_Rx_lpi_detect_Intr_1	*/ 
/*	 Fields lpi_detect	 */
#define LPI_DETECT1_WIDTH                                                     1
#define LPI_DETECT1_SHIFT                                                     0
#define LPI_DETECT1_MASK                                             0x00000001
#define LPI_DETECT1_RD(src)                              (((src) & 0x00000001))
#define LPI_DETECT1_WR(src)                         (((u32)(src)) & 0x00000001)
#define LPI_DETECT1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register EEE_Rx_lpi_detect_Intr_1Mask	*/
/*    Mask Register Fields lpi_detectMask    */
#define LPI_DETECTMASK_F1_WIDTH                                               1
#define LPI_DETECTMASK_F1_SHIFT                                               0
#define LPI_DETECTMASK_F1_MASK                                       0x00000001
#define LPI_DETECTMASK_F1_RD(src)                        (((src) & 0x00000001))
#define LPI_DETECTMASK_F1_WR(src)                   (((u32)(src)) & 0x00000001)
#define LPI_DETECTMASK_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register csr_ecm_cfg_0	*/ 
/*	 Fields pause_xon_en	 */
#define PAUSE_XON_EN0_WIDTH                                                   1
#define PAUSE_XON_EN0_SHIFT                                                  30
#define PAUSE_XON_EN0_MASK                                           0x40000000
#define PAUSE_XON_EN0_RD(src)                        (((src) & 0x40000000)>>30)
#define PAUSE_XON_EN0_WR(src)                   (((u32)(src)<<30) & 0x40000000)
#define PAUSE_XON_EN0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields rsh_en	 */
#define RSH_EN0_WIDTH                                                         1
#define RSH_EN0_SHIFT                                                        29
#define RSH_EN0_MASK                                                 0x20000000
#define RSH_EN0_RD(src)                              (((src) & 0x20000000)>>29)
#define RSH_EN0_WR(src)                         (((u32)(src)<<29) & 0x20000000)
#define RSH_EN0_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields multi_dpf_autoctrl	 */
#define MULTI_DPF_AUTOCTRL0_WIDTH                                             1
#define MULTI_DPF_AUTOCTRL0_SHIFT                                            28
#define MULTI_DPF_AUTOCTRL0_MASK                                     0x10000000
#define MULTI_DPF_AUTOCTRL0_RD(src)                  (((src) & 0x10000000)>>28)
#define MULTI_DPF_AUTOCTRL0_WR(src)             (((u32)(src)<<28) & 0x10000000)
#define MULTI_DPF_AUTOCTRL0_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields swpf_req	 */
#define SWPF_REQ0_WIDTH                                                       1
#define SWPF_REQ0_SHIFT                                                      27
#define SWPF_REQ0_MASK                                               0x08000000
#define SWPF_REQ0_RD(src)                            (((src) & 0x08000000)>>27)
#define SWPF_REQ0_WR(src)                       (((u32)(src)<<27) & 0x08000000)
#define SWPF_REQ0_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields almstempty_thrshld	 */
#define ALMSTEMPTY_THRSHLD0_WIDTH                                             9
#define ALMSTEMPTY_THRSHLD0_SHIFT                                            18
#define ALMSTEMPTY_THRSHLD0_MASK                                     0x07fc0000
#define ALMSTEMPTY_THRSHLD0_RD(src)                  (((src) & 0x07fc0000)>>18)
#define ALMSTEMPTY_THRSHLD0_WR(src)             (((u32)(src)<<18) & 0x07fc0000)
#define ALMSTEMPTY_THRSHLD0_SET(dst,src) \
                      (((dst) & ~0x07fc0000) | (((u32)(src)<<18) & 0x07fc0000))
/*	 Fields almstfull_thrshld	 */
#define ALMSTFULL_THRSHLD0_WIDTH                                              9
#define ALMSTFULL_THRSHLD0_SHIFT                                              9
#define ALMSTFULL_THRSHLD0_MASK                                      0x0003fe00
#define ALMSTFULL_THRSHLD0_RD(src)                    (((src) & 0x0003fe00)>>9)
#define ALMSTFULL_THRSHLD0_WR(src)               (((u32)(src)<<9) & 0x0003fe00)
#define ALMSTFULL_THRSHLD0_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields datardy_thrshld	 */
#define DATARDY_THRSHLD0_WIDTH                                                9
#define DATARDY_THRSHLD0_SHIFT                                                0
#define DATARDY_THRSHLD0_MASK                                        0x000001ff
#define DATARDY_THRSHLD0_RD(src)                         (((src) & 0x000001ff))
#define DATARDY_THRSHLD0_WR(src)                    (((u32)(src)) & 0x000001ff)
#define DATARDY_THRSHLD0_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register csr_ecm_cfg_1	*/ 
/*	 Fields pause_xon_en	 */
#define PAUSE_XON_EN1_WIDTH                                                   1
#define PAUSE_XON_EN1_SHIFT                                                  30
#define PAUSE_XON_EN1_MASK                                           0x40000000
#define PAUSE_XON_EN1_RD(src)                        (((src) & 0x40000000)>>30)
#define PAUSE_XON_EN1_WR(src)                   (((u32)(src)<<30) & 0x40000000)
#define PAUSE_XON_EN1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields rsh_en	 */
#define RSH_EN1_WIDTH                                                         1
#define RSH_EN1_SHIFT                                                        29
#define RSH_EN1_MASK                                                 0x20000000
#define RSH_EN1_RD(src)                              (((src) & 0x20000000)>>29)
#define RSH_EN1_WR(src)                         (((u32)(src)<<29) & 0x20000000)
#define RSH_EN1_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields multi_dpf_autoctrl	 */
#define MULTI_DPF_AUTOCTRL1_WIDTH                                             1
#define MULTI_DPF_AUTOCTRL1_SHIFT                                            28
#define MULTI_DPF_AUTOCTRL1_MASK                                     0x10000000
#define MULTI_DPF_AUTOCTRL1_RD(src)                  (((src) & 0x10000000)>>28)
#define MULTI_DPF_AUTOCTRL1_WR(src)             (((u32)(src)<<28) & 0x10000000)
#define MULTI_DPF_AUTOCTRL1_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields swpf_req	 */
#define SWPF_REQ1_WIDTH                                                       1
#define SWPF_REQ1_SHIFT                                                      27
#define SWPF_REQ1_MASK                                               0x08000000
#define SWPF_REQ1_RD(src)                            (((src) & 0x08000000)>>27)
#define SWPF_REQ1_WR(src)                       (((u32)(src)<<27) & 0x08000000)
#define SWPF_REQ1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields almstempty_thrshld	 */
#define ALMSTEMPTY_THRSHLD1_WIDTH                                             9
#define ALMSTEMPTY_THRSHLD1_SHIFT                                            18
#define ALMSTEMPTY_THRSHLD1_MASK                                     0x07fc0000
#define ALMSTEMPTY_THRSHLD1_RD(src)                  (((src) & 0x07fc0000)>>18)
#define ALMSTEMPTY_THRSHLD1_WR(src)             (((u32)(src)<<18) & 0x07fc0000)
#define ALMSTEMPTY_THRSHLD1_SET(dst,src) \
                      (((dst) & ~0x07fc0000) | (((u32)(src)<<18) & 0x07fc0000))
/*	 Fields almstfull_thrshld	 */
#define ALMSTFULL_THRSHLD1_WIDTH                                              9
#define ALMSTFULL_THRSHLD1_SHIFT                                              9
#define ALMSTFULL_THRSHLD1_MASK                                      0x0003fe00
#define ALMSTFULL_THRSHLD1_RD(src)                    (((src) & 0x0003fe00)>>9)
#define ALMSTFULL_THRSHLD1_WR(src)               (((u32)(src)<<9) & 0x0003fe00)
#define ALMSTFULL_THRSHLD1_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields datardy_thrshld	 */
#define DATARDY_THRSHLD1_WIDTH                                                9
#define DATARDY_THRSHLD1_SHIFT                                                0
#define DATARDY_THRSHLD1_MASK                                        0x000001ff
#define DATARDY_THRSHLD1_RD(src)                         (((src) & 0x000001ff))
#define DATARDY_THRSHLD1_WR(src)                    (((u32)(src)) & 0x000001ff)
#define DATARDY_THRSHLD1_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register csr_ecm_swpf_0	*/ 
/*	 Fields param	 */
#define PARAM0_WIDTH                                                         16
#define PARAM0_SHIFT                                                         16
#define PARAM0_MASK                                                  0xffff0000
#define PARAM0_RD(src)                               (((src) & 0xffff0000)>>16)
#define PARAM0_WR(src)                          (((u32)(src)<<16) & 0xffff0000)
#define PARAM0_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields extparam	 */
#define EXTPARAM0_WIDTH                                                      16
#define EXTPARAM0_SHIFT                                                       0
#define EXTPARAM0_MASK                                               0x0000ffff
#define EXTPARAM0_RD(src)                                (((src) & 0x0000ffff))
#define EXTPARAM0_WR(src)                           (((u32)(src)) & 0x0000ffff)
#define EXTPARAM0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register csr_ecm_swpf_1	*/ 
/*	 Fields param	 */
#define PARAM1_WIDTH                                                         16
#define PARAM1_SHIFT                                                         16
#define PARAM1_MASK                                                  0xffff0000
#define PARAM1_RD(src)                               (((src) & 0xffff0000)>>16)
#define PARAM1_WR(src)                          (((u32)(src)<<16) & 0xffff0000)
#define PARAM1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields extparam	 */
#define EXTPARAM1_WIDTH                                                      16
#define EXTPARAM1_SHIFT                                                       0
#define EXTPARAM1_MASK                                               0x0000ffff
#define EXTPARAM1_RD(src)                                (((src) & 0x0000ffff))
#define EXTPARAM1_WR(src)                           (((u32)(src)) & 0x0000ffff)
#define EXTPARAM1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register csr_multi_dpf_0	*/ 
/*	 Fields param	 */
#define PARAM0_F1_WIDTH                                                      16
#define PARAM0_F1_SHIFT                                                      16
#define PARAM0_F1_MASK                                               0xffff0000
#define PARAM0_F1_RD(src)                            (((src) & 0xffff0000)>>16)
#define PARAM0_F1_WR(src)                       (((u32)(src)<<16) & 0xffff0000)
#define PARAM0_F1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields extparam	 */
#define EXTPARAM0_F1_WIDTH                                                   16
#define EXTPARAM0_F1_SHIFT                                                    0
#define EXTPARAM0_F1_MASK                                            0x0000ffff
#define EXTPARAM0_F1_RD(src)                             (((src) & 0x0000ffff))
#define EXTPARAM0_F1_WR(src)                        (((u32)(src)) & 0x0000ffff)
#define EXTPARAM0_F1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register csr_multi_dpf_1	*/ 
/*	 Fields param	 */
#define PARAM1_F1_WIDTH                                                      16
#define PARAM1_F1_SHIFT                                                      16
#define PARAM1_F1_MASK                                               0xffff0000
#define PARAM1_F1_RD(src)                            (((src) & 0xffff0000)>>16)
#define PARAM1_F1_WR(src)                       (((u32)(src)<<16) & 0xffff0000)
#define PARAM1_F1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields extparam	 */
#define EXTPARAM1_F1_WIDTH                                                   16
#define EXTPARAM1_F1_SHIFT                                                    0
#define EXTPARAM1_F1_MASK                                            0x0000ffff
#define EXTPARAM1_F1_RD(src)                             (((src) & 0x0000ffff))
#define EXTPARAM1_F1_WR(src)                        (((u32)(src)) & 0x0000ffff)
#define EXTPARAM1_F1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register csr_ecm_rsh_0	*/ 
/*	 Fields crd	 */
#define CRD0_WIDTH                                                           16
#define CRD0_SHIFT                                                           16
#define CRD0_MASK                                                    0xffff0000
#define CRD0_RD(src)                                 (((src) & 0xffff0000)>>16)
#define CRD0_WR(src)                            (((u32)(src)<<16) & 0xffff0000)
#define CRD0_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields per	 */
#define PER0_WIDTH                                                           16
#define PER0_SHIFT                                                            0
#define PER0_MASK                                                    0x0000ffff
#define PER0_RD(src)                                     (((src) & 0x0000ffff))
#define PER0_WR(src)                                (((u32)(src)) & 0x0000ffff)
#define PER0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register csr_ecm_rsh_1	*/ 
/*	 Fields crd	 */
#define CRD1_WIDTH                                                           16
#define CRD1_SHIFT                                                           16
#define CRD1_MASK                                                    0xffff0000
#define CRD1_RD(src)                                 (((src) & 0xffff0000)>>16)
#define CRD1_WR(src)                            (((u32)(src)<<16) & 0xffff0000)
#define CRD1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields per	 */
#define PER1_WIDTH                                                           16
#define PER1_SHIFT                                                            0
#define PER1_MASK                                                    0x0000ffff
#define PER1_RD(src)                                     (((src) & 0x0000ffff))
#define PER1_WR(src)                                (((u32)(src)) & 0x0000ffff)
#define PER1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config0_reg_0	*/ 
/*	 Fields cfg_pfc_tx_timer_status_select_reg	 */
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG0_WIDTH                             3
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG0_SHIFT                             1
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG0_MASK                     0x0000000e
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG0_RD(src)   (((src) & 0x0000000e)>>1)
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG0_WR(src) \
                                                 (((u32)(src)<<1) & 0x0000000e)
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG0_SET(dst,src) \
                       (((dst) & ~0x0000000e) | (((u32)(src)<<1) & 0x0000000e))
/*	 Fields cfg_pfc_en	 */
#define CFG_PFC_EN0_WIDTH                                                     1
#define CFG_PFC_EN0_SHIFT                                                     0
#define CFG_PFC_EN0_MASK                                             0x00000001
#define CFG_PFC_EN0_RD(src)                              (((src) & 0x00000001))
#define CFG_PFC_EN0_WR(src)                         (((u32)(src)) & 0x00000001)
#define CFG_PFC_EN0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register PFC_Config1_reg_0	*/ 
/*	 Fields cfg_pfc_ingr_q7_level_map_reg	 */
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG0_SHIFT                                 24
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG0_MASK                          0xff000000
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG0_RD(src)       (((src) & 0xff000000)>>24)
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG0_WR(src)  (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_ingr_q6_level_map_reg	 */
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG0_SHIFT                                 16
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG0_MASK                          0x00ff0000
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG0_RD(src)       (((src) & 0x00ff0000)>>16)
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG0_WR(src)  (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_ingr_q5_level_map_reg	 */
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG0_SHIFT                                  8
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG0_MASK                          0x0000ff00
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG0_RD(src)        (((src) & 0x0000ff00)>>8)
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG0_WR(src)   (((u32)(src)<<8) & 0x0000ff00)
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG0_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_pfc_ingr_q4_level_map_reg	 */
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG0_SHIFT                                  0
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG0_MASK                          0x000000ff
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG0_RD(src)           (((src) & 0x000000ff))
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG0_WR(src)      (((u32)(src)) & 0x000000ff)
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register PFC_Config2_reg_0	*/ 
/*	 Fields cfg_pfc_ingr_q3_level_map_reg	 */
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG0_SHIFT                                 24
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG0_MASK                          0xff000000
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG0_RD(src)       (((src) & 0xff000000)>>24)
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG0_WR(src)  (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_ingr_q2_level_map_reg	 */
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG0_SHIFT                                 16
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG0_MASK                          0x00ff0000
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG0_RD(src)       (((src) & 0x00ff0000)>>16)
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG0_WR(src)  (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_ingr_q1_level_map_reg	 */
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG0_SHIFT                                  8
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG0_MASK                          0x0000ff00
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG0_RD(src)        (((src) & 0x0000ff00)>>8)
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG0_WR(src)   (((u32)(src)<<8) & 0x0000ff00)
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG0_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_pfc_ingr_q0_level_map_reg	 */
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG0_WIDTH                                  8
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG0_SHIFT                                  0
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG0_MASK                          0x000000ff
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG0_RD(src)           (((src) & 0x000000ff))
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG0_WR(src)      (((u32)(src)) & 0x000000ff)
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register PFC_Config3_reg_0	*/ 
/*	 Fields cfg_pfc_ingr_free_pool3_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG0_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG0_SHIFT                         24
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG0_MASK                  0xff000000
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG0_RD(src) \
                                                    (((src) & 0xff000000)>>24)
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG0_WR(src) \
                                                (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_ingr_free_pool2_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG0_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG0_SHIFT                         16
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG0_MASK                  0x00ff0000
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG0_RD(src) \
                                                    (((src) & 0x00ff0000)>>16)
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG0_WR(src) \
                                                (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_ingr_free_pool1_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG0_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG0_SHIFT                          8
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG0_MASK                  0x0000ff00
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG0_RD(src) \
                                                     (((src) & 0x0000ff00)>>8)
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG0_WR(src) \
                                                 (((u32)(src)<<8) & 0x0000ff00)
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG0_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_pfc_ingr_free_pool0_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG0_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG0_SHIFT                          0
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG0_MASK                  0x000000ff
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG0_RD(src)   (((src) & 0x000000ff))
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG0_WR(src) \
                                                    (((u32)(src)) & 0x000000ff)
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register PFC_Config4_reg_0	*/ 
/*	 Fields cfg_pfc_our_addr_reg_lsb	 */
#define CFG_PFC_OUR_ADDR_REG_LSB0_WIDTH                                      32
#define CFG_PFC_OUR_ADDR_REG_LSB0_SHIFT                                       0
#define CFG_PFC_OUR_ADDR_REG_LSB0_MASK                               0xffffffff
#define CFG_PFC_OUR_ADDR_REG_LSB0_RD(src)                (((src) & 0xffffffff))
#define CFG_PFC_OUR_ADDR_REG_LSB0_WR(src)           (((u32)(src)) & 0xffffffff)
#define CFG_PFC_OUR_ADDR_REG_LSB0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config5_reg_0	*/ 
/*	 Fields cfg_pfc_our_addr_reg_msb	 */
#define CFG_PFC_OUR_ADDR_REG_MSB0_WIDTH                                      16
#define CFG_PFC_OUR_ADDR_REG_MSB0_SHIFT                                      16
#define CFG_PFC_OUR_ADDR_REG_MSB0_MASK                               0xffff0000
#define CFG_PFC_OUR_ADDR_REG_MSB0_RD(src)            (((src) & 0xffff0000)>>16)
#define CFG_PFC_OUR_ADDR_REG_MSB0_WR(src)       (((u32)(src)<<16) & 0xffff0000)
#define CFG_PFC_OUR_ADDR_REG_MSB0_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_pfc_their_addr_reg_msb	 */
#define CFG_PFC_THEIR_ADDR_REG_MSB0_WIDTH                                    16
#define CFG_PFC_THEIR_ADDR_REG_MSB0_SHIFT                                     0
#define CFG_PFC_THEIR_ADDR_REG_MSB0_MASK                             0x0000ffff
#define CFG_PFC_THEIR_ADDR_REG_MSB0_RD(src)              (((src) & 0x0000ffff))
#define CFG_PFC_THEIR_ADDR_REG_MSB0_WR(src)         (((u32)(src)) & 0x0000ffff)
#define CFG_PFC_THEIR_ADDR_REG_MSB0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config6_reg_0	*/ 
/*	 Fields cfg_pfc_their_addr_reg_lsb	 */
#define CFG_PFC_THEIR_ADDR_REG_LSB0_WIDTH                                    32
#define CFG_PFC_THEIR_ADDR_REG_LSB0_SHIFT                                     0
#define CFG_PFC_THEIR_ADDR_REG_LSB0_MASK                             0xffffffff
#define CFG_PFC_THEIR_ADDR_REG_LSB0_RD(src)              (((src) & 0xffffffff))
#define CFG_PFC_THEIR_ADDR_REG_LSB0_WR(src)         (((u32)(src)) & 0xffffffff)
#define CFG_PFC_THEIR_ADDR_REG_LSB0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config7_reg_0	*/ 
/*	 Fields cfg_pfc_type_reg	 */
#define CFG_PFC_TYPE_REG0_WIDTH                                              16
#define CFG_PFC_TYPE_REG0_SHIFT                                              16
#define CFG_PFC_TYPE_REG0_MASK                                       0xffff0000
#define CFG_PFC_TYPE_REG0_RD(src)                    (((src) & 0xffff0000)>>16)
#define CFG_PFC_TYPE_REG0_WR(src)               (((u32)(src)<<16) & 0xffff0000)
#define CFG_PFC_TYPE_REG0_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_pfc_opcode_reg	 */
#define CFG_PFC_OPCODE_REG0_WIDTH                                            16
#define CFG_PFC_OPCODE_REG0_SHIFT                                             0
#define CFG_PFC_OPCODE_REG0_MASK                                     0x0000ffff
#define CFG_PFC_OPCODE_REG0_RD(src)                      (((src) & 0x0000ffff))
#define CFG_PFC_OPCODE_REG0_WR(src)                 (((u32)(src)) & 0x0000ffff)
#define CFG_PFC_OPCODE_REG0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config8_reg_0	*/ 
/*	 Fields cfg_pfc_tx_level_sw_assert_reg	 */
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG0_WIDTH                                 8
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG0_SHIFT                                24
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG0_MASK                         0xff000000
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG0_RD(src)      (((src) & 0xff000000)>>24)
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG0_WR(src) \
                                                (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG0_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_tx_level_sw_mask_reg	 */
#define CFG_PFC_TX_LEVEL_SW_MASK_REG0_WIDTH                                   8
#define CFG_PFC_TX_LEVEL_SW_MASK_REG0_SHIFT                                  16
#define CFG_PFC_TX_LEVEL_SW_MASK_REG0_MASK                           0x00ff0000
#define CFG_PFC_TX_LEVEL_SW_MASK_REG0_RD(src)        (((src) & 0x00ff0000)>>16)
#define CFG_PFC_TX_LEVEL_SW_MASK_REG0_WR(src)   (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_TX_LEVEL_SW_MASK_REG0_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_timer_tx_value_reg	 */
#define CFG_PFC_TIMER_TX_VALUE_REG0_WIDTH                                    16
#define CFG_PFC_TIMER_TX_VALUE_REG0_SHIFT                                     0
#define CFG_PFC_TIMER_TX_VALUE_REG0_MASK                             0x0000ffff
#define CFG_PFC_TIMER_TX_VALUE_REG0_RD(src)              (((src) & 0x0000ffff))
#define CFG_PFC_TIMER_TX_VALUE_REG0_WR(src)         (((u32)(src)) & 0x0000ffff)
#define CFG_PFC_TIMER_TX_VALUE_REG0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config9_reg_0	*/ 
/*	 Fields cfg_pfc_tx_timer_status_reg	 */
#define CFG_PFC_TX_TIMER_STATUS_REG0_WIDTH                                   32
#define CFG_PFC_TX_TIMER_STATUS_REG0_SHIFT                                    0
#define CFG_PFC_TX_TIMER_STATUS_REG0_MASK                            0xffffffff
#define CFG_PFC_TX_TIMER_STATUS_REG0_RD(src)             (((src) & 0xffffffff))
#define CFG_PFC_TX_TIMER_STATUS_REG0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config10_reg_0	*/ 
/*	 Fields cfg_pfc_tx_status_reg	 */
#define CFG_PFC_TX_STATUS_REG0_WIDTH                                         32
#define CFG_PFC_TX_STATUS_REG0_SHIFT                                          0
#define CFG_PFC_TX_STATUS_REG0_MASK                                  0xffffffff
#define CFG_PFC_TX_STATUS_REG0_RD(src)                   (((src) & 0xffffffff))
#define CFG_PFC_TX_STATUS_REG0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config0_reg_1	*/ 
/*	 Fields cfg_pfc_tx_timer_status_select_reg	 */
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG1_WIDTH                             3
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG1_SHIFT                             1
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG1_MASK                     0x0000000e
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG1_RD(src)   (((src) & 0x0000000e)>>1)
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG1_WR(src) \
                                                 (((u32)(src)<<1) & 0x0000000e)
#define CFG_PFC_TX_TIMER_STATUS_SELECT_REG1_SET(dst,src) \
                       (((dst) & ~0x0000000e) | (((u32)(src)<<1) & 0x0000000e))
/*	 Fields cfg_pfc_en	 */
#define CFG_PFC_EN1_WIDTH                                                     1
#define CFG_PFC_EN1_SHIFT                                                     0
#define CFG_PFC_EN1_MASK                                             0x00000001
#define CFG_PFC_EN1_RD(src)                              (((src) & 0x00000001))
#define CFG_PFC_EN1_WR(src)                         (((u32)(src)) & 0x00000001)
#define CFG_PFC_EN1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register PFC_Config1_reg_1	*/ 
/*	 Fields cfg_pfc_ingr_q7_level_map_reg	 */
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG1_SHIFT                                 24
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG1_MASK                          0xff000000
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG1_RD(src)       (((src) & 0xff000000)>>24)
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG1_WR(src)  (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_INGR_Q7_LEVEL_MAP_REG1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_ingr_q6_level_map_reg	 */
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG1_SHIFT                                 16
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG1_MASK                          0x00ff0000
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG1_RD(src)       (((src) & 0x00ff0000)>>16)
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG1_WR(src)  (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_INGR_Q6_LEVEL_MAP_REG1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_ingr_q5_level_map_reg	 */
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG1_SHIFT                                  8
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG1_MASK                          0x0000ff00
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG1_RD(src)        (((src) & 0x0000ff00)>>8)
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG1_WR(src)   (((u32)(src)<<8) & 0x0000ff00)
#define CFG_PFC_INGR_Q5_LEVEL_MAP_REG1_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_pfc_ingr_q4_level_map_reg	 */
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG1_SHIFT                                  0
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG1_MASK                          0x000000ff
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG1_RD(src)           (((src) & 0x000000ff))
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG1_WR(src)      (((u32)(src)) & 0x000000ff)
#define CFG_PFC_INGR_Q4_LEVEL_MAP_REG1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register PFC_Config2_reg_1	*/ 
/*	 Fields cfg_pfc_ingr_q3_level_map_reg	 */
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG1_SHIFT                                 24
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG1_MASK                          0xff000000
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG1_RD(src)       (((src) & 0xff000000)>>24)
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG1_WR(src)  (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_INGR_Q3_LEVEL_MAP_REG1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_ingr_q2_level_map_reg	 */
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG1_SHIFT                                 16
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG1_MASK                          0x00ff0000
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG1_RD(src)       (((src) & 0x00ff0000)>>16)
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG1_WR(src)  (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_INGR_Q2_LEVEL_MAP_REG1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_ingr_q1_level_map_reg	 */
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG1_SHIFT                                  8
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG1_MASK                          0x0000ff00
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG1_RD(src)        (((src) & 0x0000ff00)>>8)
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG1_WR(src)   (((u32)(src)<<8) & 0x0000ff00)
#define CFG_PFC_INGR_Q1_LEVEL_MAP_REG1_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_pfc_ingr_q0_level_map_reg	 */
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG1_WIDTH                                  8
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG1_SHIFT                                  0
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG1_MASK                          0x000000ff
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG1_RD(src)           (((src) & 0x000000ff))
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG1_WR(src)      (((u32)(src)) & 0x000000ff)
#define CFG_PFC_INGR_Q0_LEVEL_MAP_REG1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register PFC_Config3_reg_1	*/ 
/*	 Fields cfg_pfc_ingr_free_pool3_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG1_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG1_SHIFT                         24
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG1_MASK                  0xff000000
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG1_RD(src) \
                                                    (((src) & 0xff000000)>>24)
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG1_WR(src) \
                                                (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_INGR_FREE_POOL3_LEVEL_MAP_REG1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_ingr_free_pool2_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG1_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG1_SHIFT                         16
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG1_MASK                  0x00ff0000
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG1_RD(src) \
                                                    (((src) & 0x00ff0000)>>16)
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG1_WR(src) \
                                                (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_INGR_FREE_POOL2_LEVEL_MAP_REG1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_ingr_free_pool1_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG1_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG1_SHIFT                          8
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG1_MASK                  0x0000ff00
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG1_RD(src) \
                                                     (((src) & 0x0000ff00)>>8)
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG1_WR(src) \
                                                 (((u32)(src)<<8) & 0x0000ff00)
#define CFG_PFC_INGR_FREE_POOL1_LEVEL_MAP_REG1_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields cfg_pfc_ingr_free_pool0_level_map_reg	 */
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG1_WIDTH                          8
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG1_SHIFT                          0
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG1_MASK                  0x000000ff
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG1_RD(src)   (((src) & 0x000000ff))
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG1_WR(src) \
                                                    (((u32)(src)) & 0x000000ff)
#define CFG_PFC_INGR_FREE_POOL0_LEVEL_MAP_REG1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register PFC_Config4_reg_1	*/ 
/*	 Fields cfg_pfc_our_addr_reg_lsb	 */
#define CFG_PFC_OUR_ADDR_REG_LSB1_WIDTH                                      32
#define CFG_PFC_OUR_ADDR_REG_LSB1_SHIFT                                       0
#define CFG_PFC_OUR_ADDR_REG_LSB1_MASK                               0xffffffff
#define CFG_PFC_OUR_ADDR_REG_LSB1_RD(src)                (((src) & 0xffffffff))
#define CFG_PFC_OUR_ADDR_REG_LSB1_WR(src)           (((u32)(src)) & 0xffffffff)
#define CFG_PFC_OUR_ADDR_REG_LSB1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config5_reg_1	*/ 
/*	 Fields cfg_pfc_our_addr_reg_msb	 */
#define CFG_PFC_OUR_ADDR_REG_MSB1_WIDTH                                      16
#define CFG_PFC_OUR_ADDR_REG_MSB1_SHIFT                                      16
#define CFG_PFC_OUR_ADDR_REG_MSB1_MASK                               0xffff0000
#define CFG_PFC_OUR_ADDR_REG_MSB1_RD(src)            (((src) & 0xffff0000)>>16)
#define CFG_PFC_OUR_ADDR_REG_MSB1_WR(src)       (((u32)(src)<<16) & 0xffff0000)
#define CFG_PFC_OUR_ADDR_REG_MSB1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_pfc_their_addr_reg_msb	 */
#define CFG_PFC_THEIR_ADDR_REG_MSB1_WIDTH                                    16
#define CFG_PFC_THEIR_ADDR_REG_MSB1_SHIFT                                     0
#define CFG_PFC_THEIR_ADDR_REG_MSB1_MASK                             0x0000ffff
#define CFG_PFC_THEIR_ADDR_REG_MSB1_RD(src)              (((src) & 0x0000ffff))
#define CFG_PFC_THEIR_ADDR_REG_MSB1_WR(src)         (((u32)(src)) & 0x0000ffff)
#define CFG_PFC_THEIR_ADDR_REG_MSB1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config6_reg_1	*/ 
/*	 Fields cfg_pfc_their_addr_reg_lsb	 */
#define CFG_PFC_THEIR_ADDR_REG_LSB1_WIDTH                                    32
#define CFG_PFC_THEIR_ADDR_REG_LSB1_SHIFT                                     0
#define CFG_PFC_THEIR_ADDR_REG_LSB1_MASK                             0xffffffff
#define CFG_PFC_THEIR_ADDR_REG_LSB1_RD(src)              (((src) & 0xffffffff))
#define CFG_PFC_THEIR_ADDR_REG_LSB1_WR(src)         (((u32)(src)) & 0xffffffff)
#define CFG_PFC_THEIR_ADDR_REG_LSB1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config7_reg_1	*/ 
/*	 Fields cfg_pfc_type_reg	 */
#define CFG_PFC_TYPE_REG1_WIDTH                                              16
#define CFG_PFC_TYPE_REG1_SHIFT                                              16
#define CFG_PFC_TYPE_REG1_MASK                                       0xffff0000
#define CFG_PFC_TYPE_REG1_RD(src)                    (((src) & 0xffff0000)>>16)
#define CFG_PFC_TYPE_REG1_WR(src)               (((u32)(src)<<16) & 0xffff0000)
#define CFG_PFC_TYPE_REG1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields cfg_pfc_opcode_reg	 */
#define CFG_PFC_OPCODE_REG1_WIDTH                                            16
#define CFG_PFC_OPCODE_REG1_SHIFT                                             0
#define CFG_PFC_OPCODE_REG1_MASK                                     0x0000ffff
#define CFG_PFC_OPCODE_REG1_RD(src)                      (((src) & 0x0000ffff))
#define CFG_PFC_OPCODE_REG1_WR(src)                 (((u32)(src)) & 0x0000ffff)
#define CFG_PFC_OPCODE_REG1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config8_reg_1	*/ 
/*	 Fields cfg_pfc_tx_level_sw_assert_reg	 */
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG1_WIDTH                                 8
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG1_SHIFT                                24
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG1_MASK                         0xff000000
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG1_RD(src)      (((src) & 0xff000000)>>24)
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG1_WR(src) \
                                                (((u32)(src)<<24) & 0xff000000)
#define CFG_PFC_TX_LEVEL_SW_ASSERT_REG1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields cfg_pfc_tx_level_sw_mask_reg	 */
#define CFG_PFC_TX_LEVEL_SW_MASK_REG1_WIDTH                                   8
#define CFG_PFC_TX_LEVEL_SW_MASK_REG1_SHIFT                                  16
#define CFG_PFC_TX_LEVEL_SW_MASK_REG1_MASK                           0x00ff0000
#define CFG_PFC_TX_LEVEL_SW_MASK_REG1_RD(src)        (((src) & 0x00ff0000)>>16)
#define CFG_PFC_TX_LEVEL_SW_MASK_REG1_WR(src)   (((u32)(src)<<16) & 0x00ff0000)
#define CFG_PFC_TX_LEVEL_SW_MASK_REG1_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields cfg_pfc_timer_tx_value_reg	 */
#define CFG_PFC_TIMER_TX_VALUE_REG1_WIDTH                                    16
#define CFG_PFC_TIMER_TX_VALUE_REG1_SHIFT                                     0
#define CFG_PFC_TIMER_TX_VALUE_REG1_MASK                             0x0000ffff
#define CFG_PFC_TIMER_TX_VALUE_REG1_RD(src)              (((src) & 0x0000ffff))
#define CFG_PFC_TIMER_TX_VALUE_REG1_WR(src)         (((u32)(src)) & 0x0000ffff)
#define CFG_PFC_TIMER_TX_VALUE_REG1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register PFC_Config9_reg_1	*/ 
/*	 Fields cfg_pfc_tx_timer_status_reg	 */
#define CFG_PFC_TX_TIMER_STATUS_REG1_WIDTH                                   32
#define CFG_PFC_TX_TIMER_STATUS_REG1_SHIFT                                    0
#define CFG_PFC_TX_TIMER_STATUS_REG1_MASK                            0xffffffff
#define CFG_PFC_TX_TIMER_STATUS_REG1_RD(src)             (((src) & 0xffffffff))
#define CFG_PFC_TX_TIMER_STATUS_REG1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register PFC_Config10_reg_1	*/ 
/*	 Fields cfg_pfc_tx_status_reg	 */
#define CFG_PFC_TX_STATUS_REG1_WIDTH                                         32
#define CFG_PFC_TX_STATUS_REG1_SHIFT                                          0
#define CFG_PFC_TX_STATUS_REG1_MASK                                  0xffffffff
#define CFG_PFC_TX_STATUS_REG1_RD(src)                   (((src) & 0xffffffff))
#define CFG_PFC_TX_STATUS_REG1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ICM_Config0_reg_0	*/ 
/*	 Fields cfg_macMode	 */
#define ENET_CFG_MACMODE0_WIDTH                                            2
#define ENET_CFG_MACMODE0_SHIFT                                           18
#define ENET_CFG_MACMODE0_MASK                                    0x000c0000
#define ENET_CFG_MACMODE0_RD(src)                 (((src) & 0x000c0000)>>18)
#define ENET_CFG_MACMODE0_WR(src)            (((u32)(src)<<18) & 0x000c0000)
#define ENET_CFG_MACMODE0_SET(dst,src) \
                      (((dst) & ~0x000c0000) | (((u32)(src)<<18) & 0x000c0000))
/*	 Fields cfg_ICM_almstFull_threshold	 */
#define CFG_ICM_ALMSTFULL_THRESHOLD0_WIDTH                                    9
#define CFG_ICM_ALMSTFULL_THRESHOLD0_SHIFT                                    9
#define CFG_ICM_ALMSTFULL_THRESHOLD0_MASK                            0x0003fe00
#define CFG_ICM_ALMSTFULL_THRESHOLD0_RD(src)          (((src) & 0x0003fe00)>>9)
#define CFG_ICM_ALMSTFULL_THRESHOLD0_WR(src)     (((u32)(src)<<9) & 0x0003fe00)
#define CFG_ICM_ALMSTFULL_THRESHOLD0_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_ICM_Full_threshold	 */
#define CFG_ICM_FULL_THRESHOLD0_WIDTH                                         9
#define CFG_ICM_FULL_THRESHOLD0_SHIFT                                         0
#define CFG_ICM_FULL_THRESHOLD0_MASK                                 0x000001ff
#define CFG_ICM_FULL_THRESHOLD0_RD(src)                  (((src) & 0x000001ff))
#define CFG_ICM_FULL_THRESHOLD0_WR(src)             (((u32)(src)) & 0x000001ff)
#define CFG_ICM_FULL_THRESHOLD0_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register ICM_Config1_reg_0	*/ 
/*	 Fields CfgRFifoFullThr_ctrlfifo	 */
#define CFGRFIFOFULLTHR_CTRLFIFO0_WIDTH                                       6
#define CFGRFIFOFULLTHR_CTRLFIFO0_SHIFT                                      24
#define CFGRFIFOFULLTHR_CTRLFIFO0_MASK                               0x3f000000
#define CFGRFIFOFULLTHR_CTRLFIFO0_RD(src)            (((src) & 0x3f000000)>>24)
#define CFGRFIFOFULLTHR_CTRLFIFO0_WR(src)       (((u32)(src)<<24) & 0x3f000000)
#define CFGRFIFOFULLTHR_CTRLFIFO0_SET(dst,src) \
                      (((dst) & ~0x3f000000) | (((u32)(src)<<24) & 0x3f000000))
/*	 Fields CfgWFifoFullThr_ctrlfifo	 */
#define CFGWFIFOFULLTHR_CTRLFIFO0_WIDTH                                       6
#define CFGWFIFOFULLTHR_CTRLFIFO0_SHIFT                                      18
#define CFGWFIFOFULLTHR_CTRLFIFO0_MASK                               0x00fc0000
#define CFGWFIFOFULLTHR_CTRLFIFO0_RD(src)            (((src) & 0x00fc0000)>>18)
#define CFGWFIFOFULLTHR_CTRLFIFO0_WR(src)       (((u32)(src)<<18) & 0x00fc0000)
#define CFGWFIFOFULLTHR_CTRLFIFO0_SET(dst,src) \
                      (((dst) & ~0x00fc0000) | (((u32)(src)<<18) & 0x00fc0000))
/*	 Fields CfgRFifoFullThr_datafifo	 */
#define CFGRFIFOFULLTHR_DATAFIFO0_WIDTH                                       9
#define CFGRFIFOFULLTHR_DATAFIFO0_SHIFT                                       9
#define CFGRFIFOFULLTHR_DATAFIFO0_MASK                               0x0003fe00
#define CFGRFIFOFULLTHR_DATAFIFO0_RD(src)             (((src) & 0x0003fe00)>>9)
#define CFGRFIFOFULLTHR_DATAFIFO0_WR(src)        (((u32)(src)<<9) & 0x0003fe00)
#define CFGRFIFOFULLTHR_DATAFIFO0_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields CfgWFifoFullThr_datafifo	 */
#define CFGWFIFOFULLTHR_DATAFIFO0_WIDTH                                       9
#define CFGWFIFOFULLTHR_DATAFIFO0_SHIFT                                       0
#define CFGWFIFOFULLTHR_DATAFIFO0_MASK                               0x000001ff
#define CFGWFIFOFULLTHR_DATAFIFO0_RD(src)                (((src) & 0x000001ff))
#define CFGWFIFOFULLTHR_DATAFIFO0_WR(src)           (((u32)(src)) & 0x000001ff)
#define CFGWFIFOFULLTHR_DATAFIFO0_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register ICM_Config0_reg_1	*/ 
/*	 Fields cfg_macMode	 */
#define ENET_CFG_MACMODE1_WIDTH                                            2
#define ENET_CFG_MACMODE1_SHIFT                                           18
#define ENET_CFG_MACMODE1_MASK                                    0x000c0000
#define ENET_CFG_MACMODE1_RD(src)                 (((src) & 0x000c0000)>>18)
#define ENET_CFG_MACMODE1_WR(src)            (((u32)(src)<<18) & 0x000c0000)
#define ENET_CFG_MACMODE1_SET(dst,src) \
                      (((dst) & ~0x000c0000) | (((u32)(src)<<18) & 0x000c0000))
/*	 Fields cfg_ICM_almstFull_threshold	 */
#define CFG_ICM_ALMSTFULL_THRESHOLD1_WIDTH                                    9
#define CFG_ICM_ALMSTFULL_THRESHOLD1_SHIFT                                    9
#define CFG_ICM_ALMSTFULL_THRESHOLD1_MASK                            0x0003fe00
#define CFG_ICM_ALMSTFULL_THRESHOLD1_RD(src)          (((src) & 0x0003fe00)>>9)
#define CFG_ICM_ALMSTFULL_THRESHOLD1_WR(src)     (((u32)(src)<<9) & 0x0003fe00)
#define CFG_ICM_ALMSTFULL_THRESHOLD1_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields cfg_ICM_Full_threshold	 */
#define CFG_ICM_FULL_THRESHOLD1_WIDTH                                         9
#define CFG_ICM_FULL_THRESHOLD1_SHIFT                                         0
#define CFG_ICM_FULL_THRESHOLD1_MASK                                 0x000001ff
#define CFG_ICM_FULL_THRESHOLD1_RD(src)                  (((src) & 0x000001ff))
#define CFG_ICM_FULL_THRESHOLD1_WR(src)             (((u32)(src)) & 0x000001ff)
#define CFG_ICM_FULL_THRESHOLD1_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register ICM_Config1_reg_1	*/ 
/*	 Fields CfgRFifoFullThr_ctrlfifo	 */
#define CFGRFIFOFULLTHR_CTRLFIFO1_WIDTH                                       6
#define CFGRFIFOFULLTHR_CTRLFIFO1_SHIFT                                      24
#define CFGRFIFOFULLTHR_CTRLFIFO1_MASK                               0x3f000000
#define CFGRFIFOFULLTHR_CTRLFIFO1_RD(src)            (((src) & 0x3f000000)>>24)
#define CFGRFIFOFULLTHR_CTRLFIFO1_WR(src)       (((u32)(src)<<24) & 0x3f000000)
#define CFGRFIFOFULLTHR_CTRLFIFO1_SET(dst,src) \
                      (((dst) & ~0x3f000000) | (((u32)(src)<<24) & 0x3f000000))
/*	 Fields CfgWFifoFullThr_ctrlfifo	 */
#define CFGWFIFOFULLTHR_CTRLFIFO1_WIDTH                                       6
#define CFGWFIFOFULLTHR_CTRLFIFO1_SHIFT                                      18
#define CFGWFIFOFULLTHR_CTRLFIFO1_MASK                               0x00fc0000
#define CFGWFIFOFULLTHR_CTRLFIFO1_RD(src)            (((src) & 0x00fc0000)>>18)
#define CFGWFIFOFULLTHR_CTRLFIFO1_WR(src)       (((u32)(src)<<18) & 0x00fc0000)
#define CFGWFIFOFULLTHR_CTRLFIFO1_SET(dst,src) \
                      (((dst) & ~0x00fc0000) | (((u32)(src)<<18) & 0x00fc0000))
/*	 Fields CfgRFifoFullThr_datafifo	 */
#define CFGRFIFOFULLTHR_DATAFIFO1_WIDTH                                       9
#define CFGRFIFOFULLTHR_DATAFIFO1_SHIFT                                       9
#define CFGRFIFOFULLTHR_DATAFIFO1_MASK                               0x0003fe00
#define CFGRFIFOFULLTHR_DATAFIFO1_RD(src)             (((src) & 0x0003fe00)>>9)
#define CFGRFIFOFULLTHR_DATAFIFO1_WR(src)        (((u32)(src)<<9) & 0x0003fe00)
#define CFGRFIFOFULLTHR_DATAFIFO1_SET(dst,src) \
                       (((dst) & ~0x0003fe00) | (((u32)(src)<<9) & 0x0003fe00))
/*	 Fields CfgWFifoFullThr_datafifo	 */
#define CFGWFIFOFULLTHR_DATAFIFO1_WIDTH                                       9
#define CFGWFIFOFULLTHR_DATAFIFO1_SHIFT                                       0
#define CFGWFIFOFULLTHR_DATAFIFO1_MASK                               0x000001ff
#define CFGWFIFOFULLTHR_DATAFIFO1_RD(src)                (((src) & 0x000001ff))
#define CFGWFIFOFULLTHR_DATAFIFO1_WR(src)           (((u32)(src)) & 0x000001ff)
#define CFGWFIFOFULLTHR_DATAFIFO1_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register ICM_Config2_reg_0	*/ 
/*	 Fields CfgWaitAsyncRdEn	 */
#define CFGWAITASYNCRDEN0_WIDTH                                               1
#define CFGWAITASYNCRDEN0_SHIFT                                              16
#define CFGWAITASYNCRDEN0_MASK                                       0x00010000
#define CFGWAITASYNCRDEN0_RD(src)                    (((src) & 0x00010000)>>16)
#define CFGWAITASYNCRDEN0_WR(src)               (((u32)(src)<<16) & 0x00010000)
#define CFGWAITASYNCRDEN0_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields CfgWaitAsyncRd	 */
#define CFGWAITASYNCRD0_WIDTH                                                16
#define CFGWAITASYNCRD0_SHIFT                                                 0
#define CFGWAITASYNCRD0_MASK                                         0x0000ffff
#define CFGWAITASYNCRD0_RD(src)                          (((src) & 0x0000ffff))
#define CFGWAITASYNCRD0_WR(src)                     (((u32)(src)) & 0x0000ffff)
#define CFGWAITASYNCRD0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register ICM_Config2_reg_1	*/ 
/*	 Fields CfgWaitAsyncRdEn	 */
#define CFGWAITASYNCRDEN1_WIDTH                                               1
#define CFGWAITASYNCRDEN1_SHIFT                                              16
#define CFGWAITASYNCRDEN1_MASK                                       0x00010000
#define CFGWAITASYNCRDEN1_RD(src)                    (((src) & 0x00010000)>>16)
#define CFGWAITASYNCRDEN1_WR(src)               (((u32)(src)<<16) & 0x00010000)
#define CFGWAITASYNCRDEN1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields CfgWaitAsyncRd	 */
#define CFGWAITASYNCRD1_WIDTH                                                16
#define CFGWAITASYNCRD1_SHIFT                                                 0
#define CFGWAITASYNCRD1_MASK                                         0x0000ffff
#define CFGWAITASYNCRD1_RD(src)                          (((src) & 0x0000ffff))
#define CFGWAITASYNCRD1_WR(src)                     (((u32)(src)) & 0x0000ffff)
#define CFGWAITASYNCRD1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register ICM_Config3_reg_0	*/ 
/*	 Fields cfg_crc_strip	 */
#define CFG_CRC_STRIP0_WIDTH                                                  1
#define CFG_CRC_STRIP0_SHIFT                                                  0
#define CFG_CRC_STRIP0_MASK                                          0x00000001
#define CFG_CRC_STRIP0_RD(src)                           (((src) & 0x00000001))
#define CFG_CRC_STRIP0_WR(src)                      (((u32)(src)) & 0x00000001)
#define CFG_CRC_STRIP0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ICM_Config3_reg_1	*/ 
/*	 Fields cfg_crc_strip	 */
#define CFG_CRC_STRIP1_WIDTH                                                  1
#define CFG_CRC_STRIP1_SHIFT                                                  0
#define CFG_CRC_STRIP1_MASK                                          0x00000001
#define CFG_CRC_STRIP1_RD(src)                           (((src) & 0x00000001))
#define CFG_CRC_STRIP1_WR(src)                      (((u32)(src)) & 0x00000001)
#define CFG_CRC_STRIP1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ECM_Config0_reg_0	*/ 
/*	 Fields ecm_req_hysteresis_en	 */
#define ECM_REQ_HYSTERESIS_EN0_WIDTH                                          1
#define ECM_REQ_HYSTERESIS_EN0_SHIFT                                         28
#define ECM_REQ_HYSTERESIS_EN0_MASK                                  0x10000000
#define ECM_REQ_HYSTERESIS_EN0_RD(src)               (((src) & 0x10000000)>>28)
#define ECM_REQ_HYSTERESIS_EN0_WR(src)          (((u32)(src)<<28) & 0x10000000)
#define ECM_REQ_HYSTERESIS_EN0_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields ecm_req_hysteresis_threshold	 */
#define ECM_REQ_HYSTERESIS_THRESHOLD0_WIDTH                                   6
#define ECM_REQ_HYSTERESIS_THRESHOLD0_SHIFT                                  20
#define ECM_REQ_HYSTERESIS_THRESHOLD0_MASK                           0x03f00000
#define ECM_REQ_HYSTERESIS_THRESHOLD0_RD(src)        (((src) & 0x03f00000)>>20)
#define ECM_REQ_HYSTERESIS_THRESHOLD0_WR(src)   (((u32)(src)<<20) & 0x03f00000)
#define ECM_REQ_HYSTERESIS_THRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x03f00000) | (((u32)(src)<<20) & 0x03f00000))
/*	 Fields CfgRFifoFullThr_ecm	 */
#define CFGRFIFOFULLTHR_ECM0_WIDTH                                           10
#define CFGRFIFOFULLTHR_ECM0_SHIFT                                           10
#define CFGRFIFOFULLTHR_ECM0_MASK                                    0x000ffc00
#define CFGRFIFOFULLTHR_ECM0_RD(src)                 (((src) & 0x000ffc00)>>10)
#define CFGRFIFOFULLTHR_ECM0_WR(src)            (((u32)(src)<<10) & 0x000ffc00)
#define CFGRFIFOFULLTHR_ECM0_SET(dst,src) \
                      (((dst) & ~0x000ffc00) | (((u32)(src)<<10) & 0x000ffc00))
/*	 Fields CfgWFifoFullThr_ecm	 */
#define CFGWFIFOFULLTHR_ECM0_WIDTH                                           10
#define CFGWFIFOFULLTHR_ECM0_SHIFT                                            0
#define CFGWFIFOFULLTHR_ECM0_MASK                                    0x000003ff
#define CFGWFIFOFULLTHR_ECM0_RD(src)                     (((src) & 0x000003ff))
#define CFGWFIFOFULLTHR_ECM0_WR(src)                (((u32)(src)) & 0x000003ff)
#define CFGWFIFOFULLTHR_ECM0_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register ECM_Config0_reg_1	*/ 
/*	 Fields ecm_req_hysteresis_en	 */
#define ECM_REQ_HYSTERESIS_EN1_WIDTH                                          1
#define ECM_REQ_HYSTERESIS_EN1_SHIFT                                         28
#define ECM_REQ_HYSTERESIS_EN1_MASK                                  0x10000000
#define ECM_REQ_HYSTERESIS_EN1_RD(src)               (((src) & 0x10000000)>>28)
#define ECM_REQ_HYSTERESIS_EN1_WR(src)          (((u32)(src)<<28) & 0x10000000)
#define ECM_REQ_HYSTERESIS_EN1_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields ecm_req_hysteresis_threshold	 */
#define ECM_REQ_HYSTERESIS_THRESHOLD1_WIDTH                                   6
#define ECM_REQ_HYSTERESIS_THRESHOLD1_SHIFT                                  20
#define ECM_REQ_HYSTERESIS_THRESHOLD1_MASK                           0x03f00000
#define ECM_REQ_HYSTERESIS_THRESHOLD1_RD(src)        (((src) & 0x03f00000)>>20)
#define ECM_REQ_HYSTERESIS_THRESHOLD1_WR(src)   (((u32)(src)<<20) & 0x03f00000)
#define ECM_REQ_HYSTERESIS_THRESHOLD1_SET(dst,src) \
                      (((dst) & ~0x03f00000) | (((u32)(src)<<20) & 0x03f00000))
/*	 Fields CfgRFifoFullThr_ecm	 */
#define CFGRFIFOFULLTHR_ECM1_WIDTH                                           10
#define CFGRFIFOFULLTHR_ECM1_SHIFT                                           10
#define CFGRFIFOFULLTHR_ECM1_MASK                                    0x000ffc00
#define CFGRFIFOFULLTHR_ECM1_RD(src)                 (((src) & 0x000ffc00)>>10)
#define CFGRFIFOFULLTHR_ECM1_WR(src)            (((u32)(src)<<10) & 0x000ffc00)
#define CFGRFIFOFULLTHR_ECM1_SET(dst,src) \
                      (((dst) & ~0x000ffc00) | (((u32)(src)<<10) & 0x000ffc00))
/*	 Fields CfgWFifoFullThr_ecm	 */
#define CFGWFIFOFULLTHR_ECM1_WIDTH                                           10
#define CFGWFIFOFULLTHR_ECM1_SHIFT                                            0
#define CFGWFIFOFULLTHR_ECM1_MASK                                    0x000003ff
#define CFGWFIFOFULLTHR_ECM1_RD(src)                     (((src) & 0x000003ff))
#define CFGWFIFOFULLTHR_ECM1_WR(src)                (((u32)(src)) & 0x000003ff)
#define CFGWFIFOFULLTHR_ECM1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register ICM_ECM_Drop_Count_reg_0	*/ 
/*	 Fields ICM_Drop_Count	 */
#define ICM_DROP_COUNT0_WIDTH                                                16
#define ICM_DROP_COUNT0_SHIFT                                                16
#define ICM_DROP_COUNT0_MASK                                         0xffff0000
#define ICM_DROP_COUNT0_RD(src)                      (((src) & 0xffff0000)>>16)
#define ICM_DROP_COUNT0_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields ECM_Drop_Count	 */
#define ECM_DROP_COUNT0_WIDTH                                                16
#define ECM_DROP_COUNT0_SHIFT                                                 0
#define ECM_DROP_COUNT0_MASK                                         0x0000ffff
#define ECM_DROP_COUNT0_RD(src)                          (((src) & 0x0000ffff))
#define ECM_DROP_COUNT0_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register ICM_ECM_Drop_Count_reg_1	*/ 
/*	 Fields ICM_Drop_Count	 */
#define ICM_DROP_COUNT1_WIDTH                                                16
#define ICM_DROP_COUNT1_SHIFT                                                16
#define ICM_DROP_COUNT1_MASK                                         0xffff0000
#define ICM_DROP_COUNT1_RD(src)                      (((src) & 0xffff0000)>>16)
#define ICM_DROP_COUNT1_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields ECM_Drop_Count	 */
#define ECM_DROP_COUNT1_WIDTH                                                16
#define ECM_DROP_COUNT1_SHIFT                                                 0
#define ECM_DROP_COUNT1_MASK                                         0x0000ffff
#define ECM_DROP_COUNT1_RD(src)                          (((src) & 0x0000ffff))
#define ECM_DROP_COUNT1_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register MAC_FIFO_STS_Reg0	*/ 
/*	 Fields ecm_sof_ctrl_fifo_empty_prt1	 */
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT10_WIDTH                                   1
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT10_SHIFT                                  21
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT10_MASK                           0x00200000
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT10_RD(src)        (((src) & 0x00200000)>>21)
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields ecm_eof_ctrl_fifo_empty_prt1	 */
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT10_WIDTH                                   1
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT10_SHIFT                                  20
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT10_MASK                           0x00100000
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT10_RD(src)        (((src) & 0x00100000)>>20)
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields icm_data_fifo_empty_prt1	 */
#define ICM_DATA_FIFO_EMPTY_PRT10_WIDTH                                       1
#define ICM_DATA_FIFO_EMPTY_PRT10_SHIFT                                      19
#define ICM_DATA_FIFO_EMPTY_PRT10_MASK                               0x00080000
#define ICM_DATA_FIFO_EMPTY_PRT10_RD(src)            (((src) & 0x00080000)>>19)
#define ICM_DATA_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields icm_ctrl_fifo_empty_prt1	 */
#define ICM_CTRL_FIFO_EMPTY_PRT10_WIDTH                                       1
#define ICM_CTRL_FIFO_EMPTY_PRT10_SHIFT                                      18
#define ICM_CTRL_FIFO_EMPTY_PRT10_MASK                               0x00040000
#define ICM_CTRL_FIFO_EMPTY_PRT10_RD(src)            (((src) & 0x00040000)>>18)
#define ICM_CTRL_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields ecm_data_fifo_empty_prt1	 */
#define ECM_DATA_FIFO_EMPTY_PRT10_WIDTH                                       1
#define ECM_DATA_FIFO_EMPTY_PRT10_SHIFT                                      17
#define ECM_DATA_FIFO_EMPTY_PRT10_MASK                               0x00020000
#define ECM_DATA_FIFO_EMPTY_PRT10_RD(src)            (((src) & 0x00020000)>>17)
#define ECM_DATA_FIFO_EMPTY_PRT10_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields macif_fifo_empty_rxprt1	 */
#define MACIF_FIFO_EMPTY_RXPRT10_F2_WIDTH                                     1
#define MACIF_FIFO_EMPTY_RXPRT10_F2_SHIFT                                    16
#define MACIF_FIFO_EMPTY_RXPRT10_F2_MASK                             0x00010000
#define MACIF_FIFO_EMPTY_RXPRT10_F2_RD(src)          (((src) & 0x00010000)>>16)
#define MACIF_FIFO_EMPTY_RXPRT10_F2_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields ecm_sof_ctrl_fifo_empty_prt0	 */
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT00_WIDTH                                   1
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT00_SHIFT                                   5
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT00_MASK                           0x00000020
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT00_RD(src)         (((src) & 0x00000020)>>5)
#define ECM_SOF_CTRL_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields ecm_eof_ctrl_fifo_empty_prt0	 */
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT00_WIDTH                                   1
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT00_SHIFT                                   4
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT00_MASK                           0x00000010
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT00_RD(src)         (((src) & 0x00000010)>>4)
#define ECM_EOF_CTRL_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields icm_data_fifo_empty_prt0	 */
#define ICM_DATA_FIFO_EMPTY_PRT00_WIDTH                                       1
#define ICM_DATA_FIFO_EMPTY_PRT00_SHIFT                                       3
#define ICM_DATA_FIFO_EMPTY_PRT00_MASK                               0x00000008
#define ICM_DATA_FIFO_EMPTY_PRT00_RD(src)             (((src) & 0x00000008)>>3)
#define ICM_DATA_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields icm_ctrl_fifo_empty_prt0	 */
#define ICM_CTRL_FIFO_EMPTY_PRT00_WIDTH                                       1
#define ICM_CTRL_FIFO_EMPTY_PRT00_SHIFT                                       2
#define ICM_CTRL_FIFO_EMPTY_PRT00_MASK                               0x00000004
#define ICM_CTRL_FIFO_EMPTY_PRT00_RD(src)             (((src) & 0x00000004)>>2)
#define ICM_CTRL_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields ecm_data_fifo_empty_prt0	 */
#define ECM_DATA_FIFO_EMPTY_PRT00_WIDTH                                       1
#define ECM_DATA_FIFO_EMPTY_PRT00_SHIFT                                       1
#define ECM_DATA_FIFO_EMPTY_PRT00_MASK                               0x00000002
#define ECM_DATA_FIFO_EMPTY_PRT00_RD(src)             (((src) & 0x00000002)>>1)
#define ECM_DATA_FIFO_EMPTY_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields macif_fifo_empty_rxprt0	 */
#define MACIF_FIFO_EMPTY_RXPRT00_F2_WIDTH                                     1
#define MACIF_FIFO_EMPTY_RXPRT00_F2_SHIFT                                     0
#define MACIF_FIFO_EMPTY_RXPRT00_F2_MASK                             0x00000001
#define MACIF_FIFO_EMPTY_RXPRT00_F2_RD(src)              (((src) & 0x00000001))
#define MACIF_FIFO_EMPTY_RXPRT00_F2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register MAC_Int_Reg0	*/ 
/*	 Fields ecm_sof_ctrl_fifo_underfl_intr_prt1	 */
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT10_WIDTH                            1
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT10_SHIFT                           28
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT10_MASK                    0x10000000
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT10_RD(src) \
                                                    (((src) & 0x10000000)>>28)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<28) & 0x10000000)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields ecm_sof_ctrl_fifo_overfl_intr_prt1	 */
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT10_WIDTH                             1
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT10_SHIFT                            27
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT10_MASK                     0x08000000
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT10_RD(src)  (((src) & 0x08000000)>>27)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<27) & 0x08000000)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields ecm_eof_ctrl_fifo_underfl_intr_prt1	 */
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT10_WIDTH                            1
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT10_SHIFT                           26
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT10_MASK                    0x04000000
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT10_RD(src) \
                                                    (((src) & 0x04000000)>>26)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<26) & 0x04000000)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields ecm_eof_ctrl_fifo_overfl_intr_prt1	 */
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT10_WIDTH                             1
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT10_SHIFT                            25
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT10_MASK                     0x02000000
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT10_RD(src)  (((src) & 0x02000000)>>25)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<25) & 0x02000000)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields icm_data_fifo_underfl_intr_prt1	 */
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT10_WIDTH                                1
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT10_SHIFT                               24
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT10_MASK                        0x01000000
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT10_RD(src)     (((src) & 0x01000000)>>24)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<24) & 0x01000000)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields icm_data_fifo_overfl_intr_prt1	 */
#define ICM_DATA_FIFO_OVERFL_INTR_PRT10_WIDTH                                 1
#define ICM_DATA_FIFO_OVERFL_INTR_PRT10_SHIFT                                23
#define ICM_DATA_FIFO_OVERFL_INTR_PRT10_MASK                         0x00800000
#define ICM_DATA_FIFO_OVERFL_INTR_PRT10_RD(src)      (((src) & 0x00800000)>>23)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<23) & 0x00800000)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields icm_ctrl_fifo_underfl_intr_prt1	 */
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT10_WIDTH                                1
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT10_SHIFT                               22
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT10_MASK                        0x00400000
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT10_RD(src)     (((src) & 0x00400000)>>22)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<22) & 0x00400000)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields icm_ctrl_fifo_overfl_intr_prt1	 */
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT10_WIDTH                                 1
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT10_SHIFT                                21
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT10_MASK                         0x00200000
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT10_RD(src)      (((src) & 0x00200000)>>21)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields ecm_data_fifo_undern_intr_prt1	 */
#define ECM_DATA_FIFO_UNDERN_INTR_PRT10_WIDTH                                 1
#define ECM_DATA_FIFO_UNDERN_INTR_PRT10_SHIFT                                20
#define ECM_DATA_FIFO_UNDERN_INTR_PRT10_MASK                         0x00100000
#define ECM_DATA_FIFO_UNDERN_INTR_PRT10_RD(src)      (((src) & 0x00100000)>>20)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields ecm_data_fifo_underfl_intr_prt1	 */
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT10_WIDTH                                1
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT10_SHIFT                               19
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT10_MASK                        0x00080000
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT10_RD(src)     (((src) & 0x00080000)>>19)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields ecm_data_fifo_overfl_intr_prt1	 */
#define ECM_DATA_FIFO_OVERFL_INTR_PRT10_WIDTH                                 1
#define ECM_DATA_FIFO_OVERFL_INTR_PRT10_SHIFT                                18
#define ECM_DATA_FIFO_OVERFL_INTR_PRT10_MASK                         0x00040000
#define ECM_DATA_FIFO_OVERFL_INTR_PRT10_RD(src)      (((src) & 0x00040000)>>18)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT10_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT10_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields macif_fifo_underfl_intr_rxprt1	 */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_F2_WIDTH                              1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_F2_SHIFT                             17
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_F2_MASK                      0x00020000
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_F2_RD(src)   (((src) & 0x00020000)>>17)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_F2_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT10_F2_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields macif_fifo_overfl_intr_rxprt1	 */
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_F2_WIDTH                               1
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_F2_SHIFT                              16
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_F2_MASK                       0x00010000
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_F2_RD(src)    (((src) & 0x00010000)>>16)
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_F2_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define MACIF_FIFO_OVERFL_INTR_RXPRT10_F2_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields ecm_sof_ctrl_fifo_underfl_intr_prt0	 */
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT00_WIDTH                            1
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT00_SHIFT                           12
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT00_MASK                    0x00001000
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT00_RD(src) \
                                                    (((src) & 0x00001000)>>12)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                (((u32)(src)<<12) & 0x00001000)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields ecm_sof_ctrl_fifo_overfl_intr_prt0	 */
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT00_WIDTH                             1
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT00_SHIFT                            11
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT00_MASK                     0x00000800
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT00_RD(src)  (((src) & 0x00000800)>>11)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT00_WR(src) \
                                                (((u32)(src)<<11) & 0x00000800)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields ecm_eof_ctrl_fifo_underfl_intr_prt0	 */
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT00_WIDTH                            1
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT00_SHIFT                           10
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT00_MASK                    0x00000400
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT00_RD(src) \
                                                    (((src) & 0x00000400)>>10)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields ecm_eof_ctrl_fifo_overfl_intr_prt0	 */
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT00_WIDTH                             1
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT00_SHIFT                             9
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT00_MASK                     0x00000200
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT00_RD(src)   (((src) & 0x00000200)>>9)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields icm_data_fifo_underfl_intr_prt0	 */
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT00_WIDTH                                1
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT00_SHIFT                                8
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT00_MASK                        0x00000100
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT00_RD(src)      (((src) & 0x00000100)>>8)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<8) & 0x00000100)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields icm_data_fifo_overfl_intr_prt0	 */
#define ICM_DATA_FIFO_OVERFL_INTR_PRT00_WIDTH                                 1
#define ICM_DATA_FIFO_OVERFL_INTR_PRT00_SHIFT                                 7
#define ICM_DATA_FIFO_OVERFL_INTR_PRT00_MASK                         0x00000080
#define ICM_DATA_FIFO_OVERFL_INTR_PRT00_RD(src)       (((src) & 0x00000080)>>7)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT00_WR(src)  (((u32)(src)<<7) & 0x00000080)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields icm_ctrl_fifo_underfl_intr_prt0	 */
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT00_WIDTH                                1
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT00_SHIFT                                6
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT00_MASK                        0x00000040
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT00_RD(src)      (((src) & 0x00000040)>>6)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields icm_ctrl_fifo_overfl_intr_prt0	 */
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT00_WIDTH                                 1
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT00_SHIFT                                 5
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT00_MASK                         0x00000020
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT00_RD(src)       (((src) & 0x00000020)>>5)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT00_WR(src)  (((u32)(src)<<5) & 0x00000020)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields ecm_data_fifo_undern_intr_prt0	 */
#define ECM_DATA_FIFO_UNDERN_INTR_PRT00_WIDTH                                 1
#define ECM_DATA_FIFO_UNDERN_INTR_PRT00_SHIFT                                 4
#define ECM_DATA_FIFO_UNDERN_INTR_PRT00_MASK                         0x00000010
#define ECM_DATA_FIFO_UNDERN_INTR_PRT00_RD(src)       (((src) & 0x00000010)>>4)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT00_WR(src)  (((u32)(src)<<4) & 0x00000010)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields ecm_data_fifo_underfl_intr_prt0	 */
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT00_WIDTH                                1
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT00_SHIFT                                3
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT00_MASK                        0x00000008
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT00_RD(src)      (((src) & 0x00000008)>>3)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT00_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields ecm_data_fifo_overfl_intr_prt0	 */
#define ECM_DATA_FIFO_OVERFL_INTR_PRT00_WIDTH                                 1
#define ECM_DATA_FIFO_OVERFL_INTR_PRT00_SHIFT                                 2
#define ECM_DATA_FIFO_OVERFL_INTR_PRT00_MASK                         0x00000004
#define ECM_DATA_FIFO_OVERFL_INTR_PRT00_RD(src)       (((src) & 0x00000004)>>2)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT00_WR(src)  (((u32)(src)<<2) & 0x00000004)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT00_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields macif_fifo_underfl_intr_rxprt0	 */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_F2_WIDTH                              1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_F2_SHIFT                              1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_F2_MASK                      0x00000002
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_F2_RD(src)    (((src) & 0x00000002)>>1)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_F2_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT00_F2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields macif_fifo_overfl_intr_rxprt0	 */
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_F2_WIDTH                               1
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_F2_SHIFT                               0
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_F2_MASK                       0x00000001
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_F2_RD(src)        (((src) & 0x00000001))
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_F2_WR(src)   (((u32)(src)) & 0x00000001)
#define MACIF_FIFO_OVERFL_INTR_RXPRT00_F2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register MAC_Int_Reg0Mask	*/
/*    Mask Register Fields ecm_sof_ctrl_fifo_underfl_intr_prt1Mask    */
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                         1
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                        28
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_MASK                 0x10000000
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x10000000)>>28)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<28) & 0x10000000)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields ecm_sof_ctrl_fifo_overfl_intr_prt1Mask    */
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                          1
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                         27
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_MASK                  0x08000000
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x08000000)>>27)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<27) & 0x08000000)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields ecm_eof_ctrl_fifo_underfl_intr_prt1Mask    */
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                         1
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                        26
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_MASK                 0x04000000
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x04000000)>>26)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<26) & 0x04000000)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields ecm_eof_ctrl_fifo_overfl_intr_prt1Mask    */
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                          1
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                         25
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_MASK                  0x02000000
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_RD(src) \
                                                    (((src) & 0x02000000)>>25)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<25) & 0x02000000)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields icm_data_fifo_underfl_intr_prt1Mask    */
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                             1
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                            24
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_MASK                     0x01000000
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)  (((src) & 0x01000000)>>24)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<24) & 0x01000000)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields icm_data_fifo_overfl_intr_prt1Mask    */
#define ICM_DATA_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                              1
#define ICM_DATA_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                             23
#define ICM_DATA_FIFO_OVERFL_INTR_PRT1MASK_MASK                      0x00800000
#define ICM_DATA_FIFO_OVERFL_INTR_PRT1MASK_RD(src)   (((src) & 0x00800000)>>23)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<23) & 0x00800000)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields icm_ctrl_fifo_underfl_intr_prt1Mask    */
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                             1
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                            22
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_MASK                     0x00400000
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)  (((src) & 0x00400000)>>22)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<22) & 0x00400000)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields icm_ctrl_fifo_overfl_intr_prt1Mask    */
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                              1
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                             21
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT1MASK_MASK                      0x00200000
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT1MASK_RD(src)   (((src) & 0x00200000)>>21)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<21) & 0x00200000)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields ecm_data_fifo_undern_intr_prt1Mask    */
#define ECM_DATA_FIFO_UNDERN_INTR_PRT1MASK_WIDTH                              1
#define ECM_DATA_FIFO_UNDERN_INTR_PRT1MASK_SHIFT                             20
#define ECM_DATA_FIFO_UNDERN_INTR_PRT1MASK_MASK                      0x00100000
#define ECM_DATA_FIFO_UNDERN_INTR_PRT1MASK_RD(src)   (((src) & 0x00100000)>>20)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<20) & 0x00100000)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields ecm_data_fifo_underfl_intr_prt1Mask    */
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_WIDTH                             1
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_SHIFT                            19
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_MASK                     0x00080000
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_RD(src)  (((src) & 0x00080000)>>19)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<19) & 0x00080000)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields ecm_data_fifo_overfl_intr_prt1Mask    */
#define ECM_DATA_FIFO_OVERFL_INTR_PRT1MASK_WIDTH                              1
#define ECM_DATA_FIFO_OVERFL_INTR_PRT1MASK_SHIFT                             18
#define ECM_DATA_FIFO_OVERFL_INTR_PRT1MASK_MASK                      0x00040000
#define ECM_DATA_FIFO_OVERFL_INTR_PRT1MASK_RD(src)   (((src) & 0x00040000)>>18)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT1MASK_WR(src) \
                                                (((u32)(src)<<18) & 0x00040000)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT1MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields macif_fifo_underfl_intr_rxprt1Mask    */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_F1_WIDTH                           1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_F1_SHIFT                          17
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_F1_MASK                   0x00020000
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_F1_RD(src) \
                                                    (((src) & 0x00020000)>>17)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_F1_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT1MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields macif_fifo_overfl_intr_rxprt1Mask    */
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_F1_WIDTH                            1
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_F1_SHIFT                           16
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_F1_MASK                    0x00010000
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_F1_RD(src) \
                                                    (((src) & 0x00010000)>>16)
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_F1_WR(src) \
                                                (((u32)(src)<<16) & 0x00010000)
#define MACIF_FIFO_OVERFL_INTR_RXPRT1MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields ecm_sof_ctrl_fifo_underfl_intr_prt0Mask    */
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                         1
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                        12
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_MASK                 0x00001000
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_RD(src) \
                                                    (((src) & 0x00001000)>>12)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                (((u32)(src)<<12) & 0x00001000)
#define ECM_SOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields ecm_sof_ctrl_fifo_overfl_intr_prt0Mask    */
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                          1
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                         11
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_MASK                  0x00000800
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_RD(src) \
                                                    (((src) & 0x00000800)>>11)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                (((u32)(src)<<11) & 0x00000800)
#define ECM_SOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields ecm_eof_ctrl_fifo_underfl_intr_prt0Mask    */
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                         1
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                        10
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_MASK                 0x00000400
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_RD(src) \
                                                    (((src) & 0x00000400)>>10)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define ECM_EOF_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields ecm_eof_ctrl_fifo_overfl_intr_prt0Mask    */
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                          1
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                          9
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_MASK                  0x00000200
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_RD(src) \
                                                     (((src) & 0x00000200)>>9)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define ECM_EOF_CTRL_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields icm_data_fifo_underfl_intr_prt0Mask    */
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                             1
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                             8
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_MASK                     0x00000100
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)   (((src) & 0x00000100)>>8)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<8) & 0x00000100)
#define ICM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields icm_data_fifo_overfl_intr_prt0Mask    */
#define ICM_DATA_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                              1
#define ICM_DATA_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                              7
#define ICM_DATA_FIFO_OVERFL_INTR_PRT0MASK_MASK                      0x00000080
#define ICM_DATA_FIFO_OVERFL_INTR_PRT0MASK_RD(src)    (((src) & 0x00000080)>>7)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<7) & 0x00000080)
#define ICM_DATA_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields icm_ctrl_fifo_underfl_intr_prt0Mask    */
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                             1
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                             6
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_MASK                     0x00000040
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)   (((src) & 0x00000040)>>6)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<6) & 0x00000040)
#define ICM_CTRL_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields icm_ctrl_fifo_overfl_intr_prt0Mask    */
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                              1
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                              5
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT0MASK_MASK                      0x00000020
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT0MASK_RD(src)    (((src) & 0x00000020)>>5)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<5) & 0x00000020)
#define ICM_CTRL_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields ecm_data_fifo_undern_intr_prt0Mask    */
#define ECM_DATA_FIFO_UNDERN_INTR_PRT0MASK_WIDTH                              1
#define ECM_DATA_FIFO_UNDERN_INTR_PRT0MASK_SHIFT                              4
#define ECM_DATA_FIFO_UNDERN_INTR_PRT0MASK_MASK                      0x00000010
#define ECM_DATA_FIFO_UNDERN_INTR_PRT0MASK_RD(src)    (((src) & 0x00000010)>>4)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<4) & 0x00000010)
#define ECM_DATA_FIFO_UNDERN_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields ecm_data_fifo_underfl_intr_prt0Mask    */
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_WIDTH                             1
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_SHIFT                             3
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_MASK                     0x00000008
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_RD(src)   (((src) & 0x00000008)>>3)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<3) & 0x00000008)
#define ECM_DATA_FIFO_UNDERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields ecm_data_fifo_overfl_intr_prt0Mask    */
#define ECM_DATA_FIFO_OVERFL_INTR_PRT0MASK_WIDTH                              1
#define ECM_DATA_FIFO_OVERFL_INTR_PRT0MASK_SHIFT                              2
#define ECM_DATA_FIFO_OVERFL_INTR_PRT0MASK_MASK                      0x00000004
#define ECM_DATA_FIFO_OVERFL_INTR_PRT0MASK_RD(src)    (((src) & 0x00000004)>>2)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT0MASK_WR(src) \
                                                 (((u32)(src)<<2) & 0x00000004)
#define ECM_DATA_FIFO_OVERFL_INTR_PRT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields macif_fifo_underfl_intr_rxprt0Mask    */
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_F1_WIDTH                           1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_F1_SHIFT                           1
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_F1_MASK                   0x00000002
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_F1_RD(src) \
                                                     (((src) & 0x00000002)>>1)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_F1_WR(src) \
                                                 (((u32)(src)<<1) & 0x00000002)
#define MACIF_FIFO_UNDERFL_INTR_RXPRT0MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields macif_fifo_overfl_intr_rxprt0Mask    */
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_F1_WIDTH                            1
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_F1_SHIFT                            0
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_F1_MASK                    0x00000001
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_F1_RD(src)     (((src) & 0x00000001))
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_F1_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define MACIF_FIFO_OVERFL_INTR_RXPRT0MASK_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register MAC_Int_Reg1	*/ 
/*	 Fields linkdown_port1	 */
#define LINKDOWN_PORT11_WIDTH                                                 1
#define LINKDOWN_PORT11_SHIFT                                                 3
#define LINKDOWN_PORT11_MASK                                         0x00000008
#define LINKDOWN_PORT11_RD(src)                       (((src) & 0x00000008)>>3)
#define LINKDOWN_PORT11_WR(src)                  (((u32)(src)<<3) & 0x00000008)
#define LINKDOWN_PORT11_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields carry_port1	 */
#define CARRY_PORT11_WIDTH                                                    1
#define CARRY_PORT11_SHIFT                                                    2
#define CARRY_PORT11_MASK                                            0x00000004
#define CARRY_PORT11_RD(src)                          (((src) & 0x00000004)>>2)
#define CARRY_PORT11_WR(src)                     (((u32)(src)<<2) & 0x00000004)
#define CARRY_PORT11_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields linkdown_port0	 */
#define LINKDOWN_PORT01_WIDTH                                                 1
#define LINKDOWN_PORT01_SHIFT                                                 1
#define LINKDOWN_PORT01_MASK                                         0x00000002
#define LINKDOWN_PORT01_RD(src)                       (((src) & 0x00000002)>>1)
#define LINKDOWN_PORT01_WR(src)                  (((u32)(src)<<1) & 0x00000002)
#define LINKDOWN_PORT01_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields carry_port0	 */
#define CARRY_PORT01_WIDTH                                                    1
#define CARRY_PORT01_SHIFT                                                    0
#define CARRY_PORT01_MASK                                            0x00000001
#define CARRY_PORT01_RD(src)                             (((src) & 0x00000001))
#define CARRY_PORT01_WR(src)                        (((u32)(src)) & 0x00000001)
#define CARRY_PORT01_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register MAC_Int_Reg1Mask	*/
/*    Mask Register Fields linkdown_port1Mask    */
#define LINKDOWN_PORT1MASK_WIDTH                                              1
#define LINKDOWN_PORT1MASK_SHIFT                                              3
#define LINKDOWN_PORT1MASK_MASK                                      0x00000008
#define LINKDOWN_PORT1MASK_RD(src)                    (((src) & 0x00000008)>>3)
#define LINKDOWN_PORT1MASK_WR(src)               (((u32)(src)<<3) & 0x00000008)
#define LINKDOWN_PORT1MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields carry_port1Mask    */
#define CARRY_PORT1MASK_WIDTH                                                 1
#define CARRY_PORT1MASK_SHIFT                                                 2
#define CARRY_PORT1MASK_MASK                                         0x00000004
#define CARRY_PORT1MASK_RD(src)                       (((src) & 0x00000004)>>2)
#define CARRY_PORT1MASK_WR(src)                  (((u32)(src)<<2) & 0x00000004)
#define CARRY_PORT1MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields linkdown_port0Mask    */
#define LINKDOWN_PORT0MASK_WIDTH                                              1
#define LINKDOWN_PORT0MASK_SHIFT                                              1
#define LINKDOWN_PORT0MASK_MASK                                      0x00000002
#define LINKDOWN_PORT0MASK_RD(src)                    (((src) & 0x00000002)>>1)
#define LINKDOWN_PORT0MASK_WR(src)               (((u32)(src)<<1) & 0x00000002)
#define LINKDOWN_PORT0MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields carry_port0Mask    */
#define CARRY_PORT0MASK_WIDTH                                                 1
#define CARRY_PORT0MASK_SHIFT                                                 0
#define CARRY_PORT0MASK_MASK                                         0x00000001
#define CARRY_PORT0MASK_RD(src)                          (((src) & 0x00000001))
#define CARRY_PORT0MASK_WR(src)                     (((u32)(src)) & 0x00000001)
#define CARRY_PORT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ICM_ECM_Int_reg	*/ 
/*	 Fields ecm_bad_pkt_intr_port1	 */
#define ECM_BAD_PKT_INTR_PORT1_WIDTH                                          1
#define ECM_BAD_PKT_INTR_PORT1_SHIFT                                         16
#define ECM_BAD_PKT_INTR_PORT1_MASK                                  0x00010000
#define ECM_BAD_PKT_INTR_PORT1_RD(src)               (((src) & 0x00010000)>>16)
#define ECM_BAD_PKT_INTR_PORT1_WR(src)          (((u32)(src)<<16) & 0x00010000)
#define ECM_BAD_PKT_INTR_PORT1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields ecm_bad_pkt_intr_port0	 */
#define ECM_BAD_PKT_INTR_PORT0_WIDTH                                          1
#define ECM_BAD_PKT_INTR_PORT0_SHIFT                                          0
#define ECM_BAD_PKT_INTR_PORT0_MASK                                  0x00000001
#define ECM_BAD_PKT_INTR_PORT0_RD(src)                   (((src) & 0x00000001))
#define ECM_BAD_PKT_INTR_PORT0_WR(src)              (((u32)(src)) & 0x00000001)
#define ECM_BAD_PKT_INTR_PORT0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ICM_ECM_Int_regMask	*/
/*    Mask Register Fields ecm_bad_pkt_intr_port1Mask    */
#define ECM_BAD_PKT_INTR_PORT1MASK_WIDTH                                      1
#define ECM_BAD_PKT_INTR_PORT1MASK_SHIFT                                     16
#define ECM_BAD_PKT_INTR_PORT1MASK_MASK                              0x00010000
#define ECM_BAD_PKT_INTR_PORT1MASK_RD(src)           (((src) & 0x00010000)>>16)
#define ECM_BAD_PKT_INTR_PORT1MASK_WR(src)      (((u32)(src)<<16) & 0x00010000)
#define ECM_BAD_PKT_INTR_PORT1MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields ecm_bad_pkt_intr_port0Mask    */
#define ECM_BAD_PKT_INTR_PORT0MASK_WIDTH                                      1
#define ECM_BAD_PKT_INTR_PORT0MASK_SHIFT                                      0
#define ECM_BAD_PKT_INTR_PORT0MASK_MASK                              0x00000001
#define ECM_BAD_PKT_INTR_PORT0MASK_RD(src)               (((src) & 0x00000001))
#define ECM_BAD_PKT_INTR_PORT0MASK_WR(src)          (((u32)(src)) & 0x00000001)
#define ECM_BAD_PKT_INTR_PORT0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ECM_Bad_Pkt_Count_reg_0	*/ 
/*	 Fields bad_pkt_cntr	 */
#define BAD_PKT_CNTR0_WIDTH                                                  32
#define BAD_PKT_CNTR0_SHIFT                                                   0
#define BAD_PKT_CNTR0_MASK                                           0xffffffff
#define BAD_PKT_CNTR0_RD(src)                            (((src) & 0xffffffff))
#define BAD_PKT_CNTR0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register ECM_Bad_Pkt_Count_reg_1	*/ 
/*	 Fields bad_pkt_cntr	 */
#define BAD_PKT_CNTR1_WIDTH                                                  32
#define BAD_PKT_CNTR1_SHIFT                                                   0
#define BAD_PKT_CNTR1_MASK                                           0xffffffff
#define BAD_PKT_CNTR1_RD(src)                            (((src) & 0xffffffff))
#define BAD_PKT_CNTR1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register RX_DV_Gate_reg_0	*/ 
/*	 Fields tx_dv_gate_en	 */
#define TX_DV_GATE_EN0_WIDTH                                                  1
#define TX_DV_GATE_EN0_SHIFT                                                  2
#define TX_DV_GATE_EN0_MASK                                          0x00000004
#define TX_DV_GATE_EN0_RD(src)                        (((src) & 0x00000004)>>2)
#define TX_DV_GATE_EN0_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define TX_DV_GATE_EN0_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rx_dv_gate_en	 */
#define RX_DV_GATE_EN0_WIDTH                                                  1
#define RX_DV_GATE_EN0_SHIFT                                                  1
#define RX_DV_GATE_EN0_MASK                                          0x00000002
#define RX_DV_GATE_EN0_RD(src)                        (((src) & 0x00000002)>>1)
#define RX_DV_GATE_EN0_WR(src)                   (((u32)(src)<<1) & 0x00000002)
#define RX_DV_GATE_EN0_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields resume_rx	 */
#define RESUME_RX0_WIDTH                                                      1
#define RESUME_RX0_SHIFT                                                      0
#define RESUME_RX0_MASK                                              0x00000001
#define RESUME_RX0_RD(src)                               (((src) & 0x00000001))
#define RESUME_RX0_WR(src)                          (((u32)(src)) & 0x00000001)
#define RESUME_RX0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register RX_DV_Gate_reg_1	*/ 
/*	 Fields tx_dv_gate_en	 */
#define TX_DV_GATE_EN1_WIDTH                                                  1
#define TX_DV_GATE_EN1_SHIFT                                                  2
#define TX_DV_GATE_EN1_MASK                                          0x00000004
#define TX_DV_GATE_EN1_RD(src)                        (((src) & 0x00000004)>>2)
#define TX_DV_GATE_EN1_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define TX_DV_GATE_EN1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rx_dv_gate_en	 */
#define RX_DV_GATE_EN1_WIDTH                                                  1
#define RX_DV_GATE_EN1_SHIFT                                                  1
#define RX_DV_GATE_EN1_MASK                                          0x00000002
#define RX_DV_GATE_EN1_RD(src)                        (((src) & 0x00000002)>>1)
#define RX_DV_GATE_EN1_WR(src)                   (((u32)(src)<<1) & 0x00000002)
#define RX_DV_GATE_EN1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields resume_rx	 */
#define RESUME_RX1_WIDTH                                                      1
#define RESUME_RX1_SHIFT                                                      0
#define RESUME_RX1_MASK                                              0x00000001
#define RESUME_RX1_RD(src)                               (((src) & 0x00000001))
#define RESUME_RX1_WR(src)                          (((u32)(src)) & 0x00000001)
#define RESUME_RX1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define CLE_2INLINE_CSR_BASE_ADDR			0x01f216000ULL

/*    Address CLE_2INLINE_CSR  Registers */
#define ENET_CLE_BID_ADDR                                         0x00000000
#define ENET_CLE_BID_DEFAULT                                      0x000005c0
#define ENET_INDADDR_ADDR                                         0x00000004
#define ENET_INDADDR_DEFAULT                                      0x00000000
#define ENET_INDCMD_ADDR                                          0x00000008
#define ENET_INDCMD_DEFAULT                                       0x00000000
#define ENET_INDCMD_STATUS_ADDR                                   0x0000000c
#define ENET_INDCMD_STATUS_DEFAULT                                0x00000000
#define ENET_DATA_RAM0_ADDR                                       0x00000010
#define ENET_DATA_RAM0_DEFAULT                                    0x00000000
#define ENET_DATA_RAM1_ADDR                                       0x00000014
#define ENET_DATA_RAM1_DEFAULT                                    0x00000000
#define ENET_DATA_RAM2_ADDR                                       0x00000018
#define ENET_DATA_RAM2_DEFAULT                                    0x00000000
#define ENET_DATA_RAM3_ADDR                                       0x0000001c
#define ENET_DATA_RAM3_DEFAULT                                    0x00000000
#define ENET_DATA_RAM4_ADDR                                       0x00000020
#define ENET_DATA_RAM4_DEFAULT                                    0x00000000
#define ENET_DATA_RAM5_ADDR                                       0x00000024
#define ENET_DATA_RAM5_DEFAULT                                    0x00000000
#define ENET_DATA_RAM6_ADDR                                       0x00000028
#define ENET_DATA_RAM6_DEFAULT                                    0x00000000
#define ENET_DATA_RAM7_ADDR                                       0x0000002c
#define ENET_DATA_RAM7_DEFAULT                                    0x00000000
#define ENET_DATA_RAM8_ADDR                                       0x00000030
#define ENET_DATA_RAM8_DEFAULT                                    0x00000000
#define ENET_DATA_RAM9_ADDR                                       0x00000034
#define ENET_DATA_RAM9_DEFAULT                                    0x00000000
#define ENET_DATA_RAM10_ADDR                                      0x00000038
#define ENET_DATA_RAM10_DEFAULT                                   0x00000000
#define ENET_DATA_RAM11_ADDR                                      0x0000003c
#define ENET_DATA_RAM11_DEFAULT                                   0x00000000
#define ENET_DATA_RAM12_ADDR                                      0x00000040
#define ENET_DATA_RAM12_DEFAULT                                   0x00000000
#define ENET_DATA_RAM13_ADDR                                      0x00000044
#define ENET_DATA_RAM13_DEFAULT                                   0x00000000
#define ENET_DATA_RAM14_ADDR                                      0x00000048
#define ENET_DATA_RAM14_DEFAULT                                   0x00000000
#define ENET_DATA_RAM15_ADDR                                      0x0000004c
#define ENET_DATA_RAM15_DEFAULT                                   0x00000000
#define ENET_DATA_RAM16_ADDR                                      0x00000050
#define ENET_DATA_RAM16_DEFAULT                                   0x00000000
#define ENET_AVL_CONFIG_ADDR                                      0x00000060
#define ENET_AVL_CONFIG_DEFAULT                                   0x03ffd7fc
#define ENET_AVL_STATUS_ADDR                                      0x00000064
#define ENET_AVL_STATUS_DEFAULT                                   0x00000000
#define ENET_CLE_INTERRUPT_ADDR                                   0x00000080
#define ENET_CLE_INTERRUPT_DEFAULT                                0x00000000
#define ENET_CLE_INTERRUPTMASK_ADDR                               0x00000084
#define ENET_AVL_SEARCH_INT_ADDR                                  0x00000088
#define ENET_AVL_SEARCH_INT_DEFAULT                               0x00000000
#define ENET_AVL_SEARCH_INTMASK_ADDR                              0x0000008c
#define ENET_SW_INT_ADDR                                          0x00000090
#define ENET_SW_INT_DEFAULT                                       0x00000000
#define ENET_PT_RAM0_CTRL_ADDR                                    0x000000a0
#define ENET_PT_RAM0_CTRL_DEFAULT                                 0x00000000
#define ENET_PT_RAM1_CTRL_ADDR                                    0x000000a4
#define ENET_PT_RAM1_CTRL_DEFAULT                                 0x00000000
#define ENET_PT_RAM2_CTRL_ADDR                                    0x000000a8
#define ENET_PT_RAM2_CTRL_DEFAULT                                 0x00000000
#define ENET_PT_RAM3_CTRL_ADDR                                    0x000000ac
#define ENET_PT_RAM3_CTRL_DEFAULT                                 0x00000000
#define ENET_AVL_RAM0_CTRL_ADDR                                   0x000000b0
#define ENET_AVL_RAM0_CTRL_DEFAULT                                0x00000000
#define ENET_AVL_RAM1_CTRL_ADDR                                   0x000000b4
#define ENET_AVL_RAM1_CTRL_DEFAULT                                0x00000000
#define ENET_AVL_RAM2_CTRL_ADDR                                   0x000000b8
#define ENET_AVL_RAM2_CTRL_DEFAULT                                0x00000000
#define ENET_AVL_RAM3_CTRL_ADDR                                   0x000000bc
#define ENET_AVL_RAM3_CTRL_DEFAULT                                0x00000000
#define ENET_DB_RAM_CTRL_ADDR                                     0x000000c0
#define ENET_DB_RAM_CTRL_DEFAULT                                  0x00000000
#define ENET_DS_CTL_ADDR                                          0x000000dc
#define ENET_DS_CTL_DEFAULT                                       0x00040a0b
#define ENET_PTRAM_ERR_DIAGNOSTIC_ADDR                            0x000000e0
#define ENET_PTRAM_ERR_DIAGNOSTIC_DEFAULT                         0x00000000
#define ENET_AVLRAM_ERR_DIAGNOSTIC_ADDR                           0x000000e4
#define ENET_AVLRAM_ERR_DIAGNOSTIC_DEFAULT                        0x00000000
#define ENET_DBRAM_ERR_DIAGNOSTIC_ADDR                            0x000000e8
#define ENET_DBRAM_ERR_DIAGNOSTIC_DEFAULT                         0x00000000
#define ENET_SNPTR0_ADDR                                          0x00000100
#define ENET_SNPTR0_DEFAULT                                       0x00000000
#define ENET_SPPTR0_ADDR                                          0x00000104
#define ENET_SPPTR0_DEFAULT                                       0x00000000
#define ENET_DFCLSRESDBPTR0_ADDR                                  0x00000108
#define ENET_DFCLSRESDBPTR0_DEFAULT                               0x00001c00
#define ENET_DFCLSRESDB0_0_ADDR                                   0x0000010c
#define ENET_DFCLSRESDB0_0_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB0_1_ADDR                                   0x00000110
#define ENET_DFCLSRESDB0_1_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB0_2_ADDR                                   0x00000114
#define ENET_DFCLSRESDB0_2_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB0_3_ADDR                                   0x00000118
#define ENET_DFCLSRESDB0_3_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB0_4_ADDR                                   0x0000011c
#define ENET_DFCLSRESDB0_4_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB0_5_ADDR                                   0x00000120
#define ENET_DFCLSRESDB0_5_DEFAULT                                0x00000000
#define ENET_PARSER_CTL0_ADDR                                     0x00000130
#define ENET_PARSER_CTL0_DEFAULT                                  0x00000000
#define ENET_TMAXHOP0_ADDR                                        0x00000134
#define ENET_TMAXHOP0_DEFAULT                                     0x00000040
#define ENET_PORTNUM0_ADDR                                        0x00000138
#define ENET_PORTNUM0_DEFAULT                                     0x00000000
#define ENET_RSS_CTRL0_ADDR                                       0x0000013c
#define ENET_RSS_CTRL0_DEFAULT                                    0x00000000
#define ENET_PARSER_STATUS0_ADDR                                  0x00000170
#define ENET_PARSER_STATUS0_DEFAULT                               0x00000000
#define ENET_PARSER_STATUS0MASK_ADDR                              0x00000174
#define ENET_SNPTR_CHANGE_STATUS0_ADDR                            0x00000178
#define ENET_SNPTR_CHANGE_STATUS0_DEFAULT                         0x00000000
#define ENET_ITABLE0_ERR_DIAGNOSTIC_ADDR                          0x0000018c
#define ENET_ITABLE0_ERR_DIAGNOSTIC_DEFAULT                       0x00000000
#define ENET_PKTRAM0_ERR_DIAGNOSTIC_ADDR                          0x00000190
#define ENET_PKTRAM0_ERR_DIAGNOSTIC_DEFAULT                       0x00000000
#define ENET_ITABLE0_CTRL_ADDR                                    0x00000194
#define ENET_ITABLE0_CTRL_DEFAULT                                 0x00000000
#define ENET_LSTNVST0_ADDR                                        0x000001a0
#define ENET_LSTNVST0_DEFAULT                                     0x00000000
#define ENET_LSTTRCNVST0_0_ADDR                                   0x000001a4
#define ENET_LSTTRCNVST0_0_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_1_ADDR                                   0x000001a8
#define ENET_LSTTRCNVST0_1_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_2_ADDR                                   0x000001ac
#define ENET_LSTTRCNVST0_2_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_3_ADDR                                   0x000001b0
#define ENET_LSTTRCNVST0_3_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_4_ADDR                                   0x000001b4
#define ENET_LSTTRCNVST0_4_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_5_ADDR                                   0x000001b8
#define ENET_LSTTRCNVST0_5_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_6_ADDR                                   0x000001bc
#define ENET_LSTTRCNVST0_6_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_7_ADDR                                   0x000001c0
#define ENET_LSTTRCNVST0_7_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_8_ADDR                                   0x000001c4
#define ENET_LSTTRCNVST0_8_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_9_ADDR                                   0x000001c8
#define ENET_LSTTRCNVST0_9_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST0_10_ADDR                                  0x000001cc
#define ENET_LSTTRCNVST0_10_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST0_11_ADDR                                  0x000001d0
#define ENET_LSTTRCNVST0_11_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST0_12_ADDR                                  0x000001d4
#define ENET_LSTTRCNVST0_12_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST0_13_ADDR                                  0x000001d8
#define ENET_LSTTRCNVST0_13_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST0_14_ADDR                                  0x000001dc
#define ENET_LSTTRCNVST0_14_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST0_15_ADDR                                  0x000001e0
#define ENET_LSTTRCNVST0_15_DEFAULT                               0x00000000
#define ENET_FTRCNVSTSTR0_0_ADDR                                  0x000001f0
#define ENET_FTRCNVSTSTR0_0_DEFAULT                               0x00000008
#define ENET_FTRCNVST0_0_ADDR                                     0x000001f4
#define ENET_FTRCNVST0_0_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_1_ADDR                                     0x000001f8
#define ENET_FTRCNVST0_1_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_2_ADDR                                     0x000001fc
#define ENET_FTRCNVST0_2_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_3_ADDR                                     0x00000200
#define ENET_FTRCNVST0_3_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_4_ADDR                                     0x00000204
#define ENET_FTRCNVST0_4_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_5_ADDR                                     0x00000208
#define ENET_FTRCNVST0_5_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_6_ADDR                                     0x0000020c
#define ENET_FTRCNVST0_6_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_7_ADDR                                     0x00000210
#define ENET_FTRCNVST0_7_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_8_ADDR                                     0x00000214
#define ENET_FTRCNVST0_8_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_9_ADDR                                     0x00000218
#define ENET_FTRCNVST0_9_DEFAULT                                  0x00000000
#define ENET_FTRCNVST0_10_ADDR                                    0x0000021c
#define ENET_FTRCNVST0_10_DEFAULT                                 0x00000000
#define ENET_FTRCNVST0_11_ADDR                                    0x00000220
#define ENET_FTRCNVST0_11_DEFAULT                                 0x00000000
#define ENET_FTRCNVST0_12_ADDR                                    0x00000224
#define ENET_FTRCNVST0_12_DEFAULT                                 0x00000000
#define ENET_FTRCNVST0_13_ADDR                                    0x00000228
#define ENET_FTRCNVST0_13_DEFAULT                                 0x00000000
#define ENET_FTRCNVST0_14_ADDR                                    0x0000022c
#define ENET_FTRCNVST0_14_DEFAULT                                 0x00000000
#define ENET_FTRCNVST0_15_ADDR                                    0x00000230
#define ENET_FTRCNVST0_15_DEFAULT                                 0x00000000
#define ENET_TRCNVSTMON0_0_ADDR                                   0x00000240
#define ENET_TRCNVSTMON0_0_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_0_ADDR                                0x00000244
#define ENET_TRCNVSTMONCNT0_0_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_1_ADDR                                   0x00000248
#define ENET_TRCNVSTMON0_1_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_1_ADDR                                0x0000024c
#define ENET_TRCNVSTMONCNT0_1_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_2_ADDR                                   0x00000250
#define ENET_TRCNVSTMON0_2_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_2_ADDR                                0x00000254
#define ENET_TRCNVSTMONCNT0_2_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_3_ADDR                                   0x00000258
#define ENET_TRCNVSTMON0_3_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_3_ADDR                                0x0000025c
#define ENET_TRCNVSTMONCNT0_3_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_4_ADDR                                   0x00000260
#define ENET_TRCNVSTMON0_4_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_4_ADDR                                0x00000264
#define ENET_TRCNVSTMONCNT0_4_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_5_ADDR                                   0x00000268
#define ENET_TRCNVSTMON0_5_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_5_ADDR                                0x0000026c
#define ENET_TRCNVSTMONCNT0_5_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_6_ADDR                                   0x00000270
#define ENET_TRCNVSTMON0_6_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_6_ADDR                                0x00000274
#define ENET_TRCNVSTMONCNT0_6_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_7_ADDR                                   0x00000278
#define ENET_TRCNVSTMON0_7_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_7_ADDR                                0x0000027c
#define ENET_TRCNVSTMONCNT0_7_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_8_ADDR                                   0x00000280
#define ENET_TRCNVSTMON0_8_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_8_ADDR                                0x00000284
#define ENET_TRCNVSTMONCNT0_8_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_9_ADDR                                   0x00000288
#define ENET_TRCNVSTMON0_9_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT0_9_ADDR                                0x0000028c
#define ENET_TRCNVSTMONCNT0_9_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON0_10_ADDR                                  0x00000290
#define ENET_TRCNVSTMON0_10_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT0_10_ADDR                               0x00000294
#define ENET_TRCNVSTMONCNT0_10_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON0_11_ADDR                                  0x00000298
#define ENET_TRCNVSTMON0_11_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT0_11_ADDR                               0x0000029c
#define ENET_TRCNVSTMONCNT0_11_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON0_12_ADDR                                  0x000002a0
#define ENET_TRCNVSTMON0_12_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT0_12_ADDR                               0x000002a4
#define ENET_TRCNVSTMONCNT0_12_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON0_13_ADDR                                  0x000002a8
#define ENET_TRCNVSTMON0_13_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT0_13_ADDR                               0x000002ac
#define ENET_TRCNVSTMONCNT0_13_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON0_14_ADDR                                  0x000002b0
#define ENET_TRCNVSTMON0_14_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT0_14_ADDR                               0x000002b4
#define ENET_TRCNVSTMONCNT0_14_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON0_15_ADDR                                  0x000002b8
#define ENET_TRCNVSTMON0_15_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT0_15_ADDR                               0x000002bc
#define ENET_TRCNVSTMONCNT0_15_DEFAULT                            0x00000000
#define ENET_HASH_DIAG_CTL0_ADDR                                  0x000002c0
#define ENET_HASH_DIAG_CTL0_DEFAULT                               0x00000000
#define ENET_HASH_SEED_DEFAULT0_ADDR                              0x000002c4
#define ENET_HASH_SEED_DEFAULT0_DEFAULT                           0x00000000
#define ENET_HASH_RESULT_DIAG0_ADDR                               0x000002c8
#define ENET_HASH_RESULT_DIAG0_DEFAULT                            0x00000000
#define ENET_SNPTR1_ADDR                                          0x00000300
#define ENET_SNPTR1_DEFAULT                                       0x00000000
#define ENET_SPPTR1_ADDR                                          0x00000304
#define ENET_SPPTR1_DEFAULT                                       0x00000000
#define ENET_DFCLSRESDBPTR1_ADDR                                  0x00000308
#define ENET_DFCLSRESDBPTR1_DEFAULT                               0x00001c00
#define ENET_DFCLSRESDB1_0_ADDR                                   0x0000030c
#define ENET_DFCLSRESDB1_0_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB1_1_ADDR                                   0x00000310
#define ENET_DFCLSRESDB1_1_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB1_2_ADDR                                   0x00000314
#define ENET_DFCLSRESDB1_2_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB1_3_ADDR                                   0x00000318
#define ENET_DFCLSRESDB1_3_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB1_4_ADDR                                   0x0000031c
#define ENET_DFCLSRESDB1_4_DEFAULT                                0x00000000
#define ENET_DFCLSRESDB1_5_ADDR                                   0x00000320
#define ENET_DFCLSRESDB1_5_DEFAULT                                0x00000000
#define ENET_PARSER_CTL1_ADDR                                     0x00000330
#define ENET_PARSER_CTL1_DEFAULT                                  0x00000000
#define ENET_TMAXHOP1_ADDR                                        0x00000334
#define ENET_TMAXHOP1_DEFAULT                                     0x00000040
#define ENET_PORTNUM1_ADDR                                        0x00000338
#define ENET_PORTNUM1_DEFAULT                                     0x00000001
#define ENET_RSS_CTRL1_ADDR                                       0x0000033c
#define ENET_RSS_CTRL1_DEFAULT                                    0x00000000
#define ENET_PARSER_STATUS1_ADDR                                  0x00000370
#define ENET_PARSER_STATUS1_DEFAULT                               0x00000000
#define ENET_PARSER_STATUS1MASK_ADDR                              0x00000374
#define ENET_SNPTR_CHANGE_STATUS1_ADDR                            0x00000378
#define ENET_SNPTR_CHANGE_STATUS1_DEFAULT                         0x00000000
#define ENET_ITABLE1_ERR_DIAGNOSTIC_ADDR                          0x0000038c
#define ENET_ITABLE1_ERR_DIAGNOSTIC_DEFAULT                       0x00000000
#define ENET_PKTRAM1_ERR_DIAGNOSTIC_ADDR                          0x00000390
#define ENET_PKTRAM1_ERR_DIAGNOSTIC_DEFAULT                       0x00000000
#define ENET_ITABLE1_CTRL_ADDR                                    0x00000394
#define ENET_ITABLE1_CTRL_DEFAULT                                 0x00000000
#define ENET_LSTNVST1_ADDR                                        0x000003a0
#define ENET_LSTNVST1_DEFAULT                                     0x00000000
#define ENET_LSTTRCNVST1_0_ADDR                                   0x000003a4
#define ENET_LSTTRCNVST1_0_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_1_ADDR                                   0x000003a8
#define ENET_LSTTRCNVST1_1_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_2_ADDR                                   0x000003ac
#define ENET_LSTTRCNVST1_2_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_3_ADDR                                   0x000003b0
#define ENET_LSTTRCNVST1_3_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_4_ADDR                                   0x000003b4
#define ENET_LSTTRCNVST1_4_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_5_ADDR                                   0x000003b8
#define ENET_LSTTRCNVST1_5_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_6_ADDR                                   0x000003bc
#define ENET_LSTTRCNVST1_6_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_7_ADDR                                   0x000003c0
#define ENET_LSTTRCNVST1_7_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_8_ADDR                                   0x000003c4
#define ENET_LSTTRCNVST1_8_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_9_ADDR                                   0x000003c8
#define ENET_LSTTRCNVST1_9_DEFAULT                                0x00000000
#define ENET_LSTTRCNVST1_10_ADDR                                  0x000003cc
#define ENET_LSTTRCNVST1_10_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST1_11_ADDR                                  0x000003d0
#define ENET_LSTTRCNVST1_11_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST1_12_ADDR                                  0x000003d4
#define ENET_LSTTRCNVST1_12_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST1_13_ADDR                                  0x000003d8
#define ENET_LSTTRCNVST1_13_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST1_14_ADDR                                  0x000003dc
#define ENET_LSTTRCNVST1_14_DEFAULT                               0x00000000
#define ENET_LSTTRCNVST1_15_ADDR                                  0x000003e0
#define ENET_LSTTRCNVST1_15_DEFAULT                               0x00000000
#define ENET_FTRCNVSTSTR1_0_ADDR                                  0x000003f0
#define ENET_FTRCNVSTSTR1_0_DEFAULT                               0x00000008
#define ENET_FTRCNVST1_0_ADDR                                     0x000003f4
#define ENET_FTRCNVST1_0_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_1_ADDR                                     0x000003f8
#define ENET_FTRCNVST1_1_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_2_ADDR                                     0x000003fc
#define ENET_FTRCNVST1_2_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_3_ADDR                                     0x00000400
#define ENET_FTRCNVST1_3_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_4_ADDR                                     0x00000404
#define ENET_FTRCNVST1_4_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_5_ADDR                                     0x00000408
#define ENET_FTRCNVST1_5_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_6_ADDR                                     0x0000040c
#define ENET_FTRCNVST1_6_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_7_ADDR                                     0x00000410
#define ENET_FTRCNVST1_7_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_8_ADDR                                     0x00000414
#define ENET_FTRCNVST1_8_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_9_ADDR                                     0x00000418
#define ENET_FTRCNVST1_9_DEFAULT                                  0x00000000
#define ENET_FTRCNVST1_10_ADDR                                    0x0000041c
#define ENET_FTRCNVST1_10_DEFAULT                                 0x00000000
#define ENET_FTRCNVST1_11_ADDR                                    0x00000420
#define ENET_FTRCNVST1_11_DEFAULT                                 0x00000000
#define ENET_FTRCNVST1_12_ADDR                                    0x00000424
#define ENET_FTRCNVST1_12_DEFAULT                                 0x00000000
#define ENET_FTRCNVST1_13_ADDR                                    0x00000428
#define ENET_FTRCNVST1_13_DEFAULT                                 0x00000000
#define ENET_FTRCNVST1_14_ADDR                                    0x0000042c
#define ENET_FTRCNVST1_14_DEFAULT                                 0x00000000
#define ENET_FTRCNVST1_15_ADDR                                    0x00000430
#define ENET_FTRCNVST1_15_DEFAULT                                 0x00000000
#define ENET_TRCNVSTMON1_0_ADDR                                   0x00000440
#define ENET_TRCNVSTMON1_0_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_0_ADDR                                0x00000444
#define ENET_TRCNVSTMONCNT1_0_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_1_ADDR                                   0x00000448
#define ENET_TRCNVSTMON1_1_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_1_ADDR                                0x0000044c
#define ENET_TRCNVSTMONCNT1_1_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_2_ADDR                                   0x00000450
#define ENET_TRCNVSTMON1_2_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_2_ADDR                                0x00000454
#define ENET_TRCNVSTMONCNT1_2_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_3_ADDR                                   0x00000458
#define ENET_TRCNVSTMON1_3_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_3_ADDR                                0x0000045c
#define ENET_TRCNVSTMONCNT1_3_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_4_ADDR                                   0x00000460
#define ENET_TRCNVSTMON1_4_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_4_ADDR                                0x00000464
#define ENET_TRCNVSTMONCNT1_4_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_5_ADDR                                   0x00000468
#define ENET_TRCNVSTMON1_5_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_5_ADDR                                0x0000046c
#define ENET_TRCNVSTMONCNT1_5_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_6_ADDR                                   0x00000470
#define ENET_TRCNVSTMON1_6_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_6_ADDR                                0x00000474
#define ENET_TRCNVSTMONCNT1_6_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_7_ADDR                                   0x00000478
#define ENET_TRCNVSTMON1_7_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_7_ADDR                                0x0000047c
#define ENET_TRCNVSTMONCNT1_7_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_8_ADDR                                   0x00000480
#define ENET_TRCNVSTMON1_8_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_8_ADDR                                0x00000484
#define ENET_TRCNVSTMONCNT1_8_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_9_ADDR                                   0x00000488
#define ENET_TRCNVSTMON1_9_DEFAULT                                0x00000000
#define ENET_TRCNVSTMONCNT1_9_ADDR                                0x0000048c
#define ENET_TRCNVSTMONCNT1_9_DEFAULT                             0x00000000
#define ENET_TRCNVSTMON1_10_ADDR                                  0x00000490
#define ENET_TRCNVSTMON1_10_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT1_10_ADDR                               0x00000494
#define ENET_TRCNVSTMONCNT1_10_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON1_11_ADDR                                  0x00000498
#define ENET_TRCNVSTMON1_11_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT1_11_ADDR                               0x0000049c
#define ENET_TRCNVSTMONCNT1_11_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON1_12_ADDR                                  0x000004a0
#define ENET_TRCNVSTMON1_12_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT1_12_ADDR                               0x000004a4
#define ENET_TRCNVSTMONCNT1_12_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON1_13_ADDR                                  0x000004a8
#define ENET_TRCNVSTMON1_13_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT1_13_ADDR                               0x000004ac
#define ENET_TRCNVSTMONCNT1_13_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON1_14_ADDR                                  0x000004b0
#define ENET_TRCNVSTMON1_14_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT1_14_ADDR                               0x000004b4
#define ENET_TRCNVSTMONCNT1_14_DEFAULT                            0x00000000
#define ENET_TRCNVSTMON1_15_ADDR                                  0x000004b8
#define ENET_TRCNVSTMON1_15_DEFAULT                               0x00000000
#define ENET_TRCNVSTMONCNT1_15_ADDR                               0x000004bc
#define ENET_TRCNVSTMONCNT1_15_DEFAULT                            0x00000000
#define ENET_HASH_DIAG_CTL1_ADDR                                  0x000004c0
#define ENET_HASH_DIAG_CTL1_DEFAULT                               0x00000000
#define ENET_HASH_SEED_DEFAULT1_ADDR                              0x000004c4
#define ENET_HASH_SEED_DEFAULT1_DEFAULT                           0x00000000
#define ENET_HASH_RESULT_DIAG1_ADDR                               0x000004c8
#define ENET_HASH_RESULT_DIAG1_DEFAULT                            0x00000000

/*	Register cle_bid	*/ 
/*	 Fields revno	 */
#define ENET_REVNO_F2_WIDTH                                                2
#define ENET_REVNO_F2_SHIFT                                               14
#define ENET_REVNO_F2_MASK                                        0x0000c000
#define ENET_REVNO_F2_RD(src)                     (((src) & 0x0000c000)>>14)
#define ENET_REVNO_F2_SET(dst,src) \
                      (((dst) & ~0x0000c000) | (((u32)(src)<<14) & 0x0000c000))
/*	 Fields busid	 */
#define ENET_BUSID_WIDTH                                                   2
#define ENET_BUSID_SHIFT                                                  12
#define ENET_BUSID_MASK                                           0x00003000
#define ENET_BUSID_RD(src)                        (((src) & 0x00003000)>>12)
#define ENET_BUSID_SET(dst,src) \
                      (((dst) & ~0x00003000) | (((u32)(src)<<12) & 0x00003000))
/*	 Fields deviceid	 */
#define ENET_DEVICEID_F4_WIDTH                                            12
#define ENET_DEVICEID_F4_SHIFT                                             0
#define ENET_DEVICEID_F4_MASK                                     0x00000fff
#define ENET_DEVICEID_F4_RD(src)                      (((src) & 0x00000fff))
#define ENET_DEVICEID_F4_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register indaddr	*/ 
/*	 Fields addr	 */
#define ENET_ADDR_WIDTH                                                   32
#define ENET_ADDR_SHIFT                                                    0
#define ENET_ADDR_MASK                                            0xffffffff
#define ENET_ADDR_RD(src)                             (((src) & 0xffffffff))
#define ENET_ADDR_WR(src)                        (((u32)(src)) & 0xffffffff)
#define ENET_ADDR_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register indcmd	*/ 
/*	 Fields avl_update	 */
#define ENET_AVL_UPDATE_WIDTH                                              1
#define ENET_AVL_UPDATE_SHIFT                                              6
#define ENET_AVL_UPDATE_MASK                                      0x00000040
#define ENET_AVL_UPDATE_RD(src)                    (((src) & 0x00000040)>>6)
#define ENET_AVL_UPDATE_WR(src)               (((u32)(src)<<6) & 0x00000040)
#define ENET_AVL_UPDATE_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields avl_search	 */
#define ENET_AVL_SEARCH_WIDTH                                              1
#define ENET_AVL_SEARCH_SHIFT                                              5
#define ENET_AVL_SEARCH_MASK                                      0x00000020
#define ENET_AVL_SEARCH_RD(src)                    (((src) & 0x00000020)>>5)
#define ENET_AVL_SEARCH_WR(src)               (((u32)(src)<<5) & 0x00000020)
#define ENET_AVL_SEARCH_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields avl_del	 */
#define ENET_AVL_DEL_WIDTH                                                 1
#define ENET_AVL_DEL_SHIFT                                                 4
#define ENET_AVL_DEL_MASK                                         0x00000010
#define ENET_AVL_DEL_RD(src)                       (((src) & 0x00000010)>>4)
#define ENET_AVL_DEL_WR(src)                  (((u32)(src)<<4) & 0x00000010)
#define ENET_AVL_DEL_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields avl_add	 */
#define ENET_AVL_ADD_WIDTH                                                 1
#define ENET_AVL_ADD_SHIFT                                                 3
#define ENET_AVL_ADD_MASK                                         0x00000008
#define ENET_AVL_ADD_RD(src)                       (((src) & 0x00000008)>>3)
#define ENET_AVL_ADD_WR(src)                  (((u32)(src)<<3) & 0x00000008)
#define ENET_AVL_ADD_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields lock	 */
#define ENET_LOCK_WIDTH                                                    1
#define ENET_LOCK_SHIFT                                                    2
#define ENET_LOCK_MASK                                            0x00000004
#define ENET_LOCK_RD(src)                          (((src) & 0x00000004)>>2)
#define ENET_LOCK_WR(src)                     (((u32)(src)<<2) & 0x00000004)
#define ENET_LOCK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields read	 */
#define ENET_READ_WIDTH                                                    1
#define ENET_READ_SHIFT                                                    1
#define ENET_READ_MASK                                            0x00000002
#define ENET_READ_RD(src)                          (((src) & 0x00000002)>>1)
#define ENET_READ_WR(src)                     (((u32)(src)<<1) & 0x00000002)
#define ENET_READ_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields write	 */
#define ENET_WRITE_WIDTH                                                   1
#define ENET_WRITE_SHIFT                                                   0
#define ENET_WRITE_MASK                                           0x00000001
#define ENET_WRITE_RD(src)                            (((src) & 0x00000001))
#define ENET_WRITE_WR(src)                       (((u32)(src)) & 0x00000001)
#define ENET_WRITE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register indcmd_status	*/ 
/*	 Fields avl_err	 */
#define ENET_AVL_ERR_WIDTH                                                 1
#define ENET_AVL_ERR_SHIFT                                                31
#define ENET_AVL_ERR_MASK                                         0x80000000
#define ENET_AVL_ERR_RD(src)                      (((src) & 0x80000000)>>31)
#define ENET_AVL_ERR_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields avl_del_srch_add_addr	 */
#define ENET_AVL_DEL_SRCH_ADD_ADDR_WIDTH                                  11
#define ENET_AVL_DEL_SRCH_ADD_ADDR_SHIFT                                  17
#define ENET_AVL_DEL_SRCH_ADD_ADDR_MASK                           0x0ffe0000
#define ENET_AVL_DEL_SRCH_ADD_ADDR_RD(src)        (((src) & 0x0ffe0000)>>17)
#define ENET_AVL_DEL_SRCH_ADD_ADDR_SET(dst,src) \
                      (((dst) & ~0x0ffe0000) | (((u32)(src)<<17) & 0x0ffe0000))
/*	 Fields avl_search_hit_db_ptr	 */
#define ENET_AVL_SEARCH_HIT_DB_PTR_WIDTH                                  10
#define ENET_AVL_SEARCH_HIT_DB_PTR_SHIFT                                   7
#define ENET_AVL_SEARCH_HIT_DB_PTR_MASK                           0x0001ff80
#define ENET_AVL_SEARCH_HIT_DB_PTR_RD(src)         (((src) & 0x0001ff80)>>7)
#define ENET_AVL_SEARCH_HIT_DB_PTR_SET(dst,src) \
                       (((dst) & ~0x0001ff80) | (((u32)(src)<<7) & 0x0001ff80))
/*	 Fields avl_search_done_miss	 */
#define ENET_AVL_SEARCH_DONE_MISS_WIDTH                                    1
#define ENET_AVL_SEARCH_DONE_MISS_SHIFT                                    6
#define ENET_AVL_SEARCH_DONE_MISS_MASK                            0x00000040
#define ENET_AVL_SEARCH_DONE_MISS_RD(src)          (((src) & 0x00000040)>>6)
#define ENET_AVL_SEARCH_DONE_MISS_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields avl_search_done_hit	 */
#define ENET_AVL_SEARCH_DONE_HIT_WIDTH                                     1
#define ENET_AVL_SEARCH_DONE_HIT_SHIFT                                     5
#define ENET_AVL_SEARCH_DONE_HIT_MASK                             0x00000020
#define ENET_AVL_SEARCH_DONE_HIT_RD(src)           (((src) & 0x00000020)>>5)
#define ENET_AVL_SEARCH_DONE_HIT_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields avl_del_done	 */
#define ENET_AVL_DEL_DONE_WIDTH                                            1
#define ENET_AVL_DEL_DONE_SHIFT                                            4
#define ENET_AVL_DEL_DONE_MASK                                    0x00000010
#define ENET_AVL_DEL_DONE_RD(src)                  (((src) & 0x00000010)>>4)
#define ENET_AVL_DEL_DONE_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields avl_add_done	 */
#define ENET_AVL_ADD_DONE_WIDTH                                            1
#define ENET_AVL_ADD_DONE_SHIFT                                            3
#define ENET_AVL_ADD_DONE_MASK                                    0x00000008
#define ENET_AVL_ADD_DONE_RD(src)                  (((src) & 0x00000008)>>3)
#define ENET_AVL_ADD_DONE_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields avl_update_done	 */
#define ENET_AVL_UPDATE_DONE_WIDTH                                         1
#define ENET_AVL_UPDATE_DONE_SHIFT                                         2
#define ENET_AVL_UPDATE_DONE_MASK                                 0x00000004
#define ENET_AVL_UPDATE_DONE_RD(src)               (((src) & 0x00000004)>>2)
#define ENET_AVL_UPDATE_DONE_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields read_done	 */
#define ENET_READ_DONE_WIDTH                                               1
#define ENET_READ_DONE_SHIFT                                               1
#define ENET_READ_DONE_MASK                                       0x00000002
#define ENET_READ_DONE_RD(src)                     (((src) & 0x00000002)>>1)
#define ENET_READ_DONE_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields write_done	 */
#define ENET_WRITE_DONE_WIDTH                                              1
#define ENET_WRITE_DONE_SHIFT                                              0
#define ENET_WRITE_DONE_MASK                                      0x00000001
#define ENET_WRITE_DONE_RD(src)                       (((src) & 0x00000001))
#define ENET_WRITE_DONE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register data_ram0	*/ 
/*	 Fields data	 */
#define ENET_DATA0_WIDTH                                                  32
#define ENET_DATA0_SHIFT                                                   0
#define ENET_DATA0_MASK                                           0xffffffff
#define ENET_DATA0_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA0_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram1	*/ 
/*	 Fields data	 */
#define ENET_DATA1_WIDTH                                                  32
#define ENET_DATA1_SHIFT                                                   0
#define ENET_DATA1_MASK                                           0xffffffff
#define ENET_DATA1_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA1_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram2	*/ 
/*	 Fields data	 */
#define ENET_DATA2_WIDTH                                                  32
#define ENET_DATA2_SHIFT                                                   0
#define ENET_DATA2_MASK                                           0xffffffff
#define ENET_DATA2_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA2_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram3	*/ 
/*	 Fields data	 */
#define ENET_DATA3_WIDTH                                                  32
#define ENET_DATA3_SHIFT                                                   0
#define ENET_DATA3_MASK                                           0xffffffff
#define ENET_DATA3_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA3_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram4	*/ 
/*	 Fields data	 */
#define ENET_DATA4_WIDTH                                                  32
#define ENET_DATA4_SHIFT                                                   0
#define ENET_DATA4_MASK                                           0xffffffff
#define ENET_DATA4_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA4_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram5	*/ 
/*	 Fields data	 */
#define ENET_DATA5_WIDTH                                                  32
#define ENET_DATA5_SHIFT                                                   0
#define ENET_DATA5_MASK                                           0xffffffff
#define ENET_DATA5_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA5_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA5_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram6	*/ 
/*	 Fields data	 */
#define ENET_DATA6_WIDTH                                                  32
#define ENET_DATA6_SHIFT                                                   0
#define ENET_DATA6_MASK                                           0xffffffff
#define ENET_DATA6_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA6_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA6_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram7	*/ 
/*	 Fields data	 */
#define ENET_DATA7_WIDTH                                                  32
#define ENET_DATA7_SHIFT                                                   0
#define ENET_DATA7_MASK                                           0xffffffff
#define ENET_DATA7_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA7_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA7_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram8	*/ 
/*	 Fields data	 */
#define ENET_DATA8_WIDTH                                                  32
#define ENET_DATA8_SHIFT                                                   0
#define ENET_DATA8_MASK                                           0xffffffff
#define ENET_DATA8_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA8_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA8_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram9	*/ 
/*	 Fields data	 */
#define ENET_DATA9_WIDTH                                                  32
#define ENET_DATA9_SHIFT                                                   0
#define ENET_DATA9_MASK                                           0xffffffff
#define ENET_DATA9_RD(src)                            (((src) & 0xffffffff))
#define ENET_DATA9_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_DATA9_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram10	*/ 
/*	 Fields data	 */
#define ENET_DATA0_F1_WIDTH                                               32
#define ENET_DATA0_F1_SHIFT                                                0
#define ENET_DATA0_F1_MASK                                        0xffffffff
#define ENET_DATA0_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA0_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram11	*/ 
/*	 Fields data	 */
#define ENET_DATA1_F1_WIDTH                                               32
#define ENET_DATA1_F1_SHIFT                                                0
#define ENET_DATA1_F1_MASK                                        0xffffffff
#define ENET_DATA1_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA1_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram12	*/ 
/*	 Fields data	 */
#define ENET_DATA2_F1_WIDTH                                               32
#define ENET_DATA2_F1_SHIFT                                                0
#define ENET_DATA2_F1_MASK                                        0xffffffff
#define ENET_DATA2_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA2_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA2_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram13	*/ 
/*	 Fields data	 */
#define ENET_DATA3_F1_WIDTH                                               32
#define ENET_DATA3_F1_SHIFT                                                0
#define ENET_DATA3_F1_MASK                                        0xffffffff
#define ENET_DATA3_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA3_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA3_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram14	*/ 
/*	 Fields data	 */
#define ENET_DATA4_F1_WIDTH                                               32
#define ENET_DATA4_F1_SHIFT                                                0
#define ENET_DATA4_F1_MASK                                        0xffffffff
#define ENET_DATA4_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA4_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA4_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram15	*/ 
/*	 Fields data	 */
#define ENET_DATA5_F1_WIDTH                                               32
#define ENET_DATA5_F1_SHIFT                                                0
#define ENET_DATA5_F1_MASK                                        0xffffffff
#define ENET_DATA5_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA5_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA5_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register data_ram16	*/ 
/*	 Fields data	 */
#define ENET_DATA6_F1_WIDTH                                               32
#define ENET_DATA6_F1_SHIFT                                                0
#define ENET_DATA6_F1_MASK                                        0xffffffff
#define ENET_DATA6_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA6_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA6_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register avl_config	*/ 
/*	 Fields maxsteps_thresh	 */
#define ENET_MAXSTEPS_THRESH_WIDTH                                        12
#define ENET_MAXSTEPS_THRESH_SHIFT                                        14
#define ENET_MAXSTEPS_THRESH_MASK                                 0x03ffc000
#define ENET_MAXSTEPS_THRESH_RD(src)              (((src) & 0x03ffc000)>>14)
#define ENET_MAXSTEPS_THRESH_WR(src)         (((u32)(src)<<14) & 0x03ffc000)
#define ENET_MAXSTEPS_THRESH_SET(dst,src) \
                      (((dst) & ~0x03ffc000) | (((u32)(src)<<14) & 0x03ffc000))
/*	 Fields srchdb_depth	 */
#define ENET_SRCHDB_DEPTH_WIDTH                                           12
#define ENET_SRCHDB_DEPTH_SHIFT                                            2
#define ENET_SRCHDB_DEPTH_MASK                                    0x00003ffc
#define ENET_SRCHDB_DEPTH_RD(src)                  (((src) & 0x00003ffc)>>2)
#define ENET_SRCHDB_DEPTH_WR(src)             (((u32)(src)<<2) & 0x00003ffc)
#define ENET_SRCHDB_DEPTH_SET(dst,src) \
                       (((dst) & ~0x00003ffc) | (((u32)(src)<<2) & 0x00003ffc))
/*	 Fields string_size	 */
#define ENET_STRING_SIZE_WIDTH                                             2
#define ENET_STRING_SIZE_SHIFT                                             0
#define ENET_STRING_SIZE_MASK                                     0x00000003
#define ENET_STRING_SIZE_RD(src)                      (((src) & 0x00000003))
#define ENET_STRING_SIZE_WR(src)                 (((u32)(src)) & 0x00000003)
#define ENET_STRING_SIZE_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register avl_status	*/ 
/*	 Fields root_addr	 */
#define ENET_ROOT_ADDR_WIDTH                                              11
#define ENET_ROOT_ADDR_SHIFT                                              12
#define ENET_ROOT_ADDR_MASK                                       0x007ff000
#define ENET_ROOT_ADDR_RD(src)                    (((src) & 0x007ff000)>>12)
#define ENET_ROOT_ADDR_SET(dst,src) \
                      (((dst) & ~0x007ff000) | (((u32)(src)<<12) & 0x007ff000))
/*	 Fields node_cnt	 */
#define ENET_NODE_CNT_WIDTH                                               12
#define ENET_NODE_CNT_SHIFT                                                0
#define ENET_NODE_CNT_MASK                                        0x00000fff
#define ENET_NODE_CNT_RD(src)                         (((src) & 0x00000fff))
#define ENET_NODE_CNT_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register cle_INT	*/ 
/*	 Fields ptramaddr_ge_128	 */
#define ENET_PTRAMADDR_GE_128_WIDTH                                        1
#define ENET_PTRAMADDR_GE_128_SHIFT                                        1
#define ENET_PTRAMADDR_GE_128_MASK                                0x00000002
#define ENET_PTRAMADDR_GE_128_RD(src)              (((src) & 0x00000002)>>1)
#define ENET_PTRAMADDR_GE_128_WR(src)         (((u32)(src)<<1) & 0x00000002)
#define ENET_PTRAMADDR_GE_128_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cle_int	 */
#define ENET_CLE_INT_WIDTH                                                 1
#define ENET_CLE_INT_SHIFT                                                 0
#define ENET_CLE_INT_MASK                                         0x00000001
#define ENET_CLE_INT_RD(src)                          (((src) & 0x00000001))
#define ENET_CLE_INT_WR(src)                     (((u32)(src)) & 0x00000001)
#define ENET_CLE_INT_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register cle_interruptMask	*/
/*    Mask Register Fields ptramaddr_ge_128Mask    */
#define ENET_PTRAMADDR_GE_128MASK_WIDTH                                    1
#define ENET_PTRAMADDR_GE_128MASK_SHIFT                                    1
#define ENET_PTRAMADDR_GE_128MASK_MASK                            0x00000002
#define ENET_PTRAMADDR_GE_128MASK_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_PTRAMADDR_GE_128MASK_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_PTRAMADDR_GE_128MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields cle_intMask    */
#define ENET_CLE_INTMASK_WIDTH                                             1
#define ENET_CLE_INTMASK_SHIFT                                             0
#define ENET_CLE_INTMASK_MASK                                     0x00000001
#define ENET_CLE_INTMASK_RD(src)                      (((src) & 0x00000001))
#define ENET_CLE_INTMASK_WR(src)                 (((u32)(src)) & 0x00000001)
#define ENET_CLE_INTMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register avl_search_int	*/ 
/*	 Fields fatal_wrselfpointerr	 */
#define ENET_FATAL_WRSELFPOINTERR_WIDTH                                    1
#define ENET_FATAL_WRSELFPOINTERR_SHIFT                                   10
#define ENET_FATAL_WRSELFPOINTERR_MASK                            0x00000400
#define ENET_FATAL_WRSELFPOINTERR_RD(src)         (((src) & 0x00000400)>>10)
#define ENET_FATAL_WRSELFPOINTERR_WR(src)    (((u32)(src)<<10) & 0x00000400)
#define ENET_FATAL_WRSELFPOINTERR_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields fatal_rdselfpointerr	 */
#define ENET_FATAL_RDSELFPOINTERR_WIDTH                                    1
#define ENET_FATAL_RDSELFPOINTERR_SHIFT                                    9
#define ENET_FATAL_RDSELFPOINTERR_MASK                            0x00000200
#define ENET_FATAL_RDSELFPOINTERR_RD(src)          (((src) & 0x00000200)>>9)
#define ENET_FATAL_RDSELFPOINTERR_WR(src)     (((u32)(src)<<9) & 0x00000200)
#define ENET_FATAL_RDSELFPOINTERR_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields fatal_wrbalerr	 */
#define ENET_FATAL_WRBALERR_WIDTH                                          1
#define ENET_FATAL_WRBALERR_SHIFT                                          8
#define ENET_FATAL_WRBALERR_MASK                                  0x00000100
#define ENET_FATAL_WRBALERR_RD(src)                (((src) & 0x00000100)>>8)
#define ENET_FATAL_WRBALERR_WR(src)           (((u32)(src)<<8) & 0x00000100)
#define ENET_FATAL_WRBALERR_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields fatal_rdbalerr	 */
#define ENET_FATAL_RDBALERR_WIDTH                                          1
#define ENET_FATAL_RDBALERR_SHIFT                                          7
#define ENET_FATAL_RDBALERR_MASK                                  0x00000080
#define ENET_FATAL_RDBALERR_RD(src)                (((src) & 0x00000080)>>7)
#define ENET_FATAL_RDBALERR_WR(src)           (((u32)(src)<<7) & 0x00000080)
#define ENET_FATAL_RDBALERR_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields fatal_maxstepserr	 */
#define ENET_FATAL_MAXSTEPSERR_WIDTH                                       1
#define ENET_FATAL_MAXSTEPSERR_SHIFT                                       6
#define ENET_FATAL_MAXSTEPSERR_MASK                               0x00000040
#define ENET_FATAL_MAXSTEPSERR_RD(src)             (((src) & 0x00000040)>>6)
#define ENET_FATAL_MAXSTEPSERR_WR(src)        (((u32)(src)<<6) & 0x00000040)
#define ENET_FATAL_MAXSTEPSERR_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields fatal_rderr_ram	 */
#define ENET_FATAL_RDERR_RAM_WIDTH                                         1
#define ENET_FATAL_RDERR_RAM_SHIFT                                         5
#define ENET_FATAL_RDERR_RAM_MASK                                 0x00000020
#define ENET_FATAL_RDERR_RAM_RD(src)               (((src) & 0x00000020)>>5)
#define ENET_FATAL_RDERR_RAM_WR(src)          (((u32)(src)<<5) & 0x00000020)
#define ENET_FATAL_RDERR_RAM_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields rderr_ram	 */
#define ENET_RDERR_RAM_WIDTH                                               1
#define ENET_RDERR_RAM_SHIFT                                               4
#define ENET_RDERR_RAM_MASK                                       0x00000010
#define ENET_RDERR_RAM_RD(src)                     (((src) & 0x00000010)>>4)
#define ENET_RDERR_RAM_WR(src)                (((u32)(src)<<4) & 0x00000010)
#define ENET_RDERR_RAM_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields delerr_ridnotfound	 */
#define ENET_DELERR_RIDNOTFOUND_WIDTH                                      1
#define ENET_DELERR_RIDNOTFOUND_SHIFT                                      3
#define ENET_DELERR_RIDNOTFOUND_MASK                              0x00000008
#define ENET_DELERR_RIDNOTFOUND_RD(src)            (((src) & 0x00000008)>>3)
#define ENET_DELERR_RIDNOTFOUND_WR(src)       (((u32)(src)<<3) & 0x00000008)
#define ENET_DELERR_RIDNOTFOUND_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields delerr_empty	 */
#define ENET_DELERR_EMPTY_WIDTH                                            1
#define ENET_DELERR_EMPTY_SHIFT                                            2
#define ENET_DELERR_EMPTY_MASK                                    0x00000004
#define ENET_DELERR_EMPTY_RD(src)                  (((src) & 0x00000004)>>2)
#define ENET_DELERR_EMPTY_WR(src)             (((u32)(src)<<2) & 0x00000004)
#define ENET_DELERR_EMPTY_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields adderr_ridduplicate	 */
#define ENET_ADDERR_RIDDUPLICATE_WIDTH                                     1
#define ENET_ADDERR_RIDDUPLICATE_SHIFT                                     1
#define ENET_ADDERR_RIDDUPLICATE_MASK                             0x00000002
#define ENET_ADDERR_RIDDUPLICATE_RD(src)           (((src) & 0x00000002)>>1)
#define ENET_ADDERR_RIDDUPLICATE_WR(src)      (((u32)(src)<<1) & 0x00000002)
#define ENET_ADDERR_RIDDUPLICATE_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields adderr_full	 */
#define ENET_ADDERR_FULL_WIDTH                                             1
#define ENET_ADDERR_FULL_SHIFT                                             0
#define ENET_ADDERR_FULL_MASK                                     0x00000001
#define ENET_ADDERR_FULL_RD(src)                      (((src) & 0x00000001))
#define ENET_ADDERR_FULL_WR(src)                 (((u32)(src)) & 0x00000001)
#define ENET_ADDERR_FULL_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register avl_search_intMask	*/
/*    Mask Register Fields fatal_wrselfpointerrMask    */
#define ENET_FATAL_WRSELFPOINTERRMASK_WIDTH                                1
#define ENET_FATAL_WRSELFPOINTERRMASK_SHIFT                               10
#define ENET_FATAL_WRSELFPOINTERRMASK_MASK                        0x00000400
#define ENET_FATAL_WRSELFPOINTERRMASK_RD(src)     (((src) & 0x00000400)>>10)
#define ENET_FATAL_WRSELFPOINTERRMASK_WR(src) \
                                                (((u32)(src)<<10) & 0x00000400)
#define ENET_FATAL_WRSELFPOINTERRMASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields fatal_rdselfpointerrMask    */
#define ENET_FATAL_RDSELFPOINTERRMASK_WIDTH                                1
#define ENET_FATAL_RDSELFPOINTERRMASK_SHIFT                                9
#define ENET_FATAL_RDSELFPOINTERRMASK_MASK                        0x00000200
#define ENET_FATAL_RDSELFPOINTERRMASK_RD(src)      (((src) & 0x00000200)>>9)
#define ENET_FATAL_RDSELFPOINTERRMASK_WR(src) \
                                                 (((u32)(src)<<9) & 0x00000200)
#define ENET_FATAL_RDSELFPOINTERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields fatal_wrbalerrMask    */
#define ENET_FATAL_WRBALERRMASK_WIDTH                                      1
#define ENET_FATAL_WRBALERRMASK_SHIFT                                      8
#define ENET_FATAL_WRBALERRMASK_MASK                              0x00000100
#define ENET_FATAL_WRBALERRMASK_RD(src)            (((src) & 0x00000100)>>8)
#define ENET_FATAL_WRBALERRMASK_WR(src)       (((u32)(src)<<8) & 0x00000100)
#define ENET_FATAL_WRBALERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields fatal_rdbalerrMask    */
#define ENET_FATAL_RDBALERRMASK_WIDTH                                      1
#define ENET_FATAL_RDBALERRMASK_SHIFT                                      7
#define ENET_FATAL_RDBALERRMASK_MASK                              0x00000080
#define ENET_FATAL_RDBALERRMASK_RD(src)            (((src) & 0x00000080)>>7)
#define ENET_FATAL_RDBALERRMASK_WR(src)       (((u32)(src)<<7) & 0x00000080)
#define ENET_FATAL_RDBALERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields fatal_maxstepserrMask    */
#define ENET_FATAL_MAXSTEPSERRMASK_WIDTH                                   1
#define ENET_FATAL_MAXSTEPSERRMASK_SHIFT                                   6
#define ENET_FATAL_MAXSTEPSERRMASK_MASK                           0x00000040
#define ENET_FATAL_MAXSTEPSERRMASK_RD(src)         (((src) & 0x00000040)>>6)
#define ENET_FATAL_MAXSTEPSERRMASK_WR(src)    (((u32)(src)<<6) & 0x00000040)
#define ENET_FATAL_MAXSTEPSERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields fatal_rderr_ramMask    */
#define ENET_FATAL_RDERR_RAMMASK_WIDTH                                     1
#define ENET_FATAL_RDERR_RAMMASK_SHIFT                                     5
#define ENET_FATAL_RDERR_RAMMASK_MASK                             0x00000020
#define ENET_FATAL_RDERR_RAMMASK_RD(src)           (((src) & 0x00000020)>>5)
#define ENET_FATAL_RDERR_RAMMASK_WR(src)      (((u32)(src)<<5) & 0x00000020)
#define ENET_FATAL_RDERR_RAMMASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields rderr_ramMask    */
#define ENET_RDERR_RAMMASK_WIDTH                                           1
#define ENET_RDERR_RAMMASK_SHIFT                                           4
#define ENET_RDERR_RAMMASK_MASK                                   0x00000010
#define ENET_RDERR_RAMMASK_RD(src)                 (((src) & 0x00000010)>>4)
#define ENET_RDERR_RAMMASK_WR(src)            (((u32)(src)<<4) & 0x00000010)
#define ENET_RDERR_RAMMASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields delerr_ridnotfoundMask    */
#define ENET_DELERR_RIDNOTFOUNDMASK_WIDTH                                  1
#define ENET_DELERR_RIDNOTFOUNDMASK_SHIFT                                  3
#define ENET_DELERR_RIDNOTFOUNDMASK_MASK                          0x00000008
#define ENET_DELERR_RIDNOTFOUNDMASK_RD(src)        (((src) & 0x00000008)>>3)
#define ENET_DELERR_RIDNOTFOUNDMASK_WR(src)   (((u32)(src)<<3) & 0x00000008)
#define ENET_DELERR_RIDNOTFOUNDMASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields delerr_emptyMask    */
#define ENET_DELERR_EMPTYMASK_WIDTH                                        1
#define ENET_DELERR_EMPTYMASK_SHIFT                                        2
#define ENET_DELERR_EMPTYMASK_MASK                                0x00000004
#define ENET_DELERR_EMPTYMASK_RD(src)              (((src) & 0x00000004)>>2)
#define ENET_DELERR_EMPTYMASK_WR(src)         (((u32)(src)<<2) & 0x00000004)
#define ENET_DELERR_EMPTYMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields adderr_ridduplicateMask    */
#define ENET_ADDERR_RIDDUPLICATEMASK_WIDTH                                 1
#define ENET_ADDERR_RIDDUPLICATEMASK_SHIFT                                 1
#define ENET_ADDERR_RIDDUPLICATEMASK_MASK                         0x00000002
#define ENET_ADDERR_RIDDUPLICATEMASK_RD(src)       (((src) & 0x00000002)>>1)
#define ENET_ADDERR_RIDDUPLICATEMASK_WR(src)  (((u32)(src)<<1) & 0x00000002)
#define ENET_ADDERR_RIDDUPLICATEMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields adderr_fullMask    */
#define ENET_ADDERR_FULLMASK_WIDTH                                         1
#define ENET_ADDERR_FULLMASK_SHIFT                                         0
#define ENET_ADDERR_FULLMASK_MASK                                 0x00000001
#define ENET_ADDERR_FULLMASK_RD(src)                  (((src) & 0x00000001))
#define ENET_ADDERR_FULLMASK_WR(src)             (((u32)(src)) & 0x00000001)
#define ENET_ADDERR_FULLMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register sw_int	*/ 
/*	 Fields sw_int	 */
#define ENET_SW_INT_WIDTH                                                  1
#define ENET_SW_INT_SHIFT                                                  0
#define ENET_SW_INT_MASK                                          0x00000001
#define ENET_SW_INT_RD(src)                           (((src) & 0x00000001))
#define ENET_SW_INT_WR(src)                      (((u32)(src)) & 0x00000001)
#define ENET_SW_INT_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register pt_ram0_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_WIDTH                                                     1
#define ENET_RME_SHIFT                                                     2
#define ENET_RME_MASK                                             0x00000004
#define ENET_RME_RD(src)                           (((src) & 0x00000004)>>2)
#define ENET_RME_WR(src)                      (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_WIDTH                                                      2
#define ENET_RM_SHIFT                                                      0
#define ENET_RM_MASK                                              0x00000003
#define ENET_RM_RD(src)                               (((src) & 0x00000003))
#define ENET_RM_WR(src)                          (((u32)(src)) & 0x00000003)
#define ENET_RM_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register pt_ram1_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F1_WIDTH                                                  1
#define ENET_RME_F1_SHIFT                                                  2
#define ENET_RME_F1_MASK                                          0x00000004
#define ENET_RME_F1_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F1_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F1_WIDTH                                                   2
#define ENET_RM_F1_SHIFT                                                   0
#define ENET_RM_F1_MASK                                           0x00000003
#define ENET_RM_F1_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F1_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F1_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register pt_ram2_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F2_WIDTH                                                  1
#define ENET_RME_F2_SHIFT                                                  2
#define ENET_RME_F2_MASK                                          0x00000004
#define ENET_RME_F2_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F2_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F2_WIDTH                                                   2
#define ENET_RM_F2_SHIFT                                                   0
#define ENET_RM_F2_MASK                                           0x00000003
#define ENET_RM_F2_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F2_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F2_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register pt_ram3_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F3_WIDTH                                                  1
#define ENET_RME_F3_SHIFT                                                  2
#define ENET_RME_F3_MASK                                          0x00000004
#define ENET_RME_F3_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F3_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F3_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F3_WIDTH                                                   2
#define ENET_RM_F3_SHIFT                                                   0
#define ENET_RM_F3_MASK                                           0x00000003
#define ENET_RM_F3_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F3_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F3_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register avl_ram0_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F4_WIDTH                                                  1
#define ENET_RME_F4_SHIFT                                                  2
#define ENET_RME_F4_MASK                                          0x00000004
#define ENET_RME_F4_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F4_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F4_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F4_WIDTH                                                   2
#define ENET_RM_F4_SHIFT                                                   0
#define ENET_RM_F4_MASK                                           0x00000003
#define ENET_RM_F4_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F4_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F4_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register avl_ram1_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F5_WIDTH                                                  1
#define ENET_RME_F5_SHIFT                                                  2
#define ENET_RME_F5_MASK                                          0x00000004
#define ENET_RME_F5_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F5_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F5_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F5_WIDTH                                                   2
#define ENET_RM_F5_SHIFT                                                   0
#define ENET_RM_F5_MASK                                           0x00000003
#define ENET_RM_F5_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F5_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F5_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register avl_ram2_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F6_WIDTH                                                  1
#define ENET_RME_F6_SHIFT                                                  2
#define ENET_RME_F6_MASK                                          0x00000004
#define ENET_RME_F6_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F6_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F6_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F6_WIDTH                                                   2
#define ENET_RM_F6_SHIFT                                                   0
#define ENET_RM_F6_MASK                                           0x00000003
#define ENET_RM_F6_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F6_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F6_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register avl_ram3_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F7_WIDTH                                                  1
#define ENET_RME_F7_SHIFT                                                  2
#define ENET_RME_F7_MASK                                          0x00000004
#define ENET_RME_F7_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F7_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F7_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F7_WIDTH                                                   2
#define ENET_RM_F7_SHIFT                                                   0
#define ENET_RM_F7_MASK                                           0x00000003
#define ENET_RM_F7_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F7_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F7_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register db_ram_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F8_WIDTH                                                  1
#define ENET_RME_F8_SHIFT                                                  2
#define ENET_RME_F8_MASK                                          0x00000004
#define ENET_RME_F8_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F8_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F8_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F8_WIDTH                                                   2
#define ENET_RM_F8_SHIFT                                                   0
#define ENET_RM_F8_MASK                                           0x00000003
#define ENET_RM_F8_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F8_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F8_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register ds_ctl	*/ 
/*	 Fields sleep_stat	 */
#define ENET_SLEEP_STAT_WIDTH                                              4
#define ENET_SLEEP_STAT_SHIFT                                             28
#define ENET_SLEEP_STAT_MASK                                      0xf0000000
#define ENET_SLEEP_STAT_RD(src)                   (((src) & 0xf0000000)>>28)
#define ENET_SLEEP_STAT_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields wake_stat	 */
#define ENET_WAKE_STAT_WIDTH                                               4
#define ENET_WAKE_STAT_SHIFT                                              24
#define ENET_WAKE_STAT_MASK                                       0x0f000000
#define ENET_WAKE_STAT_RD(src)                    (((src) & 0x0f000000)>>24)
#define ENET_WAKE_STAT_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields in_progress_stat	 */
#define ENET_IN_PROGRESS_STAT_WIDTH                                        4
#define ENET_IN_PROGRESS_STAT_SHIFT                                       20
#define ENET_IN_PROGRESS_STAT_MASK                                0x00f00000
#define ENET_IN_PROGRESS_STAT_RD(src)             (((src) & 0x00f00000)>>20)
#define ENET_IN_PROGRESS_STAT_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields ram_ds	 */
#define ENET_RAM_DS_WIDTH                                                  1
#define ENET_RAM_DS_SHIFT                                                 19
#define ENET_RAM_DS_MASK                                          0x00080000
#define ENET_RAM_DS_RD(src)                       (((src) & 0x00080000)>>19)
#define ENET_RAM_DS_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields ram_rdy	 */
#define ENET_RAM_RDY_WIDTH                                                 1
#define ENET_RAM_RDY_SHIFT                                                18
#define ENET_RAM_RDY_MASK                                         0x00040000
#define ENET_RAM_RDY_RD(src)                      (((src) & 0x00040000)>>18)
#define ENET_RAM_RDY_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields dis_enet_rx_empty_usage	 */
#define ENET_DIS_ENET_RX_EMPTY_USAGE_WIDTH                                 1
#define ENET_DIS_ENET_RX_EMPTY_USAGE_SHIFT                                17
#define ENET_DIS_ENET_RX_EMPTY_USAGE_MASK                         0x00020000
#define ENET_DIS_ENET_RX_EMPTY_USAGE_RD(src)      (((src) & 0x00020000)>>17)
#define ENET_DIS_ENET_RX_EMPTY_USAGE_WR(src) \
                                                (((u32)(src)<<17) & 0x00020000)
#define ENET_DIS_ENET_RX_EMPTY_USAGE_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields ds_ctl_enable	 */
#define ENET_DS_CTL_ENABLE_WIDTH                                           1
#define ENET_DS_CTL_ENABLE_SHIFT                                          16
#define ENET_DS_CTL_ENABLE_MASK                                   0x00010000
#define ENET_DS_CTL_ENABLE_RD(src)                (((src) & 0x00010000)>>16)
#define ENET_DS_CTL_ENABLE_WR(src)           (((u32)(src)<<16) & 0x00010000)
#define ENET_DS_CTL_ENABLE_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields ds_sleep_timeout_cnt	 */
#define ENET_DS_SLEEP_TIMEOUT_CNT_WIDTH                                    8
#define ENET_DS_SLEEP_TIMEOUT_CNT_SHIFT                                    8
#define ENET_DS_SLEEP_TIMEOUT_CNT_MASK                            0x0000ff00
#define ENET_DS_SLEEP_TIMEOUT_CNT_RD(src)          (((src) & 0x0000ff00)>>8)
#define ENET_DS_SLEEP_TIMEOUT_CNT_WR(src)     (((u32)(src)<<8) & 0x0000ff00)
#define ENET_DS_SLEEP_TIMEOUT_CNT_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields ds_wake_timeout_cnt	 */
#define ENET_DS_WAKE_TIMEOUT_CNT_WIDTH                                     8
#define ENET_DS_WAKE_TIMEOUT_CNT_SHIFT                                     0
#define ENET_DS_WAKE_TIMEOUT_CNT_MASK                             0x000000ff
#define ENET_DS_WAKE_TIMEOUT_CNT_RD(src)              (((src) & 0x000000ff))
#define ENET_DS_WAKE_TIMEOUT_CNT_WR(src)         (((u32)(src)) & 0x000000ff)
#define ENET_DS_WAKE_TIMEOUT_CNT_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register ptram_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_WIDTH                                              9
#define ENET_ERROR_ADDR_SHIFT                                              2
#define ENET_ERROR_ADDR_MASK                                      0x000007fc
#define ENET_ERROR_ADDR_RD(src)                    (((src) & 0x000007fc)>>2)
#define ENET_ERROR_ADDR_WR(src)               (((u32)(src)<<2) & 0x000007fc)
#define ENET_ERROR_ADDR_SET(dst,src) \
                       (((dst) & ~0x000007fc) | (((u32)(src)<<2) & 0x000007fc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_WIDTH                                       1
#define ENET_ERROR_ADDR_ENABLE_SHIFT                                       1
#define ENET_ERROR_ADDR_ENABLE_MASK                               0x00000002
#define ENET_ERROR_ADDR_ENABLE_RD(src)             (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_WR(src)        (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_WIDTH                                 1
#define ENET_FORCE_READ_ERROR_ENABLE_SHIFT                                 0
#define ENET_FORCE_READ_ERROR_ENABLE_MASK                         0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_RD(src)          (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_WR(src)     (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register avlram_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_F1_WIDTH                                           9
#define ENET_ERROR_ADDR_F1_SHIFT                                           2
#define ENET_ERROR_ADDR_F1_MASK                                   0x000007fc
#define ENET_ERROR_ADDR_F1_RD(src)                 (((src) & 0x000007fc)>>2)
#define ENET_ERROR_ADDR_F1_WR(src)            (((u32)(src)<<2) & 0x000007fc)
#define ENET_ERROR_ADDR_F1_SET(dst,src) \
                       (((dst) & ~0x000007fc) | (((u32)(src)<<2) & 0x000007fc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_F1_WIDTH                                    1
#define ENET_ERROR_ADDR_ENABLE_F1_SHIFT                                    1
#define ENET_ERROR_ADDR_ENABLE_F1_MASK                            0x00000002
#define ENET_ERROR_ADDR_ENABLE_F1_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_F1_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_F1_WIDTH                              1
#define ENET_FORCE_READ_ERROR_ENABLE_F1_SHIFT                              0
#define ENET_FORCE_READ_ERROR_ENABLE_F1_MASK                      0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_F1_RD(src)       (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_F1_WR(src)  (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register dbram_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_F2_WIDTH                                          10
#define ENET_ERROR_ADDR_F2_SHIFT                                           2
#define ENET_ERROR_ADDR_F2_MASK                                   0x00000ffc
#define ENET_ERROR_ADDR_F2_RD(src)                 (((src) & 0x00000ffc)>>2)
#define ENET_ERROR_ADDR_F2_WR(src)            (((u32)(src)<<2) & 0x00000ffc)
#define ENET_ERROR_ADDR_F2_SET(dst,src) \
                       (((dst) & ~0x00000ffc) | (((u32)(src)<<2) & 0x00000ffc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_F2_WIDTH                                    1
#define ENET_ERROR_ADDR_ENABLE_F2_SHIFT                                    1
#define ENET_ERROR_ADDR_ENABLE_F2_MASK                            0x00000002
#define ENET_ERROR_ADDR_ENABLE_F2_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_F2_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_F2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_F2_WIDTH                              1
#define ENET_FORCE_READ_ERROR_ENABLE_F2_SHIFT                              0
#define ENET_FORCE_READ_ERROR_ENABLE_F2_MASK                      0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_F2_RD(src)       (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_F2_WR(src)  (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_F2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register snptr0	*/ 
/*	 Fields wol_mode	 */
#define ENET_WOL_MODE0_WIDTH                                               1
#define ENET_WOL_MODE0_SHIFT                                              31
#define ENET_WOL_MODE0_MASK                                       0x80000000
#define ENET_WOL_MODE0_RD(src)                    (((src) & 0x80000000)>>31)
#define ENET_WOL_MODE0_WR(src)               (((u32)(src)<<31) & 0x80000000)
#define ENET_WOL_MODE0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cle_eth_spare	 */
#define ENET_CLE_ETH_SPARE0_WIDTH                                          4
#define ENET_CLE_ETH_SPARE0_SHIFT                                         27
#define ENET_CLE_ETH_SPARE0_MASK                                  0x78000000
#define ENET_CLE_ETH_SPARE0_RD(src)               (((src) & 0x78000000)>>27)
#define ENET_CLE_ETH_SPARE0_WR(src)          (((u32)(src)<<27) & 0x78000000)
#define ENET_CLE_ETH_SPARE0_SET(dst,src) \
                      (((dst) & ~0x78000000) | (((u32)(src)<<27) & 0x78000000))
/*	 Fields snptr	 */
#define ENET_SNPTR0_WIDTH                                                 14
#define ENET_SNPTR0_SHIFT                                                  0
#define ENET_SNPTR0_MASK                                          0x00003fff
#define ENET_SNPTR0_RD(src)                           (((src) & 0x00003fff))
#define ENET_SNPTR0_WR(src)                      (((u32)(src)) & 0x00003fff)
#define ENET_SNPTR0_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register spptr0	*/ 
/*	 Fields spptr	 */
#define ENET_SPPTR0_WIDTH                                                  9
#define ENET_SPPTR0_SHIFT                                                  0
#define ENET_SPPTR0_MASK                                          0x000001ff
#define ENET_SPPTR0_RD(src)                           (((src) & 0x000001ff))
#define ENET_SPPTR0_WR(src)                      (((u32)(src)) & 0x000001ff)
#define ENET_SPPTR0_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register dfclsresdbptr0	*/ 
/*	 Fields dfclsresdbpriority	 */
#define ENET_DFCLSRESDBPRIORITY0_WIDTH                                     3
#define ENET_DFCLSRESDBPRIORITY0_SHIFT                                    10
#define ENET_DFCLSRESDBPRIORITY0_MASK                             0x00001c00
#define ENET_DFCLSRESDBPRIORITY0_RD(src)          (((src) & 0x00001c00)>>10)
#define ENET_DFCLSRESDBPRIORITY0_WR(src)     (((u32)(src)<<10) & 0x00001c00)
#define ENET_DFCLSRESDBPRIORITY0_SET(dst,src) \
                      (((dst) & ~0x00001c00) | (((u32)(src)<<10) & 0x00001c00))
/*	 Fields dfclsresdbptr	 */
#define ENET_DFCLSRESDBPTR0_WIDTH                                         10
#define ENET_DFCLSRESDBPTR0_SHIFT                                          0
#define ENET_DFCLSRESDBPTR0_MASK                                  0x000003ff
#define ENET_DFCLSRESDBPTR0_RD(src)                   (((src) & 0x000003ff))
#define ENET_DFCLSRESDBPTR0_WR(src)              (((u32)(src)) & 0x000003ff)
#define ENET_DFCLSRESDBPTR0_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register dfclsresdb0_0	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB0_WIDTH                                            32
#define ENET_DFCLSRESDB0_SHIFT                                             0
#define ENET_DFCLSRESDB0_MASK                                     0xffffffff
#define ENET_DFCLSRESDB0_RD(src)                      (((src) & 0xffffffff))
#define ENET_DFCLSRESDB0_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb0_1	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB1_WIDTH                                            32
#define ENET_DFCLSRESDB1_SHIFT                                             0
#define ENET_DFCLSRESDB1_MASK                                     0xffffffff
#define ENET_DFCLSRESDB1_RD(src)                      (((src) & 0xffffffff))
#define ENET_DFCLSRESDB1_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb0_2	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB2_WIDTH                                            32
#define ENET_DFCLSRESDB2_SHIFT                                             0
#define ENET_DFCLSRESDB2_MASK                                     0xffffffff
#define ENET_DFCLSRESDB2_RD(src)                      (((src) & 0xffffffff))
#define ENET_DFCLSRESDB2_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb0_3	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB3_WIDTH                                            32
#define ENET_DFCLSRESDB3_SHIFT                                             0
#define ENET_DFCLSRESDB3_MASK                                     0xffffffff
#define ENET_DFCLSRESDB3_RD(src)                      (((src) & 0xffffffff))
#define ENET_DFCLSRESDB3_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb0_4	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB4_WIDTH                                            32
#define ENET_DFCLSRESDB4_SHIFT                                             0
#define ENET_DFCLSRESDB4_MASK                                     0xffffffff
#define ENET_DFCLSRESDB4_RD(src)                      (((src) & 0xffffffff))
#define ENET_DFCLSRESDB4_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb0_5	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB5_WIDTH                                            32
#define ENET_DFCLSRESDB5_SHIFT                                             0
#define ENET_DFCLSRESDB5_MASK                                     0xffffffff
#define ENET_DFCLSRESDB5_RD(src)                      (((src) & 0xffffffff))
#define ENET_DFCLSRESDB5_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB5_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register parser_ctl0	*/ 
/*	 Fields pkt_data_msk_en	 */
#define ENET_PKT_DATA_MSK_EN0_WIDTH                                        1
#define ENET_PKT_DATA_MSK_EN0_SHIFT                                       31
#define ENET_PKT_DATA_MSK_EN0_MASK                                0x80000000
#define ENET_PKT_DATA_MSK_EN0_RD(src)             (((src) & 0x80000000)>>31)
#define ENET_PKT_DATA_MSK_EN0_WR(src)        (((u32)(src)<<31) & 0x80000000)
#define ENET_PKT_DATA_MSK_EN0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields use_default_ptr_as_nxt_dec_ptr	 */
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR0_WIDTH                         1
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR0_SHIFT                        30
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR0_MASK                 0x40000000
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR0_RD(src) \
                                                    (((src) & 0x40000000)>>30)
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR0_WR(src) \
                                                (((u32)(src)<<30) & 0x40000000)
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR0_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields parser_halt	 */
#define ENET_PARSER_HALT0_WIDTH                                            1
#define ENET_PARSER_HALT0_SHIFT                                            0
#define ENET_PARSER_HALT0_MASK                                    0x00000001
#define ENET_PARSER_HALT0_RD(src)                     (((src) & 0x00000001))
#define ENET_PARSER_HALT0_WR(src)                (((u32)(src)) & 0x00000001)
#define ENET_PARSER_HALT0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register tmaxhop0	*/ 
/*	 Fields tmaxhop	 */
#define ENET_TMAXHOP0_WIDTH                                                8
#define ENET_TMAXHOP0_SHIFT                                                0
#define ENET_TMAXHOP0_MASK                                        0x000000ff
#define ENET_TMAXHOP0_RD(src)                         (((src) & 0x000000ff))
#define ENET_TMAXHOP0_WR(src)                    (((u32)(src)) & 0x000000ff)
#define ENET_TMAXHOP0_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register portnum0	*/ 
/*	 Fields portnum0	 */
#define ENET_PORTNUM00_WIDTH                                               8
#define ENET_PORTNUM00_SHIFT                                               0
#define ENET_PORTNUM00_MASK                                       0x000000ff
#define ENET_PORTNUM00_RD(src)                        (((src) & 0x000000ff))
#define ENET_PORTNUM00_WR(src)                   (((u32)(src)) & 0x000000ff)
#define ENET_PORTNUM00_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register rss_ctrl0	*/ 
/*	 Fields ipv6_hashtype	 */
#define ENET_IPV6_HASHTYPE0_WIDTH                                          2
#define ENET_IPV6_HASHTYPE0_SHIFT                                          3
#define ENET_IPV6_HASHTYPE0_MASK                                  0x00000018
#define ENET_IPV6_HASHTYPE0_RD(src)                (((src) & 0x00000018)>>3)
#define ENET_IPV6_HASHTYPE0_WR(src)           (((u32)(src)<<3) & 0x00000018)
#define ENET_IPV6_HASHTYPE0_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields ipv4_hashtype	 */
#define ENET_IPV4_HASHTYPE0_WIDTH                                          2
#define ENET_IPV4_HASHTYPE0_SHIFT                                          1
#define ENET_IPV4_HASHTYPE0_MASK                                  0x00000006
#define ENET_IPV4_HASHTYPE0_RD(src)                (((src) & 0x00000006)>>1)
#define ENET_IPV4_HASHTYPE0_WR(src)           (((u32)(src)<<1) & 0x00000006)
#define ENET_IPV4_HASHTYPE0_SET(dst,src) \
                       (((dst) & ~0x00000006) | (((u32)(src)<<1) & 0x00000006))
/*	 Fields enable	 */
#define ENET_ENABLE0_WIDTH                                                 1
#define ENET_ENABLE0_SHIFT                                                 0
#define ENET_ENABLE0_MASK                                         0x00000001
#define ENET_ENABLE0_RD(src)                          (((src) & 0x00000001))
#define ENET_ENABLE0_WR(src)                     (((u32)(src)) & 0x00000001)
#define ENET_ENABLE0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register parser_status0	*/ 
/*	 Fields itableErr	 */
#define ENET_ITABLEERR0_WIDTH                                              1
#define ENET_ITABLEERR0_SHIFT                                              8
#define ENET_ITABLEERR0_MASK                                      0x00000100
#define ENET_ITABLEERR0_RD(src)                    (((src) & 0x00000100)>>8)
#define ENET_ITABLEERR0_WR(src)               (((u32)(src)<<8) & 0x00000100)
#define ENET_ITABLEERR0_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields SrchDbRamErr	 */
#define ENET_SRCHDBRAMERR0_WIDTH                                           1
#define ENET_SRCHDBRAMERR0_SHIFT                                           7
#define ENET_SRCHDBRAMERR0_MASK                                   0x00000080
#define ENET_SRCHDBRAMERR0_RD(src)                 (((src) & 0x00000080)>>7)
#define ENET_SRCHDBRAMERR0_WR(src)            (((u32)(src)<<7) & 0x00000080)
#define ENET_SRCHDBRAMERR0_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields PrsrDbRamErr	 */
#define ENET_PRSRDBRAMERR0_WIDTH                                           1
#define ENET_PRSRDBRAMERR0_SHIFT                                           6
#define ENET_PRSRDBRAMERR0_MASK                                   0x00000040
#define ENET_PRSRDBRAMERR0_RD(src)                 (((src) & 0x00000040)>>6)
#define ENET_PRSRDBRAMERR0_WR(src)            (((u32)(src)<<6) & 0x00000040)
#define ENET_PRSRDBRAMERR0_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields PktRamErr	 */
#define ENET_PKTRAMERR0_WIDTH                                              1
#define ENET_PKTRAMERR0_SHIFT                                              5
#define ENET_PKTRAMERR0_MASK                                      0x00000020
#define ENET_PKTRAMERR0_RD(src)                    (((src) & 0x00000020)>>5)
#define ENET_PKTRAMERR0_WR(src)               (((u32)(src)<<5) & 0x00000020)
#define ENET_PKTRAMERR0_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields PTRamErr	 */
#define ENET_PTRAMERR0_WIDTH                                               1
#define ENET_PTRAMERR0_SHIFT                                               4
#define ENET_PTRAMERR0_MASK                                       0x00000010
#define ENET_PTRAMERR0_RD(src)                     (((src) & 0x00000010)>>4)
#define ENET_PTRAMERR0_WR(src)                (((u32)(src)<<4) & 0x00000010)
#define ENET_PTRAMERR0_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields PrsrInvMSBStrErr	 */
#define ENET_PRSRINVMSBSTRERR0_WIDTH                                       1
#define ENET_PRSRINVMSBSTRERR0_SHIFT                                       3
#define ENET_PRSRINVMSBSTRERR0_MASK                               0x00000008
#define ENET_PRSRINVMSBSTRERR0_RD(src)             (((src) & 0x00000008)>>3)
#define ENET_PRSRINVMSBSTRERR0_WR(src)        (((u32)(src)<<3) & 0x00000008)
#define ENET_PRSRINVMSBSTRERR0_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields PktOffsetExEop	 */
#define ENET_PKTOFFSETEXEOP0_WIDTH                                         1
#define ENET_PKTOFFSETEXEOP0_SHIFT                                         2
#define ENET_PKTOFFSETEXEOP0_MASK                                 0x00000004
#define ENET_PKTOFFSETEXEOP0_RD(src)               (((src) & 0x00000004)>>2)
#define ENET_PKTOFFSETEXEOP0_WR(src)          (((u32)(src)<<2) & 0x00000004)
#define ENET_PKTOFFSETEXEOP0_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields maxhoperr	 */
#define ENET_MAXHOPERR0_WIDTH                                              1
#define ENET_MAXHOPERR0_SHIFT                                              1
#define ENET_MAXHOPERR0_MASK                                      0x00000002
#define ENET_MAXHOPERR0_RD(src)                    (((src) & 0x00000002)>>1)
#define ENET_MAXHOPERR0_WR(src)               (((u32)(src)<<1) & 0x00000002)
#define ENET_MAXHOPERR0_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields parser_halt_status	 */
#define ENET_PARSER_HALT_STATUS0_WIDTH                                     1
#define ENET_PARSER_HALT_STATUS0_SHIFT                                     0
#define ENET_PARSER_HALT_STATUS0_MASK                             0x00000001
#define ENET_PARSER_HALT_STATUS0_RD(src)              (((src) & 0x00000001))
#define ENET_PARSER_HALT_STATUS0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register parser_status0Mask	*/
/*    Mask Register Fields itableErrMask    */
#define ENET_ITABLEERRMASK_WIDTH                                           1
#define ENET_ITABLEERRMASK_SHIFT                                           8
#define ENET_ITABLEERRMASK_MASK                                   0x00000100
#define ENET_ITABLEERRMASK_RD(src)                 (((src) & 0x00000100)>>8)
#define ENET_ITABLEERRMASK_WR(src)            (((u32)(src)<<8) & 0x00000100)
#define ENET_ITABLEERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields SrchDbRamErrMask    */
#define ENET_SRCHDBRAMERRMASK_WIDTH                                        1
#define ENET_SRCHDBRAMERRMASK_SHIFT                                        7
#define ENET_SRCHDBRAMERRMASK_MASK                                0x00000080
#define ENET_SRCHDBRAMERRMASK_RD(src)              (((src) & 0x00000080)>>7)
#define ENET_SRCHDBRAMERRMASK_WR(src)         (((u32)(src)<<7) & 0x00000080)
#define ENET_SRCHDBRAMERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields PrsrDbRamErrMask    */
#define ENET_PRSRDBRAMERRMASK_WIDTH                                        1
#define ENET_PRSRDBRAMERRMASK_SHIFT                                        6
#define ENET_PRSRDBRAMERRMASK_MASK                                0x00000040
#define ENET_PRSRDBRAMERRMASK_RD(src)              (((src) & 0x00000040)>>6)
#define ENET_PRSRDBRAMERRMASK_WR(src)         (((u32)(src)<<6) & 0x00000040)
#define ENET_PRSRDBRAMERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields PktRamErrMask    */
#define ENET_PKTRAMERRMASK_WIDTH                                           1
#define ENET_PKTRAMERRMASK_SHIFT                                           5
#define ENET_PKTRAMERRMASK_MASK                                   0x00000020
#define ENET_PKTRAMERRMASK_RD(src)                 (((src) & 0x00000020)>>5)
#define ENET_PKTRAMERRMASK_WR(src)            (((u32)(src)<<5) & 0x00000020)
#define ENET_PKTRAMERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields PTRamErrMask    */
#define ENET_PTRAMERRMASK_WIDTH                                            1
#define ENET_PTRAMERRMASK_SHIFT                                            4
#define ENET_PTRAMERRMASK_MASK                                    0x00000010
#define ENET_PTRAMERRMASK_RD(src)                  (((src) & 0x00000010)>>4)
#define ENET_PTRAMERRMASK_WR(src)             (((u32)(src)<<4) & 0x00000010)
#define ENET_PTRAMERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields PrsrInvMSBStrErrMask    */
#define ENET_PRSRINVMSBSTRERRMASK_WIDTH                                    1
#define ENET_PRSRINVMSBSTRERRMASK_SHIFT                                    3
#define ENET_PRSRINVMSBSTRERRMASK_MASK                            0x00000008
#define ENET_PRSRINVMSBSTRERRMASK_RD(src)          (((src) & 0x00000008)>>3)
#define ENET_PRSRINVMSBSTRERRMASK_WR(src)     (((u32)(src)<<3) & 0x00000008)
#define ENET_PRSRINVMSBSTRERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields PktOffsetExEopMask    */
#define ENET_PKTOFFSETEXEOPMASK_WIDTH                                      1
#define ENET_PKTOFFSETEXEOPMASK_SHIFT                                      2
#define ENET_PKTOFFSETEXEOPMASK_MASK                              0x00000004
#define ENET_PKTOFFSETEXEOPMASK_RD(src)            (((src) & 0x00000004)>>2)
#define ENET_PKTOFFSETEXEOPMASK_WR(src)       (((u32)(src)<<2) & 0x00000004)
#define ENET_PKTOFFSETEXEOPMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields maxhoperrMask    */
#define ENET_MAXHOPERRMASK_WIDTH                                           1
#define ENET_MAXHOPERRMASK_SHIFT                                           1
#define ENET_MAXHOPERRMASK_MASK                                   0x00000002
#define ENET_MAXHOPERRMASK_RD(src)                 (((src) & 0x00000002)>>1)
#define ENET_MAXHOPERRMASK_WR(src)            (((u32)(src)<<1) & 0x00000002)
#define ENET_MAXHOPERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields parser_halt_statusMask    */
#define ENET_PARSER_HALT_STATUSMASK_WIDTH                                  1
#define ENET_PARSER_HALT_STATUSMASK_SHIFT                                  0
#define ENET_PARSER_HALT_STATUSMASK_MASK                          0x00000001
#define ENET_PARSER_HALT_STATUSMASK_RD(src)           (((src) & 0x00000001))
#define ENET_PARSER_HALT_STATUSMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register snptr_change_status0	*/ 
/*	 Fields snptr_change_done	 */
#define ENET_SNPTR_CHANGE_DONE0_WIDTH                                      1
#define ENET_SNPTR_CHANGE_DONE0_SHIFT                                      0
#define ENET_SNPTR_CHANGE_DONE0_MASK                              0x00000001
#define ENET_SNPTR_CHANGE_DONE0_RD(src)               (((src) & 0x00000001))
#define ENET_SNPTR_CHANGE_DONE0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register itable0_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_F3_WIDTH                                           7
#define ENET_ERROR_ADDR_F3_SHIFT                                           2
#define ENET_ERROR_ADDR_F3_MASK                                   0x000001fc
#define ENET_ERROR_ADDR_F3_RD(src)                 (((src) & 0x000001fc)>>2)
#define ENET_ERROR_ADDR_F3_WR(src)            (((u32)(src)<<2) & 0x000001fc)
#define ENET_ERROR_ADDR_F3_SET(dst,src) \
                       (((dst) & ~0x000001fc) | (((u32)(src)<<2) & 0x000001fc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_F3_WIDTH                                    1
#define ENET_ERROR_ADDR_ENABLE_F3_SHIFT                                    1
#define ENET_ERROR_ADDR_ENABLE_F3_MASK                            0x00000002
#define ENET_ERROR_ADDR_ENABLE_F3_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_F3_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_F3_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_F3_WIDTH                              1
#define ENET_FORCE_READ_ERROR_ENABLE_F3_SHIFT                              0
#define ENET_FORCE_READ_ERROR_ENABLE_F3_MASK                      0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_F3_RD(src)       (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_F3_WR(src)  (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_F3_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register pktram0_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_F4_WIDTH                                           6
#define ENET_ERROR_ADDR_F4_SHIFT                                           2
#define ENET_ERROR_ADDR_F4_MASK                                   0x000000fc
#define ENET_ERROR_ADDR_F4_RD(src)                 (((src) & 0x000000fc)>>2)
#define ENET_ERROR_ADDR_F4_WR(src)            (((u32)(src)<<2) & 0x000000fc)
#define ENET_ERROR_ADDR_F4_SET(dst,src) \
                       (((dst) & ~0x000000fc) | (((u32)(src)<<2) & 0x000000fc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_F4_WIDTH                                    1
#define ENET_ERROR_ADDR_ENABLE_F4_SHIFT                                    1
#define ENET_ERROR_ADDR_ENABLE_F4_MASK                            0x00000002
#define ENET_ERROR_ADDR_ENABLE_F4_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_F4_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_F4_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_F4_WIDTH                              1
#define ENET_FORCE_READ_ERROR_ENABLE_F4_SHIFT                              0
#define ENET_FORCE_READ_ERROR_ENABLE_F4_MASK                      0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_F4_RD(src)       (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_F4_WR(src)  (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_F4_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register itable0_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F9_WIDTH                                                  1
#define ENET_RME_F9_SHIFT                                                  2
#define ENET_RME_F9_MASK                                          0x00000004
#define ENET_RME_F9_RD(src)                        (((src) & 0x00000004)>>2)
#define ENET_RME_F9_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F9_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F9_WIDTH                                                   2
#define ENET_RM_F9_SHIFT                                                   0
#define ENET_RM_F9_MASK                                           0x00000003
#define ENET_RM_F9_RD(src)                            (((src) & 0x00000003))
#define ENET_RM_F9_WR(src)                       (((u32)(src)) & 0x00000003)
#define ENET_RM_F9_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register lstnvst0	*/ 
/*	 Fields lstnvst	 */
#define ENET_LSTNVST0_WIDTH                                               14
#define ENET_LSTNVST0_SHIFT                                                0
#define ENET_LSTNVST0_MASK                                        0x00003fff
#define ENET_LSTNVST0_RD(src)                         (((src) & 0x00003fff))
#define ENET_LSTNVST0_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_0	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST0_WIDTH                                              14
#define ENET_LTRCNVST0_SHIFT                                               0
#define ENET_LTRCNVST0_MASK                                       0x00003fff
#define ENET_LTRCNVST0_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST0_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_1	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST1_WIDTH                                              14
#define ENET_LTRCNVST1_SHIFT                                               0
#define ENET_LTRCNVST1_MASK                                       0x00003fff
#define ENET_LTRCNVST1_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_2	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST2_WIDTH                                              14
#define ENET_LTRCNVST2_SHIFT                                               0
#define ENET_LTRCNVST2_MASK                                       0x00003fff
#define ENET_LTRCNVST2_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_3	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST3_WIDTH                                              14
#define ENET_LTRCNVST3_SHIFT                                               0
#define ENET_LTRCNVST3_MASK                                       0x00003fff
#define ENET_LTRCNVST3_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_4	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST4_WIDTH                                              14
#define ENET_LTRCNVST4_SHIFT                                               0
#define ENET_LTRCNVST4_MASK                                       0x00003fff
#define ENET_LTRCNVST4_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST4_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_5	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST5_WIDTH                                              14
#define ENET_LTRCNVST5_SHIFT                                               0
#define ENET_LTRCNVST5_MASK                                       0x00003fff
#define ENET_LTRCNVST5_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST5_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_6	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST6_WIDTH                                              14
#define ENET_LTRCNVST6_SHIFT                                               0
#define ENET_LTRCNVST6_MASK                                       0x00003fff
#define ENET_LTRCNVST6_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST6_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_7	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST7_WIDTH                                              14
#define ENET_LTRCNVST7_SHIFT                                               0
#define ENET_LTRCNVST7_MASK                                       0x00003fff
#define ENET_LTRCNVST7_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST7_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_8	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST8_WIDTH                                              14
#define ENET_LTRCNVST8_SHIFT                                               0
#define ENET_LTRCNVST8_MASK                                       0x00003fff
#define ENET_LTRCNVST8_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST8_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_9	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST9_WIDTH                                              14
#define ENET_LTRCNVST9_SHIFT                                               0
#define ENET_LTRCNVST9_MASK                                       0x00003fff
#define ENET_LTRCNVST9_RD(src)                        (((src) & 0x00003fff))
#define ENET_LTRCNVST9_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_10	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST0_F1_WIDTH                                           14
#define ENET_LTRCNVST0_F1_SHIFT                                            0
#define ENET_LTRCNVST0_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST0_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST0_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_11	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST1_F1_WIDTH                                           14
#define ENET_LTRCNVST1_F1_SHIFT                                            0
#define ENET_LTRCNVST1_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST1_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST1_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_12	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST2_F1_WIDTH                                           14
#define ENET_LTRCNVST2_F1_SHIFT                                            0
#define ENET_LTRCNVST2_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST2_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST2_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_13	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST3_F1_WIDTH                                           14
#define ENET_LTRCNVST3_F1_SHIFT                                            0
#define ENET_LTRCNVST3_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST3_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST3_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_14	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST4_F1_WIDTH                                           14
#define ENET_LTRCNVST4_F1_SHIFT                                            0
#define ENET_LTRCNVST4_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST4_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST4_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst0_15	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST5_F1_WIDTH                                           14
#define ENET_LTRCNVST5_F1_SHIFT                                            0
#define ENET_LTRCNVST5_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST5_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST5_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvststr0_0	*/ 
/*	 Fields ftrcnvststrt	 */
#define ENET_FTRCNVSTSTRT0_WIDTH                                          14
#define ENET_FTRCNVSTSTRT0_SHIFT                                           0
#define ENET_FTRCNVSTSTRT0_MASK                                   0x00003fff
#define ENET_FTRCNVSTSTRT0_RD(src)                    (((src) & 0x00003fff))
#define ENET_FTRCNVSTSTRT0_WR(src)               (((u32)(src)) & 0x00003fff)
#define ENET_FTRCNVSTSTRT0_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_0	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST0_WIDTH                                              14
#define ENET_FTRCNVST0_SHIFT                                               0
#define ENET_FTRCNVST0_MASK                                       0x00003fff
#define ENET_FTRCNVST0_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST0_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_1	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST1_WIDTH                                              14
#define ENET_FTRCNVST1_SHIFT                                               0
#define ENET_FTRCNVST1_MASK                                       0x00003fff
#define ENET_FTRCNVST1_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_2	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST2_WIDTH                                              14
#define ENET_FTRCNVST2_SHIFT                                               0
#define ENET_FTRCNVST2_MASK                                       0x00003fff
#define ENET_FTRCNVST2_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_3	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST3_WIDTH                                              14
#define ENET_FTRCNVST3_SHIFT                                               0
#define ENET_FTRCNVST3_MASK                                       0x00003fff
#define ENET_FTRCNVST3_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_4	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST4_WIDTH                                              14
#define ENET_FTRCNVST4_SHIFT                                               0
#define ENET_FTRCNVST4_MASK                                       0x00003fff
#define ENET_FTRCNVST4_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST4_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_5	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST5_WIDTH                                              14
#define ENET_FTRCNVST5_SHIFT                                               0
#define ENET_FTRCNVST5_MASK                                       0x00003fff
#define ENET_FTRCNVST5_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST5_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_6	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST6_WIDTH                                              14
#define ENET_FTRCNVST6_SHIFT                                               0
#define ENET_FTRCNVST6_MASK                                       0x00003fff
#define ENET_FTRCNVST6_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST6_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_7	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST7_WIDTH                                              14
#define ENET_FTRCNVST7_SHIFT                                               0
#define ENET_FTRCNVST7_MASK                                       0x00003fff
#define ENET_FTRCNVST7_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST7_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_8	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST8_WIDTH                                              14
#define ENET_FTRCNVST8_SHIFT                                               0
#define ENET_FTRCNVST8_MASK                                       0x00003fff
#define ENET_FTRCNVST8_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST8_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_9	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST9_WIDTH                                              14
#define ENET_FTRCNVST9_SHIFT                                               0
#define ENET_FTRCNVST9_MASK                                       0x00003fff
#define ENET_FTRCNVST9_RD(src)                        (((src) & 0x00003fff))
#define ENET_FTRCNVST9_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_10	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST0_F1_WIDTH                                           14
#define ENET_FTRCNVST0_F1_SHIFT                                            0
#define ENET_FTRCNVST0_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST0_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST0_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_11	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST1_F1_WIDTH                                           14
#define ENET_FTRCNVST1_F1_SHIFT                                            0
#define ENET_FTRCNVST1_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST1_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST1_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_12	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST2_F1_WIDTH                                           14
#define ENET_FTRCNVST2_F1_SHIFT                                            0
#define ENET_FTRCNVST2_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST2_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST2_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_13	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST3_F1_WIDTH                                           14
#define ENET_FTRCNVST3_F1_SHIFT                                            0
#define ENET_FTRCNVST3_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST3_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST3_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_14	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST4_F1_WIDTH                                           14
#define ENET_FTRCNVST4_F1_SHIFT                                            0
#define ENET_FTRCNVST4_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST4_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST4_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst0_15	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST5_F1_WIDTH                                           14
#define ENET_FTRCNVST5_F1_SHIFT                                            0
#define ENET_FTRCNVST5_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST5_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST5_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmon0_0	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON0_WIDTH                                            14
#define ENET_TRCNVSTMON0_SHIFT                                             0
#define ENET_TRCNVSTMON0_MASK                                     0x00003fff
#define ENET_TRCNVSTMON0_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON0_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON0_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_0	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT0_WIDTH                                         32
#define ENET_TRCNVSTMONCNT0_SHIFT                                          0
#define ENET_TRCNVSTMONCNT0_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT0_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_1	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON1_WIDTH                                            14
#define ENET_TRCNVSTMON1_SHIFT                                             0
#define ENET_TRCNVSTMON1_MASK                                     0x00003fff
#define ENET_TRCNVSTMON1_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON1_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_1	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT1_WIDTH                                         32
#define ENET_TRCNVSTMONCNT1_SHIFT                                          0
#define ENET_TRCNVSTMONCNT1_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT1_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_2	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON2_WIDTH                                            14
#define ENET_TRCNVSTMON2_SHIFT                                             0
#define ENET_TRCNVSTMON2_MASK                                     0x00003fff
#define ENET_TRCNVSTMON2_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON2_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_2	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT2_WIDTH                                         32
#define ENET_TRCNVSTMONCNT2_SHIFT                                          0
#define ENET_TRCNVSTMONCNT2_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT2_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_3	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON3_WIDTH                                            14
#define ENET_TRCNVSTMON3_SHIFT                                             0
#define ENET_TRCNVSTMON3_MASK                                     0x00003fff
#define ENET_TRCNVSTMON3_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON3_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_3	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT3_WIDTH                                         32
#define ENET_TRCNVSTMONCNT3_SHIFT                                          0
#define ENET_TRCNVSTMONCNT3_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT3_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_4	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON4_WIDTH                                            14
#define ENET_TRCNVSTMON4_SHIFT                                             0
#define ENET_TRCNVSTMON4_MASK                                     0x00003fff
#define ENET_TRCNVSTMON4_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON4_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON4_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_4	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT4_WIDTH                                         32
#define ENET_TRCNVSTMONCNT4_SHIFT                                          0
#define ENET_TRCNVSTMONCNT4_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT4_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT4_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_5	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON5_WIDTH                                            14
#define ENET_TRCNVSTMON5_SHIFT                                             0
#define ENET_TRCNVSTMON5_MASK                                     0x00003fff
#define ENET_TRCNVSTMON5_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON5_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON5_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_5	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT5_WIDTH                                         32
#define ENET_TRCNVSTMONCNT5_SHIFT                                          0
#define ENET_TRCNVSTMONCNT5_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT5_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT5_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_6	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON6_WIDTH                                            14
#define ENET_TRCNVSTMON6_SHIFT                                             0
#define ENET_TRCNVSTMON6_MASK                                     0x00003fff
#define ENET_TRCNVSTMON6_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON6_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON6_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_6	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT6_WIDTH                                         32
#define ENET_TRCNVSTMONCNT6_SHIFT                                          0
#define ENET_TRCNVSTMONCNT6_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT6_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT6_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_7	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON7_WIDTH                                            14
#define ENET_TRCNVSTMON7_SHIFT                                             0
#define ENET_TRCNVSTMON7_MASK                                     0x00003fff
#define ENET_TRCNVSTMON7_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON7_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON7_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_7	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT7_WIDTH                                         32
#define ENET_TRCNVSTMONCNT7_SHIFT                                          0
#define ENET_TRCNVSTMONCNT7_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT7_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT7_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_8	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON8_WIDTH                                            14
#define ENET_TRCNVSTMON8_SHIFT                                             0
#define ENET_TRCNVSTMON8_MASK                                     0x00003fff
#define ENET_TRCNVSTMON8_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON8_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON8_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_8	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT8_WIDTH                                         32
#define ENET_TRCNVSTMONCNT8_SHIFT                                          0
#define ENET_TRCNVSTMONCNT8_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT8_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT8_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_9	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON9_WIDTH                                            14
#define ENET_TRCNVSTMON9_SHIFT                                             0
#define ENET_TRCNVSTMON9_MASK                                     0x00003fff
#define ENET_TRCNVSTMON9_RD(src)                      (((src) & 0x00003fff))
#define ENET_TRCNVSTMON9_WR(src)                 (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON9_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_9	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT9_WIDTH                                         32
#define ENET_TRCNVSTMONCNT9_SHIFT                                          0
#define ENET_TRCNVSTMONCNT9_MASK                                  0xffffffff
#define ENET_TRCNVSTMONCNT9_RD(src)                   (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT9_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_10	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON0_F1_WIDTH                                         14
#define ENET_TRCNVSTMON0_F1_SHIFT                                          0
#define ENET_TRCNVSTMON0_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON0_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON0_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON0_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_10	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT0_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT0_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT0_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT0_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_11	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON1_F1_WIDTH                                         14
#define ENET_TRCNVSTMON1_F1_SHIFT                                          0
#define ENET_TRCNVSTMON1_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON1_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON1_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON1_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_11	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT1_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT1_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT1_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT1_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_12	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON2_F1_WIDTH                                         14
#define ENET_TRCNVSTMON2_F1_SHIFT                                          0
#define ENET_TRCNVSTMON2_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON2_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON2_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON2_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_12	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT2_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT2_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT2_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT2_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT2_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_13	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON3_F1_WIDTH                                         14
#define ENET_TRCNVSTMON3_F1_SHIFT                                          0
#define ENET_TRCNVSTMON3_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON3_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON3_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON3_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_13	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT3_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT3_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT3_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT3_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT3_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_14	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON4_F1_WIDTH                                         14
#define ENET_TRCNVSTMON4_F1_SHIFT                                          0
#define ENET_TRCNVSTMON4_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON4_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON4_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON4_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_14	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT4_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT4_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT4_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT4_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT4_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon0_15	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON5_F1_WIDTH                                         14
#define ENET_TRCNVSTMON5_F1_SHIFT                                          0
#define ENET_TRCNVSTMON5_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON5_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON5_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON5_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt0_15	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT5_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT5_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT5_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT5_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT5_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register hash_diag_ctl0	*/ 
/*	 Fields Hash_Result_Diagnostic_Enable	 */
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE0_WIDTH                          1
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE0_SHIFT                          0
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE0_MASK                  0x00000001
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE0_RD(src)   (((src) & 0x00000001))
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE0_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register hash_seed_default0	*/ 
/*	 Fields Hash_Seed_Default	 */
#define ENET_HASH_SEED_DEFAULT0_WIDTH                                     32
#define ENET_HASH_SEED_DEFAULT0_SHIFT                                      0
#define ENET_HASH_SEED_DEFAULT0_MASK                              0xffffffff
#define ENET_HASH_SEED_DEFAULT0_RD(src)               (((src) & 0xffffffff))
#define ENET_HASH_SEED_DEFAULT0_WR(src)          (((u32)(src)) & 0xffffffff)
#define ENET_HASH_SEED_DEFAULT0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register hash_result_diag0	*/ 
/*	 Fields Hash_Result_Diagnostic	 */
#define ENET_HASH_RESULT_DIAGNOSTIC0_WIDTH                                32
#define ENET_HASH_RESULT_DIAGNOSTIC0_SHIFT                                 0
#define ENET_HASH_RESULT_DIAGNOSTIC0_MASK                         0xffffffff
#define ENET_HASH_RESULT_DIAGNOSTIC0_RD(src)          (((src) & 0xffffffff))
#define ENET_HASH_RESULT_DIAGNOSTIC0_WR(src)     (((u32)(src)) & 0xffffffff)
#define ENET_HASH_RESULT_DIAGNOSTIC0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register snptr1	*/ 
/*	 Fields wol_mode	 */
#define ENET_WOL_MODE1_WIDTH                                               1
#define ENET_WOL_MODE1_SHIFT                                              31
#define ENET_WOL_MODE1_MASK                                       0x80000000
#define ENET_WOL_MODE1_RD(src)                    (((src) & 0x80000000)>>31)
#define ENET_WOL_MODE1_WR(src)               (((u32)(src)<<31) & 0x80000000)
#define ENET_WOL_MODE1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields cle_eth_spare	 */
#define ENET_CLE_ETH_SPARE1_WIDTH                                          4
#define ENET_CLE_ETH_SPARE1_SHIFT                                         27
#define ENET_CLE_ETH_SPARE1_MASK                                  0x78000000
#define ENET_CLE_ETH_SPARE1_RD(src)               (((src) & 0x78000000)>>27)
#define ENET_CLE_ETH_SPARE1_WR(src)          (((u32)(src)<<27) & 0x78000000)
#define ENET_CLE_ETH_SPARE1_SET(dst,src) \
                      (((dst) & ~0x78000000) | (((u32)(src)<<27) & 0x78000000))
/*	 Fields snptr	 */
#define ENET_SNPTR1_WIDTH                                                 14
#define ENET_SNPTR1_SHIFT                                                  0
#define ENET_SNPTR1_MASK                                          0x00003fff
#define ENET_SNPTR1_RD(src)                           (((src) & 0x00003fff))
#define ENET_SNPTR1_WR(src)                      (((u32)(src)) & 0x00003fff)
#define ENET_SNPTR1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register spptr1	*/ 
/*	 Fields spptr	 */
#define ENET_SPPTR1_WIDTH                                                  9
#define ENET_SPPTR1_SHIFT                                                  0
#define ENET_SPPTR1_MASK                                          0x000001ff
#define ENET_SPPTR1_RD(src)                           (((src) & 0x000001ff))
#define ENET_SPPTR1_WR(src)                      (((u32)(src)) & 0x000001ff)
#define ENET_SPPTR1_SET(dst,src) \
                          (((dst) & ~0x000001ff) | (((u32)(src)) & 0x000001ff))

/*	Register dfclsresdbptr1	*/ 
/*	 Fields dfclsresdbpriority	 */
#define ENET_DFCLSRESDBPRIORITY1_WIDTH                                     3
#define ENET_DFCLSRESDBPRIORITY1_SHIFT                                    10
#define ENET_DFCLSRESDBPRIORITY1_MASK                             0x00001c00
#define ENET_DFCLSRESDBPRIORITY1_RD(src)          (((src) & 0x00001c00)>>10)
#define ENET_DFCLSRESDBPRIORITY1_WR(src)     (((u32)(src)<<10) & 0x00001c00)
#define ENET_DFCLSRESDBPRIORITY1_SET(dst,src) \
                      (((dst) & ~0x00001c00) | (((u32)(src)<<10) & 0x00001c00))
/*	 Fields dfclsresdbptr	 */
#define ENET_DFCLSRESDBPTR1_WIDTH                                         10
#define ENET_DFCLSRESDBPTR1_SHIFT                                          0
#define ENET_DFCLSRESDBPTR1_MASK                                  0x000003ff
#define ENET_DFCLSRESDBPTR1_RD(src)                   (((src) & 0x000003ff))
#define ENET_DFCLSRESDBPTR1_WR(src)              (((u32)(src)) & 0x000003ff)
#define ENET_DFCLSRESDBPTR1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register dfclsresdb1_0	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB0_F1_WIDTH                                         32
#define ENET_DFCLSRESDB0_F1_SHIFT                                          0
#define ENET_DFCLSRESDB0_F1_MASK                                  0xffffffff
#define ENET_DFCLSRESDB0_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_DFCLSRESDB0_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb1_1	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB1_F1_WIDTH                                         32
#define ENET_DFCLSRESDB1_F1_SHIFT                                          0
#define ENET_DFCLSRESDB1_F1_MASK                                  0xffffffff
#define ENET_DFCLSRESDB1_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_DFCLSRESDB1_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb1_2	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB2_F1_WIDTH                                         32
#define ENET_DFCLSRESDB2_F1_SHIFT                                          0
#define ENET_DFCLSRESDB2_F1_MASK                                  0xffffffff
#define ENET_DFCLSRESDB2_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_DFCLSRESDB2_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB2_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb1_3	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB3_F1_WIDTH                                         32
#define ENET_DFCLSRESDB3_F1_SHIFT                                          0
#define ENET_DFCLSRESDB3_F1_MASK                                  0xffffffff
#define ENET_DFCLSRESDB3_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_DFCLSRESDB3_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB3_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb1_4	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB4_F1_WIDTH                                         32
#define ENET_DFCLSRESDB4_F1_SHIFT                                          0
#define ENET_DFCLSRESDB4_F1_MASK                                  0xffffffff
#define ENET_DFCLSRESDB4_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_DFCLSRESDB4_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB4_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register dfclsresdb1_5	*/ 
/*	 Fields dfclsresdb	 */
#define ENET_DFCLSRESDB5_F1_WIDTH                                         32
#define ENET_DFCLSRESDB5_F1_SHIFT                                          0
#define ENET_DFCLSRESDB5_F1_MASK                                  0xffffffff
#define ENET_DFCLSRESDB5_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_DFCLSRESDB5_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_DFCLSRESDB5_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register parser_ctl1	*/ 
/*	 Fields pkt_data_msk_en	 */
#define ENET_PKT_DATA_MSK_EN1_WIDTH                                        1
#define ENET_PKT_DATA_MSK_EN1_SHIFT                                       31
#define ENET_PKT_DATA_MSK_EN1_MASK                                0x80000000
#define ENET_PKT_DATA_MSK_EN1_RD(src)             (((src) & 0x80000000)>>31)
#define ENET_PKT_DATA_MSK_EN1_WR(src)        (((u32)(src)<<31) & 0x80000000)
#define ENET_PKT_DATA_MSK_EN1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields use_default_ptr_as_nxt_dec_ptr	 */
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR1_WIDTH                         1
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR1_SHIFT                        30
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR1_MASK                 0x40000000
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR1_RD(src) \
                                                    (((src) & 0x40000000)>>30)
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR1_WR(src) \
                                                (((u32)(src)<<30) & 0x40000000)
#define ENET_USE_DEFAULT_PTR_AS_NXT_DEC_PTR1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields parser_halt	 */
#define ENET_PARSER_HALT1_WIDTH                                            1
#define ENET_PARSER_HALT1_SHIFT                                            0
#define ENET_PARSER_HALT1_MASK                                    0x00000001
#define ENET_PARSER_HALT1_RD(src)                     (((src) & 0x00000001))
#define ENET_PARSER_HALT1_WR(src)                (((u32)(src)) & 0x00000001)
#define ENET_PARSER_HALT1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register tmaxhop1	*/ 
/*	 Fields tmaxhop	 */
#define ENET_TMAXHOP1_WIDTH                                                8
#define ENET_TMAXHOP1_SHIFT                                                0
#define ENET_TMAXHOP1_MASK                                        0x000000ff
#define ENET_TMAXHOP1_RD(src)                         (((src) & 0x000000ff))
#define ENET_TMAXHOP1_WR(src)                    (((u32)(src)) & 0x000000ff)
#define ENET_TMAXHOP1_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register portnum1	*/ 
/*	 Fields portnum1	 */
#define ENET_PORTNUM11_WIDTH                                               8
#define ENET_PORTNUM11_SHIFT                                               0
#define ENET_PORTNUM11_MASK                                       0x000000ff
#define ENET_PORTNUM11_RD(src)                        (((src) & 0x000000ff))
#define ENET_PORTNUM11_WR(src)                   (((u32)(src)) & 0x000000ff)
#define ENET_PORTNUM11_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register rss_ctrl1	*/ 
/*	 Fields ipv6_hashtype	 */
#define ENET_IPV6_HASHTYPE1_WIDTH                                          2
#define ENET_IPV6_HASHTYPE1_SHIFT                                          3
#define ENET_IPV6_HASHTYPE1_MASK                                  0x00000018
#define ENET_IPV6_HASHTYPE1_RD(src)                (((src) & 0x00000018)>>3)
#define ENET_IPV6_HASHTYPE1_WR(src)           (((u32)(src)<<3) & 0x00000018)
#define ENET_IPV6_HASHTYPE1_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields ipv4_hashtype	 */
#define ENET_IPV4_HASHTYPE1_WIDTH                                          2
#define ENET_IPV4_HASHTYPE1_SHIFT                                          1
#define ENET_IPV4_HASHTYPE1_MASK                                  0x00000006
#define ENET_IPV4_HASHTYPE1_RD(src)                (((src) & 0x00000006)>>1)
#define ENET_IPV4_HASHTYPE1_WR(src)           (((u32)(src)<<1) & 0x00000006)
#define ENET_IPV4_HASHTYPE1_SET(dst,src) \
                       (((dst) & ~0x00000006) | (((u32)(src)<<1) & 0x00000006))
/*	 Fields enable	 */
#define ENET_ENABLE1_F2_WIDTH                                              1
#define ENET_ENABLE1_F2_SHIFT                                              0
#define ENET_ENABLE1_F2_MASK                                      0x00000001
#define ENET_ENABLE1_F2_RD(src)                       (((src) & 0x00000001))
#define ENET_ENABLE1_F2_WR(src)                  (((u32)(src)) & 0x00000001)
#define ENET_ENABLE1_F2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register parser_status1	*/ 
/*	 Fields itableErr	 */
#define ENET_ITABLEERR1_WIDTH                                              1
#define ENET_ITABLEERR1_SHIFT                                              8
#define ENET_ITABLEERR1_MASK                                      0x00000100
#define ENET_ITABLEERR1_RD(src)                    (((src) & 0x00000100)>>8)
#define ENET_ITABLEERR1_WR(src)               (((u32)(src)<<8) & 0x00000100)
#define ENET_ITABLEERR1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields SrchDbRamErr	 */
#define ENET_SRCHDBRAMERR1_WIDTH                                           1
#define ENET_SRCHDBRAMERR1_SHIFT                                           7
#define ENET_SRCHDBRAMERR1_MASK                                   0x00000080
#define ENET_SRCHDBRAMERR1_RD(src)                 (((src) & 0x00000080)>>7)
#define ENET_SRCHDBRAMERR1_WR(src)            (((u32)(src)<<7) & 0x00000080)
#define ENET_SRCHDBRAMERR1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields PrsrDbRamErr	 */
#define ENET_PRSRDBRAMERR1_WIDTH                                           1
#define ENET_PRSRDBRAMERR1_SHIFT                                           6
#define ENET_PRSRDBRAMERR1_MASK                                   0x00000040
#define ENET_PRSRDBRAMERR1_RD(src)                 (((src) & 0x00000040)>>6)
#define ENET_PRSRDBRAMERR1_WR(src)            (((u32)(src)<<6) & 0x00000040)
#define ENET_PRSRDBRAMERR1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields PktRamErr	 */
#define ENET_PKTRAMERR1_WIDTH                                              1
#define ENET_PKTRAMERR1_SHIFT                                              5
#define ENET_PKTRAMERR1_MASK                                      0x00000020
#define ENET_PKTRAMERR1_RD(src)                    (((src) & 0x00000020)>>5)
#define ENET_PKTRAMERR1_WR(src)               (((u32)(src)<<5) & 0x00000020)
#define ENET_PKTRAMERR1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields PTRamErr	 */
#define ENET_PTRAMERR1_WIDTH                                               1
#define ENET_PTRAMERR1_SHIFT                                               4
#define ENET_PTRAMERR1_MASK                                       0x00000010
#define ENET_PTRAMERR1_RD(src)                     (((src) & 0x00000010)>>4)
#define ENET_PTRAMERR1_WR(src)                (((u32)(src)<<4) & 0x00000010)
#define ENET_PTRAMERR1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields PrsrInvMSBStrErr	 */
#define ENET_PRSRINVMSBSTRERR1_WIDTH                                       1
#define ENET_PRSRINVMSBSTRERR1_SHIFT                                       3
#define ENET_PRSRINVMSBSTRERR1_MASK                               0x00000008
#define ENET_PRSRINVMSBSTRERR1_RD(src)             (((src) & 0x00000008)>>3)
#define ENET_PRSRINVMSBSTRERR1_WR(src)        (((u32)(src)<<3) & 0x00000008)
#define ENET_PRSRINVMSBSTRERR1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields PktOffsetExEop	 */
#define ENET_PKTOFFSETEXEOP1_WIDTH                                         1
#define ENET_PKTOFFSETEXEOP1_SHIFT                                         2
#define ENET_PKTOFFSETEXEOP1_MASK                                 0x00000004
#define ENET_PKTOFFSETEXEOP1_RD(src)               (((src) & 0x00000004)>>2)
#define ENET_PKTOFFSETEXEOP1_WR(src)          (((u32)(src)<<2) & 0x00000004)
#define ENET_PKTOFFSETEXEOP1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields maxhoperr	 */
#define ENET_MAXHOPERR1_WIDTH                                              1
#define ENET_MAXHOPERR1_SHIFT                                              1
#define ENET_MAXHOPERR1_MASK                                      0x00000002
#define ENET_MAXHOPERR1_RD(src)                    (((src) & 0x00000002)>>1)
#define ENET_MAXHOPERR1_WR(src)               (((u32)(src)<<1) & 0x00000002)
#define ENET_MAXHOPERR1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields parser_halt_status	 */
#define ENET_PARSER_HALT_STATUS1_WIDTH                                     1
#define ENET_PARSER_HALT_STATUS1_SHIFT                                     0
#define ENET_PARSER_HALT_STATUS1_MASK                             0x00000001
#define ENET_PARSER_HALT_STATUS1_RD(src)              (((src) & 0x00000001))
#define ENET_PARSER_HALT_STATUS1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register parser_status1Mask	*/
/*    Mask Register Fields itableErrMask    */
#define ENET_ITABLEERRMASK_F1_WIDTH                                        1
#define ENET_ITABLEERRMASK_F1_SHIFT                                        8
#define ENET_ITABLEERRMASK_F1_MASK                                0x00000100
#define ENET_ITABLEERRMASK_F1_RD(src)              (((src) & 0x00000100)>>8)
#define ENET_ITABLEERRMASK_F1_WR(src)         (((u32)(src)<<8) & 0x00000100)
#define ENET_ITABLEERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields SrchDbRamErrMask    */
#define ENET_SRCHDBRAMERRMASK_F1_WIDTH                                     1
#define ENET_SRCHDBRAMERRMASK_F1_SHIFT                                     7
#define ENET_SRCHDBRAMERRMASK_F1_MASK                             0x00000080
#define ENET_SRCHDBRAMERRMASK_F1_RD(src)           (((src) & 0x00000080)>>7)
#define ENET_SRCHDBRAMERRMASK_F1_WR(src)      (((u32)(src)<<7) & 0x00000080)
#define ENET_SRCHDBRAMERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields PrsrDbRamErrMask    */
#define ENET_PRSRDBRAMERRMASK_F1_WIDTH                                     1
#define ENET_PRSRDBRAMERRMASK_F1_SHIFT                                     6
#define ENET_PRSRDBRAMERRMASK_F1_MASK                             0x00000040
#define ENET_PRSRDBRAMERRMASK_F1_RD(src)           (((src) & 0x00000040)>>6)
#define ENET_PRSRDBRAMERRMASK_F1_WR(src)      (((u32)(src)<<6) & 0x00000040)
#define ENET_PRSRDBRAMERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields PktRamErrMask    */
#define ENET_PKTRAMERRMASK_F1_WIDTH                                        1
#define ENET_PKTRAMERRMASK_F1_SHIFT                                        5
#define ENET_PKTRAMERRMASK_F1_MASK                                0x00000020
#define ENET_PKTRAMERRMASK_F1_RD(src)              (((src) & 0x00000020)>>5)
#define ENET_PKTRAMERRMASK_F1_WR(src)         (((u32)(src)<<5) & 0x00000020)
#define ENET_PKTRAMERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields PTRamErrMask    */
#define ENET_PTRAMERRMASK_F1_WIDTH                                         1
#define ENET_PTRAMERRMASK_F1_SHIFT                                         4
#define ENET_PTRAMERRMASK_F1_MASK                                 0x00000010
#define ENET_PTRAMERRMASK_F1_RD(src)               (((src) & 0x00000010)>>4)
#define ENET_PTRAMERRMASK_F1_WR(src)          (((u32)(src)<<4) & 0x00000010)
#define ENET_PTRAMERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields PrsrInvMSBStrErrMask    */
#define ENET_PRSRINVMSBSTRERRMASK_F1_WIDTH                                 1
#define ENET_PRSRINVMSBSTRERRMASK_F1_SHIFT                                 3
#define ENET_PRSRINVMSBSTRERRMASK_F1_MASK                         0x00000008
#define ENET_PRSRINVMSBSTRERRMASK_F1_RD(src)       (((src) & 0x00000008)>>3)
#define ENET_PRSRINVMSBSTRERRMASK_F1_WR(src)  (((u32)(src)<<3) & 0x00000008)
#define ENET_PRSRINVMSBSTRERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields PktOffsetExEopMask    */
#define ENET_PKTOFFSETEXEOPMASK_F1_WIDTH                                   1
#define ENET_PKTOFFSETEXEOPMASK_F1_SHIFT                                   2
#define ENET_PKTOFFSETEXEOPMASK_F1_MASK                           0x00000004
#define ENET_PKTOFFSETEXEOPMASK_F1_RD(src)         (((src) & 0x00000004)>>2)
#define ENET_PKTOFFSETEXEOPMASK_F1_WR(src)    (((u32)(src)<<2) & 0x00000004)
#define ENET_PKTOFFSETEXEOPMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields maxhoperrMask    */
#define ENET_MAXHOPERRMASK_F1_WIDTH                                        1
#define ENET_MAXHOPERRMASK_F1_SHIFT                                        1
#define ENET_MAXHOPERRMASK_F1_MASK                                0x00000002
#define ENET_MAXHOPERRMASK_F1_RD(src)              (((src) & 0x00000002)>>1)
#define ENET_MAXHOPERRMASK_F1_WR(src)         (((u32)(src)<<1) & 0x00000002)
#define ENET_MAXHOPERRMASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields parser_halt_statusMask    */
#define ENET_PARSER_HALT_STATUSMASK_F1_WIDTH                               1
#define ENET_PARSER_HALT_STATUSMASK_F1_SHIFT                               0
#define ENET_PARSER_HALT_STATUSMASK_F1_MASK                       0x00000001
#define ENET_PARSER_HALT_STATUSMASK_F1_RD(src)        (((src) & 0x00000001))
#define ENET_PARSER_HALT_STATUSMASK_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register snptr_change_status1	*/ 
/*	 Fields snptr_change_done	 */
#define ENET_SNPTR_CHANGE_DONE1_WIDTH                                      1
#define ENET_SNPTR_CHANGE_DONE1_SHIFT                                      0
#define ENET_SNPTR_CHANGE_DONE1_MASK                              0x00000001
#define ENET_SNPTR_CHANGE_DONE1_RD(src)               (((src) & 0x00000001))
#define ENET_SNPTR_CHANGE_DONE1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register itable1_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_F5_WIDTH                                           7
#define ENET_ERROR_ADDR_F5_SHIFT                                           2
#define ENET_ERROR_ADDR_F5_MASK                                   0x000001fc
#define ENET_ERROR_ADDR_F5_RD(src)                 (((src) & 0x000001fc)>>2)
#define ENET_ERROR_ADDR_F5_WR(src)            (((u32)(src)<<2) & 0x000001fc)
#define ENET_ERROR_ADDR_F5_SET(dst,src) \
                       (((dst) & ~0x000001fc) | (((u32)(src)<<2) & 0x000001fc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_F5_WIDTH                                    1
#define ENET_ERROR_ADDR_ENABLE_F5_SHIFT                                    1
#define ENET_ERROR_ADDR_ENABLE_F5_MASK                            0x00000002
#define ENET_ERROR_ADDR_ENABLE_F5_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_F5_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_F5_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_F5_WIDTH                              1
#define ENET_FORCE_READ_ERROR_ENABLE_F5_SHIFT                              0
#define ENET_FORCE_READ_ERROR_ENABLE_F5_MASK                      0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_F5_RD(src)       (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_F5_WR(src)  (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_F5_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register pktram1_err_diagnostic	*/ 
/*	 Fields Error_Addr	 */
#define ENET_ERROR_ADDR_F6_WIDTH                                           6
#define ENET_ERROR_ADDR_F6_SHIFT                                           2
#define ENET_ERROR_ADDR_F6_MASK                                   0x000000fc
#define ENET_ERROR_ADDR_F6_RD(src)                 (((src) & 0x000000fc)>>2)
#define ENET_ERROR_ADDR_F6_WR(src)            (((u32)(src)<<2) & 0x000000fc)
#define ENET_ERROR_ADDR_F6_SET(dst,src) \
                       (((dst) & ~0x000000fc) | (((u32)(src)<<2) & 0x000000fc))
/*	 Fields Error_Addr_Enable	 */
#define ENET_ERROR_ADDR_ENABLE_F6_WIDTH                                    1
#define ENET_ERROR_ADDR_ENABLE_F6_SHIFT                                    1
#define ENET_ERROR_ADDR_ENABLE_F6_MASK                            0x00000002
#define ENET_ERROR_ADDR_ENABLE_F6_RD(src)          (((src) & 0x00000002)>>1)
#define ENET_ERROR_ADDR_ENABLE_F6_WR(src)     (((u32)(src)<<1) & 0x00000002)
#define ENET_ERROR_ADDR_ENABLE_F6_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields Force_Read_Error_Enable	 */
#define ENET_FORCE_READ_ERROR_ENABLE_F6_WIDTH                              1
#define ENET_FORCE_READ_ERROR_ENABLE_F6_SHIFT                              0
#define ENET_FORCE_READ_ERROR_ENABLE_F6_MASK                      0x00000001
#define ENET_FORCE_READ_ERROR_ENABLE_F6_RD(src)       (((src) & 0x00000001))
#define ENET_FORCE_READ_ERROR_ENABLE_F6_WR(src)  (((u32)(src)) & 0x00000001)
#define ENET_FORCE_READ_ERROR_ENABLE_F6_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register itable1_ctrl	*/ 
/*	 Fields rme	 */
#define ENET_RME_F10_WIDTH                                                 1
#define ENET_RME_F10_SHIFT                                                 2
#define ENET_RME_F10_MASK                                         0x00000004
#define ENET_RME_F10_RD(src)                       (((src) & 0x00000004)>>2)
#define ENET_RME_F10_WR(src)                  (((u32)(src)<<2) & 0x00000004)
#define ENET_RME_F10_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields rm	 */
#define ENET_RM_F10_WIDTH                                                  2
#define ENET_RM_F10_SHIFT                                                  0
#define ENET_RM_F10_MASK                                          0x00000003
#define ENET_RM_F10_RD(src)                           (((src) & 0x00000003))
#define ENET_RM_F10_WR(src)                      (((u32)(src)) & 0x00000003)
#define ENET_RM_F10_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register lstnvst1	*/ 
/*	 Fields lstnvst	 */
#define ENET_LSTNVST1_WIDTH                                               14
#define ENET_LSTNVST1_SHIFT                                                0
#define ENET_LSTNVST1_MASK                                        0x00003fff
#define ENET_LSTNVST1_RD(src)                         (((src) & 0x00003fff))
#define ENET_LSTNVST1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_0	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST0_F2_WIDTH                                           14
#define ENET_LTRCNVST0_F2_SHIFT                                            0
#define ENET_LTRCNVST0_F2_MASK                                    0x00003fff
#define ENET_LTRCNVST0_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST0_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_1	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST1_F2_WIDTH                                           14
#define ENET_LTRCNVST1_F2_SHIFT                                            0
#define ENET_LTRCNVST1_F2_MASK                                    0x00003fff
#define ENET_LTRCNVST1_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST1_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_2	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST2_F2_WIDTH                                           14
#define ENET_LTRCNVST2_F2_SHIFT                                            0
#define ENET_LTRCNVST2_F2_MASK                                    0x00003fff
#define ENET_LTRCNVST2_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST2_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_3	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST3_F2_WIDTH                                           14
#define ENET_LTRCNVST3_F2_SHIFT                                            0
#define ENET_LTRCNVST3_F2_MASK                                    0x00003fff
#define ENET_LTRCNVST3_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST3_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_4	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST4_F2_WIDTH                                           14
#define ENET_LTRCNVST4_F2_SHIFT                                            0
#define ENET_LTRCNVST4_F2_MASK                                    0x00003fff
#define ENET_LTRCNVST4_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST4_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_5	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST5_F2_WIDTH                                           14
#define ENET_LTRCNVST5_F2_SHIFT                                            0
#define ENET_LTRCNVST5_F2_MASK                                    0x00003fff
#define ENET_LTRCNVST5_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST5_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_6	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST6_F1_WIDTH                                           14
#define ENET_LTRCNVST6_F1_SHIFT                                            0
#define ENET_LTRCNVST6_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST6_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST6_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_7	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST7_F1_WIDTH                                           14
#define ENET_LTRCNVST7_F1_SHIFT                                            0
#define ENET_LTRCNVST7_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST7_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST7_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_8	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST8_F1_WIDTH                                           14
#define ENET_LTRCNVST8_F1_SHIFT                                            0
#define ENET_LTRCNVST8_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST8_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST8_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_9	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST9_F1_WIDTH                                           14
#define ENET_LTRCNVST9_F1_SHIFT                                            0
#define ENET_LTRCNVST9_F1_MASK                                    0x00003fff
#define ENET_LTRCNVST9_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST9_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_10	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST0_F3_WIDTH                                           14
#define ENET_LTRCNVST0_F3_SHIFT                                            0
#define ENET_LTRCNVST0_F3_MASK                                    0x00003fff
#define ENET_LTRCNVST0_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST0_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_11	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST1_F3_WIDTH                                           14
#define ENET_LTRCNVST1_F3_SHIFT                                            0
#define ENET_LTRCNVST1_F3_MASK                                    0x00003fff
#define ENET_LTRCNVST1_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST1_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_12	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST2_F3_WIDTH                                           14
#define ENET_LTRCNVST2_F3_SHIFT                                            0
#define ENET_LTRCNVST2_F3_MASK                                    0x00003fff
#define ENET_LTRCNVST2_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST2_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_13	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST3_F3_WIDTH                                           14
#define ENET_LTRCNVST3_F3_SHIFT                                            0
#define ENET_LTRCNVST3_F3_MASK                                    0x00003fff
#define ENET_LTRCNVST3_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST3_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_14	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST4_F3_WIDTH                                           14
#define ENET_LTRCNVST4_F3_SHIFT                                            0
#define ENET_LTRCNVST4_F3_MASK                                    0x00003fff
#define ENET_LTRCNVST4_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST4_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register lsttrcnvst1_15	*/ 
/*	 Fields ltrcnvst	 */
#define ENET_LTRCNVST5_F3_WIDTH                                           14
#define ENET_LTRCNVST5_F3_SHIFT                                            0
#define ENET_LTRCNVST5_F3_MASK                                    0x00003fff
#define ENET_LTRCNVST5_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_LTRCNVST5_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvststr1_0	*/ 
/*	 Fields ftrcnvststrt	 */
#define ENET_FTRCNVSTSTRT0_F1_WIDTH                                       14
#define ENET_FTRCNVSTSTRT0_F1_SHIFT                                        0
#define ENET_FTRCNVSTSTRT0_F1_MASK                                0x00003fff
#define ENET_FTRCNVSTSTRT0_F1_RD(src)                 (((src) & 0x00003fff))
#define ENET_FTRCNVSTSTRT0_F1_WR(src)            (((u32)(src)) & 0x00003fff)
#define ENET_FTRCNVSTSTRT0_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_0	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST0_F2_WIDTH                                           14
#define ENET_FTRCNVST0_F2_SHIFT                                            0
#define ENET_FTRCNVST0_F2_MASK                                    0x00003fff
#define ENET_FTRCNVST0_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST0_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_1	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST1_F2_WIDTH                                           14
#define ENET_FTRCNVST1_F2_SHIFT                                            0
#define ENET_FTRCNVST1_F2_MASK                                    0x00003fff
#define ENET_FTRCNVST1_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST1_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_2	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST2_F2_WIDTH                                           14
#define ENET_FTRCNVST2_F2_SHIFT                                            0
#define ENET_FTRCNVST2_F2_MASK                                    0x00003fff
#define ENET_FTRCNVST2_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST2_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_3	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST3_F2_WIDTH                                           14
#define ENET_FTRCNVST3_F2_SHIFT                                            0
#define ENET_FTRCNVST3_F2_MASK                                    0x00003fff
#define ENET_FTRCNVST3_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST3_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_4	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST4_F2_WIDTH                                           14
#define ENET_FTRCNVST4_F2_SHIFT                                            0
#define ENET_FTRCNVST4_F2_MASK                                    0x00003fff
#define ENET_FTRCNVST4_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST4_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_5	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST5_F2_WIDTH                                           14
#define ENET_FTRCNVST5_F2_SHIFT                                            0
#define ENET_FTRCNVST5_F2_MASK                                    0x00003fff
#define ENET_FTRCNVST5_F2_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST5_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_6	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST6_F1_WIDTH                                           14
#define ENET_FTRCNVST6_F1_SHIFT                                            0
#define ENET_FTRCNVST6_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST6_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST6_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_7	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST7_F1_WIDTH                                           14
#define ENET_FTRCNVST7_F1_SHIFT                                            0
#define ENET_FTRCNVST7_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST7_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST7_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_8	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST8_F1_WIDTH                                           14
#define ENET_FTRCNVST8_F1_SHIFT                                            0
#define ENET_FTRCNVST8_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST8_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST8_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_9	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST9_F1_WIDTH                                           14
#define ENET_FTRCNVST9_F1_SHIFT                                            0
#define ENET_FTRCNVST9_F1_MASK                                    0x00003fff
#define ENET_FTRCNVST9_F1_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST9_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_10	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST0_F3_WIDTH                                           14
#define ENET_FTRCNVST0_F3_SHIFT                                            0
#define ENET_FTRCNVST0_F3_MASK                                    0x00003fff
#define ENET_FTRCNVST0_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST0_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_11	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST1_F3_WIDTH                                           14
#define ENET_FTRCNVST1_F3_SHIFT                                            0
#define ENET_FTRCNVST1_F3_MASK                                    0x00003fff
#define ENET_FTRCNVST1_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST1_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_12	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST2_F3_WIDTH                                           14
#define ENET_FTRCNVST2_F3_SHIFT                                            0
#define ENET_FTRCNVST2_F3_MASK                                    0x00003fff
#define ENET_FTRCNVST2_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST2_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_13	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST3_F3_WIDTH                                           14
#define ENET_FTRCNVST3_F3_SHIFT                                            0
#define ENET_FTRCNVST3_F3_MASK                                    0x00003fff
#define ENET_FTRCNVST3_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST3_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_14	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST4_F3_WIDTH                                           14
#define ENET_FTRCNVST4_F3_SHIFT                                            0
#define ENET_FTRCNVST4_F3_MASK                                    0x00003fff
#define ENET_FTRCNVST4_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST4_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register ftrcnvst1_15	*/ 
/*	 Fields ftrcnvst	 */
#define ENET_FTRCNVST5_F3_WIDTH                                           14
#define ENET_FTRCNVST5_F3_SHIFT                                            0
#define ENET_FTRCNVST5_F3_MASK                                    0x00003fff
#define ENET_FTRCNVST5_F3_RD(src)                     (((src) & 0x00003fff))
#define ENET_FTRCNVST5_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmon1_0	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON0_F2_WIDTH                                         14
#define ENET_TRCNVSTMON0_F2_SHIFT                                          0
#define ENET_TRCNVSTMON0_F2_MASK                                  0x00003fff
#define ENET_TRCNVSTMON0_F2_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON0_F2_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON0_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_0	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT0_F2_WIDTH                                      32
#define ENET_TRCNVSTMONCNT0_F2_SHIFT                                       0
#define ENET_TRCNVSTMONCNT0_F2_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT0_F2_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT0_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_1	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON1_F2_WIDTH                                         14
#define ENET_TRCNVSTMON1_F2_SHIFT                                          0
#define ENET_TRCNVSTMON1_F2_MASK                                  0x00003fff
#define ENET_TRCNVSTMON1_F2_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON1_F2_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON1_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_1	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT1_F2_WIDTH                                      32
#define ENET_TRCNVSTMONCNT1_F2_SHIFT                                       0
#define ENET_TRCNVSTMONCNT1_F2_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT1_F2_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT1_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_2	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON2_F2_WIDTH                                         14
#define ENET_TRCNVSTMON2_F2_SHIFT                                          0
#define ENET_TRCNVSTMON2_F2_MASK                                  0x00003fff
#define ENET_TRCNVSTMON2_F2_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON2_F2_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON2_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_2	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT2_F2_WIDTH                                      32
#define ENET_TRCNVSTMONCNT2_F2_SHIFT                                       0
#define ENET_TRCNVSTMONCNT2_F2_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT2_F2_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT2_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_3	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON3_F2_WIDTH                                         14
#define ENET_TRCNVSTMON3_F2_SHIFT                                          0
#define ENET_TRCNVSTMON3_F2_MASK                                  0x00003fff
#define ENET_TRCNVSTMON3_F2_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON3_F2_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON3_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_3	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT3_F2_WIDTH                                      32
#define ENET_TRCNVSTMONCNT3_F2_SHIFT                                       0
#define ENET_TRCNVSTMONCNT3_F2_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT3_F2_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT3_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_4	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON4_F2_WIDTH                                         14
#define ENET_TRCNVSTMON4_F2_SHIFT                                          0
#define ENET_TRCNVSTMON4_F2_MASK                                  0x00003fff
#define ENET_TRCNVSTMON4_F2_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON4_F2_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON4_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_4	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT4_F2_WIDTH                                      32
#define ENET_TRCNVSTMONCNT4_F2_SHIFT                                       0
#define ENET_TRCNVSTMONCNT4_F2_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT4_F2_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT4_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_5	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON5_F2_WIDTH                                         14
#define ENET_TRCNVSTMON5_F2_SHIFT                                          0
#define ENET_TRCNVSTMON5_F2_MASK                                  0x00003fff
#define ENET_TRCNVSTMON5_F2_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON5_F2_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON5_F2_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_5	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT5_F2_WIDTH                                      32
#define ENET_TRCNVSTMONCNT5_F2_SHIFT                                       0
#define ENET_TRCNVSTMONCNT5_F2_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT5_F2_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT5_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_6	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON6_F1_WIDTH                                         14
#define ENET_TRCNVSTMON6_F1_SHIFT                                          0
#define ENET_TRCNVSTMON6_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON6_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON6_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON6_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_6	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT6_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT6_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT6_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT6_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT6_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_7	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON7_F1_WIDTH                                         14
#define ENET_TRCNVSTMON7_F1_SHIFT                                          0
#define ENET_TRCNVSTMON7_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON7_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON7_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON7_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_7	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT7_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT7_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT7_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT7_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT7_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_8	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON8_F1_WIDTH                                         14
#define ENET_TRCNVSTMON8_F1_SHIFT                                          0
#define ENET_TRCNVSTMON8_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON8_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON8_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON8_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_8	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT8_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT8_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT8_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT8_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT8_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_9	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON9_F1_WIDTH                                         14
#define ENET_TRCNVSTMON9_F1_SHIFT                                          0
#define ENET_TRCNVSTMON9_F1_MASK                                  0x00003fff
#define ENET_TRCNVSTMON9_F1_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON9_F1_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON9_F1_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_9	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT9_F1_WIDTH                                      32
#define ENET_TRCNVSTMONCNT9_F1_SHIFT                                       0
#define ENET_TRCNVSTMONCNT9_F1_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT9_F1_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT9_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_10	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON0_F3_WIDTH                                         14
#define ENET_TRCNVSTMON0_F3_SHIFT                                          0
#define ENET_TRCNVSTMON0_F3_MASK                                  0x00003fff
#define ENET_TRCNVSTMON0_F3_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON0_F3_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON0_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_10	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT0_F3_WIDTH                                      32
#define ENET_TRCNVSTMONCNT0_F3_SHIFT                                       0
#define ENET_TRCNVSTMONCNT0_F3_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT0_F3_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT0_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_11	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON1_F3_WIDTH                                         14
#define ENET_TRCNVSTMON1_F3_SHIFT                                          0
#define ENET_TRCNVSTMON1_F3_MASK                                  0x00003fff
#define ENET_TRCNVSTMON1_F3_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON1_F3_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON1_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_11	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT1_F3_WIDTH                                      32
#define ENET_TRCNVSTMONCNT1_F3_SHIFT                                       0
#define ENET_TRCNVSTMONCNT1_F3_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT1_F3_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT1_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_12	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON2_F3_WIDTH                                         14
#define ENET_TRCNVSTMON2_F3_SHIFT                                          0
#define ENET_TRCNVSTMON2_F3_MASK                                  0x00003fff
#define ENET_TRCNVSTMON2_F3_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON2_F3_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON2_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_12	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT2_F3_WIDTH                                      32
#define ENET_TRCNVSTMONCNT2_F3_SHIFT                                       0
#define ENET_TRCNVSTMONCNT2_F3_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT2_F3_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT2_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_13	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON3_F3_WIDTH                                         14
#define ENET_TRCNVSTMON3_F3_SHIFT                                          0
#define ENET_TRCNVSTMON3_F3_MASK                                  0x00003fff
#define ENET_TRCNVSTMON3_F3_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON3_F3_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON3_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_13	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT3_F3_WIDTH                                      32
#define ENET_TRCNVSTMONCNT3_F3_SHIFT                                       0
#define ENET_TRCNVSTMONCNT3_F3_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT3_F3_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT3_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_14	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON4_F3_WIDTH                                         14
#define ENET_TRCNVSTMON4_F3_SHIFT                                          0
#define ENET_TRCNVSTMON4_F3_MASK                                  0x00003fff
#define ENET_TRCNVSTMON4_F3_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON4_F3_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON4_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_14	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT4_F3_WIDTH                                      32
#define ENET_TRCNVSTMONCNT4_F3_SHIFT                                       0
#define ENET_TRCNVSTMONCNT4_F3_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT4_F3_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT4_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register trcnvstmon1_15	*/ 
/*	 Fields trcnvstmon	 */
#define ENET_TRCNVSTMON5_F3_WIDTH                                         14
#define ENET_TRCNVSTMON5_F3_SHIFT                                          0
#define ENET_TRCNVSTMON5_F3_MASK                                  0x00003fff
#define ENET_TRCNVSTMON5_F3_RD(src)                   (((src) & 0x00003fff))
#define ENET_TRCNVSTMON5_F3_WR(src)              (((u32)(src)) & 0x00003fff)
#define ENET_TRCNVSTMON5_F3_SET(dst,src) \
                          (((dst) & ~0x00003fff) | (((u32)(src)) & 0x00003fff))

/*	Register trcnvstmoncnt1_15	*/ 
/*	 Fields trcnvstmoncnt	 */
#define ENET_TRCNVSTMONCNT5_F3_WIDTH                                      32
#define ENET_TRCNVSTMONCNT5_F3_SHIFT                                       0
#define ENET_TRCNVSTMONCNT5_F3_MASK                               0xffffffff
#define ENET_TRCNVSTMONCNT5_F3_RD(src)                (((src) & 0xffffffff))
#define ENET_TRCNVSTMONCNT5_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register hash_diag_ctl1	*/ 
/*	 Fields Hash_Result_Diagnostic_Enable	 */
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE1_WIDTH                          1
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE1_SHIFT                          0
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE1_MASK                  0x00000001
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE1_RD(src)   (((src) & 0x00000001))
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE1_WR(src) \
                                                    (((u32)(src)) & 0x00000001)
#define ENET_HASH_RESULT_DIAGNOSTIC_ENABLE1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register hash_seed_default1	*/ 
/*	 Fields Hash_Seed_Default	 */
#define ENET_HASH_SEED_DEFAULT1_WIDTH                                     32
#define ENET_HASH_SEED_DEFAULT1_SHIFT                                      0
#define ENET_HASH_SEED_DEFAULT1_MASK                              0xffffffff
#define ENET_HASH_SEED_DEFAULT1_RD(src)               (((src) & 0xffffffff))
#define ENET_HASH_SEED_DEFAULT1_WR(src)          (((u32)(src)) & 0xffffffff)
#define ENET_HASH_SEED_DEFAULT1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register hash_result_diag1	*/ 
/*	 Fields Hash_Result_Diagnostic	 */
#define ENET_HASH_RESULT_DIAGNOSTIC1_WIDTH                                32
#define ENET_HASH_RESULT_DIAGNOSTIC1_SHIFT                                 0
#define ENET_HASH_RESULT_DIAGNOSTIC1_MASK                         0xffffffff
#define ENET_HASH_RESULT_DIAGNOSTIC1_RD(src)          (((src) & 0xffffffff))
#define ENET_HASH_RESULT_DIAGNOSTIC1_WR(src)     (((u32)(src)) & 0xffffffff)
#define ENET_HASH_RESULT_DIAGNOSTIC1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Global Base Address	*/
#define SATA_ENET_COMMON_CSR_BASE_ADDR			0x01f217000ULL

/*    Address SATA_ENET_COMMON_CSR  Registers */
#define SATA_ENET_CONFIG_REG_ADDR                                    0x00000000
#define SATA_ENET_CONFIG_REG_DEFAULT                                 0x00000001

/*	Register SATA_ENET_Config_Reg	*/ 
/*	 Fields cfg_sata_enet_select	 */
#define CFG_SATA_ENET_SELECT_WIDTH                                            1
#define CFG_SATA_ENET_SELECT_SHIFT                                            0
#define CFG_SATA_ENET_SELECT_MASK                                    0x00000001
#define CFG_SATA_ENET_SELECT_RD(src)                     (((src) & 0x00000001))
#define CFG_SATA_ENET_SELECT_WR(src)                (((u32)(src)) & 0x00000001)
#define CFG_SATA_ENET_SELECT_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_QMI_SLAVE_BASE_ADDR			0x01f219000ULL

/*    Address QMI_SLAVE  Registers */
#define ENET_CFGSSQMI0_ADDR                                       0x00000000
#define ENET_CFGSSQMI0_DEFAULT                                    0x804c4041
#define ENET_CFGSSQMI1_ADDR                                       0x00000004
#define ENET_CFGSSQMI1_DEFAULT                                    0x0000b7a2
#define ENET_CFGSSQMIQM0_ADDR                                     0x00000008
#define ENET_CFGSSQMIQM0_DEFAULT                                  0x00000060
#define ENET_CFGSSQMIQM1_ADDR                                     0x0000000c
#define ENET_CFGSSQMIQM1_DEFAULT                                  0x0000006c
#define ENET_CFGSSQMIFPDISABLE_ADDR                               0x00000010
#define ENET_CFGSSQMIFPDISABLE_DEFAULT                            0x00000000
#define ENET_CFGSSQMIFPRESET_ADDR                                 0x00000014
#define ENET_CFGSSQMIFPRESET_DEFAULT                              0x00000000
#define ENET_CFGSSQMIWQDISABLE_ADDR                               0x00000018
#define ENET_CFGSSQMIWQDISABLE_DEFAULT                            0x00000000
#define ENET_CFGSSQMIWQRESET_ADDR                                 0x0000001c
#define ENET_CFGSSQMIWQRESET_DEFAULT                              0x00000000
#define ENET_STSSSQMIFPPTR0_ADDR                                  0x00000020
#define ENET_STSSSQMIFPPTR0_DEFAULT                               0x00000000
#define ENET_STSSSQMIFPPTR1_ADDR                                  0x00000024
#define ENET_STSSSQMIFPPTR1_DEFAULT                               0x00000000
#define ENET_STSSSQMIFPPTR2_ADDR                                  0x00000028
#define ENET_STSSSQMIFPPTR2_DEFAULT                               0x00000000
#define ENET_STSSSQMIFPPTR3_ADDR                                  0x0000002c
#define ENET_STSSSQMIFPPTR3_DEFAULT                               0x00000000
#define ENET_STSSSQMIFPNUMENTRIES0_ADDR                           0x00000030
#define ENET_STSSSQMIFPNUMENTRIES0_DEFAULT                        0x00000000
#define ENET_STSSSQMIFPNUMENTRIES1_ADDR                           0x00000034
#define ENET_STSSSQMIFPNUMENTRIES1_DEFAULT                        0x00000000
#define ENET_STSSSQMIFPNUMENTRIES2_ADDR                           0x00000038
#define ENET_STSSSQMIFPNUMENTRIES2_DEFAULT                        0x00000000
#define ENET_STSSSQMIFPNUMENTRIES3_ADDR                           0x0000003c
#define ENET_STSSSQMIFPNUMENTRIES3_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQPTR0_ADDR                                  0x00000040
#define ENET_STSSSQMIWQPTR0_DEFAULT                               0x00000000
#define ENET_STSSSQMIWQPTR1_ADDR                                  0x00000044
#define ENET_STSSSQMIWQPTR1_DEFAULT                               0x00000000
#define ENET_STSSSQMIWQPTR2_ADDR                                  0x00000048
#define ENET_STSSSQMIWQPTR2_DEFAULT                               0x00000000
#define ENET_STSSSQMIWQPTR3_ADDR                                  0x0000004c
#define ENET_STSSSQMIWQPTR3_DEFAULT                               0x00000000
#define ENET_STSSSQMIWQNUMENTRIES0_ADDR                           0x00000050
#define ENET_STSSSQMIWQNUMENTRIES0_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES1_ADDR                           0x00000054
#define ENET_STSSSQMIWQNUMENTRIES1_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES2_ADDR                           0x00000058
#define ENET_STSSSQMIWQNUMENTRIES2_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES3_ADDR                           0x0000005c
#define ENET_STSSSQMIWQNUMENTRIES3_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES4_ADDR                           0x00000060
#define ENET_STSSSQMIWQNUMENTRIES4_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES5_ADDR                           0x00000064
#define ENET_STSSSQMIWQNUMENTRIES5_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES6_ADDR                           0x00000068
#define ENET_STSSSQMIWQNUMENTRIES6_DEFAULT                        0x00000000
#define ENET_STSSSQMIWQNUMENTRIES7_ADDR                           0x0000006c
#define ENET_STSSSQMIWQNUMENTRIES7_DEFAULT                        0x00000000
#define ENET_CFGSSQMISABENABLE_ADDR                               0x00000070
#define ENET_CFGSSQMISABENABLE_DEFAULT                            0x00000000
#define ENET_CFGSSQMISAB0_ADDR                                    0x00000074
#define ENET_CFGSSQMISAB0_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB1_ADDR                                    0x00000078
#define ENET_CFGSSQMISAB1_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB2_ADDR                                    0x0000007c
#define ENET_CFGSSQMISAB2_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB3_ADDR                                    0x00000080
#define ENET_CFGSSQMISAB3_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB4_ADDR                                    0x00000084
#define ENET_CFGSSQMISAB4_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB5_ADDR                                    0x00000088
#define ENET_CFGSSQMISAB5_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB6_ADDR                                    0x0000008c
#define ENET_CFGSSQMISAB6_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB7_ADDR                                    0x00000090
#define ENET_CFGSSQMISAB7_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB8_ADDR                                    0x00000094
#define ENET_CFGSSQMISAB8_DEFAULT                                 0x00000000
#define ENET_CFGSSQMISAB9_ADDR                                    0x00000098
#define ENET_CFGSSQMISAB9_DEFAULT                                 0x00000000
#define ENET_STSSSQMIINT0_ADDR                                    0x0000009c
#define ENET_STSSSQMIINT0_DEFAULT                                 0x00000000
#define ENET_STSSSQMIINT0MASK_ADDR                                0x000000a0
#define ENET_STSSSQMIINT1_ADDR                                    0x000000a4
#define ENET_STSSSQMIINT1_DEFAULT                                 0x00000000
#define ENET_STSSSQMIINT1MASK_ADDR                                0x000000a8
#define ENET_STSSSQMIINT2_ADDR                                    0x000000ac
#define ENET_STSSSQMIINT2_DEFAULT                                 0x00000000
#define ENET_STSSSQMIINT2MASK_ADDR                                0x000000b0
#define ENET_STSSSQMIINT3_ADDR                                    0x000000b4
#define ENET_STSSSQMIINT3_DEFAULT                                 0x00000000
#define ENET_STSSSQMIINT3MASK_ADDR                                0x000000b8
#define ENET_STSSSQMIINT4_ADDR                                    0x000000bc
#define ENET_STSSSQMIINT4_DEFAULT                                 0x00000000
#define ENET_STSSSQMIINT4MASK_ADDR                                0x000000c0
#define ENET_CFGSSQMIDBGCTRL_ADDR                                 0x000000c4
#define ENET_CFGSSQMIDBGCTRL_DEFAULT                              0x00000000
#define ENET_CFGSSQMIDBGDATA0_ADDR                                0x000000c8
#define ENET_CFGSSQMIDBGDATA0_DEFAULT                             0x00000000
#define ENET_CFGSSQMIDBGDATA1_ADDR                                0x000000cc
#define ENET_CFGSSQMIDBGDATA1_DEFAULT                             0x00000000
#define ENET_CFGSSQMIDBGDATA2_ADDR                                0x000000d0
#define ENET_CFGSSQMIDBGDATA2_DEFAULT                             0x00000000
#define ENET_CFGSSQMIDBGDATA3_ADDR                                0x000000d4
#define ENET_CFGSSQMIDBGDATA3_DEFAULT                             0x00000000
#define ENET_STSSSQMIDBGDATA_ADDR                                 0x000000d8
#define ENET_STSSSQMIDBGDATA_DEFAULT                              0x00000000
#define ENET_CFGSSQMIFPQASSOC_ADDR                                0x000000dc
#define ENET_CFGSSQMIFPQASSOC_DEFAULT                             0x00000000
#define ENET_CFGSSQMIWQASSOC_ADDR                                 0x000000e0
#define ENET_CFGSSQMIWQASSOC_DEFAULT                              0x00000000
#define ENET_CFGSSQMIMEMORY_ADDR                                  0x000000e4
#define ENET_CFGSSQMIMEMORY_DEFAULT                               0x00000000
#define ENET_STSSSQMIFIFO_ADDR                                    0x000000e8
#define ENET_STSSSQMIFIFO_DEFAULT                                 0x07ffffff
#define ENET_CFGSSQMIQMLITE_ADDR                                  0x000000ec
#define ENET_CFGSSQMIQMLITE_DEFAULT                               0x00000040
#define ENET_CFGSSQMIQMLITEFPQASSOC_ADDR                          0x000000f0
#define ENET_CFGSSQMIQMLITEFPQASSOC_DEFAULT                       0x00000000
#define ENET_CFGSSQMIQMLITEWQASSOC_ADDR                           0x000000f4
#define ENET_CFGSSQMIQMLITEWQASSOC_DEFAULT                        0x00000000
#define ENET_CFGSSQMIQMHOLD_ADDR                                  0x000000f8
#define ENET_CFGSSQMIQMHOLD_DEFAULT                               0x80000003
#define ENET_STSSSQMIQMHOLD_ADDR                                  0x000000fc
#define ENET_STSSSQMIQMHOLD_DEFAULT                               0x00000000
#define ENET_CFGSSQMIFPQVCASSOC0_ADDR                             0x00000100
#define ENET_CFGSSQMIFPQVCASSOC0_DEFAULT                          0x00000000
#define ENET_CFGSSQMIFPQVCASSOC1_ADDR                             0x00000104
#define ENET_CFGSSQMIFPQVCASSOC1_DEFAULT                          0x00000000
#define ENET_CFGSSQMIWQVCASSOC0_ADDR                              0x00000108
#define ENET_CFGSSQMIWQVCASSOC0_DEFAULT                           0x00000000
#define ENET_CFGSSQMIWQVCASSOC1_ADDR                              0x0000010c
#define ENET_CFGSSQMIWQVCASSOC1_DEFAULT                           0x00000000
#define ENET_CFGSSQMIQM2_ADDR                                     0x00000110
#define ENET_CFGSSQMIQM2_DEFAULT                                  0x00000078

/*	Register CfgSsQmi0	*/ 
/*	 Fields WQBavailFMWait	 */
#define ENET_WQBAVAILFMWAIT0_WIDTH                                         1
#define ENET_WQBAVAILFMWAIT0_SHIFT                                        31
#define ENET_WQBAVAILFMWAIT0_MASK                                 0x80000000
#define ENET_WQBAVAILFMWAIT0_RD(src)              (((src) & 0x80000000)>>31)
#define ENET_WQBAVAILFMWAIT0_WR(src)         (((u32)(src)<<31) & 0x80000000)
#define ENET_WQBAVAILFMWAIT0_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields FPDecDiffThreshold	 */
#define ENET_FPDECDIFFTHRESHOLD0_WIDTH                                     4
#define ENET_FPDECDIFFTHRESHOLD0_SHIFT                                    27
#define ENET_FPDECDIFFTHRESHOLD0_MASK                             0x78000000
#define ENET_FPDECDIFFTHRESHOLD0_RD(src)          (((src) & 0x78000000)>>27)
#define ENET_FPDECDIFFTHRESHOLD0_WR(src)     (((u32)(src)<<27) & 0x78000000)
#define ENET_FPDECDIFFTHRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x78000000) | (((u32)(src)<<27) & 0x78000000))
/*	 Fields WQDecDiffThreshold	 */
#define ENET_WQDECDIFFTHRESHOLD0_WIDTH                                     5
#define ENET_WQDECDIFFTHRESHOLD0_SHIFT                                    22
#define ENET_WQDECDIFFTHRESHOLD0_MASK                             0x07c00000
#define ENET_WQDECDIFFTHRESHOLD0_RD(src)          (((src) & 0x07c00000)>>22)
#define ENET_WQDECDIFFTHRESHOLD0_WR(src)     (((u32)(src)<<22) & 0x07c00000)
#define ENET_WQDECDIFFTHRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x07c00000) | (((u32)(src)<<22) & 0x07c00000))
/*	 Fields DeallocThreshold	 */
#define ENET_DEALLOCTHRESHOLD0_WIDTH                                       4
#define ENET_DEALLOCTHRESHOLD0_SHIFT                                      18
#define ENET_DEALLOCTHRESHOLD0_MASK                               0x003c0000
#define ENET_DEALLOCTHRESHOLD0_RD(src)            (((src) & 0x003c0000)>>18)
#define ENET_DEALLOCTHRESHOLD0_WR(src)       (((u32)(src)<<18) & 0x003c0000)
#define ENET_DEALLOCTHRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x003c0000) | (((u32)(src)<<18) & 0x003c0000))
/*	 Fields FPDecThreshold	 */
#define ENET_FPDECTHRESHOLD0_WIDTH                                         4
#define ENET_FPDECTHRESHOLD0_SHIFT                                        14
#define ENET_FPDECTHRESHOLD0_MASK                                 0x0003c000
#define ENET_FPDECTHRESHOLD0_RD(src)              (((src) & 0x0003c000)>>14)
#define ENET_FPDECTHRESHOLD0_WR(src)         (((u32)(src)<<14) & 0x0003c000)
#define ENET_FPDECTHRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x0003c000) | (((u32)(src)<<14) & 0x0003c000))
/*	 Fields FPBAvlThreshold	 */
#define ENET_FPBAVLTHRESHOLD0_WIDTH                                        4
#define ENET_FPBAVLTHRESHOLD0_SHIFT                                       10
#define ENET_FPBAVLTHRESHOLD0_MASK                                0x00003c00
#define ENET_FPBAVLTHRESHOLD0_RD(src)             (((src) & 0x00003c00)>>10)
#define ENET_FPBAVLTHRESHOLD0_WR(src)        (((u32)(src)<<10) & 0x00003c00)
#define ENET_FPBAVLTHRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x00003c00) | (((u32)(src)<<10) & 0x00003c00))
/*	 Fields WQDecThreshold	 */
#define ENET_WQDECTHRESHOLD0_WIDTH                                         5
#define ENET_WQDECTHRESHOLD0_SHIFT                                         5
#define ENET_WQDECTHRESHOLD0_MASK                                 0x000003e0
#define ENET_WQDECTHRESHOLD0_RD(src)               (((src) & 0x000003e0)>>5)
#define ENET_WQDECTHRESHOLD0_WR(src)          (((u32)(src)<<5) & 0x000003e0)
#define ENET_WQDECTHRESHOLD0_SET(dst,src) \
                       (((dst) & ~0x000003e0) | (((u32)(src)<<5) & 0x000003e0))
/*	 Fields WQBAvlThreshold	 */
#define ENET_WQBAVLTHRESHOLD0_WIDTH                                        5
#define ENET_WQBAVLTHRESHOLD0_SHIFT                                        0
#define ENET_WQBAVLTHRESHOLD0_MASK                                0x0000001f
#define ENET_WQBAVLTHRESHOLD0_RD(src)                 (((src) & 0x0000001f))
#define ENET_WQBAVLTHRESHOLD0_WR(src)            (((u32)(src)) & 0x0000001f)
#define ENET_WQBAVLTHRESHOLD0_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register CfgSsQmi1	*/ 
/*	 Fields CmOverrideLLFields	 */
#define ENET_CMOVERRIDELLFIELDS1_WIDTH                                     1
#define ENET_CMOVERRIDELLFIELDS1_SHIFT                                    15
#define ENET_CMOVERRIDELLFIELDS1_MASK                             0x00008000
#define ENET_CMOVERRIDELLFIELDS1_RD(src)          (((src) & 0x00008000)>>15)
#define ENET_CMOVERRIDELLFIELDS1_WR(src)     (((u32)(src)<<15) & 0x00008000)
#define ENET_CMOVERRIDELLFIELDS1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields CmCtrlbuffThreshold	 */
#define ENET_CMCTRLBUFFTHRESHOLD1_WIDTH                                    3
#define ENET_CMCTRLBUFFTHRESHOLD1_SHIFT                                   12
#define ENET_CMCTRLBUFFTHRESHOLD1_MASK                            0x00007000
#define ENET_CMCTRLBUFFTHRESHOLD1_RD(src)         (((src) & 0x00007000)>>12)
#define ENET_CMCTRLBUFFTHRESHOLD1_WR(src)    (((u32)(src)<<12) & 0x00007000)
#define ENET_CMCTRLBUFFTHRESHOLD1_SET(dst,src) \
                      (((dst) & ~0x00007000) | (((u32)(src)<<12) & 0x00007000))
/*	 Fields CmDatabuffThreshold	 */
#define ENET_CMDATABUFFTHRESHOLD1_WIDTH                                    5
#define ENET_CMDATABUFFTHRESHOLD1_SHIFT                                    7
#define ENET_CMDATABUFFTHRESHOLD1_MASK                            0x00000f80
#define ENET_CMDATABUFFTHRESHOLD1_RD(src)          (((src) & 0x00000f80)>>7)
#define ENET_CMDATABUFFTHRESHOLD1_WR(src)     (((u32)(src)<<7) & 0x00000f80)
#define ENET_CMDATABUFFTHRESHOLD1_SET(dst,src) \
                       (((dst) & ~0x00000f80) | (((u32)(src)<<7) & 0x00000f80))
/*	 Fields CmMsgfThreshold	 */
#define ENET_CMMSGFTHRESHOLD1_WIDTH                                        4
#define ENET_CMMSGFTHRESHOLD1_SHIFT                                        3
#define ENET_CMMSGFTHRESHOLD1_MASK                                0x00000078
#define ENET_CMMSGFTHRESHOLD1_RD(src)              (((src) & 0x00000078)>>3)
#define ENET_CMMSGFTHRESHOLD1_WR(src)         (((u32)(src)<<3) & 0x00000078)
#define ENET_CMMSGFTHRESHOLD1_SET(dst,src) \
                       (((dst) & ~0x00000078) | (((u32)(src)<<3) & 0x00000078))
/*	 Fields CmRegfThreshold	 */
#define ENET_CMREGFTHRESHOLD1_WIDTH                                        3
#define ENET_CMREGFTHRESHOLD1_SHIFT                                        0
#define ENET_CMREGFTHRESHOLD1_MASK                                0x00000007
#define ENET_CMREGFTHRESHOLD1_RD(src)                 (((src) & 0x00000007))
#define ENET_CMREGFTHRESHOLD1_WR(src)            (((u32)(src)) & 0x00000007)
#define ENET_CMREGFTHRESHOLD1_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register CfgSsQmiQM0	*/ 
/*	 Fields Address	 */
#define ENET_ADDRESS0_WIDTH                                               20
#define ENET_ADDRESS0_SHIFT                                                0
#define ENET_ADDRESS0_MASK                                        0x000fffff
#define ENET_ADDRESS0_RD(src)                         (((src) & 0x000fffff))
#define ENET_ADDRESS0_WR(src)                    (((u32)(src)) & 0x000fffff)
#define ENET_ADDRESS0_SET(dst,src) \
                          (((dst) & ~0x000fffff) | (((u32)(src)) & 0x000fffff))

/*	Register CfgSsQmiQM1	*/ 
/*	 Fields Address	 */
#define ENET_ADDRESS1_WIDTH                                               20
#define ENET_ADDRESS1_SHIFT                                                0
#define ENET_ADDRESS1_MASK                                        0x000fffff
#define ENET_ADDRESS1_RD(src)                         (((src) & 0x000fffff))
#define ENET_ADDRESS1_WR(src)                    (((u32)(src)) & 0x000fffff)
#define ENET_ADDRESS1_SET(dst,src) \
                          (((dst) & ~0x000fffff) | (((u32)(src)) & 0x000fffff))

/*	Register CfgSsQmiFPDisable	*/ 
/*	 Fields Disable	 */
#define ENET_DISABLE_WIDTH                                                32
#define ENET_DISABLE_SHIFT                                                 0
#define ENET_DISABLE_MASK                                         0xffffffff
#define ENET_DISABLE_RD(src)                          (((src) & 0xffffffff))
#define ENET_DISABLE_WR(src)                     (((u32)(src)) & 0xffffffff)
#define ENET_DISABLE_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiFPReset	*/ 
/*	 Fields Reset	 */
#define ENET_RESET_WIDTH                                                  32
#define ENET_RESET_SHIFT                                                   0
#define ENET_RESET_MASK                                           0xffffffff
#define ENET_RESET_RD(src)                            (((src) & 0xffffffff))
#define ENET_RESET_WR(src)                       (((u32)(src)) & 0xffffffff)
#define ENET_RESET_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiWQDisable	*/ 
/*	 Fields Disable	 */
#define ENET_DISABLE_F1_WIDTH                                             32
#define ENET_DISABLE_F1_SHIFT                                              0
#define ENET_DISABLE_F1_MASK                                      0xffffffff
#define ENET_DISABLE_F1_RD(src)                       (((src) & 0xffffffff))
#define ENET_DISABLE_F1_WR(src)                  (((u32)(src)) & 0xffffffff)
#define ENET_DISABLE_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiWQReset	*/ 
/*	 Fields Reset	 */
#define ENET_RESET_F1_WIDTH                                               32
#define ENET_RESET_F1_SHIFT                                                0
#define ENET_RESET_F1_MASK                                        0xffffffff
#define ENET_RESET_F1_RD(src)                         (((src) & 0xffffffff))
#define ENET_RESET_F1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_RESET_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiFPPtr0	*/ 
/*	 Fields FP7	 */
#define ENET_FP70_WIDTH                                                    3
#define ENET_FP70_SHIFT                                                   28
#define ENET_FP70_MASK                                            0x70000000
#define ENET_FP70_RD(src)                         (((src) & 0x70000000)>>28)
#define ENET_FP70_SET(dst,src) \
                      (((dst) & ~0x70000000) | (((u32)(src)<<28) & 0x70000000))
/*	 Fields FP6	 */
#define ENET_FP60_WIDTH                                                    3
#define ENET_FP60_SHIFT                                                   24
#define ENET_FP60_MASK                                            0x07000000
#define ENET_FP60_RD(src)                         (((src) & 0x07000000)>>24)
#define ENET_FP60_SET(dst,src) \
                      (((dst) & ~0x07000000) | (((u32)(src)<<24) & 0x07000000))
/*	 Fields FP5	 */
#define ENET_FP50_WIDTH                                                    3
#define ENET_FP50_SHIFT                                                   20
#define ENET_FP50_MASK                                            0x00700000
#define ENET_FP50_RD(src)                         (((src) & 0x00700000)>>20)
#define ENET_FP50_SET(dst,src) \
                      (((dst) & ~0x00700000) | (((u32)(src)<<20) & 0x00700000))
/*	 Fields FP4	 */
#define ENET_FP40_WIDTH                                                    3
#define ENET_FP40_SHIFT                                                   16
#define ENET_FP40_MASK                                            0x00070000
#define ENET_FP40_RD(src)                         (((src) & 0x00070000)>>16)
#define ENET_FP40_SET(dst,src) \
                      (((dst) & ~0x00070000) | (((u32)(src)<<16) & 0x00070000))
/*	 Fields FP3	 */
#define ENET_FP30_WIDTH                                                    3
#define ENET_FP30_SHIFT                                                   12
#define ENET_FP30_MASK                                            0x00007000
#define ENET_FP30_RD(src)                         (((src) & 0x00007000)>>12)
#define ENET_FP30_SET(dst,src) \
                      (((dst) & ~0x00007000) | (((u32)(src)<<12) & 0x00007000))
/*	 Fields FP2	 */
#define ENET_FP20_WIDTH                                                    3
#define ENET_FP20_SHIFT                                                    8
#define ENET_FP20_MASK                                            0x00000700
#define ENET_FP20_RD(src)                          (((src) & 0x00000700)>>8)
#define ENET_FP20_SET(dst,src) \
                       (((dst) & ~0x00000700) | (((u32)(src)<<8) & 0x00000700))
/*	 Fields FP1	 */
#define ENET_FP10_WIDTH                                                    3
#define ENET_FP10_SHIFT                                                    4
#define ENET_FP10_MASK                                            0x00000070
#define ENET_FP10_RD(src)                          (((src) & 0x00000070)>>4)
#define ENET_FP10_SET(dst,src) \
                       (((dst) & ~0x00000070) | (((u32)(src)<<4) & 0x00000070))
/*	 Fields FP0	 */
#define ENET_FP00_WIDTH                                                    3
#define ENET_FP00_SHIFT                                                    0
#define ENET_FP00_MASK                                            0x00000007
#define ENET_FP00_RD(src)                             (((src) & 0x00000007))
#define ENET_FP00_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register StsSsQmiFPPtr1	*/ 
/*	 Fields FP15	 */
#define ENET_FP151_WIDTH                                                   3
#define ENET_FP151_SHIFT                                                  28
#define ENET_FP151_MASK                                           0x70000000
#define ENET_FP151_RD(src)                        (((src) & 0x70000000)>>28)
#define ENET_FP151_SET(dst,src) \
                      (((dst) & ~0x70000000) | (((u32)(src)<<28) & 0x70000000))
/*	 Fields FP14	 */
#define ENET_FP141_WIDTH                                                   3
#define ENET_FP141_SHIFT                                                  24
#define ENET_FP141_MASK                                           0x07000000
#define ENET_FP141_RD(src)                        (((src) & 0x07000000)>>24)
#define ENET_FP141_SET(dst,src) \
                      (((dst) & ~0x07000000) | (((u32)(src)<<24) & 0x07000000))
/*	 Fields FP13	 */
#define ENET_FP131_WIDTH                                                   3
#define ENET_FP131_SHIFT                                                  20
#define ENET_FP131_MASK                                           0x00700000
#define ENET_FP131_RD(src)                        (((src) & 0x00700000)>>20)
#define ENET_FP131_SET(dst,src) \
                      (((dst) & ~0x00700000) | (((u32)(src)<<20) & 0x00700000))
/*	 Fields FP12	 */
#define ENET_FP121_WIDTH                                                   3
#define ENET_FP121_SHIFT                                                  16
#define ENET_FP121_MASK                                           0x00070000
#define ENET_FP121_RD(src)                        (((src) & 0x00070000)>>16)
#define ENET_FP121_SET(dst,src) \
                      (((dst) & ~0x00070000) | (((u32)(src)<<16) & 0x00070000))
/*	 Fields FP11	 */
#define ENET_FP111_WIDTH                                                   3
#define ENET_FP111_SHIFT                                                  12
#define ENET_FP111_MASK                                           0x00007000
#define ENET_FP111_RD(src)                        (((src) & 0x00007000)>>12)
#define ENET_FP111_SET(dst,src) \
                      (((dst) & ~0x00007000) | (((u32)(src)<<12) & 0x00007000))
/*	 Fields FP10	 */
#define ENET_FP101_WIDTH                                                   3
#define ENET_FP101_SHIFT                                                   8
#define ENET_FP101_MASK                                           0x00000700
#define ENET_FP101_RD(src)                         (((src) & 0x00000700)>>8)
#define ENET_FP101_SET(dst,src) \
                       (((dst) & ~0x00000700) | (((u32)(src)<<8) & 0x00000700))
/*	 Fields FP9	 */
#define ENET_FP91_WIDTH                                                    3
#define ENET_FP91_SHIFT                                                    4
#define ENET_FP91_MASK                                            0x00000070
#define ENET_FP91_RD(src)                          (((src) & 0x00000070)>>4)
#define ENET_FP91_SET(dst,src) \
                       (((dst) & ~0x00000070) | (((u32)(src)<<4) & 0x00000070))
/*	 Fields FP8	 */
#define ENET_FP81_WIDTH                                                    3
#define ENET_FP81_SHIFT                                                    0
#define ENET_FP81_MASK                                            0x00000007
#define ENET_FP81_RD(src)                             (((src) & 0x00000007))
#define ENET_FP81_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register StsSsQmiFPPtr2	*/ 
/*	 Fields FP23	 */
#define ENET_FP232_WIDTH                                                   3
#define ENET_FP232_SHIFT                                                  28
#define ENET_FP232_MASK                                           0x70000000
#define ENET_FP232_RD(src)                        (((src) & 0x70000000)>>28)
#define ENET_FP232_SET(dst,src) \
                      (((dst) & ~0x70000000) | (((u32)(src)<<28) & 0x70000000))
/*	 Fields FP22	 */
#define ENET_FP222_WIDTH                                                   3
#define ENET_FP222_SHIFT                                                  24
#define ENET_FP222_MASK                                           0x07000000
#define ENET_FP222_RD(src)                        (((src) & 0x07000000)>>24)
#define ENET_FP222_SET(dst,src) \
                      (((dst) & ~0x07000000) | (((u32)(src)<<24) & 0x07000000))
/*	 Fields FP21	 */
#define ENET_FP212_WIDTH                                                   3
#define ENET_FP212_SHIFT                                                  20
#define ENET_FP212_MASK                                           0x00700000
#define ENET_FP212_RD(src)                        (((src) & 0x00700000)>>20)
#define ENET_FP212_SET(dst,src) \
                      (((dst) & ~0x00700000) | (((u32)(src)<<20) & 0x00700000))
/*	 Fields FP20	 */
#define ENET_FP202_WIDTH                                                   3
#define ENET_FP202_SHIFT                                                  16
#define ENET_FP202_MASK                                           0x00070000
#define ENET_FP202_RD(src)                        (((src) & 0x00070000)>>16)
#define ENET_FP202_SET(dst,src) \
                      (((dst) & ~0x00070000) | (((u32)(src)<<16) & 0x00070000))
/*	 Fields FP19	 */
#define ENET_FP192_WIDTH                                                   3
#define ENET_FP192_SHIFT                                                  12
#define ENET_FP192_MASK                                           0x00007000
#define ENET_FP192_RD(src)                        (((src) & 0x00007000)>>12)
#define ENET_FP192_SET(dst,src) \
                      (((dst) & ~0x00007000) | (((u32)(src)<<12) & 0x00007000))
/*	 Fields FP18	 */
#define ENET_FP182_WIDTH                                                   3
#define ENET_FP182_SHIFT                                                   8
#define ENET_FP182_MASK                                           0x00000700
#define ENET_FP182_RD(src)                         (((src) & 0x00000700)>>8)
#define ENET_FP182_SET(dst,src) \
                       (((dst) & ~0x00000700) | (((u32)(src)<<8) & 0x00000700))
/*	 Fields FP17	 */
#define ENET_FP172_WIDTH                                                   3
#define ENET_FP172_SHIFT                                                   4
#define ENET_FP172_MASK                                           0x00000070
#define ENET_FP172_RD(src)                         (((src) & 0x00000070)>>4)
#define ENET_FP172_SET(dst,src) \
                       (((dst) & ~0x00000070) | (((u32)(src)<<4) & 0x00000070))
/*	 Fields FP16	 */
#define ENET_FP162_WIDTH                                                   3
#define ENET_FP162_SHIFT                                                   0
#define ENET_FP162_MASK                                           0x00000007
#define ENET_FP162_RD(src)                            (((src) & 0x00000007))
#define ENET_FP162_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register StsSsQmiFPPtr3	*/ 
/*	 Fields FP31	 */
#define ENET_FP313_WIDTH                                                   3
#define ENET_FP313_SHIFT                                                  28
#define ENET_FP313_MASK                                           0x70000000
#define ENET_FP313_RD(src)                        (((src) & 0x70000000)>>28)
#define ENET_FP313_SET(dst,src) \
                      (((dst) & ~0x70000000) | (((u32)(src)<<28) & 0x70000000))
/*	 Fields FP30	 */
#define ENET_FP303_WIDTH                                                   3
#define ENET_FP303_SHIFT                                                  24
#define ENET_FP303_MASK                                           0x07000000
#define ENET_FP303_RD(src)                        (((src) & 0x07000000)>>24)
#define ENET_FP303_SET(dst,src) \
                      (((dst) & ~0x07000000) | (((u32)(src)<<24) & 0x07000000))
/*	 Fields FP29	 */
#define ENET_FP293_WIDTH                                                   3
#define ENET_FP293_SHIFT                                                  20
#define ENET_FP293_MASK                                           0x00700000
#define ENET_FP293_RD(src)                        (((src) & 0x00700000)>>20)
#define ENET_FP293_SET(dst,src) \
                      (((dst) & ~0x00700000) | (((u32)(src)<<20) & 0x00700000))
/*	 Fields FP28	 */
#define ENET_FP283_WIDTH                                                   3
#define ENET_FP283_SHIFT                                                  16
#define ENET_FP283_MASK                                           0x00070000
#define ENET_FP283_RD(src)                        (((src) & 0x00070000)>>16)
#define ENET_FP283_SET(dst,src) \
                      (((dst) & ~0x00070000) | (((u32)(src)<<16) & 0x00070000))
/*	 Fields FP27	 */
#define ENET_FP273_WIDTH                                                   3
#define ENET_FP273_SHIFT                                                  12
#define ENET_FP273_MASK                                           0x00007000
#define ENET_FP273_RD(src)                        (((src) & 0x00007000)>>12)
#define ENET_FP273_SET(dst,src) \
                      (((dst) & ~0x00007000) | (((u32)(src)<<12) & 0x00007000))
/*	 Fields FP26	 */
#define ENET_FP263_WIDTH                                                   3
#define ENET_FP263_SHIFT                                                   8
#define ENET_FP263_MASK                                           0x00000700
#define ENET_FP263_RD(src)                         (((src) & 0x00000700)>>8)
#define ENET_FP263_SET(dst,src) \
                       (((dst) & ~0x00000700) | (((u32)(src)<<8) & 0x00000700))
/*	 Fields FP25	 */
#define ENET_FP253_WIDTH                                                   3
#define ENET_FP253_SHIFT                                                   4
#define ENET_FP253_MASK                                           0x00000070
#define ENET_FP253_RD(src)                         (((src) & 0x00000070)>>4)
#define ENET_FP253_SET(dst,src) \
                       (((dst) & ~0x00000070) | (((u32)(src)<<4) & 0x00000070))
/*	 Fields FP24	 */
#define ENET_FP243_WIDTH                                                   3
#define ENET_FP243_SHIFT                                                   0
#define ENET_FP243_MASK                                           0x00000007
#define ENET_FP243_RD(src)                            (((src) & 0x00000007))
#define ENET_FP243_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register StsSsQmiFPNumEntries0	*/ 
/*	 Fields FP7	 */
#define ENET_FP70_F1_WIDTH                                                 4
#define ENET_FP70_F1_SHIFT                                                28
#define ENET_FP70_F1_MASK                                         0xf0000000
#define ENET_FP70_F1_RD(src)                      (((src) & 0xf0000000)>>28)
#define ENET_FP70_F1_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields FP6	 */
#define ENET_FP60_F1_WIDTH                                                 4
#define ENET_FP60_F1_SHIFT                                                24
#define ENET_FP60_F1_MASK                                         0x0f000000
#define ENET_FP60_F1_RD(src)                      (((src) & 0x0f000000)>>24)
#define ENET_FP60_F1_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields FP5	 */
#define ENET_FP50_F1_WIDTH                                                 4
#define ENET_FP50_F1_SHIFT                                                20
#define ENET_FP50_F1_MASK                                         0x00f00000
#define ENET_FP50_F1_RD(src)                      (((src) & 0x00f00000)>>20)
#define ENET_FP50_F1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields FP4	 */
#define ENET_FP40_F1_WIDTH                                                 4
#define ENET_FP40_F1_SHIFT                                                16
#define ENET_FP40_F1_MASK                                         0x000f0000
#define ENET_FP40_F1_RD(src)                      (((src) & 0x000f0000)>>16)
#define ENET_FP40_F1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields FP3	 */
#define ENET_FP30_F1_WIDTH                                                 4
#define ENET_FP30_F1_SHIFT                                                12
#define ENET_FP30_F1_MASK                                         0x0000f000
#define ENET_FP30_F1_RD(src)                      (((src) & 0x0000f000)>>12)
#define ENET_FP30_F1_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields FP2	 */
#define ENET_FP20_F1_WIDTH                                                 4
#define ENET_FP20_F1_SHIFT                                                 8
#define ENET_FP20_F1_MASK                                         0x00000f00
#define ENET_FP20_F1_RD(src)                       (((src) & 0x00000f00)>>8)
#define ENET_FP20_F1_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields FP1	 */
#define ENET_FP10_F1_WIDTH                                                 4
#define ENET_FP10_F1_SHIFT                                                 4
#define ENET_FP10_F1_MASK                                         0x000000f0
#define ENET_FP10_F1_RD(src)                       (((src) & 0x000000f0)>>4)
#define ENET_FP10_F1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields FP0	 */
#define ENET_FP00_F1_WIDTH                                                 4
#define ENET_FP00_F1_SHIFT                                                 0
#define ENET_FP00_F1_MASK                                         0x0000000f
#define ENET_FP00_F1_RD(src)                          (((src) & 0x0000000f))
#define ENET_FP00_F1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiFPNumEntries1	*/ 
/*	 Fields FP15	 */
#define ENET_FP151_F1_WIDTH                                                4
#define ENET_FP151_F1_SHIFT                                               28
#define ENET_FP151_F1_MASK                                        0xf0000000
#define ENET_FP151_F1_RD(src)                     (((src) & 0xf0000000)>>28)
#define ENET_FP151_F1_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields FP14	 */
#define ENET_FP141_F1_WIDTH                                                4
#define ENET_FP141_F1_SHIFT                                               24
#define ENET_FP141_F1_MASK                                        0x0f000000
#define ENET_FP141_F1_RD(src)                     (((src) & 0x0f000000)>>24)
#define ENET_FP141_F1_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields FP13	 */
#define ENET_FP131_F1_WIDTH                                                4
#define ENET_FP131_F1_SHIFT                                               20
#define ENET_FP131_F1_MASK                                        0x00f00000
#define ENET_FP131_F1_RD(src)                     (((src) & 0x00f00000)>>20)
#define ENET_FP131_F1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields FP12	 */
#define ENET_FP121_F1_WIDTH                                                4
#define ENET_FP121_F1_SHIFT                                               16
#define ENET_FP121_F1_MASK                                        0x000f0000
#define ENET_FP121_F1_RD(src)                     (((src) & 0x000f0000)>>16)
#define ENET_FP121_F1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields FP11	 */
#define ENET_FP111_F1_WIDTH                                                4
#define ENET_FP111_F1_SHIFT                                               12
#define ENET_FP111_F1_MASK                                        0x0000f000
#define ENET_FP111_F1_RD(src)                     (((src) & 0x0000f000)>>12)
#define ENET_FP111_F1_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields FP10	 */
#define ENET_FP101_F1_WIDTH                                                4
#define ENET_FP101_F1_SHIFT                                                8
#define ENET_FP101_F1_MASK                                        0x00000f00
#define ENET_FP101_F1_RD(src)                      (((src) & 0x00000f00)>>8)
#define ENET_FP101_F1_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields FP9	 */
#define ENET_FP91_F1_WIDTH                                                 4
#define ENET_FP91_F1_SHIFT                                                 4
#define ENET_FP91_F1_MASK                                         0x000000f0
#define ENET_FP91_F1_RD(src)                       (((src) & 0x000000f0)>>4)
#define ENET_FP91_F1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields FP8	 */
#define ENET_FP81_F1_WIDTH                                                 4
#define ENET_FP81_F1_SHIFT                                                 0
#define ENET_FP81_F1_MASK                                         0x0000000f
#define ENET_FP81_F1_RD(src)                          (((src) & 0x0000000f))
#define ENET_FP81_F1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiFPNumEntries2	*/ 
/*	 Fields FP23	 */
#define ENET_FP232_F1_WIDTH                                                4
#define ENET_FP232_F1_SHIFT                                               28
#define ENET_FP232_F1_MASK                                        0xf0000000
#define ENET_FP232_F1_RD(src)                     (((src) & 0xf0000000)>>28)
#define ENET_FP232_F1_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields FP22	 */
#define ENET_FP222_F1_WIDTH                                                4
#define ENET_FP222_F1_SHIFT                                               24
#define ENET_FP222_F1_MASK                                        0x0f000000
#define ENET_FP222_F1_RD(src)                     (((src) & 0x0f000000)>>24)
#define ENET_FP222_F1_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields FP21	 */
#define ENET_FP212_F1_WIDTH                                                4
#define ENET_FP212_F1_SHIFT                                               20
#define ENET_FP212_F1_MASK                                        0x00f00000
#define ENET_FP212_F1_RD(src)                     (((src) & 0x00f00000)>>20)
#define ENET_FP212_F1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields FP20	 */
#define ENET_FP202_F1_WIDTH                                                4
#define ENET_FP202_F1_SHIFT                                               16
#define ENET_FP202_F1_MASK                                        0x000f0000
#define ENET_FP202_F1_RD(src)                     (((src) & 0x000f0000)>>16)
#define ENET_FP202_F1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields FP19	 */
#define ENET_FP192_F1_WIDTH                                                4
#define ENET_FP192_F1_SHIFT                                               12
#define ENET_FP192_F1_MASK                                        0x0000f000
#define ENET_FP192_F1_RD(src)                     (((src) & 0x0000f000)>>12)
#define ENET_FP192_F1_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields FP18	 */
#define ENET_FP182_F1_WIDTH                                                4
#define ENET_FP182_F1_SHIFT                                                8
#define ENET_FP182_F1_MASK                                        0x00000f00
#define ENET_FP182_F1_RD(src)                      (((src) & 0x00000f00)>>8)
#define ENET_FP182_F1_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields FP17	 */
#define ENET_FP172_F1_WIDTH                                                4
#define ENET_FP172_F1_SHIFT                                                4
#define ENET_FP172_F1_MASK                                        0x000000f0
#define ENET_FP172_F1_RD(src)                      (((src) & 0x000000f0)>>4)
#define ENET_FP172_F1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields FP16	 */
#define ENET_FP162_F1_WIDTH                                                4
#define ENET_FP162_F1_SHIFT                                                0
#define ENET_FP162_F1_MASK                                        0x0000000f
#define ENET_FP162_F1_RD(src)                         (((src) & 0x0000000f))
#define ENET_FP162_F1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiFPNumEntries3	*/ 
/*	 Fields FP31	 */
#define ENET_FP313_F1_WIDTH                                                4
#define ENET_FP313_F1_SHIFT                                               28
#define ENET_FP313_F1_MASK                                        0xf0000000
#define ENET_FP313_F1_RD(src)                     (((src) & 0xf0000000)>>28)
#define ENET_FP313_F1_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields FP30	 */
#define ENET_FP303_F1_WIDTH                                                4
#define ENET_FP303_F1_SHIFT                                               24
#define ENET_FP303_F1_MASK                                        0x0f000000
#define ENET_FP303_F1_RD(src)                     (((src) & 0x0f000000)>>24)
#define ENET_FP303_F1_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields FP29	 */
#define ENET_FP293_F1_WIDTH                                                4
#define ENET_FP293_F1_SHIFT                                               20
#define ENET_FP293_F1_MASK                                        0x00f00000
#define ENET_FP293_F1_RD(src)                     (((src) & 0x00f00000)>>20)
#define ENET_FP293_F1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields FP28	 */
#define ENET_FP283_F1_WIDTH                                                4
#define ENET_FP283_F1_SHIFT                                               16
#define ENET_FP283_F1_MASK                                        0x000f0000
#define ENET_FP283_F1_RD(src)                     (((src) & 0x000f0000)>>16)
#define ENET_FP283_F1_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields FP27	 */
#define ENET_FP273_F1_WIDTH                                                4
#define ENET_FP273_F1_SHIFT                                               12
#define ENET_FP273_F1_MASK                                        0x0000f000
#define ENET_FP273_F1_RD(src)                     (((src) & 0x0000f000)>>12)
#define ENET_FP273_F1_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields FP26	 */
#define ENET_FP263_F1_WIDTH                                                4
#define ENET_FP263_F1_SHIFT                                                8
#define ENET_FP263_F1_MASK                                        0x00000f00
#define ENET_FP263_F1_RD(src)                      (((src) & 0x00000f00)>>8)
#define ENET_FP263_F1_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields FP25	 */
#define ENET_FP253_F1_WIDTH                                                4
#define ENET_FP253_F1_SHIFT                                                4
#define ENET_FP253_F1_MASK                                        0x000000f0
#define ENET_FP253_F1_RD(src)                      (((src) & 0x000000f0)>>4)
#define ENET_FP253_F1_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields FP24	 */
#define ENET_FP243_F1_WIDTH                                                4
#define ENET_FP243_F1_SHIFT                                                0
#define ENET_FP243_F1_MASK                                        0x0000000f
#define ENET_FP243_F1_RD(src)                         (((src) & 0x0000000f))
#define ENET_FP243_F1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiWQPtr0	*/ 
/*	 Fields WQ7	 */
#define ENET_WQ70_WIDTH                                                    4
#define ENET_WQ70_SHIFT                                                   28
#define ENET_WQ70_MASK                                            0xf0000000
#define ENET_WQ70_RD(src)                         (((src) & 0xf0000000)>>28)
#define ENET_WQ70_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields WQ6	 */
#define ENET_WQ60_WIDTH                                                    4
#define ENET_WQ60_SHIFT                                                   24
#define ENET_WQ60_MASK                                            0x0f000000
#define ENET_WQ60_RD(src)                         (((src) & 0x0f000000)>>24)
#define ENET_WQ60_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields WQ5	 */
#define ENET_WQ50_WIDTH                                                    4
#define ENET_WQ50_SHIFT                                                   20
#define ENET_WQ50_MASK                                            0x00f00000
#define ENET_WQ50_RD(src)                         (((src) & 0x00f00000)>>20)
#define ENET_WQ50_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields WQ4	 */
#define ENET_WQ40_WIDTH                                                    4
#define ENET_WQ40_SHIFT                                                   16
#define ENET_WQ40_MASK                                            0x000f0000
#define ENET_WQ40_RD(src)                         (((src) & 0x000f0000)>>16)
#define ENET_WQ40_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields WQ3	 */
#define ENET_WQ30_WIDTH                                                    4
#define ENET_WQ30_SHIFT                                                   12
#define ENET_WQ30_MASK                                            0x0000f000
#define ENET_WQ30_RD(src)                         (((src) & 0x0000f000)>>12)
#define ENET_WQ30_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields WQ2	 */
#define ENET_WQ20_WIDTH                                                    4
#define ENET_WQ20_SHIFT                                                    8
#define ENET_WQ20_MASK                                            0x00000f00
#define ENET_WQ20_RD(src)                          (((src) & 0x00000f00)>>8)
#define ENET_WQ20_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields WQ1	 */
#define ENET_WQ10_WIDTH                                                    4
#define ENET_WQ10_SHIFT                                                    4
#define ENET_WQ10_MASK                                            0x000000f0
#define ENET_WQ10_RD(src)                          (((src) & 0x000000f0)>>4)
#define ENET_WQ10_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields WQ0	 */
#define ENET_WQ00_WIDTH                                                    4
#define ENET_WQ00_SHIFT                                                    0
#define ENET_WQ00_MASK                                            0x0000000f
#define ENET_WQ00_RD(src)                             (((src) & 0x0000000f))
#define ENET_WQ00_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiWQPtr1	*/ 
/*	 Fields WQ15	 */
#define ENET_WQ151_WIDTH                                                   4
#define ENET_WQ151_SHIFT                                                  28
#define ENET_WQ151_MASK                                           0xf0000000
#define ENET_WQ151_RD(src)                        (((src) & 0xf0000000)>>28)
#define ENET_WQ151_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields WQ14	 */
#define ENET_WQ141_WIDTH                                                   4
#define ENET_WQ141_SHIFT                                                  24
#define ENET_WQ141_MASK                                           0x0f000000
#define ENET_WQ141_RD(src)                        (((src) & 0x0f000000)>>24)
#define ENET_WQ141_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields WQ13	 */
#define ENET_WQ131_WIDTH                                                   4
#define ENET_WQ131_SHIFT                                                  20
#define ENET_WQ131_MASK                                           0x00f00000
#define ENET_WQ131_RD(src)                        (((src) & 0x00f00000)>>20)
#define ENET_WQ131_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields WQ12	 */
#define ENET_WQ121_WIDTH                                                   4
#define ENET_WQ121_SHIFT                                                  16
#define ENET_WQ121_MASK                                           0x000f0000
#define ENET_WQ121_RD(src)                        (((src) & 0x000f0000)>>16)
#define ENET_WQ121_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields WQ11	 */
#define ENET_WQ111_WIDTH                                                   4
#define ENET_WQ111_SHIFT                                                  12
#define ENET_WQ111_MASK                                           0x0000f000
#define ENET_WQ111_RD(src)                        (((src) & 0x0000f000)>>12)
#define ENET_WQ111_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields WQ10	 */
#define ENET_WQ101_WIDTH                                                   4
#define ENET_WQ101_SHIFT                                                   8
#define ENET_WQ101_MASK                                           0x00000f00
#define ENET_WQ101_RD(src)                         (((src) & 0x00000f00)>>8)
#define ENET_WQ101_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields WQ9	 */
#define ENET_WQ91_WIDTH                                                    4
#define ENET_WQ91_SHIFT                                                    4
#define ENET_WQ91_MASK                                            0x000000f0
#define ENET_WQ91_RD(src)                          (((src) & 0x000000f0)>>4)
#define ENET_WQ91_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields WQ8	 */
#define ENET_WQ81_WIDTH                                                    4
#define ENET_WQ81_SHIFT                                                    0
#define ENET_WQ81_MASK                                            0x0000000f
#define ENET_WQ81_RD(src)                             (((src) & 0x0000000f))
#define ENET_WQ81_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiWQPtr2	*/ 
/*	 Fields WQ23	 */
#define ENET_WQ232_WIDTH                                                   4
#define ENET_WQ232_SHIFT                                                  28
#define ENET_WQ232_MASK                                           0xf0000000
#define ENET_WQ232_RD(src)                        (((src) & 0xf0000000)>>28)
#define ENET_WQ232_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields WQ22	 */
#define ENET_WQ222_WIDTH                                                   4
#define ENET_WQ222_SHIFT                                                  24
#define ENET_WQ222_MASK                                           0x0f000000
#define ENET_WQ222_RD(src)                        (((src) & 0x0f000000)>>24)
#define ENET_WQ222_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields WQ21	 */
#define ENET_WQ212_WIDTH                                                   4
#define ENET_WQ212_SHIFT                                                  20
#define ENET_WQ212_MASK                                           0x00f00000
#define ENET_WQ212_RD(src)                        (((src) & 0x00f00000)>>20)
#define ENET_WQ212_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields WQ20	 */
#define ENET_WQ202_WIDTH                                                   4
#define ENET_WQ202_SHIFT                                                  16
#define ENET_WQ202_MASK                                           0x000f0000
#define ENET_WQ202_RD(src)                        (((src) & 0x000f0000)>>16)
#define ENET_WQ202_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields WQ19	 */
#define ENET_WQ192_WIDTH                                                   4
#define ENET_WQ192_SHIFT                                                  12
#define ENET_WQ192_MASK                                           0x0000f000
#define ENET_WQ192_RD(src)                        (((src) & 0x0000f000)>>12)
#define ENET_WQ192_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields WQ18	 */
#define ENET_WQ182_WIDTH                                                   4
#define ENET_WQ182_SHIFT                                                   8
#define ENET_WQ182_MASK                                           0x00000f00
#define ENET_WQ182_RD(src)                         (((src) & 0x00000f00)>>8)
#define ENET_WQ182_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields WQ17	 */
#define ENET_WQ172_WIDTH                                                   4
#define ENET_WQ172_SHIFT                                                   4
#define ENET_WQ172_MASK                                           0x000000f0
#define ENET_WQ172_RD(src)                         (((src) & 0x000000f0)>>4)
#define ENET_WQ172_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields WQ16	 */
#define ENET_WQ162_WIDTH                                                   4
#define ENET_WQ162_SHIFT                                                   0
#define ENET_WQ162_MASK                                           0x0000000f
#define ENET_WQ162_RD(src)                            (((src) & 0x0000000f))
#define ENET_WQ162_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiWQPtr3	*/ 
/*	 Fields WQ31	 */
#define ENET_WQ313_WIDTH                                                   4
#define ENET_WQ313_SHIFT                                                  28
#define ENET_WQ313_MASK                                           0xf0000000
#define ENET_WQ313_RD(src)                        (((src) & 0xf0000000)>>28)
#define ENET_WQ313_SET(dst,src) \
                      (((dst) & ~0xf0000000) | (((u32)(src)<<28) & 0xf0000000))
/*	 Fields WQ30	 */
#define ENET_WQ303_WIDTH                                                   4
#define ENET_WQ303_SHIFT                                                  24
#define ENET_WQ303_MASK                                           0x0f000000
#define ENET_WQ303_RD(src)                        (((src) & 0x0f000000)>>24)
#define ENET_WQ303_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields WQ29	 */
#define ENET_WQ293_WIDTH                                                   4
#define ENET_WQ293_SHIFT                                                  20
#define ENET_WQ293_MASK                                           0x00f00000
#define ENET_WQ293_RD(src)                        (((src) & 0x00f00000)>>20)
#define ENET_WQ293_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields WQ28	 */
#define ENET_WQ283_WIDTH                                                   4
#define ENET_WQ283_SHIFT                                                  16
#define ENET_WQ283_MASK                                           0x000f0000
#define ENET_WQ283_RD(src)                        (((src) & 0x000f0000)>>16)
#define ENET_WQ283_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields WQ27	 */
#define ENET_WQ273_WIDTH                                                   4
#define ENET_WQ273_SHIFT                                                  12
#define ENET_WQ273_MASK                                           0x0000f000
#define ENET_WQ273_RD(src)                        (((src) & 0x0000f000)>>12)
#define ENET_WQ273_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields WQ26	 */
#define ENET_WQ263_WIDTH                                                   4
#define ENET_WQ263_SHIFT                                                   8
#define ENET_WQ263_MASK                                           0x00000f00
#define ENET_WQ263_RD(src)                         (((src) & 0x00000f00)>>8)
#define ENET_WQ263_SET(dst,src) \
                       (((dst) & ~0x00000f00) | (((u32)(src)<<8) & 0x00000f00))
/*	 Fields WQ25	 */
#define ENET_WQ253_WIDTH                                                   4
#define ENET_WQ253_SHIFT                                                   4
#define ENET_WQ253_MASK                                           0x000000f0
#define ENET_WQ253_RD(src)                         (((src) & 0x000000f0)>>4)
#define ENET_WQ253_SET(dst,src) \
                       (((dst) & ~0x000000f0) | (((u32)(src)<<4) & 0x000000f0))
/*	 Fields WQ24	 */
#define ENET_WQ243_WIDTH                                                   4
#define ENET_WQ243_SHIFT                                                   0
#define ENET_WQ243_MASK                                           0x0000000f
#define ENET_WQ243_RD(src)                            (((src) & 0x0000000f))
#define ENET_WQ243_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register StsSsQmiWQNumEntries0	*/ 
/*	 Fields WQ3	 */
#define ENET_WQ30_F1_WIDTH                                                 5
#define ENET_WQ30_F1_SHIFT                                                24
#define ENET_WQ30_F1_MASK                                         0x1f000000
#define ENET_WQ30_F1_RD(src)                      (((src) & 0x1f000000)>>24)
#define ENET_WQ30_F1_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ2	 */
#define ENET_WQ20_F1_WIDTH                                                 5
#define ENET_WQ20_F1_SHIFT                                                16
#define ENET_WQ20_F1_MASK                                         0x001f0000
#define ENET_WQ20_F1_RD(src)                      (((src) & 0x001f0000)>>16)
#define ENET_WQ20_F1_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ1	 */
#define ENET_WQ10_F1_WIDTH                                                 5
#define ENET_WQ10_F1_SHIFT                                                 8
#define ENET_WQ10_F1_MASK                                         0x00001f00
#define ENET_WQ10_F1_RD(src)                       (((src) & 0x00001f00)>>8)
#define ENET_WQ10_F1_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ0	 */
#define ENET_WQ00_F1_WIDTH                                                 5
#define ENET_WQ00_F1_SHIFT                                                 0
#define ENET_WQ00_F1_MASK                                         0x0000001f
#define ENET_WQ00_F1_RD(src)                          (((src) & 0x0000001f))
#define ENET_WQ00_F1_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries1	*/ 
/*	 Fields WQ7	 */
#define ENET_WQ71_WIDTH                                                    5
#define ENET_WQ71_SHIFT                                                   24
#define ENET_WQ71_MASK                                            0x1f000000
#define ENET_WQ71_RD(src)                         (((src) & 0x1f000000)>>24)
#define ENET_WQ71_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ6	 */
#define ENET_WQ61_WIDTH                                                    5
#define ENET_WQ61_SHIFT                                                   16
#define ENET_WQ61_MASK                                            0x001f0000
#define ENET_WQ61_RD(src)                         (((src) & 0x001f0000)>>16)
#define ENET_WQ61_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ5	 */
#define ENET_WQ51_WIDTH                                                    5
#define ENET_WQ51_SHIFT                                                    8
#define ENET_WQ51_MASK                                            0x00001f00
#define ENET_WQ51_RD(src)                          (((src) & 0x00001f00)>>8)
#define ENET_WQ51_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ4	 */
#define ENET_WQ41_WIDTH                                                    5
#define ENET_WQ41_SHIFT                                                    0
#define ENET_WQ41_MASK                                            0x0000001f
#define ENET_WQ41_RD(src)                             (((src) & 0x0000001f))
#define ENET_WQ41_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries2	*/ 
/*	 Fields WQ11	 */
#define ENET_WQ112_WIDTH                                                   5
#define ENET_WQ112_SHIFT                                                  24
#define ENET_WQ112_MASK                                           0x1f000000
#define ENET_WQ112_RD(src)                        (((src) & 0x1f000000)>>24)
#define ENET_WQ112_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ10	 */
#define ENET_WQ102_WIDTH                                                   5
#define ENET_WQ102_SHIFT                                                  16
#define ENET_WQ102_MASK                                           0x001f0000
#define ENET_WQ102_RD(src)                        (((src) & 0x001f0000)>>16)
#define ENET_WQ102_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ9	 */
#define ENET_WQ92_WIDTH                                                    5
#define ENET_WQ92_SHIFT                                                    8
#define ENET_WQ92_MASK                                            0x00001f00
#define ENET_WQ92_RD(src)                          (((src) & 0x00001f00)>>8)
#define ENET_WQ92_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ8	 */
#define ENET_WQ82_WIDTH                                                    5
#define ENET_WQ82_SHIFT                                                    0
#define ENET_WQ82_MASK                                            0x0000001f
#define ENET_WQ82_RD(src)                             (((src) & 0x0000001f))
#define ENET_WQ82_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries3	*/ 
/*	 Fields WQ15	 */
#define ENET_WQ153_WIDTH                                                   5
#define ENET_WQ153_SHIFT                                                  24
#define ENET_WQ153_MASK                                           0x1f000000
#define ENET_WQ153_RD(src)                        (((src) & 0x1f000000)>>24)
#define ENET_WQ153_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ14	 */
#define ENET_WQ143_WIDTH                                                   5
#define ENET_WQ143_SHIFT                                                  16
#define ENET_WQ143_MASK                                           0x001f0000
#define ENET_WQ143_RD(src)                        (((src) & 0x001f0000)>>16)
#define ENET_WQ143_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ13	 */
#define ENET_WQ133_WIDTH                                                   5
#define ENET_WQ133_SHIFT                                                   8
#define ENET_WQ133_MASK                                           0x00001f00
#define ENET_WQ133_RD(src)                         (((src) & 0x00001f00)>>8)
#define ENET_WQ133_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ12	 */
#define ENET_WQ123_WIDTH                                                   5
#define ENET_WQ123_SHIFT                                                   0
#define ENET_WQ123_MASK                                           0x0000001f
#define ENET_WQ123_RD(src)                            (((src) & 0x0000001f))
#define ENET_WQ123_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries4	*/ 
/*	 Fields WQ19	 */
#define ENET_WQ194_WIDTH                                                   5
#define ENET_WQ194_SHIFT                                                  24
#define ENET_WQ194_MASK                                           0x1f000000
#define ENET_WQ194_RD(src)                        (((src) & 0x1f000000)>>24)
#define ENET_WQ194_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ18	 */
#define ENET_WQ184_WIDTH                                                   5
#define ENET_WQ184_SHIFT                                                  16
#define ENET_WQ184_MASK                                           0x001f0000
#define ENET_WQ184_RD(src)                        (((src) & 0x001f0000)>>16)
#define ENET_WQ184_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ17	 */
#define ENET_WQ174_WIDTH                                                   5
#define ENET_WQ174_SHIFT                                                   8
#define ENET_WQ174_MASK                                           0x00001f00
#define ENET_WQ174_RD(src)                         (((src) & 0x00001f00)>>8)
#define ENET_WQ174_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ16	 */
#define ENET_WQ164_WIDTH                                                   5
#define ENET_WQ164_SHIFT                                                   0
#define ENET_WQ164_MASK                                           0x0000001f
#define ENET_WQ164_RD(src)                            (((src) & 0x0000001f))
#define ENET_WQ164_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries5	*/ 
/*	 Fields WQ23	 */
#define ENET_WQ235_WIDTH                                                   5
#define ENET_WQ235_SHIFT                                                  24
#define ENET_WQ235_MASK                                           0x1f000000
#define ENET_WQ235_RD(src)                        (((src) & 0x1f000000)>>24)
#define ENET_WQ235_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ22	 */
#define ENET_WQ225_WIDTH                                                   5
#define ENET_WQ225_SHIFT                                                  16
#define ENET_WQ225_MASK                                           0x001f0000
#define ENET_WQ225_RD(src)                        (((src) & 0x001f0000)>>16)
#define ENET_WQ225_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ21	 */
#define ENET_WQ215_WIDTH                                                   5
#define ENET_WQ215_SHIFT                                                   8
#define ENET_WQ215_MASK                                           0x00001f00
#define ENET_WQ215_RD(src)                         (((src) & 0x00001f00)>>8)
#define ENET_WQ215_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ20	 */
#define ENET_WQ205_WIDTH                                                   5
#define ENET_WQ205_SHIFT                                                   0
#define ENET_WQ205_MASK                                           0x0000001f
#define ENET_WQ205_RD(src)                            (((src) & 0x0000001f))
#define ENET_WQ205_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries6	*/ 
/*	 Fields WQ27	 */
#define ENET_WQ276_WIDTH                                                   5
#define ENET_WQ276_SHIFT                                                  24
#define ENET_WQ276_MASK                                           0x1f000000
#define ENET_WQ276_RD(src)                        (((src) & 0x1f000000)>>24)
#define ENET_WQ276_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ26	 */
#define ENET_WQ266_WIDTH                                                   5
#define ENET_WQ266_SHIFT                                                  16
#define ENET_WQ266_MASK                                           0x001f0000
#define ENET_WQ266_RD(src)                        (((src) & 0x001f0000)>>16)
#define ENET_WQ266_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ25	 */
#define ENET_WQ256_WIDTH                                                   5
#define ENET_WQ256_SHIFT                                                   8
#define ENET_WQ256_MASK                                           0x00001f00
#define ENET_WQ256_RD(src)                         (((src) & 0x00001f00)>>8)
#define ENET_WQ256_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ24	 */
#define ENET_WQ246_WIDTH                                                   5
#define ENET_WQ246_SHIFT                                                   0
#define ENET_WQ246_MASK                                           0x0000001f
#define ENET_WQ246_RD(src)                            (((src) & 0x0000001f))
#define ENET_WQ246_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register StsSsQmiWQNumEntries7	*/ 
/*	 Fields WQ31	 */
#define ENET_WQ317_WIDTH                                                   5
#define ENET_WQ317_SHIFT                                                  24
#define ENET_WQ317_MASK                                           0x1f000000
#define ENET_WQ317_RD(src)                        (((src) & 0x1f000000)>>24)
#define ENET_WQ317_SET(dst,src) \
                      (((dst) & ~0x1f000000) | (((u32)(src)<<24) & 0x1f000000))
/*	 Fields WQ30	 */
#define ENET_WQ307_WIDTH                                                   5
#define ENET_WQ307_SHIFT                                                  16
#define ENET_WQ307_MASK                                           0x001f0000
#define ENET_WQ307_RD(src)                        (((src) & 0x001f0000)>>16)
#define ENET_WQ307_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields WQ29	 */
#define ENET_WQ297_WIDTH                                                   5
#define ENET_WQ297_SHIFT                                                   8
#define ENET_WQ297_MASK                                           0x00001f00
#define ENET_WQ297_RD(src)                         (((src) & 0x00001f00)>>8)
#define ENET_WQ297_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields WQ28	 */
#define ENET_WQ287_WIDTH                                                   5
#define ENET_WQ287_SHIFT                                                   0
#define ENET_WQ287_MASK                                           0x0000001f
#define ENET_WQ287_RD(src)                            (((src) & 0x0000001f))
#define ENET_WQ287_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register CfgSsQmiSabEnable	*/ 
/*	 Fields EnableMonitoring	 */
#define ENET_ENABLEMONITORING_WIDTH                                       20
#define ENET_ENABLEMONITORING_SHIFT                                        0
#define ENET_ENABLEMONITORING_MASK                                0x000fffff
#define ENET_ENABLEMONITORING_RD(src)                 (((src) & 0x000fffff))
#define ENET_ENABLEMONITORING_WR(src)            (((u32)(src)) & 0x000fffff)
#define ENET_ENABLEMONITORING_SET(dst,src) \
                          (((dst) & ~0x000fffff) | (((u32)(src)) & 0x000fffff))

/*	Register CfgSsQmiSab0	*/ 
/*	 Fields QID1	 */
#define ENET_QID10_WIDTH                                                  12
#define ENET_QID10_SHIFT                                                  16
#define ENET_QID10_MASK                                           0x0fff0000
#define ENET_QID10_RD(src)                        (((src) & 0x0fff0000)>>16)
#define ENET_QID10_WR(src)                   (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID10_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID0	 */
#define ENET_QID00_WIDTH                                                  12
#define ENET_QID00_SHIFT                                                   0
#define ENET_QID00_MASK                                           0x00000fff
#define ENET_QID00_RD(src)                            (((src) & 0x00000fff))
#define ENET_QID00_WR(src)                       (((u32)(src)) & 0x00000fff)
#define ENET_QID00_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab1	*/ 
/*	 Fields QID3	 */
#define ENET_QID31_WIDTH                                                  12
#define ENET_QID31_SHIFT                                                  16
#define ENET_QID31_MASK                                           0x0fff0000
#define ENET_QID31_RD(src)                        (((src) & 0x0fff0000)>>16)
#define ENET_QID31_WR(src)                   (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID31_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID2	 */
#define ENET_QID21_WIDTH                                                  12
#define ENET_QID21_SHIFT                                                   0
#define ENET_QID21_MASK                                           0x00000fff
#define ENET_QID21_RD(src)                            (((src) & 0x00000fff))
#define ENET_QID21_WR(src)                       (((u32)(src)) & 0x00000fff)
#define ENET_QID21_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab2	*/ 
/*	 Fields QID5	 */
#define ENET_QID52_WIDTH                                                  12
#define ENET_QID52_SHIFT                                                  16
#define ENET_QID52_MASK                                           0x0fff0000
#define ENET_QID52_RD(src)                        (((src) & 0x0fff0000)>>16)
#define ENET_QID52_WR(src)                   (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID52_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID4	 */
#define ENET_QID42_WIDTH                                                  12
#define ENET_QID42_SHIFT                                                   0
#define ENET_QID42_MASK                                           0x00000fff
#define ENET_QID42_RD(src)                            (((src) & 0x00000fff))
#define ENET_QID42_WR(src)                       (((u32)(src)) & 0x00000fff)
#define ENET_QID42_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab3	*/ 
/*	 Fields QID7	 */
#define ENET_QID73_WIDTH                                                  12
#define ENET_QID73_SHIFT                                                  16
#define ENET_QID73_MASK                                           0x0fff0000
#define ENET_QID73_RD(src)                        (((src) & 0x0fff0000)>>16)
#define ENET_QID73_WR(src)                   (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID73_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID6	 */
#define ENET_QID63_WIDTH                                                  12
#define ENET_QID63_SHIFT                                                   0
#define ENET_QID63_MASK                                           0x00000fff
#define ENET_QID63_RD(src)                            (((src) & 0x00000fff))
#define ENET_QID63_WR(src)                       (((u32)(src)) & 0x00000fff)
#define ENET_QID63_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab4	*/ 
/*	 Fields QID9	 */
#define ENET_QID94_WIDTH                                                  12
#define ENET_QID94_SHIFT                                                  16
#define ENET_QID94_MASK                                           0x0fff0000
#define ENET_QID94_RD(src)                        (((src) & 0x0fff0000)>>16)
#define ENET_QID94_WR(src)                   (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID94_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID8	 */
#define ENET_QID84_WIDTH                                                  12
#define ENET_QID84_SHIFT                                                   0
#define ENET_QID84_MASK                                           0x00000fff
#define ENET_QID84_RD(src)                            (((src) & 0x00000fff))
#define ENET_QID84_WR(src)                       (((u32)(src)) & 0x00000fff)
#define ENET_QID84_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab5	*/ 
/*	 Fields QID11	 */
#define ENET_QID115_WIDTH                                                 12
#define ENET_QID115_SHIFT                                                 16
#define ENET_QID115_MASK                                          0x0fff0000
#define ENET_QID115_RD(src)                       (((src) & 0x0fff0000)>>16)
#define ENET_QID115_WR(src)                  (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID115_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID10	 */
#define ENET_QID105_WIDTH                                                 12
#define ENET_QID105_SHIFT                                                  0
#define ENET_QID105_MASK                                          0x00000fff
#define ENET_QID105_RD(src)                           (((src) & 0x00000fff))
#define ENET_QID105_WR(src)                      (((u32)(src)) & 0x00000fff)
#define ENET_QID105_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab6	*/ 
/*	 Fields QID13	 */
#define ENET_QID136_WIDTH                                                 12
#define ENET_QID136_SHIFT                                                 16
#define ENET_QID136_MASK                                          0x0fff0000
#define ENET_QID136_RD(src)                       (((src) & 0x0fff0000)>>16)
#define ENET_QID136_WR(src)                  (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID136_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID12	 */
#define ENET_QID126_WIDTH                                                 12
#define ENET_QID126_SHIFT                                                  0
#define ENET_QID126_MASK                                          0x00000fff
#define ENET_QID126_RD(src)                           (((src) & 0x00000fff))
#define ENET_QID126_WR(src)                      (((u32)(src)) & 0x00000fff)
#define ENET_QID126_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab7	*/ 
/*	 Fields QID15	 */
#define ENET_QID157_WIDTH                                                 12
#define ENET_QID157_SHIFT                                                 16
#define ENET_QID157_MASK                                          0x0fff0000
#define ENET_QID157_RD(src)                       (((src) & 0x0fff0000)>>16)
#define ENET_QID157_WR(src)                  (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID157_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID14	 */
#define ENET_QID147_WIDTH                                                 12
#define ENET_QID147_SHIFT                                                  0
#define ENET_QID147_MASK                                          0x00000fff
#define ENET_QID147_RD(src)                           (((src) & 0x00000fff))
#define ENET_QID147_WR(src)                      (((u32)(src)) & 0x00000fff)
#define ENET_QID147_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab8	*/ 
/*	 Fields QID17	 */
#define ENET_QID178_WIDTH                                                 12
#define ENET_QID178_SHIFT                                                 16
#define ENET_QID178_MASK                                          0x0fff0000
#define ENET_QID178_RD(src)                       (((src) & 0x0fff0000)>>16)
#define ENET_QID178_WR(src)                  (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID178_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID16	 */
#define ENET_QID168_WIDTH                                                 12
#define ENET_QID168_SHIFT                                                  0
#define ENET_QID168_MASK                                          0x00000fff
#define ENET_QID168_RD(src)                           (((src) & 0x00000fff))
#define ENET_QID168_WR(src)                      (((u32)(src)) & 0x00000fff)
#define ENET_QID168_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CfgSsQmiSab9	*/ 
/*	 Fields QID19	 */
#define ENET_QID199_WIDTH                                                 12
#define ENET_QID199_SHIFT                                                 16
#define ENET_QID199_MASK                                          0x0fff0000
#define ENET_QID199_RD(src)                       (((src) & 0x0fff0000)>>16)
#define ENET_QID199_WR(src)                  (((u32)(src)<<16) & 0x0fff0000)
#define ENET_QID199_SET(dst,src) \
                      (((dst) & ~0x0fff0000) | (((u32)(src)<<16) & 0x0fff0000))
/*	 Fields QID18	 */
#define ENET_QID189_WIDTH                                                 12
#define ENET_QID189_SHIFT                                                  0
#define ENET_QID189_MASK                                          0x00000fff
#define ENET_QID189_RD(src)                           (((src) & 0x00000fff))
#define ENET_QID189_WR(src)                      (((u32)(src)) & 0x00000fff)
#define ENET_QID189_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register StsSsQmiInt0	*/ 
/*	 Fields FPOverflow	 */
#define ENET_FPOVERFLOW0_WIDTH                                            32
#define ENET_FPOVERFLOW0_SHIFT                                             0
#define ENET_FPOVERFLOW0_MASK                                     0xffffffff
#define ENET_FPOVERFLOW0_RD(src)                      (((src) & 0xffffffff))
#define ENET_FPOVERFLOW0_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_FPOVERFLOW0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt0Mask	*/
/*    Mask Register Fields FPOverflowMask    */
#define ENET_FPOVERFLOWMASK_WIDTH                                         32
#define ENET_FPOVERFLOWMASK_SHIFT                                          0
#define ENET_FPOVERFLOWMASK_MASK                                  0xffffffff
#define ENET_FPOVERFLOWMASK_RD(src)                   (((src) & 0xffffffff))
#define ENET_FPOVERFLOWMASK_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_FPOVERFLOWMASK_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt1	*/ 
/*	 Fields WQOverflow	 */
#define ENET_WQOVERFLOW1_WIDTH                                            32
#define ENET_WQOVERFLOW1_SHIFT                                             0
#define ENET_WQOVERFLOW1_MASK                                     0xffffffff
#define ENET_WQOVERFLOW1_RD(src)                      (((src) & 0xffffffff))
#define ENET_WQOVERFLOW1_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_WQOVERFLOW1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt1Mask	*/
/*    Mask Register Fields WQOverflowMask    */
#define ENET_WQOVERFLOWMASK_WIDTH                                         32
#define ENET_WQOVERFLOWMASK_SHIFT                                          0
#define ENET_WQOVERFLOWMASK_MASK                                  0xffffffff
#define ENET_WQOVERFLOWMASK_RD(src)                   (((src) & 0xffffffff))
#define ENET_WQOVERFLOWMASK_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_WQOVERFLOWMASK_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt2	*/ 
/*	 Fields FPUnderRun	 */
#define ENET_FPUNDERRUN2_WIDTH                                            32
#define ENET_FPUNDERRUN2_SHIFT                                             0
#define ENET_FPUNDERRUN2_MASK                                     0xffffffff
#define ENET_FPUNDERRUN2_RD(src)                      (((src) & 0xffffffff))
#define ENET_FPUNDERRUN2_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_FPUNDERRUN2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt2Mask	*/
/*    Mask Register Fields FPUnderRunMask    */
#define ENET_FPUNDERRUNMASK_WIDTH                                         32
#define ENET_FPUNDERRUNMASK_SHIFT                                          0
#define ENET_FPUNDERRUNMASK_MASK                                  0xffffffff
#define ENET_FPUNDERRUNMASK_RD(src)                   (((src) & 0xffffffff))
#define ENET_FPUNDERRUNMASK_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_FPUNDERRUNMASK_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt3	*/ 
/*	 Fields WQUnderRun	 */
#define ENET_WQUNDERRUN3_WIDTH                                            32
#define ENET_WQUNDERRUN3_SHIFT                                             0
#define ENET_WQUNDERRUN3_MASK                                     0xffffffff
#define ENET_WQUNDERRUN3_RD(src)                      (((src) & 0xffffffff))
#define ENET_WQUNDERRUN3_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_WQUNDERRUN3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt3Mask	*/
/*    Mask Register Fields WQUnderRunMask    */
#define ENET_WQUNDERRUNMASK_WIDTH                                         32
#define ENET_WQUNDERRUNMASK_SHIFT                                          0
#define ENET_WQUNDERRUNMASK_MASK                                  0xffffffff
#define ENET_WQUNDERRUNMASK_RD(src)                   (((src) & 0xffffffff))
#define ENET_WQUNDERRUNMASK_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_WQUNDERRUNMASK_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiInt4	*/ 
/*	 Fields axiwcmr_slverr	 */
#define ENET_AXIWCMR_SLVERR4_WIDTH                                         1
#define ENET_AXIWCMR_SLVERR4_SHIFT                                         1
#define ENET_AXIWCMR_SLVERR4_MASK                                 0x00000002
#define ENET_AXIWCMR_SLVERR4_RD(src)               (((src) & 0x00000002)>>1)
#define ENET_AXIWCMR_SLVERR4_WR(src)          (((u32)(src)<<1) & 0x00000002)
#define ENET_AXIWCMR_SLVERR4_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields axiwcmr_decerr	 */
#define ENET_AXIWCMR_DECERR4_WIDTH                                         1
#define ENET_AXIWCMR_DECERR4_SHIFT                                         0
#define ENET_AXIWCMR_DECERR4_MASK                                 0x00000001
#define ENET_AXIWCMR_DECERR4_RD(src)                  (((src) & 0x00000001))
#define ENET_AXIWCMR_DECERR4_WR(src)             (((u32)(src)) & 0x00000001)
#define ENET_AXIWCMR_DECERR4_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register StsSsQmiInt4Mask	*/
/*    Mask Register Fields axiwcmr_slverrMask    */
#define ENET_AXIWCMR_SLVERRMASK_WIDTH                                      1
#define ENET_AXIWCMR_SLVERRMASK_SHIFT                                      1
#define ENET_AXIWCMR_SLVERRMASK_MASK                              0x00000002
#define ENET_AXIWCMR_SLVERRMASK_RD(src)            (((src) & 0x00000002)>>1)
#define ENET_AXIWCMR_SLVERRMASK_WR(src)       (((u32)(src)<<1) & 0x00000002)
#define ENET_AXIWCMR_SLVERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields axiwcmr_decerrMask    */
#define ENET_AXIWCMR_DECERRMASK_WIDTH                                      1
#define ENET_AXIWCMR_DECERRMASK_SHIFT                                      0
#define ENET_AXIWCMR_DECERRMASK_MASK                              0x00000001
#define ENET_AXIWCMR_DECERRMASK_RD(src)               (((src) & 0x00000001))
#define ENET_AXIWCMR_DECERRMASK_WR(src)          (((u32)(src)) & 0x00000001)
#define ENET_AXIWCMR_DECERRMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CfgSsQmiDbgCtrl	*/ 
/*	 Fields PBID	 */
#define ENET_PBID_WIDTH                                                    6
#define ENET_PBID_SHIFT                                                   12
#define ENET_PBID_MASK                                            0x0003f000
#define ENET_PBID_RD(src)                         (((src) & 0x0003f000)>>12)
#define ENET_PBID_WR(src)                    (((u32)(src)<<12) & 0x0003f000)
#define ENET_PBID_SET(dst,src) \
                      (((dst) & ~0x0003f000) | (((u32)(src)<<12) & 0x0003f000))
/*	 Fields nAck	 */
#define ENET_NACK_WIDTH                                                    1
#define ENET_NACK_SHIFT                                                   11
#define ENET_NACK_MASK                                            0x00000800
#define ENET_NACK_RD(src)                         (((src) & 0x00000800)>>11)
#define ENET_NACK_WR(src)                    (((u32)(src)<<11) & 0x00000800)
#define ENET_NACK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields last	 */
#define ENET_LAST_WIDTH                                                    1
#define ENET_LAST_SHIFT                                                   10
#define ENET_LAST_MASK                                            0x00000400
#define ENET_LAST_RD(src)                         (((src) & 0x00000400)>>10)
#define ENET_LAST_WR(src)                    (((u32)(src)<<10) & 0x00000400)
#define ENET_LAST_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields Push	 */
#define ENET_PUSH_WIDTH                                                    1
#define ENET_PUSH_SHIFT                                                    9
#define ENET_PUSH_MASK                                            0x00000200
#define ENET_PUSH_RD(src)                          (((src) & 0x00000200)>>9)
#define ENET_PUSH_WR(src)                     (((u32)(src)<<9) & 0x00000200)
#define ENET_PUSH_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields Write	 */
#define ENET_WRITE_F2_WIDTH                                                1
#define ENET_WRITE_F2_SHIFT                                                8
#define ENET_WRITE_F2_MASK                                        0x00000100
#define ENET_WRITE_F2_RD(src)                      (((src) & 0x00000100)>>8)
#define ENET_WRITE_F2_WR(src)                 (((u32)(src)<<8) & 0x00000100)
#define ENET_WRITE_F2_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields Pop	 */
#define ENET_POP_WIDTH                                                     1
#define ENET_POP_SHIFT                                                     7
#define ENET_POP_MASK                                             0x00000080
#define ENET_POP_RD(src)                           (((src) & 0x00000080)>>7)
#define ENET_POP_WR(src)                      (((u32)(src)<<7) & 0x00000080)
#define ENET_POP_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields Read	 */
#define ENET_READ_F2_WIDTH                                                 1
#define ENET_READ_F2_SHIFT                                                 6
#define ENET_READ_F2_MASK                                         0x00000040
#define ENET_READ_F2_RD(src)                       (((src) & 0x00000040)>>6)
#define ENET_READ_F2_WR(src)                  (((u32)(src)<<6) & 0x00000040)
#define ENET_READ_F2_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields BufferAddr	 */
#define ENET_BUFFERADDR_WIDTH                                              6
#define ENET_BUFFERADDR_SHIFT                                              0
#define ENET_BUFFERADDR_MASK                                      0x0000003f
#define ENET_BUFFERADDR_RD(src)                       (((src) & 0x0000003f))
#define ENET_BUFFERADDR_WR(src)                  (((u32)(src)) & 0x0000003f)
#define ENET_BUFFERADDR_SET(dst,src) \
                          (((dst) & ~0x0000003f) | (((u32)(src)) & 0x0000003f))

/*	Register CfgSsQmiDbgData0	*/ 
/*	 Fields Data	 */
#define ENET_DATA0_F2_WIDTH                                               32
#define ENET_DATA0_F2_SHIFT                                                0
#define ENET_DATA0_F2_MASK                                        0xffffffff
#define ENET_DATA0_F2_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA0_F2_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA0_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiDbgData1	*/ 
/*	 Fields Data	 */
#define ENET_DATA1_F2_WIDTH                                               32
#define ENET_DATA1_F2_SHIFT                                                0
#define ENET_DATA1_F2_MASK                                        0xffffffff
#define ENET_DATA1_F2_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA1_F2_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA1_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiDbgData2	*/ 
/*	 Fields Data	 */
#define ENET_DATA2_F2_WIDTH                                               32
#define ENET_DATA2_F2_SHIFT                                                0
#define ENET_DATA2_F2_MASK                                        0xffffffff
#define ENET_DATA2_F2_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA2_F2_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA2_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiDbgData3	*/ 
/*	 Fields Data	 */
#define ENET_DATA3_F2_WIDTH                                               32
#define ENET_DATA3_F2_SHIFT                                                0
#define ENET_DATA3_F2_MASK                                        0xffffffff
#define ENET_DATA3_F2_RD(src)                         (((src) & 0xffffffff))
#define ENET_DATA3_F2_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_DATA3_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register StsSsQmiDbgData	*/ 
/*	 Fields Data	 */
#define ENET_DATA_WIDTH                                                   32
#define ENET_DATA_SHIFT                                                    0
#define ENET_DATA_MASK                                            0xffffffff
#define ENET_DATA_RD(src)                             (((src) & 0xffffffff))
#define ENET_DATA_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiFPQAssoc	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION_WIDTH                                            32
#define ENET_ASSOCIATION_SHIFT                                             0
#define ENET_ASSOCIATION_MASK                                     0xffffffff
#define ENET_ASSOCIATION_RD(src)                      (((src) & 0xffffffff))
#define ENET_ASSOCIATION_WR(src)                 (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiWQAssoc	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION_F1_WIDTH                                         32
#define ENET_ASSOCIATION_F1_SHIFT                                          0
#define ENET_ASSOCIATION_F1_MASK                                  0xffffffff
#define ENET_ASSOCIATION_F1_RD(src)                   (((src) & 0xffffffff))
#define ENET_ASSOCIATION_F1_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiMemory	*/ 
/*	 Fields RMA	 */
#define ENET_RMA_WIDTH                                                     2
#define ENET_RMA_SHIFT                                                     4
#define ENET_RMA_MASK                                             0x00000030
#define ENET_RMA_RD(src)                           (((src) & 0x00000030)>>4)
#define ENET_RMA_WR(src)                      (((u32)(src)<<4) & 0x00000030)
#define ENET_RMA_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields RMB	 */
#define ENET_RMB_WIDTH                                                     2
#define ENET_RMB_SHIFT                                                     2
#define ENET_RMB_MASK                                             0x0000000c
#define ENET_RMB_RD(src)                           (((src) & 0x0000000c)>>2)
#define ENET_RMB_WR(src)                      (((u32)(src)<<2) & 0x0000000c)
#define ENET_RMB_SET(dst,src) \
                       (((dst) & ~0x0000000c) | (((u32)(src)<<2) & 0x0000000c))
/*	 Fields RMEA	 */
#define ENET_RMEA_WIDTH                                                    1
#define ENET_RMEA_SHIFT                                                    1
#define ENET_RMEA_MASK                                            0x00000002
#define ENET_RMEA_RD(src)                          (((src) & 0x00000002)>>1)
#define ENET_RMEA_WR(src)                     (((u32)(src)<<1) & 0x00000002)
#define ENET_RMEA_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields RMEB	 */
#define ENET_RMEB_WIDTH                                                    1
#define ENET_RMEB_SHIFT                                                    0
#define ENET_RMEB_MASK                                            0x00000001
#define ENET_RMEB_RD(src)                             (((src) & 0x00000001))
#define ENET_RMEB_WR(src)                        (((u32)(src)) & 0x00000001)
#define ENET_RMEB_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register StsSsQmiFifo	*/ 
/*	 Fields empty	 */
#define ENET_EMPTY_WIDTH                                                  27
#define ENET_EMPTY_SHIFT                                                   0
#define ENET_EMPTY_MASK                                           0x07ffffff
#define ENET_EMPTY_RD(src)                            (((src) & 0x07ffffff))
#define ENET_EMPTY_SET(dst,src) \
                          (((dst) & ~0x07ffffff) | (((u32)(src)) & 0x07ffffff))

/*	Register CfgSsQmiQMLite	*/ 
/*	 Fields Address	 */
#define ENET_ADDRESS_WIDTH                                                20
#define ENET_ADDRESS_SHIFT                                                 0
#define ENET_ADDRESS_MASK                                         0x000fffff
#define ENET_ADDRESS_RD(src)                          (((src) & 0x000fffff))
#define ENET_ADDRESS_WR(src)                     (((u32)(src)) & 0x000fffff)
#define ENET_ADDRESS_SET(dst,src) \
                          (((dst) & ~0x000fffff) | (((u32)(src)) & 0x000fffff))

/*	Register CfgSsQmiQMLiteFPQAssoc	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION_F2_WIDTH                                         32
#define ENET_ASSOCIATION_F2_SHIFT                                          0
#define ENET_ASSOCIATION_F2_MASK                                  0xffffffff
#define ENET_ASSOCIATION_F2_RD(src)                   (((src) & 0xffffffff))
#define ENET_ASSOCIATION_F2_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiQMLiteWQAssoc	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION_F3_WIDTH                                         32
#define ENET_ASSOCIATION_F3_SHIFT                                          0
#define ENET_ASSOCIATION_F3_MASK                                  0xffffffff
#define ENET_ASSOCIATION_F3_RD(src)                   (((src) & 0xffffffff))
#define ENET_ASSOCIATION_F3_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION_F3_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiQMHold	*/ 
/*	 Fields QMLite_hold_en	 */
#define ENET_QMLITE_HOLD_EN_WIDTH                                          1
#define ENET_QMLITE_HOLD_EN_SHIFT                                         31
#define ENET_QMLITE_HOLD_EN_MASK                                  0x80000000
#define ENET_QMLITE_HOLD_EN_RD(src)               (((src) & 0x80000000)>>31)
#define ENET_QMLITE_HOLD_EN_WR(src)          (((u32)(src)<<31) & 0x80000000)
#define ENET_QMLITE_HOLD_EN_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields QM2_hold_en	 */
#define ENET_QM2_HOLD_EN_WIDTH                                             1
#define ENET_QM2_HOLD_EN_SHIFT                                             2
#define ENET_QM2_HOLD_EN_MASK                                     0x00000004
#define ENET_QM2_HOLD_EN_RD(src)                   (((src) & 0x00000004)>>2)
#define ENET_QM2_HOLD_EN_WR(src)              (((u32)(src)<<2) & 0x00000004)
#define ENET_QM2_HOLD_EN_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields QM1_hold_en	 */
#define ENET_QM1_HOLD_EN_WIDTH                                             1
#define ENET_QM1_HOLD_EN_SHIFT                                             1
#define ENET_QM1_HOLD_EN_MASK                                     0x00000002
#define ENET_QM1_HOLD_EN_RD(src)                   (((src) & 0x00000002)>>1)
#define ENET_QM1_HOLD_EN_WR(src)              (((u32)(src)<<1) & 0x00000002)
#define ENET_QM1_HOLD_EN_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields QM0_hold_en	 */
#define ENET_QM0_HOLD_EN_WIDTH                                             1
#define ENET_QM0_HOLD_EN_SHIFT                                             0
#define ENET_QM0_HOLD_EN_MASK                                     0x00000001
#define ENET_QM0_HOLD_EN_RD(src)                      (((src) & 0x00000001))
#define ENET_QM0_HOLD_EN_WR(src)                 (((u32)(src)) & 0x00000001)
#define ENET_QM0_HOLD_EN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register StsSsQmiQMHold	*/ 
/*	 Fields QMLite_hold	 */
#define ENET_QMLITE_HOLD_WIDTH                                             1
#define ENET_QMLITE_HOLD_SHIFT                                            31
#define ENET_QMLITE_HOLD_MASK                                     0x80000000
#define ENET_QMLITE_HOLD_RD(src)                  (((src) & 0x80000000)>>31)
#define ENET_QMLITE_HOLD_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields QM2_hold	 */
#define ENET_QM2_HOLD_WIDTH                                                1
#define ENET_QM2_HOLD_SHIFT                                                2
#define ENET_QM2_HOLD_MASK                                        0x00000004
#define ENET_QM2_HOLD_RD(src)                      (((src) & 0x00000004)>>2)
#define ENET_QM2_HOLD_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields QM1_hold	 */
#define ENET_QM1_HOLD_WIDTH                                                1
#define ENET_QM1_HOLD_SHIFT                                                1
#define ENET_QM1_HOLD_MASK                                        0x00000002
#define ENET_QM1_HOLD_RD(src)                      (((src) & 0x00000002)>>1)
#define ENET_QM1_HOLD_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields QM0_hold	 */
#define ENET_QM0_HOLD_WIDTH                                                1
#define ENET_QM0_HOLD_SHIFT                                                0
#define ENET_QM0_HOLD_MASK                                        0x00000001
#define ENET_QM0_HOLD_RD(src)                         (((src) & 0x00000001))
#define ENET_QM0_HOLD_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CfgSsQmiFPQVCAssoc0	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION0_WIDTH                                           32
#define ENET_ASSOCIATION0_SHIFT                                            0
#define ENET_ASSOCIATION0_MASK                                    0xffffffff
#define ENET_ASSOCIATION0_RD(src)                     (((src) & 0xffffffff))
#define ENET_ASSOCIATION0_WR(src)                (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiFPQVCAssoc1	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION1_WIDTH                                           32
#define ENET_ASSOCIATION1_SHIFT                                            0
#define ENET_ASSOCIATION1_MASK                                    0xffffffff
#define ENET_ASSOCIATION1_RD(src)                     (((src) & 0xffffffff))
#define ENET_ASSOCIATION1_WR(src)                (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiWQVCAssoc0	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION0_F1_WIDTH                                        32
#define ENET_ASSOCIATION0_F1_SHIFT                                         0
#define ENET_ASSOCIATION0_F1_MASK                                 0xffffffff
#define ENET_ASSOCIATION0_F1_RD(src)                  (((src) & 0xffffffff))
#define ENET_ASSOCIATION0_F1_WR(src)             (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION0_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiWQVCAssoc1	*/ 
/*	 Fields Association	 */
#define ENET_ASSOCIATION1_F1_WIDTH                                        32
#define ENET_ASSOCIATION1_F1_SHIFT                                         0
#define ENET_ASSOCIATION1_F1_MASK                                 0xffffffff
#define ENET_ASSOCIATION1_F1_RD(src)                  (((src) & 0xffffffff))
#define ENET_ASSOCIATION1_F1_WR(src)             (((u32)(src)) & 0xffffffff)
#define ENET_ASSOCIATION1_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CfgSsQmiQM2	*/ 
/*	 Fields Address	 */
#define ENET_ADDRESS2_WIDTH                                               20
#define ENET_ADDRESS2_SHIFT                                                0
#define ENET_ADDRESS2_MASK                                        0x000fffff
#define ENET_ADDRESS2_RD(src)                         (((src) & 0x000fffff))
#define ENET_ADDRESS2_WR(src)                    (((u32)(src)) & 0x000fffff)
#define ENET_ADDRESS2_SET(dst,src) \
                          (((dst) & ~0x000fffff) | (((u32)(src)) & 0x000fffff))

/*	Global Base Address	*/
#define SATA_ENET_SDS_CSR_REG_BASE_ADDR			0x01f21a000ULL

/*    Address SATA_ENET_SDS_CSR_REG  Registers */
#define SATA_ENET_SDS_PCS_CTL0_ADDR                                  0x00000000
#define SATA_ENET_SDS_PCS_CTL0_DEFAULT                               0x00000000
#define SATA_ENET_SDS_PCS_CTL1_ADDR                                  0x00000004
#define SATA_ENET_SDS_PCS_CTL1_DEFAULT                               0x00000000
#define SATA_ENET_SDS_PCS_CTL2_ADDR                                  0x00000008
#define SATA_ENET_SDS_PCS_CTL2_DEFAULT                               0x00000000
#define SATA_ENET_SDS_CTL0_ADDR                                      0x0000000c
#define SATA_ENET_SDS_CTL0_DEFAULT                                   0x00041d25
#define SATA_ENET_SDS_CTL1_ADDR                                      0x00000010
#define SATA_ENET_SDS_CTL1_DEFAULT                                   0x00000000
#define SATA_ENET_SDS_CMU_STATUS0_ADDR                               0x00000014
#define SATA_ENET_SDS_CMU_STATUS0_DEFAULT                            0x00000000
#define SATA_ENET_SDS0_RXTX_STATUS_ADDR                              0x00000018
#define SATA_ENET_SDS0_RXTX_STATUS_DEFAULT                           0x00000004
#define SATA_ENET_SDS1_RXTX_STATUS_ADDR                              0x00000020
#define SATA_ENET_SDS1_RXTX_STATUS_DEFAULT                           0x00000004
#define SATA_ENET_SDS_RST_CTL_ADDR                                   0x00000024
#define SATA_ENET_SDS_RST_CTL_DEFAULT                                0x00000000
#define SATA_ENET_SDS_CMU_CTL0_ADDR                                  0x00000028
#define SATA_ENET_SDS_CMU_CTL0_DEFAULT                               0x00000000
#define SATA_ENET_SDS_CMU_CTL1_ADDR                                  0x0000002c
#define SATA_ENET_SDS_CMU_CTL1_DEFAULT                               0x00000000
#define SATA_ENET_SDS_RX_CTL_ADDR                                    0x00000030
#define SATA_ENET_SDS_RX_CTL_DEFAULT                                 0x00000000
#define SATA_ENET_SDS_TX_CTL_ADDR                                    0x00000034
#define SATA_ENET_SDS_TX_CTL_DEFAULT                                 0x00000000
#define SATA_ENET_SDS_DEBUG_REG_ADDR                                 0x00000038
#define SATA_ENET_SDS_DEBUG_REG_DEFAULT                              0x00000000
#define SATA_ENET_SDS_IND_CMD_REG_ADDR                               0x0000003c
#define SATA_ENET_SDS_IND_CMD_REG_DEFAULT                            0x00000000
#define SATA_ENET_SDS_IND_RDATA_REG_ADDR                             0x00000040
#define SATA_ENET_SDS_IND_RDATA_REG_DEFAULT                          0x00000000
#define SATA_ENET_SDS_IND_WDATA_REG_ADDR                             0x00000044
#define SATA_ENET_SDS_IND_WDATA_REG_DEFAULT                          0x00000000
#define SATA_ENET_CLK_MACRO_REG_ADDR                                 0x0000004c
#define SATA_ENET_CLK_MACRO_REG_DEFAULT                              0x00028480

/*	Register SATA_ENET_SDS_PCS_CTL0	*/ 
/*	 Fields cfg_i_rx_txcoeff_cp_req	 */
#define CFG_I_RX_TXCOEFF_CP_REQ0_WIDTH                                        1
#define CFG_I_RX_TXCOEFF_CP_REQ0_SHIFT                                       29
#define CFG_I_RX_TXCOEFF_CP_REQ0_MASK                                0x20000000
#define CFG_I_RX_TXCOEFF_CP_REQ0_RD(src)             (((src) & 0x20000000)>>29)
#define CFG_I_RX_TXCOEFF_CP_REQ0_WR(src)        (((u32)(src)<<29) & 0x20000000)
#define CFG_I_RX_TXCOEFF_CP_REQ0_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields cfg_i_rx_txcoeff_cn_req	 */
#define CFG_I_RX_TXCOEFF_CN_REQ0_WIDTH                                        1
#define CFG_I_RX_TXCOEFF_CN_REQ0_SHIFT                                       28
#define CFG_I_RX_TXCOEFF_CN_REQ0_MASK                                0x10000000
#define CFG_I_RX_TXCOEFF_CN_REQ0_RD(src)             (((src) & 0x10000000)>>28)
#define CFG_I_RX_TXCOEFF_CN_REQ0_WR(src)        (((u32)(src)<<28) & 0x10000000)
#define CFG_I_RX_TXCOEFF_CN_REQ0_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields cfg_i_rx_sd_threshold	 */
#define CFG_I_RX_SD_THRESHOLD0_WIDTH                                          4
#define CFG_I_RX_SD_THRESHOLD0_SHIFT                                         24
#define CFG_I_RX_SD_THRESHOLD0_MASK                                  0x0f000000
#define CFG_I_RX_SD_THRESHOLD0_RD(src)               (((src) & 0x0f000000)>>24)
#define CFG_I_RX_SD_THRESHOLD0_WR(src)          (((u32)(src)<<24) & 0x0f000000)
#define CFG_I_RX_SD_THRESHOLD0_SET(dst,src) \
                      (((dst) & ~0x0f000000) | (((u32)(src)<<24) & 0x0f000000))
/*	 Fields cfg_i_rx_wordmode	 */
#define ENET_CFG_I_RX_WORDMODE0_WIDTH                                      3
#define ENET_CFG_I_RX_WORDMODE0_SHIFT                                     21
#define ENET_CFG_I_RX_WORDMODE0_MASK                              0x00e00000
#define ENET_CFG_I_RX_WORDMODE0_RD(src)           (((src) & 0x00e00000)>>21)
#define ENET_CFG_I_RX_WORDMODE0_WR(src)      (((u32)(src)<<21) & 0x00e00000)
#define ENET_CFG_I_RX_WORDMODE0_SET(dst,src) \
                      (((dst) & ~0x00e00000) | (((u32)(src)<<21) & 0x00e00000))
/*	 Fields cfg_i_rx_data_rate	 */
#define CFG_I_RX_DATA_RATE0_WIDTH                                             2
#define CFG_I_RX_DATA_RATE0_SHIFT                                            19
#define CFG_I_RX_DATA_RATE0_MASK                                     0x00180000
#define CFG_I_RX_DATA_RATE0_RD(src)                  (((src) & 0x00180000)>>19)
#define CFG_I_RX_DATA_RATE0_WR(src)             (((u32)(src)<<19) & 0x00180000)
#define CFG_I_RX_DATA_RATE0_SET(dst,src) \
                      (((dst) & ~0x00180000) | (((u32)(src)<<19) & 0x00180000))
/*	 Fields cfg_i_tx_wordmode	 */
#define ENET_CFG_I_TX_WORDMODE0_WIDTH                                      3
#define ENET_CFG_I_TX_WORDMODE0_SHIFT                                     16
#define ENET_CFG_I_TX_WORDMODE0_MASK                              0x00070000
#define ENET_CFG_I_TX_WORDMODE0_RD(src)           (((src) & 0x00070000)>>16)
#define ENET_CFG_I_TX_WORDMODE0_WR(src)      (((u32)(src)<<16) & 0x00070000)
#define ENET_CFG_I_TX_WORDMODE0_SET(dst,src) \
                      (((dst) & ~0x00070000) | (((u32)(src)<<16) & 0x00070000))
/*	 Fields cfg_i_tx_data_rate	 */
#define CFG_I_TX_DATA_RATE0_WIDTH                                             2
#define CFG_I_TX_DATA_RATE0_SHIFT                                            14
#define CFG_I_TX_DATA_RATE0_MASK                                     0x0000c000
#define CFG_I_TX_DATA_RATE0_RD(src)                  (((src) & 0x0000c000)>>14)
#define CFG_I_TX_DATA_RATE0_WR(src)             (((u32)(src)<<14) & 0x0000c000)
#define CFG_I_TX_DATA_RATE0_SET(dst,src) \
                      (((dst) & ~0x0000c000) | (((u32)(src)<<14) & 0x0000c000))
/*	 Fields cfg_i_tx_fifoen	 */
#define CFG_I_TX_FIFOEN0_WIDTH                                                1
#define CFG_I_TX_FIFOEN0_SHIFT                                               13
#define CFG_I_TX_FIFOEN0_MASK                                        0x00002000
#define CFG_I_TX_FIFOEN0_RD(src)                     (((src) & 0x00002000)>>13)
#define CFG_I_TX_FIFOEN0_WR(src)                (((u32)(src)<<13) & 0x00002000)
#define CFG_I_TX_FIFOEN0_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))

/*	Register SATA_ENET_SDS_PCS_CTL1	*/ 
/*	 Fields cfg_i_tx_idle	 */
#define CFG_I_TX_IDLE1_WIDTH                                                  1
#define CFG_I_TX_IDLE1_SHIFT                                                 28
#define CFG_I_TX_IDLE1_MASK                                          0x10000000
#define CFG_I_TX_IDLE1_RD(src)                       (((src) & 0x10000000)>>28)
#define CFG_I_TX_IDLE1_WR(src)                  (((u32)(src)<<28) & 0x10000000)
#define CFG_I_TX_IDLE1_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields cfg_i_tx_rxdet_clr	 */
#define CFG_I_TX_RXDET_CLR1_WIDTH                                             1
#define CFG_I_TX_RXDET_CLR1_SHIFT                                            27
#define CFG_I_TX_RXDET_CLR1_MASK                                     0x08000000
#define CFG_I_TX_RXDET_CLR1_RD(src)                  (((src) & 0x08000000)>>27)
#define CFG_I_TX_RXDET_CLR1_WR(src)             (((u32)(src)<<27) & 0x08000000)
#define CFG_I_TX_RXDET_CLR1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields cfg_i_tx_rxdet_en	 */
#define CFG_I_TX_RXDET_EN1_WIDTH                                              1
#define CFG_I_TX_RXDET_EN1_SHIFT                                             26
#define CFG_I_TX_RXDET_EN1_MASK                                      0x04000000
#define CFG_I_TX_RXDET_EN1_RD(src)                   (((src) & 0x04000000)>>26)
#define CFG_I_TX_RXDET_EN1_WR(src)              (((u32)(src)<<26) & 0x04000000)
#define CFG_I_TX_RXDET_EN1_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields cfg_i_tx_amp_en	 */
#define CFG_I_TX_AMP_EN1_WIDTH                                                1
#define CFG_I_TX_AMP_EN1_SHIFT                                               25
#define CFG_I_TX_AMP_EN1_MASK                                        0x02000000
#define CFG_I_TX_AMP_EN1_RD(src)                     (((src) & 0x02000000)>>25)
#define CFG_I_TX_AMP_EN1_WR(src)                (((u32)(src)<<25) & 0x02000000)
#define CFG_I_TX_AMP_EN1_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields cfg_i_tx_amp	 */
#define CFG_I_TX_AMP1_WIDTH                                                   4
#define CFG_I_TX_AMP1_SHIFT                                                  21
#define CFG_I_TX_AMP1_MASK                                           0x01e00000
#define CFG_I_TX_AMP1_RD(src)                        (((src) & 0x01e00000)>>21)
#define CFG_I_TX_AMP1_WR(src)                   (((u32)(src)<<21) & 0x01e00000)
#define CFG_I_TX_AMP1_SET(dst,src) \
                      (((dst) & ~0x01e00000) | (((u32)(src)<<21) & 0x01e00000))
/*	 Fields cfg_i_tx_cn2	 */
#define CFG_I_TX_CN21_WIDTH                                                   5
#define CFG_I_TX_CN21_SHIFT                                                  16
#define CFG_I_TX_CN21_MASK                                           0x001f0000
#define CFG_I_TX_CN21_RD(src)                        (((src) & 0x001f0000)>>16)
#define CFG_I_TX_CN21_WR(src)                   (((u32)(src)<<16) & 0x001f0000)
#define CFG_I_TX_CN21_SET(dst,src) \
                      (((dst) & ~0x001f0000) | (((u32)(src)<<16) & 0x001f0000))
/*	 Fields cfg_i_tx_cn1	 */
#define CFG_I_TX_CN11_WIDTH                                                   5
#define CFG_I_TX_CN11_SHIFT                                                  11
#define CFG_I_TX_CN11_MASK                                           0x0000f800
#define CFG_I_TX_CN11_RD(src)                        (((src) & 0x0000f800)>>11)
#define CFG_I_TX_CN11_WR(src)                   (((u32)(src)<<11) & 0x0000f800)
#define CFG_I_TX_CN11_SET(dst,src) \
                      (((dst) & ~0x0000f800) | (((u32)(src)<<11) & 0x0000f800))
/*	 Fields cfg_i_tx_c0	 */
#define CFG_I_TX_C01_WIDTH                                                    5
#define CFG_I_TX_C01_SHIFT                                                    6
#define CFG_I_TX_C01_MASK                                            0x000007c0
#define CFG_I_TX_C01_RD(src)                          (((src) & 0x000007c0)>>6)
#define CFG_I_TX_C01_WR(src)                     (((u32)(src)<<6) & 0x000007c0)
#define CFG_I_TX_C01_SET(dst,src) \
                       (((dst) & ~0x000007c0) | (((u32)(src)<<6) & 0x000007c0))
/*	 Fields cfg_i_tx_cp	 */
#define CFG_I_TX_CP1_WIDTH                                                    6
#define CFG_I_TX_CP1_SHIFT                                                    0
#define CFG_I_TX_CP1_MASK                                            0x0000003f
#define CFG_I_TX_CP1_RD(src)                             (((src) & 0x0000003f))
#define CFG_I_TX_CP1_WR(src)                        (((u32)(src)) & 0x0000003f)
#define CFG_I_TX_CP1_SET(dst,src) \
                          (((dst) & ~0x0000003f) | (((u32)(src)) & 0x0000003f))

/*	Register SATA_ENET_SDS_PCS_CTL2	*/ 
/*	 Fields cfg_i_fb2_div	 */
#define CFG_I_FB2_DIV2_WIDTH                                                  6
#define CFG_I_FB2_DIV2_SHIFT                                                  8
#define CFG_I_FB2_DIV2_MASK                                          0x00003f00
#define CFG_I_FB2_DIV2_RD(src)                        (((src) & 0x00003f00)>>8)
#define CFG_I_FB2_DIV2_WR(src)                   (((u32)(src)<<8) & 0x00003f00)
#define CFG_I_FB2_DIV2_SET(dst,src) \
                       (((dst) & ~0x00003f00) | (((u32)(src)<<8) & 0x00003f00))
/*	 Fields cfg_i_fb1_div	 */
#define CFG_I_FB1_DIV2_WIDTH                                                  3
#define CFG_I_FB1_DIV2_SHIFT                                                  5
#define CFG_I_FB1_DIV2_MASK                                          0x000000e0
#define CFG_I_FB1_DIV2_RD(src)                        (((src) & 0x000000e0)>>5)
#define CFG_I_FB1_DIV2_WR(src)                   (((u32)(src)<<5) & 0x000000e0)
#define CFG_I_FB1_DIV2_SET(dst,src) \
                       (((dst) & ~0x000000e0) | (((u32)(src)<<5) & 0x000000e0))
/*	 Fields cfg_i_refclksel	 */
#define CFG_I_REFCLKSEL2_WIDTH                                                1
#define CFG_I_REFCLKSEL2_SHIFT                                                4
#define CFG_I_REFCLKSEL2_MASK                                        0x00000010
#define CFG_I_REFCLKSEL2_RD(src)                      (((src) & 0x00000010)>>4)
#define CFG_I_REFCLKSEL2_WR(src)                 (((u32)(src)<<4) & 0x00000010)
#define CFG_I_REFCLKSEL2_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields cfg_i_refclk_div	 */
#define CFG_I_REFCLK_DIV2_WIDTH                                               2
#define CFG_I_REFCLK_DIV2_SHIFT                                               2
#define CFG_I_REFCLK_DIV2_MASK                                       0x0000000c
#define CFG_I_REFCLK_DIV2_RD(src)                     (((src) & 0x0000000c)>>2)
#define CFG_I_REFCLK_DIV2_WR(src)                (((u32)(src)<<2) & 0x0000000c)
#define CFG_I_REFCLK_DIV2_SET(dst,src) \
                       (((dst) & ~0x0000000c) | (((u32)(src)<<2) & 0x0000000c))
/*	 Fields cfg_i_do_rxratechange	 */
#define CFG_I_DO_RXRATECHANGE2_WIDTH                                          1
#define CFG_I_DO_RXRATECHANGE2_SHIFT                                          1
#define CFG_I_DO_RXRATECHANGE2_MASK                                  0x00000002
#define CFG_I_DO_RXRATECHANGE2_RD(src)                (((src) & 0x00000002)>>1)
#define CFG_I_DO_RXRATECHANGE2_WR(src)           (((u32)(src)<<1) & 0x00000002)
#define CFG_I_DO_RXRATECHANGE2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_i_do_txratechange	 */
#define CFG_I_DO_TXRATECHANGE2_WIDTH                                          1
#define CFG_I_DO_TXRATECHANGE2_SHIFT                                          0
#define CFG_I_DO_TXRATECHANGE2_MASK                                  0x00000001
#define CFG_I_DO_TXRATECHANGE2_RD(src)                   (((src) & 0x00000001))
#define CFG_I_DO_TXRATECHANGE2_WR(src)              (((u32)(src)) & 0x00000001)
#define CFG_I_DO_TXRATECHANGE2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS_CTL0	*/ 
/*	 Fields cfg_i_tx_spare	 */
#define CFG_I_TX_SPARE0_WIDTH                                                 3
#define CFG_I_TX_SPARE0_SHIFT                                                26
#define CFG_I_TX_SPARE0_MASK                                         0x1c000000
#define CFG_I_TX_SPARE0_RD(src)                      (((src) & 0x1c000000)>>26)
#define CFG_I_TX_SPARE0_WR(src)                 (((u32)(src)<<26) & 0x1c000000)
#define CFG_I_TX_SPARE0_SET(dst,src) \
                      (((dst) & ~0x1c000000) | (((u32)(src)<<26) & 0x1c000000))
/*	 Fields cfg_i_tx_rxlpbk_en	 */
#define CFG_I_TX_RXLPBK_EN0_WIDTH                                             1
#define CFG_I_TX_RXLPBK_EN0_SHIFT                                            25
#define CFG_I_TX_RXLPBK_EN0_MASK                                     0x02000000
#define CFG_I_TX_RXLPBK_EN0_RD(src)                  (((src) & 0x02000000)>>25)
#define CFG_I_TX_RXLPBK_EN0_WR(src)             (((u32)(src)<<25) & 0x02000000)
#define CFG_I_TX_RXLPBK_EN0_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields cfg_i_tx_ser_lpbk	 */
#define CFG_I_TX_SER_LPBK0_WIDTH                                              1
#define CFG_I_TX_SER_LPBK0_SHIFT                                             24
#define CFG_I_TX_SER_LPBK0_MASK                                      0x01000000
#define CFG_I_TX_SER_LPBK0_RD(src)                   (((src) & 0x01000000)>>24)
#define CFG_I_TX_SER_LPBK0_WR(src)              (((u32)(src)<<24) & 0x01000000)
#define CFG_I_TX_SER_LPBK0_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_i_rx_spare	 */
#define CFG_I_RX_SPARE0_WIDTH                                                 4
#define CFG_I_RX_SPARE0_SHIFT                                                20
#define CFG_I_RX_SPARE0_MASK                                         0x00f00000
#define CFG_I_RX_SPARE0_RD(src)                      (((src) & 0x00f00000)>>20)
#define CFG_I_RX_SPARE0_WR(src)                 (((u32)(src)<<20) & 0x00f00000)
#define CFG_I_RX_SPARE0_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_i_rx_ctle_lpbck	 */
#define CFG_I_RX_CTLE_LPBCK0_WIDTH                                            1
#define CFG_I_RX_CTLE_LPBCK0_SHIFT                                           19
#define CFG_I_RX_CTLE_LPBCK0_MASK                                    0x00080000
#define CFG_I_RX_CTLE_LPBCK0_RD(src)                 (((src) & 0x00080000)>>19)
#define CFG_I_RX_CTLE_LPBCK0_WR(src)            (((u32)(src)<<19) & 0x00080000)
#define CFG_I_RX_CTLE_LPBCK0_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields cfg_i_usr_pd_pll	 */
#define CFG_I_USR_PD_PLL0_WIDTH                                               1
#define CFG_I_USR_PD_PLL0_SHIFT                                              18
#define CFG_I_USR_PD_PLL0_MASK                                       0x00040000
#define CFG_I_USR_PD_PLL0_RD(src)                    (((src) & 0x00040000)>>18)
#define CFG_I_USR_PD_PLL0_WR(src)               (((u32)(src)<<18) & 0x00040000)
#define CFG_I_USR_PD_PLL0_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields cfg_i_refclk_cmos_sel	 */
#define CFG_I_REFCLK_CMOS_SEL0_WIDTH                                          1
#define CFG_I_REFCLK_CMOS_SEL0_SHIFT                                         17
#define CFG_I_REFCLK_CMOS_SEL0_MASK                                  0x00020000
#define CFG_I_REFCLK_CMOS_SEL0_RD(src)               (((src) & 0x00020000)>>17)
#define CFG_I_REFCLK_CMOS_SEL0_WR(src)          (((u32)(src)<<17) & 0x00020000)
#define CFG_I_REFCLK_CMOS_SEL0_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_i_usr_clk_buf_ena	 */
#define CFG_I_USR_CLK_BUF_ENA0_WIDTH                                          1
#define CFG_I_USR_CLK_BUF_ENA0_SHIFT                                         16
#define CFG_I_USR_CLK_BUF_ENA0_MASK                                  0x00010000
#define CFG_I_USR_CLK_BUF_ENA0_RD(src)               (((src) & 0x00010000)>>16)
#define CFG_I_USR_CLK_BUF_ENA0_WR(src)          (((u32)(src)<<16) & 0x00010000)
#define CFG_I_USR_CLK_BUF_ENA0_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_i_force_vcocal_start	 */
#define CFG_I_FORCE_VCOCAL_START0_WIDTH                                       1
#define CFG_I_FORCE_VCOCAL_START0_SHIFT                                      15
#define CFG_I_FORCE_VCOCAL_START0_MASK                               0x00008000
#define CFG_I_FORCE_VCOCAL_START0_RD(src)            (((src) & 0x00008000)>>15)
#define CFG_I_FORCE_VCOCAL_START0_WR(src)       (((u32)(src)<<15) & 0x00008000)
#define CFG_I_FORCE_VCOCAL_START0_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields cfg_i_customer_pin_mode	 */
#define ENET_CFG_I_CUSTOMER_PIN_MODE0_WIDTH                               15
#define ENET_CFG_I_CUSTOMER_PIN_MODE0_SHIFT                                0
#define ENET_CFG_I_CUSTOMER_PIN_MODE0_MASK                        0x00007fff
#define ENET_CFG_I_CUSTOMER_PIN_MODE0_RD(src)         (((src) & 0x00007fff))
#define ENET_CFG_I_CUSTOMER_PIN_MODE0_WR(src)    (((u32)(src)) & 0x00007fff)
#define ENET_CFG_I_CUSTOMER_PIN_MODE0_SET(dst,src) \
                          (((dst) & ~0x00007fff) | (((u32)(src)) & 0x00007fff))

/*	Register SATA_ENET_SDS_CTL1	*/ 
/*	 Fields cfg_i_pwr_bypass	 */
#define CFG_I_PWR_BYPASS1_WIDTH                                               1
#define CFG_I_PWR_BYPASS1_SHIFT                                              24
#define CFG_I_PWR_BYPASS1_MASK                                       0x01000000
#define CFG_I_PWR_BYPASS1_RD(src)                    (((src) & 0x01000000)>>24)
#define CFG_I_PWR_BYPASS1_WR(src)               (((u32)(src)<<24) & 0x01000000)
#define CFG_I_PWR_BYPASS1_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_i_DFE_tap_ena_ovr	 */
#define CFG_I_DFE_TAP_ENA_OVR1_WIDTH                                         16
#define CFG_I_DFE_TAP_ENA_OVR1_SHIFT                                          8
#define CFG_I_DFE_TAP_ENA_OVR1_MASK                                  0x00ffff00
#define CFG_I_DFE_TAP_ENA_OVR1_RD(src)                (((src) & 0x00ffff00)>>8)
#define CFG_I_DFE_TAP_ENA_OVR1_WR(src)           (((u32)(src)<<8) & 0x00ffff00)
#define CFG_I_DFE_TAP_ENA_OVR1_SET(dst,src) \
                       (((dst) & ~0x00ffff00) | (((u32)(src)<<8) & 0x00ffff00))
/*	 Fields cfg_i_ctle_ena	 */
#define CFG_I_CTLE_ENA1_WIDTH                                                 1
#define CFG_I_CTLE_ENA1_SHIFT                                                 7
#define CFG_I_CTLE_ENA1_MASK                                         0x00000080
#define CFG_I_CTLE_ENA1_RD(src)                       (((src) & 0x00000080)>>7)
#define CFG_I_CTLE_ENA1_WR(src)                  (((u32)(src)<<7) & 0x00000080)
#define CFG_I_CTLE_ENA1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields cfg_i_blwc_ena	 */
#define CFG_I_BLWC_ENA1_WIDTH                                                 1
#define CFG_I_BLWC_ENA1_SHIFT                                                 6
#define CFG_I_BLWC_ENA1_MASK                                         0x00000040
#define CFG_I_BLWC_ENA1_RD(src)                       (((src) & 0x00000040)>>6)
#define CFG_I_BLWC_ENA1_WR(src)                  (((u32)(src)<<6) & 0x00000040)
#define CFG_I_BLWC_ENA1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_i_BC_tap_ena_ovr	 */
#define CFG_I_BC_TAP_ENA_OVR1_WIDTH                                           2
#define CFG_I_BC_TAP_ENA_OVR1_SHIFT                                           4
#define CFG_I_BC_TAP_ENA_OVR1_MASK                                   0x00000030
#define CFG_I_BC_TAP_ENA_OVR1_RD(src)                 (((src) & 0x00000030)>>4)
#define CFG_I_BC_TAP_ENA_OVR1_WR(src)            (((u32)(src)<<4) & 0x00000030)
#define CFG_I_BC_TAP_ENA_OVR1_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_i_SPD_sel_cdr_ovr	 */
#define CFG_I_SPD_SEL_CDR_OVR1_WIDTH                                          4
#define CFG_I_SPD_SEL_CDR_OVR1_SHIFT                                          0
#define CFG_I_SPD_SEL_CDR_OVR1_MASK                                  0x0000000f
#define CFG_I_SPD_SEL_CDR_OVR1_RD(src)                   (((src) & 0x0000000f))
#define CFG_I_SPD_SEL_CDR_OVR1_WR(src)              (((u32)(src)) & 0x0000000f)
#define CFG_I_SPD_SEL_CDR_OVR1_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register SATA_ENET_SDS_CMU_STATUS0	*/ 
/*	 Fields cfg_cmu_o_pll_spare	 */
#define CFG_CMU_O_PLL_SPARE0_WIDTH                                            4
#define CFG_CMU_O_PLL_SPARE0_SHIFT                                            3
#define CFG_CMU_O_PLL_SPARE0_MASK                                    0x00000078
#define CFG_CMU_O_PLL_SPARE0_RD(src)                  (((src) & 0x00000078)>>3)
#define CFG_CMU_O_PLL_SPARE0_SET(dst,src) \
                       (((dst) & ~0x00000078) | (((u32)(src)<<3) & 0x00000078))
/*	 Fields cfg_cmu_o_vco_caldone	 */
#define CFG_CMU_O_VCO_CALDONE0_WIDTH                                          1
#define CFG_CMU_O_VCO_CALDONE0_SHIFT                                          2
#define CFG_CMU_O_VCO_CALDONE0_MASK                                  0x00000004
#define CFG_CMU_O_VCO_CALDONE0_RD(src)                (((src) & 0x00000004)>>2)
#define CFG_CMU_O_VCO_CALDONE0_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_cmu_o_pll_lock	 */
#define CFG_CMU_O_PLL_LOCK0_WIDTH                                             1
#define CFG_CMU_O_PLL_LOCK0_SHIFT                                             1
#define CFG_CMU_O_PLL_LOCK0_MASK                                     0x00000002
#define CFG_CMU_O_PLL_LOCK0_RD(src)                   (((src) & 0x00000002)>>1)
#define CFG_CMU_O_PLL_LOCK0_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_cmu_o_pll_ready	 */
#define CFG_CMU_O_PLL_READY0_WIDTH                                            1
#define CFG_CMU_O_PLL_READY0_SHIFT                                            0
#define CFG_CMU_O_PLL_READY0_MASK                                    0x00000001
#define CFG_CMU_O_PLL_READY0_RD(src)                     (((src) & 0x00000001))
#define CFG_CMU_O_PLL_READY0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS0_RXTX_STATUS	*/ 
/*	 Fields cfg_tx_o_tx_spare	 */
#define CFG_TX_O_TX_SPARE_WIDTH                                               3
#define CFG_TX_O_TX_SPARE_SHIFT                                              23
#define CFG_TX_O_TX_SPARE_MASK                                       0x03800000
#define CFG_TX_O_TX_SPARE_RD(src)                    (((src) & 0x03800000)>>23)
#define CFG_TX_O_TX_SPARE_SET(dst,src) \
                      (((dst) & ~0x03800000) | (((u32)(src)<<23) & 0x03800000))
/*	 Fields cfg_tx_o_tx_rx_pres_mid	 */
#define CFG_TX_O_TX_RX_PRES_MID_WIDTH                                         1
#define CFG_TX_O_TX_RX_PRES_MID_SHIFT                                        22
#define CFG_TX_O_TX_RX_PRES_MID_MASK                                 0x00400000
#define CFG_TX_O_TX_RX_PRES_MID_RD(src)              (((src) & 0x00400000)>>22)
#define CFG_TX_O_TX_RX_PRES_MID_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields cfg_tx_o_tx_rx_pres_zero	 */
#define CFG_TX_O_TX_RX_PRES_ZERO_WIDTH                                        1
#define CFG_TX_O_TX_RX_PRES_ZERO_SHIFT                                       21
#define CFG_TX_O_TX_RX_PRES_ZERO_MASK                                0x00200000
#define CFG_TX_O_TX_RX_PRES_ZERO_RD(src)             (((src) & 0x00200000)>>21)
#define CFG_TX_O_TX_RX_PRES_ZERO_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_tx_o_tx_ready	 */
#define CFG_TX_O_TX_READY_WIDTH                                               1
#define CFG_TX_O_TX_READY_SHIFT                                              20
#define CFG_TX_O_TX_READY_MASK                                       0x00100000
#define CFG_TX_O_TX_READY_RD(src)                    (((src) & 0x00100000)>>20)
#define CFG_TX_O_TX_READY_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_rx_o_rx_spare	 */
#define CFG_RX_O_RX_SPARE_WIDTH                                               4
#define CFG_RX_O_RX_SPARE_SHIFT                                              15
#define CFG_RX_O_RX_SPARE_MASK                                       0x00078000
#define CFG_RX_O_RX_SPARE_RD(src)                    (((src) & 0x00078000)>>15)
#define CFG_RX_O_RX_SPARE_SET(dst,src) \
                      (((dst) & ~0x00078000) | (((u32)(src)<<15) & 0x00078000))
/*	 Fields cfg_rx_o_rx_txcp_ack	 */
#define CFG_RX_O_RX_TXCP_ACK_WIDTH                                            1
#define CFG_RX_O_RX_TXCP_ACK_SHIFT                                           14
#define CFG_RX_O_RX_TXCP_ACK_MASK                                    0x00004000
#define CFG_RX_O_RX_TXCP_ACK_RD(src)                 (((src) & 0x00004000)>>14)
#define CFG_RX_O_RX_TXCP_ACK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields cfg_rx_o_rx_txcp	 */
#define CFG_RX_O_RX_TXCP_WIDTH                                                2
#define CFG_RX_O_RX_TXCP_SHIFT                                               12
#define CFG_RX_O_RX_TXCP_MASK                                        0x00003000
#define CFG_RX_O_RX_TXCP_RD(src)                     (((src) & 0x00003000)>>12)
#define CFG_RX_O_RX_TXCP_SET(dst,src) \
                      (((dst) & ~0x00003000) | (((u32)(src)<<12) & 0x00003000))
/*	 Fields cfg_rx_o_rx_txcn2_ack	 */
#define CFG_RX_O_RX_TXCN2_ACK_WIDTH                                           1
#define CFG_RX_O_RX_TXCN2_ACK_SHIFT                                          11
#define CFG_RX_O_RX_TXCN2_ACK_MASK                                   0x00000800
#define CFG_RX_O_RX_TXCN2_ACK_RD(src)                (((src) & 0x00000800)>>11)
#define CFG_RX_O_RX_TXCN2_ACK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_rx_o_rx_txcn2	 */
#define CFG_RX_O_RX_TXCN2_WIDTH                                               2
#define CFG_RX_O_RX_TXCN2_SHIFT                                               9
#define CFG_RX_O_RX_TXCN2_MASK                                       0x00000600
#define CFG_RX_O_RX_TXCN2_RD(src)                     (((src) & 0x00000600)>>9)
#define CFG_RX_O_RX_TXCN2_SET(dst,src) \
                       (((dst) & ~0x00000600) | (((u32)(src)<<9) & 0x00000600))
/*	 Fields cfg_rx_o_rx_txcn1_ack	 */
#define CFG_RX_O_RX_TXCN1_ACK_WIDTH                                           1
#define CFG_RX_O_RX_TXCN1_ACK_SHIFT                                           8
#define CFG_RX_O_RX_TXCN1_ACK_MASK                                   0x00000100
#define CFG_RX_O_RX_TXCN1_ACK_RD(src)                 (((src) & 0x00000100)>>8)
#define CFG_RX_O_RX_TXCN1_ACK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_rx_o_rx_txcn1	 */
#define CFG_RX_O_RX_TXCN1_WIDTH                                               2
#define CFG_RX_O_RX_TXCN1_SHIFT                                               6
#define CFG_RX_O_RX_TXCN1_MASK                                       0x000000c0
#define CFG_RX_O_RX_TXCN1_RD(src)                     (((src) & 0x000000c0)>>6)
#define CFG_RX_O_RX_TXCN1_SET(dst,src) \
                       (((dst) & ~0x000000c0) | (((u32)(src)<<6) & 0x000000c0))
/*	 Fields cfg_rx_o_rx_txc0_ack	 */
#define CFG_RX_O_RX_TXC0_ACK_WIDTH                                            1
#define CFG_RX_O_RX_TXC0_ACK_SHIFT                                            5
#define CFG_RX_O_RX_TXC0_ACK_MASK                                    0x00000020
#define CFG_RX_O_RX_TXC0_ACK_RD(src)                  (((src) & 0x00000020)>>5)
#define CFG_RX_O_RX_TXC0_ACK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields cfg_rx_o_rx_txc0	 */
#define CFG_RX_O_RX_TXC0_WIDTH                                                2
#define CFG_RX_O_RX_TXC0_SHIFT                                                3
#define CFG_RX_O_RX_TXC0_MASK                                        0x00000018
#define CFG_RX_O_RX_TXC0_RD(src)                      (((src) & 0x00000018)>>3)
#define CFG_RX_O_RX_TXC0_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields cfg_rx_o_rxlos_fil	 */
#define CFG_RX_O_RXLOS_FIL_WIDTH                                              1
#define CFG_RX_O_RXLOS_FIL_SHIFT                                              2
#define CFG_RX_O_RXLOS_FIL_MASK                                      0x00000004
#define CFG_RX_O_RXLOS_FIL_RD(src)                    (((src) & 0x00000004)>>2)
#define CFG_RX_O_RXLOS_FIL_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_rx_o_rx_ready	 */
#define CFG_RX_O_RX_READY_WIDTH                                               1
#define CFG_RX_O_RX_READY_SHIFT                                               0
#define CFG_RX_O_RX_READY_MASK                                       0x00000001
#define CFG_RX_O_RX_READY_RD(src)                        (((src) & 0x00000001))
#define CFG_RX_O_RX_READY_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS1_RXTX_STATUS	*/ 
/*	 Fields cfg_tx_o_tx_spare	 */
#define CFG_TX_O_TX_SPARE_F1_WIDTH                                            3
#define CFG_TX_O_TX_SPARE_F1_SHIFT                                           23
#define CFG_TX_O_TX_SPARE_F1_MASK                                    0x03800000
#define CFG_TX_O_TX_SPARE_F1_RD(src)                 (((src) & 0x03800000)>>23)
#define CFG_TX_O_TX_SPARE_F1_SET(dst,src) \
                      (((dst) & ~0x03800000) | (((u32)(src)<<23) & 0x03800000))
/*	 Fields cfg_tx_o_tx_rx_pres_mid	 */
#define CFG_TX_O_TX_RX_PRES_MID_F1_WIDTH                                      1
#define CFG_TX_O_TX_RX_PRES_MID_F1_SHIFT                                     22
#define CFG_TX_O_TX_RX_PRES_MID_F1_MASK                              0x00400000
#define CFG_TX_O_TX_RX_PRES_MID_F1_RD(src)           (((src) & 0x00400000)>>22)
#define CFG_TX_O_TX_RX_PRES_MID_F1_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields cfg_tx_o_tx_rx_pres_zero	 */
#define CFG_TX_O_TX_RX_PRES_ZERO_F1_WIDTH                                     1
#define CFG_TX_O_TX_RX_PRES_ZERO_F1_SHIFT                                    21
#define CFG_TX_O_TX_RX_PRES_ZERO_F1_MASK                             0x00200000
#define CFG_TX_O_TX_RX_PRES_ZERO_F1_RD(src)          (((src) & 0x00200000)>>21)
#define CFG_TX_O_TX_RX_PRES_ZERO_F1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields cfg_tx_o_tx_ready	 */
#define CFG_TX_O_TX_READY_F1_WIDTH                                            1
#define CFG_TX_O_TX_READY_F1_SHIFT                                           20
#define CFG_TX_O_TX_READY_F1_MASK                                    0x00100000
#define CFG_TX_O_TX_READY_F1_RD(src)                 (((src) & 0x00100000)>>20)
#define CFG_TX_O_TX_READY_F1_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields cfg_rx_o_rx_spare	 */
#define CFG_RX_O_RX_SPARE_F1_WIDTH                                            4
#define CFG_RX_O_RX_SPARE_F1_SHIFT                                           15
#define CFG_RX_O_RX_SPARE_F1_MASK                                    0x00078000
#define CFG_RX_O_RX_SPARE_F1_RD(src)                 (((src) & 0x00078000)>>15)
#define CFG_RX_O_RX_SPARE_F1_SET(dst,src) \
                      (((dst) & ~0x00078000) | (((u32)(src)<<15) & 0x00078000))
/*	 Fields cfg_rx_o_rx_txcp_ack	 */
#define CFG_RX_O_RX_TXCP_ACK_F1_WIDTH                                         1
#define CFG_RX_O_RX_TXCP_ACK_F1_SHIFT                                        14
#define CFG_RX_O_RX_TXCP_ACK_F1_MASK                                 0x00004000
#define CFG_RX_O_RX_TXCP_ACK_F1_RD(src)              (((src) & 0x00004000)>>14)
#define CFG_RX_O_RX_TXCP_ACK_F1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields cfg_rx_o_rx_txcp	 */
#define CFG_RX_O_RX_TXCP_F1_WIDTH                                             2
#define CFG_RX_O_RX_TXCP_F1_SHIFT                                            12
#define CFG_RX_O_RX_TXCP_F1_MASK                                     0x00003000
#define CFG_RX_O_RX_TXCP_F1_RD(src)                  (((src) & 0x00003000)>>12)
#define CFG_RX_O_RX_TXCP_F1_SET(dst,src) \
                      (((dst) & ~0x00003000) | (((u32)(src)<<12) & 0x00003000))
/*	 Fields cfg_rx_o_rx_txcn2_ack	 */
#define CFG_RX_O_RX_TXCN2_ACK_F1_WIDTH                                        1
#define CFG_RX_O_RX_TXCN2_ACK_F1_SHIFT                                       11
#define CFG_RX_O_RX_TXCN2_ACK_F1_MASK                                0x00000800
#define CFG_RX_O_RX_TXCN2_ACK_F1_RD(src)             (((src) & 0x00000800)>>11)
#define CFG_RX_O_RX_TXCN2_ACK_F1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_rx_o_rx_txcn2	 */
#define CFG_RX_O_RX_TXCN2_F1_WIDTH                                            2
#define CFG_RX_O_RX_TXCN2_F1_SHIFT                                            9
#define CFG_RX_O_RX_TXCN2_F1_MASK                                    0x00000600
#define CFG_RX_O_RX_TXCN2_F1_RD(src)                  (((src) & 0x00000600)>>9)
#define CFG_RX_O_RX_TXCN2_F1_SET(dst,src) \
                       (((dst) & ~0x00000600) | (((u32)(src)<<9) & 0x00000600))
/*	 Fields cfg_rx_o_rx_txcn1_ack	 */
#define CFG_RX_O_RX_TXCN1_ACK_F1_WIDTH                                        1
#define CFG_RX_O_RX_TXCN1_ACK_F1_SHIFT                                        8
#define CFG_RX_O_RX_TXCN1_ACK_F1_MASK                                0x00000100
#define CFG_RX_O_RX_TXCN1_ACK_F1_RD(src)              (((src) & 0x00000100)>>8)
#define CFG_RX_O_RX_TXCN1_ACK_F1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_rx_o_rx_txcn1	 */
#define CFG_RX_O_RX_TXCN1_F1_WIDTH                                            2
#define CFG_RX_O_RX_TXCN1_F1_SHIFT                                            6
#define CFG_RX_O_RX_TXCN1_F1_MASK                                    0x000000c0
#define CFG_RX_O_RX_TXCN1_F1_RD(src)                  (((src) & 0x000000c0)>>6)
#define CFG_RX_O_RX_TXCN1_F1_SET(dst,src) \
                       (((dst) & ~0x000000c0) | (((u32)(src)<<6) & 0x000000c0))
/*	 Fields cfg_rx_o_rx_txc0_ack	 */
#define CFG_RX_O_RX_TXC0_ACK_F1_WIDTH                                         1
#define CFG_RX_O_RX_TXC0_ACK_F1_SHIFT                                         5
#define CFG_RX_O_RX_TXC0_ACK_F1_MASK                                 0x00000020
#define CFG_RX_O_RX_TXC0_ACK_F1_RD(src)               (((src) & 0x00000020)>>5)
#define CFG_RX_O_RX_TXC0_ACK_F1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields cfg_rx_o_rx_txc0	 */
#define CFG_RX_O_RX_TXC0_F1_WIDTH                                             2
#define CFG_RX_O_RX_TXC0_F1_SHIFT                                             3
#define CFG_RX_O_RX_TXC0_F1_MASK                                     0x00000018
#define CFG_RX_O_RX_TXC0_F1_RD(src)                   (((src) & 0x00000018)>>3)
#define CFG_RX_O_RX_TXC0_F1_SET(dst,src) \
                       (((dst) & ~0x00000018) | (((u32)(src)<<3) & 0x00000018))
/*	 Fields cfg_rx_o_rxlos_fil	 */
#define CFG_RX_O_RXLOS_FIL_F1_WIDTH                                           1
#define CFG_RX_O_RXLOS_FIL_F1_SHIFT                                           2
#define CFG_RX_O_RXLOS_FIL_F1_MASK                                   0x00000004
#define CFG_RX_O_RXLOS_FIL_F1_RD(src)                 (((src) & 0x00000004)>>2)
#define CFG_RX_O_RXLOS_FIL_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_rx_o_rx_ready	 */
#define CFG_RX_O_RX_READY_F1_WIDTH                                            1
#define CFG_RX_O_RX_READY_F1_SHIFT                                            0
#define CFG_RX_O_RX_READY_F1_MASK                                    0x00000001
#define CFG_RX_O_RX_READY_F1_RD(src)                     (((src) & 0x00000001))
#define CFG_RX_O_RX_READY_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS_RST_CTL	*/ 
/*	 Fields cfg_cmu_i_refclk_div_resetn	 */
#define CFG_CMU_I_REFCLK_DIV_RESETN_WIDTH                                     1
#define CFG_CMU_I_REFCLK_DIV_RESETN_SHIFT                                     7
#define CFG_CMU_I_REFCLK_DIV_RESETN_MASK                             0x00000080
#define CFG_CMU_I_REFCLK_DIV_RESETN_RD(src)           (((src) & 0x00000080)>>7)
#define CFG_CMU_I_REFCLK_DIV_RESETN_WR(src)      (((u32)(src)<<7) & 0x00000080)
#define CFG_CMU_I_REFCLK_DIV_RESETN_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields cfg_cmu_i_post_div_resetn	 */
#define CFG_CMU_I_POST_DIV_RESETN_WIDTH                                       1
#define CFG_CMU_I_POST_DIV_RESETN_SHIFT                                       6
#define CFG_CMU_I_POST_DIV_RESETN_MASK                               0x00000040
#define CFG_CMU_I_POST_DIV_RESETN_RD(src)             (((src) & 0x00000040)>>6)
#define CFG_CMU_I_POST_DIV_RESETN_WR(src)        (((u32)(src)<<6) & 0x00000040)
#define CFG_CMU_I_POST_DIV_RESETN_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_tx_i_tx_syncclk	 */
#define CFG_TX_I_TX_SYNCCLK_WIDTH                                             1
#define CFG_TX_I_TX_SYNCCLK_SHIFT                                             5
#define CFG_TX_I_TX_SYNCCLK_MASK                                     0x00000020
#define CFG_TX_I_TX_SYNCCLK_RD(src)                   (((src) & 0x00000020)>>5)
#define CFG_TX_I_TX_SYNCCLK_WR(src)              (((u32)(src)<<5) & 0x00000020)
#define CFG_TX_I_TX_SYNCCLK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields cfg_tx_i_tx_resetn	 */
#define CFG_TX_I_TX_RESETN_WIDTH                                              1
#define CFG_TX_I_TX_RESETN_SHIFT                                              4
#define CFG_TX_I_TX_RESETN_MASK                                      0x00000010
#define CFG_TX_I_TX_RESETN_RD(src)                    (((src) & 0x00000010)>>4)
#define CFG_TX_I_TX_RESETN_WR(src)               (((u32)(src)<<4) & 0x00000010)
#define CFG_TX_I_TX_RESETN_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields cfg_rx_i_sd_resetn	 */
#define CFG_RX_I_SD_RESETN_WIDTH                                              1
#define CFG_RX_I_SD_RESETN_SHIFT                                              3
#define CFG_RX_I_SD_RESETN_MASK                                      0x00000008
#define CFG_RX_I_SD_RESETN_RD(src)                    (((src) & 0x00000008)>>3)
#define CFG_RX_I_SD_RESETN_WR(src)               (((u32)(src)<<3) & 0x00000008)
#define CFG_RX_I_SD_RESETN_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_rx_i_rx_resetn	 */
#define CFG_RX_I_RX_RESETN_WIDTH                                              1
#define CFG_RX_I_RX_RESETN_SHIFT                                              2
#define CFG_RX_I_RX_RESETN_MASK                                      0x00000004
#define CFG_RX_I_RX_RESETN_RD(src)                    (((src) & 0x00000004)>>2)
#define CFG_RX_I_RX_RESETN_WR(src)               (((u32)(src)<<2) & 0x00000004)
#define CFG_RX_I_RX_RESETN_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_cmu_i_pllresetn	 */
#define CFG_CMU_I_PLLRESETN_WIDTH                                             1
#define CFG_CMU_I_PLLRESETN_SHIFT                                             1
#define CFG_CMU_I_PLLRESETN_MASK                                     0x00000002
#define CFG_CMU_I_PLLRESETN_RD(src)                   (((src) & 0x00000002)>>1)
#define CFG_CMU_I_PLLRESETN_WR(src)              (((u32)(src)<<1) & 0x00000002)
#define CFG_CMU_I_PLLRESETN_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_cmu_i_resetb	 */
#define CFG_CMU_I_RESETB_WIDTH                                                1
#define CFG_CMU_I_RESETB_SHIFT                                                0
#define CFG_CMU_I_RESETB_MASK                                        0x00000001
#define CFG_CMU_I_RESETB_RD(src)                         (((src) & 0x00000001))
#define CFG_CMU_I_RESETB_WR(src)                    (((u32)(src)) & 0x00000001)
#define CFG_CMU_I_RESETB_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS_CMU_CTL0	*/ 
/*	 Fields cfg_cmu_i_gen3_refclk_div	 */
#define CFG_CMU_I_GEN3_REFCLK_DIV0_WIDTH                                      2
#define CFG_CMU_I_GEN3_REFCLK_DIV0_SHIFT                                     30
#define CFG_CMU_I_GEN3_REFCLK_DIV0_MASK                              0xc0000000
#define CFG_CMU_I_GEN3_REFCLK_DIV0_RD(src)           (((src) & 0xc0000000)>>30)
#define CFG_CMU_I_GEN3_REFCLK_DIV0_WR(src)      (((u32)(src)<<30) & 0xc0000000)
#define CFG_CMU_I_GEN3_REFCLK_DIV0_SET(dst,src) \
                      (((dst) & ~0xc0000000) | (((u32)(src)<<30) & 0xc0000000))
/*	 Fields cfg_cmu_i_pll_vcomomsel_pcie3	 */
#define CFG_CMU_I_PLL_VCOMOMSEL_PCIE30_WIDTH                                  5
#define CFG_CMU_I_PLL_VCOMOMSEL_PCIE30_SHIFT                                 25
#define CFG_CMU_I_PLL_VCOMOMSEL_PCIE30_MASK                          0x3e000000
#define CFG_CMU_I_PLL_VCOMOMSEL_PCIE30_RD(src)       (((src) & 0x3e000000)>>25)
#define CFG_CMU_I_PLL_VCOMOMSEL_PCIE30_WR(src)  (((u32)(src)<<25) & 0x3e000000)
#define CFG_CMU_I_PLL_VCOMOMSEL_PCIE30_SET(dst,src) \
                      (((dst) & ~0x3e000000) | (((u32)(src)<<25) & 0x3e000000))
/*	 Fields cfg_cmu_i_pll_vcovarsel_pcie3	 */
#define CFG_CMU_I_PLL_VCOVARSEL_PCIE30_WIDTH                                  4
#define CFG_CMU_I_PLL_VCOVARSEL_PCIE30_SHIFT                                 21
#define CFG_CMU_I_PLL_VCOVARSEL_PCIE30_MASK                          0x01e00000
#define CFG_CMU_I_PLL_VCOVARSEL_PCIE30_RD(src)       (((src) & 0x01e00000)>>21)
#define CFG_CMU_I_PLL_VCOVARSEL_PCIE30_WR(src)  (((u32)(src)<<21) & 0x01e00000)
#define CFG_CMU_I_PLL_VCOVARSEL_PCIE30_SET(dst,src) \
                      (((dst) & ~0x01e00000) | (((u32)(src)<<21) & 0x01e00000))
/*	 Fields cfg_cmu_i_pll_vcomomsel	 */
#define CFG_CMU_I_PLL_VCOMOMSEL0_WIDTH                                        6
#define CFG_CMU_I_PLL_VCOMOMSEL0_SHIFT                                       15
#define CFG_CMU_I_PLL_VCOMOMSEL0_MASK                                0x001f8000
#define CFG_CMU_I_PLL_VCOMOMSEL0_RD(src)             (((src) & 0x001f8000)>>15)
#define CFG_CMU_I_PLL_VCOMOMSEL0_WR(src)        (((u32)(src)<<15) & 0x001f8000)
#define CFG_CMU_I_PLL_VCOMOMSEL0_SET(dst,src) \
                      (((dst) & ~0x001f8000) | (((u32)(src)<<15) & 0x001f8000))
/*	 Fields cfg_cmu_i_pll_vcovarsel	 */
#define CFG_CMU_I_PLL_VCOVARSEL0_WIDTH                                        4
#define CFG_CMU_I_PLL_VCOVARSEL0_SHIFT                                       11
#define CFG_CMU_I_PLL_VCOVARSEL0_MASK                                0x00007800
#define CFG_CMU_I_PLL_VCOVARSEL0_RD(src)             (((src) & 0x00007800)>>11)
#define CFG_CMU_I_PLL_VCOVARSEL0_WR(src)        (((u32)(src)<<11) & 0x00007800)
#define CFG_CMU_I_PLL_VCOVARSEL0_SET(dst,src) \
                      (((dst) & ~0x00007800) | (((u32)(src)<<11) & 0x00007800))
/*	 Fields cfg_cmu_i_pll_cp	 */
#define CFG_CMU_I_PLL_CP0_WIDTH                                               5
#define CFG_CMU_I_PLL_CP0_SHIFT                                               6
#define CFG_CMU_I_PLL_CP0_MASK                                       0x000007c0
#define CFG_CMU_I_PLL_CP0_RD(src)                     (((src) & 0x000007c0)>>6)
#define CFG_CMU_I_PLL_CP0_WR(src)                (((u32)(src)<<6) & 0x000007c0)
#define CFG_CMU_I_PLL_CP0_SET(dst,src) \
                       (((dst) & ~0x000007c0) | (((u32)(src)<<6) & 0x000007c0))
/*	 Fields cfg_cmu_i_pll_lfcap	 */
#define CFG_CMU_I_PLL_LFCAP0_WIDTH                                            2
#define CFG_CMU_I_PLL_LFCAP0_SHIFT                                            4
#define CFG_CMU_I_PLL_LFCAP0_MASK                                    0x00000030
#define CFG_CMU_I_PLL_LFCAP0_RD(src)                  (((src) & 0x00000030)>>4)
#define CFG_CMU_I_PLL_LFCAP0_WR(src)             (((u32)(src)<<4) & 0x00000030)
#define CFG_CMU_I_PLL_LFCAP0_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields cfg_cmu_i_pll_lfres	 */
#define CFG_CMU_I_PLL_LFRES0_WIDTH                                            4
#define CFG_CMU_I_PLL_LFRES0_SHIFT                                            0
#define CFG_CMU_I_PLL_LFRES0_MASK                                    0x0000000f
#define CFG_CMU_I_PLL_LFRES0_RD(src)                     (((src) & 0x0000000f))
#define CFG_CMU_I_PLL_LFRES0_WR(src)                (((u32)(src)) & 0x0000000f)
#define CFG_CMU_I_PLL_LFRES0_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register SATA_ENET_SDS_CMU_CTL1	*/ 
/*	 Fields cfg_cmu_i_usrclk_div	 */
#define CFG_CMU_I_USRCLK_DIV1_WIDTH                                           3
#define CFG_CMU_I_USRCLK_DIV1_SHIFT                                          26
#define CFG_CMU_I_USRCLK_DIV1_MASK                                   0x1c000000
#define CFG_CMU_I_USRCLK_DIV1_RD(src)                (((src) & 0x1c000000)>>26)
#define CFG_CMU_I_USRCLK_DIV1_WR(src)           (((u32)(src)<<26) & 0x1c000000)
#define CFG_CMU_I_USRCLK_DIV1_SET(dst,src) \
                      (((dst) & ~0x1c000000) | (((u32)(src)<<26) & 0x1c000000))
/*	 Fields cfg_cmu_i_pciegen3	 */
#define CFG_CMU_I_PCIEGEN31_WIDTH                                             1
#define CFG_CMU_I_PCIEGEN31_SHIFT                                            25
#define CFG_CMU_I_PCIEGEN31_MASK                                     0x02000000
#define CFG_CMU_I_PCIEGEN31_RD(src)                  (((src) & 0x02000000)>>25)
#define CFG_CMU_I_PCIEGEN31_WR(src)             (((u32)(src)<<25) & 0x02000000)
#define CFG_CMU_I_PCIEGEN31_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields cfg_cmu_i_pcie_mode	 */
#define ENET_CFG_CMU_I_PCIE_MODE1_WIDTH                                    1
#define ENET_CFG_CMU_I_PCIE_MODE1_SHIFT                                   24
#define ENET_CFG_CMU_I_PCIE_MODE1_MASK                            0x01000000
#define ENET_CFG_CMU_I_PCIE_MODE1_RD(src)         (((src) & 0x01000000)>>24)
#define ENET_CFG_CMU_I_PCIE_MODE1_WR(src)    (((u32)(src)<<24) & 0x01000000)
#define ENET_CFG_CMU_I_PCIE_MODE1_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields cfg_cmu_i_pll_spare	 */
#define CFG_CMU_I_PLL_SPARE1_WIDTH                                            4
#define CFG_CMU_I_PLL_SPARE1_SHIFT                                           20
#define CFG_CMU_I_PLL_SPARE1_MASK                                    0x00f00000
#define CFG_CMU_I_PLL_SPARE1_RD(src)                 (((src) & 0x00f00000)>>20)
#define CFG_CMU_I_PLL_SPARE1_WR(src)            (((u32)(src)<<20) & 0x00f00000)
#define CFG_CMU_I_PLL_SPARE1_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields cfg_cmu_i_pll_cal	 */
#define CFG_CMU_I_PLL_CAL1_WIDTH                                              1
#define CFG_CMU_I_PLL_CAL1_SHIFT                                             17
#define CFG_CMU_I_PLL_CAL1_MASK                                      0x00020000
#define CFG_CMU_I_PLL_CAL1_RD(src)                   (((src) & 0x00020000)>>17)
#define CFG_CMU_I_PLL_CAL1_WR(src)              (((u32)(src)<<17) & 0x00020000)
#define CFG_CMU_I_PLL_CAL1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields cfg_cmu_i_pll_clk_dis	 */
#define CFG_CMU_I_PLL_CLK_DIS1_WIDTH                                          1
#define CFG_CMU_I_PLL_CLK_DIS1_SHIFT                                         16
#define CFG_CMU_I_PLL_CLK_DIS1_MASK                                  0x00010000
#define CFG_CMU_I_PLL_CLK_DIS1_RD(src)               (((src) & 0x00010000)>>16)
#define CFG_CMU_I_PLL_CLK_DIS1_WR(src)          (((u32)(src)<<16) & 0x00010000)
#define CFG_CMU_I_PLL_CLK_DIS1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields cfg_cmu_i_pll_drv	 */
#define CFG_CMU_I_PLL_DRV1_WIDTH                                              3
#define CFG_CMU_I_PLL_DRV1_SHIFT                                             13
#define CFG_CMU_I_PLL_DRV1_MASK                                      0x0000e000
#define CFG_CMU_I_PLL_DRV1_RD(src)                   (((src) & 0x0000e000)>>13)
#define CFG_CMU_I_PLL_DRV1_WR(src)              (((u32)(src)<<13) & 0x0000e000)
#define CFG_CMU_I_PLL_DRV1_SET(dst,src) \
                      (((dst) & ~0x0000e000) | (((u32)(src)<<13) & 0x0000e000))
/*	 Fields cfg_cmu_i_pll_l1pd	 */
#define CFG_CMU_I_PLL_L1PD1_WIDTH                                             1
#define CFG_CMU_I_PLL_L1PD1_SHIFT                                            12
#define CFG_CMU_I_PLL_L1PD1_MASK                                     0x00001000
#define CFG_CMU_I_PLL_L1PD1_RD(src)                  (((src) & 0x00001000)>>12)
#define CFG_CMU_I_PLL_L1PD1_WR(src)             (((u32)(src)<<12) & 0x00001000)
#define CFG_CMU_I_PLL_L1PD1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields cfg_cmu_i_pll_pd	 */
#define CFG_CMU_I_PLL_PD1_WIDTH                                               1
#define CFG_CMU_I_PLL_PD1_SHIFT                                              11
#define CFG_CMU_I_PLL_PD1_MASK                                       0x00000800
#define CFG_CMU_I_PLL_PD1_RD(src)                    (((src) & 0x00000800)>>11)
#define CFG_CMU_I_PLL_PD1_WR(src)               (((u32)(src)<<11) & 0x00000800)
#define CFG_CMU_I_PLL_PD1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_cmu_i_gen3_post_divby2	 */
#define CFG_CMU_I_GEN3_POST_DIVBY21_WIDTH                                     1
#define CFG_CMU_I_GEN3_POST_DIVBY21_SHIFT                                    10
#define CFG_CMU_I_GEN3_POST_DIVBY21_MASK                             0x00000400
#define CFG_CMU_I_GEN3_POST_DIVBY21_RD(src)          (((src) & 0x00000400)>>10)
#define CFG_CMU_I_GEN3_POST_DIVBY21_WR(src)     (((u32)(src)<<10) & 0x00000400)
#define CFG_CMU_I_GEN3_POST_DIVBY21_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_cmu_i_post_divby2	 */
#define CFG_CMU_I_POST_DIVBY21_WIDTH                                          1
#define CFG_CMU_I_POST_DIVBY21_SHIFT                                          9
#define CFG_CMU_I_POST_DIVBY21_MASK                                  0x00000200
#define CFG_CMU_I_POST_DIVBY21_RD(src)                (((src) & 0x00000200)>>9)
#define CFG_CMU_I_POST_DIVBY21_WR(src)           (((u32)(src)<<9) & 0x00000200)
#define CFG_CMU_I_POST_DIVBY21_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_cmu_i_gen3_fb2_div	 */
#define CFG_CMU_I_GEN3_FB2_DIV1_WIDTH                                         6
#define CFG_CMU_I_GEN3_FB2_DIV1_SHIFT                                         3
#define CFG_CMU_I_GEN3_FB2_DIV1_MASK                                 0x000001f8
#define CFG_CMU_I_GEN3_FB2_DIV1_RD(src)               (((src) & 0x000001f8)>>3)
#define CFG_CMU_I_GEN3_FB2_DIV1_WR(src)          (((u32)(src)<<3) & 0x000001f8)
#define CFG_CMU_I_GEN3_FB2_DIV1_SET(dst,src) \
                       (((dst) & ~0x000001f8) | (((u32)(src)<<3) & 0x000001f8))
/*	 Fields cfg_cmu_i_gen3_fb1_div	 */
#define CFG_CMU_I_GEN3_FB1_DIV1_WIDTH                                         3
#define CFG_CMU_I_GEN3_FB1_DIV1_SHIFT                                         0
#define CFG_CMU_I_GEN3_FB1_DIV1_MASK                                 0x00000007
#define CFG_CMU_I_GEN3_FB1_DIV1_RD(src)                  (((src) & 0x00000007))
#define CFG_CMU_I_GEN3_FB1_DIV1_WR(src)             (((u32)(src)) & 0x00000007)
#define CFG_CMU_I_GEN3_FB1_DIV1_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register SATA_ENET_SDS_RX_CTL	*/ 
/*	 Fields cfg_rx_i_rx_inv	 */
#define CFG_RX_I_RX_INV_WIDTH                                                 1
#define CFG_RX_I_RX_INV_SHIFT                                                11
#define CFG_RX_I_RX_INV_MASK                                         0x00000800
#define CFG_RX_I_RX_INV_RD(src)                      (((src) & 0x00000800)>>11)
#define CFG_RX_I_RX_INV_WR(src)                 (((u32)(src)<<11) & 0x00000800)
#define CFG_RX_I_RX_INV_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields cfg_rx_i_rx_txcoeff_c0_req	 */
#define CFG_RX_I_RX_TXCOEFF_C0_REQ_WIDTH                                      1
#define CFG_RX_I_RX_TXCOEFF_C0_REQ_SHIFT                                     10
#define CFG_RX_I_RX_TXCOEFF_C0_REQ_MASK                              0x00000400
#define CFG_RX_I_RX_TXCOEFF_C0_REQ_RD(src)           (((src) & 0x00000400)>>10)
#define CFG_RX_I_RX_TXCOEFF_C0_REQ_WR(src)      (((u32)(src)<<10) & 0x00000400)
#define CFG_RX_I_RX_TXCOEFF_C0_REQ_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields cfg_rx_i_rx_det_term_enable	 */
#define CFG_RX_I_RX_DET_TERM_ENABLE_WIDTH                                     1
#define CFG_RX_I_RX_DET_TERM_ENABLE_SHIFT                                     9
#define CFG_RX_I_RX_DET_TERM_ENABLE_MASK                             0x00000200
#define CFG_RX_I_RX_DET_TERM_ENABLE_RD(src)           (((src) & 0x00000200)>>9)
#define CFG_RX_I_RX_DET_TERM_ENABLE_WR(src)      (((u32)(src)<<9) & 0x00000200)
#define CFG_RX_I_RX_DET_TERM_ENABLE_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields cfg_rx_i_rxlos_fil_value	 */
#define CFG_RX_I_RXLOS_FIL_VALUE_WIDTH                                        4
#define CFG_RX_I_RXLOS_FIL_VALUE_SHIFT                                        5
#define CFG_RX_I_RXLOS_FIL_VALUE_MASK                                0x000001e0
#define CFG_RX_I_RXLOS_FIL_VALUE_RD(src)              (((src) & 0x000001e0)>>5)
#define CFG_RX_I_RXLOS_FIL_VALUE_WR(src)         (((u32)(src)<<5) & 0x000001e0)
#define CFG_RX_I_RXLOS_FIL_VALUE_SET(dst,src) \
                       (((dst) & ~0x000001e0) | (((u32)(src)<<5) & 0x000001e0))
/*	 Fields cfg_rx_i_rx_sd_pd	 */
#define CFG_RX_I_RX_SD_PD_WIDTH                                               1
#define CFG_RX_I_RX_SD_PD_SHIFT                                               4
#define CFG_RX_I_RX_SD_PD_MASK                                       0x00000010
#define CFG_RX_I_RX_SD_PD_RD(src)                     (((src) & 0x00000010)>>4)
#define CFG_RX_I_RX_SD_PD_WR(src)                (((u32)(src)<<4) & 0x00000010)
#define CFG_RX_I_RX_SD_PD_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields cfg_rx_i_rx_p2_pd	 */
#define CFG_RX_I_RX_P2_PD_WIDTH                                               1
#define CFG_RX_I_RX_P2_PD_SHIFT                                               3
#define CFG_RX_I_RX_P2_PD_MASK                                       0x00000008
#define CFG_RX_I_RX_P2_PD_RD(src)                     (((src) & 0x00000008)>>3)
#define CFG_RX_I_RX_P2_PD_WR(src)                (((u32)(src)<<3) & 0x00000008)
#define CFG_RX_I_RX_P2_PD_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_rx_i_rx_p1_pd	 */
#define CFG_RX_I_RX_P1_PD_WIDTH                                               1
#define CFG_RX_I_RX_P1_PD_SHIFT                                               2
#define CFG_RX_I_RX_P1_PD_MASK                                       0x00000004
#define CFG_RX_I_RX_P1_PD_RD(src)                     (((src) & 0x00000004)>>2)
#define CFG_RX_I_RX_P1_PD_WR(src)                (((u32)(src)<<2) & 0x00000004)
#define CFG_RX_I_RX_P1_PD_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_rx_i_rx_p0s_pd	 */
#define CFG_RX_I_RX_P0S_PD_WIDTH                                              1
#define CFG_RX_I_RX_P0S_PD_SHIFT                                              1
#define CFG_RX_I_RX_P0S_PD_MASK                                      0x00000002
#define CFG_RX_I_RX_P0S_PD_RD(src)                    (((src) & 0x00000002)>>1)
#define CFG_RX_I_RX_P0S_PD_WR(src)               (((u32)(src)<<1) & 0x00000002)
#define CFG_RX_I_RX_P0S_PD_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_rx_i_rx_pd	 */
#define CFG_RX_I_RX_PD_WIDTH                                                  1
#define CFG_RX_I_RX_PD_SHIFT                                                  0
#define CFG_RX_I_RX_PD_MASK                                          0x00000001
#define CFG_RX_I_RX_PD_RD(src)                           (((src) & 0x00000001))
#define CFG_RX_I_RX_PD_WR(src)                      (((u32)(src)) & 0x00000001)
#define CFG_RX_I_RX_PD_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS_TX_CTL	*/ 
/*	 Fields cfg_tx_i_lfps_ena	 */
#define CFG_TX_I_LFPS_ENA_WIDTH                                               1
#define CFG_TX_I_LFPS_ENA_SHIFT                                               8
#define CFG_TX_I_LFPS_ENA_MASK                                       0x00000100
#define CFG_TX_I_LFPS_ENA_RD(src)                     (((src) & 0x00000100)>>8)
#define CFG_TX_I_LFPS_ENA_WR(src)                (((u32)(src)<<8) & 0x00000100)
#define CFG_TX_I_LFPS_ENA_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields cfg_tx_i_tx_inv	 */
#define CFG_TX_I_TX_INV_WIDTH                                                 1
#define CFG_TX_I_TX_INV_SHIFT                                                 7
#define CFG_TX_I_TX_INV_MASK                                         0x00000080
#define CFG_TX_I_TX_INV_RD(src)                       (((src) & 0x00000080)>>7)
#define CFG_TX_I_TX_INV_WR(src)                  (((u32)(src)<<7) & 0x00000080)
#define CFG_TX_I_TX_INV_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields cfg_tx_i_tx_pdp2	 */
#define CFG_TX_I_TX_PDP2_WIDTH                                                1
#define CFG_TX_I_TX_PDP2_SHIFT                                                6
#define CFG_TX_I_TX_PDP2_MASK                                        0x00000040
#define CFG_TX_I_TX_PDP2_RD(src)                      (((src) & 0x00000040)>>6)
#define CFG_TX_I_TX_PDP2_WR(src)                 (((u32)(src)<<6) & 0x00000040)
#define CFG_TX_I_TX_PDP2_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields cfg_tx_i_tx_pdp1	 */
#define CFG_TX_I_TX_PDP1_WIDTH                                                1
#define CFG_TX_I_TX_PDP1_SHIFT                                                5
#define CFG_TX_I_TX_PDP1_MASK                                        0x00000020
#define CFG_TX_I_TX_PDP1_RD(src)                      (((src) & 0x00000020)>>5)
#define CFG_TX_I_TX_PDP1_WR(src)                 (((u32)(src)<<5) & 0x00000020)
#define CFG_TX_I_TX_PDP1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields cfg_tx_i_tx_pdp0s	 */
#define CFG_TX_I_TX_PDP0S_WIDTH                                               1
#define CFG_TX_I_TX_PDP0S_SHIFT                                               4
#define CFG_TX_I_TX_PDP0S_MASK                                       0x00000010
#define CFG_TX_I_TX_PDP0S_RD(src)                     (((src) & 0x00000010)>>4)
#define CFG_TX_I_TX_PDP0S_WR(src)                (((u32)(src)<<4) & 0x00000010)
#define CFG_TX_I_TX_PDP0S_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields cfg_tx_i_tx_pd	 */
#define CFG_TX_I_TX_PD_WIDTH                                                  1
#define CFG_TX_I_TX_PD_SHIFT                                                  3
#define CFG_TX_I_TX_PD_MASK                                          0x00000008
#define CFG_TX_I_TX_PD_RD(src)                        (((src) & 0x00000008)>>3)
#define CFG_TX_I_TX_PD_WR(src)                   (((u32)(src)<<3) & 0x00000008)
#define CFG_TX_I_TX_PD_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_tx_i_tx_invcn2	 */
#define CFG_TX_I_TX_INVCN2_WIDTH                                              1
#define CFG_TX_I_TX_INVCN2_SHIFT                                              2
#define CFG_TX_I_TX_INVCN2_MASK                                      0x00000004
#define CFG_TX_I_TX_INVCN2_RD(src)                    (((src) & 0x00000004)>>2)
#define CFG_TX_I_TX_INVCN2_WR(src)               (((u32)(src)<<2) & 0x00000004)
#define CFG_TX_I_TX_INVCN2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_tx_i_tx_invcn1	 */
#define CFG_TX_I_TX_INVCN1_WIDTH                                              1
#define CFG_TX_I_TX_INVCN1_SHIFT                                              1
#define CFG_TX_I_TX_INVCN1_MASK                                      0x00000002
#define CFG_TX_I_TX_INVCN1_RD(src)                    (((src) & 0x00000002)>>1)
#define CFG_TX_I_TX_INVCN1_WR(src)               (((u32)(src)<<1) & 0x00000002)
#define CFG_TX_I_TX_INVCN1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_tx_i_tx_invcp	 */
#define CFG_TX_I_TX_INVCP_WIDTH                                               1
#define CFG_TX_I_TX_INVCP_SHIFT                                               0
#define CFG_TX_I_TX_INVCP_MASK                                       0x00000001
#define CFG_TX_I_TX_INVCP_RD(src)                        (((src) & 0x00000001))
#define CFG_TX_I_TX_INVCP_WR(src)                   (((u32)(src)) & 0x00000001)
#define CFG_TX_I_TX_INVCP_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS_DEBUG_REG	*/ 
/*	 Fields cfg_i_debug_sel	 */
#define CFG_I_DEBUG_SEL_WIDTH                                                 4
#define CFG_I_DEBUG_SEL_SHIFT                                                16
#define CFG_I_DEBUG_SEL_MASK                                         0x000f0000
#define CFG_I_DEBUG_SEL_RD(src)                      (((src) & 0x000f0000)>>16)
#define CFG_I_DEBUG_SEL_WR(src)                 (((u32)(src)<<16) & 0x000f0000)
#define CFG_I_DEBUG_SEL_SET(dst,src) \
                      (((dst) & ~0x000f0000) | (((u32)(src)<<16) & 0x000f0000))
/*	 Fields cfg_o_debug_out	 */
#define CFG_O_DEBUG_OUT_WIDTH                                                16
#define CFG_O_DEBUG_OUT_SHIFT                                                 0
#define CFG_O_DEBUG_OUT_MASK                                         0x0000ffff
#define CFG_O_DEBUG_OUT_RD(src)                          (((src) & 0x0000ffff))
#define CFG_O_DEBUG_OUT_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register SATA_ENET_SDS_IND_CMD_REG	*/ 
/*	 Fields cfg_ind_addr	 */
#define CFG_IND_ADDR_WIDTH                                                   18
#define CFG_IND_ADDR_SHIFT                                                    4
#define CFG_IND_ADDR_MASK                                            0x003ffff0
#define CFG_IND_ADDR_RD(src)                          (((src) & 0x003ffff0)>>4)
#define CFG_IND_ADDR_WR(src)                     (((u32)(src)<<4) & 0x003ffff0)
#define CFG_IND_ADDR_SET(dst,src) \
                       (((dst) & ~0x003ffff0) | (((u32)(src)<<4) & 0x003ffff0))
/*	 Fields cfg_ind_err	 */
#define CFG_IND_ERR_WIDTH                                                     1
#define CFG_IND_ERR_SHIFT                                                     3
#define CFG_IND_ERR_MASK                                             0x00000008
#define CFG_IND_ERR_RD(src)                           (((src) & 0x00000008)>>3)
#define CFG_IND_ERR_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define CFG_IND_ERR_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields cfg_ind_cmd_done	 */
#define CFG_IND_CMD_DONE_WIDTH                                                1
#define CFG_IND_CMD_DONE_SHIFT                                                2
#define CFG_IND_CMD_DONE_MASK                                        0x00000004
#define CFG_IND_CMD_DONE_RD(src)                      (((src) & 0x00000004)>>2)
#define CFG_IND_CMD_DONE_WR(src)                 (((u32)(src)<<2) & 0x00000004)
#define CFG_IND_CMD_DONE_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields cfg_ind_rd_cmd	 */
#define CFG_IND_RD_CMD_WIDTH                                                  1
#define CFG_IND_RD_CMD_SHIFT                                                  1
#define CFG_IND_RD_CMD_MASK                                          0x00000002
#define CFG_IND_RD_CMD_RD(src)                        (((src) & 0x00000002)>>1)
#define CFG_IND_RD_CMD_WR(src)                   (((u32)(src)<<1) & 0x00000002)
#define CFG_IND_RD_CMD_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields cfg_ind_wr_cmd	 */
#define CFG_IND_WR_CMD_WIDTH                                                  1
#define CFG_IND_WR_CMD_SHIFT                                                  0
#define CFG_IND_WR_CMD_MASK                                          0x00000001
#define CFG_IND_WR_CMD_RD(src)                           (((src) & 0x00000001))
#define CFG_IND_WR_CMD_WR(src)                      (((u32)(src)) & 0x00000001)
#define CFG_IND_WR_CMD_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register SATA_ENET_SDS_IND_RDATA_REG	*/ 
/*	 Fields cfg_ind_rdata	 */
#define CFG_IND_RDATA_WIDTH                                                  32
#define CFG_IND_RDATA_SHIFT                                                   0
#define CFG_IND_RDATA_MASK                                           0xffffffff
#define CFG_IND_RDATA_RD(src)                            (((src) & 0xffffffff))
#define CFG_IND_RDATA_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SATA_ENET_SDS_IND_WDATA_REG	*/ 
/*	 Fields cfg_ind_wdata	 */
#define CFG_IND_WDATA_WIDTH                                                  32
#define CFG_IND_WDATA_SHIFT                                                   0
#define CFG_IND_WDATA_MASK                                           0xffffffff
#define CFG_IND_WDATA_RD(src)                            (((src) & 0xffffffff))
#define CFG_IND_WDATA_WR(src)                       (((u32)(src)) & 0xffffffff)
#define CFG_IND_WDATA_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register SATA_ENET_CLK_MACRO_REG	*/ 
/*	 Fields o_pll_ready	 */
#define O_PLL_READY_WIDTH                                                     1
#define O_PLL_READY_SHIFT                                                    31
#define O_PLL_READY_MASK                                             0x80000000
#define O_PLL_READY_RD(src)                          (((src) & 0x80000000)>>31)
#define O_PLL_READY_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields o_pll_lock	 */
#define O_PLL_LOCK_WIDTH                                                      1
#define O_PLL_LOCK_SHIFT                                                     30
#define O_PLL_LOCK_MASK                                              0x40000000
#define O_PLL_LOCK_RD(src)                           (((src) & 0x40000000)>>30)
#define O_PLL_LOCK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields i_pll_refdiv	 */
#define I_PLL_REFDIV_WIDTH                                                    2
#define I_PLL_REFDIV_SHIFT                                                   21
#define I_PLL_REFDIV_MASK                                            0x00600000
#define I_PLL_REFDIV_RD(src)                         (((src) & 0x00600000)>>21)
#define I_PLL_REFDIV_WR(src)                    (((u32)(src)<<21) & 0x00600000)
#define I_PLL_REFDIV_SET(dst,src) \
                      (((dst) & ~0x00600000) | (((u32)(src)<<21) & 0x00600000))
/*	 Fields i_pll_fbdiv	 */
#define I_PLL_FBDIV_WIDTH                                                     9
#define I_PLL_FBDIV_SHIFT                                                    12
#define I_PLL_FBDIV_MASK                                             0x001ff000
#define I_PLL_FBDIV_RD(src)                          (((src) & 0x001ff000)>>12)
#define I_PLL_FBDIV_WR(src)                     (((u32)(src)<<12) & 0x001ff000)
#define I_PLL_FBDIV_SET(dst,src) \
                      (((dst) & ~0x001ff000) | (((u32)(src)<<12) & 0x001ff000))
/*	 Fields i_customerOV	 */
#define I_CUSTOMEROV_WIDTH                                                    5
#define I_CUSTOMEROV_SHIFT                                                    7
#define I_CUSTOMEROV_MASK                                            0x00000f80
#define I_CUSTOMEROV_RD(src)                          (((src) & 0x00000f80)>>7)
#define I_CUSTOMEROV_WR(src)                     (((u32)(src)<<7) & 0x00000f80)
#define I_CUSTOMEROV_SET(dst,src) \
                       (((dst) & ~0x00000f80) | (((u32)(src)<<7) & 0x00000f80))
/*	 Fields i_io_ref_sel	 */
#define I_IO_REF_SEL_WIDTH                                                    2
#define I_IO_REF_SEL_SHIFT                                                    5
#define I_IO_REF_SEL_MASK                                            0x00000060
#define I_IO_REF_SEL_RD(src)                          (((src) & 0x00000060)>>5)
#define I_IO_REF_SEL_WR(src)                     (((u32)(src)<<5) & 0x00000060)
#define I_IO_REF_SEL_SET(dst,src) \
                       (((dst) & ~0x00000060) | (((u32)(src)<<5) & 0x00000060))
/*	 Fields i_pll_ref_sel	 */
#define I_PLL_REF_SEL_WIDTH                                                   1
#define I_PLL_REF_SEL_SHIFT                                                   4
#define I_PLL_REF_SEL_MASK                                           0x00000010
#define I_PLL_REF_SEL_RD(src)                         (((src) & 0x00000010)>>4)
#define I_PLL_REF_SEL_WR(src)                    (((u32)(src)<<4) & 0x00000010)
#define I_PLL_REF_SEL_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields i_oe	 */
#define I_OE_WIDTH                                                            2
#define I_OE_SHIFT                                                            2
#define I_OE_MASK                                                    0x0000000c
#define I_OE_RD(src)                                  (((src) & 0x0000000c)>>2)
#define I_OE_WR(src)                             (((u32)(src)<<2) & 0x0000000c)
#define I_OE_SET(dst,src) \
                       (((dst) & ~0x0000000c) | (((u32)(src)<<2) & 0x0000000c))
/*	 Fields i_bypass	 */
#define I_BYPASS_WIDTH                                                        1
#define I_BYPASS_SHIFT                                                        1
#define I_BYPASS_MASK                                                0x00000002
#define I_BYPASS_RD(src)                              (((src) & 0x00000002)>>1)
#define I_BYPASS_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define I_BYPASS_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields i_reset_b	 */
#define I_RESET_B_WIDTH                                                       1
#define I_RESET_B_SHIFT                                                       0
#define I_RESET_B_MASK                                               0x00000001
#define I_RESET_B_RD(src)                                (((src) & 0x00000001))
#define I_RESET_B_WR(src)                           (((u32)(src)) & 0x00000001)
#define I_RESET_B_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_CLKRST_CSR_BASE_ADDR			0x01f21c000ULL

/*    Address ENET_CLKRST_CSR  Registers */
#define ENET_SRST_ADDR                                               0x00000000
#define ENET_SRST_DEFAULT                                            0x0000001f
#define ENET_CLKEN_ADDR                                              0x00000008
#define ENET_CLKEN_DEFAULT                                           0x00000000
#define ENET_DSEN_ADDR                                               0x00000010
#define ENET_DSEN_DEFAULT                                            0x00000000

/*	Register enet_srst	*/ 
/*	 Fields enet_sds_reset	 */
#define ENET_SDS_RESET_WIDTH                                                  1
#define ENET_SDS_RESET_SHIFT                                                  4
#define ENET_SDS_RESET_MASK                                          0x00000010
#define ENET_SDS_RESET_RD(src)                        (((src) & 0x00000010)>>4)
#define ENET_SDS_RESET_WR(src)                   (((u32)(src)<<4) & 0x00000010)
#define ENET_SDS_RESET_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields enet1_reset	 */
#define ENET1_RESET_WIDTH                                                     1
#define ENET1_RESET_SHIFT                                                     3
#define ENET1_RESET_MASK                                             0x00000008
#define ENET1_RESET_RD(src)                           (((src) & 0x00000008)>>3)
#define ENET1_RESET_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define ENET1_RESET_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields csr1_reset	 */
#define CSR1_RESET_WIDTH                                                      1
#define CSR1_RESET_SHIFT                                                      2
#define CSR1_RESET_MASK                                              0x00000004
#define CSR1_RESET_RD(src)                            (((src) & 0x00000004)>>2)
#define CSR1_RESET_WR(src)                       (((u32)(src)<<2) & 0x00000004)
#define CSR1_RESET_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields enet0_reset	 */
#define ENET0_RESET_WIDTH                                                     1
#define ENET0_RESET_SHIFT                                                     1
#define ENET0_RESET_MASK                                             0x00000002
#define ENET0_RESET_RD(src)                           (((src) & 0x00000002)>>1)
#define ENET0_RESET_WR(src)                      (((u32)(src)<<1) & 0x00000002)
#define ENET0_RESET_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields csr0_reset	 */
#define CSR0_RESET_WIDTH                                                      1
#define CSR0_RESET_SHIFT                                                      0
#define CSR0_RESET_MASK                                              0x00000001
#define CSR0_RESET_RD(src)                               (((src) & 0x00000001))
#define CSR0_RESET_WR(src)                          (((u32)(src)) & 0x00000001)
#define CSR0_RESET_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register enet_clken	*/ 
/*	 Fields enet1_clken	 */
#define ENET1_CLKEN_WIDTH                                                     1
#define ENET1_CLKEN_SHIFT                                                     3
#define ENET1_CLKEN_MASK                                             0x00000008
#define ENET1_CLKEN_RD(src)                           (((src) & 0x00000008)>>3)
#define ENET1_CLKEN_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define ENET1_CLKEN_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields csr1_clken	 */
#define CSR1_CLKEN_WIDTH                                                      1
#define CSR1_CLKEN_SHIFT                                                      2
#define CSR1_CLKEN_MASK                                              0x00000004
#define CSR1_CLKEN_RD(src)                            (((src) & 0x00000004)>>2)
#define CSR1_CLKEN_WR(src)                       (((u32)(src)<<2) & 0x00000004)
#define CSR1_CLKEN_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields enet0_clken	 */
#define ENET0_CLKEN_WIDTH                                                     1
#define ENET0_CLKEN_SHIFT                                                     1
#define ENET0_CLKEN_MASK                                             0x00000002
#define ENET0_CLKEN_RD(src)                           (((src) & 0x00000002)>>1)
#define ENET0_CLKEN_WR(src)                      (((u32)(src)<<1) & 0x00000002)
#define ENET0_CLKEN_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields csr0_clken	 */
#define CSR0_CLKEN_WIDTH                                                      1
#define CSR0_CLKEN_SHIFT                                                      0
#define CSR0_CLKEN_MASK                                              0x00000001
#define CSR0_CLKEN_RD(src)                               (((src) & 0x00000001))
#define CSR0_CLKEN_WR(src)                          (((u32)(src)) & 0x00000001)
#define CSR0_CLKEN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register enet_dsen	*/ 
/*	 Fields enet_tx_dsen	 */
#define ENET_TX_DSEN_WIDTH                                                    1
#define ENET_TX_DSEN_SHIFT                                                    1
#define ENET_TX_DSEN_MASK                                            0x00000002
#define ENET_TX_DSEN_RD(src)                          (((src) & 0x00000002)>>1)
#define ENET_TX_DSEN_WR(src)                     (((u32)(src)<<1) & 0x00000002)
#define ENET_TX_DSEN_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields enet_rx_dsen	 */
#define ENET_RX_DSEN_WIDTH                                                    1
#define ENET_RX_DSEN_SHIFT                                                    0
#define ENET_RX_DSEN_MASK                                            0x00000001
#define ENET_RX_DSEN_RD(src)                             (((src) & 0x00000001))
#define ENET_RX_DSEN_WR(src)                        (((u32)(src)) & 0x00000001)
#define ENET_RX_DSEN_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_GLBL_DIAG_CSR_BASE_ADDR			0x01f21d000ULL
#define ENET_GLBL_DIAG_CSR_BASE_ADDR_OFFSET		0xd000

/*    Address GLBL_DIAG_CSR  Registers */
#define ENET_CFG_DIAG_SEL_ADDR                                    0x00000000
#define ENET_CFG_DIAG_SEL_DEFAULT                                 0x00000000
#define ENET_CFG_READ_BW_LAT_ADDR_MASK_ADDR                       0x00000004
#define ENET_CFG_READ_BW_LAT_ADDR_MASK_DEFAULT                    0x00000000
#define ENET_CFG_READ_BW_LAT_ADDR_PAT_ADDR                        0x00000008
#define ENET_CFG_READ_BW_LAT_ADDR_PAT_DEFAULT                     0xffffffff
#define ENET_CFG_WRITE_BW_LAT_ADDR_MASK_ADDR                      0x0000000c
#define ENET_CFG_WRITE_BW_LAT_ADDR_MASK_DEFAULT                   0x00000000
#define ENET_CFG_WRITE_BW_LAT_ADDR_PAT_ADDR                       0x00000010
#define ENET_CFG_WRITE_BW_LAT_ADDR_PAT_DEFAULT                    0xffffffff
#define ENET_CFG_DIAG_START_STOP_ADDR                             0x00000014
#define ENET_CFG_DIAG_START_STOP_DEFAULT                          0x000003ff
#define ENET_CFG_BW_MSTR_STOP_CNT_ADDR                            0x00000018
#define ENET_CFG_BW_MSTR_STOP_CNT_DEFAULT                         0x00040004
#define ENET_CFG_BW_SLV_STOP_CNT_ADDR                             0x0000001c
#define ENET_CFG_BW_SLV_STOP_CNT_DEFAULT                          0x00040004
#define ENET_STS_READ_LATENCY_OUTPUT_ADDR                         0x00000020
#define ENET_STS_READ_LATENCY_OUTPUT_DEFAULT                      0x00000000
#define ENET_STS_AXI_MRD_BW_CLK_CNT_ADDR                          0x00000024
#define ENET_STS_AXI_MRD_BW_CLK_CNT_DEFAULT                       0x00000000
#define ENET_STS_AXI_MRD_BW_BYTE_CNT_ADDR                         0x00000028
#define ENET_STS_AXI_MRD_BW_BYTE_CNT_DEFAULT                      0x00000000
#define ENET_STS_AXI_MWR_BW_CLK_CNT_ADDR                          0x0000002c
#define ENET_STS_AXI_MWR_BW_CLK_CNT_DEFAULT                       0x00000000
#define ENET_STS_AXI_MWR_BW_BYTE_CNT_ADDR                         0x00000030
#define ENET_STS_AXI_MWR_BW_BYTE_CNT_DEFAULT                      0x00000000
#define ENET_STS_AXI_SRD_BW_CLK_CNT_ADDR                          0x00000034
#define ENET_STS_AXI_SRD_BW_CLK_CNT_DEFAULT                       0x00000000
#define ENET_STS_AXI_SRD_BW_BYTE_CNT_ADDR                         0x00000038
#define ENET_STS_AXI_SRD_BW_BYTE_CNT_DEFAULT                      0x00000000
#define ENET_STS_AXI_SWR_BW_CLK_CNT_ADDR                          0x0000003c
#define ENET_STS_AXI_SWR_BW_CLK_CNT_DEFAULT                       0x00000000
#define ENET_STS_AXI_SWR_BW_BYTE_CNT_ADDR                         0x00000040
#define ENET_STS_AXI_SWR_BW_BYTE_CNT_DEFAULT                      0x00000000
#define ENET_CFG_DBG_TRIG_CTRL_ADDR                               0x00000044
#define ENET_CFG_DBG_TRIG_CTRL_DEFAULT                            0x00000000
#define ENET_CFG_DBG_PAT_REG_0_ADDR                               0x00000048
#define ENET_CFG_DBG_PAT_REG_0_DEFAULT                            0x00000000
#define ENET_CFG_DBG_PAT_MASK_REG_0_ADDR                          0x0000004c
#define ENET_CFG_DBG_PAT_MASK_REG_0_DEFAULT                       0x00000000
#define ENET_CFG_DBG_PAT_REG_1_ADDR                               0x00000050
#define ENET_CFG_DBG_PAT_REG_1_DEFAULT                            0x00000000
#define ENET_CFG_DBG_PAT_MASK_REG_1_ADDR                          0x00000054
#define ENET_CFG_DBG_PAT_MASK_REG_1_DEFAULT                       0x00000000
#define ENET_DBG_TRIG_OUT_ADDR                                    0x00000058
#define ENET_DBG_TRIG_OUT_DEFAULT                                 0x00000000
#define ENET_DBG_TRIG_INT_ADDR                                    0x0000005c
#define ENET_DBG_TRIG_INT_DEFAULT                                 0x00000000
#define ENET_DBG_TRIG_INTMASK_ADDR                                0x00000060
#define ENET_INTR_STS_ADDR                                        0x00000064
#define ENET_INTR_STS_DEFAULT                                     0x00000000
#define ENET_CFG_MEM_ECC_BYPASS_ADDR                              0x00000068
#define ENET_CFG_MEM_ECC_BYPASS_DEFAULT                           0x00000000
#define ENET_CFG_MEM_PWRDN_DIS_ADDR                               0x0000006c
#define ENET_CFG_MEM_PWRDN_DIS_DEFAULT                            0x00000000
#define ENET_CFG_MEM_RAM_SHUTDOWN_ADDR                            0x00000070
#define ENET_CFG_MEM_RAM_SHUTDOWN_DEFAULT                         0xffffffff
#define ENET_BLOCK_MEM_RDY_ADDR                                   0x00000074
#define ENET_BLOCK_MEM_RDY_DEFAULT                                0xffffffff
#define ENET_STS_READ_LATENCY_TOT_READ_REQS_ADDR                  0x0000008c
#define ENET_STS_READ_LATENCY_TOT_READ_REQS_DEFAULT               0x00000000
#define ENET_CFG_LT_MSTR_STOP_CNT_ADDR                            0x00000090
#define ENET_CFG_LT_MSTR_STOP_CNT_DEFAULT                         0x00040000
#define ENET_CFG_BW_SRD_TRIG_CAP_ADDR                             0x000000a0
#define ENET_CFG_BW_SRD_TRIG_CAP_DEFAULT                          0x00000000
#define ENET_CFG_BW_SWR_TRIG_CAP_ADDR                             0x000000a4
#define ENET_CFG_BW_SWR_TRIG_CAP_DEFAULT                          0x00000000
#define ENET_CFG_BW_MRD_TRIG_CAP_ADDR                             0x000000a8
#define ENET_CFG_BW_MRD_TRIG_CAP_DEFAULT                          0x00000000
#define ENET_CFG_BW_MWR_TRIG_CAP_ADDR                             0x000000ac
#define ENET_CFG_BW_MWR_TRIG_CAP_DEFAULT                          0x00000000
#define ENET_CFG_LT_MRD_TRIG_CAP_ADDR                             0x000000b0
#define ENET_CFG_LT_MRD_TRIG_CAP_DEFAULT                          0x00000000
#define ENET_DBG_BLOCK_AXI_ADDR                                   0x000000b4
#define ENET_DBG_BLOCK_AXI_DEFAULT                                0x00000000
#define ENET_DBG_BLOCK_NON_AXI_ADDR                               0x000000b8
#define ENET_DBG_BLOCK_NON_AXI_DEFAULT                            0x00000000
#define ENET_DBG_AXI_SHIM_OUT_ADDR                                0x000000bc
#define ENET_DBG_AXI_SHIM_OUT_DEFAULT                             0x00000000

/*	Register CFG_DIAG_SEL	*/ 
/*	 Fields CFG_SHIM_BLK_DBUS_MUX_SELECT	 */
#define ENET_CFG_SHIM_BLK_DBUS_MUX_SELECT_WIDTH                            1
#define ENET_CFG_SHIM_BLK_DBUS_MUX_SELECT_SHIFT                           12
#define ENET_CFG_SHIM_BLK_DBUS_MUX_SELECT_MASK                    0x00001000
#define ENET_CFG_SHIM_BLK_DBUS_MUX_SELECT_RD(src) \
                                                    (((src) & 0x00001000)>>12)
#define ENET_CFG_SHIM_BLK_DBUS_MUX_SELECT_WR(src) \
                                                (((u32)(src)<<12) & 0x00001000)
#define ENET_CFG_SHIM_BLK_DBUS_MUX_SELECT_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields CFG_AXI_NON_AXI_MUX_SELECT	 */
#define ENET_CFG_AXI_NON_AXI_MUX_SELECT_WIDTH                              1
#define ENET_CFG_AXI_NON_AXI_MUX_SELECT_SHIFT                             11
#define ENET_CFG_AXI_NON_AXI_MUX_SELECT_MASK                      0x00000800
#define ENET_CFG_AXI_NON_AXI_MUX_SELECT_RD(src)   (((src) & 0x00000800)>>11)
#define ENET_CFG_AXI_NON_AXI_MUX_SELECT_WR(src) \
                                                (((u32)(src)<<11) & 0x00000800)
#define ENET_CFG_AXI_NON_AXI_MUX_SELECT_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields CFG_MUX_SELECTOR	 */
#define ENET_CFG_MUX_SELECTOR_WIDTH                                       11
#define ENET_CFG_MUX_SELECTOR_SHIFT                                        0
#define ENET_CFG_MUX_SELECTOR_MASK                                0x000007ff
#define ENET_CFG_MUX_SELECTOR_RD(src)                 (((src) & 0x000007ff))
#define ENET_CFG_MUX_SELECTOR_WR(src)            (((u32)(src)) & 0x000007ff)
#define ENET_CFG_MUX_SELECTOR_SET(dst,src) \
                          (((dst) & ~0x000007ff) | (((u32)(src)) & 0x000007ff))

/*	Register CFG_READ_BW_LAT_ADDR_MASK	*/ 
/*	 Fields READ_ADDR_MASK	 */
#define ENET_READ_ADDR_MASK_WIDTH                                         32
#define ENET_READ_ADDR_MASK_SHIFT                                          0
#define ENET_READ_ADDR_MASK_MASK                                  0xffffffff
#define ENET_READ_ADDR_MASK_RD(src)                   (((src) & 0xffffffff))
#define ENET_READ_ADDR_MASK_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_READ_ADDR_MASK_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_READ_BW_LAT_ADDR_PAT	*/ 
/*	 Fields READ_ADDR_PAT	 */
#define ENET_READ_ADDR_PAT_WIDTH                                          32
#define ENET_READ_ADDR_PAT_SHIFT                                           0
#define ENET_READ_ADDR_PAT_MASK                                   0xffffffff
#define ENET_READ_ADDR_PAT_RD(src)                    (((src) & 0xffffffff))
#define ENET_READ_ADDR_PAT_WR(src)               (((u32)(src)) & 0xffffffff)
#define ENET_READ_ADDR_PAT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_WRITE_BW_LAT_ADDR_MASK	*/ 
/*	 Fields WRITE_ADDR_MASK	 */
#define ENET_WRITE_ADDR_MASK_WIDTH                                        32
#define ENET_WRITE_ADDR_MASK_SHIFT                                         0
#define ENET_WRITE_ADDR_MASK_MASK                                 0xffffffff
#define ENET_WRITE_ADDR_MASK_RD(src)                  (((src) & 0xffffffff))
#define ENET_WRITE_ADDR_MASK_WR(src)             (((u32)(src)) & 0xffffffff)
#define ENET_WRITE_ADDR_MASK_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_WRITE_BW_LAT_ADDR_PAT	*/ 
/*	 Fields WRITE_ADDR_PAT	 */
#define ENET_WRITE_ADDR_PAT_WIDTH                                         32
#define ENET_WRITE_ADDR_PAT_SHIFT                                          0
#define ENET_WRITE_ADDR_PAT_MASK                                  0xffffffff
#define ENET_WRITE_ADDR_PAT_RD(src)                   (((src) & 0xffffffff))
#define ENET_WRITE_ADDR_PAT_WR(src)              (((u32)(src)) & 0xffffffff)
#define ENET_WRITE_ADDR_PAT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_DIAG_START_STOP	*/ 
/*	 Fields CTRL_AddCap_MRD_LT	 */
#define ENET_CTRL_ADDCAP_MRD_LT_WIDTH                                      1
#define ENET_CTRL_ADDCAP_MRD_LT_SHIFT                                      9
#define ENET_CTRL_ADDCAP_MRD_LT_MASK                              0x00000200
#define ENET_CTRL_ADDCAP_MRD_LT_RD(src)            (((src) & 0x00000200)>>9)
#define ENET_CTRL_ADDCAP_MRD_LT_WR(src)       (((u32)(src)<<9) & 0x00000200)
#define ENET_CTRL_ADDCAP_MRD_LT_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields CTRL_AddCap_SRD_BW	 */
#define ENET_CTRL_ADDCAP_SRD_BW_WIDTH                                      1
#define ENET_CTRL_ADDCAP_SRD_BW_SHIFT                                      8
#define ENET_CTRL_ADDCAP_SRD_BW_MASK                              0x00000100
#define ENET_CTRL_ADDCAP_SRD_BW_RD(src)            (((src) & 0x00000100)>>8)
#define ENET_CTRL_ADDCAP_SRD_BW_WR(src)       (((u32)(src)<<8) & 0x00000100)
#define ENET_CTRL_ADDCAP_SRD_BW_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields CTRL_AddCap_MRD_BW	 */
#define ENET_CTRL_ADDCAP_MRD_BW_WIDTH                                      1
#define ENET_CTRL_ADDCAP_MRD_BW_SHIFT                                      7
#define ENET_CTRL_ADDCAP_MRD_BW_MASK                              0x00000080
#define ENET_CTRL_ADDCAP_MRD_BW_RD(src)            (((src) & 0x00000080)>>7)
#define ENET_CTRL_ADDCAP_MRD_BW_WR(src)       (((u32)(src)<<7) & 0x00000080)
#define ENET_CTRL_ADDCAP_MRD_BW_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields CTRL_AddCap_SWR_BW	 */
#define ENET_CTRL_ADDCAP_SWR_BW_WIDTH                                      1
#define ENET_CTRL_ADDCAP_SWR_BW_SHIFT                                      6
#define ENET_CTRL_ADDCAP_SWR_BW_MASK                              0x00000040
#define ENET_CTRL_ADDCAP_SWR_BW_RD(src)            (((src) & 0x00000040)>>6)
#define ENET_CTRL_ADDCAP_SWR_BW_WR(src)       (((u32)(src)<<6) & 0x00000040)
#define ENET_CTRL_ADDCAP_SWR_BW_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields CTRL_AddCap_MWR_BW	 */
#define ENET_CTRL_ADDCAP_MWR_BW_WIDTH                                      1
#define ENET_CTRL_ADDCAP_MWR_BW_SHIFT                                      5
#define ENET_CTRL_ADDCAP_MWR_BW_MASK                              0x00000020
#define ENET_CTRL_ADDCAP_MWR_BW_RD(src)            (((src) & 0x00000020)>>5)
#define ENET_CTRL_ADDCAP_MWR_BW_WR(src)       (((u32)(src)<<5) & 0x00000020)
#define ENET_CTRL_ADDCAP_MWR_BW_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields START_MRD_LT	 */
#define ENET_START_MRD_LT_WIDTH                                            1
#define ENET_START_MRD_LT_SHIFT                                            4
#define ENET_START_MRD_LT_MASK                                    0x00000010
#define ENET_START_MRD_LT_RD(src)                  (((src) & 0x00000010)>>4)
#define ENET_START_MRD_LT_WR(src)             (((u32)(src)<<4) & 0x00000010)
#define ENET_START_MRD_LT_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields START_SRD_BW	 */
#define ENET_START_SRD_BW_WIDTH                                            1
#define ENET_START_SRD_BW_SHIFT                                            3
#define ENET_START_SRD_BW_MASK                                    0x00000008
#define ENET_START_SRD_BW_RD(src)                  (((src) & 0x00000008)>>3)
#define ENET_START_SRD_BW_WR(src)             (((u32)(src)<<3) & 0x00000008)
#define ENET_START_SRD_BW_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields START_MRD_BW	 */
#define ENET_START_MRD_BW_WIDTH                                            1
#define ENET_START_MRD_BW_SHIFT                                            2
#define ENET_START_MRD_BW_MASK                                    0x00000004
#define ENET_START_MRD_BW_RD(src)                  (((src) & 0x00000004)>>2)
#define ENET_START_MRD_BW_WR(src)             (((u32)(src)<<2) & 0x00000004)
#define ENET_START_MRD_BW_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields START_SWR_BW	 */
#define ENET_START_SWR_BW_WIDTH                                            1
#define ENET_START_SWR_BW_SHIFT                                            1
#define ENET_START_SWR_BW_MASK                                    0x00000002
#define ENET_START_SWR_BW_RD(src)                  (((src) & 0x00000002)>>1)
#define ENET_START_SWR_BW_WR(src)             (((u32)(src)<<1) & 0x00000002)
#define ENET_START_SWR_BW_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields START_MWR_BW	 */
#define ENET_START_MWR_BW_WIDTH                                            1
#define ENET_START_MWR_BW_SHIFT                                            0
#define ENET_START_MWR_BW_MASK                                    0x00000001
#define ENET_START_MWR_BW_RD(src)                     (((src) & 0x00000001))
#define ENET_START_MWR_BW_WR(src)                (((u32)(src)) & 0x00000001)
#define ENET_START_MWR_BW_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CFG_BW_MSTR_STOP_CNT	*/ 
/*	 Fields MSTR_STOP_RD_CNT	 */
#define ENET_MSTR_STOP_RD_CNT_WIDTH                                       16
#define ENET_MSTR_STOP_RD_CNT_SHIFT                                       16
#define ENET_MSTR_STOP_RD_CNT_MASK                                0xffff0000
#define ENET_MSTR_STOP_RD_CNT_RD(src)             (((src) & 0xffff0000)>>16)
#define ENET_MSTR_STOP_RD_CNT_WR(src)        (((u32)(src)<<16) & 0xffff0000)
#define ENET_MSTR_STOP_RD_CNT_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields MSTR_STOP_WR_CNT	 */
#define ENET_MSTR_STOP_WR_CNT_WIDTH                                       16
#define ENET_MSTR_STOP_WR_CNT_SHIFT                                        0
#define ENET_MSTR_STOP_WR_CNT_MASK                                0x0000ffff
#define ENET_MSTR_STOP_WR_CNT_RD(src)                 (((src) & 0x0000ffff))
#define ENET_MSTR_STOP_WR_CNT_WR(src)            (((u32)(src)) & 0x0000ffff)
#define ENET_MSTR_STOP_WR_CNT_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CFG_BW_SLV_STOP_CNT	*/ 
/*	 Fields SLV_STOP_RD_CNT	 */
#define ENET_SLV_STOP_RD_CNT_WIDTH                                        16
#define ENET_SLV_STOP_RD_CNT_SHIFT                                        16
#define ENET_SLV_STOP_RD_CNT_MASK                                 0xffff0000
#define ENET_SLV_STOP_RD_CNT_RD(src)              (((src) & 0xffff0000)>>16)
#define ENET_SLV_STOP_RD_CNT_WR(src)         (((u32)(src)<<16) & 0xffff0000)
#define ENET_SLV_STOP_RD_CNT_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields SLV_STOP_WR_CNT	 */
#define ENET_SLV_STOP_WR_CNT_WIDTH                                        16
#define ENET_SLV_STOP_WR_CNT_SHIFT                                         0
#define ENET_SLV_STOP_WR_CNT_MASK                                 0x0000ffff
#define ENET_SLV_STOP_WR_CNT_RD(src)                  (((src) & 0x0000ffff))
#define ENET_SLV_STOP_WR_CNT_WR(src)             (((u32)(src)) & 0x0000ffff)
#define ENET_SLV_STOP_WR_CNT_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register STS_READ_LATENCY_OUTPUT	*/ 
/*	 Fields READ_TOT	 */
#define ENET_READ_TOT_WIDTH                                               22
#define ENET_READ_TOT_SHIFT                                                0
#define ENET_READ_TOT_MASK                                        0x003fffff
#define ENET_READ_TOT_RD(src)                         (((src) & 0x003fffff))
#define ENET_READ_TOT_SET(dst,src) \
                          (((dst) & ~0x003fffff) | (((u32)(src)) & 0x003fffff))

/*	Register STS_AXI_MRD_BW_CLK_CNT	*/ 
/*	 Fields MSTR_READ_BW_CLK_CNT	 */
#define ENET_MSTR_READ_BW_CLK_CNT_WIDTH                                   32
#define ENET_MSTR_READ_BW_CLK_CNT_SHIFT                                    0
#define ENET_MSTR_READ_BW_CLK_CNT_MASK                            0xffffffff
#define ENET_MSTR_READ_BW_CLK_CNT_RD(src)             (((src) & 0xffffffff))
#define ENET_MSTR_READ_BW_CLK_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_MRD_BW_BYTE_CNT	*/ 
/*	 Fields MSTR_READ_BW_BYTE_CNT	 */
#define ENET_MSTR_READ_BW_BYTE_CNT_WIDTH                                  32
#define ENET_MSTR_READ_BW_BYTE_CNT_SHIFT                                   0
#define ENET_MSTR_READ_BW_BYTE_CNT_MASK                           0xffffffff
#define ENET_MSTR_READ_BW_BYTE_CNT_RD(src)            (((src) & 0xffffffff))
#define ENET_MSTR_READ_BW_BYTE_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_MWR_BW_CLK_CNT	*/ 
/*	 Fields MSTR_WRITE_BW_CLK_CNT	 */
#define ENET_MSTR_WRITE_BW_CLK_CNT_WIDTH                                  32
#define ENET_MSTR_WRITE_BW_CLK_CNT_SHIFT                                   0
#define ENET_MSTR_WRITE_BW_CLK_CNT_MASK                           0xffffffff
#define ENET_MSTR_WRITE_BW_CLK_CNT_RD(src)            (((src) & 0xffffffff))
#define ENET_MSTR_WRITE_BW_CLK_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_MWR_BW_BYTE_CNT	*/ 
/*	 Fields MSTR_WRITE_BW_BYTE_CNT	 */
#define ENET_MSTR_WRITE_BW_BYTE_CNT_WIDTH                                 32
#define ENET_MSTR_WRITE_BW_BYTE_CNT_SHIFT                                  0
#define ENET_MSTR_WRITE_BW_BYTE_CNT_MASK                          0xffffffff
#define ENET_MSTR_WRITE_BW_BYTE_CNT_RD(src)           (((src) & 0xffffffff))
#define ENET_MSTR_WRITE_BW_BYTE_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_SRD_BW_CLK_CNT	*/ 
/*	 Fields SLV_READ_BW_CLK_CNT	 */
#define ENET_SLV_READ_BW_CLK_CNT_WIDTH                                    32
#define ENET_SLV_READ_BW_CLK_CNT_SHIFT                                     0
#define ENET_SLV_READ_BW_CLK_CNT_MASK                             0xffffffff
#define ENET_SLV_READ_BW_CLK_CNT_RD(src)              (((src) & 0xffffffff))
#define ENET_SLV_READ_BW_CLK_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_SRD_BW_BYTE_CNT	*/ 
/*	 Fields SLV_READ_BW_BYTE_CNT	 */
#define ENET_SLV_READ_BW_BYTE_CNT_WIDTH                                   32
#define ENET_SLV_READ_BW_BYTE_CNT_SHIFT                                    0
#define ENET_SLV_READ_BW_BYTE_CNT_MASK                            0xffffffff
#define ENET_SLV_READ_BW_BYTE_CNT_RD(src)             (((src) & 0xffffffff))
#define ENET_SLV_READ_BW_BYTE_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_SWR_BW_CLK_CNT	*/ 
/*	 Fields SLV_WRITE_BW_CLK_CNT	 */
#define ENET_SLV_WRITE_BW_CLK_CNT_WIDTH                                   32
#define ENET_SLV_WRITE_BW_CLK_CNT_SHIFT                                    0
#define ENET_SLV_WRITE_BW_CLK_CNT_MASK                            0xffffffff
#define ENET_SLV_WRITE_BW_CLK_CNT_RD(src)             (((src) & 0xffffffff))
#define ENET_SLV_WRITE_BW_CLK_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_AXI_SWR_BW_BYTE_CNT	*/ 
/*	 Fields SLV_WRITE_BW_BYTE_CNT	 */
#define ENET_SLV_WRITE_BW_BYTE_CNT_WIDTH                                  32
#define ENET_SLV_WRITE_BW_BYTE_CNT_SHIFT                                   0
#define ENET_SLV_WRITE_BW_BYTE_CNT_MASK                           0xffffffff
#define ENET_SLV_WRITE_BW_BYTE_CNT_RD(src)            (((src) & 0xffffffff))
#define ENET_SLV_WRITE_BW_BYTE_CNT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_DBG_TRIG_CTRL	*/ 
/*	 Fields TRIG_EN_OUT_CTRL	 */
#define ENET_TRIG_EN_OUT_CTRL_WIDTH                                        1
#define ENET_TRIG_EN_OUT_CTRL_SHIFT                                        5
#define ENET_TRIG_EN_OUT_CTRL_MASK                                0x00000020
#define ENET_TRIG_EN_OUT_CTRL_RD(src)              (((src) & 0x00000020)>>5)
#define ENET_TRIG_EN_OUT_CTRL_WR(src)         (((u32)(src)<<5) & 0x00000020)
#define ENET_TRIG_EN_OUT_CTRL_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields TRIG_EN	 */
#define ENET_TRIG_EN_WIDTH                                                 1
#define ENET_TRIG_EN_SHIFT                                                 4
#define ENET_TRIG_EN_MASK                                         0x00000010
#define ENET_TRIG_EN_RD(src)                       (((src) & 0x00000010)>>4)
#define ENET_TRIG_EN_WR(src)                  (((u32)(src)<<4) & 0x00000010)
#define ENET_TRIG_EN_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields AND_E	 */
#define ENET_AND_E_WIDTH                                                   2
#define ENET_AND_E_SHIFT                                                   2
#define ENET_AND_E_MASK                                           0x0000000c
#define ENET_AND_E_RD(src)                         (((src) & 0x0000000c)>>2)
#define ENET_AND_E_WR(src)                    (((u32)(src)<<2) & 0x0000000c)
#define ENET_AND_E_SET(dst,src) \
                       (((dst) & ~0x0000000c) | (((u32)(src)<<2) & 0x0000000c))
/*	 Fields OR_E	 */
#define ENET_OR_E_WIDTH                                                    2
#define ENET_OR_E_SHIFT                                                    0
#define ENET_OR_E_MASK                                            0x00000003
#define ENET_OR_E_RD(src)                             (((src) & 0x00000003))
#define ENET_OR_E_WR(src)                        (((u32)(src)) & 0x00000003)
#define ENET_OR_E_SET(dst,src) \
                          (((dst) & ~0x00000003) | (((u32)(src)) & 0x00000003))

/*	Register CFG_DBG_PAT_REG_0	*/ 
/*	 Fields PATTERN	 */
#define ENET_PATTERN0_WIDTH                                               32
#define ENET_PATTERN0_SHIFT                                                0
#define ENET_PATTERN0_MASK                                        0xffffffff
#define ENET_PATTERN0_RD(src)                         (((src) & 0xffffffff))
#define ENET_PATTERN0_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_PATTERN0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_DBG_PAT_MASK_REG_0	*/ 
/*	 Fields PAT_MASK	 */
#define ENET_PAT_MASK0_WIDTH                                              32
#define ENET_PAT_MASK0_SHIFT                                               0
#define ENET_PAT_MASK0_MASK                                       0xffffffff
#define ENET_PAT_MASK0_RD(src)                        (((src) & 0xffffffff))
#define ENET_PAT_MASK0_WR(src)                   (((u32)(src)) & 0xffffffff)
#define ENET_PAT_MASK0_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_DBG_PAT_REG_1	*/ 
/*	 Fields PATTERN	 */
#define ENET_PATTERN1_WIDTH                                               32
#define ENET_PATTERN1_SHIFT                                                0
#define ENET_PATTERN1_MASK                                        0xffffffff
#define ENET_PATTERN1_RD(src)                         (((src) & 0xffffffff))
#define ENET_PATTERN1_WR(src)                    (((u32)(src)) & 0xffffffff)
#define ENET_PATTERN1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_DBG_PAT_MASK_REG_1	*/ 
/*	 Fields PAT_MASK	 */
#define ENET_PAT_MASK1_WIDTH                                              32
#define ENET_PAT_MASK1_SHIFT                                               0
#define ENET_PAT_MASK1_MASK                                       0xffffffff
#define ENET_PAT_MASK1_RD(src)                        (((src) & 0xffffffff))
#define ENET_PAT_MASK1_WR(src)                   (((u32)(src)) & 0xffffffff)
#define ENET_PAT_MASK1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register DBG_TRIG_OUT	*/ 
/*	 Fields DBG_OUT	 */
#define ENET_DBG_OUT_WIDTH                                                32
#define ENET_DBG_OUT_SHIFT                                                 0
#define ENET_DBG_OUT_MASK                                         0xffffffff
#define ENET_DBG_OUT_RD(src)                          (((src) & 0xffffffff))
#define ENET_DBG_OUT_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register DBG_TRIG_INT	*/ 
/*	 Fields DBG_INT	 */
#define ENET_DBG_INT_WIDTH                                                 1
#define ENET_DBG_INT_SHIFT                                                 0
#define ENET_DBG_INT_MASK                                         0x00000001
#define ENET_DBG_INT_RD(src)                          (((src) & 0x00000001))
#define ENET_DBG_INT_WR(src)                     (((u32)(src)) & 0x00000001)
#define ENET_DBG_INT_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register DBG_TRIG_INTMask	*/
/*    Mask Register Fields DBG_INTMask    */
#define ENET_DBG_INTMASK_WIDTH                                             1
#define ENET_DBG_INTMASK_SHIFT                                             0
#define ENET_DBG_INTMASK_MASK                                     0x00000001
#define ENET_DBG_INTMASK_RD(src)                      (((src) & 0x00000001))
#define ENET_DBG_INTMASK_WR(src)                 (((u32)(src)) & 0x00000001)
#define ENET_DBG_INTMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register INTR_STS	*/ 
/*	 Fields DIAGMOD_INT	 */
#define ENET_DIAGMOD_INT_WIDTH                                             1
#define ENET_DIAGMOD_INT_SHIFT                                             1
#define ENET_DIAGMOD_INT_MASK                                     0x00000002
#define ENET_DIAGMOD_INT_RD(src)                   (((src) & 0x00000002)>>1)
#define ENET_DIAGMOD_INT_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields ERRMOD_INT	 */
#define ENET_ERRMOD_INT_WIDTH                                              1
#define ENET_ERRMOD_INT_SHIFT                                              0
#define ENET_ERRMOD_INT_MASK                                      0x00000001
#define ENET_ERRMOD_INT_RD(src)                       (((src) & 0x00000001))
#define ENET_ERRMOD_INT_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CFG_MEM_ECC_BYPASS	*/ 
/*	 Fields CFG_ECC_BYPASS	 */
#define ENET_CFG_ECC_BYPASS_WIDTH                                         16
#define ENET_CFG_ECC_BYPASS_SHIFT                                          0
#define ENET_CFG_ECC_BYPASS_MASK                                  0x0000ffff
#define ENET_CFG_ECC_BYPASS_RD(src)                   (((src) & 0x0000ffff))
#define ENET_CFG_ECC_BYPASS_WR(src)              (((u32)(src)) & 0x0000ffff)
#define ENET_CFG_ECC_BYPASS_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CFG_MEM_PWRDN_DIS	*/ 
/*	 Fields CFG_ECC_PWRDN_DIS	 */
#define ENET_CFG_ECC_PWRDN_DIS_WIDTH                                      16
#define ENET_CFG_ECC_PWRDN_DIS_SHIFT                                      16
#define ENET_CFG_ECC_PWRDN_DIS_MASK                               0xffff0000
#define ENET_CFG_ECC_PWRDN_DIS_RD(src)            (((src) & 0xffff0000)>>16)
#define ENET_CFG_ECC_PWRDN_DIS_WR(src)       (((u32)(src)<<16) & 0xffff0000)
#define ENET_CFG_ECC_PWRDN_DIS_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))
/*	 Fields CFG_PWRDN_DIS	 */
#define ENET_CFG_PWRDN_DIS_WIDTH                                          16
#define ENET_CFG_PWRDN_DIS_SHIFT                                           0
#define ENET_CFG_PWRDN_DIS_MASK                                   0x0000ffff
#define ENET_CFG_PWRDN_DIS_RD(src)                    (((src) & 0x0000ffff))
#define ENET_CFG_PWRDN_DIS_WR(src)               (((u32)(src)) & 0x0000ffff)
#define ENET_CFG_PWRDN_DIS_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CFG_MEM_RAM_SHUTDOWN	*/ 
/*	 Fields CFG_RAM_SHUTDOWN_EN	 */
#define ENET_CFG_RAM_SHUTDOWN_EN_WIDTH                                    32
#define ENET_CFG_RAM_SHUTDOWN_EN_SHIFT                                     0
#define ENET_CFG_RAM_SHUTDOWN_EN_MASK                             0xffffffff
#define ENET_CFG_RAM_SHUTDOWN_EN_RD(src)              (((src) & 0xffffffff))
#define ENET_CFG_RAM_SHUTDOWN_EN_WR(src)         (((u32)(src)) & 0xffffffff)
#define ENET_CFG_RAM_SHUTDOWN_EN_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register BLOCK_MEM_RDY	*/ 
/*	 Fields MEM_RDY	 */
#define ENET_MEM_RDY_WIDTH                                                32
#define ENET_MEM_RDY_SHIFT                                                 0
#define ENET_MEM_RDY_MASK                                         0xffffffff
#define ENET_MEM_RDY_RD(src)                          (((src) & 0xffffffff))
#define ENET_MEM_RDY_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register STS_READ_LATENCY_TOT_READ_REQS	*/ 
/*	 Fields TOT_READS	 */
#define ENET_TOT_READS_WIDTH                                              16
#define ENET_TOT_READS_SHIFT                                              16
#define ENET_TOT_READS_MASK                                       0xffff0000
#define ENET_TOT_READS_RD(src)                    (((src) & 0xffff0000)>>16)
#define ENET_TOT_READS_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))

/*	Register CFG_LT_MSTR_STOP_CNT	*/ 
/*	 Fields MSTR_LT_STOP_CNT	 */
#define ENET_MSTR_LT_STOP_CNT_WIDTH                                       16
#define ENET_MSTR_LT_STOP_CNT_SHIFT                                       16
#define ENET_MSTR_LT_STOP_CNT_MASK                                0xffff0000
#define ENET_MSTR_LT_STOP_CNT_RD(src)             (((src) & 0xffff0000)>>16)
#define ENET_MSTR_LT_STOP_CNT_WR(src)        (((u32)(src)<<16) & 0xffff0000)
#define ENET_MSTR_LT_STOP_CNT_SET(dst,src) \
                      (((dst) & ~0xffff0000) | (((u32)(src)<<16) & 0xffff0000))

/*	Register CFG_BW_SRD_TRIG_CAP	*/ 
/*	 Fields CAP_ADD_BWSRD	 */
#define ENET_CAP_ADD_BWSRD_WIDTH                                          32
#define ENET_CAP_ADD_BWSRD_SHIFT                                           0
#define ENET_CAP_ADD_BWSRD_MASK                                   0xffffffff
#define ENET_CAP_ADD_BWSRD_RD(src)                    (((src) & 0xffffffff))
#define ENET_CAP_ADD_BWSRD_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_BW_SWR_TRIG_CAP	*/ 
/*	 Fields CAP_ADD_BWSWR	 */
#define ENET_CAP_ADD_BWSWR_WIDTH                                          32
#define ENET_CAP_ADD_BWSWR_SHIFT                                           0
#define ENET_CAP_ADD_BWSWR_MASK                                   0xffffffff
#define ENET_CAP_ADD_BWSWR_RD(src)                    (((src) & 0xffffffff))
#define ENET_CAP_ADD_BWSWR_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_BW_MRD_TRIG_CAP	*/ 
/*	 Fields CAP_ADD_BWMRD	 */
#define ENET_CAP_ADD_BWMRD_WIDTH                                          32
#define ENET_CAP_ADD_BWMRD_SHIFT                                           0
#define ENET_CAP_ADD_BWMRD_MASK                                   0xffffffff
#define ENET_CAP_ADD_BWMRD_RD(src)                    (((src) & 0xffffffff))
#define ENET_CAP_ADD_BWMRD_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_BW_MWR_TRIG_CAP	*/ 
/*	 Fields CAP_ADD_BWMWR	 */
#define ENET_CAP_ADD_BWMWR_WIDTH                                          32
#define ENET_CAP_ADD_BWMWR_SHIFT                                           0
#define ENET_CAP_ADD_BWMWR_MASK                                   0xffffffff
#define ENET_CAP_ADD_BWMWR_RD(src)                    (((src) & 0xffffffff))
#define ENET_CAP_ADD_BWMWR_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register CFG_LT_MRD_TRIG_CAP	*/ 
/*	 Fields CAP_ADD_LTMRD	 */
#define ENET_CAP_ADD_LTMRD_WIDTH                                          32
#define ENET_CAP_ADD_LTMRD_SHIFT                                           0
#define ENET_CAP_ADD_LTMRD_MASK                                   0xffffffff
#define ENET_CAP_ADD_LTMRD_RD(src)                    (((src) & 0xffffffff))
#define ENET_CAP_ADD_LTMRD_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register DBG_BLOCK_AXI	*/ 
/*	 Fields DBG_BUS_BLOCK_AXI	 */
#define ENET_DBG_BUS_BLOCK_AXI_WIDTH                                      32
#define ENET_DBG_BUS_BLOCK_AXI_SHIFT                                       0
#define ENET_DBG_BUS_BLOCK_AXI_MASK                               0xffffffff
#define ENET_DBG_BUS_BLOCK_AXI_RD(src)                (((src) & 0xffffffff))
#define ENET_DBG_BUS_BLOCK_AXI_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register DBG_BLOCK_NON_AXI	*/ 
/*	 Fields DBG_BUS_BLOCK_NON_AXI	 */
#define ENET_DBG_BUS_BLOCK_NON_AXI_WIDTH                                  32
#define ENET_DBG_BUS_BLOCK_NON_AXI_SHIFT                                   0
#define ENET_DBG_BUS_BLOCK_NON_AXI_MASK                           0xffffffff
#define ENET_DBG_BUS_BLOCK_NON_AXI_RD(src)            (((src) & 0xffffffff))
#define ENET_DBG_BUS_BLOCK_NON_AXI_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register DBG_AXI_SHIM_OUT	*/ 
/*	 Fields DBG_BUS_SHIM	 */
#define ENET_DBG_BUS_SHIM_WIDTH                                           32
#define ENET_DBG_BUS_SHIM_SHIFT                                            0
#define ENET_DBG_BUS_SHIM_MASK                                    0xffffffff
#define ENET_DBG_BUS_SHIM_RD(src)                     (((src) & 0xffffffff))
#define ENET_DBG_BUS_SHIM_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Global Base Address	*/
#define ENET_GLBL_ERR_CSR_BASE_ADDR			0x01f21d000ULL

/*    Address GLBL_ERR_CSR  Registers */
#define GLBL_ERR_STS_ADDR                                            0x00000800
#define GLBL_ERR_STS_DEFAULT                                         0x00000000
#define GLBL_SEC_ERRL_ADDR                                           0x00000810
#define GLBL_SEC_ERRL_DEFAULT                                        0x00000000
#define GLBL_SEC_ERRLMASK_ADDR                                       0x00000814
#define GLBL_SEC_ERRH_ADDR                                           0x00000818
#define GLBL_SEC_ERRH_DEFAULT                                        0x00000000
#define GLBL_SEC_ERRHMASK_ADDR                                       0x0000081c
#define GLBL_MSEC_ERRL_ADDR                                          0x00000820
#define GLBL_MSEC_ERRL_DEFAULT                                       0x00000000
#define GLBL_MSEC_ERRLMASK_ADDR                                      0x00000824
#define GLBL_MSEC_ERRH_ADDR                                          0x00000828
#define GLBL_MSEC_ERRH_DEFAULT                                       0x00000000
#define GLBL_MSEC_ERRHMASK_ADDR                                      0x0000082c
#define GLBL_DED_ERRL_ADDR                                           0x00000830
#define GLBL_DED_ERRL_DEFAULT                                        0x00000000
#define GLBL_DED_ERRLMASK_ADDR                                       0x00000834
#define GLBL_DED_ERRH_ADDR                                           0x00000838
#define GLBL_DED_ERRH_DEFAULT                                        0x00000000
#define GLBL_DED_ERRHMASK_ADDR                                       0x0000083c
#define GLBL_MDED_ERRL_ADDR                                          0x00000840
#define GLBL_MDED_ERRL_DEFAULT                                       0x00000000
#define GLBL_MDED_ERRLMASK_ADDR                                      0x00000844
#define GLBL_MDED_ERRH_ADDR                                          0x00000848
#define GLBL_MDED_ERRH_DEFAULT                                       0x00000000
#define GLBL_MDED_ERRHMASK_ADDR                                      0x0000084c
#define GLBL_MERR_ADDR_ADDR                                          0x00000850
#define GLBL_MERR_ADDR_DEFAULT                                       0x00000000
#define GLBL_MERR_REQINFO_ADDR                                       0x00000854
#define GLBL_MERR_REQINFO_DEFAULT                                    0x00000000
#define GLBL_TRANS_ERR_ADDR                                          0x00000860
#define GLBL_TRANS_ERR_DEFAULT                                       0x00000000
#define GLBL_TRANS_ERRMASK_ADDR                                      0x00000864
#define GLBL_WDERR_ADDR_ADDR                                         0x00000870
#define GLBL_WDERR_ADDR_DEFAULT                                      0x00000000
#define GLBL_WDERR_REQINFO_ADDR                                      0x00000874
#define GLBL_WDERR_REQINFO_DEFAULT                                   0x00000000
#define GLBL_DEVERR_ADDR_ADDR                                        0x00000878
#define GLBL_DEVERR_ADDR_DEFAULT                                     0x00000000
#define GLBL_DEVERR_REQINFO_ADDR                                     0x0000087c
#define GLBL_DEVERR_REQINFO_DEFAULT                                  0x00000000
#define GLBL_SEC_ERRL_ALS_ADDR                                       0x00000880
#define GLBL_SEC_ERRL_ALS_DEFAULT                                    0x00000000
#define GLBL_SEC_ERRH_ALS_ADDR                                       0x00000884
#define GLBL_SEC_ERRH_ALS_DEFAULT                                    0x00000000
#define GLBL_DED_ERRL_ALS_ADDR                                       0x00000888
#define GLBL_DED_ERRL_ALS_DEFAULT                                    0x00000000
#define GLBL_DED_ERRH_ALS_ADDR                                       0x0000088c
#define GLBL_DED_ERRH_ALS_DEFAULT                                    0x00000000
#define GLBL_TRANS_ERR_ALS_ADDR                                      0x00000890
#define GLBL_TRANS_ERR_ALS_DEFAULT                                   0x00000000

/*	Register GLBL_ERR_STS	*/ 
/*	 Fields SHIM_ERR	 */
#define SHIM_ERR_WIDTH                                                        1
#define SHIM_ERR_SHIFT                                                        5
#define SHIM_ERR_MASK                                                0x00000020
#define SHIM_ERR_RD(src)                              (((src) & 0x00000020)>>5)
#define SHIM_ERR_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields TRANS_ERR	 */
#define TRANS_ERR_WIDTH                                                       1
#define TRANS_ERR_SHIFT                                                       4
#define TRANS_ERR_MASK                                               0x00000010
#define TRANS_ERR_RD(src)                             (((src) & 0x00000010)>>4)
#define TRANS_ERR_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields MDED_ERR	 */
#define MDED_ERR_WIDTH                                                        1
#define MDED_ERR_SHIFT                                                        3
#define MDED_ERR_MASK                                                0x00000008
#define MDED_ERR_RD(src)                              (((src) & 0x00000008)>>3)
#define MDED_ERR_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields DED_ERR	 */
#define DED_ERR_WIDTH                                                         1
#define DED_ERR_SHIFT                                                         2
#define DED_ERR_MASK                                                 0x00000004
#define DED_ERR_RD(src)                               (((src) & 0x00000004)>>2)
#define DED_ERR_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields MSEC_ERR	 */
#define MSEC_ERR_WIDTH                                                        1
#define MSEC_ERR_SHIFT                                                        1
#define MSEC_ERR_MASK                                                0x00000002
#define MSEC_ERR_RD(src)                              (((src) & 0x00000002)>>1)
#define MSEC_ERR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields SEC_ERR	 */
#define SEC_ERR_WIDTH                                                         1
#define SEC_ERR_SHIFT                                                         0
#define SEC_ERR_MASK                                                 0x00000001
#define SEC_ERR_RD(src)                                  (((src) & 0x00000001))
#define SEC_ERR_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_SEC_ERRL	*/ 
/*	 Fields SEC31	 */
#define SEC31_WIDTH                                                           1
#define SEC31_SHIFT                                                          31
#define SEC31_MASK                                                   0x80000000
#define SEC31_RD(src)                                (((src) & 0x80000000)>>31)
#define SEC31_WR(src)                           (((u32)(src)<<31) & 0x80000000)
#define SEC31_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields SEC30	 */
#define SEC30_WIDTH                                                           1
#define SEC30_SHIFT                                                          30
#define SEC30_MASK                                                   0x40000000
#define SEC30_RD(src)                                (((src) & 0x40000000)>>30)
#define SEC30_WR(src)                           (((u32)(src)<<30) & 0x40000000)
#define SEC30_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields SEC29	 */
#define SEC29_WIDTH                                                           1
#define SEC29_SHIFT                                                          29
#define SEC29_MASK                                                   0x20000000
#define SEC29_RD(src)                                (((src) & 0x20000000)>>29)
#define SEC29_WR(src)                           (((u32)(src)<<29) & 0x20000000)
#define SEC29_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields SEC28	 */
#define SEC28_WIDTH                                                           1
#define SEC28_SHIFT                                                          28
#define SEC28_MASK                                                   0x10000000
#define SEC28_RD(src)                                (((src) & 0x10000000)>>28)
#define SEC28_WR(src)                           (((u32)(src)<<28) & 0x10000000)
#define SEC28_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields SEC27	 */
#define SEC27_WIDTH                                                           1
#define SEC27_SHIFT                                                          27
#define SEC27_MASK                                                   0x08000000
#define SEC27_RD(src)                                (((src) & 0x08000000)>>27)
#define SEC27_WR(src)                           (((u32)(src)<<27) & 0x08000000)
#define SEC27_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields SEC26	 */
#define SEC26_WIDTH                                                           1
#define SEC26_SHIFT                                                          26
#define SEC26_MASK                                                   0x04000000
#define SEC26_RD(src)                                (((src) & 0x04000000)>>26)
#define SEC26_WR(src)                           (((u32)(src)<<26) & 0x04000000)
#define SEC26_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields SEC25	 */
#define SEC25_WIDTH                                                           1
#define SEC25_SHIFT                                                          25
#define SEC25_MASK                                                   0x02000000
#define SEC25_RD(src)                                (((src) & 0x02000000)>>25)
#define SEC25_WR(src)                           (((u32)(src)<<25) & 0x02000000)
#define SEC25_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields SEC24	 */
#define SEC24_WIDTH                                                           1
#define SEC24_SHIFT                                                          24
#define SEC24_MASK                                                   0x01000000
#define SEC24_RD(src)                                (((src) & 0x01000000)>>24)
#define SEC24_WR(src)                           (((u32)(src)<<24) & 0x01000000)
#define SEC24_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields SEC23	 */
#define SEC23_WIDTH                                                           1
#define SEC23_SHIFT                                                          23
#define SEC23_MASK                                                   0x00800000
#define SEC23_RD(src)                                (((src) & 0x00800000)>>23)
#define SEC23_WR(src)                           (((u32)(src)<<23) & 0x00800000)
#define SEC23_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields SEC22	 */
#define SEC22_WIDTH                                                           1
#define SEC22_SHIFT                                                          22
#define SEC22_MASK                                                   0x00400000
#define SEC22_RD(src)                                (((src) & 0x00400000)>>22)
#define SEC22_WR(src)                           (((u32)(src)<<22) & 0x00400000)
#define SEC22_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields SEC21	 */
#define SEC21_WIDTH                                                           1
#define SEC21_SHIFT                                                          21
#define SEC21_MASK                                                   0x00200000
#define SEC21_RD(src)                                (((src) & 0x00200000)>>21)
#define SEC21_WR(src)                           (((u32)(src)<<21) & 0x00200000)
#define SEC21_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields SEC20	 */
#define SEC20_WIDTH                                                           1
#define SEC20_SHIFT                                                          20
#define SEC20_MASK                                                   0x00100000
#define SEC20_RD(src)                                (((src) & 0x00100000)>>20)
#define SEC20_WR(src)                           (((u32)(src)<<20) & 0x00100000)
#define SEC20_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields SEC19	 */
#define SEC19_WIDTH                                                           1
#define SEC19_SHIFT                                                          19
#define SEC19_MASK                                                   0x00080000
#define SEC19_RD(src)                                (((src) & 0x00080000)>>19)
#define SEC19_WR(src)                           (((u32)(src)<<19) & 0x00080000)
#define SEC19_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields SEC18	 */
#define SEC18_WIDTH                                                           1
#define SEC18_SHIFT                                                          18
#define SEC18_MASK                                                   0x00040000
#define SEC18_RD(src)                                (((src) & 0x00040000)>>18)
#define SEC18_WR(src)                           (((u32)(src)<<18) & 0x00040000)
#define SEC18_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields SEC17	 */
#define SEC17_WIDTH                                                           1
#define SEC17_SHIFT                                                          17
#define SEC17_MASK                                                   0x00020000
#define SEC17_RD(src)                                (((src) & 0x00020000)>>17)
#define SEC17_WR(src)                           (((u32)(src)<<17) & 0x00020000)
#define SEC17_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields SEC16	 */
#define SEC16_WIDTH                                                           1
#define SEC16_SHIFT                                                          16
#define SEC16_MASK                                                   0x00010000
#define SEC16_RD(src)                                (((src) & 0x00010000)>>16)
#define SEC16_WR(src)                           (((u32)(src)<<16) & 0x00010000)
#define SEC16_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields SEC15	 */
#define SEC15_WIDTH                                                           1
#define SEC15_SHIFT                                                          15
#define SEC15_MASK                                                   0x00008000
#define SEC15_RD(src)                                (((src) & 0x00008000)>>15)
#define SEC15_WR(src)                           (((u32)(src)<<15) & 0x00008000)
#define SEC15_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields SEC14	 */
#define SEC14_WIDTH                                                           1
#define SEC14_SHIFT                                                          14
#define SEC14_MASK                                                   0x00004000
#define SEC14_RD(src)                                (((src) & 0x00004000)>>14)
#define SEC14_WR(src)                           (((u32)(src)<<14) & 0x00004000)
#define SEC14_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields SEC13	 */
#define SEC13_WIDTH                                                           1
#define SEC13_SHIFT                                                          13
#define SEC13_MASK                                                   0x00002000
#define SEC13_RD(src)                                (((src) & 0x00002000)>>13)
#define SEC13_WR(src)                           (((u32)(src)<<13) & 0x00002000)
#define SEC13_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields SEC12	 */
#define SEC12_WIDTH                                                           1
#define SEC12_SHIFT                                                          12
#define SEC12_MASK                                                   0x00001000
#define SEC12_RD(src)                                (((src) & 0x00001000)>>12)
#define SEC12_WR(src)                           (((u32)(src)<<12) & 0x00001000)
#define SEC12_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields SEC11	 */
#define SEC11_WIDTH                                                           1
#define SEC11_SHIFT                                                          11
#define SEC11_MASK                                                   0x00000800
#define SEC11_RD(src)                                (((src) & 0x00000800)>>11)
#define SEC11_WR(src)                           (((u32)(src)<<11) & 0x00000800)
#define SEC11_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields SEC10	 */
#define SEC10_WIDTH                                                           1
#define SEC10_SHIFT                                                          10
#define SEC10_MASK                                                   0x00000400
#define SEC10_RD(src)                                (((src) & 0x00000400)>>10)
#define SEC10_WR(src)                           (((u32)(src)<<10) & 0x00000400)
#define SEC10_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields SEC9	 */
#define SEC9_WIDTH                                                            1
#define SEC9_SHIFT                                                            9
#define SEC9_MASK                                                    0x00000200
#define SEC9_RD(src)                                  (((src) & 0x00000200)>>9)
#define SEC9_WR(src)                             (((u32)(src)<<9) & 0x00000200)
#define SEC9_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields SEC8	 */
#define SEC8_WIDTH                                                            1
#define SEC8_SHIFT                                                            8
#define SEC8_MASK                                                    0x00000100
#define SEC8_RD(src)                                  (((src) & 0x00000100)>>8)
#define SEC8_WR(src)                             (((u32)(src)<<8) & 0x00000100)
#define SEC8_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields SEC7	 */
#define SEC7_WIDTH                                                            1
#define SEC7_SHIFT                                                            7
#define SEC7_MASK                                                    0x00000080
#define SEC7_RD(src)                                  (((src) & 0x00000080)>>7)
#define SEC7_WR(src)                             (((u32)(src)<<7) & 0x00000080)
#define SEC7_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields SEC6	 */
#define SEC6_WIDTH                                                            1
#define SEC6_SHIFT                                                            6
#define SEC6_MASK                                                    0x00000040
#define SEC6_RD(src)                                  (((src) & 0x00000040)>>6)
#define SEC6_WR(src)                             (((u32)(src)<<6) & 0x00000040)
#define SEC6_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields SEC5	 */
#define SEC5_WIDTH                                                            1
#define SEC5_SHIFT                                                            5
#define SEC5_MASK                                                    0x00000020
#define SEC5_RD(src)                                  (((src) & 0x00000020)>>5)
#define SEC5_WR(src)                             (((u32)(src)<<5) & 0x00000020)
#define SEC5_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields SEC4	 */
#define SEC4_WIDTH                                                            1
#define SEC4_SHIFT                                                            4
#define SEC4_MASK                                                    0x00000010
#define SEC4_RD(src)                                  (((src) & 0x00000010)>>4)
#define SEC4_WR(src)                             (((u32)(src)<<4) & 0x00000010)
#define SEC4_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields SEC3	 */
#define SEC3_WIDTH                                                            1
#define SEC3_SHIFT                                                            3
#define SEC3_MASK                                                    0x00000008
#define SEC3_RD(src)                                  (((src) & 0x00000008)>>3)
#define SEC3_WR(src)                             (((u32)(src)<<3) & 0x00000008)
#define SEC3_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields SEC2	 */
#define SEC2_WIDTH                                                            1
#define SEC2_SHIFT                                                            2
#define SEC2_MASK                                                    0x00000004
#define SEC2_RD(src)                                  (((src) & 0x00000004)>>2)
#define SEC2_WR(src)                             (((u32)(src)<<2) & 0x00000004)
#define SEC2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields SEC1	 */
#define SEC1_WIDTH                                                            1
#define SEC1_SHIFT                                                            1
#define SEC1_MASK                                                    0x00000002
#define SEC1_RD(src)                                  (((src) & 0x00000002)>>1)
#define SEC1_WR(src)                             (((u32)(src)<<1) & 0x00000002)
#define SEC1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields SEC0	 */
#define SEC0_WIDTH                                                            1
#define SEC0_SHIFT                                                            0
#define SEC0_MASK                                                    0x00000001
#define SEC0_RD(src)                                     (((src) & 0x00000001))
#define SEC0_WR(src)                                (((u32)(src)) & 0x00000001)
#define SEC0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_SEC_ERRLMask	*/
/*    Mask Register Fields SEC31Mask    */
#define SEC31MASK_WIDTH                                                       1
#define SEC31MASK_SHIFT                                                      31
#define SEC31MASK_MASK                                               0x80000000
#define SEC31MASK_RD(src)                            (((src) & 0x80000000)>>31)
#define SEC31MASK_WR(src)                       (((u32)(src)<<31) & 0x80000000)
#define SEC31MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields SEC30Mask    */
#define SEC30MASK_WIDTH                                                       1
#define SEC30MASK_SHIFT                                                      30
#define SEC30MASK_MASK                                               0x40000000
#define SEC30MASK_RD(src)                            (((src) & 0x40000000)>>30)
#define SEC30MASK_WR(src)                       (((u32)(src)<<30) & 0x40000000)
#define SEC30MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields SEC29Mask    */
#define SEC29MASK_WIDTH                                                       1
#define SEC29MASK_SHIFT                                                      29
#define SEC29MASK_MASK                                               0x20000000
#define SEC29MASK_RD(src)                            (((src) & 0x20000000)>>29)
#define SEC29MASK_WR(src)                       (((u32)(src)<<29) & 0x20000000)
#define SEC29MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields SEC28Mask    */
#define SEC28MASK_WIDTH                                                       1
#define SEC28MASK_SHIFT                                                      28
#define SEC28MASK_MASK                                               0x10000000
#define SEC28MASK_RD(src)                            (((src) & 0x10000000)>>28)
#define SEC28MASK_WR(src)                       (((u32)(src)<<28) & 0x10000000)
#define SEC28MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields SEC27Mask    */
#define SEC27MASK_WIDTH                                                       1
#define SEC27MASK_SHIFT                                                      27
#define SEC27MASK_MASK                                               0x08000000
#define SEC27MASK_RD(src)                            (((src) & 0x08000000)>>27)
#define SEC27MASK_WR(src)                       (((u32)(src)<<27) & 0x08000000)
#define SEC27MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields SEC26Mask    */
#define SEC26MASK_WIDTH                                                       1
#define SEC26MASK_SHIFT                                                      26
#define SEC26MASK_MASK                                               0x04000000
#define SEC26MASK_RD(src)                            (((src) & 0x04000000)>>26)
#define SEC26MASK_WR(src)                       (((u32)(src)<<26) & 0x04000000)
#define SEC26MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields SEC25Mask    */
#define SEC25MASK_WIDTH                                                       1
#define SEC25MASK_SHIFT                                                      25
#define SEC25MASK_MASK                                               0x02000000
#define SEC25MASK_RD(src)                            (((src) & 0x02000000)>>25)
#define SEC25MASK_WR(src)                       (((u32)(src)<<25) & 0x02000000)
#define SEC25MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields SEC24Mask    */
#define SEC24MASK_WIDTH                                                       1
#define SEC24MASK_SHIFT                                                      24
#define SEC24MASK_MASK                                               0x01000000
#define SEC24MASK_RD(src)                            (((src) & 0x01000000)>>24)
#define SEC24MASK_WR(src)                       (((u32)(src)<<24) & 0x01000000)
#define SEC24MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields SEC23Mask    */
#define SEC23MASK_WIDTH                                                       1
#define SEC23MASK_SHIFT                                                      23
#define SEC23MASK_MASK                                               0x00800000
#define SEC23MASK_RD(src)                            (((src) & 0x00800000)>>23)
#define SEC23MASK_WR(src)                       (((u32)(src)<<23) & 0x00800000)
#define SEC23MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields SEC22Mask    */
#define SEC22MASK_WIDTH                                                       1
#define SEC22MASK_SHIFT                                                      22
#define SEC22MASK_MASK                                               0x00400000
#define SEC22MASK_RD(src)                            (((src) & 0x00400000)>>22)
#define SEC22MASK_WR(src)                       (((u32)(src)<<22) & 0x00400000)
#define SEC22MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields SEC21Mask    */
#define SEC21MASK_WIDTH                                                       1
#define SEC21MASK_SHIFT                                                      21
#define SEC21MASK_MASK                                               0x00200000
#define SEC21MASK_RD(src)                            (((src) & 0x00200000)>>21)
#define SEC21MASK_WR(src)                       (((u32)(src)<<21) & 0x00200000)
#define SEC21MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields SEC20Mask    */
#define SEC20MASK_WIDTH                                                       1
#define SEC20MASK_SHIFT                                                      20
#define SEC20MASK_MASK                                               0x00100000
#define SEC20MASK_RD(src)                            (((src) & 0x00100000)>>20)
#define SEC20MASK_WR(src)                       (((u32)(src)<<20) & 0x00100000)
#define SEC20MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields SEC19Mask    */
#define SEC19MASK_WIDTH                                                       1
#define SEC19MASK_SHIFT                                                      19
#define SEC19MASK_MASK                                               0x00080000
#define SEC19MASK_RD(src)                            (((src) & 0x00080000)>>19)
#define SEC19MASK_WR(src)                       (((u32)(src)<<19) & 0x00080000)
#define SEC19MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields SEC18Mask    */
#define SEC18MASK_WIDTH                                                       1
#define SEC18MASK_SHIFT                                                      18
#define SEC18MASK_MASK                                               0x00040000
#define SEC18MASK_RD(src)                            (((src) & 0x00040000)>>18)
#define SEC18MASK_WR(src)                       (((u32)(src)<<18) & 0x00040000)
#define SEC18MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields SEC17Mask    */
#define SEC17MASK_WIDTH                                                       1
#define SEC17MASK_SHIFT                                                      17
#define SEC17MASK_MASK                                               0x00020000
#define SEC17MASK_RD(src)                            (((src) & 0x00020000)>>17)
#define SEC17MASK_WR(src)                       (((u32)(src)<<17) & 0x00020000)
#define SEC17MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields SEC16Mask    */
#define SEC16MASK_WIDTH                                                       1
#define SEC16MASK_SHIFT                                                      16
#define SEC16MASK_MASK                                               0x00010000
#define SEC16MASK_RD(src)                            (((src) & 0x00010000)>>16)
#define SEC16MASK_WR(src)                       (((u32)(src)<<16) & 0x00010000)
#define SEC16MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields SEC15Mask    */
#define SEC15MASK_WIDTH                                                       1
#define SEC15MASK_SHIFT                                                      15
#define SEC15MASK_MASK                                               0x00008000
#define SEC15MASK_RD(src)                            (((src) & 0x00008000)>>15)
#define SEC15MASK_WR(src)                       (((u32)(src)<<15) & 0x00008000)
#define SEC15MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields SEC14Mask    */
#define SEC14MASK_WIDTH                                                       1
#define SEC14MASK_SHIFT                                                      14
#define SEC14MASK_MASK                                               0x00004000
#define SEC14MASK_RD(src)                            (((src) & 0x00004000)>>14)
#define SEC14MASK_WR(src)                       (((u32)(src)<<14) & 0x00004000)
#define SEC14MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields SEC13Mask    */
#define SEC13MASK_WIDTH                                                       1
#define SEC13MASK_SHIFT                                                      13
#define SEC13MASK_MASK                                               0x00002000
#define SEC13MASK_RD(src)                            (((src) & 0x00002000)>>13)
#define SEC13MASK_WR(src)                       (((u32)(src)<<13) & 0x00002000)
#define SEC13MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields SEC12Mask    */
#define SEC12MASK_WIDTH                                                       1
#define SEC12MASK_SHIFT                                                      12
#define SEC12MASK_MASK                                               0x00001000
#define SEC12MASK_RD(src)                            (((src) & 0x00001000)>>12)
#define SEC12MASK_WR(src)                       (((u32)(src)<<12) & 0x00001000)
#define SEC12MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields SEC11Mask    */
#define SEC11MASK_WIDTH                                                       1
#define SEC11MASK_SHIFT                                                      11
#define SEC11MASK_MASK                                               0x00000800
#define SEC11MASK_RD(src)                            (((src) & 0x00000800)>>11)
#define SEC11MASK_WR(src)                       (((u32)(src)<<11) & 0x00000800)
#define SEC11MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields SEC10Mask    */
#define SEC10MASK_WIDTH                                                       1
#define SEC10MASK_SHIFT                                                      10
#define SEC10MASK_MASK                                               0x00000400
#define SEC10MASK_RD(src)                            (((src) & 0x00000400)>>10)
#define SEC10MASK_WR(src)                       (((u32)(src)<<10) & 0x00000400)
#define SEC10MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields SEC9Mask    */
#define SEC9MASK_WIDTH                                                        1
#define SEC9MASK_SHIFT                                                        9
#define SEC9MASK_MASK                                                0x00000200
#define SEC9MASK_RD(src)                              (((src) & 0x00000200)>>9)
#define SEC9MASK_WR(src)                         (((u32)(src)<<9) & 0x00000200)
#define SEC9MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields SEC8Mask    */
#define SEC8MASK_WIDTH                                                        1
#define SEC8MASK_SHIFT                                                        8
#define SEC8MASK_MASK                                                0x00000100
#define SEC8MASK_RD(src)                              (((src) & 0x00000100)>>8)
#define SEC8MASK_WR(src)                         (((u32)(src)<<8) & 0x00000100)
#define SEC8MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields SEC7Mask    */
#define SEC7MASK_WIDTH                                                        1
#define SEC7MASK_SHIFT                                                        7
#define SEC7MASK_MASK                                                0x00000080
#define SEC7MASK_RD(src)                              (((src) & 0x00000080)>>7)
#define SEC7MASK_WR(src)                         (((u32)(src)<<7) & 0x00000080)
#define SEC7MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields SEC6Mask    */
#define SEC6MASK_WIDTH                                                        1
#define SEC6MASK_SHIFT                                                        6
#define SEC6MASK_MASK                                                0x00000040
#define SEC6MASK_RD(src)                              (((src) & 0x00000040)>>6)
#define SEC6MASK_WR(src)                         (((u32)(src)<<6) & 0x00000040)
#define SEC6MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields SEC5Mask    */
#define SEC5MASK_WIDTH                                                        1
#define SEC5MASK_SHIFT                                                        5
#define SEC5MASK_MASK                                                0x00000020
#define SEC5MASK_RD(src)                              (((src) & 0x00000020)>>5)
#define SEC5MASK_WR(src)                         (((u32)(src)<<5) & 0x00000020)
#define SEC5MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields SEC4Mask    */
#define SEC4MASK_WIDTH                                                        1
#define SEC4MASK_SHIFT                                                        4
#define SEC4MASK_MASK                                                0x00000010
#define SEC4MASK_RD(src)                              (((src) & 0x00000010)>>4)
#define SEC4MASK_WR(src)                         (((u32)(src)<<4) & 0x00000010)
#define SEC4MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields SEC3Mask    */
#define SEC3MASK_WIDTH                                                        1
#define SEC3MASK_SHIFT                                                        3
#define SEC3MASK_MASK                                                0x00000008
#define SEC3MASK_RD(src)                              (((src) & 0x00000008)>>3)
#define SEC3MASK_WR(src)                         (((u32)(src)<<3) & 0x00000008)
#define SEC3MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields SEC2Mask    */
#define SEC2MASK_WIDTH                                                        1
#define SEC2MASK_SHIFT                                                        2
#define SEC2MASK_MASK                                                0x00000004
#define SEC2MASK_RD(src)                              (((src) & 0x00000004)>>2)
#define SEC2MASK_WR(src)                         (((u32)(src)<<2) & 0x00000004)
#define SEC2MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields SEC1Mask    */
#define SEC1MASK_WIDTH                                                        1
#define SEC1MASK_SHIFT                                                        1
#define SEC1MASK_MASK                                                0x00000002
#define SEC1MASK_RD(src)                              (((src) & 0x00000002)>>1)
#define SEC1MASK_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define SEC1MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields SEC0Mask    */
#define SEC0MASK_WIDTH                                                        1
#define SEC0MASK_SHIFT                                                        0
#define SEC0MASK_MASK                                                0x00000001
#define SEC0MASK_RD(src)                                 (((src) & 0x00000001))
#define SEC0MASK_WR(src)                            (((u32)(src)) & 0x00000001)
#define SEC0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_SEC_ERRH	*/ 
/*	 Fields SEC31	 */
#define SEC31_F1_WIDTH                                                        1
#define SEC31_F1_SHIFT                                                       31
#define SEC31_F1_MASK                                                0x80000000
#define SEC31_F1_RD(src)                             (((src) & 0x80000000)>>31)
#define SEC31_F1_WR(src)                        (((u32)(src)<<31) & 0x80000000)
#define SEC31_F1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields SEC30	 */
#define SEC30_F1_WIDTH                                                        1
#define SEC30_F1_SHIFT                                                       30
#define SEC30_F1_MASK                                                0x40000000
#define SEC30_F1_RD(src)                             (((src) & 0x40000000)>>30)
#define SEC30_F1_WR(src)                        (((u32)(src)<<30) & 0x40000000)
#define SEC30_F1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields SEC29	 */
#define SEC29_F1_WIDTH                                                        1
#define SEC29_F1_SHIFT                                                       29
#define SEC29_F1_MASK                                                0x20000000
#define SEC29_F1_RD(src)                             (((src) & 0x20000000)>>29)
#define SEC29_F1_WR(src)                        (((u32)(src)<<29) & 0x20000000)
#define SEC29_F1_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields SEC28	 */
#define SEC28_F1_WIDTH                                                        1
#define SEC28_F1_SHIFT                                                       28
#define SEC28_F1_MASK                                                0x10000000
#define SEC28_F1_RD(src)                             (((src) & 0x10000000)>>28)
#define SEC28_F1_WR(src)                        (((u32)(src)<<28) & 0x10000000)
#define SEC28_F1_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields SEC27	 */
#define SEC27_F1_WIDTH                                                        1
#define SEC27_F1_SHIFT                                                       27
#define SEC27_F1_MASK                                                0x08000000
#define SEC27_F1_RD(src)                             (((src) & 0x08000000)>>27)
#define SEC27_F1_WR(src)                        (((u32)(src)<<27) & 0x08000000)
#define SEC27_F1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields SEC26	 */
#define SEC26_F1_WIDTH                                                        1
#define SEC26_F1_SHIFT                                                       26
#define SEC26_F1_MASK                                                0x04000000
#define SEC26_F1_RD(src)                             (((src) & 0x04000000)>>26)
#define SEC26_F1_WR(src)                        (((u32)(src)<<26) & 0x04000000)
#define SEC26_F1_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields SEC25	 */
#define SEC25_F1_WIDTH                                                        1
#define SEC25_F1_SHIFT                                                       25
#define SEC25_F1_MASK                                                0x02000000
#define SEC25_F1_RD(src)                             (((src) & 0x02000000)>>25)
#define SEC25_F1_WR(src)                        (((u32)(src)<<25) & 0x02000000)
#define SEC25_F1_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields SEC24	 */
#define SEC24_F1_WIDTH                                                        1
#define SEC24_F1_SHIFT                                                       24
#define SEC24_F1_MASK                                                0x01000000
#define SEC24_F1_RD(src)                             (((src) & 0x01000000)>>24)
#define SEC24_F1_WR(src)                        (((u32)(src)<<24) & 0x01000000)
#define SEC24_F1_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields SEC23	 */
#define SEC23_F1_WIDTH                                                        1
#define SEC23_F1_SHIFT                                                       23
#define SEC23_F1_MASK                                                0x00800000
#define SEC23_F1_RD(src)                             (((src) & 0x00800000)>>23)
#define SEC23_F1_WR(src)                        (((u32)(src)<<23) & 0x00800000)
#define SEC23_F1_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields SEC22	 */
#define SEC22_F1_WIDTH                                                        1
#define SEC22_F1_SHIFT                                                       22
#define SEC22_F1_MASK                                                0x00400000
#define SEC22_F1_RD(src)                             (((src) & 0x00400000)>>22)
#define SEC22_F1_WR(src)                        (((u32)(src)<<22) & 0x00400000)
#define SEC22_F1_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields SEC21	 */
#define SEC21_F1_WIDTH                                                        1
#define SEC21_F1_SHIFT                                                       21
#define SEC21_F1_MASK                                                0x00200000
#define SEC21_F1_RD(src)                             (((src) & 0x00200000)>>21)
#define SEC21_F1_WR(src)                        (((u32)(src)<<21) & 0x00200000)
#define SEC21_F1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields SEC20	 */
#define SEC20_F1_WIDTH                                                        1
#define SEC20_F1_SHIFT                                                       20
#define SEC20_F1_MASK                                                0x00100000
#define SEC20_F1_RD(src)                             (((src) & 0x00100000)>>20)
#define SEC20_F1_WR(src)                        (((u32)(src)<<20) & 0x00100000)
#define SEC20_F1_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields SEC19	 */
#define SEC19_F1_WIDTH                                                        1
#define SEC19_F1_SHIFT                                                       19
#define SEC19_F1_MASK                                                0x00080000
#define SEC19_F1_RD(src)                             (((src) & 0x00080000)>>19)
#define SEC19_F1_WR(src)                        (((u32)(src)<<19) & 0x00080000)
#define SEC19_F1_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields SEC18	 */
#define SEC18_F1_WIDTH                                                        1
#define SEC18_F1_SHIFT                                                       18
#define SEC18_F1_MASK                                                0x00040000
#define SEC18_F1_RD(src)                             (((src) & 0x00040000)>>18)
#define SEC18_F1_WR(src)                        (((u32)(src)<<18) & 0x00040000)
#define SEC18_F1_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields SEC17	 */
#define SEC17_F1_WIDTH                                                        1
#define SEC17_F1_SHIFT                                                       17
#define SEC17_F1_MASK                                                0x00020000
#define SEC17_F1_RD(src)                             (((src) & 0x00020000)>>17)
#define SEC17_F1_WR(src)                        (((u32)(src)<<17) & 0x00020000)
#define SEC17_F1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields SEC16	 */
#define SEC16_F1_WIDTH                                                        1
#define SEC16_F1_SHIFT                                                       16
#define SEC16_F1_MASK                                                0x00010000
#define SEC16_F1_RD(src)                             (((src) & 0x00010000)>>16)
#define SEC16_F1_WR(src)                        (((u32)(src)<<16) & 0x00010000)
#define SEC16_F1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields SEC15	 */
#define SEC15_F1_WIDTH                                                        1
#define SEC15_F1_SHIFT                                                       15
#define SEC15_F1_MASK                                                0x00008000
#define SEC15_F1_RD(src)                             (((src) & 0x00008000)>>15)
#define SEC15_F1_WR(src)                        (((u32)(src)<<15) & 0x00008000)
#define SEC15_F1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields SEC14	 */
#define SEC14_F1_WIDTH                                                        1
#define SEC14_F1_SHIFT                                                       14
#define SEC14_F1_MASK                                                0x00004000
#define SEC14_F1_RD(src)                             (((src) & 0x00004000)>>14)
#define SEC14_F1_WR(src)                        (((u32)(src)<<14) & 0x00004000)
#define SEC14_F1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields SEC13	 */
#define SEC13_F1_WIDTH                                                        1
#define SEC13_F1_SHIFT                                                       13
#define SEC13_F1_MASK                                                0x00002000
#define SEC13_F1_RD(src)                             (((src) & 0x00002000)>>13)
#define SEC13_F1_WR(src)                        (((u32)(src)<<13) & 0x00002000)
#define SEC13_F1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields SEC12	 */
#define SEC12_F1_WIDTH                                                        1
#define SEC12_F1_SHIFT                                                       12
#define SEC12_F1_MASK                                                0x00001000
#define SEC12_F1_RD(src)                             (((src) & 0x00001000)>>12)
#define SEC12_F1_WR(src)                        (((u32)(src)<<12) & 0x00001000)
#define SEC12_F1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields SEC11	 */
#define SEC11_F1_WIDTH                                                        1
#define SEC11_F1_SHIFT                                                       11
#define SEC11_F1_MASK                                                0x00000800
#define SEC11_F1_RD(src)                             (((src) & 0x00000800)>>11)
#define SEC11_F1_WR(src)                        (((u32)(src)<<11) & 0x00000800)
#define SEC11_F1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields SEC10	 */
#define SEC10_F1_WIDTH                                                        1
#define SEC10_F1_SHIFT                                                       10
#define SEC10_F1_MASK                                                0x00000400
#define SEC10_F1_RD(src)                             (((src) & 0x00000400)>>10)
#define SEC10_F1_WR(src)                        (((u32)(src)<<10) & 0x00000400)
#define SEC10_F1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields SEC9	 */
#define SEC9_F1_WIDTH                                                         1
#define SEC9_F1_SHIFT                                                         9
#define SEC9_F1_MASK                                                 0x00000200
#define SEC9_F1_RD(src)                               (((src) & 0x00000200)>>9)
#define SEC9_F1_WR(src)                          (((u32)(src)<<9) & 0x00000200)
#define SEC9_F1_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields SEC8	 */
#define SEC8_F1_WIDTH                                                         1
#define SEC8_F1_SHIFT                                                         8
#define SEC8_F1_MASK                                                 0x00000100
#define SEC8_F1_RD(src)                               (((src) & 0x00000100)>>8)
#define SEC8_F1_WR(src)                          (((u32)(src)<<8) & 0x00000100)
#define SEC8_F1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields SEC7	 */
#define SEC7_F1_WIDTH                                                         1
#define SEC7_F1_SHIFT                                                         7
#define SEC7_F1_MASK                                                 0x00000080
#define SEC7_F1_RD(src)                               (((src) & 0x00000080)>>7)
#define SEC7_F1_WR(src)                          (((u32)(src)<<7) & 0x00000080)
#define SEC7_F1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields SEC6	 */
#define SEC6_F1_WIDTH                                                         1
#define SEC6_F1_SHIFT                                                         6
#define SEC6_F1_MASK                                                 0x00000040
#define SEC6_F1_RD(src)                               (((src) & 0x00000040)>>6)
#define SEC6_F1_WR(src)                          (((u32)(src)<<6) & 0x00000040)
#define SEC6_F1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields SEC5	 */
#define SEC5_F1_WIDTH                                                         1
#define SEC5_F1_SHIFT                                                         5
#define SEC5_F1_MASK                                                 0x00000020
#define SEC5_F1_RD(src)                               (((src) & 0x00000020)>>5)
#define SEC5_F1_WR(src)                          (((u32)(src)<<5) & 0x00000020)
#define SEC5_F1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields SEC4	 */
#define SEC4_F1_WIDTH                                                         1
#define SEC4_F1_SHIFT                                                         4
#define SEC4_F1_MASK                                                 0x00000010
#define SEC4_F1_RD(src)                               (((src) & 0x00000010)>>4)
#define SEC4_F1_WR(src)                          (((u32)(src)<<4) & 0x00000010)
#define SEC4_F1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields SEC3	 */
#define SEC3_F1_WIDTH                                                         1
#define SEC3_F1_SHIFT                                                         3
#define SEC3_F1_MASK                                                 0x00000008
#define SEC3_F1_RD(src)                               (((src) & 0x00000008)>>3)
#define SEC3_F1_WR(src)                          (((u32)(src)<<3) & 0x00000008)
#define SEC3_F1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields SEC2	 */
#define SEC2_F1_WIDTH                                                         1
#define SEC2_F1_SHIFT                                                         2
#define SEC2_F1_MASK                                                 0x00000004
#define SEC2_F1_RD(src)                               (((src) & 0x00000004)>>2)
#define SEC2_F1_WR(src)                          (((u32)(src)<<2) & 0x00000004)
#define SEC2_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields SEC1	 */
#define SEC1_F1_WIDTH                                                         1
#define SEC1_F1_SHIFT                                                         1
#define SEC1_F1_MASK                                                 0x00000002
#define SEC1_F1_RD(src)                               (((src) & 0x00000002)>>1)
#define SEC1_F1_WR(src)                          (((u32)(src)<<1) & 0x00000002)
#define SEC1_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields SEC0	 */
#define SEC0_F1_WIDTH                                                         1
#define SEC0_F1_SHIFT                                                         0
#define SEC0_F1_MASK                                                 0x00000001
#define SEC0_F1_RD(src)                                  (((src) & 0x00000001))
#define SEC0_F1_WR(src)                             (((u32)(src)) & 0x00000001)
#define SEC0_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_SEC_ERRHMask	*/
/*    Mask Register Fields SEC31Mask    */
#define SEC31MASK_F1_WIDTH                                                    1
#define SEC31MASK_F1_SHIFT                                                   31
#define SEC31MASK_F1_MASK                                            0x80000000
#define SEC31MASK_F1_RD(src)                         (((src) & 0x80000000)>>31)
#define SEC31MASK_F1_WR(src)                    (((u32)(src)<<31) & 0x80000000)
#define SEC31MASK_F1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields SEC30Mask    */
#define SEC30MASK_F1_WIDTH                                                    1
#define SEC30MASK_F1_SHIFT                                                   30
#define SEC30MASK_F1_MASK                                            0x40000000
#define SEC30MASK_F1_RD(src)                         (((src) & 0x40000000)>>30)
#define SEC30MASK_F1_WR(src)                    (((u32)(src)<<30) & 0x40000000)
#define SEC30MASK_F1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields SEC29Mask    */
#define SEC29MASK_F1_WIDTH                                                    1
#define SEC29MASK_F1_SHIFT                                                   29
#define SEC29MASK_F1_MASK                                            0x20000000
#define SEC29MASK_F1_RD(src)                         (((src) & 0x20000000)>>29)
#define SEC29MASK_F1_WR(src)                    (((u32)(src)<<29) & 0x20000000)
#define SEC29MASK_F1_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields SEC28Mask    */
#define SEC28MASK_F1_WIDTH                                                    1
#define SEC28MASK_F1_SHIFT                                                   28
#define SEC28MASK_F1_MASK                                            0x10000000
#define SEC28MASK_F1_RD(src)                         (((src) & 0x10000000)>>28)
#define SEC28MASK_F1_WR(src)                    (((u32)(src)<<28) & 0x10000000)
#define SEC28MASK_F1_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields SEC27Mask    */
#define SEC27MASK_F1_WIDTH                                                    1
#define SEC27MASK_F1_SHIFT                                                   27
#define SEC27MASK_F1_MASK                                            0x08000000
#define SEC27MASK_F1_RD(src)                         (((src) & 0x08000000)>>27)
#define SEC27MASK_F1_WR(src)                    (((u32)(src)<<27) & 0x08000000)
#define SEC27MASK_F1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields SEC26Mask    */
#define SEC26MASK_F1_WIDTH                                                    1
#define SEC26MASK_F1_SHIFT                                                   26
#define SEC26MASK_F1_MASK                                            0x04000000
#define SEC26MASK_F1_RD(src)                         (((src) & 0x04000000)>>26)
#define SEC26MASK_F1_WR(src)                    (((u32)(src)<<26) & 0x04000000)
#define SEC26MASK_F1_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields SEC25Mask    */
#define SEC25MASK_F1_WIDTH                                                    1
#define SEC25MASK_F1_SHIFT                                                   25
#define SEC25MASK_F1_MASK                                            0x02000000
#define SEC25MASK_F1_RD(src)                         (((src) & 0x02000000)>>25)
#define SEC25MASK_F1_WR(src)                    (((u32)(src)<<25) & 0x02000000)
#define SEC25MASK_F1_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields SEC24Mask    */
#define SEC24MASK_F1_WIDTH                                                    1
#define SEC24MASK_F1_SHIFT                                                   24
#define SEC24MASK_F1_MASK                                            0x01000000
#define SEC24MASK_F1_RD(src)                         (((src) & 0x01000000)>>24)
#define SEC24MASK_F1_WR(src)                    (((u32)(src)<<24) & 0x01000000)
#define SEC24MASK_F1_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields SEC23Mask    */
#define SEC23MASK_F1_WIDTH                                                    1
#define SEC23MASK_F1_SHIFT                                                   23
#define SEC23MASK_F1_MASK                                            0x00800000
#define SEC23MASK_F1_RD(src)                         (((src) & 0x00800000)>>23)
#define SEC23MASK_F1_WR(src)                    (((u32)(src)<<23) & 0x00800000)
#define SEC23MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields SEC22Mask    */
#define SEC22MASK_F1_WIDTH                                                    1
#define SEC22MASK_F1_SHIFT                                                   22
#define SEC22MASK_F1_MASK                                            0x00400000
#define SEC22MASK_F1_RD(src)                         (((src) & 0x00400000)>>22)
#define SEC22MASK_F1_WR(src)                    (((u32)(src)<<22) & 0x00400000)
#define SEC22MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields SEC21Mask    */
#define SEC21MASK_F1_WIDTH                                                    1
#define SEC21MASK_F1_SHIFT                                                   21
#define SEC21MASK_F1_MASK                                            0x00200000
#define SEC21MASK_F1_RD(src)                         (((src) & 0x00200000)>>21)
#define SEC21MASK_F1_WR(src)                    (((u32)(src)<<21) & 0x00200000)
#define SEC21MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields SEC20Mask    */
#define SEC20MASK_F1_WIDTH                                                    1
#define SEC20MASK_F1_SHIFT                                                   20
#define SEC20MASK_F1_MASK                                            0x00100000
#define SEC20MASK_F1_RD(src)                         (((src) & 0x00100000)>>20)
#define SEC20MASK_F1_WR(src)                    (((u32)(src)<<20) & 0x00100000)
#define SEC20MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields SEC19Mask    */
#define SEC19MASK_F1_WIDTH                                                    1
#define SEC19MASK_F1_SHIFT                                                   19
#define SEC19MASK_F1_MASK                                            0x00080000
#define SEC19MASK_F1_RD(src)                         (((src) & 0x00080000)>>19)
#define SEC19MASK_F1_WR(src)                    (((u32)(src)<<19) & 0x00080000)
#define SEC19MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields SEC18Mask    */
#define SEC18MASK_F1_WIDTH                                                    1
#define SEC18MASK_F1_SHIFT                                                   18
#define SEC18MASK_F1_MASK                                            0x00040000
#define SEC18MASK_F1_RD(src)                         (((src) & 0x00040000)>>18)
#define SEC18MASK_F1_WR(src)                    (((u32)(src)<<18) & 0x00040000)
#define SEC18MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields SEC17Mask    */
#define SEC17MASK_F1_WIDTH                                                    1
#define SEC17MASK_F1_SHIFT                                                   17
#define SEC17MASK_F1_MASK                                            0x00020000
#define SEC17MASK_F1_RD(src)                         (((src) & 0x00020000)>>17)
#define SEC17MASK_F1_WR(src)                    (((u32)(src)<<17) & 0x00020000)
#define SEC17MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields SEC16Mask    */
#define SEC16MASK_F1_WIDTH                                                    1
#define SEC16MASK_F1_SHIFT                                                   16
#define SEC16MASK_F1_MASK                                            0x00010000
#define SEC16MASK_F1_RD(src)                         (((src) & 0x00010000)>>16)
#define SEC16MASK_F1_WR(src)                    (((u32)(src)<<16) & 0x00010000)
#define SEC16MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields SEC15Mask    */
#define SEC15MASK_F1_WIDTH                                                    1
#define SEC15MASK_F1_SHIFT                                                   15
#define SEC15MASK_F1_MASK                                            0x00008000
#define SEC15MASK_F1_RD(src)                         (((src) & 0x00008000)>>15)
#define SEC15MASK_F1_WR(src)                    (((u32)(src)<<15) & 0x00008000)
#define SEC15MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields SEC14Mask    */
#define SEC14MASK_F1_WIDTH                                                    1
#define SEC14MASK_F1_SHIFT                                                   14
#define SEC14MASK_F1_MASK                                            0x00004000
#define SEC14MASK_F1_RD(src)                         (((src) & 0x00004000)>>14)
#define SEC14MASK_F1_WR(src)                    (((u32)(src)<<14) & 0x00004000)
#define SEC14MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields SEC13Mask    */
#define SEC13MASK_F1_WIDTH                                                    1
#define SEC13MASK_F1_SHIFT                                                   13
#define SEC13MASK_F1_MASK                                            0x00002000
#define SEC13MASK_F1_RD(src)                         (((src) & 0x00002000)>>13)
#define SEC13MASK_F1_WR(src)                    (((u32)(src)<<13) & 0x00002000)
#define SEC13MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields SEC12Mask    */
#define SEC12MASK_F1_WIDTH                                                    1
#define SEC12MASK_F1_SHIFT                                                   12
#define SEC12MASK_F1_MASK                                            0x00001000
#define SEC12MASK_F1_RD(src)                         (((src) & 0x00001000)>>12)
#define SEC12MASK_F1_WR(src)                    (((u32)(src)<<12) & 0x00001000)
#define SEC12MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields SEC11Mask    */
#define SEC11MASK_F1_WIDTH                                                    1
#define SEC11MASK_F1_SHIFT                                                   11
#define SEC11MASK_F1_MASK                                            0x00000800
#define SEC11MASK_F1_RD(src)                         (((src) & 0x00000800)>>11)
#define SEC11MASK_F1_WR(src)                    (((u32)(src)<<11) & 0x00000800)
#define SEC11MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields SEC10Mask    */
#define SEC10MASK_F1_WIDTH                                                    1
#define SEC10MASK_F1_SHIFT                                                   10
#define SEC10MASK_F1_MASK                                            0x00000400
#define SEC10MASK_F1_RD(src)                         (((src) & 0x00000400)>>10)
#define SEC10MASK_F1_WR(src)                    (((u32)(src)<<10) & 0x00000400)
#define SEC10MASK_F1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields SEC9Mask    */
#define SEC9MASK_F1_WIDTH                                                     1
#define SEC9MASK_F1_SHIFT                                                     9
#define SEC9MASK_F1_MASK                                             0x00000200
#define SEC9MASK_F1_RD(src)                           (((src) & 0x00000200)>>9)
#define SEC9MASK_F1_WR(src)                      (((u32)(src)<<9) & 0x00000200)
#define SEC9MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields SEC8Mask    */
#define SEC8MASK_F1_WIDTH                                                     1
#define SEC8MASK_F1_SHIFT                                                     8
#define SEC8MASK_F1_MASK                                             0x00000100
#define SEC8MASK_F1_RD(src)                           (((src) & 0x00000100)>>8)
#define SEC8MASK_F1_WR(src)                      (((u32)(src)<<8) & 0x00000100)
#define SEC8MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields SEC7Mask    */
#define SEC7MASK_F1_WIDTH                                                     1
#define SEC7MASK_F1_SHIFT                                                     7
#define SEC7MASK_F1_MASK                                             0x00000080
#define SEC7MASK_F1_RD(src)                           (((src) & 0x00000080)>>7)
#define SEC7MASK_F1_WR(src)                      (((u32)(src)<<7) & 0x00000080)
#define SEC7MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields SEC6Mask    */
#define SEC6MASK_F1_WIDTH                                                     1
#define SEC6MASK_F1_SHIFT                                                     6
#define SEC6MASK_F1_MASK                                             0x00000040
#define SEC6MASK_F1_RD(src)                           (((src) & 0x00000040)>>6)
#define SEC6MASK_F1_WR(src)                      (((u32)(src)<<6) & 0x00000040)
#define SEC6MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields SEC5Mask    */
#define SEC5MASK_F1_WIDTH                                                     1
#define SEC5MASK_F1_SHIFT                                                     5
#define SEC5MASK_F1_MASK                                             0x00000020
#define SEC5MASK_F1_RD(src)                           (((src) & 0x00000020)>>5)
#define SEC5MASK_F1_WR(src)                      (((u32)(src)<<5) & 0x00000020)
#define SEC5MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields SEC4Mask    */
#define SEC4MASK_F1_WIDTH                                                     1
#define SEC4MASK_F1_SHIFT                                                     4
#define SEC4MASK_F1_MASK                                             0x00000010
#define SEC4MASK_F1_RD(src)                           (((src) & 0x00000010)>>4)
#define SEC4MASK_F1_WR(src)                      (((u32)(src)<<4) & 0x00000010)
#define SEC4MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields SEC3Mask    */
#define SEC3MASK_F1_WIDTH                                                     1
#define SEC3MASK_F1_SHIFT                                                     3
#define SEC3MASK_F1_MASK                                             0x00000008
#define SEC3MASK_F1_RD(src)                           (((src) & 0x00000008)>>3)
#define SEC3MASK_F1_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define SEC3MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields SEC2Mask    */
#define SEC2MASK_F1_WIDTH                                                     1
#define SEC2MASK_F1_SHIFT                                                     2
#define SEC2MASK_F1_MASK                                             0x00000004
#define SEC2MASK_F1_RD(src)                           (((src) & 0x00000004)>>2)
#define SEC2MASK_F1_WR(src)                      (((u32)(src)<<2) & 0x00000004)
#define SEC2MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields SEC1Mask    */
#define SEC1MASK_F1_WIDTH                                                     1
#define SEC1MASK_F1_SHIFT                                                     1
#define SEC1MASK_F1_MASK                                             0x00000002
#define SEC1MASK_F1_RD(src)                           (((src) & 0x00000002)>>1)
#define SEC1MASK_F1_WR(src)                      (((u32)(src)<<1) & 0x00000002)
#define SEC1MASK_F1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields SEC0Mask    */
#define SEC0MASK_F1_WIDTH                                                     1
#define SEC0MASK_F1_SHIFT                                                     0
#define SEC0MASK_F1_MASK                                             0x00000001
#define SEC0MASK_F1_RD(src)                              (((src) & 0x00000001))
#define SEC0MASK_F1_WR(src)                         (((u32)(src)) & 0x00000001)
#define SEC0MASK_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MSEC_ERRL	*/ 
/*	 Fields MSEC31	 */
#define MSEC31_WIDTH                                                          1
#define MSEC31_SHIFT                                                         31
#define MSEC31_MASK                                                  0x80000000
#define MSEC31_RD(src)                               (((src) & 0x80000000)>>31)
#define MSEC31_WR(src)                          (((u32)(src)<<31) & 0x80000000)
#define MSEC31_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields MSEC30	 */
#define MSEC30_WIDTH                                                          1
#define MSEC30_SHIFT                                                         30
#define MSEC30_MASK                                                  0x40000000
#define MSEC30_RD(src)                               (((src) & 0x40000000)>>30)
#define MSEC30_WR(src)                          (((u32)(src)<<30) & 0x40000000)
#define MSEC30_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields MSEC29	 */
#define MSEC29_WIDTH                                                          1
#define MSEC29_SHIFT                                                         29
#define MSEC29_MASK                                                  0x20000000
#define MSEC29_RD(src)                               (((src) & 0x20000000)>>29)
#define MSEC29_WR(src)                          (((u32)(src)<<29) & 0x20000000)
#define MSEC29_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields MSEC28	 */
#define MSEC28_WIDTH                                                          1
#define MSEC28_SHIFT                                                         28
#define MSEC28_MASK                                                  0x10000000
#define MSEC28_RD(src)                               (((src) & 0x10000000)>>28)
#define MSEC28_WR(src)                          (((u32)(src)<<28) & 0x10000000)
#define MSEC28_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields MSEC27	 */
#define MSEC27_WIDTH                                                          1
#define MSEC27_SHIFT                                                         27
#define MSEC27_MASK                                                  0x08000000
#define MSEC27_RD(src)                               (((src) & 0x08000000)>>27)
#define MSEC27_WR(src)                          (((u32)(src)<<27) & 0x08000000)
#define MSEC27_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields MSEC26	 */
#define MSEC26_WIDTH                                                          1
#define MSEC26_SHIFT                                                         26
#define MSEC26_MASK                                                  0x04000000
#define MSEC26_RD(src)                               (((src) & 0x04000000)>>26)
#define MSEC26_WR(src)                          (((u32)(src)<<26) & 0x04000000)
#define MSEC26_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields MSEC25	 */
#define MSEC25_WIDTH                                                          1
#define MSEC25_SHIFT                                                         25
#define MSEC25_MASK                                                  0x02000000
#define MSEC25_RD(src)                               (((src) & 0x02000000)>>25)
#define MSEC25_WR(src)                          (((u32)(src)<<25) & 0x02000000)
#define MSEC25_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields MSEC24	 */
#define MSEC24_WIDTH                                                          1
#define MSEC24_SHIFT                                                         24
#define MSEC24_MASK                                                  0x01000000
#define MSEC24_RD(src)                               (((src) & 0x01000000)>>24)
#define MSEC24_WR(src)                          (((u32)(src)<<24) & 0x01000000)
#define MSEC24_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields MSEC23	 */
#define MSEC23_WIDTH                                                          1
#define MSEC23_SHIFT                                                         23
#define MSEC23_MASK                                                  0x00800000
#define MSEC23_RD(src)                               (((src) & 0x00800000)>>23)
#define MSEC23_WR(src)                          (((u32)(src)<<23) & 0x00800000)
#define MSEC23_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields MSEC22	 */
#define MSEC22_WIDTH                                                          1
#define MSEC22_SHIFT                                                         22
#define MSEC22_MASK                                                  0x00400000
#define MSEC22_RD(src)                               (((src) & 0x00400000)>>22)
#define MSEC22_WR(src)                          (((u32)(src)<<22) & 0x00400000)
#define MSEC22_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields MSEC21	 */
#define MSEC21_WIDTH                                                          1
#define MSEC21_SHIFT                                                         21
#define MSEC21_MASK                                                  0x00200000
#define MSEC21_RD(src)                               (((src) & 0x00200000)>>21)
#define MSEC21_WR(src)                          (((u32)(src)<<21) & 0x00200000)
#define MSEC21_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields MSEC20	 */
#define MSEC20_WIDTH                                                          1
#define MSEC20_SHIFT                                                         20
#define MSEC20_MASK                                                  0x00100000
#define MSEC20_RD(src)                               (((src) & 0x00100000)>>20)
#define MSEC20_WR(src)                          (((u32)(src)<<20) & 0x00100000)
#define MSEC20_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields MSEC19	 */
#define MSEC19_WIDTH                                                          1
#define MSEC19_SHIFT                                                         19
#define MSEC19_MASK                                                  0x00080000
#define MSEC19_RD(src)                               (((src) & 0x00080000)>>19)
#define MSEC19_WR(src)                          (((u32)(src)<<19) & 0x00080000)
#define MSEC19_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields MSEC18	 */
#define MSEC18_WIDTH                                                          1
#define MSEC18_SHIFT                                                         18
#define MSEC18_MASK                                                  0x00040000
#define MSEC18_RD(src)                               (((src) & 0x00040000)>>18)
#define MSEC18_WR(src)                          (((u32)(src)<<18) & 0x00040000)
#define MSEC18_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields MSEC17	 */
#define MSEC17_WIDTH                                                          1
#define MSEC17_SHIFT                                                         17
#define MSEC17_MASK                                                  0x00020000
#define MSEC17_RD(src)                               (((src) & 0x00020000)>>17)
#define MSEC17_WR(src)                          (((u32)(src)<<17) & 0x00020000)
#define MSEC17_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields MSEC16	 */
#define MSEC16_WIDTH                                                          1
#define MSEC16_SHIFT                                                         16
#define MSEC16_MASK                                                  0x00010000
#define MSEC16_RD(src)                               (((src) & 0x00010000)>>16)
#define MSEC16_WR(src)                          (((u32)(src)<<16) & 0x00010000)
#define MSEC16_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields MSEC15	 */
#define MSEC15_WIDTH                                                          1
#define MSEC15_SHIFT                                                         15
#define MSEC15_MASK                                                  0x00008000
#define MSEC15_RD(src)                               (((src) & 0x00008000)>>15)
#define MSEC15_WR(src)                          (((u32)(src)<<15) & 0x00008000)
#define MSEC15_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields MSEC14	 */
#define MSEC14_WIDTH                                                          1
#define MSEC14_SHIFT                                                         14
#define MSEC14_MASK                                                  0x00004000
#define MSEC14_RD(src)                               (((src) & 0x00004000)>>14)
#define MSEC14_WR(src)                          (((u32)(src)<<14) & 0x00004000)
#define MSEC14_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields MSEC13	 */
#define MSEC13_WIDTH                                                          1
#define MSEC13_SHIFT                                                         13
#define MSEC13_MASK                                                  0x00002000
#define MSEC13_RD(src)                               (((src) & 0x00002000)>>13)
#define MSEC13_WR(src)                          (((u32)(src)<<13) & 0x00002000)
#define MSEC13_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields MSEC12	 */
#define MSEC12_WIDTH                                                          1
#define MSEC12_SHIFT                                                         12
#define MSEC12_MASK                                                  0x00001000
#define MSEC12_RD(src)                               (((src) & 0x00001000)>>12)
#define MSEC12_WR(src)                          (((u32)(src)<<12) & 0x00001000)
#define MSEC12_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields MSEC11	 */
#define MSEC11_WIDTH                                                          1
#define MSEC11_SHIFT                                                         11
#define MSEC11_MASK                                                  0x00000800
#define MSEC11_RD(src)                               (((src) & 0x00000800)>>11)
#define MSEC11_WR(src)                          (((u32)(src)<<11) & 0x00000800)
#define MSEC11_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields MSEC10	 */
#define MSEC10_WIDTH                                                          1
#define MSEC10_SHIFT                                                         10
#define MSEC10_MASK                                                  0x00000400
#define MSEC10_RD(src)                               (((src) & 0x00000400)>>10)
#define MSEC10_WR(src)                          (((u32)(src)<<10) & 0x00000400)
#define MSEC10_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields MSEC9	 */
#define MSEC9_WIDTH                                                           1
#define MSEC9_SHIFT                                                           9
#define MSEC9_MASK                                                   0x00000200
#define MSEC9_RD(src)                                 (((src) & 0x00000200)>>9)
#define MSEC9_WR(src)                            (((u32)(src)<<9) & 0x00000200)
#define MSEC9_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields MSEC8	 */
#define MSEC8_WIDTH                                                           1
#define MSEC8_SHIFT                                                           8
#define MSEC8_MASK                                                   0x00000100
#define MSEC8_RD(src)                                 (((src) & 0x00000100)>>8)
#define MSEC8_WR(src)                            (((u32)(src)<<8) & 0x00000100)
#define MSEC8_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields MSEC7	 */
#define MSEC7_WIDTH                                                           1
#define MSEC7_SHIFT                                                           7
#define MSEC7_MASK                                                   0x00000080
#define MSEC7_RD(src)                                 (((src) & 0x00000080)>>7)
#define MSEC7_WR(src)                            (((u32)(src)<<7) & 0x00000080)
#define MSEC7_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields MSEC6	 */
#define MSEC6_WIDTH                                                           1
#define MSEC6_SHIFT                                                           6
#define MSEC6_MASK                                                   0x00000040
#define MSEC6_RD(src)                                 (((src) & 0x00000040)>>6)
#define MSEC6_WR(src)                            (((u32)(src)<<6) & 0x00000040)
#define MSEC6_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields MSEC5	 */
#define MSEC5_WIDTH                                                           1
#define MSEC5_SHIFT                                                           5
#define MSEC5_MASK                                                   0x00000020
#define MSEC5_RD(src)                                 (((src) & 0x00000020)>>5)
#define MSEC5_WR(src)                            (((u32)(src)<<5) & 0x00000020)
#define MSEC5_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields MSEC4	 */
#define MSEC4_WIDTH                                                           1
#define MSEC4_SHIFT                                                           4
#define MSEC4_MASK                                                   0x00000010
#define MSEC4_RD(src)                                 (((src) & 0x00000010)>>4)
#define MSEC4_WR(src)                            (((u32)(src)<<4) & 0x00000010)
#define MSEC4_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields MSEC3	 */
#define MSEC3_WIDTH                                                           1
#define MSEC3_SHIFT                                                           3
#define MSEC3_MASK                                                   0x00000008
#define MSEC3_RD(src)                                 (((src) & 0x00000008)>>3)
#define MSEC3_WR(src)                            (((u32)(src)<<3) & 0x00000008)
#define MSEC3_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields MSEC2	 */
#define MSEC2_WIDTH                                                           1
#define MSEC2_SHIFT                                                           2
#define MSEC2_MASK                                                   0x00000004
#define MSEC2_RD(src)                                 (((src) & 0x00000004)>>2)
#define MSEC2_WR(src)                            (((u32)(src)<<2) & 0x00000004)
#define MSEC2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields MSEC1	 */
#define MSEC1_WIDTH                                                           1
#define MSEC1_SHIFT                                                           1
#define MSEC1_MASK                                                   0x00000002
#define MSEC1_RD(src)                                 (((src) & 0x00000002)>>1)
#define MSEC1_WR(src)                            (((u32)(src)<<1) & 0x00000002)
#define MSEC1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields MSEC0	 */
#define MSEC0_WIDTH                                                           1
#define MSEC0_SHIFT                                                           0
#define MSEC0_MASK                                                   0x00000001
#define MSEC0_RD(src)                                    (((src) & 0x00000001))
#define MSEC0_WR(src)                               (((u32)(src)) & 0x00000001)
#define MSEC0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MSEC_ERRLMask	*/
/*    Mask Register Fields MSEC31Mask    */
#define MSEC31MASK_WIDTH                                                      1
#define MSEC31MASK_SHIFT                                                     31
#define MSEC31MASK_MASK                                              0x80000000
#define MSEC31MASK_RD(src)                           (((src) & 0x80000000)>>31)
#define MSEC31MASK_WR(src)                      (((u32)(src)<<31) & 0x80000000)
#define MSEC31MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields MSEC30Mask    */
#define MSEC30MASK_WIDTH                                                      1
#define MSEC30MASK_SHIFT                                                     30
#define MSEC30MASK_MASK                                              0x40000000
#define MSEC30MASK_RD(src)                           (((src) & 0x40000000)>>30)
#define MSEC30MASK_WR(src)                      (((u32)(src)<<30) & 0x40000000)
#define MSEC30MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields MSEC29Mask    */
#define MSEC29MASK_WIDTH                                                      1
#define MSEC29MASK_SHIFT                                                     29
#define MSEC29MASK_MASK                                              0x20000000
#define MSEC29MASK_RD(src)                           (((src) & 0x20000000)>>29)
#define MSEC29MASK_WR(src)                      (((u32)(src)<<29) & 0x20000000)
#define MSEC29MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields MSEC28Mask    */
#define MSEC28MASK_WIDTH                                                      1
#define MSEC28MASK_SHIFT                                                     28
#define MSEC28MASK_MASK                                              0x10000000
#define MSEC28MASK_RD(src)                           (((src) & 0x10000000)>>28)
#define MSEC28MASK_WR(src)                      (((u32)(src)<<28) & 0x10000000)
#define MSEC28MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields MSEC27Mask    */
#define MSEC27MASK_WIDTH                                                      1
#define MSEC27MASK_SHIFT                                                     27
#define MSEC27MASK_MASK                                              0x08000000
#define MSEC27MASK_RD(src)                           (((src) & 0x08000000)>>27)
#define MSEC27MASK_WR(src)                      (((u32)(src)<<27) & 0x08000000)
#define MSEC27MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields MSEC26Mask    */
#define MSEC26MASK_WIDTH                                                      1
#define MSEC26MASK_SHIFT                                                     26
#define MSEC26MASK_MASK                                              0x04000000
#define MSEC26MASK_RD(src)                           (((src) & 0x04000000)>>26)
#define MSEC26MASK_WR(src)                      (((u32)(src)<<26) & 0x04000000)
#define MSEC26MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields MSEC25Mask    */
#define MSEC25MASK_WIDTH                                                      1
#define MSEC25MASK_SHIFT                                                     25
#define MSEC25MASK_MASK                                              0x02000000
#define MSEC25MASK_RD(src)                           (((src) & 0x02000000)>>25)
#define MSEC25MASK_WR(src)                      (((u32)(src)<<25) & 0x02000000)
#define MSEC25MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields MSEC24Mask    */
#define MSEC24MASK_WIDTH                                                      1
#define MSEC24MASK_SHIFT                                                     24
#define MSEC24MASK_MASK                                              0x01000000
#define MSEC24MASK_RD(src)                           (((src) & 0x01000000)>>24)
#define MSEC24MASK_WR(src)                      (((u32)(src)<<24) & 0x01000000)
#define MSEC24MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields MSEC23Mask    */
#define MSEC23MASK_WIDTH                                                      1
#define MSEC23MASK_SHIFT                                                     23
#define MSEC23MASK_MASK                                              0x00800000
#define MSEC23MASK_RD(src)                           (((src) & 0x00800000)>>23)
#define MSEC23MASK_WR(src)                      (((u32)(src)<<23) & 0x00800000)
#define MSEC23MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields MSEC22Mask    */
#define MSEC22MASK_WIDTH                                                      1
#define MSEC22MASK_SHIFT                                                     22
#define MSEC22MASK_MASK                                              0x00400000
#define MSEC22MASK_RD(src)                           (((src) & 0x00400000)>>22)
#define MSEC22MASK_WR(src)                      (((u32)(src)<<22) & 0x00400000)
#define MSEC22MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields MSEC21Mask    */
#define MSEC21MASK_WIDTH                                                      1
#define MSEC21MASK_SHIFT                                                     21
#define MSEC21MASK_MASK                                              0x00200000
#define MSEC21MASK_RD(src)                           (((src) & 0x00200000)>>21)
#define MSEC21MASK_WR(src)                      (((u32)(src)<<21) & 0x00200000)
#define MSEC21MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields MSEC20Mask    */
#define MSEC20MASK_WIDTH                                                      1
#define MSEC20MASK_SHIFT                                                     20
#define MSEC20MASK_MASK                                              0x00100000
#define MSEC20MASK_RD(src)                           (((src) & 0x00100000)>>20)
#define MSEC20MASK_WR(src)                      (((u32)(src)<<20) & 0x00100000)
#define MSEC20MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields MSEC19Mask    */
#define MSEC19MASK_WIDTH                                                      1
#define MSEC19MASK_SHIFT                                                     19
#define MSEC19MASK_MASK                                              0x00080000
#define MSEC19MASK_RD(src)                           (((src) & 0x00080000)>>19)
#define MSEC19MASK_WR(src)                      (((u32)(src)<<19) & 0x00080000)
#define MSEC19MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields MSEC18Mask    */
#define MSEC18MASK_WIDTH                                                      1
#define MSEC18MASK_SHIFT                                                     18
#define MSEC18MASK_MASK                                              0x00040000
#define MSEC18MASK_RD(src)                           (((src) & 0x00040000)>>18)
#define MSEC18MASK_WR(src)                      (((u32)(src)<<18) & 0x00040000)
#define MSEC18MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields MSEC17Mask    */
#define MSEC17MASK_WIDTH                                                      1
#define MSEC17MASK_SHIFT                                                     17
#define MSEC17MASK_MASK                                              0x00020000
#define MSEC17MASK_RD(src)                           (((src) & 0x00020000)>>17)
#define MSEC17MASK_WR(src)                      (((u32)(src)<<17) & 0x00020000)
#define MSEC17MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields MSEC16Mask    */
#define MSEC16MASK_WIDTH                                                      1
#define MSEC16MASK_SHIFT                                                     16
#define MSEC16MASK_MASK                                              0x00010000
#define MSEC16MASK_RD(src)                           (((src) & 0x00010000)>>16)
#define MSEC16MASK_WR(src)                      (((u32)(src)<<16) & 0x00010000)
#define MSEC16MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields MSEC15Mask    */
#define MSEC15MASK_WIDTH                                                      1
#define MSEC15MASK_SHIFT                                                     15
#define MSEC15MASK_MASK                                              0x00008000
#define MSEC15MASK_RD(src)                           (((src) & 0x00008000)>>15)
#define MSEC15MASK_WR(src)                      (((u32)(src)<<15) & 0x00008000)
#define MSEC15MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields MSEC14Mask    */
#define MSEC14MASK_WIDTH                                                      1
#define MSEC14MASK_SHIFT                                                     14
#define MSEC14MASK_MASK                                              0x00004000
#define MSEC14MASK_RD(src)                           (((src) & 0x00004000)>>14)
#define MSEC14MASK_WR(src)                      (((u32)(src)<<14) & 0x00004000)
#define MSEC14MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields MSEC13Mask    */
#define MSEC13MASK_WIDTH                                                      1
#define MSEC13MASK_SHIFT                                                     13
#define MSEC13MASK_MASK                                              0x00002000
#define MSEC13MASK_RD(src)                           (((src) & 0x00002000)>>13)
#define MSEC13MASK_WR(src)                      (((u32)(src)<<13) & 0x00002000)
#define MSEC13MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields MSEC12Mask    */
#define MSEC12MASK_WIDTH                                                      1
#define MSEC12MASK_SHIFT                                                     12
#define MSEC12MASK_MASK                                              0x00001000
#define MSEC12MASK_RD(src)                           (((src) & 0x00001000)>>12)
#define MSEC12MASK_WR(src)                      (((u32)(src)<<12) & 0x00001000)
#define MSEC12MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields MSEC11Mask    */
#define MSEC11MASK_WIDTH                                                      1
#define MSEC11MASK_SHIFT                                                     11
#define MSEC11MASK_MASK                                              0x00000800
#define MSEC11MASK_RD(src)                           (((src) & 0x00000800)>>11)
#define MSEC11MASK_WR(src)                      (((u32)(src)<<11) & 0x00000800)
#define MSEC11MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields MSEC10Mask    */
#define MSEC10MASK_WIDTH                                                      1
#define MSEC10MASK_SHIFT                                                     10
#define MSEC10MASK_MASK                                              0x00000400
#define MSEC10MASK_RD(src)                           (((src) & 0x00000400)>>10)
#define MSEC10MASK_WR(src)                      (((u32)(src)<<10) & 0x00000400)
#define MSEC10MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields MSEC9Mask    */
#define MSEC9MASK_WIDTH                                                       1
#define MSEC9MASK_SHIFT                                                       9
#define MSEC9MASK_MASK                                               0x00000200
#define MSEC9MASK_RD(src)                             (((src) & 0x00000200)>>9)
#define MSEC9MASK_WR(src)                        (((u32)(src)<<9) & 0x00000200)
#define MSEC9MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields MSEC8Mask    */
#define MSEC8MASK_WIDTH                                                       1
#define MSEC8MASK_SHIFT                                                       8
#define MSEC8MASK_MASK                                               0x00000100
#define MSEC8MASK_RD(src)                             (((src) & 0x00000100)>>8)
#define MSEC8MASK_WR(src)                        (((u32)(src)<<8) & 0x00000100)
#define MSEC8MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields MSEC7Mask    */
#define MSEC7MASK_WIDTH                                                       1
#define MSEC7MASK_SHIFT                                                       7
#define MSEC7MASK_MASK                                               0x00000080
#define MSEC7MASK_RD(src)                             (((src) & 0x00000080)>>7)
#define MSEC7MASK_WR(src)                        (((u32)(src)<<7) & 0x00000080)
#define MSEC7MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields MSEC6Mask    */
#define MSEC6MASK_WIDTH                                                       1
#define MSEC6MASK_SHIFT                                                       6
#define MSEC6MASK_MASK                                               0x00000040
#define MSEC6MASK_RD(src)                             (((src) & 0x00000040)>>6)
#define MSEC6MASK_WR(src)                        (((u32)(src)<<6) & 0x00000040)
#define MSEC6MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields MSEC5Mask    */
#define MSEC5MASK_WIDTH                                                       1
#define MSEC5MASK_SHIFT                                                       5
#define MSEC5MASK_MASK                                               0x00000020
#define MSEC5MASK_RD(src)                             (((src) & 0x00000020)>>5)
#define MSEC5MASK_WR(src)                        (((u32)(src)<<5) & 0x00000020)
#define MSEC5MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields MSEC4Mask    */
#define MSEC4MASK_WIDTH                                                       1
#define MSEC4MASK_SHIFT                                                       4
#define MSEC4MASK_MASK                                               0x00000010
#define MSEC4MASK_RD(src)                             (((src) & 0x00000010)>>4)
#define MSEC4MASK_WR(src)                        (((u32)(src)<<4) & 0x00000010)
#define MSEC4MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields MSEC3Mask    */
#define MSEC3MASK_WIDTH                                                       1
#define MSEC3MASK_SHIFT                                                       3
#define MSEC3MASK_MASK                                               0x00000008
#define MSEC3MASK_RD(src)                             (((src) & 0x00000008)>>3)
#define MSEC3MASK_WR(src)                        (((u32)(src)<<3) & 0x00000008)
#define MSEC3MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields MSEC2Mask    */
#define MSEC2MASK_WIDTH                                                       1
#define MSEC2MASK_SHIFT                                                       2
#define MSEC2MASK_MASK                                               0x00000004
#define MSEC2MASK_RD(src)                             (((src) & 0x00000004)>>2)
#define MSEC2MASK_WR(src)                        (((u32)(src)<<2) & 0x00000004)
#define MSEC2MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields MSEC1Mask    */
#define MSEC1MASK_WIDTH                                                       1
#define MSEC1MASK_SHIFT                                                       1
#define MSEC1MASK_MASK                                               0x00000002
#define MSEC1MASK_RD(src)                             (((src) & 0x00000002)>>1)
#define MSEC1MASK_WR(src)                        (((u32)(src)<<1) & 0x00000002)
#define MSEC1MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields MSEC0Mask    */
#define MSEC0MASK_WIDTH                                                       1
#define MSEC0MASK_SHIFT                                                       0
#define MSEC0MASK_MASK                                               0x00000001
#define MSEC0MASK_RD(src)                                (((src) & 0x00000001))
#define MSEC0MASK_WR(src)                           (((u32)(src)) & 0x00000001)
#define MSEC0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MSEC_ERRH	*/ 
/*	 Fields MSEC63	 */
#define MSEC63_WIDTH                                                          1
#define MSEC63_SHIFT                                                         31
#define MSEC63_MASK                                                  0x80000000
#define MSEC63_RD(src)                               (((src) & 0x80000000)>>31)
#define MSEC63_WR(src)                          (((u32)(src)<<31) & 0x80000000)
#define MSEC63_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields MSEC62	 */
#define MSEC62_WIDTH                                                          1
#define MSEC62_SHIFT                                                         30
#define MSEC62_MASK                                                  0x40000000
#define MSEC62_RD(src)                               (((src) & 0x40000000)>>30)
#define MSEC62_WR(src)                          (((u32)(src)<<30) & 0x40000000)
#define MSEC62_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields MSEC61	 */
#define MSEC61_WIDTH                                                          1
#define MSEC61_SHIFT                                                         29
#define MSEC61_MASK                                                  0x20000000
#define MSEC61_RD(src)                               (((src) & 0x20000000)>>29)
#define MSEC61_WR(src)                          (((u32)(src)<<29) & 0x20000000)
#define MSEC61_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields MSEC60	 */
#define MSEC60_WIDTH                                                          1
#define MSEC60_SHIFT                                                         28
#define MSEC60_MASK                                                  0x10000000
#define MSEC60_RD(src)                               (((src) & 0x10000000)>>28)
#define MSEC60_WR(src)                          (((u32)(src)<<28) & 0x10000000)
#define MSEC60_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields MSEC59	 */
#define MSEC59_WIDTH                                                          1
#define MSEC59_SHIFT                                                         27
#define MSEC59_MASK                                                  0x08000000
#define MSEC59_RD(src)                               (((src) & 0x08000000)>>27)
#define MSEC59_WR(src)                          (((u32)(src)<<27) & 0x08000000)
#define MSEC59_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields MSEC58	 */
#define MSEC58_WIDTH                                                          1
#define MSEC58_SHIFT                                                         26
#define MSEC58_MASK                                                  0x04000000
#define MSEC58_RD(src)                               (((src) & 0x04000000)>>26)
#define MSEC58_WR(src)                          (((u32)(src)<<26) & 0x04000000)
#define MSEC58_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields MSEC57	 */
#define MSEC57_WIDTH                                                          1
#define MSEC57_SHIFT                                                         25
#define MSEC57_MASK                                                  0x02000000
#define MSEC57_RD(src)                               (((src) & 0x02000000)>>25)
#define MSEC57_WR(src)                          (((u32)(src)<<25) & 0x02000000)
#define MSEC57_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields MSEC56	 */
#define MSEC56_WIDTH                                                          1
#define MSEC56_SHIFT                                                         24
#define MSEC56_MASK                                                  0x01000000
#define MSEC56_RD(src)                               (((src) & 0x01000000)>>24)
#define MSEC56_WR(src)                          (((u32)(src)<<24) & 0x01000000)
#define MSEC56_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields MSEC55	 */
#define MSEC55_WIDTH                                                          1
#define MSEC55_SHIFT                                                         23
#define MSEC55_MASK                                                  0x00800000
#define MSEC55_RD(src)                               (((src) & 0x00800000)>>23)
#define MSEC55_WR(src)                          (((u32)(src)<<23) & 0x00800000)
#define MSEC55_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields MSEC54	 */
#define MSEC54_WIDTH                                                          1
#define MSEC54_SHIFT                                                         22
#define MSEC54_MASK                                                  0x00400000
#define MSEC54_RD(src)                               (((src) & 0x00400000)>>22)
#define MSEC54_WR(src)                          (((u32)(src)<<22) & 0x00400000)
#define MSEC54_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields MSEC53	 */
#define MSEC53_WIDTH                                                          1
#define MSEC53_SHIFT                                                         21
#define MSEC53_MASK                                                  0x00200000
#define MSEC53_RD(src)                               (((src) & 0x00200000)>>21)
#define MSEC53_WR(src)                          (((u32)(src)<<21) & 0x00200000)
#define MSEC53_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields MSEC52	 */
#define MSEC52_WIDTH                                                          1
#define MSEC52_SHIFT                                                         20
#define MSEC52_MASK                                                  0x00100000
#define MSEC52_RD(src)                               (((src) & 0x00100000)>>20)
#define MSEC52_WR(src)                          (((u32)(src)<<20) & 0x00100000)
#define MSEC52_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields MSEC51	 */
#define MSEC51_WIDTH                                                          1
#define MSEC51_SHIFT                                                         19
#define MSEC51_MASK                                                  0x00080000
#define MSEC51_RD(src)                               (((src) & 0x00080000)>>19)
#define MSEC51_WR(src)                          (((u32)(src)<<19) & 0x00080000)
#define MSEC51_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields MSEC50	 */
#define MSEC50_WIDTH                                                          1
#define MSEC50_SHIFT                                                         18
#define MSEC50_MASK                                                  0x00040000
#define MSEC50_RD(src)                               (((src) & 0x00040000)>>18)
#define MSEC50_WR(src)                          (((u32)(src)<<18) & 0x00040000)
#define MSEC50_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields MSEC49	 */
#define MSEC49_WIDTH                                                          1
#define MSEC49_SHIFT                                                         17
#define MSEC49_MASK                                                  0x00020000
#define MSEC49_RD(src)                               (((src) & 0x00020000)>>17)
#define MSEC49_WR(src)                          (((u32)(src)<<17) & 0x00020000)
#define MSEC49_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields MSEC48	 */
#define MSEC48_WIDTH                                                          1
#define MSEC48_SHIFT                                                         16
#define MSEC48_MASK                                                  0x00010000
#define MSEC48_RD(src)                               (((src) & 0x00010000)>>16)
#define MSEC48_WR(src)                          (((u32)(src)<<16) & 0x00010000)
#define MSEC48_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields MSEC47	 */
#define MSEC47_WIDTH                                                          1
#define MSEC47_SHIFT                                                         15
#define MSEC47_MASK                                                  0x00008000
#define MSEC47_RD(src)                               (((src) & 0x00008000)>>15)
#define MSEC47_WR(src)                          (((u32)(src)<<15) & 0x00008000)
#define MSEC47_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields MSEC46	 */
#define MSEC46_WIDTH                                                          1
#define MSEC46_SHIFT                                                         14
#define MSEC46_MASK                                                  0x00004000
#define MSEC46_RD(src)                               (((src) & 0x00004000)>>14)
#define MSEC46_WR(src)                          (((u32)(src)<<14) & 0x00004000)
#define MSEC46_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields MSEC45	 */
#define MSEC45_WIDTH                                                          1
#define MSEC45_SHIFT                                                         13
#define MSEC45_MASK                                                  0x00002000
#define MSEC45_RD(src)                               (((src) & 0x00002000)>>13)
#define MSEC45_WR(src)                          (((u32)(src)<<13) & 0x00002000)
#define MSEC45_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields MSEC44	 */
#define MSEC44_WIDTH                                                          1
#define MSEC44_SHIFT                                                         12
#define MSEC44_MASK                                                  0x00001000
#define MSEC44_RD(src)                               (((src) & 0x00001000)>>12)
#define MSEC44_WR(src)                          (((u32)(src)<<12) & 0x00001000)
#define MSEC44_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields MSEC43	 */
#define MSEC43_WIDTH                                                          1
#define MSEC43_SHIFT                                                         11
#define MSEC43_MASK                                                  0x00000800
#define MSEC43_RD(src)                               (((src) & 0x00000800)>>11)
#define MSEC43_WR(src)                          (((u32)(src)<<11) & 0x00000800)
#define MSEC43_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields MSEC42	 */
#define MSEC42_WIDTH                                                          1
#define MSEC42_SHIFT                                                         10
#define MSEC42_MASK                                                  0x00000400
#define MSEC42_RD(src)                               (((src) & 0x00000400)>>10)
#define MSEC42_WR(src)                          (((u32)(src)<<10) & 0x00000400)
#define MSEC42_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields MSEC41	 */
#define MSEC41_WIDTH                                                          1
#define MSEC41_SHIFT                                                          9
#define MSEC41_MASK                                                  0x00000200
#define MSEC41_RD(src)                                (((src) & 0x00000200)>>9)
#define MSEC41_WR(src)                           (((u32)(src)<<9) & 0x00000200)
#define MSEC41_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields MSEC40	 */
#define MSEC40_WIDTH                                                          1
#define MSEC40_SHIFT                                                          8
#define MSEC40_MASK                                                  0x00000100
#define MSEC40_RD(src)                                (((src) & 0x00000100)>>8)
#define MSEC40_WR(src)                           (((u32)(src)<<8) & 0x00000100)
#define MSEC40_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields MSEC39	 */
#define MSEC39_WIDTH                                                          1
#define MSEC39_SHIFT                                                          7
#define MSEC39_MASK                                                  0x00000080
#define MSEC39_RD(src)                                (((src) & 0x00000080)>>7)
#define MSEC39_WR(src)                           (((u32)(src)<<7) & 0x00000080)
#define MSEC39_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields MSEC38	 */
#define MSEC38_WIDTH                                                          1
#define MSEC38_SHIFT                                                          6
#define MSEC38_MASK                                                  0x00000040
#define MSEC38_RD(src)                                (((src) & 0x00000040)>>6)
#define MSEC38_WR(src)                           (((u32)(src)<<6) & 0x00000040)
#define MSEC38_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields MSEC37	 */
#define MSEC37_WIDTH                                                          1
#define MSEC37_SHIFT                                                          5
#define MSEC37_MASK                                                  0x00000020
#define MSEC37_RD(src)                                (((src) & 0x00000020)>>5)
#define MSEC37_WR(src)                           (((u32)(src)<<5) & 0x00000020)
#define MSEC37_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields MSEC36	 */
#define MSEC36_WIDTH                                                          1
#define MSEC36_SHIFT                                                          4
#define MSEC36_MASK                                                  0x00000010
#define MSEC36_RD(src)                                (((src) & 0x00000010)>>4)
#define MSEC36_WR(src)                           (((u32)(src)<<4) & 0x00000010)
#define MSEC36_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields MSEC35	 */
#define MSEC35_WIDTH                                                          1
#define MSEC35_SHIFT                                                          3
#define MSEC35_MASK                                                  0x00000008
#define MSEC35_RD(src)                                (((src) & 0x00000008)>>3)
#define MSEC35_WR(src)                           (((u32)(src)<<3) & 0x00000008)
#define MSEC35_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields MSEC34	 */
#define MSEC34_WIDTH                                                          1
#define MSEC34_SHIFT                                                          2
#define MSEC34_MASK                                                  0x00000004
#define MSEC34_RD(src)                                (((src) & 0x00000004)>>2)
#define MSEC34_WR(src)                           (((u32)(src)<<2) & 0x00000004)
#define MSEC34_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields MSEC33	 */
#define MSEC33_WIDTH                                                          1
#define MSEC33_SHIFT                                                          1
#define MSEC33_MASK                                                  0x00000002
#define MSEC33_RD(src)                                (((src) & 0x00000002)>>1)
#define MSEC33_WR(src)                           (((u32)(src)<<1) & 0x00000002)
#define MSEC33_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields MSEC32	 */
#define MSEC32_WIDTH                                                          1
#define MSEC32_SHIFT                                                          0
#define MSEC32_MASK                                                  0x00000001
#define MSEC32_RD(src)                                   (((src) & 0x00000001))
#define MSEC32_WR(src)                              (((u32)(src)) & 0x00000001)
#define MSEC32_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MSEC_ERRHMask	*/
/*    Mask Register Fields MSEC63Mask    */
#define MSEC63MASK_WIDTH                                                      1
#define MSEC63MASK_SHIFT                                                     31
#define MSEC63MASK_MASK                                              0x80000000
#define MSEC63MASK_RD(src)                           (((src) & 0x80000000)>>31)
#define MSEC63MASK_WR(src)                      (((u32)(src)<<31) & 0x80000000)
#define MSEC63MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields MSEC62Mask    */
#define MSEC62MASK_WIDTH                                                      1
#define MSEC62MASK_SHIFT                                                     30
#define MSEC62MASK_MASK                                              0x40000000
#define MSEC62MASK_RD(src)                           (((src) & 0x40000000)>>30)
#define MSEC62MASK_WR(src)                      (((u32)(src)<<30) & 0x40000000)
#define MSEC62MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields MSEC61Mask    */
#define MSEC61MASK_WIDTH                                                      1
#define MSEC61MASK_SHIFT                                                     29
#define MSEC61MASK_MASK                                              0x20000000
#define MSEC61MASK_RD(src)                           (((src) & 0x20000000)>>29)
#define MSEC61MASK_WR(src)                      (((u32)(src)<<29) & 0x20000000)
#define MSEC61MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields MSEC60Mask    */
#define MSEC60MASK_WIDTH                                                      1
#define MSEC60MASK_SHIFT                                                     28
#define MSEC60MASK_MASK                                              0x10000000
#define MSEC60MASK_RD(src)                           (((src) & 0x10000000)>>28)
#define MSEC60MASK_WR(src)                      (((u32)(src)<<28) & 0x10000000)
#define MSEC60MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields MSEC59Mask    */
#define MSEC59MASK_WIDTH                                                      1
#define MSEC59MASK_SHIFT                                                     27
#define MSEC59MASK_MASK                                              0x08000000
#define MSEC59MASK_RD(src)                           (((src) & 0x08000000)>>27)
#define MSEC59MASK_WR(src)                      (((u32)(src)<<27) & 0x08000000)
#define MSEC59MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields MSEC58Mask    */
#define MSEC58MASK_WIDTH                                                      1
#define MSEC58MASK_SHIFT                                                     26
#define MSEC58MASK_MASK                                              0x04000000
#define MSEC58MASK_RD(src)                           (((src) & 0x04000000)>>26)
#define MSEC58MASK_WR(src)                      (((u32)(src)<<26) & 0x04000000)
#define MSEC58MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields MSEC57Mask    */
#define MSEC57MASK_WIDTH                                                      1
#define MSEC57MASK_SHIFT                                                     25
#define MSEC57MASK_MASK                                              0x02000000
#define MSEC57MASK_RD(src)                           (((src) & 0x02000000)>>25)
#define MSEC57MASK_WR(src)                      (((u32)(src)<<25) & 0x02000000)
#define MSEC57MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields MSEC56Mask    */
#define MSEC56MASK_WIDTH                                                      1
#define MSEC56MASK_SHIFT                                                     24
#define MSEC56MASK_MASK                                              0x01000000
#define MSEC56MASK_RD(src)                           (((src) & 0x01000000)>>24)
#define MSEC56MASK_WR(src)                      (((u32)(src)<<24) & 0x01000000)
#define MSEC56MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields MSEC55Mask    */
#define MSEC55MASK_WIDTH                                                      1
#define MSEC55MASK_SHIFT                                                     23
#define MSEC55MASK_MASK                                              0x00800000
#define MSEC55MASK_RD(src)                           (((src) & 0x00800000)>>23)
#define MSEC55MASK_WR(src)                      (((u32)(src)<<23) & 0x00800000)
#define MSEC55MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields MSEC54Mask    */
#define MSEC54MASK_WIDTH                                                      1
#define MSEC54MASK_SHIFT                                                     22
#define MSEC54MASK_MASK                                              0x00400000
#define MSEC54MASK_RD(src)                           (((src) & 0x00400000)>>22)
#define MSEC54MASK_WR(src)                      (((u32)(src)<<22) & 0x00400000)
#define MSEC54MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields MSEC53Mask    */
#define MSEC53MASK_WIDTH                                                      1
#define MSEC53MASK_SHIFT                                                     21
#define MSEC53MASK_MASK                                              0x00200000
#define MSEC53MASK_RD(src)                           (((src) & 0x00200000)>>21)
#define MSEC53MASK_WR(src)                      (((u32)(src)<<21) & 0x00200000)
#define MSEC53MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields MSEC52Mask    */
#define MSEC52MASK_WIDTH                                                      1
#define MSEC52MASK_SHIFT                                                     20
#define MSEC52MASK_MASK                                              0x00100000
#define MSEC52MASK_RD(src)                           (((src) & 0x00100000)>>20)
#define MSEC52MASK_WR(src)                      (((u32)(src)<<20) & 0x00100000)
#define MSEC52MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields MSEC51Mask    */
#define MSEC51MASK_WIDTH                                                      1
#define MSEC51MASK_SHIFT                                                     19
#define MSEC51MASK_MASK                                              0x00080000
#define MSEC51MASK_RD(src)                           (((src) & 0x00080000)>>19)
#define MSEC51MASK_WR(src)                      (((u32)(src)<<19) & 0x00080000)
#define MSEC51MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields MSEC50Mask    */
#define MSEC50MASK_WIDTH                                                      1
#define MSEC50MASK_SHIFT                                                     18
#define MSEC50MASK_MASK                                              0x00040000
#define MSEC50MASK_RD(src)                           (((src) & 0x00040000)>>18)
#define MSEC50MASK_WR(src)                      (((u32)(src)<<18) & 0x00040000)
#define MSEC50MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields MSEC49Mask    */
#define MSEC49MASK_WIDTH                                                      1
#define MSEC49MASK_SHIFT                                                     17
#define MSEC49MASK_MASK                                              0x00020000
#define MSEC49MASK_RD(src)                           (((src) & 0x00020000)>>17)
#define MSEC49MASK_WR(src)                      (((u32)(src)<<17) & 0x00020000)
#define MSEC49MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields MSEC48Mask    */
#define MSEC48MASK_WIDTH                                                      1
#define MSEC48MASK_SHIFT                                                     16
#define MSEC48MASK_MASK                                              0x00010000
#define MSEC48MASK_RD(src)                           (((src) & 0x00010000)>>16)
#define MSEC48MASK_WR(src)                      (((u32)(src)<<16) & 0x00010000)
#define MSEC48MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields MSEC47Mask    */
#define MSEC47MASK_WIDTH                                                      1
#define MSEC47MASK_SHIFT                                                     15
#define MSEC47MASK_MASK                                              0x00008000
#define MSEC47MASK_RD(src)                           (((src) & 0x00008000)>>15)
#define MSEC47MASK_WR(src)                      (((u32)(src)<<15) & 0x00008000)
#define MSEC47MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields MSEC46Mask    */
#define MSEC46MASK_WIDTH                                                      1
#define MSEC46MASK_SHIFT                                                     14
#define MSEC46MASK_MASK                                              0x00004000
#define MSEC46MASK_RD(src)                           (((src) & 0x00004000)>>14)
#define MSEC46MASK_WR(src)                      (((u32)(src)<<14) & 0x00004000)
#define MSEC46MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields MSEC45Mask    */
#define MSEC45MASK_WIDTH                                                      1
#define MSEC45MASK_SHIFT                                                     13
#define MSEC45MASK_MASK                                              0x00002000
#define MSEC45MASK_RD(src)                           (((src) & 0x00002000)>>13)
#define MSEC45MASK_WR(src)                      (((u32)(src)<<13) & 0x00002000)
#define MSEC45MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields MSEC44Mask    */
#define MSEC44MASK_WIDTH                                                      1
#define MSEC44MASK_SHIFT                                                     12
#define MSEC44MASK_MASK                                              0x00001000
#define MSEC44MASK_RD(src)                           (((src) & 0x00001000)>>12)
#define MSEC44MASK_WR(src)                      (((u32)(src)<<12) & 0x00001000)
#define MSEC44MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields MSEC43Mask    */
#define MSEC43MASK_WIDTH                                                      1
#define MSEC43MASK_SHIFT                                                     11
#define MSEC43MASK_MASK                                              0x00000800
#define MSEC43MASK_RD(src)                           (((src) & 0x00000800)>>11)
#define MSEC43MASK_WR(src)                      (((u32)(src)<<11) & 0x00000800)
#define MSEC43MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields MSEC42Mask    */
#define MSEC42MASK_WIDTH                                                      1
#define MSEC42MASK_SHIFT                                                     10
#define MSEC42MASK_MASK                                              0x00000400
#define MSEC42MASK_RD(src)                           (((src) & 0x00000400)>>10)
#define MSEC42MASK_WR(src)                      (((u32)(src)<<10) & 0x00000400)
#define MSEC42MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields MSEC41Mask    */
#define MSEC41MASK_WIDTH                                                      1
#define MSEC41MASK_SHIFT                                                      9
#define MSEC41MASK_MASK                                              0x00000200
#define MSEC41MASK_RD(src)                            (((src) & 0x00000200)>>9)
#define MSEC41MASK_WR(src)                       (((u32)(src)<<9) & 0x00000200)
#define MSEC41MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields MSEC40Mask    */
#define MSEC40MASK_WIDTH                                                      1
#define MSEC40MASK_SHIFT                                                      8
#define MSEC40MASK_MASK                                              0x00000100
#define MSEC40MASK_RD(src)                            (((src) & 0x00000100)>>8)
#define MSEC40MASK_WR(src)                       (((u32)(src)<<8) & 0x00000100)
#define MSEC40MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields MSEC39Mask    */
#define MSEC39MASK_WIDTH                                                      1
#define MSEC39MASK_SHIFT                                                      7
#define MSEC39MASK_MASK                                              0x00000080
#define MSEC39MASK_RD(src)                            (((src) & 0x00000080)>>7)
#define MSEC39MASK_WR(src)                       (((u32)(src)<<7) & 0x00000080)
#define MSEC39MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields MSEC38Mask    */
#define MSEC38MASK_WIDTH                                                      1
#define MSEC38MASK_SHIFT                                                      6
#define MSEC38MASK_MASK                                              0x00000040
#define MSEC38MASK_RD(src)                            (((src) & 0x00000040)>>6)
#define MSEC38MASK_WR(src)                       (((u32)(src)<<6) & 0x00000040)
#define MSEC38MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields MSEC37Mask    */
#define MSEC37MASK_WIDTH                                                      1
#define MSEC37MASK_SHIFT                                                      5
#define MSEC37MASK_MASK                                              0x00000020
#define MSEC37MASK_RD(src)                            (((src) & 0x00000020)>>5)
#define MSEC37MASK_WR(src)                       (((u32)(src)<<5) & 0x00000020)
#define MSEC37MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields MSEC36Mask    */
#define MSEC36MASK_WIDTH                                                      1
#define MSEC36MASK_SHIFT                                                      4
#define MSEC36MASK_MASK                                              0x00000010
#define MSEC36MASK_RD(src)                            (((src) & 0x00000010)>>4)
#define MSEC36MASK_WR(src)                       (((u32)(src)<<4) & 0x00000010)
#define MSEC36MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields MSEC35Mask    */
#define MSEC35MASK_WIDTH                                                      1
#define MSEC35MASK_SHIFT                                                      3
#define MSEC35MASK_MASK                                              0x00000008
#define MSEC35MASK_RD(src)                            (((src) & 0x00000008)>>3)
#define MSEC35MASK_WR(src)                       (((u32)(src)<<3) & 0x00000008)
#define MSEC35MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields MSEC34Mask    */
#define MSEC34MASK_WIDTH                                                      1
#define MSEC34MASK_SHIFT                                                      2
#define MSEC34MASK_MASK                                              0x00000004
#define MSEC34MASK_RD(src)                            (((src) & 0x00000004)>>2)
#define MSEC34MASK_WR(src)                       (((u32)(src)<<2) & 0x00000004)
#define MSEC34MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields MSEC33Mask    */
#define MSEC33MASK_WIDTH                                                      1
#define MSEC33MASK_SHIFT                                                      1
#define MSEC33MASK_MASK                                              0x00000002
#define MSEC33MASK_RD(src)                            (((src) & 0x00000002)>>1)
#define MSEC33MASK_WR(src)                       (((u32)(src)<<1) & 0x00000002)
#define MSEC33MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields MSEC32Mask    */
#define MSEC32MASK_WIDTH                                                      1
#define MSEC32MASK_SHIFT                                                      0
#define MSEC32MASK_MASK                                              0x00000001
#define MSEC32MASK_RD(src)                               (((src) & 0x00000001))
#define MSEC32MASK_WR(src)                          (((u32)(src)) & 0x00000001)
#define MSEC32MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_DED_ERRL	*/ 
/*	 Fields DED31	 */
#define DED31_WIDTH                                                           1
#define DED31_SHIFT                                                          31
#define DED31_MASK                                                   0x80000000
#define DED31_RD(src)                                (((src) & 0x80000000)>>31)
#define DED31_WR(src)                           (((u32)(src)<<31) & 0x80000000)
#define DED31_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields DED30	 */
#define DED30_WIDTH                                                           1
#define DED30_SHIFT                                                          30
#define DED30_MASK                                                   0x40000000
#define DED30_RD(src)                                (((src) & 0x40000000)>>30)
#define DED30_WR(src)                           (((u32)(src)<<30) & 0x40000000)
#define DED30_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields DED29	 */
#define DED29_WIDTH                                                           1
#define DED29_SHIFT                                                          29
#define DED29_MASK                                                   0x20000000
#define DED29_RD(src)                                (((src) & 0x20000000)>>29)
#define DED29_WR(src)                           (((u32)(src)<<29) & 0x20000000)
#define DED29_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields DED28	 */
#define DED28_WIDTH                                                           1
#define DED28_SHIFT                                                          28
#define DED28_MASK                                                   0x10000000
#define DED28_RD(src)                                (((src) & 0x10000000)>>28)
#define DED28_WR(src)                           (((u32)(src)<<28) & 0x10000000)
#define DED28_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields DED27	 */
#define DED27_WIDTH                                                           1
#define DED27_SHIFT                                                          27
#define DED27_MASK                                                   0x08000000
#define DED27_RD(src)                                (((src) & 0x08000000)>>27)
#define DED27_WR(src)                           (((u32)(src)<<27) & 0x08000000)
#define DED27_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields DED26	 */
#define DED26_WIDTH                                                           1
#define DED26_SHIFT                                                          26
#define DED26_MASK                                                   0x04000000
#define DED26_RD(src)                                (((src) & 0x04000000)>>26)
#define DED26_WR(src)                           (((u32)(src)<<26) & 0x04000000)
#define DED26_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields DED25	 */
#define DED25_WIDTH                                                           1
#define DED25_SHIFT                                                          25
#define DED25_MASK                                                   0x02000000
#define DED25_RD(src)                                (((src) & 0x02000000)>>25)
#define DED25_WR(src)                           (((u32)(src)<<25) & 0x02000000)
#define DED25_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields DED24	 */
#define DED24_WIDTH                                                           1
#define DED24_SHIFT                                                          24
#define DED24_MASK                                                   0x01000000
#define DED24_RD(src)                                (((src) & 0x01000000)>>24)
#define DED24_WR(src)                           (((u32)(src)<<24) & 0x01000000)
#define DED24_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields DED23	 */
#define DED23_WIDTH                                                           1
#define DED23_SHIFT                                                          23
#define DED23_MASK                                                   0x00800000
#define DED23_RD(src)                                (((src) & 0x00800000)>>23)
#define DED23_WR(src)                           (((u32)(src)<<23) & 0x00800000)
#define DED23_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields DED22	 */
#define DED22_WIDTH                                                           1
#define DED22_SHIFT                                                          22
#define DED22_MASK                                                   0x00400000
#define DED22_RD(src)                                (((src) & 0x00400000)>>22)
#define DED22_WR(src)                           (((u32)(src)<<22) & 0x00400000)
#define DED22_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields DED21	 */
#define DED21_WIDTH                                                           1
#define DED21_SHIFT                                                          21
#define DED21_MASK                                                   0x00200000
#define DED21_RD(src)                                (((src) & 0x00200000)>>21)
#define DED21_WR(src)                           (((u32)(src)<<21) & 0x00200000)
#define DED21_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields DED20	 */
#define DED20_WIDTH                                                           1
#define DED20_SHIFT                                                          20
#define DED20_MASK                                                   0x00100000
#define DED20_RD(src)                                (((src) & 0x00100000)>>20)
#define DED20_WR(src)                           (((u32)(src)<<20) & 0x00100000)
#define DED20_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields DED19	 */
#define DED19_WIDTH                                                           1
#define DED19_SHIFT                                                          19
#define DED19_MASK                                                   0x00080000
#define DED19_RD(src)                                (((src) & 0x00080000)>>19)
#define DED19_WR(src)                           (((u32)(src)<<19) & 0x00080000)
#define DED19_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields DED18	 */
#define DED18_WIDTH                                                           1
#define DED18_SHIFT                                                          18
#define DED18_MASK                                                   0x00040000
#define DED18_RD(src)                                (((src) & 0x00040000)>>18)
#define DED18_WR(src)                           (((u32)(src)<<18) & 0x00040000)
#define DED18_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields DED17	 */
#define DED17_WIDTH                                                           1
#define DED17_SHIFT                                                          17
#define DED17_MASK                                                   0x00020000
#define DED17_RD(src)                                (((src) & 0x00020000)>>17)
#define DED17_WR(src)                           (((u32)(src)<<17) & 0x00020000)
#define DED17_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields DED16	 */
#define DED16_WIDTH                                                           1
#define DED16_SHIFT                                                          16
#define DED16_MASK                                                   0x00010000
#define DED16_RD(src)                                (((src) & 0x00010000)>>16)
#define DED16_WR(src)                           (((u32)(src)<<16) & 0x00010000)
#define DED16_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields DED15	 */
#define DED15_WIDTH                                                           1
#define DED15_SHIFT                                                          15
#define DED15_MASK                                                   0x00008000
#define DED15_RD(src)                                (((src) & 0x00008000)>>15)
#define DED15_WR(src)                           (((u32)(src)<<15) & 0x00008000)
#define DED15_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields DED14	 */
#define DED14_WIDTH                                                           1
#define DED14_SHIFT                                                          14
#define DED14_MASK                                                   0x00004000
#define DED14_RD(src)                                (((src) & 0x00004000)>>14)
#define DED14_WR(src)                           (((u32)(src)<<14) & 0x00004000)
#define DED14_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields DED13	 */
#define DED13_WIDTH                                                           1
#define DED13_SHIFT                                                          13
#define DED13_MASK                                                   0x00002000
#define DED13_RD(src)                                (((src) & 0x00002000)>>13)
#define DED13_WR(src)                           (((u32)(src)<<13) & 0x00002000)
#define DED13_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields DED12	 */
#define DED12_WIDTH                                                           1
#define DED12_SHIFT                                                          12
#define DED12_MASK                                                   0x00001000
#define DED12_RD(src)                                (((src) & 0x00001000)>>12)
#define DED12_WR(src)                           (((u32)(src)<<12) & 0x00001000)
#define DED12_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields DED11	 */
#define DED11_WIDTH                                                           1
#define DED11_SHIFT                                                          11
#define DED11_MASK                                                   0x00000800
#define DED11_RD(src)                                (((src) & 0x00000800)>>11)
#define DED11_WR(src)                           (((u32)(src)<<11) & 0x00000800)
#define DED11_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields DED10	 */
#define DED10_WIDTH                                                           1
#define DED10_SHIFT                                                          10
#define DED10_MASK                                                   0x00000400
#define DED10_RD(src)                                (((src) & 0x00000400)>>10)
#define DED10_WR(src)                           (((u32)(src)<<10) & 0x00000400)
#define DED10_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields DED9	 */
#define DED9_WIDTH                                                            1
#define DED9_SHIFT                                                            9
#define DED9_MASK                                                    0x00000200
#define DED9_RD(src)                                  (((src) & 0x00000200)>>9)
#define DED9_WR(src)                             (((u32)(src)<<9) & 0x00000200)
#define DED9_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields DED8	 */
#define DED8_WIDTH                                                            1
#define DED8_SHIFT                                                            8
#define DED8_MASK                                                    0x00000100
#define DED8_RD(src)                                  (((src) & 0x00000100)>>8)
#define DED8_WR(src)                             (((u32)(src)<<8) & 0x00000100)
#define DED8_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields DED7	 */
#define DED7_WIDTH                                                            1
#define DED7_SHIFT                                                            7
#define DED7_MASK                                                    0x00000080
#define DED7_RD(src)                                  (((src) & 0x00000080)>>7)
#define DED7_WR(src)                             (((u32)(src)<<7) & 0x00000080)
#define DED7_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields DED6	 */
#define DED6_WIDTH                                                            1
#define DED6_SHIFT                                                            6
#define DED6_MASK                                                    0x00000040
#define DED6_RD(src)                                  (((src) & 0x00000040)>>6)
#define DED6_WR(src)                             (((u32)(src)<<6) & 0x00000040)
#define DED6_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields DED5	 */
#define DED5_WIDTH                                                            1
#define DED5_SHIFT                                                            5
#define DED5_MASK                                                    0x00000020
#define DED5_RD(src)                                  (((src) & 0x00000020)>>5)
#define DED5_WR(src)                             (((u32)(src)<<5) & 0x00000020)
#define DED5_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields DED4	 */
#define DED4_WIDTH                                                            1
#define DED4_SHIFT                                                            4
#define DED4_MASK                                                    0x00000010
#define DED4_RD(src)                                  (((src) & 0x00000010)>>4)
#define DED4_WR(src)                             (((u32)(src)<<4) & 0x00000010)
#define DED4_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields DED3	 */
#define DED3_WIDTH                                                            1
#define DED3_SHIFT                                                            3
#define DED3_MASK                                                    0x00000008
#define DED3_RD(src)                                  (((src) & 0x00000008)>>3)
#define DED3_WR(src)                             (((u32)(src)<<3) & 0x00000008)
#define DED3_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields DED2	 */
#define DED2_WIDTH                                                            1
#define DED2_SHIFT                                                            2
#define DED2_MASK                                                    0x00000004
#define DED2_RD(src)                                  (((src) & 0x00000004)>>2)
#define DED2_WR(src)                             (((u32)(src)<<2) & 0x00000004)
#define DED2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields DED1	 */
#define DED1_WIDTH                                                            1
#define DED1_SHIFT                                                            1
#define DED1_MASK                                                    0x00000002
#define DED1_RD(src)                                  (((src) & 0x00000002)>>1)
#define DED1_WR(src)                             (((u32)(src)<<1) & 0x00000002)
#define DED1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields DED0	 */
#define DED0_WIDTH                                                            1
#define DED0_SHIFT                                                            0
#define DED0_MASK                                                    0x00000001
#define DED0_RD(src)                                     (((src) & 0x00000001))
#define DED0_WR(src)                                (((u32)(src)) & 0x00000001)
#define DED0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_DED_ERRLMask	*/
/*    Mask Register Fields DED31Mask    */
#define DED31MASK_WIDTH                                                       1
#define DED31MASK_SHIFT                                                      31
#define DED31MASK_MASK                                               0x80000000
#define DED31MASK_RD(src)                            (((src) & 0x80000000)>>31)
#define DED31MASK_WR(src)                       (((u32)(src)<<31) & 0x80000000)
#define DED31MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields DED30Mask    */
#define DED30MASK_WIDTH                                                       1
#define DED30MASK_SHIFT                                                      30
#define DED30MASK_MASK                                               0x40000000
#define DED30MASK_RD(src)                            (((src) & 0x40000000)>>30)
#define DED30MASK_WR(src)                       (((u32)(src)<<30) & 0x40000000)
#define DED30MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields DED29Mask    */
#define DED29MASK_WIDTH                                                       1
#define DED29MASK_SHIFT                                                      29
#define DED29MASK_MASK                                               0x20000000
#define DED29MASK_RD(src)                            (((src) & 0x20000000)>>29)
#define DED29MASK_WR(src)                       (((u32)(src)<<29) & 0x20000000)
#define DED29MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields DED28Mask    */
#define DED28MASK_WIDTH                                                       1
#define DED28MASK_SHIFT                                                      28
#define DED28MASK_MASK                                               0x10000000
#define DED28MASK_RD(src)                            (((src) & 0x10000000)>>28)
#define DED28MASK_WR(src)                       (((u32)(src)<<28) & 0x10000000)
#define DED28MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields DED27Mask    */
#define DED27MASK_WIDTH                                                       1
#define DED27MASK_SHIFT                                                      27
#define DED27MASK_MASK                                               0x08000000
#define DED27MASK_RD(src)                            (((src) & 0x08000000)>>27)
#define DED27MASK_WR(src)                       (((u32)(src)<<27) & 0x08000000)
#define DED27MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields DED26Mask    */
#define DED26MASK_WIDTH                                                       1
#define DED26MASK_SHIFT                                                      26
#define DED26MASK_MASK                                               0x04000000
#define DED26MASK_RD(src)                            (((src) & 0x04000000)>>26)
#define DED26MASK_WR(src)                       (((u32)(src)<<26) & 0x04000000)
#define DED26MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields DED25Mask    */
#define DED25MASK_WIDTH                                                       1
#define DED25MASK_SHIFT                                                      25
#define DED25MASK_MASK                                               0x02000000
#define DED25MASK_RD(src)                            (((src) & 0x02000000)>>25)
#define DED25MASK_WR(src)                       (((u32)(src)<<25) & 0x02000000)
#define DED25MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields DED24Mask    */
#define DED24MASK_WIDTH                                                       1
#define DED24MASK_SHIFT                                                      24
#define DED24MASK_MASK                                               0x01000000
#define DED24MASK_RD(src)                            (((src) & 0x01000000)>>24)
#define DED24MASK_WR(src)                       (((u32)(src)<<24) & 0x01000000)
#define DED24MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields DED23Mask    */
#define DED23MASK_WIDTH                                                       1
#define DED23MASK_SHIFT                                                      23
#define DED23MASK_MASK                                               0x00800000
#define DED23MASK_RD(src)                            (((src) & 0x00800000)>>23)
#define DED23MASK_WR(src)                       (((u32)(src)<<23) & 0x00800000)
#define DED23MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields DED22Mask    */
#define DED22MASK_WIDTH                                                       1
#define DED22MASK_SHIFT                                                      22
#define DED22MASK_MASK                                               0x00400000
#define DED22MASK_RD(src)                            (((src) & 0x00400000)>>22)
#define DED22MASK_WR(src)                       (((u32)(src)<<22) & 0x00400000)
#define DED22MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields DED21Mask    */
#define DED21MASK_WIDTH                                                       1
#define DED21MASK_SHIFT                                                      21
#define DED21MASK_MASK                                               0x00200000
#define DED21MASK_RD(src)                            (((src) & 0x00200000)>>21)
#define DED21MASK_WR(src)                       (((u32)(src)<<21) & 0x00200000)
#define DED21MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields DED20Mask    */
#define DED20MASK_WIDTH                                                       1
#define DED20MASK_SHIFT                                                      20
#define DED20MASK_MASK                                               0x00100000
#define DED20MASK_RD(src)                            (((src) & 0x00100000)>>20)
#define DED20MASK_WR(src)                       (((u32)(src)<<20) & 0x00100000)
#define DED20MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields DED19Mask    */
#define DED19MASK_WIDTH                                                       1
#define DED19MASK_SHIFT                                                      19
#define DED19MASK_MASK                                               0x00080000
#define DED19MASK_RD(src)                            (((src) & 0x00080000)>>19)
#define DED19MASK_WR(src)                       (((u32)(src)<<19) & 0x00080000)
#define DED19MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields DED18Mask    */
#define DED18MASK_WIDTH                                                       1
#define DED18MASK_SHIFT                                                      18
#define DED18MASK_MASK                                               0x00040000
#define DED18MASK_RD(src)                            (((src) & 0x00040000)>>18)
#define DED18MASK_WR(src)                       (((u32)(src)<<18) & 0x00040000)
#define DED18MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields DED17Mask    */
#define DED17MASK_WIDTH                                                       1
#define DED17MASK_SHIFT                                                      17
#define DED17MASK_MASK                                               0x00020000
#define DED17MASK_RD(src)                            (((src) & 0x00020000)>>17)
#define DED17MASK_WR(src)                       (((u32)(src)<<17) & 0x00020000)
#define DED17MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields DED16Mask    */
#define DED16MASK_WIDTH                                                       1
#define DED16MASK_SHIFT                                                      16
#define DED16MASK_MASK                                               0x00010000
#define DED16MASK_RD(src)                            (((src) & 0x00010000)>>16)
#define DED16MASK_WR(src)                       (((u32)(src)<<16) & 0x00010000)
#define DED16MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields DED15Mask    */
#define DED15MASK_WIDTH                                                       1
#define DED15MASK_SHIFT                                                      15
#define DED15MASK_MASK                                               0x00008000
#define DED15MASK_RD(src)                            (((src) & 0x00008000)>>15)
#define DED15MASK_WR(src)                       (((u32)(src)<<15) & 0x00008000)
#define DED15MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields DED14Mask    */
#define DED14MASK_WIDTH                                                       1
#define DED14MASK_SHIFT                                                      14
#define DED14MASK_MASK                                               0x00004000
#define DED14MASK_RD(src)                            (((src) & 0x00004000)>>14)
#define DED14MASK_WR(src)                       (((u32)(src)<<14) & 0x00004000)
#define DED14MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields DED13Mask    */
#define DED13MASK_WIDTH                                                       1
#define DED13MASK_SHIFT                                                      13
#define DED13MASK_MASK                                               0x00002000
#define DED13MASK_RD(src)                            (((src) & 0x00002000)>>13)
#define DED13MASK_WR(src)                       (((u32)(src)<<13) & 0x00002000)
#define DED13MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields DED12Mask    */
#define DED12MASK_WIDTH                                                       1
#define DED12MASK_SHIFT                                                      12
#define DED12MASK_MASK                                               0x00001000
#define DED12MASK_RD(src)                            (((src) & 0x00001000)>>12)
#define DED12MASK_WR(src)                       (((u32)(src)<<12) & 0x00001000)
#define DED12MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields DED11Mask    */
#define DED11MASK_WIDTH                                                       1
#define DED11MASK_SHIFT                                                      11
#define DED11MASK_MASK                                               0x00000800
#define DED11MASK_RD(src)                            (((src) & 0x00000800)>>11)
#define DED11MASK_WR(src)                       (((u32)(src)<<11) & 0x00000800)
#define DED11MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields DED10Mask    */
#define DED10MASK_WIDTH                                                       1
#define DED10MASK_SHIFT                                                      10
#define DED10MASK_MASK                                               0x00000400
#define DED10MASK_RD(src)                            (((src) & 0x00000400)>>10)
#define DED10MASK_WR(src)                       (((u32)(src)<<10) & 0x00000400)
#define DED10MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields DED9Mask    */
#define DED9MASK_WIDTH                                                        1
#define DED9MASK_SHIFT                                                        9
#define DED9MASK_MASK                                                0x00000200
#define DED9MASK_RD(src)                              (((src) & 0x00000200)>>9)
#define DED9MASK_WR(src)                         (((u32)(src)<<9) & 0x00000200)
#define DED9MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields DED8Mask    */
#define DED8MASK_WIDTH                                                        1
#define DED8MASK_SHIFT                                                        8
#define DED8MASK_MASK                                                0x00000100
#define DED8MASK_RD(src)                              (((src) & 0x00000100)>>8)
#define DED8MASK_WR(src)                         (((u32)(src)<<8) & 0x00000100)
#define DED8MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields DED7Mask    */
#define DED7MASK_WIDTH                                                        1
#define DED7MASK_SHIFT                                                        7
#define DED7MASK_MASK                                                0x00000080
#define DED7MASK_RD(src)                              (((src) & 0x00000080)>>7)
#define DED7MASK_WR(src)                         (((u32)(src)<<7) & 0x00000080)
#define DED7MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields DED6Mask    */
#define DED6MASK_WIDTH                                                        1
#define DED6MASK_SHIFT                                                        6
#define DED6MASK_MASK                                                0x00000040
#define DED6MASK_RD(src)                              (((src) & 0x00000040)>>6)
#define DED6MASK_WR(src)                         (((u32)(src)<<6) & 0x00000040)
#define DED6MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields DED5Mask    */
#define DED5MASK_WIDTH                                                        1
#define DED5MASK_SHIFT                                                        5
#define DED5MASK_MASK                                                0x00000020
#define DED5MASK_RD(src)                              (((src) & 0x00000020)>>5)
#define DED5MASK_WR(src)                         (((u32)(src)<<5) & 0x00000020)
#define DED5MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields DED4Mask    */
#define DED4MASK_WIDTH                                                        1
#define DED4MASK_SHIFT                                                        4
#define DED4MASK_MASK                                                0x00000010
#define DED4MASK_RD(src)                              (((src) & 0x00000010)>>4)
#define DED4MASK_WR(src)                         (((u32)(src)<<4) & 0x00000010)
#define DED4MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields DED3Mask    */
#define DED3MASK_WIDTH                                                        1
#define DED3MASK_SHIFT                                                        3
#define DED3MASK_MASK                                                0x00000008
#define DED3MASK_RD(src)                              (((src) & 0x00000008)>>3)
#define DED3MASK_WR(src)                         (((u32)(src)<<3) & 0x00000008)
#define DED3MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields DED2Mask    */
#define DED2MASK_WIDTH                                                        1
#define DED2MASK_SHIFT                                                        2
#define DED2MASK_MASK                                                0x00000004
#define DED2MASK_RD(src)                              (((src) & 0x00000004)>>2)
#define DED2MASK_WR(src)                         (((u32)(src)<<2) & 0x00000004)
#define DED2MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields DED1Mask    */
#define DED1MASK_WIDTH                                                        1
#define DED1MASK_SHIFT                                                        1
#define DED1MASK_MASK                                                0x00000002
#define DED1MASK_RD(src)                              (((src) & 0x00000002)>>1)
#define DED1MASK_WR(src)                         (((u32)(src)<<1) & 0x00000002)
#define DED1MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields DED0Mask    */
#define DED0MASK_WIDTH                                                        1
#define DED0MASK_SHIFT                                                        0
#define DED0MASK_MASK                                                0x00000001
#define DED0MASK_RD(src)                                 (((src) & 0x00000001))
#define DED0MASK_WR(src)                            (((u32)(src)) & 0x00000001)
#define DED0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_DED_ERRH	*/ 
/*	 Fields DED63	 */
#define DED63_WIDTH                                                           1
#define DED63_SHIFT                                                          31
#define DED63_MASK                                                   0x80000000
#define DED63_RD(src)                                (((src) & 0x80000000)>>31)
#define DED63_WR(src)                           (((u32)(src)<<31) & 0x80000000)
#define DED63_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields DED62	 */
#define DED62_WIDTH                                                           1
#define DED62_SHIFT                                                          30
#define DED62_MASK                                                   0x40000000
#define DED62_RD(src)                                (((src) & 0x40000000)>>30)
#define DED62_WR(src)                           (((u32)(src)<<30) & 0x40000000)
#define DED62_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields DED61	 */
#define DED61_WIDTH                                                           1
#define DED61_SHIFT                                                          29
#define DED61_MASK                                                   0x20000000
#define DED61_RD(src)                                (((src) & 0x20000000)>>29)
#define DED61_WR(src)                           (((u32)(src)<<29) & 0x20000000)
#define DED61_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields DED60	 */
#define DED60_WIDTH                                                           1
#define DED60_SHIFT                                                          28
#define DED60_MASK                                                   0x10000000
#define DED60_RD(src)                                (((src) & 0x10000000)>>28)
#define DED60_WR(src)                           (((u32)(src)<<28) & 0x10000000)
#define DED60_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields DED59	 */
#define DED59_WIDTH                                                           1
#define DED59_SHIFT                                                          27
#define DED59_MASK                                                   0x08000000
#define DED59_RD(src)                                (((src) & 0x08000000)>>27)
#define DED59_WR(src)                           (((u32)(src)<<27) & 0x08000000)
#define DED59_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields DED58	 */
#define DED58_WIDTH                                                           1
#define DED58_SHIFT                                                          26
#define DED58_MASK                                                   0x04000000
#define DED58_RD(src)                                (((src) & 0x04000000)>>26)
#define DED58_WR(src)                           (((u32)(src)<<26) & 0x04000000)
#define DED58_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields DED57	 */
#define DED57_WIDTH                                                           1
#define DED57_SHIFT                                                          25
#define DED57_MASK                                                   0x02000000
#define DED57_RD(src)                                (((src) & 0x02000000)>>25)
#define DED57_WR(src)                           (((u32)(src)<<25) & 0x02000000)
#define DED57_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields DED56	 */
#define DED56_WIDTH                                                           1
#define DED56_SHIFT                                                          24
#define DED56_MASK                                                   0x01000000
#define DED56_RD(src)                                (((src) & 0x01000000)>>24)
#define DED56_WR(src)                           (((u32)(src)<<24) & 0x01000000)
#define DED56_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields DED55	 */
#define DED55_WIDTH                                                           1
#define DED55_SHIFT                                                          23
#define DED55_MASK                                                   0x00800000
#define DED55_RD(src)                                (((src) & 0x00800000)>>23)
#define DED55_WR(src)                           (((u32)(src)<<23) & 0x00800000)
#define DED55_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields DED54	 */
#define DED54_WIDTH                                                           1
#define DED54_SHIFT                                                          22
#define DED54_MASK                                                   0x00400000
#define DED54_RD(src)                                (((src) & 0x00400000)>>22)
#define DED54_WR(src)                           (((u32)(src)<<22) & 0x00400000)
#define DED54_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields DED53	 */
#define DED53_WIDTH                                                           1
#define DED53_SHIFT                                                          21
#define DED53_MASK                                                   0x00200000
#define DED53_RD(src)                                (((src) & 0x00200000)>>21)
#define DED53_WR(src)                           (((u32)(src)<<21) & 0x00200000)
#define DED53_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields DED52	 */
#define DED52_WIDTH                                                           1
#define DED52_SHIFT                                                          20
#define DED52_MASK                                                   0x00100000
#define DED52_RD(src)                                (((src) & 0x00100000)>>20)
#define DED52_WR(src)                           (((u32)(src)<<20) & 0x00100000)
#define DED52_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields DED51	 */
#define DED51_WIDTH                                                           1
#define DED51_SHIFT                                                          19
#define DED51_MASK                                                   0x00080000
#define DED51_RD(src)                                (((src) & 0x00080000)>>19)
#define DED51_WR(src)                           (((u32)(src)<<19) & 0x00080000)
#define DED51_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields DED50	 */
#define DED50_WIDTH                                                           1
#define DED50_SHIFT                                                          18
#define DED50_MASK                                                   0x00040000
#define DED50_RD(src)                                (((src) & 0x00040000)>>18)
#define DED50_WR(src)                           (((u32)(src)<<18) & 0x00040000)
#define DED50_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields DED49	 */
#define DED49_WIDTH                                                           1
#define DED49_SHIFT                                                          17
#define DED49_MASK                                                   0x00020000
#define DED49_RD(src)                                (((src) & 0x00020000)>>17)
#define DED49_WR(src)                           (((u32)(src)<<17) & 0x00020000)
#define DED49_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields DED48	 */
#define DED48_WIDTH                                                           1
#define DED48_SHIFT                                                          16
#define DED48_MASK                                                   0x00010000
#define DED48_RD(src)                                (((src) & 0x00010000)>>16)
#define DED48_WR(src)                           (((u32)(src)<<16) & 0x00010000)
#define DED48_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields DED47	 */
#define DED47_WIDTH                                                           1
#define DED47_SHIFT                                                          15
#define DED47_MASK                                                   0x00008000
#define DED47_RD(src)                                (((src) & 0x00008000)>>15)
#define DED47_WR(src)                           (((u32)(src)<<15) & 0x00008000)
#define DED47_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields DED46	 */
#define DED46_WIDTH                                                           1
#define DED46_SHIFT                                                          14
#define DED46_MASK                                                   0x00004000
#define DED46_RD(src)                                (((src) & 0x00004000)>>14)
#define DED46_WR(src)                           (((u32)(src)<<14) & 0x00004000)
#define DED46_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields DED45	 */
#define DED45_WIDTH                                                           1
#define DED45_SHIFT                                                          13
#define DED45_MASK                                                   0x00002000
#define DED45_RD(src)                                (((src) & 0x00002000)>>13)
#define DED45_WR(src)                           (((u32)(src)<<13) & 0x00002000)
#define DED45_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields DED44	 */
#define DED44_WIDTH                                                           1
#define DED44_SHIFT                                                          12
#define DED44_MASK                                                   0x00001000
#define DED44_RD(src)                                (((src) & 0x00001000)>>12)
#define DED44_WR(src)                           (((u32)(src)<<12) & 0x00001000)
#define DED44_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields DED43	 */
#define DED43_WIDTH                                                           1
#define DED43_SHIFT                                                          11
#define DED43_MASK                                                   0x00000800
#define DED43_RD(src)                                (((src) & 0x00000800)>>11)
#define DED43_WR(src)                           (((u32)(src)<<11) & 0x00000800)
#define DED43_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields DED42	 */
#define DED42_WIDTH                                                           1
#define DED42_SHIFT                                                          10
#define DED42_MASK                                                   0x00000400
#define DED42_RD(src)                                (((src) & 0x00000400)>>10)
#define DED42_WR(src)                           (((u32)(src)<<10) & 0x00000400)
#define DED42_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields DED41	 */
#define DED41_WIDTH                                                           1
#define DED41_SHIFT                                                           9
#define DED41_MASK                                                   0x00000200
#define DED41_RD(src)                                 (((src) & 0x00000200)>>9)
#define DED41_WR(src)                            (((u32)(src)<<9) & 0x00000200)
#define DED41_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields DED40	 */
#define DED40_WIDTH                                                           1
#define DED40_SHIFT                                                           8
#define DED40_MASK                                                   0x00000100
#define DED40_RD(src)                                 (((src) & 0x00000100)>>8)
#define DED40_WR(src)                            (((u32)(src)<<8) & 0x00000100)
#define DED40_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields DED39	 */
#define DED39_WIDTH                                                           1
#define DED39_SHIFT                                                           7
#define DED39_MASK                                                   0x00000080
#define DED39_RD(src)                                 (((src) & 0x00000080)>>7)
#define DED39_WR(src)                            (((u32)(src)<<7) & 0x00000080)
#define DED39_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields DED38	 */
#define DED38_WIDTH                                                           1
#define DED38_SHIFT                                                           6
#define DED38_MASK                                                   0x00000040
#define DED38_RD(src)                                 (((src) & 0x00000040)>>6)
#define DED38_WR(src)                            (((u32)(src)<<6) & 0x00000040)
#define DED38_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields DED37	 */
#define DED37_WIDTH                                                           1
#define DED37_SHIFT                                                           5
#define DED37_MASK                                                   0x00000020
#define DED37_RD(src)                                 (((src) & 0x00000020)>>5)
#define DED37_WR(src)                            (((u32)(src)<<5) & 0x00000020)
#define DED37_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields DED36	 */
#define DED36_WIDTH                                                           1
#define DED36_SHIFT                                                           4
#define DED36_MASK                                                   0x00000010
#define DED36_RD(src)                                 (((src) & 0x00000010)>>4)
#define DED36_WR(src)                            (((u32)(src)<<4) & 0x00000010)
#define DED36_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields DED35	 */
#define DED35_WIDTH                                                           1
#define DED35_SHIFT                                                           3
#define DED35_MASK                                                   0x00000008
#define DED35_RD(src)                                 (((src) & 0x00000008)>>3)
#define DED35_WR(src)                            (((u32)(src)<<3) & 0x00000008)
#define DED35_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields DED34	 */
#define DED34_WIDTH                                                           1
#define DED34_SHIFT                                                           2
#define DED34_MASK                                                   0x00000004
#define DED34_RD(src)                                 (((src) & 0x00000004)>>2)
#define DED34_WR(src)                            (((u32)(src)<<2) & 0x00000004)
#define DED34_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields DED33	 */
#define DED33_WIDTH                                                           1
#define DED33_SHIFT                                                           1
#define DED33_MASK                                                   0x00000002
#define DED33_RD(src)                                 (((src) & 0x00000002)>>1)
#define DED33_WR(src)                            (((u32)(src)<<1) & 0x00000002)
#define DED33_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields DED32	 */
#define DED32_WIDTH                                                           1
#define DED32_SHIFT                                                           0
#define DED32_MASK                                                   0x00000001
#define DED32_RD(src)                                    (((src) & 0x00000001))
#define DED32_WR(src)                               (((u32)(src)) & 0x00000001)
#define DED32_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_DED_ERRHMask	*/
/*    Mask Register Fields DED63Mask    */
#define DED63MASK_WIDTH                                                       1
#define DED63MASK_SHIFT                                                      31
#define DED63MASK_MASK                                               0x80000000
#define DED63MASK_RD(src)                            (((src) & 0x80000000)>>31)
#define DED63MASK_WR(src)                       (((u32)(src)<<31) & 0x80000000)
#define DED63MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields DED62Mask    */
#define DED62MASK_WIDTH                                                       1
#define DED62MASK_SHIFT                                                      30
#define DED62MASK_MASK                                               0x40000000
#define DED62MASK_RD(src)                            (((src) & 0x40000000)>>30)
#define DED62MASK_WR(src)                       (((u32)(src)<<30) & 0x40000000)
#define DED62MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields DED61Mask    */
#define DED61MASK_WIDTH                                                       1
#define DED61MASK_SHIFT                                                      29
#define DED61MASK_MASK                                               0x20000000
#define DED61MASK_RD(src)                            (((src) & 0x20000000)>>29)
#define DED61MASK_WR(src)                       (((u32)(src)<<29) & 0x20000000)
#define DED61MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields DED60Mask    */
#define DED60MASK_WIDTH                                                       1
#define DED60MASK_SHIFT                                                      28
#define DED60MASK_MASK                                               0x10000000
#define DED60MASK_RD(src)                            (((src) & 0x10000000)>>28)
#define DED60MASK_WR(src)                       (((u32)(src)<<28) & 0x10000000)
#define DED60MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields DED59Mask    */
#define DED59MASK_WIDTH                                                       1
#define DED59MASK_SHIFT                                                      27
#define DED59MASK_MASK                                               0x08000000
#define DED59MASK_RD(src)                            (((src) & 0x08000000)>>27)
#define DED59MASK_WR(src)                       (((u32)(src)<<27) & 0x08000000)
#define DED59MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields DED58Mask    */
#define DED58MASK_WIDTH                                                       1
#define DED58MASK_SHIFT                                                      26
#define DED58MASK_MASK                                               0x04000000
#define DED58MASK_RD(src)                            (((src) & 0x04000000)>>26)
#define DED58MASK_WR(src)                       (((u32)(src)<<26) & 0x04000000)
#define DED58MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields DED57Mask    */
#define DED57MASK_WIDTH                                                       1
#define DED57MASK_SHIFT                                                      25
#define DED57MASK_MASK                                               0x02000000
#define DED57MASK_RD(src)                            (((src) & 0x02000000)>>25)
#define DED57MASK_WR(src)                       (((u32)(src)<<25) & 0x02000000)
#define DED57MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields DED56Mask    */
#define DED56MASK_WIDTH                                                       1
#define DED56MASK_SHIFT                                                      24
#define DED56MASK_MASK                                               0x01000000
#define DED56MASK_RD(src)                            (((src) & 0x01000000)>>24)
#define DED56MASK_WR(src)                       (((u32)(src)<<24) & 0x01000000)
#define DED56MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields DED55Mask    */
#define DED55MASK_WIDTH                                                       1
#define DED55MASK_SHIFT                                                      23
#define DED55MASK_MASK                                               0x00800000
#define DED55MASK_RD(src)                            (((src) & 0x00800000)>>23)
#define DED55MASK_WR(src)                       (((u32)(src)<<23) & 0x00800000)
#define DED55MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields DED54Mask    */
#define DED54MASK_WIDTH                                                       1
#define DED54MASK_SHIFT                                                      22
#define DED54MASK_MASK                                               0x00400000
#define DED54MASK_RD(src)                            (((src) & 0x00400000)>>22)
#define DED54MASK_WR(src)                       (((u32)(src)<<22) & 0x00400000)
#define DED54MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields DED53Mask    */
#define DED53MASK_WIDTH                                                       1
#define DED53MASK_SHIFT                                                      21
#define DED53MASK_MASK                                               0x00200000
#define DED53MASK_RD(src)                            (((src) & 0x00200000)>>21)
#define DED53MASK_WR(src)                       (((u32)(src)<<21) & 0x00200000)
#define DED53MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields DED52Mask    */
#define DED52MASK_WIDTH                                                       1
#define DED52MASK_SHIFT                                                      20
#define DED52MASK_MASK                                               0x00100000
#define DED52MASK_RD(src)                            (((src) & 0x00100000)>>20)
#define DED52MASK_WR(src)                       (((u32)(src)<<20) & 0x00100000)
#define DED52MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields DED51Mask    */
#define DED51MASK_WIDTH                                                       1
#define DED51MASK_SHIFT                                                      19
#define DED51MASK_MASK                                               0x00080000
#define DED51MASK_RD(src)                            (((src) & 0x00080000)>>19)
#define DED51MASK_WR(src)                       (((u32)(src)<<19) & 0x00080000)
#define DED51MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields DED50Mask    */
#define DED50MASK_WIDTH                                                       1
#define DED50MASK_SHIFT                                                      18
#define DED50MASK_MASK                                               0x00040000
#define DED50MASK_RD(src)                            (((src) & 0x00040000)>>18)
#define DED50MASK_WR(src)                       (((u32)(src)<<18) & 0x00040000)
#define DED50MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields DED49Mask    */
#define DED49MASK_WIDTH                                                       1
#define DED49MASK_SHIFT                                                      17
#define DED49MASK_MASK                                               0x00020000
#define DED49MASK_RD(src)                            (((src) & 0x00020000)>>17)
#define DED49MASK_WR(src)                       (((u32)(src)<<17) & 0x00020000)
#define DED49MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields DED48Mask    */
#define DED48MASK_WIDTH                                                       1
#define DED48MASK_SHIFT                                                      16
#define DED48MASK_MASK                                               0x00010000
#define DED48MASK_RD(src)                            (((src) & 0x00010000)>>16)
#define DED48MASK_WR(src)                       (((u32)(src)<<16) & 0x00010000)
#define DED48MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields DED47Mask    */
#define DED47MASK_WIDTH                                                       1
#define DED47MASK_SHIFT                                                      15
#define DED47MASK_MASK                                               0x00008000
#define DED47MASK_RD(src)                            (((src) & 0x00008000)>>15)
#define DED47MASK_WR(src)                       (((u32)(src)<<15) & 0x00008000)
#define DED47MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields DED46Mask    */
#define DED46MASK_WIDTH                                                       1
#define DED46MASK_SHIFT                                                      14
#define DED46MASK_MASK                                               0x00004000
#define DED46MASK_RD(src)                            (((src) & 0x00004000)>>14)
#define DED46MASK_WR(src)                       (((u32)(src)<<14) & 0x00004000)
#define DED46MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields DED45Mask    */
#define DED45MASK_WIDTH                                                       1
#define DED45MASK_SHIFT                                                      13
#define DED45MASK_MASK                                               0x00002000
#define DED45MASK_RD(src)                            (((src) & 0x00002000)>>13)
#define DED45MASK_WR(src)                       (((u32)(src)<<13) & 0x00002000)
#define DED45MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields DED44Mask    */
#define DED44MASK_WIDTH                                                       1
#define DED44MASK_SHIFT                                                      12
#define DED44MASK_MASK                                               0x00001000
#define DED44MASK_RD(src)                            (((src) & 0x00001000)>>12)
#define DED44MASK_WR(src)                       (((u32)(src)<<12) & 0x00001000)
#define DED44MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields DED43Mask    */
#define DED43MASK_WIDTH                                                       1
#define DED43MASK_SHIFT                                                      11
#define DED43MASK_MASK                                               0x00000800
#define DED43MASK_RD(src)                            (((src) & 0x00000800)>>11)
#define DED43MASK_WR(src)                       (((u32)(src)<<11) & 0x00000800)
#define DED43MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields DED42Mask    */
#define DED42MASK_WIDTH                                                       1
#define DED42MASK_SHIFT                                                      10
#define DED42MASK_MASK                                               0x00000400
#define DED42MASK_RD(src)                            (((src) & 0x00000400)>>10)
#define DED42MASK_WR(src)                       (((u32)(src)<<10) & 0x00000400)
#define DED42MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields DED41Mask    */
#define DED41MASK_WIDTH                                                       1
#define DED41MASK_SHIFT                                                       9
#define DED41MASK_MASK                                               0x00000200
#define DED41MASK_RD(src)                             (((src) & 0x00000200)>>9)
#define DED41MASK_WR(src)                        (((u32)(src)<<9) & 0x00000200)
#define DED41MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields DED40Mask    */
#define DED40MASK_WIDTH                                                       1
#define DED40MASK_SHIFT                                                       8
#define DED40MASK_MASK                                               0x00000100
#define DED40MASK_RD(src)                             (((src) & 0x00000100)>>8)
#define DED40MASK_WR(src)                        (((u32)(src)<<8) & 0x00000100)
#define DED40MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields DED39Mask    */
#define DED39MASK_WIDTH                                                       1
#define DED39MASK_SHIFT                                                       7
#define DED39MASK_MASK                                               0x00000080
#define DED39MASK_RD(src)                             (((src) & 0x00000080)>>7)
#define DED39MASK_WR(src)                        (((u32)(src)<<7) & 0x00000080)
#define DED39MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields DED38Mask    */
#define DED38MASK_WIDTH                                                       1
#define DED38MASK_SHIFT                                                       6
#define DED38MASK_MASK                                               0x00000040
#define DED38MASK_RD(src)                             (((src) & 0x00000040)>>6)
#define DED38MASK_WR(src)                        (((u32)(src)<<6) & 0x00000040)
#define DED38MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields DED37Mask    */
#define DED37MASK_WIDTH                                                       1
#define DED37MASK_SHIFT                                                       5
#define DED37MASK_MASK                                               0x00000020
#define DED37MASK_RD(src)                             (((src) & 0x00000020)>>5)
#define DED37MASK_WR(src)                        (((u32)(src)<<5) & 0x00000020)
#define DED37MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields DED36Mask    */
#define DED36MASK_WIDTH                                                       1
#define DED36MASK_SHIFT                                                       4
#define DED36MASK_MASK                                               0x00000010
#define DED36MASK_RD(src)                             (((src) & 0x00000010)>>4)
#define DED36MASK_WR(src)                        (((u32)(src)<<4) & 0x00000010)
#define DED36MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields DED35Mask    */
#define DED35MASK_WIDTH                                                       1
#define DED35MASK_SHIFT                                                       3
#define DED35MASK_MASK                                               0x00000008
#define DED35MASK_RD(src)                             (((src) & 0x00000008)>>3)
#define DED35MASK_WR(src)                        (((u32)(src)<<3) & 0x00000008)
#define DED35MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields DED34Mask    */
#define DED34MASK_WIDTH                                                       1
#define DED34MASK_SHIFT                                                       2
#define DED34MASK_MASK                                               0x00000004
#define DED34MASK_RD(src)                             (((src) & 0x00000004)>>2)
#define DED34MASK_WR(src)                        (((u32)(src)<<2) & 0x00000004)
#define DED34MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields DED33Mask    */
#define DED33MASK_WIDTH                                                       1
#define DED33MASK_SHIFT                                                       1
#define DED33MASK_MASK                                               0x00000002
#define DED33MASK_RD(src)                             (((src) & 0x00000002)>>1)
#define DED33MASK_WR(src)                        (((u32)(src)<<1) & 0x00000002)
#define DED33MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields DED32Mask    */
#define DED32MASK_WIDTH                                                       1
#define DED32MASK_SHIFT                                                       0
#define DED32MASK_MASK                                               0x00000001
#define DED32MASK_RD(src)                                (((src) & 0x00000001))
#define DED32MASK_WR(src)                           (((u32)(src)) & 0x00000001)
#define DED32MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MDED_ERRL	*/ 
/*	 Fields MDED31	 */
#define MDED31_WIDTH                                                          1
#define MDED31_SHIFT                                                         31
#define MDED31_MASK                                                  0x80000000
#define MDED31_RD(src)                               (((src) & 0x80000000)>>31)
#define MDED31_WR(src)                          (((u32)(src)<<31) & 0x80000000)
#define MDED31_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields MDED30	 */
#define MDED30_WIDTH                                                          1
#define MDED30_SHIFT                                                         30
#define MDED30_MASK                                                  0x40000000
#define MDED30_RD(src)                               (((src) & 0x40000000)>>30)
#define MDED30_WR(src)                          (((u32)(src)<<30) & 0x40000000)
#define MDED30_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields MDED29	 */
#define MDED29_WIDTH                                                          1
#define MDED29_SHIFT                                                         29
#define MDED29_MASK                                                  0x20000000
#define MDED29_RD(src)                               (((src) & 0x20000000)>>29)
#define MDED29_WR(src)                          (((u32)(src)<<29) & 0x20000000)
#define MDED29_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields MDED28	 */
#define MDED28_WIDTH                                                          1
#define MDED28_SHIFT                                                         28
#define MDED28_MASK                                                  0x10000000
#define MDED28_RD(src)                               (((src) & 0x10000000)>>28)
#define MDED28_WR(src)                          (((u32)(src)<<28) & 0x10000000)
#define MDED28_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields MDED27	 */
#define MDED27_WIDTH                                                          1
#define MDED27_SHIFT                                                         27
#define MDED27_MASK                                                  0x08000000
#define MDED27_RD(src)                               (((src) & 0x08000000)>>27)
#define MDED27_WR(src)                          (((u32)(src)<<27) & 0x08000000)
#define MDED27_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields MDED26	 */
#define MDED26_WIDTH                                                          1
#define MDED26_SHIFT                                                         26
#define MDED26_MASK                                                  0x04000000
#define MDED26_RD(src)                               (((src) & 0x04000000)>>26)
#define MDED26_WR(src)                          (((u32)(src)<<26) & 0x04000000)
#define MDED26_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields MDED25	 */
#define MDED25_WIDTH                                                          1
#define MDED25_SHIFT                                                         25
#define MDED25_MASK                                                  0x02000000
#define MDED25_RD(src)                               (((src) & 0x02000000)>>25)
#define MDED25_WR(src)                          (((u32)(src)<<25) & 0x02000000)
#define MDED25_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields MDED24	 */
#define MDED24_WIDTH                                                          1
#define MDED24_SHIFT                                                         24
#define MDED24_MASK                                                  0x01000000
#define MDED24_RD(src)                               (((src) & 0x01000000)>>24)
#define MDED24_WR(src)                          (((u32)(src)<<24) & 0x01000000)
#define MDED24_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields MDED23	 */
#define MDED23_WIDTH                                                          1
#define MDED23_SHIFT                                                         23
#define MDED23_MASK                                                  0x00800000
#define MDED23_RD(src)                               (((src) & 0x00800000)>>23)
#define MDED23_WR(src)                          (((u32)(src)<<23) & 0x00800000)
#define MDED23_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields MDED22	 */
#define MDED22_WIDTH                                                          1
#define MDED22_SHIFT                                                         22
#define MDED22_MASK                                                  0x00400000
#define MDED22_RD(src)                               (((src) & 0x00400000)>>22)
#define MDED22_WR(src)                          (((u32)(src)<<22) & 0x00400000)
#define MDED22_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields MDED21	 */
#define MDED21_WIDTH                                                          1
#define MDED21_SHIFT                                                         21
#define MDED21_MASK                                                  0x00200000
#define MDED21_RD(src)                               (((src) & 0x00200000)>>21)
#define MDED21_WR(src)                          (((u32)(src)<<21) & 0x00200000)
#define MDED21_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields MDED20	 */
#define MDED20_WIDTH                                                          1
#define MDED20_SHIFT                                                         20
#define MDED20_MASK                                                  0x00100000
#define MDED20_RD(src)                               (((src) & 0x00100000)>>20)
#define MDED20_WR(src)                          (((u32)(src)<<20) & 0x00100000)
#define MDED20_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields MDED19	 */
#define MDED19_WIDTH                                                          1
#define MDED19_SHIFT                                                         19
#define MDED19_MASK                                                  0x00080000
#define MDED19_RD(src)                               (((src) & 0x00080000)>>19)
#define MDED19_WR(src)                          (((u32)(src)<<19) & 0x00080000)
#define MDED19_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields MDED18	 */
#define MDED18_WIDTH                                                          1
#define MDED18_SHIFT                                                         18
#define MDED18_MASK                                                  0x00040000
#define MDED18_RD(src)                               (((src) & 0x00040000)>>18)
#define MDED18_WR(src)                          (((u32)(src)<<18) & 0x00040000)
#define MDED18_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields MDED17	 */
#define MDED17_WIDTH                                                          1
#define MDED17_SHIFT                                                         17
#define MDED17_MASK                                                  0x00020000
#define MDED17_RD(src)                               (((src) & 0x00020000)>>17)
#define MDED17_WR(src)                          (((u32)(src)<<17) & 0x00020000)
#define MDED17_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields MDED16	 */
#define MDED16_WIDTH                                                          1
#define MDED16_SHIFT                                                         16
#define MDED16_MASK                                                  0x00010000
#define MDED16_RD(src)                               (((src) & 0x00010000)>>16)
#define MDED16_WR(src)                          (((u32)(src)<<16) & 0x00010000)
#define MDED16_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields MDED15	 */
#define MDED15_WIDTH                                                          1
#define MDED15_SHIFT                                                         15
#define MDED15_MASK                                                  0x00008000
#define MDED15_RD(src)                               (((src) & 0x00008000)>>15)
#define MDED15_WR(src)                          (((u32)(src)<<15) & 0x00008000)
#define MDED15_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields MDED14	 */
#define MDED14_WIDTH                                                          1
#define MDED14_SHIFT                                                         14
#define MDED14_MASK                                                  0x00004000
#define MDED14_RD(src)                               (((src) & 0x00004000)>>14)
#define MDED14_WR(src)                          (((u32)(src)<<14) & 0x00004000)
#define MDED14_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields MDED13	 */
#define MDED13_WIDTH                                                          1
#define MDED13_SHIFT                                                         13
#define MDED13_MASK                                                  0x00002000
#define MDED13_RD(src)                               (((src) & 0x00002000)>>13)
#define MDED13_WR(src)                          (((u32)(src)<<13) & 0x00002000)
#define MDED13_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields MDED12	 */
#define MDED12_WIDTH                                                          1
#define MDED12_SHIFT                                                         12
#define MDED12_MASK                                                  0x00001000
#define MDED12_RD(src)                               (((src) & 0x00001000)>>12)
#define MDED12_WR(src)                          (((u32)(src)<<12) & 0x00001000)
#define MDED12_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields MDED11	 */
#define MDED11_WIDTH                                                          1
#define MDED11_SHIFT                                                         11
#define MDED11_MASK                                                  0x00000800
#define MDED11_RD(src)                               (((src) & 0x00000800)>>11)
#define MDED11_WR(src)                          (((u32)(src)<<11) & 0x00000800)
#define MDED11_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields MDED10	 */
#define MDED10_WIDTH                                                          1
#define MDED10_SHIFT                                                         10
#define MDED10_MASK                                                  0x00000400
#define MDED10_RD(src)                               (((src) & 0x00000400)>>10)
#define MDED10_WR(src)                          (((u32)(src)<<10) & 0x00000400)
#define MDED10_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields MDED9	 */
#define MDED9_WIDTH                                                           1
#define MDED9_SHIFT                                                           9
#define MDED9_MASK                                                   0x00000200
#define MDED9_RD(src)                                 (((src) & 0x00000200)>>9)
#define MDED9_WR(src)                            (((u32)(src)<<9) & 0x00000200)
#define MDED9_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields MDED8	 */
#define MDED8_WIDTH                                                           1
#define MDED8_SHIFT                                                           8
#define MDED8_MASK                                                   0x00000100
#define MDED8_RD(src)                                 (((src) & 0x00000100)>>8)
#define MDED8_WR(src)                            (((u32)(src)<<8) & 0x00000100)
#define MDED8_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields MDED7	 */
#define MDED7_WIDTH                                                           1
#define MDED7_SHIFT                                                           7
#define MDED7_MASK                                                   0x00000080
#define MDED7_RD(src)                                 (((src) & 0x00000080)>>7)
#define MDED7_WR(src)                            (((u32)(src)<<7) & 0x00000080)
#define MDED7_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields MDED6	 */
#define MDED6_WIDTH                                                           1
#define MDED6_SHIFT                                                           6
#define MDED6_MASK                                                   0x00000040
#define MDED6_RD(src)                                 (((src) & 0x00000040)>>6)
#define MDED6_WR(src)                            (((u32)(src)<<6) & 0x00000040)
#define MDED6_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields MDED5	 */
#define MDED5_WIDTH                                                           1
#define MDED5_SHIFT                                                           5
#define MDED5_MASK                                                   0x00000020
#define MDED5_RD(src)                                 (((src) & 0x00000020)>>5)
#define MDED5_WR(src)                            (((u32)(src)<<5) & 0x00000020)
#define MDED5_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields MDED4	 */
#define MDED4_WIDTH                                                           1
#define MDED4_SHIFT                                                           4
#define MDED4_MASK                                                   0x00000010
#define MDED4_RD(src)                                 (((src) & 0x00000010)>>4)
#define MDED4_WR(src)                            (((u32)(src)<<4) & 0x00000010)
#define MDED4_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields MDED3	 */
#define MDED3_WIDTH                                                           1
#define MDED3_SHIFT                                                           3
#define MDED3_MASK                                                   0x00000008
#define MDED3_RD(src)                                 (((src) & 0x00000008)>>3)
#define MDED3_WR(src)                            (((u32)(src)<<3) & 0x00000008)
#define MDED3_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields MDED2	 */
#define MDED2_WIDTH                                                           1
#define MDED2_SHIFT                                                           2
#define MDED2_MASK                                                   0x00000004
#define MDED2_RD(src)                                 (((src) & 0x00000004)>>2)
#define MDED2_WR(src)                            (((u32)(src)<<2) & 0x00000004)
#define MDED2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields MDED1	 */
#define MDED1_WIDTH                                                           1
#define MDED1_SHIFT                                                           1
#define MDED1_MASK                                                   0x00000002
#define MDED1_RD(src)                                 (((src) & 0x00000002)>>1)
#define MDED1_WR(src)                            (((u32)(src)<<1) & 0x00000002)
#define MDED1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields MDED0	 */
#define MDED0_WIDTH                                                           1
#define MDED0_SHIFT                                                           0
#define MDED0_MASK                                                   0x00000001
#define MDED0_RD(src)                                    (((src) & 0x00000001))
#define MDED0_WR(src)                               (((u32)(src)) & 0x00000001)
#define MDED0_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MDED_ERRLMask	*/
/*    Mask Register Fields MDED31Mask    */
#define MDED31MASK_WIDTH                                                      1
#define MDED31MASK_SHIFT                                                     31
#define MDED31MASK_MASK                                              0x80000000
#define MDED31MASK_RD(src)                           (((src) & 0x80000000)>>31)
#define MDED31MASK_WR(src)                      (((u32)(src)<<31) & 0x80000000)
#define MDED31MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields MDED30Mask    */
#define MDED30MASK_WIDTH                                                      1
#define MDED30MASK_SHIFT                                                     30
#define MDED30MASK_MASK                                              0x40000000
#define MDED30MASK_RD(src)                           (((src) & 0x40000000)>>30)
#define MDED30MASK_WR(src)                      (((u32)(src)<<30) & 0x40000000)
#define MDED30MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields MDED29Mask    */
#define MDED29MASK_WIDTH                                                      1
#define MDED29MASK_SHIFT                                                     29
#define MDED29MASK_MASK                                              0x20000000
#define MDED29MASK_RD(src)                           (((src) & 0x20000000)>>29)
#define MDED29MASK_WR(src)                      (((u32)(src)<<29) & 0x20000000)
#define MDED29MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields MDED28Mask    */
#define MDED28MASK_WIDTH                                                      1
#define MDED28MASK_SHIFT                                                     28
#define MDED28MASK_MASK                                              0x10000000
#define MDED28MASK_RD(src)                           (((src) & 0x10000000)>>28)
#define MDED28MASK_WR(src)                      (((u32)(src)<<28) & 0x10000000)
#define MDED28MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields MDED27Mask    */
#define MDED27MASK_WIDTH                                                      1
#define MDED27MASK_SHIFT                                                     27
#define MDED27MASK_MASK                                              0x08000000
#define MDED27MASK_RD(src)                           (((src) & 0x08000000)>>27)
#define MDED27MASK_WR(src)                      (((u32)(src)<<27) & 0x08000000)
#define MDED27MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields MDED26Mask    */
#define MDED26MASK_WIDTH                                                      1
#define MDED26MASK_SHIFT                                                     26
#define MDED26MASK_MASK                                              0x04000000
#define MDED26MASK_RD(src)                           (((src) & 0x04000000)>>26)
#define MDED26MASK_WR(src)                      (((u32)(src)<<26) & 0x04000000)
#define MDED26MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields MDED25Mask    */
#define MDED25MASK_WIDTH                                                      1
#define MDED25MASK_SHIFT                                                     25
#define MDED25MASK_MASK                                              0x02000000
#define MDED25MASK_RD(src)                           (((src) & 0x02000000)>>25)
#define MDED25MASK_WR(src)                      (((u32)(src)<<25) & 0x02000000)
#define MDED25MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields MDED24Mask    */
#define MDED24MASK_WIDTH                                                      1
#define MDED24MASK_SHIFT                                                     24
#define MDED24MASK_MASK                                              0x01000000
#define MDED24MASK_RD(src)                           (((src) & 0x01000000)>>24)
#define MDED24MASK_WR(src)                      (((u32)(src)<<24) & 0x01000000)
#define MDED24MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields MDED23Mask    */
#define MDED23MASK_WIDTH                                                      1
#define MDED23MASK_SHIFT                                                     23
#define MDED23MASK_MASK                                              0x00800000
#define MDED23MASK_RD(src)                           (((src) & 0x00800000)>>23)
#define MDED23MASK_WR(src)                      (((u32)(src)<<23) & 0x00800000)
#define MDED23MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields MDED22Mask    */
#define MDED22MASK_WIDTH                                                      1
#define MDED22MASK_SHIFT                                                     22
#define MDED22MASK_MASK                                              0x00400000
#define MDED22MASK_RD(src)                           (((src) & 0x00400000)>>22)
#define MDED22MASK_WR(src)                      (((u32)(src)<<22) & 0x00400000)
#define MDED22MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields MDED21Mask    */
#define MDED21MASK_WIDTH                                                      1
#define MDED21MASK_SHIFT                                                     21
#define MDED21MASK_MASK                                              0x00200000
#define MDED21MASK_RD(src)                           (((src) & 0x00200000)>>21)
#define MDED21MASK_WR(src)                      (((u32)(src)<<21) & 0x00200000)
#define MDED21MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields MDED20Mask    */
#define MDED20MASK_WIDTH                                                      1
#define MDED20MASK_SHIFT                                                     20
#define MDED20MASK_MASK                                              0x00100000
#define MDED20MASK_RD(src)                           (((src) & 0x00100000)>>20)
#define MDED20MASK_WR(src)                      (((u32)(src)<<20) & 0x00100000)
#define MDED20MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields MDED19Mask    */
#define MDED19MASK_WIDTH                                                      1
#define MDED19MASK_SHIFT                                                     19
#define MDED19MASK_MASK                                              0x00080000
#define MDED19MASK_RD(src)                           (((src) & 0x00080000)>>19)
#define MDED19MASK_WR(src)                      (((u32)(src)<<19) & 0x00080000)
#define MDED19MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields MDED18Mask    */
#define MDED18MASK_WIDTH                                                      1
#define MDED18MASK_SHIFT                                                     18
#define MDED18MASK_MASK                                              0x00040000
#define MDED18MASK_RD(src)                           (((src) & 0x00040000)>>18)
#define MDED18MASK_WR(src)                      (((u32)(src)<<18) & 0x00040000)
#define MDED18MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields MDED17Mask    */
#define MDED17MASK_WIDTH                                                      1
#define MDED17MASK_SHIFT                                                     17
#define MDED17MASK_MASK                                              0x00020000
#define MDED17MASK_RD(src)                           (((src) & 0x00020000)>>17)
#define MDED17MASK_WR(src)                      (((u32)(src)<<17) & 0x00020000)
#define MDED17MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields MDED16Mask    */
#define MDED16MASK_WIDTH                                                      1
#define MDED16MASK_SHIFT                                                     16
#define MDED16MASK_MASK                                              0x00010000
#define MDED16MASK_RD(src)                           (((src) & 0x00010000)>>16)
#define MDED16MASK_WR(src)                      (((u32)(src)<<16) & 0x00010000)
#define MDED16MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields MDED15Mask    */
#define MDED15MASK_WIDTH                                                      1
#define MDED15MASK_SHIFT                                                     15
#define MDED15MASK_MASK                                              0x00008000
#define MDED15MASK_RD(src)                           (((src) & 0x00008000)>>15)
#define MDED15MASK_WR(src)                      (((u32)(src)<<15) & 0x00008000)
#define MDED15MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields MDED14Mask    */
#define MDED14MASK_WIDTH                                                      1
#define MDED14MASK_SHIFT                                                     14
#define MDED14MASK_MASK                                              0x00004000
#define MDED14MASK_RD(src)                           (((src) & 0x00004000)>>14)
#define MDED14MASK_WR(src)                      (((u32)(src)<<14) & 0x00004000)
#define MDED14MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields MDED13Mask    */
#define MDED13MASK_WIDTH                                                      1
#define MDED13MASK_SHIFT                                                     13
#define MDED13MASK_MASK                                              0x00002000
#define MDED13MASK_RD(src)                           (((src) & 0x00002000)>>13)
#define MDED13MASK_WR(src)                      (((u32)(src)<<13) & 0x00002000)
#define MDED13MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields MDED12Mask    */
#define MDED12MASK_WIDTH                                                      1
#define MDED12MASK_SHIFT                                                     12
#define MDED12MASK_MASK                                              0x00001000
#define MDED12MASK_RD(src)                           (((src) & 0x00001000)>>12)
#define MDED12MASK_WR(src)                      (((u32)(src)<<12) & 0x00001000)
#define MDED12MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields MDED11Mask    */
#define MDED11MASK_WIDTH                                                      1
#define MDED11MASK_SHIFT                                                     11
#define MDED11MASK_MASK                                              0x00000800
#define MDED11MASK_RD(src)                           (((src) & 0x00000800)>>11)
#define MDED11MASK_WR(src)                      (((u32)(src)<<11) & 0x00000800)
#define MDED11MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields MDED10Mask    */
#define MDED10MASK_WIDTH                                                      1
#define MDED10MASK_SHIFT                                                     10
#define MDED10MASK_MASK                                              0x00000400
#define MDED10MASK_RD(src)                           (((src) & 0x00000400)>>10)
#define MDED10MASK_WR(src)                      (((u32)(src)<<10) & 0x00000400)
#define MDED10MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields MDED9Mask    */
#define MDED9MASK_WIDTH                                                       1
#define MDED9MASK_SHIFT                                                       9
#define MDED9MASK_MASK                                               0x00000200
#define MDED9MASK_RD(src)                             (((src) & 0x00000200)>>9)
#define MDED9MASK_WR(src)                        (((u32)(src)<<9) & 0x00000200)
#define MDED9MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields MDED8Mask    */
#define MDED8MASK_WIDTH                                                       1
#define MDED8MASK_SHIFT                                                       8
#define MDED8MASK_MASK                                               0x00000100
#define MDED8MASK_RD(src)                             (((src) & 0x00000100)>>8)
#define MDED8MASK_WR(src)                        (((u32)(src)<<8) & 0x00000100)
#define MDED8MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields MDED7Mask    */
#define MDED7MASK_WIDTH                                                       1
#define MDED7MASK_SHIFT                                                       7
#define MDED7MASK_MASK                                               0x00000080
#define MDED7MASK_RD(src)                             (((src) & 0x00000080)>>7)
#define MDED7MASK_WR(src)                        (((u32)(src)<<7) & 0x00000080)
#define MDED7MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields MDED6Mask    */
#define MDED6MASK_WIDTH                                                       1
#define MDED6MASK_SHIFT                                                       6
#define MDED6MASK_MASK                                               0x00000040
#define MDED6MASK_RD(src)                             (((src) & 0x00000040)>>6)
#define MDED6MASK_WR(src)                        (((u32)(src)<<6) & 0x00000040)
#define MDED6MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields MDED5Mask    */
#define MDED5MASK_WIDTH                                                       1
#define MDED5MASK_SHIFT                                                       5
#define MDED5MASK_MASK                                               0x00000020
#define MDED5MASK_RD(src)                             (((src) & 0x00000020)>>5)
#define MDED5MASK_WR(src)                        (((u32)(src)<<5) & 0x00000020)
#define MDED5MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields MDED4Mask    */
#define MDED4MASK_WIDTH                                                       1
#define MDED4MASK_SHIFT                                                       4
#define MDED4MASK_MASK                                               0x00000010
#define MDED4MASK_RD(src)                             (((src) & 0x00000010)>>4)
#define MDED4MASK_WR(src)                        (((u32)(src)<<4) & 0x00000010)
#define MDED4MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields MDED3Mask    */
#define MDED3MASK_WIDTH                                                       1
#define MDED3MASK_SHIFT                                                       3
#define MDED3MASK_MASK                                               0x00000008
#define MDED3MASK_RD(src)                             (((src) & 0x00000008)>>3)
#define MDED3MASK_WR(src)                        (((u32)(src)<<3) & 0x00000008)
#define MDED3MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields MDED2Mask    */
#define MDED2MASK_WIDTH                                                       1
#define MDED2MASK_SHIFT                                                       2
#define MDED2MASK_MASK                                               0x00000004
#define MDED2MASK_RD(src)                             (((src) & 0x00000004)>>2)
#define MDED2MASK_WR(src)                        (((u32)(src)<<2) & 0x00000004)
#define MDED2MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields MDED1Mask    */
#define MDED1MASK_WIDTH                                                       1
#define MDED1MASK_SHIFT                                                       1
#define MDED1MASK_MASK                                               0x00000002
#define MDED1MASK_RD(src)                             (((src) & 0x00000002)>>1)
#define MDED1MASK_WR(src)                        (((u32)(src)<<1) & 0x00000002)
#define MDED1MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields MDED0Mask    */
#define MDED0MASK_WIDTH                                                       1
#define MDED0MASK_SHIFT                                                       0
#define MDED0MASK_MASK                                               0x00000001
#define MDED0MASK_RD(src)                                (((src) & 0x00000001))
#define MDED0MASK_WR(src)                           (((u32)(src)) & 0x00000001)
#define MDED0MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MDED_ERRH	*/ 
/*	 Fields MDED63	 */
#define MDED63_WIDTH                                                          1
#define MDED63_SHIFT                                                         31
#define MDED63_MASK                                                  0x80000000
#define MDED63_RD(src)                               (((src) & 0x80000000)>>31)
#define MDED63_WR(src)                          (((u32)(src)<<31) & 0x80000000)
#define MDED63_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields MDED62	 */
#define MDED62_WIDTH                                                          1
#define MDED62_SHIFT                                                         30
#define MDED62_MASK                                                  0x40000000
#define MDED62_RD(src)                               (((src) & 0x40000000)>>30)
#define MDED62_WR(src)                          (((u32)(src)<<30) & 0x40000000)
#define MDED62_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields MDED61	 */
#define MDED61_WIDTH                                                          1
#define MDED61_SHIFT                                                         29
#define MDED61_MASK                                                  0x20000000
#define MDED61_RD(src)                               (((src) & 0x20000000)>>29)
#define MDED61_WR(src)                          (((u32)(src)<<29) & 0x20000000)
#define MDED61_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields MDED60	 */
#define MDED60_WIDTH                                                          1
#define MDED60_SHIFT                                                         28
#define MDED60_MASK                                                  0x10000000
#define MDED60_RD(src)                               (((src) & 0x10000000)>>28)
#define MDED60_WR(src)                          (((u32)(src)<<28) & 0x10000000)
#define MDED60_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields MDED59	 */
#define MDED59_WIDTH                                                          1
#define MDED59_SHIFT                                                         27
#define MDED59_MASK                                                  0x08000000
#define MDED59_RD(src)                               (((src) & 0x08000000)>>27)
#define MDED59_WR(src)                          (((u32)(src)<<27) & 0x08000000)
#define MDED59_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields MDED58	 */
#define MDED58_WIDTH                                                          1
#define MDED58_SHIFT                                                         26
#define MDED58_MASK                                                  0x04000000
#define MDED58_RD(src)                               (((src) & 0x04000000)>>26)
#define MDED58_WR(src)                          (((u32)(src)<<26) & 0x04000000)
#define MDED58_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields MDED57	 */
#define MDED57_WIDTH                                                          1
#define MDED57_SHIFT                                                         25
#define MDED57_MASK                                                  0x02000000
#define MDED57_RD(src)                               (((src) & 0x02000000)>>25)
#define MDED57_WR(src)                          (((u32)(src)<<25) & 0x02000000)
#define MDED57_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields MDED56	 */
#define MDED56_WIDTH                                                          1
#define MDED56_SHIFT                                                         24
#define MDED56_MASK                                                  0x01000000
#define MDED56_RD(src)                               (((src) & 0x01000000)>>24)
#define MDED56_WR(src)                          (((u32)(src)<<24) & 0x01000000)
#define MDED56_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields MDED55	 */
#define MDED55_WIDTH                                                          1
#define MDED55_SHIFT                                                         23
#define MDED55_MASK                                                  0x00800000
#define MDED55_RD(src)                               (((src) & 0x00800000)>>23)
#define MDED55_WR(src)                          (((u32)(src)<<23) & 0x00800000)
#define MDED55_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields MDED54	 */
#define MDED54_WIDTH                                                          1
#define MDED54_SHIFT                                                         22
#define MDED54_MASK                                                  0x00400000
#define MDED54_RD(src)                               (((src) & 0x00400000)>>22)
#define MDED54_WR(src)                          (((u32)(src)<<22) & 0x00400000)
#define MDED54_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*	 Fields MDED53	 */
#define MDED53_WIDTH                                                          1
#define MDED53_SHIFT                                                         21
#define MDED53_MASK                                                  0x00200000
#define MDED53_RD(src)                               (((src) & 0x00200000)>>21)
#define MDED53_WR(src)                          (((u32)(src)<<21) & 0x00200000)
#define MDED53_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*	 Fields MDED52	 */
#define MDED52_WIDTH                                                          1
#define MDED52_SHIFT                                                         20
#define MDED52_MASK                                                  0x00100000
#define MDED52_RD(src)                               (((src) & 0x00100000)>>20)
#define MDED52_WR(src)                          (((u32)(src)<<20) & 0x00100000)
#define MDED52_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*	 Fields MDED51	 */
#define MDED51_WIDTH                                                          1
#define MDED51_SHIFT                                                         19
#define MDED51_MASK                                                  0x00080000
#define MDED51_RD(src)                               (((src) & 0x00080000)>>19)
#define MDED51_WR(src)                          (((u32)(src)<<19) & 0x00080000)
#define MDED51_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields MDED50	 */
#define MDED50_WIDTH                                                          1
#define MDED50_SHIFT                                                         18
#define MDED50_MASK                                                  0x00040000
#define MDED50_RD(src)                               (((src) & 0x00040000)>>18)
#define MDED50_WR(src)                          (((u32)(src)<<18) & 0x00040000)
#define MDED50_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields MDED49	 */
#define MDED49_WIDTH                                                          1
#define MDED49_SHIFT                                                         17
#define MDED49_MASK                                                  0x00020000
#define MDED49_RD(src)                               (((src) & 0x00020000)>>17)
#define MDED49_WR(src)                          (((u32)(src)<<17) & 0x00020000)
#define MDED49_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields MDED48	 */
#define MDED48_WIDTH                                                          1
#define MDED48_SHIFT                                                         16
#define MDED48_MASK                                                  0x00010000
#define MDED48_RD(src)                               (((src) & 0x00010000)>>16)
#define MDED48_WR(src)                          (((u32)(src)<<16) & 0x00010000)
#define MDED48_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields MDED47	 */
#define MDED47_WIDTH                                                          1
#define MDED47_SHIFT                                                         15
#define MDED47_MASK                                                  0x00008000
#define MDED47_RD(src)                               (((src) & 0x00008000)>>15)
#define MDED47_WR(src)                          (((u32)(src)<<15) & 0x00008000)
#define MDED47_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields MDED46	 */
#define MDED46_WIDTH                                                          1
#define MDED46_SHIFT                                                         14
#define MDED46_MASK                                                  0x00004000
#define MDED46_RD(src)                               (((src) & 0x00004000)>>14)
#define MDED46_WR(src)                          (((u32)(src)<<14) & 0x00004000)
#define MDED46_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields MDED45	 */
#define MDED45_WIDTH                                                          1
#define MDED45_SHIFT                                                         13
#define MDED45_MASK                                                  0x00002000
#define MDED45_RD(src)                               (((src) & 0x00002000)>>13)
#define MDED45_WR(src)                          (((u32)(src)<<13) & 0x00002000)
#define MDED45_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields MDED44	 */
#define MDED44_WIDTH                                                          1
#define MDED44_SHIFT                                                         12
#define MDED44_MASK                                                  0x00001000
#define MDED44_RD(src)                               (((src) & 0x00001000)>>12)
#define MDED44_WR(src)                          (((u32)(src)<<12) & 0x00001000)
#define MDED44_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields MDED43	 */
#define MDED43_WIDTH                                                          1
#define MDED43_SHIFT                                                         11
#define MDED43_MASK                                                  0x00000800
#define MDED43_RD(src)                               (((src) & 0x00000800)>>11)
#define MDED43_WR(src)                          (((u32)(src)<<11) & 0x00000800)
#define MDED43_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields MDED42	 */
#define MDED42_WIDTH                                                          1
#define MDED42_SHIFT                                                         10
#define MDED42_MASK                                                  0x00000400
#define MDED42_RD(src)                               (((src) & 0x00000400)>>10)
#define MDED42_WR(src)                          (((u32)(src)<<10) & 0x00000400)
#define MDED42_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields MDED41	 */
#define MDED41_WIDTH                                                          1
#define MDED41_SHIFT                                                          9
#define MDED41_MASK                                                  0x00000200
#define MDED41_RD(src)                                (((src) & 0x00000200)>>9)
#define MDED41_WR(src)                           (((u32)(src)<<9) & 0x00000200)
#define MDED41_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields MDED40	 */
#define MDED40_WIDTH                                                          1
#define MDED40_SHIFT                                                          8
#define MDED40_MASK                                                  0x00000100
#define MDED40_RD(src)                                (((src) & 0x00000100)>>8)
#define MDED40_WR(src)                           (((u32)(src)<<8) & 0x00000100)
#define MDED40_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields MDED39	 */
#define MDED39_WIDTH                                                          1
#define MDED39_SHIFT                                                          7
#define MDED39_MASK                                                  0x00000080
#define MDED39_RD(src)                                (((src) & 0x00000080)>>7)
#define MDED39_WR(src)                           (((u32)(src)<<7) & 0x00000080)
#define MDED39_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields MDED38	 */
#define MDED38_WIDTH                                                          1
#define MDED38_SHIFT                                                          6
#define MDED38_MASK                                                  0x00000040
#define MDED38_RD(src)                                (((src) & 0x00000040)>>6)
#define MDED38_WR(src)                           (((u32)(src)<<6) & 0x00000040)
#define MDED38_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields MDED37	 */
#define MDED37_WIDTH                                                          1
#define MDED37_SHIFT                                                          5
#define MDED37_MASK                                                  0x00000020
#define MDED37_RD(src)                                (((src) & 0x00000020)>>5)
#define MDED37_WR(src)                           (((u32)(src)<<5) & 0x00000020)
#define MDED37_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields MDED36	 */
#define MDED36_WIDTH                                                          1
#define MDED36_SHIFT                                                          4
#define MDED36_MASK                                                  0x00000010
#define MDED36_RD(src)                                (((src) & 0x00000010)>>4)
#define MDED36_WR(src)                           (((u32)(src)<<4) & 0x00000010)
#define MDED36_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields MDED35	 */
#define MDED35_WIDTH                                                          1
#define MDED35_SHIFT                                                          3
#define MDED35_MASK                                                  0x00000008
#define MDED35_RD(src)                                (((src) & 0x00000008)>>3)
#define MDED35_WR(src)                           (((u32)(src)<<3) & 0x00000008)
#define MDED35_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields MDED34	 */
#define MDED34_WIDTH                                                          1
#define MDED34_SHIFT                                                          2
#define MDED34_MASK                                                  0x00000004
#define MDED34_RD(src)                                (((src) & 0x00000004)>>2)
#define MDED34_WR(src)                           (((u32)(src)<<2) & 0x00000004)
#define MDED34_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields MDED33	 */
#define MDED33_WIDTH                                                          1
#define MDED33_SHIFT                                                          1
#define MDED33_MASK                                                  0x00000002
#define MDED33_RD(src)                                (((src) & 0x00000002)>>1)
#define MDED33_WR(src)                           (((u32)(src)<<1) & 0x00000002)
#define MDED33_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields MDED32	 */
#define MDED32_WIDTH                                                          1
#define MDED32_SHIFT                                                          0
#define MDED32_MASK                                                  0x00000001
#define MDED32_RD(src)                                   (((src) & 0x00000001))
#define MDED32_WR(src)                              (((u32)(src)) & 0x00000001)
#define MDED32_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MDED_ERRHMask	*/
/*    Mask Register Fields MDED63Mask    */
#define MDED63MASK_WIDTH                                                      1
#define MDED63MASK_SHIFT                                                     31
#define MDED63MASK_MASK                                              0x80000000
#define MDED63MASK_RD(src)                           (((src) & 0x80000000)>>31)
#define MDED63MASK_WR(src)                      (((u32)(src)<<31) & 0x80000000)
#define MDED63MASK_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*    Mask Register Fields MDED62Mask    */
#define MDED62MASK_WIDTH                                                      1
#define MDED62MASK_SHIFT                                                     30
#define MDED62MASK_MASK                                              0x40000000
#define MDED62MASK_RD(src)                           (((src) & 0x40000000)>>30)
#define MDED62MASK_WR(src)                      (((u32)(src)<<30) & 0x40000000)
#define MDED62MASK_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*    Mask Register Fields MDED61Mask    */
#define MDED61MASK_WIDTH                                                      1
#define MDED61MASK_SHIFT                                                     29
#define MDED61MASK_MASK                                              0x20000000
#define MDED61MASK_RD(src)                           (((src) & 0x20000000)>>29)
#define MDED61MASK_WR(src)                      (((u32)(src)<<29) & 0x20000000)
#define MDED61MASK_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*    Mask Register Fields MDED60Mask    */
#define MDED60MASK_WIDTH                                                      1
#define MDED60MASK_SHIFT                                                     28
#define MDED60MASK_MASK                                              0x10000000
#define MDED60MASK_RD(src)                           (((src) & 0x10000000)>>28)
#define MDED60MASK_WR(src)                      (((u32)(src)<<28) & 0x10000000)
#define MDED60MASK_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*    Mask Register Fields MDED59Mask    */
#define MDED59MASK_WIDTH                                                      1
#define MDED59MASK_SHIFT                                                     27
#define MDED59MASK_MASK                                              0x08000000
#define MDED59MASK_RD(src)                           (((src) & 0x08000000)>>27)
#define MDED59MASK_WR(src)                      (((u32)(src)<<27) & 0x08000000)
#define MDED59MASK_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*    Mask Register Fields MDED58Mask    */
#define MDED58MASK_WIDTH                                                      1
#define MDED58MASK_SHIFT                                                     26
#define MDED58MASK_MASK                                              0x04000000
#define MDED58MASK_RD(src)                           (((src) & 0x04000000)>>26)
#define MDED58MASK_WR(src)                      (((u32)(src)<<26) & 0x04000000)
#define MDED58MASK_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*    Mask Register Fields MDED57Mask    */
#define MDED57MASK_WIDTH                                                      1
#define MDED57MASK_SHIFT                                                     25
#define MDED57MASK_MASK                                              0x02000000
#define MDED57MASK_RD(src)                           (((src) & 0x02000000)>>25)
#define MDED57MASK_WR(src)                      (((u32)(src)<<25) & 0x02000000)
#define MDED57MASK_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*    Mask Register Fields MDED56Mask    */
#define MDED56MASK_WIDTH                                                      1
#define MDED56MASK_SHIFT                                                     24
#define MDED56MASK_MASK                                              0x01000000
#define MDED56MASK_RD(src)                           (((src) & 0x01000000)>>24)
#define MDED56MASK_WR(src)                      (((u32)(src)<<24) & 0x01000000)
#define MDED56MASK_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*    Mask Register Fields MDED55Mask    */
#define MDED55MASK_WIDTH                                                      1
#define MDED55MASK_SHIFT                                                     23
#define MDED55MASK_MASK                                              0x00800000
#define MDED55MASK_RD(src)                           (((src) & 0x00800000)>>23)
#define MDED55MASK_WR(src)                      (((u32)(src)<<23) & 0x00800000)
#define MDED55MASK_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*    Mask Register Fields MDED54Mask    */
#define MDED54MASK_WIDTH                                                      1
#define MDED54MASK_SHIFT                                                     22
#define MDED54MASK_MASK                                              0x00400000
#define MDED54MASK_RD(src)                           (((src) & 0x00400000)>>22)
#define MDED54MASK_WR(src)                      (((u32)(src)<<22) & 0x00400000)
#define MDED54MASK_SET(dst,src) \
                      (((dst) & ~0x00400000) | (((u32)(src)<<22) & 0x00400000))
/*    Mask Register Fields MDED53Mask    */
#define MDED53MASK_WIDTH                                                      1
#define MDED53MASK_SHIFT                                                     21
#define MDED53MASK_MASK                                              0x00200000
#define MDED53MASK_RD(src)                           (((src) & 0x00200000)>>21)
#define MDED53MASK_WR(src)                      (((u32)(src)<<21) & 0x00200000)
#define MDED53MASK_SET(dst,src) \
                      (((dst) & ~0x00200000) | (((u32)(src)<<21) & 0x00200000))
/*    Mask Register Fields MDED52Mask    */
#define MDED52MASK_WIDTH                                                      1
#define MDED52MASK_SHIFT                                                     20
#define MDED52MASK_MASK                                              0x00100000
#define MDED52MASK_RD(src)                           (((src) & 0x00100000)>>20)
#define MDED52MASK_WR(src)                      (((u32)(src)<<20) & 0x00100000)
#define MDED52MASK_SET(dst,src) \
                      (((dst) & ~0x00100000) | (((u32)(src)<<20) & 0x00100000))
/*    Mask Register Fields MDED51Mask    */
#define MDED51MASK_WIDTH                                                      1
#define MDED51MASK_SHIFT                                                     19
#define MDED51MASK_MASK                                              0x00080000
#define MDED51MASK_RD(src)                           (((src) & 0x00080000)>>19)
#define MDED51MASK_WR(src)                      (((u32)(src)<<19) & 0x00080000)
#define MDED51MASK_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*    Mask Register Fields MDED50Mask    */
#define MDED50MASK_WIDTH                                                      1
#define MDED50MASK_SHIFT                                                     18
#define MDED50MASK_MASK                                              0x00040000
#define MDED50MASK_RD(src)                           (((src) & 0x00040000)>>18)
#define MDED50MASK_WR(src)                      (((u32)(src)<<18) & 0x00040000)
#define MDED50MASK_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*    Mask Register Fields MDED49Mask    */
#define MDED49MASK_WIDTH                                                      1
#define MDED49MASK_SHIFT                                                     17
#define MDED49MASK_MASK                                              0x00020000
#define MDED49MASK_RD(src)                           (((src) & 0x00020000)>>17)
#define MDED49MASK_WR(src)                      (((u32)(src)<<17) & 0x00020000)
#define MDED49MASK_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*    Mask Register Fields MDED48Mask    */
#define MDED48MASK_WIDTH                                                      1
#define MDED48MASK_SHIFT                                                     16
#define MDED48MASK_MASK                                              0x00010000
#define MDED48MASK_RD(src)                           (((src) & 0x00010000)>>16)
#define MDED48MASK_WR(src)                      (((u32)(src)<<16) & 0x00010000)
#define MDED48MASK_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*    Mask Register Fields MDED47Mask    */
#define MDED47MASK_WIDTH                                                      1
#define MDED47MASK_SHIFT                                                     15
#define MDED47MASK_MASK                                              0x00008000
#define MDED47MASK_RD(src)                           (((src) & 0x00008000)>>15)
#define MDED47MASK_WR(src)                      (((u32)(src)<<15) & 0x00008000)
#define MDED47MASK_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*    Mask Register Fields MDED46Mask    */
#define MDED46MASK_WIDTH                                                      1
#define MDED46MASK_SHIFT                                                     14
#define MDED46MASK_MASK                                              0x00004000
#define MDED46MASK_RD(src)                           (((src) & 0x00004000)>>14)
#define MDED46MASK_WR(src)                      (((u32)(src)<<14) & 0x00004000)
#define MDED46MASK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*    Mask Register Fields MDED45Mask    */
#define MDED45MASK_WIDTH                                                      1
#define MDED45MASK_SHIFT                                                     13
#define MDED45MASK_MASK                                              0x00002000
#define MDED45MASK_RD(src)                           (((src) & 0x00002000)>>13)
#define MDED45MASK_WR(src)                      (((u32)(src)<<13) & 0x00002000)
#define MDED45MASK_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*    Mask Register Fields MDED44Mask    */
#define MDED44MASK_WIDTH                                                      1
#define MDED44MASK_SHIFT                                                     12
#define MDED44MASK_MASK                                              0x00001000
#define MDED44MASK_RD(src)                           (((src) & 0x00001000)>>12)
#define MDED44MASK_WR(src)                      (((u32)(src)<<12) & 0x00001000)
#define MDED44MASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields MDED43Mask    */
#define MDED43MASK_WIDTH                                                      1
#define MDED43MASK_SHIFT                                                     11
#define MDED43MASK_MASK                                              0x00000800
#define MDED43MASK_RD(src)                           (((src) & 0x00000800)>>11)
#define MDED43MASK_WR(src)                      (((u32)(src)<<11) & 0x00000800)
#define MDED43MASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields MDED42Mask    */
#define MDED42MASK_WIDTH                                                      1
#define MDED42MASK_SHIFT                                                     10
#define MDED42MASK_MASK                                              0x00000400
#define MDED42MASK_RD(src)                           (((src) & 0x00000400)>>10)
#define MDED42MASK_WR(src)                      (((u32)(src)<<10) & 0x00000400)
#define MDED42MASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields MDED41Mask    */
#define MDED41MASK_WIDTH                                                      1
#define MDED41MASK_SHIFT                                                      9
#define MDED41MASK_MASK                                              0x00000200
#define MDED41MASK_RD(src)                            (((src) & 0x00000200)>>9)
#define MDED41MASK_WR(src)                       (((u32)(src)<<9) & 0x00000200)
#define MDED41MASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields MDED40Mask    */
#define MDED40MASK_WIDTH                                                      1
#define MDED40MASK_SHIFT                                                      8
#define MDED40MASK_MASK                                              0x00000100
#define MDED40MASK_RD(src)                            (((src) & 0x00000100)>>8)
#define MDED40MASK_WR(src)                       (((u32)(src)<<8) & 0x00000100)
#define MDED40MASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields MDED39Mask    */
#define MDED39MASK_WIDTH                                                      1
#define MDED39MASK_SHIFT                                                      7
#define MDED39MASK_MASK                                              0x00000080
#define MDED39MASK_RD(src)                            (((src) & 0x00000080)>>7)
#define MDED39MASK_WR(src)                       (((u32)(src)<<7) & 0x00000080)
#define MDED39MASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields MDED38Mask    */
#define MDED38MASK_WIDTH                                                      1
#define MDED38MASK_SHIFT                                                      6
#define MDED38MASK_MASK                                              0x00000040
#define MDED38MASK_RD(src)                            (((src) & 0x00000040)>>6)
#define MDED38MASK_WR(src)                       (((u32)(src)<<6) & 0x00000040)
#define MDED38MASK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*    Mask Register Fields MDED37Mask    */
#define MDED37MASK_WIDTH                                                      1
#define MDED37MASK_SHIFT                                                      5
#define MDED37MASK_MASK                                              0x00000020
#define MDED37MASK_RD(src)                            (((src) & 0x00000020)>>5)
#define MDED37MASK_WR(src)                       (((u32)(src)<<5) & 0x00000020)
#define MDED37MASK_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*    Mask Register Fields MDED36Mask    */
#define MDED36MASK_WIDTH                                                      1
#define MDED36MASK_SHIFT                                                      4
#define MDED36MASK_MASK                                              0x00000010
#define MDED36MASK_RD(src)                            (((src) & 0x00000010)>>4)
#define MDED36MASK_WR(src)                       (((u32)(src)<<4) & 0x00000010)
#define MDED36MASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields MDED35Mask    */
#define MDED35MASK_WIDTH                                                      1
#define MDED35MASK_SHIFT                                                      3
#define MDED35MASK_MASK                                              0x00000008
#define MDED35MASK_RD(src)                            (((src) & 0x00000008)>>3)
#define MDED35MASK_WR(src)                       (((u32)(src)<<3) & 0x00000008)
#define MDED35MASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields MDED34Mask    */
#define MDED34MASK_WIDTH                                                      1
#define MDED34MASK_SHIFT                                                      2
#define MDED34MASK_MASK                                              0x00000004
#define MDED34MASK_RD(src)                            (((src) & 0x00000004)>>2)
#define MDED34MASK_WR(src)                       (((u32)(src)<<2) & 0x00000004)
#define MDED34MASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields MDED33Mask    */
#define MDED33MASK_WIDTH                                                      1
#define MDED33MASK_SHIFT                                                      1
#define MDED33MASK_MASK                                              0x00000002
#define MDED33MASK_RD(src)                            (((src) & 0x00000002)>>1)
#define MDED33MASK_WR(src)                       (((u32)(src)<<1) & 0x00000002)
#define MDED33MASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields MDED32Mask    */
#define MDED32MASK_WIDTH                                                      1
#define MDED32MASK_SHIFT                                                      0
#define MDED32MASK_MASK                                              0x00000001
#define MDED32MASK_RD(src)                               (((src) & 0x00000001))
#define MDED32MASK_WR(src)                          (((u32)(src)) & 0x00000001)
#define MDED32MASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_MERR_ADDR	*/ 
/*	 Fields ERRADDRL	 */
#define ERRADDRL_WIDTH                                                       32
#define ERRADDRL_SHIFT                                                        0
#define ERRADDRL_MASK                                                0xffffffff
#define ERRADDRL_RD(src)                                 (((src) & 0xffffffff))
#define ERRADDRL_WR(src)                            (((u32)(src)) & 0xffffffff)
#define ERRADDRL_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_MERR_REQINFO	*/ 
/*	 Fields ERRADDRH	 */
#define ERRADDRH_WIDTH                                                       10
#define ERRADDRH_SHIFT                                                       22
#define ERRADDRH_MASK                                                0xffc00000
#define ERRADDRH_RD(src)                             (((src) & 0xffc00000)>>22)
#define ERRADDRH_WR(src)                        (((u32)(src)<<22) & 0xffc00000)
#define ERRADDRH_SET(dst,src) \
                      (((dst) & ~0xffc00000) | (((u32)(src)<<22) & 0xffc00000))
/*	 Fields MSTRID	 */
#define MSTRID_WIDTH                                                          6
#define MSTRID_SHIFT                                                         16
#define MSTRID_MASK                                                  0x003f0000
#define MSTRID_RD(src)                               (((src) & 0x003f0000)>>16)
#define MSTRID_WR(src)                          (((u32)(src)<<16) & 0x003f0000)
#define MSTRID_SET(dst,src) \
                      (((dst) & ~0x003f0000) | (((u32)(src)<<16) & 0x003f0000))
/*	 Fields AUXINFO	 */
#define AUXINFO_WIDTH                                                         6
#define AUXINFO_SHIFT                                                        10
#define AUXINFO_MASK                                                 0x0000fc00
#define AUXINFO_RD(src)                              (((src) & 0x0000fc00)>>10)
#define AUXINFO_WR(src)                         (((u32)(src)<<10) & 0x0000fc00)
#define AUXINFO_SET(dst,src) \
                      (((dst) & ~0x0000fc00) | (((u32)(src)<<10) & 0x0000fc00))
/*	 Fields REQLEN	 */
#define REQLEN_WIDTH                                                          2
#define REQLEN_SHIFT                                                          4
#define REQLEN_MASK                                                  0x00000030
#define REQLEN_RD(src)                                (((src) & 0x00000030)>>4)
#define REQLEN_WR(src)                           (((u32)(src)<<4) & 0x00000030)
#define REQLEN_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields REQSIZE	 */
#define REQSIZE_WIDTH                                                         3
#define REQSIZE_SHIFT                                                         1
#define REQSIZE_MASK                                                 0x0000000e
#define REQSIZE_RD(src)                               (((src) & 0x0000000e)>>1)
#define REQSIZE_WR(src)                          (((u32)(src)<<1) & 0x0000000e)
#define REQSIZE_SET(dst,src) \
                       (((dst) & ~0x0000000e) | (((u32)(src)<<1) & 0x0000000e))
/*	 Fields REQTYPE	 */
#define REQTYPE_WIDTH                                                         1
#define REQTYPE_SHIFT                                                         0
#define REQTYPE_MASK                                                 0x00000001
#define REQTYPE_RD(src)                                  (((src) & 0x00000001))
#define REQTYPE_WR(src)                             (((u32)(src)) & 0x00000001)
#define REQTYPE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_TRANS_ERR	*/ 
/*	 Fields MSWRPOISON	 */
#define MSWRPOISON_WIDTH                                                      1
#define MSWRPOISON_SHIFT                                                     12
#define MSWRPOISON_MASK                                              0x00001000
#define MSWRPOISON_RD(src)                           (((src) & 0x00001000)>>12)
#define MSWRPOISON_WR(src)                      (((u32)(src)<<12) & 0x00001000)
#define MSWRPOISON_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields SWRPOISON	 */
#define SWRPOISON_WIDTH                                                       1
#define SWRPOISON_SHIFT                                                      11
#define SWRPOISON_MASK                                               0x00000800
#define SWRPOISON_RD(src)                            (((src) & 0x00000800)>>11)
#define SWRPOISON_WR(src)                       (((u32)(src)<<11) & 0x00000800)
#define SWRPOISON_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields SWRDYTMO	 */
#define SWRDYTMO_WIDTH                                                        1
#define SWRDYTMO_SHIFT                                                       10
#define SWRDYTMO_MASK                                                0x00000400
#define SWRDYTMO_RD(src)                             (((src) & 0x00000400)>>10)
#define SWRDYTMO_WR(src)                        (((u32)(src)<<10) & 0x00000400)
#define SWRDYTMO_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields SWRESPTMO	 */
#define SWRESPTMO_WIDTH                                                       1
#define SWRESPTMO_SHIFT                                                       9
#define SWRESPTMO_MASK                                               0x00000200
#define SWRESPTMO_RD(src)                             (((src) & 0x00000200)>>9)
#define SWRESPTMO_WR(src)                        (((u32)(src)<<9) & 0x00000200)
#define SWRESPTMO_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields MSWRERR	 */
#define MSWRERR_WIDTH                                                         1
#define MSWRERR_SHIFT                                                         8
#define MSWRERR_MASK                                                 0x00000100
#define MSWRERR_RD(src)                               (((src) & 0x00000100)>>8)
#define MSWRERR_WR(src)                          (((u32)(src)<<8) & 0x00000100)
#define MSWRERR_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields SWRERR	 */
#define SWRERR_WIDTH                                                          1
#define SWRERR_SHIFT                                                          7
#define SWRERR_MASK                                                  0x00000080
#define SWRERR_RD(src)                                (((src) & 0x00000080)>>7)
#define SWRERR_WR(src)                           (((u32)(src)<<7) & 0x00000080)
#define SWRERR_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields SRRDYTMO	 */
#define SRRDYTMO_WIDTH                                                        1
#define SRRDYTMO_SHIFT                                                        3
#define SRRDYTMO_MASK                                                0x00000008
#define SRRDYTMO_RD(src)                              (((src) & 0x00000008)>>3)
#define SRRDYTMO_WR(src)                         (((u32)(src)<<3) & 0x00000008)
#define SRRDYTMO_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields SRRESPTMO	 */
#define SRRESPTMO_WIDTH                                                       1
#define SRRESPTMO_SHIFT                                                       2
#define SRRESPTMO_MASK                                               0x00000004
#define SRRESPTMO_RD(src)                             (((src) & 0x00000004)>>2)
#define SRRESPTMO_WR(src)                        (((u32)(src)<<2) & 0x00000004)
#define SRRESPTMO_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields MSRDERR	 */
#define MSRDERR_WIDTH                                                         1
#define MSRDERR_SHIFT                                                         1
#define MSRDERR_MASK                                                 0x00000002
#define MSRDERR_RD(src)                               (((src) & 0x00000002)>>1)
#define MSRDERR_WR(src)                          (((u32)(src)<<1) & 0x00000002)
#define MSRDERR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields SRDERR	 */
#define SRDERR_WIDTH                                                          1
#define SRDERR_SHIFT                                                          0
#define SRDERR_MASK                                                  0x00000001
#define SRDERR_RD(src)                                   (((src) & 0x00000001))
#define SRDERR_WR(src)                              (((u32)(src)) & 0x00000001)
#define SRDERR_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_TRANS_ERRMask	*/
/*    Mask Register Fields MSWRPOISONMask    */
#define MSWRPOISONMASK_WIDTH                                                  1
#define MSWRPOISONMASK_SHIFT                                                 12
#define MSWRPOISONMASK_MASK                                          0x00001000
#define MSWRPOISONMASK_RD(src)                       (((src) & 0x00001000)>>12)
#define MSWRPOISONMASK_WR(src)                  (((u32)(src)<<12) & 0x00001000)
#define MSWRPOISONMASK_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*    Mask Register Fields SWRPOISONMask    */
#define SWRPOISONMASK_WIDTH                                                   1
#define SWRPOISONMASK_SHIFT                                                  11
#define SWRPOISONMASK_MASK                                           0x00000800
#define SWRPOISONMASK_RD(src)                        (((src) & 0x00000800)>>11)
#define SWRPOISONMASK_WR(src)                   (((u32)(src)<<11) & 0x00000800)
#define SWRPOISONMASK_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*    Mask Register Fields SWRDYTMOMask    */
#define SWRDYTMOMASK_WIDTH                                                    1
#define SWRDYTMOMASK_SHIFT                                                   10
#define SWRDYTMOMASK_MASK                                            0x00000400
#define SWRDYTMOMASK_RD(src)                         (((src) & 0x00000400)>>10)
#define SWRDYTMOMASK_WR(src)                    (((u32)(src)<<10) & 0x00000400)
#define SWRDYTMOMASK_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*    Mask Register Fields SWRESPTMOMask    */
#define SWRESPTMOMASK_WIDTH                                                   1
#define SWRESPTMOMASK_SHIFT                                                   9
#define SWRESPTMOMASK_MASK                                           0x00000200
#define SWRESPTMOMASK_RD(src)                         (((src) & 0x00000200)>>9)
#define SWRESPTMOMASK_WR(src)                    (((u32)(src)<<9) & 0x00000200)
#define SWRESPTMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*    Mask Register Fields MSWRERRMask    */
#define MSWRERRMASK_WIDTH                                                     1
#define MSWRERRMASK_SHIFT                                                     8
#define MSWRERRMASK_MASK                                             0x00000100
#define MSWRERRMASK_RD(src)                           (((src) & 0x00000100)>>8)
#define MSWRERRMASK_WR(src)                      (((u32)(src)<<8) & 0x00000100)
#define MSWRERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*    Mask Register Fields SWRERRMask    */
#define SWRERRMASK_WIDTH                                                      1
#define SWRERRMASK_SHIFT                                                      7
#define SWRERRMASK_MASK                                              0x00000080
#define SWRERRMASK_RD(src)                            (((src) & 0x00000080)>>7)
#define SWRERRMASK_WR(src)                       (((u32)(src)<<7) & 0x00000080)
#define SWRERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*    Mask Register Fields SRRDYTMOMask    */
#define SRRDYTMOMASK_WIDTH                                                    1
#define SRRDYTMOMASK_SHIFT                                                    3
#define SRRDYTMOMASK_MASK                                            0x00000008
#define SRRDYTMOMASK_RD(src)                          (((src) & 0x00000008)>>3)
#define SRRDYTMOMASK_WR(src)                     (((u32)(src)<<3) & 0x00000008)
#define SRRDYTMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields SRRESPTMOMask    */
#define SRRESPTMOMASK_WIDTH                                                   1
#define SRRESPTMOMASK_SHIFT                                                   2
#define SRRESPTMOMASK_MASK                                           0x00000004
#define SRRESPTMOMASK_RD(src)                         (((src) & 0x00000004)>>2)
#define SRRESPTMOMASK_WR(src)                    (((u32)(src)<<2) & 0x00000004)
#define SRRESPTMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields MSRDERRMask    */
#define MSRDERRMASK_WIDTH                                                     1
#define MSRDERRMASK_SHIFT                                                     1
#define MSRDERRMASK_MASK                                             0x00000002
#define MSRDERRMASK_RD(src)                           (((src) & 0x00000002)>>1)
#define MSRDERRMASK_WR(src)                      (((u32)(src)<<1) & 0x00000002)
#define MSRDERRMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields SRDERRMask    */
#define SRDERRMASK_WIDTH                                                      1
#define SRDERRMASK_SHIFT                                                      0
#define SRDERRMASK_MASK                                              0x00000001
#define SRDERRMASK_RD(src)                               (((src) & 0x00000001))
#define SRDERRMASK_WR(src)                          (((u32)(src)) & 0x00000001)
#define SRDERRMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_WDERR_ADDR	*/ 
/*	 Fields ERRADDRL	 */
#define ERRADDRL_F1_WIDTH                                                    32
#define ERRADDRL_F1_SHIFT                                                     0
#define ERRADDRL_F1_MASK                                             0xffffffff
#define ERRADDRL_F1_RD(src)                              (((src) & 0xffffffff))
#define ERRADDRL_F1_WR(src)                         (((u32)(src)) & 0xffffffff)
#define ERRADDRL_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_WDERR_REQINFO	*/ 
/*	 Fields ERRADDRH	 */
#define ERRADDRH_F1_WIDTH                                                    10
#define ERRADDRH_F1_SHIFT                                                    22
#define ERRADDRH_F1_MASK                                             0xffc00000
#define ERRADDRH_F1_RD(src)                          (((src) & 0xffc00000)>>22)
#define ERRADDRH_F1_WR(src)                     (((u32)(src)<<22) & 0xffc00000)
#define ERRADDRH_F1_SET(dst,src) \
                      (((dst) & ~0xffc00000) | (((u32)(src)<<22) & 0xffc00000))
/*	 Fields MSTRID	 */
#define MSTRID_F1_WIDTH                                                       6
#define MSTRID_F1_SHIFT                                                      16
#define MSTRID_F1_MASK                                               0x003f0000
#define MSTRID_F1_RD(src)                            (((src) & 0x003f0000)>>16)
#define MSTRID_F1_WR(src)                       (((u32)(src)<<16) & 0x003f0000)
#define MSTRID_F1_SET(dst,src) \
                      (((dst) & ~0x003f0000) | (((u32)(src)<<16) & 0x003f0000))
/*	 Fields AUXINFO	 */
#define AUXINFO_F1_WIDTH                                                      6
#define AUXINFO_F1_SHIFT                                                     10
#define AUXINFO_F1_MASK                                              0x0000fc00
#define AUXINFO_F1_RD(src)                           (((src) & 0x0000fc00)>>10)
#define AUXINFO_F1_WR(src)                      (((u32)(src)<<10) & 0x0000fc00)
#define AUXINFO_F1_SET(dst,src) \
                      (((dst) & ~0x0000fc00) | (((u32)(src)<<10) & 0x0000fc00))
/*	 Fields REQLEN	 */
#define REQLEN_F1_WIDTH                                                       2
#define REQLEN_F1_SHIFT                                                       4
#define REQLEN_F1_MASK                                               0x00000030
#define REQLEN_F1_RD(src)                             (((src) & 0x00000030)>>4)
#define REQLEN_F1_WR(src)                        (((u32)(src)<<4) & 0x00000030)
#define REQLEN_F1_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields REQSIZE	 */
#define REQSIZE_F1_WIDTH                                                      3
#define REQSIZE_F1_SHIFT                                                      1
#define REQSIZE_F1_MASK                                              0x0000000e
#define REQSIZE_F1_RD(src)                            (((src) & 0x0000000e)>>1)
#define REQSIZE_F1_WR(src)                       (((u32)(src)<<1) & 0x0000000e)
#define REQSIZE_F1_SET(dst,src) \
                       (((dst) & ~0x0000000e) | (((u32)(src)<<1) & 0x0000000e))

/*	Register GLBL_DEVERR_ADDR	*/ 
/*	 Fields ERRADDRL	 */
#define ERRADDRL_F2_WIDTH                                                    32
#define ERRADDRL_F2_SHIFT                                                     0
#define ERRADDRL_F2_MASK                                             0xffffffff
#define ERRADDRL_F2_RD(src)                              (((src) & 0xffffffff))
#define ERRADDRL_F2_WR(src)                         (((u32)(src)) & 0xffffffff)
#define ERRADDRL_F2_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_DEVERR_REQINFO	*/ 
/*	 Fields ERRADDRH	 */
#define ERRADDRH_F2_WIDTH                                                    10
#define ERRADDRH_F2_SHIFT                                                    22
#define ERRADDRH_F2_MASK                                             0xffc00000
#define ERRADDRH_F2_RD(src)                          (((src) & 0xffc00000)>>22)
#define ERRADDRH_F2_WR(src)                     (((u32)(src)<<22) & 0xffc00000)
#define ERRADDRH_F2_SET(dst,src) \
                      (((dst) & ~0xffc00000) | (((u32)(src)<<22) & 0xffc00000))
/*	 Fields MSTRID	 */
#define MSTRID_F2_WIDTH                                                       6
#define MSTRID_F2_SHIFT                                                      16
#define MSTRID_F2_MASK                                               0x003f0000
#define MSTRID_F2_RD(src)                            (((src) & 0x003f0000)>>16)
#define MSTRID_F2_WR(src)                       (((u32)(src)<<16) & 0x003f0000)
#define MSTRID_F2_SET(dst,src) \
                      (((dst) & ~0x003f0000) | (((u32)(src)<<16) & 0x003f0000))
/*	 Fields AUXINFO	 */
#define AUXINFO_F2_WIDTH                                                      6
#define AUXINFO_F2_SHIFT                                                     10
#define AUXINFO_F2_MASK                                              0x0000fc00
#define AUXINFO_F2_RD(src)                           (((src) & 0x0000fc00)>>10)
#define AUXINFO_F2_WR(src)                      (((u32)(src)<<10) & 0x0000fc00)
#define AUXINFO_F2_SET(dst,src) \
                      (((dst) & ~0x0000fc00) | (((u32)(src)<<10) & 0x0000fc00))
/*	 Fields REQLEN	 */
#define REQLEN_F2_WIDTH                                                       2
#define REQLEN_F2_SHIFT                                                       4
#define REQLEN_F2_MASK                                               0x00000030
#define REQLEN_F2_RD(src)                             (((src) & 0x00000030)>>4)
#define REQLEN_F2_WR(src)                        (((u32)(src)<<4) & 0x00000030)
#define REQLEN_F2_SET(dst,src) \
                       (((dst) & ~0x00000030) | (((u32)(src)<<4) & 0x00000030))
/*	 Fields REQSIZE	 */
#define REQSIZE_F2_WIDTH                                                      3
#define REQSIZE_F2_SHIFT                                                      1
#define REQSIZE_F2_MASK                                              0x0000000e
#define REQSIZE_F2_RD(src)                            (((src) & 0x0000000e)>>1)
#define REQSIZE_F2_WR(src)                       (((u32)(src)<<1) & 0x0000000e)
#define REQSIZE_F2_SET(dst,src) \
                       (((dst) & ~0x0000000e) | (((u32)(src)<<1) & 0x0000000e))
/*	 Fields REQTYPE	 */
#define REQTYPE_F1_WIDTH                                                      1
#define REQTYPE_F1_SHIFT                                                      0
#define REQTYPE_F1_MASK                                              0x00000001
#define REQTYPE_F1_RD(src)                               (((src) & 0x00000001))
#define REQTYPE_F1_WR(src)                          (((u32)(src)) & 0x00000001)
#define REQTYPE_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register GLBL_SEC_ERRL_ALS	*/ 
/*	 Fields SEC	 */
#define SEC_WIDTH                                                            32
#define SEC_SHIFT                                                             0
#define SEC_MASK                                                     0xffffffff
#define SEC_RD(src)                                      (((src) & 0xffffffff))
#define SEC_WR(src)                                 (((u32)(src)) & 0xffffffff)
#define SEC_SET(dst,src) (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_SEC_ERRH_ALS	*/ 
/*	 Fields SEC	 */
#define SEC_F1_WIDTH                                                         32
#define SEC_F1_SHIFT                                                          0
#define SEC_F1_MASK                                                  0xffffffff
#define SEC_F1_RD(src)                                   (((src) & 0xffffffff))
#define SEC_F1_WR(src)                              (((u32)(src)) & 0xffffffff)
#define SEC_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_DED_ERRL_ALS	*/ 
/*	 Fields DED	 */
#define DED_WIDTH                                                            32
#define DED_SHIFT                                                             0
#define DED_MASK                                                     0xffffffff
#define DED_RD(src)                                      (((src) & 0xffffffff))
#define DED_WR(src)                                 (((u32)(src)) & 0xffffffff)
#define DED_SET(dst,src) (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_DED_ERRH_ALS	*/ 
/*	 Fields DED	 */
#define DED_F1_WIDTH                                                         32
#define DED_F1_SHIFT                                                          0
#define DED_F1_MASK                                                  0xffffffff
#define DED_F1_RD(src)                                   (((src) & 0xffffffff))
#define DED_F1_WR(src)                              (((u32)(src)) & 0xffffffff)
#define DED_F1_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register GLBL_TRANS_ERR_ALS	*/ 
/*	 Fields SWRPOISON	 */
#define SWRPOISON_F1_WIDTH                                                    1
#define SWRPOISON_F1_SHIFT                                                   11
#define SWRPOISON_F1_MASK                                            0x00000800
#define SWRPOISON_F1_RD(src)                         (((src) & 0x00000800)>>11)
#define SWRPOISON_F1_WR(src)                    (((u32)(src)<<11) & 0x00000800)
#define SWRPOISON_F1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields SWRDYTMO	 */
#define SWRDYTMO_F1_WIDTH                                                     1
#define SWRDYTMO_F1_SHIFT                                                    10
#define SWRDYTMO_F1_MASK                                             0x00000400
#define SWRDYTMO_F1_RD(src)                          (((src) & 0x00000400)>>10)
#define SWRDYTMO_F1_WR(src)                     (((u32)(src)<<10) & 0x00000400)
#define SWRDYTMO_F1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields SWRESPTMO	 */
#define SWRESPTMO_F1_WIDTH                                                    1
#define SWRESPTMO_F1_SHIFT                                                    9
#define SWRESPTMO_F1_MASK                                            0x00000200
#define SWRESPTMO_F1_RD(src)                          (((src) & 0x00000200)>>9)
#define SWRESPTMO_F1_WR(src)                     (((u32)(src)<<9) & 0x00000200)
#define SWRESPTMO_F1_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields SWRERR	 */
#define SWRERR_F1_WIDTH                                                       1
#define SWRERR_F1_SHIFT                                                       7
#define SWRERR_F1_MASK                                               0x00000080
#define SWRERR_F1_RD(src)                             (((src) & 0x00000080)>>7)
#define SWRERR_F1_WR(src)                        (((u32)(src)<<7) & 0x00000080)
#define SWRERR_F1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields SRRDYTMO	 */
#define SRRDYTMO_F1_WIDTH                                                     1
#define SRRDYTMO_F1_SHIFT                                                     3
#define SRRDYTMO_F1_MASK                                             0x00000008
#define SRRDYTMO_F1_RD(src)                           (((src) & 0x00000008)>>3)
#define SRRDYTMO_F1_WR(src)                      (((u32)(src)<<3) & 0x00000008)
#define SRRDYTMO_F1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields SRRESPTMO	 */
#define SRRESPTMO_F1_WIDTH                                                    1
#define SRRESPTMO_F1_SHIFT                                                    2
#define SRRESPTMO_F1_MASK                                            0x00000004
#define SRRESPTMO_F1_RD(src)                          (((src) & 0x00000004)>>2)
#define SRRESPTMO_F1_WR(src)                     (((u32)(src)<<2) & 0x00000004)
#define SRRESPTMO_F1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields SRDERR	 */
#define SRDERR_F1_WIDTH                                                       1
#define SRDERR_F1_SHIFT                                                       0
#define SRDERR_F1_MASK                                               0x00000001
#define SRDERR_F1_RD(src)                                (((src) & 0x00000001))
#define SRDERR_F1_WR(src)                           (((u32)(src)) & 0x00000001)
#define SRDERR_F1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_SLAVE_SHIM_CSR_BASE_ADDR			0x01f21e000ULL

/*    Address SLAVE_SHIM_CSR  Registers */
#define CFG_SLV_RESP_TMO_CNTR_ADDR                                   0x00000004
#define CFG_SLV_RESP_TMO_CNTR_DEFAULT                                0x0000ffff
#define CFG_SLV_READY_TMO_CNTR_ADDR                                  0x00000008
#define CFG_SLV_READY_TMO_CNTR_DEFAULT                               0x0004ffff
#define INT_SLV_TMO_ADDR                                             0x0000000c
#define INT_SLV_TMO_DEFAULT                                          0x00000000
#define INT_SLV_TMOMASK_ADDR                                         0x00000010
#define CFG_AMA_MODE_ADDR                                            0x00000014
#define CFG_AMA_MODE_DEFAULT                                         0x00000000
#define CFG_SLV_CSR_TMO_CNTR_ADDR                                    0x00000018
#define CFG_SLV_CSR_TMO_CNTR_DEFAULT                                 0x0000ffff
#define CFG_MASK_DEV_ERR_RESP_ADDR                                   0x0000001c
#define CFG_MASK_DEV_ERR_RESP_DEFAULT                                0x00000000

/*	Register CFG_SLV_RESP_TMO_CNTR	*/ 
/*	 Fields CFG_CSR_POISON	 */
#define CFG_CSR_POISON_WIDTH                                                  1
#define CFG_CSR_POISON_SHIFT                                                 17
#define CFG_CSR_POISON_MASK                                          0x00020000
#define CFG_CSR_POISON_RD(src)                       (((src) & 0x00020000)>>17)
#define CFG_CSR_POISON_WR(src)                  (((u32)(src)<<17) & 0x00020000)
#define CFG_CSR_POISON_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields CSR_ERR_RESP_EN	 */
#define CSR_ERR_RESP_EN_WIDTH                                                 1
#define CSR_ERR_RESP_EN_SHIFT                                                16
#define CSR_ERR_RESP_EN_MASK                                         0x00010000
#define CSR_ERR_RESP_EN_RD(src)                      (((src) & 0x00010000)>>16)
#define CSR_ERR_RESP_EN_WR(src)                 (((u32)(src)<<16) & 0x00010000)
#define CSR_ERR_RESP_EN_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields CFG_CSR_RESP_TMO	 */
#define CFG_CSR_RESP_TMO_WIDTH                                               16
#define CFG_CSR_RESP_TMO_SHIFT                                                0
#define CFG_CSR_RESP_TMO_MASK                                        0x0000ffff
#define CFG_CSR_RESP_TMO_RD(src)                         (((src) & 0x0000ffff))
#define CFG_CSR_RESP_TMO_WR(src)                    (((u32)(src)) & 0x0000ffff)
#define CFG_CSR_RESP_TMO_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CFG_SLV_READY_TMO_CNTR	*/ 
/*	 Fields CFG_CSR_READY_TMO	 */
#define CFG_CSR_READY_TMO_WIDTH                                              32
#define CFG_CSR_READY_TMO_SHIFT                                               0
#define CFG_CSR_READY_TMO_MASK                                       0xffffffff
#define CFG_CSR_READY_TMO_RD(src)                        (((src) & 0xffffffff))
#define CFG_CSR_READY_TMO_WR(src)                   (((u32)(src)) & 0xffffffff)
#define CFG_CSR_READY_TMO_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register INT_SLV_TMO	*/ 
/*	 Fields STS_CSR_TMO	 */
#define STS_CSR_TMO_WIDTH                                                     1
#define STS_CSR_TMO_SHIFT                                                     4
#define STS_CSR_TMO_MASK                                             0x00000010
#define STS_CSR_TMO_RD(src)                           (((src) & 0x00000010)>>4)
#define STS_CSR_TMO_WR(src)                      (((u32)(src)<<4) & 0x00000010)
#define STS_CSR_TMO_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields STS_ARREADY_TMO	 */
#define STS_ARREADY_TMO_WIDTH                                                 1
#define STS_ARREADY_TMO_SHIFT                                                 3
#define STS_ARREADY_TMO_MASK                                         0x00000008
#define STS_ARREADY_TMO_RD(src)                       (((src) & 0x00000008)>>3)
#define STS_ARREADY_TMO_WR(src)                  (((u32)(src)<<3) & 0x00000008)
#define STS_ARREADY_TMO_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields STS_RVALID_TMO	 */
#define STS_RVALID_TMO_WIDTH                                                  1
#define STS_RVALID_TMO_SHIFT                                                  2
#define STS_RVALID_TMO_MASK                                          0x00000004
#define STS_RVALID_TMO_RD(src)                        (((src) & 0x00000004)>>2)
#define STS_RVALID_TMO_WR(src)                   (((u32)(src)<<2) & 0x00000004)
#define STS_RVALID_TMO_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields STS_AWREADY_TMO	 */
#define STS_AWREADY_TMO_WIDTH                                                 1
#define STS_AWREADY_TMO_SHIFT                                                 1
#define STS_AWREADY_TMO_MASK                                         0x00000002
#define STS_AWREADY_TMO_RD(src)                       (((src) & 0x00000002)>>1)
#define STS_AWREADY_TMO_WR(src)                  (((u32)(src)<<1) & 0x00000002)
#define STS_AWREADY_TMO_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields STS_BVALID_TMO	 */
#define STS_BVALID_TMO_WIDTH                                                  1
#define STS_BVALID_TMO_SHIFT                                                  0
#define STS_BVALID_TMO_MASK                                          0x00000001
#define STS_BVALID_TMO_RD(src)                           (((src) & 0x00000001))
#define STS_BVALID_TMO_WR(src)                      (((u32)(src)) & 0x00000001)
#define STS_BVALID_TMO_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register INT_SLV_TMOMask	*/
/*    Mask Register Fields STS_CSR_TMOMask    */
#define STS_CSR_TMOMASK_WIDTH                                                 1
#define STS_CSR_TMOMASK_SHIFT                                                 4
#define STS_CSR_TMOMASK_MASK                                         0x00000010
#define STS_CSR_TMOMASK_RD(src)                       (((src) & 0x00000010)>>4)
#define STS_CSR_TMOMASK_WR(src)                  (((u32)(src)<<4) & 0x00000010)
#define STS_CSR_TMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*    Mask Register Fields STS_ARREADY_TMOMask    */
#define STS_ARREADY_TMOMASK_WIDTH                                             1
#define STS_ARREADY_TMOMASK_SHIFT                                             3
#define STS_ARREADY_TMOMASK_MASK                                     0x00000008
#define STS_ARREADY_TMOMASK_RD(src)                   (((src) & 0x00000008)>>3)
#define STS_ARREADY_TMOMASK_WR(src)              (((u32)(src)<<3) & 0x00000008)
#define STS_ARREADY_TMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*    Mask Register Fields STS_RVALID_TMOMask    */
#define STS_RVALID_TMOMASK_WIDTH                                              1
#define STS_RVALID_TMOMASK_SHIFT                                              2
#define STS_RVALID_TMOMASK_MASK                                      0x00000004
#define STS_RVALID_TMOMASK_RD(src)                    (((src) & 0x00000004)>>2)
#define STS_RVALID_TMOMASK_WR(src)               (((u32)(src)<<2) & 0x00000004)
#define STS_RVALID_TMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*    Mask Register Fields STS_AWREADY_TMOMask    */
#define STS_AWREADY_TMOMASK_WIDTH                                             1
#define STS_AWREADY_TMOMASK_SHIFT                                             1
#define STS_AWREADY_TMOMASK_MASK                                     0x00000002
#define STS_AWREADY_TMOMASK_RD(src)                   (((src) & 0x00000002)>>1)
#define STS_AWREADY_TMOMASK_WR(src)              (((u32)(src)<<1) & 0x00000002)
#define STS_AWREADY_TMOMASK_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*    Mask Register Fields STS_BVALID_TMOMask    */
#define STS_BVALID_TMOMASK_WIDTH                                              1
#define STS_BVALID_TMOMASK_SHIFT                                              0
#define STS_BVALID_TMOMASK_MASK                                      0x00000001
#define STS_BVALID_TMOMASK_RD(src)                       (((src) & 0x00000001))
#define STS_BVALID_TMOMASK_WR(src)                  (((u32)(src)) & 0x00000001)
#define STS_BVALID_TMOMASK_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CFG_AMA_MODE	*/ 
/*	 Fields CFG_RD2WR_EN	 */
#define CFG_RD2WR_EN_WIDTH                                                    1
#define CFG_RD2WR_EN_SHIFT                                                    1
#define CFG_RD2WR_EN_MASK                                            0x00000002
#define CFG_RD2WR_EN_RD(src)                          (((src) & 0x00000002)>>1)
#define CFG_RD2WR_EN_WR(src)                     (((u32)(src)<<1) & 0x00000002)
#define CFG_RD2WR_EN_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields CFG_AMA_MODE	 */
#define ENET_CFG_AMA_MODE_WIDTH                                            1
#define ENET_CFG_AMA_MODE_SHIFT                                            0
#define ENET_CFG_AMA_MODE_MASK                                    0x00000001
#define ENET_CFG_AMA_MODE_RD(src)                     (((src) & 0x00000001))
#define ENET_CFG_AMA_MODE_WR(src)                (((u32)(src)) & 0x00000001)
#define ENET_CFG_AMA_MODE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CFG_SLV_CSR_TMO_CNTR	*/ 
/*	 Fields CFG_CSR_TMO	 */
#define CFG_CSR_TMO_WIDTH                                                    16
#define CFG_CSR_TMO_SHIFT                                                     0
#define CFG_CSR_TMO_MASK                                             0x0000ffff
#define CFG_CSR_TMO_RD(src)                              (((src) & 0x0000ffff))
#define CFG_CSR_TMO_WR(src)                         (((u32)(src)) & 0x0000ffff)
#define CFG_CSR_TMO_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register CFG_MASK_DEV_ERR_RESP	*/ 
/*	 Fields MASK_DEV_ERR_RESP	 */
#define MASK_DEV_ERR_RESP_WIDTH                                               1
#define MASK_DEV_ERR_RESP_SHIFT                                               0
#define MASK_DEV_ERR_RESP_MASK                                       0x00000001
#define MASK_DEV_ERR_RESP_RD(src)                        (((src) & 0x00000001))
#define MASK_DEV_ERR_RESP_WR(src)                   (((u32)(src)) & 0x00000001)
#define MASK_DEV_ERR_RESP_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define ENET_MASTER_SHIM_CSR_BASE_ADDR			0x01f21f000ULL

/*    Address MASTER_SHIM_CSR  Registers */
#define CFG_MST_IOB_SEL_ADDR                                         0x00000004
#define CFG_MST_IOB_SEL_DEFAULT                                      0x00000002
#define CFG_VC0_PREFETCH_ADDR                                        0x00000008
#define CFG_VC0_PREFETCH_DEFAULT                                     0x00000004
#define CFG_VC1_PREFETCH_ADDR                                        0x0000000c
#define CFG_VC1_PREFETCH_DEFAULT                                     0x00000004
#define CFG_VC2_PREFETCH_ADDR                                        0x00000010
#define CFG_VC2_PREFETCH_DEFAULT                                     0x00000004
#define VC0_TOKEN_USED_ADDR                                          0x00000014
#define VC0_TOKEN_USED_DEFAULT                                       0x00000000
#define VC1_TOKEN_USED_ADDR                                          0x00000018
#define VC1_TOKEN_USED_DEFAULT                                       0x00000000
#define VC2_TOKEN_USED_ADDR                                          0x0000001c
#define VC2_TOKEN_USED_DEFAULT                                       0x00000000
#define VC0_TOKEN_REQ_ADDR                                           0x00000020
#define VC0_TOKEN_REQ_DEFAULT                                        0x00000000
#define VC1_TOKEN_REQ_ADDR                                           0x00000024
#define VC1_TOKEN_REQ_DEFAULT                                        0x00000000
#define VC2_TOKEN_REQ_ADDR                                           0x00000028
#define VC2_TOKEN_REQ_DEFAULT                                        0x00000000

/*	Register CFG_MST_IOB_SEL	*/ 
/*	 Fields CFG_VC_BYPASS	 */
#define CFG_VC_BYPASS_WIDTH                                                   1
#define CFG_VC_BYPASS_SHIFT                                                   1
#define CFG_VC_BYPASS_MASK                                           0x00000002
#define CFG_VC_BYPASS_RD(src)                         (((src) & 0x00000002)>>1)
#define CFG_VC_BYPASS_WR(src)                    (((u32)(src)<<1) & 0x00000002)
#define CFG_VC_BYPASS_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields CFG_MST_IOB_SEL	 */
#define CFG_MST_IOB_SEL_WIDTH                                                 1
#define CFG_MST_IOB_SEL_SHIFT                                                 0
#define CFG_MST_IOB_SEL_MASK                                         0x00000001
#define CFG_MST_IOB_SEL_RD(src)                          (((src) & 0x00000001))
#define CFG_MST_IOB_SEL_WR(src)                     (((u32)(src)) & 0x00000001)
#define CFG_MST_IOB_SEL_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CFG_VC0_PREFETCH	*/ 
/*	 Fields CFG_VC0_PREFETCH_CNT	 */
#define CFG_VC0_PREFETCH_CNT_WIDTH                                            4
#define CFG_VC0_PREFETCH_CNT_SHIFT                                            0
#define CFG_VC0_PREFETCH_CNT_MASK                                    0x0000000f
#define CFG_VC0_PREFETCH_CNT_RD(src)                     (((src) & 0x0000000f))
#define CFG_VC0_PREFETCH_CNT_WR(src)                (((u32)(src)) & 0x0000000f)
#define CFG_VC0_PREFETCH_CNT_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register CFG_VC1_PREFETCH	*/ 
/*	 Fields CFG_VC1_PREFETCH_CNT	 */
#define CFG_VC1_PREFETCH_CNT_WIDTH                                            4
#define CFG_VC1_PREFETCH_CNT_SHIFT                                            0
#define CFG_VC1_PREFETCH_CNT_MASK                                    0x0000000f
#define CFG_VC1_PREFETCH_CNT_RD(src)                     (((src) & 0x0000000f))
#define CFG_VC1_PREFETCH_CNT_WR(src)                (((u32)(src)) & 0x0000000f)
#define CFG_VC1_PREFETCH_CNT_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register CFG_VC2_PREFETCH	*/ 
/*	 Fields CFG_VC2_PREFETCH_CNT	 */
#define CFG_VC2_PREFETCH_CNT_WIDTH                                            4
#define CFG_VC2_PREFETCH_CNT_SHIFT                                            0
#define CFG_VC2_PREFETCH_CNT_MASK                                    0x0000000f
#define CFG_VC2_PREFETCH_CNT_RD(src)                     (((src) & 0x0000000f))
#define CFG_VC2_PREFETCH_CNT_WR(src)                (((u32)(src)) & 0x0000000f)
#define CFG_VC2_PREFETCH_CNT_SET(dst,src) \
                          (((dst) & ~0x0000000f) | (((u32)(src)) & 0x0000000f))

/*	Register VC0_TOKEN_USED	*/ 
/*	 Fields VC0_TOKEN_USED	 */
#define VC0_TOKEN_USED_WIDTH                                                 32
#define VC0_TOKEN_USED_SHIFT                                                  0
#define VC0_TOKEN_USED_MASK                                          0xffffffff
#define VC0_TOKEN_USED_RD(src)                           (((src) & 0xffffffff))
#define VC0_TOKEN_USED_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register VC1_TOKEN_USED	*/ 
/*	 Fields VC1_TOKEN_USED	 */
#define VC1_TOKEN_USED_WIDTH                                                 32
#define VC1_TOKEN_USED_SHIFT                                                  0
#define VC1_TOKEN_USED_MASK                                          0xffffffff
#define VC1_TOKEN_USED_RD(src)                           (((src) & 0xffffffff))
#define VC1_TOKEN_USED_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register VC2_TOKEN_USED	*/ 
/*	 Fields VC2_TOKEN_USED	 */
#define VC2_TOKEN_USED_WIDTH                                                 32
#define VC2_TOKEN_USED_SHIFT                                                  0
#define VC2_TOKEN_USED_MASK                                          0xffffffff
#define VC2_TOKEN_USED_RD(src)                           (((src) & 0xffffffff))
#define VC2_TOKEN_USED_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register VC0_TOKEN_REQ	*/ 
/*	 Fields VC0_TOKEN_REQ	 */
#define VC0_TOKEN_REQ_WIDTH                                                  32
#define VC0_TOKEN_REQ_SHIFT                                                   0
#define VC0_TOKEN_REQ_MASK                                           0xffffffff
#define VC0_TOKEN_REQ_RD(src)                            (((src) & 0xffffffff))
#define VC0_TOKEN_REQ_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register VC1_TOKEN_REQ	*/ 
/*	 Fields VC1_TOKEN_REQ	 */
#define VC1_TOKEN_REQ_WIDTH                                                  32
#define VC1_TOKEN_REQ_SHIFT                                                   0
#define VC1_TOKEN_REQ_MASK                                           0xffffffff
#define VC1_TOKEN_REQ_RD(src)                            (((src) & 0xffffffff))
#define VC1_TOKEN_REQ_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Register VC2_TOKEN_REQ	*/ 
/*	 Fields VC2_TOKEN_REQ	 */
#define VC2_TOKEN_REQ_WIDTH                                                  32
#define VC2_TOKEN_REQ_SHIFT                                                   0
#define VC2_TOKEN_REQ_MASK                                           0xffffffff
#define VC2_TOKEN_REQ_RD(src)                            (((src) & 0xffffffff))
#define VC2_TOKEN_REQ_SET(dst,src) \
                          (((dst) & ~0xffffffff) | (((u32)(src)) & 0xffffffff))

/*	Global Base Address	*/
#define PE_MCXMAC_BASE_ADDR			0x000000000ULL

/*    Address PE_MCXMAC  Registers */
#define MAC_CONFIG_1_ADDR                                            0x00000000
#define MAC_CONFIG_1_DEFAULT                                         0x80000000
#define MAC_CONFIG_2_ADDR                                            0x00000004
#define MAC_CONFIG_2_DEFAULT                                         0x00007000
#define IPG_IFG_ADDR                                                 0x00000008
#define IPG_IFG_DEFAULT                                              0x40605060
#define HALF_DUPLEX_ADDR                                             0x0000000c
#define HALF_DUPLEX_DEFAULT                                          0x00a1f037
#define MAX_FRAME_LEN_ADDR                                           0x00000010
#define MAX_FRAME_LEN_DEFAULT                                        0x00000600
#define MII_MGMT_CONFIG_ADDR                                         0x00000020
#define MII_MGMT_CONFIG_DEFAULT                                      0x40000000
#define MII_MGMT_COMMAND_ADDR                                        0x00000024
#define MII_MGMT_COMMAND_DEFAULT                                     0x00000000
#define MII_MGMT_ADDRESS_ADDR                                        0x00000028
#define MII_MGMT_ADDRESS_DEFAULT                                     0x00000000
#define MII_MGMT_CONTROL_ADDR                                        0x0000002c
#define MII_MGMT_CONTROL_DEFAULT                                     0x00000000
#define MII_MGMT_STATUS_ADDR                                         0x00000030
#define MII_MGMT_STATUS_DEFAULT                                      0x00000000
#define MII_MGMT_INDICATORS_ADDR                                     0x00000034
#define MII_MGMT_INDICATORS_DEFAULT                                  0x00000000
#define INTERFACE_CONTROL_ADDR                                       0x00000038
#define INTERFACE_CONTROL_DEFAULT                                    0x00000000
#define INTERFACE_STATUS_ADDR                                        0x0000003c
#define INTERFACE_STATUS_DEFAULT                                     0x00000000
#define STATION_ADDR0_ADDR                                           0x00000040
#define STATION_ADDR0_DEFAULT                                        0x00000000
#define STATION_ADDR1_ADDR                                           0x00000044
#define STATION_ADDR1_DEFAULT                                        0x0000001e

/*	Register mac_config_1	*/ 
/*	 Fields soft_reset	 */
#define SOFT_RESET1_WIDTH                                                     1
#define SOFT_RESET1_SHIFT                                                    31
#define SOFT_RESET1_MASK                                             0x80000000
#define SOFT_RESET1_RD(src)                          (((src) & 0x80000000)>>31)
#define SOFT_RESET1_WR(src)                     (((u32)(src)<<31) & 0x80000000)
#define SOFT_RESET1_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields sim_reset	 */
#define SIM_RESET1_WIDTH                                                      1
#define SIM_RESET1_SHIFT                                                     30
#define SIM_RESET1_MASK                                              0x40000000
#define SIM_RESET1_RD(src)                           (((src) & 0x40000000)>>30)
#define SIM_RESET1_WR(src)                      (((u32)(src)<<30) & 0x40000000)
#define SIM_RESET1_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields reset_rx_mc	 */
#define RESET_RX_MC1_WIDTH                                                    1
#define RESET_RX_MC1_SHIFT                                                   19
#define RESET_RX_MC1_MASK                                            0x00080000
#define RESET_RX_MC1_RD(src)                         (((src) & 0x00080000)>>19)
#define RESET_RX_MC1_WR(src)                    (((u32)(src)<<19) & 0x00080000)
#define RESET_RX_MC1_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields reset_tx_mc	 */
#define RESET_TX_MC1_WIDTH                                                    1
#define RESET_TX_MC1_SHIFT                                                   18
#define RESET_TX_MC1_MASK                                            0x00040000
#define RESET_TX_MC1_RD(src)                         (((src) & 0x00040000)>>18)
#define RESET_TX_MC1_WR(src)                    (((u32)(src)<<18) & 0x00040000)
#define RESET_TX_MC1_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields reset_rx_fun	 */
#define RESET_RX_FUN1_WIDTH                                                   1
#define RESET_RX_FUN1_SHIFT                                                  17
#define RESET_RX_FUN1_MASK                                           0x00020000
#define RESET_RX_FUN1_RD(src)                        (((src) & 0x00020000)>>17)
#define RESET_RX_FUN1_WR(src)                   (((u32)(src)<<17) & 0x00020000)
#define RESET_RX_FUN1_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields reset_tx_fun	 */
#define RESET_TX_FUN1_WIDTH                                                   1
#define RESET_TX_FUN1_SHIFT                                                  16
#define RESET_TX_FUN1_MASK                                           0x00010000
#define RESET_TX_FUN1_RD(src)                        (((src) & 0x00010000)>>16)
#define RESET_TX_FUN1_WR(src)                   (((u32)(src)<<16) & 0x00010000)
#define RESET_TX_FUN1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields loop_back	 */
#define LOOP_BACK1_WIDTH                                                      1
#define LOOP_BACK1_SHIFT                                                      8
#define LOOP_BACK1_MASK                                              0x00000100
#define LOOP_BACK1_RD(src)                            (((src) & 0x00000100)>>8)
#define LOOP_BACK1_WR(src)                       (((u32)(src)<<8) & 0x00000100)
#define LOOP_BACK1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields rx_flow_en	 */
#define RX_FLOW_EN1_WIDTH                                                     1
#define RX_FLOW_EN1_SHIFT                                                     5
#define RX_FLOW_EN1_MASK                                             0x00000020
#define RX_FLOW_EN1_RD(src)                           (((src) & 0x00000020)>>5)
#define RX_FLOW_EN1_WR(src)                      (((u32)(src)<<5) & 0x00000020)
#define RX_FLOW_EN1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields tx_flow_en	 */
#define TX_FLOW_EN1_WIDTH                                                     1
#define TX_FLOW_EN1_SHIFT                                                     4
#define TX_FLOW_EN1_MASK                                             0x00000010
#define TX_FLOW_EN1_RD(src)                           (((src) & 0x00000010)>>4)
#define TX_FLOW_EN1_WR(src)                      (((u32)(src)<<4) & 0x00000010)
#define TX_FLOW_EN1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields syncd_rx_enable	 */
#define SYNCD_RX_ENABLE1_WIDTH                                                1
#define SYNCD_RX_ENABLE1_SHIFT                                                3
#define SYNCD_RX_ENABLE1_MASK                                        0x00000008
#define SYNCD_RX_ENABLE1_RD(src)                      (((src) & 0x00000008)>>3)
#define SYNCD_RX_ENABLE1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields rx_en	 */
#define RX_EN1_WIDTH                                                          1
#define RX_EN1_SHIFT                                                          2
#define RX_EN1_MASK                                                  0x00000004
#define RX_EN1_RD(src)                                (((src) & 0x00000004)>>2)
#define RX_EN1_WR(src)                           (((u32)(src)<<2) & 0x00000004)
#define RX_EN1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields syncd_tx_en	 */
#define SYNCD_TX_EN1_WIDTH                                                    1
#define SYNCD_TX_EN1_SHIFT                                                    1
#define SYNCD_TX_EN1_MASK                                            0x00000002
#define SYNCD_TX_EN1_RD(src)                          (((src) & 0x00000002)>>1)
#define SYNCD_TX_EN1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields tx_en	 */
#define TX_EN1_WIDTH                                                          1
#define TX_EN1_SHIFT                                                          0
#define TX_EN1_MASK                                                  0x00000001
#define TX_EN1_RD(src)                                   (((src) & 0x00000001))
#define TX_EN1_WR(src)                              (((u32)(src)) & 0x00000001)
#define TX_EN1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register mac_config_2	*/ 
/*	 Fields preamble_length	 */
#define PREAMBLE_LENGTH2_WIDTH                                                4
#define PREAMBLE_LENGTH2_SHIFT                                               12
#define PREAMBLE_LENGTH2_MASK                                        0x0000f000
#define PREAMBLE_LENGTH2_RD(src)                     (((src) & 0x0000f000)>>12)
#define PREAMBLE_LENGTH2_WR(src)                (((u32)(src)<<12) & 0x0000f000)
#define PREAMBLE_LENGTH2_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields interface_mode	 */
#define ENET_INTERFACE_MODE2_WIDTH                                         2
#define ENET_INTERFACE_MODE2_SHIFT                                         8
#define ENET_INTERFACE_MODE2_MASK                                 0x00000300
#define ENET_INTERFACE_MODE2_RD(src)               (((src) & 0x00000300)>>8)
#define ENET_INTERFACE_MODE2_WR(src)          (((u32)(src)<<8) & 0x00000300)
#define ENET_INTERFACE_MODE2_SET(dst,src) \
                       (((dst) & ~0x00000300) | (((u32)(src)<<8) & 0x00000300))
/*	 Fields huge_frame_en	 */
#define HUGE_FRAME_EN2_WIDTH                                                  1
#define HUGE_FRAME_EN2_SHIFT                                                  5
#define HUGE_FRAME_EN2_MASK                                          0x00000020
#define HUGE_FRAME_EN2_RD(src)                        (((src) & 0x00000020)>>5)
#define HUGE_FRAME_EN2_WR(src)                   (((u32)(src)<<5) & 0x00000020)
#define HUGE_FRAME_EN2_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields length_check	 */
#define LENGTH_CHECK2_WIDTH                                                   1
#define LENGTH_CHECK2_SHIFT                                                   4
#define LENGTH_CHECK2_MASK                                           0x00000010
#define LENGTH_CHECK2_RD(src)                         (((src) & 0x00000010)>>4)
#define LENGTH_CHECK2_WR(src)                    (((u32)(src)<<4) & 0x00000010)
#define LENGTH_CHECK2_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields pad_crc	 */
#define PAD_CRC2_WIDTH                                                        1
#define PAD_CRC2_SHIFT                                                        2
#define PAD_CRC2_MASK                                                0x00000004
#define PAD_CRC2_RD(src)                              (((src) & 0x00000004)>>2)
#define PAD_CRC2_WR(src)                         (((u32)(src)<<2) & 0x00000004)
#define PAD_CRC2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields crc_en	 */
#define CRC_EN2_WIDTH                                                         1
#define CRC_EN2_SHIFT                                                         1
#define CRC_EN2_MASK                                                 0x00000002
#define CRC_EN2_RD(src)                               (((src) & 0x00000002)>>1)
#define CRC_EN2_WR(src)                          (((u32)(src)<<1) & 0x00000002)
#define CRC_EN2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields full_duplex	 */
#define FULL_DUPLEX2_WIDTH                                                    1
#define FULL_DUPLEX2_SHIFT                                                    0
#define FULL_DUPLEX2_MASK                                            0x00000001
#define FULL_DUPLEX2_RD(src)                             (((src) & 0x00000001))
#define FULL_DUPLEX2_WR(src)                        (((u32)(src)) & 0x00000001)
#define FULL_DUPLEX2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register ipg_ifg	*/ 
/*	 Fields non_b2b_ipg_part1	 */
#define NON_B2B_IPG_PART1_WIDTH                                               7
#define NON_B2B_IPG_PART1_SHIFT                                              24
#define NON_B2B_IPG_PART1_MASK                                       0x7f000000
#define NON_B2B_IPG_PART1_RD(src)                    (((src) & 0x7f000000)>>24)
#define NON_B2B_IPG_PART1_WR(src)               (((u32)(src)<<24) & 0x7f000000)
#define NON_B2B_IPG_PART1_SET(dst,src) \
                      (((dst) & ~0x7f000000) | (((u32)(src)<<24) & 0x7f000000))
/*	 Fields non_b2b_ipg_part2	 */
#define NON_B2B_IPG_PART2_WIDTH                                               7
#define NON_B2B_IPG_PART2_SHIFT                                              16
#define NON_B2B_IPG_PART2_MASK                                       0x007f0000
#define NON_B2B_IPG_PART2_RD(src)                    (((src) & 0x007f0000)>>16)
#define NON_B2B_IPG_PART2_WR(src)               (((u32)(src)<<16) & 0x007f0000)
#define NON_B2B_IPG_PART2_SET(dst,src) \
                      (((dst) & ~0x007f0000) | (((u32)(src)<<16) & 0x007f0000))
/*	 Fields min_ifg_enforce	 */
#define MIN_IFG_ENFORCE_WIDTH                                                 8
#define MIN_IFG_ENFORCE_SHIFT                                                 8
#define MIN_IFG_ENFORCE_MASK                                         0x0000ff00
#define MIN_IFG_ENFORCE_RD(src)                       (((src) & 0x0000ff00)>>8)
#define MIN_IFG_ENFORCE_WR(src)                  (((u32)(src)<<8) & 0x0000ff00)
#define MIN_IFG_ENFORCE_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields b2b_ipg	 */
#define B2B_IPG_WIDTH                                                         7
#define B2B_IPG_SHIFT                                                         0
#define B2B_IPG_MASK                                                 0x0000007f
#define B2B_IPG_RD(src)                                  (((src) & 0x0000007f))
#define B2B_IPG_WR(src)                             (((u32)(src)) & 0x0000007f)
#define B2B_IPG_SET(dst,src) \
                          (((dst) & ~0x0000007f) | (((u32)(src)) & 0x0000007f))

/*	Register half_duplex	*/ 
/*	 Fields alt_beb_trunc	 */
#define ALT_BEB_TRUNC_WIDTH                                                   4
#define ALT_BEB_TRUNC_SHIFT                                                  20
#define ALT_BEB_TRUNC_MASK                                           0x00f00000
#define ALT_BEB_TRUNC_RD(src)                        (((src) & 0x00f00000)>>20)
#define ALT_BEB_TRUNC_WR(src)                   (((u32)(src)<<20) & 0x00f00000)
#define ALT_BEB_TRUNC_SET(dst,src) \
                      (((dst) & ~0x00f00000) | (((u32)(src)<<20) & 0x00f00000))
/*	 Fields alt_beb	 */
#define ALT_BEB_WIDTH                                                         1
#define ALT_BEB_SHIFT                                                        19
#define ALT_BEB_MASK                                                 0x00080000
#define ALT_BEB_RD(src)                              (((src) & 0x00080000)>>19)
#define ALT_BEB_WR(src)                         (((u32)(src)<<19) & 0x00080000)
#define ALT_BEB_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields bp_no_backoff	 */
#define BP_NO_BACKOFF_WIDTH                                                   1
#define BP_NO_BACKOFF_SHIFT                                                  18
#define BP_NO_BACKOFF_MASK                                           0x00040000
#define BP_NO_BACKOFF_RD(src)                        (((src) & 0x00040000)>>18)
#define BP_NO_BACKOFF_WR(src)                   (((u32)(src)<<18) & 0x00040000)
#define BP_NO_BACKOFF_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields no_backoff	 */
#define NO_BACKOFF_WIDTH                                                      1
#define NO_BACKOFF_SHIFT                                                     17
#define NO_BACKOFF_MASK                                              0x00020000
#define NO_BACKOFF_RD(src)                           (((src) & 0x00020000)>>17)
#define NO_BACKOFF_WR(src)                      (((u32)(src)<<17) & 0x00020000)
#define NO_BACKOFF_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields excessive_defer	 */
#define EXCESSIVE_DEFER_WIDTH                                                 1
#define EXCESSIVE_DEFER_SHIFT                                                16
#define EXCESSIVE_DEFER_MASK                                         0x00010000
#define EXCESSIVE_DEFER_RD(src)                      (((src) & 0x00010000)>>16)
#define EXCESSIVE_DEFER_WR(src)                 (((u32)(src)<<16) & 0x00010000)
#define EXCESSIVE_DEFER_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields retrans_max	 */
#define RETRANS_MAX_WIDTH                                                     4
#define RETRANS_MAX_SHIFT                                                    12
#define RETRANS_MAX_MASK                                             0x0000f000
#define RETRANS_MAX_RD(src)                          (((src) & 0x0000f000)>>12)
#define RETRANS_MAX_WR(src)                     (((u32)(src)<<12) & 0x0000f000)
#define RETRANS_MAX_SET(dst,src) \
                      (((dst) & ~0x0000f000) | (((u32)(src)<<12) & 0x0000f000))
/*	 Fields col_window	 */
#define COL_WINDOW_WIDTH                                                     10
#define COL_WINDOW_SHIFT                                                      0
#define COL_WINDOW_MASK                                              0x000003ff
#define COL_WINDOW_RD(src)                               (((src) & 0x000003ff))
#define COL_WINDOW_WR(src)                          (((u32)(src)) & 0x000003ff)
#define COL_WINDOW_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register max_frame_len	*/ 
/*	 Fields max_frame_len	 */
#define MAX_FRAME_LEN_WIDTH                                                  16
#define MAX_FRAME_LEN_SHIFT                                                   0
#define MAX_FRAME_LEN_MASK                                           0x0000ffff
#define MAX_FRAME_LEN_RD(src)                            (((src) & 0x0000ffff))
#define MAX_FRAME_LEN_WR(src)                       (((u32)(src)) & 0x0000ffff)
#define MAX_FRAME_LEN_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register mii_mgmt_config	*/ 
/*	 Fields reset_mii_mgmt	 */
#define RESET_MII_MGMT_WIDTH                                                  1
#define RESET_MII_MGMT_SHIFT                                                 31
#define RESET_MII_MGMT_MASK                                          0x80000000
#define RESET_MII_MGMT_RD(src)                       (((src) & 0x80000000)>>31)
#define RESET_MII_MGMT_WR(src)                  (((u32)(src)<<31) & 0x80000000)
#define RESET_MII_MGMT_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields mdo_at_negedge_en	 */
#define MDO_AT_NEGEDGE_EN_WIDTH                                               1
#define MDO_AT_NEGEDGE_EN_SHIFT                                              30
#define MDO_AT_NEGEDGE_EN_MASK                                       0x40000000
#define MDO_AT_NEGEDGE_EN_RD(src)                    (((src) & 0x40000000)>>30)
#define MDO_AT_NEGEDGE_EN_WR(src)               (((u32)(src)<<30) & 0x40000000)
#define MDO_AT_NEGEDGE_EN_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields mdo_after_5mgtclks_en	 */
#define MDO_AFTER_5MGTCLKS_EN_WIDTH                                           1
#define MDO_AFTER_5MGTCLKS_EN_SHIFT                                          29
#define MDO_AFTER_5MGTCLKS_EN_MASK                                   0x20000000
#define MDO_AFTER_5MGTCLKS_EN_RD(src)                (((src) & 0x20000000)>>29)
#define MDO_AFTER_5MGTCLKS_EN_WR(src)           (((u32)(src)<<29) & 0x20000000)
#define MDO_AFTER_5MGTCLKS_EN_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields mdo_after_4mgtclks_en	 */
#define MDO_AFTER_4MGTCLKS_EN_WIDTH                                           1
#define MDO_AFTER_4MGTCLKS_EN_SHIFT                                          28
#define MDO_AFTER_4MGTCLKS_EN_MASK                                   0x10000000
#define MDO_AFTER_4MGTCLKS_EN_RD(src)                (((src) & 0x10000000)>>28)
#define MDO_AFTER_4MGTCLKS_EN_WR(src)           (((u32)(src)<<28) & 0x10000000)
#define MDO_AFTER_4MGTCLKS_EN_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields mdo_after_3mgtclks_en	 */
#define MDO_AFTER_3MGTCLKS_EN_WIDTH                                           1
#define MDO_AFTER_3MGTCLKS_EN_SHIFT                                          27
#define MDO_AFTER_3MGTCLKS_EN_MASK                                   0x08000000
#define MDO_AFTER_3MGTCLKS_EN_RD(src)                (((src) & 0x08000000)>>27)
#define MDO_AFTER_3MGTCLKS_EN_WR(src)           (((u32)(src)<<27) & 0x08000000)
#define MDO_AFTER_3MGTCLKS_EN_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields scan_auto_incr	 */
#define SCAN_AUTO_INCR_WIDTH                                                  1
#define SCAN_AUTO_INCR_SHIFT                                                  5
#define SCAN_AUTO_INCR_MASK                                          0x00000020
#define SCAN_AUTO_INCR_RD(src)                        (((src) & 0x00000020)>>5)
#define SCAN_AUTO_INCR_WR(src)                   (((u32)(src)<<5) & 0x00000020)
#define SCAN_AUTO_INCR_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields PREAMBLE_SUPPRESSION	 */
#define PREAMBLE_SUPPRESSION_WIDTH                                            1
#define PREAMBLE_SUPPRESSION_SHIFT                                            4
#define PREAMBLE_SUPPRESSION_MASK                                    0x00000010
#define PREAMBLE_SUPPRESSION_RD(src)                  (((src) & 0x00000010)>>4)
#define PREAMBLE_SUPPRESSION_WR(src)             (((u32)(src)<<4) & 0x00000010)
#define PREAMBLE_SUPPRESSION_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields mgmt_clock_sel	 */
#define MGMT_CLOCK_SEL_WIDTH                                                  3
#define MGMT_CLOCK_SEL_SHIFT                                                  0
#define MGMT_CLOCK_SEL_MASK                                          0x00000007
#define MGMT_CLOCK_SEL_RD(src)                           (((src) & 0x00000007))
#define MGMT_CLOCK_SEL_WR(src)                      (((u32)(src)) & 0x00000007)
#define MGMT_CLOCK_SEL_SET(dst,src) \
                          (((dst) & ~0x00000007) | (((u32)(src)) & 0x00000007))

/*	Register mii_mgmt_command	*/ 
/*	 Fields scan_cycle	 */
#define SCAN_CYCLE_WIDTH                                                      1
#define SCAN_CYCLE_SHIFT                                                      1
#define SCAN_CYCLE_MASK                                              0x00000002
#define SCAN_CYCLE_RD(src)                            (((src) & 0x00000002)>>1)
#define SCAN_CYCLE_WR(src)                       (((u32)(src)<<1) & 0x00000002)
#define SCAN_CYCLE_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields read_cycle	 */
#define READ_CYCLE_WIDTH                                                      1
#define READ_CYCLE_SHIFT                                                      0
#define READ_CYCLE_MASK                                              0x00000001
#define READ_CYCLE_RD(src)                               (((src) & 0x00000001))
#define READ_CYCLE_WR(src)                          (((u32)(src)) & 0x00000001)
#define READ_CYCLE_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register mii_mgmt_address	*/ 
/*	 Fields phy_addr	 */
#define PHY_ADDR_WIDTH                                                        5
#define PHY_ADDR_SHIFT                                                        8
#define PHY_ADDR_MASK                                                0x00001f00
#define PHY_ADDR_RD(src)                              (((src) & 0x00001f00)>>8)
#define PHY_ADDR_WR(src)                         (((u32)(src)<<8) & 0x00001f00)
#define PHY_ADDR_SET(dst,src) \
                       (((dst) & ~0x00001f00) | (((u32)(src)<<8) & 0x00001f00))
/*	 Fields reg_addr	 */
#define REG_ADDR_WIDTH                                                        5
#define REG_ADDR_SHIFT                                                        0
#define REG_ADDR_MASK                                                0x0000001f
#define REG_ADDR_RD(src)                                 (((src) & 0x0000001f))
#define REG_ADDR_WR(src)                            (((u32)(src)) & 0x0000001f)
#define REG_ADDR_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Register mii_mgmt_control	*/ 
/*	 Fields phy_control	 */
#define PHY_CONTROL_WIDTH                                                    16
#define PHY_CONTROL_SHIFT                                                     0
#define PHY_CONTROL_MASK                                             0x0000ffff
#define PHY_CONTROL_RD(src)                              (((src) & 0x0000ffff))
#define PHY_CONTROL_WR(src)                         (((u32)(src)) & 0x0000ffff)
#define PHY_CONTROL_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register mii_mgmt_status	*/ 
/*	 Fields phy_status	 */
#define PHY_STATUS_WIDTH                                                     16
#define PHY_STATUS_SHIFT                                                      0
#define PHY_STATUS_MASK                                              0x0000ffff
#define PHY_STATUS_RD(src)                               (((src) & 0x0000ffff))
#define PHY_STATUS_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register mii_mgmt_indicators	*/ 
/*	 Fields not_valid	 */
#define NOT_VALID_WIDTH                                                       1
#define NOT_VALID_SHIFT                                                       2
#define NOT_VALID_MASK                                               0x00000004
#define NOT_VALID_RD(src)                             (((src) & 0x00000004)>>2)
#define NOT_VALID_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields scanning	 */
#define SCANNING_WIDTH                                                        1
#define SCANNING_SHIFT                                                        1
#define SCANNING_MASK                                                0x00000002
#define SCANNING_RD(src)                              (((src) & 0x00000002)>>1)
#define SCANNING_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields busy	 */
#define BUSY_WIDTH                                                            1
#define BUSY_SHIFT                                                            0
#define BUSY_MASK                                                    0x00000001
#define BUSY_RD(src)                                     (((src) & 0x00000001))
#define BUSY_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register interface_control	*/ 
/*	 Fields reset_int	 */
#define RESET_INT_WIDTH                                                       1
#define RESET_INT_SHIFT                                                      31
#define RESET_INT_MASK                                               0x80000000
#define RESET_INT_RD(src)                            (((src) & 0x80000000)>>31)
#define RESET_INT_WR(src)                       (((u32)(src)<<31) & 0x80000000)
#define RESET_INT_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields tbi_mode	 */
#define ENET_TBI_MODE_WIDTH                                                1
#define ENET_TBI_MODE_SHIFT                                               27
#define ENET_TBI_MODE_MASK                                        0x08000000
#define ENET_TBI_MODE_RD(src)                     (((src) & 0x08000000)>>27)
#define ENET_TBI_MODE_WR(src)                (((u32)(src)<<27) & 0x08000000)
#define ENET_TBI_MODE_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields ghd_mode	 */
#define ENET_GHD_MODE_WIDTH                                                1
#define ENET_GHD_MODE_SHIFT                                               26
#define ENET_GHD_MODE_MASK                                        0x04000000
#define ENET_GHD_MODE_RD(src)                     (((src) & 0x04000000)>>26)
#define ENET_GHD_MODE_WR(src)                (((u32)(src)<<26) & 0x04000000)
#define ENET_GHD_MODE_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields lhd_mode	 */
#define ENET_LHD_MODE_WIDTH                                                1
#define ENET_LHD_MODE_SHIFT                                               25
#define ENET_LHD_MODE_MASK                                        0x02000000
#define ENET_LHD_MODE_RD(src)                     (((src) & 0x02000000)>>25)
#define ENET_LHD_MODE_WR(src)                (((u32)(src)<<25) & 0x02000000)
#define ENET_LHD_MODE_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields phy_mode	 */
#define ENET_PHY_MODE_WIDTH                                                1
#define ENET_PHY_MODE_SHIFT                                               24
#define ENET_PHY_MODE_MASK                                        0x01000000
#define ENET_PHY_MODE_RD(src)                     (((src) & 0x01000000)>>24)
#define ENET_PHY_MODE_WR(src)                (((u32)(src)<<24) & 0x01000000)
#define ENET_PHY_MODE_SET(dst,src) \
                      (((dst) & ~0x01000000) | (((u32)(src)<<24) & 0x01000000))
/*	 Fields reset_permii	 */
#define RESET_PERMII_WIDTH                                                    1
#define RESET_PERMII_SHIFT                                                   23
#define RESET_PERMII_MASK                                            0x00800000
#define RESET_PERMII_RD(src)                         (((src) & 0x00800000)>>23)
#define RESET_PERMII_WR(src)                    (((u32)(src)<<23) & 0x00800000)
#define RESET_PERMII_SET(dst,src) \
                      (((dst) & ~0x00800000) | (((u32)(src)<<23) & 0x00800000))
/*	 Fields speed	 */
#define SPEED_WIDTH                                                           1
#define SPEED_SHIFT                                                          16
#define SPEED_MASK                                                   0x00010000
#define SPEED_RD(src)                                (((src) & 0x00010000)>>16)
#define SPEED_WR(src)                           (((u32)(src)<<16) & 0x00010000)
#define SPEED_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields reset_pe100x	 */
#define RESET_PE100X_WIDTH                                                    1
#define RESET_PE100X_SHIFT                                                   15
#define RESET_PE100X_MASK                                            0x00008000
#define RESET_PE100X_RD(src)                         (((src) & 0x00008000)>>15)
#define RESET_PE100X_WR(src)                    (((u32)(src)<<15) & 0x00008000)
#define RESET_PE100X_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields force_quiet	 */
#define FORCE_QUIET_WIDTH                                                     1
#define FORCE_QUIET_SHIFT                                                    10
#define FORCE_QUIET_MASK                                             0x00000400
#define FORCE_QUIET_RD(src)                          (((src) & 0x00000400)>>10)
#define FORCE_QUIET_WR(src)                     (((u32)(src)<<10) & 0x00000400)
#define FORCE_QUIET_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields no_cipher	 */
#define NO_CIPHER_WIDTH                                                       1
#define NO_CIPHER_SHIFT                                                       9
#define NO_CIPHER_MASK                                               0x00000200
#define NO_CIPHER_RD(src)                             (((src) & 0x00000200)>>9)
#define NO_CIPHER_WR(src)                        (((u32)(src)<<9) & 0x00000200)
#define NO_CIPHER_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields disable_link_fail	 */
#define DISABLE_LINK_FAIL_WIDTH                                               1
#define DISABLE_LINK_FAIL_SHIFT                                               8
#define DISABLE_LINK_FAIL_MASK                                       0x00000100
#define DISABLE_LINK_FAIL_RD(src)                     (((src) & 0x00000100)>>8)
#define DISABLE_LINK_FAIL_WR(src)                (((u32)(src)<<8) & 0x00000100)
#define DISABLE_LINK_FAIL_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields reset_gpsi	 */
#define RESET_GPSI_WIDTH                                                      1
#define RESET_GPSI_SHIFT                                                      7
#define RESET_GPSI_MASK                                              0x00000080
#define RESET_GPSI_RD(src)                            (((src) & 0x00000080)>>7)
#define RESET_GPSI_WR(src)                       (((u32)(src)<<7) & 0x00000080)
#define RESET_GPSI_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields en_jabber	 */
#define EN_JABBER_WIDTH                                                       1
#define EN_JABBER_SHIFT                                                       0
#define EN_JABBER_MASK                                               0x00000001
#define EN_JABBER_RD(src)                                (((src) & 0x00000001))
#define EN_JABBER_WR(src)                           (((u32)(src)) & 0x00000001)
#define EN_JABBER_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register interface_status	*/ 
/*	 Fields excess_defer	 */
#define EXCESS_DEFER_WIDTH                                                    1
#define EXCESS_DEFER_SHIFT                                                    9
#define EXCESS_DEFER_MASK                                            0x00000200
#define EXCESS_DEFER_RD(src)                          (((src) & 0x00000200)>>9)
#define EXCESS_DEFER_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields clash	 */
#define CLASH_WIDTH                                                           1
#define CLASH_SHIFT                                                           8
#define CLASH_MASK                                                   0x00000100
#define CLASH_RD(src)                                 (((src) & 0x00000100)>>8)
#define CLASH_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields mii_jabber	 */
#define MII_JABBER_WIDTH                                                      1
#define MII_JABBER_SHIFT                                                      7
#define MII_JABBER_MASK                                              0x00000080
#define MII_JABBER_RD(src)                            (((src) & 0x00000080)>>7)
#define MII_JABBER_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields link_ok	 */
#define LINK_OK_WIDTH                                                         1
#define LINK_OK_SHIFT                                                         6
#define LINK_OK_MASK                                                 0x00000040
#define LINK_OK_RD(src)                               (((src) & 0x00000040)>>6)
#define LINK_OK_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields full_duplex	 */
#define FULL_DUPLEX_WIDTH                                                     1
#define FULL_DUPLEX_SHIFT                                                     5
#define FULL_DUPLEX_MASK                                             0x00000020
#define FULL_DUPLEX_RD(src)                           (((src) & 0x00000020)>>5)
#define FULL_DUPLEX_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields speed	 */
#define SPEED_F1_WIDTH                                                        1
#define SPEED_F1_SHIFT                                                        4
#define SPEED_F1_MASK                                                0x00000010
#define SPEED_F1_RD(src)                              (((src) & 0x00000010)>>4)
#define SPEED_F1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields link_fail	 */
#define LINK_FAIL_WIDTH                                                       1
#define LINK_FAIL_SHIFT                                                       3
#define LINK_FAIL_MASK                                               0x00000008
#define LINK_FAIL_RD(src)                             (((src) & 0x00000008)>>3)
#define LINK_FAIL_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields loss_of_carrier	 */
#define LOSS_OF_CARRIER_WIDTH                                                 1
#define LOSS_OF_CARRIER_SHIFT                                                 2
#define LOSS_OF_CARRIER_MASK                                         0x00000004
#define LOSS_OF_CARRIER_RD(src)                       (((src) & 0x00000004)>>2)
#define LOSS_OF_CARRIER_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields sqe_error	 */
#define SQE_ERROR_WIDTH                                                       1
#define SQE_ERROR_SHIFT                                                       1
#define SQE_ERROR_MASK                                               0x00000002
#define SQE_ERROR_RD(src)                             (((src) & 0x00000002)>>1)
#define SQE_ERROR_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields jabber	 */
#define JABBER_WIDTH                                                          1
#define JABBER_SHIFT                                                          0
#define JABBER_MASK                                                  0x00000001
#define JABBER_RD(src)                                   (((src) & 0x00000001))
#define JABBER_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register station_addr0	*/ 
/*	 Fields station_oct0	 */
#define STATION_OCT00_WIDTH                                                   8
#define STATION_OCT00_SHIFT                                                  24
#define STATION_OCT00_MASK                                           0xff000000
#define STATION_OCT00_RD(src)                        (((src) & 0xff000000)>>24)
#define STATION_OCT00_WR(src)                   (((u32)(src)<<24) & 0xff000000)
#define STATION_OCT00_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields station_oct1	 */
#define STATION_OCT10_WIDTH                                                   8
#define STATION_OCT10_SHIFT                                                  16
#define STATION_OCT10_MASK                                           0x00ff0000
#define STATION_OCT10_RD(src)                        (((src) & 0x00ff0000)>>16)
#define STATION_OCT10_WR(src)                   (((u32)(src)<<16) & 0x00ff0000)
#define STATION_OCT10_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields station_oct2	 */
#define STATION_OCT20_WIDTH                                                   8
#define STATION_OCT20_SHIFT                                                   8
#define STATION_OCT20_MASK                                           0x0000ff00
#define STATION_OCT20_RD(src)                         (((src) & 0x0000ff00)>>8)
#define STATION_OCT20_WR(src)                    (((u32)(src)<<8) & 0x0000ff00)
#define STATION_OCT20_SET(dst,src) \
                       (((dst) & ~0x0000ff00) | (((u32)(src)<<8) & 0x0000ff00))
/*	 Fields station_oct3	 */
#define STATION_OCT30_WIDTH                                                   8
#define STATION_OCT30_SHIFT                                                   0
#define STATION_OCT30_MASK                                           0x000000ff
#define STATION_OCT30_RD(src)                            (((src) & 0x000000ff))
#define STATION_OCT30_WR(src)                       (((u32)(src)) & 0x000000ff)
#define STATION_OCT30_SET(dst,src) \
                          (((dst) & ~0x000000ff) | (((u32)(src)) & 0x000000ff))

/*	Register station_addr1	*/ 
/*	 Fields station_oct	 */
#define STATION_OCT1_WIDTH                                                    8
#define STATION_OCT1_SHIFT                                                   24
#define STATION_OCT1_MASK                                            0xff000000
#define STATION_OCT1_RD(src)                         (((src) & 0xff000000)>>24)
#define STATION_OCT1_WR(src)                    (((u32)(src)<<24) & 0xff000000)
#define STATION_OCT1_SET(dst,src) \
                      (((dst) & ~0xff000000) | (((u32)(src)<<24) & 0xff000000))
/*	 Fields station_oct1	 */
#define STATION_OCT11_WIDTH                                                   8
#define STATION_OCT11_SHIFT                                                  16
#define STATION_OCT11_MASK                                           0x00ff0000
#define STATION_OCT11_RD(src)                        (((src) & 0x00ff0000)>>16)
#define STATION_OCT11_WR(src)                   (((u32)(src)<<16) & 0x00ff0000)
#define STATION_OCT11_SET(dst,src) \
                      (((dst) & ~0x00ff0000) | (((u32)(src)<<16) & 0x00ff0000))
/*	 Fields linkdnintmask	 */
#define LINKDNINTMASK1_WIDTH                                                  1
#define LINKDNINTMASK1_SHIFT                                                  8
#define LINKDNINTMASK1_MASK                                          0x00000100
#define LINKDNINTMASK1_RD(src)                        (((src) & 0x00000100)>>8)
#define LINKDNINTMASK1_WR(src)                   (((u32)(src)<<8) & 0x00000100)
#define LINKDNINTMASK1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields phyid	 */
#define PHYID1_WIDTH                                                          5
#define PHYID1_SHIFT                                                          0
#define PHYID1_MASK                                                  0x0000001f
#define PHYID1_RD(src)                                   (((src) & 0x0000001f))
#define PHYID1_WR(src)                              (((u32)(src)) & 0x0000001f)
#define PHYID1_SET(dst,src) \
                          (((dst) & ~0x0000001f) | (((u32)(src)) & 0x0000001f))

/*	Global Base Address	*/
#define PEMSTAT_BASE_ADDR			0x000000000ULL

/*    Address PEMSTAT  Registers */
#define TR64_ADDR                                                    0x00000020
#define TR64_DEFAULT                                                 0x00000000
#define TR127_ADDR                                                   0x00000021
#define TR127_DEFAULT                                                0x00000000
#define TR255_ADDR                                                   0x00000022
#define TR255_DEFAULT                                                0x00000000
#define TR511_ADDR                                                   0x00000023
#define TR511_DEFAULT                                                0x00000000
#define TR1K_ADDR                                                    0x00000024
#define TR1K_DEFAULT                                                 0x00000000
#define TRMAX_ADDR                                                   0x00000025
#define TRMAX_DEFAULT                                                0x00000000
#define TRMGV_ADDR                                                   0x00000026
#define TRMGV_DEFAULT                                                0x00000000
#define RBYT_ADDR                                                    0x00000027
#define RBYT_DEFAULT                                                 0x00000000
#define RPKT_ADDR                                                    0x00000028
#define RPKT_DEFAULT                                                 0x00000000
#define RFCS_ADDR                                                    0x00000029
#define RFCS_DEFAULT                                                 0x00000000
#define RMCA_ADDR                                                    0x0000002a
#define RMCA_DEFAULT                                                 0x00000000
#define RBCA_ADDR                                                    0x0000002b
#define RBCA_DEFAULT                                                 0x00000000
#define RXCF_ADDR                                                    0x0000002c
#define RXCF_DEFAULT                                                 0x00000000
#define RXPF_ADDR                                                    0x0000002d
#define RXPF_DEFAULT                                                 0x00000000
#define RXUO_ADDR                                                    0x0000002e
#define RXUO_DEFAULT                                                 0x00000000
#define RALN_ADDR                                                    0x0000002f
#define RALN_DEFAULT                                                 0x00000000
#define RFLR_ADDR                                                    0x00000030
#define RFLR_DEFAULT                                                 0x00000000
#define RCDE_ADDR                                                    0x00000031
#define RCDE_DEFAULT                                                 0x00000000
#define RCSE_ADDR                                                    0x00000032
#define RCSE_DEFAULT                                                 0x00000000
#define RUND_ADDR                                                    0x00000033
#define RUND_DEFAULT                                                 0x00000000
#define ROVR_ADDR                                                    0x00000034
#define ROVR_DEFAULT                                                 0x00000000
#define RFRG_ADDR                                                    0x00000035
#define RFRG_DEFAULT                                                 0x00000000
#define RJBR_ADDR                                                    0x00000036
#define RJBR_DEFAULT                                                 0x00000000
#define RDRP_ADDR                                                    0x00000037
#define RDRP_DEFAULT                                                 0x00000000
#define TBYT_ADDR                                                    0x00000038
#define TBYT_DEFAULT                                                 0x00000000
#define TPKT_ADDR                                                    0x00000039
#define TPKT_DEFAULT                                                 0x00000000
#define TMCA_ADDR                                                    0x0000003a
#define TMCA_DEFAULT                                                 0x00000000
#define TBCA_ADDR                                                    0x0000003b
#define TBCA_DEFAULT                                                 0x00000000
#define TXPF_ADDR                                                    0x0000003c
#define TXPF_DEFAULT                                                 0x00000000
#define TDFR_ADDR                                                    0x0000003d
#define TDFR_DEFAULT                                                 0x00000000
#define TEDF_ADDR                                                    0x0000003e
#define TEDF_DEFAULT                                                 0x00000000
#define TSCL_ADDR                                                    0x0000003f
#define TSCL_DEFAULT                                                 0x00000000
#define TMCL_ADDR                                                    0x00000040
#define TMCL_DEFAULT                                                 0x00000000
#define TLCL_ADDR                                                    0x00000041
#define TLCL_DEFAULT                                                 0x00000000
#define TXCL_ADDR                                                    0x00000042
#define TXCL_DEFAULT                                                 0x00000000
#define TNCL_ADDR                                                    0x00000043
#define TNCL_DEFAULT                                                 0x00000000
#define TPFH_ADDR                                                    0x00000044
#define TPFH_DEFAULT                                                 0x00000000
#define TDRP_ADDR                                                    0x00000045
#define TDRP_DEFAULT                                                 0x00000000
#define TJBR_ADDR                                                    0x00000046
#define TJBR_DEFAULT                                                 0x00000000
#define TFCS_ADDR                                                    0x00000047
#define TFCS_DEFAULT                                                 0x00000000
#define TXCF_ADDR                                                    0x00000048
#define TXCF_DEFAULT                                                 0x00000000
#define TOVR_ADDR                                                    0x00000049
#define TOVR_DEFAULT                                                 0x00000000
#define TUND_ADDR                                                    0x0000004a
#define TUND_DEFAULT                                                 0x00000000
#define TFRG_ADDR                                                    0x0000004b
#define TFRG_DEFAULT                                                 0x00000000
#define CAR1_ADDR                                                    0x0000004c
#define CAR1_DEFAULT                                                 0x00000000
#define CAR2_ADDR                                                    0x0000004d
#define CAR2_DEFAULT                                                 0x00000000
#define CAM1_ADDR                                                    0x0000004e
#define CAM1_DEFAULT                                                 0xfe01ffff
#define CAM2_ADDR                                                    0x0000004f
#define CAM2_DEFAULT                                                 0x000fffff

/*	Register TR64	*/ 
/*	 Fields tx_rx_64b_frame_cntr	 */
#define TX_RX_64B_FRAME_CNTR4_WIDTH                                          31
#define TX_RX_64B_FRAME_CNTR4_SHIFT                                           0
#define TX_RX_64B_FRAME_CNTR4_MASK                                   0x7fffffff
#define TX_RX_64B_FRAME_CNTR4_RD(src)                    (((src) & 0x7fffffff))
#define TX_RX_64B_FRAME_CNTR4_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TR127	*/ 
/*	 Fields tx_rx_127b_frame_cntr	 */
#define TX_RX_127B_FRAME_CNTR7_WIDTH                                         31
#define TX_RX_127B_FRAME_CNTR7_SHIFT                                          0
#define TX_RX_127B_FRAME_CNTR7_MASK                                  0x7fffffff
#define TX_RX_127B_FRAME_CNTR7_RD(src)                   (((src) & 0x7fffffff))
#define TX_RX_127B_FRAME_CNTR7_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TR255	*/ 
/*	 Fields tx_rx_255b_frame_cntr	 */
#define TX_RX_255B_FRAME_CNTR5_WIDTH                                         31
#define TX_RX_255B_FRAME_CNTR5_SHIFT                                          0
#define TX_RX_255B_FRAME_CNTR5_MASK                                  0x7fffffff
#define TX_RX_255B_FRAME_CNTR5_RD(src)                   (((src) & 0x7fffffff))
#define TX_RX_255B_FRAME_CNTR5_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TR511	*/ 
/*	 Fields tx_rx_511b_frame_cntr	 */
#define TX_RX_511B_FRAME_CNTR1_WIDTH                                         31
#define TX_RX_511B_FRAME_CNTR1_SHIFT                                          0
#define TX_RX_511B_FRAME_CNTR1_MASK                                  0x7fffffff
#define TX_RX_511B_FRAME_CNTR1_RD(src)                   (((src) & 0x7fffffff))
#define TX_RX_511B_FRAME_CNTR1_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TR1K	*/ 
/*	 Fields tx_rx_1Kb_frame_cntr	 */
#define TX_RX_1KB_FRAME_CNTR_WIDTH                                           31
#define TX_RX_1KB_FRAME_CNTR_SHIFT                                            0
#define TX_RX_1KB_FRAME_CNTR_MASK                                    0x7fffffff
#define TX_RX_1KB_FRAME_CNTR_RD(src)                     (((src) & 0x7fffffff))
#define TX_RX_1KB_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TRMAX	*/ 
/*	 Fields tx_rx_maxb_frame_cntr	 */
#define TX_RX_MAXB_FRAME_CNTR_WIDTH                                          31
#define TX_RX_MAXB_FRAME_CNTR_SHIFT                                           0
#define TX_RX_MAXB_FRAME_CNTR_MASK                                   0x7fffffff
#define TX_RX_MAXB_FRAME_CNTR_RD(src)                    (((src) & 0x7fffffff))
#define TX_RX_MAXB_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TRMGV	*/ 
/*	 Fields trmgv	 */
#define TRMGV_WIDTH                                                          31
#define TRMGV_SHIFT                                                           0
#define TRMGV_MASK                                                   0x7fffffff
#define TRMGV_RD(src)                                    (((src) & 0x7fffffff))
#define TRMGV_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RBYT	*/ 
/*	 Fields rx_byte_cntr	 */
#define RX_BYTE_CNTR_WIDTH                                                   31
#define RX_BYTE_CNTR_SHIFT                                                    0
#define RX_BYTE_CNTR_MASK                                            0x7fffffff
#define RX_BYTE_CNTR_RD(src)                             (((src) & 0x7fffffff))
#define RX_BYTE_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RPKT	*/ 
/*	 Fields rx_pkt_cntr	 */
#define RX_PKT_CNTR_WIDTH                                                    31
#define RX_PKT_CNTR_SHIFT                                                     0
#define RX_PKT_CNTR_MASK                                             0x7fffffff
#define RX_PKT_CNTR_RD(src)                              (((src) & 0x7fffffff))
#define RX_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RFCS	*/ 
/*	 Fields rx_fcs_error_cntr	 */
#define RX_FCS_ERROR_CNTR_WIDTH                                              16
#define RX_FCS_ERROR_CNTR_SHIFT                                               0
#define RX_FCS_ERROR_CNTR_MASK                                       0x0000ffff
#define RX_FCS_ERROR_CNTR_RD(src)                        (((src) & 0x0000ffff))
#define RX_FCS_ERROR_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RMCA	*/ 
/*	 Fields rx_mc_pkt_cntr	 */
#define RX_MC_PKT_CNTR_WIDTH                                                 31
#define RX_MC_PKT_CNTR_SHIFT                                                  0
#define RX_MC_PKT_CNTR_MASK                                          0x7fffffff
#define RX_MC_PKT_CNTR_RD(src)                           (((src) & 0x7fffffff))
#define RX_MC_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RBCA	*/ 
/*	 Fields rx_bc_pkt_cntr	 */
#define RX_BC_PKT_CNTR_WIDTH                                                 31
#define RX_BC_PKT_CNTR_SHIFT                                                  0
#define RX_BC_PKT_CNTR_MASK                                          0x7fffffff
#define RX_BC_PKT_CNTR_RD(src)                           (((src) & 0x7fffffff))
#define RX_BC_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register RXCF	*/ 
/*	 Fields rx_ctrl_pkt_cntr	 */
#define RX_CTRL_PKT_CNTR_WIDTH                                               16
#define RX_CTRL_PKT_CNTR_SHIFT                                                0
#define RX_CTRL_PKT_CNTR_MASK                                        0x0000ffff
#define RX_CTRL_PKT_CNTR_RD(src)                         (((src) & 0x0000ffff))
#define RX_CTRL_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RXPF	*/ 
/*	 Fields rx_pause_pkt_cntr	 */
#define RX_PAUSE_PKT_CNTR_WIDTH                                              16
#define RX_PAUSE_PKT_CNTR_SHIFT                                               0
#define RX_PAUSE_PKT_CNTR_MASK                                       0x0000ffff
#define RX_PAUSE_PKT_CNTR_RD(src)                        (((src) & 0x0000ffff))
#define RX_PAUSE_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RXUO	*/ 
/*	 Fields rx_unk_opcode_cntr	 */
#define RX_UNK_OPCODE_CNTR_WIDTH                                             16
#define RX_UNK_OPCODE_CNTR_SHIFT                                              0
#define RX_UNK_OPCODE_CNTR_MASK                                      0x0000ffff
#define RX_UNK_OPCODE_CNTR_RD(src)                       (((src) & 0x0000ffff))
#define RX_UNK_OPCODE_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RALN	*/ 
/*	 Fields rx_align_err_cntr	 */
#define RX_ALIGN_ERR_CNTR_WIDTH                                              16
#define RX_ALIGN_ERR_CNTR_SHIFT                                               0
#define RX_ALIGN_ERR_CNTR_MASK                                       0x0000ffff
#define RX_ALIGN_ERR_CNTR_RD(src)                        (((src) & 0x0000ffff))
#define RX_ALIGN_ERR_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RFLR	*/ 
/*	 Fields rx_len_err_cntr	 */
#define RX_LEN_ERR_CNTR_WIDTH                                                16
#define RX_LEN_ERR_CNTR_SHIFT                                                 0
#define RX_LEN_ERR_CNTR_MASK                                         0x0000ffff
#define RX_LEN_ERR_CNTR_RD(src)                          (((src) & 0x0000ffff))
#define RX_LEN_ERR_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RCDE	*/ 
/*	 Fields rx_code_err_cntr	 */
#define RX_CODE_ERR_CNTR_WIDTH                                               16
#define RX_CODE_ERR_CNTR_SHIFT                                                0
#define RX_CODE_ERR_CNTR_MASK                                        0x0000ffff
#define RX_CODE_ERR_CNTR_RD(src)                         (((src) & 0x0000ffff))
#define RX_CODE_ERR_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RCSE	*/ 
/*	 Fields rx_false_carrier_cntr	 */
#define RX_FALSE_CARRIER_CNTR_WIDTH                                          16
#define RX_FALSE_CARRIER_CNTR_SHIFT                                           0
#define RX_FALSE_CARRIER_CNTR_MASK                                   0x0000ffff
#define RX_FALSE_CARRIER_CNTR_RD(src)                    (((src) & 0x0000ffff))
#define RX_FALSE_CARRIER_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RUND	*/ 
/*	 Fields rx_undrsize_pkt_cntr	 */
#define RX_UNDRSIZE_PKT_CNTR_WIDTH                                           16
#define RX_UNDRSIZE_PKT_CNTR_SHIFT                                            0
#define RX_UNDRSIZE_PKT_CNTR_MASK                                    0x0000ffff
#define RX_UNDRSIZE_PKT_CNTR_RD(src)                     (((src) & 0x0000ffff))
#define RX_UNDRSIZE_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register ROVR	*/ 
/*	 Fields rx_ovrsize_pkt_cntr	 */
#define RX_OVRSIZE_PKT_CNTR_WIDTH                                            16
#define RX_OVRSIZE_PKT_CNTR_SHIFT                                             0
#define RX_OVRSIZE_PKT_CNTR_MASK                                     0x0000ffff
#define RX_OVRSIZE_PKT_CNTR_RD(src)                      (((src) & 0x0000ffff))
#define RX_OVRSIZE_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RFRG	*/ 
/*	 Fields rx_frag_cntr	 */
#define RX_FRAG_CNTR_WIDTH                                                   16
#define RX_FRAG_CNTR_SHIFT                                                    0
#define RX_FRAG_CNTR_MASK                                            0x0000ffff
#define RX_FRAG_CNTR_RD(src)                             (((src) & 0x0000ffff))
#define RX_FRAG_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RJBR	*/ 
/*	 Fields rx_jabber_cntr	 */
#define RX_JABBER_CNTR_WIDTH                                                 16
#define RX_JABBER_CNTR_SHIFT                                                  0
#define RX_JABBER_CNTR_MASK                                          0x0000ffff
#define RX_JABBER_CNTR_RD(src)                           (((src) & 0x0000ffff))
#define RX_JABBER_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register RDRP	*/ 
/*	 Fields rx_dropped_pkt_cntr	 */
#define RX_DROPPED_PKT_CNTR_WIDTH                                            16
#define RX_DROPPED_PKT_CNTR_SHIFT                                             0
#define RX_DROPPED_PKT_CNTR_MASK                                     0x0000ffff
#define RX_DROPPED_PKT_CNTR_RD(src)                      (((src) & 0x0000ffff))
#define RX_DROPPED_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TBYT	*/ 
/*	 Fields tx_byte_cntr	 */
#define TX_BYTE_CNTR_WIDTH                                                   31
#define TX_BYTE_CNTR_SHIFT                                                    0
#define TX_BYTE_CNTR_MASK                                            0x7fffffff
#define TX_BYTE_CNTR_RD(src)                             (((src) & 0x7fffffff))
#define TX_BYTE_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TPKT	*/ 
/*	 Fields tx_pkt_cntr	 */
#define TX_PKT_CNTR_WIDTH                                                    31
#define TX_PKT_CNTR_SHIFT                                                     0
#define TX_PKT_CNTR_MASK                                             0x7fffffff
#define TX_PKT_CNTR_RD(src)                              (((src) & 0x7fffffff))
#define TX_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TMCA	*/ 
/*	 Fields tx_mc_pkt_cntr	 */
#define TX_MC_PKT_CNTR_WIDTH                                                 31
#define TX_MC_PKT_CNTR_SHIFT                                                  0
#define TX_MC_PKT_CNTR_MASK                                          0x7fffffff
#define TX_MC_PKT_CNTR_RD(src)                           (((src) & 0x7fffffff))
#define TX_MC_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TBCA	*/ 
/*	 Fields tx_bc_pkt_cntr	 */
#define TX_BC_PKT_CNTR_WIDTH                                                 31
#define TX_BC_PKT_CNTR_SHIFT                                                  0
#define TX_BC_PKT_CNTR_MASK                                          0x7fffffff
#define TX_BC_PKT_CNTR_RD(src)                           (((src) & 0x7fffffff))
#define TX_BC_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TXPF	*/ 
/*	 Fields tx_pause_pkt_cntr	 */
#define TX_PAUSE_PKT_CNTR_WIDTH                                              16
#define TX_PAUSE_PKT_CNTR_SHIFT                                               0
#define TX_PAUSE_PKT_CNTR_MASK                                       0x0000ffff
#define TX_PAUSE_PKT_CNTR_RD(src)                        (((src) & 0x0000ffff))
#define TX_PAUSE_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TDFR	*/ 
/*	 Fields tx_defer_pkt_cntr	 */
#define TX_DEFER_PKT_CNTR_WIDTH                                              31
#define TX_DEFER_PKT_CNTR_SHIFT                                               0
#define TX_DEFER_PKT_CNTR_MASK                                       0x7fffffff
#define TX_DEFER_PKT_CNTR_RD(src)                        (((src) & 0x7fffffff))
#define TX_DEFER_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TEDF	*/ 
/*	 Fields tx_exc_defer_pkt_cntr	 */
#define TX_EXC_DEFER_PKT_CNTR_WIDTH                                          31
#define TX_EXC_DEFER_PKT_CNTR_SHIFT                                           0
#define TX_EXC_DEFER_PKT_CNTR_MASK                                   0x7fffffff
#define TX_EXC_DEFER_PKT_CNTR_RD(src)                    (((src) & 0x7fffffff))
#define TX_EXC_DEFER_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TSCL	*/ 
/*	 Fields tx_col_pkt_cntr	 */
#define TX_COL_PKT_CNTR_WIDTH                                                31
#define TX_COL_PKT_CNTR_SHIFT                                                 0
#define TX_COL_PKT_CNTR_MASK                                         0x7fffffff
#define TX_COL_PKT_CNTR_RD(src)                          (((src) & 0x7fffffff))
#define TX_COL_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TMCL	*/ 
/*	 Fields tx_mul_col_pkt_cntr	 */
#define TX_MUL_COL_PKT_CNTR_WIDTH                                            31
#define TX_MUL_COL_PKT_CNTR_SHIFT                                             0
#define TX_MUL_COL_PKT_CNTR_MASK                                     0x7fffffff
#define TX_MUL_COL_PKT_CNTR_RD(src)                      (((src) & 0x7fffffff))
#define TX_MUL_COL_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TLCL	*/ 
/*	 Fields tx_late_col_pkt_cntr	 */
#define TX_LATE_COL_PKT_CNTR_WIDTH                                           31
#define TX_LATE_COL_PKT_CNTR_SHIFT                                            0
#define TX_LATE_COL_PKT_CNTR_MASK                                    0x7fffffff
#define TX_LATE_COL_PKT_CNTR_RD(src)                     (((src) & 0x7fffffff))
#define TX_LATE_COL_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TXCL	*/ 
/*	 Fields tx_exc_col_pkt_cntr	 */
#define TX_EXC_COL_PKT_CNTR_WIDTH                                            31
#define TX_EXC_COL_PKT_CNTR_SHIFT                                             0
#define TX_EXC_COL_PKT_CNTR_MASK                                     0x7fffffff
#define TX_EXC_COL_PKT_CNTR_RD(src)                      (((src) & 0x7fffffff))
#define TX_EXC_COL_PKT_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TNCL	*/ 
/*	 Fields tx_total_col_cntr	 */
#define TX_TOTAL_COL_CNTR_WIDTH                                              31
#define TX_TOTAL_COL_CNTR_SHIFT                                               0
#define TX_TOTAL_COL_CNTR_MASK                                       0x7fffffff
#define TX_TOTAL_COL_CNTR_RD(src)                        (((src) & 0x7fffffff))
#define TX_TOTAL_COL_CNTR_SET(dst,src) \
                          (((dst) & ~0x7fffffff) | (((u32)(src)) & 0x7fffffff))

/*	Register TPFH	*/ 
/*	 Fields tx_pause_frame_cntr	 */
#define TX_PAUSE_FRAME_CNTR_WIDTH                                            16
#define TX_PAUSE_FRAME_CNTR_SHIFT                                             0
#define TX_PAUSE_FRAME_CNTR_MASK                                     0x0000ffff
#define TX_PAUSE_FRAME_CNTR_RD(src)                      (((src) & 0x0000ffff))
#define TX_PAUSE_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TDRP	*/ 
/*	 Fields tx_drop_frame_cntr	 */
#define TX_DROP_FRAME_CNTR_WIDTH                                             16
#define TX_DROP_FRAME_CNTR_SHIFT                                              0
#define TX_DROP_FRAME_CNTR_MASK                                      0x0000ffff
#define TX_DROP_FRAME_CNTR_RD(src)                       (((src) & 0x0000ffff))
#define TX_DROP_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x0000ffff) | (((u32)(src)) & 0x0000ffff))

/*	Register TJBR	*/ 
/*	 Fields tx_jabber_frame_cntr	 */
#define TX_JABBER_FRAME_CNTR_WIDTH                                           12
#define TX_JABBER_FRAME_CNTR_SHIFT                                            0
#define TX_JABBER_FRAME_CNTR_MASK                                    0x00000fff
#define TX_JABBER_FRAME_CNTR_RD(src)                     (((src) & 0x00000fff))
#define TX_JABBER_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register TFCS	*/ 
/*	 Fields tx_fcs_error_cntr	 */
#define TX_FCS_ERROR_CNTR_WIDTH                                              12
#define TX_FCS_ERROR_CNTR_SHIFT                                               0
#define TX_FCS_ERROR_CNTR_MASK                                       0x00000fff
#define TX_FCS_ERROR_CNTR_RD(src)                        (((src) & 0x00000fff))
#define TX_FCS_ERROR_CNTR_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register TXCF	*/ 
/*	 Fields tx_ctrl_frame_cntr	 */
#define TX_CTRL_FRAME_CNTR_WIDTH                                             12
#define TX_CTRL_FRAME_CNTR_SHIFT                                              0
#define TX_CTRL_FRAME_CNTR_MASK                                      0x00000fff
#define TX_CTRL_FRAME_CNTR_RD(src)                       (((src) & 0x00000fff))
#define TX_CTRL_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register TOVR	*/ 
/*	 Fields tx_ovrsize_frame_cntr	 */
#define TX_OVRSIZE_FRAME_CNTR_WIDTH                                          12
#define TX_OVRSIZE_FRAME_CNTR_SHIFT                                           0
#define TX_OVRSIZE_FRAME_CNTR_MASK                                   0x00000fff
#define TX_OVRSIZE_FRAME_CNTR_RD(src)                    (((src) & 0x00000fff))
#define TX_OVRSIZE_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register TUND	*/ 
/*	 Fields tx_undsize_frame_cntr	 */
#define TX_UNDSIZE_FRAME_CNTR_WIDTH                                          12
#define TX_UNDSIZE_FRAME_CNTR_SHIFT                                           0
#define TX_UNDSIZE_FRAME_CNTR_MASK                                   0x00000fff
#define TX_UNDSIZE_FRAME_CNTR_RD(src)                    (((src) & 0x00000fff))
#define TX_UNDSIZE_FRAME_CNTR_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register TFRG	*/ 
/*	 Fields tx_frag_cntr	 */
#define TX_FRAG_CNTR_WIDTH                                                   12
#define TX_FRAG_CNTR_SHIFT                                                    0
#define TX_FRAG_CNTR_MASK                                            0x00000fff
#define TX_FRAG_CNTR_RD(src)                             (((src) & 0x00000fff))
#define TX_FRAG_CNTR_SET(dst,src) \
                          (((dst) & ~0x00000fff) | (((u32)(src)) & 0x00000fff))

/*	Register CAR1	*/ 
/*	 Fields C1_64	 */
#define C1_641_WIDTH                                                          1
#define C1_641_SHIFT                                                         31
#define C1_641_MASK                                                  0x80000000
#define C1_641_RD(src)                               (((src) & 0x80000000)>>31)
#define C1_641_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields C1_127	 */
#define C1_1271_WIDTH                                                         1
#define C1_1271_SHIFT                                                        30
#define C1_1271_MASK                                                 0x40000000
#define C1_1271_RD(src)                              (((src) & 0x40000000)>>30)
#define C1_1271_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields C1_255	 */
#define C1_2551_WIDTH                                                         1
#define C1_2551_SHIFT                                                        29
#define C1_2551_MASK                                                 0x20000000
#define C1_2551_RD(src)                              (((src) & 0x20000000)>>29)
#define C1_2551_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields C1_511	 */
#define C1_5111_WIDTH                                                         1
#define C1_5111_SHIFT                                                        28
#define C1_5111_MASK                                                 0x10000000
#define C1_5111_RD(src)                              (((src) & 0x10000000)>>28)
#define C1_5111_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields C1_1K	 */
#define C1_1K1_WIDTH                                                          1
#define C1_1K1_SHIFT                                                         27
#define C1_1K1_MASK                                                  0x08000000
#define C1_1K1_RD(src)                               (((src) & 0x08000000)>>27)
#define C1_1K1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields C1_MAX	 */
#define C1_MAX1_WIDTH                                                         1
#define C1_MAX1_SHIFT                                                        26
#define C1_MAX1_MASK                                                 0x04000000
#define C1_MAX1_RD(src)                              (((src) & 0x04000000)>>26)
#define C1_MAX1_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields C1_MGV	 */
#define C1_MGV1_WIDTH                                                         1
#define C1_MGV1_SHIFT                                                        25
#define C1_MGV1_MASK                                                 0x02000000
#define C1_MGV1_RD(src)                              (((src) & 0x02000000)>>25)
#define C1_MGV1_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields C1_RBY	 */
#define C1_RBY1_WIDTH                                                         1
#define C1_RBY1_SHIFT                                                        16
#define C1_RBY1_MASK                                                 0x00010000
#define C1_RBY1_RD(src)                              (((src) & 0x00010000)>>16)
#define C1_RBY1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields C1_RPK	 */
#define C1_RPK1_WIDTH                                                         1
#define C1_RPK1_SHIFT                                                        15
#define C1_RPK1_MASK                                                 0x00008000
#define C1_RPK1_RD(src)                              (((src) & 0x00008000)>>15)
#define C1_RPK1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields C1_RFC	 */
#define C1_RFC1_WIDTH                                                         1
#define C1_RFC1_SHIFT                                                        14
#define C1_RFC1_MASK                                                 0x00004000
#define C1_RFC1_RD(src)                              (((src) & 0x00004000)>>14)
#define C1_RFC1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields C1_RMC	 */
#define C1_RMC1_WIDTH                                                         1
#define C1_RMC1_SHIFT                                                        13
#define C1_RMC1_MASK                                                 0x00002000
#define C1_RMC1_RD(src)                              (((src) & 0x00002000)>>13)
#define C1_RMC1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields C1_RBC	 */
#define C1_RBC1_WIDTH                                                         1
#define C1_RBC1_SHIFT                                                        12
#define C1_RBC1_MASK                                                 0x00001000
#define C1_RBC1_RD(src)                              (((src) & 0x00001000)>>12)
#define C1_RBC1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields C1_RXC	 */
#define C1_RXC1_WIDTH                                                         1
#define C1_RXC1_SHIFT                                                        11
#define C1_RXC1_MASK                                                 0x00000800
#define C1_RXC1_RD(src)                              (((src) & 0x00000800)>>11)
#define C1_RXC1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields C1_RXP	 */
#define C1_RXP1_WIDTH                                                         1
#define C1_RXP1_SHIFT                                                        10
#define C1_RXP1_MASK                                                 0x00000400
#define C1_RXP1_RD(src)                              (((src) & 0x00000400)>>10)
#define C1_RXP1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields C1_RXU	 */
#define C1_RXU1_WIDTH                                                         1
#define C1_RXU1_SHIFT                                                         9
#define C1_RXU1_MASK                                                 0x00000200
#define C1_RXU1_RD(src)                               (((src) & 0x00000200)>>9)
#define C1_RXU1_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields C1_RAL	 */
#define C1_RAL1_WIDTH                                                         1
#define C1_RAL1_SHIFT                                                         8
#define C1_RAL1_MASK                                                 0x00000100
#define C1_RAL1_RD(src)                               (((src) & 0x00000100)>>8)
#define C1_RAL1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields C1_RFL	 */
#define C1_RFL1_WIDTH                                                         1
#define C1_RFL1_SHIFT                                                         7
#define C1_RFL1_MASK                                                 0x00000080
#define C1_RFL1_RD(src)                               (((src) & 0x00000080)>>7)
#define C1_RFL1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields C1_RCD	 */
#define C1_RCD1_WIDTH                                                         1
#define C1_RCD1_SHIFT                                                         6
#define C1_RCD1_MASK                                                 0x00000040
#define C1_RCD1_RD(src)                               (((src) & 0x00000040)>>6)
#define C1_RCD1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields C1_RCS	 */
#define C1_RCS1_WIDTH                                                         1
#define C1_RCS1_SHIFT                                                         5
#define C1_RCS1_MASK                                                 0x00000020
#define C1_RCS1_RD(src)                               (((src) & 0x00000020)>>5)
#define C1_RCS1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields C1_RUN	 */
#define C1_RUN1_WIDTH                                                         1
#define C1_RUN1_SHIFT                                                         4
#define C1_RUN1_MASK                                                 0x00000010
#define C1_RUN1_RD(src)                               (((src) & 0x00000010)>>4)
#define C1_RUN1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields C1_ROV	 */
#define C1_ROV1_WIDTH                                                         1
#define C1_ROV1_SHIFT                                                         3
#define C1_ROV1_MASK                                                 0x00000008
#define C1_ROV1_RD(src)                               (((src) & 0x00000008)>>3)
#define C1_ROV1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields C1_RFR	 */
#define C1_RFR1_WIDTH                                                         1
#define C1_RFR1_SHIFT                                                         2
#define C1_RFR1_MASK                                                 0x00000004
#define C1_RFR1_RD(src)                               (((src) & 0x00000004)>>2)
#define C1_RFR1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields C1_RJB	 */
#define C1_RJB1_WIDTH                                                         1
#define C1_RJB1_SHIFT                                                         1
#define C1_RJB1_MASK                                                 0x00000002
#define C1_RJB1_RD(src)                               (((src) & 0x00000002)>>1)
#define C1_RJB1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields C1_RDR	 */
#define C1_RDR1_WIDTH                                                         1
#define C1_RDR1_SHIFT                                                         0
#define C1_RDR1_MASK                                                 0x00000001
#define C1_RDR1_RD(src)                                  (((src) & 0x00000001))
#define C1_RDR1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CAR2	*/ 
/*	 Fields C2_TJB	 */
#define C2_TJB2_WIDTH                                                         1
#define C2_TJB2_SHIFT                                                        19
#define C2_TJB2_MASK                                                 0x00080000
#define C2_TJB2_RD(src)                              (((src) & 0x00080000)>>19)
#define C2_TJB2_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields C2_TFC	 */
#define C2_TFC2_WIDTH                                                         1
#define C2_TFC2_SHIFT                                                        18
#define C2_TFC2_MASK                                                 0x00040000
#define C2_TFC2_RD(src)                              (((src) & 0x00040000)>>18)
#define C2_TFC2_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields C2_TCF	 */
#define C2_TCF2_WIDTH                                                         1
#define C2_TCF2_SHIFT                                                        17
#define C2_TCF2_MASK                                                 0x00020000
#define C2_TCF2_RD(src)                              (((src) & 0x00020000)>>17)
#define C2_TCF2_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields C2_TOV	 */
#define C2_TOV2_WIDTH                                                         1
#define C2_TOV2_SHIFT                                                        16
#define C2_TOV2_MASK                                                 0x00010000
#define C2_TOV2_RD(src)                              (((src) & 0x00010000)>>16)
#define C2_TOV2_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields C2_TUN	 */
#define C2_TUN2_WIDTH                                                         1
#define C2_TUN2_SHIFT                                                        15
#define C2_TUN2_MASK                                                 0x00008000
#define C2_TUN2_RD(src)                              (((src) & 0x00008000)>>15)
#define C2_TUN2_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields C2_TFG	 */
#define C2_TFG2_WIDTH                                                         1
#define C2_TFG2_SHIFT                                                        14
#define C2_TFG2_MASK                                                 0x00004000
#define C2_TFG2_RD(src)                              (((src) & 0x00004000)>>14)
#define C2_TFG2_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields C2_TBY	 */
#define C2_TBY2_WIDTH                                                         1
#define C2_TBY2_SHIFT                                                        13
#define C2_TBY2_MASK                                                 0x00002000
#define C2_TBY2_RD(src)                              (((src) & 0x00002000)>>13)
#define C2_TBY2_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields C2_TPK	 */
#define C2_TPK2_WIDTH                                                         1
#define C2_TPK2_SHIFT                                                        12
#define C2_TPK2_MASK                                                 0x00001000
#define C2_TPK2_RD(src)                              (((src) & 0x00001000)>>12)
#define C2_TPK2_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields C2_TMC	 */
#define C2_TMC2_WIDTH                                                         1
#define C2_TMC2_SHIFT                                                        11
#define C2_TMC2_MASK                                                 0x00000800
#define C2_TMC2_RD(src)                              (((src) & 0x00000800)>>11)
#define C2_TMC2_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields C2_TBC	 */
#define C2_TBC2_WIDTH                                                         1
#define C2_TBC2_SHIFT                                                        10
#define C2_TBC2_MASK                                                 0x00000400
#define C2_TBC2_RD(src)                              (((src) & 0x00000400)>>10)
#define C2_TBC2_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields C2_TPF	 */
#define C2_TPF2_WIDTH                                                         1
#define C2_TPF2_SHIFT                                                         9
#define C2_TPF2_MASK                                                 0x00000200
#define C2_TPF2_RD(src)                               (((src) & 0x00000200)>>9)
#define C2_TPF2_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields C2_TDF	 */
#define C2_TDF2_WIDTH                                                         1
#define C2_TDF2_SHIFT                                                         8
#define C2_TDF2_MASK                                                 0x00000100
#define C2_TDF2_RD(src)                               (((src) & 0x00000100)>>8)
#define C2_TDF2_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields C2_TED	 */
#define C2_TED2_WIDTH                                                         1
#define C2_TED2_SHIFT                                                         7
#define C2_TED2_MASK                                                 0x00000080
#define C2_TED2_RD(src)                               (((src) & 0x00000080)>>7)
#define C2_TED2_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields C2_TSC	 */
#define C2_TSC2_WIDTH                                                         1
#define C2_TSC2_SHIFT                                                         6
#define C2_TSC2_MASK                                                 0x00000040
#define C2_TSC2_RD(src)                               (((src) & 0x00000040)>>6)
#define C2_TSC2_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields C2_TMA	 */
#define C2_TMA2_WIDTH                                                         1
#define C2_TMA2_SHIFT                                                         5
#define C2_TMA2_MASK                                                 0x00000020
#define C2_TMA2_RD(src)                               (((src) & 0x00000020)>>5)
#define C2_TMA2_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields C2_TLC	 */
#define C2_TLC2_WIDTH                                                         1
#define C2_TLC2_SHIFT                                                         4
#define C2_TLC2_MASK                                                 0x00000010
#define C2_TLC2_RD(src)                               (((src) & 0x00000010)>>4)
#define C2_TLC2_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields C2_TXC	 */
#define C2_TXC2_WIDTH                                                         1
#define C2_TXC2_SHIFT                                                         3
#define C2_TXC2_MASK                                                 0x00000008
#define C2_TXC2_RD(src)                               (((src) & 0x00000008)>>3)
#define C2_TXC2_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields C2_TNC	 */
#define C2_TNC2_WIDTH                                                         1
#define C2_TNC2_SHIFT                                                         2
#define C2_TNC2_MASK                                                 0x00000004
#define C2_TNC2_RD(src)                               (((src) & 0x00000004)>>2)
#define C2_TNC2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields C2_TPH	 */
#define C2_TPH2_WIDTH                                                         1
#define C2_TPH2_SHIFT                                                         1
#define C2_TPH2_MASK                                                 0x00000002
#define C2_TPH2_RD(src)                               (((src) & 0x00000002)>>1)
#define C2_TPH2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields C2_TDP	 */
#define C2_TDP2_WIDTH                                                         1
#define C2_TDP2_SHIFT                                                         0
#define C2_TDP2_MASK                                                 0x00000001
#define C2_TDP2_RD(src)                                  (((src) & 0x00000001))
#define C2_TDP2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CAM1	*/ 
/*	 Fields M1_64	 */
#define M1_641_WIDTH                                                          1
#define M1_641_SHIFT                                                         31
#define M1_641_MASK                                                  0x80000000
#define M1_641_RD(src)                               (((src) & 0x80000000)>>31)
#define M1_641_SET(dst,src) \
                      (((dst) & ~0x80000000) | (((u32)(src)<<31) & 0x80000000))
/*	 Fields M1_127	 */
#define M1_1271_WIDTH                                                         1
#define M1_1271_SHIFT                                                        30
#define M1_1271_MASK                                                 0x40000000
#define M1_1271_RD(src)                              (((src) & 0x40000000)>>30)
#define M1_1271_SET(dst,src) \
                      (((dst) & ~0x40000000) | (((u32)(src)<<30) & 0x40000000))
/*	 Fields M1_255	 */
#define M1_2551_WIDTH                                                         1
#define M1_2551_SHIFT                                                        29
#define M1_2551_MASK                                                 0x20000000
#define M1_2551_RD(src)                              (((src) & 0x20000000)>>29)
#define M1_2551_SET(dst,src) \
                      (((dst) & ~0x20000000) | (((u32)(src)<<29) & 0x20000000))
/*	 Fields M1_511	 */
#define M1_5111_WIDTH                                                         1
#define M1_5111_SHIFT                                                        28
#define M1_5111_MASK                                                 0x10000000
#define M1_5111_RD(src)                              (((src) & 0x10000000)>>28)
#define M1_5111_SET(dst,src) \
                      (((dst) & ~0x10000000) | (((u32)(src)<<28) & 0x10000000))
/*	 Fields M1_1K	 */
#define M1_1K1_WIDTH                                                          1
#define M1_1K1_SHIFT                                                         27
#define M1_1K1_MASK                                                  0x08000000
#define M1_1K1_RD(src)                               (((src) & 0x08000000)>>27)
#define M1_1K1_SET(dst,src) \
                      (((dst) & ~0x08000000) | (((u32)(src)<<27) & 0x08000000))
/*	 Fields M1_MAX	 */
#define M1_MAX1_WIDTH                                                         1
#define M1_MAX1_SHIFT                                                        26
#define M1_MAX1_MASK                                                 0x04000000
#define M1_MAX1_RD(src)                              (((src) & 0x04000000)>>26)
#define M1_MAX1_SET(dst,src) \
                      (((dst) & ~0x04000000) | (((u32)(src)<<26) & 0x04000000))
/*	 Fields M1_MGV	 */
#define M1_MGV1_WIDTH                                                         1
#define M1_MGV1_SHIFT                                                        25
#define M1_MGV1_MASK                                                 0x02000000
#define M1_MGV1_RD(src)                              (((src) & 0x02000000)>>25)
#define M1_MGV1_SET(dst,src) \
                      (((dst) & ~0x02000000) | (((u32)(src)<<25) & 0x02000000))
/*	 Fields M1_RBY	 */
#define M1_RBY1_WIDTH                                                         1
#define M1_RBY1_SHIFT                                                        16
#define M1_RBY1_MASK                                                 0x00010000
#define M1_RBY1_RD(src)                              (((src) & 0x00010000)>>16)
#define M1_RBY1_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields M1_RPK	 */
#define M1_RPK1_WIDTH                                                         1
#define M1_RPK1_SHIFT                                                        15
#define M1_RPK1_MASK                                                 0x00008000
#define M1_RPK1_RD(src)                              (((src) & 0x00008000)>>15)
#define M1_RPK1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields M1_RFC	 */
#define M1_RFC1_WIDTH                                                         1
#define M1_RFC1_SHIFT                                                        14
#define M1_RFC1_MASK                                                 0x00004000
#define M1_RFC1_RD(src)                              (((src) & 0x00004000)>>14)
#define M1_RFC1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields M1_RMC	 */
#define M1_RMC1_WIDTH                                                         1
#define M1_RMC1_SHIFT                                                        13
#define M1_RMC1_MASK                                                 0x00002000
#define M1_RMC1_RD(src)                              (((src) & 0x00002000)>>13)
#define M1_RMC1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields M1_RBC	 */
#define M1_RBC1_WIDTH                                                         1
#define M1_RBC1_SHIFT                                                        12
#define M1_RBC1_MASK                                                 0x00001000
#define M1_RBC1_RD(src)                              (((src) & 0x00001000)>>12)
#define M1_RBC1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields M1_RXC	 */
#define M1_RXC1_WIDTH                                                         1
#define M1_RXC1_SHIFT                                                        11
#define M1_RXC1_MASK                                                 0x00000800
#define M1_RXC1_RD(src)                              (((src) & 0x00000800)>>11)
#define M1_RXC1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields M1_RXP	 */
#define M1_RXP1_WIDTH                                                         1
#define M1_RXP1_SHIFT                                                        10
#define M1_RXP1_MASK                                                 0x00000400
#define M1_RXP1_RD(src)                              (((src) & 0x00000400)>>10)
#define M1_RXP1_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields M1_RXU	 */
#define M1_RXU1_WIDTH                                                         1
#define M1_RXU1_SHIFT                                                         9
#define M1_RXU1_MASK                                                 0x00000200
#define M1_RXU1_RD(src)                               (((src) & 0x00000200)>>9)
#define M1_RXU1_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields M1_RAL	 */
#define M1_RAL1_WIDTH                                                         1
#define M1_RAL1_SHIFT                                                         8
#define M1_RAL1_MASK                                                 0x00000100
#define M1_RAL1_RD(src)                               (((src) & 0x00000100)>>8)
#define M1_RAL1_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields M1_RFL	 */
#define M1_RFL1_WIDTH                                                         1
#define M1_RFL1_SHIFT                                                         7
#define M1_RFL1_MASK                                                 0x00000080
#define M1_RFL1_RD(src)                               (((src) & 0x00000080)>>7)
#define M1_RFL1_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields M1_RCD	 */
#define M1_RCD1_WIDTH                                                         1
#define M1_RCD1_SHIFT                                                         6
#define M1_RCD1_MASK                                                 0x00000040
#define M1_RCD1_RD(src)                               (((src) & 0x00000040)>>6)
#define M1_RCD1_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields M1_RCS	 */
#define M1_RCS1_WIDTH                                                         1
#define M1_RCS1_SHIFT                                                         5
#define M1_RCS1_MASK                                                 0x00000020
#define M1_RCS1_RD(src)                               (((src) & 0x00000020)>>5)
#define M1_RCS1_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields M1_RUN	 */
#define M1_RUN1_WIDTH                                                         1
#define M1_RUN1_SHIFT                                                         4
#define M1_RUN1_MASK                                                 0x00000010
#define M1_RUN1_RD(src)                               (((src) & 0x00000010)>>4)
#define M1_RUN1_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields M1_ROV	 */
#define M1_ROV1_WIDTH                                                         1
#define M1_ROV1_SHIFT                                                         3
#define M1_ROV1_MASK                                                 0x00000008
#define M1_ROV1_RD(src)                               (((src) & 0x00000008)>>3)
#define M1_ROV1_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields M1_RFR	 */
#define M1_RFR1_WIDTH                                                         1
#define M1_RFR1_SHIFT                                                         2
#define M1_RFR1_MASK                                                 0x00000004
#define M1_RFR1_RD(src)                               (((src) & 0x00000004)>>2)
#define M1_RFR1_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields M1_RJB	 */
#define M1_RJB1_WIDTH                                                         1
#define M1_RJB1_SHIFT                                                         1
#define M1_RJB1_MASK                                                 0x00000002
#define M1_RJB1_RD(src)                               (((src) & 0x00000002)>>1)
#define M1_RJB1_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields M1_RDR	 */
#define M1_RDR1_WIDTH                                                         1
#define M1_RDR1_SHIFT                                                         0
#define M1_RDR1_MASK                                                 0x00000001
#define M1_RDR1_RD(src)                                  (((src) & 0x00000001))
#define M1_RDR1_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register CAM2	*/ 
/*	 Fields M2_TJB	 */
#define M2_TJB2_WIDTH                                                         1
#define M2_TJB2_SHIFT                                                        19
#define M2_TJB2_MASK                                                 0x00080000
#define M2_TJB2_RD(src)                              (((src) & 0x00080000)>>19)
#define M2_TJB2_SET(dst,src) \
                      (((dst) & ~0x00080000) | (((u32)(src)<<19) & 0x00080000))
/*	 Fields M2_TFC	 */
#define M2_TFC2_WIDTH                                                         1
#define M2_TFC2_SHIFT                                                        18
#define M2_TFC2_MASK                                                 0x00040000
#define M2_TFC2_RD(src)                              (((src) & 0x00040000)>>18)
#define M2_TFC2_SET(dst,src) \
                      (((dst) & ~0x00040000) | (((u32)(src)<<18) & 0x00040000))
/*	 Fields M2_TCF	 */
#define M2_TCF2_WIDTH                                                         1
#define M2_TCF2_SHIFT                                                        17
#define M2_TCF2_MASK                                                 0x00020000
#define M2_TCF2_RD(src)                              (((src) & 0x00020000)>>17)
#define M2_TCF2_SET(dst,src) \
                      (((dst) & ~0x00020000) | (((u32)(src)<<17) & 0x00020000))
/*	 Fields M2_TOV	 */
#define M2_TOV2_WIDTH                                                         1
#define M2_TOV2_SHIFT                                                        16
#define M2_TOV2_MASK                                                 0x00010000
#define M2_TOV2_RD(src)                              (((src) & 0x00010000)>>16)
#define M2_TOV2_SET(dst,src) \
                      (((dst) & ~0x00010000) | (((u32)(src)<<16) & 0x00010000))
/*	 Fields M2_TUN	 */
#define M2_TUN2_WIDTH                                                         1
#define M2_TUN2_SHIFT                                                        15
#define M2_TUN2_MASK                                                 0x00008000
#define M2_TUN2_RD(src)                              (((src) & 0x00008000)>>15)
#define M2_TUN2_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields M2_TFG	 */
#define M2_TFG2_WIDTH                                                         1
#define M2_TFG2_SHIFT                                                        14
#define M2_TFG2_MASK                                                 0x00004000
#define M2_TFG2_RD(src)                              (((src) & 0x00004000)>>14)
#define M2_TFG2_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields M2_TBY	 */
#define M2_TBY2_WIDTH                                                         1
#define M2_TBY2_SHIFT                                                        13
#define M2_TBY2_MASK                                                 0x00002000
#define M2_TBY2_RD(src)                              (((src) & 0x00002000)>>13)
#define M2_TBY2_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields M2_TPK	 */
#define M2_TPK2_WIDTH                                                         1
#define M2_TPK2_SHIFT                                                        12
#define M2_TPK2_MASK                                                 0x00001000
#define M2_TPK2_RD(src)                              (((src) & 0x00001000)>>12)
#define M2_TPK2_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields M2_TMC	 */
#define M2_TMC2_WIDTH                                                         1
#define M2_TMC2_SHIFT                                                        11
#define M2_TMC2_MASK                                                 0x00000800
#define M2_TMC2_RD(src)                              (((src) & 0x00000800)>>11)
#define M2_TMC2_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields M2_TBC	 */
#define M2_TBC2_WIDTH                                                         1
#define M2_TBC2_SHIFT                                                        10
#define M2_TBC2_MASK                                                 0x00000400
#define M2_TBC2_RD(src)                              (((src) & 0x00000400)>>10)
#define M2_TBC2_SET(dst,src) \
                      (((dst) & ~0x00000400) | (((u32)(src)<<10) & 0x00000400))
/*	 Fields M2_TPF	 */
#define M2_TPF2_WIDTH                                                         1
#define M2_TPF2_SHIFT                                                         9
#define M2_TPF2_MASK                                                 0x00000200
#define M2_TPF2_RD(src)                               (((src) & 0x00000200)>>9)
#define M2_TPF2_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields M2_TDF	 */
#define M2_TDF2_WIDTH                                                         1
#define M2_TDF2_SHIFT                                                         8
#define M2_TDF2_MASK                                                 0x00000100
#define M2_TDF2_RD(src)                               (((src) & 0x00000100)>>8)
#define M2_TDF2_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields M2_TED	 */
#define M2_TED2_WIDTH                                                         1
#define M2_TED2_SHIFT                                                         7
#define M2_TED2_MASK                                                 0x00000080
#define M2_TED2_RD(src)                               (((src) & 0x00000080)>>7)
#define M2_TED2_SET(dst,src) \
                       (((dst) & ~0x00000080) | (((u32)(src)<<7) & 0x00000080))
/*	 Fields M2_TSC	 */
#define M2_TSC2_WIDTH                                                         1
#define M2_TSC2_SHIFT                                                         6
#define M2_TSC2_MASK                                                 0x00000040
#define M2_TSC2_RD(src)                               (((src) & 0x00000040)>>6)
#define M2_TSC2_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields M2_TMA	 */
#define M2_TMA2_WIDTH                                                         1
#define M2_TMA2_SHIFT                                                         5
#define M2_TMA2_MASK                                                 0x00000020
#define M2_TMA2_RD(src)                               (((src) & 0x00000020)>>5)
#define M2_TMA2_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields M2_TLC	 */
#define M2_TLC2_WIDTH                                                         1
#define M2_TLC2_SHIFT                                                         4
#define M2_TLC2_MASK                                                 0x00000010
#define M2_TLC2_RD(src)                               (((src) & 0x00000010)>>4)
#define M2_TLC2_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields M2_TXC	 */
#define M2_TXC2_WIDTH                                                         1
#define M2_TXC2_SHIFT                                                         3
#define M2_TXC2_MASK                                                 0x00000008
#define M2_TXC2_RD(src)                               (((src) & 0x00000008)>>3)
#define M2_TXC2_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields M2_TNC	 */
#define M2_TNC2_WIDTH                                                         1
#define M2_TNC2_SHIFT                                                         2
#define M2_TNC2_MASK                                                 0x00000004
#define M2_TNC2_RD(src)                               (((src) & 0x00000004)>>2)
#define M2_TNC2_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields M2_TPH	 */
#define M2_TPH2_WIDTH                                                         1
#define M2_TPH2_SHIFT                                                         1
#define M2_TPH2_MASK                                                 0x00000002
#define M2_TPH2_RD(src)                               (((src) & 0x00000002)>>1)
#define M2_TPH2_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields M2_TDP	 */
#define M2_TDP2_WIDTH                                                         1
#define M2_TDP2_SHIFT                                                         0
#define M2_TDP2_MASK                                                 0x00000001
#define M2_TDP2_RD(src)                                  (((src) & 0x00000001))
#define M2_TDP2_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Global Base Address	*/
#define M_SGMII_BASE_ADDR			0x000000000ULL

/*    Address M_SGMII  Registers */
#define SGMII_CONTROL_ADDR                                           0x00000000
#define SGMII_CONTROL_DEFAULT                                        0x00000000
#define SGMII_STATUS_ADDR                                            0x00000004
#define SGMII_STATUS_DEFAULT                                         0x00000000
#define SGMII_RESERVED_1_ADDR                                        0x00000008
#define SGMII_RESERVED_1_DEFAULT                                     0x00000000
#define SGMII_RESERVED_2_ADDR                                        0x0000000c
#define SGMII_RESERVED_2_DEFAULT                                     0x00000000
#define SGMII_AN_ADVERTISEMENT_ADDR                                  0x00000010
#define SGMII_AN_ADVERTISEMENT_DEFAULT                               0x00000001
#define SGMII_AN_SGMII_PARTNER_BASE_PAGE_ABILITY_ADDR                0x00000014
#define SGMII_AN_SGMII_PARTNER_BASE_PAGE_ABILITY_DEFAULT             0x00000000
#define SGMII_AN_EXPANSION_ADDR                                      0x00000018
#define SGMII_AN_EXPANSION_DEFAULT                                   0x00000000
#define SGMII_AN_NEXT_PAGE_TRANSMIT_ADDR                             0x0000001c
#define SGMII_AN_NEXT_PAGE_TRANSMIT_DEFAULT                          0x00000000
#define SGMII_AN_LINK_PARTNER_ABILITY_NEXT_PAGE_ADDR                 0x00000020
#define SGMII_AN_LINK_PARTNER_ABILITY_NEXT_PAGE_DEFAULT              0x00000000
#define SGMII_EXTENDED_STATUS_ADDR                                   0x0000003c
#define SGMII_EXTENDED_STATUS_DEFAULT                                0x00000000
#define SGMII_JITTER_DIAGNOSTICS_ADDR                                0x00000040
#define SGMII_JITTER_DIAGNOSTICS_DEFAULT                             0x00000000
#define SGMII_TBI_CONTROL_ADDR                                       0x00000044
#define SGMII_TBI_CONTROL_DEFAULT                                    0x00008000

/*	Register sgmii_control	*/ 
/*	 Fields reset_phy	 */
#define RESET_PHY_WIDTH                                                       1
#define RESET_PHY_SHIFT                                                      15
#define RESET_PHY_MASK                                               0x00008000
#define RESET_PHY_RD(src)                            (((src) & 0x00008000)>>15)
#define RESET_PHY_WR(src)                       (((u32)(src)<<15) & 0x00008000)
#define RESET_PHY_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields loopback	 */
#define LOOPBACK_WIDTH                                                        1
#define LOOPBACK_SHIFT                                                       14
#define LOOPBACK_MASK                                                0x00004000
#define LOOPBACK_RD(src)                             (((src) & 0x00004000)>>14)
#define LOOPBACK_WR(src)                        (((u32)(src)<<14) & 0x00004000)
#define LOOPBACK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields speed_1	 */
#define SPEED_1_WIDTH                                                         1
#define SPEED_1_SHIFT                                                        13
#define SPEED_1_MASK                                                 0x00002000
#define SPEED_1_RD(src)                              (((src) & 0x00002000)>>13)
#define SPEED_1_WR(src)                         (((u32)(src)<<13) & 0x00002000)
#define SPEED_1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields enable_an	 */
#define ENABLE_AN_WIDTH                                                       1
#define ENABLE_AN_SHIFT                                                      12
#define ENABLE_AN_MASK                                               0x00001000
#define ENABLE_AN_RD(src)                            (((src) & 0x00001000)>>12)
#define ENABLE_AN_WR(src)                       (((u32)(src)<<12) & 0x00001000)
#define ENABLE_AN_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields reset_an	 */
#define RESET_AN_WIDTH                                                        1
#define RESET_AN_SHIFT                                                        9
#define RESET_AN_MASK                                                0x00000200
#define RESET_AN_RD(src)                              (((src) & 0x00000200)>>9)
#define RESET_AN_WR(src)                         (((u32)(src)<<9) & 0x00000200)
#define RESET_AN_SET(dst,src) \
                       (((dst) & ~0x00000200) | (((u32)(src)<<9) & 0x00000200))
/*	 Fields fulld	 */
#define FULLD_WIDTH                                                           1
#define FULLD_SHIFT                                                           8
#define FULLD_MASK                                                   0x00000100
#define FULLD_RD(src)                                 (((src) & 0x00000100)>>8)
#define FULLD_WR(src)                            (((u32)(src)<<8) & 0x00000100)
#define FULLD_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields speed_0	 */
#define SPEED_0_WIDTH                                                         1
#define SPEED_0_SHIFT                                                         6
#define SPEED_0_MASK                                                 0x00000040
#define SPEED_0_RD(src)                               (((src) & 0x00000040)>>6)
#define SPEED_0_WR(src)                          (((u32)(src)<<6) & 0x00000040)
#define SPEED_0_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))

/*	Register sgmii_status	*/ 
/*	 Fields extended_status	 */
#define EXTENDED_STATUS_WIDTH                                                 1
#define EXTENDED_STATUS_SHIFT                                                 8
#define EXTENDED_STATUS_MASK                                         0x00000100
#define EXTENDED_STATUS_RD(src)                       (((src) & 0x00000100)>>8)
#define EXTENDED_STATUS_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields MF_premable_suppression_enable	 */
#define MF_PREMABLE_SUPPRESSION_ENABLE_WIDTH                                  1
#define MF_PREMABLE_SUPPRESSION_ENABLE_SHIFT                                  6
#define MF_PREMABLE_SUPPRESSION_ENABLE_MASK                          0x00000040
#define MF_PREMABLE_SUPPRESSION_ENABLE_RD(src)        (((src) & 0x00000040)>>6)
#define MF_PREMABLE_SUPPRESSION_ENABLE_SET(dst,src) \
                       (((dst) & ~0x00000040) | (((u32)(src)<<6) & 0x00000040))
/*	 Fields auto_negotiation_complete	 */
#define AUTO_NEGOTIATION_COMPLETE_WIDTH                                       1
#define AUTO_NEGOTIATION_COMPLETE_SHIFT                                       5
#define AUTO_NEGOTIATION_COMPLETE_MASK                               0x00000020
#define AUTO_NEGOTIATION_COMPLETE_RD(src)             (((src) & 0x00000020)>>5)
#define AUTO_NEGOTIATION_COMPLETE_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields remote_fault	 */
#define REMOTE_FAULT_WIDTH                                                    1
#define REMOTE_FAULT_SHIFT                                                    4
#define REMOTE_FAULT_MASK                                            0x00000010
#define REMOTE_FAULT_RD(src)                          (((src) & 0x00000010)>>4)
#define REMOTE_FAULT_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields auto_negotiation_ability	 */
#define AUTO_NEGOTIATION_ABILITY_WIDTH                                        1
#define AUTO_NEGOTIATION_ABILITY_SHIFT                                        3
#define AUTO_NEGOTIATION_ABILITY_MASK                                0x00000008
#define AUTO_NEGOTIATION_ABILITY_RD(src)              (((src) & 0x00000008)>>3)
#define AUTO_NEGOTIATION_ABILITY_SET(dst,src) \
                       (((dst) & ~0x00000008) | (((u32)(src)<<3) & 0x00000008))
/*	 Fields link_status	 */
#define LINK_STATUS_WIDTH                                                     1
#define LINK_STATUS_SHIFT                                                     2
#define LINK_STATUS_MASK                                             0x00000004
#define LINK_STATUS_RD(src)                           (((src) & 0x00000004)>>2)
#define LINK_STATUS_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields extended_capability	 */
#define EXTENDED_CAPABILITY_WIDTH                                             1
#define EXTENDED_CAPABILITY_SHIFT                                             0
#define EXTENDED_CAPABILITY_MASK                                     0x00000001
#define EXTENDED_CAPABILITY_RD(src)                      (((src) & 0x00000001))
#define EXTENDED_CAPABILITY_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/*	Register sgmii_reserved_1	*/ 

/*	Register sgmii_reserved_2	*/ 

/*	Register sgmii_an_advertisement	*/ 
/*	 Fields link_up	 */
#define LINK_UP_WIDTH                                                         1
#define LINK_UP_SHIFT                                                        15
#define LINK_UP_MASK                                                 0x00008000
#define LINK_UP_RD(src)                              (((src) & 0x00008000)>>15)
#define LINK_UP_WR(src)                         (((u32)(src)<<15) & 0x00008000)
#define LINK_UP_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields ack	 */
#define ACK_WIDTH                                                             1
#define ACK_SHIFT                                                            14
#define ACK_MASK                                                     0x00004000
#define ACK_RD(src)                                  (((src) & 0x00004000)>>14)
#define ACK_WR(src)                             (((u32)(src)<<14) & 0x00004000)
#define ACK_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields full_duplex	 */
#define FULL_DUPLEX_F2_WIDTH                                                  1
#define FULL_DUPLEX_F2_SHIFT                                                 12
#define FULL_DUPLEX_F2_MASK                                          0x00001000
#define FULL_DUPLEX_F2_RD(src)                       (((src) & 0x00001000)>>12)
#define FULL_DUPLEX_F2_WR(src)                  (((u32)(src)<<12) & 0x00001000)
#define FULL_DUPLEX_F2_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields link_speed	 */
#define LINK_SPEED_WIDTH                                                      2
#define LINK_SPEED_SHIFT                                                     10
#define LINK_SPEED_MASK                                              0x00000c00
#define LINK_SPEED_RD(src)                           (((src) & 0x00000c00)>>10)
#define LINK_SPEED_WR(src)                      (((u32)(src)<<10) & 0x00000c00)
#define LINK_SPEED_SET(dst,src) \
                      (((dst) & ~0x00000c00) | (((u32)(src)<<10) & 0x00000c00))
/*	 Fields reserved1	 */
#define RESERVED1_WIDTH                                                      10
#define RESERVED1_SHIFT                                                       0
#define RESERVED1_MASK                                               0x000003ff
#define RESERVED1_RD(src)                                (((src) & 0x000003ff))
#define RESERVED1_WR(src)                           (((u32)(src)) & 0x000003ff)
#define RESERVED1_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register sgmii_an_sgmii_partner_base_page_ability	*/ 
/*	 Fields link_up	 */
#define LINK_UP_F1_WIDTH                                                      1
#define LINK_UP_F1_SHIFT                                                     15
#define LINK_UP_F1_MASK                                              0x00008000
#define LINK_UP_F1_RD(src)                           (((src) & 0x00008000)>>15)
#define LINK_UP_F1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields ack	 */
#define ACK_F1_WIDTH                                                          1
#define ACK_F1_SHIFT                                                         14
#define ACK_F1_MASK                                                  0x00004000
#define ACK_F1_RD(src)                               (((src) & 0x00004000)>>14)
#define ACK_F1_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields full_duplex	 */
#define FULL_DUPLEX_F3_WIDTH                                                  1
#define FULL_DUPLEX_F3_SHIFT                                                 12
#define FULL_DUPLEX_F3_MASK                                          0x00001000
#define FULL_DUPLEX_F3_RD(src)                       (((src) & 0x00001000)>>12)
#define FULL_DUPLEX_F3_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields link_speed	 */
#define LINK_SPEED_F1_WIDTH                                                   2
#define LINK_SPEED_F1_SHIFT                                                  10
#define LINK_SPEED_F1_MASK                                           0x00000c00
#define LINK_SPEED_F1_RD(src)                        (((src) & 0x00000c00)>>10)
#define LINK_SPEED_F1_SET(dst,src) \
                      (((dst) & ~0x00000c00) | (((u32)(src)<<10) & 0x00000c00))

/*	Register sgmii_an_expansion	*/ 
/*	 Fields next_page_able	 */
#define NEXT_PAGE_ABLE_WIDTH                                                  1
#define NEXT_PAGE_ABLE_SHIFT                                                  2
#define NEXT_PAGE_ABLE_MASK                                          0x00000004
#define NEXT_PAGE_ABLE_RD(src)                        (((src) & 0x00000004)>>2)
#define NEXT_PAGE_ABLE_SET(dst,src) \
                       (((dst) & ~0x00000004) | (((u32)(src)<<2) & 0x00000004))
/*	 Fields page_received	 */
#define PAGE_RECEIVED_WIDTH                                                   1
#define PAGE_RECEIVED_SHIFT                                                   1
#define PAGE_RECEIVED_MASK                                           0x00000002
#define PAGE_RECEIVED_RD(src)                         (((src) & 0x00000002)>>1)
#define PAGE_RECEIVED_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))

/*	Register sgmii_an_next_page_transmit	*/ 
/*	 Fields next_page	 */
#define NEXT_PAGE_WIDTH                                                       1
#define NEXT_PAGE_SHIFT                                                      15
#define NEXT_PAGE_MASK                                               0x00008000
#define NEXT_PAGE_RD(src)                            (((src) & 0x00008000)>>15)
#define NEXT_PAGE_WR(src)                       (((u32)(src)<<15) & 0x00008000)
#define NEXT_PAGE_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields ack	 */
#define ACK_F2_WIDTH                                                          1
#define ACK_F2_SHIFT                                                         14
#define ACK_F2_MASK                                                  0x00004000
#define ACK_F2_RD(src)                               (((src) & 0x00004000)>>14)
#define ACK_F2_WR(src)                          (((u32)(src)<<14) & 0x00004000)
#define ACK_F2_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields message_page	 */
#define MESSAGE_PAGE_WIDTH                                                    1
#define MESSAGE_PAGE_SHIFT                                                   13
#define MESSAGE_PAGE_MASK                                            0x00002000
#define MESSAGE_PAGE_RD(src)                         (((src) & 0x00002000)>>13)
#define MESSAGE_PAGE_WR(src)                    (((u32)(src)<<13) & 0x00002000)
#define MESSAGE_PAGE_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields acknowledge	 */
#define ACKNOWLEDGE_WIDTH                                                     1
#define ACKNOWLEDGE_SHIFT                                                    12
#define ACKNOWLEDGE_MASK                                             0x00001000
#define ACKNOWLEDGE_RD(src)                          (((src) & 0x00001000)>>12)
#define ACKNOWLEDGE_WR(src)                     (((u32)(src)<<12) & 0x00001000)
#define ACKNOWLEDGE_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields toggle	 */
#define TOGGLE_WIDTH                                                          1
#define TOGGLE_SHIFT                                                         11
#define TOGGLE_MASK                                                  0x00000800
#define TOGGLE_RD(src)                               (((src) & 0x00000800)>>11)
#define TOGGLE_WR(src)                          (((u32)(src)<<11) & 0x00000800)
#define TOGGLE_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields message	 */
#define MESSAGE_WIDTH                                                        11
#define MESSAGE_SHIFT                                                         0
#define MESSAGE_MASK                                                 0x000007ff
#define MESSAGE_RD(src)                                  (((src) & 0x000007ff))
#define MESSAGE_WR(src)                             (((u32)(src)) & 0x000007ff)
#define MESSAGE_SET(dst,src) \
                          (((dst) & ~0x000007ff) | (((u32)(src)) & 0x000007ff))

/*	Register sgmii_an_link_partner_ability_next_page	*/ 
/*	 Fields next_page	 */
#define NEXT_PAGE_F1_WIDTH                                                    1
#define NEXT_PAGE_F1_SHIFT                                                   15
#define NEXT_PAGE_F1_MASK                                            0x00008000
#define NEXT_PAGE_F1_RD(src)                         (((src) & 0x00008000)>>15)
#define NEXT_PAGE_F1_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields ack	 */
#define ACK_F3_WIDTH                                                          1
#define ACK_F3_SHIFT                                                         14
#define ACK_F3_MASK                                                  0x00004000
#define ACK_F3_RD(src)                               (((src) & 0x00004000)>>14)
#define ACK_F3_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields message_page	 */
#define MESSAGE_PAGE_F1_WIDTH                                                 1
#define MESSAGE_PAGE_F1_SHIFT                                                13
#define MESSAGE_PAGE_F1_MASK                                         0x00002000
#define MESSAGE_PAGE_F1_RD(src)                      (((src) & 0x00002000)>>13)
#define MESSAGE_PAGE_F1_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields acknowledge	 */
#define ACKNOWLEDGE_F1_WIDTH                                                  1
#define ACKNOWLEDGE_F1_SHIFT                                                 12
#define ACKNOWLEDGE_F1_MASK                                          0x00001000
#define ACKNOWLEDGE_F1_RD(src)                       (((src) & 0x00001000)>>12)
#define ACKNOWLEDGE_F1_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields toggle	 */
#define TOGGLE_F1_WIDTH                                                       1
#define TOGGLE_F1_SHIFT                                                      11
#define TOGGLE_F1_MASK                                               0x00000800
#define TOGGLE_F1_RD(src)                            (((src) & 0x00000800)>>11)
#define TOGGLE_F1_SET(dst,src) \
                      (((dst) & ~0x00000800) | (((u32)(src)<<11) & 0x00000800))
/*	 Fields message	 */
#define MESSAGE_F1_WIDTH                                                     11
#define MESSAGE_F1_SHIFT                                                      0
#define MESSAGE_F1_MASK                                              0x000007ff
#define MESSAGE_F1_RD(src)                               (((src) & 0x000007ff))
#define MESSAGE_F1_SET(dst,src) \
                          (((dst) & ~0x000007ff) | (((u32)(src)) & 0x000007ff))

/*	Register sgmii_extended_status	*/ 
/*	 Fields base_x_full_duplex	 */
#define BASE_X_FULL_DUPLEX_WIDTH                                              1
#define BASE_X_FULL_DUPLEX_SHIFT                                             15
#define BASE_X_FULL_DUPLEX_MASK                                      0x00008000
#define BASE_X_FULL_DUPLEX_RD(src)                   (((src) & 0x00008000)>>15)
#define BASE_X_FULL_DUPLEX_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields base_x_half_duplex	 */
#define BASE_X_HALF_DUPLEX_WIDTH                                              1
#define BASE_X_HALF_DUPLEX_SHIFT                                             14
#define BASE_X_HALF_DUPLEX_MASK                                      0x00004000
#define BASE_X_HALF_DUPLEX_RD(src)                   (((src) & 0x00004000)>>14)
#define BASE_X_HALF_DUPLEX_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields base_t_full_duplex	 */
#define BASE_T_FULL_DUPLEX_WIDTH                                              1
#define BASE_T_FULL_DUPLEX_SHIFT                                             13
#define BASE_T_FULL_DUPLEX_MASK                                      0x00002000
#define BASE_T_FULL_DUPLEX_RD(src)                   (((src) & 0x00002000)>>13)
#define BASE_T_FULL_DUPLEX_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields base_t_half_duplex	 */
#define BASE_T_HALF_DUPLEX_WIDTH                                              1
#define BASE_T_HALF_DUPLEX_SHIFT                                             12
#define BASE_T_HALF_DUPLEX_MASK                                      0x00001000
#define BASE_T_HALF_DUPLEX_RD(src)                   (((src) & 0x00001000)>>12)
#define BASE_T_HALF_DUPLEX_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))

/*	Register sgmii_jitter_diagnostics	*/ 
/*	 Fields jitter_diagnostic_enable	 */
#define JITTER_DIAGNOSTIC_ENABLE_WIDTH                                        1
#define JITTER_DIAGNOSTIC_ENABLE_SHIFT                                       15
#define JITTER_DIAGNOSTIC_ENABLE_MASK                                0x00008000
#define JITTER_DIAGNOSTIC_ENABLE_RD(src)             (((src) & 0x00008000)>>15)
#define JITTER_DIAGNOSTIC_ENABLE_WR(src)        (((u32)(src)<<15) & 0x00008000)
#define JITTER_DIAGNOSTIC_ENABLE_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields jitter_pattern_select	 */
#define JITTER_PATTERN_SELECT_WIDTH                                           3
#define JITTER_PATTERN_SELECT_SHIFT                                          12
#define JITTER_PATTERN_SELECT_MASK                                   0x00007000
#define JITTER_PATTERN_SELECT_RD(src)                (((src) & 0x00007000)>>12)
#define JITTER_PATTERN_SELECT_WR(src)           (((u32)(src)<<12) & 0x00007000)
#define JITTER_PATTERN_SELECT_SET(dst,src) \
                      (((dst) & ~0x00007000) | (((u32)(src)<<12) & 0x00007000))
/*	 Fields custom_jitter_pattern	 */
#define CUSTOM_JITTER_PATTERN_WIDTH                                          10
#define CUSTOM_JITTER_PATTERN_SHIFT                                           0
#define CUSTOM_JITTER_PATTERN_MASK                                   0x000003ff
#define CUSTOM_JITTER_PATTERN_RD(src)                    (((src) & 0x000003ff))
#define CUSTOM_JITTER_PATTERN_WR(src)               (((u32)(src)) & 0x000003ff)
#define CUSTOM_JITTER_PATTERN_SET(dst,src) \
                          (((dst) & ~0x000003ff) | (((u32)(src)) & 0x000003ff))

/*	Register sgmii_tbi_control	*/ 
/*	 Fields soft_reset	 */
#define SOFT_RESET_WIDTH                                                      1
#define SOFT_RESET_SHIFT                                                     15
#define SOFT_RESET_MASK                                              0x00008000
#define SOFT_RESET_RD(src)                           (((src) & 0x00008000)>>15)
#define SOFT_RESET_WR(src)                      (((u32)(src)<<15) & 0x00008000)
#define SOFT_RESET_SET(dst,src) \
                      (((dst) & ~0x00008000) | (((u32)(src)<<15) & 0x00008000))
/*	 Fields shortcut_link_timer	 */
#define SHORTCUT_LINK_TIMER_WIDTH                                             1
#define SHORTCUT_LINK_TIMER_SHIFT                                            14
#define SHORTCUT_LINK_TIMER_MASK                                     0x00004000
#define SHORTCUT_LINK_TIMER_RD(src)                  (((src) & 0x00004000)>>14)
#define SHORTCUT_LINK_TIMER_WR(src)             (((u32)(src)<<14) & 0x00004000)
#define SHORTCUT_LINK_TIMER_SET(dst,src) \
                      (((dst) & ~0x00004000) | (((u32)(src)<<14) & 0x00004000))
/*	 Fields disable_receive_running_disparity	 */
#define DISABLE_RECEIVE_RUNNING_DISPARITY_WIDTH                               1
#define DISABLE_RECEIVE_RUNNING_DISPARITY_SHIFT                              13
#define DISABLE_RECEIVE_RUNNING_DISPARITY_MASK                       0x00002000
#define DISABLE_RECEIVE_RUNNING_DISPARITY_RD(src)    (((src) & 0x00002000)>>13)
#define DISABLE_RECEIVE_RUNNING_DISPARITY_WR(src) \
                                                (((u32)(src)<<13) & 0x00002000)
#define DISABLE_RECEIVE_RUNNING_DISPARITY_SET(dst,src) \
                      (((dst) & ~0x00002000) | (((u32)(src)<<13) & 0x00002000))
/*	 Fields disable_transmit_running_disparity	 */
#define DISABLE_TRANSMIT_RUNNING_DISPARITY_WIDTH                              1
#define DISABLE_TRANSMIT_RUNNING_DISPARITY_SHIFT                             12
#define DISABLE_TRANSMIT_RUNNING_DISPARITY_MASK                      0x00001000
#define DISABLE_TRANSMIT_RUNNING_DISPARITY_RD(src)   (((src) & 0x00001000)>>12)
#define DISABLE_TRANSMIT_RUNNING_DISPARITY_WR(src) \
                                                (((u32)(src)<<12) & 0x00001000)
#define DISABLE_TRANSMIT_RUNNING_DISPARITY_SET(dst,src) \
                      (((dst) & ~0x00001000) | (((u32)(src)<<12) & 0x00001000))
/*	 Fields auto_negotiation_sense	 */
#define AUTO_NEGOTIATION_SENSE_WIDTH                                          1
#define AUTO_NEGOTIATION_SENSE_SHIFT                                          8
#define AUTO_NEGOTIATION_SENSE_MASK                                  0x00000100
#define AUTO_NEGOTIATION_SENSE_RD(src)                (((src) & 0x00000100)>>8)
#define AUTO_NEGOTIATION_SENSE_WR(src)           (((u32)(src)<<8) & 0x00000100)
#define AUTO_NEGOTIATION_SENSE_SET(dst,src) \
                       (((dst) & ~0x00000100) | (((u32)(src)<<8) & 0x00000100))
/*	 Fields receive_clock_select	 */
#define RECEIVE_CLOCK_SELECT_WIDTH                                            1
#define RECEIVE_CLOCK_SELECT_SHIFT                                            5
#define RECEIVE_CLOCK_SELECT_MASK                                    0x00000020
#define RECEIVE_CLOCK_SELECT_RD(src)                  (((src) & 0x00000020)>>5)
#define RECEIVE_CLOCK_SELECT_WR(src)             (((u32)(src)<<5) & 0x00000020)
#define RECEIVE_CLOCK_SELECT_SET(dst,src) \
                       (((dst) & ~0x00000020) | (((u32)(src)<<5) & 0x00000020))
/*	 Fields gmii_mode	 */
#define ENET_GMII_MODE_WIDTH                                               1
#define ENET_GMII_MODE_SHIFT                                               4
#define ENET_GMII_MODE_MASK                                       0x00000010
#define ENET_GMII_MODE_RD(src)                     (((src) & 0x00000010)>>4)
#define ENET_GMII_MODE_WR(src)                (((u32)(src)<<4) & 0x00000010)
#define ENET_GMII_MODE_SET(dst,src) \
                       (((dst) & ~0x00000010) | (((u32)(src)<<4) & 0x00000010))
/*	 Fields enable_wrap	 */
#define ENABLE_WRAP_WIDTH                                                     1
#define ENABLE_WRAP_SHIFT                                                     1
#define ENABLE_WRAP_MASK                                             0x00000002
#define ENABLE_WRAP_RD(src)                           (((src) & 0x00000002)>>1)
#define ENABLE_WRAP_WR(src)                      (((u32)(src)<<1) & 0x00000002)
#define ENABLE_WRAP_SET(dst,src) \
                       (((dst) & ~0x00000002) | (((u32)(src)<<1) & 0x00000002))
/*	 Fields enable_comma_detect	 */
#define ENABLE_COMMA_DETECT_WIDTH                                             1
#define ENABLE_COMMA_DETECT_SHIFT                                             0
#define ENABLE_COMMA_DETECT_MASK                                     0x00000001
#define ENABLE_COMMA_DETECT_RD(src)                      (((src) & 0x00000001))
#define ENABLE_COMMA_DETECT_WR(src)                 (((u32)(src)) & 0x00000001)
#define ENABLE_COMMA_DETECT_SET(dst,src) \
                          (((dst) & ~0x00000001) | (((u32)(src)) & 0x00000001))

/* Manually added defines for compatability with legacy PPro family */	
#define BUSY_F14_MASK BUSY_MASK

#define KC_SERDES_RXTX_REGS_RXTX_REG0__ADDR                0x400
#define KC_SERDES_RXTX_REGS_RXTX_REG1__ADDR                0x402
#define KC_SERDES_RXTX_REGS_RXTX_REG2__ADDR                0x404
#define KC_SERDES_RXTX_REGS_RXTX_REG3__ADDR                0x406
#define KC_SERDES_RXTX_REGS_RXTX_REG4__ADDR                0x408
#define KC_SERDES_RXTX_REGS_RXTX_REG5__ADDR                0x40a
#define KC_SERDES_RXTX_REGS_RXTX_REG6__ADDR                0x40c
#define KC_SERDES_RXTX_REGS_RXTX_REG7__ADDR                0x40e
#define KC_SERDES_RXTX_REGS_RXTX_REG8__ADDR                0x410
#define KC_SERDES_RXTX_REGS_RXTX_REG9__ADDR                0x412
#define KC_SERDES_RXTX_REGS_RXTX_REG10__ADDR               0x414
#define KC_SERDES_RXTX_REGS_RXTX_REG11__ADDR               0x416
#define KC_SERDES_RXTX_REGS_RXTX_REG12__ADDR               0x418
#define KC_SERDES_RXTX_REGS_RXTX_REG13__ADDR               0x41a
#define KC_SERDES_RXTX_REGS_RXTX_REG14__ADDR               0x41c
#define KC_SERDES_RXTX_REGS_RXTX_REG15__ADDR               0x41e
#define KC_SERDES_RXTX_REGS_RXTX_REG16__ADDR               0x420
#define KC_SERDES_RXTX_REGS_RXTX_REG17__ADDR               0x422
#define KC_SERDES_RXTX_REGS_RXTX_REG18__ADDR               0x424
#define KC_SERDES_RXTX_REGS_RXTX_REG19__ADDR               0x426
#define KC_SERDES_RXTX_REGS_RXTX_REG20__ADDR               0x428
#define KC_SERDES_RXTX_REGS_RXTX_REG21__ADDR               0x42a
#define KC_SERDES_RXTX_REGS_RXTX_REG22__ADDR               0x42c
#define KC_SERDES_RXTX_REGS_RXTX_REG23__ADDR               0x42e
#define KC_SERDES_RXTX_REGS_RXTX_REG24__ADDR               0x430
#define KC_SERDES_RXTX_REGS_RXTX_REG25__ADDR               0x432
#define KC_SERDES_RXTX_REGS_RXTX_REG26__ADDR               0x434
#define KC_SERDES_RXTX_REGS_RXTX_REG27__ADDR               0x436
#define KC_SERDES_RXTX_REGS_RXTX_REG28__ADDR               0x438
#define KC_SERDES_RXTX_REGS_RXTX_REG29__ADDR               0x43a
#define KC_SERDES_RXTX_REGS_RXTX_REG30__ADDR               0x43c
#define KC_SERDES_RXTX_REGS_RXTX_REG31__ADDR               0x43e
#define KC_SERDES_RXTX_REGS_RXTX_REG32__ADDR               0x440
#define KC_SERDES_RXTX_REGS_RXTX_REG33__ADDR               0x442
#define KC_SERDES_RXTX_REGS_RXTX_REG34__ADDR               0x444
#define KC_SERDES_RXTX_REGS_RXTX_REG35__ADDR               0x446
#define KC_SERDES_RXTX_REGS_RXTX_REG36__ADDR               0x448
#define KC_SERDES_RXTX_REGS_RXTX_REG37__ADDR               0x44a
#define KC_SERDES_RXTX_REGS_RXTX_REG38__ADDR               0x44c
#define KC_SERDES_RXTX_REGS_RXTX_REG39__ADDR               0x44e
#define KC_SERDES_RXTX_REGS_RXTX_REG40__ADDR               0x450
#define KC_SERDES_RXTX_REGS_RXTX_REG41__ADDR               0x452
#define KC_SERDES_RXTX_REGS_RXTX_REG42__ADDR               0x454
#define KC_SERDES_RXTX_REGS_RXTX_REG43__ADDR               0x456
#define KC_SERDES_RXTX_REGS_RXTX_REG44__ADDR               0x458
#define KC_SERDES_RXTX_REGS_RXTX_REG45__ADDR               0x45a
#define KC_SERDES_RXTX_REGS_RXTX_REG46__ADDR               0x45c
#define KC_SERDES_RXTX_REGS_RXTX_REG47__ADDR               0x45e
#define KC_SERDES_RXTX_REGS_RXTX_REG48__ADDR               0x460
#define KC_SERDES_RXTX_REGS_RXTX_REG49__ADDR               0x462

#define KC_SERDES_RXTX_REGS_RXTX_REG50__ADDR               0x464
#define KC_SERDES_RXTX_REGS_RXTX_REG51__ADDR               0x466
#define KC_SERDES_RXTX_REGS_RXTX_REG52__ADDR               0x468
#define KC_SERDES_RXTX_REGS_RXTX_REG53__ADDR               0x46a
#define KC_SERDES_RXTX_REGS_RXTX_REG54__ADDR               0x46c
#define KC_SERDES_RXTX_REGS_RXTX_REG55__ADDR               0x46e
#define KC_SERDES_RXTX_REGS_RXTX_REG56__ADDR               0x470
#define KC_SERDES_RXTX_REGS_RXTX_REG57__ADDR               0x472
#define KC_SERDES_RXTX_REGS_RXTX_REG58__ADDR               0x474
#define KC_SERDES_RXTX_REGS_RXTX_REG59__ADDR               0x476
#define KC_SERDES_RXTX_REGS_RXTX_REG60__ADDR               0x478
#define KC_SERDES_RXTX_REGS_RXTX_REG61__ADDR               0x47a
#define KC_SERDES_RXTX_REGS_RXTX_REG62__ADDR               0x47c
#define KC_SERDES_RXTX_REGS_RXTX_REG63__ADDR               0x47e
#define KC_SERDES_RXTX_REGS_RXTX_REG64__ADDR               0x480
#define KC_SERDES_RXTX_REGS_RXTX_REG65__ADDR               0x482
#define KC_SERDES_RXTX_REGS_RXTX_REG66__ADDR               0x484
#define KC_SERDES_RXTX_REGS_RXTX_REG67__ADDR               0x486
#define KC_SERDES_RXTX_REGS_RXTX_REG68__ADDR               0x488
#define KC_SERDES_RXTX_REGS_RXTX_REG69__ADDR               0x48a
#define KC_SERDES_RXTX_REGS_RXTX_REG70__ADDR               0x48c
#define KC_SERDES_RXTX_REGS_RXTX_REG71__ADDR               0x48e
#define KC_SERDES_RXTX_REGS_RXTX_REG72__ADDR               0x490
#define KC_SERDES_RXTX_REGS_RXTX_REG73__ADDR               0x492
#define KC_SERDES_RXTX_REGS_RXTX_REG74__ADDR               0x494
#define KC_SERDES_RXTX_REGS_RXTX_REG75__ADDR               0x496
#define KC_SERDES_RXTX_REGS_RXTX_REG76__ADDR               0x498
#define KC_SERDES_RXTX_REGS_RXTX_REG77__ADDR               0x49a
#define KC_SERDES_RXTX_REGS_RXTX_REG78__ADDR               0x49c
#define KC_SERDES_RXTX_REGS_RXTX_REG79__ADDR               0x49e
#define KC_SERDES_RXTX_REGS_RXTX_REG80__ADDR               0x4a0
#define KC_SERDES_RXTX_REGS_RXTX_REG81__ADDR               0x4a2
#define KC_SERDES_RXTX_REGS_RXTX_REG82__ADDR               0x4a4
#define KC_SERDES_RXTX_REGS_RXTX_REG83__ADDR               0x4a6
#define KC_SERDES_RXTX_REGS_RXTX_REG84__ADDR               0x4a8
#define KC_SERDES_RXTX_REGS_RXTX_REG85__ADDR               0x4aa
#define KC_SERDES_RXTX_REGS_RXTX_REG86__ADDR               0x4ac
#define KC_SERDES_RXTX_REGS_RXTX_REG87__ADDR               0x4ae
#define KC_SERDES_RXTX_REGS_RXTX_REG88__ADDR               0x4b0
#define KC_SERDES_RXTX_REGS_RXTX_REG89__ADDR               0x4b2
#define KC_SERDES_RXTX_REGS_RXTX_REG90__ADDR               0x4b4
#define KC_SERDES_RXTX_REGS_RXTX_REG91__ADDR               0x4b6
#define KC_SERDES_RXTX_REGS_RXTX_REG92__ADDR               0x4b8
#define KC_SERDES_RXTX_REGS_RXTX_REG93__ADDR               0x4ba
#define KC_SERDES_RXTX_REGS_RXTX_REG94__ADDR               0x4bc
#define KC_SERDES_RXTX_REGS_RXTX_REG95__ADDR               0x4be
#define KC_SERDES_RXTX_REGS_RXTX_REG96__ADDR               0x4c0
#define KC_SERDES_RXTX_REGS_RXTX_REG97__ADDR               0x4c2
#define KC_SERDES_RXTX_REGS_RXTX_REG98__ADDR               0x4c4
#define KC_SERDES_RXTX_REGS_RXTX_REG99__ADDR               0x4c6
#define KC_SERDES_RXTX_REGS_RXTX_REG100__ADDR              0x4c8
#define KC_SERDES_RXTX_REGS_RXTX_REG101__ADDR              0x4ca
#define KC_SERDES_RXTX_REGS_RXTX_REG102__ADDR              0x4cc
#define KC_SERDES_RXTX_REGS_RXTX_REG103__ADDR              0x4ce
#define KC_SERDES_RXTX_REGS_RXTX_REG104__ADDR              0x4d0
#define KC_SERDES_RXTX_REGS_RXTX_REG105__ADDR              0x4d2
#define KC_SERDES_RXTX_REGS_RXTX_REG106__ADDR              0x4d4
#define KC_SERDES_RXTX_REGS_RXTX_REG107__ADDR              0x4d6
#define KC_SERDES_RXTX_REGS_RXTX_REG108__ADDR              0x4d8
#define KC_SERDES_RXTX_REGS_RXTX_REG109__ADDR              0x4da
#define KC_SERDES_RXTX_REGS_RXTX_REG110__ADDR              0x4dc
#define KC_SERDES_RXTX_REGS_RXTX_REG111__ADDR              0x4de
#define KC_SERDES_RXTX_REGS_RXTX_REG112__ADDR              0x4e0
#define KC_SERDES_RXTX_REGS_RXTX_REG113__ADDR              0x4e2
#define KC_SERDES_RXTX_REGS_RXTX_REG114__ADDR              0x4e4
#define KC_SERDES_RXTX_REGS_RXTX_REG115__ADDR              0x4e6
#define KC_SERDES_RXTX_REGS_RXTX_REG116__ADDR              0x4e8
#define KC_SERDES_RXTX_REGS_RXTX_REG117__ADDR              0x4ea
#define KC_SERDES_RXTX_REGS_RXTX_REG118__ADDR              0x4ec
#define KC_SERDES_RXTX_REGS_RXTX_REG119__ADDR              0x4ee
#define KC_SERDES_RXTX_REGS_RXTX_REG120__ADDR              0x4f0
#define KC_SERDES_RXTX_REGS_RXTX_REG121__ADDR              0x4f2
#define KC_SERDES_RXTX_REGS_RXTX_REG122__ADDR              0x4f4
#define KC_SERDES_RXTX_REGS_RXTX_REG123__ADDR              0x4f6
#define KC_SERDES_RXTX_REGS_RXTX_REG124__ADDR              0x4f8
#define KC_SERDES_RXTX_REGS_RXTX_REG125__ADDR              0x4fa
#define KC_SERDES_RXTX_REGS_RXTX_REG126__ADDR              0x4fc
#define KC_SERDES_RXTX_REGS_RXTX_REG127__ADDR              0x4fe
#define KC_SERDES_RXTX_REGS_RXTX_REG128__ADDR              0x500
#define KC_SERDES_RXTX_REGS_RXTX_REG129__ADDR              0x502
#define KC_SERDES_RXTX_REGS_RXTX_REG130__ADDR              0x504
#define KC_SERDES_RXTX_REGS_RXTX_REG131__ADDR              0x506
#define KC_SERDES_RXTX_REGS_RXTX_REG132__ADDR              0x508
#define KC_SERDES_RXTX_REGS_RXTX_REG133__ADDR              0x50a
#define KC_SERDES_RXTX_REGS_RXTX_REG134__ADDR              0x50c
#define KC_SERDES_RXTX_REGS_RXTX_REG135__ADDR              0x50e
#define KC_SERDES_RXTX_REGS_RXTX_REG136__ADDR              0x510
#define KC_SERDES_RXTX_REGS_RXTX_REG137__ADDR              0x512
#define KC_SERDES_RXTX_REGS_RXTX_REG138__ADDR              0x514
#define KC_SERDES_RXTX_REGS_RXTX_REG139__ADDR              0x516
#define KC_SERDES_RXTX_REGS_RXTX_REG140__ADDR              0x518
#define KC_SERDES_RXTX_REGS_RXTX_REG141__ADDR              0x51a
#define KC_SERDES_RXTX_REGS_RXTX_REG142__ADDR              0x51c
#define KC_SERDES_RXTX_REGS_RXTX_REG143__ADDR              0x51e
#define KC_SERDES_RXTX_REGS_RXTX_REG144__ADDR              0x520
#define KC_SERDES_RXTX_REGS_RXTX_REG145__ADDR              0x522
#define KC_SERDES_RXTX_REGS_RXTX_REG146__ADDR              0x524
#define KC_SERDES_RXTX_REGS_RXTX_REG147__ADDR              0x526
#define KC_SERDES_RXTX_REGS_RXTX_REG148__ADDR              0x528
#define KC_SERDES_RXTX_REGS_RXTX_REG149__ADDR              0x52a
#define KC_SERDES_RXTX_REGS_RXTX_REG150__ADDR              0x52c
#define KC_SERDES_RXTX_REGS_RXTX_REG151__ADDR              0x52e
#define KC_SERDES_RXTX_REGS_RXTX_REG152__ADDR              0x530
#define KC_SERDES_RXTX_REGS_RXTX_REG153__ADDR              0x532
#define KC_SERDES_RXTX_REGS_RXTX_REG154__ADDR              0x534
#define KC_SERDES_RXTX_REGS_RXTX_REG155__ADDR              0x536
#define KC_SERDES_RXTX_REGS_RXTX_REG156__ADDR              0x538
#define KC_SERDES_RXTX_REGS_RXTX_REG157__ADDR              0x53a
#define KC_SERDES_RXTX_REGS_RXTX_REG158__ADDR              0x53c
#define KC_SERDES_RXTX_REGS_RXTX_REG159__ADDR              0x53e
#define KC_SERDES_RXTX_REGS_RXTX_REG160__ADDR              0x540
#define KC_SERDES_RXTX_REGS_RXTX_REG161__ADDR              0x542
#define KC_SERDES_RXTX_REGS_RXTX_REG162__ADDR              0x544

/*****rxtx_reg14 START *****/
#define FIELD_RXTX_REG14_TX_ATO_LSB		12
#define FIELD_RXTX_REG14_TX_ATO_MSB		15
#define FIELD_RXTX_REG14_TX_ATO_WIDTH		4
#define FIELD_RXTX_REG14_TX_ATO_MASK		0x0000f000
#define FIELD_RXTX_REG14_TX_ATO_SHIFT_MASK		0xc
#define FIELD_RXTX_REG14_TX_ATO_RD(src)	((FIELD_RXTX_REG14_TX_ATO_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG14_TX_ATO_SHIFT_MASK)
#define FIELD_RXTX_REG14_TX_ATO_WR(dst)	(FIELD_RXTX_REG14_TX_ATO_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG14_TX_ATO_SHIFT_MASK))
#define FIELD_RXTX_REG14_TX_ATO_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG14_TX_ATO_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG14_TX_ATO_SHIFT_MASK) & FIELD_RXTX_REG14_TX_ATO_MASK))

#define FIELD_RXTX_REG14_RX_ATO_LSB		7
#define FIELD_RXTX_REG14_RX_ATO_MSB		11
#define FIELD_RXTX_REG14_RX_ATO_WIDTH		5
#define FIELD_RXTX_REG14_RX_ATO_MASK		0x00000f80
#define FIELD_RXTX_REG14_RX_ATO_SHIFT_MASK		0x7
#define FIELD_RXTX_REG14_RX_ATO_RD(src)	((FIELD_RXTX_REG14_RX_ATO_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG14_RX_ATO_SHIFT_MASK)
#define FIELD_RXTX_REG14_RX_ATO_WR(dst)	(FIELD_RXTX_REG14_RX_ATO_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG14_RX_ATO_SHIFT_MASK))
#define FIELD_RXTX_REG14_RX_ATO_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG14_RX_ATO_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG14_RX_ATO_SHIFT_MASK) & FIELD_RXTX_REG14_RX_ATO_MASK))

#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_LSB		6
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_MSB		6
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_WIDTH		1
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_MASK		0x00000040
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_SHIFT_MASK		0x6
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_RD(src)	((FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_SHIFT_MASK)
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_WR(dst)	(FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_SHIFT_MASK))
#define FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_SHIFT_MASK) & FIELD_RXTX_REG14_CTLE_LATCAL_MAN_ENA_MASK))

#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_LSB		0
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_MSB		5
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_WIDTH		6
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_MASK		0x0000003f
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_SHIFT_MASK		0x0
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_RD(src)	((FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_WR(dst)	(FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_SHIFT_MASK))
#define FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_SHIFT_MASK) & FIELD_RXTX_REG14_CLTE_LATCAL_MAN_PROG_MASK))

#define RESERVE_BITS_RXTX_REG14 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG14 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG14 0x00000000
#define READ_ONLY_BITS_RXTX_REG14 0x00000000
/****** rxtx_reg14 END *****/

/*****rxtx_reg21 START *****/
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_LSB		10
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_MSB		15
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_MASK		0x0000fc00
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_SHIFT_MASK		0xa
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG21_DO_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG21_DO_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG21_DO_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG21_DO_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG21_DO_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG21_DO_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG21_DO_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG21_DO_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_LSB		4
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_MSB		9
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_MASK		0x000003f0
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_SHIFT_MASK		0x4
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG21_XO_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG21_XO_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG21_XO_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG21_XO_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG21_XO_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG21_XO_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG21_XO_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG21_XO_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_LSB		0
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_MSB		3
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_WIDTH		4
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_MASK		0x0000000f
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_SHIFT_MASK		0x0
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_RD(src)	((FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_WR(dst)	(FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_SHIFT_MASK))
#define FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_SHIFT_MASK) & FIELD_RXTX_REG21_LATCH_CAL_FAIL_ODD_MASK))

#define RESERVE_BITS_RXTX_REG21 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG21 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG21 0x00000000
#define READ_ONLY_BITS_RXTX_REG21 0x0000ffff
/****** rxtx_reg21 END *****/

/*****rxtx_reg22 START *****/
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_LSB		10
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_MSB		15
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_MASK		0x0000fc00
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_SHIFT_MASK		0xa
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG22_EO_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG22_EO_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG22_EO_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG22_EO_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG22_EO_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG22_EO_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG22_EO_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG22_EO_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_LSB		4
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_MSB		9
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_MASK		0x000003f0
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_SHIFT_MASK		0x4
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG22_SO_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG22_SO_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG22_SO_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG22_SO_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG22_SO_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG22_SO_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG22_SO_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG22_SO_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_LSB		0
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_MSB		3
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_WIDTH		4
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_MASK		0x0000000f
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_SHIFT_MASK		0x0
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_RD(src)	((FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_WR(dst)	(FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_SHIFT_MASK))
#define FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_SHIFT_MASK) & FIELD_RXTX_REG22_LATCH_CAL_FAIL_EVEN_MASK))

#define RESERVE_BITS_RXTX_REG22 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG22 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG22 0x00000000
#define READ_ONLY_BITS_RXTX_REG22 0x0000ffff
/****** rxtx_reg22 END *****/

/*****rxtx_reg23 START *****/
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_LSB		10
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_MSB		15
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_MASK		0x0000fc00
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_SHIFT_MASK		0xa
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG23_DE_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG23_DE_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG23_DE_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG23_DE_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG23_DE_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG23_DE_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG23_DE_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG23_DE_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_LSB		4
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_MSB		9
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_MASK		0x000003f0
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_SHIFT_MASK		0x4
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG23_XE_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG23_XE_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG23_XE_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG23_XE_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG23_XE_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG23_XE_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG23_XE_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG23_XE_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG23_RESERVED_3_LSB		0
#define FIELD_RXTX_REG23_RESERVED_3_MSB		3
#define FIELD_RXTX_REG23_RESERVED_3_WIDTH		4
#define FIELD_RXTX_REG23_RESERVED_3_MASK		0x0000000f
#define FIELD_RXTX_REG23_RESERVED_3_SHIFT_MASK		0x0
#define FIELD_RXTX_REG23_RESERVED_3_RD(src)	((FIELD_RXTX_REG23_RESERVED_3_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG23_RESERVED_3_WR(dst)	(FIELD_RXTX_REG23_RESERVED_3_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG23_RESERVED_3_SHIFT_MASK))
#define FIELD_RXTX_REG23_RESERVED_3_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG23_RESERVED_3_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG23_RESERVED_3_SHIFT_MASK) & FIELD_RXTX_REG23_RESERVED_3_MASK))

#define RESERVE_BITS_RXTX_REG23 0x0000000f
#define SELF_CLEAR_BITS_RXTX_REG23 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG23 0x00000000
#define READ_ONLY_BITS_RXTX_REG23 0x0000ffff
/****** rxtx_reg23 END *****/

/*****rxtx_reg24 START *****/
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_LSB		10
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_MSB		15
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_MASK		0x0000fc00
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_SHIFT_MASK		0xa
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG24_EE_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG24_EE_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG24_EE_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG24_EE_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG24_EE_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG24_EE_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG24_EE_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG24_EE_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_LSB		4
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_MSB		9
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_WIDTH		6
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_MASK		0x000003f0
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_SHIFT_MASK		0x4
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_RD(src)	((FIELD_RXTX_REG24_SE_LATCH_CALOUT_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG24_SE_LATCH_CALOUT_SHIFT_MASK)
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_WR(dst)	(FIELD_RXTX_REG24_SE_LATCH_CALOUT_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG24_SE_LATCH_CALOUT_SHIFT_MASK))
#define FIELD_RXTX_REG24_SE_LATCH_CALOUT_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG24_SE_LATCH_CALOUT_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG24_SE_LATCH_CALOUT_SHIFT_MASK) & FIELD_RXTX_REG24_SE_LATCH_CALOUT_MASK))

#define FIELD_RXTX_REG24_TX_BC_CP1_UP_LSB		3
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_MSB		3
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_WIDTH		1
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_MASK		0x00000008
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_SHIFT_MASK		0x3
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_RD(src)	((FIELD_RXTX_REG24_TX_BC_CP1_UP_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG24_TX_BC_CP1_UP_SHIFT_MASK)
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_WR(dst)	(FIELD_RXTX_REG24_TX_BC_CP1_UP_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG24_TX_BC_CP1_UP_SHIFT_MASK))
#define FIELD_RXTX_REG24_TX_BC_CP1_UP_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG24_TX_BC_CP1_UP_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG24_TX_BC_CP1_UP_SHIFT_MASK) & FIELD_RXTX_REG24_TX_BC_CP1_UP_MASK))

#define FIELD_RXTX_REG24_TX_BC_CN1_UP_LSB		2
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_MSB		2
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_WIDTH		1
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_MASK		0x00000004
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_SHIFT_MASK		0x2
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_RD(src)	((FIELD_RXTX_REG24_TX_BC_CN1_UP_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG24_TX_BC_CN1_UP_SHIFT_MASK)
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_WR(dst)	(FIELD_RXTX_REG24_TX_BC_CN1_UP_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG24_TX_BC_CN1_UP_SHIFT_MASK))
#define FIELD_RXTX_REG24_TX_BC_CN1_UP_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG24_TX_BC_CN1_UP_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG24_TX_BC_CN1_UP_SHIFT_MASK) & FIELD_RXTX_REG24_TX_BC_CN1_UP_MASK))

#define FIELD_RXTX_REG24_TX_BC_CP1_DN_LSB		1
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_MSB		1
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_WIDTH		1
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_MASK		0x00000002
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_SHIFT_MASK		0x1
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_RD(src)	((FIELD_RXTX_REG24_TX_BC_CP1_DN_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG24_TX_BC_CP1_DN_SHIFT_MASK)
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_WR(dst)	(FIELD_RXTX_REG24_TX_BC_CP1_DN_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG24_TX_BC_CP1_DN_SHIFT_MASK))
#define FIELD_RXTX_REG24_TX_BC_CP1_DN_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG24_TX_BC_CP1_DN_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG24_TX_BC_CP1_DN_SHIFT_MASK) & FIELD_RXTX_REG24_TX_BC_CP1_DN_MASK))

#define FIELD_RXTX_REG24_TX_BC_CN1_DN_LSB		0
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_MSB		0
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_WIDTH		1
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_MASK		0x00000001
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_SHIFT_MASK		0x0
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_RD(src)	((FIELD_RXTX_REG24_TX_BC_CN1_DN_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_WR(dst)	(FIELD_RXTX_REG24_TX_BC_CN1_DN_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG24_TX_BC_CN1_DN_SHIFT_MASK))
#define FIELD_RXTX_REG24_TX_BC_CN1_DN_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG24_TX_BC_CN1_DN_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG24_TX_BC_CN1_DN_SHIFT_MASK) & FIELD_RXTX_REG24_TX_BC_CN1_DN_MASK))

#define RESERVE_BITS_RXTX_REG24 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG24 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG24 0x00000000
#define READ_ONLY_BITS_RXTX_REG24 0x0000ffff
/****** rxtx_reg24 END *****/

/*****rxtx_reg121 START *****/
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_LSB		6
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_MSB		15
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_WIDTH		10
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_MASK		0x0000ffc0
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_SHIFT_MASK		0x6
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_RD(src)	((FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_SHIFT_MASK)
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_WR(dst)	(FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_SHIFT_MASK))
#define FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_SHIFT_MASK) & FIELD_RXTX_REG121_CDR_ACCUM_RD_MSB_MASK))

#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_LSB		1
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_MSB		5
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_WIDTH		5
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_MASK		0x0000003e
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_SHIFT_MASK		0x1
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_RD(src)	((FIELD_RXTX_REG121_SUMOS_CAL_CODE_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG121_SUMOS_CAL_CODE_SHIFT_MASK)
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_WR(dst)	(FIELD_RXTX_REG121_SUMOS_CAL_CODE_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG121_SUMOS_CAL_CODE_SHIFT_MASK))
#define FIELD_RXTX_REG121_SUMOS_CAL_CODE_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG121_SUMOS_CAL_CODE_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG121_SUMOS_CAL_CODE_SHIFT_MASK) & FIELD_RXTX_REG121_SUMOS_CAL_CODE_MASK))

#define FIELD_RXTX_REG121_RESERVED_0_LSB		0
#define FIELD_RXTX_REG121_RESERVED_0_MSB		0
#define FIELD_RXTX_REG121_RESERVED_0_WIDTH		1
#define FIELD_RXTX_REG121_RESERVED_0_MASK		0x00000001
#define FIELD_RXTX_REG121_RESERVED_0_SHIFT_MASK		0x0
#define FIELD_RXTX_REG121_RESERVED_0_RD(src)	((FIELD_RXTX_REG121_RESERVED_0_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG121_RESERVED_0_WR(dst)	(FIELD_RXTX_REG121_RESERVED_0_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG121_RESERVED_0_SHIFT_MASK))
#define FIELD_RXTX_REG121_RESERVED_0_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG121_RESERVED_0_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG121_RESERVED_0_SHIFT_MASK) & FIELD_RXTX_REG121_RESERVED_0_MASK))

#define RESERVE_BITS_RXTX_REG121 0x00000001
#define SELF_CLEAR_BITS_RXTX_REG121 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG121 0x00000000
#define READ_ONLY_BITS_RXTX_REG121 0x0000ffff
/****** rxtx_reg121 END *****/

/*****rxtx_reg122 START *****/
#define FIELD_RXTX_REG122_RESERVED_15_LSB		0
#define FIELD_RXTX_REG122_RESERVED_15_MSB		15
#define FIELD_RXTX_REG122_RESERVED_15_WIDTH		16
#define FIELD_RXTX_REG122_RESERVED_15_MASK		0x0000ffff
#define FIELD_RXTX_REG122_RESERVED_15_SHIFT_MASK		0x0
#define FIELD_RXTX_REG122_RESERVED_15_RD(src)	((FIELD_RXTX_REG122_RESERVED_15_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG122_RESERVED_15_WR(dst)	(FIELD_RXTX_REG122_RESERVED_15_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG122_RESERVED_15_SHIFT_MASK))
#define FIELD_RXTX_REG122_RESERVED_15_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG122_RESERVED_15_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG122_RESERVED_15_SHIFT_MASK) & FIELD_RXTX_REG122_RESERVED_15_MASK))

#define RESERVE_BITS_RXTX_REG122 0x0000ffff
#define SELF_CLEAR_BITS_RXTX_REG122 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG122 0x00000000
#define READ_ONLY_BITS_RXTX_REG122 0x00000000
/****** rxtx_reg122 END *****/

/*****rxtx_reg123 START *****/
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_LSB		0
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_MSB		15
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_WIDTH		16
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_MASK		0x0000ffff
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_SHIFT_MASK		0x0
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_RD(src)	((FIELD_RXTX_REG123_EYE_ACCUMULATOR1_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_WR(dst)	(FIELD_RXTX_REG123_EYE_ACCUMULATOR1_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG123_EYE_ACCUMULATOR1_SHIFT_MASK))
#define FIELD_RXTX_REG123_EYE_ACCUMULATOR1_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG123_EYE_ACCUMULATOR1_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG123_EYE_ACCUMULATOR1_SHIFT_MASK) & FIELD_RXTX_REG123_EYE_ACCUMULATOR1_MASK))

#define RESERVE_BITS_RXTX_REG123 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG123 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG123 0x00000000
#define READ_ONLY_BITS_RXTX_REG123 0x0000ffff
/****** rxtx_reg123 END *****/

/*****rxtx_reg124 START *****/
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_LSB		0
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_MSB		15
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_WIDTH		16
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_MASK		0x0000ffff
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_SHIFT_MASK		0x0
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_RD(src)	((FIELD_RXTX_REG124_EYE_ACCUMULATOR0_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_WR(dst)	(FIELD_RXTX_REG124_EYE_ACCUMULATOR0_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG124_EYE_ACCUMULATOR0_SHIFT_MASK))
#define FIELD_RXTX_REG124_EYE_ACCUMULATOR0_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG124_EYE_ACCUMULATOR0_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG124_EYE_ACCUMULATOR0_SHIFT_MASK) & FIELD_RXTX_REG124_EYE_ACCUMULATOR0_MASK))

#define RESERVE_BITS_RXTX_REG124 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG124 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG124 0x00000000
#define READ_ONLY_BITS_RXTX_REG124 0x0000ffff
/****** rxtx_reg124 END *****/

/*****rxtx_reg125 START *****/
#define FIELD_RXTX_REG125_PQ_REG_LSB		9
#define FIELD_RXTX_REG125_PQ_REG_MSB		15
#define FIELD_RXTX_REG125_PQ_REG_WIDTH		7
#define FIELD_RXTX_REG125_PQ_REG_MASK		0x0000fe00
#define FIELD_RXTX_REG125_PQ_REG_SHIFT_MASK		0x9
#define FIELD_RXTX_REG125_PQ_REG_RD(src)	((FIELD_RXTX_REG125_PQ_REG_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG125_PQ_REG_SHIFT_MASK)
#define FIELD_RXTX_REG125_PQ_REG_WR(dst)	(FIELD_RXTX_REG125_PQ_REG_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG125_PQ_REG_SHIFT_MASK))
#define FIELD_RXTX_REG125_PQ_REG_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG125_PQ_REG_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG125_PQ_REG_SHIFT_MASK) & FIELD_RXTX_REG125_PQ_REG_MASK))

#define FIELD_RXTX_REG125_SIGN_PQ_LSB		8
#define FIELD_RXTX_REG125_SIGN_PQ_MSB		8
#define FIELD_RXTX_REG125_SIGN_PQ_WIDTH		1
#define FIELD_RXTX_REG125_SIGN_PQ_MASK		0x00000100
#define FIELD_RXTX_REG125_SIGN_PQ_SHIFT_MASK		0x8
#define FIELD_RXTX_REG125_SIGN_PQ_RD(src)	((FIELD_RXTX_REG125_SIGN_PQ_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG125_SIGN_PQ_SHIFT_MASK)
#define FIELD_RXTX_REG125_SIGN_PQ_WR(dst)	(FIELD_RXTX_REG125_SIGN_PQ_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG125_SIGN_PQ_SHIFT_MASK))
#define FIELD_RXTX_REG125_SIGN_PQ_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG125_SIGN_PQ_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG125_SIGN_PQ_SHIFT_MASK) & FIELD_RXTX_REG125_SIGN_PQ_MASK))

#define FIELD_RXTX_REG125_SIGN_PQ_2C_LSB		7
#define FIELD_RXTX_REG125_SIGN_PQ_2C_MSB		7
#define FIELD_RXTX_REG125_SIGN_PQ_2C_WIDTH		1
#define FIELD_RXTX_REG125_SIGN_PQ_2C_MASK		0x00000080
#define FIELD_RXTX_REG125_SIGN_PQ_2C_SHIFT_MASK		0x7
#define FIELD_RXTX_REG125_SIGN_PQ_2C_RD(src)	((FIELD_RXTX_REG125_SIGN_PQ_2C_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG125_SIGN_PQ_2C_SHIFT_MASK)
#define FIELD_RXTX_REG125_SIGN_PQ_2C_WR(dst)	(FIELD_RXTX_REG125_SIGN_PQ_2C_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG125_SIGN_PQ_2C_SHIFT_MASK))
#define FIELD_RXTX_REG125_SIGN_PQ_2C_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG125_SIGN_PQ_2C_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG125_SIGN_PQ_2C_SHIFT_MASK) & FIELD_RXTX_REG125_SIGN_PQ_2C_MASK))

#define FIELD_RXTX_REG125_PHZ_MANUALCODE_LSB		2
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_MSB		6
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_WIDTH		5
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_MASK		0x0000007c
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_SHIFT_MASK		0x2
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_RD(src)	((FIELD_RXTX_REG125_PHZ_MANUALCODE_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG125_PHZ_MANUALCODE_SHIFT_MASK)
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_WR(dst)	(FIELD_RXTX_REG125_PHZ_MANUALCODE_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG125_PHZ_MANUALCODE_SHIFT_MASK))
#define FIELD_RXTX_REG125_PHZ_MANUALCODE_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG125_PHZ_MANUALCODE_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG125_PHZ_MANUALCODE_SHIFT_MASK) & FIELD_RXTX_REG125_PHZ_MANUALCODE_MASK))

#define FIELD_RXTX_REG125_PHZ_MANUAL_LSB		1
#define FIELD_RXTX_REG125_PHZ_MANUAL_MSB		1
#define FIELD_RXTX_REG125_PHZ_MANUAL_WIDTH		1
#define FIELD_RXTX_REG125_PHZ_MANUAL_MASK		0x00000002
#define FIELD_RXTX_REG125_PHZ_MANUAL_SHIFT_MASK		0x1
#define FIELD_RXTX_REG125_PHZ_MANUAL_RD(src)	((FIELD_RXTX_REG125_PHZ_MANUAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG125_PHZ_MANUAL_SHIFT_MASK)
#define FIELD_RXTX_REG125_PHZ_MANUAL_WR(dst)	(FIELD_RXTX_REG125_PHZ_MANUAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG125_PHZ_MANUAL_SHIFT_MASK))
#define FIELD_RXTX_REG125_PHZ_MANUAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG125_PHZ_MANUAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG125_PHZ_MANUAL_SHIFT_MASK) & FIELD_RXTX_REG125_PHZ_MANUAL_MASK))

#define FIELD_RXTX_REG125_RESERVED_0_LSB		0
#define FIELD_RXTX_REG125_RESERVED_0_MSB		0
#define FIELD_RXTX_REG125_RESERVED_0_WIDTH		1
#define FIELD_RXTX_REG125_RESERVED_0_MASK		0x00000001
#define FIELD_RXTX_REG125_RESERVED_0_SHIFT_MASK		0x0
#define FIELD_RXTX_REG125_RESERVED_0_RD(src)	((FIELD_RXTX_REG125_RESERVED_0_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG125_RESERVED_0_WR(dst)	(FIELD_RXTX_REG125_RESERVED_0_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG125_RESERVED_0_SHIFT_MASK))
#define FIELD_RXTX_REG125_RESERVED_0_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG125_RESERVED_0_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG125_RESERVED_0_SHIFT_MASK) & FIELD_RXTX_REG125_RESERVED_0_MASK))

#define RESERVE_BITS_RXTX_REG125 0x00000001
#define SELF_CLEAR_BITS_RXTX_REG125 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG125 0x00000000
#define READ_ONLY_BITS_RXTX_REG125 0x00000000
/****** rxtx_reg125 END *****/

/*****rxtx_reg126 START *****/
#define FIELD_RXTX_REG126_QI_REG_LSB		9
#define FIELD_RXTX_REG126_QI_REG_MSB		15
#define FIELD_RXTX_REG126_QI_REG_WIDTH		7
#define FIELD_RXTX_REG126_QI_REG_MASK		0x0000fe00
#define FIELD_RXTX_REG126_QI_REG_SHIFT_MASK		0x9
#define FIELD_RXTX_REG126_QI_REG_RD(src)	((FIELD_RXTX_REG126_QI_REG_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG126_QI_REG_SHIFT_MASK)
#define FIELD_RXTX_REG126_QI_REG_WR(dst)	(FIELD_RXTX_REG126_QI_REG_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG126_QI_REG_SHIFT_MASK))
#define FIELD_RXTX_REG126_QI_REG_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG126_QI_REG_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG126_QI_REG_SHIFT_MASK) & FIELD_RXTX_REG126_QI_REG_MASK))

#define FIELD_RXTX_REG126_RESERVED_8_LSB		2
#define FIELD_RXTX_REG126_RESERVED_8_MSB		8
#define FIELD_RXTX_REG126_RESERVED_8_WIDTH		7
#define FIELD_RXTX_REG126_RESERVED_8_MASK		0x000001fc
#define FIELD_RXTX_REG126_RESERVED_8_SHIFT_MASK		0x2
#define FIELD_RXTX_REG126_RESERVED_8_RD(src)	((FIELD_RXTX_REG126_RESERVED_8_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG126_RESERVED_8_SHIFT_MASK)
#define FIELD_RXTX_REG126_RESERVED_8_WR(dst)	(FIELD_RXTX_REG126_RESERVED_8_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG126_RESERVED_8_SHIFT_MASK))
#define FIELD_RXTX_REG126_RESERVED_8_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG126_RESERVED_8_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG126_RESERVED_8_SHIFT_MASK) & FIELD_RXTX_REG126_RESERVED_8_MASK))

#define FIELD_RXTX_REG126_SIGN_QI_REG_LSB		1
#define FIELD_RXTX_REG126_SIGN_QI_REG_MSB		1
#define FIELD_RXTX_REG126_SIGN_QI_REG_WIDTH		1
#define FIELD_RXTX_REG126_SIGN_QI_REG_MASK		0x00000002
#define FIELD_RXTX_REG126_SIGN_QI_REG_SHIFT_MASK		0x1
#define FIELD_RXTX_REG126_SIGN_QI_REG_RD(src)	((FIELD_RXTX_REG126_SIGN_QI_REG_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG126_SIGN_QI_REG_SHIFT_MASK)
#define FIELD_RXTX_REG126_SIGN_QI_REG_WR(dst)	(FIELD_RXTX_REG126_SIGN_QI_REG_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG126_SIGN_QI_REG_SHIFT_MASK))
#define FIELD_RXTX_REG126_SIGN_QI_REG_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG126_SIGN_QI_REG_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG126_SIGN_QI_REG_SHIFT_MASK) & FIELD_RXTX_REG126_SIGN_QI_REG_MASK))

#define FIELD_RXTX_REG126_RESERVED_0_LSB		0
#define FIELD_RXTX_REG126_RESERVED_0_MSB		0
#define FIELD_RXTX_REG126_RESERVED_0_WIDTH		1
#define FIELD_RXTX_REG126_RESERVED_0_MASK		0x00000001
#define FIELD_RXTX_REG126_RESERVED_0_SHIFT_MASK		0x0
#define FIELD_RXTX_REG126_RESERVED_0_RD(src)	((FIELD_RXTX_REG126_RESERVED_0_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG126_RESERVED_0_WR(dst)	(FIELD_RXTX_REG126_RESERVED_0_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG126_RESERVED_0_SHIFT_MASK))
#define FIELD_RXTX_REG126_RESERVED_0_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG126_RESERVED_0_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG126_RESERVED_0_SHIFT_MASK) & FIELD_RXTX_REG126_RESERVED_0_MASK))

#define RESERVE_BITS_RXTX_REG126 0x000001fd
#define SELF_CLEAR_BITS_RXTX_REG126 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG126 0x00000000
#define READ_ONLY_BITS_RXTX_REG126 0x00000000
/****** rxtx_reg126 END *****/

/*****rxtx_reg127 START *****/
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_LSB		10
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_MSB		15
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_MASK		0x0000fc00
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_SHIFT_MASK		0xa
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG127_DO_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG127_DO_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG127_DO_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG127_DO_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG127_DO_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG127_DO_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG127_DO_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG127_DO_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_LSB		4
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_MSB		9
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_MASK		0x000003f0
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_SHIFT_MASK		0x4
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG127_XO_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG127_XO_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG127_XO_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG127_XO_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG127_XO_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG127_XO_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG127_XO_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG127_XO_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_LSB		3
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_MSB		3
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_WIDTH		1
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_MASK		0x00000008
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_SHIFT_MASK		0x3
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_RD(src)	((FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_SHIFT_MASK)
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_WR(dst)	(FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_SHIFT_MASK))
#define FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_SHIFT_MASK) & FIELD_RXTX_REG127_LATCH_MAN_CAL_ENA_MASK))

#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_LSB		2
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_MSB		2
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_WIDTH		1
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_MASK		0x00000004
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_SHIFT_MASK		0x2
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_RD(src)	((FIELD_RXTX_REG127_FORCE_LAT_CAL_START_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG127_FORCE_LAT_CAL_START_SHIFT_MASK)
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_WR(dst)	(FIELD_RXTX_REG127_FORCE_LAT_CAL_START_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG127_FORCE_LAT_CAL_START_SHIFT_MASK))
#define FIELD_RXTX_REG127_FORCE_LAT_CAL_START_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG127_FORCE_LAT_CAL_START_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG127_FORCE_LAT_CAL_START_SHIFT_MASK) & FIELD_RXTX_REG127_FORCE_LAT_CAL_START_MASK))

#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_LSB		1
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_MSB		1
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_WIDTH		1
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_MASK		0x00000002
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_SHIFT_MASK		0x1
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_RD(src)	((FIELD_RXTX_REG127_FORCE_SUM_CAL_START_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG127_FORCE_SUM_CAL_START_SHIFT_MASK)
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_WR(dst)	(FIELD_RXTX_REG127_FORCE_SUM_CAL_START_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG127_FORCE_SUM_CAL_START_SHIFT_MASK))
#define FIELD_RXTX_REG127_FORCE_SUM_CAL_START_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG127_FORCE_SUM_CAL_START_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG127_FORCE_SUM_CAL_START_SHIFT_MASK) & FIELD_RXTX_REG127_FORCE_SUM_CAL_START_MASK))

#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_LSB		0
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_MSB		0
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_WIDTH		1
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_MASK		0x00000001
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_SHIFT_MASK		0x0
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_RD(src)	((FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_WR(dst)	(FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_SHIFT_MASK))
#define FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_SHIFT_MASK) & FIELD_RXTX_REG127_FORCE_CTLE_CAL_START_MASK))

#define RESERVE_BITS_RXTX_REG127 0x00000000
#define SELF_CLEAR_BITS_RXTX_REG127 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG127 0x00000000
#define READ_ONLY_BITS_RXTX_REG127 0x00000000
/****** rxtx_reg127 END *****/

/*****rxtx_reg128 START *****/
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_LSB		10
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_MSB		15
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_MASK		0x0000fc00
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_SHIFT_MASK		0xa
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG128_EO_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG128_EO_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG128_EO_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG128_EO_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG128_EO_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG128_EO_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG128_EO_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG128_EO_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_LSB		4
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_MSB		9
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_MASK		0x000003f0
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_SHIFT_MASK		0x4
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG128_SO_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG128_SO_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG128_SO_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG128_SO_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG128_SO_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG128_SO_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG128_SO_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG128_SO_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_LSB		2
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_MSB		3
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_WIDTH		2
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_MASK		0x0000000c
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_SHIFT_MASK		0x2
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_RD(src)	((FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_SHIFT_MASK)
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_WR(dst)	(FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_SHIFT_MASK))
#define FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_SHIFT_MASK) & FIELD_RXTX_REG128_LATCH_CAL_WAIT_SEL_MASK))

#define FIELD_RXTX_REG128_RESERVED_1_LSB		0
#define FIELD_RXTX_REG128_RESERVED_1_MSB		1
#define FIELD_RXTX_REG128_RESERVED_1_WIDTH		2
#define FIELD_RXTX_REG128_RESERVED_1_MASK		0x00000003
#define FIELD_RXTX_REG128_RESERVED_1_SHIFT_MASK		0x0
#define FIELD_RXTX_REG128_RESERVED_1_RD(src)	((FIELD_RXTX_REG128_RESERVED_1_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG128_RESERVED_1_WR(dst)	(FIELD_RXTX_REG128_RESERVED_1_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG128_RESERVED_1_SHIFT_MASK))
#define FIELD_RXTX_REG128_RESERVED_1_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG128_RESERVED_1_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG128_RESERVED_1_SHIFT_MASK) & FIELD_RXTX_REG128_RESERVED_1_MASK))

#define RESERVE_BITS_RXTX_REG128 0x00000003
#define SELF_CLEAR_BITS_RXTX_REG128 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG128 0x00000000
#define READ_ONLY_BITS_RXTX_REG128 0x00000000
/****** rxtx_reg128 END *****/

/*****rxtx_reg129 START *****/
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_LSB		10
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_MSB		15
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_MASK		0x0000fc00
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_SHIFT_MASK		0xa
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG129_DE_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG129_DE_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG129_DE_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG129_DE_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG129_DE_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG129_DE_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG129_DE_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG129_DE_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_LSB		4
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_MSB		9
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_MASK		0x000003f0
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_SHIFT_MASK		0x4
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG129_XE_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG129_XE_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG129_XE_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG129_XE_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG129_XE_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG129_XE_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG129_XE_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG129_XE_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG129_RESERVED_3_LSB		0
#define FIELD_RXTX_REG129_RESERVED_3_MSB		3
#define FIELD_RXTX_REG129_RESERVED_3_WIDTH		4
#define FIELD_RXTX_REG129_RESERVED_3_MASK		0x0000000f
#define FIELD_RXTX_REG129_RESERVED_3_SHIFT_MASK		0x0
#define FIELD_RXTX_REG129_RESERVED_3_RD(src)	((FIELD_RXTX_REG129_RESERVED_3_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG129_RESERVED_3_WR(dst)	(FIELD_RXTX_REG129_RESERVED_3_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG129_RESERVED_3_SHIFT_MASK))
#define FIELD_RXTX_REG129_RESERVED_3_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG129_RESERVED_3_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG129_RESERVED_3_SHIFT_MASK) & FIELD_RXTX_REG129_RESERVED_3_MASK))

#define RESERVE_BITS_RXTX_REG129 0x0000000f
#define SELF_CLEAR_BITS_RXTX_REG129 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG129 0x00000000
#define READ_ONLY_BITS_RXTX_REG129 0x00000000
/****** rxtx_reg129 END *****/

/*****rxtx_reg130 START *****/
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_LSB		10
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_MSB		15
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_MASK		0x0000fc00
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_SHIFT_MASK		0xa
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG130_EE_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG130_EE_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG130_EE_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG130_EE_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG130_EE_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG130_EE_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG130_EE_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG130_EE_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_LSB		4
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_MSB		9
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_WIDTH		6
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_MASK		0x000003f0
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_SHIFT_MASK		0x4
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_RD(src)	((FIELD_RXTX_REG130_SE_LATCH_MANCAL_MASK & (unsigned int)(src)) >> FIELD_RXTX_REG130_SE_LATCH_MANCAL_SHIFT_MASK)
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_WR(dst)	(FIELD_RXTX_REG130_SE_LATCH_MANCAL_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG130_SE_LATCH_MANCAL_SHIFT_MASK))
#define FIELD_RXTX_REG130_SE_LATCH_MANCAL_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG130_SE_LATCH_MANCAL_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG130_SE_LATCH_MANCAL_SHIFT_MASK) & FIELD_RXTX_REG130_SE_LATCH_MANCAL_MASK))

#define FIELD_RXTX_REG130_RESERVED_3_LSB		0
#define FIELD_RXTX_REG130_RESERVED_3_MSB		3
#define FIELD_RXTX_REG130_RESERVED_3_WIDTH		4
#define FIELD_RXTX_REG130_RESERVED_3_MASK		0x0000000f
#define FIELD_RXTX_REG130_RESERVED_3_SHIFT_MASK		0x0
#define FIELD_RXTX_REG130_RESERVED_3_RD(src)	((FIELD_RXTX_REG130_RESERVED_3_MASK & (unsigned int)(src)))
#define FIELD_RXTX_REG130_RESERVED_3_WR(dst)	(FIELD_RXTX_REG130_RESERVED_3_MASK & ((unsigned int)(dst) << FIELD_RXTX_REG130_RESERVED_3_SHIFT_MASK))
#define FIELD_RXTX_REG130_RESERVED_3_SET(dst, src)	(((dst) & ~FIELD_RXTX_REG130_RESERVED_3_MASK) | (((unsigned int)(src) << FIELD_RXTX_REG130_RESERVED_3_SHIFT_MASK) & FIELD_RXTX_REG130_RESERVED_3_MASK))

#define RESERVE_BITS_RXTX_REG130 0x0000000f
#define SELF_CLEAR_BITS_RXTX_REG130 0x00000000
#define WRITE_ONE_TO_CLEAR_BITS_RXTX_REG130 0x00000000
#define READ_ONLY_BITS_RXTX_REG130 0x00000000
/****** rxtx_reg130 END *****/


#endif
