/**
 * Copyright (c) 2013, AppliedMicro Corp. All rights reserved.
 *
 * This program and the accompanying materials
 * are licensed and made available under the terms and conditions of the BSD License
 * which accompanies this distribution.  The full text of the license may be found at
 * http://opensource.org/licenses/bsd-license.php
 *
 * THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
 * WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
 *
 **/

#ifndef _RB_MCU_KCPHYREG_TASKS_SVH_
#define _RB_MCU_KCPHYREG_TASKS_SVH_

#ifndef PALLADIUM

#include "ddr_mcu.h"
#include "ddr_lib.h"

   /******************************************************************************
    *   KC PHY Tasks copied from KC Release and heavily modifed
    *   /projects/svdc/vrelease/koolchip_phy/KC_T40G_D3_2G_R00_R22/verification/testbench/reg_tasks.vh
    * - comment @(posedge regInfInst.clk);
    * - change top.regInfInst.read --> rd4B_KC_PHY
    * - change top.regInfInst.write --> wr4B_KC_PHY
    *
    * Copied again from: potenza/MAIN/dv/lib/sv/seqs/rb/rb_mcu_kc_PHYReg_tasks.svh#4
    * xlated to C for bringup etc
    *    task read_  ==> unsigned int phy_rf_read_
    *    task write_ ==> void phy_rf_write_
    *
    *****************************************************************************/

/* ifdef _APM_FULL_KC_TASKS

   unsigned int phy_rf_read_cfg_parity_oe(void *p) {
   // cfg_parity_oe [15] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x1;
   }

   void phy_rf_write_cfg_parity_oe(void *p, unsigned int writeData) {
   // cfg_parity_oe [15] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff7fff) | (~0xffff7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_x4_en(void *p) {
   // cfg_x4_en [14] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x1;
   }
*/

void phy_rf_write_cfg_x4_en(void *p, unsigned int writeData)
{
	// cfg_x4_en [14] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffbfff) | (~0xffffbfff & (writeData << 14));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_disable_dll_lock(void *p) {
   // cfg_disable_dll_lock [13] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 13) & 0x1;
   }

   void phy_rf_write_cfg_disable_dll_lock(void *p, unsigned int writeData) {
   // cfg_disable_dll_lock [13] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffdfff) | (~0xffffdfff & (writeData << 13));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_read_w_fixed_delay(void *p) {
   // cfg_read_w_fixed_delay [12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x1;
   }
*/
void phy_rf_write_cfg_read_w_fixed_delay(void *p, unsigned int writeData)
{
	// cfg_read_w_fixed_delay [12] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffefff) | (~0xffffefff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_sel(void *p) {
   // cfg_delay_from_rden_sel [11] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x1;
   }
*/
void phy_rf_write_cfg_delay_from_rden_sel(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_sel [11] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff7ff) | (~0xfffff7ff & (writeData << 11));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_delay_from_rden(void *p)
{
	// cfg_delay_from_rden [10:8] RW 1
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xC0;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 8) & 0x7;
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden(void *p) {
   // cfg_delay_from_rden [10:8] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden [10:8] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xC0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff8ff) | (~0xfffff8ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_mode(void *p) {
   // cfg_rdlvl_mode [7:6] RW 2
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }
*/
void phy_rf_write_cfg_rdlvl_mode(void *p, unsigned int writeData)
{
	// cfg_rdlvl_mode [7:6] RW 2
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff3f) | (~0xffffff3f & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrlvl_mode(void *p) {
   // cfg_wrlvl_mode [5:4] RW 2
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }
*/
void phy_rf_write_cfg_wrlvl_mode(void *p, unsigned int writeData)
{
	// cfg_wrlvl_mode [5:4] RW 2
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffcf) | (~0xffffffcf & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_gate_mode(void *p) {
   // cfg_rdlvl_gate_mode [3:2] RW 2
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }
*/
void phy_rf_write_cfg_rdlvl_gate_mode(void *p, unsigned int writeData)
{
	// cfg_rdlvl_gate_mode [3:2] RW 2
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff3) | (~0xfffffff3 & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_reset_oe(void *p) {
   // cfg_reset_oe [1] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_reset_oe(void *p, unsigned int writeData)
{
	// cfg_reset_oe [1] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cmd_oe(void *p) {
   // cfg_cmd_oe [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_cmd_oe(void *p, unsigned int writeData)
{
	// cfg_cmd_oe [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs7_oe(void *p) {
   // cfg_cs7_oe [31] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 31) & 0x1;
   }
*/
void phy_rf_write_cfg_cs7_oe(void *p, unsigned int writeData)
{
	// cfg_cs7_oe [31] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0x7fffffff) | (~0x7fffffff & (writeData << 31));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs6_oe(void *p) {
   // cfg_cs6_oe [30] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 30) & 0x1;
   }
*/
void phy_rf_write_cfg_cs6_oe(void *p, unsigned int writeData)
{
	// cfg_cs6_oe [30] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xbfffffff) | (~0xbfffffff & (writeData << 30));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs5_oe(void *p) {
   // cfg_cs5_oe [29] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 29) & 0x1;
   }
*/
void phy_rf_write_cfg_cs5_oe(void *p, unsigned int writeData)
{
	// cfg_cs5_oe [29] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xdfffffff) | (~0xdfffffff & (writeData << 29));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs4_oe(void *p) {
   // cfg_cs4_oe [28] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 28) & 0x1;
   }
*/
void phy_rf_write_cfg_cs4_oe(void *p, unsigned int writeData)
{
	// cfg_cs4_oe [28] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xefffffff) | (~0xefffffff & (writeData << 28));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs3_oe(void *p) {
   // cfg_cs3_oe [27] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 27) & 0x1;
   }
*/
void phy_rf_write_cfg_cs3_oe(void *p, unsigned int writeData)
{
	// cfg_cs3_oe [27] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xf7ffffff) | (~0xf7ffffff & (writeData << 27));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs2_oe(void *p) {
   // cfg_cs2_oe [26] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 26) & 0x1;
   }
*/
void phy_rf_write_cfg_cs2_oe(void *p, unsigned int writeData)
{
	// cfg_cs2_oe [26] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfbffffff) | (~0xfbffffff & (writeData << 26));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs1_oe(void *p) {
   // cfg_cs1_oe [25] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 25) & 0x1;
   }
*/
void phy_rf_write_cfg_cs1_oe(void *p, unsigned int writeData)
{
	// cfg_cs1_oe [25] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfdffffff) | (~0xfdffffff & (writeData << 25));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cs0_oe(void *p) {
   // cfg_cs0_oe [24] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0x1;
   }
*/
void phy_rf_write_cfg_cs0_oe(void *p, unsigned int writeData)
{
	// cfg_cs0_oe [24] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfeffffff) | (~0xfeffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck7_oe(void *p) {
   // cfg_ck7_oe [23] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 23) & 0x1;
   }
*/
void phy_rf_write_cfg_ck7_oe(void *p, unsigned int writeData)
{
	// cfg_ck7_oe [23] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff7fffff) | (~0xff7fffff & (writeData << 23));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck6_oe(void *p) {
   // cfg_ck6_oe [22] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 22) & 0x1;
   }
*/
void phy_rf_write_cfg_ck6_oe(void *p, unsigned int writeData)
{
	// cfg_ck6_oe [22] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffbfffff) | (~0xffbfffff & (writeData << 22));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck5_oe(void *p) {
   // cfg_ck5_oe [21] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x1;
   }
*/
void phy_rf_write_cfg_ck5_oe(void *p, unsigned int writeData)
{
	// cfg_ck5_oe [21] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffdfffff) | (~0xffdfffff & (writeData << 21));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck4_oe(void *p) {
   // cfg_ck4_oe [20] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 20) & 0x1;
   }
*/
void phy_rf_write_cfg_ck4_oe(void *p, unsigned int writeData)
{
	// cfg_ck4_oe [20] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffefffff) | (~0xffefffff & (writeData << 20));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck3_oe(void *p) {
   // cfg_ck3_oe [19] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 19) & 0x1;
   }
*/
void phy_rf_write_cfg_ck3_oe(void *p, unsigned int writeData)
{
	// cfg_ck3_oe [19] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfff7ffff) | (~0xfff7ffff & (writeData << 19));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck2_oe(void *p) {
   // cfg_ck2_oe [18] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x1;
   }
*/
void phy_rf_write_cfg_ck2_oe(void *p, unsigned int writeData)
{
	// cfg_ck2_oe [18] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffbffff) | (~0xfffbffff & (writeData << 18));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck1_oe(void *p) {
   // cfg_ck1_oe [17] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 17) & 0x1;
   }
*/
void phy_rf_write_cfg_ck1_oe(void *p, unsigned int writeData)
{
	// cfg_ck1_oe [17] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffdffff) | (~0xfffdffff & (writeData << 17));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ck0_oe(void *p) {
   // cfg_ck0_oe [16] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0x1;
   }
*/
void phy_rf_write_cfg_ck0_oe(void *p, unsigned int writeData)
{
	// cfg_ck0_oe [16] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffeffff) | (~0xfffeffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt7_oe(void *p) {
   // cfg_odt7_oe [15] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x1;
   }
*/
void phy_rf_write_cfg_odt7_oe(void *p, unsigned int writeData)
{
	// cfg_odt7_oe [15] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff7fff) | (~0xffff7fff & (writeData << 15));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt6_oe(void *p) {
   // cfg_odt6_oe [14] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x1;
   }
*/
void phy_rf_write_cfg_odt6_oe(void *p, unsigned int writeData)
{
	// cfg_odt6_oe [14] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffbfff) | (~0xffffbfff & (writeData << 14));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt5_oe(void *p) {
   // cfg_odt5_oe [13] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 13) & 0x1;
   }
*/
void phy_rf_write_cfg_odt5_oe(void *p, unsigned int writeData)
{
	// cfg_odt5_oe [13] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffdfff) | (~0xffffdfff & (writeData << 13));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt4_oe(void *p) {
   // cfg_odt4_oe [12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x1;
   }
*/
void phy_rf_write_cfg_odt4_oe(void *p, unsigned int writeData)
{
	// cfg_odt4_oe [12] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffefff) | (~0xffffefff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt3_oe(void *p) {
   // cfg_odt3_oe [11] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x1;
   }
*/
void phy_rf_write_cfg_odt3_oe(void *p, unsigned int writeData)
{
	// cfg_odt3_oe [11] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff7ff) | (~0xfffff7ff & (writeData << 11));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt2_oe(void *p) {
   // cfg_odt2_oe [10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }
*/
void phy_rf_write_cfg_odt2_oe(void *p, unsigned int writeData)
{
	// cfg_odt2_oe [10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffbff) | (~0xfffffbff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt1_oe(void *p) {
   // cfg_odt1_oe [9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }
*/
void phy_rf_write_cfg_odt1_oe(void *p, unsigned int writeData)
{
	// cfg_odt1_oe [9] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_odt0_oe(void *p) {
   // cfg_odt0_oe [8] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }
*/
void phy_rf_write_cfg_odt0_oe(void *p, unsigned int writeData)
{
	// cfg_odt0_oe [8] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffeff) | (~0xfffffeff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke7_oe(void *p) {
   // cfg_cke7_oe [7] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }
*/
void phy_rf_write_cfg_cke7_oe(void *p, unsigned int writeData)
{
	// cfg_cke7_oe [7] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff7f) | (~0xffffff7f & (writeData << 7));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke6_oe(void *p) {
   // cfg_cke6_oe [6] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }
*/
void phy_rf_write_cfg_cke6_oe(void *p, unsigned int writeData)
{
	// cfg_cke6_oe [6] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke5_oe(void *p) {
   // cfg_cke5_oe [5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }
*/
void phy_rf_write_cfg_cke5_oe(void *p, unsigned int writeData)
{
	// cfg_cke5_oe [5] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke4_oe(void *p) {
   // cfg_cke4_oe [4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }
*/
void phy_rf_write_cfg_cke4_oe(void *p, unsigned int writeData)
{
	// cfg_cke4_oe [4] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke3_oe(void *p) {
   // cfg_cke3_oe [3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_cfg_cke3_oe(void *p, unsigned int writeData)
{
	// cfg_cke3_oe [3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke2_oe(void *p) {
   // cfg_cke2_oe [2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_cke2_oe(void *p, unsigned int writeData)
{
	// cfg_cke2_oe [2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke1_oe(void *p) {
   // cfg_cke1_oe [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_cke1_oe(void *p, unsigned int writeData)
{
	// cfg_cke1_oe [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cke0_oe(void *p) {
   // cfg_cke0_oe [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_cke0_oe(void *p, unsigned int writeData)
{
	// cfg_cke0_oe [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro8_1_en(void *p) {
   // cfg_macro8_1_en [17] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 17) & 0x1;
   }
*/
void phy_rf_write_cfg_macro8_1_en(void *p, unsigned int writeData)
{
	// cfg_macro8_1_en [17] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffdffff) | (~0xfffdffff & (writeData << 17));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro8_0_en(void *p) {
   // cfg_macro8_0_en [16] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0x1;
   }
*/
void phy_rf_write_cfg_macro8_0_en(void *p, unsigned int writeData)
{
	// cfg_macro8_0_en [16] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffeffff) | (~0xfffeffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro7_1_en(void *p) {
   // cfg_macro7_1_en [15] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x1;
   }
*/
void phy_rf_write_cfg_macro7_1_en(void *p, unsigned int writeData)
{
	// cfg_macro7_1_en [15] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff7fff) | (~0xffff7fff & (writeData << 15));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro7_0_en(void *p) {
   // cfg_macro7_0_en [14] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x1;
   }
*/
void phy_rf_write_cfg_macro7_0_en(void *p, unsigned int writeData)
{
	// cfg_macro7_0_en [14] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffbfff) | (~0xffffbfff & (writeData << 14));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro6_1_en(void *p) {
   // cfg_macro6_1_en [13] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 13) & 0x1;
   }
*/
void phy_rf_write_cfg_macro6_1_en(void *p, unsigned int writeData)
{
	// cfg_macro6_1_en [13] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffdfff) | (~0xffffdfff & (writeData << 13));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro6_0_en(void *p) {
   // cfg_macro6_0_en [12] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x1;
   }
*/
void phy_rf_write_cfg_macro6_0_en(void *p, unsigned int writeData)
{
	// cfg_macro6_0_en [12] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffefff) | (~0xffffefff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro5_1_en(void *p) {
   // cfg_macro5_1_en [11] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x1;
   }
*/
void phy_rf_write_cfg_macro5_1_en(void *p, unsigned int writeData)
{
	// cfg_macro5_1_en [11] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff7ff) | (~0xfffff7ff & (writeData << 11));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro5_0_en(void *p) {
   // cfg_macro5_0_en [10] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }
*/
void phy_rf_write_cfg_macro5_0_en(void *p, unsigned int writeData)
{
	// cfg_macro5_0_en [10] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffbff) | (~0xfffffbff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro4_1_en(void *p) {
   // cfg_macro4_1_en [9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }
*/
void phy_rf_write_cfg_macro4_1_en(void *p, unsigned int writeData)
{
	// cfg_macro4_1_en [9] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro4_0_en(void *p) {
   // cfg_macro4_0_en [8] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }
*/
void phy_rf_write_cfg_macro4_0_en(void *p, unsigned int writeData)
{
	// cfg_macro4_0_en [8] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffeff) | (~0xfffffeff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro3_1_en(void *p) {
   // cfg_macro3_1_en [7] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }
*/
void phy_rf_write_cfg_macro3_1_en(void *p, unsigned int writeData)
{
	// cfg_macro3_1_en [7] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff7f) | (~0xffffff7f & (writeData << 7));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro3_0_en(void *p) {
   // cfg_macro3_0_en [6] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }
*/
void phy_rf_write_cfg_macro3_0_en(void *p, unsigned int writeData)
{
	// cfg_macro3_0_en [6] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro2_1_en(void *p) {
   // cfg_macro2_1_en [5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }
*/
void phy_rf_write_cfg_macro2_1_en(void *p, unsigned int writeData)
{
	// cfg_macro2_1_en [5] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro2_0_en(void *p) {
   // cfg_macro2_0_en [4] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }
*/
void phy_rf_write_cfg_macro2_0_en(void *p, unsigned int writeData)
{
	// cfg_macro2_0_en [4] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro1_1_en(void *p) {
   // cfg_macro1_1_en [3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_cfg_macro1_1_en(void *p, unsigned int writeData)
{
	// cfg_macro1_1_en [3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro1_0_en(void *p) {
   // cfg_macro1_0_en [2] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_macro1_0_en(void *p, unsigned int writeData)
{
	// cfg_macro1_0_en [2] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro0_1_en(void *p) {
   // cfg_macro0_1_en [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_macro0_1_en(void *p, unsigned int writeData)
{
	// cfg_macro0_1_en [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro0_0_en(void *p) {
   // cfg_macro0_0_en [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_macro0_0_en(void *p, unsigned int writeData)
{
	// cfg_macro0_0_en [0] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_prbs_srst(void *p) {
   // cfg_prbs_srst [1] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_prbs_srst(void *p, unsigned int writeData)
{
	// cfg_prbs_srst [1] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_tr_srst(void *p) {
   // cfg_tr_srst [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_tr_srst(void *p, unsigned int writeData)
{
	// cfg_tr_srst [0] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrlvl_retrain_en(void *p) {
   // cfg_wrlvl_retrain_en [2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }

   void phy_rf_write_cfg_wrlvl_retrain_en(void *p, unsigned int writeData) {
   // cfg_wrlvl_retrain_en [2] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_retrain_en(void *p) {
   // cfg_rdlvl_retrain_en [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   void phy_rf_write_cfg_rdlvl_retrain_en(void *p, unsigned int writeData) {
   // cfg_rdlvl_retrain_en [1] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_retrain_en(void *p) {
   // cfg_rdlvl_gate_retrain_en [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_rdlvl_gate_retrain_en(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_retrain_en [0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cal_ba_addr(void *p) {
   // cfg_cal_ba_addr [31:29] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 29) & 0x7;
   }
*/
void phy_rf_write_cfg_cal_ba_addr(void *p, unsigned int writeData)
{
	// cfg_cal_ba_addr [31:29] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x14;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0x1fffffff) | (~0x1fffffff & (writeData << 29));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cal_col_addr(void *p) {
   // cfg_cal_col_addr [28:16] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0x1fff;
   }
*/
void phy_rf_write_cfg_cal_col_addr(void *p, unsigned int writeData)
{
	// cfg_cal_col_addr [28:16] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x14;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xe000ffff) | (~0xe000ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cal_row_addr(void *p) {
   // cfg_cal_row_addr [15:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }
*/
void phy_rf_write_cfg_cal_row_addr(void *p, unsigned int writeData)
{
	// cfg_cal_row_addr [15:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x14;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_wr_cal_done(void *p) {
   // wr_cal_done [0] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   unsigned int phy_rf_read_cfg_wrlvl_en(void *p) {
   // cfg_wrlvl_en [6] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }

   void phy_rf_write_cfg_wrlvl_en(void *p, unsigned int writeData) {
   // cfg_wrlvl_en [6] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_en(void *p) {
   // cfg_rdlvl_gate_en [5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }

   void phy_rf_write_cfg_rdlvl_gate_en(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_en [5] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_en(void *p) {
   // cfg_rdlvl_en [4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }

   void phy_rf_write_cfg_rdlvl_en(void *p, unsigned int writeData) {
   // cfg_rdlvl_en [4] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_2nd_rdlvl_en(void *p) {
   // cfg_2nd_rdlvl_en [3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_cfg_2nd_rdlvl_en(void *p, unsigned int writeData)
{
	// cfg_2nd_rdlvl_en [3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x1c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wr_deskew_en(void *p) {
   // cfg_wr_deskew_en [2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_wr_deskew_en(void *p, unsigned int writeData)
{
	// cfg_wr_deskew_en [2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x1c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrcal_en(void *p) {
   // cfg_wrcal_en [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_wrcal_en(void *p, unsigned int writeData)
{
	// cfg_wrcal_en [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x1c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rd_deskew_en(void *p) {
   // cfg_rd_deskew_en [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_rd_deskew_en(void *p, unsigned int writeData)
{
	// cfg_rd_deskew_en [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x1c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_deskew_delay_param(void *p) {
   // cfg_deskew_delay_param [11:4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0xff;
   }

   void phy_rf_write_cfg_deskew_delay_param(void *p, unsigned int writeData) {
   // cfg_deskew_delay_param [11:4] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff00f) | (~0xfffff00f & (writeData << 4));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_deskew_samples_per_delay(void *p) {
   // cfg_deskew_samples_per_delay [3:0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xf;
   }
*/
void phy_rf_write_cfg_deskew_samples_per_delay(void *p, unsigned int writeData)
{
	// cfg_deskew_samples_per_delay [3:0] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x20;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff0) | (~0xfffffff0 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wr_deskew_done(void *p) {
   // cfg_wr_deskew_done [1] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   unsigned int phy_rf_read_cfg_rd_deskew_done(void *p) {
   // cfg_rd_deskew_done [0] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   unsigned int phy_rf_read_training_done(void *p) {
   // training_done [0] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   unsigned int phy_rf_read_twlmrd(void *p) {
   // twlmrd [31:24] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }
*/
void phy_rf_write_twlmrd(void *p, unsigned int writeData)
{
	// twlmrd [31:24] RW 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_tmod(void *p) {
   // tmod [23:16] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_tmod(void *p, unsigned int writeData)
{
	// tmod [23:16] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_twrlvl_ww(void *p) {
   // twrlvl_ww [15:8] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }
*/
void phy_rf_write_twrlvl_ww(void *p, unsigned int writeData)
{
	// twrlvl_ww [15:8] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_trp(void *p) {
   // trp [7:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }
*/
void phy_rf_write_trp(void *p, unsigned int writeData)
{
	// trp [7:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_mc_power_ok(void *p) {
   // cfg_mc_power_ok [0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_mc_power_ok(void *p, unsigned int writeData) {
   // cfg_mc_power_ok [0] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_trcd(void *p) {
   // trcd [31:24] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }
*/
void phy_rf_write_trcd(void *p, unsigned int writeData)
{
	// trcd [31:24] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x34;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_twrd(void *p) {
   // twrd [23:16] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_twrd(void *p, unsigned int writeData)
{
	// twrd [23:16] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x34;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_twl(void *p) {
   // twl [15:8] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }
*/
void phy_rf_write_twl(void *p, unsigned int writeData)
{
	// twl [15:8] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x34;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_trl(void *p) {
   // trl [7:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }
*/
void phy_rf_write_trl(void *p, unsigned int writeData)
{
	// trl [7:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x34;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dqs_odis_lat(void *p) {
   // cfg_dqs_odis_lat [23:21] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }
*/
void phy_rf_write_cfg_dqs_odis_lat(void *p, unsigned int writeData)
{
	// cfg_dqs_odis_lat [23:21] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dqs_oen_lat(void *p) {
   // cfg_dqs_oen_lat [20:18] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }
*/
void phy_rf_write_cfg_dqs_oen_lat(void *p, unsigned int writeData)
{
	// cfg_dqs_oen_lat [20:18] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dq_odis_lat(void *p) {
   // cfg_dq_odis_lat [17:15] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }
*/
void phy_rf_write_cfg_dq_odis_lat(void *p, unsigned int writeData)
{
	// cfg_dq_odis_lat [17:15] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dq_oen_lat(void *p) {
   // cfg_dq_oen_lat [14:12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }
*/
void phy_rf_write_cfg_dq_oen_lat(void *p, unsigned int writeData)
{
	// cfg_dq_oen_lat [14:12] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dqs_odtdis_lat(void *p) {
   // cfg_dqs_odtdis_lat [11:9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }
*/
void phy_rf_write_cfg_dqs_odtdis_lat(void *p, unsigned int writeData)
{
	// cfg_dqs_odtdis_lat [11:9] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dqs_odten_lat(void *p) {
   // cfg_dqs_odten_lat [8:6] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }
*/
void phy_rf_write_cfg_dqs_odten_lat(void *p, unsigned int writeData)
{
	// cfg_dqs_odten_lat [8:6] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dq_odtdis_lat(void *p) {
   // cfg_dq_odtdis_lat [5:3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }
*/
void phy_rf_write_cfg_dq_odtdis_lat(void *p, unsigned int writeData)
{
	// cfg_dq_odtdis_lat [5:3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dq_odten_lat(void *p) {
   // cfg_dq_odten_lat [2:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }
*/
void phy_rf_write_cfg_dq_odten_lat(void *p, unsigned int writeData)
{
	// cfg_dq_odten_lat [2:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_cmd_stren(void *p) {
   // cfg_drv_cmd_stren [20:18] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }
*/
void phy_rf_write_cfg_drv_cmd_stren(void *p, unsigned int writeData)
{
	// cfg_drv_cmd_stren [20:18] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_ad_slew(void *p) {
   // cfg_drv_ad_slew [17:16] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0x3;
   }
*/
void phy_rf_write_cfg_drv_ad_slew(void *p, unsigned int writeData)
{
	// cfg_drv_ad_slew [17:16] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffcffff) | (~0xfffcffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_ad_stren(void *p) {
   // cfg_drv_ad_stren [15:13] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 13) & 0x7;
   }
*/
void phy_rf_write_cfg_drv_ad_stren(void *p, unsigned int writeData)
{
	// cfg_drv_ad_stren [15:13] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff1fff) | (~0xffff1fff & (writeData << 13));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rcvr_os(void *p) {
   // cfg_rcvr_os [12:10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x7;
   }
*/
void phy_rf_write_cfg_rcvr_os(void *p, unsigned int writeData)
{
	// cfg_rcvr_os [12:10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffe3ff) | (~0xffffe3ff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_slew(void *p) {
   // cfg_drv_slew [9:8] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x3;
   }
*/
void phy_rf_write_cfg_drv_slew(void *p, unsigned int writeData)
{
	// cfg_drv_slew [9:8] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffcff) | (~0xfffffcff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_stren(void *p) {
   // cfg_drv_stren [7:5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x7;
   }
*/
void phy_rf_write_cfg_drv_stren(void *p, unsigned int writeData)
{
	// cfg_drv_stren [7:5] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff1f) | (~0xffffff1f & (writeData << 5));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_dm_slew(void *p) {
   // cfg_drv_dm_slew [4:3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x3;
   }
*/
void phy_rf_write_cfg_drv_dm_slew(void *p, unsigned int writeData)
{
	// cfg_drv_dm_slew [4:3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffe7) | (~0xffffffe7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_dm_stren(void *p) {
   // cfg_drv_dm_stren [2:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }
*/
void phy_rf_write_cfg_drv_dm_stren(void *p, unsigned int writeData)
{
	// cfg_drv_dm_stren [2:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x3c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dis_odt(void *p) {
   // cfg_dis_odt [23:15] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x1ff;
   }

   void phy_rf_write_cfg_dis_odt(void *p, unsigned int writeData) {
   // cfg_dis_odt [23:15] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff007fff) | (~0xff007fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_odt_stren(void *p) {
   // cfg_odt_stren [14:12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_odt_stren(void *p, unsigned int writeData) {
   // cfg_odt_stren [14:12] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_drv_clk_slew(void *p) {
   // cfg_drv_clk_slew [11:10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x3;
   }
*/
void phy_rf_write_cfg_drv_clk_slew(void *p, unsigned int writeData)
{
	// cfg_drv_clk_slew [11:10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x40;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff3ff) | (~0xfffff3ff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_clk_stren(void *p) {
   // cfg_drv_clk_stren [9:7] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x7;
   }
*/
void phy_rf_write_cfg_drv_clk_stren(void *p, unsigned int writeData)
{
	// cfg_drv_clk_stren [9:7] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x40;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffc7f) | (~0xfffffc7f & (writeData << 7));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_ctl_slew(void *p) {
   // cfg_drv_ctl_slew [6:5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x3;
   }
*/
void phy_rf_write_cfg_drv_ctl_slew(void *p, unsigned int writeData)
{
	// cfg_drv_ctl_slew [6:5] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x40;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff9f) | (~0xffffff9f & (writeData << 5));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_ctl_stren(void *p) {
   // cfg_drv_ctl_stren [4:2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x7;
   }
*/
void phy_rf_write_cfg_drv_ctl_stren(void *p, unsigned int writeData)
{
	// cfg_drv_ctl_stren [4:2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x40;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffe3) | (~0xffffffe3 & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_drv_cmd_slew(void *p) {
   // cfg_drv_cmd_slew [1:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }
*/
void phy_rf_write_cfg_drv_cmd_slew(void *p, unsigned int writeData)
{
	// cfg_drv_cmd_slew [1:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x40;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffc) | (~0xfffffffc & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_calib_code_n(void *p) {
   // cfg_calib_code_n [11:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x44;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3f;
   }

   void phy_rf_write_cfg_calib_code_n(void *p, unsigned int writeData) {
   // cfg_calib_code_n [11:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x44;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff03f) | (~0xfffff03f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_calib_code_p(void *p) {
   // cfg_calib_code_p [5:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x44;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3f;
   }

   void phy_rf_write_cfg_calib_code_p(void *p, unsigned int writeData) {
   // cfg_calib_code_p [5:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x44;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc0) | (~0xffffffc0 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_rank7_odt(void *p) {
   // rank7_odt [31:30] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 30) & 0x3;
   }
*/
void phy_rf_write_rank7_odt(void *p, unsigned int writeData)
{
	// rank7_odt [31:30] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0x3fffffff) | (~0x3fffffff & (writeData << 30));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank6_odt(void *p) {
   // rank6_odt [29:28] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 28) & 0x3;
   }
*/
void phy_rf_write_rank6_odt(void *p, unsigned int writeData)
{
	// rank6_odt [29:28] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xcfffffff) | (~0xcfffffff & (writeData << 28));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank5_odt(void *p) {
   // rank5_odt [27:26] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 26) & 0x3;
   }
*/
void phy_rf_write_rank5_odt(void *p, unsigned int writeData)
{
	// rank5_odt [27:26] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xf3ffffff) | (~0xf3ffffff & (writeData << 26));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank4_odt(void *p) {
   // rank4_odt [25:24] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0x3;
   }
*/
void phy_rf_write_rank4_odt(void *p, unsigned int writeData)
{
	// rank4_odt [25:24] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfcffffff) | (~0xfcffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank3_odt(void *p) {
   // rank3_odt [23:22] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 22) & 0x3;
   }
*/
void phy_rf_write_rank3_odt(void *p, unsigned int writeData)
{
	// rank3_odt [23:22] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff3fffff) | (~0xff3fffff & (writeData << 22));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank2_odt(void *p) {
   // rank2_odt [21:20] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 20) & 0x3;
   }
*/
void phy_rf_write_rank2_odt(void *p, unsigned int writeData)
{
	// rank2_odt [21:20] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffcfffff) | (~0xffcfffff & (writeData << 20));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank1_odt(void *p) {
   // rank1_odt [19:18] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x3;
   }
*/
void phy_rf_write_rank1_odt(void *p, unsigned int writeData)
{
	// rank1_odt [19:18] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfff3ffff) | (~0xfff3ffff & (writeData << 18));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank0_odt(void *p) {
   // rank0_odt [17:16] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0x3;
   }
*/
void phy_rf_write_rank0_odt(void *p, unsigned int writeData)
{
	// rank0_odt [17:16] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffcffff) | (~0xfffcffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank7_cke(void *p) {
   // rank7_cke [15:14] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x3;
   }
*/
void phy_rf_write_rank7_cke(void *p, unsigned int writeData)
{
	// rank7_cke [15:14] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff3fff) | (~0xffff3fff & (writeData << 14));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank6_cke(void *p) {
   // rank6_cke [13:12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x3;
   }
*/
void phy_rf_write_rank6_cke(void *p, unsigned int writeData)
{
	// rank6_cke [13:12] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffcfff) | (~0xffffcfff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank5_cke(void *p) {
   // rank5_cke [11:10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x3;
   }
*/
void phy_rf_write_rank5_cke(void *p, unsigned int writeData)
{
	// rank5_cke [11:10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff3ff) | (~0xfffff3ff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank4_cke(void *p) {
   // rank4_cke [9:8] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x3;
   }
*/
void phy_rf_write_rank4_cke(void *p, unsigned int writeData)
{
	// rank4_cke [9:8] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffcff) | (~0xfffffcff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank3_cke(void *p) {
   // rank3_cke [7:6] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }
*/
void phy_rf_write_rank3_cke(void *p, unsigned int writeData)
{
	// rank3_cke [7:6] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff3f) | (~0xffffff3f & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank2_cke(void *p) {
   // rank2_cke [5:4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }
*/
void phy_rf_write_rank2_cke(void *p, unsigned int writeData)
{
	// rank2_cke [5:4] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffcf) | (~0xffffffcf & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank1_cke(void *p) {
   // rank1_cke [3:2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }
*/
void phy_rf_write_rank1_cke(void *p, unsigned int writeData)
{
	// rank1_cke [3:2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff3) | (~0xfffffff3 & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank0_cke(void *p) {
   // rank0_cke [1:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }
*/
void phy_rf_write_rank0_cke(void *p, unsigned int writeData)
{
	// rank0_cke [1:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffc) | (~0xfffffffc & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_lp4_code(void *p) {
   // cfg_lp4_code [15:12] RW 9
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xf;
   }

   void phy_rf_write_cfg_lp4_code(void *p, unsigned int writeData) {
   // cfg_lp4_code [15:12] RW 9
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0fff) | (~0xffff0fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_lp3_code(void *p) {
   // cfg_lp3_code [11:8] RW 7
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xf;
   }

   void phy_rf_write_cfg_lp3_code(void *p, unsigned int writeData) {
   // cfg_lp3_code [11:8] RW 7
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff0ff) | (~0xfffff0ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_lp2_code(void *p) {
   // cfg_lp2_code [7:4] RW 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0xf;
   }

   void phy_rf_write_cfg_lp2_code(void *p, unsigned int writeData) {
   // cfg_lp2_code [7:4] RW 3
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff0f) | (~0xffffff0f & (writeData << 4));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_lp1_code(void *p) {
   // cfg_lp1_code [3:0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xf;
   }

   void phy_rf_write_cfg_lp1_code(void *p, unsigned int writeData) {
   // cfg_lp1_code [3:0] RW 1
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff0) | (~0xfffffff0 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_wakeup_time_lp4(void *p) {
   // wakeup_time_lp4 [31:20] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 20) & 0xfff;
   }
*/
void phy_rf_write_wakeup_time_lp4(void *p, unsigned int writeData)
{
	// wakeup_time_lp4 [31:20] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData = (regReadData & 0xfffff) | (~0xfffff & (writeData << 20));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_wakeup_time_lp3(void *p) {
   // wakeup_time_lp3 [19:12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xff;
   }
*/
void phy_rf_write_wakeup_time_lp3(void *p, unsigned int writeData)
{
	// wakeup_time_lp3 [19:12] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfff00fff) | (~0xfff00fff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_wakeup_time_lp2(void *p) {
   // wakeup_time_lp2 [11:4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0xff;
   }
*/
void phy_rf_write_wakeup_time_lp2(void *p, unsigned int writeData)
{
	// wakeup_time_lp2 [11:4] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff00f) | (~0xfffff00f & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_wakeup_time_lp1(void *p) {
   // wakeup_time_lp1 [3:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xf;
   }
*/
void phy_rf_write_wakeup_time_lp1(void *p, unsigned int writeData)
{
	// wakeup_time_lp1 [3:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff0) | (~0xfffffff0 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cmd_pi_en(void *p) {
   // cfg_cmd_pi_en [10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }
*/
void phy_rf_write_cfg_cmd_pi_en(void *p, unsigned int writeData)
{
	// cfg_cmd_pi_en [10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x54;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffbff) | (~0xfffffbff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cmd_pi_byp(void *p) {
   // cfg_cmd_pi_byp [9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }
*/
void phy_rf_write_cfg_cmd_pi_byp(void *p, unsigned int writeData)
{
	// cfg_cmd_pi_byp [9] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x54;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cmd_delay(void *p) {
   // cfg_cmd_delay [8:0] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1ff;
   }
*/
void phy_rf_write_cfg_cmd_delay(void *p, unsigned int writeData)
{
	// cfg_cmd_delay [8:0] RW 80
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x54;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe00) | (~0xfffffe00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ad_pi_en(void *p) {
   // cfg_ad_pi_en [10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }
*/
void phy_rf_write_cfg_ad_pi_en(void *p, unsigned int writeData)
{
	// cfg_ad_pi_en [10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x58;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffbff) | (~0xfffffbff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ad_pi_byp(void *p) {
   // cfg_ad_pi_byp [9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }
*/
void phy_rf_write_cfg_ad_pi_byp(void *p, unsigned int writeData)
{
	// cfg_ad_pi_byp [9] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x58;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ad_delay(void *p) {
   // cfg_ad_delay [8:0] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1ff;
   }
*/
void phy_rf_write_cfg_ad_delay(void *p, unsigned int writeData)
{
	// cfg_ad_delay [8:0] RW 80
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x58;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe00) | (~0xfffffe00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ctl_pi_en(void *p) {
   // cfg_ctl_pi_en [10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }
*/
void phy_rf_write_cfg_ctl_pi_en(void *p, unsigned int writeData)
{
	// cfg_ctl_pi_en [10] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x5c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffbff) | (~0xfffffbff & (writeData << 10));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ctl_pi_byp(void *p) {
   // cfg_ctl_pi_byp [9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }
*/
void phy_rf_write_cfg_ctl_pi_byp(void *p, unsigned int writeData)
{
	// cfg_ctl_pi_byp [9] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x5c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_ctl_delay(void *p) {
   // cfg_ctl_delay [8:0] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1ff;
   }
*/
void phy_rf_write_cfg_ctl_delay(void *p, unsigned int writeData)
{
	// cfg_ctl_delay [8:0] RW 80
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x5c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe00) | (~0xfffffe00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dpd_ck_status(void *p) {
   // cfg_dpd_ck_status [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_dpd_ck_status(void *p, unsigned int writeData)
{
	// cfg_dpd_ck_status [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x60;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rst_ck_status(void *p) {
   // cfg_rst_ck_status [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_rst_ck_status(void *p, unsigned int writeData)
{
	// cfg_rst_ck_status [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x60;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dll_bypass(void *p) {
   // cfg_dll_bypass [9:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3ff;
   }
*/
void phy_rf_write_cfg_dll_bypass(void *p, unsigned int writeData)
{
	// cfg_dll_bypass [9:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x64;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffc00) | (~0xfffffc00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank7(void *p) {
   // rank7 [7] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }
*/
void phy_rf_write_rank7(void *p, unsigned int writeData)
{
	// rank7 [7] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff7f) | (~0xffffff7f & (writeData << 7));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank6(void *p) {
   // rank6 [6] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }
*/
void phy_rf_write_rank6(void *p, unsigned int writeData)
{
	// rank6 [6] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank5(void *p) {
   // rank5 [5] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }
*/
void phy_rf_write_rank5(void *p, unsigned int writeData)
{
	// rank5 [5] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank4(void *p) {
   // rank4 [4] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }
*/
void phy_rf_write_rank4(void *p, unsigned int writeData)
{
	// rank4 [4] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank3(void *p) {
   // rank3 [3] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_rank3(void *p, unsigned int writeData)
{
	// rank3 [3] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank2(void *p) {
   // rank2 [2] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_rank2(void *p, unsigned int writeData)
{
	// rank2 [2] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank1(void *p) {
   // rank1 [1] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_rank1(void *p, unsigned int writeData)
{
	// rank1 [1] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rank0(void *p) {
   // rank0 [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_rank0(void *p, unsigned int writeData)
{
	// rank0 [0] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x68;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrlvl_load(void *p) {
   // cfg_wrlvl_load [2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_wrlvl_load(void *p, unsigned int writeData)
{
	// cfg_wrlvl_load [2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x6c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_gatelvl_load(void *p) {
   // cfg_gatelvl_load [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_gatelvl_load(void *p, unsigned int writeData)
{
	// cfg_gatelvl_load [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x6c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_load(void *p) {
   // cfg_rdlvl_load [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_rdlvl_load(void *p, unsigned int writeData)
{
	// cfg_rdlvl_load [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x6c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_debug_sel(void *p) {
   // cfg_debug_sel [31:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x70;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffffff;
   }

   void phy_rf_write_cfg_debug_sel(void *p, unsigned int writeData) {
   // cfg_debug_sel [31:0] RW 0
      unsigned int regAddr;
      
      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x70;
      phy_write_reg(mcu, regAddr, writeData);
   }
*/
unsigned int phy_rf_read_dqs_weak_pull_down_disable(void *p)
{
	// dqs_weak_pull_down_disable [0] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x74;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1;
}

void phy_rf_write_dqs_weak_pull_down_disable(void *p, unsigned int writeData)
{
	// dqs_weak_pull_down_disable [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x74;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern4(void *p) {
   // cfg_pattern4 [31:24] RW BB
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern4(void *p, unsigned int writeData)
{
	// cfg_pattern4 [31:24] RW BB
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x78;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern3(void *p) {
   // cfg_pattern3 [23:16] RW AA
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern3(void *p, unsigned int writeData)
{
	// cfg_pattern3 [23:16] RW AA
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x78;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern2(void *p) {
   // cfg_pattern2 [15:8] RW 99
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern2(void *p, unsigned int writeData)
{
	// cfg_pattern2 [15:8] RW 99
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x78;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern1(void *p) {
   // cfg_pattern1 [7:0] RW 88
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern1(void *p, unsigned int writeData)
{
	// cfg_pattern1 [7:0] RW 88
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x78;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern8(void *p) {
   // cfg_pattern8 [31:24] RW FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern8(void *p, unsigned int writeData)
{
	// cfg_pattern8 [31:24] RW FF
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x7c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern7(void *p) {
   // cfg_pattern7 [23:16] RW EE
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern7(void *p, unsigned int writeData)
{
	// cfg_pattern7 [23:16] RW EE
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x7c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern6(void *p) {
   // cfg_pattern6 [15:8] RW DD
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern6(void *p, unsigned int writeData)
{
	// cfg_pattern6 [15:8] RW DD
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x7c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pattern5(void *p) {
   // cfg_pattern5 [7:0] RW CC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }
*/
void phy_rf_write_cfg_pattern5(void *p, unsigned int writeData)
{
	// cfg_pattern5 [7:0] RW CC
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x7c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_num_of_wr_samples(void *p) {
   // cfg_num_of_wr_samples [31:24] RW 6
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }
*/
void phy_rf_write_cfg_num_of_wr_samples(void *p, unsigned int writeData)
{
	// cfg_num_of_wr_samples [31:24] RW 6
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x80;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrlvl_incr_size(void *p) {
   // cfg_wrlvl_incr_size [23:16] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_cfg_wrlvl_incr_size(void *p, unsigned int writeData)
{
	// cfg_wrlvl_incr_size [23:16] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x80;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_write_samples_per_delay(void *p) {
   // cfg_write_samples_per_delay [15:12] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xf;
   }
*/
void phy_rf_write_cfg_write_samples_per_delay(void *p, unsigned int writeData)
{
	// cfg_write_samples_per_delay [15:12] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x80;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff0fff) | (~0xffff0fff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrlvl_max_delay_limit(void *p) {
   // cfg_wrlvl_max_delay_limit [11:0] RW 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }
*/
void phy_rf_write_cfg_wrlvl_max_delay_limit(void *p, unsigned int writeData)
{
	// cfg_wrlvl_max_delay_limit [11:0] RW 180
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x80;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_incr_size(void *p) {
   // cfg_rdlvl_incr_size [23:16] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_cfg_rdlvl_incr_size(void *p, unsigned int writeData)
{
	// cfg_rdlvl_incr_size [23:16] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x84;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_read_samples_per_delay(void *p) {
   // cfg_read_samples_per_delay [15:12] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xf;
   }
*/
void phy_rf_write_cfg_read_samples_per_delay(void *p, unsigned int writeData)
{
	// cfg_read_samples_per_delay [15:12] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x84;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff0fff) | (~0xffff0fff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_max_delay_limit(void *p) {
   // cfg_rdlvl_max_delay_limit [11:0] RW 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }
*/
void phy_rf_write_cfg_rdlvl_max_delay_limit(void *p, unsigned int writeData)
{
	// cfg_rdlvl_max_delay_limit [11:0] RW 180
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x84;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_num_of_gt_samples(void *p) {
   // cfg_num_of_gt_samples [31:24] RW D0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }
*/
void phy_rf_write_cfg_num_of_gt_samples(void *p, unsigned int writeData)
{
	// cfg_num_of_gt_samples [31:24] RW D0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x88;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_gate_incr_size(void *p) {
   // cfg_rdlvl_gate_incr_size [23:16] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }
*/
void phy_rf_write_cfg_rdlvl_gate_incr_size(void *p, unsigned int writeData)
{
	// cfg_rdlvl_gate_incr_size [23:16] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x88;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_gate_samples_per_delay(void *p) {
   // cfg_gate_samples_per_delay [15:12] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xf;
   }
*/
void phy_rf_write_cfg_gate_samples_per_delay(void *p, unsigned int writeData)
{
	// cfg_gate_samples_per_delay [15:12] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x88;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff0fff) | (~0xffff0fff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_rdlvl_gate_max_delay_limit(void *p) {
   // cfg_rdlvl_gate_max_delay_limit [11:0] RW 5FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }
*/
void phy_rf_write_cfg_rdlvl_gate_max_delay_limit(void *p,
						 unsigned int writeData)
{
	// cfg_rdlvl_gate_max_delay_limit [11:0] RW 5FC
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x88;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_gt_retrain_val(void *p) {
   // cfg_gt_retrain_val [23:16] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_cfg_gt_retrain_val(void *p, unsigned int writeData) {
   // cfg_gt_retrain_val [23:16] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrcal_max_delay_limit(void *p) {
   // cfg_wrcal_max_delay_limit [11:0] RW 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }
*/
void phy_rf_write_cfg_wrcal_max_delay_limit(void *p, unsigned int writeData)
{
	// cfg_wrcal_max_delay_limit [11:0] RW 3FC
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x8c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_wrlvl_error(void *p) {
   // cfg_wrlvl_error [4] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }

   unsigned int phy_rf_read_cfg_wrcal_error(void *p) {
   // cfg_wrcal_error [3] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_error(void *p) {
   // cfg_rdlvl_gate_error [2] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }

   unsigned int phy_rf_read_cfg_rdlvl_error(void *p) {
   // cfg_rdlvl_error [1] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   unsigned int phy_rf_read_cfg_training_error(void *p) {
   // cfg_training_error [0] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   unsigned int phy_rf_read_cfg_zq_counter(void *p) {
   // cfg_zq_counter [31:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffffff;
   }
*/
void phy_rf_write_cfg_zq_counter(void *p, unsigned int writeData)
{
	// cfg_zq_counter [31:0] RW 0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x94;
	phy_write_reg(mcu, regAddr, writeData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_prbs_trip_cnt_l(void *p) {
   // cfg_prbs_trip_cnt_l [31:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffffff;
   }
*/
void phy_rf_write_cfg_prbs_trip_cnt_l(void *p, unsigned int writeData)
{
	// cfg_prbs_trip_cnt_l [31:0] RW 0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x98;
	phy_write_reg(mcu, regAddr, writeData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_prbs_trip_cnt_h(void *p) {
   // cfg_prbs_trip_cnt_h [31:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffffff;
   }
*/
void phy_rf_write_cfg_prbs_trip_cnt_h(void *p, unsigned int writeData)
{
	// cfg_prbs_trip_cnt_h [31:0] RW 0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x9c;
	phy_write_reg(mcu, regAddr, writeData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_bert_resetb(void *p) {
   // cfg_bert_resetb [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_bert_resetb(void *p, unsigned int writeData)
{
	// cfg_bert_resetb [0] RW 1
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xa0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_prbs_bit_sel(void *p) {
   // prbs_bit_sel [3:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xf;
   }
*/
void phy_rf_write_prbs_bit_sel(void *p, unsigned int writeData)
{
	// prbs_bit_sel [3:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xa4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff0) | (~0xfffffff0 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_prbs_fail15(void *p) {
   // prbs_fail15 [15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x1;
   }

   void phy_rf_write_prbs_fail15(void *p, unsigned int writeData) {
   // prbs_fail15 [15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff7fff) | (~0xffff7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail14(void *p) {
   // prbs_fail14 [14] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x1;
   }

   void phy_rf_write_prbs_fail14(void *p, unsigned int writeData) {
   // prbs_fail14 [14] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffbfff) | (~0xffffbfff & (writeData << 14));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail13(void *p) {
   // prbs_fail13 [13] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 13) & 0x1;
   }

   void phy_rf_write_prbs_fail13(void *p, unsigned int writeData) {
   // prbs_fail13 [13] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffdfff) | (~0xffffdfff & (writeData << 13));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail12(void *p) {
   // prbs_fail12 [12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x1;
   }

   void phy_rf_write_prbs_fail12(void *p, unsigned int writeData) {
   // prbs_fail12 [12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffefff) | (~0xffffefff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail11(void *p) {
   // prbs_fail11 [11] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x1;
   }

   void phy_rf_write_prbs_fail11(void *p, unsigned int writeData) {
   // prbs_fail11 [11] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff7ff) | (~0xfffff7ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail10(void *p) {
   // prbs_fail10 [10] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }

   void phy_rf_write_prbs_fail10(void *p, unsigned int writeData) {
   // prbs_fail10 [10] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffbff) | (~0xfffffbff & (writeData << 10));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail9(void *p) {
   // prbs_fail9 [9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }

   void phy_rf_write_prbs_fail9(void *p, unsigned int writeData) {
   // prbs_fail9 [9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail8(void *p) {
   // prbs_fail8 [8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   void phy_rf_write_prbs_fail8(void *p, unsigned int writeData) {
   // prbs_fail8 [8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffeff) | (~0xfffffeff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail7(void *p) {
   // prbs_fail7 [7] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }

   void phy_rf_write_prbs_fail7(void *p, unsigned int writeData) {
   // prbs_fail7 [7] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff7f) | (~0xffffff7f & (writeData << 7));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail6(void *p) {
   // prbs_fail6 [6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }

   void phy_rf_write_prbs_fail6(void *p, unsigned int writeData) {
   // prbs_fail6 [6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail5(void *p) {
   // prbs_fail5 [5] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }

   void phy_rf_write_prbs_fail5(void *p, unsigned int writeData) {
   // prbs_fail5 [5] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail4(void *p) {
   // prbs_fail4 [4] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }

   void phy_rf_write_prbs_fail4(void *p, unsigned int writeData) {
   // prbs_fail4 [4] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail3(void *p) {
   // prbs_fail3 [3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }

   void phy_rf_write_prbs_fail3(void *p, unsigned int writeData) {
   // prbs_fail3 [3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail2(void *p) {
   // prbs_fail2 [2] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }

   void phy_rf_write_prbs_fail2(void *p, unsigned int writeData) {
   // prbs_fail2 [2] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail1(void *p) {
   // prbs_fail1 [1] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   void phy_rf_write_prbs_fail1(void *p, unsigned int writeData) {
   // prbs_fail1 [1] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_fail0(void *p) {
   // prbs_fail0 [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_prbs_fail0(void *p, unsigned int writeData) {
   // prbs_fail0 [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_prbs_error_capture(void *p) {
   // cfg_prbs_error_capture [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_prbs_error_capture(void *p, unsigned int writeData) {
   // cfg_prbs_error_capture [0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_prbs_load(void *p) {
   // cfg_prbs_load [0] Rw 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
unsigned int phy_rf_read_cfg_prbs_cnt_done(void *p)
{
	// cfg_prbs_cnt_done [0] CORL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xb4;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1;
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dll_cal_busy(void *p) {
   // cfg_dll_cal_busy [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_dll_cal_busy(void *p, unsigned int writeData) {
   // cfg_dll_cal_busy [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_disable_dll_cal(void *p) {
   // cfg_disable_dll_cal [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_disable_dll_cal(void *p, unsigned int writeData)
{
	// cfg_disable_dll_cal [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xbc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_rdlvl_trim_for_wrlvl_trim(void *p) {
   // rdlvl_trim_for_wrlvl_trim [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_rdlvl_trim_for_wrlvl_trim(void *p, unsigned int writeData) {
   // rdlvl_trim_for_wrlvl_trim [0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_delay_from_rden_7(void *p) {
   // cfg_delay_from_rden_7 [23:21] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_7(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_7 [23:21] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_6(void *p) {
   // cfg_delay_from_rden_6 [20:18] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_6(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_6 [20:18] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_5(void *p) {
   // cfg_delay_from_rden_5 [17:15] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_5(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_5 [17:15] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_4(void *p) {
   // cfg_delay_from_rden_4 [14:12] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_4(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_4 [14:12] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_3(void *p) {
   // cfg_delay_from_rden_3 [11:9] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_3(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_3 [11:9] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_2(void *p) {
   // cfg_delay_from_rden_2 [8:6] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_2(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_2 [8:6] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_1(void *p) {
   // cfg_delay_from_rden_1 [5:3] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_1(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_1 [5:3] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_delay_from_rden_0(void *p) {
   // cfg_delay_from_rden_0 [2:0] RWL 3
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }
*/
void phy_rf_write_cfg_delay_from_rden_0(void *p, unsigned int writeData)
{
	// cfg_delay_from_rden_0 [2:0] RWL 3
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xc0;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_macro8_1_error(void *p) {
   // macro8_1_error [17] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 17) & 0x1;
   }

   unsigned int phy_rf_read_macro8_0_error(void *p) {
   // macro8_0_error [16] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0x1;
   }

   unsigned int phy_rf_read_macro7_1_error(void *p) {
   // macro7_1_error [15] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x1;
   }

   unsigned int phy_rf_read_macro7_0_error(void *p) {
   // macro7_0_error [14] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x1;
   }

   unsigned int phy_rf_read_macro6_1_error(void *p) {
   // macro6_1_error [13] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 13) & 0x1;
   }

   unsigned int phy_rf_read_macro6_0_error(void *p) {
   // macro6_0_error [12] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x1;
   }

   unsigned int phy_rf_read_macro5_1_error(void *p) {
   // macro5_1_error [11] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x1;
   }

   unsigned int phy_rf_read_macro5_0_error(void *p) {
   // macro5_0_error [10] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x1;
   }

   unsigned int phy_rf_read_macro4_1_error(void *p) {
   // macro4_1_error [9] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }

   unsigned int phy_rf_read_macro4_0_error(void *p) {
   // macro4_0_error [8] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_macro3_1_error(void *p) {
   // macro3_1_error [7] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }

   unsigned int phy_rf_read_macro3_0_error(void *p) {
   // macro3_0_error [6] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }

   unsigned int phy_rf_read_macro2_1_error(void *p) {
   // macro2_1_error [5] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }

   unsigned int phy_rf_read_macro2_0_error(void *p) {
   // macro2_0_error [4] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }

   unsigned int phy_rf_read_macro1_1_error(void *p) {
   // macro1_1_error [3] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }

   unsigned int phy_rf_read_macro1_0_error(void *p) {
   // macro1_0_error [2] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }

   unsigned int phy_rf_read_macro0_1_error(void *p) {
   // macro0_1_error [1] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   unsigned int phy_rf_read_macro0_0_error(void *p) {
   // macro0_0_error [0] CORL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   unsigned int phy_rf_read_cfg_prbs_clk_enable(void *p) {
   // cfg_prbs_clk_enable [1] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   void phy_rf_write_cfg_prbs_clk_enable(void *p, unsigned int writeData) {
   // cfg_prbs_clk_enable [1] RW 1
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_training_clk_enable(void *p) {
   // cfg_training_clk_enable [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_training_clk_enable(void *p, unsigned int writeData) {
   // cfg_training_clk_enable [0] RW 1
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_pll_reset(void *p) {
   // cfg_pll_reset [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_pll_reset(void *p, unsigned int writeData) {
   // cfg_pll_reset [0] RW 1
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_pll_lock(void *p) {
   // cfg_pll_lock [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_pll_lock(void *p, unsigned int writeData) {
   // cfg_pll_lock [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_divider_reset(void *p) {
   // cfg_divider_reset [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_divider_reset(void *p, unsigned int writeData) {
   // cfg_divider_reset [0] RW 1
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_phy_reset(void *p) {
   // cfg_phy_reset [0] RW 1
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_phy_reset(void *p, unsigned int writeData) {
   // cfg_phy_reset [0] RW 1
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_fly_over_read(void *p) {
   // cfg_fly_over_read [7] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }

   void phy_rf_write_cfg_fly_over_read(void *p, unsigned int writeData) {
   // cfg_fly_over_read [7] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff7f) | (~0xffffff7f & (writeData << 7));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_fly_over_sel(void *p) {
   // cfg_fly_over_sel [6] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }

   void phy_rf_write_cfg_fly_over_sel(void *p, unsigned int writeData) {
   // cfg_fly_over_sel [6] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_farend_loopback_read(void *p) {
   // cfg_farend_loopback_read [5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }

   void phy_rf_write_cfg_farend_loopback_read(void *p, unsigned int writeData) {
   // cfg_farend_loopback_read [5] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_farend_loopback(void *p) {
   // cfg_farend_loopback [4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }

   void phy_rf_write_cfg_farend_loopback(void *p, unsigned int writeData) {
   // cfg_farend_loopback [4] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_data_loopback_en(void *p) {
   // cfg_data_loopback_en [3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_cfg_data_loopback_en(void *p, unsigned int writeData)
{
	// cfg_data_loopback_en [3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xdc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_add_loopback_en(void *p) {
   // cfg_add_loopback_en [2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_add_loopback_en(void *p, unsigned int writeData)
{
	// cfg_add_loopback_en [2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xdc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_longloopback_en(void *p) {
   // cfg_longloopback_en [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_longloopback_en(void *p, unsigned int writeData)
{
	// cfg_longloopback_en [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xdc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_loopback_en(void *p) {
   // cfg_loopback_en [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_loopback_en(void *p, unsigned int writeData)
{
	// cfg_loopback_en [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xdc;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_prbs_err_cnt1(void *p) {
   // prbs_err_cnt1 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt1(void *p, unsigned int writeData) {
   // prbs_err_cnt1 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt0(void *p) {
   // prbs_err_cnt0 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt0(void *p, unsigned int writeData) {
   // prbs_err_cnt0 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt3(void *p) {
   // prbs_err_cnt3 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt3(void *p, unsigned int writeData) {
   // prbs_err_cnt3 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt2(void *p) {
   // prbs_err_cnt2 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt2(void *p, unsigned int writeData) {
   // prbs_err_cnt2 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt5(void *p) {
   // prbs_err_cnt5 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt5(void *p, unsigned int writeData) {
   // prbs_err_cnt5 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt4(void *p) {
   // prbs_err_cnt4 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt4(void *p, unsigned int writeData) {
   // prbs_err_cnt4 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt7(void *p) {
   // prbs_err_cnt7 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt7(void *p, unsigned int writeData) {
   // prbs_err_cnt7 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt6(void *p) {
   // prbs_err_cnt6 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt6(void *p, unsigned int writeData) {
   // prbs_err_cnt6 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt9(void *p) {
   // prbs_err_cnt9 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt9(void *p, unsigned int writeData) {
   // prbs_err_cnt9 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt8(void *p) {
   // prbs_err_cnt8 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt8(void *p, unsigned int writeData) {
   // prbs_err_cnt8 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt11(void *p) {
   // prbs_err_cnt11 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt11(void *p, unsigned int writeData) {
   // prbs_err_cnt11 [31:16] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt10(void *p) {
   // prbs_err_cnt10 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt10(void *p, unsigned int writeData) {
   // prbs_err_cnt10 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_prbs_err_cnt12(void *p) {
   // prbs_err_cnt12 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_prbs_err_cnt12(void *p, unsigned int writeData) {
   // prbs_err_cnt12 [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xf8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll_cal_state(void *p) {
   // cfg_dll_cal_state [23:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xfc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffff;
   }

   void phy_rf_write_cfg_dll_cal_state(void *p, unsigned int writeData) {
   // cfg_dll_cal_state [23:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xfc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000000) | (~0xff000000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll_test_capture(void *p) {
   // cfg_dll_test_capture [9:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x100;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3ff;
   }

   void phy_rf_write_cfg_dll_test_capture(void *p, unsigned int writeData) {
   // cfg_dll_test_capture [9:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x100;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffc00) | (~0xfffffc00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_lowfrq_en(void *p) {
   // cfg_lowfrq_en [11:2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x104;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3ff;
   }
*/
void phy_rf_write_cfg_lowfrq_en(void *p, unsigned int writeData)
{
	// cfg_lowfrq_en [11:2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x104;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffff003) | (~0xfffff003 & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_hi_bwctrl(void *p) {
   // cfg_hi_bwctrl [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x104;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   void phy_rf_write_cfg_hi_bwctrl(void *p, unsigned int writeData) {
   // cfg_hi_bwctrl [1] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x104;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_pll_atest_sel(void *p) {
   // cfg_pll_atest_sel [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x104;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_pll_atest_sel(void *p, unsigned int writeData) {
   // cfg_pll_atest_sel [0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x104;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dqxclk_cdr_pi_preload_en(void *p) {
   // cfg_dqxclk_cdr_pi_preload_en [9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1;
   }

   void phy_rf_write_cfg_dqxclk_cdr_pi_preload_en(void *p, unsigned int writeData) {
   // cfg_dqxclk_cdr_pi_preload_en [9] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffdff) | (~0xfffffdff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_piclk_cdr_pi_preload_en(void *p) {
   // cfg_piclk_cdr_pi_preload_en [8] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   void phy_rf_write_cfg_piclk_cdr_pi_preload_en(void *p, unsigned int writeData) {
   // cfg_piclk_cdr_pi_preload_en [8] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffeff) | (~0xfffffeff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_phyclk1x_cdr_pi_preload_en(void *p) {
   // cfg_phyclk1x_cdr_pi_preload_en [7] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 7) & 0x1;
   }

   void phy_rf_write_cfg_phyclk1x_cdr_pi_preload_en(void *p, unsigned int writeData) {
   // cfg_phyclk1x_cdr_pi_preload_en [7] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff7f) | (~0xffffff7f & (writeData << 7));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_pcclk_cdr_pi_preload_en(void *p) {
   // cfg_pcclk_cdr_pi_preload_en [6] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x1;
   }

   void phy_rf_write_cfg_pcclk_cdr_pi_preload_en(void *p, unsigned int writeData) {
   // cfg_pcclk_cdr_pi_preload_en [6] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffbf) | (~0xffffffbf & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_mcclk_cdr_pi_preload_en(void *p) {
   // cfg_mcclk_cdr_pi_preload_en [5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x1;
   }

   void phy_rf_write_cfg_mcclk_cdr_pi_preload_en(void *p, unsigned int writeData) {
   // cfg_mcclk_cdr_pi_preload_en [5] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffdf) | (~0xffffffdf & (writeData << 5));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dqxclk_cdr_phloop_en(void *p) {
   // cfg_dqxclk_cdr_phloop_en [4] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }
*/
void phy_rf_write_cfg_dqxclk_cdr_phloop_en(void *p, unsigned int writeData)
{
	// cfg_dqxclk_cdr_phloop_en [4] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x108;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_piclk_cdr_phloop_en(void *p) {
   // cfg_piclk_cdr_phloop_en [3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_cfg_piclk_cdr_phloop_en(void *p, unsigned int writeData)
{
	// cfg_piclk_cdr_phloop_en [3] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x108;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_phyclk1x_cdr_phloop_en(void *p) {
   // cfg_phyclk1x_cdr_phloop_en [2] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_phyclk1x_cdr_phloop_en(void *p, unsigned int writeData)
{
	// cfg_phyclk1x_cdr_phloop_en [2] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x108;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pcclk_cdr_phloop_en(void *p) {
   // cfg_pcclk_cdr_phloop_en [1] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_pcclk_cdr_phloop_en(void *p, unsigned int writeData)
{
	// cfg_pcclk_cdr_phloop_en [1] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x108;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_mcclk_cdr_phloop_en(void *p) {
   // cfg_mcclk_cdr_phloop_en [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x108;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_mcclk_cdr_phloop_en(void *p, unsigned int writeData)
{
	// cfg_mcclk_cdr_phloop_en [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x108;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dtest_ena(void *p) {
   // cfg_dtest_ena [19:10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x3ff;
   }

   void phy_rf_write_cfg_dtest_ena(void *p, unsigned int writeData) {
   // cfg_dtest_ena [19:10] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfff003ff) | (~0xfff003ff & (writeData << 10));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_atest_ena(void *p) {
   // cfg_atest_ena [9:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3ff;
   }

   void phy_rf_write_cfg_atest_ena(void *p, unsigned int writeData) {
   // cfg_atest_ena [9:0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x10c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffc00) | (~0xfffffc00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dtest_add(void *p) {
   // cfg_dtest_add [19:10] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x110;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x3ff;
   }

   void phy_rf_write_cfg_dtest_add(void *p, unsigned int writeData) {
   // cfg_dtest_add [19:10] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x110;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfff003ff) | (~0xfff003ff & (writeData << 10));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_atest_add(void *p) {
   // cfg_atest_add [9:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x110;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3ff;
   }

   void phy_rf_write_cfg_atest_add(void *p, unsigned int writeData) {
   // cfg_atest_add [9:0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x110;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffc00) | (~0xfffffc00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rcvr_bias_en(void *p) {
   // cfg_rcvr_bias_en [17:9] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x114;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x1ff;
   }

   void phy_rf_write_cfg_rcvr_bias_en(void *p, unsigned int writeData) {
   // cfg_rcvr_bias_en [17:9] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x114;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc01ff) | (~0xfffc01ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_ena_recv(void *p) {
   // cfg_ena_recv [8:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x114;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1ff;
   }

   void phy_rf_write_cfg_ena_recv(void *p, unsigned int writeData) {
   // cfg_ena_recv [8:0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x114;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe00) | (~0xfffffe00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll_num(void *p) {
   // cfg_dll_num [7:5] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x118;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 5) & 0x7;
   }
*/
void phy_rf_write_cfg_dll_num(void *p, unsigned int writeData)
{
	// cfg_dll_num [7:5] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x118;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff1f) | (~0xffffff1f & (writeData << 5));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_macro_num(void *p) {
   // cfg_macro_num [4:1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x118;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0xf;
   }
*/
void phy_rf_write_cfg_macro_num(void *p, unsigned int writeData)
{
	// cfg_macro_num [4:1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x118;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffe1) | (~0xffffffe1 & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dll_cal_en(void *p) {
   // cfg_dll_cal_en [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x118;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_dll_cal_en(void *p, unsigned int writeData)
{
	// cfg_dll_cal_en [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x118;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dll_cal_done(void *p)
{
	// cfg_dll_cal_done [0] CORL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x11c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1;
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_m9_dll0_quad_b_step(void *p) {
   // m9_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x120;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x120;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_a_step(void *p) {
   // m9_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x120;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x120;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_d_step(void *p) {
   // m9_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x124;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x124;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_c_step(void *p) {
   // m9_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x124;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x124;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_f_step(void *p) {
   // m9_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x128;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x128;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_e_step(void *p) {
   // m9_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x128;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x128;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_h_step(void *p) {
   // m9_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x12c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x12c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_g_step(void *p) {
   // m9_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x12c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m9_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m9_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x12c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_a_wt(void *p) {
   // m9_dll0_quad_a_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_a_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_b_wt(void *p) {
   // m9_dll0_quad_b_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_b_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_c_wt(void *p) {
   // m9_dll0_quad_c_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_c_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_d_wt(void *p) {
   // m9_dll0_quad_d_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_d_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x130;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_e_wt(void *p) {
   // m9_dll0_quad_e_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_e_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_f_wt(void *p) {
   // m9_dll0_quad_f_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_f_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_g_wt(void *p) {
   // m9_dll0_quad_g_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_g_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m9_dll0_quad_h_wt(void *p) {
   // m9_dll0_quad_h_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m9_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m9_dll0_quad_h_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x134;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wait_status_timer(void *p) {
   // cfg_wait_status_timer [16:9] RW 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x138;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0xff;
   }
*/
void phy_rf_write_cfg_wait_status_timer(void *p, unsigned int writeData)
{
	// cfg_wait_status_timer [16:9] RW 10
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x138;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffe01ff) | (~0xfffe01ff & (writeData << 9));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cont_samples(void *p) {
   // cfg_cont_samples [8:1] RW 5
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x138;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0xff;
   }
*/
void phy_rf_write_cfg_cont_samples(void *p, unsigned int writeData)
{
	// cfg_cont_samples [8:1] RW 5
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x138;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe01) | (~0xfffffe01 & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dll_sft_rst(void *p) {
   // cfg_dll_sft_rst [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x138;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_dll_sft_rst(void *p, unsigned int writeData)
{
	// cfg_dll_sft_rst [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x138;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_poc(void *p) {
   // cfg_poc [14] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 14) & 0x1;
   }

   void phy_rf_write_cfg_poc(void *p, unsigned int writeData) {
   // cfg_poc [14] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffbfff) | (~0xffffbfff & (writeData << 14));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_lock_count(void *p) {
   // cfg_cdr_lock_count [13:12] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x3;
   }

   void phy_rf_write_cfg_cdr_lock_count(void *p, unsigned int writeData) {
   // cfg_cdr_lock_count [13:12] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffcfff) | (~0xffffcfff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_pi_preload_val(void *p) {
   // cfg_cdr_pi_preload_val [11:3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1ff;
   }

   void phy_rf_write_cfg_cdr_pi_preload_val(void *p, unsigned int writeData) {
   // cfg_cdr_pi_preload_val [11:3] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff007) | (~0xfffff007 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_kphase(void *p) {
   // cfg_cdr_kphase [2:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_cdr_kphase(void *p, unsigned int writeData) {
   // cfg_cdr_kphase [2:0] RW 0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x13c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dqxclk_cdr_lock_reset(void *p) {
   // cfg_dqxclk_cdr_lock_reset [4] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x140;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }
*/
void phy_rf_write_cfg_dqxclk_cdr_lock_reset(void *p, unsigned int writeData)
{
	// cfg_dqxclk_cdr_lock_reset [4] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x140;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_piclk_cdr_lock_reset(void *p) {
   // cfg_piclk_cdr_lock_reset [3] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x140;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }
*/
void phy_rf_write_cfg_piclk_cdr_lock_reset(void *p, unsigned int writeData)
{
	// cfg_piclk_cdr_lock_reset [3] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x140;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_phyclk1x_cdr_lock_reset(void *p) {
   // cfg_phyclk1x_cdr_lock_reset [2] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x140;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }
*/
void phy_rf_write_cfg_phyclk1x_cdr_lock_reset(void *p, unsigned int writeData)
{
	// cfg_phyclk1x_cdr_lock_reset [2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x140;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_pcclk_cdr_lock_reset(void *p) {
   // cfg_pcclk_cdr_lock_reset [1] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x140;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }
*/
void phy_rf_write_cfg_pcclk_cdr_lock_reset(void *p, unsigned int writeData)
{
	// cfg_pcclk_cdr_lock_reset [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x140;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_mcclk_cdr_lock_reset(void *p) {
   // cfg_mcclk_cdr_lock_reset [0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x140;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_mcclk_cdr_lock_reset(void *p, unsigned int writeData)
{
	// cfg_mcclk_cdr_lock_reset [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x140;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_dqxclk_cdr_lock(void *p) {
   // cfg_dqxclk_cdr_lock [4] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x1;
   }

   void phy_rf_write_cfg_dqxclk_cdr_lock(void *p, unsigned int writeData) {
   // cfg_dqxclk_cdr_lock [4] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffef) | (~0xffffffef & (writeData << 4));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_piclk_cdr_lock(void *p) {
   // cfg_piclk_cdr_lock [3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x1;
   }

   void phy_rf_write_cfg_piclk_cdr_lock(void *p, unsigned int writeData) {
   // cfg_piclk_cdr_lock [3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff7) | (~0xfffffff7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_phyclk1x_cdr_lock(void *p) {
   // cfg_phyclk1x_cdr_lock [2] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x1;
   }

   void phy_rf_write_cfg_phyclk1x_cdr_lock(void *p, unsigned int writeData) {
   // cfg_phyclk1x_cdr_lock [2] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffb) | (~0xfffffffb & (writeData << 2));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_pcclk_cdr_lock(void *p) {
   // cfg_pcclk_cdr_lock [1] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 1) & 0x1;
   }

   void phy_rf_write_cfg_pcclk_cdr_lock(void *p, unsigned int writeData) {
   // cfg_pcclk_cdr_lock [1] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_mcclk_cdr_lock(void *p) {
   // cfg_mcclk_cdr_lock [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x144;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }
*/
void phy_rf_write_cfg_mcclk_cdr_lock(void *p, unsigned int writeData)
{
	// cfg_mcclk_cdr_lock [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x144;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_cdr_pi_out(void *p) {
   // cfg_cdr_pi_out [6:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x148;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_pi_out(void *p, unsigned int writeData) {
   // cfg_cdr_pi_out [6:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x148;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff80) | (~0xffffff80 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_3(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_3 [31:24] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_3 [31:24] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_2(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_2 [23:16] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_2 [23:16] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_1(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_1 [15:8] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_1 [15:8] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_0(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_0 [7:0] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_0 [7:0] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x14c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_7(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_7 [31:24] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_7 [31:24] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_6(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_6 [23:16] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_6 [23:16] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_5(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_5 [15:8] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_5 [15:8] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_4(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_4 [7:0] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_4 [7:0] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x150;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_8(void *p) {
   // cfg_rdlvl_gate_delay_pre_val_8 [7:0] RW 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x154;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_8(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay_pre_val_8 [7:0] RW 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x154;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_timeout_counter(void *p) {
   // cfg_timeout_counter [31:0] RW 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x158;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffffff;
   }
*/
void phy_rf_write_cfg_timeout_counter(void *p, unsigned int writeData)
{
	// cfg_timeout_counter [31:0] RW 0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0x158;
	phy_write_reg(mcu, regAddr, writeData);
}

/* ifdef _APM_FULL_KC_TASKS
   unsigned int phy_rf_read_cfg_trig_data(void *p) {
   // cfg_trig_data [31:16] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x15c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xffff;
   }

   void phy_rf_write_cfg_trig_data(void *p, unsigned int writeData) {
   // cfg_trig_data [31:16] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x15c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff) | (~0xffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_mask_data(void *p) {
   // cfg_mask_data [15:0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x15c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_cfg_mask_data(void *p, unsigned int writeData) {
   // cfg_mask_data [15:0] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x15c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_skip_samples(void *p) {
   // cfg_skip_samples [19:10] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x160;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 10) & 0x3ff;
   }

   void phy_rf_write_cfg_skip_samples(void *p, unsigned int writeData) {
   // cfg_skip_samples [19:10] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x160;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfff003ff) | (~0xfff003ff & (writeData << 10));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_num_samples(void *p) {
   // cfg_num_samples [9:0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x160;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3ff;
   }

   void phy_rf_write_cfg_num_samples(void *p, unsigned int writeData) {
   // cfg_num_samples [9:0] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x160;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffc00) | (~0xfffffc00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_initial_skip(void *p) {
   // cfg_initial_skip [31:0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x164;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffffffff;
   }

   void phy_rf_write_cfg_initial_skip(void *p, unsigned int writeData) {
   // cfg_initial_skip [31:0] RW 0x0
      unsigned int regAddr;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x164;
      phy_write_reg(mcu, regAddr, writeData);
   }

   unsigned int phy_rf_read_cfg_en_fifo_trig(void *p) {
   // cfg_en_fifo_trig [1:0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x168;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   void phy_rf_write_cfg_en_fifo_trig(void *p, unsigned int writeData) {
   // cfg_en_fifo_trig [1:0] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x168;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffc) | (~0xfffffffc & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_fifo_srst(void *p) {
   // cfg_fifo_srst [0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x16c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_fifo_srst(void *p, unsigned int writeData) {
   // cfg_fifo_srst [0] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x16c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_fifo_read(void *p) {
   // cfg_fifo_read [0] RW 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x170;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_fifo_read(void *p, unsigned int writeData) {
   // cfg_fifo_read [0] RW 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x170;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_fifo_empty(void *p) {
   // cfg_fifo_empty [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x174;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_fifo_empty(void *p, unsigned int writeData) {
   // cfg_fifo_empty [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x174;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_fifo_rdata(void *p) {
   // cfg_fifo_rdata [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x178;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xffff;
   }

   void phy_rf_write_cfg_fifo_rdata(void *p, unsigned int writeData) {
   // cfg_fifo_rdata [15:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x178;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff0000) | (~0xffff0000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_sampling_done(void *p) {
   // cfg_sampling_done [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x17c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x1;
   }

   void phy_rf_write_cfg_sampling_done(void *p, unsigned int writeData) {
   // cfg_sampling_done [0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x17c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_d_wt(void *p) {
   // m0_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_c_wt(void *p) {
   // m0_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_b_wt(void *p) {
   // m0_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_a_wt(void *p) {
   // m0_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x180;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_h_wt(void *p) {
   // m0_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_g_wt(void *p) {
   // m0_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_f_wt(void *p) {
   // m0_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_e_wt(void *p) {
   // m0_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m0_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m0_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x184;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_d_wt(void *p) {
   // m0_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_c_wt(void *p) {
   // m0_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_b_wt(void *p) {
   // m0_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_a_wt(void *p) {
   // m0_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x188;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_h_wt(void *p) {
   // m0_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_g_wt(void *p) {
   // m0_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_f_wt(void *p) {
   // m0_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_e_wt(void *p) {
   // m0_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m0_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m0_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x18c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_d_wt(void *p) {
   // m0_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_c_wt(void *p) {
   // m0_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_b_wt(void *p) {
   // m0_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_a_wt(void *p) {
   // m0_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x190;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_h_wt(void *p) {
   // m0_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_g_wt(void *p) {
   // m0_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_f_wt(void *p) {
   // m0_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_e_wt(void *p) {
   // m0_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m0_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m0_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x194;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_b_step(void *p) {
   // m0_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x198;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x198;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_a_step(void *p) {
   // m0_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x198;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x198;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_d_step(void *p) {
   // m0_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x19c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x19c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_c_step(void *p) {
   // m0_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x19c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x19c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_f_step(void *p) {
   // m0_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_e_step(void *p) {
   // m0_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_h_step(void *p) {
   // m0_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll0_quad_g_step(void *p) {
   // m0_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m0_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_b_step(void *p) {
   // m0_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_a_step(void *p) {
   // m0_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_d_step(void *p) {
   // m0_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_c_step(void *p) {
   // m0_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_f_step(void *p) {
   // m0_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_e_step(void *p) {
   // m0_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_h_step(void *p) {
   // m0_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll1_quad_g_step(void *p) {
   // m0_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m0_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_b_step(void *p) {
   // m0_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_a_step(void *p) {
   // m0_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_d_step(void *p) {
   // m0_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_c_step(void *p) {
   // m0_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_f_step(void *p) {
   // m0_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_e_step(void *p) {
   // m0_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_h_step(void *p) {
   // m0_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m0_dll2_quad_g_step(void *p) {
   // m0_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m0_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m0_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }
*/
/* ifdef _APM_FULL_KC_TASKS

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_7(void *p) {
   // cfg_rdlvl_trim_delay_0_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_6(void *p) {
   // cfg_rdlvl_trim_delay_0_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_5(void *p) {
   // cfg_rdlvl_trim_delay_0_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_4(void *p) {
   // cfg_rdlvl_trim_delay_0_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_3(void *p) {
   // cfg_rdlvl_trim_delay_0_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_2(void *p) {
   // cfg_rdlvl_trim_delay_0_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_1(void *p) {
   // cfg_rdlvl_trim_delay_0_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_0(void *p) {
   // cfg_rdlvl_trim_delay_0_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_0_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_7(void *p) {
   // cfg_wrlvl_trim_delay_0_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_6(void *p) {
   // cfg_wrlvl_trim_delay_0_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_5(void *p) {
   // cfg_wrlvl_trim_delay_0_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_4(void *p) {
   // cfg_wrlvl_trim_delay_0_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_3(void *p) {
   // cfg_wrlvl_trim_delay_0_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_2(void *p) {
   // cfg_wrlvl_trim_delay_0_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_1(void *p) {
   // cfg_wrlvl_trim_delay_0_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_0(void *p) {
   // cfg_wrlvl_trim_delay_0_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_0_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_0_1(void *p) {
   // cfg_wrdq_del_0_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_0_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_0_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_0_0(void *p) {
   // cfg_wrdq_del_0_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_0_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_0_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_0_1(void *p) {
   // cfg_del_eye0_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_0_0(void *p) {
   // cfg_del_eye0_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_0_1(void *p) {
   // cfg_del_eye1_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_0_0(void *p) {
   // cfg_del_eye1_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_0_1(void *p) {
   // cfg_del_eye2_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_0_0(void *p) {
   // cfg_del_eye2_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_0_1(void *p) {
   // cfg_del_eye3_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_0_0(void *p) {
   // cfg_del_eye3_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_0_1(void *p) {
   // cfg_del_eye4_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_0_0(void *p) {
   // cfg_del_eye4_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_0_1(void *p) {
   // cfg_del_eye5_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_0_0(void *p) {
   // cfg_del_eye5_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_0_1(void *p) {
   // cfg_del_eye6_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_0_0(void *p) {
   // cfg_del_eye6_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_0_1(void *p) {
   // cfg_del_eye7_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_0_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_0_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_0_0(void *p) {
   // cfg_del_eye7_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_0_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_0_0(void *p) {
   // cfg_rdlvl_delay0_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_0_1(void *p) {
   // cfg_rdlvl_delay0_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1f8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_0_0(void *p) {
   // cfg_rdlvl_gate_delay0_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1fc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x1fc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_0_1(void *p) {
   // cfg_rdlvl_gate_delay0_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x200;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x200;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_0_0(void *p) {
   // cfg_wrlvl_delay0_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x204;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x204;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_0_1(void *p) {
   // cfg_wrlvl_delay0_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x208;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x208;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_0_0(void *p) {
   // cfg_rdlvl_delay1_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x20c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x20c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_0_1(void *p) {
   // cfg_rdlvl_delay1_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x210;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x210;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_0_0(void *p) {
   // cfg_rdlvl_gate_delay1_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x214;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x214;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_0_1(void *p) {
   // cfg_rdlvl_gate_delay1_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x218;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x218;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_0_0(void *p) {
   // cfg_wrlvl_delay1_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x21c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x21c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_0_1(void *p) {
   // cfg_wrlvl_delay1_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x220;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x220;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_0_0(void *p) {
   // cfg_rdlvl_delay2_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x224;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x224;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_0_1(void *p) {
   // cfg_rdlvl_delay2_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x228;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x228;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_0_0(void *p) {
   // cfg_rdlvl_gate_delay2_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x22c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x22c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_0_1(void *p) {
   // cfg_rdlvl_gate_delay2_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x230;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x230;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_0_0(void *p) {
   // cfg_wrlvl_delay2_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x234;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x234;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_0_1(void *p) {
   // cfg_wrlvl_delay2_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x238;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x238;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_0_0(void *p) {
   // cfg_rdlvl_delay3_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x23c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x23c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_0_1(void *p) {
   // cfg_rdlvl_delay3_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x240;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x240;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_0_0(void *p) {
   // cfg_rdlvl_gate_delay3_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x244;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x244;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_0_1(void *p) {
   // cfg_rdlvl_gate_delay3_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x248;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x248;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_0_0(void *p) {
   // cfg_wrlvl_delay3_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x24c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x24c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_0_1(void *p) {
   // cfg_wrlvl_delay3_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x250;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x250;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_0_0(void *p) {
   // cfg_rdlvl_delay4_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x254;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x254;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_0_1(void *p) {
   // cfg_rdlvl_delay4_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x258;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x258;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_0_0(void *p) {
   // cfg_rdlvl_gate_delay4_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x25c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x25c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_0_1(void *p) {
   // cfg_rdlvl_gate_delay4_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x260;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x260;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_0_0(void *p) {
   // cfg_wrlvl_delay4_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x264;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x264;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_0_1(void *p) {
   // cfg_wrlvl_delay4_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x268;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x268;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_0_0(void *p) {
   // cfg_rdlvl_delay5_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x26c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x26c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_0_1(void *p) {
   // cfg_rdlvl_delay5_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x270;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x270;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_0_0(void *p) {
   // cfg_rdlvl_gate_delay5_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x274;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x274;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_0_1(void *p) {
   // cfg_rdlvl_gate_delay5_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x278;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x278;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_0_0(void *p) {
   // cfg_wrlvl_delay5_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x27c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x27c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_0_1(void *p) {
   // cfg_wrlvl_delay5_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x280;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x280;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_0_0(void *p) {
   // cfg_rdlvl_delay6_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x284;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x284;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_0_1(void *p) {
   // cfg_rdlvl_delay6_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x288;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x288;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_0_0(void *p) {
   // cfg_rdlvl_gate_delay6_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x28c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x28c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_0_1(void *p) {
   // cfg_rdlvl_gate_delay6_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x290;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x290;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_0_0(void *p) {
   // cfg_wrlvl_delay6_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x294;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x294;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_0_1(void *p) {
   // cfg_wrlvl_delay6_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x298;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x298;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_0_0(void *p) {
   // cfg_rdlvl_delay7_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x29c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_0_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x29c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_0_1(void *p) {
   // cfg_rdlvl_delay7_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_0_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_0_0(void *p) {
   // cfg_rdlvl_gate_delay7_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_0_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_0_1(void *p) {
   // cfg_rdlvl_gate_delay7_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_0_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_0_0(void *p) {
   // cfg_wrlvl_delay7_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_0_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_0_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_0_1(void *p) {
   // cfg_wrlvl_delay7_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_0_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_0_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_0(void *p) {
   // cfg_cdr_dqxclk_pi_out_0 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_0(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_0 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_0(void *p) {
   // cfg_dll0_peak_0 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_0(void *p, unsigned int writeData) {
   // cfg_dll0_peak_0 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_0(void *p) {
   // cfg_wrlvl_time_out_status_0 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_0(void *p) {
   // cfg_deskew_time_out_status_0 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_0(void *p) {
   // cfg_wrcal_time_out_status_0 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_0(void *p) {
   // cfg_rdlvl_time_out_status_0 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_0(void *p) {
   // cfg_rdlvl_gate_time_out_status_0 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x2b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m1_dll0_quad_d_wt(void *p) {
   // m1_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_c_wt(void *p) {
   // m1_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_b_wt(void *p) {
   // m1_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_a_wt(void *p) {
   // m1_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x300;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_h_wt(void *p) {
   // m1_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_g_wt(void *p) {
   // m1_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_f_wt(void *p) {
   // m1_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_e_wt(void *p) {
   // m1_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m1_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m1_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x304;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_d_wt(void *p) {
   // m1_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_c_wt(void *p) {
   // m1_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_b_wt(void *p) {
   // m1_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_a_wt(void *p) {
   // m1_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x308;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_h_wt(void *p) {
   // m1_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_g_wt(void *p) {
   // m1_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_f_wt(void *p) {
   // m1_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_e_wt(void *p) {
   // m1_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m1_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m1_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x30c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_d_wt(void *p) {
   // m1_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_c_wt(void *p) {
   // m1_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_b_wt(void *p) {
   // m1_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_a_wt(void *p) {
   // m1_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x310;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_h_wt(void *p) {
   // m1_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_g_wt(void *p) {
   // m1_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_f_wt(void *p) {
   // m1_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_e_wt(void *p) {
   // m1_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m1_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m1_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x314;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_b_step(void *p) {
   // m1_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x318;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x318;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_a_step(void *p) {
   // m1_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x318;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x318;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_d_step(void *p) {
   // m1_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x31c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x31c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_c_step(void *p) {
   // m1_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x31c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x31c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_f_step(void *p) {
   // m1_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x320;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x320;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_e_step(void *p) {
   // m1_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x320;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x320;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_h_step(void *p) {
   // m1_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x324;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x324;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll0_quad_g_step(void *p) {
   // m1_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x324;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m1_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x324;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_b_step(void *p) {
   // m1_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x328;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x328;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_a_step(void *p) {
   // m1_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x328;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x328;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_d_step(void *p) {
   // m1_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x32c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x32c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_c_step(void *p) {
   // m1_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x32c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x32c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_f_step(void *p) {
   // m1_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x330;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x330;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_e_step(void *p) {
   // m1_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x330;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x330;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_h_step(void *p) {
   // m1_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x334;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x334;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll1_quad_g_step(void *p) {
   // m1_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x334;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m1_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x334;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_b_step(void *p) {
   // m1_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x338;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x338;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_a_step(void *p) {
   // m1_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x338;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x338;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_d_step(void *p) {
   // m1_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x33c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x33c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_c_step(void *p) {
   // m1_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x33c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x33c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_f_step(void *p) {
   // m1_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x340;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x340;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_e_step(void *p) {
   // m1_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x340;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x340;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_h_step(void *p) {
   // m1_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x344;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x344;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m1_dll2_quad_g_step(void *p) {
   // m1_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x344;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m1_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m1_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x344;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_7(void *p) {
   // cfg_rdlvl_trim_delay_1_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_6(void *p) {
   // cfg_rdlvl_trim_delay_1_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_5(void *p) {
   // cfg_rdlvl_trim_delay_1_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_4(void *p) {
   // cfg_rdlvl_trim_delay_1_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_3(void *p) {
   // cfg_rdlvl_trim_delay_1_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_2(void *p) {
   // cfg_rdlvl_trim_delay_1_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_1(void *p) {
   // cfg_rdlvl_trim_delay_1_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_0(void *p) {
   // cfg_rdlvl_trim_delay_1_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_1_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x348;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_7(void *p) {
   // cfg_wrlvl_trim_delay_1_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_6(void *p) {
   // cfg_wrlvl_trim_delay_1_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_5(void *p) {
   // cfg_wrlvl_trim_delay_1_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_4(void *p) {
   // cfg_wrlvl_trim_delay_1_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_3(void *p) {
   // cfg_wrlvl_trim_delay_1_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_2(void *p) {
   // cfg_wrlvl_trim_delay_1_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_1(void *p) {
   // cfg_wrlvl_trim_delay_1_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_0(void *p) {
   // cfg_wrlvl_trim_delay_1_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_1_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x34c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_1_1(void *p) {
   // cfg_wrdq_del_1_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x350;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_1_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_1_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x350;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_1_0(void *p) {
   // cfg_wrdq_del_1_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x350;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_1_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_1_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x350;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_1_1(void *p) {
   // cfg_del_eye0_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x354;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x354;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_1_0(void *p) {
   // cfg_del_eye0_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x354;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x354;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_1_1(void *p) {
   // cfg_del_eye1_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x358;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x358;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_1_0(void *p) {
   // cfg_del_eye1_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x358;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x358;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_1_1(void *p) {
   // cfg_del_eye2_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x35c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x35c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_1_0(void *p) {
   // cfg_del_eye2_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x35c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x35c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_1_1(void *p) {
   // cfg_del_eye3_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x360;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x360;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_1_0(void *p) {
   // cfg_del_eye3_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x360;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x360;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_1_1(void *p) {
   // cfg_del_eye4_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x364;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x364;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_1_0(void *p) {
   // cfg_del_eye4_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x364;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x364;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_1_1(void *p) {
   // cfg_del_eye5_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x368;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x368;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_1_0(void *p) {
   // cfg_del_eye5_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x368;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x368;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_1_1(void *p) {
   // cfg_del_eye6_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x36c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x36c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_1_0(void *p) {
   // cfg_del_eye6_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x36c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x36c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_1_1(void *p) {
   // cfg_del_eye7_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x370;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_1_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_1_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x370;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_1_0(void *p) {
   // cfg_del_eye7_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x370;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_1_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x370;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_1_0(void *p) {
   // cfg_rdlvl_delay0_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x374;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x374;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_1_1(void *p) {
   // cfg_rdlvl_delay0_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x378;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x378;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_1_0(void *p) {
   // cfg_rdlvl_gate_delay0_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x37c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x37c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_1_1(void *p) {
   // cfg_rdlvl_gate_delay0_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x380;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x380;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_1_0(void *p) {
   // cfg_wrlvl_delay0_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x384;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x384;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_1_1(void *p) {
   // cfg_wrlvl_delay0_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x388;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x388;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_1_0(void *p) {
   // cfg_rdlvl_delay1_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x38c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_1_1(void *p) {
   // cfg_rdlvl_delay1_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x390;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x390;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_1_0(void *p) {
   // cfg_rdlvl_gate_delay1_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x394;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x394;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_1_1(void *p) {
   // cfg_rdlvl_gate_delay1_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x398;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x398;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_1_0(void *p) {
   // cfg_wrlvl_delay1_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x39c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x39c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_1_1(void *p) {
   // cfg_wrlvl_delay1_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_1_0(void *p) {
   // cfg_rdlvl_delay2_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_1_1(void *p) {
   // cfg_rdlvl_delay2_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_1_0(void *p) {
   // cfg_rdlvl_gate_delay2_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_1_1(void *p) {
   // cfg_rdlvl_gate_delay2_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_1_0(void *p) {
   // cfg_wrlvl_delay2_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_1_1(void *p) {
   // cfg_wrlvl_delay2_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_1_0(void *p) {
   // cfg_rdlvl_delay3_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_1_1(void *p) {
   // cfg_rdlvl_delay3_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_1_0(void *p) {
   // cfg_rdlvl_gate_delay3_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_1_1(void *p) {
   // cfg_rdlvl_gate_delay3_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_1_0(void *p) {
   // cfg_wrlvl_delay3_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_1_1(void *p) {
   // cfg_wrlvl_delay3_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_1_0(void *p) {
   // cfg_rdlvl_delay4_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_1_1(void *p) {
   // cfg_rdlvl_delay4_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_1_0(void *p) {
   // cfg_rdlvl_gate_delay4_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_1_1(void *p) {
   // cfg_rdlvl_gate_delay4_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_1_0(void *p) {
   // cfg_wrlvl_delay4_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_1_1(void *p) {
   // cfg_wrlvl_delay4_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_1_0(void *p) {
   // cfg_rdlvl_delay5_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_1_1(void *p) {
   // cfg_rdlvl_delay5_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_1_0(void *p) {
   // cfg_rdlvl_gate_delay5_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3f4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3f4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_1_1(void *p) {
   // cfg_rdlvl_gate_delay5_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3f8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3f8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_1_0(void *p) {
   // cfg_wrlvl_delay5_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3fc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x3fc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_1_1(void *p) {
   // cfg_wrlvl_delay5_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x400;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x400;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_1_0(void *p) {
   // cfg_rdlvl_delay6_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x404;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x404;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_1_1(void *p) {
   // cfg_rdlvl_delay6_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x408;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x408;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_1_0(void *p) {
   // cfg_rdlvl_gate_delay6_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x40c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_1_1(void *p) {
   // cfg_rdlvl_gate_delay6_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x410;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x410;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_1_0(void *p) {
   // cfg_wrlvl_delay6_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x414;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x414;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_1_1(void *p) {
   // cfg_wrlvl_delay6_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x418;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x418;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_1_0(void *p) {
   // cfg_rdlvl_delay7_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x41c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_1_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x41c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_1_1(void *p) {
   // cfg_rdlvl_delay7_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x420;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_1_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x420;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_1_0(void *p) {
   // cfg_rdlvl_gate_delay7_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x424;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_1_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x424;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_1_1(void *p) {
   // cfg_rdlvl_gate_delay7_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x428;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_1_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x428;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_1_0(void *p) {
   // cfg_wrlvl_delay7_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x42c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_1_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_1_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x42c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_1_1(void *p) {
   // cfg_wrlvl_delay7_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x430;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_1_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_1_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x430;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_1(void *p) {
   // cfg_cdr_dqxclk_pi_out_1 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x434;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_1(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_1 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x434;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_1(void *p) {
   // cfg_dll0_peak_1 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x434;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_1(void *p, unsigned int writeData) {
   // cfg_dll0_peak_1 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x434;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_1(void *p) {
   // cfg_wrlvl_time_out_status_1 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x438;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_1(void *p) {
   // cfg_deskew_time_out_status_1 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x438;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_1(void *p) {
   // cfg_wrcal_time_out_status_1 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x438;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_1(void *p) {
   // cfg_rdlvl_time_out_status_1 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x438;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_1(void *p) {
   // cfg_rdlvl_gate_time_out_status_1 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x438;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m2_dll0_quad_d_wt(void *p) {
   // m2_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_c_wt(void *p) {
   // m2_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_b_wt(void *p) {
   // m2_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_a_wt(void *p) {
   // m2_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x480;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_h_wt(void *p) {
   // m2_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_g_wt(void *p) {
   // m2_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_f_wt(void *p) {
   // m2_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_e_wt(void *p) {
   // m2_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m2_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m2_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x484;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_d_wt(void *p) {
   // m2_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_c_wt(void *p) {
   // m2_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_b_wt(void *p) {
   // m2_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_a_wt(void *p) {
   // m2_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x488;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_h_wt(void *p) {
   // m2_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_g_wt(void *p) {
   // m2_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_f_wt(void *p) {
   // m2_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_e_wt(void *p) {
   // m2_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m2_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m2_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x48c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_d_wt(void *p) {
   // m2_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_c_wt(void *p) {
   // m2_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_b_wt(void *p) {
   // m2_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_a_wt(void *p) {
   // m2_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x490;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_h_wt(void *p) {
   // m2_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_g_wt(void *p) {
   // m2_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_f_wt(void *p) {
   // m2_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_e_wt(void *p) {
   // m2_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m2_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m2_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x494;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_b_step(void *p) {
   // m2_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x498;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x498;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_a_step(void *p) {
   // m2_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x498;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x498;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_d_step(void *p) {
   // m2_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x49c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x49c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_c_step(void *p) {
   // m2_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x49c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x49c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_f_step(void *p) {
   // m2_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_e_step(void *p) {
   // m2_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_h_step(void *p) {
   // m2_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll0_quad_g_step(void *p) {
   // m2_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m2_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_b_step(void *p) {
   // m2_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_a_step(void *p) {
   // m2_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_d_step(void *p) {
   // m2_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_c_step(void *p) {
   // m2_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_f_step(void *p) {
   // m2_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_e_step(void *p) {
   // m2_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_h_step(void *p) {
   // m2_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll1_quad_g_step(void *p) {
   // m2_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m2_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_b_step(void *p) {
   // m2_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_a_step(void *p) {
   // m2_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_d_step(void *p) {
   // m2_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_c_step(void *p) {
   // m2_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_f_step(void *p) {
   // m2_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_e_step(void *p) {
   // m2_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_h_step(void *p) {
   // m2_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m2_dll2_quad_g_step(void *p) {
   // m2_dll2_quad_g_step [10:0] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m2_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m2_dll2_quad_g_step [10:0] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_7(void *p) {
   // cfg_rdlvl_trim_delay_2_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_6(void *p) {
   // cfg_rdlvl_trim_delay_2_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_5(void *p) {
   // cfg_rdlvl_trim_delay_2_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_4(void *p) {
   // cfg_rdlvl_trim_delay_2_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_3(void *p) {
   // cfg_rdlvl_trim_delay_2_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_2(void *p) {
   // cfg_rdlvl_trim_delay_2_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_1(void *p) {
   // cfg_rdlvl_trim_delay_2_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_0(void *p) {
   // cfg_rdlvl_trim_delay_2_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_2_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_7(void *p) {
   // cfg_wrlvl_trim_delay_2_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_6(void *p) {
   // cfg_wrlvl_trim_delay_2_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_5(void *p) {
   // cfg_wrlvl_trim_delay_2_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_4(void *p) {
   // cfg_wrlvl_trim_delay_2_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_3(void *p) {
   // cfg_wrlvl_trim_delay_2_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_2(void *p) {
   // cfg_wrlvl_trim_delay_2_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_1(void *p) {
   // cfg_wrlvl_trim_delay_2_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_0(void *p) {
   // cfg_wrlvl_trim_delay_2_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_2_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_2_1(void *p) {
   // cfg_wrdq_del_2_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_2_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_2_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_2_0(void *p) {
   // cfg_wrdq_del_2_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_2_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_2_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_2_1(void *p) {
   // cfg_del_eye0_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_2_0(void *p) {
   // cfg_del_eye0_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_2_1(void *p) {
   // cfg_del_eye1_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_2_0(void *p) {
   // cfg_del_eye1_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_2_1(void *p) {
   // cfg_del_eye2_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_2_0(void *p) {
   // cfg_del_eye2_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_2_1(void *p) {
   // cfg_del_eye3_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_2_0(void *p) {
   // cfg_del_eye3_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_2_1(void *p) {
   // cfg_del_eye4_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_2_0(void *p) {
   // cfg_del_eye4_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_2_1(void *p) {
   // cfg_del_eye5_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_2_0(void *p) {
   // cfg_del_eye5_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_2_1(void *p) {
   // cfg_del_eye6_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_2_0(void *p) {
   // cfg_del_eye6_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_2_1(void *p) {
   // cfg_del_eye7_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_2_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_2_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_2_0(void *p) {
   // cfg_del_eye7_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_2_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_2_0(void *p) {
   // cfg_rdlvl_delay0_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_2_1(void *p) {
   // cfg_rdlvl_delay0_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4f8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_2_0(void *p) {
   // cfg_rdlvl_gate_delay0_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4fc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x4fc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_2_1(void *p) {
   // cfg_rdlvl_gate_delay0_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x500;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x500;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_2_0(void *p) {
   // cfg_wrlvl_delay0_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x504;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x504;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_2_1(void *p) {
   // cfg_wrlvl_delay0_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x508;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x508;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_2_0(void *p) {
   // cfg_rdlvl_delay1_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x50c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x50c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_2_1(void *p) {
   // cfg_rdlvl_delay1_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x510;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x510;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_2_0(void *p) {
   // cfg_rdlvl_gate_delay1_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x514;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x514;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_2_1(void *p) {
   // cfg_rdlvl_gate_delay1_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x518;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x518;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_2_0(void *p) {
   // cfg_wrlvl_delay1_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x51c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x51c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_2_1(void *p) {
   // cfg_wrlvl_delay1_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x520;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x520;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_2_0(void *p) {
   // cfg_rdlvl_delay2_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x524;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x524;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_2_1(void *p) {
   // cfg_rdlvl_delay2_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x528;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x528;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_2_0(void *p) {
   // cfg_rdlvl_gate_delay2_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x52c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x52c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_2_1(void *p) {
   // cfg_rdlvl_gate_delay2_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x530;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x530;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_2_0(void *p) {
   // cfg_wrlvl_delay2_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x534;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x534;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_2_1(void *p) {
   // cfg_wrlvl_delay2_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x538;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x538;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_2_0(void *p) {
   // cfg_rdlvl_delay3_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x53c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x53c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_2_1(void *p) {
   // cfg_rdlvl_delay3_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x540;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x540;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_2_0(void *p) {
   // cfg_rdlvl_gate_delay3_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x544;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x544;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_2_1(void *p) {
   // cfg_rdlvl_gate_delay3_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x548;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x548;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_2_0(void *p) {
   // cfg_wrlvl_delay3_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x54c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x54c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_2_1(void *p) {
   // cfg_wrlvl_delay3_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x550;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x550;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_2_0(void *p) {
   // cfg_rdlvl_delay4_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x554;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x554;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_2_1(void *p) {
   // cfg_rdlvl_delay4_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x558;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x558;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_2_0(void *p) {
   // cfg_rdlvl_gate_delay4_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x55c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x55c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_2_1(void *p) {
   // cfg_rdlvl_gate_delay4_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x560;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x560;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_2_0(void *p) {
   // cfg_wrlvl_delay4_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x564;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x564;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_2_1(void *p) {
   // cfg_wrlvl_delay4_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x568;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x568;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_2_0(void *p) {
   // cfg_rdlvl_delay5_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x56c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x56c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_2_1(void *p) {
   // cfg_rdlvl_delay5_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x570;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x570;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_2_0(void *p) {
   // cfg_rdlvl_gate_delay5_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x574;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x574;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_2_1(void *p) {
   // cfg_rdlvl_gate_delay5_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x578;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x578;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_2_0(void *p) {
   // cfg_wrlvl_delay5_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x57c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x57c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_2_1(void *p) {
   // cfg_wrlvl_delay5_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x580;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x580;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_2_0(void *p) {
   // cfg_rdlvl_delay6_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x584;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x584;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_2_1(void *p) {
   // cfg_rdlvl_delay6_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x588;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x588;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_2_0(void *p) {
   // cfg_rdlvl_gate_delay6_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x58c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x58c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_2_1(void *p) {
   // cfg_rdlvl_gate_delay6_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x590;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x590;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_2_0(void *p) {
   // cfg_wrlvl_delay6_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x594;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x594;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_2_1(void *p) {
   // cfg_wrlvl_delay6_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x598;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x598;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_2_0(void *p) {
   // cfg_rdlvl_delay7_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x59c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_2_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x59c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_2_1(void *p) {
   // cfg_rdlvl_delay7_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_2_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_2_0(void *p) {
   // cfg_rdlvl_gate_delay7_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_2_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_2_1(void *p) {
   // cfg_rdlvl_gate_delay7_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_2_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_2_0(void *p) {
   // cfg_wrlvl_delay7_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_2_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_2_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_2_1(void *p) {
   // cfg_wrlvl_delay7_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_2_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_2_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_2(void *p) {
   // cfg_cdr_dqxclk_pi_out_2 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_2(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_2 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_2(void *p) {
   // cfg_dll0_peak_2 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_2(void *p, unsigned int writeData) {
   // cfg_dll0_peak_2 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_2(void *p) {
   // cfg_wrlvl_time_out_status_2 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_2(void *p) {
   // cfg_deskew_time_out_status_2 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_2(void *p) {
   // cfg_wrcal_time_out_status_2 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_2(void *p) {
   // cfg_rdlvl_time_out_status_2 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_2(void *p) {
   // cfg_rdlvl_gate_time_out_status_2 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x5b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m3_dll0_quad_d_wt(void *p) {
   // m3_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_c_wt(void *p) {
   // m3_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_b_wt(void *p) {
   // m3_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_a_wt(void *p) {
   // m3_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x600;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_h_wt(void *p) {
   // m3_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_g_wt(void *p) {
   // m3_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_f_wt(void *p) {
   // m3_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_e_wt(void *p) {
   // m3_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m3_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m3_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x604;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_d_wt(void *p) {
   // m3_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_c_wt(void *p) {
   // m3_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_b_wt(void *p) {
   // m3_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_a_wt(void *p) {
   // m3_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x608;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_h_wt(void *p) {
   // m3_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_g_wt(void *p) {
   // m3_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_f_wt(void *p) {
   // m3_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_e_wt(void *p) {
   // m3_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m3_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m3_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x60c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_d_wt(void *p) {
   // m3_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_c_wt(void *p) {
   // m3_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_b_wt(void *p) {
   // m3_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_a_wt(void *p) {
   // m3_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x610;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_h_wt(void *p) {
   // m3_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_g_wt(void *p) {
   // m3_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_f_wt(void *p) {
   // m3_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_e_wt(void *p) {
   // m3_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m3_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m3_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x614;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_b_step(void *p) {
   // m3_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x618;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x618;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_a_step(void *p) {
   // m3_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x618;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x618;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_d_step(void *p) {
   // m3_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x61c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x61c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_c_step(void *p) {
   // m3_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x61c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x61c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_f_step(void *p) {
   // m3_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x620;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x620;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_e_step(void *p) {
   // m3_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x620;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x620;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_h_step(void *p) {
   // m3_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x624;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x624;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll0_quad_g_step(void *p) {
   // m3_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x624;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m3_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x624;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_b_step(void *p) {
   // m3_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x628;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x628;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_a_step(void *p) {
   // m3_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x628;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x628;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_d_step(void *p) {
   // m3_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x62c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x62c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_c_step(void *p) {
   // m3_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x62c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x62c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_f_step(void *p) {
   // m3_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x630;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x630;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_e_step(void *p) {
   // m3_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x630;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x630;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_h_step(void *p) {
   // m3_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x634;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x634;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll1_quad_g_step(void *p) {
   // m3_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x634;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m3_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x634;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_b_step(void *p) {
   // m3_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x638;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x638;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_a_step(void *p) {
   // m3_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x638;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x638;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_d_step(void *p) {
   // m3_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x63c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x63c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_c_step(void *p) {
   // m3_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x63c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x63c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_f_step(void *p) {
   // m3_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x640;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x640;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_e_step(void *p) {
   // m3_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x640;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x640;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_h_step(void *p) {
   // m3_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x644;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x644;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m3_dll2_quad_g_step(void *p) {
   // m3_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x644;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m3_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m3_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x644;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_7(void *p) {
   // cfg_rdlvl_trim_delay_3_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_6(void *p) {
   // cfg_rdlvl_trim_delay_3_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_5(void *p) {
   // cfg_rdlvl_trim_delay_3_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_4(void *p) {
   // cfg_rdlvl_trim_delay_3_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_3(void *p) {
   // cfg_rdlvl_trim_delay_3_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_2(void *p) {
   // cfg_rdlvl_trim_delay_3_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_1(void *p) {
   // cfg_rdlvl_trim_delay_3_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_0(void *p) {
   // cfg_rdlvl_trim_delay_3_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_3_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x648;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_7(void *p) {
   // cfg_wrlvl_trim_delay_3_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_6(void *p) {
   // cfg_wrlvl_trim_delay_3_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_5(void *p) {
   // cfg_wrlvl_trim_delay_3_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_4(void *p) {
   // cfg_wrlvl_trim_delay_3_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_3(void *p) {
   // cfg_wrlvl_trim_delay_3_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_2(void *p) {
   // cfg_wrlvl_trim_delay_3_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_1(void *p) {
   // cfg_wrlvl_trim_delay_3_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_0(void *p) {
   // cfg_wrlvl_trim_delay_3_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_3_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x64c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_3_1(void *p) {
   // cfg_wrdq_del_3_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x650;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_3_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_3_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x650;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_3_0(void *p) {
   // cfg_wrdq_del_3_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x650;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_3_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_3_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x650;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_3_1(void *p) {
   // cfg_del_eye0_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x654;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x654;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_3_0(void *p) {
   // cfg_del_eye0_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x654;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x654;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_3_1(void *p) {
   // cfg_del_eye1_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x658;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x658;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_3_0(void *p) {
   // cfg_del_eye1_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x658;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x658;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_3_1(void *p) {
   // cfg_del_eye2_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x65c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x65c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_3_0(void *p) {
   // cfg_del_eye2_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x65c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x65c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_3_1(void *p) {
   // cfg_del_eye3_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x660;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x660;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_3_0(void *p) {
   // cfg_del_eye3_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x660;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x660;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_3_1(void *p) {
   // cfg_del_eye4_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x664;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x664;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_3_0(void *p) {
   // cfg_del_eye4_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x664;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x664;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_3_1(void *p) {
   // cfg_del_eye5_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x668;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x668;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_3_0(void *p) {
   // cfg_del_eye5_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x668;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x668;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_3_1(void *p) {
   // cfg_del_eye6_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x66c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x66c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_3_0(void *p) {
   // cfg_del_eye6_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x66c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x66c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_3_1(void *p) {
   // cfg_del_eye7_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x670;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_3_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_3_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x670;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_3_0(void *p) {
   // cfg_del_eye7_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x670;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_3_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x670;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_3_0(void *p) {
   // cfg_rdlvl_delay0_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x674;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x674;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_3_1(void *p) {
   // cfg_rdlvl_delay0_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x678;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x678;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_3_0(void *p) {
   // cfg_rdlvl_gate_delay0_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x67c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x67c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_3_1(void *p) {
   // cfg_rdlvl_gate_delay0_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x680;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x680;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_3_0(void *p) {
   // cfg_wrlvl_delay0_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x684;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x684;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_3_1(void *p) {
   // cfg_wrlvl_delay0_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x688;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x688;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_3_0(void *p) {
   // cfg_rdlvl_delay1_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x68c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_3_1(void *p) {
   // cfg_rdlvl_delay1_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x690;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x690;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_3_0(void *p) {
   // cfg_rdlvl_gate_delay1_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x694;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x694;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_3_1(void *p) {
   // cfg_rdlvl_gate_delay1_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x698;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x698;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_3_0(void *p) {
   // cfg_wrlvl_delay1_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x69c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x69c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_3_1(void *p) {
   // cfg_wrlvl_delay1_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_3_0(void *p) {
   // cfg_rdlvl_delay2_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_3_1(void *p) {
   // cfg_rdlvl_delay2_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_3_0(void *p) {
   // cfg_rdlvl_gate_delay2_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_3_1(void *p) {
   // cfg_rdlvl_gate_delay2_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_3_0(void *p) {
   // cfg_wrlvl_delay2_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_3_1(void *p) {
   // cfg_wrlvl_delay2_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_3_0(void *p) {
   // cfg_rdlvl_delay3_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_3_1(void *p) {
   // cfg_rdlvl_delay3_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_3_0(void *p) {
   // cfg_rdlvl_gate_delay3_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_3_1(void *p) {
   // cfg_rdlvl_gate_delay3_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_3_0(void *p) {
   // cfg_wrlvl_delay3_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_3_1(void *p) {
   // cfg_wrlvl_delay3_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_3_0(void *p) {
   // cfg_rdlvl_delay4_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_3_1(void *p) {
   // cfg_rdlvl_delay4_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_3_0(void *p) {
   // cfg_rdlvl_gate_delay4_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_3_1(void *p) {
   // cfg_rdlvl_gate_delay4_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_3_0(void *p) {
   // cfg_wrlvl_delay4_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_3_1(void *p) {
   // cfg_wrlvl_delay4_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_3_0(void *p) {
   // cfg_rdlvl_delay5_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_3_1(void *p) {
   // cfg_rdlvl_delay5_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_3_0(void *p) {
   // cfg_rdlvl_gate_delay5_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6f4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6f4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_3_1(void *p) {
   // cfg_rdlvl_gate_delay5_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6f8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6f8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_3_0(void *p) {
   // cfg_wrlvl_delay5_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6fc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x6fc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_3_1(void *p) {
   // cfg_wrlvl_delay5_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x700;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x700;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_3_0(void *p) {
   // cfg_rdlvl_delay6_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x704;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x704;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_3_1(void *p) {
   // cfg_rdlvl_delay6_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x708;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x708;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_3_0(void *p) {
   // cfg_rdlvl_gate_delay6_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x70c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x70c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_3_1(void *p) {
   // cfg_rdlvl_gate_delay6_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x710;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x710;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_3_0(void *p) {
   // cfg_wrlvl_delay6_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x714;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x714;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_3_1(void *p) {
   // cfg_wrlvl_delay6_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x718;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x718;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_3_0(void *p) {
   // cfg_rdlvl_delay7_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x71c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_3_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x71c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_3_1(void *p) {
   // cfg_rdlvl_delay7_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x720;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_3_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x720;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_3_0(void *p) {
   // cfg_rdlvl_gate_delay7_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x724;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_3_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x724;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_3_1(void *p) {
   // cfg_rdlvl_gate_delay7_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x728;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_3_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x728;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_3_0(void *p) {
   // cfg_wrlvl_delay7_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x72c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_3_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_3_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x72c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_3_1(void *p) {
   // cfg_wrlvl_delay7_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x730;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_3_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_3_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x730;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_3(void *p) {
   // cfg_cdr_dqxclk_pi_out_3 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x734;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_3(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_3 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x734;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_3(void *p) {
   // cfg_dll0_peak_3 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x734;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_3(void *p, unsigned int writeData) {
   // cfg_dll0_peak_3 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x734;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_3(void *p) {
   // cfg_wrlvl_time_out_status_3 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x738;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_3(void *p) {
   // cfg_deskew_time_out_status_3 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x738;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_3(void *p) {
   // cfg_wrcal_time_out_status_3 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x738;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_3(void *p) {
   // cfg_rdlvl_time_out_status_3 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x738;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_3(void *p) {
   // cfg_rdlvl_gate_time_out_status_3 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x738;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m4_dll0_quad_d_wt(void *p) {
   // m4_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_c_wt(void *p) {
   // m4_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_b_wt(void *p) {
   // m4_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_a_wt(void *p) {
   // m4_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x780;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_h_wt(void *p) {
   // m4_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_g_wt(void *p) {
   // m4_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_f_wt(void *p) {
   // m4_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_e_wt(void *p) {
   // m4_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m4_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m4_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x784;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_d_wt(void *p) {
   // m4_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_c_wt(void *p) {
   // m4_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_b_wt(void *p) {
   // m4_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_a_wt(void *p) {
   // m4_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x788;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_h_wt(void *p) {
   // m4_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_g_wt(void *p) {
   // m4_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_f_wt(void *p) {
   // m4_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_e_wt(void *p) {
   // m4_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m4_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m4_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x78c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_d_wt(void *p) {
   // m4_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_c_wt(void *p) {
   // m4_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_b_wt(void *p) {
   // m4_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_a_wt(void *p) {
   // m4_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x790;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_h_wt(void *p) {
   // m4_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_g_wt(void *p) {
   // m4_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_f_wt(void *p) {
   // m4_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_e_wt(void *p) {
   // m4_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m4_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m4_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x794;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_b_step(void *p) {
   // m4_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x798;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x798;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_a_step(void *p) {
   // m4_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x798;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x798;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_d_step(void *p) {
   // m4_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x79c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x79c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_c_step(void *p) {
   // m4_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x79c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x79c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_f_step(void *p) {
   // m4_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_e_step(void *p) {
   // m4_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_h_step(void *p) {
   // m4_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll0_quad_g_step(void *p) {
   // m4_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m4_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_b_step(void *p) {
   // m4_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_a_step(void *p) {
   // m4_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_d_step(void *p) {
   // m4_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_c_step(void *p) {
   // m4_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_f_step(void *p) {
   // m4_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_e_step(void *p) {
   // m4_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_h_step(void *p) {
   // m4_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll1_quad_g_step(void *p) {
   // m4_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m4_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_b_step(void *p) {
   // m4_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_a_step(void *p) {
   // m4_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_d_step(void *p) {
   // m4_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_c_step(void *p) {
   // m4_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_f_step(void *p) {
   // m4_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_e_step(void *p) {
   // m4_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_h_step(void *p) {
   // m4_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m4_dll2_quad_g_step(void *p) {
   // m4_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m4_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m4_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_7(void *p) {
   // cfg_rdlvl_trim_delay_4_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_6(void *p) {
   // cfg_rdlvl_trim_delay_4_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_5(void *p) {
   // cfg_rdlvl_trim_delay_4_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_4(void *p) {
   // cfg_rdlvl_trim_delay_4_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_3(void *p) {
   // cfg_rdlvl_trim_delay_4_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_2(void *p) {
   // cfg_rdlvl_trim_delay_4_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_1(void *p) {
   // cfg_rdlvl_trim_delay_4_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_0(void *p) {
   // cfg_rdlvl_trim_delay_4_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_4_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_7(void *p) {
   // cfg_wrlvl_trim_delay_4_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_6(void *p) {
   // cfg_wrlvl_trim_delay_4_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_5(void *p) {
   // cfg_wrlvl_trim_delay_4_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_4(void *p) {
   // cfg_wrlvl_trim_delay_4_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_3(void *p) {
   // cfg_wrlvl_trim_delay_4_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_2(void *p) {
   // cfg_wrlvl_trim_delay_4_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_1(void *p) {
   // cfg_wrlvl_trim_delay_4_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_0(void *p) {
   // cfg_wrlvl_trim_delay_4_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_4_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_4_1(void *p) {
   // cfg_wrdq_del_4_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_4_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_4_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_4_0(void *p) {
   // cfg_wrdq_del_4_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_4_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_4_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_4_1(void *p) {
   // cfg_del_eye0_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_4_0(void *p) {
   // cfg_del_eye0_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_4_1(void *p) {
   // cfg_del_eye1_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_4_0(void *p) {
   // cfg_del_eye1_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_4_1(void *p) {
   // cfg_del_eye2_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_4_0(void *p) {
   // cfg_del_eye2_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_4_1(void *p) {
   // cfg_del_eye3_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_4_0(void *p) {
   // cfg_del_eye3_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_4_1(void *p) {
   // cfg_del_eye4_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_4_0(void *p) {
   // cfg_del_eye4_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_4_1(void *p) {
   // cfg_del_eye5_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_4_0(void *p) {
   // cfg_del_eye5_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_4_1(void *p) {
   // cfg_del_eye6_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_4_0(void *p) {
   // cfg_del_eye6_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_4_1(void *p) {
   // cfg_del_eye7_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_4_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_4_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_4_0(void *p) {
   // cfg_del_eye7_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_4_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_4_0(void *p) {
   // cfg_rdlvl_delay0_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_4_1(void *p) {
   // cfg_rdlvl_delay0_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7f8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_4_0(void *p) {
   // cfg_rdlvl_gate_delay0_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7fc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x7fc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_4_1(void *p) {
   // cfg_rdlvl_gate_delay0_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x800;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x800;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_4_0(void *p) {
   // cfg_wrlvl_delay0_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x804;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x804;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_4_1(void *p) {
   // cfg_wrlvl_delay0_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x808;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x808;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_4_0(void *p) {
   // cfg_rdlvl_delay1_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x80c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x80c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_4_1(void *p) {
   // cfg_rdlvl_delay1_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x810;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x810;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_4_0(void *p) {
   // cfg_rdlvl_gate_delay1_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x814;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x814;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_4_1(void *p) {
   // cfg_rdlvl_gate_delay1_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x818;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x818;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_4_0(void *p) {
   // cfg_wrlvl_delay1_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x81c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x81c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_4_1(void *p) {
   // cfg_wrlvl_delay1_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x820;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x820;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_4_0(void *p) {
   // cfg_rdlvl_delay2_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x824;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x824;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_4_1(void *p) {
   // cfg_rdlvl_delay2_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x828;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x828;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_4_0(void *p) {
   // cfg_rdlvl_gate_delay2_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x82c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x82c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_4_1(void *p) {
   // cfg_rdlvl_gate_delay2_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x830;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x830;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_4_0(void *p) {
   // cfg_wrlvl_delay2_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x834;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x834;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_4_1(void *p) {
   // cfg_wrlvl_delay2_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x838;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x838;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_4_0(void *p) {
   // cfg_rdlvl_delay3_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x83c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x83c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_4_1(void *p) {
   // cfg_rdlvl_delay3_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x840;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x840;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_4_0(void *p) {
   // cfg_rdlvl_gate_delay3_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x844;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x844;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_4_1(void *p) {
   // cfg_rdlvl_gate_delay3_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x848;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x848;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_4_0(void *p) {
   // cfg_wrlvl_delay3_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x84c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x84c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_4_1(void *p) {
   // cfg_wrlvl_delay3_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x850;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x850;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_4_0(void *p) {
   // cfg_rdlvl_delay4_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x854;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x854;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_4_1(void *p) {
   // cfg_rdlvl_delay4_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x858;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x858;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_4_0(void *p) {
   // cfg_rdlvl_gate_delay4_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x85c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x85c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_4_1(void *p) {
   // cfg_rdlvl_gate_delay4_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x860;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x860;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_4_0(void *p) {
   // cfg_wrlvl_delay4_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x864;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x864;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_4_1(void *p) {
   // cfg_wrlvl_delay4_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x868;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x868;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_4_0(void *p) {
   // cfg_rdlvl_delay5_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x86c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x86c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_4_1(void *p) {
   // cfg_rdlvl_delay5_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x870;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x870;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_4_0(void *p) {
   // cfg_rdlvl_gate_delay5_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x874;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x874;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_4_1(void *p) {
   // cfg_rdlvl_gate_delay5_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x878;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x878;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_4_0(void *p) {
   // cfg_wrlvl_delay5_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x87c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x87c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_4_1(void *p) {
   // cfg_wrlvl_delay5_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x880;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x880;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_4_0(void *p) {
   // cfg_rdlvl_delay6_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x884;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x884;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_4_1(void *p) {
   // cfg_rdlvl_delay6_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x888;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x888;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_4_0(void *p) {
   // cfg_rdlvl_gate_delay6_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x88c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x88c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_4_1(void *p) {
   // cfg_rdlvl_gate_delay6_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x890;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x890;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_4_0(void *p) {
   // cfg_wrlvl_delay6_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x894;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x894;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_4_1(void *p) {
   // cfg_wrlvl_delay6_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x898;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x898;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_4_0(void *p) {
   // cfg_rdlvl_delay7_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x89c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_4_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x89c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_4_1(void *p) {
   // cfg_rdlvl_delay7_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_4_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_4_0(void *p) {
   // cfg_rdlvl_gate_delay7_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_4_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_4_1(void *p) {
   // cfg_rdlvl_gate_delay7_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_4_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_4_0(void *p) {
   // cfg_wrlvl_delay7_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_4_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_4_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_4_1(void *p) {
   // cfg_wrlvl_delay7_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_4_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_4_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_4(void *p) {
   // cfg_cdr_dqxclk_pi_out_4 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_4(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_4 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_4(void *p) {
   // cfg_dll0_peak_4 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_4(void *p, unsigned int writeData) {
   // cfg_dll0_peak_4 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_4(void *p) {
   // cfg_wrlvl_time_out_status_4 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_4(void *p) {
   // cfg_deskew_time_out_status_4 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_4(void *p) {
   // cfg_wrcal_time_out_status_4 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_4(void *p) {
   // cfg_rdlvl_time_out_status_4 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_4(void *p) {
   // cfg_rdlvl_gate_time_out_status_4 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x8b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m5_dll0_quad_d_wt(void *p) {
   // m5_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_c_wt(void *p) {
   // m5_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_b_wt(void *p) {
   // m5_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_a_wt(void *p) {
   // m5_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x900;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_h_wt(void *p) {
   // m5_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_g_wt(void *p) {
   // m5_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_f_wt(void *p) {
   // m5_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_e_wt(void *p) {
   // m5_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m5_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m5_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x904;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_d_wt(void *p) {
   // m5_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_c_wt(void *p) {
   // m5_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_b_wt(void *p) {
   // m5_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_a_wt(void *p) {
   // m5_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x908;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_h_wt(void *p) {
   // m5_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_g_wt(void *p) {
   // m5_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_f_wt(void *p) {
   // m5_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_e_wt(void *p) {
   // m5_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m5_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m5_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x90c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_d_wt(void *p) {
   // m5_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_c_wt(void *p) {
   // m5_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_b_wt(void *p) {
   // m5_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_a_wt(void *p) {
   // m5_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x910;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_h_wt(void *p) {
   // m5_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_g_wt(void *p) {
   // m5_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_f_wt(void *p) {
   // m5_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_e_wt(void *p) {
   // m5_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m5_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m5_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x914;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_b_step(void *p) {
   // m5_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x918;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x918;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_a_step(void *p) {
   // m5_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x918;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x918;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_d_step(void *p) {
   // m5_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x91c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x91c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_c_step(void *p) {
   // m5_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x91c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x91c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_f_step(void *p) {
   // m5_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x920;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x920;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_e_step(void *p) {
   // m5_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x920;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x920;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_h_step(void *p) {
   // m5_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x924;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x924;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll0_quad_g_step(void *p) {
   // m5_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x924;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m5_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x924;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_b_step(void *p) {
   // m5_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x928;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x928;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_a_step(void *p) {
   // m5_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x928;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x928;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_d_step(void *p) {
   // m5_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x92c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x92c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_c_step(void *p) {
   // m5_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x92c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x92c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_f_step(void *p) {
   // m5_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x930;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x930;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_e_step(void *p) {
   // m5_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x930;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x930;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_h_step(void *p) {
   // m5_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x934;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x934;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll1_quad_g_step(void *p) {
   // m5_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x934;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m5_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x934;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_b_step(void *p) {
   // m5_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x938;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x938;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_a_step(void *p) {
   // m5_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x938;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x938;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_d_step(void *p) {
   // m5_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x93c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x93c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_c_step(void *p) {
   // m5_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x93c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x93c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_f_step(void *p) {
   // m5_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x940;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x940;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_e_step(void *p) {
   // m5_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x940;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x940;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_h_step(void *p) {
   // m5_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x944;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x944;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m5_dll2_quad_g_step(void *p) {
   // m5_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x944;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m5_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m5_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x944;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_7(void *p) {
   // cfg_rdlvl_trim_delay_5_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_6(void *p) {
   // cfg_rdlvl_trim_delay_5_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_5(void *p) {
   // cfg_rdlvl_trim_delay_5_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_4(void *p) {
   // cfg_rdlvl_trim_delay_5_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_3(void *p) {
   // cfg_rdlvl_trim_delay_5_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_2(void *p) {
   // cfg_rdlvl_trim_delay_5_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_1(void *p) {
   // cfg_rdlvl_trim_delay_5_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_0(void *p) {
   // cfg_rdlvl_trim_delay_5_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_5_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x948;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_7(void *p) {
   // cfg_wrlvl_trim_delay_5_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_6(void *p) {
   // cfg_wrlvl_trim_delay_5_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_5(void *p) {
   // cfg_wrlvl_trim_delay_5_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_4(void *p) {
   // cfg_wrlvl_trim_delay_5_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_3(void *p) {
   // cfg_wrlvl_trim_delay_5_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_2(void *p) {
   // cfg_wrlvl_trim_delay_5_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_1(void *p) {
   // cfg_wrlvl_trim_delay_5_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_0(void *p) {
   // cfg_wrlvl_trim_delay_5_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_5_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x94c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_5_1(void *p) {
   // cfg_wrdq_del_5_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x950;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_5_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_5_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x950;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_5_0(void *p) {
   // cfg_wrdq_del_5_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x950;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_5_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_5_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x950;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_5_1(void *p) {
   // cfg_del_eye0_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x954;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x954;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_5_0(void *p) {
   // cfg_del_eye0_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x954;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x954;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_5_1(void *p) {
   // cfg_del_eye1_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x958;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x958;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_5_0(void *p) {
   // cfg_del_eye1_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x958;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x958;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_5_1(void *p) {
   // cfg_del_eye2_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x95c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x95c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_5_0(void *p) {
   // cfg_del_eye2_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x95c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x95c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_5_1(void *p) {
   // cfg_del_eye3_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x960;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x960;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_5_0(void *p) {
   // cfg_del_eye3_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x960;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x960;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_5_1(void *p) {
   // cfg_del_eye4_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x964;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x964;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_5_0(void *p) {
   // cfg_del_eye4_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x964;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x964;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_5_1(void *p) {
   // cfg_del_eye5_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x968;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x968;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_5_0(void *p) {
   // cfg_del_eye5_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x968;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x968;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_5_1(void *p) {
   // cfg_del_eye6_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x96c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x96c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_5_0(void *p) {
   // cfg_del_eye6_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x96c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x96c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_5_1(void *p) {
   // cfg_del_eye7_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x970;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_5_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_5_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x970;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_5_0(void *p) {
   // cfg_del_eye7_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x970;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_5_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x970;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_5_0(void *p) {
   // cfg_rdlvl_delay0_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x974;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x974;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_5_1(void *p) {
   // cfg_rdlvl_delay0_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x978;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x978;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_5_0(void *p) {
   // cfg_rdlvl_gate_delay0_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x97c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x97c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_5_1(void *p) {
   // cfg_rdlvl_gate_delay0_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x980;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x980;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_5_0(void *p) {
   // cfg_wrlvl_delay0_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x984;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x984;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_5_1(void *p) {
   // cfg_wrlvl_delay0_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x988;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x988;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_5_0(void *p) {
   // cfg_rdlvl_delay1_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x98c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x98c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_5_1(void *p) {
   // cfg_rdlvl_delay1_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x990;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x990;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_5_0(void *p) {
   // cfg_rdlvl_gate_delay1_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x994;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x994;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_5_1(void *p) {
   // cfg_rdlvl_gate_delay1_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x998;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x998;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_5_0(void *p) {
   // cfg_wrlvl_delay1_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x99c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x99c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_5_1(void *p) {
   // cfg_wrlvl_delay1_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9a0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9a0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_5_0(void *p) {
   // cfg_rdlvl_delay2_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9a4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9a4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_5_1(void *p) {
   // cfg_rdlvl_delay2_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9a8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9a8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_5_0(void *p) {
   // cfg_rdlvl_gate_delay2_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9ac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9ac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_5_1(void *p) {
   // cfg_rdlvl_gate_delay2_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9b0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9b0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_5_0(void *p) {
   // cfg_wrlvl_delay2_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9b4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9b4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_5_1(void *p) {
   // cfg_wrlvl_delay2_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9b8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9b8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_5_0(void *p) {
   // cfg_rdlvl_delay3_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9bc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9bc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_5_1(void *p) {
   // cfg_rdlvl_delay3_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_5_0(void *p) {
   // cfg_rdlvl_gate_delay3_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_5_1(void *p) {
   // cfg_rdlvl_gate_delay3_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9c8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_5_0(void *p) {
   // cfg_wrlvl_delay3_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9cc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9cc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_5_1(void *p) {
   // cfg_wrlvl_delay3_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9d0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9d0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_5_0(void *p) {
   // cfg_rdlvl_delay4_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9d4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9d4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_5_1(void *p) {
   // cfg_rdlvl_delay4_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9d8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9d8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_5_0(void *p) {
   // cfg_rdlvl_gate_delay4_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9dc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9dc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_5_1(void *p) {
   // cfg_rdlvl_gate_delay4_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9e0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9e0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_5_0(void *p) {
   // cfg_wrlvl_delay4_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9e4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9e4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_5_1(void *p) {
   // cfg_wrlvl_delay4_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9e8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9e8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_5_0(void *p) {
   // cfg_rdlvl_delay5_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9ec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9ec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_5_1(void *p) {
   // cfg_rdlvl_delay5_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9f0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9f0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_5_0(void *p) {
   // cfg_rdlvl_gate_delay5_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9f4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9f4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_5_1(void *p) {
   // cfg_rdlvl_gate_delay5_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9f8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9f8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_5_0(void *p) {
   // cfg_wrlvl_delay5_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9fc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0x9fc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_5_1(void *p) {
   // cfg_wrlvl_delay5_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_5_0(void *p) {
   // cfg_rdlvl_delay6_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_5_1(void *p) {
   // cfg_rdlvl_delay6_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_5_0(void *p) {
   // cfg_rdlvl_gate_delay6_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_5_1(void *p) {
   // cfg_rdlvl_gate_delay6_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_5_0(void *p) {
   // cfg_wrlvl_delay6_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_5_1(void *p) {
   // cfg_wrlvl_delay6_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa18;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_5_0(void *p) {
   // cfg_rdlvl_delay7_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_5_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_5_1(void *p) {
   // cfg_rdlvl_delay7_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_5_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_5_0(void *p) {
   // cfg_rdlvl_gate_delay7_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_5_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa24;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_5_1(void *p) {
   // cfg_rdlvl_gate_delay7_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_5_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa28;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_5_0(void *p) {
   // cfg_wrlvl_delay7_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_5_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_5_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa2c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_5_1(void *p) {
   // cfg_wrlvl_delay7_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_5_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_5_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_5(void *p) {
   // cfg_cdr_dqxclk_pi_out_5 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_5(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_5 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_5(void *p) {
   // cfg_dll0_peak_5 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_5(void *p, unsigned int writeData) {
   // cfg_dll0_peak_5 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_5(void *p) {
   // cfg_wrlvl_time_out_status_5 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_5(void *p) {
   // cfg_deskew_time_out_status_5 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_5(void *p) {
   // cfg_wrcal_time_out_status_5 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_5(void *p) {
   // cfg_rdlvl_time_out_status_5 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_5(void *p) {
   // cfg_rdlvl_gate_time_out_status_5 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m6_dll0_quad_d_wt(void *p) {
   // m6_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_c_wt(void *p) {
   // m6_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_b_wt(void *p) {
   // m6_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_a_wt(void *p) {
   // m6_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_h_wt(void *p) {
   // m6_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_g_wt(void *p) {
   // m6_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_f_wt(void *p) {
   // m6_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_e_wt(void *p) {
   // m6_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m6_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m6_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_d_wt(void *p) {
   // m6_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_c_wt(void *p) {
   // m6_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_b_wt(void *p) {
   // m6_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_a_wt(void *p) {
   // m6_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_h_wt(void *p) {
   // m6_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_g_wt(void *p) {
   // m6_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_f_wt(void *p) {
   // m6_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_e_wt(void *p) {
   // m6_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m6_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m6_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_d_wt(void *p) {
   // m6_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_c_wt(void *p) {
   // m6_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_b_wt(void *p) {
   // m6_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_a_wt(void *p) {
   // m6_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_h_wt(void *p) {
   // m6_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_g_wt(void *p) {
   // m6_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_f_wt(void *p) {
   // m6_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_e_wt(void *p) {
   // m6_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m6_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m6_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_b_step(void *p) {
   // m6_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_a_step(void *p) {
   // m6_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_d_step(void *p) {
   // m6_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_c_step(void *p) {
   // m6_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xa9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_f_step(void *p) {
   // m6_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_e_step(void *p) {
   // m6_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_h_step(void *p) {
   // m6_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll0_quad_g_step(void *p) {
   // m6_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m6_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_b_step(void *p) {
   // m6_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_a_step(void *p) {
   // m6_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaa8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_d_step(void *p) {
   // m6_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_c_step(void *p) {
   // m6_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_f_step(void *p) {
   // m6_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_e_step(void *p) {
   // m6_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_h_step(void *p) {
   // m6_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll1_quad_g_step(void *p) {
   // m6_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m6_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_b_step(void *p) {
   // m6_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_a_step(void *p) {
   // m6_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xab8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_d_step(void *p) {
   // m6_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xabc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xabc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_c_step(void *p) {
   // m6_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xabc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xabc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_f_step(void *p) {
   // m6_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_e_step(void *p) {
   // m6_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_h_step(void *p) {
   // m6_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m6_dll2_quad_g_step(void *p) {
   // m6_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m6_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m6_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_7(void *p) {
   // cfg_rdlvl_trim_delay_6_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_6(void *p) {
   // cfg_rdlvl_trim_delay_6_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_5(void *p) {
   // cfg_rdlvl_trim_delay_6_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_4(void *p) {
   // cfg_rdlvl_trim_delay_6_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_3(void *p) {
   // cfg_rdlvl_trim_delay_6_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_2(void *p) {
   // cfg_rdlvl_trim_delay_6_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_1(void *p) {
   // cfg_rdlvl_trim_delay_6_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_0(void *p) {
   // cfg_rdlvl_trim_delay_6_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_6_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xac8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_7(void *p) {
   // cfg_wrlvl_trim_delay_6_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_6(void *p) {
   // cfg_wrlvl_trim_delay_6_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_5(void *p) {
   // cfg_wrlvl_trim_delay_6_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_4(void *p) {
   // cfg_wrlvl_trim_delay_6_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_3(void *p) {
   // cfg_wrlvl_trim_delay_6_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_2(void *p) {
   // cfg_wrlvl_trim_delay_6_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_1(void *p) {
   // cfg_wrlvl_trim_delay_6_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_0(void *p) {
   // cfg_wrlvl_trim_delay_6_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_6_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xacc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_6_1(void *p) {
   // cfg_wrdq_del_6_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_6_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_6_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_6_0(void *p) {
   // cfg_wrdq_del_6_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_6_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_6_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_6_1(void *p) {
   // cfg_del_eye0_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_6_0(void *p) {
   // cfg_del_eye0_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_6_1(void *p) {
   // cfg_del_eye1_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_6_0(void *p) {
   // cfg_del_eye1_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xad8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_6_1(void *p) {
   // cfg_del_eye2_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xadc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xadc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_6_0(void *p) {
   // cfg_del_eye2_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xadc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xadc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_6_1(void *p) {
   // cfg_del_eye3_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_6_0(void *p) {
   // cfg_del_eye3_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_6_1(void *p) {
   // cfg_del_eye4_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_6_0(void *p) {
   // cfg_del_eye4_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_6_1(void *p) {
   // cfg_del_eye5_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_6_0(void *p) {
   // cfg_del_eye5_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xae8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_6_1(void *p) {
   // cfg_del_eye6_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_6_0(void *p) {
   // cfg_del_eye6_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_6_1(void *p) {
   // cfg_del_eye7_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_6_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_6_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_6_0(void *p) {
   // cfg_del_eye7_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_6_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_6_0(void *p) {
   // cfg_rdlvl_delay0_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_6_1(void *p) {
   // cfg_rdlvl_delay0_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xaf8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_6_0(void *p) {
   // cfg_rdlvl_gate_delay0_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xafc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xafc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_6_1(void *p) {
   // cfg_rdlvl_gate_delay0_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_6_0(void *p) {
   // cfg_wrlvl_delay0_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_6_1(void *p) {
   // cfg_wrlvl_delay0_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_6_0(void *p) {
   // cfg_rdlvl_delay1_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_6_1(void *p) {
   // cfg_rdlvl_delay1_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_6_0(void *p) {
   // cfg_rdlvl_gate_delay1_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_6_1(void *p) {
   // cfg_rdlvl_gate_delay1_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb18;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_6_0(void *p) {
   // cfg_wrlvl_delay1_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_6_1(void *p) {
   // cfg_wrlvl_delay1_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_6_0(void *p) {
   // cfg_rdlvl_delay2_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb24;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_6_1(void *p) {
   // cfg_rdlvl_delay2_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb28;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_6_0(void *p) {
   // cfg_rdlvl_gate_delay2_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb2c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_6_1(void *p) {
   // cfg_rdlvl_gate_delay2_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_6_0(void *p) {
   // cfg_wrlvl_delay2_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_6_1(void *p) {
   // cfg_wrlvl_delay2_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb38;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_6_0(void *p) {
   // cfg_rdlvl_delay3_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb3c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_6_1(void *p) {
   // cfg_rdlvl_delay3_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb40;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_6_0(void *p) {
   // cfg_rdlvl_gate_delay3_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb44;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb44;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_6_1(void *p) {
   // cfg_rdlvl_gate_delay3_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_6_0(void *p) {
   // cfg_wrlvl_delay3_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_6_1(void *p) {
   // cfg_wrlvl_delay3_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb50;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_6_0(void *p) {
   // cfg_rdlvl_delay4_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb54;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_6_1(void *p) {
   // cfg_rdlvl_delay4_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb58;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_6_0(void *p) {
   // cfg_rdlvl_gate_delay4_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb5c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_6_1(void *p) {
   // cfg_rdlvl_gate_delay4_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb60;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb60;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_6_0(void *p) {
   // cfg_wrlvl_delay4_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb64;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb64;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_6_1(void *p) {
   // cfg_wrlvl_delay4_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb68;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_6_0(void *p) {
   // cfg_rdlvl_delay5_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb6c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_6_1(void *p) {
   // cfg_rdlvl_delay5_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb70;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb70;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_6_0(void *p) {
   // cfg_rdlvl_gate_delay5_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb74;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb74;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_6_1(void *p) {
   // cfg_rdlvl_gate_delay5_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb78;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_6_0(void *p) {
   // cfg_wrlvl_delay5_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb7c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_6_1(void *p) {
   // cfg_wrlvl_delay5_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_6_0(void *p) {
   // cfg_rdlvl_delay6_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_6_1(void *p) {
   // cfg_rdlvl_delay6_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_6_0(void *p) {
   // cfg_rdlvl_gate_delay6_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_6_1(void *p) {
   // cfg_rdlvl_gate_delay6_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_6_0(void *p) {
   // cfg_wrlvl_delay6_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_6_1(void *p) {
   // cfg_wrlvl_delay6_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_6_0(void *p) {
   // cfg_rdlvl_delay7_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_6_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xb9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_6_1(void *p) {
   // cfg_rdlvl_delay7_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xba0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_6_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xba0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_6_0(void *p) {
   // cfg_rdlvl_gate_delay7_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xba4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_6_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xba4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_6_1(void *p) {
   // cfg_rdlvl_gate_delay7_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xba8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_6_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xba8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_6_0(void *p) {
   // cfg_wrlvl_delay7_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_6_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_6_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_6_1(void *p) {
   // cfg_wrlvl_delay7_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_6_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_6_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_6(void *p) {
   // cfg_cdr_dqxclk_pi_out_6 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_6(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_6 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_6(void *p) {
   // cfg_dll0_peak_6 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_6(void *p, unsigned int writeData) {
   // cfg_dll0_peak_6 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_6(void *p) {
   // cfg_wrlvl_time_out_status_6 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_6(void *p) {
   // cfg_deskew_time_out_status_6 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_6(void *p) {
   // cfg_wrcal_time_out_status_6 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_6(void *p) {
   // cfg_rdlvl_time_out_status_6 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_6(void *p) {
   // cfg_rdlvl_gate_time_out_status_6 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xbb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m7_dll0_quad_d_wt(void *p) {
   // m7_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_c_wt(void *p) {
   // m7_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_b_wt(void *p) {
   // m7_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_a_wt(void *p) {
   // m7_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_h_wt(void *p) {
   // m7_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_g_wt(void *p) {
   // m7_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_f_wt(void *p) {
   // m7_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_e_wt(void *p) {
   // m7_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m7_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m7_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_d_wt(void *p) {
   // m7_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_c_wt(void *p) {
   // m7_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_b_wt(void *p) {
   // m7_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_a_wt(void *p) {
   // m7_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_h_wt(void *p) {
   // m7_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_g_wt(void *p) {
   // m7_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_f_wt(void *p) {
   // m7_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_e_wt(void *p) {
   // m7_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m7_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m7_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_d_wt(void *p) {
   // m7_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_c_wt(void *p) {
   // m7_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_b_wt(void *p) {
   // m7_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_a_wt(void *p) {
   // m7_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_h_wt(void *p) {
   // m7_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_g_wt(void *p) {
   // m7_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_f_wt(void *p) {
   // m7_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_e_wt(void *p) {
   // m7_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m7_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m7_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_b_step(void *p) {
   // m7_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc18;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_a_step(void *p) {
   // m7_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc18;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_d_step(void *p) {
   // m7_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_c_step(void *p) {
   // m7_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_f_step(void *p) {
   // m7_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_e_step(void *p) {
   // m7_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_h_step(void *p) {
   // m7_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc24;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll0_quad_g_step(void *p) {
   // m7_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m7_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc24;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_b_step(void *p) {
   // m7_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc28;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_a_step(void *p) {
   // m7_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc28;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_d_step(void *p) {
   // m7_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc2c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_c_step(void *p) {
   // m7_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc2c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_f_step(void *p) {
   // m7_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_e_step(void *p) {
   // m7_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_h_step(void *p) {
   // m7_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll1_quad_g_step(void *p) {
   // m7_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m7_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_b_step(void *p) {
   // m7_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc38;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_a_step(void *p) {
   // m7_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc38;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_d_step(void *p) {
   // m7_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc3c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_c_step(void *p) {
   // m7_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc3c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_f_step(void *p) {
   // m7_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc40;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_e_step(void *p) {
   // m7_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc40;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_h_step(void *p) {
   // m7_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc44;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc44;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m7_dll2_quad_g_step(void *p) {
   // m7_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc44;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m7_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m7_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc44;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_7(void *p) {
   // cfg_rdlvl_trim_delay_7_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_6(void *p) {
   // cfg_rdlvl_trim_delay_7_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_5(void *p) {
   // cfg_rdlvl_trim_delay_7_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_4(void *p) {
   // cfg_rdlvl_trim_delay_7_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_3(void *p) {
   // cfg_rdlvl_trim_delay_7_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_2(void *p) {
   // cfg_rdlvl_trim_delay_7_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_1(void *p) {
   // cfg_rdlvl_trim_delay_7_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_0(void *p) {
   // cfg_rdlvl_trim_delay_7_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_7_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_7(void *p) {
   // cfg_wrlvl_trim_delay_7_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_6(void *p) {
   // cfg_wrlvl_trim_delay_7_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_5(void *p) {
   // cfg_wrlvl_trim_delay_7_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_4(void *p) {
   // cfg_wrlvl_trim_delay_7_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_3(void *p) {
   // cfg_wrlvl_trim_delay_7_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_2(void *p) {
   // cfg_wrlvl_trim_delay_7_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_1(void *p) {
   // cfg_wrlvl_trim_delay_7_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_0(void *p) {
   // cfg_wrlvl_trim_delay_7_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_7_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_7_1(void *p) {
   // cfg_wrdq_del_7_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_7_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_7_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc50;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_7_0(void *p) {
   // cfg_wrdq_del_7_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_7_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_7_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc50;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_7_1(void *p) {
   // cfg_del_eye0_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc54;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_7_0(void *p) {
   // cfg_del_eye0_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc54;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_7_1(void *p) {
   // cfg_del_eye1_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc58;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_7_0(void *p) {
   // cfg_del_eye1_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc58;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_7_1(void *p) {
   // cfg_del_eye2_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc5c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_7_0(void *p) {
   // cfg_del_eye2_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc5c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_7_1(void *p) {
   // cfg_del_eye3_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc60;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc60;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_7_0(void *p) {
   // cfg_del_eye3_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc60;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc60;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_7_1(void *p) {
   // cfg_del_eye4_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc64;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc64;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_7_0(void *p) {
   // cfg_del_eye4_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc64;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc64;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_7_1(void *p) {
   // cfg_del_eye5_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc68;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_7_0(void *p) {
   // cfg_del_eye5_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc68;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_7_1(void *p) {
   // cfg_del_eye6_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc6c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_7_0(void *p) {
   // cfg_del_eye6_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc6c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_7_1(void *p) {
   // cfg_del_eye7_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc70;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_7_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_7_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc70;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_7_0(void *p) {
   // cfg_del_eye7_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc70;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_7_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc70;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_7_0(void *p) {
   // cfg_rdlvl_delay0_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc74;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc74;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_7_1(void *p) {
   // cfg_rdlvl_delay0_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc78;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_7_0(void *p) {
   // cfg_rdlvl_gate_delay0_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc7c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_7_1(void *p) {
   // cfg_rdlvl_gate_delay0_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_7_0(void *p) {
   // cfg_wrlvl_delay0_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_7_1(void *p) {
   // cfg_wrlvl_delay0_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_7_0(void *p) {
   // cfg_rdlvl_delay1_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_7_1(void *p) {
   // cfg_rdlvl_delay1_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_7_0(void *p) {
   // cfg_rdlvl_gate_delay1_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_7_1(void *p) {
   // cfg_rdlvl_gate_delay1_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_7_0(void *p) {
   // cfg_wrlvl_delay1_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xc9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_7_1(void *p) {
   // cfg_wrlvl_delay1_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xca0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xca0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_7_0(void *p) {
   // cfg_rdlvl_delay2_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xca4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xca4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_7_1(void *p) {
   // cfg_rdlvl_delay2_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xca8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xca8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_7_0(void *p) {
   // cfg_rdlvl_gate_delay2_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_7_1(void *p) {
   // cfg_rdlvl_gate_delay2_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcb0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcb0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_7_0(void *p) {
   // cfg_wrlvl_delay2_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcb4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcb4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_7_1(void *p) {
   // cfg_wrlvl_delay2_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcb8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_7_0(void *p) {
   // cfg_rdlvl_delay3_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcbc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcbc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_7_1(void *p) {
   // cfg_rdlvl_delay3_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_7_0(void *p) {
   // cfg_rdlvl_gate_delay3_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_7_1(void *p) {
   // cfg_rdlvl_gate_delay3_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_7_0(void *p) {
   // cfg_wrlvl_delay3_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xccc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xccc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_7_1(void *p) {
   // cfg_wrlvl_delay3_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcd0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcd0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_7_0(void *p) {
   // cfg_rdlvl_delay4_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcd4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcd4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_7_1(void *p) {
   // cfg_rdlvl_delay4_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcd8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcd8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_7_0(void *p) {
   // cfg_rdlvl_gate_delay4_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcdc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcdc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_7_1(void *p) {
   // cfg_rdlvl_gate_delay4_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xce0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xce0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_7_0(void *p) {
   // cfg_wrlvl_delay4_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xce4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xce4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_7_1(void *p) {
   // cfg_wrlvl_delay4_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xce8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xce8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_7_0(void *p) {
   // cfg_rdlvl_delay5_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_7_1(void *p) {
   // cfg_rdlvl_delay5_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_7_0(void *p) {
   // cfg_rdlvl_gate_delay5_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcf4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcf4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_7_1(void *p) {
   // cfg_rdlvl_gate_delay5_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcf8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcf8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_7_0(void *p) {
   // cfg_wrlvl_delay5_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcfc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xcfc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_7_1(void *p) {
   // cfg_wrlvl_delay5_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_7_0(void *p) {
   // cfg_rdlvl_delay6_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_7_1(void *p) {
   // cfg_rdlvl_delay6_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_7_0(void *p) {
   // cfg_rdlvl_gate_delay6_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_7_1(void *p) {
   // cfg_rdlvl_gate_delay6_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_7_0(void *p) {
   // cfg_wrlvl_delay6_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_7_1(void *p) {
   // cfg_wrlvl_delay6_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd18;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_7_0(void *p) {
   // cfg_rdlvl_delay7_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_7_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_7_1(void *p) {
   // cfg_rdlvl_delay7_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_7_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_7_0(void *p) {
   // cfg_rdlvl_gate_delay7_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_7_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd24;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_7_1(void *p) {
   // cfg_rdlvl_gate_delay7_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_7_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd28;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_7_0(void *p) {
   // cfg_wrlvl_delay7_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_7_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_7_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd2c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_7_1(void *p) {
   // cfg_wrlvl_delay7_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_7_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_7_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_7(void *p) {
   // cfg_cdr_dqxclk_pi_out_7 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x7f;
   }

   void phy_rf_write_cfg_cdr_dqxclk_pi_out_7(void *p, unsigned int writeData) {
   // cfg_cdr_dqxclk_pi_out_7 [14:8] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_dll0_peak_7(void *p) {
   // cfg_dll0_peak_7 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_cfg_dll0_peak_7(void *p, unsigned int writeData) {
   // cfg_dll0_peak_7 [7:0] RWL FF
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_time_out_status_7(void *p) {
   // cfg_wrlvl_time_out_status_7 [8] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0x1;
   }

   unsigned int phy_rf_read_cfg_deskew_time_out_status_7(void *p) {
   // cfg_deskew_time_out_status_7 [7:6] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x3;
   }

   unsigned int phy_rf_read_cfg_wrcal_time_out_status_7(void *p) {
   // cfg_wrcal_time_out_status_7 [5:4] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 4) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_time_out_status_7(void *p) {
   // cfg_rdlvl_time_out_status_7 [3:2] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 2) & 0x3;
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_7(void *p) {
   // cfg_rdlvl_gate_time_out_status_7 [1:0] CORL 0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x3;
   }

   unsigned int phy_rf_read_m8_dll0_quad_d_wt(void *p) {
   // m8_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_d_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_c_wt(void *p) {
   // m8_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_c_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_b_wt(void *p) {
   // m8_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_b_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_a_wt(void *p) {
   // m8_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_a_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_h_wt(void *p) {
   // m8_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_h_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_g_wt(void *p) {
   // m8_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_g_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_f_wt(void *p) {
   // m8_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_f_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_e_wt(void *p) {
   // m8_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m8_dll0_quad_e_wt(void *p, unsigned int writeData) {
   // m8_dll0_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_d_wt(void *p) {
   // m8_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_d_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_c_wt(void *p) {
   // m8_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_c_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_b_wt(void *p) {
   // m8_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_b_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_a_wt(void *p) {
   // m8_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_a_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_h_wt(void *p) {
   // m8_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_h_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_g_wt(void *p) {
   // m8_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_g_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_f_wt(void *p) {
   // m8_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_f_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_e_wt(void *p) {
   // m8_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m8_dll1_quad_e_wt(void *p, unsigned int writeData) {
   // m8_dll1_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_d_wt(void *p) {
   // m8_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_d_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_d_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_c_wt(void *p) {
   // m8_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_c_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_c_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_b_wt(void *p) {
   // m8_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_b_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_b_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_a_wt(void *p) {
   // m8_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_a_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_a_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_h_wt(void *p) {
   // m8_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 24) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_h_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_h_wt [31:24] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_g_wt(void *p) {
   // m8_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 16) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_g_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_g_wt [23:16] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_f_wt(void *p) {
   // m8_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 8) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_f_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_f_wt [15:8] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_e_wt(void *p) {
   // m8_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xff;
   }

   void phy_rf_write_m8_dll2_quad_e_wt(void *p, unsigned int writeData) {
   // m8_dll2_quad_e_wt [7:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_b_step(void *p) {
   // m8_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_b_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_a_step(void *p) {
   // m8_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_a_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_d_step(void *p) {
   // m8_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_d_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_c_step(void *p) {
   // m8_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_c_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xd9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_f_step(void *p) {
   // m8_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_f_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_e_step(void *p) {
   // m8_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_e_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_h_step(void *p) {
   // m8_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_h_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll0_quad_g_step(void *p) {
   // m8_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll0_quad_g_step(void *p, unsigned int writeData) {
   // m8_dll0_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_b_step(void *p) {
   // m8_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_b_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_a_step(void *p) {
   // m8_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_a_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xda8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_d_step(void *p) {
   // m8_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_d_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_c_step(void *p) {
   // m8_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_c_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_f_step(void *p) {
   // m8_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_f_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_e_step(void *p) {
   // m8_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_e_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_h_step(void *p) {
   // m8_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_h_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll1_quad_g_step(void *p) {
   // m8_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll1_quad_g_step(void *p, unsigned int writeData) {
   // m8_dll1_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_b_step(void *p) {
   // m8_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_b_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_b_step [21:11] RWL 100
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_a_step(void *p) {
   // m8_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_a_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_a_step [10:0] RWL 80
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdb8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_d_step(void *p) {
   // m8_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdbc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_d_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_d_step [21:11] RWL 200
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdbc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_c_step(void *p) {
   // m8_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdbc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_c_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_c_step [10:0] RWL 180
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdbc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_f_step(void *p) {
   // m8_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_f_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_f_step [21:11] RWL 300
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_e_step(void *p) {
   // m8_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_e_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_e_step [10:0] RWL 280
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_h_step(void *p) {
   // m8_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 11) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_h_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_h_step [21:11] RWL 3FC
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffc007ff) | (~0xffc007ff & (writeData << 11));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_m8_dll2_quad_g_step(void *p) {
   // m8_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7ff;
   }

   void phy_rf_write_m8_dll2_quad_g_step(void *p, unsigned int writeData) {
   // m8_dll2_quad_g_step [10:0] RWL 380
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff800) | (~0xfffff800 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_7(void *p) {
   // cfg_rdlvl_trim_delay_8_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_7(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_6(void *p) {
   // cfg_rdlvl_trim_delay_8_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_6(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_5(void *p) {
   // cfg_rdlvl_trim_delay_8_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_5(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_4(void *p) {
   // cfg_rdlvl_trim_delay_8_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_4(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_3(void *p) {
   // cfg_rdlvl_trim_delay_8_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_3(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_2(void *p) {
   // cfg_rdlvl_trim_delay_8_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_2(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_1(void *p) {
   // cfg_rdlvl_trim_delay_8_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_0(void *p) {
   // cfg_rdlvl_trim_delay_8_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_rdlvl_trim_delay_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_trim_delay_8_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdc8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_7(void *p) {
   // cfg_wrlvl_trim_delay_8_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 21) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_7(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_7 [23:21] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff1fffff) | (~0xff1fffff & (writeData << 21));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_6(void *p) {
   // cfg_wrlvl_trim_delay_8_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 18) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_6(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_6 [20:18] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffe3ffff) | (~0xffe3ffff & (writeData << 18));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_5(void *p) {
   // cfg_wrlvl_trim_delay_8_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 15) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_5(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_5 [17:15] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffc7fff) | (~0xfffc7fff & (writeData << 15));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_4(void *p) {
   // cfg_wrlvl_trim_delay_8_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_4(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_4 [14:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffff8fff) | (~0xffff8fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_3(void *p) {
   // cfg_wrlvl_trim_delay_8_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 9) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_3(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_3 [11:9] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff1ff) | (~0xfffff1ff & (writeData << 9));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_2(void *p) {
   // cfg_wrlvl_trim_delay_8_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 6) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_2(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_2 [8:6] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffe3f) | (~0xfffffe3f & (writeData << 6));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_1(void *p) {
   // cfg_wrlvl_trim_delay_8_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 3) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_1 [5:3] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xffffffc7) | (~0xffffffc7 & (writeData << 3));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_0(void *p) {
   // cfg_wrlvl_trim_delay_8_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0x7;
   }

   void phy_rf_write_cfg_wrlvl_trim_delay_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_trim_delay_8_0 [2:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdcc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffffff8) | (~0xfffffff8 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_8_1(void *p) {
   // cfg_wrdq_del_8_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_8_1(void *p, unsigned int writeData) {
   // cfg_wrdq_del_8_1 [23:12] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrdq_del_8_0(void *p) {
   // cfg_wrdq_del_8_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrdq_del_8_0(void *p, unsigned int writeData) {
   // cfg_wrdq_del_8_0 [11:0] RWL 40
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_8_1(void *p) {
   // cfg_del_eye0_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye0_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye0_8_0(void *p) {
   // cfg_del_eye0_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye0_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye0_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_8_1(void *p) {
   // cfg_del_eye1_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye1_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye1_8_0(void *p) {
   // cfg_del_eye1_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye1_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye1_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdd8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_8_1(void *p) {
   // cfg_del_eye2_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xddc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye2_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xddc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye2_8_0(void *p) {
   // cfg_del_eye2_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xddc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye2_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye2_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xddc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_8_1(void *p) {
   // cfg_del_eye3_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye3_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye3_8_0(void *p) {
   // cfg_del_eye3_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye3_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye3_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_8_1(void *p) {
   // cfg_del_eye4_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye4_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye4_8_0(void *p) {
   // cfg_del_eye4_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye4_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye4_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_8_1(void *p) {
   // cfg_del_eye5_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye5_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye5_8_0(void *p) {
   // cfg_del_eye5_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye5_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye5_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xde8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_8_1(void *p) {
   // cfg_del_eye6_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye6_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye6_8_0(void *p) {
   // cfg_del_eye6_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdec;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye6_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye6_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdec;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_8_1(void *p) {
   // cfg_del_eye7_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 12) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_8_1(void *p, unsigned int writeData) {
   // cfg_del_eye7_8_1 [23:12] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xff000fff) | (~0xff000fff & (writeData << 12));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_del_eye7_8_0(void *p) {
   // cfg_del_eye7_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_del_eye7_8_0(void *p, unsigned int writeData) {
   // cfg_del_eye7_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_8_0(void *p) {
   // cfg_rdlvl_delay0_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay0_8_1(void *p) {
   // cfg_rdlvl_delay0_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay0_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay0_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdf8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_8_0(void *p) {
   // cfg_rdlvl_gate_delay0_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdfc;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xdfc;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_8_1(void *p) {
   // cfg_rdlvl_gate_delay0_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe00;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay0_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay0_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe00;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_8_0(void *p) {
   // cfg_wrlvl_delay0_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe04;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe04;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay0_8_1(void *p) {
   // cfg_wrlvl_delay0_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe08;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay0_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay0_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe08;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_8_0(void *p) {
   // cfg_rdlvl_delay1_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe0c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe0c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay1_8_1(void *p) {
   // cfg_rdlvl_delay1_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe10;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay1_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay1_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe10;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_8_0(void *p) {
   // cfg_rdlvl_gate_delay1_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe14;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe14;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_8_1(void *p) {
   // cfg_rdlvl_gate_delay1_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe18;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay1_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay1_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe18;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_8_0(void *p) {
   // cfg_wrlvl_delay1_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe1c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe1c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay1_8_1(void *p) {
   // cfg_wrlvl_delay1_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe20;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay1_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay1_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe20;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_8_0(void *p) {
   // cfg_rdlvl_delay2_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe24;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe24;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay2_8_1(void *p) {
   // cfg_rdlvl_delay2_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe28;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay2_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay2_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe28;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_8_0(void *p) {
   // cfg_rdlvl_gate_delay2_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe2c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe2c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_8_1(void *p) {
   // cfg_rdlvl_gate_delay2_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe30;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay2_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay2_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe30;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_8_0(void *p) {
   // cfg_wrlvl_delay2_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe34;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe34;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay2_8_1(void *p) {
   // cfg_wrlvl_delay2_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe38;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay2_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay2_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe38;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_8_0(void *p) {
   // cfg_rdlvl_delay3_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe3c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe3c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay3_8_1(void *p) {
   // cfg_rdlvl_delay3_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe40;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay3_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay3_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe40;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_8_0(void *p) {
   // cfg_rdlvl_gate_delay3_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe44;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe44;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_8_1(void *p) {
   // cfg_rdlvl_gate_delay3_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe48;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay3_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay3_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe48;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_8_0(void *p) {
   // cfg_wrlvl_delay3_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe4c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe4c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay3_8_1(void *p) {
   // cfg_wrlvl_delay3_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe50;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay3_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay3_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe50;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_8_0(void *p) {
   // cfg_rdlvl_delay4_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe54;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe54;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay4_8_1(void *p) {
   // cfg_rdlvl_delay4_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe58;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay4_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay4_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe58;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_8_0(void *p) {
   // cfg_rdlvl_gate_delay4_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe5c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe5c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_8_1(void *p) {
   // cfg_rdlvl_gate_delay4_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe60;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay4_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay4_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe60;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_8_0(void *p) {
   // cfg_wrlvl_delay4_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe64;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe64;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay4_8_1(void *p) {
   // cfg_wrlvl_delay4_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe68;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay4_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay4_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe68;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_8_0(void *p) {
   // cfg_rdlvl_delay5_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe6c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe6c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay5_8_1(void *p) {
   // cfg_rdlvl_delay5_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe70;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay5_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay5_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe70;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_8_0(void *p) {
   // cfg_rdlvl_gate_delay5_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe74;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe74;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_8_1(void *p) {
   // cfg_rdlvl_gate_delay5_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe78;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay5_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay5_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe78;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_8_0(void *p) {
   // cfg_wrlvl_delay5_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe7c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe7c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay5_8_1(void *p) {
   // cfg_wrlvl_delay5_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe80;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay5_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay5_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe80;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_8_0(void *p) {
   // cfg_rdlvl_delay6_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe84;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe84;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay6_8_1(void *p) {
   // cfg_rdlvl_delay6_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe88;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay6_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay6_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe88;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_8_0(void *p) {
   // cfg_rdlvl_gate_delay6_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe8c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe8c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_8_1(void *p) {
   // cfg_rdlvl_gate_delay6_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe90;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay6_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay6_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe90;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_8_0(void *p) {
   // cfg_wrlvl_delay6_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe94;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe94;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay6_8_1(void *p) {
   // cfg_wrlvl_delay6_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe98;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay6_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay6_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe98;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_8_0(void *p) {
   // cfg_rdlvl_delay7_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe9c;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_8_0 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xe9c;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_delay7_8_1(void *p) {
   // cfg_rdlvl_delay7_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xea0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_delay7_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_delay7_8_1 [11:0] RWL 0x0
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xea0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_8_0(void *p) {
   // cfg_rdlvl_gate_delay7_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xea4;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_8_0(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xea4;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_8_1(void *p) {
   // cfg_rdlvl_gate_delay7_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xea8;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_rdlvl_gate_delay7_8_1(void *p, unsigned int writeData) {
   // cfg_rdlvl_gate_delay7_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xea8;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_8_0(void *p) {
   // cfg_wrlvl_delay7_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xeac;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_8_0(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_8_0 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xeac;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }

   unsigned int phy_rf_read_cfg_wrlvl_delay7_8_1(void *p) {
   // cfg_wrlvl_delay7_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xeb0;
      regReadData = phy_read_reg(mcu, regAddr);
      return (regReadData >> 0) & 0xfff;
   }

   void phy_rf_write_cfg_wrlvl_delay7_8_1(void *p, unsigned int writeData) {
   // cfg_wrlvl_delay7_8_1 [11:0] RWL 10
      unsigned int regAddr;
      unsigned int regWriteData;
      unsigned int regReadData;

      struct apm_mcu *mcu = (struct apm_mcu *)p;
      regAddr = 0xeb0;
      regReadData = phy_read_reg(mcu, regAddr);
      regWriteData = (regReadData & 0xfffff000) | (~0xfffff000 & (writeData << 0));
      phy_write_reg(mcu, regAddr, regWriteData);
   }
 */

unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_8(void *p)
{
	// cfg_cdr_dqxclk_pi_out_8 [14:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb4;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 8) & 0x7f;
}

void phy_rf_write_cfg_cdr_dqxclk_pi_out_8(void *p, unsigned int writeData)
{
	// cfg_cdr_dqxclk_pi_out_8 [14:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff80ff) | (~0xffff80ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dll0_peak_8(void *p)
{
	// cfg_dll0_peak_8 [7:0] RWL FF
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb4;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xff;
}

void phy_rf_write_cfg_dll0_peak_8(void *p, unsigned int writeData)
{
	// cfg_dll0_peak_8 [7:0] RWL FF
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb4;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_wrlvl_time_out_status_8(void *p)
{
	// cfg_wrlvl_time_out_status_8 [8] CORL 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb8;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 8) & 0x1;
}

unsigned int phy_rf_read_cfg_deskew_time_out_status_8(void *p)
{
	// cfg_deskew_time_out_status_8 [7:6] CORL 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb8;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 6) & 0x3;
}

unsigned int phy_rf_read_cfg_wrcal_time_out_status_8(void *p)
{
	// cfg_wrcal_time_out_status_8 [5:4] CORL 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb8;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 4) & 0x3;
}

unsigned int phy_rf_read_cfg_rdlvl_time_out_status_8(void *p)
{
	// cfg_rdlvl_time_out_status_8 [3:2] CORL 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb8;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 2) & 0x3;
}

unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_8(void *p)
{
	// cfg_rdlvl_gate_time_out_status_8 [1:0] CORL 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xeb8;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x3;
}

unsigned int phy_rf_read_cfg_gt_dly_st_0(void *p)
{
	// cfg_gt_dly_st_0 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf00;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_gt_dly_st_0(void *p, unsigned int writeData)
{
	// cfg_gt_dly_st_0 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf00;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_gt_dly_st_1(void *p)
{
	// cfg_gt_dly_st_1 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf04;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_gt_dly_st_1(void *p, unsigned int writeData)
{
	// cfg_gt_dly_st_1 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf04;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_rd_dly_st_0(void *p)
{
	// cfg_rd_dly_st_0 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf08;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_rd_dly_st_0(void *p, unsigned int writeData)
{
	// cfg_rd_dly_st_0 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf08;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_rd_dly_st_1(void *p)
{
	// cfg_rd_dly_st_1 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf0c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_rd_dly_st_1(void *p, unsigned int writeData)
{
	// cfg_rd_dly_st_1 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf0c;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_wr_dly_st_0(void *p)
{
	// cfg_wr_dly_st_0 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf10;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_wr_dly_st_0(void *p, unsigned int writeData)
{
	// cfg_wr_dly_st_0 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf10;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_wr_dly_st_1(void *p)
{
	// cfg_wr_dly_st_1 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf14;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_wr_dly_st_1(void *p, unsigned int writeData)
{
	// cfg_wr_dly_st_1 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf14;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_deskew_st_0(void *p)
{
	// cfg_deskew_st_0 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf18;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_deskew_st_0(void *p, unsigned int writeData)
{
	// cfg_deskew_st_0 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf18;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_deskew_st_1(void *p)
{
	// cfg_deskew_st_1 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf1c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_deskew_st_1(void *p, unsigned int writeData)
{
	// cfg_deskew_st_1 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf1c;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_wr_deskew_st_0(void *p)
{
	// cfg_wr_deskew_st_0 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf20;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_wr_deskew_st_0(void *p, unsigned int writeData)
{
	// cfg_wr_deskew_st_0 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf20;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_wr_deskew_st_1(void *p)
{
	// cfg_wr_deskew_st_1 [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf24;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_wr_deskew_st_1(void *p, unsigned int writeData)
{
	// cfg_wr_deskew_st_1 [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf24;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_ctrl_fsm_st(void *p)
{
	// cfg_ctrl_fsm_st [31:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf28;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_cfg_ctrl_fsm_st(void *p, unsigned int writeData)
{
	// cfg_ctrl_fsm_st [31:0] RWL 0x0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf28;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_spare_register_1_3(void *p)
{
	// spare_register_1_3 [31:24] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 24) & 0xff;
}

void phy_rf_write_spare_register_1_3(void *p, unsigned int writeData)
{
	// spare_register_1_3 [31:24] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_1_2(void *p)
{
	// spare_register_1_2 [23:16] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 16) & 0xff;
}

void phy_rf_write_spare_register_1_2(void *p, unsigned int writeData)
{
	// spare_register_1_2 [23:16] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_1_1(void *p)
{
	// spare_register_1_1 [15:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 8) & 0xff;
}

void phy_rf_write_spare_register_1_1(void *p, unsigned int writeData)
{
	// spare_register_1_1 [15:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_1_0(void *p)
{
	// spare_register_1_0 [7:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xff;
}

void phy_rf_write_spare_register_1_0(void *p, unsigned int writeData)
{
	// spare_register_1_0 [7:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf2c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_2_3(void *p)
{
	// spare_register_2_3 [31:24] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 24) & 0xff;
}

void phy_rf_write_spare_register_2_3(void *p, unsigned int writeData)
{
	// spare_register_2_3 [31:24] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_2_2(void *p)
{
	// spare_register_2_2 [23:16] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 16) & 0xff;
}

void phy_rf_write_spare_register_2_2(void *p, unsigned int writeData)
{
	// spare_register_2_2 [23:16] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_2_1(void *p)
{
	// spare_register_2_1 [15:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 8) & 0xff;
}

void phy_rf_write_spare_register_2_1(void *p, unsigned int writeData)
{
	// spare_register_2_1 [15:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_2_0(void *p)
{
	// spare_register_2_0 [7:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xff;
}

void phy_rf_write_spare_register_2_0(void *p, unsigned int writeData)
{
	// spare_register_2_0 [7:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf30;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_cmd_180_code(void *p)
{
	// cfg_cmd_180_code [8:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf34;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1ff;
}

void phy_rf_write_cfg_cmd_180_code(void *p, unsigned int writeData)
{
	// cfg_cmd_180_code [8:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf34;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffe00) | (~0xfffffe00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_chip_select(void *p)
{
	// cfg_chip_select [7:0] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf38;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xff;
}

void phy_rf_write_cfg_chip_select(void *p, unsigned int writeData)
{
	// cfg_chip_select [7:0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf38;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_vendor_specific_1(void *p)
{
	// vendor_specific_1 [31:0] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf3c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_vendor_specific_1(void *p, unsigned int writeData)
{
	// vendor_specific_1 [31:0] RW 0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf3c;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_vendor_specific_2(void *p)
{
	// vendor_specific_2 [31:0] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf40;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xffffffff;
}

void phy_rf_write_vendor_specific_2(void *p, unsigned int writeData)
{
	// vendor_specific_2 [31:0] RW 0
	unsigned int regAddr;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf40;
	phy_write_reg(mcu, regAddr, writeData);
}

unsigned int phy_rf_read_cfg_cdr_reset_b(void *p)
{
	// cfg_cdr_reset_b [0] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf44;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1;
}

void phy_rf_write_cfg_cdr_reset_b(void *p, unsigned int writeData)
{
	// cfg_cdr_reset_b [0] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf44;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_0_3(void *p)
{
	// spare_register_0_3 [31:24] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 24) & 0xff;
}

void phy_rf_write_spare_register_0_3(void *p, unsigned int writeData)
{
	// spare_register_0_3 [31:24] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff) | (~0xffffff & (writeData << 24));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_0_2(void *p)
{
	// spare_register_0_2 [23:16] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 16) & 0xff;
}

void phy_rf_write_spare_register_0_2(void *p, unsigned int writeData)
{
	// spare_register_0_2 [23:16] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xff00ffff) | (~0xff00ffff & (writeData << 16));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_0_1(void *p)
{
	// spare_register_0_1 [15:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 8) & 0xff;
}

void phy_rf_write_spare_register_0_1(void *p, unsigned int writeData)
{
	// spare_register_0_1 [15:8] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffff00ff) | (~0xffff00ff & (writeData << 8));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_spare_register_0_0(void *p)
{
	// spare_register_0_0 [7:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0xff;
}

void phy_rf_write_spare_register_0_0(void *p, unsigned int writeData)
{
	// spare_register_0_0 [7:0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf48;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff00) | (~0xffffff00 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_3(void *p)
{
	// cfg_dqxclk_90_3 [27:21] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 21) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_3(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_3 [27:21] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xf01fffff) | (~0xf01fffff & (writeData << 21));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_2(void *p)
{
	// cfg_dqxclk_90_2 [20:14] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 14) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_2(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_2 [20:14] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffe03fff) | (~0xffe03fff & (writeData << 14));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_1(void *p)
{
	// cfg_dqxclk_90_1 [13:7] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 7) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_1(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_1 [13:7] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffc07f) | (~0xffffc07f & (writeData << 7));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_0(void *p)
{
	// cfg_dqxclk_90_0 [6:0] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_0(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_0 [6:0] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf4c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff80) | (~0xffffff80 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_7(void *p)
{
	// cfg_dqxclk_90_7 [27:21] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 21) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_7(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_7 [27:21] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xf01fffff) | (~0xf01fffff & (writeData << 21));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_6(void *p)
{
	// cfg_dqxclk_90_6 [20:14] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 14) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_6(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_6 [20:14] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffe03fff) | (~0xffe03fff & (writeData << 14));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_5(void *p)
{
	// cfg_dqxclk_90_5 [13:7] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 7) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_5(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_5 [13:7] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffc07f) | (~0xffffc07f & (writeData << 7));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_4(void *p)
{
	// cfg_dqxclk_90_4 [6:0] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_4(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_4 [6:0] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf50;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff80) | (~0xffffff80 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_dqxclk_90_8(void *p)
{
	// cfg_dqxclk_90_8 [6:0] RWL 40
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf54;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x7f;
}

void phy_rf_write_cfg_dqxclk_90_8(void *p, unsigned int writeData)
{
	// cfg_dqxclk_90_8 [6:0] RWL 40
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf54;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffff80) | (~0xffffff80 & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_macro_num_pi_addr_180_cal(void *p)
{
	// cfg_macro_num_pi_addr_180_cal [5:2] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf58;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 2) & 0xf;
}

void phy_rf_write_cfg_macro_num_pi_addr_180_cal(void *p, unsigned int writeData)
{
	// cfg_macro_num_pi_addr_180_cal [5:2] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf58;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xffffffc3) | (~0xffffffc3 & (writeData << 2));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_enable_peak_computation(void *p)
{
	// cfg_enable_peak_computation [1] RW 0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf58;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 1) & 0x1;
}

void phy_rf_write_cfg_enable_peak_computation(void *p, unsigned int writeData)
{
	// cfg_enable_peak_computation [1] RW 0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf58;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffd) | (~0xfffffffd & (writeData << 1));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_addr_cal_en(void *p)
{
	// cfg_addr_cal_en [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf58;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1;
}

void phy_rf_write_cfg_addr_cal_en(void *p, unsigned int writeData)
{
	// cfg_addr_cal_en [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf58;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

unsigned int phy_rf_read_cfg_addr_cal_done(void *p)
{
	// cfg_addr_cal_done [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf5c;
	regReadData = phy_read_reg(mcu, regAddr);
	return (regReadData >> 0) & 0x1;
}

void phy_rf_write_cfg_addr_cal_done(void *p, unsigned int writeData)
{
	// cfg_addr_cal_done [0] RWL 0x0
	unsigned int regAddr;
	unsigned int regWriteData;
	unsigned int regReadData;

	struct apm_mcu *mcu = (struct apm_mcu *)p;
	regAddr = 0xf5c;
	regReadData = phy_read_reg(mcu, regAddr);
	regWriteData =
	    (regReadData & 0xfffffffe) | (~0xfffffffe & (writeData << 0));
	phy_write_reg(mcu, regAddr, regWriteData);
}

#endif // #ifndef PALLADIUM

#endif
