/**
 * Copyright (c) 2013, AppliedMicro Corp. All rights reserved.
 *
 * This program and the accompanying materials
 * are licensed and made available under the terms and conditions of the BSD License
 * which accompanies this distribution.  The full text of the license may be found at
 * http://opensource.org/licenses/bsd-license.php
 *
 * THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
 * WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
 *
 **/

#ifndef _KC_PHY_UTIL_REG_FLDS_
#define _KC_PHY_UTIL_REG_FLDS_

// Begin: customize for MCU
// Register Offset Address

// These PHY csrs - control pll that  Mcb controls directly
// Should not take effect
#define  PHY_REG_CFG_PLL_RESET        0xCC
#define  PHY_REG_CFG_DIVIDER_RESET    0xD4
#define  PHY_REG_CFG_PHY_RESET        0xD8
// ----- 

#define  PHY_REG_CFG_PHY_CONFIG       0x0
#define  PHY_REG_CFG_MEM_OE           0x4
#define  PHY_REG_CFG_MACRO_ENABLE     0x8
#define  PHY_REG_CFG_PHY_SRST         0xC
#define  PHY_REG_CFG_WRCAL_ADDR       0x14
#define  PHY_REG_CFG_TRAINING_DONE    0x28
#define  PHY_REG_CFG_DDR_PARAM_1      0x2C
#define  PHY_REG_CFG_DDR_PARAM_2      0x34
#define  PHY_REG_CFG_ANALOG_CONFIG_2  0x3c
#define  PHY_REG_CFG_ANALOG_CONFIG_3  0x40
#define  PHY_REG_CFG_ZQ_CAL_CODE      0x44
#define  PHY_REG_CFG_RANK_SHARE       0x48
#define  PHY_REG_CFG_WAKEUP_TIME      0x50
#define  PHY_REG_CFG_CMD_DELAY        0x54
#define  PHY_REG_CFG_AD_DELAY         0x58
#define  PHY_REG_CFG_CTL_DELAY        0x5C
#define  PHY_REG_CFG_RANK_EN          0x68
#define  PHY_REG_CFG_TRAINING_CONFIG_1 0x80
#define  PHY_REG_CFG_TRAINING_CONFIG_2 0x84
#define  PHY_REG_CFG_TRAINING_CONFIG_3 0x88
#define  PHY_REG_CFG_TRAINING_CONFIG_4 0x8C
#define  PHY_REG_CFG_ZQ_COUNTER       0x94
#define  PHY_REG_CFG_PRBS_TRIP_L      0x98
#define  PHY_REG_CFG_PRBS_TRIP_H      0x9C
#define  PHY_REG_CFG_PRBS_RESETB      0xA0
#define  PHY_REG_CFG_PRBS_BIT_SEL     0xA4
#define  PHY_REG_CFG_PRBS_STATUS      0xA8
#define  PHY_REG_CFG_PRBS_CAPTURE     0xAC
#define  PHY_REG_CFG_PRBS_LOAD        0xB0
#define  PHY_REG_CFG_PRBS_CNT_DONE    0xB4
#define  PHY_REG_CFG_DISABLE_DLL_CAL  0xbc
#define  PHY_REG_CFG_DELAY_FROM_RD_EN 0xC0
#define  PHY_REG_CFG_LOOPBACK         0xDC
#define  PHY_REG_CFG_PRBS_ERR_CNT_1   0xe0
#define  PHY_REG_CFG_PRBS_ERR_CNT_2   0xe4
#define  PHY_REG_CFG_PRBS_ERR_CNT_3   0xe8
#define  PHY_REG_CFG_PRBS_ERR_CNT_4   0xec
#define  PHY_REG_CFG_PRBS_ERR_CNT_5   0xf0
#define  PHY_REG_CFG_PRBS_ERR_CNT_6   0xf4
#define  PHY_REG_CFG_PRBS_ERR_CNT_7   0xf8
#define  PHY_REG_CFG_RETRAIN_ENABLE   0x104
#define  PHY_REG_CFG_CDR_ENABLE       0x108
#define  PHY_REG_CFG_RECEIVER_BIAS    0x114
#define  PHY_REG_CFG_CDR_LOCK_RESET   0x140
#define  PHY_REG_CFG_CDR_LOCK         0x144
#define  PHY_REG_CFG_PI_CODE          0x148
#define  PHY_REG_CFG_GATE_PRE_VAL_1   0x14C
#define  PHY_REG_CFG_GATE_PRE_VAL_2   0x150
#define  PHY_REG_CFG_GATE_PRE_VAL_3   0x154
#define  PHY_REG_CFG_CDR_CONFIG       0x13c

#define  PHY_REG_CFG_DQX_PEAK_0       0x2b4
#define  PHY_REG_CFG_DQX_PEAK_1       0x434
#define  PHY_REG_CFG_DQX_PEAK_2       0x5b4
#define  PHY_REG_CFG_DQX_PEAK_3       0x734
#define  PHY_REG_CFG_DQX_PEAK_4       0x8b4
#define  PHY_REG_CFG_DQX_PEAK_5       0xa34
#define  PHY_REG_CFG_DQX_PEAK_6       0xbb4
#define  PHY_REG_CFG_DQX_PEAK_7       0xd34
#define  PHY_REG_CFG_DQX_PEAK_8       0xeb4

#define  PHY_REG_SPARE_REGISTER_1_0   0xf2c
#define  PHY_REG_CFG_CMD_CODE         0xf34
#define  PHY_REG_CFG_CDR_RESETB       0xF44
#define  PHY_REG_CFG_ADDR_CAL_EN      0xf58
#define  PHY_REG_CFG_ADDR_CAL_DONE    0xf5c

// JHR 2/23 original
#define  PHY_INIT_DLY_FROM_RD_EN_VAL  0x3
// JHR 2/33 suggested test value (fails quickly - bad)  PHY_INIT_DLY_FROM_RD_EN_VAL  0x4

#define  PRBS_AM_LONG     0x0
#define  PRBS_DM_LONG     0x1
#define  PRBS_AM_SHORT    0x2
#define  PRBS_DM_SHORT    0x3
#define  PRBS_AM_DM_SHORT 0x4
#define  PRBS_AM_DM_LONG  0x5

#define PHY_PRBS_LOOP_DQS_SCHMOO   0x80
#define PHY_PRBS_LB_DQX   0
#define PHY_PRBS_LB_TYPE  PRBS_DM_SHORT

#define   PHY_CFG_CMD_DELAY_REG                    KC_PHY_REG21
#define   PHY_CFG_AD_DELAY_REG                     KC_PHY_REG22
#define   PHY_CFG_CTL_DELAY_REG                    KC_PHY_REG23
#define   PHY_CFG_CMD_DELAY                        0x080
#define   PHY_CFG_AD_DELAY                         0x080
#define   PHY_CFG_CTL_DELAY                        0x080

#define   PHY_CFG_REG_WRLVL_DELAY               0x1C0
// 0x4C0  //0x1C0   //0x250 //
#define   PHY_CFG_REG_RDLVL_GATE_DELAY          0x4C0
// 0x7C0  //0x2C0   //0x270 //
#define   PHY_CFG_REG_RDLVL_DELAY               0x040

#define   PHY_CFG_CK_CKE_CS_ODT_EN_REG               0x004
#define   PHY_CFG_CK_CKE_CS_ODT_EN_VALUE        0xffffffff

#define PHY_CFG_REG_RDLVL_DELAY0_0              0x1f4
#define PHY_CFG_REG_RDLVL_DELAY0_0_1            0x1f8
#define PHY_CFG_REG_RDLVL_GATE_DELAY0_0         0x1fc
#define PHY_CFG_REG_RDLVL_GATE_DELAY0_0_1       0x200
#define PHY_CFG_REG_WRLVL_DELAY0_0              0x204
#define PHY_CFG_REG_WRLVL_DELAY0_0_1            0x208

#define PHY_CFG_REG_WRCAL_PAT1                  0x78
#define PHY_CFG_REG_WRCAL_PAT2                  0x7C

#define PHY_CFG_RDLVL_TRIM_N                    0x1C8
#define PHY_CFG_WRLVL_TRIM_N                    0x1CC

#define PHY_CFG_WRDQ_DEL_N_0                    0x1D0
#define PHY_CFG_DQX_90_1                        0xF4C
#define PHY_CFG_DQX_90_2                        0xF50
#define PHY_CFG_DQX_90_3                        0xF54

// To calculate PHY_CFG+REG address for  PHY_CFG_REG_LVL_DELAY<rank>_<macro/lane>
// new address = PHY_CFG_REG_LVL_DELAY0_0 + rank * 0x18 + lane * 0x180
// new address = PHY_CFG_REG_LVL_DELAY0_0_1 + rank * 0x18 + lane * 0x180

#define PHY_REG_INCR_4_MACRO_OFFSET    0x180
#define PHY_REG_INCR_4_RANK_OFFSET     0x18

// General training error
#define  KC_PHY_REG36  0x90
#define  KC_PHY_REG36_CFG_WRLVL_ERROR_RNG  4
#define  KC_PHY_REG36_CFG_WRCAL_ERROR_RNG  3
#define  KC_PHY_REG36_CFG_RDLVL_GATE_ERROR_RNG  2
#define  KC_PHY_REG36_CFG_RDLVL_ERROR_RNG  1
#define  KC_PHY_REG36_CFG_TRAINING_ERROR_RNG  0

//Per lane training error
#define  KC_PHY_REG49  0xc4
#define  KC_PHY_REG49_MACRO8_1_ERROR_RNG  17
#define  KC_PHY_REG49_MACRO8_0_ERROR_RNG  16
#define  KC_PHY_REG49_MACRO7_1_ERROR_RNG  15
#define  KC_PHY_REG49_MACRO7_0_ERROR_RNG  14
#define  KC_PHY_REG49_MACRO6_1_ERROR_RNG  13
#define  KC_PHY_REG49_MACRO6_0_ERROR_RNG  12
#define  KC_PHY_REG49_MACRO5_1_ERROR_RNG  11
#define  KC_PHY_REG49_MACRO5_0_ERROR_RNG  10
#define  KC_PHY_REG49_MACRO4_1_ERROR_RNG  9
#define  KC_PHY_REG49_MACRO4_0_ERROR_RNG  8
#define  KC_PHY_REG49_MACRO3_1_ERROR_RNG  7
#define  KC_PHY_REG49_MACRO3_0_ERROR_RNG  6
#define  KC_PHY_REG49_MACRO2_1_ERROR_RNG  5
#define  KC_PHY_REG49_MACRO2_0_ERROR_RNG  4
#define  KC_PHY_REG49_MACRO1_1_ERROR_RNG  3
#define  KC_PHY_REG49_MACRO1_0_ERROR_RNG  2
#define  KC_PHY_REG49_MACRO0_1_ERROR_RNG  1
#define  KC_PHY_REG49_MACRO0_0_ERROR_RNG  0

// CSRs

// High level KC PHY routines
void kc_phy_timing_param_setup(void *ptr);
void kc_phy_set_wrlvl_func(void *ptr, int unsigned /*0 */ orfunc);
void kc_phy_post_train_cfg(void *ptr);
void kc_phy_pre_dfi_reset(void *ptr);	//JHR added for CDR
void kc_phy_dll_prog_quad_wt_steps(void *ptr, int unsigned /*0 */ lofreq);
void kc_phy_en180_cal_addrmacro(void *ptr);
void kc_phy_init_before_train(void *ptr);
void kc_phy_quick_setup(void *ptr);
void kc_phy_drv_strength_slew_setup(void *ptr);
int mcu_kc_phy_pbrs_loopback(void *ptr);
int prbs_short_loopback_dm(void *ptr);
int prbs_long_loopback_dm(void *ptr);
int prbs_short_loopback_dm_infinite(void *ptr);
int prbs_long_loopback_dm_infinite(void *ptr);
int prbs_short_loopback_am(void *ptr);
int prbs_long_loopback_am(void *ptr);
int mcu_kc_phy_prbs_short_loopback_sweep(void *ptr, int unsigned dqx,
					 int unsigned lbtype);
int prbs_general_loopback_dm(void *ptr, int unsigned lbtype,
			     int unsigned loopcnt);
int prbs_general_loopback_am(void *ptr, int unsigned lbtype);

// CSR access by field
unsigned int phy_rf_read_cfg_parity_oe(void *p);
void phy_rf_write_cfg_parity_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_x4_en(void *p);
void phy_rf_write_cfg_x4_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_disable_dll_lock(void *p);
void phy_rf_write_cfg_disable_dll_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_read_w_fixed_delay(void *p);
void phy_rf_write_cfg_read_w_fixed_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_sel(void *p);
void phy_rf_write_cfg_delay_from_rden_sel(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden(void *p);
void phy_rf_write_cfg_delay_from_rden(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_mode(void *p);
void phy_rf_write_cfg_rdlvl_mode(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_mode(void *p);
void phy_rf_write_cfg_wrlvl_mode(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_mode(void *p);
void phy_rf_write_cfg_rdlvl_gate_mode(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_reset_oe(void *p);
void phy_rf_write_cfg_reset_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cmd_oe(void *p);
void phy_rf_write_cfg_cmd_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs7_oe(void *p);
void phy_rf_write_cfg_cs7_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs6_oe(void *p);
void phy_rf_write_cfg_cs6_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs5_oe(void *p);
void phy_rf_write_cfg_cs5_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs4_oe(void *p);
void phy_rf_write_cfg_cs4_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs3_oe(void *p);
void phy_rf_write_cfg_cs3_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs2_oe(void *p);
void phy_rf_write_cfg_cs2_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs1_oe(void *p);
void phy_rf_write_cfg_cs1_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cs0_oe(void *p);
void phy_rf_write_cfg_cs0_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck7_oe(void *p);
void phy_rf_write_cfg_ck7_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck6_oe(void *p);
void phy_rf_write_cfg_ck6_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck5_oe(void *p);
void phy_rf_write_cfg_ck5_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck4_oe(void *p);
void phy_rf_write_cfg_ck4_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck3_oe(void *p);
void phy_rf_write_cfg_ck3_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck2_oe(void *p);
void phy_rf_write_cfg_ck2_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck1_oe(void *p);
void phy_rf_write_cfg_ck1_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ck0_oe(void *p);
void phy_rf_write_cfg_ck0_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt7_oe(void *p);
void phy_rf_write_cfg_odt7_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt6_oe(void *p);
void phy_rf_write_cfg_odt6_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt5_oe(void *p);
void phy_rf_write_cfg_odt5_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt4_oe(void *p);
void phy_rf_write_cfg_odt4_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt3_oe(void *p);
void phy_rf_write_cfg_odt3_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt2_oe(void *p);
void phy_rf_write_cfg_odt2_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt1_oe(void *p);
void phy_rf_write_cfg_odt1_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt0_oe(void *p);
void phy_rf_write_cfg_odt0_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke7_oe(void *p);
void phy_rf_write_cfg_cke7_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke6_oe(void *p);
void phy_rf_write_cfg_cke6_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke5_oe(void *p);
void phy_rf_write_cfg_cke5_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke4_oe(void *p);
void phy_rf_write_cfg_cke4_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke3_oe(void *p);
void phy_rf_write_cfg_cke3_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke2_oe(void *p);
void phy_rf_write_cfg_cke2_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke1_oe(void *p);
void phy_rf_write_cfg_cke1_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cke0_oe(void *p);
void phy_rf_write_cfg_cke0_oe(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro8_1_en(void *p);
void phy_rf_write_cfg_macro8_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro8_0_en(void *p);
void phy_rf_write_cfg_macro8_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro7_1_en(void *p);
void phy_rf_write_cfg_macro7_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro7_0_en(void *p);
void phy_rf_write_cfg_macro7_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro6_1_en(void *p);
void phy_rf_write_cfg_macro6_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro6_0_en(void *p);
void phy_rf_write_cfg_macro6_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro5_1_en(void *p);
void phy_rf_write_cfg_macro5_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro5_0_en(void *p);
void phy_rf_write_cfg_macro5_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro4_1_en(void *p);
void phy_rf_write_cfg_macro4_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro4_0_en(void *p);
void phy_rf_write_cfg_macro4_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro3_1_en(void *p);
void phy_rf_write_cfg_macro3_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro3_0_en(void *p);
void phy_rf_write_cfg_macro3_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro2_1_en(void *p);
void phy_rf_write_cfg_macro2_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro2_0_en(void *p);
void phy_rf_write_cfg_macro2_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro1_1_en(void *p);
void phy_rf_write_cfg_macro1_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro1_0_en(void *p);
void phy_rf_write_cfg_macro1_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro0_1_en(void *p);
void phy_rf_write_cfg_macro0_1_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro0_0_en(void *p);
void phy_rf_write_cfg_macro0_0_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_prbs_srst(void *p);
void phy_rf_write_cfg_prbs_srst(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_tr_srst(void *p);
void phy_rf_write_cfg_tr_srst(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_retrain_en(void *p);
void phy_rf_write_cfg_wrlvl_retrain_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_retrain_en(void *p);
void phy_rf_write_cfg_rdlvl_retrain_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_retrain_en(void *p);
void phy_rf_write_cfg_rdlvl_gate_retrain_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cal_ba_addr(void *p);
void phy_rf_write_cfg_cal_ba_addr(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cal_col_addr(void *p);
void phy_rf_write_cfg_cal_col_addr(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cal_row_addr(void *p);
void phy_rf_write_cfg_cal_row_addr(void *p, unsigned int writeData);
unsigned int phy_rf_read_wr_cal_done(void *p);
unsigned int phy_rf_read_cfg_wrlvl_en(void *p);
void phy_rf_write_cfg_wrlvl_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_en(void *p);
void phy_rf_write_cfg_rdlvl_gate_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_en(void *p);
void phy_rf_write_cfg_rdlvl_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_2nd_rdlvl_en(void *p);
void phy_rf_write_cfg_2nd_rdlvl_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wr_deskew_en(void *p);
void phy_rf_write_cfg_wr_deskew_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrcal_en(void *p);
void phy_rf_write_cfg_wrcal_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rd_deskew_en(void *p);
void phy_rf_write_cfg_rd_deskew_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_deskew_delay_param(void *p);
void phy_rf_write_cfg_deskew_delay_param(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_deskew_samples_per_delay(void *p);
void phy_rf_write_cfg_deskew_samples_per_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wr_deskew_done(void *p);
unsigned int phy_rf_read_cfg_rd_deskew_done(void *p);
unsigned int phy_rf_read_training_done(void *p);
unsigned int phy_rf_read_twlmrd(void *p);
void phy_rf_write_twlmrd(void *p, unsigned int writeData);
unsigned int phy_rf_read_tmod(void *p);
void phy_rf_write_tmod(void *p, unsigned int writeData);
unsigned int phy_rf_read_twrlvl_ww(void *p);
void phy_rf_write_twrlvl_ww(void *p, unsigned int writeData);
unsigned int phy_rf_read_trp(void *p);
void phy_rf_write_trp(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_mc_power_ok(void *p);
void phy_rf_write_cfg_mc_power_ok(void *p, unsigned int writeData);
unsigned int phy_rf_read_trcd(void *p);
void phy_rf_write_trcd(void *p, unsigned int writeData);
unsigned int phy_rf_read_twrd(void *p);
void phy_rf_write_twrd(void *p, unsigned int writeData);
unsigned int phy_rf_read_twl(void *p);
void phy_rf_write_twl(void *p, unsigned int writeData);
unsigned int phy_rf_read_trl(void *p);
void phy_rf_write_trl(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqs_odis_lat(void *p);
void phy_rf_write_cfg_dqs_odis_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqs_oen_lat(void *p);
void phy_rf_write_cfg_dqs_oen_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dq_odis_lat(void *p);
void phy_rf_write_cfg_dq_odis_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dq_oen_lat(void *p);
void phy_rf_write_cfg_dq_oen_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqs_odtdis_lat(void *p);
void phy_rf_write_cfg_dqs_odtdis_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqs_odten_lat(void *p);
void phy_rf_write_cfg_dqs_odten_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dq_odtdis_lat(void *p);
void phy_rf_write_cfg_dq_odtdis_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dq_odten_lat(void *p);
void phy_rf_write_cfg_dq_odten_lat(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_cmd_stren(void *p);
void phy_rf_write_cfg_drv_cmd_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_ad_slew(void *p);
void phy_rf_write_cfg_drv_ad_slew(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_ad_stren(void *p);
void phy_rf_write_cfg_drv_ad_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rcvr_os(void *p);
void phy_rf_write_cfg_rcvr_os(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_slew(void *p);
void phy_rf_write_cfg_drv_slew(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_stren(void *p);
void phy_rf_write_cfg_drv_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_dm_slew(void *p);
void phy_rf_write_cfg_drv_dm_slew(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_dm_stren(void *p);
void phy_rf_write_cfg_drv_dm_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dis_odt(void *p);
void phy_rf_write_cfg_dis_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_odt_stren(void *p);
void phy_rf_write_cfg_odt_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_clk_slew(void *p);
void phy_rf_write_cfg_drv_clk_slew(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_clk_stren(void *p);
void phy_rf_write_cfg_drv_clk_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_ctl_slew(void *p);
void phy_rf_write_cfg_drv_ctl_slew(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_ctl_stren(void *p);
void phy_rf_write_cfg_drv_ctl_stren(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_drv_cmd_slew(void *p);
void phy_rf_write_cfg_drv_cmd_slew(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_calib_code_n(void *p);
void phy_rf_write_cfg_calib_code_n(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_calib_code_p(void *p);
void phy_rf_write_cfg_calib_code_p(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank7_odt(void *p);
void phy_rf_write_rank7_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank6_odt(void *p);
void phy_rf_write_rank6_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank5_odt(void *p);
void phy_rf_write_rank5_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank4_odt(void *p);
void phy_rf_write_rank4_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank3_odt(void *p);
void phy_rf_write_rank3_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank2_odt(void *p);
void phy_rf_write_rank2_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank1_odt(void *p);
void phy_rf_write_rank1_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank0_odt(void *p);
void phy_rf_write_rank0_odt(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank7_cke(void *p);
void phy_rf_write_rank7_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank6_cke(void *p);
void phy_rf_write_rank6_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank5_cke(void *p);
void phy_rf_write_rank5_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank4_cke(void *p);
void phy_rf_write_rank4_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank3_cke(void *p);
void phy_rf_write_rank3_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank2_cke(void *p);
void phy_rf_write_rank2_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank1_cke(void *p);
void phy_rf_write_rank1_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank0_cke(void *p);
void phy_rf_write_rank0_cke(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_lp4_code(void *p);
void phy_rf_write_cfg_lp4_code(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_lp3_code(void *p);
void phy_rf_write_cfg_lp3_code(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_lp2_code(void *p);
void phy_rf_write_cfg_lp2_code(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_lp1_code(void *p);
void phy_rf_write_cfg_lp1_code(void *p, unsigned int writeData);
unsigned int phy_rf_read_wakeup_time_lp4(void *p);
void phy_rf_write_wakeup_time_lp4(void *p, unsigned int writeData);
unsigned int phy_rf_read_wakeup_time_lp3(void *p);
void phy_rf_write_wakeup_time_lp3(void *p, unsigned int writeData);
unsigned int phy_rf_read_wakeup_time_lp2(void *p);
void phy_rf_write_wakeup_time_lp2(void *p, unsigned int writeData);
unsigned int phy_rf_read_wakeup_time_lp1(void *p);
void phy_rf_write_wakeup_time_lp1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cmd_pi_en(void *p);
void phy_rf_write_cfg_cmd_pi_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cmd_pi_byp(void *p);
void phy_rf_write_cfg_cmd_pi_byp(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cmd_delay(void *p);
void phy_rf_write_cfg_cmd_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ad_pi_en(void *p);
void phy_rf_write_cfg_ad_pi_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ad_pi_byp(void *p);
void phy_rf_write_cfg_ad_pi_byp(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ad_delay(void *p);
void phy_rf_write_cfg_ad_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ctl_pi_en(void *p);
void phy_rf_write_cfg_ctl_pi_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ctl_pi_byp(void *p);
void phy_rf_write_cfg_ctl_pi_byp(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ctl_delay(void *p);
void phy_rf_write_cfg_ctl_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dpd_ck_status(void *p);
void phy_rf_write_cfg_dpd_ck_status(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rst_ck_status(void *p);
void phy_rf_write_cfg_rst_ck_status(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_bypass(void *p);
void phy_rf_write_cfg_dll_bypass(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank7(void *p);
void phy_rf_write_rank7(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank6(void *p);
void phy_rf_write_rank6(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank5(void *p);
void phy_rf_write_rank5(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank4(void *p);
void phy_rf_write_rank4(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank3(void *p);
void phy_rf_write_rank3(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank2(void *p);
void phy_rf_write_rank2(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank1(void *p);
void phy_rf_write_rank1(void *p, unsigned int writeData);
unsigned int phy_rf_read_rank0(void *p);
void phy_rf_write_rank0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_load(void *p);
void phy_rf_write_cfg_wrlvl_load(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_gatelvl_load(void *p);
void phy_rf_write_cfg_gatelvl_load(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_load(void *p);
void phy_rf_write_cfg_rdlvl_load(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_debug_sel(void *p);
void phy_rf_write_cfg_debug_sel(void *p, unsigned int writeData);
unsigned int phy_rf_read_dqs_weak_pull_down_disable(void *p);
void phy_rf_write_dqs_weak_pull_down_disable(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern4(void *p);
void phy_rf_write_cfg_pattern4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern3(void *p);
void phy_rf_write_cfg_pattern3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern2(void *p);
void phy_rf_write_cfg_pattern2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern1(void *p);
void phy_rf_write_cfg_pattern1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern8(void *p);
void phy_rf_write_cfg_pattern8(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern7(void *p);
void phy_rf_write_cfg_pattern7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern6(void *p);
void phy_rf_write_cfg_pattern6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pattern5(void *p);
void phy_rf_write_cfg_pattern5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_num_of_wr_samples(void *p);
void phy_rf_write_cfg_num_of_wr_samples(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_incr_size(void *p);
void phy_rf_write_cfg_wrlvl_incr_size(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_write_samples_per_delay(void *p);
void phy_rf_write_cfg_write_samples_per_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_max_delay_limit(void *p);
void phy_rf_write_cfg_wrlvl_max_delay_limit(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_incr_size(void *p);
void phy_rf_write_cfg_rdlvl_incr_size(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_read_samples_per_delay(void *p);
void phy_rf_write_cfg_read_samples_per_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_max_delay_limit(void *p);
void phy_rf_write_cfg_rdlvl_max_delay_limit(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_num_of_gt_samples(void *p);
void phy_rf_write_cfg_num_of_gt_samples(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_incr_size(void *p);
void phy_rf_write_cfg_rdlvl_gate_incr_size(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_gate_samples_per_delay(void *p);
void phy_rf_write_cfg_gate_samples_per_delay(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_max_delay_limit(void *p);
void phy_rf_write_cfg_rdlvl_gate_max_delay_limit(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_gt_retrain_val(void *p);
void phy_rf_write_cfg_gt_retrain_val(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrcal_max_delay_limit(void *p);
void phy_rf_write_cfg_wrcal_max_delay_limit(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_error(void *p);
unsigned int phy_rf_read_cfg_wrcal_error(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_error(void *p);
unsigned int phy_rf_read_cfg_rdlvl_error(void *p);
unsigned int phy_rf_read_cfg_training_error(void *p);
unsigned int phy_rf_read_cfg_zq_counter(void *p);
void phy_rf_write_cfg_zq_counter(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_prbs_trip_cnt_l(void *p);
void phy_rf_write_cfg_prbs_trip_cnt_l(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_prbs_trip_cnt_h(void *p);
void phy_rf_write_cfg_prbs_trip_cnt_h(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_bert_resetb(void *p);
void phy_rf_write_cfg_bert_resetb(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_bit_sel(void *p);
void phy_rf_write_prbs_bit_sel(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail15(void *p);
void phy_rf_write_prbs_fail15(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail14(void *p);
void phy_rf_write_prbs_fail14(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail13(void *p);
void phy_rf_write_prbs_fail13(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail12(void *p);
void phy_rf_write_prbs_fail12(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail11(void *p);
void phy_rf_write_prbs_fail11(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail10(void *p);
void phy_rf_write_prbs_fail10(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail9(void *p);
void phy_rf_write_prbs_fail9(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail8(void *p);
void phy_rf_write_prbs_fail8(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail7(void *p);
void phy_rf_write_prbs_fail7(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail6(void *p);
void phy_rf_write_prbs_fail6(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail5(void *p);
void phy_rf_write_prbs_fail5(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail4(void *p);
void phy_rf_write_prbs_fail4(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail3(void *p);
void phy_rf_write_prbs_fail3(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail2(void *p);
void phy_rf_write_prbs_fail2(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail1(void *p);
void phy_rf_write_prbs_fail1(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_fail0(void *p);
void phy_rf_write_prbs_fail0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_prbs_error_capture(void *p);
void phy_rf_write_cfg_prbs_error_capture(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_prbs_load(void *p);
unsigned int phy_rf_read_cfg_prbs_cnt_done(void *p);
unsigned int phy_rf_read_cfg_dll_cal_busy(void *p);
void phy_rf_write_cfg_dll_cal_busy(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_disable_dll_cal(void *p);
void phy_rf_write_cfg_disable_dll_cal(void *p, unsigned int writeData);
unsigned int phy_rf_read_rdlvl_trim_for_wrlvl_trim(void *p);
void phy_rf_write_rdlvl_trim_for_wrlvl_trim(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_7(void *p);
void phy_rf_write_cfg_delay_from_rden_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_6(void *p);
void phy_rf_write_cfg_delay_from_rden_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_5(void *p);
void phy_rf_write_cfg_delay_from_rden_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_4(void *p);
void phy_rf_write_cfg_delay_from_rden_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_3(void *p);
void phy_rf_write_cfg_delay_from_rden_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_2(void *p);
void phy_rf_write_cfg_delay_from_rden_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_1(void *p);
void phy_rf_write_cfg_delay_from_rden_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_delay_from_rden_0(void *p);
void phy_rf_write_cfg_delay_from_rden_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_macro8_1_error(void *p);
unsigned int phy_rf_read_macro8_0_error(void *p);
unsigned int phy_rf_read_macro7_1_error(void *p);
unsigned int phy_rf_read_macro7_0_error(void *p);
unsigned int phy_rf_read_macro6_1_error(void *p);
unsigned int phy_rf_read_macro6_0_error(void *p);
unsigned int phy_rf_read_macro5_1_error(void *p);
unsigned int phy_rf_read_macro5_0_error(void *p);
unsigned int phy_rf_read_macro4_1_error(void *p);
unsigned int phy_rf_read_macro4_0_error(void *p);
unsigned int phy_rf_read_macro3_1_error(void *p);
unsigned int phy_rf_read_macro3_0_error(void *p);
unsigned int phy_rf_read_macro2_1_error(void *p);
unsigned int phy_rf_read_macro2_0_error(void *p);
unsigned int phy_rf_read_macro1_1_error(void *p);
unsigned int phy_rf_read_macro1_0_error(void *p);
unsigned int phy_rf_read_macro0_1_error(void *p);
unsigned int phy_rf_read_macro0_0_error(void *p);
unsigned int phy_rf_read_cfg_prbs_clk_enable(void *p);
void phy_rf_write_cfg_prbs_clk_enable(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_training_clk_enable(void *p);
void phy_rf_write_cfg_training_clk_enable(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pll_reset(void *p);
void phy_rf_write_cfg_pll_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pll_lock(void *p);
void phy_rf_write_cfg_pll_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_divider_reset(void *p);
void phy_rf_write_cfg_divider_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_phy_reset(void *p);
void phy_rf_write_cfg_phy_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_fly_over_read(void *p);
void phy_rf_write_cfg_fly_over_read(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_fly_over_sel(void *p);
void phy_rf_write_cfg_fly_over_sel(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_farend_loopback_read(void *p);
void phy_rf_write_cfg_farend_loopback_read(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_farend_loopback(void *p);
void phy_rf_write_cfg_farend_loopback(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_data_loopback_en(void *p);
void phy_rf_write_cfg_data_loopback_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_add_loopback_en(void *p);
void phy_rf_write_cfg_add_loopback_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_longloopback_en(void *p);
void phy_rf_write_cfg_longloopback_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_loopback_en(void *p);
void phy_rf_write_cfg_loopback_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt1(void *p);
void phy_rf_write_prbs_err_cnt1(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt0(void *p);
void phy_rf_write_prbs_err_cnt0(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt3(void *p);
void phy_rf_write_prbs_err_cnt3(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt2(void *p);
void phy_rf_write_prbs_err_cnt2(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt5(void *p);
void phy_rf_write_prbs_err_cnt5(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt4(void *p);
void phy_rf_write_prbs_err_cnt4(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt7(void *p);
void phy_rf_write_prbs_err_cnt7(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt6(void *p);
void phy_rf_write_prbs_err_cnt6(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt9(void *p);
void phy_rf_write_prbs_err_cnt9(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt8(void *p);
void phy_rf_write_prbs_err_cnt8(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt11(void *p);
void phy_rf_write_prbs_err_cnt11(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt10(void *p);
void phy_rf_write_prbs_err_cnt10(void *p, unsigned int writeData);
unsigned int phy_rf_read_prbs_err_cnt12(void *p);
void phy_rf_write_prbs_err_cnt12(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_cal_state(void *p);
void phy_rf_write_cfg_dll_cal_state(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_test_capture(void *p);
void phy_rf_write_cfg_dll_test_capture(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_lowfrq_en(void *p);
void phy_rf_write_cfg_lowfrq_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_hi_bwctrl(void *p);
void phy_rf_write_cfg_hi_bwctrl(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pll_atest_sel(void *p);
void phy_rf_write_cfg_pll_atest_sel(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_cdr_pi_preload_en(void *p);
void phy_rf_write_cfg_dqxclk_cdr_pi_preload_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_piclk_cdr_pi_preload_en(void *p);
void phy_rf_write_cfg_piclk_cdr_pi_preload_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_phyclk1x_cdr_pi_preload_en(void *p);
void phy_rf_write_cfg_phyclk1x_cdr_pi_preload_en(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_pcclk_cdr_pi_preload_en(void *p);
void phy_rf_write_cfg_pcclk_cdr_pi_preload_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_mcclk_cdr_pi_preload_en(void *p);
void phy_rf_write_cfg_mcclk_cdr_pi_preload_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_cdr_phloop_en(void *p);
void phy_rf_write_cfg_dqxclk_cdr_phloop_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_piclk_cdr_phloop_en(void *p);
void phy_rf_write_cfg_piclk_cdr_phloop_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_phyclk1x_cdr_phloop_en(void *p);
void phy_rf_write_cfg_phyclk1x_cdr_phloop_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pcclk_cdr_phloop_en(void *p);
void phy_rf_write_cfg_pcclk_cdr_phloop_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_mcclk_cdr_phloop_en(void *p);
void phy_rf_write_cfg_mcclk_cdr_phloop_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dtest_ena(void *p);
void phy_rf_write_cfg_dtest_ena(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_atest_ena(void *p);
void phy_rf_write_cfg_atest_ena(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dtest_add(void *p);
void phy_rf_write_cfg_dtest_add(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_atest_add(void *p);
void phy_rf_write_cfg_atest_add(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rcvr_bias_en(void *p);
void phy_rf_write_cfg_rcvr_bias_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ena_recv(void *p);
void phy_rf_write_cfg_ena_recv(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_num(void *p);
void phy_rf_write_cfg_dll_num(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro_num(void *p);
void phy_rf_write_cfg_macro_num(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_cal_en(void *p);
void phy_rf_write_cfg_dll_cal_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_cal_done(void *p);
unsigned int phy_rf_read_m9_dll0_quad_b_step(void *p);
void phy_rf_write_m9_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_a_step(void *p);
void phy_rf_write_m9_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_d_step(void *p);
void phy_rf_write_m9_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_c_step(void *p);
void phy_rf_write_m9_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_f_step(void *p);
void phy_rf_write_m9_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_e_step(void *p);
void phy_rf_write_m9_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_h_step(void *p);
void phy_rf_write_m9_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_g_step(void *p);
void phy_rf_write_m9_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_a_wt(void *p);
void phy_rf_write_m9_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_b_wt(void *p);
void phy_rf_write_m9_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_c_wt(void *p);
void phy_rf_write_m9_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_d_wt(void *p);
void phy_rf_write_m9_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_e_wt(void *p);
void phy_rf_write_m9_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_f_wt(void *p);
void phy_rf_write_m9_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_g_wt(void *p);
void phy_rf_write_m9_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m9_dll0_quad_h_wt(void *p);
void phy_rf_write_m9_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wait_status_timer(void *p);
void phy_rf_write_cfg_wait_status_timer(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cont_samples(void *p);
void phy_rf_write_cfg_cont_samples(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll_sft_rst(void *p);
void phy_rf_write_cfg_dll_sft_rst(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_poc(void *p);
void phy_rf_write_cfg_poc(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_lock_count(void *p);
void phy_rf_write_cfg_cdr_lock_count(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_pi_preload_val(void *p);
void phy_rf_write_cfg_cdr_pi_preload_val(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_kphase(void *p);
void phy_rf_write_cfg_cdr_kphase(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_cdr_lock_reset(void *p);
void phy_rf_write_cfg_dqxclk_cdr_lock_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_piclk_cdr_lock_reset(void *p);
void phy_rf_write_cfg_piclk_cdr_lock_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_phyclk1x_cdr_lock_reset(void *p);
void phy_rf_write_cfg_phyclk1x_cdr_lock_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pcclk_cdr_lock_reset(void *p);
void phy_rf_write_cfg_pcclk_cdr_lock_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_mcclk_cdr_lock_reset(void *p);
void phy_rf_write_cfg_mcclk_cdr_lock_reset(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_cdr_lock(void *p);
void phy_rf_write_cfg_dqxclk_cdr_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_piclk_cdr_lock(void *p);
void phy_rf_write_cfg_piclk_cdr_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_phyclk1x_cdr_lock(void *p);
void phy_rf_write_cfg_phyclk1x_cdr_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_pcclk_cdr_lock(void *p);
void phy_rf_write_cfg_pcclk_cdr_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_mcclk_cdr_lock(void *p);
void phy_rf_write_cfg_mcclk_cdr_lock(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_pi_out(void *p);
void phy_rf_write_cfg_cdr_pi_out(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_3(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_3(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_2(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_2(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_1(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_0(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_7(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_7(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_6(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_6(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_5(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_5(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_4(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_4(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay_pre_val_8(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay_pre_val_8(void *p,
						 unsigned int writeData);
unsigned int phy_rf_read_cfg_timeout_counter(void *p);
void phy_rf_write_cfg_timeout_counter(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_trig_data(void *p);
void phy_rf_write_cfg_trig_data(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_mask_data(void *p);
void phy_rf_write_cfg_mask_data(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_skip_samples(void *p);
void phy_rf_write_cfg_skip_samples(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_num_samples(void *p);
void phy_rf_write_cfg_num_samples(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_initial_skip(void *p);
void phy_rf_write_cfg_initial_skip(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_en_fifo_trig(void *p);
void phy_rf_write_cfg_en_fifo_trig(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_fifo_srst(void *p);
void phy_rf_write_cfg_fifo_srst(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_fifo_read(void *p);
void phy_rf_write_cfg_fifo_read(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_fifo_empty(void *p);
void phy_rf_write_cfg_fifo_empty(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_fifo_rdata(void *p);
void phy_rf_write_cfg_fifo_rdata(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_sampling_done(void *p);
void phy_rf_write_cfg_sampling_done(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_d_wt(void *p);
void phy_rf_write_m0_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_c_wt(void *p);
void phy_rf_write_m0_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_b_wt(void *p);
void phy_rf_write_m0_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_a_wt(void *p);
void phy_rf_write_m0_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_h_wt(void *p);
void phy_rf_write_m0_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_g_wt(void *p);
void phy_rf_write_m0_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_f_wt(void *p);
void phy_rf_write_m0_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_e_wt(void *p);
void phy_rf_write_m0_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_d_wt(void *p);
void phy_rf_write_m0_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_c_wt(void *p);
void phy_rf_write_m0_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_b_wt(void *p);
void phy_rf_write_m0_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_a_wt(void *p);
void phy_rf_write_m0_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_h_wt(void *p);
void phy_rf_write_m0_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_g_wt(void *p);
void phy_rf_write_m0_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_f_wt(void *p);
void phy_rf_write_m0_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_e_wt(void *p);
void phy_rf_write_m0_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_d_wt(void *p);
void phy_rf_write_m0_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_c_wt(void *p);
void phy_rf_write_m0_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_b_wt(void *p);
void phy_rf_write_m0_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_a_wt(void *p);
void phy_rf_write_m0_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_h_wt(void *p);
void phy_rf_write_m0_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_g_wt(void *p);
void phy_rf_write_m0_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_f_wt(void *p);
void phy_rf_write_m0_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_e_wt(void *p);
void phy_rf_write_m0_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_b_step(void *p);
void phy_rf_write_m0_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_a_step(void *p);
void phy_rf_write_m0_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_d_step(void *p);
void phy_rf_write_m0_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_c_step(void *p);
void phy_rf_write_m0_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_f_step(void *p);
void phy_rf_write_m0_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_e_step(void *p);
void phy_rf_write_m0_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_h_step(void *p);
void phy_rf_write_m0_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll0_quad_g_step(void *p);
void phy_rf_write_m0_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_b_step(void *p);
void phy_rf_write_m0_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_a_step(void *p);
void phy_rf_write_m0_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_d_step(void *p);
void phy_rf_write_m0_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_c_step(void *p);
void phy_rf_write_m0_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_f_step(void *p);
void phy_rf_write_m0_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_e_step(void *p);
void phy_rf_write_m0_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_h_step(void *p);
void phy_rf_write_m0_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll1_quad_g_step(void *p);
void phy_rf_write_m0_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_b_step(void *p);
void phy_rf_write_m0_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_a_step(void *p);
void phy_rf_write_m0_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_d_step(void *p);
void phy_rf_write_m0_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_c_step(void *p);
void phy_rf_write_m0_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_f_step(void *p);
void phy_rf_write_m0_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_e_step(void *p);
void phy_rf_write_m0_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_h_step(void *p);
void phy_rf_write_m0_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m0_dll2_quad_g_step(void *p);
void phy_rf_write_m0_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_0_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_0_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_0_1(void *p);
void phy_rf_write_cfg_wrdq_del_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_0_0(void *p);
void phy_rf_write_cfg_wrdq_del_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_0_1(void *p);
void phy_rf_write_cfg_del_eye0_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_0_0(void *p);
void phy_rf_write_cfg_del_eye0_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_0_1(void *p);
void phy_rf_write_cfg_del_eye1_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_0_0(void *p);
void phy_rf_write_cfg_del_eye1_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_0_1(void *p);
void phy_rf_write_cfg_del_eye2_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_0_0(void *p);
void phy_rf_write_cfg_del_eye2_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_0_1(void *p);
void phy_rf_write_cfg_del_eye3_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_0_0(void *p);
void phy_rf_write_cfg_del_eye3_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_0_1(void *p);
void phy_rf_write_cfg_del_eye4_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_0_0(void *p);
void phy_rf_write_cfg_del_eye4_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_0_1(void *p);
void phy_rf_write_cfg_del_eye5_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_0_0(void *p);
void phy_rf_write_cfg_del_eye5_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_0_1(void *p);
void phy_rf_write_cfg_del_eye6_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_0_0(void *p);
void phy_rf_write_cfg_del_eye6_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_0_1(void *p);
void phy_rf_write_cfg_del_eye7_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_0_0(void *p);
void phy_rf_write_cfg_del_eye7_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_0_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_0_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_0_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_0_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_0_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_0_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_0(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_0(void *p);
void phy_rf_write_cfg_dll0_peak_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_0(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_0(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_0(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_0(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_0(void *p);
unsigned int phy_rf_read_m1_dll0_quad_d_wt(void *p);
void phy_rf_write_m1_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_c_wt(void *p);
void phy_rf_write_m1_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_b_wt(void *p);
void phy_rf_write_m1_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_a_wt(void *p);
void phy_rf_write_m1_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_h_wt(void *p);
void phy_rf_write_m1_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_g_wt(void *p);
void phy_rf_write_m1_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_f_wt(void *p);
void phy_rf_write_m1_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_e_wt(void *p);
void phy_rf_write_m1_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_d_wt(void *p);
void phy_rf_write_m1_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_c_wt(void *p);
void phy_rf_write_m1_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_b_wt(void *p);
void phy_rf_write_m1_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_a_wt(void *p);
void phy_rf_write_m1_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_h_wt(void *p);
void phy_rf_write_m1_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_g_wt(void *p);
void phy_rf_write_m1_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_f_wt(void *p);
void phy_rf_write_m1_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_e_wt(void *p);
void phy_rf_write_m1_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_d_wt(void *p);
void phy_rf_write_m1_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_c_wt(void *p);
void phy_rf_write_m1_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_b_wt(void *p);
void phy_rf_write_m1_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_a_wt(void *p);
void phy_rf_write_m1_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_h_wt(void *p);
void phy_rf_write_m1_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_g_wt(void *p);
void phy_rf_write_m1_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_f_wt(void *p);
void phy_rf_write_m1_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_e_wt(void *p);
void phy_rf_write_m1_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_b_step(void *p);
void phy_rf_write_m1_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_a_step(void *p);
void phy_rf_write_m1_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_d_step(void *p);
void phy_rf_write_m1_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_c_step(void *p);
void phy_rf_write_m1_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_f_step(void *p);
void phy_rf_write_m1_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_e_step(void *p);
void phy_rf_write_m1_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_h_step(void *p);
void phy_rf_write_m1_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll0_quad_g_step(void *p);
void phy_rf_write_m1_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_b_step(void *p);
void phy_rf_write_m1_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_a_step(void *p);
void phy_rf_write_m1_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_d_step(void *p);
void phy_rf_write_m1_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_c_step(void *p);
void phy_rf_write_m1_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_f_step(void *p);
void phy_rf_write_m1_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_e_step(void *p);
void phy_rf_write_m1_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_h_step(void *p);
void phy_rf_write_m1_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll1_quad_g_step(void *p);
void phy_rf_write_m1_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_b_step(void *p);
void phy_rf_write_m1_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_a_step(void *p);
void phy_rf_write_m1_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_d_step(void *p);
void phy_rf_write_m1_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_c_step(void *p);
void phy_rf_write_m1_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_f_step(void *p);
void phy_rf_write_m1_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_e_step(void *p);
void phy_rf_write_m1_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_h_step(void *p);
void phy_rf_write_m1_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m1_dll2_quad_g_step(void *p);
void phy_rf_write_m1_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_1_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_1_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_1_1(void *p);
void phy_rf_write_cfg_wrdq_del_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_1_0(void *p);
void phy_rf_write_cfg_wrdq_del_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_1_1(void *p);
void phy_rf_write_cfg_del_eye0_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_1_0(void *p);
void phy_rf_write_cfg_del_eye0_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_1_1(void *p);
void phy_rf_write_cfg_del_eye1_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_1_0(void *p);
void phy_rf_write_cfg_del_eye1_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_1_1(void *p);
void phy_rf_write_cfg_del_eye2_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_1_0(void *p);
void phy_rf_write_cfg_del_eye2_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_1_1(void *p);
void phy_rf_write_cfg_del_eye3_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_1_0(void *p);
void phy_rf_write_cfg_del_eye3_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_1_1(void *p);
void phy_rf_write_cfg_del_eye4_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_1_0(void *p);
void phy_rf_write_cfg_del_eye4_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_1_1(void *p);
void phy_rf_write_cfg_del_eye5_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_1_0(void *p);
void phy_rf_write_cfg_del_eye5_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_1_1(void *p);
void phy_rf_write_cfg_del_eye6_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_1_0(void *p);
void phy_rf_write_cfg_del_eye6_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_1_1(void *p);
void phy_rf_write_cfg_del_eye7_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_1_0(void *p);
void phy_rf_write_cfg_del_eye7_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_1_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_1_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_1_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_1_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_1_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_1_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_1(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_1(void *p);
void phy_rf_write_cfg_dll0_peak_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_1(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_1(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_1(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_1(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_1(void *p);
unsigned int phy_rf_read_m2_dll0_quad_d_wt(void *p);
void phy_rf_write_m2_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_c_wt(void *p);
void phy_rf_write_m2_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_b_wt(void *p);
void phy_rf_write_m2_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_a_wt(void *p);
void phy_rf_write_m2_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_h_wt(void *p);
void phy_rf_write_m2_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_g_wt(void *p);
void phy_rf_write_m2_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_f_wt(void *p);
void phy_rf_write_m2_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_e_wt(void *p);
void phy_rf_write_m2_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_d_wt(void *p);
void phy_rf_write_m2_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_c_wt(void *p);
void phy_rf_write_m2_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_b_wt(void *p);
void phy_rf_write_m2_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_a_wt(void *p);
void phy_rf_write_m2_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_h_wt(void *p);
void phy_rf_write_m2_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_g_wt(void *p);
void phy_rf_write_m2_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_f_wt(void *p);
void phy_rf_write_m2_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_e_wt(void *p);
void phy_rf_write_m2_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_d_wt(void *p);
void phy_rf_write_m2_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_c_wt(void *p);
void phy_rf_write_m2_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_b_wt(void *p);
void phy_rf_write_m2_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_a_wt(void *p);
void phy_rf_write_m2_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_h_wt(void *p);
void phy_rf_write_m2_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_g_wt(void *p);
void phy_rf_write_m2_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_f_wt(void *p);
void phy_rf_write_m2_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_e_wt(void *p);
void phy_rf_write_m2_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_b_step(void *p);
void phy_rf_write_m2_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_a_step(void *p);
void phy_rf_write_m2_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_d_step(void *p);
void phy_rf_write_m2_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_c_step(void *p);
void phy_rf_write_m2_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_f_step(void *p);
void phy_rf_write_m2_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_e_step(void *p);
void phy_rf_write_m2_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_h_step(void *p);
void phy_rf_write_m2_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll0_quad_g_step(void *p);
void phy_rf_write_m2_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_b_step(void *p);
void phy_rf_write_m2_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_a_step(void *p);
void phy_rf_write_m2_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_d_step(void *p);
void phy_rf_write_m2_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_c_step(void *p);
void phy_rf_write_m2_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_f_step(void *p);
void phy_rf_write_m2_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_e_step(void *p);
void phy_rf_write_m2_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_h_step(void *p);
void phy_rf_write_m2_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll1_quad_g_step(void *p);
void phy_rf_write_m2_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_b_step(void *p);
void phy_rf_write_m2_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_a_step(void *p);
void phy_rf_write_m2_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_d_step(void *p);
void phy_rf_write_m2_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_c_step(void *p);
void phy_rf_write_m2_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_f_step(void *p);
void phy_rf_write_m2_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_e_step(void *p);
void phy_rf_write_m2_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_h_step(void *p);
void phy_rf_write_m2_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m2_dll2_quad_g_step(void *p);
void phy_rf_write_m2_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_2_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_2_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_2_1(void *p);
void phy_rf_write_cfg_wrdq_del_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_2_0(void *p);
void phy_rf_write_cfg_wrdq_del_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_2_1(void *p);
void phy_rf_write_cfg_del_eye0_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_2_0(void *p);
void phy_rf_write_cfg_del_eye0_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_2_1(void *p);
void phy_rf_write_cfg_del_eye1_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_2_0(void *p);
void phy_rf_write_cfg_del_eye1_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_2_1(void *p);
void phy_rf_write_cfg_del_eye2_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_2_0(void *p);
void phy_rf_write_cfg_del_eye2_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_2_1(void *p);
void phy_rf_write_cfg_del_eye3_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_2_0(void *p);
void phy_rf_write_cfg_del_eye3_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_2_1(void *p);
void phy_rf_write_cfg_del_eye4_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_2_0(void *p);
void phy_rf_write_cfg_del_eye4_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_2_1(void *p);
void phy_rf_write_cfg_del_eye5_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_2_0(void *p);
void phy_rf_write_cfg_del_eye5_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_2_1(void *p);
void phy_rf_write_cfg_del_eye6_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_2_0(void *p);
void phy_rf_write_cfg_del_eye6_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_2_1(void *p);
void phy_rf_write_cfg_del_eye7_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_2_0(void *p);
void phy_rf_write_cfg_del_eye7_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_2_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_2_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_2_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_2_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_2_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_2_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_2(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_2(void *p);
void phy_rf_write_cfg_dll0_peak_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_2(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_2(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_2(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_2(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_2(void *p);
unsigned int phy_rf_read_m3_dll0_quad_d_wt(void *p);
void phy_rf_write_m3_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_c_wt(void *p);
void phy_rf_write_m3_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_b_wt(void *p);
void phy_rf_write_m3_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_a_wt(void *p);
void phy_rf_write_m3_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_h_wt(void *p);
void phy_rf_write_m3_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_g_wt(void *p);
void phy_rf_write_m3_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_f_wt(void *p);
void phy_rf_write_m3_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_e_wt(void *p);
void phy_rf_write_m3_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_d_wt(void *p);
void phy_rf_write_m3_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_c_wt(void *p);
void phy_rf_write_m3_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_b_wt(void *p);
void phy_rf_write_m3_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_a_wt(void *p);
void phy_rf_write_m3_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_h_wt(void *p);
void phy_rf_write_m3_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_g_wt(void *p);
void phy_rf_write_m3_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_f_wt(void *p);
void phy_rf_write_m3_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_e_wt(void *p);
void phy_rf_write_m3_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_d_wt(void *p);
void phy_rf_write_m3_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_c_wt(void *p);
void phy_rf_write_m3_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_b_wt(void *p);
void phy_rf_write_m3_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_a_wt(void *p);
void phy_rf_write_m3_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_h_wt(void *p);
void phy_rf_write_m3_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_g_wt(void *p);
void phy_rf_write_m3_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_f_wt(void *p);
void phy_rf_write_m3_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_e_wt(void *p);
void phy_rf_write_m3_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_b_step(void *p);
void phy_rf_write_m3_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_a_step(void *p);
void phy_rf_write_m3_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_d_step(void *p);
void phy_rf_write_m3_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_c_step(void *p);
void phy_rf_write_m3_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_f_step(void *p);
void phy_rf_write_m3_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_e_step(void *p);
void phy_rf_write_m3_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_h_step(void *p);
void phy_rf_write_m3_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll0_quad_g_step(void *p);
void phy_rf_write_m3_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_b_step(void *p);
void phy_rf_write_m3_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_a_step(void *p);
void phy_rf_write_m3_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_d_step(void *p);
void phy_rf_write_m3_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_c_step(void *p);
void phy_rf_write_m3_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_f_step(void *p);
void phy_rf_write_m3_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_e_step(void *p);
void phy_rf_write_m3_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_h_step(void *p);
void phy_rf_write_m3_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll1_quad_g_step(void *p);
void phy_rf_write_m3_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_b_step(void *p);
void phy_rf_write_m3_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_a_step(void *p);
void phy_rf_write_m3_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_d_step(void *p);
void phy_rf_write_m3_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_c_step(void *p);
void phy_rf_write_m3_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_f_step(void *p);
void phy_rf_write_m3_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_e_step(void *p);
void phy_rf_write_m3_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_h_step(void *p);
void phy_rf_write_m3_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m3_dll2_quad_g_step(void *p);
void phy_rf_write_m3_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_3_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_3_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_3_1(void *p);
void phy_rf_write_cfg_wrdq_del_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_3_0(void *p);
void phy_rf_write_cfg_wrdq_del_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_3_1(void *p);
void phy_rf_write_cfg_del_eye0_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_3_0(void *p);
void phy_rf_write_cfg_del_eye0_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_3_1(void *p);
void phy_rf_write_cfg_del_eye1_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_3_0(void *p);
void phy_rf_write_cfg_del_eye1_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_3_1(void *p);
void phy_rf_write_cfg_del_eye2_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_3_0(void *p);
void phy_rf_write_cfg_del_eye2_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_3_1(void *p);
void phy_rf_write_cfg_del_eye3_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_3_0(void *p);
void phy_rf_write_cfg_del_eye3_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_3_1(void *p);
void phy_rf_write_cfg_del_eye4_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_3_0(void *p);
void phy_rf_write_cfg_del_eye4_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_3_1(void *p);
void phy_rf_write_cfg_del_eye5_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_3_0(void *p);
void phy_rf_write_cfg_del_eye5_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_3_1(void *p);
void phy_rf_write_cfg_del_eye6_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_3_0(void *p);
void phy_rf_write_cfg_del_eye6_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_3_1(void *p);
void phy_rf_write_cfg_del_eye7_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_3_0(void *p);
void phy_rf_write_cfg_del_eye7_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_3_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_3_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_3_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_3_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_3_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_3_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_3_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_3_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_3(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_3(void *p);
void phy_rf_write_cfg_dll0_peak_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_3(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_3(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_3(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_3(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_3(void *p);
unsigned int phy_rf_read_m4_dll0_quad_d_wt(void *p);
void phy_rf_write_m4_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_c_wt(void *p);
void phy_rf_write_m4_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_b_wt(void *p);
void phy_rf_write_m4_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_a_wt(void *p);
void phy_rf_write_m4_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_h_wt(void *p);
void phy_rf_write_m4_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_g_wt(void *p);
void phy_rf_write_m4_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_f_wt(void *p);
void phy_rf_write_m4_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_e_wt(void *p);
void phy_rf_write_m4_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_d_wt(void *p);
void phy_rf_write_m4_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_c_wt(void *p);
void phy_rf_write_m4_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_b_wt(void *p);
void phy_rf_write_m4_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_a_wt(void *p);
void phy_rf_write_m4_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_h_wt(void *p);
void phy_rf_write_m4_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_g_wt(void *p);
void phy_rf_write_m4_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_f_wt(void *p);
void phy_rf_write_m4_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_e_wt(void *p);
void phy_rf_write_m4_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_d_wt(void *p);
void phy_rf_write_m4_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_c_wt(void *p);
void phy_rf_write_m4_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_b_wt(void *p);
void phy_rf_write_m4_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_a_wt(void *p);
void phy_rf_write_m4_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_h_wt(void *p);
void phy_rf_write_m4_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_g_wt(void *p);
void phy_rf_write_m4_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_f_wt(void *p);
void phy_rf_write_m4_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_e_wt(void *p);
void phy_rf_write_m4_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_b_step(void *p);
void phy_rf_write_m4_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_a_step(void *p);
void phy_rf_write_m4_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_d_step(void *p);
void phy_rf_write_m4_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_c_step(void *p);
void phy_rf_write_m4_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_f_step(void *p);
void phy_rf_write_m4_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_e_step(void *p);
void phy_rf_write_m4_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_h_step(void *p);
void phy_rf_write_m4_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll0_quad_g_step(void *p);
void phy_rf_write_m4_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_b_step(void *p);
void phy_rf_write_m4_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_a_step(void *p);
void phy_rf_write_m4_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_d_step(void *p);
void phy_rf_write_m4_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_c_step(void *p);
void phy_rf_write_m4_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_f_step(void *p);
void phy_rf_write_m4_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_e_step(void *p);
void phy_rf_write_m4_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_h_step(void *p);
void phy_rf_write_m4_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll1_quad_g_step(void *p);
void phy_rf_write_m4_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_b_step(void *p);
void phy_rf_write_m4_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_a_step(void *p);
void phy_rf_write_m4_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_d_step(void *p);
void phy_rf_write_m4_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_c_step(void *p);
void phy_rf_write_m4_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_f_step(void *p);
void phy_rf_write_m4_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_e_step(void *p);
void phy_rf_write_m4_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_h_step(void *p);
void phy_rf_write_m4_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m4_dll2_quad_g_step(void *p);
void phy_rf_write_m4_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_4_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_4_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_4_1(void *p);
void phy_rf_write_cfg_wrdq_del_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_4_0(void *p);
void phy_rf_write_cfg_wrdq_del_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_4_1(void *p);
void phy_rf_write_cfg_del_eye0_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_4_0(void *p);
void phy_rf_write_cfg_del_eye0_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_4_1(void *p);
void phy_rf_write_cfg_del_eye1_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_4_0(void *p);
void phy_rf_write_cfg_del_eye1_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_4_1(void *p);
void phy_rf_write_cfg_del_eye2_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_4_0(void *p);
void phy_rf_write_cfg_del_eye2_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_4_1(void *p);
void phy_rf_write_cfg_del_eye3_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_4_0(void *p);
void phy_rf_write_cfg_del_eye3_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_4_1(void *p);
void phy_rf_write_cfg_del_eye4_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_4_0(void *p);
void phy_rf_write_cfg_del_eye4_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_4_1(void *p);
void phy_rf_write_cfg_del_eye5_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_4_0(void *p);
void phy_rf_write_cfg_del_eye5_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_4_1(void *p);
void phy_rf_write_cfg_del_eye6_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_4_0(void *p);
void phy_rf_write_cfg_del_eye6_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_4_1(void *p);
void phy_rf_write_cfg_del_eye7_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_4_0(void *p);
void phy_rf_write_cfg_del_eye7_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_4_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_4_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_4_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_4_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_4_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_4_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_4_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_4_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_4(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_4(void *p);
void phy_rf_write_cfg_dll0_peak_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_4(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_4(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_4(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_4(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_4(void *p);
unsigned int phy_rf_read_m5_dll0_quad_d_wt(void *p);
void phy_rf_write_m5_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_c_wt(void *p);
void phy_rf_write_m5_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_b_wt(void *p);
void phy_rf_write_m5_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_a_wt(void *p);
void phy_rf_write_m5_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_h_wt(void *p);
void phy_rf_write_m5_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_g_wt(void *p);
void phy_rf_write_m5_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_f_wt(void *p);
void phy_rf_write_m5_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_e_wt(void *p);
void phy_rf_write_m5_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_d_wt(void *p);
void phy_rf_write_m5_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_c_wt(void *p);
void phy_rf_write_m5_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_b_wt(void *p);
void phy_rf_write_m5_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_a_wt(void *p);
void phy_rf_write_m5_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_h_wt(void *p);
void phy_rf_write_m5_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_g_wt(void *p);
void phy_rf_write_m5_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_f_wt(void *p);
void phy_rf_write_m5_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_e_wt(void *p);
void phy_rf_write_m5_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_d_wt(void *p);
void phy_rf_write_m5_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_c_wt(void *p);
void phy_rf_write_m5_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_b_wt(void *p);
void phy_rf_write_m5_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_a_wt(void *p);
void phy_rf_write_m5_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_h_wt(void *p);
void phy_rf_write_m5_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_g_wt(void *p);
void phy_rf_write_m5_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_f_wt(void *p);
void phy_rf_write_m5_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_e_wt(void *p);
void phy_rf_write_m5_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_b_step(void *p);
void phy_rf_write_m5_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_a_step(void *p);
void phy_rf_write_m5_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_d_step(void *p);
void phy_rf_write_m5_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_c_step(void *p);
void phy_rf_write_m5_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_f_step(void *p);
void phy_rf_write_m5_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_e_step(void *p);
void phy_rf_write_m5_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_h_step(void *p);
void phy_rf_write_m5_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll0_quad_g_step(void *p);
void phy_rf_write_m5_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_b_step(void *p);
void phy_rf_write_m5_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_a_step(void *p);
void phy_rf_write_m5_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_d_step(void *p);
void phy_rf_write_m5_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_c_step(void *p);
void phy_rf_write_m5_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_f_step(void *p);
void phy_rf_write_m5_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_e_step(void *p);
void phy_rf_write_m5_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_h_step(void *p);
void phy_rf_write_m5_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll1_quad_g_step(void *p);
void phy_rf_write_m5_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_b_step(void *p);
void phy_rf_write_m5_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_a_step(void *p);
void phy_rf_write_m5_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_d_step(void *p);
void phy_rf_write_m5_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_c_step(void *p);
void phy_rf_write_m5_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_f_step(void *p);
void phy_rf_write_m5_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_e_step(void *p);
void phy_rf_write_m5_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_h_step(void *p);
void phy_rf_write_m5_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m5_dll2_quad_g_step(void *p);
void phy_rf_write_m5_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_5_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_5_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_5_1(void *p);
void phy_rf_write_cfg_wrdq_del_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_5_0(void *p);
void phy_rf_write_cfg_wrdq_del_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_5_1(void *p);
void phy_rf_write_cfg_del_eye0_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_5_0(void *p);
void phy_rf_write_cfg_del_eye0_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_5_1(void *p);
void phy_rf_write_cfg_del_eye1_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_5_0(void *p);
void phy_rf_write_cfg_del_eye1_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_5_1(void *p);
void phy_rf_write_cfg_del_eye2_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_5_0(void *p);
void phy_rf_write_cfg_del_eye2_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_5_1(void *p);
void phy_rf_write_cfg_del_eye3_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_5_0(void *p);
void phy_rf_write_cfg_del_eye3_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_5_1(void *p);
void phy_rf_write_cfg_del_eye4_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_5_0(void *p);
void phy_rf_write_cfg_del_eye4_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_5_1(void *p);
void phy_rf_write_cfg_del_eye5_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_5_0(void *p);
void phy_rf_write_cfg_del_eye5_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_5_1(void *p);
void phy_rf_write_cfg_del_eye6_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_5_0(void *p);
void phy_rf_write_cfg_del_eye6_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_5_1(void *p);
void phy_rf_write_cfg_del_eye7_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_5_0(void *p);
void phy_rf_write_cfg_del_eye7_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_5_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_5_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_5_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_5_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_5_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_5_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_5_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_5_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_5(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_5(void *p);
void phy_rf_write_cfg_dll0_peak_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_5(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_5(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_5(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_5(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_5(void *p);
unsigned int phy_rf_read_m6_dll0_quad_d_wt(void *p);
void phy_rf_write_m6_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_c_wt(void *p);
void phy_rf_write_m6_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_b_wt(void *p);
void phy_rf_write_m6_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_a_wt(void *p);
void phy_rf_write_m6_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_h_wt(void *p);
void phy_rf_write_m6_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_g_wt(void *p);
void phy_rf_write_m6_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_f_wt(void *p);
void phy_rf_write_m6_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_e_wt(void *p);
void phy_rf_write_m6_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_d_wt(void *p);
void phy_rf_write_m6_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_c_wt(void *p);
void phy_rf_write_m6_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_b_wt(void *p);
void phy_rf_write_m6_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_a_wt(void *p);
void phy_rf_write_m6_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_h_wt(void *p);
void phy_rf_write_m6_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_g_wt(void *p);
void phy_rf_write_m6_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_f_wt(void *p);
void phy_rf_write_m6_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_e_wt(void *p);
void phy_rf_write_m6_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_d_wt(void *p);
void phy_rf_write_m6_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_c_wt(void *p);
void phy_rf_write_m6_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_b_wt(void *p);
void phy_rf_write_m6_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_a_wt(void *p);
void phy_rf_write_m6_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_h_wt(void *p);
void phy_rf_write_m6_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_g_wt(void *p);
void phy_rf_write_m6_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_f_wt(void *p);
void phy_rf_write_m6_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_e_wt(void *p);
void phy_rf_write_m6_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_b_step(void *p);
void phy_rf_write_m6_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_a_step(void *p);
void phy_rf_write_m6_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_d_step(void *p);
void phy_rf_write_m6_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_c_step(void *p);
void phy_rf_write_m6_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_f_step(void *p);
void phy_rf_write_m6_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_e_step(void *p);
void phy_rf_write_m6_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_h_step(void *p);
void phy_rf_write_m6_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll0_quad_g_step(void *p);
void phy_rf_write_m6_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_b_step(void *p);
void phy_rf_write_m6_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_a_step(void *p);
void phy_rf_write_m6_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_d_step(void *p);
void phy_rf_write_m6_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_c_step(void *p);
void phy_rf_write_m6_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_f_step(void *p);
void phy_rf_write_m6_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_e_step(void *p);
void phy_rf_write_m6_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_h_step(void *p);
void phy_rf_write_m6_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll1_quad_g_step(void *p);
void phy_rf_write_m6_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_b_step(void *p);
void phy_rf_write_m6_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_a_step(void *p);
void phy_rf_write_m6_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_d_step(void *p);
void phy_rf_write_m6_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_c_step(void *p);
void phy_rf_write_m6_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_f_step(void *p);
void phy_rf_write_m6_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_e_step(void *p);
void phy_rf_write_m6_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_h_step(void *p);
void phy_rf_write_m6_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m6_dll2_quad_g_step(void *p);
void phy_rf_write_m6_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_6_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_6_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_6_1(void *p);
void phy_rf_write_cfg_wrdq_del_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_6_0(void *p);
void phy_rf_write_cfg_wrdq_del_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_6_1(void *p);
void phy_rf_write_cfg_del_eye0_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_6_0(void *p);
void phy_rf_write_cfg_del_eye0_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_6_1(void *p);
void phy_rf_write_cfg_del_eye1_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_6_0(void *p);
void phy_rf_write_cfg_del_eye1_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_6_1(void *p);
void phy_rf_write_cfg_del_eye2_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_6_0(void *p);
void phy_rf_write_cfg_del_eye2_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_6_1(void *p);
void phy_rf_write_cfg_del_eye3_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_6_0(void *p);
void phy_rf_write_cfg_del_eye3_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_6_1(void *p);
void phy_rf_write_cfg_del_eye4_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_6_0(void *p);
void phy_rf_write_cfg_del_eye4_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_6_1(void *p);
void phy_rf_write_cfg_del_eye5_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_6_0(void *p);
void phy_rf_write_cfg_del_eye5_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_6_1(void *p);
void phy_rf_write_cfg_del_eye6_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_6_0(void *p);
void phy_rf_write_cfg_del_eye6_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_6_1(void *p);
void phy_rf_write_cfg_del_eye7_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_6_0(void *p);
void phy_rf_write_cfg_del_eye7_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_6_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_6_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_6_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_6_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_6_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_6_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_6_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_6_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_6(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_6(void *p);
void phy_rf_write_cfg_dll0_peak_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_6(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_6(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_6(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_6(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_6(void *p);
unsigned int phy_rf_read_m7_dll0_quad_d_wt(void *p);
void phy_rf_write_m7_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_c_wt(void *p);
void phy_rf_write_m7_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_b_wt(void *p);
void phy_rf_write_m7_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_a_wt(void *p);
void phy_rf_write_m7_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_h_wt(void *p);
void phy_rf_write_m7_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_g_wt(void *p);
void phy_rf_write_m7_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_f_wt(void *p);
void phy_rf_write_m7_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_e_wt(void *p);
void phy_rf_write_m7_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_d_wt(void *p);
void phy_rf_write_m7_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_c_wt(void *p);
void phy_rf_write_m7_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_b_wt(void *p);
void phy_rf_write_m7_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_a_wt(void *p);
void phy_rf_write_m7_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_h_wt(void *p);
void phy_rf_write_m7_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_g_wt(void *p);
void phy_rf_write_m7_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_f_wt(void *p);
void phy_rf_write_m7_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_e_wt(void *p);
void phy_rf_write_m7_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_d_wt(void *p);
void phy_rf_write_m7_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_c_wt(void *p);
void phy_rf_write_m7_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_b_wt(void *p);
void phy_rf_write_m7_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_a_wt(void *p);
void phy_rf_write_m7_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_h_wt(void *p);
void phy_rf_write_m7_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_g_wt(void *p);
void phy_rf_write_m7_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_f_wt(void *p);
void phy_rf_write_m7_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_e_wt(void *p);
void phy_rf_write_m7_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_b_step(void *p);
void phy_rf_write_m7_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_a_step(void *p);
void phy_rf_write_m7_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_d_step(void *p);
void phy_rf_write_m7_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_c_step(void *p);
void phy_rf_write_m7_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_f_step(void *p);
void phy_rf_write_m7_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_e_step(void *p);
void phy_rf_write_m7_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_h_step(void *p);
void phy_rf_write_m7_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll0_quad_g_step(void *p);
void phy_rf_write_m7_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_b_step(void *p);
void phy_rf_write_m7_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_a_step(void *p);
void phy_rf_write_m7_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_d_step(void *p);
void phy_rf_write_m7_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_c_step(void *p);
void phy_rf_write_m7_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_f_step(void *p);
void phy_rf_write_m7_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_e_step(void *p);
void phy_rf_write_m7_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_h_step(void *p);
void phy_rf_write_m7_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll1_quad_g_step(void *p);
void phy_rf_write_m7_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_b_step(void *p);
void phy_rf_write_m7_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_a_step(void *p);
void phy_rf_write_m7_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_d_step(void *p);
void phy_rf_write_m7_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_c_step(void *p);
void phy_rf_write_m7_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_f_step(void *p);
void phy_rf_write_m7_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_e_step(void *p);
void phy_rf_write_m7_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_h_step(void *p);
void phy_rf_write_m7_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m7_dll2_quad_g_step(void *p);
void phy_rf_write_m7_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_7_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_7_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_7_1(void *p);
void phy_rf_write_cfg_wrdq_del_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_7_0(void *p);
void phy_rf_write_cfg_wrdq_del_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_7_1(void *p);
void phy_rf_write_cfg_del_eye0_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_7_0(void *p);
void phy_rf_write_cfg_del_eye0_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_7_1(void *p);
void phy_rf_write_cfg_del_eye1_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_7_0(void *p);
void phy_rf_write_cfg_del_eye1_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_7_1(void *p);
void phy_rf_write_cfg_del_eye2_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_7_0(void *p);
void phy_rf_write_cfg_del_eye2_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_7_1(void *p);
void phy_rf_write_cfg_del_eye3_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_7_0(void *p);
void phy_rf_write_cfg_del_eye3_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_7_1(void *p);
void phy_rf_write_cfg_del_eye4_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_7_0(void *p);
void phy_rf_write_cfg_del_eye4_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_7_1(void *p);
void phy_rf_write_cfg_del_eye5_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_7_0(void *p);
void phy_rf_write_cfg_del_eye5_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_7_1(void *p);
void phy_rf_write_cfg_del_eye6_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_7_0(void *p);
void phy_rf_write_cfg_del_eye6_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_7_1(void *p);
void phy_rf_write_cfg_del_eye7_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_7_0(void *p);
void phy_rf_write_cfg_del_eye7_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_7_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_7_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_7_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_7_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_7_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_7_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_7_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_7_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_7(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_7(void *p);
void phy_rf_write_cfg_dll0_peak_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_7(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_7(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_7(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_7(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_7(void *p);
unsigned int phy_rf_read_m8_dll0_quad_d_wt(void *p);
void phy_rf_write_m8_dll0_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_c_wt(void *p);
void phy_rf_write_m8_dll0_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_b_wt(void *p);
void phy_rf_write_m8_dll0_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_a_wt(void *p);
void phy_rf_write_m8_dll0_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_h_wt(void *p);
void phy_rf_write_m8_dll0_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_g_wt(void *p);
void phy_rf_write_m8_dll0_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_f_wt(void *p);
void phy_rf_write_m8_dll0_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_e_wt(void *p);
void phy_rf_write_m8_dll0_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_d_wt(void *p);
void phy_rf_write_m8_dll1_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_c_wt(void *p);
void phy_rf_write_m8_dll1_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_b_wt(void *p);
void phy_rf_write_m8_dll1_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_a_wt(void *p);
void phy_rf_write_m8_dll1_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_h_wt(void *p);
void phy_rf_write_m8_dll1_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_g_wt(void *p);
void phy_rf_write_m8_dll1_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_f_wt(void *p);
void phy_rf_write_m8_dll1_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_e_wt(void *p);
void phy_rf_write_m8_dll1_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_d_wt(void *p);
void phy_rf_write_m8_dll2_quad_d_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_c_wt(void *p);
void phy_rf_write_m8_dll2_quad_c_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_b_wt(void *p);
void phy_rf_write_m8_dll2_quad_b_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_a_wt(void *p);
void phy_rf_write_m8_dll2_quad_a_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_h_wt(void *p);
void phy_rf_write_m8_dll2_quad_h_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_g_wt(void *p);
void phy_rf_write_m8_dll2_quad_g_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_f_wt(void *p);
void phy_rf_write_m8_dll2_quad_f_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_e_wt(void *p);
void phy_rf_write_m8_dll2_quad_e_wt(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_b_step(void *p);
void phy_rf_write_m8_dll0_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_a_step(void *p);
void phy_rf_write_m8_dll0_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_d_step(void *p);
void phy_rf_write_m8_dll0_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_c_step(void *p);
void phy_rf_write_m8_dll0_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_f_step(void *p);
void phy_rf_write_m8_dll0_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_e_step(void *p);
void phy_rf_write_m8_dll0_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_h_step(void *p);
void phy_rf_write_m8_dll0_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll0_quad_g_step(void *p);
void phy_rf_write_m8_dll0_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_b_step(void *p);
void phy_rf_write_m8_dll1_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_a_step(void *p);
void phy_rf_write_m8_dll1_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_d_step(void *p);
void phy_rf_write_m8_dll1_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_c_step(void *p);
void phy_rf_write_m8_dll1_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_f_step(void *p);
void phy_rf_write_m8_dll1_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_e_step(void *p);
void phy_rf_write_m8_dll1_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_h_step(void *p);
void phy_rf_write_m8_dll1_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll1_quad_g_step(void *p);
void phy_rf_write_m8_dll1_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_b_step(void *p);
void phy_rf_write_m8_dll2_quad_b_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_a_step(void *p);
void phy_rf_write_m8_dll2_quad_a_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_d_step(void *p);
void phy_rf_write_m8_dll2_quad_d_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_c_step(void *p);
void phy_rf_write_m8_dll2_quad_c_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_f_step(void *p);
void phy_rf_write_m8_dll2_quad_f_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_e_step(void *p);
void phy_rf_write_m8_dll2_quad_e_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_h_step(void *p);
void phy_rf_write_m8_dll2_quad_h_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_m8_dll2_quad_g_step(void *p);
void phy_rf_write_m8_dll2_quad_g_step(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_7(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_6(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_5(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_4(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_3(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_2(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_1(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_trim_delay_8_0(void *p);
void phy_rf_write_cfg_rdlvl_trim_delay_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_7(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_6(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_5(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_4(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_3(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_2(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_1(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_trim_delay_8_0(void *p);
void phy_rf_write_cfg_wrlvl_trim_delay_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_8_1(void *p);
void phy_rf_write_cfg_wrdq_del_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrdq_del_8_0(void *p);
void phy_rf_write_cfg_wrdq_del_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_8_1(void *p);
void phy_rf_write_cfg_del_eye0_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye0_8_0(void *p);
void phy_rf_write_cfg_del_eye0_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_8_1(void *p);
void phy_rf_write_cfg_del_eye1_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye1_8_0(void *p);
void phy_rf_write_cfg_del_eye1_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_8_1(void *p);
void phy_rf_write_cfg_del_eye2_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye2_8_0(void *p);
void phy_rf_write_cfg_del_eye2_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_8_1(void *p);
void phy_rf_write_cfg_del_eye3_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye3_8_0(void *p);
void phy_rf_write_cfg_del_eye3_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_8_1(void *p);
void phy_rf_write_cfg_del_eye4_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye4_8_0(void *p);
void phy_rf_write_cfg_del_eye4_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_8_1(void *p);
void phy_rf_write_cfg_del_eye5_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye5_8_0(void *p);
void phy_rf_write_cfg_del_eye5_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_8_1(void *p);
void phy_rf_write_cfg_del_eye6_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye6_8_0(void *p);
void phy_rf_write_cfg_del_eye6_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_8_1(void *p);
void phy_rf_write_cfg_del_eye7_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_del_eye7_8_0(void *p);
void phy_rf_write_cfg_del_eye7_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay0_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay0_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay0_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay0_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay0_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay0_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay0_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay0_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay1_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay1_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay1_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay1_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay1_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay1_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay1_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay1_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay2_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay2_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay2_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay2_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay2_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay2_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay2_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay2_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay3_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay3_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay3_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay3_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay3_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay3_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay3_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay3_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay4_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay4_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay4_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay4_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay4_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay4_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay4_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay4_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay5_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay5_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay5_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay5_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay5_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay5_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay5_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay5_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay6_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay6_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay6_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay6_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay6_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay6_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay6_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay6_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_8_0(void *p);
void phy_rf_write_cfg_rdlvl_delay7_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_delay7_8_1(void *p);
void phy_rf_write_cfg_rdlvl_delay7_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_8_0(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rdlvl_gate_delay7_8_1(void *p);
void phy_rf_write_cfg_rdlvl_gate_delay7_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_8_0(void *p);
void phy_rf_write_cfg_wrlvl_delay7_8_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_delay7_8_1(void *p);
void phy_rf_write_cfg_wrlvl_delay7_8_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_dqxclk_pi_out_8(void *p);
void phy_rf_write_cfg_cdr_dqxclk_pi_out_8(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dll0_peak_8(void *p);
void phy_rf_write_cfg_dll0_peak_8(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wrlvl_time_out_status_8(void *p);
unsigned int phy_rf_read_cfg_deskew_time_out_status_8(void *p);
unsigned int phy_rf_read_cfg_wrcal_time_out_status_8(void *p);
unsigned int phy_rf_read_cfg_rdlvl_time_out_status_8(void *p);
unsigned int phy_rf_read_cfg_rdlvl_gate_time_out_status_8(void *p);
unsigned int phy_rf_read_cfg_gt_dly_st_0(void *p);
void phy_rf_write_cfg_gt_dly_st_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_gt_dly_st_1(void *p);
void phy_rf_write_cfg_gt_dly_st_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rd_dly_st_0(void *p);
void phy_rf_write_cfg_rd_dly_st_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_rd_dly_st_1(void *p);
void phy_rf_write_cfg_rd_dly_st_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wr_dly_st_0(void *p);
void phy_rf_write_cfg_wr_dly_st_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wr_dly_st_1(void *p);
void phy_rf_write_cfg_wr_dly_st_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_deskew_st_0(void *p);
void phy_rf_write_cfg_deskew_st_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_deskew_st_1(void *p);
void phy_rf_write_cfg_deskew_st_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wr_deskew_st_0(void *p);
void phy_rf_write_cfg_wr_deskew_st_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_wr_deskew_st_1(void *p);
void phy_rf_write_cfg_wr_deskew_st_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_ctrl_fsm_st(void *p);
void phy_rf_write_cfg_ctrl_fsm_st(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_1_3(void *p);
void phy_rf_write_spare_register_1_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_1_2(void *p);
void phy_rf_write_spare_register_1_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_1_1(void *p);
void phy_rf_write_spare_register_1_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_1_0(void *p);
void phy_rf_write_spare_register_1_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_2_3(void *p);
void phy_rf_write_spare_register_2_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_2_2(void *p);
void phy_rf_write_spare_register_2_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_2_1(void *p);
void phy_rf_write_spare_register_2_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_2_0(void *p);
void phy_rf_write_spare_register_2_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cmd_180_code(void *p);
void phy_rf_write_cfg_cmd_180_code(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_chip_select(void *p);
void phy_rf_write_cfg_chip_select(void *p, unsigned int writeData);
unsigned int phy_rf_read_vendor_specific_1(void *p);
void phy_rf_write_vendor_specific_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_vendor_specific_2(void *p);
void phy_rf_write_vendor_specific_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_cdr_reset_b(void *p);
void phy_rf_write_cfg_cdr_reset_b(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_0_3(void *p);
void phy_rf_write_spare_register_0_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_0_2(void *p);
void phy_rf_write_spare_register_0_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_0_1(void *p);
void phy_rf_write_spare_register_0_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_spare_register_0_0(void *p);
void phy_rf_write_spare_register_0_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_3(void *p);
void phy_rf_write_cfg_dqxclk_90_3(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_2(void *p);
void phy_rf_write_cfg_dqxclk_90_2(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_1(void *p);
void phy_rf_write_cfg_dqxclk_90_1(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_0(void *p);
void phy_rf_write_cfg_dqxclk_90_0(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_7(void *p);
void phy_rf_write_cfg_dqxclk_90_7(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_6(void *p);
void phy_rf_write_cfg_dqxclk_90_6(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_5(void *p);
void phy_rf_write_cfg_dqxclk_90_5(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_4(void *p);
void phy_rf_write_cfg_dqxclk_90_4(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_dqxclk_90_8(void *p);
void phy_rf_write_cfg_dqxclk_90_8(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_macro_num_pi_addr_180_cal(void *p);
void phy_rf_write_cfg_macro_num_pi_addr_180_cal(void *p,
						unsigned int writeData);
unsigned int phy_rf_read_cfg_enable_peak_computation(void *p);
void phy_rf_write_cfg_enable_peak_computation(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_addr_cal_en(void *p);
void phy_rf_write_cfg_addr_cal_en(void *p, unsigned int writeData);
unsigned int phy_rf_read_cfg_addr_cal_done(void *p);
void phy_rf_write_cfg_addr_cal_done(void *p, unsigned int writeData);

#endif
